/* libgtk_s7.c */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>
#include <stdbool.h>
#include "s7.h"

#if ((!__NetBSD__) && ((_MSC_VER) || (!defined(__STC__)) || (defined(__STDC_VERSION__) && (__STDC_VERSION__ < 199901L))))
  #define __func__ __FUNCTION__
#endif

#include <string.h>
#include <stdlib.h>
#include <stdint.h>
#include <inttypes.h>

#include <glib.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#if (!GTK_CHECK_VERSION(3, 0, 0))
  #include <gdk/gdkkeysyms.h>
#endif
#include <glib-object.h>
#include <pango/pango.h>
#include <cairo/cairo.h>
static s7_pointer lg_true, lg_false;
static bool lg_boolean(s7_pointer val) {return(val != lg_false);}
#define lg_make_c_pointer_with_type(Sc, Type, Ptr) s7_make_c_pointer_with_type(Sc, (void *)Ptr, Type, lg_false)


static int xm_obj_tag;
static s7_pointer xm_obj_free(s7_scheme *sc, s7_pointer obj)
{
  free(s7_c_object_value(obj));
  return(NULL);
}
static s7_pointer s7_equal_xm(s7_scheme *sc, s7_pointer args)
{
  return(s7_make_boolean(sc, s7_car(args) == s7_cadr(args)));
}
static s7_pointer make_xm_obj(s7_scheme *sc, void *ptr)
{
  return(s7_make_c_object(sc, xm_obj_tag, ptr));
}
static void define_xm_obj(s7_scheme *sc)
{
  xm_obj_tag = s7_make_c_type(sc, "<gtk_s7>");
  s7_c_type_set_gc_free(sc, xm_obj_tag, xm_obj_free);
  s7_c_type_set_is_equal(sc, xm_obj_tag, s7_equal_xm);
}  

static s7_pointer GtkColorButton__sym, GtkViewport__sym, GtkAspectFrame__sym, GtkAlternativeTrigger__sym, GtkMnemonicTrigger__sym,
                  GtkKeyvalTrigger__sym, gconstpointer_sym, GtkShortcutController__sym, GtkNamedAction__sym, GtkSignalAction__sym,
                  GtkShortcutFunc_sym, GtkShortcutAction__sym, GtkShortcutTrigger__sym, GtkShortcut__sym, action_sym,
                  d_sym, dd_sym, GVariantType__sym, GMenuItem__sym, GtkNative__sym,
                  GVariant__sym, GVariantType___sym, GtkWidgetActionActivateFunc_sym, GtkPopover__sym, id_sym,
                  drag_source_sym, gtk_tree_drag_source_drag_data_get_sym, GtkTreePath___sym, tree_model_sym, gtk_tree_create_row_drag_content_sym,
                  va_list_sym, GtkMenuButtonCreatePopupFunc_sym, const_sym, GtkDropTargetAsync__sym, gsize__sym,
                  GtkDropTarget__sym, GtkDropControllerMotion__sym, GtkDragIcon__sym, GtkEventControllerFocus__sym, GHashTable__sym,
                  GtkConstraintLayout__sym, GtkConstraintTarget__sym, GtkConstraint__sym, GtkIconPaintable__sym, GtkIconTheme__sym,
                  GtkConstraintGuide__sym, gtk_event_controller_motion_contains_pointer_sym, _sym, GdkVulkanContext__sym, GError___sym,
                  GdkFrameClock__sym, GdkToplevelLayout__sym, GdkToplevel__sym, GtkPopoverMenu__sym, GtkCenterLayout__sym,
                  GtkGestureClick__sym, GtkPopoverMenuBar__sym, GtkNoSelection__sym, GtkDragSource__sym, GdkPopupLayout__sym,
                  GdkPopup__sym, GdkDragSurface__sym, GtkPropagationLimit_sym, GtkGestureLongPress__sym, GtkScaleFormatValueFunc_sym,
                  GdkContentProvider___sym, GtkFixedLayoutChild__sym, GtkTreeDragDest__sym, GtkTreeListRow__sym, GtkTreeListModel__sym,
                  GtkText__sym, GtkSortListModel__sym, GtkSliceListModel__sym, GtkSingleSelection__sym, GtkPasswordEntry__sym,
                  GtkMapListModel__sym, GtkLayoutChild__sym, GtkGridLayoutChild__sym, GtkGridLayout__sym, GtkFlattenListModel__sym,
                  GtkFilterListModel__sym, GtkCustomAllocateFunc_sym, GtkCustomMeasureFunc_sym, GtkCustomRequestModeFunc_sym, GtkBoxLayout__sym,
                  graphene_point_t__sym, graphene_matrix_t__sym, GtkRoot__sym, GtkWidgetClass__sym, GtkLayoutManager__sym,
                  GtkSelectionModel__sym, GtkStackPage__sym, GtkNotebookPage__sym, GskTransform__sym, GParamSpec__sym,
                  GObjectClass__sym, GListModel__sym, GtkAssistantPage__sym, GtkAllocation__sym, GActionGroup__sym,
                  GtkWidgetPaintable__sym, GtkVideo__sym, GtkPicture__sym, gint64_sym, GtkMediaFile__sym,
                  GtkMediaControls__sym, GtkMediaStream__sym, GdkTimeCoord___sym, GtkGestureStylus__sym, GdkGLTexture__sym,
                  GdkDrag__sym, GdkDrop__sym, GdkCairoContext__sym, GdkSurface__sym, GMenu__sym,
                  GApplicationFlags_sym, GdkPaintable__sym, GdkCursor__sym, GBytes__sym, GInputStream__sym,
                  GdkContentDeserializer__sym, GdkContentSerializer__sym, GOutputStream__sym, GdkContentFormatsBuilder__sym, GString__sym,
                  GdkTexture__sym, GAsyncResult__sym, GAsyncReadyCallback_sym, GCancellable__sym, GdkContentProvider__sym,
                  GdkContentFormats__sym, GdkClipboard__sym, GdkAppLaunchContext__sym, GtkEventControllerScroll__sym, GtkEventController__sym,
                  GFile__sym, GtkCssProvider__sym, GtkWidgetPath__sym, GtkCssSection__sym, GtkStyleProvider__sym,
                  GtkScrollbar__sym, GtkCenterBox__sym, GtkCheckButton__sym, GtkDrawingAreaDrawFunc_sym, GtkShortcutLabel__sym,
                  GtkPadActionEntry__sym, GtkPadController__sym, GdkDevicePad__sym, GdkMonitor__sym, GdkDeviceTool__sym,
                  GdkSeat__sym, GtkShortcutsWindow__sym, GtkStackSidebar__sym, GtkStyleContext__sym, GdkGLContext__sym,
                  GtkGLArea__sym, GtkGestureZoom__sym, GtkGestureSwipe__sym, GtkGestureSingle__sym, GtkGestureRotate__sym,
                  GtkGesturePan__sym, GtkGestureDrag__sym, GdkEventSequence__sym, GtkGesture__sym, GtkActionBar__sym,
                  GtkFlowBox__sym, GtkFlowBoxChild__sym, GtkSearchBar__sym, GtkListBox__sym, GtkListBoxRow__sym,
                  GtkHeaderBar__sym, GtkRevealer__sym, GtkStack__sym, GtkStackSwitcher__sym, GtkMenu__sym,
                  GtkLevelBar__sym, GtkMenuButton__sym, GtkColorChooser__sym, GtkApplicationWindow__sym, GtkApplication__sym,
                  GMenuModel__sym, guint___sym, GtkFontChooser__sym, GtkOverlay__sym, GtkWindowGroup__sym,
                  GIcon__sym, GtkOrientable__sym, GtkCellArea__sym, GtkBorder__sym, GtkSwitch__sym,
                  GtkScrollable__sym, GtkGrid__sym, GdkRGBA__sym, GtkComboBoxText__sym, cairo_region_overlap_t_sym,
                  cairo_rectangle_int_t__sym, double__sym, cairo_rectangle_t__sym, cairo_device_t__sym, cairo_text_cluster_flags_t__sym,
                  cairo_text_cluster_t___sym, cairo_glyph_t___sym, cairo_text_cluster_t__sym, cairo_region_t__sym, GtkMessageDialog__sym,
                  GdkDevice__sym, GtkAccessible__sym, GdkModifierType__sym, GtkSpinner__sym, GtkEntryBuffer__sym,
                  GtkInfoBar__sym, GtkScaleButton__sym, GtkCalendarDetailFunc_sym, GtkTooltip__sym, cairo_rectangle_list_t__sym,
                  void__sym, cairo_path_t__sym, cairo_destroy_func_t_sym, cairo_user_data_key_t__sym, cairo_text_extents_t__sym,
                  cairo_font_extents_t__sym, cairo_font_face_t__sym, cairo_glyph_t__sym, cairo_scaled_font_t__sym, cairo_matrix_t__sym,
                  cairo_pattern_t__sym, GtkPageRange__sym, GtkPaperSize__sym, GtkPrintSettingsFunc_sym, GtkPageSetupDoneFunc_sym,
                  GtkPrintSettings__sym, GtkPrintOperation__sym, GtkPageSetup__sym, GtkPrintContext__sym, cairo_surface_t__sym,
                  GtkRecentData__sym, GtkRecentInfo__sym, GtkRecentManager__sym, GtkLinkButton__sym, GDestroyNotify_sym,
                  GtkAssistantPageFunc_sym, GtkAssistant__sym, GValue__sym, GLogFunc_sym, PangoMatrix__sym,
                  PangoRenderer__sym, GtkFileChooserButton__sym, PangoScriptIter__sym, PangoAttrFilterFunc_sym, GtkIconViewForeachFunc_sym,
                  gchar___sym, GtkAboutDialog__sym, GtkTreeViewRowSeparatorFunc_sym, GtkCellView__sym, GtkIconInfo__sym,
                  GtkFileChooser__sym, GtkCellLayoutDataFunc_sym, GtkCellLayout__sym, GtkFileFilterFunc_sym, GtkFileFilter__sym,
                  GSourceFunc_sym, GtkEntryCompletionMatchFunc_sym, GtkFontButton__sym, GtkExpander__sym, GtkComboBox__sym,
                  GtkTreeModelFilter__sym, GdkDisplay__sym, PangoLayoutRun__sym, PangoLayoutIter__sym, PangoLayoutLine__sym,
                  int__sym, PangoItem__sym, PangoAnalysis__sym, PangoGlyphString__sym, PangoFontMap__sym,
                  PangoFontFace__sym, PangoFontFace___sym, PangoFontFamily__sym, PangoFontDescription___sym, PangoCoverage__sym,
                  PangoFontMetrics__sym, PangoFontset__sym, PangoFont__sym, PangoFontFamily___sym, PangoLogAttr__sym,
                  PangoAttrList___sym, PangoAttrIterator__sym, PangoRectangle__sym, PangoAttribute__sym, PangoColor__sym,
                  GtkWindow__sym, PangoContext__sym, AtkObject__sym, GtkTreeViewSearchEqualFunc_sym, GtkTreeViewMappingFunc_sym,
                  GtkTreeViewColumnDropFunc_sym, GtkTreeCellDataFunc_sym, GtkTreeStore__sym, GtkTreeIterCompareFunc_sym, GtkTreeSortable__sym,
                  GtkTreeSelectionForeachFunc_sym, GtkTreeModel___sym, GtkTreeSelectionFunc_sym, GtkTreeModelSort__sym, GtkTreeModelForeachFunc_sym,
                  GObject__sym, GtkTreeRowReference__sym, gint__sym, GtkTreeDragSource__sym, GtkToggleButton__sym,
                  PangoTabArray__sym, GtkTextView__sym, GtkTextTagTableForeach_sym, GtkTextCharPredicate_sym, GtkTextMark__sym,
                  GtkTextChildAnchor__sym, GtkTextIter__sym, GtkTextTagTable__sym, GtkTextBuffer__sym, GtkStatusbar__sym,
                  GtkSpinButton__sym, GtkSizeGroup__sym, GtkSettings__sym, GtkScrolledWindow__sym, GtkScale__sym,
                  GtkRange__sym, GtkRadioButton__sym, GSList__sym, GtkProgressBar__sym, GtkPaned__sym,
                  GtkNotebook__sym, PangoLanguage__sym, GtkListStore__sym, PangoLayout__sym, GtkLabel__sym,
                  guint16__sym, GtkIMContextSimple__sym, GdkEventKey__sym, PangoAttrList__sym, GtkIMContext__sym,
                  GtkImage__sym, GtkFrame__sym, GtkFixed__sym, GtkEntry__sym, GtkEditable__sym,
                  etc_sym, GtkDialog__sym, GList__sym, GtkCallback_sym, GtkContainer__sym,
                  GtkCellRendererToggle__sym, GtkCellRendererText__sym, GtkCellEditable__sym, GtkCalendar__sym, GtkButton__sym,
                  GtkBox__sym, GtkBin__sym, GtkAdjustment__sym, GtkAccelLabel__sym, char___sym,
                  GdkPixbufDestroyNotify_sym, GError__sym, guchar__sym, GdkPixbuf__sym, GdkKeymapKey__sym,
                  GdkKeymap__sym, GdkRectangle__sym, GtkDestroyNotify_sym, GSignalEmissionHook_sym, GSignalInvocationHint__sym,
                  guint__sym, GSignalQuery__sym, GType__sym, GSignalCMarshaller_sym, gpointer_sym,
                  GSignalAccumulator_sym, GClosureNotify_sym, GCallback_sym, GClosure__sym, gunichar__sym,
                  void_sym, GtkDrawingArea__sym, GtkIconView__sym, GtkEntryCompletion__sym, GtkFileFilterInfo__sym,
                  GtkTreeSelection__sym, GtkCellRenderer__sym, GtkTreeViewColumn__sym, GtkTreeView__sym, GtkTreeIter__sym,
                  GtkTreePath__sym, GtkTreeModel__sym, GtkTextTag__sym, lambda_data_sym, GtkWidget__sym,
                  GdkEventMotion__sym, gdouble__sym, GdkEventAny__sym, GdkEvent__sym, cairo_t__sym,
                  cairo_font_options_t__sym, PangoFontDescription__sym, GtkMenuBar__sym, GtkEventControllerLegacy__sym, GtkCellRendererPixbuf__sym,
                  GtkSeparator__sym, GdkEventExpose__sym, GdkEventNoExpose__sym, GdkEventVisibility__sym, GdkEventButton__sym,
                  GdkEventCrossing__sym, GdkEventFocus__sym, GdkEventConfigure__sym, GdkEventProperty__sym, GdkEventSelection__sym,
                  GdkEventProximity__sym, GdkEventSetting__sym, GdkEventWindowState__sym, GdkEventDND__sym, GtkFileChooserDialog__sym,
                  GtkFileChooserWidget__sym, GtkCellRendererCombo__sym, GtkCellRendererProgress__sym, GtkCellRendererAccel__sym, GtkCellRendererSpin__sym,
                  GtkCellRendererSpinner__sym, GtkFontChooserDialog__sym, GtkFontChooserWidget__sym, GtkColorChooserDialog__sym, GtkColorWidget__sym;

#define lg_is_list(Arg) s7_is_list(sc, Arg)
static s7_scheme *cbsc = NULL;
static void lg_func2(GtkWidget* w, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   lg_make_c_pointer_with_type(cbsc, GtkWidget__sym, w),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_timer_func(gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 1,
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_destroy_func(gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_cadddr((s7_pointer)func_info), 
           s7_list(cbsc, 1,
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_text_tag_table_foreach(GtkTextTag* tag, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   lg_make_c_pointer_with_type(cbsc, GtkTextTag__sym, tag),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_model_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, model),
                   lg_make_c_pointer_with_type(cbsc, GtkTreePath__sym, path),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_tree_selection_func(GtkTreeModel* model, GtkTreePath* path, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, model),
                   lg_make_c_pointer_with_type(cbsc, GtkTreePath__sym, path),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, iter),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_text_char_predicate(gunichar ch, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_integer(cbsc, ch),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_tree_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, GtkTreeViewColumn* prev_column, GtkTreeViewColumn* next_column, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeView__sym, tree_view),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeViewColumn__sym, column),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeViewColumn__sym, prev_column),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeViewColumn__sym, next_column),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_tree_mapping(GtkTreeView* tree_view, GtkTreePath* path, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeView__sym, tree_view),
                   lg_make_c_pointer_with_type(cbsc, GtkTreePath__sym, path),
                   s7_cadr((s7_pointer)func_info)));
}

static gboolean lg_tree_search(GtkTreeModel* model, gint column, const gchar* key, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, model),
                   s7_make_integer(cbsc, column),
                   s7_make_string(cbsc, key),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_cell_data(GtkTreeViewColumn* tree_column, GtkCellRenderer* cell, GtkTreeModel* tree_model, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeViewColumn__sym, tree_column),
                   lg_make_c_pointer_with_type(cbsc, GtkCellRenderer__sym, cell),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, tree_model),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, iter),
                   s7_cadr((s7_pointer)func_info)));
}

static gint lg_iter_compare(GtkTreeModel* model, GtkTreeIter* a, GtkTreeIter* b, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gint)0);
  return((gint)s7_integer(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, model),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, a),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, b),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_tree_selection(GtkTreeSelection* selection, GtkTreeModel* model, GtkTreePath* path, gboolean path_currently_selected, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeSelection__sym, selection),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, model),
                   lg_make_c_pointer_with_type(cbsc, GtkTreePath__sym, path),
                   s7_make_boolean(cbsc, path_currently_selected),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_file_filter(const GtkFileFilterInfo* info, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   lg_make_c_pointer_with_type(cbsc, GtkFileFilterInfo__sym, (void *)info),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_entry_completion_match(GtkEntryCompletion* completion, const gchar* key, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   lg_make_c_pointer_with_type(cbsc, GtkEntryCompletion__sym, completion),
                   s7_make_string(cbsc, key),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static gboolean lg_row_separator(GtkTreeModel* model, GtkTreeIter* iter, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gboolean)0);
  return((gboolean)lg_boolean(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   lg_make_c_pointer_with_type(cbsc, GtkTreeModel__sym, model),
                   lg_make_c_pointer_with_type(cbsc, GtkTreeIter__sym, iter),
                   s7_cadr((s7_pointer)func_info)))));
}

static void lg_icon_view_foreach(GtkIconView* icon_view, GtkTreePath* path, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 3,
                   lg_make_c_pointer_with_type(cbsc, GtkIconView__sym, icon_view),
                   lg_make_c_pointer_with_type(cbsc, GtkTreePath__sym, path),
                   s7_cadr((s7_pointer)func_info)));
}

static void lg_g_message_log_func(const gchar* domain, GLogLevelFlags log_level, const gchar* message, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 4,
                   s7_make_string(cbsc, domain),
                   s7_make_integer(cbsc, log_level),
                   s7_make_string(cbsc, message),
                   s7_cadr((s7_pointer)func_info)));
}

static gint lg_page_func(gint current_page, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return((gint)0);
  return((gint)s7_integer(s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 2,
                   s7_make_integer(cbsc, current_page),
                   s7_cadr((s7_pointer)func_info)))));
}

#if GTK_CHECK_VERSION(3, 92, 0)
static void lg_draw_func(GtkDrawingArea* self, cairo_t* cr, int width, int height, gpointer func_info)
{
  if (!s7_is_list(cbsc, (s7_pointer)func_info)) return;
  s7_call(cbsc, 
    s7_car((s7_pointer)func_info), 
           s7_list(cbsc, 5,
                   lg_make_c_pointer_with_type(cbsc, GtkDrawingArea__sym, self),
                   lg_make_c_pointer_with_type(cbsc, cairo_t__sym, cr),
                   s7_make_integer(cbsc, width),
                   s7_make_integer(cbsc, height),
                   s7_cadr((s7_pointer)func_info)));
}
#endif


static gboolean lg_func3(GtkWidget *w, GdkEventAny *ev, gpointer data)
{
  return(s7_call(cbsc, s7_car((s7_pointer)data),
                       s7_list(cbsc, 3, s7_make_c_pointer_with_type(cbsc, w, GtkWidget__sym, lg_false),
                                        s7_make_c_pointer_with_type(cbsc, ev, GdkEventAny__sym, lg_false),
                                        (s7_is_pair(s7_cdr((s7_pointer)data))) ? (s7_cadr((s7_pointer)data)) : s7_nil(cbsc))) != lg_false);
}

static gboolean lg_func4(GtkPrintOperation *op, GtkPrintContext *context, gint page_nr, gpointer data)
{
  return(s7_call(cbsc, s7_car((s7_pointer)data),
                       s7_list(cbsc, 4, s7_make_c_pointer_with_type(cbsc, op, GtkPrintOperation__sym, lg_false),
                                        s7_make_c_pointer_with_type(cbsc, context, GtkPrintContext__sym, lg_false),
                                        s7_make_integer(cbsc, page_nr),
                                        (s7_is_pair(s7_cdr((s7_pointer)data))) ? (s7_cadr((s7_pointer)data)) : s7_nil(cbsc))) != lg_false);
}

static s7_pointer lg_g_unichar_validate(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_validate "gboolean g_unichar_validate(gunichar ch)"
  s7_pointer ch;
  ch = s7_car(args);
  if (!s7_is_integer(ch)) s7_wrong_type_arg_error(sc, "g_unichar_validate", 1, ch, "gunichar");
  return(s7_make_boolean(sc, g_unichar_validate((gunichar)s7_integer(ch))));
}

static s7_pointer lg_g_unichar_isalnum(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isalnum "gboolean g_unichar_isalnum(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isalnum", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isalnum((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isalpha(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isalpha "gboolean g_unichar_isalpha(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isalpha", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isalpha((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_iscntrl(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iscntrl "gboolean g_unichar_iscntrl(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iscntrl", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iscntrl((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isdefined(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isdefined "gboolean g_unichar_isdefined(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isdefined", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isdefined((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isdigit(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isdigit "gboolean g_unichar_isdigit(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isdigit", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isdigit((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isgraph(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isgraph "gboolean g_unichar_isgraph(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isgraph", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isgraph((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_islower(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_islower "gboolean g_unichar_islower(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_islower", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_islower((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_ismark(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_ismark "gboolean g_unichar_ismark(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_ismark", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_ismark((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isprint(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isprint "gboolean g_unichar_isprint(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isprint", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isprint((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_ispunct(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_ispunct "gboolean g_unichar_ispunct(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_ispunct", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_ispunct((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isspace(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isspace "gboolean g_unichar_isspace(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isspace", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isspace((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_istitle(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_istitle "gboolean g_unichar_istitle(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_istitle", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_istitle((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isupper(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isupper "gboolean g_unichar_isupper(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isupper", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isupper((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_isxdigit(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_isxdigit "gboolean g_unichar_isxdigit(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_isxdigit", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_isxdigit((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_iswide(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iswide "gboolean g_unichar_iswide(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iswide", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iswide((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_iswide_cjk(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iswide_cjk "gboolean g_unichar_iswide_cjk(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iswide_cjk", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iswide_cjk((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_iszerowidth(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_iszerowidth "gboolean g_unichar_iszerowidth(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_iszerowidth", 1, c, "gunichar");
  return(s7_make_boolean(sc, g_unichar_iszerowidth((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_toupper(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_toupper "gunichar g_unichar_toupper(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_toupper", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_toupper((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_tolower(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_tolower "gunichar g_unichar_tolower(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_tolower", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_tolower((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_totitle(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_totitle "gunichar g_unichar_totitle(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_totitle", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_totitle((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_digit_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_digit_value "gint g_unichar_digit_value(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_digit_value", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_digit_value((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_xdigit_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_xdigit_value "gint g_unichar_xdigit_value(gunichar c)"
  s7_pointer c;
  c = s7_car(args);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_unichar_xdigit_value", 1, c, "gunichar");
  return(s7_make_integer(sc, g_unichar_xdigit_value((gunichar)s7_integer(c))));
}

static s7_pointer lg_g_unichar_combining_class(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unichar_combining_class "gint g_unichar_combining_class(gunichar uc)"
  s7_pointer uc;
  uc = s7_car(args);
  if (!s7_is_integer(uc)) s7_wrong_type_arg_error(sc, "g_unichar_combining_class", 1, uc, "gunichar");
  return(s7_make_integer(sc, g_unichar_combining_class((gunichar)s7_integer(uc))));
}

static s7_pointer lg_g_unicode_canonical_ordering(s7_scheme *sc, s7_pointer args)
{
  #define H_g_unicode_canonical_ordering "void g_unicode_canonical_ordering(gunichar* string, gsize len)"
  s7_pointer _p;
  s7_pointer string, len;
  _p = args;
  string = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(string, gunichar__sym)) s7_wrong_type_arg_error(sc, "g_unicode_canonical_ordering", 1, string, "gunichar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_unicode_canonical_ordering", 2, len, "gsize");
  g_unicode_canonical_ordering((gunichar*)s7_c_pointer(string), (gsize)s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_g_utf8_get_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_get_char "gunichar g_utf8_get_char(gchar* p)"
  s7_pointer p;
  p = s7_car(args);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_get_char", 1, p, "gchar*");
  return(s7_make_integer(sc, g_utf8_get_char((const gchar*)s7_string(p))));
}

static s7_pointer lg_g_utf8_get_char_validated(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_get_char_validated "gunichar g_utf8_get_char_validated(gchar* p, gssize max_len)"
  s7_pointer _p;
  s7_pointer p, max_len;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_get_char_validated", 1, p, "gchar*");
  max_len = s7_car(_p);
  if (!s7_is_integer(max_len)) s7_wrong_type_arg_error(sc, "g_utf8_get_char_validated", 2, max_len, "gssize");
  return(s7_make_integer(sc, g_utf8_get_char_validated((const gchar*)s7_string(p), (gssize)s7_integer(max_len))));
}

static s7_pointer lg_g_utf8_prev_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_prev_char "gchar* g_utf8_prev_char(gchar* p)"
  s7_pointer p;
  p = s7_car(args);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_prev_char", 1, p, "gchar*");
  return(s7_make_string(sc, g_utf8_prev_char((const gchar*)s7_string(p))));
}

static s7_pointer lg_g_utf8_find_next_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_find_next_char "gchar* g_utf8_find_next_char(gchar* p, gchar* end)"
  s7_pointer _p;
  s7_pointer p, end;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_find_next_char", 1, p, "gchar*");
  end = s7_car(_p);
  if (!s7_is_string(end)) s7_wrong_type_arg_error(sc, "g_utf8_find_next_char", 2, end, "gchar*");
  return(s7_make_string(sc, g_utf8_find_next_char((const gchar*)s7_string(p), (const gchar*)s7_string(end))));
}

static s7_pointer lg_g_utf8_find_prev_char(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_find_prev_char "gchar* g_utf8_find_prev_char(gchar* str, gchar* p)"
  s7_pointer _p;
  s7_pointer str, p;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_find_prev_char", 1, str, "gchar*");
  p = s7_car(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_find_prev_char", 2, p, "gchar*");
  return(s7_make_string(sc, g_utf8_find_prev_char((const gchar*)s7_string(str), (const gchar*)s7_string(p))));
}

static s7_pointer lg_g_utf8_strlen(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strlen "glong g_utf8_strlen(gchar* p, gssize max)"
  s7_pointer _p;
  s7_pointer p, max;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_strlen", 1, p, "gchar*");
  max = s7_car(_p);
  if (!s7_is_integer(max)) s7_wrong_type_arg_error(sc, "g_utf8_strlen", 2, max, "gssize");
  return(s7_make_integer(sc, g_utf8_strlen((const gchar*)s7_string(p), (gssize)s7_integer(max))));
}

static s7_pointer lg_g_utf8_strchr(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strchr "gchar* g_utf8_strchr(gchar* p, gssize len, gunichar c)"
  s7_pointer _p;
  s7_pointer p, len, c;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_strchr", 1, p, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strchr", 2, len, "gssize");
  c = s7_car(_p);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_utf8_strchr", 3, c, "gunichar");
  return(s7_make_string(sc, g_utf8_strchr((const gchar*)s7_string(p), (gssize)s7_integer(len), (gunichar)s7_integer(c))));
}

static s7_pointer lg_g_utf8_strrchr(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strrchr "gchar* g_utf8_strrchr(gchar* p, gssize len, gunichar c)"
  s7_pointer _p;
  s7_pointer p, len, c;
  _p = args;
  p = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(p)) s7_wrong_type_arg_error(sc, "g_utf8_strrchr", 1, p, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strrchr", 2, len, "gssize");
  c = s7_car(_p);
  if (!s7_is_integer(c)) s7_wrong_type_arg_error(sc, "g_utf8_strrchr", 3, c, "gunichar");
  return(s7_make_string(sc, g_utf8_strrchr((const gchar*)s7_string(p), (gssize)s7_integer(len), (gunichar)s7_integer(c))));
}

static s7_pointer lg_g_utf8_strreverse(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strreverse "gchar* g_utf8_strreverse(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_strreverse", 1, str, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strreverse", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_strreverse((const gchar*)s7_string(str), (gssize)s7_integer(len))));
}

static s7_pointer lg_g_utf8_validate(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_validate "gboolean g_utf8_validate(gchar* str, gssize max_len, gchar** [end])"
  s7_pointer _p;
  s7_pointer str, max_len;
  gchar* ref_end = NULL;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_validate", 1, str, "gchar*");
  max_len = s7_car(_p);
  if (!s7_is_integer(max_len)) s7_wrong_type_arg_error(sc, "g_utf8_validate", 2, max_len, "gssize");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, g_utf8_validate((const gchar*)s7_string(str), (gssize)s7_integer(max_len), (const gchar**)&ref_end));
      return(s7_list(sc, 2, res_ult, s7_make_string(sc, ref_end)));
   }
}

static s7_pointer lg_g_utf8_strup(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strup "gchar* g_utf8_strup(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_strup", 1, str, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strup", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_strup((const gchar*)s7_string(str), (gssize)s7_integer(len))));
}

static s7_pointer lg_g_utf8_strdown(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_strdown "gchar* g_utf8_strdown(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_strdown", 1, str, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_strdown", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_strdown((const gchar*)s7_string(str), (gssize)s7_integer(len))));
}

static s7_pointer lg_g_utf8_casefold(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_casefold "gchar* g_utf8_casefold(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_casefold", 1, str, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_casefold", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_casefold((const gchar*)s7_string(str), (gssize)s7_integer(len))));
}

static s7_pointer lg_g_utf8_normalize(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_normalize "gchar* g_utf8_normalize(gchar* str, gssize len, GNormalizeMode mode)"
  s7_pointer _p;
  s7_pointer str, len, mode;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_normalize", 1, str, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_normalize", 2, len, "gssize");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "g_utf8_normalize", 3, mode, "GNormalizeMode");
  return(s7_make_string(sc, g_utf8_normalize((const gchar*)s7_string(str), (gssize)s7_integer(len), (GNormalizeMode)s7_integer(mode))));
}

static s7_pointer lg_g_utf8_collate(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_collate "gint g_utf8_collate(gchar* str1, gchar* str2)"
  s7_pointer _p;
  s7_pointer str1, str2;
  _p = args;
  str1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str1)) s7_wrong_type_arg_error(sc, "g_utf8_collate", 1, str1, "gchar*");
  str2 = s7_car(_p);
  if (!s7_is_string(str2)) s7_wrong_type_arg_error(sc, "g_utf8_collate", 2, str2, "gchar*");
  return(s7_make_integer(sc, g_utf8_collate((const gchar*)s7_string(str1), (const gchar*)s7_string(str2))));
}

static s7_pointer lg_g_utf8_collate_key(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_collate_key "gchar* g_utf8_collate_key(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key", 1, str, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_collate_key((const gchar*)s7_string(str), (gssize)s7_integer(len))));
}

static s7_pointer lg_g_utf8_collate_key_for_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_g_utf8_collate_key_for_filename "gchar* g_utf8_collate_key_for_filename(gchar* str, gssize len)"
  s7_pointer _p;
  s7_pointer str, len;
  _p = args;
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key_for_filename", 1, str, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "g_utf8_collate_key_for_filename", 2, len, "gssize");
  return(s7_make_string(sc, g_utf8_collate_key_for_filename((const gchar*)s7_string(str), (gssize)s7_integer(len))));
}

static s7_pointer lg_g_cclosure_new(s7_scheme *sc, s7_pointer args)
{
  #define H_g_cclosure_new "GClosure* g_cclosure_new(GCallback func, lambda_data func_info, GClosureNotify destroy_data)"
  s7_pointer _p;
  s7_pointer func, func_info, destroy_data;
  _p = args;
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy_data = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(destroy_data, GClosureNotify_sym)) && (destroy_data != lg_false)) s7_wrong_type_arg_error(sc, "g_cclosure_new", 3, destroy_data, "GClosureNotify");
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    res_ult = lg_make_c_pointer_with_type(sc, GClosure__sym, g_cclosure_new(((s7_is_aritable(sc, func, 4)) ? (GCallback)lg_func4 : ((s7_is_aritable(sc, func, 3)) ? (GCallback)lg_func3 : (GCallback)lg_func2)), (gpointer)lg_ptr, NULL));
    return(res_ult);
   }
}

static s7_pointer lg_g_signal_newv(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_newv "guint g_signal_newv(gchar* signal_name, GType itype, GSignalFlags signal_flags, \
GClosure* class_closure, GSignalAccumulator accumulator, gpointer accu_data, GSignalCMarshaller c_marshaller, \
GType return_type, guint n_params, GType* param_types)"
  s7_pointer _p;
  s7_pointer signal_name, itype, signal_flags, class_closure, accumulator, accu_data, c_marshaller, return_type, n_params, param_types;
  _p = args;
  signal_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(signal_name)) s7_wrong_type_arg_error(sc, "g_signal_newv", 1, signal_name, "gchar*");
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_newv", 2, itype, "GType");
  signal_flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_flags)) s7_wrong_type_arg_error(sc, "g_signal_newv", 3, signal_flags, "GSignalFlags");
  class_closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(class_closure, GClosure__sym)) && (class_closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_newv", 4, class_closure, "GClosure*");
  accumulator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accumulator, GSignalAccumulator_sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 5, accumulator, "GSignalAccumulator");
  accu_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accu_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 6, accu_data, "gpointer");
  c_marshaller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(c_marshaller, GSignalCMarshaller_sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 7, c_marshaller, "GSignalCMarshaller");
  return_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(return_type)) s7_wrong_type_arg_error(sc, "g_signal_newv", 8, return_type, "GType");
  n_params = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_params)) s7_wrong_type_arg_error(sc, "g_signal_newv", 9, n_params, "guint");
  param_types = s7_car(_p);
  if (!s7_is_c_pointer_of_type(param_types, GType__sym)) s7_wrong_type_arg_error(sc, "g_signal_newv", 10, param_types, "GType*");
  return(s7_make_integer(sc, g_signal_newv((gchar*)s7_string(signal_name), (GType)s7_integer(itype), (GSignalFlags)s7_integer(signal_flags), (class_closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(class_closure), (GSignalAccumulator)s7_c_pointer(accumulator), (gpointer)s7_c_pointer(accu_data), (GSignalCMarshaller)s7_c_pointer(c_marshaller), (GType)s7_integer(return_type), (guint)s7_integer(n_params), (GType*)s7_c_pointer(param_types))));
}

static s7_pointer lg_g_signal_lookup(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_lookup "guint g_signal_lookup(gchar* name, GType itype)"
  s7_pointer _p;
  s7_pointer name, itype;
  _p = args;
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_signal_lookup", 1, name, "gchar*");
  itype = s7_car(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_lookup", 2, itype, "GType");
  return(s7_make_integer(sc, g_signal_lookup((gchar*)s7_string(name), (GType)s7_integer(itype))));
}

static s7_pointer lg_g_signal_name(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_name "gchar* g_signal_name(guint signal_id)"
  s7_pointer signal_id;
  signal_id = s7_car(args);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_name", 1, signal_id, "guint");
  return(s7_make_string(sc, g_signal_name((guint)s7_integer(signal_id))));
}

static s7_pointer lg_g_signal_query(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_query "void g_signal_query(guint signal_id, GSignalQuery* query)"
  s7_pointer _p;
  s7_pointer signal_id, query;
  _p = args;
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_query", 1, signal_id, "guint");
  query = s7_car(_p);
  if (!s7_is_c_pointer_of_type(query, GSignalQuery__sym)) s7_wrong_type_arg_error(sc, "g_signal_query", 2, query, "GSignalQuery*");
  g_signal_query((guint)s7_integer(signal_id), (GSignalQuery*)s7_c_pointer(query));
  return(lg_false);
}

static s7_pointer lg_g_signal_list_ids(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_list_ids "guint* g_signal_list_ids(GType itype, guint* n_ids)"
  s7_pointer _p;
  s7_pointer itype, n_ids;
  _p = args;
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_list_ids", 1, itype, "GType");
  n_ids = s7_car(_p);
  if (!s7_is_c_pointer_of_type(n_ids, guint__sym)) s7_wrong_type_arg_error(sc, "g_signal_list_ids", 2, n_ids, "guint*");
  return(lg_make_c_pointer_with_type(sc, guint__sym, g_signal_list_ids((GType)s7_integer(itype), (guint*)s7_c_pointer(n_ids))));
}

static s7_pointer lg_g_signal_parse_name(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_parse_name "gboolean g_signal_parse_name(gchar* detailed_signal, GType itype, guint* [signal_id_p], \
GQuark* [detail_p], gboolean force_detail_quark)"
  s7_pointer _p;
  s7_pointer detailed_signal, itype, force_detail_quark;
  guint ref_signal_id_p;
  GQuark ref_detail_p;
  _p = args;
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_parse_name", 1, detailed_signal, "gchar*");
  itype = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(itype)) s7_wrong_type_arg_error(sc, "g_signal_parse_name", 2, itype, "GType");
  force_detail_quark = s7_car(_p);
  if (!s7_is_boolean(force_detail_quark)) s7_wrong_type_arg_error(sc, "g_signal_parse_name", 5, force_detail_quark, "gboolean");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, g_signal_parse_name((gchar*)s7_string(detailed_signal), (GType)s7_integer(itype), &ref_signal_id_p, &ref_detail_p, (gboolean)lg_boolean(force_detail_quark)));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_signal_id_p), s7_make_integer(sc, ref_detail_p)));
   }
}

static s7_pointer lg_g_signal_get_invocation_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_get_invocation_hint "GSignalInvocationHint* g_signal_get_invocation_hint(gpointer instance)"
  s7_pointer instance;
  instance = s7_car(args);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_get_invocation_hint", 1, instance, "gpointer");
  return(lg_make_c_pointer_with_type(sc, GSignalInvocationHint__sym, g_signal_get_invocation_hint((gpointer)s7_c_pointer(instance))));
}

static s7_pointer lg_g_signal_stop_emission(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_stop_emission "void g_signal_stop_emission(gpointer instance, guint signal_id, GQuark detail)"
  s7_pointer _p;
  s7_pointer instance, signal_id, detail;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission", 1, instance, "gpointer");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission", 2, signal_id, "guint");
  detail = s7_car(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission", 3, detail, "GQuark");
  g_signal_stop_emission((gpointer)s7_c_pointer(instance), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail));
  return(lg_false);
}

static s7_pointer lg_g_signal_stop_emission_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_stop_emission_by_name "void g_signal_stop_emission_by_name(gpointer instance, gchar* detailed_signal)"
  s7_pointer _p;
  s7_pointer instance, detailed_signal;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission_by_name", 1, instance, "gpointer");
  detailed_signal = s7_car(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_stop_emission_by_name", 2, detailed_signal, "gchar*");
  g_signal_stop_emission_by_name((gpointer)s7_c_pointer(instance), (gchar*)s7_string(detailed_signal));
  return(lg_false);
}

static s7_pointer lg_g_signal_add_emission_hook(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_add_emission_hook "gulong g_signal_add_emission_hook(guint signal_id, GQuark quark, \
GSignalEmissionHook hook_func, lambda_data func_info, GtkDestroyNotify data_destroy)"
  s7_pointer _p;
  s7_pointer signal_id, quark, hook_func, func_info, data_destroy;
  _p = args;
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 1, signal_id, "guint");
  quark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(quark)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 2, quark, "GQuark");
  hook_func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(hook_func, GSignalEmissionHook_sym)) s7_wrong_type_arg_error(sc, "g_signal_add_emission_hook", 3, hook_func, "GSignalEmissionHook");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  data_destroy = s7_car(_p);
  {
    s7_pointer res_ult;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, data_destroy);
    res_ult = s7_make_integer(sc, g_signal_add_emission_hook((guint)s7_integer(signal_id), (GQuark)s7_integer(quark), (GSignalEmissionHook)s7_c_pointer(hook_func), (gpointer)lg_ptr, lg_destroy_func));
    return(res_ult);
   }
}

static s7_pointer lg_g_signal_remove_emission_hook(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_remove_emission_hook "void g_signal_remove_emission_hook(guint signal_id, gulong hook_id)"
  s7_pointer _p;
  s7_pointer signal_id, hook_id;
  _p = args;
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_remove_emission_hook", 1, signal_id, "guint");
  hook_id = s7_car(_p);
  if (!s7_is_integer(hook_id)) s7_wrong_type_arg_error(sc, "g_signal_remove_emission_hook", 2, hook_id, "gulong");
  g_signal_remove_emission_hook((guint)s7_integer(signal_id), (gulong)s7_integer(hook_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_has_handler_pending(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_has_handler_pending "gboolean g_signal_has_handler_pending(gpointer instance, guint signal_id, \
GQuark detail, gboolean may_be_blocked)"
  s7_pointer _p;
  s7_pointer instance, signal_id, detail, may_be_blocked;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 1, instance, "gpointer");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 2, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 3, detail, "GQuark");
  may_be_blocked = s7_car(_p);
  if (!s7_is_boolean(may_be_blocked)) s7_wrong_type_arg_error(sc, "g_signal_has_handler_pending", 4, may_be_blocked, "gboolean");
  return(s7_make_boolean(sc, g_signal_has_handler_pending((gpointer)s7_c_pointer(instance), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail), (gboolean)lg_boolean(may_be_blocked))));
}

static s7_pointer lg_g_signal_connect_closure_by_id(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect_closure_by_id "gulong g_signal_connect_closure_by_id(gpointer instance, \
guint signal_id, GQuark detail, GClosure* closure, gboolean after)"
  s7_pointer _p;
  s7_pointer instance, signal_id, detail, closure, after;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 1, instance, "gpointer");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 2, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 3, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 4, closure, "GClosure*");
  after = s7_car(_p);
  if (!s7_is_boolean(after)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure_by_id", 5, after, "gboolean");
  return(s7_make_integer(sc, g_signal_connect_closure_by_id((gpointer)s7_c_pointer(instance), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail), (closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(closure), (gboolean)lg_boolean(after))));
}

static s7_pointer lg_g_signal_connect_closure(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect_closure "gulong g_signal_connect_closure(gpointer instance, gchar* detailed_signal, \
GClosure* closure, gboolean after)"
  s7_pointer _p;
  s7_pointer instance, detailed_signal, closure, after;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 1, instance, "gpointer");
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 2, detailed_signal, "gchar*");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 3, closure, "GClosure*");
  after = s7_car(_p);
  if (!s7_is_boolean(after)) s7_wrong_type_arg_error(sc, "g_signal_connect_closure", 4, after, "gboolean");
  return(s7_make_integer(sc, g_signal_connect_closure((gpointer)s7_c_pointer(instance), (gchar*)s7_string(detailed_signal), (closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(closure), (gboolean)lg_boolean(after))));
}

static s7_pointer lg_g_signal_connect_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect_data "gulong g_signal_connect_data(gpointer instance, gchar* detailed_signal, \
GCallback func, lambda_data func_info, GClosureNotify destroy_data, GConnectFlags connect_flags)"
  s7_pointer _p;
  s7_pointer instance, detailed_signal, func, func_info, destroy_data, connect_flags;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 1, instance, "gpointer");
  detailed_signal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(detailed_signal)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 2, detailed_signal, "gchar*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy_data = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(destroy_data, GClosureNotify_sym)) && (destroy_data != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 5, destroy_data, "GClosureNotify");
  connect_flags = s7_car(_p);
  if (!s7_is_integer(connect_flags)) s7_wrong_type_arg_error(sc, "g_signal_connect_data", 6, connect_flags, "GConnectFlags");
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    res_ult = s7_make_integer(sc, g_signal_connect_data((gpointer)s7_c_pointer(instance), (gchar*)s7_string(detailed_signal), ((s7_is_aritable(sc, func, 4)) ? (GCallback)lg_func4 : ((s7_is_aritable(sc, func, 3)) ? (GCallback)lg_func3 : (GCallback)lg_func2)), (gpointer)lg_ptr, NULL, (GConnectFlags)s7_integer(connect_flags)));
    return(res_ult);
   }
}

static s7_pointer lg_g_signal_handler_block(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_block "void g_signal_handler_block(gpointer instance, gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_block", 1, instance, "gpointer");
  handler_id = s7_car(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_block", 2, handler_id, "gulong");
  g_signal_handler_block((gpointer)s7_c_pointer(instance), (gulong)s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_handler_unblock(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_unblock "void g_signal_handler_unblock(gpointer instance, gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_unblock", 1, instance, "gpointer");
  handler_id = s7_car(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_unblock", 2, handler_id, "gulong");
  g_signal_handler_unblock((gpointer)s7_c_pointer(instance), (gulong)s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_handler_disconnect(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_disconnect "void g_signal_handler_disconnect(gpointer instance, gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_disconnect", 1, instance, "gpointer");
  handler_id = s7_car(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_disconnect", 2, handler_id, "gulong");
  g_signal_handler_disconnect((gpointer)s7_c_pointer(instance), (gulong)s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_g_signal_handler_is_connected(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_is_connected "gboolean g_signal_handler_is_connected(gpointer instance, \
gulong handler_id)"
  s7_pointer _p;
  s7_pointer instance, handler_id;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_is_connected", 1, instance, "gpointer");
  handler_id = s7_car(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_is_connected", 2, handler_id, "gulong");
  return(s7_make_boolean(sc, g_signal_handler_is_connected((gpointer)s7_c_pointer(instance), (gulong)s7_integer(handler_id))));
}

static s7_pointer lg_g_signal_handler_find(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handler_find "gulong g_signal_handler_find(gpointer instance, GSignalMatchType mask, \
guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 6, func, "gpointer");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handler_find", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handler_find((gpointer)s7_c_pointer(instance), (GSignalMatchType)s7_integer(mask), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail), (closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(closure), (gpointer)s7_c_pointer(func), (gpointer)s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_block_matched(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_block_matched "guint g_signal_handlers_block_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 6, func, "gpointer");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_block_matched", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handlers_block_matched((gpointer)s7_c_pointer(instance), (GSignalMatchType)s7_integer(mask), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail), (closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(closure), (gpointer)s7_c_pointer(func), (gpointer)s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_unblock_matched(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_unblock_matched "guint g_signal_handlers_unblock_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 6, func, "gpointer");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_unblock_matched", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handlers_unblock_matched((gpointer)s7_c_pointer(instance), (GSignalMatchType)s7_integer(mask), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail), (closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(closure), (gpointer)s7_c_pointer(func), (gpointer)s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_disconnect_matched(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_disconnect_matched "guint g_signal_handlers_disconnect_matched(gpointer instance, \
GSignalMatchType mask, guint signal_id, GQuark detail, GClosure* closure, gpointer func, gpointer data)"
  s7_pointer _p;
  s7_pointer instance, mask, signal_id, detail, closure, func, data;
  _p = args;
  instance = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 1, instance, "gpointer");
  mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mask)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 2, mask, "GSignalMatchType");
  signal_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(signal_id)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 3, signal_id, "guint");
  detail = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(detail)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 4, detail, "GQuark");
  closure = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(closure, GClosure__sym)) && (closure != lg_false)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 5, closure, "GClosure*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 6, func, "gpointer");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_disconnect_matched", 7, data, "gpointer");
  return(s7_make_integer(sc, g_signal_handlers_disconnect_matched((gpointer)s7_c_pointer(instance), (GSignalMatchType)s7_integer(mask), (guint)s7_integer(signal_id), (GQuark)s7_integer(detail), (closure == lg_false) ? NULL : (GClosure*)s7_c_pointer(closure), (gpointer)s7_c_pointer(func), (gpointer)s7_c_pointer(data))));
}

static s7_pointer lg_g_signal_handlers_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_handlers_destroy "void g_signal_handlers_destroy(gpointer instance)"
  s7_pointer instance;
  instance = s7_car(args);
  if (!s7_is_c_pointer_of_type(instance, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_signal_handlers_destroy", 1, instance, "gpointer");
  g_signal_handlers_destroy((gpointer)s7_c_pointer(instance));
  return(lg_false);
}

static s7_pointer lg_g_object_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_ref "gpointer g_object_ref(gpointer object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_object_ref", 1, object, "gpointer");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, g_object_ref((gpointer)s7_c_pointer(object))));
}

static s7_pointer lg_g_object_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_unref "void g_object_unref(gpointer object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_object_unref", 1, object, "gpointer");
  g_object_unref((gpointer)s7_c_pointer(object));
  return(lg_false);
}

static s7_pointer lg_gdk_event_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_copy "GdkEvent* gdk_event_copy(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_copy", 1, event, "GdkEvent*");
  return(lg_make_c_pointer_with_type(sc, GdkEvent__sym, gdk_event_copy((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_get_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_time "guint32 gdk_event_get_time(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gdk_event_get_time", 1, event, "GdkEvent*");
  return(s7_make_integer(sc, gdk_event_get_time((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_state "gboolean gdk_event_get_state(GdkEvent* event, GdkModifierType* [state])"
  s7_pointer _p;
  s7_pointer event;
  GdkModifierType ref_state;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_state", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_state((GdkEvent*)s7_c_pointer(event), &ref_state));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_state)));
   }
}

static s7_pointer lg_gdk_event_get_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_coords "gboolean gdk_event_get_coords(GdkEvent* event, gdouble* [x_win], gdouble* [y_win])"
  s7_pointer _p;
  s7_pointer event;
  gdouble ref_x_win;
  gdouble ref_y_win;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_coords", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_coords((GdkEvent*)s7_c_pointer(event), &ref_x_win, &ref_y_win));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x_win), s7_make_real(sc, ref_y_win)));
   }
}

static s7_pointer lg_gdk_event_get_root_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_root_coords "gboolean gdk_event_get_root_coords(GdkEvent* event, gdouble* [x_root], \
gdouble* [y_root])"
  s7_pointer _p;
  s7_pointer event;
  gdouble ref_x_root;
  gdouble ref_y_root;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_root_coords", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_root_coords((GdkEvent*)s7_c_pointer(event), &ref_x_root, &ref_y_root));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x_root), s7_make_real(sc, ref_y_root)));
   }
}

static s7_pointer lg_gdk_set_show_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_set_show_events "void gdk_set_show_events(gboolean show_events)"
  s7_pointer show_events;
  show_events = s7_car(args);
  if (!s7_is_boolean(show_events)) s7_wrong_type_arg_error(sc, "gdk_set_show_events", 1, show_events, "gboolean");
  gdk_set_show_events((gboolean)lg_boolean(show_events));
  return(lg_false);
}

static s7_pointer lg_gdk_get_show_events(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_get_show_events "gboolean gdk_get_show_events( void)"
  return(s7_make_boolean(sc, gdk_get_show_events()));
}

static s7_pointer lg_gdk_rectangle_intersect(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_intersect "gboolean gdk_rectangle_intersect(GdkRectangle* src1, GdkRectangle* src2, \
GdkRectangle* dest)"
  s7_pointer _p;
  s7_pointer src1, src2, dest;
  _p = args;
  src1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src1, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_intersect", 1, src1, "GdkRectangle*");
  src2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src2, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_intersect", 2, src2, "GdkRectangle*");
  dest = s7_car(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_intersect", 3, dest, "GdkRectangle*");
  return(s7_make_boolean(sc, gdk_rectangle_intersect((GdkRectangle*)s7_c_pointer(src1), (GdkRectangle*)s7_c_pointer(src2), (GdkRectangle*)s7_c_pointer(dest))));
}

static s7_pointer lg_gdk_rectangle_union(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_union "void gdk_rectangle_union(GdkRectangle* src1, GdkRectangle* src2, GdkRectangle* dest)"
  s7_pointer _p;
  s7_pointer src1, src2, dest;
  _p = args;
  src1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src1, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_union", 1, src1, "GdkRectangle*");
  src2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src2, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_union", 2, src2, "GdkRectangle*");
  dest = s7_car(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_union", 3, dest, "GdkRectangle*");
  gdk_rectangle_union((GdkRectangle*)s7_c_pointer(src1), (GdkRectangle*)s7_c_pointer(src2), (GdkRectangle*)s7_c_pointer(dest));
  return(lg_false);
}

static s7_pointer lg_gdk_keymap_lookup_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_lookup_key "guint gdk_keymap_lookup_key(GdkKeymap* keymap, GdkKeymapKey* key)"
  s7_pointer _p;
  s7_pointer keymap, key;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_lookup_key", 1, keymap, "GdkKeymap*");
  key = s7_car(_p);
  if (!s7_is_c_pointer_of_type(key, GdkKeymapKey__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_lookup_key", 2, key, "GdkKeymapKey*");
  return(s7_make_integer(sc, gdk_keymap_lookup_key((GdkKeymap*)s7_c_pointer(keymap), (GdkKeymapKey*)s7_c_pointer(key))));
}

static s7_pointer lg_gdk_keyval_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_name "gchar* gdk_keyval_name(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_name", 1, keyval, "guint");
  return(s7_make_string(sc, gdk_keyval_name((guint)s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_from_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_from_name "guint gdk_keyval_from_name(gchar* keyval_name)"
  s7_pointer keyval_name;
  keyval_name = s7_car(args);
  if (!s7_is_string(keyval_name)) s7_wrong_type_arg_error(sc, "gdk_keyval_from_name", 1, keyval_name, "gchar*");
  return(s7_make_integer(sc, gdk_keyval_from_name((gchar*)s7_string(keyval_name))));
}

static s7_pointer lg_gdk_keyval_convert_case(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_convert_case "void gdk_keyval_convert_case(guint symbol, guint* [lower], guint* [upper])"
  s7_pointer _p;
  s7_pointer symbol;
  guint ref_lower;
  guint ref_upper;
  _p = args;
  symbol = s7_car(_p);
  if (!s7_is_integer(symbol)) s7_wrong_type_arg_error(sc, "gdk_keyval_convert_case", 1, symbol, "guint");
  gdk_keyval_convert_case((guint)s7_integer(symbol), &ref_lower, &ref_upper);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_lower), s7_make_integer(sc, ref_upper)));
}

static s7_pointer lg_gdk_keyval_to_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_to_upper "guint gdk_keyval_to_upper(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_to_upper", 1, keyval, "guint");
  return(s7_make_integer(sc, gdk_keyval_to_upper((guint)s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_to_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_to_lower "guint gdk_keyval_to_lower(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_to_lower", 1, keyval, "guint");
  return(s7_make_integer(sc, gdk_keyval_to_lower((guint)s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_is_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_is_upper "gboolean gdk_keyval_is_upper(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_is_upper", 1, keyval, "guint");
  return(s7_make_boolean(sc, gdk_keyval_is_upper((guint)s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_is_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_is_lower "gboolean gdk_keyval_is_lower(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_is_lower", 1, keyval, "guint");
  return(s7_make_boolean(sc, gdk_keyval_is_lower((guint)s7_integer(keyval))));
}

static s7_pointer lg_gdk_keyval_to_unicode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keyval_to_unicode "guint32 gdk_keyval_to_unicode(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_keyval_to_unicode", 1, keyval, "guint");
  return(s7_make_integer(sc, gdk_keyval_to_unicode((guint)s7_integer(keyval))));
}

static s7_pointer lg_gdk_unicode_to_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_unicode_to_keyval "guint gdk_unicode_to_keyval(guint32 wc)"
  s7_pointer wc;
  wc = s7_car(args);
  if (!s7_is_integer(wc)) s7_wrong_type_arg_error(sc, "gdk_unicode_to_keyval", 1, wc, "guint32");
  return(s7_make_integer(sc, gdk_unicode_to_keyval((guint32)s7_integer(wc))));
}

static s7_pointer lg_gdk_utf8_to_string_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_utf8_to_string_target "gchar* gdk_utf8_to_string_target(gchar* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gdk_utf8_to_string_target", 1, str, "gchar*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gdk_utf8_to_string_target((gchar*)s7_string(str));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gdk_pixbuf_error_quark(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_error_quark "GQuark gdk_pixbuf_error_quark( void)"
  return(s7_make_integer(sc, gdk_pixbuf_error_quark()));
}

static s7_pointer lg_gdk_pixbuf_get_colorspace(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_colorspace "GdkColorspace gdk_pixbuf_get_colorspace(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_colorspace", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_colorspace((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_n_channels(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_n_channels "int gdk_pixbuf_get_n_channels(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_n_channels", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_n_channels((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_has_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_has_alpha "gboolean gdk_pixbuf_get_has_alpha(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_has_alpha", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_boolean(sc, gdk_pixbuf_get_has_alpha((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_bits_per_sample(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_bits_per_sample "int gdk_pixbuf_get_bits_per_sample(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_bits_per_sample", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_bits_per_sample((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_pixels(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_pixels "guchar* gdk_pixbuf_get_pixels(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_pixels", 1, pixbuf, "GdkPixbuf*");
  return(lg_make_c_pointer_with_type(sc, guchar__sym, gdk_pixbuf_get_pixels((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_width "int gdk_pixbuf_get_width(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_width", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_width((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_height "int gdk_pixbuf_get_height(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_height", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_height((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_get_rowstride(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_rowstride "int gdk_pixbuf_get_rowstride(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_rowstride", 1, pixbuf, "GdkPixbuf*");
  return(s7_make_integer(sc, gdk_pixbuf_get_rowstride((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new "GdkPixbuf* gdk_pixbuf_new(GdkColorspace colorspace, gboolean has_alpha, int bits_per_sample, \
int width, int height)"
  s7_pointer _p;
  s7_pointer colorspace, has_alpha, bits_per_sample, width, height;
  _p = args;
  colorspace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(colorspace)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 1, colorspace, "GdkColorspace");
  has_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 2, has_alpha, "gboolean");
  bits_per_sample = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bits_per_sample)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 3, bits_per_sample, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 4, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new", 5, height, "int");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_new((GdkColorspace)s7_integer(colorspace), (gboolean)lg_boolean(has_alpha), (int)s7_integer(bits_per_sample), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_gdk_pixbuf_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_copy "GdkPixbuf* gdk_pixbuf_copy(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy", 1, pixbuf, "GdkPixbuf*");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_copy((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_pixbuf_new_subpixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_subpixbuf "GdkPixbuf* gdk_pixbuf_new_subpixbuf(GdkPixbuf* src_pixbuf, int src_x, \
int src_y, int width, int height)"
  s7_pointer _p;
  s7_pointer src_pixbuf, src_x, src_y, width, height;
  _p = args;
  src_pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src_pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 1, src_pixbuf, "GdkPixbuf*");
  src_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 2, src_x, "int");
  src_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 3, src_y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 4, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_subpixbuf", 5, height, "int");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_new_subpixbuf((GdkPixbuf*)s7_c_pointer(src_pixbuf), (int)s7_integer(src_x), (int)s7_integer(src_y), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_gdk_pixbuf_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_from_file "GdkPixbuf* gdk_pixbuf_new_from_file(char* filename, GError** [error])"
  s7_pointer _p;
  s7_pointer filename;
  GError* ref_error = NULL;
  _p = args;
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_file", 1, filename, "char*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_new_from_file((char*)s7_string(filename), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_pixbuf_new_from_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_from_data "GdkPixbuf* gdk_pixbuf_new_from_data(guchar* data, GdkColorspace colorspace, \
gboolean has_alpha, int bits_per_sample, int width, int height, int rowstride, GdkPixbufDestroyNotify destroy_fn, \
gpointer destroy_fn_data)"
  s7_pointer _p;
  s7_pointer data, colorspace, has_alpha, bits_per_sample, width, height, rowstride, destroy_fn, destroy_fn_data;
  _p = args;
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 1, data, "guchar*");
  colorspace = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(colorspace)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 2, colorspace, "GdkColorspace");
  has_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 3, has_alpha, "gboolean");
  bits_per_sample = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bits_per_sample)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 4, bits_per_sample, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 5, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 6, height, "int");
  rowstride = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(rowstride)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 7, rowstride, "int");
  destroy_fn = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy_fn, GdkPixbufDestroyNotify_sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 8, destroy_fn, "GdkPixbufDestroyNotify");
  destroy_fn_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(destroy_fn_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_data", 9, destroy_fn_data, "gpointer");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_new_from_data((guchar*)s7_c_pointer(data), (GdkColorspace)s7_integer(colorspace), (gboolean)lg_boolean(has_alpha), (int)s7_integer(bits_per_sample), (int)s7_integer(width), (int)s7_integer(height), (int)s7_integer(rowstride), (GdkPixbufDestroyNotify)s7_c_pointer(destroy_fn), (gpointer)s7_c_pointer(destroy_fn_data))));
}

static s7_pointer lg_gdk_pixbuf_new_from_xpm_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_new_from_xpm_data "GdkPixbuf* gdk_pixbuf_new_from_xpm_data(char** data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, char___sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_new_from_xpm_data", 1, data, "char**");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_new_from_xpm_data((const char**)s7_c_pointer(data))));
}

static s7_pointer lg_gdk_pixbuf_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_fill "void gdk_pixbuf_fill(GdkPixbuf* pixbuf, guint32 pixel)"
  s7_pointer _p;
  s7_pointer pixbuf, pixel;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_fill", 1, pixbuf, "GdkPixbuf*");
  pixel = s7_car(_p);
  if (!s7_is_integer(pixel)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_fill", 2, pixel, "guint32");
  gdk_pixbuf_fill((GdkPixbuf*)s7_c_pointer(pixbuf), (guint32)s7_integer(pixel));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_savev(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_savev "gboolean gdk_pixbuf_savev(GdkPixbuf* pixbuf, char* filename, char* type, \
char** option_keys, char** option_values, GError** [error])"
  s7_pointer _p;
  s7_pointer pixbuf, filename, type, option_keys, option_values;
  GError* ref_error = NULL;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 1, pixbuf, "GdkPixbuf*");
  filename = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 2, filename, "char*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 3, type, "char*");
  option_keys = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(option_keys, char___sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 4, option_keys, "char**");
  option_values = s7_car(_p);
  if (!s7_is_c_pointer_of_type(option_values, char___sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_savev", 5, option_values, "char**");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_pixbuf_savev((GdkPixbuf*)s7_c_pointer(pixbuf), (char*)s7_string(filename), (char*)s7_string(type), (char**)s7_c_pointer(option_keys), (char**)s7_c_pointer(option_values), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_pixbuf_add_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_add_alpha "GdkPixbuf* gdk_pixbuf_add_alpha(GdkPixbuf* pixbuf, gboolean substitute_color, \
guchar r, guchar g, guchar b)"
  s7_pointer _p;
  s7_pointer pixbuf, substitute_color, r, g, b;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 1, pixbuf, "GdkPixbuf*");
  substitute_color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(substitute_color)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 2, substitute_color, "gboolean");
  r = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(r)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 3, r, "guchar");
  g = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(g)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 4, g, "guchar");
  b = s7_car(_p);
  if (!s7_is_integer(b)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_add_alpha", 5, b, "guchar");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_add_alpha((GdkPixbuf*)s7_c_pointer(pixbuf), (gboolean)lg_boolean(substitute_color), (guchar)s7_integer(r), (guchar)s7_integer(g), (guchar)s7_integer(b))));
}

static s7_pointer lg_gdk_pixbuf_copy_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_copy_area "void gdk_pixbuf_copy_area(GdkPixbuf* src_pixbuf, int src_x, int src_y, \
int width, int height, GdkPixbuf* dest_pixbuf, int dest_x, int dest_y)"
  s7_pointer _p;
  s7_pointer src_pixbuf, src_x, src_y, width, height, dest_pixbuf, dest_x, dest_y;
  _p = args;
  src_pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src_pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 1, src_pixbuf, "GdkPixbuf*");
  src_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 2, src_x, "int");
  src_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 3, src_y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 4, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 5, height, "int");
  dest_pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest_pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 6, dest_pixbuf, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 7, dest_x, "int");
  dest_y = s7_car(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_copy_area", 8, dest_y, "int");
  gdk_pixbuf_copy_area((GdkPixbuf*)s7_c_pointer(src_pixbuf), (int)s7_integer(src_x), (int)s7_integer(src_y), (int)s7_integer(width), (int)s7_integer(height), (GdkPixbuf*)s7_c_pointer(dest_pixbuf), (int)s7_integer(dest_x), (int)s7_integer(dest_y));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_saturate_and_pixelate(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_saturate_and_pixelate "void gdk_pixbuf_saturate_and_pixelate(GdkPixbuf* src, GdkPixbuf* dest, \
gfloat saturation, gboolean pixelate)"
  s7_pointer _p;
  s7_pointer src, dest, saturation, pixelate;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 2, dest, "GdkPixbuf*");
  saturation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(saturation)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 3, saturation, "gfloat");
  pixelate = s7_car(_p);
  if (!s7_is_boolean(pixelate)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_saturate_and_pixelate", 4, pixelate, "gboolean");
  gdk_pixbuf_saturate_and_pixelate((GdkPixbuf*)s7_c_pointer(src), (GdkPixbuf*)s7_c_pointer(dest), (gfloat)s7_real(saturation), (gboolean)lg_boolean(pixelate));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_scale "void gdk_pixbuf_scale(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, int dest_y, \
int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, GdkInterpType interp_type)"
  s7_pointer _p;
  s7_pointer src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 2, dest, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 3, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 4, dest_y, "int");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 5, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 6, dest_height, "int");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 7, offset_x, "double");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 8, offset_y, "double");
  scale_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 9, scale_x, "double");
  scale_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 10, scale_y, "double");
  interp_type = s7_car(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale", 11, interp_type, "GdkInterpType");
  gdk_pixbuf_scale((GdkPixbuf*)s7_c_pointer(src), (GdkPixbuf*)s7_c_pointer(dest), (int)s7_integer(dest_x), (int)s7_integer(dest_y), (int)s7_integer(dest_width), (int)s7_integer(dest_height), (double)s7_real(offset_x), (double)s7_real(offset_y), (double)s7_real(scale_x), (double)s7_real(scale_y), (GdkInterpType)s7_integer(interp_type));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_composite(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_composite "void gdk_pixbuf_composite(GdkPixbuf* src, GdkPixbuf* dest, int dest_x, \
int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, double scale_y, \
GdkInterpType interp_type, int overall_alpha)"
  s7_pointer _p;
  s7_pointer src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 2, dest, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 3, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 4, dest_y, "int");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 5, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 6, dest_height, "int");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 7, offset_x, "double");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 8, offset_y, "double");
  scale_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 9, scale_x, "double");
  scale_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 10, scale_y, "double");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 11, interp_type, "GdkInterpType");
  overall_alpha = s7_car(_p);
  if (!s7_is_integer(overall_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite", 12, overall_alpha, "int");
  gdk_pixbuf_composite((GdkPixbuf*)s7_c_pointer(src), (GdkPixbuf*)s7_c_pointer(dest), (int)s7_integer(dest_x), (int)s7_integer(dest_y), (int)s7_integer(dest_width), (int)s7_integer(dest_height), (double)s7_real(offset_x), (double)s7_real(offset_y), (double)s7_real(scale_x), (double)s7_real(scale_y), (GdkInterpType)s7_integer(interp_type), (int)s7_integer(overall_alpha));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_composite_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_composite_color "void gdk_pixbuf_composite_color(GdkPixbuf* src, GdkPixbuf* dest, \
int dest_x, int dest_y, int dest_width, int dest_height, double offset_x, double offset_y, double scale_x, \
double scale_y, GdkInterpType interp_type, int overall_alpha, int check_x, int check_y, int check_size, \
guint32 color1, guint32 color2)"
  s7_pointer _p;
  s7_pointer src, dest, dest_x, dest_y, dest_width, dest_height, offset_x, offset_y, scale_x, scale_y, interp_type, overall_alpha, check_x, check_y, check_size, color1, color2;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 1, src, "GdkPixbuf*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 2, dest, "GdkPixbuf*");
  dest_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 3, dest_x, "int");
  dest_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 4, dest_y, "int");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 5, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 6, dest_height, "int");
  offset_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 7, offset_x, "double");
  offset_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 8, offset_y, "double");
  scale_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 9, scale_x, "double");
  scale_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(scale_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 10, scale_y, "double");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 11, interp_type, "GdkInterpType");
  overall_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(overall_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 12, overall_alpha, "int");
  check_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_x)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 13, check_x, "int");
  check_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_y)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 14, check_y, "int");
  check_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_size)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 15, check_size, "int");
  color1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(color1)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 16, color1, "guint32");
  color2 = s7_car(_p);
  if (!s7_is_integer(color2)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color", 17, color2, "guint32");
  gdk_pixbuf_composite_color((GdkPixbuf*)s7_c_pointer(src), (GdkPixbuf*)s7_c_pointer(dest), (int)s7_integer(dest_x), (int)s7_integer(dest_y), (int)s7_integer(dest_width), (int)s7_integer(dest_height), (double)s7_real(offset_x), (double)s7_real(offset_y), (double)s7_real(scale_x), (double)s7_real(scale_y), (GdkInterpType)s7_integer(interp_type), (int)s7_integer(overall_alpha), (int)s7_integer(check_x), (int)s7_integer(check_y), (int)s7_integer(check_size), (guint32)s7_integer(color1), (guint32)s7_integer(color2));
  return(lg_false);
}

static s7_pointer lg_gdk_pixbuf_scale_simple(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_scale_simple "GdkPixbuf* gdk_pixbuf_scale_simple(GdkPixbuf* src, int dest_width, \
int dest_height, GdkInterpType interp_type)"
  s7_pointer _p;
  s7_pointer src, dest_width, dest_height, interp_type;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 1, src, "GdkPixbuf*");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 2, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 3, dest_height, "int");
  interp_type = s7_car(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_scale_simple", 4, interp_type, "GdkInterpType");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_scale_simple((GdkPixbuf*)s7_c_pointer(src), (int)s7_integer(dest_width), (int)s7_integer(dest_height), (GdkInterpType)s7_integer(interp_type))));
}

static s7_pointer lg_gdk_pixbuf_composite_color_simple(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_composite_color_simple "GdkPixbuf* gdk_pixbuf_composite_color_simple(GdkPixbuf* src, \
int dest_width, int dest_height, GdkInterpType interp_type, int overall_alpha, int check_size, guint32 color1, \
guint32 color2)"
  s7_pointer _p;
  s7_pointer src, dest_width, dest_height, interp_type, overall_alpha, check_size, color1, color2;
  _p = args;
  src = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 1, src, "GdkPixbuf*");
  dest_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_width)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 2, dest_width, "int");
  dest_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dest_height)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 3, dest_height, "int");
  interp_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interp_type)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 4, interp_type, "GdkInterpType");
  overall_alpha = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(overall_alpha)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 5, overall_alpha, "int");
  check_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(check_size)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 6, check_size, "int");
  color1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(color1)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 7, color1, "guint32");
  color2 = s7_car(_p);
  if (!s7_is_integer(color2)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_composite_color_simple", 8, color2, "guint32");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_composite_color_simple((GdkPixbuf*)s7_c_pointer(src), (int)s7_integer(dest_width), (int)s7_integer(dest_height), (GdkInterpType)s7_integer(interp_type), (int)s7_integer(overall_alpha), (int)s7_integer(check_size), (guint32)s7_integer(color1), (guint32)s7_integer(color2))));
}

static s7_pointer lg_gdk_pixbuf_get_option(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_option "gchar* gdk_pixbuf_get_option(GdkPixbuf* pixbuf, gchar* key)"
  s7_pointer _p;
  s7_pointer pixbuf, key;
  _p = args;
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_option", 1, pixbuf, "GdkPixbuf*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_option", 2, key, "gchar*");
  return(s7_make_string(sc, gdk_pixbuf_get_option((GdkPixbuf*)s7_c_pointer(pixbuf), (gchar*)s7_string(key))));
}

static s7_pointer lg_gtk_accel_label_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_new "GtkWidget* gtk_accel_label_new(gchar* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "gtk_accel_label_new", 1, string, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_accel_label_new((gchar*)s7_string(string))));
}

static s7_pointer lg_gtk_accel_label_get_accel_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_accel_width "guint gtk_accel_label_get_accel_width(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_accel_width", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_integer(sc, gtk_accel_label_get_accel_width((GtkAccelLabel*)s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_accel_label_refetch(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_refetch "gboolean gtk_accel_label_refetch(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_refetch", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_boolean(sc, gtk_accel_label_refetch((GtkAccelLabel*)s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_adjustment_clamp_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_clamp_page "void gtk_adjustment_clamp_page(GtkAdjustment* adjustment, gdouble lower, \
gdouble upper)"
  s7_pointer _p;
  s7_pointer adjustment, lower, upper;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_clamp_page", 1, adjustment, "GtkAdjustment*");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_clamp_page", 2, lower, "gdouble");
  upper = s7_car(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_clamp_page", 3, upper, "gdouble");
  gtk_adjustment_clamp_page((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(lower), (gdouble)s7_real(upper));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_value "gdouble gtk_adjustment_get_value(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_value", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_value((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_value "void gtk_adjustment_set_value(GtkAdjustment* adjustment, gdouble value)"
  s7_pointer _p;
  s7_pointer adjustment, value;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_value", 1, adjustment, "GtkAdjustment*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_value", 2, value, "gdouble");
  gtk_adjustment_set_value((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_bin_get_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_bin_get_child "GtkWidget* gtk_bin_get_child(GtkBin* bin)"
  s7_pointer bin;
  bin = s7_car(args);
  if (!s7_is_c_pointer_of_type(bin, GtkBin__sym)) s7_wrong_type_arg_error(sc, "gtk_bin_get_child", 1, bin, "GtkBin*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_bin_get_child((GtkBin*)s7_c_pointer(bin))));
}

static s7_pointer lg_gtk_box_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_homogeneous "void gtk_box_set_homogeneous(GtkBox* box, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer box, homogeneous;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_homogeneous", 1, box, "GtkBox*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_box_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_box_set_homogeneous((GtkBox*)s7_c_pointer(box), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_box_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_get_homogeneous "gboolean gtk_box_get_homogeneous(GtkBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_get_homogeneous", 1, box, "GtkBox*");
  return(s7_make_boolean(sc, gtk_box_get_homogeneous((GtkBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_box_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_spacing "void gtk_box_set_spacing(GtkBox* box, gint spacing)"
  s7_pointer _p;
  s7_pointer box, spacing;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_spacing", 1, box, "GtkBox*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_box_set_spacing", 2, spacing, "gint");
  gtk_box_set_spacing((GtkBox*)s7_c_pointer(box), (gint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_box_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_get_spacing "gint gtk_box_get_spacing(GtkBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_get_spacing", 1, box, "GtkBox*");
  return(s7_make_integer(sc, gtk_box_get_spacing((GtkBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new "GtkWidget* gtk_button_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_button_new()));
}

static s7_pointer lg_gtk_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new_with_label "GtkWidget* gtk_button_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_button_new_with_label", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_button_new_with_label((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new_with_mnemonic "GtkWidget* gtk_button_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_button_new_with_mnemonic", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_button_new_with_mnemonic((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_button_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_label "void gtk_button_set_label(GtkButton* button, gchar* label)"
  s7_pointer _p;
  s7_pointer button, label;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_label", 1, button, "GtkButton*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_button_set_label", 2, label, "gchar*");
  gtk_button_set_label((GtkButton*)s7_c_pointer(button), (gchar*)s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_label "gchar* gtk_button_get_label(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_label", 1, button, "GtkButton*");
  return(s7_make_string(sc, gtk_button_get_label((GtkButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_button_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_use_underline "void gtk_button_set_use_underline(GtkButton* button, gboolean use_underline)"
  s7_pointer _p;
  s7_pointer button, use_underline;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_use_underline", 1, button, "GtkButton*");
  use_underline = s7_car(_p);
  if (!s7_is_boolean(use_underline)) s7_wrong_type_arg_error(sc, "gtk_button_set_use_underline", 2, use_underline, "gboolean");
  gtk_button_set_use_underline((GtkButton*)s7_c_pointer(button), (gboolean)lg_boolean(use_underline));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_use_underline "gboolean gtk_button_get_use_underline(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_use_underline", 1, button, "GtkButton*");
  return(s7_make_boolean(sc, gtk_button_get_use_underline((GtkButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_calendar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_new "GtkWidget* gtk_calendar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_calendar_new()));
}

static s7_pointer lg_gtk_calendar_select_day(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_select_day "void gtk_calendar_select_day(GtkCalendar* calendar, guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_day", 1, calendar, "GtkCalendar*");
  day = s7_car(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_day", 2, day, "guint");
  gtk_calendar_select_day((GtkCalendar*)s7_c_pointer(calendar), (guint)s7_integer(day));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_clear_marks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_clear_marks "void gtk_calendar_clear_marks(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_clear_marks", 1, calendar, "GtkCalendar*");
  gtk_calendar_clear_marks((GtkCalendar*)s7_c_pointer(calendar));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_date(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_date "void gtk_calendar_get_date(GtkCalendar* calendar, guint* [year], guint* [month], \
guint* [day])"
  s7_pointer _p;
  s7_pointer calendar;
  guint ref_year;
  guint ref_month;
  guint ref_day;
  _p = args;
  calendar = s7_car(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_date", 1, calendar, "GtkCalendar*");
  gtk_calendar_get_date((GtkCalendar*)s7_c_pointer(calendar), &ref_year, &ref_month, &ref_day);
    return(s7_list(sc, 3, s7_make_integer(sc, ref_year), s7_make_integer(sc, ref_month), s7_make_integer(sc, ref_day)));
}

static s7_pointer lg_gtk_cell_editable_start_editing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_editable_start_editing "void gtk_cell_editable_start_editing(GtkCellEditable* cell_editable, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer cell_editable, event;
  _p = args;
  cell_editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_editable, GtkCellEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_start_editing", 1, cell_editable, "GtkCellEditable*");
  event = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_start_editing", 2, event, "GdkEvent*");
  gtk_cell_editable_start_editing((GtkCellEditable*)s7_c_pointer(cell_editable), (GdkEvent*)s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_editable_editing_done(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_editable_editing_done "void gtk_cell_editable_editing_done(GtkCellEditable* cell_editable)"
  s7_pointer cell_editable;
  cell_editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_editable, GtkCellEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_editing_done", 1, cell_editable, "GtkCellEditable*");
  gtk_cell_editable_editing_done((GtkCellEditable*)s7_c_pointer(cell_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_editable_remove_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_editable_remove_widget "void gtk_cell_editable_remove_widget(GtkCellEditable* cell_editable)"
  s7_pointer cell_editable;
  cell_editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_editable, GtkCellEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_editable_remove_widget", 1, cell_editable, "GtkCellEditable*");
  gtk_cell_editable_remove_widget((GtkCellEditable*)s7_c_pointer(cell_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_activate "gboolean gtk_cell_renderer_activate(GtkCellRenderer* cell, GdkEvent* event, \
GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, GtkCellRendererState flags)"
  s7_pointer _p;
  s7_pointer cell, event, widget, path, background_area, cell_area, flags;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 1, cell, "GtkCellRenderer*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 2, event, "GdkEvent*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 3, widget, "GtkWidget*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 4, path, "gchar*");
  background_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(background_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 5, background_area, "GdkRectangle*");
  cell_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 6, cell_area, "GdkRectangle*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_activate", 7, flags, "GtkCellRendererState");
  return(s7_make_boolean(sc, gtk_cell_renderer_activate((GtkCellRenderer*)s7_c_pointer(cell), (GdkEvent*)s7_c_pointer(event), (GtkWidget*)s7_c_pointer(widget), (gchar*)s7_string(path), (GdkRectangle*)s7_c_pointer(background_area), (GdkRectangle*)s7_c_pointer(cell_area), (GtkCellRendererState)s7_integer(flags))));
}

static s7_pointer lg_gtk_cell_renderer_start_editing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_start_editing "GtkCellEditable* gtk_cell_renderer_start_editing(GtkCellRenderer* cell, \
GdkEvent* event, GtkWidget* widget, gchar* path, GdkRectangle* background_area, GdkRectangle* cell_area, \
GtkCellRendererState flags)"
  s7_pointer _p;
  s7_pointer cell, event, widget, path, background_area, cell_area, flags;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 1, cell, "GtkCellRenderer*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(event, GdkEvent__sym)) && (event != lg_false)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 2, event, "GdkEvent*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 3, widget, "GtkWidget*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 4, path, "gchar*");
  background_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(background_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 5, background_area, "GdkRectangle*");
  cell_area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 6, cell_area, "GdkRectangle*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_start_editing", 7, flags, "GtkCellRendererState");
  return(lg_make_c_pointer_with_type(sc, GtkCellEditable__sym, gtk_cell_renderer_start_editing((GtkCellRenderer*)s7_c_pointer(cell), (GdkEvent*)s7_c_pointer(event), (GtkWidget*)s7_c_pointer(widget), (gchar*)s7_string(path), (GdkRectangle*)s7_c_pointer(background_area), (GdkRectangle*)s7_c_pointer(cell_area), (GtkCellRendererState)s7_integer(flags))));
}

static s7_pointer lg_gtk_cell_renderer_set_fixed_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_fixed_size "void gtk_cell_renderer_set_fixed_size(GtkCellRenderer* cell, \
gint width, gint height)"
  s7_pointer _p;
  s7_pointer cell, width, height;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_fixed_size", 1, cell, "GtkCellRenderer*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_fixed_size", 2, width, "gint");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_fixed_size", 3, height, "gint");
  gtk_cell_renderer_set_fixed_size((GtkCellRenderer*)s7_c_pointer(cell), (gint)s7_integer(width), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_fixed_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_fixed_size "void gtk_cell_renderer_get_fixed_size(GtkCellRenderer* cell, \
gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer cell;
  gint ref_width;
  gint ref_height;
  _p = args;
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_fixed_size", 1, cell, "GtkCellRenderer*");
  gtk_cell_renderer_get_fixed_size((GtkCellRenderer*)s7_c_pointer(cell), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_cell_renderer_pixbuf_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_pixbuf_new "GtkCellRenderer* gtk_cell_renderer_pixbuf_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_pixbuf_new()));
}

static s7_pointer lg_gtk_cell_renderer_text_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_text_new "GtkCellRenderer* gtk_cell_renderer_text_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_text_new()));
}

static s7_pointer lg_gtk_cell_renderer_text_set_fixed_height_from_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_text_set_fixed_height_from_font "void gtk_cell_renderer_text_set_fixed_height_from_font(GtkCellRendererText* renderer, \
gint number_of_rows)"
  s7_pointer _p;
  s7_pointer renderer, number_of_rows;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, GtkCellRendererText__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_text_set_fixed_height_from_font", 1, renderer, "GtkCellRendererText*");
  number_of_rows = s7_car(_p);
  if (!s7_is_integer(number_of_rows)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_text_set_fixed_height_from_font", 2, number_of_rows, "gint");
  gtk_cell_renderer_text_set_fixed_height_from_font((GtkCellRendererText*)s7_c_pointer(renderer), (gint)s7_integer(number_of_rows));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_toggle_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_new "GtkCellRenderer* gtk_cell_renderer_toggle_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_toggle_new()));
}

static s7_pointer lg_gtk_cell_renderer_toggle_get_radio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_get_radio "gboolean gtk_cell_renderer_toggle_get_radio(GtkCellRendererToggle* toggle)"
  s7_pointer toggle;
  toggle = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_get_radio", 1, toggle, "GtkCellRendererToggle*");
  return(s7_make_boolean(sc, gtk_cell_renderer_toggle_get_radio((GtkCellRendererToggle*)s7_c_pointer(toggle))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_set_radio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_set_radio "void gtk_cell_renderer_toggle_set_radio(GtkCellRendererToggle* toggle, \
gboolean radio)"
  s7_pointer _p;
  s7_pointer toggle, radio;
  _p = args;
  toggle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_radio", 1, toggle, "GtkCellRendererToggle*");
  radio = s7_car(_p);
  if (!s7_is_boolean(radio)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_radio", 2, radio, "gboolean");
  gtk_cell_renderer_toggle_set_radio((GtkCellRendererToggle*)s7_c_pointer(toggle), (gboolean)lg_boolean(radio));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_toggle_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_get_active "gboolean gtk_cell_renderer_toggle_get_active(GtkCellRendererToggle* toggle)"
  s7_pointer toggle;
  toggle = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_get_active", 1, toggle, "GtkCellRendererToggle*");
  return(s7_make_boolean(sc, gtk_cell_renderer_toggle_get_active((GtkCellRendererToggle*)s7_c_pointer(toggle))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_set_active "void gtk_cell_renderer_toggle_set_active(GtkCellRendererToggle* toggle, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer toggle, setting;
  _p = args;
  toggle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_active", 1, toggle, "GtkCellRendererToggle*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_active", 2, setting, "gboolean");
  gtk_cell_renderer_toggle_set_active((GtkCellRendererToggle*)s7_c_pointer(toggle), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_check_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_new "GtkWidget* gtk_check_button_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_check_button_new()));
}

static s7_pointer lg_gtk_check_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_new_with_label "GtkWidget* gtk_check_button_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_check_button_new_with_label", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_check_button_new_with_label((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_check_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_new_with_mnemonic "GtkWidget* gtk_check_button_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_check_button_new_with_mnemonic", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_check_button_new_with_mnemonic((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_container_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_add "void gtk_container_add(GtkContainer* container, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer container, widget;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_add", 1, container, "GtkContainer*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_container_add", 2, widget, "GtkWidget*");
  gtk_container_add((GtkContainer*)s7_c_pointer(container), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_container_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_remove "void gtk_container_remove(GtkContainer* container, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer container, widget;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_remove", 1, container, "GtkContainer*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_container_remove", 2, widget, "GtkWidget*");
  gtk_container_remove((GtkContainer*)s7_c_pointer(container), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_container_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_foreach "void gtk_container_foreach(GtkContainer* container, GtkCallback func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer container, func, func_info;
  _p = args;
  container = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_foreach", 1, container, "GtkContainer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_container_foreach((GtkContainer*)s7_c_pointer(container), lg_func2, (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_container_get_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_container_get_children "GList* gtk_container_get_children(GtkContainer* container)"
  s7_pointer container;
  container = s7_car(args);
  if (!s7_is_c_pointer_of_type(container, GtkContainer__sym)) s7_wrong_type_arg_error(sc, "gtk_container_get_children", 1, container, "GtkContainer*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_container_get_children((GtkContainer*)s7_c_pointer(container))));
}

static s7_pointer lg_gtk_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_new "GtkWidget* gtk_dialog_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_dialog_new()));
}

static s7_pointer lg_gtk_dialog_add_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_add_action_widget "void gtk_dialog_add_action_widget(GtkDialog* dialog, GtkWidget* child, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, child, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_action_widget", 1, dialog, "GtkDialog*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_action_widget", 2, child, "GtkWidget*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_action_widget", 3, response_id, "gint");
  gtk_dialog_add_action_widget((GtkDialog*)s7_c_pointer(dialog), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_add_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_add_button "GtkWidget* gtk_dialog_add_button(GtkDialog* dialog, gchar* button_text, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, button_text, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_button", 1, dialog, "GtkDialog*");
  button_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(button_text)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_button", 2, button_text, "gchar*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_button", 3, response_id, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_dialog_add_button((GtkDialog*)s7_c_pointer(dialog), (gchar*)s7_string(button_text), (gint)s7_integer(response_id))));
}

static s7_pointer lg_gtk_dialog_add_buttons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_add_buttons "void gtk_dialog_add_buttons(GtkDialog* dialog, etc buttons)"
  s7_pointer _p;
  s7_pointer dialog, buttons;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_buttons", 1, dialog, "GtkDialog*");
  buttons = s7_car(_p);
  if (!lg_is_list(buttons)) s7_wrong_type_arg_error(sc, "gtk_dialog_add_buttons", 2, buttons, "etc");
  {
    int etc_len = 0;
    GtkDialog* p_arg0;
    if (s7_is_list(sc, buttons)) etc_len = s7_list_length(sc, buttons);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_dialog_add_buttons", 1, buttons, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_dialog_add_buttons", 1, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_dialog_add_buttons", 1, buttons, "... list len must be multiple of 2");
    p_arg0 = (GtkDialog*)s7_c_pointer(dialog);
    switch (etc_len)
      {
        case 2: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), NULL); break;
        case 4: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), NULL); break;
        case 6: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), NULL); break;
        case 8: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), NULL); break;
        case 10: gtk_dialog_add_buttons(p_arg0, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), s7_string(s7_list_ref(sc, buttons, 8)), s7_integer(s7_list_ref(sc, buttons, 9)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_dialog_set_response_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_set_response_sensitive "void gtk_dialog_set_response_sensitive(GtkDialog* dialog, \
gint response_id, gboolean setting)"
  s7_pointer _p;
  s7_pointer dialog, response_id, setting;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_response_sensitive", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_response_sensitive", 2, response_id, "gint");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_response_sensitive", 3, setting, "gboolean");
  gtk_dialog_set_response_sensitive((GtkDialog*)s7_c_pointer(dialog), (gint)s7_integer(response_id), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_set_default_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_set_default_response "void gtk_dialog_set_default_response(GtkDialog* dialog, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_default_response", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_set_default_response", 2, response_id, "gint");
  gtk_dialog_set_default_response((GtkDialog*)s7_c_pointer(dialog), (gint)s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_response "void gtk_dialog_response(GtkDialog* dialog, gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_response", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_response", 2, response_id, "gint");
  gtk_dialog_response((GtkDialog*)s7_c_pointer(dialog), (gint)s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_dialog_run(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_run "gint gtk_dialog_run(GtkDialog* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_run", 1, dialog, "GtkDialog*");
  return(s7_make_integer(sc, gtk_dialog_run((GtkDialog*)s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_drawing_area_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_new "GtkWidget* gtk_drawing_area_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_drawing_area_new()));
}

static s7_pointer lg_gtk_editable_select_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_select_region "void gtk_editable_select_region(GtkEditable* editable, int start, \
int end)"
  s7_pointer _p;
  s7_pointer editable, start, end;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_select_region", 1, editable, "GtkEditable*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start)) s7_wrong_type_arg_error(sc, "gtk_editable_select_region", 2, start, "int");
  end = s7_car(_p);
  if (!s7_is_integer(end)) s7_wrong_type_arg_error(sc, "gtk_editable_select_region", 3, end, "int");
  gtk_editable_select_region((GtkEditable*)s7_c_pointer(editable), (int)s7_integer(start), (int)s7_integer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_selection_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_selection_bounds "gboolean gtk_editable_get_selection_bounds(GtkEditable* editable, \
int* [start], int* [end])"
  s7_pointer _p;
  s7_pointer editable;
  int ref_start;
  int ref_end;
  _p = args;
  editable = s7_car(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_selection_bounds", 1, editable, "GtkEditable*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_editable_get_selection_bounds((GtkEditable*)s7_c_pointer(editable), &ref_start, &ref_end));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_start), s7_make_integer(sc, ref_end)));
   }
}

static s7_pointer lg_gtk_editable_insert_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_insert_text "void gtk_editable_insert_text(GtkEditable* editable, gchar* new_text, \
int new_text_length, int* [position])"
  s7_pointer _p;
  s7_pointer editable, new_text, new_text_length;
  int ref_position;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_insert_text", 1, editable, "GtkEditable*");
  new_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(new_text)) s7_wrong_type_arg_error(sc, "gtk_editable_insert_text", 2, new_text, "gchar*");
  new_text_length = s7_car(_p);
  if (!s7_is_integer(new_text_length)) s7_wrong_type_arg_error(sc, "gtk_editable_insert_text", 3, new_text_length, "int");
  gtk_editable_insert_text((GtkEditable*)s7_c_pointer(editable), (gchar*)s7_string(new_text), (int)s7_integer(new_text_length), &ref_position);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_position)));
}

static s7_pointer lg_gtk_editable_delete_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_delete_text "void gtk_editable_delete_text(GtkEditable* editable, int start_pos, \
int end_pos)"
  s7_pointer _p;
  s7_pointer editable, start_pos, end_pos;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_text", 1, editable, "GtkEditable*");
  start_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_text", 2, start_pos, "int");
  end_pos = s7_car(_p);
  if (!s7_is_integer(end_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_text", 3, end_pos, "int");
  gtk_editable_delete_text((GtkEditable*)s7_c_pointer(editable), (int)s7_integer(start_pos), (int)s7_integer(end_pos));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_chars "gchar* gtk_editable_get_chars(GtkEditable* editable, int start_pos, \
int end_pos)"
  s7_pointer _p;
  s7_pointer editable, start_pos, end_pos;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_chars", 1, editable, "GtkEditable*");
  start_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_get_chars", 2, start_pos, "int");
  end_pos = s7_car(_p);
  if (!s7_is_integer(end_pos)) s7_wrong_type_arg_error(sc, "gtk_editable_get_chars", 3, end_pos, "int");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_editable_get_chars((GtkEditable*)s7_c_pointer(editable), (int)s7_integer(start_pos), (int)s7_integer(end_pos));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_editable_delete_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_delete_selection "void gtk_editable_delete_selection(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delete_selection", 1, editable, "GtkEditable*");
  gtk_editable_delete_selection((GtkEditable*)s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_position "void gtk_editable_set_position(GtkEditable* editable, gint position)"
  s7_pointer _p;
  s7_pointer editable, position;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_position", 1, editable, "GtkEditable*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_editable_set_position", 2, position, "gint");
  gtk_editable_set_position((GtkEditable*)s7_c_pointer(editable), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_position "gint gtk_editable_get_position(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_position", 1, editable, "GtkEditable*");
  return(s7_make_integer(sc, gtk_editable_get_position((GtkEditable*)s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_editable_set_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_editable "void gtk_editable_set_editable(GtkEditable* editable, gboolean is_editable)"
  s7_pointer _p;
  s7_pointer editable, is_editable;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_editable", 1, editable, "GtkEditable*");
  is_editable = s7_car(_p);
  if (!s7_is_boolean(is_editable)) s7_wrong_type_arg_error(sc, "gtk_editable_set_editable", 2, is_editable, "gboolean");
  gtk_editable_set_editable((GtkEditable*)s7_c_pointer(editable), (gboolean)lg_boolean(is_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_editable "gboolean gtk_editable_get_editable(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_editable", 1, editable, "GtkEditable*");
  return(s7_make_boolean(sc, gtk_editable_get_editable((GtkEditable*)s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_entry_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_new "GtkWidget* gtk_entry_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_entry_new()));
}

static s7_pointer lg_gtk_entry_set_visibility(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_visibility "void gtk_entry_set_visibility(GtkEntry* entry, gboolean visible)"
  s7_pointer _p;
  s7_pointer entry, visible;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_visibility", 1, entry, "GtkEntry*");
  visible = s7_car(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_entry_set_visibility", 2, visible, "gboolean");
  gtk_entry_set_visibility((GtkEntry*)s7_c_pointer(entry), (gboolean)lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_visibility(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_visibility "gboolean gtk_entry_get_visibility(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_visibility", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_visibility((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_invisible_char "void gtk_entry_set_invisible_char(GtkEntry* entry, gunichar ch)"
  s7_pointer _p;
  s7_pointer entry, ch;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_invisible_char", 1, entry, "GtkEntry*");
  ch = s7_car(_p);
  if (!s7_is_integer(ch)) s7_wrong_type_arg_error(sc, "gtk_entry_set_invisible_char", 2, ch, "gunichar");
  gtk_entry_set_invisible_char((GtkEntry*)s7_c_pointer(entry), (gunichar)s7_integer(ch));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_invisible_char "gunichar gtk_entry_get_invisible_char(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_invisible_char", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_invisible_char((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_has_frame "void gtk_entry_set_has_frame(GtkEntry* entry, gboolean setting)"
  s7_pointer _p;
  s7_pointer entry, setting;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_has_frame", 1, entry, "GtkEntry*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_entry_set_has_frame", 2, setting, "gboolean");
  gtk_entry_set_has_frame((GtkEntry*)s7_c_pointer(entry), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_has_frame "gboolean gtk_entry_get_has_frame(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_has_frame", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_has_frame((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_max_length "void gtk_entry_set_max_length(GtkEntry* entry, gint max)"
  s7_pointer _p;
  s7_pointer entry, max;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_max_length", 1, entry, "GtkEntry*");
  max = s7_car(_p);
  if (!s7_is_integer(max)) s7_wrong_type_arg_error(sc, "gtk_entry_set_max_length", 2, max, "gint");
  gtk_entry_set_max_length((GtkEntry*)s7_c_pointer(entry), (gint)s7_integer(max));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_max_length "gint gtk_entry_get_max_length(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_max_length", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_max_length((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_activates_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_activates_default "void gtk_entry_set_activates_default(GtkEntry* entry, gboolean setting)"
  s7_pointer _p;
  s7_pointer entry, setting;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_activates_default", 1, entry, "GtkEntry*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_entry_set_activates_default", 2, setting, "gboolean");
  gtk_entry_set_activates_default((GtkEntry*)s7_c_pointer(entry), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_activates_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_activates_default "gboolean gtk_entry_get_activates_default(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_activates_default", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_activates_default((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_fixed_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_new "GtkWidget* gtk_fixed_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_fixed_new()));
}

static s7_pointer lg_gtk_fixed_put(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_put "void gtk_fixed_put(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  s7_pointer _p;
  s7_pointer fixed, widget, x, y;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 1, fixed, "GtkFixed*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 2, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 3, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_fixed_put", 4, y, "gint");
  gtk_fixed_put((GtkFixed*)s7_c_pointer(fixed), (GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(x), (gint)s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_fixed_move(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_move "void gtk_fixed_move(GtkFixed* fixed, GtkWidget* widget, gint x, gint y)"
  s7_pointer _p;
  s7_pointer fixed, widget, x, y;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 1, fixed, "GtkFixed*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 2, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 3, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_fixed_move", 4, y, "gint");
  gtk_fixed_move((GtkFixed*)s7_c_pointer(fixed), (GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(x), (gint)s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_new "GtkWidget* gtk_frame_new(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_frame_new", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_frame_new((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_frame_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_label "void gtk_frame_set_label(GtkFrame* frame, gchar* label)"
  s7_pointer _p;
  s7_pointer frame, label;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label", 1, frame, "GtkFrame*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label", 2, label, "gchar*");
  gtk_frame_set_label((GtkFrame*)s7_c_pointer(frame), (gchar*)s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_label "gchar* gtk_frame_get_label(GtkFrame* frame)"
  s7_pointer frame;
  frame = s7_car(args);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_label", 1, frame, "GtkFrame*");
  return(s7_make_string(sc, gtk_frame_get_label((GtkFrame*)s7_c_pointer(frame))));
}

static s7_pointer lg_gtk_frame_set_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_label_widget "void gtk_frame_set_label_widget(GtkFrame* frame, GtkWidget* label_widget)"
  s7_pointer _p;
  s7_pointer frame, label_widget;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_widget", 1, frame, "GtkFrame*");
  label_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(label_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_widget", 2, label_widget, "GtkWidget*");
  gtk_frame_set_label_widget((GtkFrame*)s7_c_pointer(frame), (GtkWidget*)s7_c_pointer(label_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_label_widget "GtkWidget* gtk_frame_get_label_widget(GtkFrame* frame)"
  s7_pointer frame;
  frame = s7_car(args);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_label_widget", 1, frame, "GtkFrame*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_frame_get_label_widget((GtkFrame*)s7_c_pointer(frame))));
}

static s7_pointer lg_gtk_image_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new "GtkWidget* gtk_image_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_image_new()));
}

static s7_pointer lg_gtk_image_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_file "GtkWidget* gtk_image_new_from_file(gchar* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_file", 1, filename, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_image_new_from_file((gchar*)s7_string(filename))));
}

static s7_pointer lg_gtk_image_new_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_pixbuf "GtkWidget* gtk_image_new_from_pixbuf(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if ((!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) && (pixbuf != lg_false)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_pixbuf", 1, pixbuf, "GdkPixbuf*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_image_new_from_pixbuf((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gtk_image_set_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_file "void gtk_image_set_from_file(GtkImage* image, gchar* filename)"
  s7_pointer _p;
  s7_pointer image, filename;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_file", 1, image, "GtkImage*");
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_file", 2, filename, "gchar*");
  gtk_image_set_from_file((GtkImage*)s7_c_pointer(image), (gchar*)s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_from_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_pixbuf "void gtk_image_set_from_pixbuf(GtkImage* image, GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer image, pixbuf;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_pixbuf", 1, image, "GtkImage*");
  pixbuf = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) && (pixbuf != lg_false)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_pixbuf", 2, pixbuf, "GdkPixbuf*");
  gtk_image_set_from_pixbuf((GtkImage*)s7_c_pointer(image), (GdkPixbuf*)s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_image_get_storage_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_storage_type "GtkImageType gtk_image_get_storage_type(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_storage_type", 1, image, "GtkImage*");
  return(s7_make_integer(sc, gtk_image_get_storage_type((GtkImage*)s7_c_pointer(image))));
}

static s7_pointer lg_gtk_im_context_get_preedit_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_get_preedit_string "void gtk_im_context_get_preedit_string(GtkIMContext* context, \
gchar** [str], PangoAttrList** [attrs], gint* [cursor_pos])"
  s7_pointer _p;
  s7_pointer context;
  gchar* ref_str = NULL;
  PangoAttrList* ref_attrs = NULL;
  gint ref_cursor_pos;
  _p = args;
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_get_preedit_string", 1, context, "GtkIMContext*");
  gtk_im_context_get_preedit_string((GtkIMContext*)s7_c_pointer(context), &ref_str, &ref_attrs, &ref_cursor_pos);
    return(s7_list(sc, 3, s7_make_string(sc, ref_str), s7_make_c_pointer(sc, ref_attrs), s7_make_integer(sc, ref_cursor_pos)));
}

static s7_pointer lg_gtk_im_context_filter_keypress(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_filter_keypress "gboolean gtk_im_context_filter_keypress(GtkIMContext* context, \
GdkEventKey* event)"
  s7_pointer _p;
  s7_pointer context, event;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_filter_keypress", 1, context, "GtkIMContext*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventKey__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_filter_keypress", 2, event, "GdkEventKey*");
  return(s7_make_boolean(sc, gtk_im_context_filter_keypress((GtkIMContext*)s7_c_pointer(context), (GdkEventKey*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_im_context_focus_in(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_focus_in "void gtk_im_context_focus_in(GtkIMContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_focus_in", 1, context, "GtkIMContext*");
  gtk_im_context_focus_in((GtkIMContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_focus_out(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_focus_out "void gtk_im_context_focus_out(GtkIMContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_focus_out", 1, context, "GtkIMContext*");
  gtk_im_context_focus_out((GtkIMContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_reset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_reset "void gtk_im_context_reset(GtkIMContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_reset", 1, context, "GtkIMContext*");
  gtk_im_context_reset((GtkIMContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_set_cursor_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_set_cursor_location "void gtk_im_context_set_cursor_location(GtkIMContext* context, \
GdkRectangle* area)"
  s7_pointer _p;
  s7_pointer context, area;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_cursor_location", 1, context, "GtkIMContext*");
  area = s7_car(_p);
  if (!s7_is_c_pointer_of_type(area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_cursor_location", 2, area, "GdkRectangle*");
  gtk_im_context_set_cursor_location((GtkIMContext*)s7_c_pointer(context), (GdkRectangle*)s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_set_use_preedit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_set_use_preedit "void gtk_im_context_set_use_preedit(GtkIMContext* context, \
gboolean use_preedit)"
  s7_pointer _p;
  s7_pointer context, use_preedit;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_use_preedit", 1, context, "GtkIMContext*");
  use_preedit = s7_car(_p);
  if (!s7_is_boolean(use_preedit)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_use_preedit", 2, use_preedit, "gboolean");
  gtk_im_context_set_use_preedit((GtkIMContext*)s7_c_pointer(context), (gboolean)lg_boolean(use_preedit));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_set_surrounding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_set_surrounding "void gtk_im_context_set_surrounding(GtkIMContext* context, \
gchar* text, gint len, gint cursor_index)"
  s7_pointer _p;
  s7_pointer context, text, len, cursor_index;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 1, context, "GtkIMContext*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 3, len, "gint");
  cursor_index = s7_car(_p);
  if (!s7_is_integer(cursor_index)) s7_wrong_type_arg_error(sc, "gtk_im_context_set_surrounding", 4, cursor_index, "gint");
  gtk_im_context_set_surrounding((GtkIMContext*)s7_c_pointer(context), (gchar*)s7_string(text), (gint)s7_integer(len), (gint)s7_integer(cursor_index));
  return(lg_false);
}

static s7_pointer lg_gtk_im_context_get_surrounding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_get_surrounding "gboolean gtk_im_context_get_surrounding(GtkIMContext* context, \
gchar** [text], gint* [cursor_index])"
  s7_pointer _p;
  s7_pointer context;
  gchar* ref_text = NULL;
  gint ref_cursor_index;
  _p = args;
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_get_surrounding", 1, context, "GtkIMContext*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_im_context_get_surrounding((GtkIMContext*)s7_c_pointer(context), &ref_text, &ref_cursor_index));
      return(s7_list(sc, 3, res_ult, s7_make_string(sc, ref_text), s7_make_integer(sc, ref_cursor_index)));
   }
}

static s7_pointer lg_gtk_im_context_delete_surrounding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_delete_surrounding "gboolean gtk_im_context_delete_surrounding(GtkIMContext* context, \
gint offset, gint n_chars)"
  s7_pointer _p;
  s7_pointer context, offset, n_chars;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkIMContext__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_delete_surrounding", 1, context, "GtkIMContext*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(offset)) s7_wrong_type_arg_error(sc, "gtk_im_context_delete_surrounding", 2, offset, "gint");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_im_context_delete_surrounding", 3, n_chars, "gint");
  return(s7_make_boolean(sc, gtk_im_context_delete_surrounding((GtkIMContext*)s7_c_pointer(context), (gint)s7_integer(offset), (gint)s7_integer(n_chars))));
}

static s7_pointer lg_gtk_im_context_simple_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_simple_new "GtkIMContext* gtk_im_context_simple_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkIMContext__sym, gtk_im_context_simple_new()));
}

static s7_pointer lg_gtk_im_context_simple_add_table(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_im_context_simple_add_table "void gtk_im_context_simple_add_table(GtkIMContextSimple* context_simple, \
guint16* data, gint max_seq_len, gint n_seqs)"
  s7_pointer _p;
  s7_pointer context_simple, data, max_seq_len, n_seqs;
  _p = args;
  context_simple = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context_simple, GtkIMContextSimple__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 1, context_simple, "GtkIMContextSimple*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guint16__sym)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 2, data, "guint16*");
  max_seq_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(max_seq_len)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 3, max_seq_len, "gint");
  n_seqs = s7_car(_p);
  if (!s7_is_integer(n_seqs)) s7_wrong_type_arg_error(sc, "gtk_im_context_simple_add_table", 4, n_seqs, "gint");
  gtk_im_context_simple_add_table((GtkIMContextSimple*)s7_c_pointer(context_simple), (guint16*)s7_c_pointer(data), (gint)s7_integer(max_seq_len), (gint)s7_integer(n_seqs));
  return(lg_false);
}

static s7_pointer lg_gtk_label_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_new "GtkWidget* gtk_label_new(char* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_new", 1, str, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_label_new((char*)s7_string(str))));
}

static s7_pointer lg_gtk_label_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_new_with_mnemonic "GtkWidget* gtk_label_new_with_mnemonic(char* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_new_with_mnemonic", 1, str, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_label_new_with_mnemonic((char*)s7_string(str))));
}

static s7_pointer lg_gtk_label_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_text "void gtk_label_set_text(GtkLabel* label, char* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_text", 1, label, "GtkLabel*");
  str = s7_car(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_text", 2, str, "char*");
  gtk_label_set_text((GtkLabel*)s7_c_pointer(label), (char*)s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_text "gchar* gtk_label_get_text(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_text", 1, label, "GtkLabel*");
  return(s7_make_string(sc, gtk_label_get_text((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_attributes "void gtk_label_set_attributes(GtkLabel* label, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer label, attrs;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_attributes", 1, label, "GtkLabel*");
  attrs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_attributes", 2, attrs, "PangoAttrList*");
  gtk_label_set_attributes((GtkLabel*)s7_c_pointer(label), (PangoAttrList*)s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_attributes "PangoAttrList* gtk_label_get_attributes(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_attributes", 1, label, "GtkLabel*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, gtk_label_get_attributes((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_label "void gtk_label_set_label(GtkLabel* label, gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_label", 1, label, "GtkLabel*");
  str = s7_car(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_label", 2, str, "gchar*");
  gtk_label_set_label((GtkLabel*)s7_c_pointer(label), (gchar*)s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_label "gchar* gtk_label_get_label(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_label", 1, label, "GtkLabel*");
  return(s7_make_string(sc, gtk_label_get_label((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_markup "void gtk_label_set_markup(GtkLabel* label, gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup", 1, label, "GtkLabel*");
  str = s7_car(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup", 2, str, "gchar*");
  gtk_label_set_markup((GtkLabel*)s7_c_pointer(label), (gchar*)s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_use_markup "void gtk_label_set_use_markup(GtkLabel* label, gboolean setting)"
  s7_pointer _p;
  s7_pointer label, setting;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_markup", 1, label, "GtkLabel*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_markup", 2, setting, "gboolean");
  gtk_label_set_use_markup((GtkLabel*)s7_c_pointer(label), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_use_markup "gboolean gtk_label_get_use_markup(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_use_markup", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_use_markup((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_use_underline "void gtk_label_set_use_underline(GtkLabel* label, gboolean setting)"
  s7_pointer _p;
  s7_pointer label, setting;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_underline", 1, label, "GtkLabel*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_label_set_use_underline", 2, setting, "gboolean");
  gtk_label_set_use_underline((GtkLabel*)s7_c_pointer(label), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_use_underline "gboolean gtk_label_get_use_underline(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_use_underline", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_use_underline((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_markup_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_markup_with_mnemonic "void gtk_label_set_markup_with_mnemonic(GtkLabel* label, \
gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup_with_mnemonic", 1, label, "GtkLabel*");
  str = s7_car(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_markup_with_mnemonic", 2, str, "gchar*");
  gtk_label_set_markup_with_mnemonic((GtkLabel*)s7_c_pointer(label), (gchar*)s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_mnemonic_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_mnemonic_keyval "guint gtk_label_get_mnemonic_keyval(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_mnemonic_keyval", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_mnemonic_keyval((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_mnemonic_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_mnemonic_widget "void gtk_label_set_mnemonic_widget(GtkLabel* label, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer label, widget;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_mnemonic_widget", 1, label, "GtkLabel*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_mnemonic_widget", 2, widget, "GtkWidget*");
  gtk_label_set_mnemonic_widget((GtkLabel*)s7_c_pointer(label), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_mnemonic_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_mnemonic_widget "GtkWidget* gtk_label_get_mnemonic_widget(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_mnemonic_widget", 1, label, "GtkLabel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_label_get_mnemonic_widget((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_text_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_text_with_mnemonic "void gtk_label_set_text_with_mnemonic(GtkLabel* label, \
gchar* str)"
  s7_pointer _p;
  s7_pointer label, str;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_text_with_mnemonic", 1, label, "GtkLabel*");
  str = s7_car(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_label_set_text_with_mnemonic", 2, str, "gchar*");
  gtk_label_set_text_with_mnemonic((GtkLabel*)s7_c_pointer(label), (gchar*)s7_string(str));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_justify "void gtk_label_set_justify(GtkLabel* label, GtkJustification jtype)"
  s7_pointer _p;
  s7_pointer label, jtype;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_justify", 1, label, "GtkLabel*");
  jtype = s7_car(_p);
  if (!s7_is_integer(jtype)) s7_wrong_type_arg_error(sc, "gtk_label_set_justify", 2, jtype, "GtkJustification");
  gtk_label_set_justify((GtkLabel*)s7_c_pointer(label), (GtkJustification)s7_integer(jtype));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_justify "GtkJustification gtk_label_get_justify(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_justify", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_justify((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_pattern(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_pattern "void gtk_label_set_pattern(GtkLabel* label, gchar* pattern)"
  s7_pointer _p;
  s7_pointer label, pattern;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_pattern", 1, label, "GtkLabel*");
  pattern = s7_car(_p);
  if (!s7_is_string(pattern)) s7_wrong_type_arg_error(sc, "gtk_label_set_pattern", 2, pattern, "gchar*");
  gtk_label_set_pattern((GtkLabel*)s7_c_pointer(label), (gchar*)s7_string(pattern));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_selectable "void gtk_label_set_selectable(GtkLabel* label, gboolean setting)"
  s7_pointer _p;
  s7_pointer label, setting;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_selectable", 1, label, "GtkLabel*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_label_set_selectable", 2, setting, "gboolean");
  gtk_label_set_selectable((GtkLabel*)s7_c_pointer(label), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_selectable "gboolean gtk_label_get_selectable(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_selectable", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_selectable((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_select_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_select_region "void gtk_label_select_region(GtkLabel* label, gint start_offset, \
gint end_offset)"
  s7_pointer _p;
  s7_pointer label, start_offset, end_offset;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_select_region", 1, label, "GtkLabel*");
  start_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_offset)) s7_wrong_type_arg_error(sc, "gtk_label_select_region", 2, start_offset, "gint");
  end_offset = s7_car(_p);
  if (!s7_is_integer(end_offset)) s7_wrong_type_arg_error(sc, "gtk_label_select_region", 3, end_offset, "gint");
  gtk_label_select_region((GtkLabel*)s7_c_pointer(label), (gint)s7_integer(start_offset), (gint)s7_integer(end_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_selection_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_selection_bounds "gboolean gtk_label_get_selection_bounds(GtkLabel* label, \
gint* [start], gint* [end])"
  s7_pointer _p;
  s7_pointer label;
  gint ref_start;
  gint ref_end;
  _p = args;
  label = s7_car(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_selection_bounds", 1, label, "GtkLabel*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_label_get_selection_bounds((GtkLabel*)s7_c_pointer(label), &ref_start, &ref_end));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_start), s7_make_integer(sc, ref_end)));
   }
}

static s7_pointer lg_gtk_label_get_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_layout "PangoLayout* gtk_label_get_layout(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_layout", 1, label, "GtkLabel*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, gtk_label_get_layout((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_get_layout_offsets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_layout_offsets "void gtk_label_get_layout_offsets(GtkLabel* label, gint* [x], \
gint* [y])"
  s7_pointer _p;
  s7_pointer label;
  gint ref_x;
  gint ref_y;
  _p = args;
  label = s7_car(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_layout_offsets", 1, label, "GtkLabel*");
  gtk_label_get_layout_offsets((GtkLabel*)s7_c_pointer(label), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gtk_list_store_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_new "GtkListStore* gtk_list_store_new(gint n_columns, etc types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_list_store_new", 1, n_columns, "gint");
  types = s7_car(_p);
  if (!lg_is_list(types)) s7_wrong_type_arg_error(sc, "gtk_list_store_new", 2, types, "etc");
  {
    int etc_len = 0;
    GtkListStore* res_ult = NULL;
    gint p_arg0;
    if (s7_is_list(sc, types)) etc_len = s7_list_length(sc, types);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_list_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_list_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = (gint)s7_integer(n_columns);
    switch (etc_len)
      {
        case 1: res_ult = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0))); break;
        case 2: res_ult = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1))); break;
        case 3: res_ult = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2))); break;
        case 4: res_ult = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3))); break;
        case 5: res_ult = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4))); break;
        case 6: res_ult = gtk_list_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4)), s7_c_pointer(s7_list_ref(sc, types, 5))); break;
      }
    return(s7_make_c_pointer(sc, res_ult));
  }
}

static s7_pointer lg_gtk_list_store_newv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_newv "GtkListStore* gtk_list_store_newv(gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_list_store_newv", 1, n_columns, "gint");
  types = s7_car(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_newv", 2, types, "GType*");
  return(lg_make_c_pointer_with_type(sc, GtkListStore__sym, gtk_list_store_newv((gint)s7_integer(n_columns), (GType*)s7_c_pointer(types))));
}

static s7_pointer lg_gtk_list_store_set_column_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_set_column_types "void gtk_list_store_set_column_types(GtkListStore* list_store, \
gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer list_store, n_columns, types;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set_column_types", 1, list_store, "GtkListStore*");
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_list_store_set_column_types", 2, n_columns, "gint");
  types = s7_car(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set_column_types", 3, types, "GType*");
  gtk_list_store_set_column_types((GtkListStore*)s7_c_pointer(list_store), (gint)s7_integer(n_columns), (GType*)s7_c_pointer(types));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_set "void gtk_list_store_set(GtkListStore* list_store, GtkTreeIter* iter, \
etc values)"
  s7_pointer _p;
  s7_pointer list_store, iter, values;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_set", 2, iter, "GtkTreeIter*");
  values = s7_car(_p);
  if (!lg_is_list(values)) s7_wrong_type_arg_error(sc, "gtk_list_store_set", 3, values, "etc");
  {
    int etc_len = 0;
    GtkListStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (s7_is_list(sc, values)) etc_len = s7_list_length(sc, values);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_list_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_list_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_list_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = (GtkListStore*)s7_c_pointer(list_store);
    p_arg1 = (GtkTreeIter*)s7_c_pointer(iter);
    switch (etc_len)
      {
        case 2: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), -1); break;
        case 4: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), -1); break;
        case 6: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), -1); break;
        case 8: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), -1); break;
        case 10: gtk_list_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), s7_integer(s7_list_ref(sc, values, 8)), s7_string(s7_list_ref(sc, values, 9)), -1); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_list_store_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert "void gtk_list_store_insert(GtkListStore* list_store, GtkTreeIter* iter, \
gint position)"
  s7_pointer _p;
  s7_pointer list_store, iter, position;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert", 2, iter, "GtkTreeIter*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert", 3, position, "gint");
  gtk_list_store_insert((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_before "void gtk_list_store_insert_before(GtkListStore* list_store, \
GtkTreeIter* iter, GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer list_store, iter, sibling;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_before", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_before", 2, iter, "GtkTreeIter*");
  sibling = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_before", 3, sibling, "GtkTreeIter*");
  gtk_list_store_insert_before((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_insert_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_after "void gtk_list_store_insert_after(GtkListStore* list_store, GtkTreeIter* iter, \
GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer list_store, iter, sibling;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_after", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_after", 2, iter, "GtkTreeIter*");
  sibling = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_after", 3, sibling, "GtkTreeIter*");
  gtk_list_store_insert_after((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_prepend "void gtk_list_store_prepend(GtkListStore* list_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer list_store, iter;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_prepend", 1, list_store, "GtkListStore*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_prepend", 2, iter, "GtkTreeIter*");
  gtk_list_store_prepend((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_append "void gtk_list_store_append(GtkListStore* list_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer list_store, iter;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_append", 1, list_store, "GtkListStore*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_append", 2, iter, "GtkTreeIter*");
  gtk_list_store_append((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_clear "void gtk_list_store_clear(GtkListStore* list_store)"
  s7_pointer list_store;
  list_store = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_clear", 1, list_store, "GtkListStore*");
  gtk_list_store_clear((GtkListStore*)s7_c_pointer(list_store));
  return(lg_false);
}

static s7_pointer lg_gtk_check_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_version "gchar* gtk_check_version(guint required_major, guint required_minor, guint required_micro)"
  s7_pointer _p;
  s7_pointer required_major, required_minor, required_micro;
  _p = args;
  required_major = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(required_major)) s7_wrong_type_arg_error(sc, "gtk_check_version", 1, required_major, "guint");
  required_minor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(required_minor)) s7_wrong_type_arg_error(sc, "gtk_check_version", 2, required_minor, "guint");
  required_micro = s7_car(_p);
  if (!s7_is_integer(required_micro)) s7_wrong_type_arg_error(sc, "gtk_check_version", 3, required_micro, "guint");
    return(s7_make_string(sc, (gchar*)gtk_check_version((guint)s7_integer(required_major), (guint)s7_integer(required_minor), (guint)s7_integer(required_micro))));
}

static s7_pointer lg_gtk_disable_setlocale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_disable_setlocale "void gtk_disable_setlocale( void)"
  gtk_disable_setlocale();
  return(lg_false);
}

static s7_pointer lg_gtk_get_default_language(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_default_language "PangoLanguage* gtk_get_default_language( void)"
  return(lg_make_c_pointer_with_type(sc, PangoLanguage__sym, gtk_get_default_language()));
}

static s7_pointer lg_gtk_events_pending(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_events_pending "gint gtk_events_pending( void)"
  return(s7_make_integer(sc, gtk_events_pending()));
}

static s7_pointer lg_gtk_menu_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_new "GtkWidget* gtk_menu_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_menu_bar_new()));
}

static s7_pointer lg_gtk_notebook_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_new "GtkWidget* gtk_notebook_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_notebook_new()));
}

static s7_pointer lg_gtk_notebook_remove_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_remove_page "void gtk_notebook_remove_page(GtkNotebook* notebook, gint page_num)"
  s7_pointer _p;
  s7_pointer notebook, page_num;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_remove_page", 1, notebook, "GtkNotebook*");
  page_num = s7_car(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_notebook_remove_page", 2, page_num, "gint");
  gtk_notebook_remove_page((GtkNotebook*)s7_c_pointer(notebook), (gint)s7_integer(page_num));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_current_page "gint gtk_notebook_get_current_page(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_current_page", 1, notebook, "GtkNotebook*");
  return(s7_make_integer(sc, gtk_notebook_get_current_page((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_get_nth_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_nth_page "GtkWidget* gtk_notebook_get_nth_page(GtkNotebook* notebook, gint page_num)"
  s7_pointer _p;
  s7_pointer notebook, page_num;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_nth_page", 1, notebook, "GtkNotebook*");
  page_num = s7_car(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_nth_page", 2, page_num, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_notebook_get_nth_page((GtkNotebook*)s7_c_pointer(notebook), (gint)s7_integer(page_num))));
}

static s7_pointer lg_gtk_notebook_page_num(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_page_num "gint gtk_notebook_page_num(GtkNotebook* notebook, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_page_num", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_page_num", 2, child, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_page_num((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_current_page "void gtk_notebook_set_current_page(GtkNotebook* notebook, \
gint page_num)"
  s7_pointer _p;
  s7_pointer notebook, page_num;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_current_page", 1, notebook, "GtkNotebook*");
  page_num = s7_car(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_current_page", 2, page_num, "gint");
  gtk_notebook_set_current_page((GtkNotebook*)s7_c_pointer(notebook), (gint)s7_integer(page_num));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_next_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_next_page "void gtk_notebook_next_page(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_next_page", 1, notebook, "GtkNotebook*");
  gtk_notebook_next_page((GtkNotebook*)s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_prev_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_prev_page "void gtk_notebook_prev_page(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prev_page", 1, notebook, "GtkNotebook*");
  gtk_notebook_prev_page((GtkNotebook*)s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_show_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_show_border "void gtk_notebook_set_show_border(GtkNotebook* notebook, gboolean show_border)"
  s7_pointer _p;
  s7_pointer notebook, show_border;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_border", 1, notebook, "GtkNotebook*");
  show_border = s7_car(_p);
  if (!s7_is_boolean(show_border)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_border", 2, show_border, "gboolean");
  gtk_notebook_set_show_border((GtkNotebook*)s7_c_pointer(notebook), (gboolean)lg_boolean(show_border));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_show_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_show_border "gboolean gtk_notebook_get_show_border(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_show_border", 1, notebook, "GtkNotebook*");
  return(s7_make_boolean(sc, gtk_notebook_get_show_border((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_set_show_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_show_tabs "void gtk_notebook_set_show_tabs(GtkNotebook* notebook, gboolean show_tabs)"
  s7_pointer _p;
  s7_pointer notebook, show_tabs;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_tabs", 1, notebook, "GtkNotebook*");
  show_tabs = s7_car(_p);
  if (!s7_is_boolean(show_tabs)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_show_tabs", 2, show_tabs, "gboolean");
  gtk_notebook_set_show_tabs((GtkNotebook*)s7_c_pointer(notebook), (gboolean)lg_boolean(show_tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_show_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_show_tabs "gboolean gtk_notebook_get_show_tabs(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_show_tabs", 1, notebook, "GtkNotebook*");
  return(s7_make_boolean(sc, gtk_notebook_get_show_tabs((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_set_tab_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_pos "void gtk_notebook_set_tab_pos(GtkNotebook* notebook, GtkPositionType pos)"
  s7_pointer _p;
  s7_pointer notebook, pos;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_pos", 1, notebook, "GtkNotebook*");
  pos = s7_car(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_pos", 2, pos, "GtkPositionType");
  gtk_notebook_set_tab_pos((GtkNotebook*)s7_c_pointer(notebook), (GtkPositionType)s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_pos "GtkPositionType gtk_notebook_get_tab_pos(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_pos", 1, notebook, "GtkNotebook*");
  return(s7_make_integer(sc, gtk_notebook_get_tab_pos((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_set_scrollable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_scrollable "void gtk_notebook_set_scrollable(GtkNotebook* notebook, gboolean scrollable)"
  s7_pointer _p;
  s7_pointer notebook, scrollable;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_scrollable", 1, notebook, "GtkNotebook*");
  scrollable = s7_car(_p);
  if (!s7_is_boolean(scrollable)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_scrollable", 2, scrollable, "gboolean");
  gtk_notebook_set_scrollable((GtkNotebook*)s7_c_pointer(notebook), (gboolean)lg_boolean(scrollable));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_scrollable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_scrollable "gboolean gtk_notebook_get_scrollable(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_scrollable", 1, notebook, "GtkNotebook*");
  return(s7_make_boolean(sc, gtk_notebook_get_scrollable((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_notebook_popup_enable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_popup_enable "void gtk_notebook_popup_enable(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_popup_enable", 1, notebook, "GtkNotebook*");
  gtk_notebook_popup_enable((GtkNotebook*)s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_popup_disable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_popup_disable "void gtk_notebook_popup_disable(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_popup_disable", 1, notebook, "GtkNotebook*");
  gtk_notebook_popup_disable((GtkNotebook*)s7_c_pointer(notebook));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_label "GtkWidget* gtk_notebook_get_tab_label(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label", 2, child, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_notebook_get_tab_label((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_tab_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_label "void gtk_notebook_set_tab_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label", 2, child, "GtkWidget*");
  tab_label = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label", 3, tab_label, "GtkWidget*");
  gtk_notebook_set_tab_label((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_tab_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_label_text "void gtk_notebook_set_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* tab_text)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_text;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label_text", 2, child, "GtkWidget*");
  tab_text = s7_car(_p);
  if (!s7_is_string(tab_text)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_label_text", 3, tab_text, "gchar*");
  gtk_notebook_set_tab_label_text((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (gchar*)s7_string(tab_text));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_label_text "gchar* gtk_notebook_get_tab_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_label_text", 2, child, "GtkWidget*");
  return(s7_make_string(sc, gtk_notebook_get_tab_label_text((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_get_menu_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_menu_label "GtkWidget* gtk_notebook_get_menu_label(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label", 2, child, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_notebook_get_menu_label((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_menu_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_menu_label "void gtk_notebook_set_menu_label(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* menu_label)"
  s7_pointer _p;
  s7_pointer notebook, child, menu_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label", 2, child, "GtkWidget*");
  menu_label = s7_car(_p);
  if (!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label", 3, menu_label, "GtkWidget*");
  gtk_notebook_set_menu_label((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(menu_label));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_set_menu_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_menu_label_text "void gtk_notebook_set_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child, gchar* menu_text)"
  s7_pointer _p;
  s7_pointer notebook, child, menu_text;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label_text", 2, child, "GtkWidget*");
  menu_text = s7_car(_p);
  if (!s7_is_string(menu_text)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_menu_label_text", 3, menu_text, "gchar*");
  gtk_notebook_set_menu_label_text((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (gchar*)s7_string(menu_text));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_menu_label_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_menu_label_text "gchar* gtk_notebook_get_menu_label_text(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label_text", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_menu_label_text", 2, child, "GtkWidget*");
  return(s7_make_string(sc, gtk_notebook_get_menu_label_text((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_reorder_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_reorder_child "void gtk_notebook_reorder_child(GtkNotebook* notebook, GtkWidget* child, \
gint position)"
  s7_pointer _p;
  s7_pointer notebook, child, position;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_reorder_child", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_reorder_child", 2, child, "GtkWidget*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_notebook_reorder_child", 3, position, "gint");
  gtk_notebook_reorder_child((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_append_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_append_page "gint gtk_notebook_append_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page", 2, child, "GtkWidget*");
  tab_label = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page", 3, tab_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_append_page((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label))));
}

static s7_pointer lg_gtk_notebook_append_page_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_append_page_menu "gint gtk_notebook_append_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, menu_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 3, tab_label, "GtkWidget*");
  menu_label = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) && (menu_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_append_page_menu", 4, menu_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_append_page_menu((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label), (GtkWidget*)s7_c_pointer(menu_label))));
}

static s7_pointer lg_gtk_notebook_prepend_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_prepend_page "gint gtk_notebook_prepend_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page", 2, child, "GtkWidget*");
  tab_label = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page", 3, tab_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_prepend_page((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label))));
}

static s7_pointer lg_gtk_notebook_prepend_page_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_prepend_page_menu "gint gtk_notebook_prepend_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, menu_label;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 3, tab_label, "GtkWidget*");
  menu_label = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) && (menu_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_prepend_page_menu", 4, menu_label, "GtkWidget*");
  return(s7_make_integer(sc, gtk_notebook_prepend_page_menu((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label), (GtkWidget*)s7_c_pointer(menu_label))));
}

static s7_pointer lg_gtk_notebook_insert_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_insert_page "gint gtk_notebook_insert_page(GtkNotebook* notebook, GtkWidget* child, \
GtkWidget* tab_label, gint position)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, position;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 3, tab_label, "GtkWidget*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page", 4, position, "gint");
  return(s7_make_integer(sc, gtk_notebook_insert_page((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label), (gint)s7_integer(position))));
}

static s7_pointer lg_gtk_notebook_insert_page_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_insert_page_menu "gint gtk_notebook_insert_page_menu(GtkNotebook* notebook, \
GtkWidget* child, GtkWidget* tab_label, GtkWidget* menu_label, gint position)"
  s7_pointer _p;
  s7_pointer notebook, child, tab_label, menu_label, position;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 2, child, "GtkWidget*");
  tab_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(tab_label, GtkWidget__sym)) && (tab_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 3, tab_label, "GtkWidget*");
  menu_label = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(menu_label, GtkWidget__sym)) && (menu_label != lg_false)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 4, menu_label, "GtkWidget*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_notebook_insert_page_menu", 5, position, "gint");
  return(s7_make_integer(sc, gtk_notebook_insert_page_menu((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(tab_label), (GtkWidget*)s7_c_pointer(menu_label), (gint)s7_integer(position))));
}

static s7_pointer lg_gtk_paned_add1(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_add1 "void gtk_paned_add1(GtkPaned* paned, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer paned, child;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add1", 1, paned, "GtkPaned*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add1", 2, child, "GtkWidget*");
  gtk_paned_add1((GtkPaned*)s7_c_pointer(paned), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_add2(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_add2 "void gtk_paned_add2(GtkPaned* paned, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer paned, child;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add2", 1, paned, "GtkPaned*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_add2", 2, child, "GtkWidget*");
  gtk_paned_add2((GtkPaned*)s7_c_pointer(paned), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_pack1(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_pack1 "void gtk_paned_pack1(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  s7_pointer _p;
  s7_pointer paned, child, resize, shrink;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 1, paned, "GtkPaned*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 2, child, "GtkWidget*");
  resize = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resize)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 3, resize, "gboolean");
  shrink = s7_car(_p);
  if (!s7_is_boolean(shrink)) s7_wrong_type_arg_error(sc, "gtk_paned_pack1", 4, shrink, "gboolean");
  gtk_paned_pack1((GtkPaned*)s7_c_pointer(paned), (GtkWidget*)s7_c_pointer(child), (gboolean)lg_boolean(resize), (gboolean)lg_boolean(shrink));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_pack2(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_pack2 "void gtk_paned_pack2(GtkPaned* paned, GtkWidget* child, gboolean resize, \
gboolean shrink)"
  s7_pointer _p;
  s7_pointer paned, child, resize, shrink;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 1, paned, "GtkPaned*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 2, child, "GtkWidget*");
  resize = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(resize)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 3, resize, "gboolean");
  shrink = s7_car(_p);
  if (!s7_is_boolean(shrink)) s7_wrong_type_arg_error(sc, "gtk_paned_pack2", 4, shrink, "gboolean");
  gtk_paned_pack2((GtkPaned*)s7_c_pointer(paned), (GtkWidget*)s7_c_pointer(child), (gboolean)lg_boolean(resize), (gboolean)lg_boolean(shrink));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_position "gint gtk_paned_get_position(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_position", 1, paned, "GtkPaned*");
  return(s7_make_integer(sc, gtk_paned_get_position((GtkPaned*)s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_paned_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_set_position "void gtk_paned_set_position(GtkPaned* paned, gint position)"
  s7_pointer _p;
  s7_pointer paned, position;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_set_position", 1, paned, "GtkPaned*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_paned_set_position", 2, position, "gint");
  gtk_paned_set_position((GtkPaned*)s7_c_pointer(paned), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_new "GtkWidget* gtk_progress_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_progress_bar_new()));
}

static s7_pointer lg_gtk_progress_bar_pulse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_pulse "void gtk_progress_bar_pulse(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_pulse", 1, pbar, "GtkProgressBar*");
  gtk_progress_bar_pulse((GtkProgressBar*)s7_c_pointer(pbar));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_text "void gtk_progress_bar_set_text(GtkProgressBar* pbar, gchar* text)"
  s7_pointer _p;
  s7_pointer pbar, text;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_text", 1, pbar, "GtkProgressBar*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_text", 2, text, "gchar*");
  gtk_progress_bar_set_text((GtkProgressBar*)s7_c_pointer(pbar), (gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_set_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_fraction "void gtk_progress_bar_set_fraction(GtkProgressBar* pbar, gdouble fraction)"
  s7_pointer _p;
  s7_pointer pbar, fraction;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_fraction", 1, pbar, "GtkProgressBar*");
  fraction = s7_car(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_fraction", 2, fraction, "gdouble");
  gtk_progress_bar_set_fraction((GtkProgressBar*)s7_c_pointer(pbar), (gdouble)s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_set_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_pulse_step "void gtk_progress_bar_set_pulse_step(GtkProgressBar* pbar, \
gdouble fraction)"
  s7_pointer _p;
  s7_pointer pbar, fraction;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_pulse_step", 1, pbar, "GtkProgressBar*");
  fraction = s7_car(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_pulse_step", 2, fraction, "gdouble");
  gtk_progress_bar_set_pulse_step((GtkProgressBar*)s7_c_pointer(pbar), (gdouble)s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_text "gchar* gtk_progress_bar_get_text(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_text", 1, pbar, "GtkProgressBar*");
  return(s7_make_string(sc, gtk_progress_bar_get_text((GtkProgressBar*)s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_progress_bar_get_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_fraction "gdouble gtk_progress_bar_get_fraction(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_fraction", 1, pbar, "GtkProgressBar*");
  return(s7_make_real(sc, gtk_progress_bar_get_fraction((GtkProgressBar*)s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_progress_bar_get_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_pulse_step "gdouble gtk_progress_bar_get_pulse_step(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_pulse_step", 1, pbar, "GtkProgressBar*");
  return(s7_make_real(sc, gtk_progress_bar_get_pulse_step((GtkProgressBar*)s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_radio_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new "GtkWidget* gtk_radio_button_new(GSList* group)"
  s7_pointer group;
  group = s7_car(args);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new", 1, group, "GSList*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_radio_button_new((GSList*)s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_button_new_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_from_widget "GtkWidget* gtk_radio_button_new_from_widget(GtkRadioButton* group)"
  s7_pointer group;
  group = s7_car(args);
  if (!s7_is_c_pointer_of_type(group, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_from_widget", 1, group, "GtkRadioButton*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_radio_button_new_from_widget((GtkRadioButton*)s7_c_pointer(group))));
}

static s7_pointer lg_gtk_radio_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_label "GtkWidget* gtk_radio_button_new_with_label(GSList* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label", 1, group, "GSList*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label", 2, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_radio_button_new_with_label((GSList*)s7_c_pointer(group), (gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_new_with_label_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_label_from_widget "GtkWidget* gtk_radio_button_new_with_label_from_widget(GtkRadioButton* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label_from_widget", 1, group, "GtkRadioButton*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_label_from_widget", 2, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_radio_button_new_with_label_from_widget((GtkRadioButton*)s7_c_pointer(group), (gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_mnemonic "GtkWidget* gtk_radio_button_new_with_mnemonic(GSList* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic", 1, group, "GSList*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic", 2, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_radio_button_new_with_mnemonic((GSList*)s7_c_pointer(group), (gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_new_with_mnemonic_from_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_new_with_mnemonic_from_widget "GtkWidget* gtk_radio_button_new_with_mnemonic_from_widget(GtkRadioButton* group, \
gchar* label)"
  s7_pointer _p;
  s7_pointer group, label;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic_from_widget", 1, group, "GtkRadioButton*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_radio_button_new_with_mnemonic_from_widget", 2, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_radio_button_new_with_mnemonic_from_widget((GtkRadioButton*)s7_c_pointer(group), (gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_radio_button_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_get_group "GSList* gtk_radio_button_get_group(GtkRadioButton* radio_button)"
  s7_pointer radio_button;
  radio_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(radio_button, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_get_group", 1, radio_button, "GtkRadioButton*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_radio_button_get_group((GtkRadioButton*)s7_c_pointer(radio_button))));
}

static s7_pointer lg_gtk_radio_button_set_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_set_group "void gtk_radio_button_set_group(GtkRadioButton* radio_button, \
GSList* group)"
  s7_pointer _p;
  s7_pointer radio_button, group;
  _p = args;
  radio_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(radio_button, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_set_group", 1, radio_button, "GtkRadioButton*");
  group = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(group, GSList__sym)) && (group != lg_false)) s7_wrong_type_arg_error(sc, "gtk_radio_button_set_group", 2, group, "GSList*");
  gtk_radio_button_set_group((GtkRadioButton*)s7_c_pointer(radio_button), (GSList*)s7_c_pointer(group));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_adjustment "void gtk_range_set_adjustment(GtkRange* range, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer range, adjustment;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_adjustment", 1, range, "GtkRange*");
  adjustment = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_range_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_range_set_adjustment((GtkRange*)s7_c_pointer(range), (GtkAdjustment*)s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_adjustment "GtkAdjustment* gtk_range_get_adjustment(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_adjustment", 1, range, "GtkRange*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_range_get_adjustment((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_inverted "void gtk_range_set_inverted(GtkRange* range, gboolean setting)"
  s7_pointer _p;
  s7_pointer range, setting;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_inverted", 1, range, "GtkRange*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_range_set_inverted", 2, setting, "gboolean");
  gtk_range_set_inverted((GtkRange*)s7_c_pointer(range), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_inverted "gboolean gtk_range_get_inverted(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_inverted", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_inverted((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_increments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_increments "void gtk_range_set_increments(GtkRange* range, gdouble step, gdouble page)"
  s7_pointer _p;
  s7_pointer range, step, page;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_increments", 1, range, "GtkRange*");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_range_set_increments", 2, step, "gdouble");
  page = s7_car(_p);
  if (!s7_is_real(page)) s7_wrong_type_arg_error(sc, "gtk_range_set_increments", 3, page, "gdouble");
  gtk_range_set_increments((GtkRange*)s7_c_pointer(range), (gdouble)s7_real(step), (gdouble)s7_real(page));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_range "void gtk_range_set_range(GtkRange* range, gdouble min, gdouble max)"
  s7_pointer _p;
  s7_pointer range, min, max;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_range", 1, range, "GtkRange*");
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_range_set_range", 2, min, "gdouble");
  max = s7_car(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_range_set_range", 3, max, "gdouble");
  gtk_range_set_range((GtkRange*)s7_c_pointer(range), (gdouble)s7_real(min), (gdouble)s7_real(max));
  return(lg_false);
}

static s7_pointer lg_gtk_range_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_value "void gtk_range_set_value(GtkRange* range, gdouble value)"
  s7_pointer _p;
  s7_pointer range, value;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_value", 1, range, "GtkRange*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_range_set_value", 2, value, "gdouble");
  gtk_range_set_value((GtkRange*)s7_c_pointer(range), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_value "gdouble gtk_range_get_value(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_value", 1, range, "GtkRange*");
  return(s7_make_real(sc, gtk_range_get_value((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_scale_set_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_digits "void gtk_scale_set_digits(GtkScale* scale, gint digits)"
  s7_pointer _p;
  s7_pointer scale, digits;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_digits", 1, scale, "GtkScale*");
  digits = s7_car(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_scale_set_digits", 2, digits, "gint");
  gtk_scale_set_digits((GtkScale*)s7_c_pointer(scale), (gint)s7_integer(digits));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_digits "gint gtk_scale_get_digits(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_digits", 1, scale, "GtkScale*");
  return(s7_make_integer(sc, gtk_scale_get_digits((GtkScale*)s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scale_set_draw_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_draw_value "void gtk_scale_set_draw_value(GtkScale* scale, gboolean draw_value)"
  s7_pointer _p;
  s7_pointer scale, draw_value;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_draw_value", 1, scale, "GtkScale*");
  draw_value = s7_car(_p);
  if (!s7_is_boolean(draw_value)) s7_wrong_type_arg_error(sc, "gtk_scale_set_draw_value", 2, draw_value, "gboolean");
  gtk_scale_set_draw_value((GtkScale*)s7_c_pointer(scale), (gboolean)lg_boolean(draw_value));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_draw_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_draw_value "gboolean gtk_scale_get_draw_value(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_draw_value", 1, scale, "GtkScale*");
  return(s7_make_boolean(sc, gtk_scale_get_draw_value((GtkScale*)s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scale_set_value_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_value_pos "void gtk_scale_set_value_pos(GtkScale* scale, GtkPositionType pos)"
  s7_pointer _p;
  s7_pointer scale, pos;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_value_pos", 1, scale, "GtkScale*");
  pos = s7_car(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_scale_set_value_pos", 2, pos, "GtkPositionType");
  gtk_scale_set_value_pos((GtkScale*)s7_c_pointer(scale), (GtkPositionType)s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_value_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_value_pos "GtkPositionType gtk_scale_get_value_pos(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_value_pos", 1, scale, "GtkScale*");
  return(s7_make_integer(sc, gtk_scale_get_value_pos((GtkScale*)s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scrolled_window_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_new "GtkWidget* gtk_scrolled_window_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer hadjustment, vadjustment;
  _p = args;
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_new", 1, hadjustment, "GtkAdjustment*");
  vadjustment = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) && (vadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_new", 2, vadjustment, "GtkAdjustment*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scrolled_window_new((GtkAdjustment*)s7_c_pointer(hadjustment), (GtkAdjustment*)s7_c_pointer(vadjustment))));
}

static s7_pointer lg_gtk_scrolled_window_set_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_hadjustment "void gtk_scrolled_window_set_hadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  s7_pointer _p;
  s7_pointer scrolled_window, hadjustment;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_hadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  hadjustment = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_hadjustment", 2, hadjustment, "GtkAdjustment*");
  gtk_scrolled_window_set_hadjustment((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (GtkAdjustment*)s7_c_pointer(hadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_set_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_vadjustment "void gtk_scrolled_window_set_vadjustment(GtkScrolledWindow* scrolled_window, \
GtkAdjustment* hadjustment)"
  s7_pointer _p;
  s7_pointer scrolled_window, hadjustment;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_vadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  hadjustment = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_vadjustment", 2, hadjustment, "GtkAdjustment*");
  gtk_scrolled_window_set_vadjustment((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (GtkAdjustment*)s7_c_pointer(hadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_hadjustment "GtkAdjustment* gtk_scrolled_window_get_hadjustment(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_hadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_scrolled_window_get_hadjustment((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_get_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_vadjustment "GtkAdjustment* gtk_scrolled_window_get_vadjustment(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_vadjustment", 1, scrolled_window, "GtkScrolledWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_scrolled_window_get_vadjustment((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_policy "void gtk_scrolled_window_set_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType hscrollbar_policy, GtkPolicyType vscrollbar_policy)"
  s7_pointer _p;
  s7_pointer scrolled_window, hscrollbar_policy, vscrollbar_policy;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_policy", 1, scrolled_window, "GtkScrolledWindow*");
  hscrollbar_policy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hscrollbar_policy)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_policy", 2, hscrollbar_policy, "GtkPolicyType");
  vscrollbar_policy = s7_car(_p);
  if (!s7_is_integer(vscrollbar_policy)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_policy", 3, vscrollbar_policy, "GtkPolicyType");
  gtk_scrolled_window_set_policy((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (GtkPolicyType)s7_integer(hscrollbar_policy), (GtkPolicyType)s7_integer(vscrollbar_policy));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_policy "void gtk_scrolled_window_get_policy(GtkScrolledWindow* scrolled_window, \
GtkPolicyType* [hscrollbar_policy], GtkPolicyType* [vscrollbar_policy])"
  s7_pointer _p;
  s7_pointer scrolled_window;
  GtkPolicyType ref_hscrollbar_policy;
  GtkPolicyType ref_vscrollbar_policy;
  _p = args;
  scrolled_window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_policy", 1, scrolled_window, "GtkScrolledWindow*");
  gtk_scrolled_window_get_policy((GtkScrolledWindow*)s7_c_pointer(scrolled_window), &ref_hscrollbar_policy, &ref_vscrollbar_policy);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_hscrollbar_policy), s7_make_integer(sc, ref_vscrollbar_policy)));
}

static s7_pointer lg_gtk_scrolled_window_set_placement(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_placement "void gtk_scrolled_window_set_placement(GtkScrolledWindow* scrolled_window, \
GtkCornerType window_placement)"
  s7_pointer _p;
  s7_pointer scrolled_window, window_placement;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_placement", 1, scrolled_window, "GtkScrolledWindow*");
  window_placement = s7_car(_p);
  if (!s7_is_integer(window_placement)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_placement", 2, window_placement, "GtkCornerType");
  gtk_scrolled_window_set_placement((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (GtkCornerType)s7_integer(window_placement));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_placement(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_placement "GtkCornerType gtk_scrolled_window_get_placement(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_placement", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_placement((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_settings_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_settings_get_default "GtkSettings* gtk_settings_get_default( void)"
  return(lg_make_c_pointer_with_type(sc, GtkSettings__sym, gtk_settings_get_default()));
}

static s7_pointer lg_gtk_size_group_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_new "GtkSizeGroup* gtk_size_group_new(GtkSizeGroupMode mode)"
  s7_pointer mode;
  mode = s7_car(args);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_size_group_new", 1, mode, "GtkSizeGroupMode");
  return(lg_make_c_pointer_with_type(sc, GtkSizeGroup__sym, gtk_size_group_new((GtkSizeGroupMode)s7_integer(mode))));
}

static s7_pointer lg_gtk_size_group_set_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_set_mode "void gtk_size_group_set_mode(GtkSizeGroup* size_group, GtkSizeGroupMode mode)"
  s7_pointer _p;
  s7_pointer size_group, mode;
  _p = args;
  size_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_set_mode", 1, size_group, "GtkSizeGroup*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_size_group_set_mode", 2, mode, "GtkSizeGroupMode");
  gtk_size_group_set_mode((GtkSizeGroup*)s7_c_pointer(size_group), (GtkSizeGroupMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_size_group_get_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_get_mode "GtkSizeGroupMode gtk_size_group_get_mode(GtkSizeGroup* size_group)"
  s7_pointer size_group;
  size_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_get_mode", 1, size_group, "GtkSizeGroup*");
  return(s7_make_integer(sc, gtk_size_group_get_mode((GtkSizeGroup*)s7_c_pointer(size_group))));
}

static s7_pointer lg_gtk_size_group_add_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_add_widget "void gtk_size_group_add_widget(GtkSizeGroup* size_group, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer size_group, widget;
  _p = args;
  size_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_add_widget", 1, size_group, "GtkSizeGroup*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_add_widget", 2, widget, "GtkWidget*");
  gtk_size_group_add_widget((GtkSizeGroup*)s7_c_pointer(size_group), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_size_group_remove_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_remove_widget "void gtk_size_group_remove_widget(GtkSizeGroup* size_group, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer size_group, widget;
  _p = args;
  size_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_remove_widget", 1, size_group, "GtkSizeGroup*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_remove_widget", 2, widget, "GtkWidget*");
  gtk_size_group_remove_widget((GtkSizeGroup*)s7_c_pointer(size_group), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_configure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_configure "void gtk_spin_button_configure(GtkSpinButton* spin_button, GtkAdjustment* adjustment, \
gdouble climb_rate, guint digits)"
  s7_pointer _p;
  s7_pointer spin_button, adjustment, climb_rate, digits;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 1, spin_button, "GtkSpinButton*");
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 2, adjustment, "GtkAdjustment*");
  climb_rate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(climb_rate)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 3, climb_rate, "gdouble");
  digits = s7_car(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_spin_button_configure", 4, digits, "guint");
  gtk_spin_button_configure((GtkSpinButton*)s7_c_pointer(spin_button), (GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(climb_rate), (guint)s7_integer(digits));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_new "GtkWidget* gtk_spin_button_new(GtkAdjustment* adjustment, gdouble climb_rate, \
guint digits)"
  s7_pointer _p;
  s7_pointer adjustment, climb_rate, digits;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new", 1, adjustment, "GtkAdjustment*");
  climb_rate = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(climb_rate)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new", 2, climb_rate, "gdouble");
  digits = s7_car(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new", 3, digits, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_spin_button_new((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(climb_rate), (guint)s7_integer(digits))));
}

static s7_pointer lg_gtk_spin_button_new_with_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_new_with_range "GtkWidget* gtk_spin_button_new_with_range(gdouble min, gdouble max, \
gdouble step)"
  s7_pointer _p;
  s7_pointer min, max, step;
  _p = args;
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new_with_range", 1, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new_with_range", 2, max, "gdouble");
  step = s7_car(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_spin_button_new_with_range", 3, step, "gdouble");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_spin_button_new_with_range((gdouble)s7_real(min), (gdouble)s7_real(max), (gdouble)s7_real(step))));
}

static s7_pointer lg_gtk_spin_button_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_adjustment "void gtk_spin_button_set_adjustment(GtkSpinButton* spin_button, \
GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer spin_button, adjustment;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_adjustment", 1, spin_button, "GtkSpinButton*");
  adjustment = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) && (adjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_spin_button_set_adjustment((GtkSpinButton*)s7_c_pointer(spin_button), (GtkAdjustment*)s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_adjustment "GtkAdjustment* gtk_spin_button_get_adjustment(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_adjustment", 1, spin_button, "GtkSpinButton*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_spin_button_get_adjustment((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_digits "void gtk_spin_button_set_digits(GtkSpinButton* spin_button, guint digits)"
  s7_pointer _p;
  s7_pointer spin_button, digits;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_digits", 1, spin_button, "GtkSpinButton*");
  digits = s7_car(_p);
  if (!s7_is_integer(digits)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_digits", 2, digits, "guint");
  gtk_spin_button_set_digits((GtkSpinButton*)s7_c_pointer(spin_button), (guint)s7_integer(digits));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_digits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_digits "guint gtk_spin_button_get_digits(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_digits", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_digits((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_increments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_increments "void gtk_spin_button_set_increments(GtkSpinButton* spin_button, \
gdouble step, gdouble page)"
  s7_pointer _p;
  s7_pointer spin_button, step, page;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_increments", 1, spin_button, "GtkSpinButton*");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_increments", 2, step, "gdouble");
  page = s7_car(_p);
  if (!s7_is_real(page)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_increments", 3, page, "gdouble");
  gtk_spin_button_set_increments((GtkSpinButton*)s7_c_pointer(spin_button), (gdouble)s7_real(step), (gdouble)s7_real(page));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_increments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_increments "void gtk_spin_button_get_increments(GtkSpinButton* spin_button, \
gdouble* [step], gdouble* [page])"
  s7_pointer _p;
  s7_pointer spin_button;
  gdouble ref_step;
  gdouble ref_page;
  _p = args;
  spin_button = s7_car(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_increments", 1, spin_button, "GtkSpinButton*");
  gtk_spin_button_get_increments((GtkSpinButton*)s7_c_pointer(spin_button), &ref_step, &ref_page);
    return(s7_list(sc, 2, s7_make_real(sc, ref_step), s7_make_real(sc, ref_page)));
}

static s7_pointer lg_gtk_spin_button_set_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_range "void gtk_spin_button_set_range(GtkSpinButton* spin_button, gdouble min, \
gdouble max)"
  s7_pointer _p;
  s7_pointer spin_button, min, max;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_range", 1, spin_button, "GtkSpinButton*");
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_range", 2, min, "gdouble");
  max = s7_car(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_range", 3, max, "gdouble");
  gtk_spin_button_set_range((GtkSpinButton*)s7_c_pointer(spin_button), (gdouble)s7_real(min), (gdouble)s7_real(max));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_range "void gtk_spin_button_get_range(GtkSpinButton* spin_button, gdouble* [min], \
gdouble* [max])"
  s7_pointer _p;
  s7_pointer spin_button;
  gdouble ref_min;
  gdouble ref_max;
  _p = args;
  spin_button = s7_car(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_range", 1, spin_button, "GtkSpinButton*");
  gtk_spin_button_get_range((GtkSpinButton*)s7_c_pointer(spin_button), &ref_min, &ref_max);
    return(s7_list(sc, 2, s7_make_real(sc, ref_min), s7_make_real(sc, ref_max)));
}

static s7_pointer lg_gtk_spin_button_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_value "gdouble gtk_spin_button_get_value(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_value", 1, spin_button, "GtkSpinButton*");
  return(s7_make_real(sc, gtk_spin_button_get_value((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_get_value_as_int(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_value_as_int "gint gtk_spin_button_get_value_as_int(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_value_as_int", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_value_as_int((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_value "void gtk_spin_button_set_value(GtkSpinButton* spin_button, gdouble value)"
  s7_pointer _p;
  s7_pointer spin_button, value;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_value", 1, spin_button, "GtkSpinButton*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_value", 2, value, "gdouble");
  gtk_spin_button_set_value((GtkSpinButton*)s7_c_pointer(spin_button), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_set_update_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_update_policy "void gtk_spin_button_set_update_policy(GtkSpinButton* spin_button, \
GtkSpinButtonUpdatePolicy policy)"
  s7_pointer _p;
  s7_pointer spin_button, policy;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_update_policy", 1, spin_button, "GtkSpinButton*");
  policy = s7_car(_p);
  if (!s7_is_integer(policy)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_update_policy", 2, policy, "GtkSpinButtonUpdatePolicy");
  gtk_spin_button_set_update_policy((GtkSpinButton*)s7_c_pointer(spin_button), (GtkSpinButtonUpdatePolicy)s7_integer(policy));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_update_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_update_policy "GtkSpinButtonUpdatePolicy gtk_spin_button_get_update_policy(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_update_policy", 1, spin_button, "GtkSpinButton*");
  return(s7_make_integer(sc, gtk_spin_button_get_update_policy((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_numeric(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_numeric "void gtk_spin_button_set_numeric(GtkSpinButton* spin_button, \
gboolean numeric)"
  s7_pointer _p;
  s7_pointer spin_button, numeric;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_numeric", 1, spin_button, "GtkSpinButton*");
  numeric = s7_car(_p);
  if (!s7_is_boolean(numeric)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_numeric", 2, numeric, "gboolean");
  gtk_spin_button_set_numeric((GtkSpinButton*)s7_c_pointer(spin_button), (gboolean)lg_boolean(numeric));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_numeric(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_numeric "gboolean gtk_spin_button_get_numeric(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_numeric", 1, spin_button, "GtkSpinButton*");
  return(s7_make_boolean(sc, gtk_spin_button_get_numeric((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_spin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_spin "void gtk_spin_button_spin(GtkSpinButton* spin_button, GtkSpinType direction, \
gdouble increment)"
  s7_pointer _p;
  s7_pointer spin_button, direction, increment;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_spin", 1, spin_button, "GtkSpinButton*");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_spin_button_spin", 2, direction, "GtkSpinType");
  increment = s7_car(_p);
  if (!s7_is_real(increment)) s7_wrong_type_arg_error(sc, "gtk_spin_button_spin", 3, increment, "gdouble");
  gtk_spin_button_spin((GtkSpinButton*)s7_c_pointer(spin_button), (GtkSpinType)s7_integer(direction), (gdouble)s7_real(increment));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_set_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_wrap "void gtk_spin_button_set_wrap(GtkSpinButton* spin_button, gboolean wrap)"
  s7_pointer _p;
  s7_pointer spin_button, wrap;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_wrap", 1, spin_button, "GtkSpinButton*");
  wrap = s7_car(_p);
  if (!s7_is_boolean(wrap)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_wrap", 2, wrap, "gboolean");
  gtk_spin_button_set_wrap((GtkSpinButton*)s7_c_pointer(spin_button), (gboolean)lg_boolean(wrap));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_wrap "gboolean gtk_spin_button_get_wrap(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_wrap", 1, spin_button, "GtkSpinButton*");
  return(s7_make_boolean(sc, gtk_spin_button_get_wrap((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_set_snap_to_ticks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_set_snap_to_ticks "void gtk_spin_button_set_snap_to_ticks(GtkSpinButton* spin_button, \
gboolean snap_to_ticks)"
  s7_pointer _p;
  s7_pointer spin_button, snap_to_ticks;
  _p = args;
  spin_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_snap_to_ticks", 1, spin_button, "GtkSpinButton*");
  snap_to_ticks = s7_car(_p);
  if (!s7_is_boolean(snap_to_ticks)) s7_wrong_type_arg_error(sc, "gtk_spin_button_set_snap_to_ticks", 2, snap_to_ticks, "gboolean");
  gtk_spin_button_set_snap_to_ticks((GtkSpinButton*)s7_c_pointer(spin_button), (gboolean)lg_boolean(snap_to_ticks));
  return(lg_false);
}

static s7_pointer lg_gtk_spin_button_get_snap_to_ticks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_get_snap_to_ticks "gboolean gtk_spin_button_get_snap_to_ticks(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_get_snap_to_ticks", 1, spin_button, "GtkSpinButton*");
  return(s7_make_boolean(sc, gtk_spin_button_get_snap_to_ticks((GtkSpinButton*)s7_c_pointer(spin_button))));
}

static s7_pointer lg_gtk_spin_button_update(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spin_button_update "void gtk_spin_button_update(GtkSpinButton* spin_button)"
  s7_pointer spin_button;
  spin_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(spin_button, GtkSpinButton__sym)) s7_wrong_type_arg_error(sc, "gtk_spin_button_update", 1, spin_button, "GtkSpinButton*");
  gtk_spin_button_update((GtkSpinButton*)s7_c_pointer(spin_button));
  return(lg_false);
}

static s7_pointer lg_gtk_statusbar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_new "GtkWidget* gtk_statusbar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_statusbar_new()));
}

static s7_pointer lg_gtk_statusbar_get_context_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_get_context_id "guint gtk_statusbar_get_context_id(GtkStatusbar* statusbar, \
gchar* context_description)"
  s7_pointer _p;
  s7_pointer statusbar, context_description;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_get_context_id", 1, statusbar, "GtkStatusbar*");
  context_description = s7_car(_p);
  if (!s7_is_string(context_description)) s7_wrong_type_arg_error(sc, "gtk_statusbar_get_context_id", 2, context_description, "gchar*");
  return(s7_make_integer(sc, gtk_statusbar_get_context_id((GtkStatusbar*)s7_c_pointer(statusbar), (gchar*)s7_string(context_description))));
}

static s7_pointer lg_gtk_statusbar_push(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_push "guint gtk_statusbar_push(GtkStatusbar* statusbar, guint context_id, gchar* text)"
  s7_pointer _p;
  s7_pointer statusbar, context_id, text;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_push", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_push", 2, context_id, "guint");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_statusbar_push", 3, text, "gchar*");
  return(s7_make_integer(sc, gtk_statusbar_push((GtkStatusbar*)s7_c_pointer(statusbar), (guint)s7_integer(context_id), (gchar*)s7_string(text))));
}

static s7_pointer lg_gtk_statusbar_pop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_pop "void gtk_statusbar_pop(GtkStatusbar* statusbar, guint context_id)"
  s7_pointer _p;
  s7_pointer statusbar, context_id;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_pop", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_pop", 2, context_id, "guint");
  gtk_statusbar_pop((GtkStatusbar*)s7_c_pointer(statusbar), (guint)s7_integer(context_id));
  return(lg_false);
}

static s7_pointer lg_gtk_statusbar_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_remove "void gtk_statusbar_remove(GtkStatusbar* statusbar, guint context_id, \
guint message_id)"
  s7_pointer _p;
  s7_pointer statusbar, context_id, message_id;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove", 2, context_id, "guint");
  message_id = s7_car(_p);
  if (!s7_is_integer(message_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove", 3, message_id, "guint");
  gtk_statusbar_remove((GtkStatusbar*)s7_c_pointer(statusbar), (guint)s7_integer(context_id), (guint)s7_integer(message_id));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_new "GtkTextBuffer* gtk_text_buffer_new(GtkTextTagTable* table)"
  s7_pointer table;
  table = s7_car(args);
  if ((!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) && (table != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_new", 1, table, "GtkTextTagTable*");
  return(lg_make_c_pointer_with_type(sc, GtkTextBuffer__sym, gtk_text_buffer_new((GtkTextTagTable*)s7_c_pointer(table))));
}

static s7_pointer lg_gtk_text_buffer_get_line_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_line_count "gint gtk_text_buffer_get_line_count(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_line_count", 1, buffer, "GtkTextBuffer*");
  return(s7_make_integer(sc, gtk_text_buffer_get_line_count((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_char_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_char_count "gint gtk_text_buffer_get_char_count(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_char_count", 1, buffer, "GtkTextBuffer*");
  return(s7_make_integer(sc, gtk_text_buffer_get_char_count((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_tag_table(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_tag_table "GtkTextTagTable* gtk_text_buffer_get_tag_table(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_tag_table", 1, buffer, "GtkTextBuffer*");
  return(lg_make_c_pointer_with_type(sc, GtkTextTagTable__sym, gtk_text_buffer_get_tag_table((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_set_text "void gtk_text_buffer_set_text(GtkTextBuffer* buffer, gchar* text, \
gint len)"
  s7_pointer _p;
  s7_pointer buffer, text, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_text", 1, buffer, "GtkTextBuffer*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_text", 2, text, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_text", 3, len, "gint");
  gtk_text_buffer_set_text((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(text), (gint)s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert "void gtk_text_buffer_insert(GtkTextBuffer* buffer, GtkTextIter* iter, \
gchar* text, gint len)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 3, text, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert", 4, len, "gint");
  gtk_text_buffer_insert((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gchar*)s7_string(text), (gint)s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_at_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_at_cursor "void gtk_text_buffer_insert_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len)"
  s7_pointer _p;
  s7_pointer buffer, text, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_at_cursor", 1, buffer, "GtkTextBuffer*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_at_cursor", 2, text, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_at_cursor", 3, len, "gint");
  gtk_text_buffer_insert_at_cursor((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(text), (gint)s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_interactive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_interactive "gboolean gtk_text_buffer_insert_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 4, len, "gint");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive", 5, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_insert_interactive((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gchar*)s7_string(text), (gint)s7_integer(len), (gboolean)lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_insert_interactive_at_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_interactive_at_cursor "gboolean gtk_text_buffer_insert_interactive_at_cursor(GtkTextBuffer* buffer, \
gchar* text, gint len, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, text, len, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 1, buffer, "GtkTextBuffer*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 2, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 3, len, "gint");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_interactive_at_cursor", 4, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_insert_interactive_at_cursor((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(text), (gint)s7_integer(len), (gboolean)lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_insert_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_range "void gtk_text_buffer_insert_range(GtkTextBuffer* buffer, GtkTextIter* iter, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, iter, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 2, iter, "GtkTextIter*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 3, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range", 4, end, "GtkTextIter*");
  gtk_text_buffer_insert_range((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_range_interactive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_range_interactive "gboolean gtk_text_buffer_insert_range_interactive(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextIter* start, GtkTextIter* end, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, iter, start, end, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 2, iter, "GtkTextIter*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 3, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 4, end, "GtkTextIter*");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_range_interactive", 5, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_insert_range_interactive((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end), (gboolean)lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_insert_with_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_with_tags "void gtk_text_buffer_insert_with_tags(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len, tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 4, len, "gint");
  tags = s7_car(_p);
  if (!lg_is_list(tags)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags", 5, tags, "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (s7_is_list(sc, tags)) etc_len = s7_list_length(sc, tags);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags", 4, tags, "... list too long (max len: 6)");
    p_arg0 = (GtkTextBuffer*)s7_c_pointer(buffer);
    p_arg1 = (GtkTextIter*)s7_c_pointer(iter);
    p_arg2 = (gchar*)s7_string(text);
    p_arg3 = (gint)s7_integer(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 0)), NULL); break;
        case 2: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 0)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 1)), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 0)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 1)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 2)), NULL); break;
        case 4: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 0)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 1)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 2)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 3)), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 0)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 1)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 2)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 3)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 4)), NULL); break;
        case 6: gtk_text_buffer_insert_with_tags(p_arg0, p_arg1, p_arg2, p_arg3, (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 0)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 1)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 2)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 3)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 4)), (GtkTextTag*)s7_c_pointer(s7_list_ref(sc, tags, 5)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_text_buffer_insert_with_tags_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_with_tags_by_name "void gtk_text_buffer_insert_with_tags_by_name(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* text, gint len, etc tags)"
  s7_pointer _p;
  s7_pointer buffer, iter, text, len, tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 2, iter, "GtkTextIter*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 3, text, "gchar*");
  len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, len, "gint");
  tags = s7_car(_p);
  if (!lg_is_list(tags)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 5, tags, "etc");
  {
    int etc_len = 0;
    GtkTextBuffer* p_arg0;
    GtkTextIter* p_arg1;
    gchar* p_arg2;
    gint p_arg3;
    if (s7_is_list(sc, tags)) etc_len = s7_list_length(sc, tags);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list too long (max len: 6)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_text_buffer_insert_with_tags_by_name", 4, tags, "... list len must be multiple of 2");
    p_arg0 = (GtkTextBuffer*)s7_c_pointer(buffer);
    p_arg1 = (GtkTextIter*)s7_c_pointer(iter);
    p_arg2 = (gchar*)s7_string(text);
    p_arg3 = (gint)s7_integer(len);
    switch (etc_len)
      {
        case 1: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, tags, 0)), NULL); break;
        case 3: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, tags, 0)), s7_integer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), NULL); break;
        case 5: gtk_text_buffer_insert_with_tags_by_name(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, tags, 0)), s7_integer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), s7_integer(s7_list_ref(sc, tags, 3)), s7_string(s7_list_ref(sc, tags, 4)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_text_buffer_delete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete "void gtk_text_buffer_delete(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete", 2, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete", 3, end, "GtkTextIter*");
  gtk_text_buffer_delete((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_delete_interactive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_interactive "gboolean gtk_text_buffer_delete_interactive(GtkTextBuffer* buffer, \
GtkTextIter* start_iter, GtkTextIter* end_iter, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, start_iter, end_iter, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 1, buffer, "GtkTextBuffer*");
  start_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start_iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 2, start_iter, "GtkTextIter*");
  end_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end_iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 3, end_iter, "GtkTextIter*");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_interactive", 4, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_delete_interactive((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start_iter), (GtkTextIter*)s7_c_pointer(end_iter), (gboolean)lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_text "gchar* gtk_text_buffer_get_text(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  s7_pointer _p;
  s7_pointer buffer, start, end, include_hidden_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 3, end, "GtkTextIter*");
  include_hidden_chars = s7_car(_p);
  if (!s7_is_boolean(include_hidden_chars)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_text", 4, include_hidden_chars, "gboolean");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_text_buffer_get_text((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end), (gboolean)lg_boolean(include_hidden_chars));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_buffer_get_slice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_slice "gchar* gtk_text_buffer_get_slice(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end, gboolean include_hidden_chars)"
  s7_pointer _p;
  s7_pointer buffer, start, end, include_hidden_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 2, start, "GtkTextIter*");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 3, end, "GtkTextIter*");
  include_hidden_chars = s7_car(_p);
  if (!s7_is_boolean(include_hidden_chars)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_slice", 4, include_hidden_chars, "gboolean");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_text_buffer_get_slice((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end), (gboolean)lg_boolean(include_hidden_chars));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_buffer_insert_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_child_anchor "void gtk_text_buffer_insert_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  s7_pointer _p;
  s7_pointer buffer, iter, anchor;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_child_anchor", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_child_anchor", 2, iter, "GtkTextIter*");
  anchor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_child_anchor", 3, anchor, "GtkTextChildAnchor*");
  gtk_text_buffer_insert_child_anchor((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (GtkTextChildAnchor*)s7_c_pointer(anchor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_create_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_create_child_anchor "GtkTextChildAnchor* gtk_text_buffer_create_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer buffer, iter;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_child_anchor", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_child_anchor", 2, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GtkTextChildAnchor__sym, gtk_text_buffer_create_child_anchor((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_buffer_create_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_create_mark "GtkTextMark* gtk_text_buffer_create_mark(GtkTextBuffer* buffer, \
gchar* mark_name, GtkTextIter* where, gboolean left_gravity)"
  s7_pointer _p;
  s7_pointer buffer, mark_name, where, left_gravity;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 1, buffer, "GtkTextBuffer*");
  mark_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mark_name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 2, mark_name, "gchar*");
  where = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 3, where, "GtkTextIter*");
  left_gravity = s7_car(_p);
  if (!s7_is_boolean(left_gravity)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_mark", 4, left_gravity, "gboolean");
  return(lg_make_c_pointer_with_type(sc, GtkTextMark__sym, gtk_text_buffer_create_mark((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(mark_name), (GtkTextIter*)s7_c_pointer(where), (gboolean)lg_boolean(left_gravity))));
}

static s7_pointer lg_gtk_text_buffer_move_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_move_mark "void gtk_text_buffer_move_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, mark, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark", 1, buffer, "GtkTextBuffer*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark", 2, mark, "GtkTextMark*");
  where = s7_car(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark", 3, where, "GtkTextIter*");
  gtk_text_buffer_move_mark((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextMark*)s7_c_pointer(mark), (GtkTextIter*)s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_delete_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_mark "void gtk_text_buffer_delete_mark(GtkTextBuffer* buffer, GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer buffer, mark;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark", 1, buffer, "GtkTextBuffer*");
  mark = s7_car(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark", 2, mark, "GtkTextMark*");
  gtk_text_buffer_delete_mark((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextMark*)s7_c_pointer(mark));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_mark "GtkTextMark* gtk_text_buffer_get_mark(GtkTextBuffer* buffer, gchar* name)"
  s7_pointer _p;
  s7_pointer buffer, name;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_mark", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_mark", 2, name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkTextMark__sym, gtk_text_buffer_get_mark((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(name))));
}

static s7_pointer lg_gtk_text_buffer_move_mark_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_move_mark_by_name "void gtk_text_buffer_move_mark_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, name, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark_by_name", 2, name, "gchar*");
  where = s7_car(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_move_mark_by_name", 3, where, "GtkTextIter*");
  gtk_text_buffer_move_mark_by_name((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(name), (GtkTextIter*)s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_delete_mark_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_mark_by_name "void gtk_text_buffer_delete_mark_by_name(GtkTextBuffer* buffer, \
gchar* name)"
  s7_pointer _p;
  s7_pointer buffer, name;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_mark_by_name", 2, name, "gchar*");
  gtk_text_buffer_delete_mark_by_name((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_insert "GtkTextMark* gtk_text_buffer_get_insert(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_insert", 1, buffer, "GtkTextBuffer*");
  return(lg_make_c_pointer_with_type(sc, GtkTextMark__sym, gtk_text_buffer_get_insert((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_selection_bound(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_selection_bound "GtkTextMark* gtk_text_buffer_get_selection_bound(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bound", 1, buffer, "GtkTextBuffer*");
  return(lg_make_c_pointer_with_type(sc, GtkTextMark__sym, gtk_text_buffer_get_selection_bound((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_place_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_place_cursor "void gtk_text_buffer_place_cursor(GtkTextBuffer* buffer, GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_place_cursor", 1, buffer, "GtkTextBuffer*");
  where = s7_car(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_place_cursor", 2, where, "GtkTextIter*");
  gtk_text_buffer_place_cursor((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_apply_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_apply_tag "void gtk_text_buffer_apply_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, tag, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 1, buffer, "GtkTextBuffer*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 2, tag, "GtkTextTag*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 3, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag", 4, end, "GtkTextIter*");
  gtk_text_buffer_apply_tag((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextTag*)s7_c_pointer(tag), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_tag "void gtk_text_buffer_remove_tag(GtkTextBuffer* buffer, GtkTextTag* tag, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, tag, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 1, buffer, "GtkTextBuffer*");
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 2, tag, "GtkTextTag*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 3, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag", 4, end, "GtkTextIter*");
  gtk_text_buffer_remove_tag((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextTag*)s7_c_pointer(tag), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_apply_tag_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_apply_tag_by_name "void gtk_text_buffer_apply_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, name, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 2, name, "gchar*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 3, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_apply_tag_by_name", 4, end, "GtkTextIter*");
  gtk_text_buffer_apply_tag_by_name((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(name), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_tag_by_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_tag_by_name "void gtk_text_buffer_remove_tag_by_name(GtkTextBuffer* buffer, \
gchar* name, GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, name, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 1, buffer, "GtkTextBuffer*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 2, name, "gchar*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 3, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_tag_by_name", 4, end, "GtkTextIter*");
  gtk_text_buffer_remove_tag_by_name((GtkTextBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(name), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_all_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_all_tags "void gtk_text_buffer_remove_all_tags(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_all_tags", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_all_tags", 2, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_all_tags", 3, end, "GtkTextIter*");
  gtk_text_buffer_remove_all_tags((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_create_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_create_tag "GtkTextTag* gtk_text_buffer_create_tag(GtkTextBuffer* buffer, \
gchar* tag_name, etc tags)"
  s7_pointer _p;
  s7_pointer buffer, tag_name, tags;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_tag", 1, buffer, "GtkTextBuffer*");
  tag_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(tag_name)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_tag", 2, tag_name, "gchar*");
  tags = s7_car(_p);
  if ((!lg_is_list(tags)) && (tags != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_create_tag", 3, tags, "etc");
  {
    int etc_len = 0;
    GtkTextTag* res_ult = NULL;
    GtkTextBuffer* p_arg0;
    gchar* p_arg1;
    if (s7_is_list(sc, tags)) etc_len = s7_list_length(sc, tags);
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_text_buffer_create_tag", 2, tags, "... list too long (max len: 6)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_text_buffer_create_tag", 2, tags, "... list len must be multiple of 2");
    p_arg0 = (GtkTextBuffer*)s7_c_pointer(buffer);
    p_arg1 = (gchar*)s7_string(tag_name);
    switch (etc_len)
      {
        case 0: res_ult = gtk_text_buffer_create_tag(p_arg0, p_arg1, NULL); break;
        case 2: res_ult = gtk_text_buffer_create_tag(p_arg0, p_arg1, s7_string(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), NULL); break;
        case 4: res_ult = gtk_text_buffer_create_tag(p_arg0, p_arg1, s7_string(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), NULL); break;
        case 6: res_ult = gtk_text_buffer_create_tag(p_arg0, p_arg1, s7_string(s7_list_ref(sc, tags, 0)), s7_c_pointer(s7_list_ref(sc, tags, 1)), s7_string(s7_list_ref(sc, tags, 2)), s7_c_pointer(s7_list_ref(sc, tags, 3)), s7_string(s7_list_ref(sc, tags, 4)), s7_c_pointer(s7_list_ref(sc, tags, 5)), NULL); break;
      }
    return(s7_make_c_pointer(sc, res_ult));
  }
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_line_offset "void gtk_text_buffer_get_iter_at_line_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint char_offset)"
  s7_pointer _p;
  s7_pointer buffer, iter, line_number, char_offset;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 2, iter, "GtkTextIter*");
  line_number = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 3, line_number, "gint");
  char_offset = s7_car(_p);
  if (!s7_is_integer(char_offset)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_offset", 4, char_offset, "gint");
  gtk_text_buffer_get_iter_at_line_offset((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(line_number), (gint)s7_integer(char_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_line_index "void gtk_text_buffer_get_iter_at_line_index(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number, gint byte_index)"
  s7_pointer _p;
  s7_pointer buffer, iter, line_number, byte_index;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 2, iter, "GtkTextIter*");
  line_number = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 3, line_number, "gint");
  byte_index = s7_car(_p);
  if (!s7_is_integer(byte_index)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line_index", 4, byte_index, "gint");
  gtk_text_buffer_get_iter_at_line_index((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(line_number), (gint)s7_integer(byte_index));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_offset "void gtk_text_buffer_get_iter_at_offset(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint char_offset)"
  s7_pointer _p;
  s7_pointer buffer, iter, char_offset;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_offset", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_offset", 2, iter, "GtkTextIter*");
  char_offset = s7_car(_p);
  if (!s7_is_integer(char_offset)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_offset", 3, char_offset, "gint");
  gtk_text_buffer_get_iter_at_offset((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(char_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_line "void gtk_text_buffer_get_iter_at_line(GtkTextBuffer* buffer, \
GtkTextIter* iter, gint line_number)"
  s7_pointer _p;
  s7_pointer buffer, iter, line_number;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line", 2, iter, "GtkTextIter*");
  line_number = s7_car(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_line", 3, line_number, "gint");
  gtk_text_buffer_get_iter_at_line((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(line_number));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_start_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_start_iter "void gtk_text_buffer_get_start_iter(GtkTextBuffer* buffer, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer buffer, iter;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_start_iter", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_start_iter", 2, iter, "GtkTextIter*");
  gtk_text_buffer_get_start_iter((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_end_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_end_iter "void gtk_text_buffer_get_end_iter(GtkTextBuffer* buffer, GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer buffer, iter;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_end_iter", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_end_iter", 2, iter, "GtkTextIter*");
  gtk_text_buffer_get_end_iter((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_bounds "void gtk_text_buffer_get_bounds(GtkTextBuffer* buffer, GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_bounds", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_bounds", 2, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_bounds", 3, end, "GtkTextIter*");
  gtk_text_buffer_get_bounds((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_mark "void gtk_text_buffer_get_iter_at_mark(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer buffer, iter, mark;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_mark", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_mark", 2, iter, "GtkTextIter*");
  mark = s7_car(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_mark", 3, mark, "GtkTextMark*");
  gtk_text_buffer_get_iter_at_mark((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (GtkTextMark*)s7_c_pointer(mark));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_iter_at_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_iter_at_child_anchor "void gtk_text_buffer_get_iter_at_child_anchor(GtkTextBuffer* buffer, \
GtkTextIter* iter, GtkTextChildAnchor* anchor)"
  s7_pointer _p;
  s7_pointer buffer, iter, anchor;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_child_anchor", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_child_anchor", 2, iter, "GtkTextIter*");
  anchor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_iter_at_child_anchor", 3, anchor, "GtkTextChildAnchor*");
  gtk_text_buffer_get_iter_at_child_anchor((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (GtkTextChildAnchor*)s7_c_pointer(anchor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_modified(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_modified "gboolean gtk_text_buffer_get_modified(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_modified", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_modified((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_set_modified(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_set_modified "void gtk_text_buffer_set_modified(GtkTextBuffer* buffer, gboolean setting)"
  s7_pointer _p;
  s7_pointer buffer, setting;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_modified", 1, buffer, "GtkTextBuffer*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_modified", 2, setting, "gboolean");
  gtk_text_buffer_set_modified((GtkTextBuffer*)s7_c_pointer(buffer), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_selection_bounds(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_selection_bounds "gboolean gtk_text_buffer_get_selection_bounds(GtkTextBuffer* buffer, \
GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer buffer, start, end;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bounds", 1, buffer, "GtkTextBuffer*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bounds", 2, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_bounds", 3, end, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_selection_bounds((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end))));
}

static s7_pointer lg_gtk_text_buffer_delete_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_delete_selection "gboolean gtk_text_buffer_delete_selection(GtkTextBuffer* buffer, \
gboolean interactive, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, interactive, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_selection", 1, buffer, "GtkTextBuffer*");
  interactive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(interactive)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_selection", 2, interactive, "gboolean");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_delete_selection", 3, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_delete_selection((GtkTextBuffer*)s7_c_pointer(buffer), (gboolean)lg_boolean(interactive), (gboolean)lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_text_buffer_begin_user_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_begin_user_action "void gtk_text_buffer_begin_user_action(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_begin_user_action", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_begin_user_action((GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_end_user_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_end_user_action "void gtk_text_buffer_end_user_action(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_end_user_action", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_end_user_action((GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_child_anchor_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_child_anchor_new "GtkTextChildAnchor* gtk_text_child_anchor_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkTextChildAnchor__sym, gtk_text_child_anchor_new()));
}

static s7_pointer lg_gtk_text_child_anchor_get_widgets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_child_anchor_get_widgets "GList* gtk_text_child_anchor_get_widgets(GtkTextChildAnchor* anchor)"
  s7_pointer anchor;
  anchor = s7_car(args);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_child_anchor_get_widgets", 1, anchor, "GtkTextChildAnchor*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_text_child_anchor_get_widgets((GtkTextChildAnchor*)s7_c_pointer(anchor))));
}

static s7_pointer lg_gtk_text_child_anchor_get_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_child_anchor_get_deleted "gboolean gtk_text_child_anchor_get_deleted(GtkTextChildAnchor* anchor)"
  s7_pointer anchor;
  anchor = s7_car(args);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_child_anchor_get_deleted", 1, anchor, "GtkTextChildAnchor*");
  return(s7_make_boolean(sc, gtk_text_child_anchor_get_deleted((GtkTextChildAnchor*)s7_c_pointer(anchor))));
}

static s7_pointer lg_gtk_text_iter_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_buffer "GtkTextBuffer* gtk_text_iter_get_buffer(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_buffer", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GtkTextBuffer__sym, gtk_text_iter_get_buffer((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_copy "GtkTextIter* gtk_text_iter_copy(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_copy", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GtkTextIter__sym, gtk_text_iter_copy((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_free "void gtk_text_iter_free(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_free", 1, iter, "GtkTextIter*");
  gtk_text_iter_free((GtkTextIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_get_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_offset "gint gtk_text_iter_get_offset(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_offset", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_offset((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_line "gint gtk_text_iter_get_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_line", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_line_offset "gint gtk_text_iter_get_line_offset(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_line_offset", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_line_offset((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_line_index "gint gtk_text_iter_get_line_index(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_line_index", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_line_index((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_visible_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_line_offset "gint gtk_text_iter_get_visible_line_offset(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_line_offset", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_visible_line_offset((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_visible_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_line_index "gint gtk_text_iter_get_visible_line_index(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_line_index", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_visible_line_index((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_char "gunichar gtk_text_iter_get_char(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_char", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_char((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_slice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_slice "gchar* gtk_text_iter_get_slice(GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_slice", 1, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_slice", 2, end, "GtkTextIter*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_text_iter_get_slice((GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_text "gchar* gtk_text_iter_get_text(GtkTextIter* start, GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_text", 1, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_text", 2, end, "GtkTextIter*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_text_iter_get_text((GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_visible_slice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_slice "gchar* gtk_text_iter_get_visible_slice(GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_slice", 1, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_slice", 2, end, "GtkTextIter*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_text_iter_get_visible_slice((GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_visible_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_visible_text "gchar* gtk_text_iter_get_visible_text(GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer start, end;
  _p = args;
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_text", 1, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_visible_text", 2, end, "GtkTextIter*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_text_iter_get_visible_text((GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_text_iter_get_marks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_marks "GSList* gtk_text_iter_get_marks(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_marks", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_text_iter_get_marks((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_child_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_child_anchor "GtkTextChildAnchor* gtk_text_iter_get_child_anchor(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_child_anchor", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GtkTextChildAnchor__sym, gtk_text_iter_get_child_anchor((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_toggled_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_toggled_tags "GSList* gtk_text_iter_get_toggled_tags(GtkTextIter* iter, \
gboolean toggled_on)"
  s7_pointer _p;
  s7_pointer iter, toggled_on;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_toggled_tags", 1, iter, "GtkTextIter*");
  toggled_on = s7_car(_p);
  if (!s7_is_boolean(toggled_on)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_toggled_tags", 2, toggled_on, "gboolean");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_text_iter_get_toggled_tags((GtkTextIter*)s7_c_pointer(iter), (gboolean)lg_boolean(toggled_on))));
}

static s7_pointer lg_gtk_text_iter_ends_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_tag "gboolean gtk_text_iter_ends_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_tag((GtkTextIter*)s7_c_pointer(iter), (GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_toggles_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_toggles_tag "gboolean gtk_text_iter_toggles_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_toggles_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_toggles_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_toggles_tag((GtkTextIter*)s7_c_pointer(iter), (GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_has_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_has_tag "gboolean gtk_text_iter_has_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_has_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_has_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_has_tag((GtkTextIter*)s7_c_pointer(iter), (GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_get_tags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_tags "GSList* gtk_text_iter_get_tags(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_tags", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_text_iter_get_tags((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_editable "gboolean gtk_text_iter_editable(GtkTextIter* iter, gboolean default_setting)"
  s7_pointer _p;
  s7_pointer iter, default_setting;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_editable", 1, iter, "GtkTextIter*");
  default_setting = s7_car(_p);
  if (!s7_is_boolean(default_setting)) s7_wrong_type_arg_error(sc, "gtk_text_iter_editable", 2, default_setting, "gboolean");
  return(s7_make_boolean(sc, gtk_text_iter_editable((GtkTextIter*)s7_c_pointer(iter), (gboolean)lg_boolean(default_setting))));
}

static s7_pointer lg_gtk_text_iter_can_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_can_insert "gboolean gtk_text_iter_can_insert(GtkTextIter* iter, gboolean default_editability)"
  s7_pointer _p;
  s7_pointer iter, default_editability;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_can_insert", 1, iter, "GtkTextIter*");
  default_editability = s7_car(_p);
  if (!s7_is_boolean(default_editability)) s7_wrong_type_arg_error(sc, "gtk_text_iter_can_insert", 2, default_editability, "gboolean");
  return(s7_make_boolean(sc, gtk_text_iter_can_insert((GtkTextIter*)s7_c_pointer(iter), (gboolean)lg_boolean(default_editability))));
}

static s7_pointer lg_gtk_text_iter_starts_word(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_word "gboolean gtk_text_iter_starts_word(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_word", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_word((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_ends_word(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_word "gboolean gtk_text_iter_ends_word(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_word", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_word((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_inside_word(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_inside_word "gboolean gtk_text_iter_inside_word(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_inside_word", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_inside_word((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_starts_sentence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_sentence "gboolean gtk_text_iter_starts_sentence(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_sentence", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_sentence((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_ends_sentence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_sentence "gboolean gtk_text_iter_ends_sentence(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_sentence", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_sentence((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_inside_sentence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_inside_sentence "gboolean gtk_text_iter_inside_sentence(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_inside_sentence", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_inside_sentence((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_starts_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_line "gboolean gtk_text_iter_starts_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_ends_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_ends_line "gboolean gtk_text_iter_ends_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_ends_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_ends_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_is_cursor_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_is_cursor_position "gboolean gtk_text_iter_is_cursor_position(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_is_cursor_position", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_is_cursor_position((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_chars_in_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_chars_in_line "gint gtk_text_iter_get_chars_in_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_chars_in_line", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_chars_in_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_bytes_in_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_bytes_in_line "gint gtk_text_iter_get_bytes_in_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_bytes_in_line", 1, iter, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_get_bytes_in_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_get_language(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_language "PangoLanguage* gtk_text_iter_get_language(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_language", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, PangoLanguage__sym, gtk_text_iter_get_language((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_is_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_is_end "gboolean gtk_text_iter_is_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_is_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_is_end((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_is_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_is_start "gboolean gtk_text_iter_is_start(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_is_start", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_is_start((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_char "gboolean gtk_text_iter_forward_char(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_char", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_char((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_char "gboolean gtk_text_iter_backward_char(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_char", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_char((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_chars "gboolean gtk_text_iter_forward_chars(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_chars", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_chars", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_chars((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_chars "gboolean gtk_text_iter_backward_chars(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_chars", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_chars", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_chars((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_line "gboolean gtk_text_iter_forward_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_line "gboolean gtk_text_iter_backward_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_lines "gboolean gtk_text_iter_forward_lines(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_lines((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_lines "gboolean gtk_text_iter_backward_lines(GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_lines((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_word_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_word_end "gboolean gtk_text_iter_forward_word_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_word_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_word_end((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_word_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_word_start "gboolean gtk_text_iter_backward_word_start(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_word_start", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_word_start((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_word_ends(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_word_ends "gboolean gtk_text_iter_forward_word_ends(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_word_ends", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_word_ends", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_word_ends((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_word_starts(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_word_starts "gboolean gtk_text_iter_backward_word_starts(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_word_starts", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_word_starts", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_word_starts((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_sentence_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_sentence_end "gboolean gtk_text_iter_forward_sentence_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_sentence_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_sentence_end((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_sentence_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_sentence_start "gboolean gtk_text_iter_backward_sentence_start(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_sentence_start", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_sentence_start((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_sentence_ends(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_sentence_ends "gboolean gtk_text_iter_forward_sentence_ends(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_sentence_ends", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_sentence_ends", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_sentence_ends((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_sentence_starts(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_sentence_starts "gboolean gtk_text_iter_backward_sentence_starts(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_sentence_starts", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_sentence_starts", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_sentence_starts((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_forward_cursor_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_cursor_position "gboolean gtk_text_iter_forward_cursor_position(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_cursor_position", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_cursor_position((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_cursor_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_cursor_position "gboolean gtk_text_iter_backward_cursor_position(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_cursor_position", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_cursor_position((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_cursor_positions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_cursor_positions "gboolean gtk_text_iter_forward_cursor_positions(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_cursor_positions", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_cursor_positions", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_cursor_positions((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_cursor_positions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_cursor_positions "gboolean gtk_text_iter_backward_cursor_positions(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_cursor_positions", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_cursor_positions", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_cursor_positions((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_set_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_offset "void gtk_text_iter_set_offset(GtkTextIter* iter, gint char_offset)"
  s7_pointer _p;
  s7_pointer iter, char_offset;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_offset", 1, iter, "GtkTextIter*");
  char_offset = s7_car(_p);
  if (!s7_is_integer(char_offset)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_offset", 2, char_offset, "gint");
  gtk_text_iter_set_offset((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(char_offset));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_line "void gtk_text_iter_set_line(GtkTextIter* iter, gint line_number)"
  s7_pointer _p;
  s7_pointer iter, line_number;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line", 1, iter, "GtkTextIter*");
  line_number = s7_car(_p);
  if (!s7_is_integer(line_number)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line", 2, line_number, "gint");
  gtk_text_iter_set_line((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(line_number));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_line_offset "void gtk_text_iter_set_line_offset(GtkTextIter* iter, gint char_on_line)"
  s7_pointer _p;
  s7_pointer iter, char_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_offset", 1, iter, "GtkTextIter*");
  char_on_line = s7_car(_p);
  if (!s7_is_integer(char_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_offset", 2, char_on_line, "gint");
  gtk_text_iter_set_line_offset((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(char_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_line_index "void gtk_text_iter_set_line_index(GtkTextIter* iter, gint byte_on_line)"
  s7_pointer _p;
  s7_pointer iter, byte_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_index", 1, iter, "GtkTextIter*");
  byte_on_line = s7_car(_p);
  if (!s7_is_integer(byte_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_line_index", 2, byte_on_line, "gint");
  gtk_text_iter_set_line_index((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(byte_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_to_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_to_end "void gtk_text_iter_forward_to_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_end", 1, iter, "GtkTextIter*");
  gtk_text_iter_forward_to_end((GtkTextIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_to_line_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_to_line_end "gboolean gtk_text_iter_forward_to_line_end(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_line_end", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_to_line_end((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_set_visible_line_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_visible_line_offset "void gtk_text_iter_set_visible_line_offset(GtkTextIter* iter, \
gint char_on_line)"
  s7_pointer _p;
  s7_pointer iter, char_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_offset", 1, iter, "GtkTextIter*");
  char_on_line = s7_car(_p);
  if (!s7_is_integer(char_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_offset", 2, char_on_line, "gint");
  gtk_text_iter_set_visible_line_offset((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(char_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_set_visible_line_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_set_visible_line_index "void gtk_text_iter_set_visible_line_index(GtkTextIter* iter, \
gint byte_on_line)"
  s7_pointer _p;
  s7_pointer iter, byte_on_line;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_index", 1, iter, "GtkTextIter*");
  byte_on_line = s7_car(_p);
  if (!s7_is_integer(byte_on_line)) s7_wrong_type_arg_error(sc, "gtk_text_iter_set_visible_line_index", 2, byte_on_line, "gint");
  gtk_text_iter_set_visible_line_index((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(byte_on_line));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_to_tag_toggle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_to_tag_toggle "gboolean gtk_text_iter_forward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_tag_toggle", 1, iter, "GtkTextIter*");
  tag = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_to_tag_toggle", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_to_tag_toggle((GtkTextIter*)s7_c_pointer(iter), (GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_backward_to_tag_toggle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_to_tag_toggle "gboolean gtk_text_iter_backward_to_tag_toggle(GtkTextIter* iter, \
GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_to_tag_toggle", 1, iter, "GtkTextIter*");
  tag = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_to_tag_toggle", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_to_tag_toggle((GtkTextIter*)s7_c_pointer(iter), (GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_iter_forward_find_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_find_char "gboolean gtk_text_iter_forward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_info, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter /* , pred */ , func_info, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_find_char", 1, iter, "GtkTextIter*");
  /* pred = s7_car(_p); */ _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  limit = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_find_char", 4, limit, "GtkTextIter*");
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    res_ult = s7_make_boolean(sc, gtk_text_iter_forward_find_char((GtkTextIter*)s7_c_pointer(iter), lg_text_char_predicate, (gpointer)lg_ptr, (GtkTextIter*)s7_c_pointer(limit)));
    return(res_ult);
   }
}

static s7_pointer lg_gtk_text_iter_backward_find_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_find_char "gboolean gtk_text_iter_backward_find_char(GtkTextIter* iter, \
GtkTextCharPredicate pred, lambda_data func_info, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter /* , pred */ , func_info, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_find_char", 1, iter, "GtkTextIter*");
  /* pred = s7_car(_p); */ _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  limit = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_find_char", 4, limit, "GtkTextIter*");
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    res_ult = s7_make_boolean(sc, gtk_text_iter_backward_find_char((GtkTextIter*)s7_c_pointer(iter), lg_text_char_predicate, (gpointer)lg_ptr, (GtkTextIter*)s7_c_pointer(limit)));
    return(res_ult);
   }
}

static s7_pointer lg_gtk_text_iter_forward_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_search "gboolean gtk_text_iter_forward_search(GtkTextIter* iter, gchar* str, \
GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter, str, flags, match_start, match_end, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 1, iter, "GtkTextIter*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 2, str, "gchar*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 3, flags, "GtkTextSearchFlags");
  match_start = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_start, GtkTextIter__sym)) && (match_start != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 4, match_start, "GtkTextIter*");
  match_end = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_end, GtkTextIter__sym)) && (match_end != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 5, match_end, "GtkTextIter*");
  limit = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_search", 6, limit, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_search((GtkTextIter*)s7_c_pointer(iter), (gchar*)s7_string(str), (GtkTextSearchFlags)s7_integer(flags), (GtkTextIter*)s7_c_pointer(match_start), (GtkTextIter*)s7_c_pointer(match_end), (GtkTextIter*)s7_c_pointer(limit))));
}

static s7_pointer lg_gtk_text_iter_backward_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_search "gboolean gtk_text_iter_backward_search(GtkTextIter* iter, \
gchar* str, GtkTextSearchFlags flags, GtkTextIter* match_start, GtkTextIter* match_end, GtkTextIter* limit)"
  s7_pointer _p;
  s7_pointer iter, str, flags, match_start, match_end, limit;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 1, iter, "GtkTextIter*");
  str = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 2, str, "gchar*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 3, flags, "GtkTextSearchFlags");
  match_start = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_start, GtkTextIter__sym)) && (match_start != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 4, match_start, "GtkTextIter*");
  match_end = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(match_end, GtkTextIter__sym)) && (match_end != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 5, match_end, "GtkTextIter*");
  limit = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(limit, GtkTextIter__sym)) && (limit != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_search", 6, limit, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_search((GtkTextIter*)s7_c_pointer(iter), (gchar*)s7_string(str), (GtkTextSearchFlags)s7_integer(flags), (GtkTextIter*)s7_c_pointer(match_start), (GtkTextIter*)s7_c_pointer(match_end), (GtkTextIter*)s7_c_pointer(limit))));
}

static s7_pointer lg_gtk_text_iter_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_equal "gboolean gtk_text_iter_equal(GtkTextIter* lhs, GtkTextIter* rhs)"
  s7_pointer _p;
  s7_pointer lhs, rhs;
  _p = args;
  lhs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(lhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_equal", 1, lhs, "GtkTextIter*");
  rhs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_equal", 2, rhs, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_equal((GtkTextIter*)s7_c_pointer(lhs), (GtkTextIter*)s7_c_pointer(rhs))));
}

static s7_pointer lg_gtk_text_iter_compare(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_compare "gint gtk_text_iter_compare(GtkTextIter* lhs, GtkTextIter* rhs)"
  s7_pointer _p;
  s7_pointer lhs, rhs;
  _p = args;
  lhs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(lhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_compare", 1, lhs, "GtkTextIter*");
  rhs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rhs, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_compare", 2, rhs, "GtkTextIter*");
  return(s7_make_integer(sc, gtk_text_iter_compare((GtkTextIter*)s7_c_pointer(lhs), (GtkTextIter*)s7_c_pointer(rhs))));
}

static s7_pointer lg_gtk_text_iter_in_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_in_range "gboolean gtk_text_iter_in_range(GtkTextIter* iter, GtkTextIter* start, \
GtkTextIter* end)"
  s7_pointer _p;
  s7_pointer iter, start, end;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_in_range", 1, iter, "GtkTextIter*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_in_range", 2, start, "GtkTextIter*");
  end = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_in_range", 3, end, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_in_range((GtkTextIter*)s7_c_pointer(iter), (GtkTextIter*)s7_c_pointer(start), (GtkTextIter*)s7_c_pointer(end))));
}

static s7_pointer lg_gtk_text_iter_order(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_order "void gtk_text_iter_order(GtkTextIter* first, GtkTextIter* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_order", 1, first, "GtkTextIter*");
  second = s7_car(_p);
  if (!s7_is_c_pointer_of_type(second, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_order", 2, second, "GtkTextIter*");
  gtk_text_iter_order((GtkTextIter*)s7_c_pointer(first), (GtkTextIter*)s7_c_pointer(second));
  return(lg_false);
}

static s7_pointer lg_gtk_text_mark_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_set_visible "void gtk_text_mark_set_visible(GtkTextMark* mark, gboolean setting)"
  s7_pointer _p;
  s7_pointer mark, setting;
  _p = args;
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_set_visible", 1, mark, "GtkTextMark*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_mark_set_visible", 2, setting, "gboolean");
  gtk_text_mark_set_visible((GtkTextMark*)s7_c_pointer(mark), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_mark_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_visible "gboolean gtk_text_mark_get_visible(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_visible", 1, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_mark_get_visible((GtkTextMark*)s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_name "char* gtk_text_mark_get_name(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_name", 1, mark, "GtkTextMark*");
  return(s7_make_string(sc, gtk_text_mark_get_name((GtkTextMark*)s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_deleted "gboolean gtk_text_mark_get_deleted(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_deleted", 1, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_mark_get_deleted((GtkTextMark*)s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_buffer "GtkTextBuffer* gtk_text_mark_get_buffer(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_buffer", 1, mark, "GtkTextMark*");
  return(lg_make_c_pointer_with_type(sc, GtkTextBuffer__sym, gtk_text_mark_get_buffer((GtkTextMark*)s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_mark_get_left_gravity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_get_left_gravity "gboolean gtk_text_mark_get_left_gravity(GtkTextMark* mark)"
  s7_pointer mark;
  mark = s7_car(args);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_mark_get_left_gravity", 1, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_mark_get_left_gravity((GtkTextMark*)s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_tag_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_new "GtkTextTag* gtk_text_tag_new(gchar* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_tag_new", 1, name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkTextTag__sym, gtk_text_tag_new((gchar*)s7_string(name))));
}

static s7_pointer lg_gtk_text_tag_get_priority(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_get_priority "gint gtk_text_tag_get_priority(GtkTextTag* tag)"
  s7_pointer tag;
  tag = s7_car(args);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_get_priority", 1, tag, "GtkTextTag*");
  return(s7_make_integer(sc, gtk_text_tag_get_priority((GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gtk_text_tag_set_priority(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_set_priority "void gtk_text_tag_set_priority(GtkTextTag* tag, gint priority)"
  s7_pointer _p;
  s7_pointer tag, priority;
  _p = args;
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_set_priority", 1, tag, "GtkTextTag*");
  priority = s7_car(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gtk_text_tag_set_priority", 2, priority, "gint");
  gtk_text_tag_set_priority((GtkTextTag*)s7_c_pointer(tag), (gint)s7_integer(priority));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_table_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_new "GtkTextTagTable* gtk_text_tag_table_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkTextTagTable__sym, gtk_text_tag_table_new()));
}

static s7_pointer lg_gtk_text_tag_table_add(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_add "void gtk_text_tag_table_add(GtkTextTagTable* table, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer table, tag;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_add", 1, table, "GtkTextTagTable*");
  tag = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_add", 2, tag, "GtkTextTag*");
  gtk_text_tag_table_add((GtkTextTagTable*)s7_c_pointer(table), (GtkTextTag*)s7_c_pointer(tag));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_table_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_remove "void gtk_text_tag_table_remove(GtkTextTagTable* table, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer table, tag;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_remove", 1, table, "GtkTextTagTable*");
  tag = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_remove", 2, tag, "GtkTextTag*");
  gtk_text_tag_table_remove((GtkTextTagTable*)s7_c_pointer(table), (GtkTextTag*)s7_c_pointer(tag));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_table_lookup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_lookup "GtkTextTag* gtk_text_tag_table_lookup(GtkTextTagTable* table, \
gchar* name)"
  s7_pointer _p;
  s7_pointer table, name;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_lookup", 1, table, "GtkTextTagTable*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_lookup", 2, name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkTextTag__sym, gtk_text_tag_table_lookup((GtkTextTagTable*)s7_c_pointer(table), (gchar*)s7_string(name))));
}

static s7_pointer lg_gtk_text_tag_table_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_foreach "void gtk_text_tag_table_foreach(GtkTextTagTable* table, GtkTextTagTableForeach func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer table, func, func_info;
  _p = args;
  table = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_foreach", 1, table, "GtkTextTagTable*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_text_tag_table_foreach((GtkTextTagTable*)s7_c_pointer(table), lg_text_tag_table_foreach, (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_text_tag_table_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_table_get_size "gint gtk_text_tag_table_get_size(GtkTextTagTable* table)"
  s7_pointer table;
  table = s7_car(args);
  if (!s7_is_c_pointer_of_type(table, GtkTextTagTable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_table_get_size", 1, table, "GtkTextTagTable*");
  return(s7_make_integer(sc, gtk_text_tag_table_get_size((GtkTextTagTable*)s7_c_pointer(table))));
}

static s7_pointer lg_gtk_text_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_new "GtkWidget* gtk_text_view_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_text_view_new()));
}

static s7_pointer lg_gtk_text_view_new_with_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_new_with_buffer "GtkWidget* gtk_text_view_new_with_buffer(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_new_with_buffer", 1, buffer, "GtkTextBuffer*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_text_view_new_with_buffer((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_view_set_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_buffer "void gtk_text_view_set_buffer(GtkTextView* text_view, GtkTextBuffer* buffer)"
  s7_pointer _p;
  s7_pointer text_view, buffer;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_buffer", 1, text_view, "GtkTextView*");
  buffer = s7_car(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_buffer", 2, buffer, "GtkTextBuffer*");
  gtk_text_view_set_buffer((GtkTextView*)s7_c_pointer(text_view), (GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_buffer "GtkTextBuffer* gtk_text_view_get_buffer(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_buffer", 1, text_view, "GtkTextView*");
  return(lg_make_c_pointer_with_type(sc, GtkTextBuffer__sym, gtk_text_view_get_buffer((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_scroll_to_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_scroll_to_iter "gboolean gtk_text_view_scroll_to_iter(GtkTextView* text_view, \
GtkTextIter* iter, gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  s7_pointer _p;
  s7_pointer text_view, iter, within_margin, use_align, xalign, yalign;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 2, iter, "GtkTextIter*");
  within_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(within_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 3, within_margin, "gdouble");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 4, use_align, "gboolean");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 5, xalign, "gdouble");
  yalign = s7_car(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_iter", 6, yalign, "gdouble");
  return(s7_make_boolean(sc, gtk_text_view_scroll_to_iter((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), (gdouble)s7_real(within_margin), (gboolean)lg_boolean(use_align), (gdouble)s7_real(xalign), (gdouble)s7_real(yalign))));
}

static s7_pointer lg_gtk_text_view_scroll_to_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_scroll_to_mark "void gtk_text_view_scroll_to_mark(GtkTextView* text_view, GtkTextMark* mark, \
gdouble within_margin, gboolean use_align, gdouble xalign, gdouble yalign)"
  s7_pointer _p;
  s7_pointer text_view, mark, within_margin, use_align, xalign, yalign;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 1, text_view, "GtkTextView*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 2, mark, "GtkTextMark*");
  within_margin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(within_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 3, within_margin, "gdouble");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 4, use_align, "gboolean");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 5, xalign, "gdouble");
  yalign = s7_car(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_to_mark", 6, yalign, "gdouble");
  gtk_text_view_scroll_to_mark((GtkTextView*)s7_c_pointer(text_view), (GtkTextMark*)s7_c_pointer(mark), (gdouble)s7_real(within_margin), (gboolean)lg_boolean(use_align), (gdouble)s7_real(xalign), (gdouble)s7_real(yalign));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_scroll_mark_onscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_scroll_mark_onscreen "void gtk_text_view_scroll_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer text_view, mark;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_mark_onscreen", 1, text_view, "GtkTextView*");
  mark = s7_car(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_scroll_mark_onscreen", 2, mark, "GtkTextMark*");
  gtk_text_view_scroll_mark_onscreen((GtkTextView*)s7_c_pointer(text_view), (GtkTextMark*)s7_c_pointer(mark));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_move_mark_onscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_move_mark_onscreen "gboolean gtk_text_view_move_mark_onscreen(GtkTextView* text_view, \
GtkTextMark* mark)"
  s7_pointer _p;
  s7_pointer text_view, mark;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_mark_onscreen", 1, text_view, "GtkTextView*");
  mark = s7_car(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_mark_onscreen", 2, mark, "GtkTextMark*");
  return(s7_make_boolean(sc, gtk_text_view_move_mark_onscreen((GtkTextView*)s7_c_pointer(text_view), (GtkTextMark*)s7_c_pointer(mark))));
}

static s7_pointer lg_gtk_text_view_place_cursor_onscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_place_cursor_onscreen "gboolean gtk_text_view_place_cursor_onscreen(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_place_cursor_onscreen", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_place_cursor_onscreen((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_get_visible_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_visible_rect "void gtk_text_view_get_visible_rect(GtkTextView* text_view, \
GdkRectangle* visible_rect)"
  s7_pointer _p;
  s7_pointer text_view, visible_rect;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_visible_rect", 1, text_view, "GtkTextView*");
  visible_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(visible_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_visible_rect", 2, visible_rect, "GdkRectangle*");
  gtk_text_view_get_visible_rect((GtkTextView*)s7_c_pointer(text_view), (GdkRectangle*)s7_c_pointer(visible_rect));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_cursor_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_cursor_visible "void gtk_text_view_set_cursor_visible(GtkTextView* text_view, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer text_view, setting;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_cursor_visible", 1, text_view, "GtkTextView*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_cursor_visible", 2, setting, "gboolean");
  gtk_text_view_set_cursor_visible((GtkTextView*)s7_c_pointer(text_view), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_cursor_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_cursor_visible "gboolean gtk_text_view_get_cursor_visible(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_cursor_visible", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_cursor_visible((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_get_iter_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_iter_location "void gtk_text_view_get_iter_location(GtkTextView* text_view, \
GtkTextIter* iter, GdkRectangle* location)"
  s7_pointer _p;
  s7_pointer text_view, iter, location;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_location", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_location", 2, iter, "GtkTextIter*");
  location = s7_car(_p);
  if (!s7_is_c_pointer_of_type(location, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_location", 3, location, "GdkRectangle*");
  gtk_text_view_get_iter_location((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), (GdkRectangle*)s7_c_pointer(location));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_line_yrange(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_line_yrange "void gtk_text_view_get_line_yrange(GtkTextView* text_view, \
GtkTextIter* iter, gint* [y], gint* [height])"
  s7_pointer _p;
  s7_pointer text_view, iter;
  gint ref_y;
  gint ref_height;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_yrange", 1, text_view, "GtkTextView*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_yrange", 2, iter, "GtkTextIter*");
  gtk_text_view_get_line_yrange((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), &ref_y, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_y), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_text_view_get_line_at_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_line_at_y "void gtk_text_view_get_line_at_y(GtkTextView* text_view, GtkTextIter* target_iter, \
gint y, gint* [line_top])"
  s7_pointer _p;
  s7_pointer text_view, target_iter, y;
  gint ref_line_top;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_at_y", 1, text_view, "GtkTextView*");
  target_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target_iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_at_y", 2, target_iter, "GtkTextIter*");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_line_at_y", 3, y, "gint");
  gtk_text_view_get_line_at_y((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(target_iter), (gint)s7_integer(y), &ref_line_top);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_line_top)));
}

static s7_pointer lg_gtk_text_view_window_to_buffer_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_window_to_buffer_coords "void gtk_text_view_window_to_buffer_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint window_x, gint window_y, gint* [buffer_x], gint* [buffer_y])"
  s7_pointer _p;
  s7_pointer text_view, win, window_x, window_y;
  gint ref_buffer_x;
  gint ref_buffer_y;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 1, text_view, "GtkTextView*");
  win = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 2, win, "GtkTextWindowType");
  window_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(window_x)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 3, window_x, "gint");
  window_y = s7_car(_p);
  if (!s7_is_integer(window_y)) s7_wrong_type_arg_error(sc, "gtk_text_view_window_to_buffer_coords", 4, window_y, "gint");
  gtk_text_view_window_to_buffer_coords((GtkTextView*)s7_c_pointer(text_view), (GtkTextWindowType)s7_integer(win), (gint)s7_integer(window_x), (gint)s7_integer(window_y), &ref_buffer_x, &ref_buffer_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_buffer_x), s7_make_integer(sc, ref_buffer_y)));
}

static s7_pointer lg_gtk_text_view_set_border_window_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_border_window_size "void gtk_text_view_set_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type, gint size)"
  s7_pointer _p;
  s7_pointer text_view, type, size;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_border_window_size", 1, text_view, "GtkTextView*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_border_window_size", 2, type, "GtkTextWindowType");
  size = s7_car(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_border_window_size", 3, size, "gint");
  gtk_text_view_set_border_window_size((GtkTextView*)s7_c_pointer(text_view), (GtkTextWindowType)s7_integer(type), (gint)s7_integer(size));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_border_window_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_border_window_size "gint gtk_text_view_get_border_window_size(GtkTextView* text_view, \
GtkTextWindowType type)"
  s7_pointer _p;
  s7_pointer text_view, type;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_border_window_size", 1, text_view, "GtkTextView*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_border_window_size", 2, type, "GtkTextWindowType");
  return(s7_make_integer(sc, gtk_text_view_get_border_window_size((GtkTextView*)s7_c_pointer(text_view), (GtkTextWindowType)s7_integer(type))));
}

static s7_pointer lg_gtk_text_view_forward_display_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_forward_display_line "gboolean gtk_text_view_forward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line", 1, text_view, "GtkTextView*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_forward_display_line((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_backward_display_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_backward_display_line "gboolean gtk_text_view_backward_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line", 1, text_view, "GtkTextView*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_backward_display_line((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_forward_display_line_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_forward_display_line_end "gboolean gtk_text_view_forward_display_line_end(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line_end", 1, text_view, "GtkTextView*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_forward_display_line_end", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_forward_display_line_end((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_backward_display_line_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_backward_display_line_start "gboolean gtk_text_view_backward_display_line_start(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line_start", 1, text_view, "GtkTextView*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_backward_display_line_start", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_backward_display_line_start((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_starts_display_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_starts_display_line "gboolean gtk_text_view_starts_display_line(GtkTextView* text_view, \
GtkTextIter* iter)"
  s7_pointer _p;
  s7_pointer text_view, iter;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_starts_display_line", 1, text_view, "GtkTextView*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_starts_display_line", 2, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_view_starts_display_line((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_view_move_visually(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_move_visually "gboolean gtk_text_view_move_visually(GtkTextView* text_view, \
GtkTextIter* iter, gint count)"
  s7_pointer _p;
  s7_pointer text_view, iter, count;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_visually", 1, text_view, "GtkTextView*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_visually", 2, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_visually", 3, count, "gint");
  return(s7_make_boolean(sc, gtk_text_view_move_visually((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_view_add_child_at_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_add_child_at_anchor "void gtk_text_view_add_child_at_anchor(GtkTextView* text_view, \
GtkWidget* child, GtkTextChildAnchor* anchor)"
  s7_pointer _p;
  s7_pointer text_view, child, anchor;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_at_anchor", 1, text_view, "GtkTextView*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_at_anchor", 2, child, "GtkWidget*");
  anchor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(anchor, GtkTextChildAnchor__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_child_at_anchor", 3, anchor, "GtkTextChildAnchor*");
  gtk_text_view_add_child_at_anchor((GtkTextView*)s7_c_pointer(text_view), (GtkWidget*)s7_c_pointer(child), (GtkTextChildAnchor*)s7_c_pointer(anchor));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_wrap_mode "void gtk_text_view_set_wrap_mode(GtkTextView* text_view, GtkWrapMode wrap_mode)"
  s7_pointer _p;
  s7_pointer text_view, wrap_mode;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_wrap_mode", 1, text_view, "GtkTextView*");
  wrap_mode = s7_car(_p);
  if (!s7_is_integer(wrap_mode)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_wrap_mode", 2, wrap_mode, "GtkWrapMode");
  gtk_text_view_set_wrap_mode((GtkTextView*)s7_c_pointer(text_view), (GtkWrapMode)s7_integer(wrap_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_wrap_mode "GtkWrapMode gtk_text_view_get_wrap_mode(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_wrap_mode", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_wrap_mode((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_editable "void gtk_text_view_set_editable(GtkTextView* text_view, gboolean setting)"
  s7_pointer _p;
  s7_pointer text_view, setting;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_editable", 1, text_view, "GtkTextView*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_editable", 2, setting, "gboolean");
  gtk_text_view_set_editable((GtkTextView*)s7_c_pointer(text_view), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_editable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_editable "gboolean gtk_text_view_get_editable(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_editable", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_editable((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_pixels_above_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_pixels_above_lines "void gtk_text_view_set_pixels_above_lines(GtkTextView* text_view, \
gint pixels_above_lines)"
  s7_pointer _p;
  s7_pointer text_view, pixels_above_lines;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_above_lines", 1, text_view, "GtkTextView*");
  pixels_above_lines = s7_car(_p);
  if (!s7_is_integer(pixels_above_lines)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_above_lines", 2, pixels_above_lines, "gint");
  gtk_text_view_set_pixels_above_lines((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(pixels_above_lines));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_pixels_above_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_pixels_above_lines "gint gtk_text_view_get_pixels_above_lines(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_pixels_above_lines", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_pixels_above_lines((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_pixels_below_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_pixels_below_lines "void gtk_text_view_set_pixels_below_lines(GtkTextView* text_view, \
gint pixels_below_lines)"
  s7_pointer _p;
  s7_pointer text_view, pixels_below_lines;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_below_lines", 1, text_view, "GtkTextView*");
  pixels_below_lines = s7_car(_p);
  if (!s7_is_integer(pixels_below_lines)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_below_lines", 2, pixels_below_lines, "gint");
  gtk_text_view_set_pixels_below_lines((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(pixels_below_lines));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_pixels_below_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_pixels_below_lines "gint gtk_text_view_get_pixels_below_lines(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_pixels_below_lines", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_pixels_below_lines((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_pixels_inside_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_pixels_inside_wrap "void gtk_text_view_set_pixels_inside_wrap(GtkTextView* text_view, \
gint pixels_inside_wrap)"
  s7_pointer _p;
  s7_pointer text_view, pixels_inside_wrap;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_inside_wrap", 1, text_view, "GtkTextView*");
  pixels_inside_wrap = s7_car(_p);
  if (!s7_is_integer(pixels_inside_wrap)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_pixels_inside_wrap", 2, pixels_inside_wrap, "gint");
  gtk_text_view_set_pixels_inside_wrap((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(pixels_inside_wrap));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_pixels_inside_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_pixels_inside_wrap "gint gtk_text_view_get_pixels_inside_wrap(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_pixels_inside_wrap", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_pixels_inside_wrap((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_justification(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_justification "void gtk_text_view_set_justification(GtkTextView* text_view, \
GtkJustification justification)"
  s7_pointer _p;
  s7_pointer text_view, justification;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_justification", 1, text_view, "GtkTextView*");
  justification = s7_car(_p);
  if (!s7_is_integer(justification)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_justification", 2, justification, "GtkJustification");
  gtk_text_view_set_justification((GtkTextView*)s7_c_pointer(text_view), (GtkJustification)s7_integer(justification));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_justification(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_justification "GtkJustification gtk_text_view_get_justification(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_justification", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_justification((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_left_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_left_margin "void gtk_text_view_set_left_margin(GtkTextView* text_view, \
gint left_margin)"
  s7_pointer _p;
  s7_pointer text_view, left_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_left_margin", 1, text_view, "GtkTextView*");
  left_margin = s7_car(_p);
  if (!s7_is_integer(left_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_left_margin", 2, left_margin, "gint");
  gtk_text_view_set_left_margin((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(left_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_left_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_left_margin "gint gtk_text_view_get_left_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_left_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_left_margin((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_right_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_right_margin "void gtk_text_view_set_right_margin(GtkTextView* text_view, \
gint right_margin)"
  s7_pointer _p;
  s7_pointer text_view, right_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_right_margin", 1, text_view, "GtkTextView*");
  right_margin = s7_car(_p);
  if (!s7_is_integer(right_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_right_margin", 2, right_margin, "gint");
  gtk_text_view_set_right_margin((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(right_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_right_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_right_margin "gint gtk_text_view_get_right_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_right_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_right_margin((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_indent "void gtk_text_view_set_indent(GtkTextView* text_view, gint indent)"
  s7_pointer _p;
  s7_pointer text_view, indent;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_indent", 1, text_view, "GtkTextView*");
  indent = s7_car(_p);
  if (!s7_is_integer(indent)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_indent", 2, indent, "gint");
  gtk_text_view_set_indent((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(indent));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_indent "gint gtk_text_view_get_indent(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_indent", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_indent((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_tabs "void gtk_text_view_set_tabs(GtkTextView* text_view, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer text_view, tabs;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_tabs", 1, text_view, "GtkTextView*");
  tabs = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) && (tabs != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_tabs", 2, tabs, "PangoTabArray*");
  gtk_text_view_set_tabs((GtkTextView*)s7_c_pointer(text_view), (PangoTabArray*)s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_tabs "PangoTabArray* gtk_text_view_get_tabs(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_tabs", 1, text_view, "GtkTextView*");
  return(lg_make_c_pointer_with_type(sc, PangoTabArray__sym, gtk_text_view_get_tabs((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_toggle_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_new "GtkWidget* gtk_toggle_button_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_toggle_button_new()));
}

static s7_pointer lg_gtk_toggle_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_new_with_label "GtkWidget* gtk_toggle_button_new_with_label(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_new_with_label", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_toggle_button_new_with_label((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_toggle_button_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_new_with_mnemonic "GtkWidget* gtk_toggle_button_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_new_with_mnemonic", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_toggle_button_new_with_mnemonic((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_toggle_button_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_set_active "void gtk_toggle_button_set_active(GtkToggleButton* toggle_button, \
gboolean is_active)"
  s7_pointer _p;
  s7_pointer toggle_button, is_active;
  _p = args;
  toggle_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle_button, GtkToggleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_set_active", 1, toggle_button, "GtkToggleButton*");
  is_active = s7_car(_p);
  if (!s7_is_boolean(is_active)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_set_active", 2, is_active, "gboolean");
  gtk_toggle_button_set_active((GtkToggleButton*)s7_c_pointer(toggle_button), (gboolean)lg_boolean(is_active));
  return(lg_false);
}

static s7_pointer lg_gtk_toggle_button_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_get_active "gboolean gtk_toggle_button_get_active(GtkToggleButton* toggle_button)"
  s7_pointer toggle_button;
  toggle_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle_button, GtkToggleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_get_active", 1, toggle_button, "GtkToggleButton*");
  return(s7_make_boolean(sc, gtk_toggle_button_get_active((GtkToggleButton*)s7_c_pointer(toggle_button))));
}

static s7_pointer lg_gtk_toggle_button_toggled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toggle_button_toggled "void gtk_toggle_button_toggled(GtkToggleButton* toggle_button)"
  s7_pointer toggle_button;
  toggle_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle_button, GtkToggleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_toggle_button_toggled", 1, toggle_button, "GtkToggleButton*");
  gtk_toggle_button_toggled((GtkToggleButton*)s7_c_pointer(toggle_button));
  return(lg_false);
}

static s7_pointer lg_gtk_toolbar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_toolbar_new "GtkWidget* gtk_toolbar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_toolbar_new()));
}

static s7_pointer lg_gtk_tree_drag_source_row_draggable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_source_row_draggable "gboolean gtk_tree_drag_source_row_draggable(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer drag_source, path;
  _p = args;
  drag_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_source, GtkTreeDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_row_draggable", 1, drag_source, "GtkTreeDragSource*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_row_draggable", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_drag_source_row_draggable((GtkTreeDragSource*)s7_c_pointer(drag_source), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_drag_source_drag_data_delete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_source_drag_data_delete "gboolean gtk_tree_drag_source_drag_data_delete(GtkTreeDragSource* drag_source, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer drag_source, path;
  _p = args;
  drag_source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_source, GtkTreeDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_delete", 1, drag_source, "GtkTreeDragSource*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_source_drag_data_delete", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_drag_source_drag_data_delete((GtkTreeDragSource*)s7_c_pointer(drag_source), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_new "GtkTreePath* gtk_tree_path_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_path_new()));
}

static s7_pointer lg_gtk_tree_path_new_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_new_from_string "GtkTreePath* gtk_tree_path_new_from_string(gchar* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_tree_path_new_from_string", 1, path, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_path_new_from_string((gchar*)s7_string(path))));
}

static s7_pointer lg_gtk_tree_path_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_to_string "gchar* gtk_tree_path_to_string(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_to_string", 1, path, "GtkTreePath*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_tree_path_to_string((GtkTreePath*)s7_c_pointer(path));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_tree_path_new_first(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_new_first "GtkTreePath* gtk_tree_path_new_first( void)"
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_path_new_first()));
}

static s7_pointer lg_gtk_tree_path_append_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_append_index "void gtk_tree_path_append_index(GtkTreePath* path, gint index)"
  s7_pointer _p;
  s7_pointer path, index;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_append_index", 1, path, "GtkTreePath*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tree_path_append_index", 2, index, "gint");
  gtk_tree_path_append_index((GtkTreePath*)s7_c_pointer(path), (gint)s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_prepend_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_prepend_index "void gtk_tree_path_prepend_index(GtkTreePath* path, gint index)"
  s7_pointer _p;
  s7_pointer path, index;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_prepend_index", 1, path, "GtkTreePath*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tree_path_prepend_index", 2, index, "gint");
  gtk_tree_path_prepend_index((GtkTreePath*)s7_c_pointer(path), (gint)s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_get_depth(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_get_depth "gint gtk_tree_path_get_depth(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_get_depth", 1, path, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_tree_path_get_depth((GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_get_indices(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_get_indices "gint* gtk_tree_path_get_indices(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_get_indices", 1, path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, gint__sym, gtk_tree_path_get_indices((GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_free "void gtk_tree_path_free(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_free", 1, path, "GtkTreePath*");
  gtk_tree_path_free((GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_copy "GtkTreePath* gtk_tree_path_copy(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_copy", 1, path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_path_copy((GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_compare(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_compare "gint gtk_tree_path_compare(GtkTreePath* a, GtkTreePath* b)"
  s7_pointer _p;
  s7_pointer a, b;
  _p = args;
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_compare", 1, a, "GtkTreePath*");
  b = s7_car(_p);
  if (!s7_is_c_pointer_of_type(b, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_compare", 2, b, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_tree_path_compare((GtkTreePath*)s7_c_pointer(a), (GtkTreePath*)s7_c_pointer(b))));
}

static s7_pointer lg_gtk_tree_path_next(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_next "void gtk_tree_path_next(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_next", 1, path, "GtkTreePath*");
  gtk_tree_path_next((GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_prev(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_prev "gboolean gtk_tree_path_prev(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_prev", 1, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_prev((GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_up(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_up "gboolean gtk_tree_path_up(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_up", 1, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_up((GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_path_down(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_down "void gtk_tree_path_down(GtkTreePath* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_down", 1, path, "GtkTreePath*");
  gtk_tree_path_down((GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_path_is_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_is_ancestor "gboolean gtk_tree_path_is_ancestor(GtkTreePath* path, GtkTreePath* descendant)"
  s7_pointer _p;
  s7_pointer path, descendant;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_ancestor", 1, path, "GtkTreePath*");
  descendant = s7_car(_p);
  if (!s7_is_c_pointer_of_type(descendant, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_ancestor", 2, descendant, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_is_ancestor((GtkTreePath*)s7_c_pointer(path), (GtkTreePath*)s7_c_pointer(descendant))));
}

static s7_pointer lg_gtk_tree_path_is_descendant(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_path_is_descendant "gboolean gtk_tree_path_is_descendant(GtkTreePath* path, GtkTreePath* ancestor)"
  s7_pointer _p;
  s7_pointer path, ancestor;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_descendant", 1, path, "GtkTreePath*");
  ancestor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(ancestor, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_path_is_descendant", 2, ancestor, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_path_is_descendant((GtkTreePath*)s7_c_pointer(path), (GtkTreePath*)s7_c_pointer(ancestor))));
}

static s7_pointer lg_gtk_tree_row_reference_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_new "GtkTreeRowReference* gtk_tree_row_reference_new(GtkTreeModel* model, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer model, path;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new", 1, model, "GtkTreeModel*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new", 2, path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeRowReference__sym, gtk_tree_row_reference_new((GtkTreeModel*)s7_c_pointer(model), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_row_reference_new_proxy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_new_proxy "GtkTreeRowReference* gtk_tree_row_reference_new_proxy(GObject* proxy, \
GtkTreeModel* model, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer proxy, model, path;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new_proxy", 1, proxy, "GObject*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new_proxy", 2, model, "GtkTreeModel*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_new_proxy", 3, path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeRowReference__sym, gtk_tree_row_reference_new_proxy((GObject*)s7_c_pointer(proxy), (GtkTreeModel*)s7_c_pointer(model), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_row_reference_get_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_get_path "GtkTreePath* gtk_tree_row_reference_get_path(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_get_path", 1, reference, "GtkTreeRowReference*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_row_reference_get_path((GtkTreeRowReference*)s7_c_pointer(reference))));
}

static s7_pointer lg_gtk_tree_row_reference_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_valid "gboolean gtk_tree_row_reference_valid(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_valid", 1, reference, "GtkTreeRowReference*");
  return(s7_make_boolean(sc, gtk_tree_row_reference_valid((GtkTreeRowReference*)s7_c_pointer(reference))));
}

static s7_pointer lg_gtk_tree_row_reference_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_free "void gtk_tree_row_reference_free(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_free", 1, reference, "GtkTreeRowReference*");
  gtk_tree_row_reference_free((GtkTreeRowReference*)s7_c_pointer(reference));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_inserted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_inserted "void gtk_tree_row_reference_inserted(GObject* proxy, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer proxy, path;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_inserted", 1, proxy, "GObject*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_inserted", 2, path, "GtkTreePath*");
  gtk_tree_row_reference_inserted((GObject*)s7_c_pointer(proxy), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_deleted "void gtk_tree_row_reference_deleted(GObject* proxy, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer proxy, path;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_deleted", 1, proxy, "GObject*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_deleted", 2, path, "GtkTreePath*");
  gtk_tree_row_reference_deleted((GObject*)s7_c_pointer(proxy), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_reordered(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_reordered "void gtk_tree_row_reference_reordered(GObject* proxy, GtkTreePath* path, \
GtkTreeIter* iter, gint* new_order)"
  s7_pointer _p;
  s7_pointer proxy, path, iter, new_order;
  _p = args;
  proxy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(proxy, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 1, proxy, "GObject*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 3, iter, "GtkTreeIter*");
  new_order = s7_car(_p);
  if (!s7_is_c_pointer_of_type(new_order, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_reordered", 4, new_order, "gint*");
  gtk_tree_row_reference_reordered((GObject*)s7_c_pointer(proxy), (GtkTreePath*)s7_c_pointer(path), (GtkTreeIter*)s7_c_pointer(iter), (gint*)s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_iter_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_iter_copy "GtkTreeIter* gtk_tree_iter_copy(GtkTreeIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_iter_copy", 1, iter, "GtkTreeIter*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeIter__sym, gtk_tree_iter_copy((GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_iter_free "void gtk_tree_iter_free(GtkTreeIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_iter_free", 1, iter, "GtkTreeIter*");
  gtk_tree_iter_free((GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_get_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_flags "GtkTreeModelFlags gtk_tree_model_get_flags(GtkTreeModel* tree_model)"
  s7_pointer tree_model;
  tree_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_flags", 1, tree_model, "GtkTreeModel*");
  return(s7_make_integer(sc, gtk_tree_model_get_flags((GtkTreeModel*)s7_c_pointer(tree_model))));
}

static s7_pointer lg_gtk_tree_model_get_n_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_n_columns "gint gtk_tree_model_get_n_columns(GtkTreeModel* tree_model)"
  s7_pointer tree_model;
  tree_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_n_columns", 1, tree_model, "GtkTreeModel*");
  return(s7_make_integer(sc, gtk_tree_model_get_n_columns((GtkTreeModel*)s7_c_pointer(tree_model))));
}

static s7_pointer lg_gtk_tree_model_get_column_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_column_type "GType gtk_tree_model_get_column_type(GtkTreeModel* tree_model, \
gint index)"
  s7_pointer _p;
  s7_pointer tree_model, index;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_column_type", 1, tree_model, "GtkTreeModel*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_column_type", 2, index, "gint");
  return(s7_make_integer(sc, gtk_tree_model_get_column_type((GtkTreeModel*)s7_c_pointer(tree_model), (gint)s7_integer(index))));
}

static s7_pointer lg_gtk_tree_model_get_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_iter "gboolean gtk_tree_model_get_iter(GtkTreeModel* tree_model, GtkTreeIter* iter, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_model, iter, path;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter", 2, iter, "GtkTreeIter*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter", 3, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_model_get_iter((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_model_get_iter_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_iter_from_string "gboolean gtk_tree_model_get_iter_from_string(GtkTreeModel* tree_model, \
GtkTreeIter* iter, gchar* path_string)"
  s7_pointer _p;
  s7_pointer tree_model, iter, path_string;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_from_string", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_from_string", 2, iter, "GtkTreeIter*");
  path_string = s7_car(_p);
  if (!s7_is_string(path_string)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_from_string", 3, path_string, "gchar*");
  return(s7_make_boolean(sc, gtk_tree_model_get_iter_from_string((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter), (gchar*)s7_string(path_string))));
}

static s7_pointer lg_gtk_tree_model_get_iter_first(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_iter_first "gboolean gtk_tree_model_get_iter_first(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_first", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_iter_first", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_get_iter_first((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_get_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_path "GtkTreePath* gtk_tree_model_get_path(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_path", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_path", 2, iter, "GtkTreeIter*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_model_get_path((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_next(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_next "gboolean gtk_tree_model_iter_next(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_next", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_next", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_next((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_children "gboolean gtk_tree_model_iter_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent)"
  s7_pointer _p;
  s7_pointer tree_model, iter, parent;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_children", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_children", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_children", 3, parent, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_children((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent))));
}

static s7_pointer lg_gtk_tree_model_iter_has_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_has_child "gboolean gtk_tree_model_iter_has_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_has_child", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_has_child", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_has_child((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_n_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_n_children "gint gtk_tree_model_iter_n_children(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_n_children", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) && (iter != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_n_children", 2, iter, "GtkTreeIter*");
  return(s7_make_integer(sc, gtk_tree_model_iter_n_children((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_model_iter_nth_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_nth_child "gboolean gtk_tree_model_iter_nth_child(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* parent, gint n)"
  s7_pointer _p;
  s7_pointer tree_model, iter, parent, n;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 3, parent, "GtkTreeIter*");
  n = s7_car(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_nth_child", 4, n, "gint");
  return(s7_make_boolean(sc, gtk_tree_model_iter_nth_child((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent), (gint)s7_integer(n))));
}

static s7_pointer lg_gtk_tree_model_iter_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_parent "gboolean gtk_tree_model_iter_parent(GtkTreeModel* tree_model, \
GtkTreeIter* iter, GtkTreeIter* child)"
  s7_pointer _p;
  s7_pointer tree_model, iter, child;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_parent", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_parent", 2, iter, "GtkTreeIter*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_parent", 3, child, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_parent((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_tree_model_ref_node(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_ref_node "void gtk_tree_model_ref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_ref_node", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_ref_node", 2, iter, "GtkTreeIter*");
  gtk_tree_model_ref_node((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_unref_node(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_unref_node "void gtk_tree_model_unref_node(GtkTreeModel* tree_model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_unref_node", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_unref_node", 2, iter, "GtkTreeIter*");
  gtk_tree_model_unref_node((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_foreach "void gtk_tree_model_foreach(GtkTreeModel* model, GtkTreeModelForeachFunc func, \
lambda_data func_info)"
  s7_pointer _p;
  s7_pointer model, func, func_info;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_foreach", 1, model, "GtkTreeModel*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_tree_model_foreach((GtkTreeModel*)s7_c_pointer(model), lg_model_func, (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_model_row_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_changed "void gtk_tree_model_row_changed(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_changed", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_changed", 2, path, "GtkTreePath*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_changed", 3, iter, "GtkTreeIter*");
  gtk_tree_model_row_changed((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreePath*)s7_c_pointer(path), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_row_inserted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_inserted "void gtk_tree_model_row_inserted(GtkTreeModel* tree_model, GtkTreePath* path, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_inserted", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_inserted", 2, path, "GtkTreePath*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_inserted", 3, iter, "GtkTreeIter*");
  gtk_tree_model_row_inserted((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreePath*)s7_c_pointer(path), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_row_has_child_toggled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_has_child_toggled "void gtk_tree_model_row_has_child_toggled(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_has_child_toggled", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_has_child_toggled", 2, path, "GtkTreePath*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_has_child_toggled", 3, iter, "GtkTreeIter*");
  gtk_tree_model_row_has_child_toggled((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreePath*)s7_c_pointer(path), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_row_deleted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_row_deleted "void gtk_tree_model_row_deleted(GtkTreeModel* tree_model, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_model, path;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_deleted", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_row_deleted", 2, path, "GtkTreePath*");
  gtk_tree_model_row_deleted((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_rows_reordered(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_rows_reordered "void gtk_tree_model_rows_reordered(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter, new_order;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 3, iter, "GtkTreeIter*");
  new_order = s7_car(_p);
  if (!s7_is_c_pointer_of_type(new_order, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered", 4, new_order, "gint*");
  gtk_tree_model_rows_reordered((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreePath*)s7_c_pointer(path), (GtkTreeIter*)s7_c_pointer(iter), (gint*)s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_new_with_model "GtkTreeModel* gtk_tree_model_sort_new_with_model(GtkTreeModel* child_model)"
  s7_pointer child_model;
  child_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(child_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_new_with_model", 1, child_model, "GtkTreeModel*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_tree_model_sort_new_with_model((GtkTreeModel*)s7_c_pointer(child_model))));
}

static s7_pointer lg_gtk_tree_model_sort_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_get_model "GtkTreeModel* gtk_tree_model_sort_get_model(GtkTreeModelSort* tree_model)"
  s7_pointer tree_model;
  tree_model = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_get_model", 1, tree_model, "GtkTreeModelSort*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_tree_model_sort_get_model((GtkTreeModelSort*)s7_c_pointer(tree_model))));
}

static s7_pointer lg_gtk_tree_model_sort_convert_child_path_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_child_path_to_path "GtkTreePath* gtk_tree_model_sort_convert_child_path_to_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* child_path)"
  s7_pointer _p;
  s7_pointer tree_model_sort, child_path;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_path_to_path", 1, tree_model_sort, "GtkTreeModelSort*");
  child_path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_path_to_path", 2, child_path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_model_sort_convert_child_path_to_path((GtkTreeModelSort*)s7_c_pointer(tree_model_sort), (GtkTreePath*)s7_c_pointer(child_path))));
}

static s7_pointer lg_gtk_tree_model_sort_convert_child_iter_to_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_child_iter_to_iter "void gtk_tree_model_sort_convert_child_iter_to_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* sort_iter, GtkTreeIter* child_iter)"
  s7_pointer _p;
  s7_pointer tree_model_sort, sort_iter, child_iter;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", 1, tree_model_sort, "GtkTreeModelSort*");
  sort_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sort_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", 2, sort_iter, "GtkTreeIter*");
  child_iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", 3, child_iter, "GtkTreeIter*");
  gtk_tree_model_sort_convert_child_iter_to_iter((GtkTreeModelSort*)s7_c_pointer(tree_model_sort), (GtkTreeIter*)s7_c_pointer(sort_iter), (GtkTreeIter*)s7_c_pointer(child_iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_convert_path_to_child_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_path_to_child_path "GtkTreePath* gtk_tree_model_sort_convert_path_to_child_path(GtkTreeModelSort* tree_model_sort, \
GtkTreePath* sorted_path)"
  s7_pointer _p;
  s7_pointer tree_model_sort, sorted_path;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_path_to_child_path", 1, tree_model_sort, "GtkTreeModelSort*");
  sorted_path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sorted_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_path_to_child_path", 2, sorted_path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_model_sort_convert_path_to_child_path((GtkTreeModelSort*)s7_c_pointer(tree_model_sort), (GtkTreePath*)s7_c_pointer(sorted_path))));
}

static s7_pointer lg_gtk_tree_model_sort_convert_iter_to_child_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_convert_iter_to_child_iter "void gtk_tree_model_sort_convert_iter_to_child_iter(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* child_iter, GtkTreeIter* sorted_iter)"
  s7_pointer _p;
  s7_pointer tree_model_sort, child_iter, sorted_iter;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", 1, tree_model_sort, "GtkTreeModelSort*");
  child_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", 2, child_iter, "GtkTreeIter*");
  sorted_iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sorted_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", 3, sorted_iter, "GtkTreeIter*");
  gtk_tree_model_sort_convert_iter_to_child_iter((GtkTreeModelSort*)s7_c_pointer(tree_model_sort), (GtkTreeIter*)s7_c_pointer(child_iter), (GtkTreeIter*)s7_c_pointer(sorted_iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_reset_default_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_reset_default_sort_func "void gtk_tree_model_sort_reset_default_sort_func(GtkTreeModelSort* tree_model_sort)"
  s7_pointer tree_model_sort;
  tree_model_sort = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_reset_default_sort_func", 1, tree_model_sort, "GtkTreeModelSort*");
  gtk_tree_model_sort_reset_default_sort_func((GtkTreeModelSort*)s7_c_pointer(tree_model_sort));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_sort_clear_cache(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_clear_cache "void gtk_tree_model_sort_clear_cache(GtkTreeModelSort* tree_model_sort)"
  s7_pointer tree_model_sort;
  tree_model_sort = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_clear_cache", 1, tree_model_sort, "GtkTreeModelSort*");
  gtk_tree_model_sort_clear_cache((GtkTreeModelSort*)s7_c_pointer(tree_model_sort));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_set_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_set_mode "void gtk_tree_selection_set_mode(GtkTreeSelection* selection, \
GtkSelectionMode type)"
  s7_pointer _p;
  s7_pointer selection, type;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_mode", 1, selection, "GtkTreeSelection*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_mode", 2, type, "GtkSelectionMode");
  gtk_tree_selection_set_mode((GtkTreeSelection*)s7_c_pointer(selection), (GtkSelectionMode)s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_get_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_mode "GtkSelectionMode gtk_tree_selection_get_mode(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_mode", 1, selection, "GtkTreeSelection*");
  return(s7_make_integer(sc, gtk_tree_selection_get_mode((GtkTreeSelection*)s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tree_selection_set_select_function(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_set_select_function "void gtk_tree_selection_set_select_function(GtkTreeSelection* selection, \
GtkTreeSelectionFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer selection, func, func_info, destroy;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_set_select_function", 1, selection, "GtkTreeSelection*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_selection_set_select_function((GtkTreeSelection*)s7_c_pointer(selection), lg_tree_selection, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_selection_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_user_data "gpointer gtk_tree_selection_get_user_data(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_user_data", 1, selection, "GtkTreeSelection*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gtk_tree_selection_get_user_data((GtkTreeSelection*)s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tree_selection_get_tree_view(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_tree_view "GtkTreeView* gtk_tree_selection_get_tree_view(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_tree_view", 1, selection, "GtkTreeSelection*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeView__sym, gtk_tree_selection_get_tree_view((GtkTreeSelection*)s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_tree_selection_get_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_selected "gboolean gtk_tree_selection_get_selected(GtkTreeSelection* selection, \
GtkTreeModel** model, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, model, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected", 1, selection, "GtkTreeSelection*");
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel___sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected", 2, model, "GtkTreeModel**");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected", 3, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_selection_get_selected((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreeModel**)s7_c_pointer(model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_selection_selected_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_selected_foreach "void gtk_tree_selection_selected_foreach(GtkTreeSelection* selection, \
GtkTreeSelectionForeachFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer selection, func, func_info;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_selected_foreach", 1, selection, "GtkTreeSelection*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_tree_selection_selected_foreach((GtkTreeSelection*)s7_c_pointer(selection), lg_tree_selection_func, (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_selection_select_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_path "void gtk_tree_selection_select_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection, path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_path", 1, selection, "GtkTreeSelection*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_path", 2, path, "GtkTreePath*");
  gtk_tree_selection_select_path((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_unselect_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_unselect_path "void gtk_tree_selection_unselect_path(GtkTreeSelection* selection, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection, path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_path", 1, selection, "GtkTreeSelection*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_path", 2, path, "GtkTreePath*");
  gtk_tree_selection_unselect_path((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_select_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_iter "void gtk_tree_selection_select_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_iter", 1, selection, "GtkTreeSelection*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_iter", 2, iter, "GtkTreeIter*");
  gtk_tree_selection_select_iter((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_unselect_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_unselect_iter "void gtk_tree_selection_unselect_iter(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_iter", 1, selection, "GtkTreeSelection*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_iter", 2, iter, "GtkTreeIter*");
  gtk_tree_selection_unselect_iter((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_path_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_path_is_selected "gboolean gtk_tree_selection_path_is_selected(GtkTreeSelection* selection, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer selection, path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_path_is_selected", 1, selection, "GtkTreeSelection*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_path_is_selected", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_selection_path_is_selected((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_selection_iter_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_iter_is_selected "gboolean gtk_tree_selection_iter_is_selected(GtkTreeSelection* selection, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer selection, iter;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_iter_is_selected", 1, selection, "GtkTreeSelection*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_iter_is_selected", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_selection_iter_is_selected((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_selection_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_all "void gtk_tree_selection_select_all(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_all", 1, selection, "GtkTreeSelection*");
  gtk_tree_selection_select_all((GtkTreeSelection*)s7_c_pointer(selection));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_unselect_all "void gtk_tree_selection_unselect_all(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_unselect_all", 1, selection, "GtkTreeSelection*");
  gtk_tree_selection_unselect_all((GtkTreeSelection*)s7_c_pointer(selection));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_select_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_select_range "void gtk_tree_selection_select_range(GtkTreeSelection* selection, \
GtkTreePath* start_path, GtkTreePath* end_path)"
  s7_pointer _p;
  s7_pointer selection, start_path, end_path;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_range", 1, selection, "GtkTreeSelection*");
  start_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(start_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_range", 2, start_path, "GtkTreePath*");
  end_path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(end_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_select_range", 3, end_path, "GtkTreePath*");
  gtk_tree_selection_select_range((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreePath*)s7_c_pointer(start_path), (GtkTreePath*)s7_c_pointer(end_path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_sortable_sort_column_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_sort_column_changed "void gtk_tree_sortable_sort_column_changed(GtkTreeSortable* sortable)"
  s7_pointer sortable;
  sortable = s7_car(args);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_sort_column_changed", 1, sortable, "GtkTreeSortable*");
  gtk_tree_sortable_sort_column_changed((GtkTreeSortable*)s7_c_pointer(sortable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_sortable_get_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_get_sort_column_id "gboolean gtk_tree_sortable_get_sort_column_id(GtkTreeSortable* sortable, \
gint* [sort_column_id], GtkSortType* [order])"
  s7_pointer _p;
  s7_pointer sortable;
  gint ref_sort_column_id;
  GtkSortType ref_order;
  _p = args;
  sortable = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_get_sort_column_id", 1, sortable, "GtkTreeSortable*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_sortable_get_sort_column_id((GtkTreeSortable*)s7_c_pointer(sortable), &ref_sort_column_id, &ref_order));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_sort_column_id), s7_make_integer(sc, ref_order)));
   }
}

static s7_pointer lg_gtk_tree_sortable_set_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_set_sort_column_id "void gtk_tree_sortable_set_sort_column_id(GtkTreeSortable* sortable, \
gint sort_column_id, GtkSortType order)"
  s7_pointer _p;
  s7_pointer sortable, sort_column_id, order;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_column_id", 1, sortable, "GtkTreeSortable*");
  sort_column_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sort_column_id)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_column_id", 2, sort_column_id, "gint");
  order = s7_car(_p);
  if (!s7_is_integer(order)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_column_id", 3, order, "GtkSortType");
  gtk_tree_sortable_set_sort_column_id((GtkTreeSortable*)s7_c_pointer(sortable), (gint)s7_integer(sort_column_id), (GtkSortType)s7_integer(order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_sortable_set_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_set_sort_func "void gtk_tree_sortable_set_sort_func(GtkTreeSortable* sortable, \
gint sort_column_id, GtkTreeIterCompareFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer sortable, sort_column_id, func, func_info, destroy;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 1, sortable, "GtkTreeSortable*");
  sort_column_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(sort_column_id)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_sort_func", 2, sort_column_id, "gint");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_sortable_set_sort_func((GtkTreeSortable*)s7_c_pointer(sortable), (gint)s7_integer(sort_column_id), lg_iter_compare, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_sortable_set_default_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_set_default_sort_func "void gtk_tree_sortable_set_default_sort_func(GtkTreeSortable* sortable, \
GtkTreeIterCompareFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer sortable, func, func_info, destroy;
  _p = args;
  sortable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_set_default_sort_func", 1, sortable, "GtkTreeSortable*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_sortable_set_default_sort_func((GtkTreeSortable*)s7_c_pointer(sortable), lg_iter_compare, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_sortable_has_default_sort_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_sortable_has_default_sort_func "gboolean gtk_tree_sortable_has_default_sort_func(GtkTreeSortable* sortable)"
  s7_pointer sortable;
  sortable = s7_car(args);
  if (!s7_is_c_pointer_of_type(sortable, GtkTreeSortable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_sortable_has_default_sort_func", 1, sortable, "GtkTreeSortable*");
  return(s7_make_boolean(sc, gtk_tree_sortable_has_default_sort_func((GtkTreeSortable*)s7_c_pointer(sortable))));
}

static s7_pointer lg_gtk_tree_store_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_new "GtkTreeStore* gtk_tree_store_new(gint n_columns, etc types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_tree_store_new", 1, n_columns, "gint");
  types = s7_car(_p);
  if (!lg_is_list(types)) s7_wrong_type_arg_error(sc, "gtk_tree_store_new", 2, types, "etc");
  {
    int etc_len = 0;
    GtkTreeStore* res_ult = NULL;
    gint p_arg0;
    if (s7_is_list(sc, types)) etc_len = s7_list_length(sc, types);
    if (etc_len < 1) s7_out_of_range_error(sc, "gtk_tree_store_new", 1, types, "... list must have at least 1 entry");
    if (etc_len > 6) s7_out_of_range_error(sc, "gtk_tree_store_new", 1, types, "... list too long (max len: 6)");
    p_arg0 = (gint)s7_integer(n_columns);
    switch (etc_len)
      {
        case 1: res_ult = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0))); break;
        case 2: res_ult = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1))); break;
        case 3: res_ult = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2))); break;
        case 4: res_ult = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3))); break;
        case 5: res_ult = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4))); break;
        case 6: res_ult = gtk_tree_store_new(p_arg0, s7_c_pointer(s7_list_ref(sc, types, 0)), s7_c_pointer(s7_list_ref(sc, types, 1)), s7_c_pointer(s7_list_ref(sc, types, 2)), s7_c_pointer(s7_list_ref(sc, types, 3)), s7_c_pointer(s7_list_ref(sc, types, 4)), s7_c_pointer(s7_list_ref(sc, types, 5))); break;
      }
    return(s7_make_c_pointer(sc, res_ult));
  }
}

static s7_pointer lg_gtk_tree_store_newv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_newv "GtkTreeStore* gtk_tree_store_newv(gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer n_columns, types;
  _p = args;
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_tree_store_newv", 1, n_columns, "gint");
  types = s7_car(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_newv", 2, types, "GType*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeStore__sym, gtk_tree_store_newv((gint)s7_integer(n_columns), (GType*)s7_c_pointer(types))));
}

static s7_pointer lg_gtk_tree_store_set_column_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_set_column_types "void gtk_tree_store_set_column_types(GtkTreeStore* tree_store, \
gint n_columns, GType* types)"
  s7_pointer _p;
  s7_pointer tree_store, n_columns, types;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set_column_types", 1, tree_store, "GtkTreeStore*");
  n_columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_columns)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set_column_types", 2, n_columns, "gint");
  types = s7_car(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set_column_types", 3, types, "GType*");
  gtk_tree_store_set_column_types((GtkTreeStore*)s7_c_pointer(tree_store), (gint)s7_integer(n_columns), (GType*)s7_c_pointer(types));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_set "void gtk_tree_store_set(GtkTreeStore* tree_store, GtkTreeIter* iter, \
etc values)"
  s7_pointer _p;
  s7_pointer tree_store, iter, values;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set", 2, iter, "GtkTreeIter*");
  values = s7_car(_p);
  if (!lg_is_list(values)) s7_wrong_type_arg_error(sc, "gtk_tree_store_set", 3, values, "etc");
  {
    int etc_len = 0;
    GtkTreeStore* p_arg0;
    GtkTreeIter* p_arg1;
    if (s7_is_list(sc, values)) etc_len = s7_list_length(sc, values);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_store_set", 2, values, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_store_set", 2, values, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_store_set", 2, values, "... list len must be multiple of 2");
    p_arg0 = (GtkTreeStore*)s7_c_pointer(tree_store);
    p_arg1 = (GtkTreeIter*)s7_c_pointer(iter);
    switch (etc_len)
      {
        case 2: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), -1); break;
        case 4: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), -1); break;
        case 6: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), -1); break;
        case 8: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), -1); break;
        case 10: gtk_tree_store_set(p_arg0, p_arg1, s7_integer(s7_list_ref(sc, values, 0)), s7_string(s7_list_ref(sc, values, 1)), s7_integer(s7_list_ref(sc, values, 2)), s7_string(s7_list_ref(sc, values, 3)), s7_integer(s7_list_ref(sc, values, 4)), s7_string(s7_list_ref(sc, values, 5)), s7_integer(s7_list_ref(sc, values, 6)), s7_string(s7_list_ref(sc, values, 7)), s7_integer(s7_list_ref(sc, values, 8)), s7_string(s7_list_ref(sc, values, 9)), -1); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_tree_store_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_remove "void gtk_tree_store_remove(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_store, iter;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_remove", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_remove", 2, iter, "GtkTreeIter*");
  gtk_tree_store_remove((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_insert "void gtk_tree_store_insert(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, gint position)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent, position;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 3, parent, "GtkTreeIter*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert", 4, position, "gint");
  gtk_tree_store_insert((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_insert_before "void gtk_tree_store_insert_before(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* parent, GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent, sibling;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 3, parent, "GtkTreeIter*");
  sibling = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_before", 4, sibling, "GtkTreeIter*");
  gtk_tree_store_insert_before((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent), (GtkTreeIter*)s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_insert_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_insert_after "void gtk_tree_store_insert_after(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent, GtkTreeIter* sibling)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent, sibling;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 3, parent, "GtkTreeIter*");
  sibling = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(sibling, GtkTreeIter__sym)) && (sibling != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_insert_after", 4, sibling, "GtkTreeIter*");
  gtk_tree_store_insert_after((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent), (GtkTreeIter*)s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_prepend "void gtk_tree_store_prepend(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_prepend", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_prepend", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_prepend", 3, parent, "GtkTreeIter*");
  gtk_tree_store_prepend((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_append "void gtk_tree_store_append(GtkTreeStore* tree_store, GtkTreeIter* iter, \
GtkTreeIter* parent)"
  s7_pointer _p;
  s7_pointer tree_store, iter, parent;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_append", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_append", 2, iter, "GtkTreeIter*");
  parent = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_store_append", 3, parent, "GtkTreeIter*");
  gtk_tree_store_append((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_is_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_is_ancestor "gboolean gtk_tree_store_is_ancestor(GtkTreeStore* tree_store, \
GtkTreeIter* iter, GtkTreeIter* descendant)"
  s7_pointer _p;
  s7_pointer tree_store, iter, descendant;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_is_ancestor", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_is_ancestor", 2, iter, "GtkTreeIter*");
  descendant = s7_car(_p);
  if (!s7_is_c_pointer_of_type(descendant, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_is_ancestor", 3, descendant, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_store_is_ancestor((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(descendant))));
}

static s7_pointer lg_gtk_tree_store_iter_depth(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_iter_depth "gint gtk_tree_store_iter_depth(GtkTreeStore* tree_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_store, iter;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_iter_depth", 1, tree_store, "GtkTreeStore*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_iter_depth", 2, iter, "GtkTreeIter*");
  return(s7_make_integer(sc, gtk_tree_store_iter_depth((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_store_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_clear "void gtk_tree_store_clear(GtkTreeStore* tree_store)"
  s7_pointer tree_store;
  tree_store = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_clear", 1, tree_store, "GtkTreeStore*");
  gtk_tree_store_clear((GtkTreeStore*)s7_c_pointer(tree_store));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_new "GtkTreeViewColumn* gtk_tree_view_column_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkTreeViewColumn__sym, gtk_tree_view_column_new()));
}

static s7_pointer lg_gtk_tree_view_column_new_with_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_new_with_attributes "GtkTreeViewColumn* gtk_tree_view_column_new_with_attributes(gchar* title, \
GtkCellRenderer* cell, etc attributes)"
  s7_pointer _p;
  s7_pointer title, cell, attributes;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_attributes", 1, title, "gchar*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_attributes", 2, cell, "GtkCellRenderer*");
  attributes = s7_car(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_attributes", 3, attributes, "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* res_ult = NULL;
    gchar* p_arg0;
    GtkCellRenderer* p_arg1;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_view_column_new_with_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_view_column_new_with_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_view_column_new_with_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = (gchar*)s7_string(title);
    p_arg1 = (GtkCellRenderer*)s7_c_pointer(cell);
    switch (etc_len)
      {
        case 2: res_ult = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: res_ult = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: res_ult = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: res_ult = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: res_ult = gtk_tree_view_column_new_with_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(s7_make_c_pointer(sc, res_ult));
  }
}

static s7_pointer lg_gtk_tree_view_column_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_pack_start "void gtk_tree_view_column_pack_start(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_column, cell, expand;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_start", 1, tree_column, "GtkTreeViewColumn*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_start", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_start", 3, expand, "gboolean");
  gtk_tree_view_column_pack_start((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_pack_end "void gtk_tree_view_column_pack_end(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell, gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_column, cell, expand;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_end", 1, tree_column, "GtkTreeViewColumn*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_end", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_pack_end", 3, expand, "gboolean");
  gtk_tree_view_column_pack_end((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_clear "void gtk_tree_view_column_clear(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clear", 1, tree_column, "GtkTreeViewColumn*");
  gtk_tree_view_column_clear((GtkTreeViewColumn*)s7_c_pointer(tree_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_add_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_add_attribute "void gtk_tree_view_column_add_attribute(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gchar* attribute, gint column)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer, attribute, column;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 2, cell_renderer, "GtkCellRenderer*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 3, attribute, "gchar*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_add_attribute", 4, column, "gint");
  gtk_tree_view_column_add_attribute((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell_renderer), (gchar*)s7_string(attribute), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_attributes "void gtk_tree_view_column_set_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, etc attributes)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer, attributes;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_attributes", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_attributes", 2, cell_renderer, "GtkCellRenderer*");
  attributes = s7_car(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_attributes", 3, attributes, "etc");
  {
    int etc_len = 0;
    GtkTreeViewColumn* p_arg0;
    GtkCellRenderer* p_arg1;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_view_column_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_view_column_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_view_column_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = (GtkTreeViewColumn*)s7_c_pointer(tree_column);
    p_arg1 = (GtkCellRenderer*)s7_c_pointer(cell_renderer);
    switch (etc_len)
      {
        case 2: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: gtk_tree_view_column_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_tree_view_column_set_cell_data_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_cell_data_func "void gtk_tree_view_column_set_cell_data_func(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, GtkTreeCellDataFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer, func, func_info, destroy;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_cell_data_func", 2, cell_renderer, "GtkCellRenderer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_view_column_set_cell_data_func((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell_renderer), lg_cell_data, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_view_column_clear_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_clear_attributes "void gtk_tree_view_column_clear_attributes(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer)"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clear_attributes", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clear_attributes", 2, cell_renderer, "GtkCellRenderer*");
  gtk_tree_view_column_clear_attributes((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell_renderer));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_spacing "void gtk_tree_view_column_set_spacing(GtkTreeViewColumn* tree_column, \
gint spacing)"
  s7_pointer _p;
  s7_pointer tree_column, spacing;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_spacing", 1, tree_column, "GtkTreeViewColumn*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_spacing", 2, spacing, "gint");
  gtk_tree_view_column_set_spacing((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_spacing "gint gtk_tree_view_column_get_spacing(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_spacing", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_spacing((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_visible "void gtk_tree_view_column_set_visible(GtkTreeViewColumn* tree_column, \
gboolean visible)"
  s7_pointer _p;
  s7_pointer tree_column, visible;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_visible", 1, tree_column, "GtkTreeViewColumn*");
  visible = s7_car(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_visible", 2, visible, "gboolean");
  gtk_tree_view_column_set_visible((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gboolean)lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_visible "gboolean gtk_tree_view_column_get_visible(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_visible", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_visible((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_resizable "void gtk_tree_view_column_set_resizable(GtkTreeViewColumn* tree_column, \
gboolean resizable)"
  s7_pointer _p;
  s7_pointer tree_column, resizable;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_resizable", 1, tree_column, "GtkTreeViewColumn*");
  resizable = s7_car(_p);
  if (!s7_is_boolean(resizable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_resizable", 2, resizable, "gboolean");
  gtk_tree_view_column_set_resizable((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gboolean)lg_boolean(resizable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_resizable "gboolean gtk_tree_view_column_get_resizable(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_resizable", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_resizable((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sizing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sizing "void gtk_tree_view_column_set_sizing(GtkTreeViewColumn* tree_column, \
GtkTreeViewColumnSizing type)"
  s7_pointer _p;
  s7_pointer tree_column, type;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sizing", 1, tree_column, "GtkTreeViewColumn*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sizing", 2, type, "GtkTreeViewColumnSizing");
  gtk_tree_view_column_set_sizing((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkTreeViewColumnSizing)s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sizing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sizing "GtkTreeViewColumnSizing gtk_tree_view_column_get_sizing(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sizing", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_sizing((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_width "gint gtk_tree_view_column_get_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_width((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_get_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_fixed_width "gint gtk_tree_view_column_get_fixed_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_fixed_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_fixed_width((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_fixed_width "void gtk_tree_view_column_set_fixed_width(GtkTreeViewColumn* tree_column, \
gint fixed_width)"
  s7_pointer _p;
  s7_pointer tree_column, fixed_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_fixed_width", 1, tree_column, "GtkTreeViewColumn*");
  fixed_width = s7_car(_p);
  if (!s7_is_integer(fixed_width)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_fixed_width", 2, fixed_width, "gint");
  gtk_tree_view_column_set_fixed_width((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gint)s7_integer(fixed_width));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_min_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_min_width "void gtk_tree_view_column_set_min_width(GtkTreeViewColumn* tree_column, \
gint min_width)"
  s7_pointer _p;
  s7_pointer tree_column, min_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_min_width", 1, tree_column, "GtkTreeViewColumn*");
  min_width = s7_car(_p);
  if (!s7_is_integer(min_width)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_min_width", 2, min_width, "gint");
  gtk_tree_view_column_set_min_width((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gint)s7_integer(min_width));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_min_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_min_width "gint gtk_tree_view_column_get_min_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_min_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_min_width((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_max_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_max_width "void gtk_tree_view_column_set_max_width(GtkTreeViewColumn* tree_column, \
gint max_width)"
  s7_pointer _p;
  s7_pointer tree_column, max_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_max_width", 1, tree_column, "GtkTreeViewColumn*");
  max_width = s7_car(_p);
  if (!s7_is_integer(max_width)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_max_width", 2, max_width, "gint");
  gtk_tree_view_column_set_max_width((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gint)s7_integer(max_width));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_max_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_max_width "gint gtk_tree_view_column_get_max_width(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_max_width", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_max_width((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_clicked(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_clicked "void gtk_tree_view_column_clicked(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_clicked", 1, tree_column, "GtkTreeViewColumn*");
  gtk_tree_view_column_clicked((GtkTreeViewColumn*)s7_c_pointer(tree_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_title "void gtk_tree_view_column_set_title(GtkTreeViewColumn* tree_column, \
gchar* title)"
  s7_pointer _p;
  s7_pointer tree_column, title;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_title", 1, tree_column, "GtkTreeViewColumn*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_title", 2, title, "gchar*");
  gtk_tree_view_column_set_title((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_title "gchar* gtk_tree_view_column_get_title(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_title", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_string(sc, gtk_tree_view_column_get_title((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_clickable "void gtk_tree_view_column_set_clickable(GtkTreeViewColumn* tree_column, \
gboolean clickable)"
  s7_pointer _p;
  s7_pointer tree_column, clickable;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_clickable", 1, tree_column, "GtkTreeViewColumn*");
  clickable = s7_car(_p);
  if (!s7_is_boolean(clickable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_clickable", 2, clickable, "gboolean");
  gtk_tree_view_column_set_clickable((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gboolean)lg_boolean(clickable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_clickable "gboolean gtk_tree_view_column_get_clickable(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_clickable", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_clickable((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_widget "void gtk_tree_view_column_set_widget(GtkTreeViewColumn* tree_column, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer tree_column, widget;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_widget", 1, tree_column, "GtkTreeViewColumn*");
  widget = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) && (widget != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_widget", 2, widget, "GtkWidget*");
  gtk_tree_view_column_set_widget((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_widget "GtkWidget* gtk_tree_view_column_get_widget(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_widget", 1, tree_column, "GtkTreeViewColumn*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_tree_view_column_get_widget((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_alignment "void gtk_tree_view_column_set_alignment(GtkTreeViewColumn* tree_column, \
gfloat xalign)"
  s7_pointer _p;
  s7_pointer tree_column, xalign;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_alignment", 1, tree_column, "GtkTreeViewColumn*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_alignment", 2, xalign, "gfloat");
  gtk_tree_view_column_set_alignment((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gfloat)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_alignment "gfloat gtk_tree_view_column_get_alignment(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_alignment", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_real(sc, gtk_tree_view_column_get_alignment((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_reorderable "void gtk_tree_view_column_set_reorderable(GtkTreeViewColumn* tree_column, \
gboolean reorderable)"
  s7_pointer _p;
  s7_pointer tree_column, reorderable;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_reorderable", 1, tree_column, "GtkTreeViewColumn*");
  reorderable = s7_car(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_reorderable", 2, reorderable, "gboolean");
  gtk_tree_view_column_set_reorderable((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gboolean)lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_reorderable "gboolean gtk_tree_view_column_get_reorderable(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_reorderable", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_reorderable((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sort_column_id "void gtk_tree_view_column_set_sort_column_id(GtkTreeViewColumn* tree_column, \
gint sort_column_id)"
  s7_pointer _p;
  s7_pointer tree_column, sort_column_id;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_column_id", 1, tree_column, "GtkTreeViewColumn*");
  sort_column_id = s7_car(_p);
  if (!s7_is_integer(sort_column_id)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_column_id", 2, sort_column_id, "gint");
  gtk_tree_view_column_set_sort_column_id((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gint)s7_integer(sort_column_id));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sort_column_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sort_column_id "gint gtk_tree_view_column_get_sort_column_id(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sort_column_id", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_sort_column_id((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sort_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sort_indicator "void gtk_tree_view_column_set_sort_indicator(GtkTreeViewColumn* tree_column, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer tree_column, setting;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_indicator", 1, tree_column, "GtkTreeViewColumn*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_indicator", 2, setting, "gboolean");
  gtk_tree_view_column_set_sort_indicator((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sort_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sort_indicator "gboolean gtk_tree_view_column_get_sort_indicator(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sort_indicator", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_sort_indicator((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_set_sort_order(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_sort_order "void gtk_tree_view_column_set_sort_order(GtkTreeViewColumn* tree_column, \
GtkSortType order)"
  s7_pointer _p;
  s7_pointer tree_column, order;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_order", 1, tree_column, "GtkTreeViewColumn*");
  order = s7_car(_p);
  if (!s7_is_integer(order)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_sort_order", 2, order, "GtkSortType");
  gtk_tree_view_column_set_sort_order((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkSortType)s7_integer(order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_sort_order(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_sort_order "GtkSortType gtk_tree_view_column_get_sort_order(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_sort_order", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_sort_order((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_cell_set_cell_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_set_cell_data "void gtk_tree_view_column_cell_set_cell_data(GtkTreeViewColumn* tree_column, \
GtkTreeModel* tree_model, GtkTreeIter* iter, gboolean is_expander, gboolean is_expanded)"
  s7_pointer _p;
  s7_pointer tree_column, tree_model, iter, is_expander, is_expanded;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 1, tree_column, "GtkTreeViewColumn*");
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 2, tree_model, "GtkTreeModel*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 3, iter, "GtkTreeIter*");
  is_expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(is_expander)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 4, is_expander, "gboolean");
  is_expanded = s7_car(_p);
  if (!s7_is_boolean(is_expanded)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_set_cell_data", 5, is_expanded, "gboolean");
  gtk_tree_view_column_cell_set_cell_data((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter), (gboolean)lg_boolean(is_expander), (gboolean)lg_boolean(is_expanded));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_cell_is_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_is_visible "gboolean gtk_tree_view_column_cell_is_visible(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_is_visible", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_cell_is_visible((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_cell_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_get_position "gboolean gtk_tree_view_column_cell_get_position(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell_renderer, gint* [start_pos], gint* [width])"
  s7_pointer _p;
  s7_pointer tree_column, cell_renderer;
  gint ref_start_pos;
  gint ref_width;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_position", 1, tree_column, "GtkTreeViewColumn*");
  cell_renderer = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell_renderer, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_position", 2, cell_renderer, "GtkCellRenderer*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_view_column_cell_get_position((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell_renderer), &ref_start_pos, &ref_width));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_start_pos), s7_make_integer(sc, ref_width)));
   }
}

static s7_pointer lg_gtk_tree_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_new "GtkWidget* gtk_tree_view_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_tree_view_new()));
}

static s7_pointer lg_gtk_tree_view_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_new_with_model "GtkWidget* gtk_tree_view_new_with_model(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_new_with_model", 1, model, "GtkTreeModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_tree_view_new_with_model((GtkTreeModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_tree_view_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_model "GtkTreeModel* gtk_tree_view_get_model(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_model", 1, tree_view, "GtkTreeView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_tree_view_get_model((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_model "void gtk_tree_view_set_model(GtkTreeView* tree_view, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer tree_view, model;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_model", 1, tree_view, "GtkTreeView*");
  model = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_model", 2, model, "GtkTreeModel*");
  gtk_tree_view_set_model((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_selection "GtkTreeSelection* gtk_tree_view_get_selection(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_selection", 1, tree_view, "GtkTreeView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeSelection__sym, gtk_tree_view_get_selection((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_get_headers_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_headers_visible "gboolean gtk_tree_view_get_headers_visible(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_headers_visible", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_headers_visible((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_headers_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_headers_visible "void gtk_tree_view_set_headers_visible(GtkTreeView* tree_view, \
gboolean headers_visible)"
  s7_pointer _p;
  s7_pointer tree_view, headers_visible;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_visible", 1, tree_view, "GtkTreeView*");
  headers_visible = s7_car(_p);
  if (!s7_is_boolean(headers_visible)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_visible", 2, headers_visible, "gboolean");
  gtk_tree_view_set_headers_visible((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(headers_visible));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_columns_autosize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_columns_autosize "void gtk_tree_view_columns_autosize(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_columns_autosize", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_columns_autosize((GtkTreeView*)s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_headers_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_headers_clickable "void gtk_tree_view_set_headers_clickable(GtkTreeView* tree_view, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer tree_view, setting;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_clickable", 1, tree_view, "GtkTreeView*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_headers_clickable", 2, setting, "gboolean");
  gtk_tree_view_set_headers_clickable((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_append_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_append_column "gint gtk_tree_view_append_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_append_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_append_column", 2, column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_append_column((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeViewColumn*)s7_c_pointer(column))));
}

static s7_pointer lg_gtk_tree_view_remove_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_remove_column "gint gtk_tree_view_remove_column(GtkTreeView* tree_view, GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_remove_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_remove_column", 2, column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_remove_column((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeViewColumn*)s7_c_pointer(column))));
}

static s7_pointer lg_gtk_tree_view_insert_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_insert_column "gint gtk_tree_view_insert_column(GtkTreeView* tree_view, GtkTreeViewColumn* column, \
gint position)"
  s7_pointer _p;
  s7_pointer tree_view, column, position;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column", 2, column, "GtkTreeViewColumn*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column", 3, position, "gint");
  return(s7_make_integer(sc, gtk_tree_view_insert_column((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeViewColumn*)s7_c_pointer(column), (gint)s7_integer(position))));
}

static s7_pointer lg_gtk_tree_view_insert_column_with_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_insert_column_with_attributes "gint gtk_tree_view_insert_column_with_attributes(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, etc attributes)"
  s7_pointer _p;
  s7_pointer tree_view, position, title, cell, attributes;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 1, tree_view, "GtkTreeView*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 2, position, "gint");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 3, title, "gchar*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, cell, "GtkCellRenderer*");
  attributes = s7_car(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_attributes", 5, attributes, "etc");
  {
    int etc_len = 0;
    gint res_ult = 0;
    GtkTreeView* p_arg0;
    gint p_arg1;
    gchar* p_arg2;
    GtkCellRenderer* p_arg3;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_tree_view_insert_column_with_attributes", 4, attributes, "... list len must be multiple of 2");
    p_arg0 = (GtkTreeView*)s7_c_pointer(tree_view);
    p_arg1 = (gint)s7_integer(position);
    p_arg2 = (gchar*)s7_string(title);
    p_arg3 = (GtkCellRenderer*)s7_c_pointer(cell);
    switch (etc_len)
      {
        case 2: res_ult = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: res_ult = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: res_ult = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: res_ult = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: res_ult = gtk_tree_view_insert_column_with_attributes(p_arg0, p_arg1, p_arg2, p_arg3, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(s7_make_integer(sc, res_ult));
  }
}

static s7_pointer lg_gtk_tree_view_insert_column_with_data_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_insert_column_with_data_func "gint gtk_tree_view_insert_column_with_data_func(GtkTreeView* tree_view, \
gint position, gchar* title, GtkCellRenderer* cell, GtkTreeCellDataFunc func, lambda_data func_info, \
GtkDestroyNotify dnotify)"
  s7_pointer _p;
  s7_pointer tree_view, position, title, cell, func, func_info, dnotify;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 1, tree_view, "GtkTreeView*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 2, position, "gint");
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 3, title, "gchar*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_insert_column_with_data_func", 4, cell, "GtkCellRenderer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  dnotify = s7_car(_p);
  {
    s7_pointer res_ult;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, dnotify);
    res_ult = s7_make_integer(sc, gtk_tree_view_insert_column_with_data_func((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(position), (gchar*)s7_string(title), (GtkCellRenderer*)s7_c_pointer(cell), lg_cell_data, (gpointer)lg_ptr, lg_destroy_func));
    return(res_ult);
   }
}

static s7_pointer lg_gtk_tree_view_get_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_column "GtkTreeViewColumn* gtk_tree_view_get_column(GtkTreeView* tree_view, \
gint n)"
  s7_pointer _p;
  s7_pointer tree_view, n;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_column", 1, tree_view, "GtkTreeView*");
  n = s7_car(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_column", 2, n, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkTreeViewColumn__sym, gtk_tree_view_get_column((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(n))));
}

static s7_pointer lg_gtk_tree_view_get_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_columns "GList* gtk_tree_view_get_columns(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_columns", 1, tree_view, "GtkTreeView*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_tree_view_get_columns((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_move_column_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_move_column_after "void gtk_tree_view_move_column_after(GtkTreeView* tree_view, \
GtkTreeViewColumn* column, GtkTreeViewColumn* base_column)"
  s7_pointer _p;
  s7_pointer tree_view, column, base_column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_move_column_after", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_move_column_after", 2, column, "GtkTreeViewColumn*");
  base_column = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(base_column, GtkTreeViewColumn__sym)) && (base_column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_move_column_after", 3, base_column, "GtkTreeViewColumn*");
  gtk_tree_view_move_column_after((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeViewColumn*)s7_c_pointer(column), (GtkTreeViewColumn*)s7_c_pointer(base_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_expander_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_expander_column "void gtk_tree_view_set_expander_column(GtkTreeView* tree_view, \
GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_expander_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_expander_column", 2, column, "GtkTreeViewColumn*");
  gtk_tree_view_set_expander_column((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeViewColumn*)s7_c_pointer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_expander_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_expander_column "GtkTreeViewColumn* gtk_tree_view_get_expander_column(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_expander_column", 1, tree_view, "GtkTreeView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeViewColumn__sym, gtk_tree_view_get_expander_column((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_column_drag_function(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_column_drag_function "void gtk_tree_view_set_column_drag_function(GtkTreeView* tree_view, \
GtkTreeViewColumnDropFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_column_drag_function", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_view_set_column_drag_function((GtkTreeView*)s7_c_pointer(tree_view), lg_tree_column, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_view_scroll_to_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_scroll_to_point "void gtk_tree_view_scroll_to_point(GtkTreeView* tree_view, \
gint tree_x, gint tree_y)"
  s7_pointer _p;
  s7_pointer tree_view, tree_x, tree_y;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_point", 1, tree_view, "GtkTreeView*");
  tree_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tree_x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_point", 2, tree_x, "gint");
  tree_y = s7_car(_p);
  if (!s7_is_integer(tree_y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_point", 3, tree_y, "gint");
  gtk_tree_view_scroll_to_point((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(tree_x), (gint)s7_integer(tree_y));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_scroll_to_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_scroll_to_cell "void gtk_tree_view_scroll_to_cell(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, gboolean use_align, gfloat row_align, gfloat col_align)"
  s7_pointer _p;
  s7_pointer tree_view, path, column, use_align, row_align, col_align;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) && (path != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 3, column, "GtkTreeViewColumn*");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 4, use_align, "gboolean");
  row_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(row_align)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 5, row_align, "gfloat");
  col_align = s7_car(_p);
  if (!s7_is_real(col_align)) s7_wrong_type_arg_error(sc, "gtk_tree_view_scroll_to_cell", 6, col_align, "gfloat");
  gtk_tree_view_scroll_to_cell((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(column), (gboolean)lg_boolean(use_align), (gfloat)s7_real(row_align), (gfloat)s7_real(col_align));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_row_activated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_row_activated "void gtk_tree_view_row_activated(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column)"
  s7_pointer _p;
  s7_pointer tree_view, path, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_activated", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_activated", 2, path, "GtkTreePath*");
  column = s7_car(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_activated", 3, column, "GtkTreeViewColumn*");
  gtk_tree_view_row_activated((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_expand_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_expand_all "void gtk_tree_view_expand_all(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_all", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_expand_all((GtkTreeView*)s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_collapse_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_collapse_all "void gtk_tree_view_collapse_all(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_collapse_all", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_collapse_all((GtkTreeView*)s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_expand_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_expand_row "gboolean gtk_tree_view_expand_row(GtkTreeView* tree_view, GtkTreePath* path, \
gboolean open_all)"
  s7_pointer _p;
  s7_pointer tree_view, path, open_all;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_row", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_row", 2, path, "GtkTreePath*");
  open_all = s7_car(_p);
  if (!s7_is_boolean(open_all)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_row", 3, open_all, "gboolean");
  return(s7_make_boolean(sc, gtk_tree_view_expand_row((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (gboolean)lg_boolean(open_all))));
}

static s7_pointer lg_gtk_tree_view_collapse_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_collapse_row "gboolean gtk_tree_view_collapse_row(GtkTreeView* tree_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_collapse_row", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_collapse_row", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_view_collapse_row((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_view_map_expanded_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_map_expanded_rows "void gtk_tree_view_map_expanded_rows(GtkTreeView* tree_view, \
GtkTreeViewMappingFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_map_expanded_rows", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    gtk_tree_view_map_expanded_rows((GtkTreeView*)s7_c_pointer(tree_view), lg_tree_mapping, (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_tree_view_row_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_row_expanded "gboolean gtk_tree_view_row_expanded(GtkTreeView* tree_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_expanded", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_row_expanded", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_tree_view_row_expanded((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_view_set_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_reorderable "void gtk_tree_view_set_reorderable(GtkTreeView* tree_view, \
gboolean reorderable)"
  s7_pointer _p;
  s7_pointer tree_view, reorderable;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_reorderable", 1, tree_view, "GtkTreeView*");
  reorderable = s7_car(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_reorderable", 2, reorderable, "gboolean");
  gtk_tree_view_set_reorderable((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_reorderable "gboolean gtk_tree_view_get_reorderable(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_reorderable", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_reorderable((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_cursor "void gtk_tree_view_set_cursor(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* focus_column, gboolean start_editing)"
  s7_pointer _p;
  s7_pointer tree_view, path, focus_column, start_editing;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 2, path, "GtkTreePath*");
  focus_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focus_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 3, focus_column, "GtkTreeViewColumn*");
  start_editing = s7_car(_p);
  if (!s7_is_boolean(start_editing)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor", 4, start_editing, "gboolean");
  gtk_tree_view_set_cursor((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(focus_column), (gboolean)lg_boolean(start_editing));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_cursor "void gtk_tree_view_get_cursor(GtkTreeView* tree_view, GtkTreePath** [path], \
GtkTreeViewColumn** [focus_column])"
  s7_pointer _p;
  s7_pointer tree_view;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_focus_column = NULL;
  _p = args;
  tree_view = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cursor", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_get_cursor((GtkTreeView*)s7_c_pointer(tree_view), &ref_path, &ref_focus_column);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_focus_column)));
}

static s7_pointer lg_gtk_tree_view_get_path_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_path_at_pos "gboolean gtk_tree_view_get_path_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  s7_pointer _p;
  s7_pointer tree_view, x, y;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_path_at_pos", 1, tree_view, "GtkTreeView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_path_at_pos", 2, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_path_at_pos", 3, y, "gint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_view_get_path_at_pos((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(x), (gint)s7_integer(y), &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
      return(s7_list(sc, 5, res_ult, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_column), s7_make_integer(sc, ref_cell_x), s7_make_integer(sc, ref_cell_y)));
   }
}

static s7_pointer lg_gtk_tree_view_get_cell_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_cell_area "void gtk_tree_view_get_cell_area(GtkTreeView* tree_view, GtkTreePath* path, \
GtkTreeViewColumn* column, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer tree_view, path, column, rect;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) && (path != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 3, column, "GtkTreeViewColumn*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_cell_area", 4, rect, "GdkRectangle*");
  gtk_tree_view_get_cell_area((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(column), (GdkRectangle*)s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_background_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_background_area "void gtk_tree_view_get_background_area(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* column, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer tree_view, path, column, rect;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) && (path != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 2, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) && (column != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 3, column, "GtkTreeViewColumn*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_background_area", 4, rect, "GdkRectangle*");
  gtk_tree_view_get_background_area((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(column), (GdkRectangle*)s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_visible_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_visible_rect "void gtk_tree_view_get_visible_rect(GtkTreeView* tree_view, \
GdkRectangle* visible_rect)"
  s7_pointer _p;
  s7_pointer tree_view, visible_rect;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_visible_rect", 1, tree_view, "GtkTreeView*");
  visible_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(visible_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_visible_rect", 2, visible_rect, "GdkRectangle*");
  gtk_tree_view_get_visible_rect((GtkTreeView*)s7_c_pointer(tree_view), (GdkRectangle*)s7_c_pointer(visible_rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_unset_rows_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_unset_rows_drag_source "void gtk_tree_view_unset_rows_drag_source(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_unset_rows_drag_source", 1, tree_view, "GtkTreeView*");
  gtk_tree_view_unset_rows_drag_source((GtkTreeView*)s7_c_pointer(tree_view));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_dest_row_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_dest_row_at_pos "gboolean gtk_tree_view_get_dest_row_at_pos(GtkTreeView* tree_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkTreeViewDropPosition* [pos])"
  s7_pointer _p;
  s7_pointer tree_view, drag_x, drag_y;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewDropPosition ref_pos;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_dest_row_at_pos", 1, tree_view, "GtkTreeView*");
  drag_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(drag_x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_dest_row_at_pos", 2, drag_x, "gint");
  drag_y = s7_car(_p);
  if (!s7_is_integer(drag_y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_dest_row_at_pos", 3, drag_y, "gint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_view_get_dest_row_at_pos((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(drag_x), (gint)s7_integer(drag_y), &ref_path, &ref_pos));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_pos)));
   }
}

static s7_pointer lg_gtk_tree_view_set_enable_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_enable_search "void gtk_tree_view_set_enable_search(GtkTreeView* tree_view, \
gboolean enable_search)"
  s7_pointer _p;
  s7_pointer tree_view, enable_search;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_search", 1, tree_view, "GtkTreeView*");
  enable_search = s7_car(_p);
  if (!s7_is_boolean(enable_search)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_search", 2, enable_search, "gboolean");
  gtk_tree_view_set_enable_search((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(enable_search));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_enable_search(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_enable_search "gboolean gtk_tree_view_get_enable_search(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_enable_search", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_enable_search((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_get_search_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_column "gint gtk_tree_view_get_search_column(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_column", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_search_column((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_column "void gtk_tree_view_set_search_column(GtkTreeView* tree_view, \
gint column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_column", 2, column, "gint");
  gtk_tree_view_set_search_column((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_search_equal_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_equal_func "GtkTreeViewSearchEqualFunc gtk_tree_view_get_search_equal_func(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_equal_func", 1, tree_view, "GtkTreeView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeViewSearchEqualFunc_sym, gtk_tree_view_get_search_equal_func((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_equal_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_equal_func "void gtk_tree_view_set_search_equal_func(GtkTreeView* tree_view, \
GtkTreeViewSearchEqualFunc func, lambda_data func_info, GtkDestroyNotify search_destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, search_destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_equal_func", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  search_destroy = s7_car(_p);
  {
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, search_destroy);
    gtk_tree_view_set_search_equal_func((GtkTreeView*)s7_c_pointer(tree_view), lg_tree_search, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_viewport_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_viewport_new "GtkWidget* gtk_viewport_new(GtkAdjustment* hadjustment, GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer hadjustment, vadjustment;
  _p = args;
  hadjustment = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) && (hadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_viewport_new", 1, hadjustment, "GtkAdjustment*");
  vadjustment = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) && (vadjustment != lg_false)) s7_wrong_type_arg_error(sc, "gtk_viewport_new", 2, vadjustment, "GtkAdjustment*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_viewport_new((GtkAdjustment*)s7_c_pointer(hadjustment), (GtkAdjustment*)s7_c_pointer(vadjustment))));
}

static s7_pointer lg_gtk_widget_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_destroy "void gtk_widget_destroy(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_destroy", 1, widget, "GtkWidget*");
  gtk_widget_destroy((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_destroyed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_destroyed "void gtk_widget_destroyed(GtkWidget* widget, GtkWidget** [widget_pointer])"
  s7_pointer _p;
  s7_pointer widget;
  GtkWidget* ref_widget_pointer = NULL;
  _p = args;
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_destroyed", 1, widget, "GtkWidget*");
  gtk_widget_destroyed((GtkWidget*)s7_c_pointer(widget), &ref_widget_pointer);
    return(s7_list(sc, 1, s7_make_c_pointer(sc, ref_widget_pointer)));
}

static s7_pointer lg_gtk_widget_unparent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unparent "void gtk_widget_unparent(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unparent", 1, widget, "GtkWidget*");
  gtk_widget_unparent((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_show(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_show "void gtk_widget_show(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_show", 1, widget, "GtkWidget*");
  gtk_widget_show((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_hide(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_hide "void gtk_widget_hide(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_hide", 1, widget, "GtkWidget*");
  gtk_widget_hide((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_map "void gtk_widget_map(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_map", 1, widget, "GtkWidget*");
  gtk_widget_map((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unmap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unmap "void gtk_widget_unmap(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unmap", 1, widget, "GtkWidget*");
  gtk_widget_unmap((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_realize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_realize "void gtk_widget_realize(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_realize", 1, widget, "GtkWidget*");
  gtk_widget_realize((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unrealize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unrealize "void gtk_widget_unrealize(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unrealize", 1, widget, "GtkWidget*");
  gtk_widget_unrealize((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_draw(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_draw "void gtk_widget_queue_draw(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_draw", 1, widget, "GtkWidget*");
  gtk_widget_queue_draw((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_resize "void gtk_widget_queue_resize(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_resize", 1, widget, "GtkWidget*");
  gtk_widget_queue_resize((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_mnemonic_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_mnemonic_activate "gboolean gtk_widget_mnemonic_activate(GtkWidget* widget, gboolean group_cycling)"
  s7_pointer _p;
  s7_pointer widget, group_cycling;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_mnemonic_activate", 1, widget, "GtkWidget*");
  group_cycling = s7_car(_p);
  if (!s7_is_boolean(group_cycling)) s7_wrong_type_arg_error(sc, "gtk_widget_mnemonic_activate", 2, group_cycling, "gboolean");
  return(s7_make_boolean(sc, gtk_widget_mnemonic_activate((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(group_cycling))));
}

static s7_pointer lg_gtk_widget_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_event "gboolean gtk_widget_event(GtkWidget* widget, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer widget, event;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_event", 1, widget, "GtkWidget*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_widget_event((GtkWidget*)s7_c_pointer(widget), (GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_widget_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_activate "gboolean gtk_widget_activate(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_activate((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_is_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_focus "gboolean gtk_widget_is_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_focus((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_name "void gtk_widget_set_name(GtkWidget* widget, gchar* name)"
  s7_pointer _p;
  s7_pointer widget, name;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_name", 1, widget, "GtkWidget*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_set_name", 2, name, "gchar*");
  gtk_widget_set_name((GtkWidget*)s7_c_pointer(widget), (gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_name "gchar* gtk_widget_get_name(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_name", 1, widget, "GtkWidget*");
  return(s7_make_string(sc, gtk_widget_get_name((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_sensitive "void gtk_widget_set_sensitive(GtkWidget* widget, gboolean sensitive)"
  s7_pointer _p;
  s7_pointer widget, sensitive;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_sensitive", 1, widget, "GtkWidget*");
  sensitive = s7_car(_p);
  if (!s7_is_boolean(sensitive)) s7_wrong_type_arg_error(sc, "gtk_widget_set_sensitive", 2, sensitive, "gboolean");
  gtk_widget_set_sensitive((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_parent "void gtk_widget_set_parent(GtkWidget* widget, GtkWidget* parent)"
  s7_pointer _p;
  s7_pointer widget, parent;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_parent", 1, widget, "GtkWidget*");
  parent = s7_car(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_parent", 2, parent, "GtkWidget*");
  gtk_widget_set_parent((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_child_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_child_visible "void gtk_widget_set_child_visible(GtkWidget* widget, gboolean is_visible)"
  s7_pointer _p;
  s7_pointer widget, is_visible;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_child_visible", 1, widget, "GtkWidget*");
  is_visible = s7_car(_p);
  if (!s7_is_boolean(is_visible)) s7_wrong_type_arg_error(sc, "gtk_widget_set_child_visible", 2, is_visible, "gboolean");
  gtk_widget_set_child_visible((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(is_visible));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_child_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_child_visible "gboolean gtk_widget_get_child_visible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_child_visible", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_child_visible((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_parent "GtkWidget* gtk_widget_get_parent(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_parent", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_parent((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_child_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_child_focus "gboolean gtk_widget_child_focus(GtkWidget* widget, GtkDirectionType direction)"
  s7_pointer _p;
  s7_pointer widget, direction;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_child_focus", 1, widget, "GtkWidget*");
  direction = s7_car(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_widget_child_focus", 2, direction, "GtkDirectionType");
  return(s7_make_boolean(sc, gtk_widget_child_focus((GtkWidget*)s7_c_pointer(widget), (GtkDirectionType)s7_integer(direction))));
}

static s7_pointer lg_gtk_widget_set_size_request(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_size_request "void gtk_widget_set_size_request(GtkWidget* widget, gint width, \
gint height)"
  s7_pointer _p;
  s7_pointer widget, width, height;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_size_request", 1, widget, "GtkWidget*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_widget_set_size_request", 2, width, "gint");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_widget_set_size_request", 3, height, "gint");
  gtk_widget_set_size_request((GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(width), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_size_request(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_size_request "void gtk_widget_get_size_request(GtkWidget* widget, gint* [width], \
gint* [height])"
  s7_pointer _p;
  s7_pointer widget;
  gint ref_width;
  gint ref_height;
  _p = args;
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_size_request", 1, widget, "GtkWidget*");
  gtk_widget_get_size_request((GtkWidget*)s7_c_pointer(widget), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_widget_get_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_ancestor "GtkWidget* gtk_widget_get_ancestor(GtkWidget* widget, GType widget_type)"
  s7_pointer _p;
  s7_pointer widget, widget_type;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_ancestor", 1, widget, "GtkWidget*");
  widget_type = s7_car(_p);
  if (!s7_is_integer(widget_type)) s7_wrong_type_arg_error(sc, "gtk_widget_get_ancestor", 2, widget_type, "GType");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_ancestor((GtkWidget*)s7_c_pointer(widget), (GType)s7_integer(widget_type))));
}

static s7_pointer lg_gtk_widget_get_settings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_settings "GtkSettings* gtk_widget_get_settings(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_settings", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkSettings__sym, gtk_widget_get_settings((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_accessible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_accessible "AtkObject* gtk_widget_get_accessible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_accessible", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, AtkObject__sym, gtk_widget_get_accessible((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_is_ancestor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_ancestor "gboolean gtk_widget_is_ancestor(GtkWidget* widget, GtkWidget* ancestor)"
  s7_pointer _p;
  s7_pointer widget, ancestor;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_ancestor", 1, widget, "GtkWidget*");
  ancestor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(ancestor, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_ancestor", 2, ancestor, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_ancestor((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(ancestor))));
}

static s7_pointer lg_gtk_widget_translate_coordinates(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_translate_coordinates "gboolean gtk_widget_translate_coordinates(GtkWidget* src_widget, \
GtkWidget* dest_widget, gint src_x, gint src_y, gint* [dest_x], gint* [dest_y])"
  s7_pointer _p;
  s7_pointer src_widget, dest_widget, src_x, src_y;
  gint ref_dest_x;
  gint ref_dest_y;
  _p = args;
  src_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(src_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 1, src_widget, "GtkWidget*");
  dest_widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 2, dest_widget, "GtkWidget*");
  src_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(src_x)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 3, src_x, "gint");
  src_y = s7_car(_p);
  if (!s7_is_integer(src_y)) s7_wrong_type_arg_error(sc, "gtk_widget_translate_coordinates", 4, src_y, "gint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_widget_translate_coordinates((GtkWidget*)s7_c_pointer(src_widget), (GtkWidget*)s7_c_pointer(dest_widget), (gint)s7_integer(src_x), (gint)s7_integer(src_y), &ref_dest_x, &ref_dest_y));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_dest_x), s7_make_integer(sc, ref_dest_y)));
   }
}

static s7_pointer lg_gtk_widget_create_pango_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_create_pango_context "PangoContext* gtk_widget_create_pango_context(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_create_pango_context", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, PangoContext__sym, gtk_widget_create_pango_context((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_pango_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_pango_context "PangoContext* gtk_widget_get_pango_context(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_pango_context", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, PangoContext__sym, gtk_widget_get_pango_context((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_create_pango_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_create_pango_layout "PangoLayout* gtk_widget_create_pango_layout(GtkWidget* widget, \
gchar* text)"
  s7_pointer _p;
  s7_pointer widget, text;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_create_pango_layout", 1, widget, "GtkWidget*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_widget_create_pango_layout", 2, text, "gchar*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, gtk_widget_create_pango_layout((GtkWidget*)s7_c_pointer(widget), (gchar*)s7_string(text))));
}

static s7_pointer lg_gtk_widget_set_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_direction "void gtk_widget_set_direction(GtkWidget* widget, GtkTextDirection dir)"
  s7_pointer _p;
  s7_pointer widget, dir;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_direction", 1, widget, "GtkWidget*");
  dir = s7_car(_p);
  if (!s7_is_integer(dir)) s7_wrong_type_arg_error(sc, "gtk_widget_set_direction", 2, dir, "GtkTextDirection");
  gtk_widget_set_direction((GtkWidget*)s7_c_pointer(widget), (GtkTextDirection)s7_integer(dir));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_direction "GtkTextDirection gtk_widget_get_direction(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_direction", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_direction((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_default_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_default_direction "void gtk_widget_set_default_direction(GtkTextDirection dir)"
  s7_pointer dir;
  dir = s7_car(args);
  if (!s7_is_integer(dir)) s7_wrong_type_arg_error(sc, "gtk_widget_set_default_direction", 1, dir, "GtkTextDirection");
  gtk_widget_set_default_direction((GtkTextDirection)s7_integer(dir));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_default_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_default_direction "GtkTextDirection gtk_widget_get_default_direction( void)"
  return(s7_make_integer(sc, gtk_widget_get_default_direction()));
}

static s7_pointer lg_gtk_window_is_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_is_active "gboolean gtk_window_is_active(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_is_active", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_is_active((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_title "void gtk_window_set_title(GtkWindow* window, gchar* title)"
  s7_pointer _p;
  s7_pointer window, title;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_title", 1, window, "GtkWindow*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_window_set_title", 2, title, "gchar*");
  gtk_window_set_title((GtkWindow*)s7_c_pointer(window), (gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_auto_startup_notification(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_auto_startup_notification "void gtk_window_set_auto_startup_notification(gboolean setting)"
  s7_pointer setting;
  setting = s7_car(args);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_auto_startup_notification", 1, setting, "gboolean");
  gtk_window_set_auto_startup_notification((gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_title "gchar* gtk_window_get_title(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_title", 1, window, "GtkWindow*");
  return(s7_make_string(sc, gtk_window_get_title((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_focus "void gtk_window_set_focus(GtkWindow* window, GtkWidget* focus)"
  s7_pointer _p;
  s7_pointer window, focus;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus", 1, window, "GtkWindow*");
  focus = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(focus, GtkWidget__sym)) && (focus != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus", 2, focus, "GtkWidget*");
  gtk_window_set_focus((GtkWindow*)s7_c_pointer(window), (GtkWidget*)s7_c_pointer(focus));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_focus "GtkWidget* gtk_window_get_focus(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_focus", 1, window, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_window_get_focus((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_transient_for(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_transient_for "void gtk_window_set_transient_for(GtkWindow* window, GtkWindow* parent)"
  s7_pointer _p;
  s7_pointer window, parent;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_transient_for", 1, window, "GtkWindow*");
  parent = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_window_set_transient_for", 2, parent, "GtkWindow*");
  gtk_window_set_transient_for((GtkWindow*)s7_c_pointer(window), (GtkWindow*)s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_transient_for(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_transient_for "GtkWindow* gtk_window_get_transient_for(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_transient_for", 1, window, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWindow__sym, gtk_window_get_transient_for((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_destroy_with_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_destroy_with_parent "void gtk_window_set_destroy_with_parent(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_destroy_with_parent", 1, window, "GtkWindow*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_destroy_with_parent", 2, setting, "gboolean");
  gtk_window_set_destroy_with_parent((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_destroy_with_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_destroy_with_parent "gboolean gtk_window_get_destroy_with_parent(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_destroy_with_parent", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_destroy_with_parent((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_resizable "void gtk_window_set_resizable(GtkWindow* window, gboolean resizable)"
  s7_pointer _p;
  s7_pointer window, resizable;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_resizable", 1, window, "GtkWindow*");
  resizable = s7_car(_p);
  if (!s7_is_boolean(resizable)) s7_wrong_type_arg_error(sc, "gtk_window_set_resizable", 2, resizable, "gboolean");
  gtk_window_set_resizable((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(resizable));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_resizable "gboolean gtk_window_get_resizable(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_resizable", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_resizable((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_decorated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_decorated "void gtk_window_set_decorated(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_decorated", 1, window, "GtkWindow*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_decorated", 2, setting, "gboolean");
  gtk_window_set_decorated((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_decorated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_decorated "gboolean gtk_window_get_decorated(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_decorated", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_decorated((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_modal "void gtk_window_set_modal(GtkWindow* window, gboolean modal)"
  s7_pointer _p;
  s7_pointer window, modal;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_modal", 1, window, "GtkWindow*");
  modal = s7_car(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gtk_window_set_modal", 2, modal, "gboolean");
  gtk_window_set_modal((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_modal "gboolean gtk_window_get_modal(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_modal", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_modal((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_list_toplevels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_list_toplevels "GList* gtk_window_list_toplevels( void)"
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_window_list_toplevels()));
}

static s7_pointer lg_gtk_window_present(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_present "void gtk_window_present(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_present", 1, window, "GtkWindow*");
  gtk_window_present((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_maximize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_maximize "void gtk_window_maximize(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_maximize", 1, window, "GtkWindow*");
  gtk_window_maximize((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_unmaximize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_unmaximize "void gtk_window_unmaximize(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_unmaximize", 1, window, "GtkWindow*");
  gtk_window_unmaximize((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_default_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_size "void gtk_window_set_default_size(GtkWindow* window, gint width, \
gint height)"
  s7_pointer _p;
  s7_pointer window, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_size", 1, window, "GtkWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_size", 2, width, "gint");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_size", 3, height, "gint");
  gtk_window_set_default_size((GtkWindow*)s7_c_pointer(window), (gint)s7_integer(width), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_default_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_size "void gtk_window_get_default_size(GtkWindow* window, gint* [width], \
gint* [height])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_width;
  gint ref_height;
  _p = args;
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_default_size", 1, window, "GtkWindow*");
  gtk_window_get_default_size((GtkWindow*)s7_c_pointer(window), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_window_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_resize "void gtk_window_resize(GtkWindow* window, gint width, gint height)"
  s7_pointer _p;
  s7_pointer window, width, height;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_resize", 1, window, "GtkWindow*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_window_resize", 2, width, "gint");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_window_resize", 3, height, "gint");
  gtk_window_resize((GtkWindow*)s7_c_pointer(window), (gint)s7_integer(width), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_size "void gtk_window_get_size(GtkWindow* window, gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer window;
  gint ref_width;
  gint ref_height;
  _p = args;
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_size", 1, window, "GtkWindow*");
  gtk_window_get_size((GtkWindow*)s7_c_pointer(window), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_pango_color_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_color_copy "PangoColor* pango_color_copy(PangoColor* src)"
  s7_pointer src;
  src = s7_car(args);
  if (!s7_is_c_pointer_of_type(src, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_color_copy", 1, src, "PangoColor*");
  return(lg_make_c_pointer_with_type(sc, PangoColor__sym, pango_color_copy((PangoColor*)s7_c_pointer(src))));
}

static s7_pointer lg_pango_color_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_color_free "void pango_color_free(PangoColor* color)"
  s7_pointer color;
  color = s7_car(args);
  if (!s7_is_c_pointer_of_type(color, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_color_free", 1, color, "PangoColor*");
  pango_color_free((PangoColor*)s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_pango_color_parse(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_color_parse "gboolean pango_color_parse(PangoColor* color, char* spec)"
  s7_pointer _p;
  s7_pointer color, spec;
  _p = args;
  color = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(color, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_color_parse", 1, color, "PangoColor*");
  spec = s7_car(_p);
  if (!s7_is_string(spec)) s7_wrong_type_arg_error(sc, "pango_color_parse", 2, spec, "char*");
  return(s7_make_boolean(sc, pango_color_parse((PangoColor*)s7_c_pointer(color), (char*)s7_string(spec))));
}

static s7_pointer lg_pango_attr_type_register(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_type_register "PangoAttrType pango_attr_type_register(gchar* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "pango_attr_type_register", 1, name, "gchar*");
  return(s7_make_integer(sc, pango_attr_type_register((gchar*)s7_string(name))));
}

static s7_pointer lg_pango_attribute_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attribute_copy "PangoAttribute* pango_attribute_copy(PangoAttribute* attr)"
  s7_pointer attr;
  attr = s7_car(args);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_copy", 1, attr, "PangoAttribute*");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attribute_copy((PangoAttribute*)s7_c_pointer(attr))));
}

static s7_pointer lg_pango_attribute_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attribute_destroy "void pango_attribute_destroy(PangoAttribute* attr)"
  s7_pointer attr;
  attr = s7_car(args);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_destroy", 1, attr, "PangoAttribute*");
  pango_attribute_destroy((PangoAttribute*)s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attribute_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attribute_equal "gboolean pango_attribute_equal(PangoAttribute* attr1, PangoAttribute* attr2)"
  s7_pointer _p;
  s7_pointer attr1, attr2;
  _p = args;
  attr1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr1, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_equal", 1, attr1, "PangoAttribute*");
  attr2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attr2, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attribute_equal", 2, attr2, "PangoAttribute*");
  return(s7_make_boolean(sc, pango_attribute_equal((PangoAttribute*)s7_c_pointer(attr1), (PangoAttribute*)s7_c_pointer(attr2))));
}

static s7_pointer lg_pango_attr_language_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_language_new "PangoAttribute* pango_attr_language_new(PangoLanguage* language)"
  s7_pointer language;
  language = s7_car(args);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_attr_language_new", 1, language, "PangoLanguage*");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_language_new((PangoLanguage*)s7_c_pointer(language))));
}

static s7_pointer lg_pango_attr_family_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_family_new "PangoAttribute* pango_attr_family_new(char* family)"
  s7_pointer family;
  family = s7_car(args);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "pango_attr_family_new", 1, family, "char*");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_family_new((char*)s7_string(family))));
}

static s7_pointer lg_pango_attr_foreground_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_foreground_new "PangoAttribute* pango_attr_foreground_new(guint16 red, guint16 green, \
guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_foreground_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_foreground_new", 2, green, "guint16");
  blue = s7_car(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_foreground_new", 3, blue, "guint16");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_foreground_new((guint16)s7_integer(red), (guint16)s7_integer(green), (guint16)s7_integer(blue))));
}

static s7_pointer lg_pango_attr_background_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_background_new "PangoAttribute* pango_attr_background_new(guint16 red, guint16 green, \
guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_background_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_background_new", 2, green, "guint16");
  blue = s7_car(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_background_new", 3, blue, "guint16");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_background_new((guint16)s7_integer(red), (guint16)s7_integer(green), (guint16)s7_integer(blue))));
}

static s7_pointer lg_pango_attr_size_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_size_new "PangoAttribute* pango_attr_size_new(int size)"
  s7_pointer size;
  size = s7_car(args);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "pango_attr_size_new", 1, size, "int");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_size_new((int)s7_integer(size))));
}

static s7_pointer lg_pango_attr_style_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_style_new "PangoAttribute* pango_attr_style_new(PangoStyle style)"
  s7_pointer style;
  style = s7_car(args);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "pango_attr_style_new", 1, style, "PangoStyle");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_style_new((PangoStyle)s7_integer(style))));
}

static s7_pointer lg_pango_attr_weight_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_weight_new "PangoAttribute* pango_attr_weight_new(PangoWeight weight)"
  s7_pointer weight;
  weight = s7_car(args);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "pango_attr_weight_new", 1, weight, "PangoWeight");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_weight_new((PangoWeight)s7_integer(weight))));
}

static s7_pointer lg_pango_attr_variant_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_variant_new "PangoAttribute* pango_attr_variant_new(PangoVariant variant)"
  s7_pointer variant;
  variant = s7_car(args);
  if (!s7_is_integer(variant)) s7_wrong_type_arg_error(sc, "pango_attr_variant_new", 1, variant, "PangoVariant");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_variant_new((PangoVariant)s7_integer(variant))));
}

static s7_pointer lg_pango_attr_stretch_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_stretch_new "PangoAttribute* pango_attr_stretch_new(PangoStretch stretch)"
  s7_pointer stretch;
  stretch = s7_car(args);
  if (!s7_is_integer(stretch)) s7_wrong_type_arg_error(sc, "pango_attr_stretch_new", 1, stretch, "PangoStretch");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_stretch_new((PangoStretch)s7_integer(stretch))));
}

static s7_pointer lg_pango_attr_font_desc_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_font_desc_new "PangoAttribute* pango_attr_font_desc_new(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_attr_font_desc_new", 1, desc, "PangoFontDescription*");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_font_desc_new((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_attr_underline_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_underline_new "PangoAttribute* pango_attr_underline_new(PangoUnderline underline)"
  s7_pointer underline;
  underline = s7_car(args);
  if (!s7_is_integer(underline)) s7_wrong_type_arg_error(sc, "pango_attr_underline_new", 1, underline, "PangoUnderline");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_underline_new((PangoUnderline)s7_integer(underline))));
}

static s7_pointer lg_pango_attr_strikethrough_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_strikethrough_new "PangoAttribute* pango_attr_strikethrough_new(gboolean strikethrough)"
  s7_pointer strikethrough;
  strikethrough = s7_car(args);
  if (!s7_is_boolean(strikethrough)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_new", 1, strikethrough, "gboolean");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_strikethrough_new((gboolean)lg_boolean(strikethrough))));
}

static s7_pointer lg_pango_attr_rise_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_rise_new "PangoAttribute* pango_attr_rise_new(int rise)"
  s7_pointer rise;
  rise = s7_car(args);
  if (!s7_is_integer(rise)) s7_wrong_type_arg_error(sc, "pango_attr_rise_new", 1, rise, "int");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_rise_new((int)s7_integer(rise))));
}

static s7_pointer lg_pango_attr_shape_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_shape_new "PangoAttribute* pango_attr_shape_new(PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer ink_rect, logical_rect;
  _p = args;
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_attr_shape_new", 1, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_attr_shape_new", 2, logical_rect, "PangoRectangle*");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_shape_new((PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect))));
}

static s7_pointer lg_pango_attr_scale_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_scale_new "PangoAttribute* pango_attr_scale_new(double scale_factor)"
  s7_pointer scale_factor;
  scale_factor = s7_car(args);
  if (!s7_is_real(scale_factor)) s7_wrong_type_arg_error(sc, "pango_attr_scale_new", 1, scale_factor, "double");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_scale_new((double)s7_real(scale_factor))));
}

static s7_pointer lg_pango_attr_list_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_new "PangoAttrList* pango_attr_list_new( void)"
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, pango_attr_list_new()));
}

static s7_pointer lg_pango_attr_list_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_unref "void pango_attr_list_unref(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_unref", 1, list, "PangoAttrList*");
  pango_attr_list_unref((PangoAttrList*)s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_copy "PangoAttrList* pango_attr_list_copy(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_copy", 1, list, "PangoAttrList*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, pango_attr_list_copy((PangoAttrList*)s7_c_pointer(list))));
}

static s7_pointer lg_pango_attr_list_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_insert "void pango_attr_list_insert(PangoAttrList* list, PangoAttribute* attr)"
  s7_pointer _p;
  s7_pointer list, attr;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert", 1, list, "PangoAttrList*");
  attr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert", 2, attr, "PangoAttribute*");
  pango_attr_list_insert((PangoAttrList*)s7_c_pointer(list), (PangoAttribute*)s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_insert_before "void pango_attr_list_insert_before(PangoAttrList* list, PangoAttribute* attr)"
  s7_pointer _p;
  s7_pointer list, attr;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert_before", 1, list, "PangoAttrList*");
  attr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_insert_before", 2, attr, "PangoAttribute*");
  pango_attr_list_insert_before((PangoAttrList*)s7_c_pointer(list), (PangoAttribute*)s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_change(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_change "void pango_attr_list_change(PangoAttrList* list, PangoAttribute* attr)"
  s7_pointer _p;
  s7_pointer list, attr;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_change", 1, list, "PangoAttrList*");
  attr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attr, PangoAttribute__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_change", 2, attr, "PangoAttribute*");
  pango_attr_list_change((PangoAttrList*)s7_c_pointer(list), (PangoAttribute*)s7_c_pointer(attr));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_splice(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_splice "void pango_attr_list_splice(PangoAttrList* list, PangoAttrList* other, \
gint pos, gint len)"
  s7_pointer _p;
  s7_pointer list, other, pos, len;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 1, list, "PangoAttrList*");
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 2, other, "PangoAttrList*");
  pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 3, pos, "gint");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "pango_attr_list_splice", 4, len, "gint");
  pango_attr_list_splice((PangoAttrList*)s7_c_pointer(list), (PangoAttrList*)s7_c_pointer(other), (gint)s7_integer(pos), (gint)s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_pango_attr_list_get_iterator(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_get_iterator "PangoAttrIterator* pango_attr_list_get_iterator(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_get_iterator", 1, list, "PangoAttrList*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrIterator__sym, pango_attr_list_get_iterator((PangoAttrList*)s7_c_pointer(list))));
}

static s7_pointer lg_pango_attr_iterator_range(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_range "void pango_attr_iterator_range(PangoAttrIterator* iterator, gint* [start], \
gint* [end])"
  s7_pointer _p;
  s7_pointer iterator;
  gint ref_start;
  gint ref_end;
  _p = args;
  iterator = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_range", 1, iterator, "PangoAttrIterator*");
  pango_attr_iterator_range((PangoAttrIterator*)s7_c_pointer(iterator), &ref_start, &ref_end);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_start), s7_make_integer(sc, ref_end)));
}

static s7_pointer lg_pango_attr_iterator_next(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_next "gboolean pango_attr_iterator_next(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_next", 1, iterator, "PangoAttrIterator*");
  return(s7_make_boolean(sc, pango_attr_iterator_next((PangoAttrIterator*)s7_c_pointer(iterator))));
}

static s7_pointer lg_pango_attr_iterator_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_copy "PangoAttrIterator* pango_attr_iterator_copy(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_copy", 1, iterator, "PangoAttrIterator*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrIterator__sym, pango_attr_iterator_copy((PangoAttrIterator*)s7_c_pointer(iterator))));
}

static s7_pointer lg_pango_attr_iterator_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_destroy "void pango_attr_iterator_destroy(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_destroy", 1, iterator, "PangoAttrIterator*");
  pango_attr_iterator_destroy((PangoAttrIterator*)s7_c_pointer(iterator));
  return(lg_false);
}

static s7_pointer lg_pango_attr_iterator_get(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_get "PangoAttribute* pango_attr_iterator_get(PangoAttrIterator* iterator, \
PangoAttrType type)"
  s7_pointer _p;
  s7_pointer iterator, type;
  _p = args;
  iterator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get", 1, iterator, "PangoAttrIterator*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get", 2, type, "PangoAttrType");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_iterator_get((PangoAttrIterator*)s7_c_pointer(iterator), (PangoAttrType)s7_integer(type))));
}

static s7_pointer lg_pango_attr_iterator_get_font(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_get_font "void pango_attr_iterator_get_font(PangoAttrIterator* iterator, \
PangoFontDescription* desc, PangoLanguage** [language], GSList** [extra_attrs])"
  s7_pointer _p;
  s7_pointer iterator, desc;
  PangoLanguage* ref_language = NULL;
  GSList* ref_extra_attrs = NULL;
  _p = args;
  iterator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get_font", 1, iterator, "PangoAttrIterator*");
  desc = s7_car(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get_font", 2, desc, "PangoFontDescription*");
  pango_attr_iterator_get_font((PangoAttrIterator*)s7_c_pointer(iterator), (PangoFontDescription*)s7_c_pointer(desc), &ref_language, &ref_extra_attrs);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_language), s7_make_c_pointer(sc, ref_extra_attrs)));
}

static s7_pointer lg_pango_parse_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_parse_markup "gboolean pango_parse_markup(char* markup_text, int length, gunichar accel_marker, \
PangoAttrList** attr_list, char** text, gunichar* accel_char, GError** [error])"
  s7_pointer _p;
  s7_pointer markup_text, length, accel_marker, attr_list, text, accel_char;
  GError* ref_error = NULL;
  _p = args;
  markup_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup_text)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 1, markup_text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 2, length, "int");
  accel_marker = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_marker)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 3, accel_marker, "gunichar");
  attr_list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attr_list, PangoAttrList___sym)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 4, attr_list, "PangoAttrList**");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text, char___sym)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 5, text, "char**");
  accel_char = s7_car(_p);
  if (!s7_is_c_pointer_of_type(accel_char, gunichar__sym)) s7_wrong_type_arg_error(sc, "pango_parse_markup", 6, accel_char, "gunichar*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, pango_parse_markup((char*)s7_string(markup_text), (int)s7_integer(length), (gunichar)s7_integer(accel_marker), (PangoAttrList**)s7_c_pointer(attr_list), (char**)s7_c_pointer(text), (gunichar*)s7_c_pointer(accel_char), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_pango_find_paragraph_boundary(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_find_paragraph_boundary "void pango_find_paragraph_boundary(gchar* text, gint length, \
gint* [paragraph_delimiter_index], gint* [next_paragraph_start])"
  s7_pointer _p;
  s7_pointer text, length;
  gint ref_paragraph_delimiter_index;
  gint ref_next_paragraph_start;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_find_paragraph_boundary", 1, text, "gchar*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_find_paragraph_boundary", 2, length, "gint");
  pango_find_paragraph_boundary((gchar*)s7_string(text), (gint)s7_integer(length), &ref_paragraph_delimiter_index, &ref_next_paragraph_start);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_paragraph_delimiter_index), s7_make_integer(sc, ref_next_paragraph_start)));
}

static s7_pointer lg_pango_get_log_attrs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_get_log_attrs "void pango_get_log_attrs(char* text, int length, int level, PangoLanguage* language, \
PangoLogAttr* log_attrs, int attrs_len)"
  s7_pointer _p;
  s7_pointer text, length, level, language, log_attrs, attrs_len;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 1, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 2, length, "int");
  level = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(level)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 3, level, "int");
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 4, language, "PangoLanguage*");
  log_attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(log_attrs, PangoLogAttr__sym)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 5, log_attrs, "PangoLogAttr*");
  attrs_len = s7_car(_p);
  if (!s7_is_integer(attrs_len)) s7_wrong_type_arg_error(sc, "pango_get_log_attrs", 6, attrs_len, "int");
  pango_get_log_attrs((char*)s7_string(text), (int)s7_integer(length), (int)s7_integer(level), (PangoLanguage*)s7_c_pointer(language), (PangoLogAttr*)s7_c_pointer(log_attrs), (int)s7_integer(attrs_len));
  return(lg_false);
}

static s7_pointer lg_pango_context_list_families(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_list_families "void pango_context_list_families(PangoContext* context, PangoFontFamily*** [families], \
int* [n_families])"
  s7_pointer _p;
  s7_pointer context;
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  _p = args;
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_list_families", 1, context, "PangoContext*");
  pango_context_list_families((PangoContext*)s7_c_pointer(context), &ref_families, &ref_n_families);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_families), s7_make_integer(sc, ref_n_families)));
}

static s7_pointer lg_pango_context_load_font(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_load_font "PangoFont* pango_context_load_font(PangoContext* context, PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer context, desc;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_font", 1, context, "PangoContext*");
  desc = s7_car(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_font", 2, desc, "PangoFontDescription*");
  return(lg_make_c_pointer_with_type(sc, PangoFont__sym, pango_context_load_font((PangoContext*)s7_c_pointer(context), (PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_context_load_fontset(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_load_fontset "PangoFontset* pango_context_load_fontset(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer context, desc, language;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_fontset", 1, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_fontset", 2, desc, "PangoFontDescription*");
  language = s7_car(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_context_load_fontset", 3, language, "PangoLanguage*");
  return(lg_make_c_pointer_with_type(sc, PangoFontset__sym, pango_context_load_fontset((PangoContext*)s7_c_pointer(context), (PangoFontDescription*)s7_c_pointer(desc), (PangoLanguage*)s7_c_pointer(language))));
}

static s7_pointer lg_pango_context_get_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_metrics "PangoFontMetrics* pango_context_get_metrics(PangoContext* context, \
PangoFontDescription* desc, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer context, desc, language;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_metrics", 1, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_metrics", 2, desc, "PangoFontDescription*");
  language = s7_car(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_metrics", 3, language, "PangoLanguage*");
  return(lg_make_c_pointer_with_type(sc, PangoFontMetrics__sym, pango_context_get_metrics((PangoContext*)s7_c_pointer(context), (PangoFontDescription*)s7_c_pointer(desc), (PangoLanguage*)s7_c_pointer(language))));
}

static s7_pointer lg_pango_context_set_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_set_font_description "void pango_context_set_font_description(PangoContext* context, \
PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer context, desc;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_font_description", 1, context, "PangoContext*");
  desc = s7_car(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_font_description", 2, desc, "PangoFontDescription*");
  pango_context_set_font_description((PangoContext*)s7_c_pointer(context), (PangoFontDescription*)s7_c_pointer(desc));
  return(lg_false);
}

static s7_pointer lg_pango_context_get_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_font_description "PangoFontDescription* pango_context_get_font_description(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_font_description", 1, context, "PangoContext*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_context_get_font_description((PangoContext*)s7_c_pointer(context))));
}

static s7_pointer lg_pango_context_get_language(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_language "PangoLanguage* pango_context_get_language(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_language", 1, context, "PangoContext*");
  return(lg_make_c_pointer_with_type(sc, PangoLanguage__sym, pango_context_get_language((PangoContext*)s7_c_pointer(context))));
}

static s7_pointer lg_pango_context_set_language(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_set_language "void pango_context_set_language(PangoContext* context, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer context, language;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_language", 1, context, "PangoContext*");
  language = s7_car(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_language", 2, language, "PangoLanguage*");
  pango_context_set_language((PangoContext*)s7_c_pointer(context), (PangoLanguage*)s7_c_pointer(language));
  return(lg_false);
}

static s7_pointer lg_pango_context_set_base_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_set_base_dir "void pango_context_set_base_dir(PangoContext* context, PangoDirection direction)"
  s7_pointer _p;
  s7_pointer context, direction;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_set_base_dir", 1, context, "PangoContext*");
  direction = s7_car(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "pango_context_set_base_dir", 2, direction, "PangoDirection");
  pango_context_set_base_dir((PangoContext*)s7_c_pointer(context), (PangoDirection)s7_integer(direction));
  return(lg_false);
}

static s7_pointer lg_pango_context_get_base_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_context_get_base_dir "PangoDirection pango_context_get_base_dir(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_context_get_base_dir", 1, context, "PangoContext*");
  return(s7_make_integer(sc, pango_context_get_base_dir((PangoContext*)s7_c_pointer(context))));
}

static s7_pointer lg_pango_itemize(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_itemize "GList* pango_itemize(PangoContext* context, char* text, int start_index, int length, \
PangoAttrList* attrs, PangoAttrIterator* cached_iter)"
  s7_pointer _p;
  s7_pointer context, text, start_index, length, attrs, cached_iter;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_itemize", 1, context, "PangoContext*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_itemize", 2, text, "char*");
  start_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_index)) s7_wrong_type_arg_error(sc, "pango_itemize", 3, start_index, "int");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_itemize", 4, length, "int");
  attrs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_itemize", 5, attrs, "PangoAttrList*");
  cached_iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cached_iter, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_itemize", 6, cached_iter, "PangoAttrIterator*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, pango_itemize((PangoContext*)s7_c_pointer(context), (char*)s7_string(text), (int)s7_integer(start_index), (int)s7_integer(length), (PangoAttrList*)s7_c_pointer(attrs), (PangoAttrIterator*)s7_c_pointer(cached_iter))));
}

static s7_pointer lg_pango_coverage_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_new "PangoCoverage* pango_coverage_new( void)"
  return(lg_make_c_pointer_with_type(sc, PangoCoverage__sym, pango_coverage_new()));
}

static s7_pointer lg_pango_coverage_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_ref "PangoCoverage* pango_coverage_ref(PangoCoverage* coverage)"
  s7_pointer coverage;
  coverage = s7_car(args);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_ref", 1, coverage, "PangoCoverage*");
  return(lg_make_c_pointer_with_type(sc, PangoCoverage__sym, pango_coverage_ref((PangoCoverage*)s7_c_pointer(coverage))));
}

static s7_pointer lg_pango_coverage_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_unref "void pango_coverage_unref(PangoCoverage* coverage)"
  s7_pointer coverage;
  coverage = s7_car(args);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_unref", 1, coverage, "PangoCoverage*");
  pango_coverage_unref((PangoCoverage*)s7_c_pointer(coverage));
  return(lg_false);
}

static s7_pointer lg_pango_coverage_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_copy "PangoCoverage* pango_coverage_copy(PangoCoverage* coverage)"
  s7_pointer coverage;
  coverage = s7_car(args);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_copy", 1, coverage, "PangoCoverage*");
  return(lg_make_c_pointer_with_type(sc, PangoCoverage__sym, pango_coverage_copy((PangoCoverage*)s7_c_pointer(coverage))));
}

static s7_pointer lg_pango_coverage_get(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_get "PangoCoverageLevel pango_coverage_get(PangoCoverage* coverage, int index)"
  s7_pointer _p;
  s7_pointer coverage, index;
  _p = args;
  coverage = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_get", 1, coverage, "PangoCoverage*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_coverage_get", 2, index, "int");
  return(s7_make_integer(sc, pango_coverage_get((PangoCoverage*)s7_c_pointer(coverage), (int)s7_integer(index))));
}

static s7_pointer lg_pango_coverage_set(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_coverage_set "void pango_coverage_set(PangoCoverage* coverage, int index, PangoCoverageLevel level)"
  s7_pointer _p;
  s7_pointer coverage, index, level;
  _p = args;
  coverage = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(coverage, PangoCoverage__sym)) s7_wrong_type_arg_error(sc, "pango_coverage_set", 1, coverage, "PangoCoverage*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_coverage_set", 2, index, "int");
  level = s7_car(_p);
  if (!s7_is_integer(level)) s7_wrong_type_arg_error(sc, "pango_coverage_set", 3, level, "PangoCoverageLevel");
  pango_coverage_set((PangoCoverage*)s7_c_pointer(coverage), (int)s7_integer(index), (PangoCoverageLevel)s7_integer(level));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_new "PangoFontDescription* pango_font_description_new( void)"
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_font_description_new()));
}

static s7_pointer lg_pango_font_description_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_copy "PangoFontDescription* pango_font_description_copy(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_copy", 1, desc, "PangoFontDescription*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_font_description_copy((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_copy_static(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_copy_static "PangoFontDescription* pango_font_description_copy_static(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_copy_static", 1, desc, "PangoFontDescription*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_font_description_copy_static((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_hash(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_hash "guint pango_font_description_hash(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_hash", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_hash((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_equal "gboolean pango_font_description_equal(PangoFontDescription* desc1, \
PangoFontDescription* desc2)"
  s7_pointer _p;
  s7_pointer desc1, desc2;
  _p = args;
  desc1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc1, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_equal", 1, desc1, "PangoFontDescription*");
  desc2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(desc2, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_equal", 2, desc2, "PangoFontDescription*");
  return(s7_make_boolean(sc, pango_font_description_equal((PangoFontDescription*)s7_c_pointer(desc1), (PangoFontDescription*)s7_c_pointer(desc2))));
}

static s7_pointer lg_pango_font_description_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_free "void pango_font_description_free(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_free", 1, desc, "PangoFontDescription*");
  pango_font_description_free((PangoFontDescription*)s7_c_pointer(desc));
  return(lg_false);
}

static s7_pointer lg_pango_font_descriptions_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_descriptions_free "void pango_font_descriptions_free(PangoFontDescription** descs, \
int n_descs)"
  s7_pointer _p;
  s7_pointer descs, n_descs;
  _p = args;
  descs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(descs, PangoFontDescription___sym)) s7_wrong_type_arg_error(sc, "pango_font_descriptions_free", 1, descs, "PangoFontDescription**");
  n_descs = s7_car(_p);
  if (!s7_is_integer(n_descs)) s7_wrong_type_arg_error(sc, "pango_font_descriptions_free", 2, n_descs, "int");
  pango_font_descriptions_free((PangoFontDescription**)s7_c_pointer(descs), (int)s7_integer(n_descs));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_set_family(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_family "void pango_font_description_set_family(PangoFontDescription* desc, \
char* family)"
  s7_pointer _p;
  s7_pointer desc, family;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family", 1, desc, "PangoFontDescription*");
  family = s7_car(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family", 2, family, "char*");
  pango_font_description_set_family((PangoFontDescription*)s7_c_pointer(desc), (char*)s7_string(family));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_set_family_static(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_family_static "void pango_font_description_set_family_static(PangoFontDescription* desc, \
char* family)"
  s7_pointer _p;
  s7_pointer desc, family;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family_static", 1, desc, "PangoFontDescription*");
  family = s7_car(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "pango_font_description_set_family_static", 2, family, "char*");
  pango_font_description_set_family_static((PangoFontDescription*)s7_c_pointer(desc), (char*)s7_string(family));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_family(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_family "char* pango_font_description_get_family(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_family", 1, desc, "PangoFontDescription*");
  return(s7_make_string(sc, pango_font_description_get_family((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_style(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_style "void pango_font_description_set_style(PangoFontDescription* desc, \
PangoStyle style)"
  s7_pointer _p;
  s7_pointer desc, style;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_style", 1, desc, "PangoFontDescription*");
  style = s7_car(_p);
  if (!s7_is_integer(style)) s7_wrong_type_arg_error(sc, "pango_font_description_set_style", 2, style, "PangoStyle");
  pango_font_description_set_style((PangoFontDescription*)s7_c_pointer(desc), (PangoStyle)s7_integer(style));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_style(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_style "PangoStyle pango_font_description_get_style(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_style", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_style((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_variant(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_variant "void pango_font_description_set_variant(PangoFontDescription* desc, \
PangoVariant variant)"
  s7_pointer _p;
  s7_pointer desc, variant;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_variant", 1, desc, "PangoFontDescription*");
  variant = s7_car(_p);
  if (!s7_is_integer(variant)) s7_wrong_type_arg_error(sc, "pango_font_description_set_variant", 2, variant, "PangoVariant");
  pango_font_description_set_variant((PangoFontDescription*)s7_c_pointer(desc), (PangoVariant)s7_integer(variant));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_variant(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_variant "PangoVariant pango_font_description_get_variant(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_variant", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_variant((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_weight(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_weight "void pango_font_description_set_weight(PangoFontDescription* desc, \
PangoWeight weight)"
  s7_pointer _p;
  s7_pointer desc, weight;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_weight", 1, desc, "PangoFontDescription*");
  weight = s7_car(_p);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "pango_font_description_set_weight", 2, weight, "PangoWeight");
  pango_font_description_set_weight((PangoFontDescription*)s7_c_pointer(desc), (PangoWeight)s7_integer(weight));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_weight(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_weight "PangoWeight pango_font_description_get_weight(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_weight", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_weight((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_stretch(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_stretch "void pango_font_description_set_stretch(PangoFontDescription* desc, \
PangoStretch stretch)"
  s7_pointer _p;
  s7_pointer desc, stretch;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_stretch", 1, desc, "PangoFontDescription*");
  stretch = s7_car(_p);
  if (!s7_is_integer(stretch)) s7_wrong_type_arg_error(sc, "pango_font_description_set_stretch", 2, stretch, "PangoStretch");
  pango_font_description_set_stretch((PangoFontDescription*)s7_c_pointer(desc), (PangoStretch)s7_integer(stretch));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_stretch(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_stretch "PangoStretch pango_font_description_get_stretch(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_stretch", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_stretch((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_set_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_size "void pango_font_description_set_size(PangoFontDescription* desc, \
gint size)"
  s7_pointer _p;
  s7_pointer desc, size;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_size", 1, desc, "PangoFontDescription*");
  size = s7_car(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "pango_font_description_set_size", 2, size, "gint");
  pango_font_description_set_size((PangoFontDescription*)s7_c_pointer(desc), (gint)s7_integer(size));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_size "gint pango_font_description_get_size(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_size", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_size((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_get_set_fields(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_get_set_fields "PangoFontMask pango_font_description_get_set_fields(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_get_set_fields", 1, desc, "PangoFontDescription*");
  return(s7_make_integer(sc, pango_font_description_get_set_fields((PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_description_unset_fields(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_unset_fields "void pango_font_description_unset_fields(PangoFontDescription* desc, \
PangoFontMask to_unset)"
  s7_pointer _p;
  s7_pointer desc, to_unset;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_unset_fields", 1, desc, "PangoFontDescription*");
  to_unset = s7_car(_p);
  if (!s7_is_integer(to_unset)) s7_wrong_type_arg_error(sc, "pango_font_description_unset_fields", 2, to_unset, "PangoFontMask");
  pango_font_description_unset_fields((PangoFontDescription*)s7_c_pointer(desc), (PangoFontMask)s7_integer(to_unset));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_merge(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_merge "void pango_font_description_merge(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  s7_pointer _p;
  s7_pointer desc, desc_to_merge, replace_existing;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge", 1, desc, "PangoFontDescription*");
  desc_to_merge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc_to_merge, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge", 2, desc_to_merge, "PangoFontDescription*");
  replace_existing = s7_car(_p);
  if (!s7_is_boolean(replace_existing)) s7_wrong_type_arg_error(sc, "pango_font_description_merge", 3, replace_existing, "gboolean");
  pango_font_description_merge((PangoFontDescription*)s7_c_pointer(desc), (PangoFontDescription*)s7_c_pointer(desc_to_merge), (gboolean)lg_boolean(replace_existing));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_merge_static(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_merge_static "void pango_font_description_merge_static(PangoFontDescription* desc, \
PangoFontDescription* desc_to_merge, gboolean replace_existing)"
  s7_pointer _p;
  s7_pointer desc, desc_to_merge, replace_existing;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge_static", 1, desc, "PangoFontDescription*");
  desc_to_merge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc_to_merge, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_merge_static", 2, desc_to_merge, "PangoFontDescription*");
  replace_existing = s7_car(_p);
  if (!s7_is_boolean(replace_existing)) s7_wrong_type_arg_error(sc, "pango_font_description_merge_static", 3, replace_existing, "gboolean");
  pango_font_description_merge_static((PangoFontDescription*)s7_c_pointer(desc), (PangoFontDescription*)s7_c_pointer(desc_to_merge), (gboolean)lg_boolean(replace_existing));
  return(lg_false);
}

static s7_pointer lg_pango_font_description_better_match(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_better_match "gboolean pango_font_description_better_match(PangoFontDescription* desc, \
PangoFontDescription* old_match, PangoFontDescription* new_match)"
  s7_pointer _p;
  s7_pointer desc, old_match, new_match;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_better_match", 1, desc, "PangoFontDescription*");
  old_match = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(old_match, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_better_match", 2, old_match, "PangoFontDescription*");
  new_match = s7_car(_p);
  if (!s7_is_c_pointer_of_type(new_match, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_better_match", 3, new_match, "PangoFontDescription*");
  return(s7_make_boolean(sc, pango_font_description_better_match((PangoFontDescription*)s7_c_pointer(desc), (PangoFontDescription*)s7_c_pointer(old_match), (PangoFontDescription*)s7_c_pointer(new_match))));
}

static s7_pointer lg_pango_font_description_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_from_string "PangoFontDescription* pango_font_description_from_string(char* str)"
  s7_pointer str;
  str = s7_car(args);
  if (!s7_is_string(str)) s7_wrong_type_arg_error(sc, "pango_font_description_from_string", 1, str, "char*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_font_description_from_string((char*)s7_string(str))));
}

static s7_pointer lg_pango_font_description_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_to_string "char* pango_font_description_to_string(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_to_string", 1, desc, "PangoFontDescription*");
  {
    char* res_ult;
    s7_pointer rtn;
    res_ult = pango_font_description_to_string((PangoFontDescription*)s7_c_pointer(desc));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_pango_font_description_to_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_to_filename "char* pango_font_description_to_filename(PangoFontDescription* desc)"
  s7_pointer desc;
  desc = s7_car(args);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_to_filename", 1, desc, "PangoFontDescription*");
  {
    char* res_ult;
    s7_pointer rtn;
    res_ult = pango_font_description_to_filename((PangoFontDescription*)s7_c_pointer(desc));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_pango_font_metrics_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_ref "PangoFontMetrics* pango_font_metrics_ref(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_ref", 1, metrics, "PangoFontMetrics*");
  return(lg_make_c_pointer_with_type(sc, PangoFontMetrics__sym, pango_font_metrics_ref((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_unref "void pango_font_metrics_unref(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_unref", 1, metrics, "PangoFontMetrics*");
  pango_font_metrics_unref((PangoFontMetrics*)s7_c_pointer(metrics));
  return(lg_false);
}

static s7_pointer lg_pango_font_metrics_get_ascent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_ascent "int pango_font_metrics_get_ascent(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_ascent", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_ascent((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_descent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_descent "int pango_font_metrics_get_descent(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_descent", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_descent((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_approximate_char_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_approximate_char_width "int pango_font_metrics_get_approximate_char_width(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_approximate_char_width", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_approximate_char_width((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_approximate_digit_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_approximate_digit_width "int pango_font_metrics_get_approximate_digit_width(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_approximate_digit_width", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_approximate_digit_width((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_family_list_faces(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_family_list_faces "void pango_font_family_list_faces(PangoFontFamily* family, \
PangoFontFace*** [faces], int* [n_faces])"
  s7_pointer _p;
  s7_pointer family;
  PangoFontFace** ref_faces = NULL;
  int ref_n_faces;
  _p = args;
  family = s7_car(_p);
  if (!s7_is_c_pointer_of_type(family, PangoFontFamily__sym)) s7_wrong_type_arg_error(sc, "pango_font_family_list_faces", 1, family, "PangoFontFamily*");
  pango_font_family_list_faces((PangoFontFamily*)s7_c_pointer(family), &ref_faces, &ref_n_faces);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_faces), s7_make_integer(sc, ref_n_faces)));
}

static s7_pointer lg_pango_font_family_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_family_get_name "char* pango_font_family_get_name(PangoFontFamily* family)"
  s7_pointer family;
  family = s7_car(args);
  if (!s7_is_c_pointer_of_type(family, PangoFontFamily__sym)) s7_wrong_type_arg_error(sc, "pango_font_family_get_name", 1, family, "PangoFontFamily*");
  return(s7_make_string(sc, pango_font_family_get_name((PangoFontFamily*)s7_c_pointer(family))));
}

static s7_pointer lg_pango_font_face_describe(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_face_describe "PangoFontDescription* pango_font_face_describe(PangoFontFace* face)"
  s7_pointer face;
  face = s7_car(args);
  if (!s7_is_c_pointer_of_type(face, PangoFontFace__sym)) s7_wrong_type_arg_error(sc, "pango_font_face_describe", 1, face, "PangoFontFace*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_font_face_describe((PangoFontFace*)s7_c_pointer(face))));
}

static s7_pointer lg_pango_font_face_get_face_name(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_face_get_face_name "char* pango_font_face_get_face_name(PangoFontFace* face)"
  s7_pointer face;
  face = s7_car(args);
  if (!s7_is_c_pointer_of_type(face, PangoFontFace__sym)) s7_wrong_type_arg_error(sc, "pango_font_face_get_face_name", 1, face, "PangoFontFace*");
  return(s7_make_string(sc, pango_font_face_get_face_name((PangoFontFace*)s7_c_pointer(face))));
}

static s7_pointer lg_pango_font_describe(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_describe "PangoFontDescription* pango_font_describe(PangoFont* font)"
  s7_pointer font;
  font = s7_car(args);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_describe", 1, font, "PangoFont*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, pango_font_describe((PangoFont*)s7_c_pointer(font))));
}

static s7_pointer lg_pango_font_get_coverage(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_get_coverage "PangoCoverage* pango_font_get_coverage(PangoFont* font, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer font, language;
  _p = args;
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_coverage", 1, font, "PangoFont*");
  language = s7_car(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_coverage", 2, language, "PangoLanguage*");
  return(lg_make_c_pointer_with_type(sc, PangoCoverage__sym, pango_font_get_coverage((PangoFont*)s7_c_pointer(font), (PangoLanguage*)s7_c_pointer(language))));
}

static s7_pointer lg_pango_font_get_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_get_metrics "PangoFontMetrics* pango_font_get_metrics(PangoFont* font, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer font, language;
  _p = args;
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_metrics", 1, font, "PangoFont*");
  language = s7_car(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_metrics", 2, language, "PangoLanguage*");
  return(lg_make_c_pointer_with_type(sc, PangoFontMetrics__sym, pango_font_get_metrics((PangoFont*)s7_c_pointer(font), (PangoLanguage*)s7_c_pointer(language))));
}

static s7_pointer lg_pango_font_get_glyph_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_get_glyph_extents "void pango_font_get_glyph_extents(PangoFont* font, PangoGlyph glyph, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer font, glyph, ink_rect, logical_rect;
  _p = args;
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 1, font, "PangoFont*");
  glyph = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(glyph)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 2, glyph, "PangoGlyph");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 3, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_font_get_glyph_extents", 4, logical_rect, "PangoRectangle*");
  pango_font_get_glyph_extents((PangoFont*)s7_c_pointer(font), (PangoGlyph)s7_integer(glyph), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_font_map_load_font(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_load_font "PangoFont* pango_font_map_load_font(PangoFontMap* fontmap, PangoContext* context, \
PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer fontmap, context, desc;
  _p = args;
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_font", 1, fontmap, "PangoFontMap*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_font", 2, context, "PangoContext*");
  desc = s7_car(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_font", 3, desc, "PangoFontDescription*");
  return(lg_make_c_pointer_with_type(sc, PangoFont__sym, pango_font_map_load_font((PangoFontMap*)s7_c_pointer(fontmap), (PangoContext*)s7_c_pointer(context), (PangoFontDescription*)s7_c_pointer(desc))));
}

static s7_pointer lg_pango_font_map_load_fontset(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_load_fontset "PangoFontset* pango_font_map_load_fontset(PangoFontMap* fontmap, \
PangoContext* context, PangoFontDescription* desc, PangoLanguage* language)"
  s7_pointer _p;
  s7_pointer fontmap, context, desc, language;
  _p = args;
  fontmap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 1, fontmap, "PangoFontMap*");
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 2, context, "PangoContext*");
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 3, desc, "PangoFontDescription*");
  language = s7_car(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_load_fontset", 4, language, "PangoLanguage*");
  return(lg_make_c_pointer_with_type(sc, PangoFontset__sym, pango_font_map_load_fontset((PangoFontMap*)s7_c_pointer(fontmap), (PangoContext*)s7_c_pointer(context), (PangoFontDescription*)s7_c_pointer(desc), (PangoLanguage*)s7_c_pointer(language))));
}

static s7_pointer lg_pango_font_map_list_families(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_list_families "void pango_font_map_list_families(PangoFontMap* fontmap, PangoFontFamily*** [families], \
int* [n_families])"
  s7_pointer _p;
  s7_pointer fontmap;
  PangoFontFamily** ref_families = NULL;
  int ref_n_families;
  _p = args;
  fontmap = s7_car(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_list_families", 1, fontmap, "PangoFontMap*");
  pango_font_map_list_families((PangoFontMap*)s7_c_pointer(fontmap), &ref_families, &ref_n_families);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_families), s7_make_integer(sc, ref_n_families)));
}

static s7_pointer lg_pango_glyph_string_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_new "PangoGlyphString* pango_glyph_string_new( void)"
  return(lg_make_c_pointer_with_type(sc, PangoGlyphString__sym, pango_glyph_string_new()));
}

static s7_pointer lg_pango_glyph_string_set_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_set_size "void pango_glyph_string_set_size(PangoGlyphString* string, gint new_len)"
  s7_pointer _p;
  s7_pointer string, new_len;
  _p = args;
  string = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(string, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_set_size", 1, string, "PangoGlyphString*");
  new_len = s7_car(_p);
  if (!s7_is_integer(new_len)) s7_wrong_type_arg_error(sc, "pango_glyph_string_set_size", 2, new_len, "gint");
  pango_glyph_string_set_size((PangoGlyphString*)s7_c_pointer(string), (gint)s7_integer(new_len));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_copy "PangoGlyphString* pango_glyph_string_copy(PangoGlyphString* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_c_pointer_of_type(string, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_copy", 1, string, "PangoGlyphString*");
  return(lg_make_c_pointer_with_type(sc, PangoGlyphString__sym, pango_glyph_string_copy((PangoGlyphString*)s7_c_pointer(string))));
}

static s7_pointer lg_pango_glyph_string_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_free "void pango_glyph_string_free(PangoGlyphString* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_c_pointer_of_type(string, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_free", 1, string, "PangoGlyphString*");
  pango_glyph_string_free((PangoGlyphString*)s7_c_pointer(string));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_extents "void pango_glyph_string_extents(PangoGlyphString* glyphs, PangoFont* font, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer glyphs, font, ink_rect, logical_rect;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 1, glyphs, "PangoGlyphString*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 2, font, "PangoFont*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 3, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents", 4, logical_rect, "PangoRectangle*");
  pango_glyph_string_extents((PangoGlyphString*)s7_c_pointer(glyphs), (PangoFont*)s7_c_pointer(font), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_extents_range(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_extents_range "void pango_glyph_string_extents_range(PangoGlyphString* glyphs, \
int start, int end, PangoFont* font, PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer glyphs, start, end, font, ink_rect, logical_rect;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 1, glyphs, "PangoGlyphString*");
  start = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 2, start, "int");
  end = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(end)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 3, end, "int");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 4, font, "PangoFont*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 5, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_extents_range", 6, logical_rect, "PangoRectangle*");
  pango_glyph_string_extents_range((PangoGlyphString*)s7_c_pointer(glyphs), (int)s7_integer(start), (int)s7_integer(end), (PangoFont*)s7_c_pointer(font), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_glyph_string_get_logical_widths(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_get_logical_widths "void pango_glyph_string_get_logical_widths(PangoGlyphString* glyphs, \
char* text, int length, int embedding_level, int* [logical_widths])"
  s7_pointer _p;
  s7_pointer glyphs, text, length, embedding_level;
  int ref_logical_widths;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 1, glyphs, "PangoGlyphString*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 3, length, "int");
  embedding_level = s7_car(_p);
  if (!s7_is_integer(embedding_level)) s7_wrong_type_arg_error(sc, "pango_glyph_string_get_logical_widths", 4, embedding_level, "int");
  pango_glyph_string_get_logical_widths((PangoGlyphString*)s7_c_pointer(glyphs), (char*)s7_string(text), (int)s7_integer(length), (int)s7_integer(embedding_level), &ref_logical_widths);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_logical_widths)));
}

static s7_pointer lg_pango_glyph_string_index_to_x(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_index_to_x "void pango_glyph_string_index_to_x(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int index, gboolean trailing, int* [x_pos])"
  s7_pointer _p;
  s7_pointer glyphs, text, length, analysis, index, trailing;
  int ref_x_pos;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 1, glyphs, "PangoGlyphString*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 3, length, "int");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 4, analysis, "PangoAnalysis*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 5, index, "int");
  trailing = s7_car(_p);
  if (!s7_is_boolean(trailing)) s7_wrong_type_arg_error(sc, "pango_glyph_string_index_to_x", 6, trailing, "gboolean");
  pango_glyph_string_index_to_x((PangoGlyphString*)s7_c_pointer(glyphs), (char*)s7_string(text), (int)s7_integer(length), (PangoAnalysis*)s7_c_pointer(analysis), (int)s7_integer(index), (gboolean)lg_boolean(trailing), &ref_x_pos);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_x_pos)));
}

static s7_pointer lg_pango_glyph_string_x_to_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_glyph_string_x_to_index "void pango_glyph_string_x_to_index(PangoGlyphString* glyphs, \
char* text, int length, PangoAnalysis* analysis, int x_pos, int* [index], int* [trailing])"
  s7_pointer _p;
  s7_pointer glyphs, text, length, analysis, x_pos;
  int ref_index;
  int ref_trailing;
  _p = args;
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 1, glyphs, "PangoGlyphString*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 2, text, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 3, length, "int");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 4, analysis, "PangoAnalysis*");
  x_pos = s7_car(_p);
  if (!s7_is_integer(x_pos)) s7_wrong_type_arg_error(sc, "pango_glyph_string_x_to_index", 5, x_pos, "int");
  pango_glyph_string_x_to_index((PangoGlyphString*)s7_c_pointer(glyphs), (char*)s7_string(text), (int)s7_integer(length), (PangoAnalysis*)s7_c_pointer(analysis), (int)s7_integer(x_pos), &ref_index, &ref_trailing);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_index), s7_make_integer(sc, ref_trailing)));
}

static s7_pointer lg_pango_shape(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_shape "void pango_shape(gchar* text, gint length, PangoAnalysis* analysis, PangoGlyphString* glyphs)"
  s7_pointer _p;
  s7_pointer text, length, analysis, glyphs;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_shape", 1, text, "gchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_shape", 2, length, "gint");
  analysis = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(analysis, PangoAnalysis__sym)) s7_wrong_type_arg_error(sc, "pango_shape", 3, analysis, "PangoAnalysis*");
  glyphs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_shape", 4, glyphs, "PangoGlyphString*");
  pango_shape((gchar*)s7_string(text), (gint)s7_integer(length), (PangoAnalysis*)s7_c_pointer(analysis), (PangoGlyphString*)s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_pango_reorder_items(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_reorder_items "GList* pango_reorder_items(GList* logical_items)"
  s7_pointer logical_items;
  logical_items = s7_car(args);
  if (!s7_is_c_pointer_of_type(logical_items, GList__sym)) s7_wrong_type_arg_error(sc, "pango_reorder_items", 1, logical_items, "GList*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, pango_reorder_items((GList*)s7_c_pointer(logical_items))));
}

static s7_pointer lg_pango_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_new "PangoItem* pango_item_new( void)"
  return(lg_make_c_pointer_with_type(sc, PangoItem__sym, pango_item_new()));
}

static s7_pointer lg_pango_item_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_copy "PangoItem* pango_item_copy(PangoItem* item)"
  s7_pointer item;
  item = s7_car(args);
  if (!s7_is_c_pointer_of_type(item, PangoItem__sym)) s7_wrong_type_arg_error(sc, "pango_item_copy", 1, item, "PangoItem*");
  return(lg_make_c_pointer_with_type(sc, PangoItem__sym, pango_item_copy((PangoItem*)s7_c_pointer(item))));
}

static s7_pointer lg_pango_item_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_free "void pango_item_free(PangoItem* item)"
  s7_pointer item;
  item = s7_car(args);
  if (!s7_is_c_pointer_of_type(item, PangoItem__sym)) s7_wrong_type_arg_error(sc, "pango_item_free", 1, item, "PangoItem*");
  pango_item_free((PangoItem*)s7_c_pointer(item));
  return(lg_false);
}

static s7_pointer lg_pango_item_split(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_item_split "PangoItem* pango_item_split(PangoItem* orig, int split_index, int split_offset)"
  s7_pointer _p;
  s7_pointer orig, split_index, split_offset;
  _p = args;
  orig = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(orig, PangoItem__sym)) s7_wrong_type_arg_error(sc, "pango_item_split", 1, orig, "PangoItem*");
  split_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(split_index)) s7_wrong_type_arg_error(sc, "pango_item_split", 2, split_index, "int");
  split_offset = s7_car(_p);
  if (!s7_is_integer(split_offset)) s7_wrong_type_arg_error(sc, "pango_item_split", 3, split_offset, "int");
  return(lg_make_c_pointer_with_type(sc, PangoItem__sym, pango_item_split((PangoItem*)s7_c_pointer(orig), (int)s7_integer(split_index), (int)s7_integer(split_offset))));
}

static s7_pointer lg_pango_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_new "PangoLayout* pango_layout_new(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_layout_new", 1, context, "PangoContext*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, pango_layout_new((PangoContext*)s7_c_pointer(context))));
}

static s7_pointer lg_pango_layout_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_copy "PangoLayout* pango_layout_copy(PangoLayout* src)"
  s7_pointer src;
  src = s7_car(args);
  if (!s7_is_c_pointer_of_type(src, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_copy", 1, src, "PangoLayout*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, pango_layout_copy((PangoLayout*)s7_c_pointer(src))));
}

static s7_pointer lg_pango_layout_get_context(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_context "PangoContext* pango_layout_get_context(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_context", 1, layout, "PangoLayout*");
  return(lg_make_c_pointer_with_type(sc, PangoContext__sym, pango_layout_get_context((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_attributes "void pango_layout_set_attributes(PangoLayout* layout, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer layout, attrs;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_attributes", 1, layout, "PangoLayout*");
  attrs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_attributes", 2, attrs, "PangoAttrList*");
  pango_layout_set_attributes((PangoLayout*)s7_c_pointer(layout), (PangoAttrList*)s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_attributes "PangoAttrList* pango_layout_get_attributes(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_attributes", 1, layout, "PangoLayout*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, pango_layout_get_attributes((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_text "void pango_layout_set_text(PangoLayout* layout, char* text, int length)"
  s7_pointer _p;
  s7_pointer layout, text, length;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_text", 1, layout, "PangoLayout*");
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_layout_set_text", 2, text, "char*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_layout_set_text", 3, length, "int");
  pango_layout_set_text((PangoLayout*)s7_c_pointer(layout), (char*)s7_string(text), (int)s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_text "char* pango_layout_get_text(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_text", 1, layout, "PangoLayout*");
  return(s7_make_string(sc, pango_layout_get_text((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_markup "void pango_layout_set_markup(PangoLayout* layout, char* markup, \
int length)"
  s7_pointer _p;
  s7_pointer layout, markup, length;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup", 1, layout, "PangoLayout*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup", 2, markup, "char*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup", 3, length, "int");
  pango_layout_set_markup((PangoLayout*)s7_c_pointer(layout), (char*)s7_string(markup), (int)s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_pango_layout_set_markup_with_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_markup_with_accel "void pango_layout_set_markup_with_accel(PangoLayout* layout, \
char* markup, int length, gunichar accel_marker, gunichar* accel_char)"
  s7_pointer _p;
  s7_pointer layout, markup, length, accel_marker, accel_char;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 1, layout, "PangoLayout*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 2, markup, "char*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 3, length, "int");
  accel_marker = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accel_marker)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 4, accel_marker, "gunichar");
  accel_char = s7_car(_p);
  if (!s7_is_c_pointer_of_type(accel_char, gunichar__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_markup_with_accel", 5, accel_char, "gunichar*");
  pango_layout_set_markup_with_accel((PangoLayout*)s7_c_pointer(layout), (char*)s7_string(markup), (int)s7_integer(length), (gunichar)s7_integer(accel_marker), (gunichar*)s7_c_pointer(accel_char));
  return(lg_false);
}

static s7_pointer lg_pango_layout_set_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_font_description "void pango_layout_set_font_description(PangoLayout* layout, \
PangoFontDescription* desc)"
  s7_pointer _p;
  s7_pointer layout, desc;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_font_description", 1, layout, "PangoLayout*");
  desc = s7_car(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_font_description", 2, desc, "PangoFontDescription*");
  pango_layout_set_font_description((PangoLayout*)s7_c_pointer(layout), (PangoFontDescription*)s7_c_pointer(desc));
  return(lg_false);
}

static s7_pointer lg_pango_layout_set_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_width "void pango_layout_set_width(PangoLayout* layout, int width)"
  s7_pointer _p;
  s7_pointer layout, width;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_width", 1, layout, "PangoLayout*");
  width = s7_car(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "pango_layout_set_width", 2, width, "int");
  pango_layout_set_width((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_width "int pango_layout_get_width(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_width", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_width((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_wrap "void pango_layout_set_wrap(PangoLayout* layout, PangoWrapMode wrap)"
  s7_pointer _p;
  s7_pointer layout, wrap;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_wrap", 1, layout, "PangoLayout*");
  wrap = s7_car(_p);
  if (!s7_is_integer(wrap)) s7_wrong_type_arg_error(sc, "pango_layout_set_wrap", 2, wrap, "PangoWrapMode");
  pango_layout_set_wrap((PangoLayout*)s7_c_pointer(layout), (PangoWrapMode)s7_integer(wrap));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_wrap "PangoWrapMode pango_layout_get_wrap(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_wrap", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_wrap((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_indent "void pango_layout_set_indent(PangoLayout* layout, int indent)"
  s7_pointer _p;
  s7_pointer layout, indent;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_indent", 1, layout, "PangoLayout*");
  indent = s7_car(_p);
  if (!s7_is_integer(indent)) s7_wrong_type_arg_error(sc, "pango_layout_set_indent", 2, indent, "int");
  pango_layout_set_indent((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(indent));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_indent(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_indent "int pango_layout_get_indent(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_indent", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_indent((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_spacing "void pango_layout_set_spacing(PangoLayout* layout, int spacing)"
  s7_pointer _p;
  s7_pointer layout, spacing;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_spacing", 1, layout, "PangoLayout*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "pango_layout_set_spacing", 2, spacing, "int");
  pango_layout_set_spacing((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_spacing "int pango_layout_get_spacing(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_spacing", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_spacing((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_justify "void pango_layout_set_justify(PangoLayout* layout, gboolean justify)"
  s7_pointer _p;
  s7_pointer layout, justify;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_justify", 1, layout, "PangoLayout*");
  justify = s7_car(_p);
  if (!s7_is_boolean(justify)) s7_wrong_type_arg_error(sc, "pango_layout_set_justify", 2, justify, "gboolean");
  pango_layout_set_justify((PangoLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(justify));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_justify(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_justify "gboolean pango_layout_get_justify(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_justify", 1, layout, "PangoLayout*");
  return(s7_make_boolean(sc, pango_layout_get_justify((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_alignment "void pango_layout_set_alignment(PangoLayout* layout, PangoAlignment alignment)"
  s7_pointer _p;
  s7_pointer layout, alignment;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_alignment", 1, layout, "PangoLayout*");
  alignment = s7_car(_p);
  if (!s7_is_integer(alignment)) s7_wrong_type_arg_error(sc, "pango_layout_set_alignment", 2, alignment, "PangoAlignment");
  pango_layout_set_alignment((PangoLayout*)s7_c_pointer(layout), (PangoAlignment)s7_integer(alignment));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_alignment "PangoAlignment pango_layout_get_alignment(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_alignment", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_alignment((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_tabs "void pango_layout_set_tabs(PangoLayout* layout, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer layout, tabs;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_tabs", 1, layout, "PangoLayout*");
  tabs = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) && (tabs != lg_false)) s7_wrong_type_arg_error(sc, "pango_layout_set_tabs", 2, tabs, "PangoTabArray*");
  pango_layout_set_tabs((PangoLayout*)s7_c_pointer(layout), (PangoTabArray*)s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_tabs "PangoTabArray* pango_layout_get_tabs(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_tabs", 1, layout, "PangoLayout*");
  return(lg_make_c_pointer_with_type(sc, PangoTabArray__sym, pango_layout_get_tabs((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_set_single_paragraph_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_single_paragraph_mode "void pango_layout_set_single_paragraph_mode(PangoLayout* layout, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer layout, setting;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_single_paragraph_mode", 1, layout, "PangoLayout*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "pango_layout_set_single_paragraph_mode", 2, setting, "gboolean");
  pango_layout_set_single_paragraph_mode((PangoLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_single_paragraph_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_single_paragraph_mode "gboolean pango_layout_get_single_paragraph_mode(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_single_paragraph_mode", 1, layout, "PangoLayout*");
  return(s7_make_boolean(sc, pango_layout_get_single_paragraph_mode((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_context_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_context_changed "void pango_layout_context_changed(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_context_changed", 1, layout, "PangoLayout*");
  pango_layout_context_changed((PangoLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_log_attrs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_log_attrs "void pango_layout_get_log_attrs(PangoLayout* layout, PangoLogAttr** [attrs], \
gint* [n_attrs])"
  s7_pointer _p;
  s7_pointer layout;
  PangoLogAttr* ref_attrs = NULL;
  gint ref_n_attrs;
  _p = args;
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_log_attrs", 1, layout, "PangoLayout*");
  pango_layout_get_log_attrs((PangoLayout*)s7_c_pointer(layout), &ref_attrs, &ref_n_attrs);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_attrs), s7_make_integer(sc, ref_n_attrs)));
}

static s7_pointer lg_pango_layout_index_to_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_index_to_pos "void pango_layout_index_to_pos(PangoLayout* layout, int index, \
PangoRectangle* pos)"
  s7_pointer _p;
  s7_pointer layout, index, pos;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_pos", 1, layout, "PangoLayout*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_pos", 2, index, "int");
  pos = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pos, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_pos", 3, pos, "PangoRectangle*");
  pango_layout_index_to_pos((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(index), (PangoRectangle*)s7_c_pointer(pos));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_cursor_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_cursor_pos "void pango_layout_get_cursor_pos(PangoLayout* layout, int index, \
PangoRectangle* strong_pos, PangoRectangle* weak_pos)"
  s7_pointer _p;
  s7_pointer layout, index, strong_pos, weak_pos;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 1, layout, "PangoLayout*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 2, index, "int");
  strong_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(strong_pos, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 3, strong_pos, "PangoRectangle*");
  weak_pos = s7_car(_p);
  if (!s7_is_c_pointer_of_type(weak_pos, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_cursor_pos", 4, weak_pos, "PangoRectangle*");
  pango_layout_get_cursor_pos((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(index), (PangoRectangle*)s7_c_pointer(strong_pos), (PangoRectangle*)s7_c_pointer(weak_pos));
  return(lg_false);
}

static s7_pointer lg_pango_layout_move_cursor_visually(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_move_cursor_visually "void pango_layout_move_cursor_visually(PangoLayout* layout, \
gboolean strong, int old_index, int old_trailing, int direction, int* new_index, int* new_trailing)"
  s7_pointer _p;
  s7_pointer layout, strong, old_index, old_trailing, direction, new_index, new_trailing;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 1, layout, "PangoLayout*");
  strong = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(strong)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 2, strong, "gboolean");
  old_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(old_index)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 3, old_index, "int");
  old_trailing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(old_trailing)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 4, old_trailing, "int");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 5, direction, "int");
  new_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_index, int__sym)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 6, new_index, "int*");
  new_trailing = s7_car(_p);
  if (!s7_is_c_pointer_of_type(new_trailing, int__sym)) s7_wrong_type_arg_error(sc, "pango_layout_move_cursor_visually", 7, new_trailing, "int*");
  pango_layout_move_cursor_visually((PangoLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(strong), (int)s7_integer(old_index), (int)s7_integer(old_trailing), (int)s7_integer(direction), (int*)s7_c_pointer(new_index), (int*)s7_c_pointer(new_trailing));
  return(lg_false);
}

static s7_pointer lg_pango_layout_xy_to_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_xy_to_index "gboolean pango_layout_xy_to_index(PangoLayout* layout, int x, int y, \
int* [index], int* [trailing])"
  s7_pointer _p;
  s7_pointer layout, x, y;
  int ref_index;
  int ref_trailing;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_xy_to_index", 1, layout, "PangoLayout*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_layout_xy_to_index", 2, x, "int");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_layout_xy_to_index", 3, y, "int");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, pango_layout_xy_to_index((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(x), (int)s7_integer(y), &ref_index, &ref_trailing));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_index), s7_make_integer(sc, ref_trailing)));
   }
}

static s7_pointer lg_pango_layout_get_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_extents "void pango_layout_get_extents(PangoLayout* layout, PangoRectangle* ink_rect, \
PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer layout, ink_rect, logical_rect;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_extents", 1, layout, "PangoLayout*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_get_extents((PangoLayout*)s7_c_pointer(layout), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_pixel_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_pixel_extents "void pango_layout_get_pixel_extents(PangoLayout* layout, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer layout, ink_rect, logical_rect;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_extents", 1, layout, "PangoLayout*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_get_pixel_extents((PangoLayout*)s7_c_pointer(layout), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_size "void pango_layout_get_size(PangoLayout* layout, int* [width], int* [height])"
  s7_pointer _p;
  s7_pointer layout;
  int ref_width;
  int ref_height;
  _p = args;
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_size", 1, layout, "PangoLayout*");
  pango_layout_get_size((PangoLayout*)s7_c_pointer(layout), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_pango_layout_get_pixel_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_pixel_size "void pango_layout_get_pixel_size(PangoLayout* layout, int* [width], \
int* [height])"
  s7_pointer _p;
  s7_pointer layout;
  int ref_width;
  int ref_height;
  _p = args;
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_pixel_size", 1, layout, "PangoLayout*");
  pango_layout_get_pixel_size((PangoLayout*)s7_c_pointer(layout), &ref_width, &ref_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_pango_layout_get_line_count(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_line_count "int pango_layout_get_line_count(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_line_count", 1, layout, "PangoLayout*");
  return(s7_make_integer(sc, pango_layout_get_line_count((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_get_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_line "PangoLayoutLine* pango_layout_get_line(PangoLayout* layout, int line)"
  s7_pointer _p;
  s7_pointer layout, line;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_line", 1, layout, "PangoLayout*");
  line = s7_car(_p);
  if (!s7_is_integer(line)) s7_wrong_type_arg_error(sc, "pango_layout_get_line", 2, line, "int");
  return(lg_make_c_pointer_with_type(sc, PangoLayoutLine__sym, pango_layout_get_line((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(line))));
}

static s7_pointer lg_pango_layout_get_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_lines "GSList* pango_layout_get_lines(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_lines", 1, layout, "PangoLayout*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, pango_layout_get_lines((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_line_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_unref "void pango_layout_line_unref(PangoLayoutLine* line)"
  s7_pointer line;
  line = s7_car(args);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_unref", 1, line, "PangoLayoutLine*");
  pango_layout_line_unref((PangoLayoutLine*)s7_c_pointer(line));
  return(lg_false);
}

static s7_pointer lg_pango_layout_line_x_to_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_x_to_index "gboolean pango_layout_line_x_to_index(PangoLayoutLine* line, \
int x_pos, int* [index], int* [trailing])"
  s7_pointer _p;
  s7_pointer line, x_pos;
  int ref_index;
  int ref_trailing;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_x_to_index", 1, line, "PangoLayoutLine*");
  x_pos = s7_car(_p);
  if (!s7_is_integer(x_pos)) s7_wrong_type_arg_error(sc, "pango_layout_line_x_to_index", 2, x_pos, "int");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, pango_layout_line_x_to_index((PangoLayoutLine*)s7_c_pointer(line), (int)s7_integer(x_pos), &ref_index, &ref_trailing));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_index), s7_make_integer(sc, ref_trailing)));
   }
}

static s7_pointer lg_pango_layout_line_index_to_x(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_index_to_x "void pango_layout_line_index_to_x(PangoLayoutLine* line, int index, \
gboolean trailing, int* [x_pos])"
  s7_pointer _p;
  s7_pointer line, index, trailing;
  int ref_x_pos;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_index_to_x", 1, line, "PangoLayoutLine*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "pango_layout_line_index_to_x", 2, index, "int");
  trailing = s7_car(_p);
  if (!s7_is_boolean(trailing)) s7_wrong_type_arg_error(sc, "pango_layout_line_index_to_x", 3, trailing, "gboolean");
  pango_layout_line_index_to_x((PangoLayoutLine*)s7_c_pointer(line), (int)s7_integer(index), (gboolean)lg_boolean(trailing), &ref_x_pos);
    return(s7_list(sc, 1, s7_make_integer(sc, ref_x_pos)));
}

static s7_pointer lg_pango_layout_line_get_x_ranges(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_get_x_ranges "void pango_layout_line_get_x_ranges(PangoLayoutLine* line, \
int start_index, int end_index, int** [ranges], int* [n_ranges])"
  s7_pointer _p;
  s7_pointer line, start_index, end_index;
  int* ref_ranges = NULL;
  int ref_n_ranges;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_x_ranges", 1, line, "PangoLayoutLine*");
  start_index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_index)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_x_ranges", 2, start_index, "int");
  end_index = s7_car(_p);
  if (!s7_is_integer(end_index)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_x_ranges", 3, end_index, "int");
  pango_layout_line_get_x_ranges((PangoLayoutLine*)s7_c_pointer(line), (int)s7_integer(start_index), (int)s7_integer(end_index), &ref_ranges, &ref_n_ranges);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_ranges), s7_make_integer(sc, ref_n_ranges)));
}

static s7_pointer lg_pango_layout_line_get_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_get_extents "void pango_layout_line_get_extents(PangoLayoutLine* line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer line, ink_rect, logical_rect;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_extents", 1, line, "PangoLayoutLine*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_line_get_extents((PangoLayoutLine*)s7_c_pointer(line), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_line_get_pixel_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_get_pixel_extents "void pango_layout_line_get_pixel_extents(PangoLayoutLine* layout_line, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer layout_line, ink_rect, logical_rect;
  _p = args;
  layout_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout_line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_pixel_extents", 1, layout_line, "PangoLayoutLine*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_pixel_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_get_pixel_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_line_get_pixel_extents((PangoLayoutLine*)s7_c_pointer(layout_line), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_iter "PangoLayoutIter* pango_layout_get_iter(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_iter", 1, layout, "PangoLayout*");
  return(lg_make_c_pointer_with_type(sc, PangoLayoutIter__sym, pango_layout_get_iter((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_layout_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_free "void pango_layout_iter_free(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_free", 1, iter, "PangoLayoutIter*");
  pango_layout_iter_free((PangoLayoutIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_index(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_index "int pango_layout_iter_get_index(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_index", 1, iter, "PangoLayoutIter*");
  return(s7_make_integer(sc, pango_layout_iter_get_index((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_get_run(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_run "PangoLayoutRun* pango_layout_iter_get_run(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run", 1, iter, "PangoLayoutIter*");
  return(lg_make_c_pointer_with_type(sc, PangoLayoutRun__sym, pango_layout_iter_get_run((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_get_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_line "PangoLayoutLine* pango_layout_iter_get_line(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line", 1, iter, "PangoLayoutIter*");
  return(lg_make_c_pointer_with_type(sc, PangoLayoutLine__sym, pango_layout_iter_get_line((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_at_last_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_at_last_line "gboolean pango_layout_iter_at_last_line(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_at_last_line", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_at_last_line((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_char(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_char "gboolean pango_layout_iter_next_char(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_char", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_char((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_cluster(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_cluster "gboolean pango_layout_iter_next_cluster(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_cluster", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_cluster((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_run(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_run "gboolean pango_layout_iter_next_run(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_run", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_run((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_next_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_next_line "gboolean pango_layout_iter_next_line(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_next_line", 1, iter, "PangoLayoutIter*");
  return(s7_make_boolean(sc, pango_layout_iter_next_line((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_layout_iter_get_char_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_char_extents "void pango_layout_iter_get_char_extents(PangoLayoutIter* iter, \
PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_char_extents", 1, iter, "PangoLayoutIter*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_char_extents", 2, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_char_extents((PangoLayoutIter*)s7_c_pointer(iter), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_cluster_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_cluster_extents "void pango_layout_iter_get_cluster_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_cluster_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_cluster_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_cluster_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_cluster_extents((PangoLayoutIter*)s7_c_pointer(iter), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_run_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_run_extents "void pango_layout_iter_get_run_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_run_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_run_extents((PangoLayoutIter*)s7_c_pointer(iter), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_line_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_line_extents "void pango_layout_iter_get_line_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_line_extents((PangoLayoutIter*)s7_c_pointer(iter), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_line_yrange(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_line_yrange "void pango_layout_iter_get_line_yrange(PangoLayoutIter* iter, \
int* [y0], int* [y1])"
  s7_pointer _p;
  s7_pointer iter;
  int ref_y0;
  int ref_y1;
  _p = args;
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_line_yrange", 1, iter, "PangoLayoutIter*");
  pango_layout_iter_get_line_yrange((PangoLayoutIter*)s7_c_pointer(iter), &ref_y0, &ref_y1);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_y0), s7_make_integer(sc, ref_y1)));
}

static s7_pointer lg_pango_layout_iter_get_layout_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_layout_extents "void pango_layout_iter_get_layout_extents(PangoLayoutIter* iter, \
PangoRectangle* ink_rect, PangoRectangle* logical_rect)"
  s7_pointer _p;
  s7_pointer iter, ink_rect, logical_rect;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_layout_extents", 1, iter, "PangoLayoutIter*");
  ink_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ink_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_layout_extents", 2, ink_rect, "PangoRectangle*");
  logical_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(logical_rect, PangoRectangle__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_layout_extents", 3, logical_rect, "PangoRectangle*");
  pango_layout_iter_get_layout_extents((PangoLayoutIter*)s7_c_pointer(iter), (PangoRectangle*)s7_c_pointer(ink_rect), (PangoRectangle*)s7_c_pointer(logical_rect));
  return(lg_false);
}

static s7_pointer lg_pango_layout_iter_get_baseline(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_iter_get_baseline "int pango_layout_iter_get_baseline(PangoLayoutIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoLayoutIter__sym)) s7_wrong_type_arg_error(sc, "pango_layout_iter_get_baseline", 1, iter, "PangoLayoutIter*");
  return(s7_make_integer(sc, pango_layout_iter_get_baseline((PangoLayoutIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_language_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_language_from_string "PangoLanguage* pango_language_from_string(char* language)"
  s7_pointer language;
  language = s7_car(args);
  if (!s7_is_string(language)) s7_wrong_type_arg_error(sc, "pango_language_from_string", 1, language, "char*");
  return(lg_make_c_pointer_with_type(sc, PangoLanguage__sym, pango_language_from_string((char*)s7_string(language))));
}

static s7_pointer lg_pango_language_matches(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_language_matches "gboolean pango_language_matches(PangoLanguage* language, char* range_list)"
  s7_pointer _p;
  s7_pointer language, range_list;
  _p = args;
  language = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(language, PangoLanguage__sym)) s7_wrong_type_arg_error(sc, "pango_language_matches", 1, language, "PangoLanguage*");
  range_list = s7_car(_p);
  if (!s7_is_string(range_list)) s7_wrong_type_arg_error(sc, "pango_language_matches", 2, range_list, "char*");
  return(s7_make_boolean(sc, pango_language_matches((PangoLanguage*)s7_c_pointer(language), (char*)s7_string(range_list))));
}

static s7_pointer lg_G_OBJECT_TYPE(s7_scheme *sc, s7_pointer args)
{
  #define H_G_OBJECT_TYPE "GType G_OBJECT_TYPE(GObject* object)"
  s7_pointer object;
  object = s7_car(args);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "G_OBJECT_TYPE", 1, object, "GObject*");
  return(s7_make_integer(sc, G_OBJECT_TYPE((GObject*)s7_c_pointer(object))));
}

static s7_pointer lg_gtk_tree_model_get_string_from_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_get_string_from_iter "gchar* gtk_tree_model_get_string_from_iter(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_string_from_iter", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_get_string_from_iter", 2, iter, "GtkTreeIter*");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_tree_model_get_string_from_iter((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_tree_model_sort_iter_is_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_sort_iter_is_valid "gboolean gtk_tree_model_sort_iter_is_valid(GtkTreeModelSort* tree_model_sort, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model_sort, iter;
  _p = args;
  tree_model_sort = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model_sort, GtkTreeModelSort__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_iter_is_valid", 1, tree_model_sort, "GtkTreeModelSort*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_sort_iter_is_valid", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_sort_iter_is_valid((GtkTreeModelSort*)s7_c_pointer(tree_model_sort), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_view_expand_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_expand_to_path "void gtk_tree_view_expand_to_path(GtkTreeView* tree_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_to_path", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_expand_to_path", 2, path, "GtkTreePath*");
  gtk_tree_view_expand_to_path((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_selection_get_selected_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_get_selected_rows "GList* gtk_tree_selection_get_selected_rows(GtkTreeSelection* selection, \
GtkTreeModel** model)"
  s7_pointer _p;
  s7_pointer selection, model;
  _p = args;
  selection = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected_rows", 1, selection, "GtkTreeSelection*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel___sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_get_selected_rows", 2, model, "GtkTreeModel**");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_tree_selection_get_selected_rows((GtkTreeSelection*)s7_c_pointer(selection), (GtkTreeModel**)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_tree_selection_count_selected_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_selection_count_selected_rows "int gtk_tree_selection_count_selected_rows(GtkTreeSelection* selection)"
  s7_pointer selection;
  selection = s7_car(args);
  if (!s7_is_c_pointer_of_type(selection, GtkTreeSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_selection_count_selected_rows", 1, selection, "GtkTreeSelection*");
  return(s7_make_integer(sc, gtk_tree_selection_count_selected_rows((GtkTreeSelection*)s7_c_pointer(selection))));
}

static s7_pointer lg_gtk_notebook_get_n_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_n_pages "int gtk_notebook_get_n_pages(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_n_pages", 1, notebook, "GtkNotebook*");
  return(s7_make_integer(sc, gtk_notebook_get_n_pages((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_list_store_reorder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_reorder "void gtk_list_store_reorder(GtkListStore* store, int* new_order)"
  s7_pointer _p;
  s7_pointer store, new_order;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_reorder", 1, store, "GtkListStore*");
  new_order = s7_car(_p);
  if (!s7_is_c_pointer_of_type(new_order, int__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_reorder", 2, new_order, "int*");
  gtk_list_store_reorder((GtkListStore*)s7_c_pointer(store), (int*)s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_swap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_swap "void gtk_list_store_swap(GtkListStore* store, GtkTreeIter* a, GtkTreeIter* b)"
  s7_pointer _p;
  s7_pointer store, a, b;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_swap", 1, store, "GtkListStore*");
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_swap", 2, a, "GtkTreeIter*");
  b = s7_car(_p);
  if (!s7_is_c_pointer_of_type(b, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_swap", 3, b, "GtkTreeIter*");
  gtk_list_store_swap((GtkListStore*)s7_c_pointer(store), (GtkTreeIter*)s7_c_pointer(a), (GtkTreeIter*)s7_c_pointer(b));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_move_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_move_after "void gtk_list_store_move_after(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  s7_pointer _p;
  s7_pointer store, iter, position;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_after", 1, store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_after", 2, iter, "GtkTreeIter*");
  position = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(position, GtkTreeIter__sym)) && (position != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_after", 3, position, "GtkTreeIter*");
  gtk_list_store_move_after((GtkListStore*)s7_c_pointer(store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_move_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_move_before "void gtk_list_store_move_before(GtkListStore* store, GtkTreeIter* iter, \
GtkTreeIter* position)"
  s7_pointer _p;
  s7_pointer store, iter, position;
  _p = args;
  store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_before", 1, store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_before", 2, iter, "GtkTreeIter*");
  position = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(position, GtkTreeIter__sym)) && (position != lg_false)) s7_wrong_type_arg_error(sc, "gtk_list_store_move_before", 3, position, "GtkTreeIter*");
  gtk_list_store_move_before((GtkListStore*)s7_c_pointer(store), (GtkTreeIter*)s7_c_pointer(iter), (GtkTreeIter*)s7_c_pointer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_reorder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_reorder "void gtk_tree_store_reorder(GtkTreeStore* tree_store, GtkTreeIter* parent, \
int* new_order)"
  s7_pointer _p;
  s7_pointer tree_store, parent, new_order;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_reorder", 1, tree_store, "GtkTreeStore*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_reorder", 2, parent, "GtkTreeIter*");
  new_order = s7_car(_p);
  if (!s7_is_c_pointer_of_type(new_order, int__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_reorder", 3, new_order, "int*");
  gtk_tree_store_reorder((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(parent), (int*)s7_c_pointer(new_order));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_store_swap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_store_swap "void gtk_tree_store_swap(GtkTreeStore* tree_store, GtkTreeIter* a, GtkTreeIter* b)"
  s7_pointer _p;
  s7_pointer tree_store, a, b;
  _p = args;
  tree_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_store, GtkTreeStore__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_swap", 1, tree_store, "GtkTreeStore*");
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_swap", 2, a, "GtkTreeIter*");
  b = s7_car(_p);
  if (!s7_is_c_pointer_of_type(b, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_store_swap", 3, b, "GtkTreeIter*");
  gtk_tree_store_swap((GtkTreeStore*)s7_c_pointer(tree_store), (GtkTreeIter*)s7_c_pointer(a), (GtkTreeIter*)s7_c_pointer(b));
  return(lg_false);
}

static s7_pointer lg_gdk_display_open(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_open "GdkDisplay* gdk_display_open(gchar* display_name)"
  s7_pointer display_name;
  display_name = s7_car(args);
  if (!s7_is_string(display_name)) s7_wrong_type_arg_error(sc, "gdk_display_open", 1, display_name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_display_open((gchar*)s7_string(display_name))));
}

static s7_pointer lg_gdk_display_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_name "gchar* gdk_display_get_name(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_name", 1, display, "GdkDisplay*");
  return(s7_make_string(sc, gdk_display_get_name((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_beep(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_beep "void gdk_display_beep(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_beep", 1, display, "GdkDisplay*");
  gdk_display_beep((GdkDisplay*)s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_sync(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_sync "void gdk_display_sync(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_sync", 1, display, "GdkDisplay*");
  gdk_display_sync((GdkDisplay*)s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_close(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_close "void gdk_display_close(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_close", 1, display, "GdkDisplay*");
  gdk_display_close((GdkDisplay*)s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gdk_display_get_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_event "GdkEvent* gdk_display_get_event(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_event", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GdkEvent__sym, gdk_display_get_event((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_peek_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_peek_event "GdkEvent* gdk_display_peek_event(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_peek_event", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GdkEvent__sym, gdk_display_peek_event((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_put_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_put_event "void gdk_display_put_event(GdkDisplay* display, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer display, event;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_put_event", 1, display, "GdkDisplay*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_display_put_event", 2, event, "GdkEvent*");
  gdk_display_put_event((GdkDisplay*)s7_c_pointer(display), (GdkEvent*)s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gdk_display_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default "GdkDisplay* gdk_display_get_default( void)"
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_display_get_default()));
}

static s7_pointer lg_gtk_widget_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_display "GdkDisplay* gtk_widget_get_display(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_display", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gtk_widget_get_display((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_g_list_free(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_free "void g_list_free(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_free", 1, list, "GList*");
  g_list_free((GList*)s7_c_pointer(list));
  return(lg_false);
}

static s7_pointer lg_g_list_reverse(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_reverse "GList* g_list_reverse(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "g_list_reverse", 1, list, "GList*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, g_list_reverse((GList*)s7_c_pointer(list))));
}

static s7_pointer lg_g_list_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_copy "GList* g_list_copy(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "g_list_copy", 1, list, "GList*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, g_list_copy((GList*)s7_c_pointer(list))));
}

static s7_pointer lg_g_list_last(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_last "GList* g_list_last(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_last", 1, list, "GList*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, g_list_last((GList*)s7_c_pointer(list))));
}

static s7_pointer lg_g_list_first(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_first "GList* g_list_first(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_first", 1, list, "GList*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, g_list_first((GList*)s7_c_pointer(list))));
}

static s7_pointer lg_g_list_length(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_length "guint g_list_length(GList* list)"
  s7_pointer list;
  list = s7_car(args);
  if ((!s7_is_c_pointer_of_type(list, GList__sym)) && (list != lg_false)) s7_wrong_type_arg_error(sc, "g_list_length", 1, list, "GList*");
  return(s7_make_integer(sc, g_list_length((GList*)s7_c_pointer(list))));
}

static s7_pointer lg_g_free(s7_scheme *sc, s7_pointer args)
{
  #define H_g_free "void g_free(gpointer mem)"
  s7_pointer mem;
  mem = s7_car(args);
  if (!s7_is_c_pointer_of_type(mem, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_free", 1, mem, "gpointer");
  g_free((gpointer)s7_c_pointer(mem));
  return(lg_false);
}

static s7_pointer lg_g_list_remove_link(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_remove_link "GList* g_list_remove_link(GList* list, GList* llink)"
  s7_pointer _p;
  s7_pointer list, llink;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_remove_link", 1, list, "GList*");
  llink = s7_car(_p);
  if (!s7_is_c_pointer_of_type(llink, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_remove_link", 2, llink, "GList*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, g_list_remove_link((GList*)s7_c_pointer(list), (GList*)s7_c_pointer(llink))));
}

static s7_pointer lg_g_object_get_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_get_data "gpointer g_object_get_data(GObject* object, gchar* key)"
  s7_pointer _p;
  s7_pointer object, key;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "g_object_get_data", 1, object, "GObject*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "g_object_get_data", 2, key, "gchar*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, g_object_get_data((GObject*)s7_c_pointer(object), (const gchar*)s7_string(key))));
}

static s7_pointer lg_g_object_set_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_object_set_data "void g_object_set_data(GObject* object, gchar* key, gpointer data)"
  s7_pointer _p;
  s7_pointer object, key, data;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "g_object_set_data", 1, object, "GObject*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "g_object_set_data", 2, key, "gchar*");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_object_set_data", 3, data, "gpointer");
  g_object_set_data((GObject*)s7_c_pointer(object), (const gchar*)s7_string(key), (gpointer)s7_c_pointer(data));
  return(lg_false);
}

static s7_pointer lg_gdk_display_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_flush "void gdk_display_flush(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_flush", 1, display, "GdkDisplay*");
  gdk_display_flush((GdkDisplay*)s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_set_display_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_display_options "void gtk_calendar_set_display_options(GtkCalendar* calendar, \
GtkCalendarDisplayOptions flags)"
  s7_pointer _p;
  s7_pointer calendar, flags;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_display_options", 1, calendar, "GtkCalendar*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_display_options", 2, flags, "GtkCalendarDisplayOptions");
  gtk_calendar_set_display_options((GtkCalendar*)s7_c_pointer(calendar), (GtkCalendarDisplayOptions)s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_display_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_display_options "GtkCalendarDisplayOptions gtk_calendar_get_display_options(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_display_options", 1, calendar, "GtkCalendar*");
  return(s7_make_integer(sc, gtk_calendar_get_display_options((GtkCalendar*)s7_c_pointer(calendar))));
}

static s7_pointer lg_gtk_entry_set_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_completion "void gtk_entry_set_completion(GtkEntry* entry, GtkEntryCompletion* completion)"
  s7_pointer _p;
  s7_pointer entry, completion;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_completion", 1, entry, "GtkEntry*");
  completion = s7_car(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_completion", 2, completion, "GtkEntryCompletion*");
  gtk_entry_set_completion((GtkEntry*)s7_c_pointer(entry), (GtkEntryCompletion*)s7_c_pointer(completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_completion "GtkEntryCompletion* gtk_entry_get_completion(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_completion", 1, entry, "GtkEntry*");
  return(lg_make_c_pointer_with_type(sc, GtkEntryCompletion__sym, gtk_entry_get_completion((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_text_buffer_select_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_select_range "void gtk_text_buffer_select_range(GtkTextBuffer* buffer, GtkTextIter* ins, \
GtkTextIter* bound)"
  s7_pointer _p;
  s7_pointer buffer, ins, bound;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_select_range", 1, buffer, "GtkTextBuffer*");
  ins = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ins, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_select_range", 2, ins, "GtkTextIter*");
  bound = s7_car(_p);
  if (!s7_is_c_pointer_of_type(bound, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_select_range", 3, bound, "GtkTextIter*");
  gtk_text_buffer_select_range((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(ins), (GtkTextIter*)s7_c_pointer(bound));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_overwrite(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_overwrite "void gtk_text_view_set_overwrite(GtkTextView* text_view, gboolean overwrite)"
  s7_pointer _p;
  s7_pointer text_view, overwrite;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_overwrite", 1, text_view, "GtkTextView*");
  overwrite = s7_car(_p);
  if (!s7_is_boolean(overwrite)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_overwrite", 2, overwrite, "gboolean");
  gtk_text_view_set_overwrite((GtkTextView*)s7_c_pointer(text_view), (gboolean)lg_boolean(overwrite));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_overwrite(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_overwrite "gboolean gtk_text_view_get_overwrite(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_overwrite", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_overwrite((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_accepts_tab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_accepts_tab "void gtk_text_view_set_accepts_tab(GtkTextView* text_view, \
gboolean accepts_tab)"
  s7_pointer _p;
  s7_pointer text_view, accepts_tab;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_accepts_tab", 1, text_view, "GtkTextView*");
  accepts_tab = s7_car(_p);
  if (!s7_is_boolean(accepts_tab)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_accepts_tab", 2, accepts_tab, "gboolean");
  gtk_text_view_set_accepts_tab((GtkTextView*)s7_c_pointer(text_view), (gboolean)lg_boolean(accepts_tab));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_accepts_tab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_accepts_tab "gboolean gtk_text_view_get_accepts_tab(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_accepts_tab", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_accepts_tab((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_tree_view_column_set_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_set_expand "void gtk_tree_view_column_set_expand(GtkTreeViewColumn* tree_column, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_column, expand;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_expand", 1, tree_column, "GtkTreeViewColumn*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_set_expand", 2, expand, "gboolean");
  gtk_tree_view_column_set_expand((GtkTreeViewColumn*)s7_c_pointer(tree_column), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_get_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_expand "gboolean gtk_tree_view_column_get_expand(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_expand", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_boolean(sc, gtk_tree_view_column_get_expand((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_file_chooser_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_dialog_new "GtkWidget* gtk_file_chooser_dialog_new(gchar* title, GtkWindow* parent, \
GtkFileChooserAction action, etc buttons)"
  s7_pointer _p;
  s7_pointer title, parent, action, buttons;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 1, title, "gchar*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if ((!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) && (parent != lg_false)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 2, parent, "GtkWindow*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 3, action, "GtkFileChooserAction");
  buttons = s7_car(_p);
  if ((!lg_is_list(buttons)) && (buttons != lg_false)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_dialog_new", 4, buttons, "etc");
  {
    int etc_len = 0;
    GtkWidget* res_ult = NULL;
    gchar* p_arg0;
    GtkWindow* p_arg1;
    GtkFileChooserAction p_arg2;
    if (s7_is_list(sc, buttons)) etc_len = s7_list_length(sc, buttons);
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_file_chooser_dialog_new", 3, buttons, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_file_chooser_dialog_new", 3, buttons, "... list len must be multiple of 2");
    p_arg0 = (gchar*)s7_string(title);
    p_arg1 = (GtkWindow*)s7_c_pointer(parent);
    p_arg2 = (GtkFileChooserAction)s7_integer(action);
    switch (etc_len)
      {
        case 0: res_ult = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, NULL, NULL); break;
        case 2: res_ult = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), NULL); break;
        case 4: res_ult = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), NULL); break;
        case 6: res_ult = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), NULL); break;
        case 8: res_ult = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), NULL); break;
        case 10: res_ult = gtk_file_chooser_dialog_new(p_arg0, p_arg1, p_arg2, s7_string(s7_list_ref(sc, buttons, 0)), s7_integer(s7_list_ref(sc, buttons, 1)), s7_string(s7_list_ref(sc, buttons, 2)), s7_integer(s7_list_ref(sc, buttons, 3)), s7_string(s7_list_ref(sc, buttons, 4)), s7_integer(s7_list_ref(sc, buttons, 5)), s7_string(s7_list_ref(sc, buttons, 6)), s7_integer(s7_list_ref(sc, buttons, 7)), s7_string(s7_list_ref(sc, buttons, 8)), s7_integer(s7_list_ref(sc, buttons, 9)), NULL); break;
      }
    return(s7_make_c_pointer(sc, res_ult));
  }
}

static s7_pointer lg_gtk_file_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_widget_new "GtkWidget* gtk_file_chooser_widget_new(GtkFileChooserAction action)"
  s7_pointer action;
  action = s7_car(args);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_widget_new", 1, action, "GtkFileChooserAction");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_file_chooser_widget_new((GtkFileChooserAction)s7_integer(action))));
}

static s7_pointer lg_gtk_tree_model_filter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_new "GtkTreeModel* gtk_tree_model_filter_new(GtkTreeModel* child_model, \
GtkTreePath* root)"
  s7_pointer _p;
  s7_pointer child_model, root;
  _p = args;
  child_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_new", 1, child_model, "GtkTreeModel*");
  root = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(root, GtkTreePath__sym)) && (root != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_new", 2, root, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_tree_model_filter_new((GtkTreeModel*)s7_c_pointer(child_model), (GtkTreePath*)s7_c_pointer(root))));
}

static s7_pointer lg_gtk_tree_model_filter_set_visible_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_set_visible_column "void gtk_tree_model_filter_set_visible_column(GtkTreeModelFilter* filter, \
gint column)"
  s7_pointer _p;
  s7_pointer filter, column;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_set_visible_column", 1, filter, "GtkTreeModelFilter*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_set_visible_column", 2, column, "gint");
  gtk_tree_model_filter_set_visible_column((GtkTreeModelFilter*)s7_c_pointer(filter), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_filter_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_get_model "GtkTreeModel* gtk_tree_model_filter_get_model(GtkTreeModelFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_get_model", 1, filter, "GtkTreeModelFilter*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_tree_model_filter_get_model((GtkTreeModelFilter*)s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_tree_model_filter_convert_iter_to_child_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_iter_to_child_iter "void gtk_tree_model_filter_convert_iter_to_child_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* child_iter, GtkTreeIter* filter_iter)"
  s7_pointer _p;
  s7_pointer filter, child_iter, filter_iter;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", 1, filter, "GtkTreeModelFilter*");
  child_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", 2, child_iter, "GtkTreeIter*");
  filter_iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(filter_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", 3, filter_iter, "GtkTreeIter*");
  gtk_tree_model_filter_convert_iter_to_child_iter((GtkTreeModelFilter*)s7_c_pointer(filter), (GtkTreeIter*)s7_c_pointer(child_iter), (GtkTreeIter*)s7_c_pointer(filter_iter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_filter_convert_child_path_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_child_path_to_path "GtkTreePath* gtk_tree_model_filter_convert_child_path_to_path(GtkTreeModelFilter* filter, \
GtkTreePath* child_path)"
  s7_pointer _p;
  s7_pointer filter, child_path;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_path_to_path", 1, filter, "GtkTreeModelFilter*");
  child_path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_path_to_path", 2, child_path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_model_filter_convert_child_path_to_path((GtkTreeModelFilter*)s7_c_pointer(filter), (GtkTreePath*)s7_c_pointer(child_path))));
}

static s7_pointer lg_gtk_tree_model_filter_convert_path_to_child_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_path_to_child_path "GtkTreePath* gtk_tree_model_filter_convert_path_to_child_path(GtkTreeModelFilter* path, \
GtkTreePath* filter_path)"
  s7_pointer _p;
  s7_pointer path, filter_path;
  _p = args;
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_path_to_child_path", 1, path, "GtkTreeModelFilter*");
  filter_path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(filter_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_path_to_child_path", 2, filter_path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_tree_model_filter_convert_path_to_child_path((GtkTreeModelFilter*)s7_c_pointer(path), (GtkTreePath*)s7_c_pointer(filter_path))));
}

static s7_pointer lg_gtk_tree_model_filter_refilter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_refilter "void gtk_tree_model_filter_refilter(GtkTreeModelFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_refilter", 1, filter, "GtkTreeModelFilter*");
  gtk_tree_model_filter_refilter((GtkTreeModelFilter*)s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_model_filter_clear_cache(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_clear_cache "void gtk_tree_model_filter_clear_cache(GtkTreeModelFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_clear_cache", 1, filter, "GtkTreeModelFilter*");
  gtk_tree_model_filter_clear_cache((GtkTreeModelFilter*)s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new "GtkWidget* gtk_combo_box_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_combo_box_new()));
}

static s7_pointer lg_gtk_combo_box_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new_with_model "GtkWidget* gtk_combo_box_new_with_model(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_new_with_model", 1, model, "GtkTreeModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_combo_box_new_with_model((GtkTreeModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_combo_box_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_model "void gtk_combo_box_set_model(GtkComboBox* combo_box, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer combo_box, model;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_model", 1, combo_box, "GtkComboBox*");
  model = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_model", 2, model, "GtkTreeModel*");
  gtk_combo_box_set_model((GtkComboBox*)s7_c_pointer(combo_box), (GtkTreeModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_active "gint gtk_combo_box_get_active(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_active((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_active "void gtk_combo_box_set_active(GtkComboBox* combo_box, gint index)"
  s7_pointer _p;
  s7_pointer combo_box, index;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active", 1, combo_box, "GtkComboBox*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active", 2, index, "gint");
  gtk_combo_box_set_active((GtkComboBox*)s7_c_pointer(combo_box), (gint)s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_active_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_active_iter "gboolean gtk_combo_box_get_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer combo_box, iter;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active_iter", 1, combo_box, "GtkComboBox*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active_iter", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_combo_box_get_active_iter((GtkComboBox*)s7_c_pointer(combo_box), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_combo_box_set_active_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_active_iter "void gtk_combo_box_set_active_iter(GtkComboBox* combo_box, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer combo_box, iter;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_iter", 1, combo_box, "GtkComboBox*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_iter", 2, iter, "GtkTreeIter*");
  gtk_combo_box_set_active_iter((GtkComboBox*)s7_c_pointer(combo_box), (GtkTreeIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_model "GtkTreeModel* gtk_combo_box_get_model(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_model", 1, combo_box, "GtkComboBox*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_combo_box_get_model((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_expander_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_new "GtkWidget* gtk_expander_new(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_expander_new", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_expander_new((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_expander_new_with_mnemonic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_new_with_mnemonic "GtkWidget* gtk_expander_new_with_mnemonic(gchar* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_expander_new_with_mnemonic", 1, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_expander_new_with_mnemonic((gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_expander_set_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_expanded "void gtk_expander_set_expanded(GtkExpander* expander, gboolean expanded)"
  s7_pointer _p;
  s7_pointer expander, expanded;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_expanded", 1, expander, "GtkExpander*");
  expanded = s7_car(_p);
  if (!s7_is_boolean(expanded)) s7_wrong_type_arg_error(sc, "gtk_expander_set_expanded", 2, expanded, "gboolean");
  gtk_expander_set_expanded((GtkExpander*)s7_c_pointer(expander), (gboolean)lg_boolean(expanded));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_expanded "gboolean gtk_expander_get_expanded(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_expanded", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_expanded((GtkExpander*)s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_label "void gtk_expander_set_label(GtkExpander* expander, gchar* label)"
  s7_pointer _p;
  s7_pointer expander, label;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label", 1, expander, "GtkExpander*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label", 2, label, "gchar*");
  gtk_expander_set_label((GtkExpander*)s7_c_pointer(expander), (gchar*)s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_label "gchar* gtk_expander_get_label(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_label", 1, expander, "GtkExpander*");
  return(s7_make_string(sc, gtk_expander_get_label((GtkExpander*)s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_use_underline "void gtk_expander_set_use_underline(GtkExpander* expander, \
gboolean use_underline)"
  s7_pointer _p;
  s7_pointer expander, use_underline;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_underline", 1, expander, "GtkExpander*");
  use_underline = s7_car(_p);
  if (!s7_is_boolean(use_underline)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_underline", 2, use_underline, "gboolean");
  gtk_expander_set_use_underline((GtkExpander*)s7_c_pointer(expander), (gboolean)lg_boolean(use_underline));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_use_underline "gboolean gtk_expander_get_use_underline(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_use_underline", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_use_underline((GtkExpander*)s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_label_widget "void gtk_expander_set_label_widget(GtkExpander* expander, \
GtkWidget* label_widget)"
  s7_pointer _p;
  s7_pointer expander, label_widget;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label_widget", 1, expander, "GtkExpander*");
  label_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(label_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_label_widget", 2, label_widget, "GtkWidget*");
  gtk_expander_set_label_widget((GtkExpander*)s7_c_pointer(expander), (GtkWidget*)s7_c_pointer(label_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_label_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_label_widget "GtkWidget* gtk_expander_get_label_widget(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_label_widget", 1, expander, "GtkExpander*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_expander_get_label_widget((GtkExpander*)s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_expander_set_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_use_markup "void gtk_expander_set_use_markup(GtkExpander* expander, gboolean use_markup)"
  s7_pointer _p;
  s7_pointer expander, use_markup;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_markup", 1, expander, "GtkExpander*");
  use_markup = s7_car(_p);
  if (!s7_is_boolean(use_markup)) s7_wrong_type_arg_error(sc, "gtk_expander_set_use_markup", 2, use_markup, "gboolean");
  gtk_expander_set_use_markup((GtkExpander*)s7_c_pointer(expander), (gboolean)lg_boolean(use_markup));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_use_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_use_markup "gboolean gtk_expander_get_use_markup(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_use_markup", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_use_markup((GtkExpander*)s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_font_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_new "GtkWidget* gtk_font_button_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_font_button_new()));
}

static s7_pointer lg_gtk_font_button_new_with_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_new_with_font "GtkWidget* gtk_font_button_new_with_font(gchar* fontname)"
  s7_pointer fontname;
  fontname = s7_car(args);
  if (!s7_is_string(fontname)) s7_wrong_type_arg_error(sc, "gtk_font_button_new_with_font", 1, fontname, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_font_button_new_with_font((gchar*)s7_string(fontname))));
}

static s7_pointer lg_gtk_font_button_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_title "gchar* gtk_font_button_get_title(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_title", 1, font_button, "GtkFontButton*");
  return(s7_make_string(sc, gtk_font_button_get_title((GtkFontButton*)s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_title "void gtk_font_button_set_title(GtkFontButton* font_button, gchar* title)"
  s7_pointer _p;
  s7_pointer font_button, title;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_title", 1, font_button, "GtkFontButton*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_title", 2, title, "gchar*");
  gtk_font_button_set_title((GtkFontButton*)s7_c_pointer(font_button), (gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_use_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_use_font "gboolean gtk_font_button_get_use_font(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_use_font", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_use_font((GtkFontButton*)s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_use_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_use_font "void gtk_font_button_set_use_font(GtkFontButton* font_button, \
gboolean use_font)"
  s7_pointer _p;
  s7_pointer font_button, use_font;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_font", 1, font_button, "GtkFontButton*");
  use_font = s7_car(_p);
  if (!s7_is_boolean(use_font)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_font", 2, use_font, "gboolean");
  gtk_font_button_set_use_font((GtkFontButton*)s7_c_pointer(font_button), (gboolean)lg_boolean(use_font));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_use_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_use_size "gboolean gtk_font_button_get_use_size(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_use_size", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_use_size((GtkFontButton*)s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_use_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_use_size "void gtk_font_button_set_use_size(GtkFontButton* font_button, \
gboolean use_size)"
  s7_pointer _p;
  s7_pointer font_button, use_size;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_size", 1, font_button, "GtkFontButton*");
  use_size = s7_car(_p);
  if (!s7_is_boolean(use_size)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_use_size", 2, use_size, "gboolean");
  gtk_font_button_set_use_size((GtkFontButton*)s7_c_pointer(font_button), (gboolean)lg_boolean(use_size));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_new "GtkEntryCompletion* gtk_entry_completion_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkEntryCompletion__sym, gtk_entry_completion_new()));
}

static s7_pointer lg_gtk_entry_completion_get_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_entry "GtkWidget* gtk_entry_completion_get_entry(GtkEntryCompletion* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_entry", 1, entry, "GtkEntryCompletion*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_entry_completion_get_entry((GtkEntryCompletion*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_completion_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_model "void gtk_entry_completion_set_model(GtkEntryCompletion* completion, \
GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer completion, model;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_model", 1, completion, "GtkEntryCompletion*");
  model = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_model", 2, model, "GtkTreeModel*");
  gtk_entry_completion_set_model((GtkEntryCompletion*)s7_c_pointer(completion), (GtkTreeModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_model "GtkTreeModel* gtk_entry_completion_get_model(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_model", 1, completion, "GtkEntryCompletion*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_entry_completion_get_model((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_set_match_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_match_func "void gtk_entry_completion_set_match_func(GtkEntryCompletion* completion, \
GtkEntryCompletionMatchFunc func, lambda_data func_info, GtkDestroyNotify func_notify)"
  s7_pointer _p;
  s7_pointer completion, func, func_info, func_notify;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_match_func", 1, completion, "GtkEntryCompletion*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  func_notify = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, func_notify);
    gtk_entry_completion_set_match_func((GtkEntryCompletion*)s7_c_pointer(completion), lg_entry_completion_match, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_entry_completion_set_minimum_key_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_minimum_key_length "void gtk_entry_completion_set_minimum_key_length(GtkEntryCompletion* completion, \
gint length)"
  s7_pointer _p;
  s7_pointer completion, length;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_minimum_key_length", 1, completion, "GtkEntryCompletion*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_minimum_key_length", 2, length, "gint");
  gtk_entry_completion_set_minimum_key_length((GtkEntryCompletion*)s7_c_pointer(completion), (gint)s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_minimum_key_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_minimum_key_length "gint gtk_entry_completion_get_minimum_key_length(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_minimum_key_length", 1, completion, "GtkEntryCompletion*");
  return(s7_make_integer(sc, gtk_entry_completion_get_minimum_key_length((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_complete "void gtk_entry_completion_complete(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_complete", 1, completion, "GtkEntryCompletion*");
  gtk_entry_completion_complete((GtkEntryCompletion*)s7_c_pointer(completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_insert_action_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_insert_action_text "void gtk_entry_completion_insert_action_text(GtkEntryCompletion* completion, \
gint index, gchar* text)"
  s7_pointer _p;
  s7_pointer completion, index, text;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_text", 1, completion, "GtkEntryCompletion*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_text", 2, index, "gint");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_text", 3, text, "gchar*");
  gtk_entry_completion_insert_action_text((GtkEntryCompletion*)s7_c_pointer(completion), (gint)s7_integer(index), (gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_insert_action_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_insert_action_markup "void gtk_entry_completion_insert_action_markup(GtkEntryCompletion* completion, \
gint index, gchar* markup)"
  s7_pointer _p;
  s7_pointer completion, index, markup;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_markup", 1, completion, "GtkEntryCompletion*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_markup", 2, index, "gint");
  markup = s7_car(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_action_markup", 3, markup, "gchar*");
  gtk_entry_completion_insert_action_markup((GtkEntryCompletion*)s7_c_pointer(completion), (gint)s7_integer(index), (gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_delete_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_delete_action "void gtk_entry_completion_delete_action(GtkEntryCompletion* completion, \
gint index)"
  s7_pointer _p;
  s7_pointer completion, index;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_delete_action", 1, completion, "GtkEntryCompletion*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_delete_action", 2, index, "gint");
  gtk_entry_completion_delete_action((GtkEntryCompletion*)s7_c_pointer(completion), (gint)s7_integer(index));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_set_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_text_column "void gtk_entry_completion_set_text_column(GtkEntryCompletion* completion, \
gint column)"
  s7_pointer _p;
  s7_pointer completion, column;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_text_column", 1, completion, "GtkEntryCompletion*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_text_column", 2, column, "gint");
  gtk_entry_completion_set_text_column((GtkEntryCompletion*)s7_c_pointer(completion), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_g_timeout_add_full(s7_scheme *sc, s7_pointer args)
{
  #define H_g_timeout_add_full "guint g_timeout_add_full(gint priority, guint interval, GSourceFunc func, \
lambda_data func_info, GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, interval, func, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 1, priority, "gint");
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "g_timeout_add_full", 2, interval, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  notify = s7_car(_p);
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, notify);
    res_ult = s7_make_integer(sc, g_timeout_add_full((gint)s7_integer(priority), (guint)s7_integer(interval), lg_timer_func, (gpointer)lg_ptr, lg_destroy_func));
    return(res_ult);
   }
}

static s7_pointer lg_g_timeout_add(s7_scheme *sc, s7_pointer args)
{
  #define H_g_timeout_add "guint g_timeout_add(guint interval, GSourceFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer interval, func, func_info;
  _p = args;
  interval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(interval)) s7_wrong_type_arg_error(sc, "g_timeout_add", 1, interval, "guint");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    res_ult = s7_make_integer(sc, g_timeout_add((guint)s7_integer(interval), lg_timer_func, (gpointer)lg_ptr));
    return(res_ult);
   }
}

static s7_pointer lg_g_idle_add(s7_scheme *sc, s7_pointer args)
{
  #define H_g_idle_add "guint g_idle_add(GSourceFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer func, func_info;
  _p = args;
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    res_ult = s7_make_integer(sc, g_idle_add(lg_timer_func, (gpointer)lg_ptr));
    return(res_ult);
   }
}

static s7_pointer lg_g_idle_add_full(s7_scheme *sc, s7_pointer args)
{
  #define H_g_idle_add_full "guint g_idle_add_full(gint priority, GSourceFunc func, lambda_data func_info, \
GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer priority, func, func_info, notify;
  _p = args;
  priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "g_idle_add_full", 1, priority, "gint");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  notify = s7_car(_p);
  {
    s7_pointer res_ult;
    int loc;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    loc = s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 2, s7_make_integer(sc, loc));
    s7_list_set(sc, lg_ptr, 3, notify);
    res_ult = s7_make_integer(sc, g_idle_add_full((gint)s7_integer(priority), lg_timer_func, (gpointer)lg_ptr, lg_destroy_func));
    return(res_ult);
   }
}

static s7_pointer lg_g_idle_remove_by_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_idle_remove_by_data "gboolean g_idle_remove_by_data(gpointer data)"
  s7_pointer data;
  data = s7_car(args);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "g_idle_remove_by_data", 1, data, "gpointer");
  return(s7_make_boolean(sc, g_idle_remove_by_data((gpointer)s7_c_pointer(data))));
}

static s7_pointer lg_g_source_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_g_source_remove "gboolean g_source_remove(guint tag)"
  s7_pointer tag;
  tag = s7_car(args);
  if (!s7_is_integer(tag)) s7_wrong_type_arg_error(sc, "g_source_remove", 1, tag, "guint");
  return(s7_make_boolean(sc, g_source_remove((guint)s7_integer(tag))));
}

static s7_pointer lg_gtk_file_filter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_new "GtkFileFilter* gtk_file_filter_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkFileFilter__sym, gtk_file_filter_new()));
}

static s7_pointer lg_gtk_file_filter_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_set_name "void gtk_file_filter_set_name(GtkFileFilter* filter, gchar* name)"
  s7_pointer _p;
  s7_pointer filter, name;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_set_name", 1, filter, "GtkFileFilter*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_file_filter_set_name", 2, name, "gchar*");
  gtk_file_filter_set_name((GtkFileFilter*)s7_c_pointer(filter), (gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_file_filter_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_get_name "gchar* gtk_file_filter_get_name(GtkFileFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_get_name", 1, filter, "GtkFileFilter*");
  return(s7_make_string(sc, gtk_file_filter_get_name((GtkFileFilter*)s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_file_filter_add_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_mime_type "void gtk_file_filter_add_mime_type(GtkFileFilter* filter, \
gchar* mime_type)"
  s7_pointer _p;
  s7_pointer filter, mime_type;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_mime_type", 1, filter, "GtkFileFilter*");
  mime_type = s7_car(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_mime_type", 2, mime_type, "gchar*");
  gtk_file_filter_add_mime_type((GtkFileFilter*)s7_c_pointer(filter), (gchar*)s7_string(mime_type));
  return(lg_false);
}

static s7_pointer lg_gtk_file_filter_add_pattern(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_pattern "void gtk_file_filter_add_pattern(GtkFileFilter* filter, gchar* pattern)"
  s7_pointer _p;
  s7_pointer filter, pattern;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_pattern", 1, filter, "GtkFileFilter*");
  pattern = s7_car(_p);
  if (!s7_is_string(pattern)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_pattern", 2, pattern, "gchar*");
  gtk_file_filter_add_pattern((GtkFileFilter*)s7_c_pointer(filter), (gchar*)s7_string(pattern));
  return(lg_false);
}

static s7_pointer lg_gtk_file_filter_add_custom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_custom "void gtk_file_filter_add_custom(GtkFileFilter* filter, GtkFileFilterFlags needed, \
GtkFileFilterFunc func, lambda_data func_info, GtkDestroyNotify notify)"
  s7_pointer _p;
  s7_pointer filter, needed, func, func_info, notify;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 1, filter, "GtkFileFilter*");
  needed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(needed)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_custom", 2, needed, "GtkFileFilterFlags");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  notify = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, notify);
    gtk_file_filter_add_custom((GtkFileFilter*)s7_c_pointer(filter), (GtkFileFilterFlags)s7_integer(needed), lg_file_filter, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_file_filter_get_needed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_get_needed "GtkFileFilterFlags gtk_file_filter_get_needed(GtkFileFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_get_needed", 1, filter, "GtkFileFilter*");
  return(s7_make_integer(sc, gtk_file_filter_get_needed((GtkFileFilter*)s7_c_pointer(filter))));
}

static s7_pointer lg_gtk_file_filter_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_filter "gboolean gtk_file_filter_filter(GtkFileFilter* filter, GtkFileFilterInfo* filter_info)"
  s7_pointer _p;
  s7_pointer filter, filter_info;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_filter", 1, filter, "GtkFileFilter*");
  filter_info = s7_car(_p);
  if (!s7_is_c_pointer_of_type(filter_info, GtkFileFilterInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_filter", 2, filter_info, "GtkFileFilterInfo*");
  return(s7_make_boolean(sc, gtk_file_filter_filter((GtkFileFilter*)s7_c_pointer(filter), (GtkFileFilterInfo*)s7_c_pointer(filter_info))));
}

static s7_pointer lg_gtk_cell_layout_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_pack_start "void gtk_cell_layout_pack_start(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, expand;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_start", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_start", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_start", 3, expand, "gboolean");
  gtk_cell_layout_pack_start((GtkCellLayout*)s7_c_pointer(cell_layout), (GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_pack_end "void gtk_cell_layout_pack_end(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, expand;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_end", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_end", 2, cell, "GtkCellRenderer*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_pack_end", 3, expand, "gboolean");
  gtk_cell_layout_pack_end((GtkCellLayout*)s7_c_pointer(cell_layout), (GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_clear "void gtk_cell_layout_clear(GtkCellLayout* cell_layout)"
  s7_pointer cell_layout;
  cell_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_clear", 1, cell_layout, "GtkCellLayout*");
  gtk_cell_layout_clear((GtkCellLayout*)s7_c_pointer(cell_layout));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_set_attributes "void gtk_cell_layout_set_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, etc attributes)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, attributes;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_attributes", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_attributes", 2, cell, "GtkCellRenderer*");
  attributes = s7_car(_p);
  if (!lg_is_list(attributes)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_attributes", 3, attributes, "etc");
  {
    int etc_len = 0;
    GtkCellLayout* p_arg0;
    GtkCellRenderer* p_arg1;
    if (s7_is_list(sc, attributes)) etc_len = s7_list_length(sc, attributes);
    if (etc_len < 2) s7_out_of_range_error(sc, "gtk_cell_layout_set_attributes", 2, attributes, "... list must have at least 2 entries");
    if (etc_len > 10) s7_out_of_range_error(sc, "gtk_cell_layout_set_attributes", 2, attributes, "... list too long (max len: 10)");
    if ((etc_len % 2) != 0) s7_out_of_range_error(sc, "gtk_cell_layout_set_attributes", 2, attributes, "... list len must be multiple of 2");
    p_arg0 = (GtkCellLayout*)s7_c_pointer(cell_layout);
    p_arg1 = (GtkCellRenderer*)s7_c_pointer(cell);
    switch (etc_len)
      {
        case 2: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), NULL); break;
        case 4: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), NULL); break;
        case 6: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), NULL); break;
        case 8: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), NULL); break;
        case 10: gtk_cell_layout_set_attributes(p_arg0, p_arg1, s7_string(s7_list_ref(sc, attributes, 0)), s7_integer(s7_list_ref(sc, attributes, 1)), s7_string(s7_list_ref(sc, attributes, 2)), s7_integer(s7_list_ref(sc, attributes, 3)), s7_string(s7_list_ref(sc, attributes, 4)), s7_integer(s7_list_ref(sc, attributes, 5)), s7_string(s7_list_ref(sc, attributes, 6)), s7_integer(s7_list_ref(sc, attributes, 7)), s7_string(s7_list_ref(sc, attributes, 8)), s7_integer(s7_list_ref(sc, attributes, 9)), NULL); break;
      }
    return(lg_false);
  }
}

static s7_pointer lg_gtk_cell_layout_add_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_add_attribute "void gtk_cell_layout_add_attribute(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, gchar* attribute, gint column)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, attribute, column;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 2, cell, "GtkCellRenderer*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 3, attribute, "gchar*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_add_attribute", 4, column, "gint");
  gtk_cell_layout_add_attribute((GtkCellLayout*)s7_c_pointer(cell_layout), (GtkCellRenderer*)s7_c_pointer(cell), (gchar*)s7_string(attribute), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_set_cell_data_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_set_cell_data_func "void gtk_cell_layout_set_cell_data_func(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell, GtkCellLayoutDataFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, func, func_info, destroy;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 2, cell, "GtkCellRenderer*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkCellLayoutDataFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_set_cell_data_func", 3, func, "GtkCellLayoutDataFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_cell_layout_set_cell_data_func((GtkCellLayout*)s7_c_pointer(cell_layout), (GtkCellRenderer*)s7_c_pointer(cell), (GtkCellLayoutDataFunc)s7_c_pointer(func), (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_cell_layout_clear_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_clear_attributes "void gtk_cell_layout_clear_attributes(GtkCellLayout* cell_layout, \
GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer cell_layout, cell;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_clear_attributes", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_clear_attributes", 2, cell, "GtkCellRenderer*");
  gtk_cell_layout_clear_attributes((GtkCellLayout*)s7_c_pointer(cell_layout), (GtkCellRenderer*)s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_action "void gtk_file_chooser_set_action(GtkFileChooser* chooser, GtkFileChooserAction action)"
  s7_pointer _p;
  s7_pointer chooser, action;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_action", 1, chooser, "GtkFileChooser*");
  action = s7_car(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_action", 2, action, "GtkFileChooserAction");
  gtk_file_chooser_set_action((GtkFileChooser*)s7_c_pointer(chooser), (GtkFileChooserAction)s7_integer(action));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_action "GtkFileChooserAction gtk_file_chooser_get_action(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_action", 1, chooser, "GtkFileChooser*");
  return(s7_make_integer(sc, gtk_file_chooser_get_action((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_icon_info_get_base_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_get_base_size "gint gtk_icon_info_get_base_size(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_get_base_size", 1, icon_info, "GtkIconInfo*");
  return(s7_make_integer(sc, gtk_icon_info_get_base_size((GtkIconInfo*)s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_icon_info_get_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_get_filename "gchar* gtk_icon_info_get_filename(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_get_filename", 1, icon_info, "GtkIconInfo*");
  return(s7_make_string(sc, gtk_icon_info_get_filename((GtkIconInfo*)s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_icon_info_load_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_load_icon "GdkPixbuf* gtk_icon_info_load_icon(GtkIconInfo* icon_info, GError** [error])"
  s7_pointer _p;
  s7_pointer icon_info;
  GError* ref_error = NULL;
  _p = args;
  icon_info = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_load_icon", 1, icon_info, "GtkIconInfo*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gtk_icon_info_load_icon((GtkIconInfo*)s7_c_pointer(icon_info), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_list_store_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_remove "gboolean gtk_list_store_remove(GtkListStore* list_store, GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer list_store, iter;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_remove", 1, list_store, "GtkListStore*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_remove", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_list_store_remove((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_cell_layout_reorder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_reorder "void gtk_cell_layout_reorder(GtkCellLayout* cell_layout, GtkCellRenderer* cell, \
gint position)"
  s7_pointer _p;
  s7_pointer cell_layout, cell, position;
  _p = args;
  cell_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_reorder", 1, cell_layout, "GtkCellLayout*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_reorder", 2, cell, "GtkCellRenderer*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_reorder", 3, position, "gint");
  gtk_cell_layout_reorder((GtkCellLayout*)s7_c_pointer(cell_layout), (GtkCellRenderer*)s7_c_pointer(cell), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_get_child1(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_child1 "GtkWidget* gtk_paned_get_child1(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_child1", 1, paned, "GtkPaned*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_paned_get_child1((GtkPaned*)s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_paned_get_child2(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_child2 "GtkWidget* gtk_paned_get_child2(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_child2", 1, paned, "GtkPaned*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_paned_get_child2((GtkPaned*)s7_c_pointer(paned))));
}

static s7_pointer lg_g_list_nth_data(s7_scheme *sc, s7_pointer args)
{
  #define H_g_list_nth_data "gpointer g_list_nth_data(GList* list, guint n)"
  s7_pointer _p;
  s7_pointer list, n;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, GList__sym)) s7_wrong_type_arg_error(sc, "g_list_nth_data", 1, list, "GList*");
  n = s7_car(_p);
  if (!s7_is_integer(n)) s7_wrong_type_arg_error(sc, "g_list_nth_data", 2, n, "guint");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, g_list_nth_data((GList*)s7_c_pointer(list), (guint)s7_integer(n))));
}

static s7_pointer lg_gtk_combo_box_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_popup "void gtk_combo_box_popup(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popup", 1, combo_box, "GtkComboBox*");
  gtk_combo_box_popup((GtkComboBox*)s7_c_pointer(combo_box));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_popdown(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_popdown "void gtk_combo_box_popdown(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popdown", 1, combo_box, "GtkComboBox*");
  gtk_combo_box_popdown((GtkComboBox*)s7_c_pointer(combo_box));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_layout "PangoLayout* gtk_scale_get_layout(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_layout", 1, scale, "GtkScale*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, gtk_scale_get_layout((GtkScale*)s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_scale_get_layout_offsets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_layout_offsets "void gtk_scale_get_layout_offsets(GtkScale* scale, gint* [x], \
gint* [y])"
  s7_pointer _p;
  s7_pointer scale;
  gint ref_x;
  gint ref_y;
  _p = args;
  scale = s7_car(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_layout_offsets", 1, scale, "GtkScale*");
  gtk_scale_get_layout_offsets((GtkScale*)s7_c_pointer(scale), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gtk_entry_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_alignment "void gtk_entry_set_alignment(GtkEntry* entry, gfloat xalign)"
  s7_pointer _p;
  s7_pointer entry, xalign;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_alignment", 1, entry, "GtkEntry*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_entry_set_alignment", 2, xalign, "gfloat");
  gtk_entry_set_alignment((GtkEntry*)s7_c_pointer(entry), (gfloat)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_alignment "gfloat gtk_entry_get_alignment(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_alignment", 1, entry, "GtkEntry*");
  return(s7_make_real(sc, gtk_entry_get_alignment((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_widget_list_mnemonic_labels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_list_mnemonic_labels "GList* gtk_widget_list_mnemonic_labels(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_list_mnemonic_labels", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_widget_list_mnemonic_labels((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_add_mnemonic_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_add_mnemonic_label "void gtk_widget_add_mnemonic_label(GtkWidget* widget, GtkWidget* label)"
  s7_pointer _p;
  s7_pointer widget, label;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_mnemonic_label", 1, widget, "GtkWidget*");
  label = s7_car(_p);
  if (!s7_is_c_pointer_of_type(label, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_mnemonic_label", 2, label, "GtkWidget*");
  gtk_widget_add_mnemonic_label((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(label));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_remove_mnemonic_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_remove_mnemonic_label "void gtk_widget_remove_mnemonic_label(GtkWidget* widget, \
GtkWidget* label)"
  s7_pointer _p;
  s7_pointer widget, label;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_mnemonic_label", 1, widget, "GtkWidget*");
  label = s7_car(_p);
  if (!s7_is_c_pointer_of_type(label, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_mnemonic_label", 2, label, "GtkWidget*");
  gtk_widget_remove_mnemonic_label((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(label));
  return(lg_false);
}

static s7_pointer lg_g_quark_from_string(s7_scheme *sc, s7_pointer args)
{
  #define H_g_quark_from_string "GQuark g_quark_from_string(gchar* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "g_quark_from_string", 1, string, "gchar*");
  return(s7_make_integer(sc, g_quark_from_string((gchar*)s7_string(string))));
}

static s7_pointer lg_g_quark_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_g_quark_to_string "gchar* g_quark_to_string(GQuark quark)"
  s7_pointer quark;
  quark = s7_car(args);
  if (!s7_is_integer(quark)) s7_wrong_type_arg_error(sc, "g_quark_to_string", 1, quark, "GQuark");
  return(s7_make_string(sc, g_quark_to_string((GQuark)s7_integer(quark))));
}

static s7_pointer lg_gtk_cell_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new "GtkWidget* gtk_cell_view_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_cell_view_new()));
}

static s7_pointer lg_gtk_cell_view_new_with_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new_with_text "GtkWidget* gtk_cell_view_new_with_text(gchar* text)"
  s7_pointer text;
  text = s7_car(args);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_cell_view_new_with_text", 1, text, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_cell_view_new_with_text((gchar*)s7_string(text))));
}

static s7_pointer lg_gtk_cell_view_new_with_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new_with_markup "GtkWidget* gtk_cell_view_new_with_markup(gchar* markup)"
  s7_pointer markup;
  markup = s7_car(args);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_cell_view_new_with_markup", 1, markup, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_cell_view_new_with_markup((gchar*)s7_string(markup))));
}

static s7_pointer lg_gtk_cell_view_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_model "void gtk_cell_view_set_model(GtkCellView* cell_view, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer cell_view, model;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_model", 1, cell_view, "GtkCellView*");
  model = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_model", 2, model, "GtkTreeModel*");
  gtk_cell_view_set_model((GtkCellView*)s7_c_pointer(cell_view), (GtkTreeModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_set_displayed_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_displayed_row "void gtk_cell_view_set_displayed_row(GtkCellView* cell_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer cell_view, path;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_displayed_row", 1, cell_view, "GtkCellView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_displayed_row", 2, path, "GtkTreePath*");
  gtk_cell_view_set_displayed_row((GtkCellView*)s7_c_pointer(cell_view), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_get_displayed_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_displayed_row "GtkTreePath* gtk_cell_view_get_displayed_row(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_displayed_row", 1, cell_view, "GtkCellView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_cell_view_get_displayed_row((GtkCellView*)s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_entry_completion_insert_prefix(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_insert_prefix "void gtk_entry_completion_insert_prefix(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_insert_prefix", 1, completion, "GtkEntryCompletion*");
  gtk_entry_completion_insert_prefix((GtkEntryCompletion*)s7_c_pointer(completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_set_inline_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_inline_completion "void gtk_entry_completion_set_inline_completion(GtkEntryCompletion* completion, \
gboolean inline_completion)"
  s7_pointer _p;
  s7_pointer completion, inline_completion;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_completion", 1, completion, "GtkEntryCompletion*");
  inline_completion = s7_car(_p);
  if (!s7_is_boolean(inline_completion)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_completion", 2, inline_completion, "gboolean");
  gtk_entry_completion_set_inline_completion((GtkEntryCompletion*)s7_c_pointer(completion), (gboolean)lg_boolean(inline_completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_inline_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_inline_completion "gboolean gtk_entry_completion_get_inline_completion(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_inline_completion", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_inline_completion((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_set_popup_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_popup_completion "void gtk_entry_completion_set_popup_completion(GtkEntryCompletion* completion, \
gboolean popup_completion)"
  s7_pointer _p;
  s7_pointer completion, popup_completion;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_completion", 1, completion, "GtkEntryCompletion*");
  popup_completion = s7_car(_p);
  if (!s7_is_boolean(popup_completion)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_completion", 2, popup_completion, "gboolean");
  gtk_entry_completion_set_popup_completion((GtkEntryCompletion*)s7_c_pointer(completion), (gboolean)lg_boolean(popup_completion));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_popup_completion(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_popup_completion "gboolean gtk_entry_completion_get_popup_completion(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_popup_completion", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_popup_completion((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_get_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_text_column "gint gtk_entry_completion_get_text_column(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_text_column", 1, completion, "GtkEntryCompletion*");
  return(s7_make_integer(sc, gtk_entry_completion_get_text_column((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_tree_view_set_fixed_height_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_fixed_height_mode "void gtk_tree_view_set_fixed_height_mode(GtkTreeView* tree_view, \
gboolean enable)"
  s7_pointer _p;
  s7_pointer tree_view, enable;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_fixed_height_mode", 1, tree_view, "GtkTreeView*");
  enable = s7_car(_p);
  if (!s7_is_boolean(enable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_fixed_height_mode", 2, enable, "gboolean");
  gtk_tree_view_set_fixed_height_mode((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(enable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_fixed_height_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_fixed_height_mode "gboolean gtk_tree_view_get_fixed_height_mode(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_fixed_height_mode", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_fixed_height_mode((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_hover_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_hover_selection "void gtk_tree_view_set_hover_selection(GtkTreeView* tree_view, \
gboolean hover)"
  s7_pointer _p;
  s7_pointer tree_view, hover;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_selection", 1, tree_view, "GtkTreeView*");
  hover = s7_car(_p);
  if (!s7_is_boolean(hover)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_selection", 2, hover, "gboolean");
  gtk_tree_view_set_hover_selection((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(hover));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_hover_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_hover_selection "gboolean gtk_tree_view_get_hover_selection(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_hover_selection", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_hover_selection((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_row_separator_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_row_separator_func "void gtk_tree_view_set_row_separator_func(GtkTreeView* tree_view, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer tree_view, func, func_info, destroy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_row_separator_func", 1, tree_view, "GtkTreeView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_tree_view_set_row_separator_func((GtkTreeView*)s7_c_pointer(tree_view), lg_row_separator, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_window_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_icon_name "void gtk_window_set_icon_name(GtkWindow* window, gchar* name)"
  s7_pointer _p;
  s7_pointer window, name;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_name", 1, window, "GtkWindow*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_window_set_icon_name", 2, name, "gchar*");
  gtk_window_set_icon_name((GtkWindow*)s7_c_pointer(window), (gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_icon_name "gchar* gtk_window_get_icon_name(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_icon_name", 1, window, "GtkWindow*");
  return(s7_make_string(sc, gtk_window_get_icon_name((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_set_default_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_icon_name "void gtk_window_set_default_icon_name(gchar* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_icon_name", 1, name, "gchar*");
  gtk_window_set_default_icon_name((gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_new "GtkWidget* gtk_about_dialog_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_about_dialog_new()));
}

static s7_pointer lg_gtk_about_dialog_get_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_version "gchar* gtk_about_dialog_get_version(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_version", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_version((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_version "void gtk_about_dialog_set_version(GtkAboutDialog* about, gchar* version)"
  s7_pointer _p;
  s7_pointer about, version;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_version", 1, about, "GtkAboutDialog*");
  version = s7_car(_p);
  if (!s7_is_string(version)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_version", 2, version, "gchar*");
  gtk_about_dialog_set_version((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(version));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_copyright(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_copyright "gchar* gtk_about_dialog_get_copyright(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_copyright", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_copyright((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_copyright(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_copyright "void gtk_about_dialog_set_copyright(GtkAboutDialog* about, \
gchar* copyright)"
  s7_pointer _p;
  s7_pointer about, copyright;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_copyright", 1, about, "GtkAboutDialog*");
  copyright = s7_car(_p);
  if (!s7_is_string(copyright)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_copyright", 2, copyright, "gchar*");
  gtk_about_dialog_set_copyright((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(copyright));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_comments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_comments "gchar* gtk_about_dialog_get_comments(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_comments", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_comments((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_comments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_comments "void gtk_about_dialog_set_comments(GtkAboutDialog* about, \
gchar* comments)"
  s7_pointer _p;
  s7_pointer about, comments;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_comments", 1, about, "GtkAboutDialog*");
  comments = s7_car(_p);
  if (!s7_is_string(comments)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_comments", 2, comments, "gchar*");
  gtk_about_dialog_set_comments((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(comments));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_website(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_website "gchar* gtk_about_dialog_get_website(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_website", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_website((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_website(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_website "void gtk_about_dialog_set_website(GtkAboutDialog* about, gchar* website)"
  s7_pointer _p;
  s7_pointer about, website;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website", 1, about, "GtkAboutDialog*");
  website = s7_car(_p);
  if (!s7_is_string(website)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website", 2, website, "gchar*");
  gtk_about_dialog_set_website((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(website));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_website_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_website_label "gchar* gtk_about_dialog_get_website_label(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_website_label", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_website_label((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_website_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_website_label "void gtk_about_dialog_set_website_label(GtkAboutDialog* about, \
gchar* website_label)"
  s7_pointer _p;
  s7_pointer about, website_label;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website_label", 1, about, "GtkAboutDialog*");
  website_label = s7_car(_p);
  if (!s7_is_string(website_label)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_website_label", 2, website_label, "gchar*");
  gtk_about_dialog_set_website_label((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(website_label));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_authors(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_authors "gchar** gtk_about_dialog_get_authors(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_authors", 1, about, "GtkAboutDialog*");
    return(lg_make_c_pointer_with_type(sc, gchar___sym, (gchar**)gtk_about_dialog_get_authors((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_authors(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_authors "void gtk_about_dialog_set_authors(GtkAboutDialog* about, gchar** authors)"
  s7_pointer _p;
  s7_pointer about, authors;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_authors", 1, about, "GtkAboutDialog*");
  authors = s7_car(_p);
  if (!s7_is_c_pointer_of_type(authors, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_authors", 2, authors, "gchar**");
  gtk_about_dialog_set_authors((GtkAboutDialog*)s7_c_pointer(about), (const gchar**)s7_c_pointer(authors));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_documenters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_documenters "gchar** gtk_about_dialog_get_documenters(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_documenters", 1, about, "GtkAboutDialog*");
    return(lg_make_c_pointer_with_type(sc, gchar___sym, (gchar**)gtk_about_dialog_get_documenters((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_documenters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_documenters "void gtk_about_dialog_set_documenters(GtkAboutDialog* about, \
gchar** documenters)"
  s7_pointer _p;
  s7_pointer about, documenters;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_documenters", 1, about, "GtkAboutDialog*");
  documenters = s7_car(_p);
  if (!s7_is_c_pointer_of_type(documenters, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_documenters", 2, documenters, "gchar**");
  gtk_about_dialog_set_documenters((GtkAboutDialog*)s7_c_pointer(about), (const gchar**)s7_c_pointer(documenters));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_artists(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_artists "gchar** gtk_about_dialog_get_artists(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_artists", 1, about, "GtkAboutDialog*");
    return(lg_make_c_pointer_with_type(sc, gchar___sym, (gchar**)gtk_about_dialog_get_artists((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_artists(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_artists "void gtk_about_dialog_set_artists(GtkAboutDialog* about, gchar** artists)"
  s7_pointer _p;
  s7_pointer about, artists;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_artists", 1, about, "GtkAboutDialog*");
  artists = s7_car(_p);
  if (!s7_is_c_pointer_of_type(artists, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_artists", 2, artists, "gchar**");
  gtk_about_dialog_set_artists((GtkAboutDialog*)s7_c_pointer(about), (const gchar**)s7_c_pointer(artists));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_translator_credits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_translator_credits "gchar* gtk_about_dialog_get_translator_credits(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_translator_credits", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_translator_credits((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_translator_credits(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_translator_credits "void gtk_about_dialog_set_translator_credits(GtkAboutDialog* about, \
gchar* translator_credits)"
  s7_pointer _p;
  s7_pointer about, translator_credits;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_translator_credits", 1, about, "GtkAboutDialog*");
  translator_credits = s7_car(_p);
  if (!s7_is_string(translator_credits)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_translator_credits", 2, translator_credits, "gchar*");
  gtk_about_dialog_set_translator_credits((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(translator_credits));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_program_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_program_name "gchar* gtk_about_dialog_get_program_name(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_program_name", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_program_name((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_program_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_program_name "void gtk_about_dialog_set_program_name(GtkAboutDialog* about, \
gchar* name)"
  s7_pointer _p;
  s7_pointer about, name;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_program_name", 1, about, "GtkAboutDialog*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_program_name", 2, name, "gchar*");
  gtk_about_dialog_set_program_name((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_new "GtkWidget* gtk_icon_view_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_icon_view_new()));
}

static s7_pointer lg_gtk_icon_view_new_with_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_new_with_model "GtkWidget* gtk_icon_view_new_with_model(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_new_with_model", 1, model, "GtkTreeModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_icon_view_new_with_model((GtkTreeModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_icon_view_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_model "void gtk_icon_view_set_model(GtkIconView* icon_view, GtkTreeModel* model)"
  s7_pointer _p;
  s7_pointer icon_view, model;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_model", 1, icon_view, "GtkIconView*");
  model = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) && (model != lg_false)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_model", 2, model, "GtkTreeModel*");
  gtk_icon_view_set_model((GtkIconView*)s7_c_pointer(icon_view), (GtkTreeModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_model "GtkTreeModel* gtk_icon_view_get_model(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_model", 1, icon_view, "GtkIconView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_icon_view_get_model((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_text_column "void gtk_icon_view_set_text_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_text_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_text_column", 2, column, "gint");
  gtk_icon_view_set_text_column((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_text_column "gint gtk_icon_view_get_text_column(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_text_column", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_text_column((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_markup_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_markup_column "void gtk_icon_view_set_markup_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_markup_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_markup_column", 2, column, "gint");
  gtk_icon_view_set_markup_column((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_markup_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_markup_column "gint gtk_icon_view_get_markup_column(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_markup_column", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_markup_column((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_pixbuf_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_pixbuf_column "void gtk_icon_view_set_pixbuf_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_pixbuf_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_pixbuf_column", 2, column, "gint");
  gtk_icon_view_set_pixbuf_column((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_pixbuf_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_pixbuf_column "gint gtk_icon_view_get_pixbuf_column(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_pixbuf_column", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_pixbuf_column((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_get_path_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_path_at_pos "GtkTreePath* gtk_icon_view_get_path_at_pos(GtkIconView* icon_view, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer icon_view, x, y;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_path_at_pos", 1, icon_view, "GtkIconView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_path_at_pos", 2, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_path_at_pos", 3, y, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkTreePath__sym, gtk_icon_view_get_path_at_pos((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(x), (gint)s7_integer(y))));
}

static s7_pointer lg_gtk_icon_view_selected_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_selected_foreach "void gtk_icon_view_selected_foreach(GtkIconView* icon_view, \
GtkIconViewForeachFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer icon_view, func, func_info;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_selected_foreach", 1, icon_view, "GtkIconView*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    gtk_icon_view_selected_foreach((GtkIconView*)s7_c_pointer(icon_view), lg_icon_view_foreach, (gpointer)lg_ptr);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_icon_view_set_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_selection_mode "void gtk_icon_view_set_selection_mode(GtkIconView* icon_view, \
GtkSelectionMode mode)"
  s7_pointer _p;
  s7_pointer icon_view, mode;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_selection_mode", 1, icon_view, "GtkIconView*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_selection_mode", 2, mode, "GtkSelectionMode");
  gtk_icon_view_set_selection_mode((GtkIconView*)s7_c_pointer(icon_view), (GtkSelectionMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_selection_mode "GtkSelectionMode gtk_icon_view_get_selection_mode(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_selection_mode", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_selection_mode((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_select_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_select_path "void gtk_icon_view_select_path(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_select_path", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_select_path", 2, path, "GtkTreePath*");
  gtk_icon_view_select_path((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unselect_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unselect_path "void gtk_icon_view_unselect_path(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unselect_path", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unselect_path", 2, path, "GtkTreePath*");
  gtk_icon_view_unselect_path((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_path_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_path_is_selected "gboolean gtk_icon_view_path_is_selected(GtkIconView* icon_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_path_is_selected", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_path_is_selected", 2, path, "GtkTreePath*");
  return(s7_make_boolean(sc, gtk_icon_view_path_is_selected((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_icon_view_get_selected_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_selected_items "GList* gtk_icon_view_get_selected_items(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_selected_items", 1, icon_view, "GtkIconView*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_icon_view_get_selected_items((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_select_all "void gtk_icon_view_select_all(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_select_all", 1, icon_view, "GtkIconView*");
  gtk_icon_view_select_all((GtkIconView*)s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unselect_all "void gtk_icon_view_unselect_all(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unselect_all", 1, icon_view, "GtkIconView*");
  gtk_icon_view_unselect_all((GtkIconView*)s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_item_activated(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_item_activated "void gtk_icon_view_item_activated(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_item_activated", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_item_activated", 2, path, "GtkTreePath*");
  gtk_icon_view_item_activated((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_combo_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_combo_new "GtkCellRenderer* gtk_cell_renderer_combo_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_combo_new()));
}

static s7_pointer lg_gtk_cell_renderer_progress_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_progress_new "GtkCellRenderer* gtk_cell_renderer_progress_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_progress_new()));
}

static s7_pointer lg_gtk_combo_box_set_row_separator_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_row_separator_func "void gtk_combo_box_set_row_separator_func(GtkComboBox* combo_box, \
GtkTreeViewRowSeparatorFunc func, lambda_data func_info, GtkDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer combo_box, func, func_info, destroy;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_row_separator_func", 1, combo_box, "GtkComboBox*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_combo_box_set_row_separator_func((GtkComboBox*)s7_c_pointer(combo_box), lg_row_separator, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_label_set_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_ellipsize "void gtk_label_set_ellipsize(GtkLabel* label, PangoEllipsizeMode mode)"
  s7_pointer _p;
  s7_pointer label, mode;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_ellipsize", 1, label, "GtkLabel*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_label_set_ellipsize", 2, mode, "PangoEllipsizeMode");
  gtk_label_set_ellipsize((GtkLabel*)s7_c_pointer(label), (PangoEllipsizeMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_ellipsize "PangoEllipsizeMode gtk_label_get_ellipsize(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_ellipsize", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_ellipsize((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_pango_attr_fallback_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_fallback_new "PangoAttribute* pango_attr_fallback_new(gboolean enable_fallback)"
  s7_pointer enable_fallback;
  enable_fallback = s7_car(args);
  if (!s7_is_boolean(enable_fallback)) s7_wrong_type_arg_error(sc, "pango_attr_fallback_new", 1, enable_fallback, "gboolean");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_fallback_new((gboolean)lg_boolean(enable_fallback))));
}

static s7_pointer lg_pango_attr_letter_spacing_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_letter_spacing_new "PangoAttribute* pango_attr_letter_spacing_new(int letter_spacing)"
  s7_pointer letter_spacing;
  letter_spacing = s7_car(args);
  if (!s7_is_integer(letter_spacing)) s7_wrong_type_arg_error(sc, "pango_attr_letter_spacing_new", 1, letter_spacing, "int");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_letter_spacing_new((int)s7_integer(letter_spacing))));
}

static s7_pointer lg_pango_attr_list_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_filter "PangoAttrList* pango_attr_list_filter(PangoAttrList* list, PangoAttrFilterFunc func, \
gpointer data)"
  s7_pointer _p;
  s7_pointer list, func, data;
  _p = args;
  list = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_filter", 1, list, "PangoAttrList*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, PangoAttrFilterFunc_sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_filter", 2, func, "PangoAttrFilterFunc");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_filter", 3, data, "gpointer");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, pango_attr_list_filter((PangoAttrList*)s7_c_pointer(list), (PangoAttrFilterFunc)s7_c_pointer(func), (gpointer)s7_c_pointer(data))));
}

static s7_pointer lg_pango_attr_iterator_get_attrs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_iterator_get_attrs "GSList* pango_attr_iterator_get_attrs(PangoAttrIterator* iterator)"
  s7_pointer iterator;
  iterator = s7_car(args);
  if (!s7_is_c_pointer_of_type(iterator, PangoAttrIterator__sym)) s7_wrong_type_arg_error(sc, "pango_attr_iterator_get_attrs", 1, iterator, "PangoAttrIterator*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, pango_attr_iterator_get_attrs((PangoAttrIterator*)s7_c_pointer(iterator))));
}

static s7_pointer lg_pango_font_metrics_get_underline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_underline_position "int pango_font_metrics_get_underline_position(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_underline_position", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_underline_position((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_underline_thickness(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_underline_thickness "int pango_font_metrics_get_underline_thickness(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_underline_thickness", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_underline_thickness((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_strikethrough_position(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_strikethrough_position "int pango_font_metrics_get_strikethrough_position(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_strikethrough_position", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_strikethrough_position((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_metrics_get_strikethrough_thickness(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_metrics_get_strikethrough_thickness "int pango_font_metrics_get_strikethrough_thickness(PangoFontMetrics* metrics)"
  s7_pointer metrics;
  metrics = s7_car(args);
  if (!s7_is_c_pointer_of_type(metrics, PangoFontMetrics__sym)) s7_wrong_type_arg_error(sc, "pango_font_metrics_get_strikethrough_thickness", 1, metrics, "PangoFontMetrics*");
  return(s7_make_integer(sc, pango_font_metrics_get_strikethrough_thickness((PangoFontMetrics*)s7_c_pointer(metrics))));
}

static s7_pointer lg_pango_font_family_is_monospace(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_family_is_monospace "gboolean pango_font_family_is_monospace(PangoFontFamily* family)"
  s7_pointer family;
  family = s7_car(args);
  if (!s7_is_c_pointer_of_type(family, PangoFontFamily__sym)) s7_wrong_type_arg_error(sc, "pango_font_family_is_monospace", 1, family, "PangoFontFamily*");
  return(s7_make_boolean(sc, pango_font_family_is_monospace((PangoFontFamily*)s7_c_pointer(family))));
}

static s7_pointer lg_pango_font_face_list_sizes(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_face_list_sizes "void pango_font_face_list_sizes(PangoFontFace* face, int** [sizes], \
int* [n_sizes])"
  s7_pointer _p;
  s7_pointer face;
  int* ref_sizes = NULL;
  int ref_n_sizes;
  _p = args;
  face = s7_car(_p);
  if (!s7_is_c_pointer_of_type(face, PangoFontFace__sym)) s7_wrong_type_arg_error(sc, "pango_font_face_list_sizes", 1, face, "PangoFontFace*");
  pango_font_face_list_sizes((PangoFontFace*)s7_c_pointer(face), &ref_sizes, &ref_n_sizes);
    return(s7_list(sc, 2, s7_make_c_pointer(sc, ref_sizes), s7_make_integer(sc, ref_n_sizes)));
}

static s7_pointer lg_pango_layout_set_auto_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_set_auto_dir "void pango_layout_set_auto_dir(PangoLayout* layout, gboolean auto_dir)"
  s7_pointer _p;
  s7_pointer layout, auto_dir;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_set_auto_dir", 1, layout, "PangoLayout*");
  auto_dir = s7_car(_p);
  if (!s7_is_boolean(auto_dir)) s7_wrong_type_arg_error(sc, "pango_layout_set_auto_dir", 2, auto_dir, "gboolean");
  pango_layout_set_auto_dir((PangoLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(auto_dir));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_auto_dir(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_auto_dir "gboolean pango_layout_get_auto_dir(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_auto_dir", 1, layout, "PangoLayout*");
  return(s7_make_boolean(sc, pango_layout_get_auto_dir((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_pango_script_iter_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_new "PangoScriptIter* pango_script_iter_new(char* text, int length)"
  s7_pointer _p;
  s7_pointer text, length;
  _p = args;
  text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "pango_script_iter_new", 1, text, "char*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "pango_script_iter_new", 2, length, "int");
  return(lg_make_c_pointer_with_type(sc, PangoScriptIter__sym, pango_script_iter_new((char*)s7_string(text), (int)s7_integer(length))));
}

static s7_pointer lg_pango_script_iter_get_range(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_get_range "void pango_script_iter_get_range(PangoScriptIter* iter, char** [start], \
char** [end], PangoScript* [script])"
  s7_pointer _p;
  s7_pointer iter;
  char* ref_start = NULL;
  char* ref_end = NULL;
  PangoScript ref_script;
  _p = args;
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, PangoScriptIter__sym)) s7_wrong_type_arg_error(sc, "pango_script_iter_get_range", 1, iter, "PangoScriptIter*");
  pango_script_iter_get_range((PangoScriptIter*)s7_c_pointer(iter), (const char**)&ref_start, (const char**)&ref_end, &ref_script);
    return(s7_list(sc, 3, s7_make_string(sc, ref_start), s7_make_string(sc, ref_end), s7_make_integer(sc, ref_script)));
}

static s7_pointer lg_pango_script_iter_next(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_next "gboolean pango_script_iter_next(PangoScriptIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoScriptIter__sym)) s7_wrong_type_arg_error(sc, "pango_script_iter_next", 1, iter, "PangoScriptIter*");
  return(s7_make_boolean(sc, pango_script_iter_next((PangoScriptIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_pango_script_iter_free(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_script_iter_free "void pango_script_iter_free(PangoScriptIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, PangoScriptIter__sym)) s7_wrong_type_arg_error(sc, "pango_script_iter_free", 1, iter, "PangoScriptIter*");
  pango_script_iter_free((PangoScriptIter*)s7_c_pointer(iter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_button_new_with_dialog(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_new_with_dialog "GtkWidget* gtk_file_chooser_button_new_with_dialog(GtkWidget* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_new_with_dialog", 1, dialog, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_file_chooser_button_new_with_dialog((GtkWidget*)s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_file_chooser_button_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_get_title "gchar* gtk_file_chooser_button_get_title(GtkFileChooserButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_get_title", 1, button, "GtkFileChooserButton*");
  return(s7_make_string(sc, gtk_file_chooser_button_get_title((GtkFileChooserButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_file_chooser_button_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_set_title "void gtk_file_chooser_button_set_title(GtkFileChooserButton* button, \
gchar* title)"
  s7_pointer _p;
  s7_pointer button, title;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_title", 1, button, "GtkFileChooserButton*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_title", 2, title, "gchar*");
  gtk_file_chooser_button_set_title((GtkFileChooserButton*)s7_c_pointer(button), (gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_hover_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_hover_expand "void gtk_tree_view_set_hover_expand(GtkTreeView* tree_view, \
gboolean expand)"
  s7_pointer _p;
  s7_pointer tree_view, expand;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_expand", 1, tree_view, "GtkTreeView*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_hover_expand", 2, expand, "gboolean");
  gtk_tree_view_set_hover_expand((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_hover_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_hover_expand "gboolean gtk_tree_view_get_hover_expand(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_hover_expand", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_hover_expand((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_about_dialog_get_logo_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_logo_icon_name "gchar* gtk_about_dialog_get_logo_icon_name(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_logo_icon_name", 1, about, "GtkAboutDialog*");
  return(s7_make_string(sc, gtk_about_dialog_get_logo_icon_name((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_logo_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_logo_icon_name "void gtk_about_dialog_set_logo_icon_name(GtkAboutDialog* about, \
gchar* icon_name)"
  s7_pointer _p;
  s7_pointer about, icon_name;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo_icon_name", 1, about, "GtkAboutDialog*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo_icon_name", 2, icon_name, "gchar*");
  gtk_about_dialog_set_logo_icon_name((GtkAboutDialog*)s7_c_pointer(about), (gchar*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_get_label "gchar* gtk_accelerator_get_label(guint accelerator_key, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer accelerator_key, accelerator_mods;
  _p = args;
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label", 1, accelerator_key, "guint");
  accelerator_mods = s7_car(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label", 2, accelerator_mods, "GdkModifierType");
  {
    gchar* res_ult;
    s7_pointer rtn;
    res_ult = gtk_accelerator_get_label((guint)s7_integer(accelerator_key), (GdkModifierType)s7_integer(accelerator_mods));
    rtn = s7_make_string(sc, res_ult);
    g_free(res_ult);
    return(rtn);
  }
}

static s7_pointer lg_gtk_file_chooser_button_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_get_width_chars "gint gtk_file_chooser_button_get_width_chars(GtkFileChooserButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_get_width_chars", 1, button, "GtkFileChooserButton*");
  return(s7_make_integer(sc, gtk_file_chooser_button_get_width_chars((GtkFileChooserButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_file_chooser_button_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_set_width_chars "void gtk_file_chooser_button_set_width_chars(GtkFileChooserButton* button, \
gint n_chars)"
  s7_pointer _p;
  s7_pointer button, n_chars;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_width_chars", 1, button, "GtkFileChooserButton*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_width_chars", 2, n_chars, "gint");
  gtk_file_chooser_button_set_width_chars((GtkFileChooserButton*)s7_c_pointer(button), (gint)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_pixel_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_pixel_size "void gtk_image_set_pixel_size(GtkImage* image, gint pixel_size)"
  s7_pointer _p;
  s7_pointer image, pixel_size;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_pixel_size", 1, image, "GtkImage*");
  pixel_size = s7_car(_p);
  if (!s7_is_integer(pixel_size)) s7_wrong_type_arg_error(sc, "gtk_image_set_pixel_size", 2, pixel_size, "gint");
  gtk_image_set_pixel_size((GtkImage*)s7_c_pointer(image), (gint)s7_integer(pixel_size));
  return(lg_false);
}

static s7_pointer lg_gtk_image_get_pixel_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_pixel_size "gint gtk_image_get_pixel_size(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_pixel_size", 1, image, "GtkImage*");
  return(s7_make_integer(sc, gtk_image_get_pixel_size((GtkImage*)s7_c_pointer(image))));
}

static s7_pointer lg_gtk_label_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_width_chars "void gtk_label_set_width_chars(GtkLabel* label, gint n_chars)"
  s7_pointer _p;
  s7_pointer label, n_chars;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_width_chars", 1, label, "GtkLabel*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_label_set_width_chars", 2, n_chars, "gint");
  gtk_label_set_width_chars((GtkLabel*)s7_c_pointer(label), (gint)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_width_chars "gint gtk_label_get_width_chars(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_width_chars", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_width_chars((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_text_buffer_backspace(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_backspace "gboolean gtk_text_buffer_backspace(GtkTextBuffer* buffer, GtkTextIter* iter, \
gboolean interactive, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, iter, interactive, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 2, iter, "GtkTextIter*");
  interactive = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(interactive)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 3, interactive, "gboolean");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_backspace", 4, default_editable, "gboolean");
  return(s7_make_boolean(sc, gtk_text_buffer_backspace((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (gboolean)lg_boolean(interactive), (gboolean)lg_boolean(default_editable))));
}

static s7_pointer lg_gtk_file_filter_add_pixbuf_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_filter_add_pixbuf_formats "void gtk_file_filter_add_pixbuf_formats(GtkFileFilter* filter)"
  s7_pointer filter;
  filter = s7_car(args);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_filter_add_pixbuf_formats", 1, filter, "GtkFileFilter*");
  gtk_file_filter_add_pixbuf_formats((GtkFileFilter*)s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_single_line_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_single_line_mode "void gtk_label_set_single_line_mode(GtkLabel* label, gboolean single_line_mode)"
  s7_pointer _p;
  s7_pointer label, single_line_mode;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_single_line_mode", 1, label, "GtkLabel*");
  single_line_mode = s7_car(_p);
  if (!s7_is_boolean(single_line_mode)) s7_wrong_type_arg_error(sc, "gtk_label_set_single_line_mode", 2, single_line_mode, "gboolean");
  gtk_label_set_single_line_mode((GtkLabel*)s7_c_pointer(label), (gboolean)lg_boolean(single_line_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_single_line_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_single_line_mode "gboolean gtk_label_get_single_line_mode(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_single_line_mode", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_single_line_mode((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_progress_bar_set_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_ellipsize "void gtk_progress_bar_set_ellipsize(GtkProgressBar* pbar, \
PangoEllipsizeMode mode)"
  s7_pointer _p;
  s7_pointer pbar, mode;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_ellipsize", 1, pbar, "GtkProgressBar*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_ellipsize", 2, mode, "PangoEllipsizeMode");
  gtk_progress_bar_set_ellipsize((GtkProgressBar*)s7_c_pointer(pbar), (PangoEllipsizeMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_ellipsize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_ellipsize "PangoEllipsizeMode gtk_progress_bar_get_ellipsize(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_ellipsize", 1, pbar, "GtkProgressBar*");
  return(s7_make_integer(sc, gtk_progress_bar_get_ellipsize((GtkProgressBar*)s7_c_pointer(pbar))));
}

static s7_pointer lg_pango_attr_underline_color_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_underline_color_new "PangoAttribute* pango_attr_underline_color_new(guint16 red, \
guint16 green, guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_underline_color_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_underline_color_new", 2, green, "guint16");
  blue = s7_car(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_underline_color_new", 3, blue, "guint16");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_underline_color_new((guint16)s7_integer(red), (guint16)s7_integer(green), (guint16)s7_integer(blue))));
}

static s7_pointer lg_pango_attr_strikethrough_color_new(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_strikethrough_color_new "PangoAttribute* pango_attr_strikethrough_color_new(guint16 red, \
guint16 green, guint16 blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(red)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_color_new", 1, red, "guint16");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(green)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_color_new", 2, green, "guint16");
  blue = s7_car(_p);
  if (!s7_is_integer(blue)) s7_wrong_type_arg_error(sc, "pango_attr_strikethrough_color_new", 3, blue, "guint16");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_strikethrough_color_new((guint16)s7_integer(red), (guint16)s7_integer(green), (guint16)s7_integer(blue))));
}

static s7_pointer lg_pango_renderer_draw_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_layout "void pango_renderer_draw_layout(PangoRenderer* renderer, PangoLayout* layout, \
int x, int y)"
  s7_pointer _p;
  s7_pointer renderer, layout, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 1, renderer, "PangoRenderer*");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 2, layout, "PangoLayout*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 3, x, "int");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout", 4, y, "int");
  pango_renderer_draw_layout((PangoRenderer*)s7_c_pointer(renderer), (PangoLayout*)s7_c_pointer(layout), (int)s7_integer(x), (int)s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_layout_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_layout_line "void pango_renderer_draw_layout_line(PangoRenderer* renderer, \
PangoLayoutLine* line, int x, int y)"
  s7_pointer _p;
  s7_pointer renderer, line, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 1, renderer, "PangoRenderer*");
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 2, line, "PangoLayoutLine*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 3, x, "int");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_layout_line", 4, y, "int");
  pango_renderer_draw_layout_line((PangoRenderer*)s7_c_pointer(renderer), (PangoLayoutLine*)s7_c_pointer(line), (int)s7_integer(x), (int)s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_glyphs "void pango_renderer_draw_glyphs(PangoRenderer* renderer, PangoFont* font, \
PangoGlyphString* glyphs, int x, int y)"
  s7_pointer _p;
  s7_pointer renderer, font, glyphs, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 1, renderer, "PangoRenderer*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 2, font, "PangoFont*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 3, glyphs, "PangoGlyphString*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 4, x, "int");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyphs", 5, y, "int");
  pango_renderer_draw_glyphs((PangoRenderer*)s7_c_pointer(renderer), (PangoFont*)s7_c_pointer(font), (PangoGlyphString*)s7_c_pointer(glyphs), (int)s7_integer(x), (int)s7_integer(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_rectangle "void pango_renderer_draw_rectangle(PangoRenderer* renderer, \
PangoRenderPart part, int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer renderer, part, x, y, width, height;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 2, part, "PangoRenderPart");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 3, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 4, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 5, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_rectangle", 6, height, "int");
  pango_renderer_draw_rectangle((PangoRenderer*)s7_c_pointer(renderer), (PangoRenderPart)s7_integer(part), (int)s7_integer(x), (int)s7_integer(y), (int)s7_integer(width), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_error_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_error_underline "void pango_renderer_draw_error_underline(PangoRenderer* renderer, \
int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer renderer, x, y, width, height;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 1, renderer, "PangoRenderer*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 3, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 4, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_error_underline", 5, height, "int");
  pango_renderer_draw_error_underline((PangoRenderer*)s7_c_pointer(renderer), (int)s7_integer(x), (int)s7_integer(y), (int)s7_integer(width), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_trapezoid(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_trapezoid "void pango_renderer_draw_trapezoid(PangoRenderer* renderer, \
PangoRenderPart part, double y1, double x11, double x21, double y2, double x12, double x22)"
  s7_pointer _p;
  s7_pointer renderer, part, y1, x11, x21, y2, x12, x22;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 2, part, "PangoRenderPart");
  y1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 3, y1, "double");
  x11 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x11)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 4, x11, "double");
  x21 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x21)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 5, x21, "double");
  y2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y2)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 6, y2, "double");
  x12 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x12)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 7, x12, "double");
  x22 = s7_car(_p);
  if (!s7_is_real(x22)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_trapezoid", 8, x22, "double");
  pango_renderer_draw_trapezoid((PangoRenderer*)s7_c_pointer(renderer), (PangoRenderPart)s7_integer(part), (double)s7_real(y1), (double)s7_real(x11), (double)s7_real(x21), (double)s7_real(y2), (double)s7_real(x12), (double)s7_real(x22));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_draw_glyph(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_draw_glyph "void pango_renderer_draw_glyph(PangoRenderer* renderer, PangoFont* font, \
PangoGlyph glyph, double x, double y)"
  s7_pointer _p;
  s7_pointer renderer, font, glyph, x, y;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 1, renderer, "PangoRenderer*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 2, font, "PangoFont*");
  glyph = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(glyph)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 3, glyph, "PangoGlyph");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 4, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "pango_renderer_draw_glyph", 5, y, "double");
  pango_renderer_draw_glyph((PangoRenderer*)s7_c_pointer(renderer), (PangoFont*)s7_c_pointer(font), (PangoGlyph)s7_integer(glyph), (double)s7_real(x), (double)s7_real(y));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_activate "void pango_renderer_activate(PangoRenderer* renderer)"
  s7_pointer renderer;
  renderer = s7_car(args);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_activate", 1, renderer, "PangoRenderer*");
  pango_renderer_activate((PangoRenderer*)s7_c_pointer(renderer));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_deactivate(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_deactivate "void pango_renderer_deactivate(PangoRenderer* renderer)"
  s7_pointer renderer;
  renderer = s7_car(args);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_deactivate", 1, renderer, "PangoRenderer*");
  pango_renderer_deactivate((PangoRenderer*)s7_c_pointer(renderer));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_part_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_part_changed "void pango_renderer_part_changed(PangoRenderer* renderer, PangoRenderPart part)"
  s7_pointer _p;
  s7_pointer renderer, part;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_part_changed", 1, renderer, "PangoRenderer*");
  part = s7_car(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_part_changed", 2, part, "PangoRenderPart");
  pango_renderer_part_changed((PangoRenderer*)s7_c_pointer(renderer), (PangoRenderPart)s7_integer(part));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_set_color(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_set_color "void pango_renderer_set_color(PangoRenderer* renderer, PangoRenderPart part, \
PangoColor* color)"
  s7_pointer _p;
  s7_pointer renderer, part, color;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_color", 1, renderer, "PangoRenderer*");
  part = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_set_color", 2, part, "PangoRenderPart");
  color = s7_car(_p);
  if (!s7_is_c_pointer_of_type(color, PangoColor__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_color", 3, color, "PangoColor*");
  pango_renderer_set_color((PangoRenderer*)s7_c_pointer(renderer), (PangoRenderPart)s7_integer(part), (PangoColor*)s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_pango_renderer_get_color(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_get_color "PangoColor* pango_renderer_get_color(PangoRenderer* renderer, PangoRenderPart part)"
  s7_pointer _p;
  s7_pointer renderer, part;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_get_color", 1, renderer, "PangoRenderer*");
  part = s7_car(_p);
  if (!s7_is_integer(part)) s7_wrong_type_arg_error(sc, "pango_renderer_get_color", 2, part, "PangoRenderPart");
  return(lg_make_c_pointer_with_type(sc, PangoColor__sym, pango_renderer_get_color((PangoRenderer*)s7_c_pointer(renderer), (PangoRenderPart)s7_integer(part))));
}

static s7_pointer lg_pango_renderer_set_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_renderer_set_matrix "void pango_renderer_set_matrix(PangoRenderer* renderer, PangoMatrix* matrix)"
  s7_pointer _p;
  s7_pointer renderer, matrix;
  _p = args;
  renderer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(renderer, PangoRenderer__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_matrix", 1, renderer, "PangoRenderer*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, PangoMatrix__sym)) s7_wrong_type_arg_error(sc, "pango_renderer_set_matrix", 2, matrix, "PangoMatrix*");
  pango_renderer_set_matrix((PangoRenderer*)s7_c_pointer(renderer), (PangoMatrix*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_g_log_set_handler(s7_scheme *sc, s7_pointer args)
{
  #define H_g_log_set_handler "guint g_log_set_handler(gchar* log_domain, GLogLevelFlags log_levels, \
GLogFunc func, lambda_data func_info)"
  s7_pointer _p;
  s7_pointer log_domain, log_levels, func, func_info;
  _p = args;
  log_domain = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(log_domain)) s7_wrong_type_arg_error(sc, "g_log_set_handler", 1, log_domain, "gchar*");
  log_levels = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(log_levels)) s7_wrong_type_arg_error(sc, "g_log_set_handler", 2, log_levels, "GLogLevelFlags");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p);
  {
    s7_pointer res_ult;
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    res_ult = s7_make_integer(sc, g_log_set_handler((gchar*)s7_string(log_domain), (GLogLevelFlags)s7_integer(log_levels), lg_g_message_log_func, (gpointer)lg_ptr));
    return(res_ult);
   }
}

static s7_pointer lg_g_log_remove_handler(s7_scheme *sc, s7_pointer args)
{
  #define H_g_log_remove_handler "void g_log_remove_handler(gchar* log_domain, guint handler_id)"
  s7_pointer _p;
  s7_pointer log_domain, handler_id;
  _p = args;
  log_domain = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(log_domain)) s7_wrong_type_arg_error(sc, "g_log_remove_handler", 1, log_domain, "gchar*");
  handler_id = s7_car(_p);
  if (!s7_is_integer(handler_id)) s7_wrong_type_arg_error(sc, "g_log_remove_handler", 2, handler_id, "guint");
  g_log_remove_handler((gchar*)s7_string(log_domain), (guint)s7_integer(handler_id));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_stop_editing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_stop_editing "void gtk_cell_renderer_stop_editing(GtkCellRenderer* cell, \
gboolean canceled)"
  s7_pointer _p;
  s7_pointer cell, canceled;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_stop_editing", 1, cell, "GtkCellRenderer*");
  canceled = s7_car(_p);
  if (!s7_is_boolean(canceled)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_stop_editing", 2, canceled, "gboolean");
  gtk_cell_renderer_stop_editing((GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(canceled));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_new "GtkWidget* gtk_file_chooser_button_new(gchar* title, GtkFileChooserAction action)"
  s7_pointer _p;
  s7_pointer title, action;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_new", 1, title, "gchar*");
  action = s7_car(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_new", 2, action, "GtkFileChooserAction");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_file_chooser_button_new((const gchar*)s7_string(title), (GtkFileChooserAction)s7_integer(action))));
}

static s7_pointer lg_gtk_icon_view_set_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_columns "void gtk_icon_view_set_columns(GtkIconView* icon_view, gint columns)"
  s7_pointer _p;
  s7_pointer icon_view, columns;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_columns", 1, icon_view, "GtkIconView*");
  columns = s7_car(_p);
  if (!s7_is_integer(columns)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_columns", 2, columns, "gint");
  gtk_icon_view_set_columns((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(columns));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_columns "gint gtk_icon_view_get_columns(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_columns", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_columns((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_item_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_item_width "void gtk_icon_view_set_item_width(GtkIconView* icon_view, gint item_width)"
  s7_pointer _p;
  s7_pointer icon_view, item_width;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_width", 1, icon_view, "GtkIconView*");
  item_width = s7_car(_p);
  if (!s7_is_integer(item_width)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_width", 2, item_width, "gint");
  gtk_icon_view_set_item_width((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(item_width));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_width "gint gtk_icon_view_get_item_width(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_width", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_width((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_spacing "void gtk_icon_view_set_spacing(GtkIconView* icon_view, gint spacing)"
  s7_pointer _p;
  s7_pointer icon_view, spacing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_spacing", 1, icon_view, "GtkIconView*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_spacing", 2, spacing, "gint");
  gtk_icon_view_set_spacing((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_spacing "gint gtk_icon_view_get_spacing(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_spacing", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_spacing((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_row_spacing "void gtk_icon_view_set_row_spacing(GtkIconView* icon_view, \
gint row_spacing)"
  s7_pointer _p;
  s7_pointer icon_view, row_spacing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_row_spacing", 1, icon_view, "GtkIconView*");
  row_spacing = s7_car(_p);
  if (!s7_is_integer(row_spacing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_row_spacing", 2, row_spacing, "gint");
  gtk_icon_view_set_row_spacing((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(row_spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_row_spacing "gint gtk_icon_view_get_row_spacing(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_row_spacing", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_row_spacing((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_column_spacing "void gtk_icon_view_set_column_spacing(GtkIconView* icon_view, \
gint column_spacing)"
  s7_pointer _p;
  s7_pointer icon_view, column_spacing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_column_spacing", 1, icon_view, "GtkIconView*");
  column_spacing = s7_car(_p);
  if (!s7_is_integer(column_spacing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_column_spacing", 2, column_spacing, "gint");
  gtk_icon_view_set_column_spacing((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(column_spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_column_spacing "gint gtk_icon_view_get_column_spacing(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_column_spacing", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_column_spacing((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_set_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_margin "void gtk_icon_view_set_margin(GtkIconView* icon_view, gint margin)"
  s7_pointer _p;
  s7_pointer icon_view, margin;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_margin", 1, icon_view, "GtkIconView*");
  margin = s7_car(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_margin", 2, margin, "gint");
  gtk_icon_view_set_margin((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_margin "gint gtk_icon_view_get_margin(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_margin", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_margin((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_label_set_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_max_width_chars "void gtk_label_set_max_width_chars(GtkLabel* label, gint n_chars)"
  s7_pointer _p;
  s7_pointer label, n_chars;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_max_width_chars", 1, label, "GtkLabel*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_label_set_max_width_chars", 2, n_chars, "gint");
  gtk_label_set_max_width_chars((GtkLabel*)s7_c_pointer(label), (gint)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_max_width_chars "gint gtk_label_get_max_width_chars(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_max_width_chars", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_max_width_chars((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_list_store_insert_with_values(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_with_values "void gtk_list_store_insert_with_values(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, ...)"
  s7_pointer _p;
  s7_pointer list_store, iter, position;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_values", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_values", 2, iter, "GtkTreeIter*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_values", 3, position, "gint");
  gtk_list_store_insert_with_values((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_list_store_insert_with_valuesv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_store_insert_with_valuesv "void gtk_list_store_insert_with_valuesv(GtkListStore* list_store, \
GtkTreeIter* iter, gint position, gint* columns, GValue* values, gint n_values)"
  s7_pointer _p;
  s7_pointer list_store, iter, position, columns, values, n_values;
  _p = args;
  list_store = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_store, GtkListStore__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 1, list_store, "GtkListStore*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 2, iter, "GtkTreeIter*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 3, position, "gint");
  columns = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(columns, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 4, columns, "gint*");
  values = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(values, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 5, values, "GValue*");
  n_values = s7_car(_p);
  if (!s7_is_integer(n_values)) s7_wrong_type_arg_error(sc, "gtk_list_store_insert_with_valuesv", 6, n_values, "gint");
  gtk_list_store_insert_with_valuesv((GtkListStore*)s7_c_pointer(list_store), (GtkTreeIter*)s7_c_pointer(iter), (gint)s7_integer(position), (gint*)s7_c_pointer(columns), (GValue*)s7_c_pointer(values), (gint)s7_integer(n_values));
  return(lg_false);
}

static s7_pointer lg_pango_attr_size_new_absolute(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_size_new_absolute "PangoAttribute* pango_attr_size_new_absolute(int size)"
  s7_pointer size;
  size = s7_car(args);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "pango_attr_size_new_absolute", 1, size, "int");
  return(lg_make_c_pointer_with_type(sc, PangoAttribute__sym, pango_attr_size_new_absolute((int)s7_integer(size))));
}

static s7_pointer lg_pango_font_description_set_absolute_size(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_description_set_absolute_size "void pango_font_description_set_absolute_size(PangoFontDescription* desc, \
double size)"
  s7_pointer _p;
  s7_pointer desc, size;
  _p = args;
  desc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "pango_font_description_set_absolute_size", 1, desc, "PangoFontDescription*");
  size = s7_car(_p);
  if (!s7_is_real(size)) s7_wrong_type_arg_error(sc, "pango_font_description_set_absolute_size", 2, size, "double");
  pango_font_description_set_absolute_size((PangoFontDescription*)s7_c_pointer(desc), (double)s7_real(size));
  return(lg_false);
}

static s7_pointer lg_pango_layout_get_font_description(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_get_font_description "PangoFontDescription* pango_layout_get_font_description(PangoLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_get_font_description", 1, layout, "PangoLayout*");
    return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, (PangoFontDescription*)pango_layout_get_font_description((PangoLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gtk_dialog_get_response_for_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_response_for_widget "gint gtk_dialog_get_response_for_widget(GtkDialog* dialog, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer dialog, widget;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_response_for_widget", 1, dialog, "GtkDialog*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_response_for_widget", 2, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_dialog_get_response_for_widget((GtkDialog*)s7_c_pointer(dialog), (GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_entry_completion_set_popup_set_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_popup_set_width "void gtk_entry_completion_set_popup_set_width(GtkEntryCompletion* completion, \
gboolean popup_set_width)"
  s7_pointer _p;
  s7_pointer completion, popup_set_width;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_set_width", 1, completion, "GtkEntryCompletion*");
  popup_set_width = s7_car(_p);
  if (!s7_is_boolean(popup_set_width)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_set_width", 2, popup_set_width, "gboolean");
  gtk_entry_completion_set_popup_set_width((GtkEntryCompletion*)s7_c_pointer(completion), (gboolean)lg_boolean(popup_set_width));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_popup_set_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_popup_set_width "gboolean gtk_entry_completion_get_popup_set_width(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_popup_set_width", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_popup_set_width((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_set_popup_single_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_popup_single_match "void gtk_entry_completion_set_popup_single_match(GtkEntryCompletion* completion, \
gboolean popup_single_match)"
  s7_pointer _p;
  s7_pointer completion, popup_single_match;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_single_match", 1, completion, "GtkEntryCompletion*");
  popup_single_match = s7_car(_p);
  if (!s7_is_boolean(popup_single_match)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_popup_single_match", 2, popup_single_match, "gboolean");
  gtk_entry_completion_set_popup_single_match((GtkEntryCompletion*)s7_c_pointer(completion), (gboolean)lg_boolean(popup_single_match));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_popup_single_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_popup_single_match "gboolean gtk_entry_completion_get_popup_single_match(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_popup_single_match", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_popup_single_match((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_icon_view_get_item_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_at_pos "gboolean gtk_icon_view_get_item_at_pos(GtkIconView* icon_view, \
gint x, gint y, GtkTreePath** [path], GtkCellRenderer** [cell])"
  s7_pointer _p;
  s7_pointer icon_view, x, y;
  GtkTreePath* ref_path = NULL;
  GtkCellRenderer* ref_cell = NULL;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_at_pos", 1, icon_view, "GtkIconView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_at_pos", 2, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_at_pos", 3, y, "gint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_icon_view_get_item_at_pos((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(x), (gint)s7_integer(y), &ref_path, &ref_cell));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_cell)));
   }
}

static s7_pointer lg_gtk_icon_view_get_visible_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_visible_range "gboolean gtk_icon_view_get_visible_range(GtkIconView* icon_view, \
GtkTreePath** [start_path], GtkTreePath** [end_path])"
  s7_pointer _p;
  s7_pointer icon_view;
  GtkTreePath* ref_start_path = NULL;
  GtkTreePath* ref_end_path = NULL;
  _p = args;
  icon_view = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_visible_range", 1, icon_view, "GtkIconView*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_icon_view_get_visible_range((GtkIconView*)s7_c_pointer(icon_view), &ref_start_path, &ref_end_path));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_start_path), s7_make_c_pointer(sc, ref_end_path)));
   }
}

static s7_pointer lg_gtk_icon_view_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_cursor "void gtk_icon_view_set_cursor(GtkIconView* icon_view, GtkTreePath* path, \
GtkCellRenderer* cell, gboolean start_editing)"
  s7_pointer _p;
  s7_pointer icon_view, path, cell, start_editing;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 2, path, "GtkTreePath*");
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 3, cell, "GtkCellRenderer*");
  start_editing = s7_car(_p);
  if (!s7_is_boolean(start_editing)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_cursor", 4, start_editing, "gboolean");
  gtk_icon_view_set_cursor((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path), (GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(start_editing));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_cursor "gboolean gtk_icon_view_get_cursor(GtkIconView* icon_view, GtkTreePath** [path], \
GtkCellRenderer** [cell])"
  s7_pointer _p;
  s7_pointer icon_view;
  GtkTreePath* ref_path = NULL;
  GtkCellRenderer* ref_cell = NULL;
  _p = args;
  icon_view = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_cursor", 1, icon_view, "GtkIconView*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_icon_view_get_cursor((GtkIconView*)s7_c_pointer(icon_view), &ref_path, &ref_cell));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_cell)));
   }
}

static s7_pointer lg_gtk_icon_view_scroll_to_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_scroll_to_path "void gtk_icon_view_scroll_to_path(GtkIconView* icon_view, GtkTreePath* path, \
gboolean use_align, gfloat row_align, gfloat col_align)"
  s7_pointer _p;
  s7_pointer icon_view, path, use_align, row_align, col_align;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 1, icon_view, "GtkIconView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 2, path, "GtkTreePath*");
  use_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(use_align)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 3, use_align, "gboolean");
  row_align = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(row_align)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 4, row_align, "gfloat");
  col_align = s7_car(_p);
  if (!s7_is_real(col_align)) s7_wrong_type_arg_error(sc, "gtk_icon_view_scroll_to_path", 5, col_align, "gfloat");
  gtk_icon_view_scroll_to_path((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path), (gboolean)lg_boolean(use_align), (gfloat)s7_real(row_align), (gfloat)s7_real(col_align));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_unset_model_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_unset_model_drag_source "void gtk_icon_view_unset_model_drag_source(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_unset_model_drag_source", 1, icon_view, "GtkIconView*");
  gtk_icon_view_unset_model_drag_source((GtkIconView*)s7_c_pointer(icon_view));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_set_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_reorderable "void gtk_icon_view_set_reorderable(GtkIconView* icon_view, \
gboolean reorderable)"
  s7_pointer _p;
  s7_pointer icon_view, reorderable;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_reorderable", 1, icon_view, "GtkIconView*");
  reorderable = s7_car(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_reorderable", 2, reorderable, "gboolean");
  gtk_icon_view_set_reorderable((GtkIconView*)s7_c_pointer(icon_view), (gboolean)lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_reorderable "gboolean gtk_icon_view_get_reorderable(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_reorderable", 1, icon_view, "GtkIconView*");
  return(s7_make_boolean(sc, gtk_icon_view_get_reorderable((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_icon_view_get_dest_item_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_dest_item_at_pos "gboolean gtk_icon_view_get_dest_item_at_pos(GtkIconView* icon_view, \
gint drag_x, gint drag_y, GtkTreePath** [path], GtkIconViewDropPosition* [pos])"
  s7_pointer _p;
  s7_pointer icon_view, drag_x, drag_y;
  GtkTreePath* ref_path = NULL;
  GtkIconViewDropPosition ref_pos;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_dest_item_at_pos", 1, icon_view, "GtkIconView*");
  drag_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(drag_x)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_dest_item_at_pos", 2, drag_x, "gint");
  drag_y = s7_car(_p);
  if (!s7_is_integer(drag_y)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_dest_item_at_pos", 3, drag_y, "gint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_icon_view_get_dest_item_at_pos((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(drag_x), (gint)s7_integer(drag_y), &ref_path, &ref_pos));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_path), s7_make_integer(sc, ref_pos)));
   }
}

static s7_pointer lg_gtk_image_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_clear "void gtk_image_clear(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_clear", 1, image, "GtkImage*");
  gtk_image_clear((GtkImage*)s7_c_pointer(image));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_forward_visible_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_visible_line "gboolean gtk_text_iter_forward_visible_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_visible_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_forward_visible_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_backward_visible_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_visible_line "gboolean gtk_text_iter_backward_visible_line(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_visible_line", 1, iter, "GtkTextIter*");
  return(s7_make_boolean(sc, gtk_text_iter_backward_visible_line((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_text_iter_forward_visible_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_forward_visible_lines "gboolean gtk_text_iter_forward_visible_lines(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_visible_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_forward_visible_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_forward_visible_lines((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_text_iter_backward_visible_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_backward_visible_lines "gboolean gtk_text_iter_backward_visible_lines(GtkTextIter* iter, \
gint count)"
  s7_pointer _p;
  s7_pointer iter, count;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_visible_lines", 1, iter, "GtkTextIter*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "gtk_text_iter_backward_visible_lines", 2, count, "gint");
  return(s7_make_boolean(sc, gtk_text_iter_backward_visible_lines((GtkTextIter*)s7_c_pointer(iter), (gint)s7_integer(count))));
}

static s7_pointer lg_gtk_window_present_with_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_present_with_time "void gtk_window_present_with_time(GtkWindow* window, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer window, timestamp;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_present_with_time", 1, window, "GtkWindow*");
  timestamp = s7_car(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gtk_window_present_with_time", 2, timestamp, "guint32");
  gtk_window_present_with_time((GtkWindow*)s7_c_pointer(window), (guint32)s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_row_reference_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_row_reference_get_model "GtkTreeModel* gtk_tree_row_reference_get_model(GtkTreeRowReference* reference)"
  s7_pointer reference;
  reference = s7_car(args);
  if (!s7_is_c_pointer_of_type(reference, GtkTreeRowReference__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_row_reference_get_model", 1, reference, "GtkTreeRowReference*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_tree_row_reference_get_model((GtkTreeRowReference*)s7_c_pointer(reference))));
}

static s7_pointer lg_gtk_tree_view_column_queue_resize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_queue_resize "void gtk_tree_view_column_queue_resize(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_queue_resize", 1, tree_column, "GtkTreeViewColumn*");
  gtk_tree_view_column_queue_resize((GtkTreeViewColumn*)s7_c_pointer(tree_column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_visible_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_visible_range "gboolean gtk_tree_view_get_visible_range(GtkTreeView* tree_view, \
GtkTreePath** [start_path], GtkTreePath** [end_path])"
  s7_pointer _p;
  s7_pointer tree_view;
  GtkTreePath* ref_start_path = NULL;
  GtkTreePath* ref_end_path = NULL;
  _p = args;
  tree_view = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_visible_range", 1, tree_view, "GtkTreeView*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_view_get_visible_range((GtkTreeView*)s7_c_pointer(tree_view), &ref_start_path, &ref_end_path));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_start_path), s7_make_c_pointer(sc, ref_end_path)));
   }
}

static s7_pointer lg_pango_attr_list_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_attr_list_ref "PangoAttrList* pango_attr_list_ref(PangoAttrList* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "pango_attr_list_ref", 1, list, "PangoAttrList*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, pango_attr_list_ref((PangoAttrList*)s7_c_pointer(list))));
}

static s7_pointer lg_pango_layout_line_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_line_ref "PangoLayoutLine* pango_layout_line_ref(PangoLayoutLine* line)"
  s7_pointer line;
  line = s7_car(args);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_layout_line_ref", 1, line, "PangoLayoutLine*");
  return(lg_make_c_pointer_with_type(sc, PangoLayoutLine__sym, pango_layout_line_ref((PangoLayoutLine*)s7_c_pointer(line))));
}

static s7_pointer lg_pango_layout_index_to_line_x(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_layout_index_to_line_x "void pango_layout_index_to_line_x(PangoLayout* layout, int index_, \
gboolean trailing, int* [line], int* [x_pos])"
  s7_pointer _p;
  s7_pointer layout, index_, trailing;
  int ref_line;
  int ref_x_pos;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_line_x", 1, layout, "PangoLayout*");
  index_ = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index_)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_line_x", 2, index_, "int");
  trailing = s7_car(_p);
  if (!s7_is_boolean(trailing)) s7_wrong_type_arg_error(sc, "pango_layout_index_to_line_x", 3, trailing, "gboolean");
  pango_layout_index_to_line_x((PangoLayout*)s7_c_pointer(layout), (int)s7_integer(index_), (gboolean)lg_boolean(trailing), &ref_line, &ref_x_pos);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_line), s7_make_integer(sc, ref_x_pos)));
}

static s7_pointer lg_gdk_display_supports_shapes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_shapes "gboolean gdk_display_supports_shapes(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_shapes", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_shapes((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_supports_input_shapes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_supports_input_shapes "gboolean gdk_display_supports_input_shapes(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_supports_input_shapes", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_supports_input_shapes((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_notebook_get_tab_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_reorderable "gboolean gtk_notebook_get_tab_reorderable(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_reorderable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_reorderable", 2, child, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_notebook_get_tab_reorderable((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_tab_reorderable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_reorderable "void gtk_notebook_set_tab_reorderable(GtkNotebook* notebook, \
GtkWidget* child, gboolean reorderable)"
  s7_pointer _p;
  s7_pointer notebook, child, reorderable;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_reorderable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_reorderable", 2, child, "GtkWidget*");
  reorderable = s7_car(_p);
  if (!s7_is_boolean(reorderable)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_reorderable", 3, reorderable, "gboolean");
  gtk_notebook_set_tab_reorderable((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (gboolean)lg_boolean(reorderable));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_tab_detachable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_tab_detachable "gboolean gtk_notebook_get_tab_detachable(GtkNotebook* notebook, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_detachable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_tab_detachable", 2, child, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_notebook_get_tab_detachable((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_set_tab_detachable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_tab_detachable "void gtk_notebook_set_tab_detachable(GtkNotebook* notebook, \
GtkWidget* child, gboolean detachable)"
  s7_pointer _p;
  s7_pointer notebook, child, detachable;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_detachable", 1, notebook, "GtkNotebook*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_detachable", 2, child, "GtkWidget*");
  detachable = s7_car(_p);
  if (!s7_is_boolean(detachable)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_tab_detachable", 3, detachable, "gboolean");
  gtk_notebook_set_tab_detachable((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child), (gboolean)lg_boolean(detachable));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_unset_placement(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_unset_placement "void gtk_scrolled_window_unset_placement(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_unset_placement", 1, scrolled_window, "GtkScrolledWindow*");
  gtk_scrolled_window_unset_placement((GtkScrolledWindow*)s7_c_pointer(scrolled_window));
  return(lg_false);
}

static s7_pointer lg_gtk_size_group_get_widgets(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_size_group_get_widgets "GSList* gtk_size_group_get_widgets(GtkSizeGroup* size_group)"
  s7_pointer size_group;
  size_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(size_group, GtkSizeGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_size_group_get_widgets", 1, size_group, "GtkSizeGroup*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_size_group_get_widgets((GtkSizeGroup*)s7_c_pointer(size_group))));
}

static s7_pointer lg_gtk_text_buffer_get_has_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_has_selection "gboolean gtk_text_buffer_get_has_selection(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_has_selection", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_has_selection((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_tree_view_get_headers_clickable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_headers_clickable "gboolean gtk_tree_view_get_headers_clickable(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_headers_clickable", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_headers_clickable((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_window_set_deletable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_deletable "void gtk_window_set_deletable(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_deletable", 1, window, "GtkWindow*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_deletable", 2, setting, "gboolean");
  gtk_window_set_deletable((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_deletable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_deletable "gboolean gtk_window_get_deletable(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_deletable", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_deletable((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_assistant_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_new "GtkWidget* gtk_assistant_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_assistant_new()));
}

static s7_pointer lg_gtk_assistant_get_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_current_page "gint gtk_assistant_get_current_page(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_current_page", 1, assistant, "GtkAssistant*");
  return(s7_make_integer(sc, gtk_assistant_get_current_page((GtkAssistant*)s7_c_pointer(assistant))));
}

static s7_pointer lg_gtk_assistant_set_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_current_page "void gtk_assistant_set_current_page(GtkAssistant* assistant, \
gint page_num)"
  s7_pointer _p;
  s7_pointer assistant, page_num;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_current_page", 1, assistant, "GtkAssistant*");
  page_num = s7_car(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_current_page", 2, page_num, "gint");
  gtk_assistant_set_current_page((GtkAssistant*)s7_c_pointer(assistant), (gint)s7_integer(page_num));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_n_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_n_pages "gint gtk_assistant_get_n_pages(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_n_pages", 1, assistant, "GtkAssistant*");
  return(s7_make_integer(sc, gtk_assistant_get_n_pages((GtkAssistant*)s7_c_pointer(assistant))));
}

static s7_pointer lg_gtk_assistant_get_nth_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_nth_page "GtkWidget* gtk_assistant_get_nth_page(GtkAssistant* assistant, \
gint page_num)"
  s7_pointer _p;
  s7_pointer assistant, page_num;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_nth_page", 1, assistant, "GtkAssistant*");
  page_num = s7_car(_p);
  if (!s7_is_integer(page_num)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_nth_page", 2, page_num, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_assistant_get_nth_page((GtkAssistant*)s7_c_pointer(assistant), (gint)s7_integer(page_num))));
}

static s7_pointer lg_gtk_assistant_prepend_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_prepend_page "gint gtk_assistant_prepend_page(GtkAssistant* assistant, GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_prepend_page", 1, assistant, "GtkAssistant*");
  page = s7_car(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_prepend_page", 2, page, "GtkWidget*");
  return(s7_make_integer(sc, gtk_assistant_prepend_page((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_append_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_append_page "gint gtk_assistant_append_page(GtkAssistant* assistant, GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_append_page", 1, assistant, "GtkAssistant*");
  page = s7_car(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_append_page", 2, page, "GtkWidget*");
  return(s7_make_integer(sc, gtk_assistant_append_page((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_insert_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_insert_page "gint gtk_assistant_insert_page(GtkAssistant* assistant, GtkWidget* page, \
gint position)"
  s7_pointer _p;
  s7_pointer assistant, page, position;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_insert_page", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_insert_page", 2, page, "GtkWidget*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_assistant_insert_page", 3, position, "gint");
  return(s7_make_integer(sc, gtk_assistant_insert_page((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page), (gint)s7_integer(position))));
}

static s7_pointer lg_gtk_assistant_set_forward_page_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_forward_page_func "void gtk_assistant_set_forward_page_func(GtkAssistant* assistant, \
GtkAssistantPageFunc page_func, lambda_data func_info, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer assistant /* , page_func */ , func_info, destroy;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_forward_page_func", 1, assistant, "GtkAssistant*");
  /* page_func = s7_car(_p); */ _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_assistant_set_forward_page_func((GtkAssistant*)s7_c_pointer(assistant), lg_page_func, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_assistant_set_page_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_page_type "void gtk_assistant_set_page_type(GtkAssistant* assistant, GtkWidget* page, \
GtkAssistantPageType type)"
  s7_pointer _p;
  s7_pointer assistant, page, type;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_type", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_type", 2, page, "GtkWidget*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_type", 3, type, "GtkAssistantPageType");
  gtk_assistant_set_page_type((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page), (GtkAssistantPageType)s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_page_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page_type "GtkAssistantPageType gtk_assistant_get_page_type(GtkAssistant* assistant, \
GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_type", 1, assistant, "GtkAssistant*");
  page = s7_car(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_type", 2, page, "GtkWidget*");
  return(s7_make_integer(sc, gtk_assistant_get_page_type((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_set_page_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_page_title "void gtk_assistant_set_page_title(GtkAssistant* assistant, \
GtkWidget* page, gchar* title)"
  s7_pointer _p;
  s7_pointer assistant, page, title;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_title", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_title", 2, page, "GtkWidget*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_title", 3, title, "gchar*");
  gtk_assistant_set_page_title((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page), (gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_page_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page_title "gchar* gtk_assistant_get_page_title(GtkAssistant* assistant, \
GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_title", 1, assistant, "GtkAssistant*");
  page = s7_car(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_title", 2, page, "GtkWidget*");
  return(s7_make_string(sc, gtk_assistant_get_page_title((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_set_page_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_set_page_complete "void gtk_assistant_set_page_complete(GtkAssistant* assistant, \
GtkWidget* page, gboolean complete)"
  s7_pointer _p;
  s7_pointer assistant, page, complete;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_complete", 1, assistant, "GtkAssistant*");
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_complete", 2, page, "GtkWidget*");
  complete = s7_car(_p);
  if (!s7_is_boolean(complete)) s7_wrong_type_arg_error(sc, "gtk_assistant_set_page_complete", 3, complete, "gboolean");
  gtk_assistant_set_page_complete((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page), (gboolean)lg_boolean(complete));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_get_page_complete(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page_complete "gboolean gtk_assistant_get_page_complete(GtkAssistant* assistant, \
GtkWidget* page)"
  s7_pointer _p;
  s7_pointer assistant, page;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_complete", 1, assistant, "GtkAssistant*");
  page = s7_car(_p);
  if (!s7_is_c_pointer_of_type(page, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page_complete", 2, page, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_assistant_get_page_complete((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_add_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_add_action_widget "void gtk_assistant_add_action_widget(GtkAssistant* assistant, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer assistant, child;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_add_action_widget", 1, assistant, "GtkAssistant*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_add_action_widget", 2, child, "GtkWidget*");
  gtk_assistant_add_action_widget((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_remove_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_remove_action_widget "void gtk_assistant_remove_action_widget(GtkAssistant* assistant, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer assistant, child;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_remove_action_widget", 1, assistant, "GtkAssistant*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_remove_action_widget", 2, child, "GtkWidget*");
  gtk_assistant_remove_action_widget((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_update_buttons_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_update_buttons_state "void gtk_assistant_update_buttons_state(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_update_buttons_state", 1, assistant, "GtkAssistant*");
  gtk_assistant_update_buttons_state((GtkAssistant*)s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_accel_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_accel_new "GtkCellRenderer* gtk_cell_renderer_accel_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_accel_new()));
}

static s7_pointer lg_gtk_cell_renderer_spin_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_spin_new "GtkCellRenderer* gtk_cell_renderer_spin_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_spin_new()));
}

static s7_pointer lg_gtk_link_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_new "GtkWidget* gtk_link_button_new(gchar* uri)"
  s7_pointer uri;
  uri = s7_car(args);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_link_button_new", 1, uri, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_link_button_new((gchar*)s7_string(uri))));
}

static s7_pointer lg_gtk_link_button_new_with_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_new_with_label "GtkWidget* gtk_link_button_new_with_label(gchar* uri, gchar* label)"
  s7_pointer _p;
  s7_pointer uri, label;
  _p = args;
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_link_button_new_with_label", 1, uri, "gchar*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_link_button_new_with_label", 2, label, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_link_button_new_with_label((gchar*)s7_string(uri), (gchar*)s7_string(label))));
}

static s7_pointer lg_gtk_link_button_get_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_get_uri "gchar* gtk_link_button_get_uri(GtkLinkButton* link_button)"
  s7_pointer link_button;
  link_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_get_uri", 1, link_button, "GtkLinkButton*");
  return(s7_make_string(sc, gtk_link_button_get_uri((GtkLinkButton*)s7_c_pointer(link_button))));
}

static s7_pointer lg_gtk_link_button_set_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_set_uri "void gtk_link_button_set_uri(GtkLinkButton* link_button, gchar* uri)"
  s7_pointer _p;
  s7_pointer link_button, uri;
  _p = args;
  link_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_uri", 1, link_button, "GtkLinkButton*");
  uri = s7_car(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_uri", 2, uri, "gchar*");
  gtk_link_button_set_uri((GtkLinkButton*)s7_c_pointer(link_button), (gchar*)s7_string(uri));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_manager_error_quark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_error_quark "GQuark gtk_recent_manager_error_quark( void)"
  return(s7_make_integer(sc, gtk_recent_manager_error_quark()));
}

static s7_pointer lg_gtk_recent_manager_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_new "GtkRecentManager* gtk_recent_manager_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkRecentManager__sym, gtk_recent_manager_new()));
}

static s7_pointer lg_gtk_recent_manager_get_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_get_default "GtkRecentManager* gtk_recent_manager_get_default( void)"
  return(lg_make_c_pointer_with_type(sc, GtkRecentManager__sym, gtk_recent_manager_get_default()));
}

static s7_pointer lg_gtk_recent_manager_remove_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_remove_item "gboolean gtk_recent_manager_remove_item(GtkRecentManager* manager, \
gchar* uri, GError** [error])"
  s7_pointer _p;
  s7_pointer manager, uri;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_remove_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_remove_item", 2, uri, "gchar*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_recent_manager_remove_item((GtkRecentManager*)s7_c_pointer(manager), (gchar*)s7_string(uri), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_lookup_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_lookup_item "GtkRecentInfo* gtk_recent_manager_lookup_item(GtkRecentManager* manager, \
gchar* uri, GError** [error])"
  s7_pointer _p;
  s7_pointer manager, uri;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_lookup_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_lookup_item", 2, uri, "gchar*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GtkRecentInfo__sym, gtk_recent_manager_lookup_item((GtkRecentManager*)s7_c_pointer(manager), (gchar*)s7_string(uri), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_has_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_has_item "gboolean gtk_recent_manager_has_item(GtkRecentManager* manager, \
gchar* uri)"
  s7_pointer _p;
  s7_pointer manager, uri;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_has_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_has_item", 2, uri, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_manager_has_item((GtkRecentManager*)s7_c_pointer(manager), (gchar*)s7_string(uri))));
}

static s7_pointer lg_gtk_recent_manager_move_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_move_item "gboolean gtk_recent_manager_move_item(GtkRecentManager* manager, \
gchar* uri, gchar* new_uri, GError** [error])"
  s7_pointer _p;
  s7_pointer manager, uri, new_uri;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_move_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_move_item", 2, uri, "gchar*");
  new_uri = s7_car(_p);
  if (!s7_is_string(new_uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_move_item", 3, new_uri, "gchar*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_recent_manager_move_item((GtkRecentManager*)s7_c_pointer(manager), (gchar*)s7_string(uri), (gchar*)s7_string(new_uri), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_manager_get_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_get_items "GList* gtk_recent_manager_get_items(GtkRecentManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_get_items", 1, manager, "GtkRecentManager*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_recent_manager_get_items((GtkRecentManager*)s7_c_pointer(manager))));
}

static s7_pointer lg_gtk_recent_manager_purge_items(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_purge_items "gint gtk_recent_manager_purge_items(GtkRecentManager* manager, \
GError** [error])"
  s7_pointer _p;
  s7_pointer manager;
  GError* ref_error = NULL;
  _p = args;
  manager = s7_car(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_purge_items", 1, manager, "GtkRecentManager*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, gtk_recent_manager_purge_items((GtkRecentManager*)s7_c_pointer(manager), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_recent_info_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_ref "GtkRecentInfo* gtk_recent_info_ref(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_ref", 1, info, "GtkRecentInfo*");
  return(lg_make_c_pointer_with_type(sc, GtkRecentInfo__sym, gtk_recent_info_ref((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_unref "void gtk_recent_info_unref(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_unref", 1, info, "GtkRecentInfo*");
  gtk_recent_info_unref((GtkRecentInfo*)s7_c_pointer(info));
  return(lg_false);
}

static s7_pointer lg_gtk_recent_info_get_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_uri "gchar* gtk_recent_info_get_uri(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_uri", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_get_uri((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_display_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_display_name "gchar* gtk_recent_info_get_display_name(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_display_name", 1, info, "GtkRecentInfo*");
    return(s7_make_string(sc, (gchar*)gtk_recent_info_get_display_name((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_description(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_description "gchar* gtk_recent_info_get_description(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_description", 1, info, "GtkRecentInfo*");
    return(s7_make_string(sc, (gchar*)gtk_recent_info_get_description((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_mime_type "gchar* gtk_recent_info_get_mime_type(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_mime_type", 1, info, "GtkRecentInfo*");
    return(s7_make_string(sc, (gchar*)gtk_recent_info_get_mime_type((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_added(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_added "time_t gtk_recent_info_get_added(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_added", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_added((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_modified(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_modified "time_t gtk_recent_info_get_modified(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_modified", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_modified((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_visited(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_visited "time_t gtk_recent_info_get_visited(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_visited", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_visited((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_private_hint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_private_hint "gboolean gtk_recent_info_get_private_hint(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_private_hint", 1, info, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_get_private_hint((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_applications(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_applications "gchar** gtk_recent_info_get_applications(GtkRecentInfo* info, \
gsize* [length])"
  s7_pointer _p;
  s7_pointer info;
  gsize ref_length;
  _p = args;
  info = s7_car(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_applications", 1, info, "GtkRecentInfo*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, gchar___sym, gtk_recent_info_get_applications((GtkRecentInfo*)s7_c_pointer(info), &ref_length));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_recent_info_last_application(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_last_application "gchar* gtk_recent_info_last_application(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_last_application", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_last_application((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_has_application(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_has_application "gboolean gtk_recent_info_has_application(GtkRecentInfo* info, \
gchar* app_name)"
  s7_pointer _p;
  s7_pointer info, app_name;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_application", 1, info, "GtkRecentInfo*");
  app_name = s7_car(_p);
  if (!s7_is_string(app_name)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_application", 2, app_name, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_info_has_application((GtkRecentInfo*)s7_c_pointer(info), (gchar*)s7_string(app_name))));
}

static s7_pointer lg_gtk_recent_info_get_groups(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_groups "gchar** gtk_recent_info_get_groups(GtkRecentInfo* info, gsize* [length])"
  s7_pointer _p;
  s7_pointer info;
  gsize ref_length;
  _p = args;
  info = s7_car(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_groups", 1, info, "GtkRecentInfo*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, gchar___sym, gtk_recent_info_get_groups((GtkRecentInfo*)s7_c_pointer(info), &ref_length));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_length)));
   }
}

static s7_pointer lg_gtk_recent_info_has_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_has_group "gboolean gtk_recent_info_has_group(GtkRecentInfo* info, gchar* group_name)"
  s7_pointer _p;
  s7_pointer info, group_name;
  _p = args;
  info = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_group", 1, info, "GtkRecentInfo*");
  group_name = s7_car(_p);
  if (!s7_is_string(group_name)) s7_wrong_type_arg_error(sc, "gtk_recent_info_has_group", 2, group_name, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_info_has_group((GtkRecentInfo*)s7_c_pointer(info), (gchar*)s7_string(group_name))));
}

static s7_pointer lg_gtk_recent_info_get_short_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_short_name "gchar* gtk_recent_info_get_short_name(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_short_name", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_get_short_name((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_uri_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_uri_display "gchar* gtk_recent_info_get_uri_display(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_uri_display", 1, info, "GtkRecentInfo*");
  return(s7_make_string(sc, gtk_recent_info_get_uri_display((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_get_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_get_age "gint gtk_recent_info_get_age(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_get_age", 1, info, "GtkRecentInfo*");
  return(s7_make_integer(sc, gtk_recent_info_get_age((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_is_local(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_is_local "gboolean gtk_recent_info_is_local(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_is_local", 1, info, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_is_local((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_exists(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_exists "gboolean gtk_recent_info_exists(GtkRecentInfo* info)"
  s7_pointer info;
  info = s7_car(args);
  if (!s7_is_c_pointer_of_type(info, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_exists", 1, info, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_exists((GtkRecentInfo*)s7_c_pointer(info))));
}

static s7_pointer lg_gtk_recent_info_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_info_match "gboolean gtk_recent_info_match(GtkRecentInfo* info_a, GtkRecentInfo* info_b)"
  s7_pointer _p;
  s7_pointer info_a, info_b;
  _p = args;
  info_a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_a, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_match", 1, info_a, "GtkRecentInfo*");
  info_b = s7_car(_p);
  if (!s7_is_c_pointer_of_type(info_b, GtkRecentInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_info_match", 2, info_b, "GtkRecentInfo*");
  return(s7_make_boolean(sc, gtk_recent_info_match((GtkRecentInfo*)s7_c_pointer(info_a), (GtkRecentInfo*)s7_c_pointer(info_b))));
}

static s7_pointer lg_gtk_recent_manager_add_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_add_item "gboolean gtk_recent_manager_add_item(GtkRecentManager* manager, \
gchar* uri)"
  s7_pointer _p;
  s7_pointer manager, uri;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_item", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_item", 2, uri, "gchar*");
  return(s7_make_boolean(sc, gtk_recent_manager_add_item((GtkRecentManager*)s7_c_pointer(manager), (gchar*)s7_string(uri))));
}

static s7_pointer lg_gtk_recent_manager_add_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_recent_manager_add_full "gboolean gtk_recent_manager_add_full(GtkRecentManager* manager, \
gchar* uri, GtkRecentData* recent_data)"
  s7_pointer _p;
  s7_pointer manager, uri, recent_data;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkRecentManager__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_full", 1, manager, "GtkRecentManager*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_full", 2, uri, "gchar*");
  recent_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(recent_data, GtkRecentData__sym)) s7_wrong_type_arg_error(sc, "gtk_recent_manager_add_full", 3, recent_data, "GtkRecentData*");
  return(s7_make_boolean(sc, gtk_recent_manager_add_full((GtkRecentManager*)s7_c_pointer(manager), (gchar*)s7_string(uri), (GtkRecentData*)s7_c_pointer(recent_data))));
}

static s7_pointer lg_gtk_tree_model_filter_convert_child_iter_to_iter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_filter_convert_child_iter_to_iter "gboolean gtk_tree_model_filter_convert_child_iter_to_iter(GtkTreeModelFilter* filter, \
GtkTreeIter* filter_iter, GtkTreeIter* child_iter)"
  s7_pointer _p;
  s7_pointer filter, filter_iter, child_iter;
  _p = args;
  filter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkTreeModelFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", 1, filter, "GtkTreeModelFilter*");
  filter_iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(filter_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", 2, filter_iter, "GtkTreeIter*");
  child_iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child_iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", 3, child_iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_filter_convert_child_iter_to_iter((GtkTreeModelFilter*)s7_c_pointer(filter), (GtkTreeIter*)s7_c_pointer(filter_iter), (GtkTreeIter*)s7_c_pointer(child_iter))));
}

static s7_pointer lg_gtk_tree_view_get_grid_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_grid_lines "GtkTreeViewGridLines gtk_tree_view_get_grid_lines(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_grid_lines", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_grid_lines((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_grid_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_grid_lines "void gtk_tree_view_set_grid_lines(GtkTreeView* tree_view, GtkTreeViewGridLines grid_lines)"
  s7_pointer _p;
  s7_pointer tree_view, grid_lines;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_grid_lines", 1, tree_view, "GtkTreeView*");
  grid_lines = s7_car(_p);
  if (!s7_is_integer(grid_lines)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_grid_lines", 2, grid_lines, "GtkTreeViewGridLines");
  gtk_tree_view_set_grid_lines((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreeViewGridLines)s7_integer(grid_lines));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_enable_tree_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_enable_tree_lines "gboolean gtk_tree_view_get_enable_tree_lines(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_enable_tree_lines", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_enable_tree_lines((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_enable_tree_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_enable_tree_lines "void gtk_tree_view_set_enable_tree_lines(GtkTreeView* tree_view, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer tree_view, enabled;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_tree_lines", 1, tree_view, "GtkTreeView*");
  enabled = s7_car(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_enable_tree_lines", 2, enabled, "gboolean");
  gtk_tree_view_set_enable_tree_lines((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gtk_print_context_get_cairo_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_cairo_context "cairo_t* gtk_print_context_get_cairo_context(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_cairo_context", 1, context, "GtkPrintContext*");
  return(lg_make_c_pointer_with_type(sc, cairo_t__sym, gtk_print_context_get_cairo_context((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_page_setup "GtkPageSetup* gtk_print_context_get_page_setup(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_page_setup", 1, context, "GtkPrintContext*");
  return(lg_make_c_pointer_with_type(sc, GtkPageSetup__sym, gtk_print_context_get_page_setup((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_width "gdouble gtk_print_context_get_width(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_width", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_width((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_height "gdouble gtk_print_context_get_height(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_height", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_height((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_dpi_x(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_dpi_x "gdouble gtk_print_context_get_dpi_x(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_dpi_x", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_dpi_x((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_get_dpi_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_get_dpi_y "gdouble gtk_print_context_get_dpi_y(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_get_dpi_y", 1, context, "GtkPrintContext*");
  return(s7_make_real(sc, gtk_print_context_get_dpi_y((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_create_pango_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_create_pango_context "PangoContext* gtk_print_context_create_pango_context(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_create_pango_context", 1, context, "GtkPrintContext*");
  return(lg_make_c_pointer_with_type(sc, PangoContext__sym, gtk_print_context_create_pango_context((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_create_pango_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_create_pango_layout "PangoLayout* gtk_print_context_create_pango_layout(GtkPrintContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_create_pango_layout", 1, context, "GtkPrintContext*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, gtk_print_context_create_pango_layout((GtkPrintContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_print_context_set_cairo_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_context_set_cairo_context "void gtk_print_context_set_cairo_context(GtkPrintContext* context, \
cairo_t* cr, double dpi_x, double dpi_y)"
  s7_pointer _p;
  s7_pointer context, cr, dpi_x, dpi_y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkPrintContext__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 1, context, "GtkPrintContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 2, cr, "cairo_t*");
  dpi_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dpi_x)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 3, dpi_x, "double");
  dpi_y = s7_car(_p);
  if (!s7_is_real(dpi_y)) s7_wrong_type_arg_error(sc, "gtk_print_context_set_cairo_context", 4, dpi_y, "double");
  gtk_print_context_set_cairo_context((GtkPrintContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (double)s7_real(dpi_x), (double)s7_real(dpi_y));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_new "GtkPrintOperation* gtk_print_operation_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkPrintOperation__sym, gtk_print_operation_new()));
}

static s7_pointer lg_gtk_print_operation_set_default_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_default_page_setup "void gtk_print_operation_set_default_page_setup(GtkPrintOperation* op, \
GtkPageSetup* default_page_setup)"
  s7_pointer _p;
  s7_pointer op, default_page_setup;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_default_page_setup", 1, op, "GtkPrintOperation*");
  default_page_setup = s7_car(_p);
  if (!s7_is_c_pointer_of_type(default_page_setup, GtkPageSetup__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_default_page_setup", 2, default_page_setup, "GtkPageSetup*");
  gtk_print_operation_set_default_page_setup((GtkPrintOperation*)s7_c_pointer(op), (GtkPageSetup*)s7_c_pointer(default_page_setup));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_get_default_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_default_page_setup "GtkPageSetup* gtk_print_operation_get_default_page_setup(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_default_page_setup", 1, op, "GtkPrintOperation*");
  return(lg_make_c_pointer_with_type(sc, GtkPageSetup__sym, gtk_print_operation_get_default_page_setup((GtkPrintOperation*)s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_set_print_settings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_print_settings "void gtk_print_operation_set_print_settings(GtkPrintOperation* op, \
GtkPrintSettings* print_settings)"
  s7_pointer _p;
  s7_pointer op, print_settings;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_print_settings", 1, op, "GtkPrintOperation*");
  print_settings = s7_car(_p);
  if (!s7_is_c_pointer_of_type(print_settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_print_settings", 2, print_settings, "GtkPrintSettings*");
  gtk_print_operation_set_print_settings((GtkPrintOperation*)s7_c_pointer(op), (GtkPrintSettings*)s7_c_pointer(print_settings));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_get_print_settings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_print_settings "GtkPrintSettings* gtk_print_operation_get_print_settings(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_print_settings", 1, op, "GtkPrintOperation*");
  return(lg_make_c_pointer_with_type(sc, GtkPrintSettings__sym, gtk_print_operation_get_print_settings((GtkPrintOperation*)s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_set_job_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_job_name "void gtk_print_operation_set_job_name(GtkPrintOperation* op, \
gchar* job_name)"
  s7_pointer _p;
  s7_pointer op, job_name;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_job_name", 1, op, "GtkPrintOperation*");
  job_name = s7_car(_p);
  if (!s7_is_string(job_name)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_job_name", 2, job_name, "gchar*");
  gtk_print_operation_set_job_name((GtkPrintOperation*)s7_c_pointer(op), (gchar*)s7_string(job_name));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_n_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_n_pages "void gtk_print_operation_set_n_pages(GtkPrintOperation* op, \
gint n_pages)"
  s7_pointer _p;
  s7_pointer op, n_pages;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_n_pages", 1, op, "GtkPrintOperation*");
  n_pages = s7_car(_p);
  if (!s7_is_integer(n_pages)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_n_pages", 2, n_pages, "gint");
  gtk_print_operation_set_n_pages((GtkPrintOperation*)s7_c_pointer(op), (gint)s7_integer(n_pages));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_current_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_current_page "void gtk_print_operation_set_current_page(GtkPrintOperation* op, \
gint current_page)"
  s7_pointer _p;
  s7_pointer op, current_page;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_current_page", 1, op, "GtkPrintOperation*");
  current_page = s7_car(_p);
  if (!s7_is_integer(current_page)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_current_page", 2, current_page, "gint");
  gtk_print_operation_set_current_page((GtkPrintOperation*)s7_c_pointer(op), (gint)s7_integer(current_page));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_use_full_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_use_full_page "void gtk_print_operation_set_use_full_page(GtkPrintOperation* op, \
gboolean full_page)"
  s7_pointer _p;
  s7_pointer op, full_page;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_use_full_page", 1, op, "GtkPrintOperation*");
  full_page = s7_car(_p);
  if (!s7_is_boolean(full_page)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_use_full_page", 2, full_page, "gboolean");
  gtk_print_operation_set_use_full_page((GtkPrintOperation*)s7_c_pointer(op), (gboolean)lg_boolean(full_page));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_unit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_unit "void gtk_print_operation_set_unit(GtkPrintOperation* op, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer op, unit;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_unit", 1, op, "GtkPrintOperation*");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_unit", 2, unit, "GtkUnit");
  gtk_print_operation_set_unit((GtkPrintOperation*)s7_c_pointer(op), (GtkUnit)s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_export_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_export_filename "void gtk_print_operation_set_export_filename(GtkPrintOperation* op, \
gchar* filename)"
  s7_pointer _p;
  s7_pointer op, filename;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_export_filename", 1, op, "GtkPrintOperation*");
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_export_filename", 2, filename, "gchar*");
  gtk_print_operation_set_export_filename((GtkPrintOperation*)s7_c_pointer(op), (gchar*)s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_track_print_status(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_track_print_status "void gtk_print_operation_set_track_print_status(GtkPrintOperation* op, \
gboolean track_status)"
  s7_pointer _p;
  s7_pointer op, track_status;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_track_print_status", 1, op, "GtkPrintOperation*");
  track_status = s7_car(_p);
  if (!s7_is_boolean(track_status)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_track_print_status", 2, track_status, "gboolean");
  gtk_print_operation_set_track_print_status((GtkPrintOperation*)s7_c_pointer(op), (gboolean)lg_boolean(track_status));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_show_progress(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_show_progress "void gtk_print_operation_set_show_progress(GtkPrintOperation* op, \
gboolean show_progress)"
  s7_pointer _p;
  s7_pointer op, show_progress;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_show_progress", 1, op, "GtkPrintOperation*");
  show_progress = s7_car(_p);
  if (!s7_is_boolean(show_progress)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_show_progress", 2, show_progress, "gboolean");
  gtk_print_operation_set_show_progress((GtkPrintOperation*)s7_c_pointer(op), (gboolean)lg_boolean(show_progress));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_allow_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_allow_async "void gtk_print_operation_set_allow_async(GtkPrintOperation* op, \
gboolean allow_async)"
  s7_pointer _p;
  s7_pointer op, allow_async;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_allow_async", 1, op, "GtkPrintOperation*");
  allow_async = s7_car(_p);
  if (!s7_is_boolean(allow_async)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_allow_async", 2, allow_async, "gboolean");
  gtk_print_operation_set_allow_async((GtkPrintOperation*)s7_c_pointer(op), (gboolean)lg_boolean(allow_async));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_set_custom_tab_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_custom_tab_label "void gtk_print_operation_set_custom_tab_label(GtkPrintOperation* op, \
gchar* label)"
  s7_pointer _p;
  s7_pointer op, label;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_custom_tab_label", 1, op, "GtkPrintOperation*");
  label = s7_car(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_custom_tab_label", 2, label, "gchar*");
  gtk_print_operation_set_custom_tab_label((GtkPrintOperation*)s7_c_pointer(op), (gchar*)s7_string(label));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_run(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_run "GtkPrintOperationResult gtk_print_operation_run(GtkPrintOperation* op, \
GtkPrintOperationAction action, GtkWindow* parent, GError** [error])"
  s7_pointer _p;
  s7_pointer op, action, parent;
  GError* ref_error = NULL;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_run", 1, op, "GtkPrintOperation*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gtk_print_operation_run", 2, action, "GtkPrintOperationAction");
  parent = s7_car(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_run", 3, parent, "GtkWindow*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, gtk_print_operation_run((GtkPrintOperation*)s7_c_pointer(op), (GtkPrintOperationAction)s7_integer(action), (GtkWindow*)s7_c_pointer(parent), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_print_operation_get_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_error "void gtk_print_operation_get_error(GtkPrintOperation* op, \
GError** [error])"
  s7_pointer _p;
  s7_pointer op;
  GError* ref_error = NULL;
  _p = args;
  op = s7_car(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_error", 1, op, "GtkPrintOperation*");
  gtk_print_operation_get_error((GtkPrintOperation*)s7_c_pointer(op), &ref_error);
    return(s7_list(sc, 1, s7_make_c_pointer(sc, ref_error)));
}

static s7_pointer lg_gtk_print_operation_get_status(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_status "GtkPrintStatus gtk_print_operation_get_status(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_status", 1, op, "GtkPrintOperation*");
  return(s7_make_integer(sc, gtk_print_operation_get_status((GtkPrintOperation*)s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_get_status_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_status_string "gchar* gtk_print_operation_get_status_string(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_status_string", 1, op, "GtkPrintOperation*");
  return(s7_make_string(sc, gtk_print_operation_get_status_string((GtkPrintOperation*)s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_is_finished(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_is_finished "gboolean gtk_print_operation_is_finished(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_is_finished", 1, op, "GtkPrintOperation*");
  return(s7_make_boolean(sc, gtk_print_operation_is_finished((GtkPrintOperation*)s7_c_pointer(op))));
}

static s7_pointer lg_gtk_print_operation_cancel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_cancel "void gtk_print_operation_cancel(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_cancel", 1, op, "GtkPrintOperation*");
  gtk_print_operation_cancel((GtkPrintOperation*)s7_c_pointer(op));
  return(lg_false);
}

static s7_pointer lg_gtk_print_run_page_setup_dialog(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_run_page_setup_dialog "GtkPageSetup* gtk_print_run_page_setup_dialog(GtkWindow* parent, \
GtkPageSetup* page_setup, GtkPrintSettings* settings)"
  s7_pointer _p;
  s7_pointer parent, page_setup, settings;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog", 1, parent, "GtkWindow*");
  page_setup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_setup, GtkPageSetup__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog", 2, page_setup, "GtkPageSetup*");
  settings = s7_car(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog", 3, settings, "GtkPrintSettings*");
  return(lg_make_c_pointer_with_type(sc, GtkPageSetup__sym, gtk_print_run_page_setup_dialog((GtkWindow*)s7_c_pointer(parent), (GtkPageSetup*)s7_c_pointer(page_setup), (GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_run_page_setup_dialog_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_run_page_setup_dialog_async "void gtk_print_run_page_setup_dialog_async(GtkWindow* parent, \
GtkPageSetup* page_setup, GtkPrintSettings* settings, GtkPageSetupDoneFunc done_cb, gpointer data)"
  s7_pointer _p;
  s7_pointer parent, page_setup, settings, done_cb, data;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 1, parent, "GtkWindow*");
  page_setup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_setup, GtkPageSetup__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 2, page_setup, "GtkPageSetup*");
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 3, settings, "GtkPrintSettings*");
  done_cb = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(done_cb, GtkPageSetupDoneFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 4, done_cb, "GtkPageSetupDoneFunc");
  data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_print_run_page_setup_dialog_async", 5, data, "gpointer");
  gtk_print_run_page_setup_dialog_async((GtkWindow*)s7_c_pointer(parent), (GtkPageSetup*)s7_c_pointer(page_setup), (GtkPrintSettings*)s7_c_pointer(settings), (GtkPageSetupDoneFunc)s7_c_pointer(done_cb), (gpointer)s7_c_pointer(data));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_new "GtkPrintSettings* gtk_print_settings_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkPrintSettings__sym, gtk_print_settings_new()));
}

static s7_pointer lg_gtk_print_settings_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_copy "GtkPrintSettings* gtk_print_settings_copy(GtkPrintSettings* other)"
  s7_pointer other;
  other = s7_car(args);
  if (!s7_is_c_pointer_of_type(other, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_copy", 1, other, "GtkPrintSettings*");
  return(lg_make_c_pointer_with_type(sc, GtkPrintSettings__sym, gtk_print_settings_copy((GtkPrintSettings*)s7_c_pointer(other))));
}

static s7_pointer lg_gtk_print_settings_has_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_has_key "gboolean gtk_print_settings_has_key(GtkPrintSettings* settings, \
gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_has_key", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_has_key", 2, key, "gchar*");
  return(s7_make_boolean(sc, gtk_print_settings_has_key((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get "gchar* gtk_print_settings_get(GtkPrintSettings* settings, gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get", 2, key, "gchar*");
  return(s7_make_string(sc, gtk_print_settings_get((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set "void gtk_print_settings_set(GtkPrintSettings* settings, gchar* key, \
gchar* value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set", 2, key, "gchar*");
  value = s7_car(_p);
  if (!s7_is_string(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set", 3, value, "gchar*");
  gtk_print_settings_set((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gchar*)s7_string(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_unset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_unset "void gtk_print_settings_unset(GtkPrintSettings* settings, gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_unset", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_unset", 2, key, "gchar*");
  gtk_print_settings_unset((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_foreach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_foreach "void gtk_print_settings_foreach(GtkPrintSettings* settings, GtkPrintSettingsFunc func, \
gpointer user_data)"
  s7_pointer _p;
  s7_pointer settings, func, user_data;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_foreach", 1, settings, "GtkPrintSettings*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkPrintSettingsFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_foreach", 2, func, "GtkPrintSettingsFunc");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_foreach", 3, user_data, "gpointer");
  gtk_print_settings_foreach((GtkPrintSettings*)s7_c_pointer(settings), (GtkPrintSettingsFunc)s7_c_pointer(func), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_bool(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_bool "gboolean gtk_print_settings_get_bool(GtkPrintSettings* settings, \
gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_bool", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_bool", 2, key, "gchar*");
  return(s7_make_boolean(sc, gtk_print_settings_get_bool((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_set_bool(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_bool "void gtk_print_settings_set_bool(GtkPrintSettings* settings, \
gchar* key, gboolean value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_bool", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_bool", 2, key, "gchar*");
  value = s7_car(_p);
  if (!s7_is_boolean(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_bool", 3, value, "gboolean");
  gtk_print_settings_set_bool((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gboolean)lg_boolean(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_double "gdouble gtk_print_settings_get_double(GtkPrintSettings* settings, \
gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double", 2, key, "gchar*");
  return(s7_make_real(sc, gtk_print_settings_get_double((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_get_double_with_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_double_with_default "gdouble gtk_print_settings_get_double_with_default(GtkPrintSettings* settings, \
gchar* key, gdouble def)"
  s7_pointer _p;
  s7_pointer settings, key, def;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double_with_default", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double_with_default", 2, key, "gchar*");
  def = s7_car(_p);
  if (!s7_is_real(def)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_double_with_default", 3, def, "gdouble");
  return(s7_make_real(sc, gtk_print_settings_get_double_with_default((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gdouble)s7_real(def))));
}

static s7_pointer lg_gtk_print_settings_set_double(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_double "void gtk_print_settings_set_double(GtkPrintSettings* settings, \
gchar* key, gdouble value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_double", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_double", 2, key, "gchar*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_double", 3, value, "gdouble");
  gtk_print_settings_set_double((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_length "gdouble gtk_print_settings_get_length(GtkPrintSettings* settings, \
gchar* key, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, key, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_length", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_length", 2, key, "gchar*");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_length", 3, unit, "GtkUnit");
  return(s7_make_real(sc, gtk_print_settings_get_length((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (GtkUnit)s7_integer(unit))));
}

static s7_pointer lg_gtk_print_settings_set_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_length "void gtk_print_settings_set_length(GtkPrintSettings* settings, \
gchar* key, gdouble value, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, key, value, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 2, key, "gchar*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 3, value, "gdouble");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_length", 4, unit, "GtkUnit");
  gtk_print_settings_set_length((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gdouble)s7_real(value), (GtkUnit)s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_int(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_int "gint gtk_print_settings_get_int(GtkPrintSettings* settings, gchar* key)"
  s7_pointer _p;
  s7_pointer settings, key;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int", 2, key, "gchar*");
  return(s7_make_integer(sc, gtk_print_settings_get_int((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key))));
}

static s7_pointer lg_gtk_print_settings_get_int_with_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_int_with_default "gint gtk_print_settings_get_int_with_default(GtkPrintSettings* settings, \
gchar* key, gint def)"
  s7_pointer _p;
  s7_pointer settings, key, def;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int_with_default", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int_with_default", 2, key, "gchar*");
  def = s7_car(_p);
  if (!s7_is_integer(def)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_int_with_default", 3, def, "gint");
  return(s7_make_integer(sc, gtk_print_settings_get_int_with_default((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gint)s7_integer(def))));
}

static s7_pointer lg_gtk_print_settings_set_int(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_int "void gtk_print_settings_set_int(GtkPrintSettings* settings, gchar* key, \
gint value)"
  s7_pointer _p;
  s7_pointer settings, key, value;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_int", 1, settings, "GtkPrintSettings*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_int", 2, key, "gchar*");
  value = s7_car(_p);
  if (!s7_is_integer(value)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_int", 3, value, "gint");
  gtk_print_settings_set_int((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(key), (gint)s7_integer(value));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_printer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_printer "gchar* gtk_print_settings_get_printer(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_printer", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_printer((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_printer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_printer "void gtk_print_settings_set_printer(GtkPrintSettings* settings, \
gchar* printer)"
  s7_pointer _p;
  s7_pointer settings, printer;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_printer", 1, settings, "GtkPrintSettings*");
  printer = s7_car(_p);
  if (!s7_is_string(printer)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_printer", 2, printer, "gchar*");
  gtk_print_settings_set_printer((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(printer));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_orientation "GtkPageOrientation gtk_print_settings_get_orientation(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_orientation", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_orientation((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_orientation "void gtk_print_settings_set_orientation(GtkPrintSettings* settings, \
GtkPageOrientation orientation)"
  s7_pointer _p;
  s7_pointer settings, orientation;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_orientation", 1, settings, "GtkPrintSettings*");
  orientation = s7_car(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_orientation", 2, orientation, "GtkPageOrientation");
  gtk_print_settings_set_orientation((GtkPrintSettings*)s7_c_pointer(settings), (GtkPageOrientation)s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_paper_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_paper_size "GtkPaperSize* gtk_print_settings_get_paper_size(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_size", 1, settings, "GtkPrintSettings*");
  return(lg_make_c_pointer_with_type(sc, GtkPaperSize__sym, gtk_print_settings_get_paper_size((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_paper_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_paper_size "void gtk_print_settings_set_paper_size(GtkPrintSettings* settings, \
GtkPaperSize* paper_size)"
  s7_pointer _p;
  s7_pointer settings, paper_size;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_size", 1, settings, "GtkPrintSettings*");
  paper_size = s7_car(_p);
  if (!s7_is_c_pointer_of_type(paper_size, GtkPaperSize__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_size", 2, paper_size, "GtkPaperSize*");
  gtk_print_settings_set_paper_size((GtkPrintSettings*)s7_c_pointer(settings), (GtkPaperSize*)s7_c_pointer(paper_size));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_paper_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_paper_width "gdouble gtk_print_settings_get_paper_width(GtkPrintSettings* settings, \
GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_width", 1, settings, "GtkPrintSettings*");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_width", 2, unit, "GtkUnit");
  return(s7_make_real(sc, gtk_print_settings_get_paper_width((GtkPrintSettings*)s7_c_pointer(settings), (GtkUnit)s7_integer(unit))));
}

static s7_pointer lg_gtk_print_settings_set_paper_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_paper_width "void gtk_print_settings_set_paper_width(GtkPrintSettings* settings, \
gdouble width, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, width, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_width", 1, settings, "GtkPrintSettings*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_width", 2, width, "gdouble");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_width", 3, unit, "GtkUnit");
  gtk_print_settings_set_paper_width((GtkPrintSettings*)s7_c_pointer(settings), (gdouble)s7_real(width), (GtkUnit)s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_paper_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_paper_height "gdouble gtk_print_settings_get_paper_height(GtkPrintSettings* settings, \
GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_height", 1, settings, "GtkPrintSettings*");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_paper_height", 2, unit, "GtkUnit");
  return(s7_make_real(sc, gtk_print_settings_get_paper_height((GtkPrintSettings*)s7_c_pointer(settings), (GtkUnit)s7_integer(unit))));
}

static s7_pointer lg_gtk_print_settings_set_paper_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_paper_height "void gtk_print_settings_set_paper_height(GtkPrintSettings* settings, \
gdouble height, GtkUnit unit)"
  s7_pointer _p;
  s7_pointer settings, height, unit;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_height", 1, settings, "GtkPrintSettings*");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_height", 2, height, "gdouble");
  unit = s7_car(_p);
  if (!s7_is_integer(unit)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_paper_height", 3, unit, "GtkUnit");
  gtk_print_settings_set_paper_height((GtkPrintSettings*)s7_c_pointer(settings), (gdouble)s7_real(height), (GtkUnit)s7_integer(unit));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_use_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_use_color "gboolean gtk_print_settings_get_use_color(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_use_color", 1, settings, "GtkPrintSettings*");
  return(s7_make_boolean(sc, gtk_print_settings_get_use_color((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_use_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_use_color "void gtk_print_settings_set_use_color(GtkPrintSettings* settings, \
gboolean use_color)"
  s7_pointer _p;
  s7_pointer settings, use_color;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_use_color", 1, settings, "GtkPrintSettings*");
  use_color = s7_car(_p);
  if (!s7_is_boolean(use_color)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_use_color", 2, use_color, "gboolean");
  gtk_print_settings_set_use_color((GtkPrintSettings*)s7_c_pointer(settings), (gboolean)lg_boolean(use_color));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_collate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_collate "gboolean gtk_print_settings_get_collate(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_collate", 1, settings, "GtkPrintSettings*");
  return(s7_make_boolean(sc, gtk_print_settings_get_collate((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_collate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_collate "void gtk_print_settings_set_collate(GtkPrintSettings* settings, \
gboolean collate)"
  s7_pointer _p;
  s7_pointer settings, collate;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_collate", 1, settings, "GtkPrintSettings*");
  collate = s7_car(_p);
  if (!s7_is_boolean(collate)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_collate", 2, collate, "gboolean");
  gtk_print_settings_set_collate((GtkPrintSettings*)s7_c_pointer(settings), (gboolean)lg_boolean(collate));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_reverse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_reverse "gboolean gtk_print_settings_get_reverse(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_reverse", 1, settings, "GtkPrintSettings*");
  return(s7_make_boolean(sc, gtk_print_settings_get_reverse((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_reverse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_reverse "void gtk_print_settings_set_reverse(GtkPrintSettings* settings, \
gboolean reverse)"
  s7_pointer _p;
  s7_pointer settings, reverse;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_reverse", 1, settings, "GtkPrintSettings*");
  reverse = s7_car(_p);
  if (!s7_is_boolean(reverse)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_reverse", 2, reverse, "gboolean");
  gtk_print_settings_set_reverse((GtkPrintSettings*)s7_c_pointer(settings), (gboolean)lg_boolean(reverse));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_duplex(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_duplex "GtkPrintDuplex gtk_print_settings_get_duplex(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_duplex", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_duplex((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_duplex(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_duplex "void gtk_print_settings_set_duplex(GtkPrintSettings* settings, \
GtkPrintDuplex duplex)"
  s7_pointer _p;
  s7_pointer settings, duplex;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_duplex", 1, settings, "GtkPrintSettings*");
  duplex = s7_car(_p);
  if (!s7_is_integer(duplex)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_duplex", 2, duplex, "GtkPrintDuplex");
  gtk_print_settings_set_duplex((GtkPrintSettings*)s7_c_pointer(settings), (GtkPrintDuplex)s7_integer(duplex));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_quality(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_quality "GtkPrintQuality gtk_print_settings_get_quality(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_quality", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_quality((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_quality(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_quality "void gtk_print_settings_set_quality(GtkPrintSettings* settings, \
GtkPrintQuality quality)"
  s7_pointer _p;
  s7_pointer settings, quality;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_quality", 1, settings, "GtkPrintSettings*");
  quality = s7_car(_p);
  if (!s7_is_integer(quality)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_quality", 2, quality, "GtkPrintQuality");
  gtk_print_settings_set_quality((GtkPrintSettings*)s7_c_pointer(settings), (GtkPrintQuality)s7_integer(quality));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_n_copies(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_n_copies "gint gtk_print_settings_get_n_copies(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_n_copies", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_n_copies((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_n_copies(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_n_copies "void gtk_print_settings_set_n_copies(GtkPrintSettings* settings, \
gint num_copies)"
  s7_pointer _p;
  s7_pointer settings, num_copies;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_n_copies", 1, settings, "GtkPrintSettings*");
  num_copies = s7_car(_p);
  if (!s7_is_integer(num_copies)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_n_copies", 2, num_copies, "gint");
  gtk_print_settings_set_n_copies((GtkPrintSettings*)s7_c_pointer(settings), (gint)s7_integer(num_copies));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_number_up(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_number_up "gint gtk_print_settings_get_number_up(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_number_up", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_number_up((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_number_up(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_number_up "void gtk_print_settings_set_number_up(GtkPrintSettings* settings, \
gint number_up)"
  s7_pointer _p;
  s7_pointer settings, number_up;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_number_up", 1, settings, "GtkPrintSettings*");
  number_up = s7_car(_p);
  if (!s7_is_integer(number_up)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_number_up", 2, number_up, "gint");
  gtk_print_settings_set_number_up((GtkPrintSettings*)s7_c_pointer(settings), (gint)s7_integer(number_up));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_resolution "gint gtk_print_settings_get_resolution(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_resolution", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_resolution((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_resolution "void gtk_print_settings_set_resolution(GtkPrintSettings* settings, \
gint resolution)"
  s7_pointer _p;
  s7_pointer settings, resolution;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_resolution", 1, settings, "GtkPrintSettings*");
  resolution = s7_car(_p);
  if (!s7_is_integer(resolution)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_resolution", 2, resolution, "gint");
  gtk_print_settings_set_resolution((GtkPrintSettings*)s7_c_pointer(settings), (gint)s7_integer(resolution));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_scale "gdouble gtk_print_settings_get_scale(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_scale", 1, settings, "GtkPrintSettings*");
  return(s7_make_real(sc, gtk_print_settings_get_scale((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_scale "void gtk_print_settings_set_scale(GtkPrintSettings* settings, \
gdouble scale)"
  s7_pointer _p;
  s7_pointer settings, scale;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_scale", 1, settings, "GtkPrintSettings*");
  scale = s7_car(_p);
  if (!s7_is_real(scale)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_scale", 2, scale, "gdouble");
  gtk_print_settings_set_scale((GtkPrintSettings*)s7_c_pointer(settings), (gdouble)s7_real(scale));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_print_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_print_pages "GtkPrintPages gtk_print_settings_get_print_pages(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_print_pages", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_print_pages((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_print_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_print_pages "void gtk_print_settings_set_print_pages(GtkPrintSettings* settings, \
GtkPrintPages pages)"
  s7_pointer _p;
  s7_pointer settings, pages;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_print_pages", 1, settings, "GtkPrintSettings*");
  pages = s7_car(_p);
  if (!s7_is_integer(pages)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_print_pages", 2, pages, "GtkPrintPages");
  gtk_print_settings_set_print_pages((GtkPrintSettings*)s7_c_pointer(settings), (GtkPrintPages)s7_integer(pages));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_page_ranges(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_page_ranges "GtkPageRange* gtk_print_settings_get_page_ranges(GtkPrintSettings* settings, \
gint* num_ranges)"
  s7_pointer _p;
  s7_pointer settings, num_ranges;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_page_ranges", 1, settings, "GtkPrintSettings*");
  num_ranges = s7_car(_p);
  if (!s7_is_c_pointer_of_type(num_ranges, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_page_ranges", 2, num_ranges, "gint*");
  return(lg_make_c_pointer_with_type(sc, GtkPageRange__sym, gtk_print_settings_get_page_ranges((GtkPrintSettings*)s7_c_pointer(settings), (gint*)s7_c_pointer(num_ranges))));
}

static s7_pointer lg_gtk_print_settings_set_page_ranges(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_page_ranges "void gtk_print_settings_set_page_ranges(GtkPrintSettings* settings, \
GtkPageRange* page_ranges, gint num_ranges)"
  s7_pointer _p;
  s7_pointer settings, page_ranges, num_ranges;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_ranges", 1, settings, "GtkPrintSettings*");
  page_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page_ranges, GtkPageRange__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_ranges", 2, page_ranges, "GtkPageRange*");
  num_ranges = s7_car(_p);
  if (!s7_is_integer(num_ranges)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_ranges", 3, num_ranges, "gint");
  gtk_print_settings_set_page_ranges((GtkPrintSettings*)s7_c_pointer(settings), (GtkPageRange*)s7_c_pointer(page_ranges), (gint)s7_integer(num_ranges));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_page_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_page_set "GtkPageSet gtk_print_settings_get_page_set(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_page_set", 1, settings, "GtkPrintSettings*");
  return(s7_make_integer(sc, gtk_print_settings_get_page_set((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_page_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_page_set "void gtk_print_settings_set_page_set(GtkPrintSettings* settings, \
GtkPageSet page_set)"
  s7_pointer _p;
  s7_pointer settings, page_set;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_set", 1, settings, "GtkPrintSettings*");
  page_set = s7_car(_p);
  if (!s7_is_integer(page_set)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_page_set", 2, page_set, "GtkPageSet");
  gtk_print_settings_set_page_set((GtkPrintSettings*)s7_c_pointer(settings), (GtkPageSet)s7_integer(page_set));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_default_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_default_source "gchar* gtk_print_settings_get_default_source(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_default_source", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_default_source((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_default_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_default_source "void gtk_print_settings_set_default_source(GtkPrintSettings* settings, \
gchar* default_source)"
  s7_pointer _p;
  s7_pointer settings, default_source;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_default_source", 1, settings, "GtkPrintSettings*");
  default_source = s7_car(_p);
  if (!s7_is_string(default_source)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_default_source", 2, default_source, "gchar*");
  gtk_print_settings_set_default_source((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(default_source));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_media_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_media_type "gchar* gtk_print_settings_get_media_type(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_media_type", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_media_type((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_media_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_media_type "void gtk_print_settings_set_media_type(GtkPrintSettings* settings, \
gchar* media_type)"
  s7_pointer _p;
  s7_pointer settings, media_type;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_media_type", 1, settings, "GtkPrintSettings*");
  media_type = s7_car(_p);
  if (!s7_is_string(media_type)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_media_type", 2, media_type, "gchar*");
  gtk_print_settings_set_media_type((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(media_type));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_dither(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_dither "gchar* gtk_print_settings_get_dither(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_dither", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_dither((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_dither(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_dither "void gtk_print_settings_set_dither(GtkPrintSettings* settings, \
gchar* dither)"
  s7_pointer _p;
  s7_pointer settings, dither;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_dither", 1, settings, "GtkPrintSettings*");
  dither = s7_car(_p);
  if (!s7_is_string(dither)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_dither", 2, dither, "gchar*");
  gtk_print_settings_set_dither((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(dither));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_finishings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_finishings "gchar* gtk_print_settings_get_finishings(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_finishings", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_finishings((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_finishings(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_finishings "void gtk_print_settings_set_finishings(GtkPrintSettings* settings, \
gchar* finishings)"
  s7_pointer _p;
  s7_pointer settings, finishings;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_finishings", 1, settings, "GtkPrintSettings*");
  finishings = s7_car(_p);
  if (!s7_is_string(finishings)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_finishings", 2, finishings, "gchar*");
  gtk_print_settings_set_finishings((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(finishings));
  return(lg_false);
}

static s7_pointer lg_gtk_print_settings_get_output_bin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_get_output_bin "gchar* gtk_print_settings_get_output_bin(GtkPrintSettings* settings)"
  s7_pointer settings;
  settings = s7_car(args);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_get_output_bin", 1, settings, "GtkPrintSettings*");
  return(s7_make_string(sc, gtk_print_settings_get_output_bin((GtkPrintSettings*)s7_c_pointer(settings))));
}

static s7_pointer lg_gtk_print_settings_set_output_bin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_set_output_bin "void gtk_print_settings_set_output_bin(GtkPrintSettings* settings, \
gchar* output_bin)"
  s7_pointer _p;
  s7_pointer settings, output_bin;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_output_bin", 1, settings, "GtkPrintSettings*");
  output_bin = s7_car(_p);
  if (!s7_is_string(output_bin)) s7_wrong_type_arg_error(sc, "gtk_print_settings_set_output_bin", 2, output_bin, "gchar*");
  gtk_print_settings_set_output_bin((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(output_bin));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_create_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_create_layout "PangoLayout* pango_cairo_create_layout(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_create_layout", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, PangoLayout__sym, pango_cairo_create_layout((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_pango_cairo_update_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_update_layout "void pango_cairo_update_layout(cairo_t* cr, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer cr, layout;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_layout", 1, cr, "cairo_t*");
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_layout", 2, layout, "PangoLayout*");
  pango_cairo_update_layout((cairo_t*)s7_c_pointer(cr), (PangoLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_update_context(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_update_context "void pango_cairo_update_context(cairo_t* cr, PangoContext* context)"
  s7_pointer _p;
  s7_pointer cr, context;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_context", 1, cr, "cairo_t*");
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_update_context", 2, context, "PangoContext*");
  pango_cairo_update_context((cairo_t*)s7_c_pointer(cr), (PangoContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_context_set_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_set_font_options "void pango_cairo_context_set_font_options(PangoContext* context, \
cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer context, options;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_font_options", 1, context, "PangoContext*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_font_options", 2, options, "cairo_font_options_t*");
  pango_cairo_context_set_font_options((PangoContext*)s7_c_pointer(context), (cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_context_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_get_font_options "cairo_font_options_t* pango_cairo_context_get_font_options(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_get_font_options", 1, context, "PangoContext*");
    return(lg_make_c_pointer_with_type(sc, cairo_font_options_t__sym, (cairo_font_options_t*)pango_cairo_context_get_font_options((PangoContext*)s7_c_pointer(context))));
}

static s7_pointer lg_pango_cairo_context_set_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_set_resolution "void pango_cairo_context_set_resolution(PangoContext* context, \
gdouble dpi)"
  s7_pointer _p;
  s7_pointer context, dpi;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_resolution", 1, context, "PangoContext*");
  dpi = s7_car(_p);
  if (!s7_is_real(dpi)) s7_wrong_type_arg_error(sc, "pango_cairo_context_set_resolution", 2, dpi, "gdouble");
  pango_cairo_context_set_resolution((PangoContext*)s7_c_pointer(context), (gdouble)s7_real(dpi));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_context_get_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_context_get_resolution "gdouble pango_cairo_context_get_resolution(PangoContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, PangoContext__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_context_get_resolution", 1, context, "PangoContext*");
  return(s7_make_real(sc, pango_cairo_context_get_resolution((PangoContext*)s7_c_pointer(context))));
}

static s7_pointer lg_pango_cairo_show_glyph_string(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_glyph_string "void pango_cairo_show_glyph_string(cairo_t* cr, PangoFont* font, \
PangoGlyphString* glyphs)"
  s7_pointer _p;
  s7_pointer cr, font, glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_glyph_string", 1, cr, "cairo_t*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_glyph_string", 2, font, "PangoFont*");
  glyphs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_glyph_string", 3, glyphs, "PangoGlyphString*");
  pango_cairo_show_glyph_string((cairo_t*)s7_c_pointer(cr), (PangoFont*)s7_c_pointer(font), (PangoGlyphString*)s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_show_layout_line(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_layout_line "void pango_cairo_show_layout_line(cairo_t* cr, PangoLayoutLine* line)"
  s7_pointer _p;
  s7_pointer cr, line;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout_line", 1, cr, "cairo_t*");
  line = s7_car(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout_line", 2, line, "PangoLayoutLine*");
  pango_cairo_show_layout_line((cairo_t*)s7_c_pointer(cr), (PangoLayoutLine*)s7_c_pointer(line));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_show_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_layout "void pango_cairo_show_layout(cairo_t* cr, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer cr, layout;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout", 1, cr, "cairo_t*");
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_layout", 2, layout, "PangoLayout*");
  pango_cairo_show_layout((cairo_t*)s7_c_pointer(cr), (PangoLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_show_error_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_show_error_underline "void pango_cairo_show_error_underline(cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer cr, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 3, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 4, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "pango_cairo_show_error_underline", 5, height, "gdouble");
  pango_cairo_show_error_underline((cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_glyph_string_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_glyph_string_path "void pango_cairo_glyph_string_path(cairo_t* cr, PangoFont* font, \
PangoGlyphString* glyphs)"
  s7_pointer _p;
  s7_pointer cr, font, glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_glyph_string_path", 1, cr, "cairo_t*");
  font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font, PangoFont__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_glyph_string_path", 2, font, "PangoFont*");
  glyphs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(glyphs, PangoGlyphString__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_glyph_string_path", 3, glyphs, "PangoGlyphString*");
  pango_cairo_glyph_string_path((cairo_t*)s7_c_pointer(cr), (PangoFont*)s7_c_pointer(font), (PangoGlyphString*)s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_layout_line_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_layout_line_path "void pango_cairo_layout_line_path(cairo_t* cr, PangoLayoutLine* line)"
  s7_pointer _p;
  s7_pointer cr, line;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_line_path", 1, cr, "cairo_t*");
  line = s7_car(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_line_path", 2, line, "PangoLayoutLine*");
  pango_cairo_layout_line_path((cairo_t*)s7_c_pointer(cr), (PangoLayoutLine*)s7_c_pointer(line));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_layout_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_layout_path "void pango_cairo_layout_path(cairo_t* cr, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer cr, layout;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_path", 1, cr, "cairo_t*");
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_layout_path", 2, layout, "PangoLayout*");
  pango_cairo_layout_path((cairo_t*)s7_c_pointer(cr), (PangoLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_pango_cairo_error_underline_path(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_cairo_error_underline_path "void pango_cairo_error_underline_path(cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer cr, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 3, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 4, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "pango_cairo_error_underline_path", 5, height, "gdouble");
  pango_cairo_error_underline_path((cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gdk_cairo_set_source_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_set_source_pixbuf "void gdk_cairo_set_source_pixbuf(cairo_t* cr, GdkPixbuf* pixbuf, \
gdouble pixbuf_x, gdouble pixbuf_y)"
  s7_pointer _p;
  s7_pointer cr, pixbuf, pixbuf_x, pixbuf_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 1, cr, "cairo_t*");
  pixbuf = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 2, pixbuf, "GdkPixbuf*");
  pixbuf_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(pixbuf_x)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 3, pixbuf_x, "gdouble");
  pixbuf_y = s7_car(_p);
  if (!s7_is_real(pixbuf_y)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_pixbuf", 4, pixbuf_y, "gdouble");
  gdk_cairo_set_source_pixbuf((cairo_t*)s7_c_pointer(cr), (GdkPixbuf*)s7_c_pointer(pixbuf), (gdouble)s7_real(pixbuf_x), (gdouble)s7_real(pixbuf_y));
  return(lg_false);
}

static s7_pointer lg_gdk_cairo_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_rectangle "void gdk_cairo_rectangle(cairo_t* cr, GdkRectangle* rectangle)"
  s7_pointer _p;
  s7_pointer cr, rectangle;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_rectangle", 1, cr, "cairo_t*");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_rectangle", 2, rectangle, "GdkRectangle*");
  gdk_cairo_rectangle((cairo_t*)s7_c_pointer(cr), (GdkRectangle*)s7_c_pointer(rectangle));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_layout_get_cells(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_layout_get_cells "GList* gtk_cell_layout_get_cells(GtkCellLayout* cell_layout)"
  s7_pointer cell_layout;
  cell_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_layout, GtkCellLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_layout_get_cells", 1, cell_layout, "GtkCellLayout*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_cell_layout_get_cells((GtkCellLayout*)s7_c_pointer(cell_layout))));
}

static s7_pointer lg_gtk_entry_completion_set_inline_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_set_inline_selection "void gtk_entry_completion_set_inline_selection(GtkEntryCompletion* completion, \
gboolean inline_selection)"
  s7_pointer _p;
  s7_pointer completion, inline_selection;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_selection", 1, completion, "GtkEntryCompletion*");
  inline_selection = s7_car(_p);
  if (!s7_is_boolean(inline_selection)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_set_inline_selection", 2, inline_selection, "gboolean");
  gtk_entry_completion_set_inline_selection((GtkEntryCompletion*)s7_c_pointer(completion), (gboolean)lg_boolean(inline_selection));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_get_inline_selection(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_inline_selection "gboolean gtk_entry_completion_get_inline_selection(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_inline_selection", 1, completion, "GtkEntryCompletion*");
  return(s7_make_boolean(sc, gtk_entry_completion_get_inline_selection((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_entry_completion_get_completion_prefix(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_get_completion_prefix "gchar* gtk_entry_completion_get_completion_prefix(GtkEntryCompletion* completion)"
  s7_pointer completion;
  completion = s7_car(args);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_get_completion_prefix", 1, completion, "GtkEntryCompletion*");
  return(s7_make_string(sc, gtk_entry_completion_get_completion_prefix((GtkEntryCompletion*)s7_c_pointer(completion))));
}

static s7_pointer lg_gtk_print_settings_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_new_from_file "GtkPrintSettings* gtk_print_settings_new_from_file(gchar* file_name, \
GError** [error])"
  s7_pointer _p;
  s7_pointer file_name;
  GError* ref_error = NULL;
  _p = args;
  file_name = s7_car(_p);
  if (!s7_is_string(file_name)) s7_wrong_type_arg_error(sc, "gtk_print_settings_new_from_file", 1, file_name, "gchar*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GtkPrintSettings__sym, gtk_print_settings_new_from_file((gchar*)s7_string(file_name), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_print_settings_to_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_settings_to_file "gboolean gtk_print_settings_to_file(GtkPrintSettings* settings, \
gchar* file_name, GError** [error])"
  s7_pointer _p;
  s7_pointer settings, file_name;
  GError* ref_error = NULL;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkPrintSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_print_settings_to_file", 1, settings, "GtkPrintSettings*");
  file_name = s7_car(_p);
  if (!s7_is_string(file_name)) s7_wrong_type_arg_error(sc, "gtk_print_settings_to_file", 2, file_name, "gchar*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_print_settings_to_file((GtkPrintSettings*)s7_c_pointer(settings), (gchar*)s7_string(file_name), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_range_set_show_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_show_fill_level "void gtk_range_set_show_fill_level(GtkRange* range,  gboolean, \
show_fill_level)"
  s7_pointer _p;
  s7_pointer range, show_fill_level;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_show_fill_level", 1, range, "GtkRange*");
  show_fill_level = s7_car(_p);
  if (!s7_is_boolean(show_fill_level)) s7_wrong_type_arg_error(sc, "gtk_range_set_show_fill_level", 2, show_fill_level, "gboolean");
  gtk_range_set_show_fill_level((GtkRange*)s7_c_pointer(range), (gboolean)lg_boolean(show_fill_level));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_show_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_show_fill_level "gboolean gtk_range_get_show_fill_level(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_show_fill_level", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_show_fill_level((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_restrict_to_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_restrict_to_fill_level "void gtk_range_set_restrict_to_fill_level(GtkRange* range, \
 gboolean, restrict_to_fill_level)"
  s7_pointer _p;
  s7_pointer range, restrict_to_fill_level;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_restrict_to_fill_level", 1, range, "GtkRange*");
  restrict_to_fill_level = s7_car(_p);
  if (!s7_is_boolean(restrict_to_fill_level)) s7_wrong_type_arg_error(sc, "gtk_range_set_restrict_to_fill_level", 2, restrict_to_fill_level, "gboolean");
  gtk_range_set_restrict_to_fill_level((GtkRange*)s7_c_pointer(range), (gboolean)lg_boolean(restrict_to_fill_level));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_restrict_to_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_restrict_to_fill_level "gboolean gtk_range_get_restrict_to_fill_level(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_restrict_to_fill_level", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_restrict_to_fill_level((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_set_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_fill_level "void gtk_range_set_fill_level(GtkRange* range,  gdouble, fill_level)"
  s7_pointer _p;
  s7_pointer range, fill_level;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_fill_level", 1, range, "GtkRange*");
  fill_level = s7_car(_p);
  if (!s7_is_real(fill_level)) s7_wrong_type_arg_error(sc, "gtk_range_set_fill_level", 2, fill_level, "gdouble");
  gtk_range_set_fill_level((GtkRange*)s7_c_pointer(range), (gdouble)s7_real(fill_level));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_fill_level(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_fill_level "gdouble gtk_range_get_fill_level(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_fill_level", 1, range, "GtkRange*");
  return(s7_make_real(sc, gtk_range_get_fill_level((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_tree_view_set_show_expanders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_show_expanders "void gtk_tree_view_set_show_expanders(GtkTreeView* tree_view, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer tree_view, enabled;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_show_expanders", 1, tree_view, "GtkTreeView*");
  enabled = s7_car(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_show_expanders", 2, enabled, "gboolean");
  gtk_tree_view_set_show_expanders((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_show_expanders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_show_expanders "gboolean gtk_tree_view_get_show_expanders(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_show_expanders", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_show_expanders((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_level_indentation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_level_indentation "void gtk_tree_view_set_level_indentation(GtkTreeView* tree_view, \
gint indentation)"
  s7_pointer _p;
  s7_pointer tree_view, indentation;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_level_indentation", 1, tree_view, "GtkTreeView*");
  indentation = s7_car(_p);
  if (!s7_is_integer(indentation)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_level_indentation", 2, indentation, "gint");
  gtk_tree_view_set_level_indentation((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(indentation));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_level_indentation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_level_indentation "gint gtk_tree_view_get_level_indentation(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_level_indentation", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_level_indentation((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_widget_keynav_failed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_keynav_failed "gboolean gtk_widget_keynav_failed(GtkWidget* widget, GtkDirectionType direction)"
  s7_pointer _p;
  s7_pointer widget, direction;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_keynav_failed", 1, widget, "GtkWidget*");
  direction = s7_car(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_widget_keynav_failed", 2, direction, "GtkDirectionType");
  return(s7_make_boolean(sc, gtk_widget_keynav_failed((GtkWidget*)s7_c_pointer(widget), (GtkDirectionType)s7_integer(direction))));
}

static s7_pointer lg_gtk_widget_error_bell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_error_bell "void gtk_widget_error_bell(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_error_bell", 1, widget, "GtkWidget*");
  gtk_widget_error_bell((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_trigger_tooltip_query(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_trigger_tooltip_query "void gtk_widget_trigger_tooltip_query(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_trigger_tooltip_query", 1, widget, "GtkWidget*");
  gtk_widget_trigger_tooltip_query((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_startup_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_startup_id "void gtk_window_set_startup_id(GtkWindow* window, gchar* startup_id)"
  s7_pointer _p;
  s7_pointer window, startup_id;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_startup_id", 1, window, "GtkWindow*");
  startup_id = s7_car(_p);
  if (!s7_is_string(startup_id)) s7_wrong_type_arg_error(sc, "gtk_window_set_startup_id", 2, startup_id, "gchar*");
  gtk_window_set_startup_id((GtkWindow*)s7_c_pointer(window), (gchar*)s7_string(startup_id));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_add_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_add_mark "void gtk_text_buffer_add_mark(GtkTextBuffer* buffer, GtkTextMark* mark, \
GtkTextIter* where)"
  s7_pointer _p;
  s7_pointer buffer, mark, where;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_mark", 1, buffer, "GtkTextBuffer*");
  mark = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mark, GtkTextMark__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_mark", 2, mark, "GtkTextMark*");
  where = s7_car(_p);
  if (!s7_is_c_pointer_of_type(where, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_mark", 3, where, "GtkTextIter*");
  gtk_text_buffer_add_mark((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextMark*)s7_c_pointer(mark), (GtkTextIter*)s7_c_pointer(where));
  return(lg_false);
}

static s7_pointer lg_gtk_text_mark_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_mark_new "GtkTextMark* gtk_text_mark_new(gchar* name, gboolean left_gravity)"
  s7_pointer _p;
  s7_pointer name, left_gravity;
  _p = args;
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_text_mark_new", 1, name, "gchar*");
  left_gravity = s7_car(_p);
  if (!s7_is_boolean(left_gravity)) s7_wrong_type_arg_error(sc, "gtk_text_mark_new", 2, left_gravity, "gboolean");
  return(lg_make_c_pointer_with_type(sc, GtkTextMark__sym, gtk_text_mark_new((gchar*)s7_string(name), (gboolean)lg_boolean(left_gravity))));
}

static s7_pointer lg_gtk_tree_view_column_get_tree_view(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_tree_view "GtkWidget* gtk_tree_view_column_get_tree_view(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_tree_view", 1, tree_column, "GtkTreeViewColumn*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_tree_view_column_get_tree_view((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tooltip_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_text "void gtk_tooltip_set_text(GtkTooltip* tooltip, gchar* text)"
  s7_pointer _p;
  s7_pointer tooltip, text;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_text", 1, tooltip, "GtkTooltip*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_text", 2, text, "gchar*");
  gtk_tooltip_set_text((GtkTooltip*)s7_c_pointer(tooltip), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_convert_widget_to_tree_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_widget_to_tree_coords "void gtk_tree_view_convert_widget_to_tree_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [tx], gint* [ty])"
  s7_pointer _p;
  s7_pointer tree_view, wx, wy;
  gint ref_tx;
  gint ref_ty;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_tree_coords", 1, tree_view, "GtkTreeView*");
  wx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_tree_coords", 2, wx, "gint");
  wy = s7_car(_p);
  if (!s7_is_integer(wy)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_tree_coords", 3, wy, "gint");
  gtk_tree_view_convert_widget_to_tree_coords((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(wx), (gint)s7_integer(wy), &ref_tx, &ref_ty);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_tx), s7_make_integer(sc, ref_ty)));
}

static s7_pointer lg_gtk_tree_view_convert_tree_to_widget_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_tree_to_widget_coords "void gtk_tree_view_convert_tree_to_widget_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [wx], gint* [wy])"
  s7_pointer _p;
  s7_pointer tree_view, tx, ty;
  gint ref_wx;
  gint ref_wy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_widget_coords", 1, tree_view, "GtkTreeView*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_widget_coords", 2, tx, "gint");
  ty = s7_car(_p);
  if (!s7_is_integer(ty)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_widget_coords", 3, ty, "gint");
  gtk_tree_view_convert_tree_to_widget_coords((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(tx), (gint)s7_integer(ty), &ref_wx, &ref_wy);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_wx), s7_make_integer(sc, ref_wy)));
}

static s7_pointer lg_gtk_tree_view_convert_widget_to_bin_window_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_widget_to_bin_window_coords "void gtk_tree_view_convert_widget_to_bin_window_coords(GtkTreeView* tree_view, \
gint wx, gint wy, gint* [bx], gint* [by])"
  s7_pointer _p;
  s7_pointer tree_view, wx, wy;
  gint ref_bx;
  gint ref_by;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", 1, tree_view, "GtkTreeView*");
  wx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(wx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", 2, wx, "gint");
  wy = s7_car(_p);
  if (!s7_is_integer(wy)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", 3, wy, "gint");
  gtk_tree_view_convert_widget_to_bin_window_coords((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(wx), (gint)s7_integer(wy), &ref_bx, &ref_by);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_bx), s7_make_integer(sc, ref_by)));
}

static s7_pointer lg_gtk_tree_view_convert_bin_window_to_widget_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_bin_window_to_widget_coords "void gtk_tree_view_convert_bin_window_to_widget_coords(GtkTreeView* tree_view, \
gint bx, gint by, gint* [wx], gint* [wy])"
  s7_pointer _p;
  s7_pointer tree_view, bx, by;
  gint ref_wx;
  gint ref_wy;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", 1, tree_view, "GtkTreeView*");
  bx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", 2, bx, "gint");
  by = s7_car(_p);
  if (!s7_is_integer(by)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", 3, by, "gint");
  gtk_tree_view_convert_bin_window_to_widget_coords((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(bx), (gint)s7_integer(by), &ref_wx, &ref_wy);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_wx), s7_make_integer(sc, ref_wy)));
}

static s7_pointer lg_gtk_tree_view_convert_tree_to_bin_window_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_tree_to_bin_window_coords "void gtk_tree_view_convert_tree_to_bin_window_coords(GtkTreeView* tree_view, \
gint tx, gint ty, gint* [bx], gint* [by])"
  s7_pointer _p;
  s7_pointer tree_view, tx, ty;
  gint ref_bx;
  gint ref_by;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", 1, tree_view, "GtkTreeView*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(tx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", 2, tx, "gint");
  ty = s7_car(_p);
  if (!s7_is_integer(ty)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", 3, ty, "gint");
  gtk_tree_view_convert_tree_to_bin_window_coords((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(tx), (gint)s7_integer(ty), &ref_bx, &ref_by);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_bx), s7_make_integer(sc, ref_by)));
}

static s7_pointer lg_gtk_tree_view_convert_bin_window_to_tree_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_convert_bin_window_to_tree_coords "void gtk_tree_view_convert_bin_window_to_tree_coords(GtkTreeView* tree_view, \
gint bx, gint by, gint* [tx], gint* [ty])"
  s7_pointer _p;
  s7_pointer tree_view, bx, by;
  gint ref_tx;
  gint ref_ty;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", 1, tree_view, "GtkTreeView*");
  bx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(bx)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", 2, bx, "gint");
  by = s7_car(_p);
  if (!s7_is_integer(by)) s7_wrong_type_arg_error(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", 3, by, "gint");
  gtk_tree_view_convert_bin_window_to_tree_coords((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(bx), (gint)s7_integer(by), &ref_tx, &ref_ty);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_tx), s7_make_integer(sc, ref_ty)));
}

static s7_pointer lg_gtk_widget_set_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_tooltip_text "void gtk_widget_set_tooltip_text(GtkWidget* widget, gchar* text)"
  s7_pointer _p;
  s7_pointer widget, text;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_text", 1, widget, "GtkWidget*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_text", 2, text, "gchar*");
  gtk_widget_set_tooltip_text((GtkWidget*)s7_c_pointer(widget), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_tooltip_text "gchar* gtk_widget_get_tooltip_text(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_tooltip_text", 1, widget, "GtkWidget*");
  return(s7_make_string(sc, gtk_widget_get_tooltip_text((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_tooltip_markup "void gtk_widget_set_tooltip_markup(GtkWidget* widget, gchar* markup)"
  s7_pointer _p;
  s7_pointer widget, markup;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_markup", 1, widget, "GtkWidget*");
  markup = s7_car(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_widget_set_tooltip_markup", 2, markup, "gchar*");
  gtk_widget_set_tooltip_markup((GtkWidget*)s7_c_pointer(widget), (const gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_tooltip_markup "gchar* gtk_widget_get_tooltip_markup(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_tooltip_markup", 1, widget, "GtkWidget*");
  return(s7_make_string(sc, gtk_widget_get_tooltip_markup((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_tree_view_is_rubber_banding_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_is_rubber_banding_active "gboolean gtk_tree_view_is_rubber_banding_active(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_rubber_banding_active", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_is_rubber_banding_active((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_icon_view_set_tooltip_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_tooltip_item "void gtk_icon_view_set_tooltip_item(GtkIconView* icon_view, \
GtkTooltip* tooltip, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, tooltip, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_item", 1, icon_view, "GtkIconView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_item", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_item", 3, path, "GtkTreePath*");
  gtk_icon_view_set_tooltip_item((GtkIconView*)s7_c_pointer(icon_view), (GtkTooltip*)s7_c_pointer(tooltip), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_set_tooltip_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_tooltip_cell "void gtk_icon_view_set_tooltip_cell(GtkIconView* icon_view, \
GtkTooltip* tooltip, GtkTreePath* path, GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer icon_view, tooltip, path, cell;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 1, icon_view, "GtkIconView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 3, path, "GtkTreePath*");
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_cell", 4, cell, "GtkCellRenderer*");
  gtk_icon_view_set_tooltip_cell((GtkIconView*)s7_c_pointer(icon_view), (GtkTooltip*)s7_c_pointer(tooltip), (GtkTreePath*)s7_c_pointer(path), (GtkCellRenderer*)s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_tooltip_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_tooltip_context "gboolean gtk_icon_view_get_tooltip_context(GtkIconView* icon_view, \
gint* [x], gint* [y], gboolean keyboard_tip, GtkTreeModel** [model], GtkTreePath** [path], GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer icon_view, keyboard_tip, iter;
  gint ref_x;
  gint ref_y;
  GtkTreeModel* ref_model = NULL;
  GtkTreePath* ref_path = NULL;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_context", 1, icon_view, "GtkIconView*");
  keyboard_tip = s7_car(_p);
  if (!s7_is_boolean(keyboard_tip)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_context", 4, keyboard_tip, "gboolean");
  iter = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) && (iter != lg_false)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_context", 7, iter, "GtkTreeIter*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_icon_view_get_tooltip_context((GtkIconView*)s7_c_pointer(icon_view), &ref_x, &ref_y, (gboolean)lg_boolean(keyboard_tip), &ref_model, &ref_path, (GtkTreeIter*)s7_c_pointer(iter)));
      return(s7_list(sc, 5, res_ult, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y), s7_make_c_pointer(sc, ref_model), s7_make_c_pointer(sc, ref_path)));
   }
}

static s7_pointer lg_gtk_icon_view_set_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_tooltip_column "void gtk_icon_view_set_tooltip_column(GtkIconView* icon_view, \
gint column)"
  s7_pointer _p;
  s7_pointer icon_view, column;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_column", 1, icon_view, "GtkIconView*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_tooltip_column", 2, column, "gint");
  gtk_icon_view_set_tooltip_column((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_tooltip_column "gint gtk_icon_view_get_tooltip_column(GtkIconView* icon_view, \
)"
  s7_pointer icon_view ;
  icon_view  = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view , GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_tooltip_column", 1, icon_view , "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_tooltip_column((GtkIconView*)s7_c_pointer(icon_view ))));
}

static s7_pointer lg_gtk_tooltip_set_tip_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_tip_area "void gtk_tooltip_set_tip_area(GtkTooltip* tooltip, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer tooltip, rect;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_tip_area", 1, tooltip, "GtkTooltip*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_tip_area", 2, rect, "GdkRectangle*");
  gtk_tooltip_set_tip_area((GtkTooltip*)s7_c_pointer(tooltip), (GdkRectangle*)s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_tooltip_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_tooltip_row "void gtk_tree_view_set_tooltip_row(GtkTreeView* tree_view, \
GtkTooltip* tooltip, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, tooltip, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_row", 1, tree_view, "GtkTreeView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_row", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_row", 3, path, "GtkTreePath*");
  gtk_tree_view_set_tooltip_row((GtkTreeView*)s7_c_pointer(tree_view), (GtkTooltip*)s7_c_pointer(tooltip), (GtkTreePath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_tooltip_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_tooltip_cell "void gtk_tree_view_set_tooltip_cell(GtkTreeView* tree_view, \
GtkTooltip* tooltip, GtkTreePath* path, GtkTreeViewColumn* column, GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer tree_view, tooltip, path, column, cell;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 1, tree_view, "GtkTreeView*");
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 2, tooltip, "GtkTooltip*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 3, path, "GtkTreePath*");
  column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 4, column, "GtkTreeViewColumn*");
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_cell", 5, cell, "GtkCellRenderer*");
  gtk_tree_view_set_tooltip_cell((GtkTreeView*)s7_c_pointer(tree_view), (GtkTooltip*)s7_c_pointer(tooltip), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(column), (GtkCellRenderer*)s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_tooltip_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_tooltip_context "gboolean gtk_tree_view_get_tooltip_context(GtkTreeView* tree_view, \
gint* [x], gint* [y], gboolean keyboard_tip, GtkTreeModel** [model], GtkTreePath** [path], GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_view, keyboard_tip, iter;
  gint ref_x;
  gint ref_y;
  GtkTreeModel* ref_model = NULL;
  GtkTreePath* ref_path = NULL;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_context", 1, tree_view, "GtkTreeView*");
  keyboard_tip = s7_car(_p);
  if (!s7_is_boolean(keyboard_tip)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_context", 4, keyboard_tip, "gboolean");
  iter = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) && (iter != lg_false)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_context", 7, iter, "GtkTreeIter*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_view_get_tooltip_context((GtkTreeView*)s7_c_pointer(tree_view), &ref_x, &ref_y, (gboolean)lg_boolean(keyboard_tip), &ref_model, &ref_path, (GtkTreeIter*)s7_c_pointer(iter)));
      return(s7_list(sc, 5, res_ult, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y), s7_make_c_pointer(sc, ref_model), s7_make_c_pointer(sc, ref_path)));
   }
}

static s7_pointer lg_gtk_tree_view_set_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_tooltip_column "void gtk_tree_view_set_tooltip_column(GtkTreeView* tree_view, \
gint column)"
  s7_pointer _p;
  s7_pointer tree_view, column;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_column", 1, tree_view, "GtkTreeView*");
  column = s7_car(_p);
  if (!s7_is_integer(column)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_tooltip_column", 2, column, "gint");
  gtk_tree_view_set_tooltip_column((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(column));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_tooltip_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_tooltip_column "gint gtk_tree_view_get_tooltip_column(GtkTreeView* tree_view, \
)"
  s7_pointer tree_view ;
  tree_view  = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view , GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_tooltip_column", 1, tree_view , "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_tooltip_column((GtkTreeView*)s7_c_pointer(tree_view ))));
}

static s7_pointer lg_gtk_widget_set_has_tooltip(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_has_tooltip "void gtk_widget_set_has_tooltip(GtkWidget* widget, gboolean has_tooltip)"
  s7_pointer _p;
  s7_pointer widget, has_tooltip;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_has_tooltip", 1, widget, "GtkWidget*");
  has_tooltip = s7_car(_p);
  if (!s7_is_boolean(has_tooltip)) s7_wrong_type_arg_error(sc, "gtk_widget_set_has_tooltip", 2, has_tooltip, "gboolean");
  gtk_widget_set_has_tooltip((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(has_tooltip));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_has_tooltip(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_has_tooltip "gboolean gtk_widget_get_has_tooltip(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_has_tooltip", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_has_tooltip((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_calendar_set_detail_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_detail_func "void gtk_calendar_set_detail_func(GtkCalendar* calendar, GtkCalendarDetailFunc func, \
lambda_data func_info, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer calendar, func, func_info, destroy;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_func", 1, calendar, "GtkCalendar*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkCalendarDetailFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_func", 2, func, "GtkCalendarDetailFunc");
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_calendar_set_detail_func((GtkCalendar*)s7_c_pointer(calendar), (GtkCalendarDetailFunc)s7_c_pointer(func), (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_calendar_set_detail_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_detail_width_chars "void gtk_calendar_set_detail_width_chars(GtkCalendar* calendar, \
gint chars)"
  s7_pointer _p;
  s7_pointer calendar, chars;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_width_chars", 1, calendar, "GtkCalendar*");
  chars = s7_car(_p);
  if (!s7_is_integer(chars)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_width_chars", 2, chars, "gint");
  gtk_calendar_set_detail_width_chars((GtkCalendar*)s7_c_pointer(calendar), (gint)s7_integer(chars));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_set_detail_height_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_detail_height_rows "void gtk_calendar_set_detail_height_rows(GtkCalendar* calendar, \
gint rows)"
  s7_pointer _p;
  s7_pointer calendar, rows;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_height_rows", 1, calendar, "GtkCalendar*");
  rows = s7_car(_p);
  if (!s7_is_integer(rows)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_detail_height_rows", 2, rows, "gint");
  gtk_calendar_set_detail_height_rows((GtkCalendar*)s7_c_pointer(calendar), (gint)s7_integer(rows));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_detail_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_detail_width_chars "gint gtk_calendar_get_detail_width_chars(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_detail_width_chars", 1, calendar, "GtkCalendar*");
  return(s7_make_integer(sc, gtk_calendar_get_detail_width_chars((GtkCalendar*)s7_c_pointer(calendar))));
}

static s7_pointer lg_gtk_calendar_get_detail_height_rows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_detail_height_rows "gint gtk_calendar_get_detail_height_rows(GtkCalendar* calendar)"
  s7_pointer calendar;
  calendar = s7_car(args);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_detail_height_rows", 1, calendar, "GtkCalendar*");
  return(s7_make_integer(sc, gtk_calendar_get_detail_height_rows((GtkCalendar*)s7_c_pointer(calendar))));
}

static s7_pointer lg_gtk_dialog_get_content_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_content_area "GtkWidget* gtk_dialog_get_content_area(GtkDialog* dialog)"
  s7_pointer dialog;
  dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_content_area", 1, dialog, "GtkDialog*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_dialog_get_content_area((GtkDialog*)s7_c_pointer(dialog))));
}

static s7_pointer lg_gtk_entry_set_overwrite_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_overwrite_mode "void gtk_entry_set_overwrite_mode(GtkEntry* entry, gboolean overwrite)"
  s7_pointer _p;
  s7_pointer entry, overwrite;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_overwrite_mode", 1, entry, "GtkEntry*");
  overwrite = s7_car(_p);
  if (!s7_is_boolean(overwrite)) s7_wrong_type_arg_error(sc, "gtk_entry_set_overwrite_mode", 2, overwrite, "gboolean");
  gtk_entry_set_overwrite_mode((GtkEntry*)s7_c_pointer(entry), (gboolean)lg_boolean(overwrite));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_overwrite_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_overwrite_mode "gboolean gtk_entry_get_overwrite_mode(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_overwrite_mode", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_get_overwrite_mode((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_get_text_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_text_length "guint16 gtk_entry_get_text_length(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_text_length", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_text_length((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_scale_button_get_plus_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_get_plus_button "GtkWidget* gtk_scale_button_get_plus_button(GtkScaleButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkScaleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_get_plus_button", 1, button, "GtkScaleButton*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scale_button_get_plus_button((GtkScaleButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_scale_button_get_minus_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_get_minus_button "GtkWidget* gtk_scale_button_get_minus_button(GtkScaleButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkScaleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_get_minus_button", 1, button, "GtkScaleButton*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scale_button_get_minus_button((GtkScaleButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_scale_button_get_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_get_popup "GtkWidget* gtk_scale_button_get_popup(GtkScaleButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkScaleButton__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_get_popup", 1, button, "GtkScaleButton*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scale_button_get_popup((GtkScaleButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_adjustment_get_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_lower "gdouble gtk_adjustment_get_lower(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_lower", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_lower((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_lower "void gtk_adjustment_set_lower(GtkAdjustment* adjustment, gdouble lower)"
  s7_pointer _p;
  s7_pointer adjustment, lower;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_lower", 1, adjustment, "GtkAdjustment*");
  lower = s7_car(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_lower", 2, lower, "gdouble");
  gtk_adjustment_set_lower((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(lower));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_upper "gdouble gtk_adjustment_get_upper(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_upper", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_upper((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_upper(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_upper "void gtk_adjustment_set_upper(GtkAdjustment* adjustment, gdouble upper)"
  s7_pointer _p;
  s7_pointer adjustment, upper;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_upper", 1, adjustment, "GtkAdjustment*");
  upper = s7_car(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_upper", 2, upper, "gdouble");
  gtk_adjustment_set_upper((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(upper));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_step_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_step_increment "gdouble gtk_adjustment_get_step_increment(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_step_increment", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_step_increment((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_step_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_step_increment "void gtk_adjustment_set_step_increment(GtkAdjustment* adjustment, \
gdouble step_increment)"
  s7_pointer _p;
  s7_pointer adjustment, step_increment;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_step_increment", 1, adjustment, "GtkAdjustment*");
  step_increment = s7_car(_p);
  if (!s7_is_real(step_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_step_increment", 2, step_increment, "gdouble");
  gtk_adjustment_set_step_increment((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(step_increment));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_page_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_page_increment "gdouble gtk_adjustment_get_page_increment(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_page_increment", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_page_increment((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_page_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_page_increment "void gtk_adjustment_set_page_increment(GtkAdjustment* adjustment, \
gdouble page_increment)"
  s7_pointer _p;
  s7_pointer adjustment, page_increment;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_increment", 1, adjustment, "GtkAdjustment*");
  page_increment = s7_car(_p);
  if (!s7_is_real(page_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_increment", 2, page_increment, "gdouble");
  gtk_adjustment_set_page_increment((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(page_increment));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_page_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_page_size "gdouble gtk_adjustment_get_page_size(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_page_size", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_page_size((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_adjustment_set_page_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_set_page_size "void gtk_adjustment_set_page_size(GtkAdjustment* adjustment, \
gdouble page_size)"
  s7_pointer _p;
  s7_pointer adjustment, page_size;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_size", 1, adjustment, "GtkAdjustment*");
  page_size = s7_car(_p);
  if (!s7_is_real(page_size)) s7_wrong_type_arg_error(sc, "gtk_adjustment_set_page_size", 2, page_size, "gdouble");
  gtk_adjustment_set_page_size((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(page_size));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_configure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_configure "void gtk_adjustment_configure(GtkAdjustment* adjustment, gdouble value, \
gdouble lower, gdouble upper, gdouble step_increment, gdouble page_increment, gdouble page_size)"
  s7_pointer _p;
  s7_pointer adjustment, value, lower, upper, step_increment, page_increment, page_size;
  _p = args;
  adjustment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 1, adjustment, "GtkAdjustment*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 2, value, "gdouble");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 3, lower, "gdouble");
  upper = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 4, upper, "gdouble");
  step_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 5, step_increment, "gdouble");
  page_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 6, page_increment, "gdouble");
  page_size = s7_car(_p);
  if (!s7_is_real(page_size)) s7_wrong_type_arg_error(sc, "gtk_adjustment_configure", 7, page_size, "gdouble");
  gtk_adjustment_configure((GtkAdjustment*)s7_c_pointer(adjustment), (gdouble)s7_real(value), (gdouble)s7_real(lower), (gdouble)s7_real(upper), (gdouble)s7_real(step_increment), (gdouble)s7_real(page_increment), (gdouble)s7_real(page_size));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_button_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_button_sensitivity "void gtk_combo_box_set_button_sensitivity(GtkComboBox* combo_box, \
GtkSensitivityType sensitivity)"
  s7_pointer _p;
  s7_pointer combo_box, sensitivity;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_button_sensitivity", 1, combo_box, "GtkComboBox*");
  sensitivity = s7_car(_p);
  if (!s7_is_integer(sensitivity)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_button_sensitivity", 2, sensitivity, "GtkSensitivityType");
  gtk_combo_box_set_button_sensitivity((GtkComboBox*)s7_c_pointer(combo_box), (GtkSensitivityType)s7_integer(sensitivity));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_button_sensitivity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_button_sensitivity "GtkSensitivityType gtk_combo_box_get_button_sensitivity(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_button_sensitivity", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_button_sensitivity((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_window_get_default_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_widget "GtkWidget* gtk_window_get_default_widget(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_default_widget", 1, window, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_window_get_default_widget((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_link_button_get_visited(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_get_visited "gboolean gtk_link_button_get_visited(GtkLinkButton* link_button)"
  s7_pointer link_button;
  link_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_get_visited", 1, link_button, "GtkLinkButton*");
  return(s7_make_boolean(sc, gtk_link_button_get_visited((GtkLinkButton*)s7_c_pointer(link_button))));
}

static s7_pointer lg_gtk_link_button_set_visited(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_link_button_set_visited "void gtk_link_button_set_visited(GtkLinkButton* link_button, \
bool visited)"
  s7_pointer _p;
  s7_pointer link_button, visited;
  _p = args;
  link_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(link_button, GtkLinkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_visited", 1, link_button, "GtkLinkButton*");
  visited = s7_car(_p);
  if (!s7_is_boolean(visited)) s7_wrong_type_arg_error(sc, "gtk_link_button_set_visited", 2, visited, "bool");
  gtk_link_button_set_visited((GtkLinkButton*)s7_c_pointer(link_button), (bool)lg_boolean(visited));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_model "GtkTreeModel* gtk_cell_view_get_model(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_model", 1, cell_view, "GtkCellView*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeModel__sym, gtk_cell_view_get_model((GtkCellView*)s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_entry_unset_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_unset_invisible_char "void gtk_entry_unset_invisible_char(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_unset_invisible_char", 1, entry, "GtkEntry*");
  gtk_entry_unset_invisible_char((GtkEntry*)s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_progress_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_progress_fraction "void gtk_entry_set_progress_fraction(GtkEntry* entry, gdouble fraction)"
  s7_pointer _p;
  s7_pointer entry, fraction;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_fraction", 1, entry, "GtkEntry*");
  fraction = s7_car(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_fraction", 2, fraction, "gdouble");
  gtk_entry_set_progress_fraction((GtkEntry*)s7_c_pointer(entry), (gdouble)s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_progress_fraction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_progress_fraction "gdouble gtk_entry_get_progress_fraction(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_progress_fraction", 1, entry, "GtkEntry*");
  return(s7_make_real(sc, gtk_entry_get_progress_fraction((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_progress_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_progress_pulse_step "void gtk_entry_set_progress_pulse_step(GtkEntry* entry, \
gdouble fraction)"
  s7_pointer _p;
  s7_pointer entry, fraction;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_pulse_step", 1, entry, "GtkEntry*");
  fraction = s7_car(_p);
  if (!s7_is_real(fraction)) s7_wrong_type_arg_error(sc, "gtk_entry_set_progress_pulse_step", 2, fraction, "gdouble");
  gtk_entry_set_progress_pulse_step((GtkEntry*)s7_c_pointer(entry), (gdouble)s7_real(fraction));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_progress_pulse_step(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_progress_pulse_step "gdouble gtk_entry_get_progress_pulse_step(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_progress_pulse_step", 1, entry, "GtkEntry*");
  return(s7_make_real(sc, gtk_entry_get_progress_pulse_step((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_progress_pulse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_progress_pulse "void gtk_entry_progress_pulse(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_progress_pulse", 1, entry, "GtkEntry*");
  gtk_entry_progress_pulse((GtkEntry*)s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_name "gchar* gtk_entry_get_icon_name(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_name", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_name", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_string(sc, gtk_entry_get_icon_name((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_set_icon_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_activatable "void gtk_entry_set_icon_activatable(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gboolean activatable)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, activatable;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_activatable", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_activatable", 2, icon_pos, "GtkEntryIconPosition");
  activatable = s7_car(_p);
  if (!s7_is_boolean(activatable)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_activatable", 3, activatable, "gboolean");
  gtk_entry_set_icon_activatable((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos), (gboolean)lg_boolean(activatable));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_activatable "gboolean gtk_entry_get_icon_activatable(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_activatable", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_activatable", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_boolean(sc, gtk_entry_get_icon_activatable((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_set_icon_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_sensitive "void gtk_entry_set_icon_sensitive(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gboolean sensitive)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, sensitive;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_sensitive", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_sensitive", 2, icon_pos, "GtkEntryIconPosition");
  sensitive = s7_car(_p);
  if (!s7_is_boolean(sensitive)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_sensitive", 3, sensitive, "gboolean");
  gtk_entry_set_icon_sensitive((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos), (gboolean)lg_boolean(sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_sensitive "gboolean gtk_entry_get_icon_sensitive(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_sensitive", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_sensitive", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_boolean(sc, gtk_entry_get_icon_sensitive((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_at_pos "gint gtk_entry_get_icon_at_pos(GtkEntry* entry, gint x, gint y)"
  s7_pointer _p;
  s7_pointer entry, x, y;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_at_pos", 1, entry, "GtkEntry*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_at_pos", 2, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_at_pos", 3, y, "gint");
  return(s7_make_integer(sc, gtk_entry_get_icon_at_pos((GtkEntry*)s7_c_pointer(entry), (gint)s7_integer(x), (gint)s7_integer(y))));
}

static s7_pointer lg_gtk_entry_set_icon_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_tooltip_text "void gtk_entry_set_icon_tooltip_text(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
gchar* tooltip)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, tooltip;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_text", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_text", 2, icon_pos, "GtkEntryIconPosition");
  tooltip = s7_car(_p);
  if (!s7_is_string(tooltip)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_text", 3, tooltip, "gchar*");
  gtk_entry_set_icon_tooltip_text((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos), (gchar*)s7_string(tooltip));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_set_icon_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_tooltip_markup "void gtk_entry_set_icon_tooltip_markup(GtkEntry* entry, \
GtkEntryIconPosition icon_pos, gchar* tooltip)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, tooltip;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_markup", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_markup", 2, icon_pos, "GtkEntryIconPosition");
  tooltip = s7_car(_p);
  if (!s7_is_string(tooltip)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_tooltip_markup", 3, tooltip, "gchar*");
  gtk_entry_set_icon_tooltip_markup((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos), (gchar*)s7_string(tooltip));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_icon_tooltip_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_tooltip_text "gchar* gtk_entry_get_icon_tooltip_text(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_text", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_text", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_string(sc, gtk_entry_get_icon_tooltip_text((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_tooltip_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_tooltip_markup "gchar* gtk_entry_get_icon_tooltip_markup(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_markup", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_tooltip_markup", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_string(sc, gtk_entry_get_icon_tooltip_markup((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_scale_add_mark(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_add_mark "void gtk_scale_add_mark(GtkScale* scale, gdouble value, GtkPositionType position, \
gchar* markup)"
  s7_pointer _p;
  s7_pointer scale, value, position, markup;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 1, scale, "GtkScale*");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 2, value, "gdouble");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 3, position, "GtkPositionType");
  markup = s7_car(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_scale_add_mark", 4, markup, "gchar*");
  gtk_scale_add_mark((GtkScale*)s7_c_pointer(scale), (gdouble)s7_real(value), (GtkPositionType)s7_integer(position), (gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_clear_marks(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_clear_marks "void gtk_scale_clear_marks(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_clear_marks", 1, scale, "GtkScale*");
  gtk_scale_clear_marks((GtkScale*)s7_c_pointer(scale));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_default_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_default_icon_name "gchar* gtk_window_get_default_icon_name( void)"
  return(s7_make_string(sc, gtk_window_get_default_icon_name()));
}

static s7_pointer lg_gtk_label_get_current_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_current_uri "gchar* gtk_label_get_current_uri(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_current_uri", 1, label, "GtkLabel*");
  return(s7_make_string(sc, gtk_label_get_current_uri((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_info_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_new "GtkWidget* gtk_info_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_info_bar_new()));
}

static s7_pointer lg_gtk_info_bar_add_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_add_action_widget "void gtk_info_bar_add_action_widget(GtkInfoBar* info_bar, \
GtkWidget* child, gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, child, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_action_widget", 1, info_bar, "GtkInfoBar*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_action_widget", 2, child, "GtkWidget*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_action_widget", 3, response_id, "gint");
  gtk_info_bar_add_action_widget((GtkInfoBar*)s7_c_pointer(info_bar), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_add_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_add_button "GtkWidget* gtk_info_bar_add_button(GtkInfoBar* info_bar, gchar* button_text, \
gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, button_text, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_button", 1, info_bar, "GtkInfoBar*");
  button_text = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(button_text)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_button", 2, button_text, "gchar*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_add_button", 3, response_id, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_info_bar_add_button((GtkInfoBar*)s7_c_pointer(info_bar), (gchar*)s7_string(button_text), (gint)s7_integer(response_id))));
}

static s7_pointer lg_gtk_info_bar_set_response_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_response_sensitive "void gtk_info_bar_set_response_sensitive(GtkInfoBar* info_bar, \
gint response_id, gboolean setting)"
  s7_pointer _p;
  s7_pointer info_bar, response_id, setting;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_response_sensitive", 1, info_bar, "GtkInfoBar*");
  response_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_response_sensitive", 2, response_id, "gint");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_response_sensitive", 3, setting, "gboolean");
  gtk_info_bar_set_response_sensitive((GtkInfoBar*)s7_c_pointer(info_bar), (gint)s7_integer(response_id), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_set_default_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_default_response "void gtk_info_bar_set_default_response(GtkInfoBar* info_bar, \
gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_default_response", 1, info_bar, "GtkInfoBar*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_default_response", 2, response_id, "gint");
  gtk_info_bar_set_default_response((GtkInfoBar*)s7_c_pointer(info_bar), (gint)s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_response "void gtk_info_bar_response(GtkInfoBar* info_bar, gint response_id)"
  s7_pointer _p;
  s7_pointer info_bar, response_id;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_response", 1, info_bar, "GtkInfoBar*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_info_bar_response", 2, response_id, "gint");
  gtk_info_bar_response((GtkInfoBar*)s7_c_pointer(info_bar), (gint)s7_integer(response_id));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_set_message_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_message_type "void gtk_info_bar_set_message_type(GtkInfoBar* info_bar, GtkMessageType message_type)"
  s7_pointer _p;
  s7_pointer info_bar, message_type;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_message_type", 1, info_bar, "GtkInfoBar*");
  message_type = s7_car(_p);
  if (!s7_is_integer(message_type)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_message_type", 2, message_type, "GtkMessageType");
  gtk_info_bar_set_message_type((GtkInfoBar*)s7_c_pointer(info_bar), (GtkMessageType)s7_integer(message_type));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_get_message_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_message_type "GtkMessageType gtk_info_bar_get_message_type(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_message_type", 1, info_bar, "GtkInfoBar*");
  return(s7_make_integer(sc, gtk_info_bar_get_message_type((GtkInfoBar*)s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_entry_new_with_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_new_with_buffer "GtkWidget* gtk_entry_new_with_buffer(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_new_with_buffer", 1, buffer, "GtkEntryBuffer*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_entry_new_with_buffer((GtkEntryBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_buffer "GtkEntryBuffer* gtk_entry_get_buffer(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_buffer", 1, entry, "GtkEntry*");
  return(lg_make_c_pointer_with_type(sc, GtkEntryBuffer__sym, gtk_entry_get_buffer((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_buffer "void gtk_entry_set_buffer(GtkEntry* entry, GtkEntryBuffer* buffer)"
  s7_pointer _p;
  s7_pointer entry, buffer;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_buffer", 1, entry, "GtkEntry*");
  buffer = s7_car(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_buffer", 2, buffer, "GtkEntryBuffer*");
  gtk_entry_set_buffer((GtkEntry*)s7_c_pointer(entry), (GtkEntryBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_track_visited_links(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_track_visited_links "void gtk_label_set_track_visited_links(GtkLabel* label, \
gboolean track_links)"
  s7_pointer _p;
  s7_pointer label, track_links;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_track_visited_links", 1, label, "GtkLabel*");
  track_links = s7_car(_p);
  if (!s7_is_boolean(track_links)) s7_wrong_type_arg_error(sc, "gtk_label_set_track_visited_links", 2, track_links, "gboolean");
  gtk_label_set_track_visited_links((GtkLabel*)s7_c_pointer(label), (gboolean)lg_boolean(track_links));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_track_visited_links(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_track_visited_links "gboolean gtk_label_get_track_visited_links(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_track_visited_links", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_track_visited_links((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_print_operation_set_embed_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_set_embed_page_setup "void gtk_print_operation_set_embed_page_setup(GtkPrintOperation* op, \
gboolean embed)"
  s7_pointer _p;
  s7_pointer op, embed;
  _p = args;
  op = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_embed_page_setup", 1, op, "GtkPrintOperation*");
  embed = s7_car(_p);
  if (!s7_is_boolean(embed)) s7_wrong_type_arg_error(sc, "gtk_print_operation_set_embed_page_setup", 2, embed, "gboolean");
  gtk_print_operation_set_embed_page_setup((GtkPrintOperation*)s7_c_pointer(op), (gboolean)lg_boolean(embed));
  return(lg_false);
}

static s7_pointer lg_gtk_print_operation_get_embed_page_setup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_print_operation_get_embed_page_setup "gboolean gtk_print_operation_get_embed_page_setup(GtkPrintOperation* op)"
  s7_pointer op;
  op = s7_car(args);
  if (!s7_is_c_pointer_of_type(op, GtkPrintOperation__sym)) s7_wrong_type_arg_error(sc, "gtk_print_operation_get_embed_page_setup", 1, op, "GtkPrintOperation*");
  return(s7_make_boolean(sc, gtk_print_operation_get_embed_page_setup((GtkPrintOperation*)s7_c_pointer(op))));
}

static s7_pointer lg_gtk_entry_buffer_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_new "GtkEntryBuffer* gtk_entry_buffer_new(gchar* initial_chars, gint n_initial_chars)"
  s7_pointer _p;
  s7_pointer initial_chars, n_initial_chars;
  _p = args;
  initial_chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(initial_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_new", 1, initial_chars, "gchar*");
  n_initial_chars = s7_car(_p);
  if (!s7_is_integer(n_initial_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_new", 2, n_initial_chars, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkEntryBuffer__sym, gtk_entry_buffer_new((gchar*)s7_string(initial_chars), (gint)s7_integer(n_initial_chars))));
}

static s7_pointer lg_gtk_entry_buffer_get_bytes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_bytes "gsize gtk_entry_buffer_get_bytes(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_bytes", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_integer(sc, gtk_entry_buffer_get_bytes((GtkEntryBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_get_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_length "guint gtk_entry_buffer_get_length(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_length", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_integer(sc, gtk_entry_buffer_get_length((GtkEntryBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_get_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_text "gchar* gtk_entry_buffer_get_text(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_text", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_string(sc, gtk_entry_buffer_get_text((GtkEntryBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_set_text "void gtk_entry_buffer_set_text(GtkEntryBuffer* buffer, gchar* chars, \
gint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, chars, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_text", 1, buffer, "GtkEntryBuffer*");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_text", 2, chars, "gchar*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_text", 3, n_chars, "gint");
  gtk_entry_buffer_set_text((GtkEntryBuffer*)s7_c_pointer(buffer), (gchar*)s7_string(chars), (gint)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_buffer_set_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_set_max_length "void gtk_entry_buffer_set_max_length(GtkEntryBuffer* buffer, \
guint max_length)"
  s7_pointer _p;
  s7_pointer buffer, max_length;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_max_length", 1, buffer, "GtkEntryBuffer*");
  max_length = s7_car(_p);
  if (!s7_is_integer(max_length)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_set_max_length", 2, max_length, "guint");
  gtk_entry_buffer_set_max_length((GtkEntryBuffer*)s7_c_pointer(buffer), (guint)s7_integer(max_length));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_buffer_get_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_get_max_length "guint gtk_entry_buffer_get_max_length(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_get_max_length", 1, buffer, "GtkEntryBuffer*");
  return(s7_make_integer(sc, gtk_entry_buffer_get_max_length((GtkEntryBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_entry_buffer_insert_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_insert_text "guint gtk_entry_buffer_insert_text(GtkEntryBuffer* buffer, \
guint position, gchar* chars, gint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, chars, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 2, position, "guint");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 3, chars, "gchar*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_insert_text", 4, n_chars, "gint");
  return(s7_make_integer(sc, gtk_entry_buffer_insert_text((GtkEntryBuffer*)s7_c_pointer(buffer), (guint)s7_integer(position), (gchar*)s7_string(chars), (gint)s7_integer(n_chars))));
}

static s7_pointer lg_gtk_entry_buffer_delete_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_delete_text "guint gtk_entry_buffer_delete_text(GtkEntryBuffer* buffer, \
guint position, gint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_delete_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_delete_text", 2, position, "guint");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_delete_text", 3, n_chars, "gint");
  return(s7_make_integer(sc, gtk_entry_buffer_delete_text((GtkEntryBuffer*)s7_c_pointer(buffer), (guint)s7_integer(position), (gint)s7_integer(n_chars))));
}

static s7_pointer lg_gtk_entry_buffer_emit_inserted_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_emit_inserted_text "void gtk_entry_buffer_emit_inserted_text(GtkEntryBuffer* buffer, \
guint position, gchar* chars, guint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, chars, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 2, position, "guint");
  chars = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 3, chars, "gchar*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_inserted_text", 4, n_chars, "guint");
  gtk_entry_buffer_emit_inserted_text((GtkEntryBuffer*)s7_c_pointer(buffer), (guint)s7_integer(position), (gchar*)s7_string(chars), (guint)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_buffer_emit_deleted_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_buffer_emit_deleted_text "void gtk_entry_buffer_emit_deleted_text(GtkEntryBuffer* buffer, \
guint position, guint n_chars)"
  s7_pointer _p;
  s7_pointer buffer, position, n_chars;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_deleted_text", 1, buffer, "GtkEntryBuffer*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_deleted_text", 2, position, "guint");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_entry_buffer_emit_deleted_text", 3, n_chars, "guint");
  gtk_entry_buffer_emit_deleted_text((GtkEntryBuffer*)s7_c_pointer(buffer), (guint)s7_integer(position), (guint)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_alignment "void gtk_cell_renderer_set_alignment(GtkCellRenderer* cell, \
gfloat xalign, gfloat yalign)"
  s7_pointer _p;
  s7_pointer cell, xalign, yalign;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_alignment", 1, cell, "GtkCellRenderer*");
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_alignment", 2, xalign, "gfloat");
  yalign = s7_car(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_alignment", 3, yalign, "gfloat");
  gtk_cell_renderer_set_alignment((GtkCellRenderer*)s7_c_pointer(cell), (gfloat)s7_real(xalign), (gfloat)s7_real(yalign));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_alignment "void gtk_cell_renderer_get_alignment(GtkCellRenderer* cell, \
gfloat* [xalign], gfloat* [yalign])"
  s7_pointer _p;
  s7_pointer cell;
  gfloat ref_xalign;
  gfloat ref_yalign;
  _p = args;
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_alignment", 1, cell, "GtkCellRenderer*");
  gtk_cell_renderer_get_alignment((GtkCellRenderer*)s7_c_pointer(cell), &ref_xalign, &ref_yalign);
    return(s7_list(sc, 2, s7_make_real(sc, ref_xalign), s7_make_real(sc, ref_yalign)));
}

static s7_pointer lg_gtk_cell_renderer_set_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_padding "void gtk_cell_renderer_set_padding(GtkCellRenderer* cell, \
gint xpad, gint ypad)"
  s7_pointer _p;
  s7_pointer cell, xpad, ypad;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_padding", 1, cell, "GtkCellRenderer*");
  xpad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(xpad)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_padding", 2, xpad, "gint");
  ypad = s7_car(_p);
  if (!s7_is_integer(ypad)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_padding", 3, ypad, "gint");
  gtk_cell_renderer_set_padding((GtkCellRenderer*)s7_c_pointer(cell), (gint)s7_integer(xpad), (gint)s7_integer(ypad));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_padding "void gtk_cell_renderer_get_padding(GtkCellRenderer* cell, \
gint* [xpad], gint* [ypad])"
  s7_pointer _p;
  s7_pointer cell;
  gint ref_xpad;
  gint ref_ypad;
  _p = args;
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_padding", 1, cell, "GtkCellRenderer*");
  gtk_cell_renderer_get_padding((GtkCellRenderer*)s7_c_pointer(cell), &ref_xpad, &ref_ypad);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_xpad), s7_make_integer(sc, ref_ypad)));
}

static s7_pointer lg_gtk_cell_renderer_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_visible "void gtk_cell_renderer_set_visible(GtkCellRenderer* cell, \
gboolean visible)"
  s7_pointer _p;
  s7_pointer cell, visible;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_visible", 1, cell, "GtkCellRenderer*");
  visible = s7_car(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_visible", 2, visible, "gboolean");
  gtk_cell_renderer_set_visible((GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_visible "gboolean gtk_cell_renderer_get_visible(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_visible", 1, cell, "GtkCellRenderer*");
  return(s7_make_boolean(sc, gtk_cell_renderer_get_visible((GtkCellRenderer*)s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_set_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_sensitive "void gtk_cell_renderer_set_sensitive(GtkCellRenderer* cell, \
gboolean sensitive)"
  s7_pointer _p;
  s7_pointer cell, sensitive;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_sensitive", 1, cell, "GtkCellRenderer*");
  sensitive = s7_car(_p);
  if (!s7_is_boolean(sensitive)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_sensitive", 2, sensitive, "gboolean");
  gtk_cell_renderer_set_sensitive((GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_sensitive "gboolean gtk_cell_renderer_get_sensitive(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_sensitive", 1, cell, "GtkCellRenderer*");
  return(s7_make_boolean(sc, gtk_cell_renderer_get_sensitive((GtkCellRenderer*)s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_get_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_get_activatable "gboolean gtk_cell_renderer_toggle_get_activatable(GtkCellRendererToggle* toggle)"
  s7_pointer toggle;
  toggle = s7_car(args);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_get_activatable", 1, toggle, "GtkCellRendererToggle*");
  return(s7_make_boolean(sc, gtk_cell_renderer_toggle_get_activatable((GtkCellRendererToggle*)s7_c_pointer(toggle))));
}

static s7_pointer lg_gtk_cell_renderer_toggle_set_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_toggle_set_activatable "void gtk_cell_renderer_toggle_set_activatable(GtkCellRendererToggle* toggle, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer toggle, setting;
  _p = args;
  toggle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toggle, GtkCellRendererToggle__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_activatable", 1, toggle, "GtkCellRendererToggle*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_toggle_set_activatable", 2, setting, "gboolean");
  gtk_cell_renderer_toggle_set_activatable((GtkCellRendererToggle*)s7_c_pointer(toggle), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_can_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_can_focus "void gtk_widget_set_can_focus(GtkWidget* widget, gboolean can_focus)"
  s7_pointer _p;
  s7_pointer widget, can_focus;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_focus", 1, widget, "GtkWidget*");
  can_focus = s7_car(_p);
  if (!s7_is_boolean(can_focus)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_focus", 2, can_focus, "gboolean");
  gtk_widget_set_can_focus((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(can_focus));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_can_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_can_focus "gboolean gtk_widget_get_can_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_can_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_can_focus((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_has_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_focus "gboolean gtk_widget_has_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_focus((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_has_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_default "gboolean gtk_widget_has_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_default", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_default((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_sensitive "gboolean gtk_widget_get_sensitive(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_sensitive", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_sensitive((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_is_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_sensitive "gboolean gtk_widget_is_sensitive(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_sensitive", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_sensitive((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_icon_view_set_item_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_item_padding "void gtk_icon_view_set_item_padding(GtkIconView* icon_view, \
gint item_padding)"
  s7_pointer _p;
  s7_pointer icon_view, item_padding;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_padding", 1, icon_view, "GtkIconView*");
  item_padding = s7_car(_p);
  if (!s7_is_integer(item_padding)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_padding", 2, item_padding, "gint");
  gtk_icon_view_set_item_padding((GtkIconView*)s7_c_pointer(icon_view), (gint)s7_integer(item_padding));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_padding "gint gtk_icon_view_get_item_padding(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_padding", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_padding((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_widget_has_grab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_grab "gboolean gtk_widget_has_grab(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_grab", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_grab((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_visible "void gtk_widget_set_visible(GtkWidget* widget, gboolean visible)"
  s7_pointer _p;
  s7_pointer widget, visible;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_visible", 1, widget, "GtkWidget*");
  visible = s7_car(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_widget_set_visible", 2, visible, "gboolean");
  gtk_widget_set_visible((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_visible "gboolean gtk_widget_get_visible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_visible", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_visible((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_range_set_flippable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_flippable "void gtk_range_set_flippable(GtkRange* range, gboolean flippable)"
  s7_pointer _p;
  s7_pointer range, flippable;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_flippable", 1, range, "GtkRange*");
  flippable = s7_car(_p);
  if (!s7_is_boolean(flippable)) s7_wrong_type_arg_error(sc, "gtk_range_set_flippable", 2, flippable, "gboolean");
  gtk_range_set_flippable((GtkRange*)s7_c_pointer(range), (gboolean)lg_boolean(flippable));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_flippable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_flippable "gboolean gtk_range_get_flippable(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_flippable", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_flippable((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_widget_is_drawable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_drawable "gboolean gtk_widget_is_drawable(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_drawable", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_drawable((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_receives_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_receives_default "void gtk_widget_set_receives_default(GtkWidget* widget, \
gboolean receives_default)"
  s7_pointer _p;
  s7_pointer widget, receives_default;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_receives_default", 1, widget, "GtkWidget*");
  receives_default = s7_car(_p);
  if (!s7_is_boolean(receives_default)) s7_wrong_type_arg_error(sc, "gtk_widget_set_receives_default", 2, receives_default, "gboolean");
  gtk_widget_set_receives_default((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(receives_default));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_receives_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_receives_default "gboolean gtk_widget_get_receives_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_receives_default", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_receives_default((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_dialog_get_widget_for_response(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_dialog_get_widget_for_response "GtkWidget* gtk_dialog_get_widget_for_response(GtkDialog* dialog, \
gint response_id)"
  s7_pointer _p;
  s7_pointer dialog, response_id;
  _p = args;
  dialog = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dialog, GtkDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_widget_for_response", 1, dialog, "GtkDialog*");
  response_id = s7_car(_p);
  if (!s7_is_integer(response_id)) s7_wrong_type_arg_error(sc, "gtk_dialog_get_widget_for_response", 2, response_id, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_dialog_get_widget_for_response((GtkDialog*)s7_c_pointer(dialog), (gint)s7_integer(response_id))));
}

static s7_pointer lg_gtk_spinner_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_new "GtkWidget* gtk_spinner_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_spinner_new()));
}

static s7_pointer lg_gtk_spinner_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_start "void gtk_spinner_start(GtkSpinner* spinner)"
  s7_pointer spinner;
  spinner = s7_car(args);
  if (!s7_is_c_pointer_of_type(spinner, GtkSpinner__sym)) s7_wrong_type_arg_error(sc, "gtk_spinner_start", 1, spinner, "GtkSpinner*");
  gtk_spinner_start((GtkSpinner*)s7_c_pointer(spinner));
  return(lg_false);
}

static s7_pointer lg_gtk_spinner_stop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_stop "void gtk_spinner_stop(GtkSpinner* spinner)"
  s7_pointer spinner;
  spinner = s7_car(args);
  if (!s7_is_c_pointer_of_type(spinner, GtkSpinner__sym)) s7_wrong_type_arg_error(sc, "gtk_spinner_stop", 1, spinner, "GtkSpinner*");
  gtk_spinner_stop((GtkSpinner*)s7_c_pointer(spinner));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_spinner_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_spinner_new "GtkCellRenderer* gtk_cell_renderer_spinner_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCellRenderer__sym, gtk_cell_renderer_spinner_new()));
}

static s7_pointer lg_gtk_notebook_get_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_action_widget "GtkWidget* gtk_notebook_get_action_widget(GtkNotebook* notebook, \
GtkPackType pack_type)"
  s7_pointer _p;
  s7_pointer notebook, pack_type;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_action_widget", 1, notebook, "GtkNotebook*");
  pack_type = s7_car(_p);
  if (!s7_is_integer(pack_type)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_action_widget", 2, pack_type, "GtkPackType");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_notebook_get_action_widget((GtkNotebook*)s7_c_pointer(notebook), (GtkPackType)s7_integer(pack_type))));
}

static s7_pointer lg_gtk_notebook_set_action_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_action_widget "void gtk_notebook_set_action_widget(GtkNotebook* notebook, \
GtkWidget* widget, GtkPackType pack_type)"
  s7_pointer _p;
  s7_pointer notebook, widget, pack_type;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_action_widget", 1, notebook, "GtkNotebook*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_action_widget", 2, widget, "GtkWidget*");
  pack_type = s7_car(_p);
  if (!s7_is_integer(pack_type)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_action_widget", 3, pack_type, "GtkPackType");
  gtk_notebook_set_action_widget((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(widget), (GtkPackType)s7_integer(pack_type));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_mnemonics_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_mnemonics_visible "void gtk_window_set_mnemonics_visible(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_mnemonics_visible", 1, window, "GtkWindow*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_mnemonics_visible", 2, setting, "gboolean");
  gtk_window_set_mnemonics_visible((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_mnemonics_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_mnemonics_visible "gboolean gtk_window_get_mnemonics_visible(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_mnemonics_visible", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_mnemonics_visible((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_range_set_slider_size_fixed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_set_slider_size_fixed "void gtk_range_set_slider_size_fixed(GtkRange* range, gboolean size_fixed)"
  s7_pointer _p;
  s7_pointer range, size_fixed;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_set_slider_size_fixed", 1, range, "GtkRange*");
  size_fixed = s7_car(_p);
  if (!s7_is_boolean(size_fixed)) s7_wrong_type_arg_error(sc, "gtk_range_set_slider_size_fixed", 2, size_fixed, "gboolean");
  gtk_range_set_slider_size_fixed((GtkRange*)s7_c_pointer(range), (gboolean)lg_boolean(size_fixed));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_slider_size_fixed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_slider_size_fixed "gboolean gtk_range_get_slider_size_fixed(GtkRange* range)"
  s7_pointer range;
  range = s7_car(args);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_slider_size_fixed", 1, range, "GtkRange*");
  return(s7_make_boolean(sc, gtk_range_get_slider_size_fixed((GtkRange*)s7_c_pointer(range))));
}

static s7_pointer lg_gtk_range_get_range_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_range_rect "void gtk_range_get_range_rect(GtkRange* range, GdkRectangle* range_rect)"
  s7_pointer _p;
  s7_pointer range, range_rect;
  _p = args;
  range = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_range_rect", 1, range, "GtkRange*");
  range_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(range_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_range_rect", 2, range_rect, "GdkRectangle*");
  gtk_range_get_range_rect((GtkRange*)s7_c_pointer(range), (GdkRectangle*)s7_c_pointer(range_rect));
  return(lg_false);
}

static s7_pointer lg_gtk_range_get_slider_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_range_get_slider_range "void gtk_range_get_slider_range(GtkRange* range, gint* [slider_start], \
gint* [slider_end])"
  s7_pointer _p;
  s7_pointer range;
  gint ref_slider_start;
  gint ref_slider_end;
  _p = args;
  range = s7_car(_p);
  if (!s7_is_c_pointer_of_type(range, GtkRange__sym)) s7_wrong_type_arg_error(sc, "gtk_range_get_slider_range", 1, range, "GtkRange*");
  gtk_range_get_slider_range((GtkRange*)s7_c_pointer(range), &ref_slider_start, &ref_slider_end);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_slider_start), s7_make_integer(sc, ref_slider_end)));
}

static s7_pointer lg_gtk_widget_get_realized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_realized "gboolean gtk_widget_get_realized(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_realized", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_realized((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_mapped(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_mapped "gboolean gtk_widget_get_mapped(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_mapped", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_mapped((GtkWidget*)s7_c_pointer(widget))));
}

#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_gdk_keymap_add_virtual_modifiers(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_keymap_add_virtual_modifiers "void gdk_keymap_add_virtual_modifiers(GdkKeymap* keymap, \
GdkModifierType* state)"
  s7_pointer _p;
  s7_pointer keymap, state;
  _p = args;
  keymap = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keymap, GdkKeymap__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_add_virtual_modifiers", 1, keymap, "GdkKeymap*");
  state = s7_car(_p);
  if (!s7_is_c_pointer_of_type(state, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gdk_keymap_add_virtual_modifiers", 2, state, "GdkModifierType*");
  gdk_keymap_add_virtual_modifiers((GdkKeymap*)s7_c_pointer(keymap), (GdkModifierType*)s7_c_pointer(state));
  return(lg_false);
}

static s7_pointer lg_gtk_accessible_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accessible_get_widget "GtkWidget* gtk_accessible_get_widget(GtkAccessible* accessible)"
  s7_pointer accessible;
  accessible = s7_car(args);
  if (!s7_is_c_pointer_of_type(accessible, GtkAccessible__sym)) s7_wrong_type_arg_error(sc, "gtk_accessible_get_widget", 1, accessible, "GtkAccessible*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_accessible_get_widget((GtkAccessible*)s7_c_pointer(accessible))));
}

static s7_pointer lg_gdk_event_set_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_device "void gdk_event_set_device(GdkEvent* event, GdkDevice* device)"
  s7_pointer _p;
  s7_pointer event, device;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device", 1, event, "GdkEvent*");
  device = s7_car(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device", 2, device, "GdkDevice*");
  gdk_event_set_device((GdkEvent*)s7_c_pointer(event), (GdkDevice*)s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_device "GdkDevice* gdk_event_get_device(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_device", 1, event, "GdkEvent*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gdk_event_get_device((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_events_get_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_get_distance "gboolean gdk_events_get_distance(GdkEvent* event1, GdkEvent* event2, \
gdouble* [distance])"
  s7_pointer _p;
  s7_pointer event1, event2;
  gdouble ref_distance;
  _p = args;
  event1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event1, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_distance", 1, event1, "GdkEvent*");
  event2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event2, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_distance", 2, event2, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_events_get_distance((GdkEvent*)s7_c_pointer(event1), (GdkEvent*)s7_c_pointer(event2), &ref_distance));
      return(s7_list(sc, 2, res_ult, s7_make_real(sc, ref_distance)));
   }
}

static s7_pointer lg_gdk_events_get_angle(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_get_angle "gboolean gdk_events_get_angle(GdkEvent* event1, GdkEvent* event2, gdouble* [angle])"
  s7_pointer _p;
  s7_pointer event1, event2;
  gdouble ref_angle;
  _p = args;
  event1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event1, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_angle", 1, event1, "GdkEvent*");
  event2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event2, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_angle", 2, event2, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_events_get_angle((GdkEvent*)s7_c_pointer(event1), (GdkEvent*)s7_c_pointer(event2), &ref_angle));
      return(s7_list(sc, 2, res_ult, s7_make_real(sc, ref_angle)));
   }
}

static s7_pointer lg_gdk_events_get_center(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_events_get_center "gboolean gdk_events_get_center(GdkEvent* event1, GdkEvent* event2, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer event1, event2;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  event1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event1, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_center", 1, event1, "GdkEvent*");
  event2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event2, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_events_get_center", 2, event2, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_events_get_center((GdkEvent*)s7_c_pointer(event1), (GdkEvent*)s7_c_pointer(event2), &ref_x, &ref_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_combo_box_popup_for_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_popup_for_device "void gtk_combo_box_popup_for_device(GtkComboBox* combo_box, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer combo_box, device;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popup_for_device", 1, combo_box, "GtkComboBox*");
  device = s7_car(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_popup_for_device", 2, device, "GdkDevice*");
  gtk_combo_box_popup_for_device((GtkComboBox*)s7_c_pointer(combo_box), (GdkDevice*)s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_new "GtkWidget* gtk_paned_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_paned_new", 1, orientation, "GtkOrientation");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_paned_new((GtkOrientation)s7_integer(orientation))));
}

static s7_pointer lg_gtk_scale_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_new "GtkWidget* gtk_scale_new(GtkOrientation orientation, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer orientation, adjustment;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_scale_new", 1, orientation, "GtkOrientation");
  adjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_new", 2, adjustment, "GtkAdjustment*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scale_new((GtkOrientation)s7_integer(orientation), (GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_scale_new_with_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_new_with_range "GtkWidget* gtk_scale_new_with_range(GtkOrientation orientation, \
gdouble min, gdouble max, gdouble step)"
  s7_pointer _p;
  s7_pointer orientation, min, max, step;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 1, orientation, "GtkOrientation");
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 2, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 3, max, "gdouble");
  step = s7_car(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_scale_new_with_range", 4, step, "gdouble");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scale_new_with_range((GtkOrientation)s7_integer(orientation), (gdouble)s7_real(min), (gdouble)s7_real(max), (gdouble)s7_real(step))));
}

static s7_pointer lg_gtk_scrollbar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_new "GtkWidget* gtk_scrollbar_new(GtkOrientation orientation, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer orientation, adjustment;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_new", 1, orientation, "GtkOrientation");
  adjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_new", 2, adjustment, "GtkAdjustment*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scrollbar_new((GtkOrientation)s7_integer(orientation), (GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_separator_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_separator_new "GtkWidget* gtk_separator_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_separator_new", 1, orientation, "GtkOrientation");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_separator_new((GtkOrientation)s7_integer(orientation))));
}

static s7_pointer lg_gtk_widget_device_is_shadowed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_device_is_shadowed "gboolean gtk_widget_device_is_shadowed(GtkWidget* widget, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer widget, device;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_device_is_shadowed", 1, widget, "GtkWidget*");
  device = s7_car(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_device_is_shadowed", 2, device, "GdkDevice*");
  return(s7_make_boolean(sc, gtk_widget_device_is_shadowed((GtkWidget*)s7_c_pointer(widget), (GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gtk_widget_get_support_multidevice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_support_multidevice "gboolean gtk_widget_get_support_multidevice(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_support_multidevice", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_support_multidevice((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_support_multidevice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_support_multidevice "void gtk_widget_set_support_multidevice(GtkWidget* widget, \
gboolean support_multidevice)"
  s7_pointer _p;
  s7_pointer widget, support_multidevice;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_support_multidevice", 1, widget, "GtkWidget*");
  support_multidevice = s7_car(_p);
  if (!s7_is_boolean(support_multidevice)) s7_wrong_type_arg_error(sc, "gtk_widget_set_support_multidevice", 2, support_multidevice, "gboolean");
  gtk_widget_set_support_multidevice((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(support_multidevice));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_row "gint gtk_icon_view_get_item_row(GtkIconView* icon_view, GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_row", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_row", 2, path, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_row((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_icon_view_get_item_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_column "gint gtk_icon_view_get_item_column(GtkIconView* icon_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_column", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_column", 2, path, "GtkTreePath*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_column((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_statusbar_remove_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_statusbar_remove_all "void gtk_statusbar_remove_all(GtkStatusbar* statusbar, guint context_id)"
  s7_pointer _p;
  s7_pointer statusbar, context_id;
  _p = args;
  statusbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(statusbar, GtkStatusbar__sym)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove_all", 1, statusbar, "GtkStatusbar*");
  context_id = s7_car(_p);
  if (!s7_is_integer(context_id)) s7_wrong_type_arg_error(sc, "gtk_statusbar_remove_all", 2, context_id, "guint");
  gtk_statusbar_remove_all((GtkStatusbar*)s7_c_pointer(statusbar), (guint)s7_integer(context_id));
  return(lg_false);
}

static s7_pointer lg_gtk_window_has_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_has_group "gboolean gtk_window_has_group(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_has_group", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_has_group((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_calendar_select_month(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_select_month "void gtk_calendar_select_month(GtkCalendar* calendar, guint month, \
guint year)"
  s7_pointer _p;
  s7_pointer calendar, month, year;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_month", 1, calendar, "GtkCalendar*");
  month = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(month)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_month", 2, month, "guint");
  year = s7_car(_p);
  if (!s7_is_integer(year)) s7_wrong_type_arg_error(sc, "gtk_calendar_select_month", 3, year, "guint");
  gtk_calendar_select_month((GtkCalendar*)s7_c_pointer(calendar), (guint)s7_integer(month), (guint)s7_integer(year));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_mark_day(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_mark_day "void gtk_calendar_mark_day(GtkCalendar* calendar, guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_mark_day", 1, calendar, "GtkCalendar*");
  day = s7_car(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_mark_day", 2, day, "guint");
  gtk_calendar_mark_day((GtkCalendar*)s7_c_pointer(calendar), (guint)s7_integer(day));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_unmark_day(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_unmark_day "void gtk_calendar_unmark_day(GtkCalendar* calendar, guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_unmark_day", 1, calendar, "GtkCalendar*");
  day = s7_car(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_unmark_day", 2, day, "guint");
  gtk_calendar_unmark_day((GtkCalendar*)s7_c_pointer(calendar), (guint)s7_integer(day));
  return(lg_false);
}

static s7_pointer lg_gtk_accessible_set_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accessible_set_widget "void gtk_accessible_set_widget(GtkAccessible* accessible, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer accessible, widget;
  _p = args;
  accessible = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accessible, GtkAccessible__sym)) s7_wrong_type_arg_error(sc, "gtk_accessible_set_widget", 1, accessible, "GtkAccessible*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_accessible_set_widget", 2, widget, "GtkWidget*");
  gtk_accessible_set_widget((GtkAccessible*)s7_c_pointer(accessible), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_message_dialog_get_message_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_message_dialog_get_message_area "GtkWidget* gtk_message_dialog_get_message_area(GtkMessageDialog* message_dialog)"
  s7_pointer message_dialog;
  message_dialog = s7_car(args);
  if (!s7_is_c_pointer_of_type(message_dialog, GtkMessageDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_message_dialog_get_message_area", 1, message_dialog, "GtkMessageDialog*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_message_dialog_get_message_area((GtkMessageDialog*)s7_c_pointer(message_dialog))));
}

static s7_pointer lg_gdk_pango_layout_line_get_clip_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pango_layout_line_get_clip_region "cairo_region_t* gdk_pango_layout_line_get_clip_region(PangoLayoutLine* line, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  s7_pointer _p;
  s7_pointer line, x_origin, y_origin, index_ranges, n_ranges;
  _p = args;
  line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(line, PangoLayoutLine__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 1, line, "PangoLayoutLine*");
  x_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 2, x_origin, "gint");
  y_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 3, y_origin, "gint");
  index_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(index_ranges, gint__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 4, index_ranges, "gint*");
  n_ranges = s7_car(_p);
  if (!s7_is_integer(n_ranges)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_line_get_clip_region", 5, n_ranges, "gint");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, gdk_pango_layout_line_get_clip_region((PangoLayoutLine*)s7_c_pointer(line), (gint)s7_integer(x_origin), (gint)s7_integer(y_origin), (gint*)s7_c_pointer(index_ranges), (gint)s7_integer(n_ranges))));
}

static s7_pointer lg_gdk_pango_layout_get_clip_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pango_layout_get_clip_region "cairo_region_t* gdk_pango_layout_get_clip_region(PangoLayout* layout, \
gint x_origin, gint y_origin, gint* index_ranges, gint n_ranges)"
  s7_pointer _p;
  s7_pointer layout, x_origin, y_origin, index_ranges, n_ranges;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 1, layout, "PangoLayout*");
  x_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 2, x_origin, "gint");
  y_origin = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y_origin)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 3, y_origin, "gint");
  index_ranges = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(index_ranges, gint__sym)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 4, index_ranges, "gint*");
  n_ranges = s7_car(_p);
  if (!s7_is_integer(n_ranges)) s7_wrong_type_arg_error(sc, "gdk_pango_layout_get_clip_region", 5, n_ranges, "gint");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, gdk_pango_layout_get_clip_region((PangoLayout*)s7_c_pointer(layout), (gint)s7_integer(x_origin), (gint)s7_integer(y_origin), (gint*)s7_c_pointer(index_ranges), (gint)s7_integer(n_ranges))));
}

static s7_pointer lg_gdk_display_is_closed(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_is_closed "gboolean gdk_display_is_closed(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_is_closed", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_is_closed((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_calendar_get_day_is_marked(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_day_is_marked "gboolean gtk_calendar_get_day_is_marked(GtkCalendar* calendar, \
guint day)"
  s7_pointer _p;
  s7_pointer calendar, day;
  _p = args;
  calendar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(calendar, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_day_is_marked", 1, calendar, "GtkCalendar*");
  day = s7_car(_p);
  if (!s7_is_integer(day)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_day_is_marked", 2, day, "guint");
  return(s7_make_boolean(sc, gtk_calendar_get_day_is_marked((GtkCalendar*)s7_c_pointer(calendar), (guint)s7_integer(day))));
}

static s7_pointer lg_gtk_progress_bar_set_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_inverted "void gtk_progress_bar_set_inverted(GtkProgressBar* pbar, gboolean inverted)"
  s7_pointer _p;
  s7_pointer pbar, inverted;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_inverted", 1, pbar, "GtkProgressBar*");
  inverted = s7_car(_p);
  if (!s7_is_boolean(inverted)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_inverted", 2, inverted, "gboolean");
  gtk_progress_bar_set_inverted((GtkProgressBar*)s7_c_pointer(pbar), (gboolean)lg_boolean(inverted));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_inverted "gboolean gtk_progress_bar_get_inverted(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_inverted", 1, pbar, "GtkProgressBar*");
  return(s7_make_boolean(sc, gtk_progress_bar_get_inverted((GtkProgressBar*)s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_radio_button_join_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_radio_button_join_group "void gtk_radio_button_join_group(GtkRadioButton* radio_button, \
GtkRadioButton* group_source)"
  s7_pointer _p;
  s7_pointer radio_button, group_source;
  _p = args;
  radio_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(radio_button, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_join_group", 1, radio_button, "GtkRadioButton*");
  group_source = s7_car(_p);
  if (!s7_is_c_pointer_of_type(group_source, GtkRadioButton__sym)) s7_wrong_type_arg_error(sc, "gtk_radio_button_join_group", 2, group_source, "GtkRadioButton*");
  gtk_radio_button_join_group((GtkRadioButton*)s7_c_pointer(radio_button), (GtkRadioButton*)s7_c_pointer(group_source));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_new "GtkAdjustment* gtk_adjustment_new(gdouble value, gdouble lower, gdouble upper, \
gdouble step_increment, gdouble page_increment, gdouble page_size)"
  s7_pointer _p;
  s7_pointer value, lower, upper, step_increment, page_increment, page_size;
  _p = args;
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 1, value, "gdouble");
  lower = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(lower)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 2, lower, "gdouble");
  upper = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(upper)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 3, upper, "gdouble");
  step_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 4, step_increment, "gdouble");
  page_increment = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(page_increment)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 5, page_increment, "gdouble");
  page_size = s7_car(_p);
  if (!s7_is_real(page_size)) s7_wrong_type_arg_error(sc, "gtk_adjustment_new", 6, page_size, "gdouble");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_adjustment_new((gdouble)s7_real(value), (gdouble)s7_real(lower), (gdouble)s7_real(upper), (gdouble)s7_real(step_increment), (gdouble)s7_real(page_increment), (gdouble)s7_real(page_size))));
}

static s7_pointer lg_gtk_icon_view_create_drag_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_create_drag_icon "cairo_surface_t* gtk_icon_view_create_drag_icon(GtkIconView* icon_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer icon_view, path;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_create_drag_icon", 1, icon_view, "GtkIconView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_create_drag_icon", 2, path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, gtk_icon_view_create_drag_icon((GtkIconView*)s7_c_pointer(icon_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gtk_tree_view_create_row_drag_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_create_row_drag_icon "cairo_surface_t* gtk_tree_view_create_row_drag_icon(GtkTreeView* tree_view, \
GtkTreePath* path)"
  s7_pointer _p;
  s7_pointer tree_view, path;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_create_row_drag_icon", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_create_row_drag_icon", 2, path, "GtkTreePath*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, gtk_tree_view_create_row_drag_icon((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path))));
}

static s7_pointer lg_gdk_cairo_region_create_from_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_region_create_from_surface "cairo_region_t* gdk_cairo_region_create_from_surface(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_region_create_from_surface", 1, surface, "cairo_surface_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, gdk_cairo_region_create_from_surface((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_gtk_cell_renderer_get_request_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_request_mode "GtkSizeRequestMode gtk_cell_renderer_get_request_mode(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_request_mode", 1, cell, "GtkCellRenderer*");
  return(s7_make_integer(sc, gtk_cell_renderer_get_request_mode((GtkCellRenderer*)s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_width "void gtk_cell_renderer_get_preferred_width(GtkCellRenderer* cell, \
GtkWidget* widget, gint* [minimum_size], gint* [natural_size])"
  s7_pointer _p;
  s7_pointer cell, widget;
  gint ref_minimum_size;
  gint ref_natural_size;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width", 2, widget, "GtkWidget*");
  gtk_cell_renderer_get_preferred_width((GtkCellRenderer*)s7_c_pointer(cell), (GtkWidget*)s7_c_pointer(widget), &ref_minimum_size, &ref_natural_size);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_size), s7_make_integer(sc, ref_natural_size)));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_height_for_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_height_for_width "void gtk_cell_renderer_get_preferred_height_for_width(GtkCellRenderer* cell, \
GtkWidget* widget, gint width, gint* [minimum_height], gint* [natural_height])"
  s7_pointer _p;
  s7_pointer cell, widget, width;
  gint ref_minimum_height;
  gint ref_natural_height;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height_for_width", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height_for_width", 2, widget, "GtkWidget*");
  width = s7_car(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height_for_width", 3, width, "gint");
  gtk_cell_renderer_get_preferred_height_for_width((GtkCellRenderer*)s7_c_pointer(cell), (GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(width), &ref_minimum_height, &ref_natural_height);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_height), s7_make_integer(sc, ref_natural_height)));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_height "void gtk_cell_renderer_get_preferred_height(GtkCellRenderer* cell, \
GtkWidget* widget, gint* [minimum_size], gint* [natural_size])"
  s7_pointer _p;
  s7_pointer cell, widget;
  gint ref_minimum_size;
  gint ref_natural_size;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_height", 2, widget, "GtkWidget*");
  gtk_cell_renderer_get_preferred_height((GtkCellRenderer*)s7_c_pointer(cell), (GtkWidget*)s7_c_pointer(widget), &ref_minimum_size, &ref_natural_size);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_size), s7_make_integer(sc, ref_natural_size)));
}

static s7_pointer lg_gtk_cell_renderer_get_preferred_width_for_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_preferred_width_for_height "void gtk_cell_renderer_get_preferred_width_for_height(GtkCellRenderer* cell, \
GtkWidget* widget, gint height, gint* [minimum_width], gint* [natural_width])"
  s7_pointer _p;
  s7_pointer cell, widget, height;
  gint ref_minimum_width;
  gint ref_natural_width;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width_for_height", 1, cell, "GtkCellRenderer*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width_for_height", 2, widget, "GtkWidget*");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_preferred_width_for_height", 3, height, "gint");
  gtk_cell_renderer_get_preferred_width_for_height((GtkCellRenderer*)s7_c_pointer(cell), (GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(height), &ref_minimum_width, &ref_natural_width);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_minimum_width), s7_make_integer(sc, ref_natural_width)));
}

static s7_pointer lg_gtk_notebook_set_group_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_set_group_name "void gtk_notebook_set_group_name(GtkNotebook* notebook, gchar* group_name)"
  s7_pointer _p;
  s7_pointer notebook, group_name;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_group_name", 1, notebook, "GtkNotebook*");
  group_name = s7_car(_p);
  if (!s7_is_string(group_name)) s7_wrong_type_arg_error(sc, "gtk_notebook_set_group_name", 2, group_name, "gchar*");
  gtk_notebook_set_group_name((GtkNotebook*)s7_c_pointer(notebook), (const gchar*)s7_string(group_name));
  return(lg_false);
}

static s7_pointer lg_gtk_notebook_get_group_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_group_name "gchar* gtk_notebook_get_group_name(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_group_name", 1, notebook, "GtkNotebook*");
    return(s7_make_string(sc, (gchar*)gtk_notebook_get_group_name((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_widget_get_request_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_request_mode "GtkSizeRequestMode gtk_widget_get_request_mode(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_request_mode", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_request_mode((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_allocated_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_allocated_width "int gtk_widget_get_allocated_width(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_allocated_width", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_allocated_width((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_allocated_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_allocated_height "int gtk_widget_get_allocated_height(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_allocated_height", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_allocated_height((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_halign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_halign "GtkAlign gtk_widget_get_halign(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_halign", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_halign((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_halign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_halign "void gtk_widget_set_halign(GtkWidget* widget, GtkAlign align)"
  s7_pointer _p;
  s7_pointer widget, align;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_halign", 1, widget, "GtkWidget*");
  align = s7_car(_p);
  if (!s7_is_integer(align)) s7_wrong_type_arg_error(sc, "gtk_widget_set_halign", 2, align, "GtkAlign");
  gtk_widget_set_halign((GtkWidget*)s7_c_pointer(widget), (GtkAlign)s7_integer(align));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_valign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_valign "GtkAlign gtk_widget_get_valign(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_valign", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_valign((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_valign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_valign "void gtk_widget_set_valign(GtkWidget* widget, GtkAlign align)"
  s7_pointer _p;
  s7_pointer widget, align;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_valign", 1, widget, "GtkWidget*");
  align = s7_car(_p);
  if (!s7_is_integer(align)) s7_wrong_type_arg_error(sc, "gtk_widget_set_valign", 2, align, "GtkAlign");
  gtk_widget_set_valign((GtkWidget*)s7_c_pointer(widget), (GtkAlign)s7_integer(align));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_margin_top(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_top "gint gtk_widget_get_margin_top(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_top", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_top((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_top(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_top "void gtk_widget_set_margin_top(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_top", 1, widget, "GtkWidget*");
  margin = s7_car(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_top", 2, margin, "gint");
  gtk_widget_set_margin_top((GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_margin_bottom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_bottom "gint gtk_widget_get_margin_bottom(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_bottom", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_bottom((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_bottom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_bottom "void gtk_widget_set_margin_bottom(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_bottom", 1, widget, "GtkWidget*");
  margin = s7_car(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_bottom", 2, margin, "gint");
  gtk_widget_set_margin_bottom((GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_new_with_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new_with_entry "GtkWidget* gtk_combo_box_new_with_entry( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_combo_box_new_with_entry()));
}

static s7_pointer lg_gtk_combo_box_get_has_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_has_entry "gboolean gtk_combo_box_get_has_entry(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_has_entry", 1, combo_box, "GtkComboBox*");
  return(s7_make_boolean(sc, gtk_combo_box_get_has_entry((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_set_entry_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_entry_text_column "void gtk_combo_box_set_entry_text_column(GtkComboBox* combo_box, \
gint text_column)"
  s7_pointer _p;
  s7_pointer combo_box, text_column;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_entry_text_column", 1, combo_box, "GtkComboBox*");
  text_column = s7_car(_p);
  if (!s7_is_integer(text_column)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_entry_text_column", 2, text_column, "gint");
  gtk_combo_box_set_entry_text_column((GtkComboBox*)s7_c_pointer(combo_box), (gint)s7_integer(text_column));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_entry_text_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_entry_text_column "gint gtk_combo_box_get_entry_text_column(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_entry_text_column", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_entry_text_column((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_widget_get_hexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_hexpand "gboolean gtk_widget_get_hexpand(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_hexpand", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_hexpand((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_hexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_hexpand "void gtk_widget_set_hexpand(GtkWidget* widget, gboolean expand)"
  s7_pointer _p;
  s7_pointer widget, expand;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand", 1, widget, "GtkWidget*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand", 2, expand, "gboolean");
  gtk_widget_set_hexpand((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_hexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_hexpand_set "gboolean gtk_widget_get_hexpand_set(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_hexpand_set", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_hexpand_set((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_hexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_hexpand_set "void gtk_widget_set_hexpand_set(GtkWidget* widget, gboolean set)"
  s7_pointer _p;
  s7_pointer widget, set;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand_set", 1, widget, "GtkWidget*");
  set = s7_car(_p);
  if (!s7_is_boolean(set)) s7_wrong_type_arg_error(sc, "gtk_widget_set_hexpand_set", 2, set, "gboolean");
  gtk_widget_set_hexpand_set((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(set));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_vexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_vexpand "gboolean gtk_widget_get_vexpand(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_vexpand", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_vexpand((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_vexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_vexpand "void gtk_widget_set_vexpand(GtkWidget* widget, gboolean expand)"
  s7_pointer _p;
  s7_pointer widget, expand;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand", 1, widget, "GtkWidget*");
  expand = s7_car(_p);
  if (!s7_is_boolean(expand)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand", 2, expand, "gboolean");
  gtk_widget_set_vexpand((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(expand));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_vexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_vexpand_set "gboolean gtk_widget_get_vexpand_set(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_vexpand_set", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_vexpand_set((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_vexpand_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_vexpand_set "void gtk_widget_set_vexpand_set(GtkWidget* widget, gboolean set)"
  s7_pointer _p;
  s7_pointer widget, set;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand_set", 1, widget, "GtkWidget*");
  set = s7_car(_p);
  if (!s7_is_boolean(set)) s7_wrong_type_arg_error(sc, "gtk_widget_set_vexpand_set", 2, set, "gboolean");
  gtk_widget_set_vexpand_set((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(set));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_compute_expand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_compute_expand "gboolean gtk_widget_compute_expand(GtkWidget* widget, GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer widget, orientation;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_expand", 1, widget, "GtkWidget*");
  orientation = s7_car(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_expand", 2, orientation, "GtkOrientation");
  return(s7_make_boolean(sc, gtk_widget_compute_expand((GtkWidget*)s7_c_pointer(widget), (GtkOrientation)s7_integer(orientation))));
}

static s7_pointer lg_gtk_combo_box_text_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_new "GtkWidget* gtk_combo_box_text_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_combo_box_text_new()));
}

static s7_pointer lg_gtk_combo_box_text_new_with_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_new_with_entry "GtkWidget* gtk_combo_box_text_new_with_entry( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_combo_box_text_new_with_entry()));
}

static s7_pointer lg_gtk_combo_box_text_append_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_append_text "void gtk_combo_box_text_append_text(GtkComboBoxText* combo_box, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append_text", 1, combo_box, "GtkComboBoxText*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append_text", 2, text, "gchar*");
  gtk_combo_box_text_append_text((GtkComboBoxText*)s7_c_pointer(combo_box), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_insert_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_insert_text "void gtk_combo_box_text_insert_text(GtkComboBoxText* combo_box, \
gint position, gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, position, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert_text", 1, combo_box, "GtkComboBoxText*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert_text", 2, position, "gint");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert_text", 3, text, "gchar*");
  gtk_combo_box_text_insert_text((GtkComboBoxText*)s7_c_pointer(combo_box), (gint)s7_integer(position), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_prepend_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_prepend_text "void gtk_combo_box_text_prepend_text(GtkComboBoxText* combo_box, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend_text", 1, combo_box, "GtkComboBoxText*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend_text", 2, text, "gchar*");
  gtk_combo_box_text_prepend_text((GtkComboBoxText*)s7_c_pointer(combo_box), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_remove "void gtk_combo_box_text_remove(GtkComboBoxText* combo_box, gint position)"
  s7_pointer _p;
  s7_pointer combo_box, position;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_remove", 1, combo_box, "GtkComboBoxText*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_remove", 2, position, "gint");
  gtk_combo_box_text_remove((GtkComboBoxText*)s7_c_pointer(combo_box), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_get_active_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_get_active_text "gchar* gtk_combo_box_text_get_active_text(GtkComboBoxText* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_get_active_text", 1, combo_box, "GtkComboBoxText*");
  return(s7_make_string(sc, gtk_combo_box_text_get_active_text((GtkComboBoxText*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gdk_cairo_set_source_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_set_source_rgba "void gdk_cairo_set_source_rgba(cairo_t* cr, GdkRGBA* rgba)"
  s7_pointer _p;
  s7_pointer cr, rgba;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_rgba", 1, cr, "cairo_t*");
  rgba = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_set_source_rgba", 2, rgba, "GdkRGBA*");
  gdk_cairo_set_source_rgba((cairo_t*)s7_c_pointer(cr), (GdkRGBA*)s7_c_pointer(rgba));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_remove_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_remove_all "void gtk_combo_box_text_remove_all(GtkComboBoxText* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_remove_all", 1, combo_box, "GtkComboBoxText*");
  gtk_combo_box_text_remove_all((GtkComboBoxText*)s7_c_pointer(combo_box));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_set_popup_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_popup_fixed_width "void gtk_combo_box_set_popup_fixed_width(GtkComboBox* combo_box, \
gboolean fixed)"
  s7_pointer _p;
  s7_pointer combo_box, fixed;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_popup_fixed_width", 1, combo_box, "GtkComboBox*");
  fixed = s7_car(_p);
  if (!s7_is_boolean(fixed)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_popup_fixed_width", 2, fixed, "gboolean");
  gtk_combo_box_set_popup_fixed_width((GtkComboBox*)s7_c_pointer(combo_box), (gboolean)lg_boolean(fixed));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_popup_fixed_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_popup_fixed_width "gboolean gtk_combo_box_get_popup_fixed_width(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_popup_fixed_width", 1, combo_box, "GtkComboBox*");
  return(s7_make_boolean(sc, gtk_combo_box_get_popup_fixed_width((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_scrolled_window_get_min_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_min_content_width "gint gtk_scrolled_window_get_min_content_width(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_min_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_min_content_width((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_min_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_min_content_width "void gtk_scrolled_window_set_min_content_width(GtkScrolledWindow* scrolled_window, \
gint width)"
  s7_pointer _p;
  s7_pointer scrolled_window, width;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  width = s7_car(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_width", 2, width, "gint");
  gtk_scrolled_window_set_min_content_width((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gint)s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_min_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_min_content_height "gint gtk_scrolled_window_get_min_content_height(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_min_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_min_content_height((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_min_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_min_content_height "void gtk_scrolled_window_set_min_content_height(GtkScrolledWindow* scrolled_window, \
gint height)"
  s7_pointer _p;
  s7_pointer scrolled_window, height;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_min_content_height", 2, height, "gint");
  gtk_scrolled_window_set_min_content_height((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_new "GtkWidget* gtk_grid_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_grid_new()));
}

static s7_pointer lg_gtk_grid_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_attach "void gtk_grid_attach(GtkGrid* grid, GtkWidget* child, gint left, gint top, \
gint width, gint height)"
  s7_pointer _p;
  s7_pointer grid, child, left, top, width, height;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 1, grid, "GtkGrid*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 2, child, "GtkWidget*");
  left = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 3, left, "gint");
  top = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 4, top, "gint");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 5, width, "gint");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_grid_attach", 6, height, "gint");
  gtk_grid_attach((GtkGrid*)s7_c_pointer(grid), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(left), (gint)s7_integer(top), (gint)s7_integer(width), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_attach_next_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_attach_next_to "void gtk_grid_attach_next_to(GtkGrid* grid, GtkWidget* child, GtkWidget* sibling, \
GtkPositionType side, gint width, gint height)"
  s7_pointer _p;
  s7_pointer grid, child, sibling, side, width, height;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 1, grid, "GtkGrid*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 2, child, "GtkWidget*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 3, sibling, "GtkWidget*");
  side = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(side)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 4, side, "GtkPositionType");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 5, width, "gint");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_grid_attach_next_to", 6, height, "gint");
  gtk_grid_attach_next_to((GtkGrid*)s7_c_pointer(grid), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(sibling), (GtkPositionType)s7_integer(side), (gint)s7_integer(width), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_set_row_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_row_homogeneous "void gtk_grid_set_row_homogeneous(GtkGrid* grid, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer grid, homogeneous;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_homogeneous", 1, grid, "GtkGrid*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_homogeneous", 2, homogeneous, "gboolean");
  gtk_grid_set_row_homogeneous((GtkGrid*)s7_c_pointer(grid), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_row_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_row_homogeneous "gboolean gtk_grid_get_row_homogeneous(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_homogeneous", 1, grid, "GtkGrid*");
  return(s7_make_boolean(sc, gtk_grid_get_row_homogeneous((GtkGrid*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_row_spacing "void gtk_grid_set_row_spacing(GtkGrid* grid, guint spacing)"
  s7_pointer _p;
  s7_pointer grid, spacing;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_spacing", 1, grid, "GtkGrid*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_spacing", 2, spacing, "guint");
  gtk_grid_set_row_spacing((GtkGrid*)s7_c_pointer(grid), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_row_spacing "guint gtk_grid_get_row_spacing(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_spacing", 1, grid, "GtkGrid*");
  return(s7_make_integer(sc, gtk_grid_get_row_spacing((GtkGrid*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_set_column_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_column_homogeneous "void gtk_grid_set_column_homogeneous(GtkGrid* grid, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer grid, homogeneous;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_homogeneous", 1, grid, "GtkGrid*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_homogeneous", 2, homogeneous, "gboolean");
  gtk_grid_set_column_homogeneous((GtkGrid*)s7_c_pointer(grid), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_column_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_column_homogeneous "gboolean gtk_grid_get_column_homogeneous(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_column_homogeneous", 1, grid, "GtkGrid*");
  return(s7_make_boolean(sc, gtk_grid_get_column_homogeneous((GtkGrid*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_column_spacing "void gtk_grid_set_column_spacing(GtkGrid* grid, guint spacing)"
  s7_pointer _p;
  s7_pointer grid, spacing;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_spacing", 1, grid, "GtkGrid*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_grid_set_column_spacing", 2, spacing, "guint");
  gtk_grid_set_column_spacing((GtkGrid*)s7_c_pointer(grid), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_column_spacing "guint gtk_grid_get_column_spacing(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_column_spacing", 1, grid, "GtkGrid*");
  return(s7_make_integer(sc, gtk_grid_get_column_spacing((GtkGrid*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_scrollable_get_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_hadjustment "GtkAdjustment* gtk_scrollable_get_hadjustment(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_hadjustment", 1, scrollable, "GtkScrollable*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_scrollable_get_hadjustment((GtkScrollable*)s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_hadjustment "void gtk_scrollable_set_hadjustment(GtkScrollable* scrollable, \
GtkAdjustment* hadjustment)"
  s7_pointer _p;
  s7_pointer scrollable, hadjustment;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hadjustment", 1, scrollable, "GtkScrollable*");
  hadjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(hadjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hadjustment", 2, hadjustment, "GtkAdjustment*");
  gtk_scrollable_set_hadjustment((GtkScrollable*)s7_c_pointer(scrollable), (GtkAdjustment*)s7_c_pointer(hadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollable_get_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_vadjustment "GtkAdjustment* gtk_scrollable_get_vadjustment(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_vadjustment", 1, scrollable, "GtkScrollable*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_scrollable_get_vadjustment((GtkScrollable*)s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_vadjustment "void gtk_scrollable_set_vadjustment(GtkScrollable* scrollable, \
GtkAdjustment* vadjustment)"
  s7_pointer _p;
  s7_pointer scrollable, vadjustment;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vadjustment", 1, scrollable, "GtkScrollable*");
  vadjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(vadjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vadjustment", 2, vadjustment, "GtkAdjustment*");
  gtk_scrollable_set_vadjustment((GtkScrollable*)s7_c_pointer(scrollable), (GtkAdjustment*)s7_c_pointer(vadjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_next_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_next_page "void gtk_assistant_next_page(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_next_page", 1, assistant, "GtkAssistant*");
  gtk_assistant_next_page((GtkAssistant*)s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_assistant_previous_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_previous_page "void gtk_assistant_previous_page(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_previous_page", 1, assistant, "GtkAssistant*");
  gtk_assistant_previous_page((GtkAssistant*)s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_new_with_model_and_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_new_with_model_and_entry "GtkWidget* gtk_combo_box_new_with_model_and_entry(GtkTreeModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_new_with_model_and_entry", 1, model, "GtkTreeModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_combo_box_new_with_model_and_entry((GtkTreeModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_scrollable_get_hscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_hscroll_policy "GtkScrollablePolicy gtk_scrollable_get_hscroll_policy(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_hscroll_policy", 1, scrollable, "GtkScrollable*");
  return(s7_make_integer(sc, gtk_scrollable_get_hscroll_policy((GtkScrollable*)s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_hscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_hscroll_policy "void gtk_scrollable_set_hscroll_policy(GtkScrollable* scrollable, \
GtkScrollablePolicy policy)"
  s7_pointer _p;
  s7_pointer scrollable, policy;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hscroll_policy", 1, scrollable, "GtkScrollable*");
  policy = s7_car(_p);
  if (!s7_is_integer(policy)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_hscroll_policy", 2, policy, "GtkScrollablePolicy");
  gtk_scrollable_set_hscroll_policy((GtkScrollable*)s7_c_pointer(scrollable), (GtkScrollablePolicy)s7_integer(policy));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollable_get_vscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_vscroll_policy "GtkScrollablePolicy gtk_scrollable_get_vscroll_policy(GtkScrollable* scrollable)"
  s7_pointer scrollable;
  scrollable = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_vscroll_policy", 1, scrollable, "GtkScrollable*");
  return(s7_make_integer(sc, gtk_scrollable_get_vscroll_policy((GtkScrollable*)s7_c_pointer(scrollable))));
}

static s7_pointer lg_gtk_scrollable_set_vscroll_policy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_set_vscroll_policy "void gtk_scrollable_set_vscroll_policy(GtkScrollable* scrollable, \
GtkScrollablePolicy policy)"
  s7_pointer _p;
  s7_pointer scrollable, policy;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vscroll_policy", 1, scrollable, "GtkScrollable*");
  policy = s7_car(_p);
  if (!s7_is_integer(policy)) s7_wrong_type_arg_error(sc, "gtk_scrollable_set_vscroll_policy", 2, policy, "GtkScrollablePolicy");
  gtk_scrollable_set_vscroll_policy((GtkScrollable*)s7_c_pointer(scrollable), (GtkScrollablePolicy)s7_integer(policy));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_new "GtkWidget* gtk_switch_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_switch_new()));
}

static s7_pointer lg_gtk_switch_set_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_set_active "void gtk_switch_set_active(GtkSwitch* sw, gboolean is_active)"
  s7_pointer _p;
  s7_pointer sw, is_active;
  _p = args;
  sw = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_set_active", 1, sw, "GtkSwitch*");
  is_active = s7_car(_p);
  if (!s7_is_boolean(is_active)) s7_wrong_type_arg_error(sc, "gtk_switch_set_active", 2, is_active, "gboolean");
  gtk_switch_set_active((GtkSwitch*)s7_c_pointer(sw), (gboolean)lg_boolean(is_active));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_get_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_get_active "gboolean gtk_switch_get_active(GtkSwitch* sw)"
  s7_pointer sw;
  sw = s7_car(args);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_get_active", 1, sw, "GtkSwitch*");
  return(s7_make_boolean(sc, gtk_switch_get_active((GtkSwitch*)s7_c_pointer(sw))));
}

static s7_pointer lg_gtk_border_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_border_new "GtkBorder* gtk_border_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkBorder__sym, gtk_border_new()));
}

static s7_pointer lg_gtk_border_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_border_copy "GtkBorder* gtk_border_copy(GtkBorder* border_)"
  s7_pointer border_;
  border_ = s7_car(args);
  if (!s7_is_c_pointer_of_type(border_, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_border_copy", 1, border_, "GtkBorder*");
  return(lg_make_c_pointer_with_type(sc, GtkBorder__sym, gtk_border_copy((GtkBorder*)s7_c_pointer(border_))));
}

static s7_pointer lg_gtk_border_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_border_free "void gtk_border_free(GtkBorder* border_)"
  s7_pointer border_;
  border_ = s7_car(args);
  if (!s7_is_c_pointer_of_type(border_, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_border_free", 1, border_, "GtkBorder*");
  gtk_border_free((GtkBorder*)s7_c_pointer(border_));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_id_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_id_column "gint gtk_combo_box_get_id_column(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_id_column", 1, combo_box, "GtkComboBox*");
  return(s7_make_integer(sc, gtk_combo_box_get_id_column((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_set_id_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_id_column "void gtk_combo_box_set_id_column(GtkComboBox* combo_box, gint id_column)"
  s7_pointer _p;
  s7_pointer combo_box, id_column;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_id_column", 1, combo_box, "GtkComboBox*");
  id_column = s7_car(_p);
  if (!s7_is_integer(id_column)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_id_column", 2, id_column, "gint");
  gtk_combo_box_set_id_column((GtkComboBox*)s7_c_pointer(combo_box), (gint)s7_integer(id_column));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_get_active_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_get_active_id "gchar* gtk_combo_box_get_active_id(GtkComboBox* combo_box)"
  s7_pointer combo_box;
  combo_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_get_active_id", 1, combo_box, "GtkComboBox*");
  return(s7_make_string(sc, gtk_combo_box_get_active_id((GtkComboBox*)s7_c_pointer(combo_box))));
}

static s7_pointer lg_gtk_combo_box_text_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_insert "void gtk_combo_box_text_insert(GtkComboBoxText* combo_box, gint position, \
gchar* id, gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, position, id, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 1, combo_box, "GtkComboBoxText*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 2, position, "gint");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 3, id, "gchar*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_insert", 4, text, "gchar*");
  gtk_combo_box_text_insert((GtkComboBoxText*)s7_c_pointer(combo_box), (gint)s7_integer(position), (const gchar*)s7_string(id), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_append(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_append "void gtk_combo_box_text_append(GtkComboBoxText* combo_box, gchar* id, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, id, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append", 1, combo_box, "GtkComboBoxText*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append", 2, id, "gchar*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_append", 3, text, "gchar*");
  gtk_combo_box_text_append((GtkComboBoxText*)s7_c_pointer(combo_box), (const gchar*)s7_string(id), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_combo_box_text_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_text_prepend "void gtk_combo_box_text_prepend(GtkComboBoxText* combo_box, gchar* id, \
gchar* text)"
  s7_pointer _p;
  s7_pointer combo_box, id, text;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBoxText__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend", 1, combo_box, "GtkComboBoxText*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend", 2, id, "gchar*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_combo_box_text_prepend", 3, text, "gchar*");
  gtk_combo_box_text_prepend((GtkComboBoxText*)s7_c_pointer(combo_box), (const gchar*)s7_string(id), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_new "GtkWidget* gtk_box_new(GtkOrientation orientation, gint spacing)"
  s7_pointer _p;
  s7_pointer orientation, spacing;
  _p = args;
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_box_new", 1, orientation, "GtkOrientation");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_box_new", 2, spacing, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_box_new((GtkOrientation)s7_integer(orientation), (gint)s7_integer(spacing))));
}

static s7_pointer lg_gtk_tree_view_set_cursor_on_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_cursor_on_cell "void gtk_tree_view_set_cursor_on_cell(GtkTreeView* tree_view, \
GtkTreePath* path, GtkTreeViewColumn* focus_column, GtkCellRenderer* focus_cell, gboolean start_editing)"
  s7_pointer _p;
  s7_pointer tree_view, path, focus_column, focus_cell, start_editing;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 1, tree_view, "GtkTreeView*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 2, path, "GtkTreePath*");
  focus_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focus_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 3, focus_column, "GtkTreeViewColumn*");
  focus_cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(focus_cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 4, focus_cell, "GtkCellRenderer*");
  start_editing = s7_car(_p);
  if (!s7_is_boolean(start_editing)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_cursor_on_cell", 5, start_editing, "gboolean");
  gtk_tree_view_set_cursor_on_cell((GtkTreeView*)s7_c_pointer(tree_view), (GtkTreePath*)s7_c_pointer(path), (GtkTreeViewColumn*)s7_c_pointer(focus_column), (GtkCellRenderer*)s7_c_pointer(focus_cell), (gboolean)lg_boolean(start_editing));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_set_rubber_banding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_rubber_banding "void gtk_tree_view_set_rubber_banding(GtkTreeView* tree_view, \
gboolean enable)"
  s7_pointer _p;
  s7_pointer tree_view, enable;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_rubber_banding", 1, tree_view, "GtkTreeView*");
  enable = s7_car(_p);
  if (!s7_is_boolean(enable)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_rubber_banding", 2, enable, "gboolean");
  gtk_tree_view_set_rubber_banding((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(enable));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_rubber_banding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_rubber_banding "gboolean gtk_tree_view_get_rubber_banding(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_rubber_banding", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_rubber_banding((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tooltip_set_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_markup "void gtk_tooltip_set_markup(GtkTooltip* tooltip, gchar* markup)"
  s7_pointer _p;
  s7_pointer tooltip, markup;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_markup", 1, tooltip, "GtkTooltip*");
  markup = s7_car(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_markup", 2, markup, "gchar*");
  gtk_tooltip_set_markup((GtkTooltip*)s7_c_pointer(tooltip), (const gchar*)s7_string(markup));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_custom(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_custom "void gtk_tooltip_set_custom(GtkTooltip* tooltip, GtkWidget* custom_widget)"
  s7_pointer _p;
  s7_pointer tooltip, custom_widget;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_custom", 1, tooltip, "GtkTooltip*");
  custom_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(custom_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_custom", 2, custom_widget, "GtkWidget*");
  gtk_tooltip_set_custom((GtkTooltip*)s7_c_pointer(tooltip), (GtkWidget*)s7_c_pointer(custom_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_column_new_with_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_new_with_area "GtkTreeViewColumn* gtk_tree_view_column_new_with_area(GtkCellArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkCellArea__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_new_with_area", 1, area, "GtkCellArea*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeViewColumn__sym, gtk_tree_view_column_new_with_area((GtkCellArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_tree_view_column_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_button "GtkWidget* gtk_tree_view_column_get_button(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_button", 1, tree_column, "GtkTreeViewColumn*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_tree_view_column_get_button((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_tree_view_column_focus_cell(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_focus_cell "void gtk_tree_view_column_focus_cell(GtkTreeViewColumn* tree_column, \
GtkCellRenderer* cell)"
  s7_pointer _p;
  s7_pointer tree_column, cell;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_focus_cell", 1, tree_column, "GtkTreeViewColumn*");
  cell = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_focus_cell", 2, cell, "GtkCellRenderer*");
  gtk_tree_view_column_focus_cell((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GtkCellRenderer*)s7_c_pointer(cell));
  return(lg_false);
}

static s7_pointer lg_gtk_orientable_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_orientable_set_orientation "void gtk_orientable_set_orientation(GtkOrientable* orientable, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer orientable, orientation;
  _p = args;
  orientable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(orientable, GtkOrientable__sym)) s7_wrong_type_arg_error(sc, "gtk_orientable_set_orientation", 1, orientable, "GtkOrientable*");
  orientation = s7_car(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_orientable_set_orientation", 2, orientation, "GtkOrientation");
  gtk_orientable_set_orientation((GtkOrientable*)s7_c_pointer(orientable), (GtkOrientation)s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_orientable_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_orientable_get_orientation "GtkOrientation gtk_orientable_get_orientation(GtkOrientable* orientable)"
  s7_pointer orientable;
  orientable = s7_car(args);
  if (!s7_is_c_pointer_of_type(orientable, GtkOrientable__sym)) s7_wrong_type_arg_error(sc, "gtk_orientable_get_orientation", 1, orientable, "GtkOrientable*");
  return(s7_make_integer(sc, gtk_orientable_get_orientation((GtkOrientable*)s7_c_pointer(orientable))));
}

static s7_pointer lg_gtk_get_major_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_major_version "guint gtk_get_major_version( void)"
    return(s7_make_integer(sc, (guint)gtk_get_major_version()));
}

static s7_pointer lg_gtk_get_minor_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_minor_version "guint gtk_get_minor_version( void)"
    return(s7_make_integer(sc, (guint)gtk_get_minor_version()));
}

static s7_pointer lg_gtk_get_micro_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_micro_version "guint gtk_get_micro_version( void)"
    return(s7_make_integer(sc, (guint)gtk_get_micro_version()));
}

static s7_pointer lg_gtk_get_binary_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_binary_age "guint gtk_get_binary_age( void)"
    return(s7_make_integer(sc, (guint)gtk_get_binary_age()));
}

static s7_pointer lg_gtk_get_interface_age(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_interface_age "guint gtk_get_interface_age( void)"
    return(s7_make_integer(sc, (guint)gtk_get_interface_age()));
}

static s7_pointer lg_gtk_progress_bar_set_show_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_set_show_text "void gtk_progress_bar_set_show_text(GtkProgressBar* pbar, \
gboolean show_text)"
  s7_pointer _p;
  s7_pointer pbar, show_text;
  _p = args;
  pbar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_show_text", 1, pbar, "GtkProgressBar*");
  show_text = s7_car(_p);
  if (!s7_is_boolean(show_text)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_set_show_text", 2, show_text, "gboolean");
  gtk_progress_bar_set_show_text((GtkProgressBar*)s7_c_pointer(pbar), (gboolean)lg_boolean(show_text));
  return(lg_false);
}

static s7_pointer lg_gtk_progress_bar_get_show_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_progress_bar_get_show_text "gboolean gtk_progress_bar_get_show_text(GtkProgressBar* pbar)"
  s7_pointer pbar;
  pbar = s7_car(args);
  if (!s7_is_c_pointer_of_type(pbar, GtkProgressBar__sym)) s7_wrong_type_arg_error(sc, "gtk_progress_bar_get_show_text", 1, pbar, "GtkProgressBar*");
  return(s7_make_boolean(sc, gtk_progress_bar_get_show_text((GtkProgressBar*)s7_c_pointer(pbar))));
}

static s7_pointer lg_gtk_entry_get_icon_storage_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_storage_type "GtkImageType gtk_entry_get_icon_storage_type(GtkEntry* entry, \
GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_storage_type", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_storage_type", 2, icon_pos, "GtkEntryIconPosition");
  return(s7_make_integer(sc, gtk_entry_get_icon_storage_type((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_entry_get_icon_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_icon_gicon "GIcon* gtk_entry_get_icon_gicon(GtkEntry* entry, GtkEntryIconPosition icon_pos)"
  s7_pointer _p;
  s7_pointer entry, icon_pos;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_gicon", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_get_icon_gicon", 2, icon_pos, "GtkEntryIconPosition");
  return(lg_make_c_pointer_with_type(sc, GIcon__sym, gtk_entry_get_icon_gicon((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos))));
}

static s7_pointer lg_gtk_assistant_commit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_commit "void gtk_assistant_commit(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_commit", 1, assistant, "GtkAssistant*");
  gtk_assistant_commit((GtkAssistant*)s7_c_pointer(assistant));
  return(lg_false);
}

static s7_pointer lg_gtk_window_fullscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_fullscreen "void gtk_window_fullscreen(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen", 1, window, "GtkWindow*");
  gtk_window_fullscreen((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_unfullscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_unfullscreen "void gtk_window_unfullscreen(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_unfullscreen", 1, window, "GtkWindow*");
  gtk_window_unfullscreen((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_group_add_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_add_window "void gtk_window_group_add_window(GtkWindowGroup* window_group, \
GtkWindow* window)"
  s7_pointer _p;
  s7_pointer window_group, window;
  _p = args;
  window_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_add_window", 1, window_group, "GtkWindowGroup*");
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_add_window", 2, window, "GtkWindow*");
  gtk_window_group_add_window((GtkWindowGroup*)s7_c_pointer(window_group), (GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_group_remove_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_remove_window "void gtk_window_group_remove_window(GtkWindowGroup* window_group, \
GtkWindow* window)"
  s7_pointer _p;
  s7_pointer window_group, window;
  _p = args;
  window_group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_remove_window", 1, window_group, "GtkWindowGroup*");
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_remove_window", 2, window, "GtkWindow*");
  gtk_window_group_remove_window((GtkWindowGroup*)s7_c_pointer(window_group), (GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_group_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_new "GtkWindowGroup* gtk_window_group_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWindowGroup__sym, gtk_window_group_new()));
}

static s7_pointer lg_gtk_window_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_group "GtkWindowGroup* gtk_window_get_group(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_group", 1, window, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWindowGroup__sym, gtk_window_get_group((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_window_group_list_windows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_group_list_windows "GList* gtk_window_group_list_windows(GtkWindowGroup* window_group)"
  s7_pointer window_group;
  window_group = s7_car(args);
  if (!s7_is_c_pointer_of_type(window_group, GtkWindowGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_window_group_list_windows", 1, window_group, "GtkWindowGroup*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_window_group_list_windows((GtkWindowGroup*)s7_c_pointer(window_group))));
}

static s7_pointer lg_gtk_icon_view_set_item_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_item_orientation "void gtk_icon_view_set_item_orientation(GtkIconView* icon_view, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer icon_view, orientation;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_orientation", 1, icon_view, "GtkIconView*");
  orientation = s7_car(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_item_orientation", 2, orientation, "GtkOrientation");
  gtk_icon_view_set_item_orientation((GtkIconView*)s7_c_pointer(icon_view), (GtkOrientation)s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_item_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_item_orientation "GtkOrientation gtk_icon_view_get_item_orientation(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_item_orientation", 1, icon_view, "GtkIconView*");
  return(s7_make_integer(sc, gtk_icon_view_get_item_orientation((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_text_view_im_context_filter_keypress(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_im_context_filter_keypress "gboolean gtk_text_view_im_context_filter_keypress(GtkTextView* text_view, \
GdkEventKey* event)"
  s7_pointer _p;
  s7_pointer text_view, event;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_im_context_filter_keypress", 1, text_view, "GtkTextView*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEventKey__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_im_context_filter_keypress", 2, event, "GdkEventKey*");
  return(s7_make_boolean(sc, gtk_text_view_im_context_filter_keypress((GtkTextView*)s7_c_pointer(text_view), (GdkEventKey*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_text_view_reset_im_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_reset_im_context "void gtk_text_view_reset_im_context(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_reset_im_context", 1, text_view, "GtkTextView*");
  gtk_text_view_reset_im_context((GtkTextView*)s7_c_pointer(text_view));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_get_draw_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_draw_sensitive "gboolean gtk_cell_view_get_draw_sensitive(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_draw_sensitive", 1, cell_view, "GtkCellView*");
  return(s7_make_boolean(sc, gtk_cell_view_get_draw_sensitive((GtkCellView*)s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_cell_view_set_draw_sensitive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_draw_sensitive "void gtk_cell_view_set_draw_sensitive(GtkCellView* cell_view, \
gboolean draw_sensitive)"
  s7_pointer _p;
  s7_pointer cell_view, draw_sensitive;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_draw_sensitive", 1, cell_view, "GtkCellView*");
  draw_sensitive = s7_car(_p);
  if (!s7_is_boolean(draw_sensitive)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_draw_sensitive", 2, draw_sensitive, "gboolean");
  gtk_cell_view_set_draw_sensitive((GtkCellView*)s7_c_pointer(cell_view), (gboolean)lg_boolean(draw_sensitive));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_view_get_fit_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_get_fit_model "gboolean gtk_cell_view_get_fit_model(GtkCellView* cell_view)"
  s7_pointer cell_view;
  cell_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_get_fit_model", 1, cell_view, "GtkCellView*");
  return(s7_make_boolean(sc, gtk_cell_view_get_fit_model((GtkCellView*)s7_c_pointer(cell_view))));
}

static s7_pointer lg_gtk_cell_view_set_fit_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_set_fit_model "void gtk_cell_view_set_fit_model(GtkCellView* cell_view, gboolean fit_model)"
  s7_pointer _p;
  s7_pointer cell_view, fit_model;
  _p = args;
  cell_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell_view, GtkCellView__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_fit_model", 1, cell_view, "GtkCellView*");
  fit_model = s7_car(_p);
  if (!s7_is_boolean(fit_model)) s7_wrong_type_arg_error(sc, "gtk_cell_view_set_fit_model", 2, fit_model, "gboolean");
  gtk_cell_view_set_fit_model((GtkCellView*)s7_c_pointer(cell_view), (gboolean)lg_boolean(fit_model));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_new_with_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_new_with_area "GtkWidget* gtk_icon_view_new_with_area(GtkCellArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkCellArea__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_new_with_area", 1, area, "GtkCellArea*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_icon_view_new_with_area((GtkCellArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_tree_model_iter_previous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_iter_previous "gboolean gtk_tree_model_iter_previous(GtkTreeModel* tree_model, \
GtkTreeIter* iter)"
  s7_pointer _p;
  s7_pointer tree_model, iter;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_previous", 1, tree_model, "GtkTreeModel*");
  iter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_iter_previous", 2, iter, "GtkTreeIter*");
  return(s7_make_boolean(sc, gtk_tree_model_iter_previous((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreeIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_view_is_blank_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_is_blank_at_pos "gboolean gtk_tree_view_is_blank_at_pos(GtkTreeView* tree_view, \
gint x, gint y, GtkTreePath** [path], GtkTreeViewColumn** [column], gint* [cell_x], gint* [cell_y])"
  s7_pointer _p;
  s7_pointer tree_view, x, y;
  GtkTreePath* ref_path = NULL;
  GtkTreeViewColumn* ref_column = NULL;
  gint ref_cell_x;
  gint ref_cell_y;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_blank_at_pos", 1, tree_view, "GtkTreeView*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_blank_at_pos", 2, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_tree_view_is_blank_at_pos", 3, y, "gint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_tree_view_is_blank_at_pos((GtkTreeView*)s7_c_pointer(tree_view), (gint)s7_integer(x), (gint)s7_integer(y), &ref_path, &ref_column, &ref_cell_x, &ref_cell_y));
      return(s7_list(sc, 5, res_ult, s7_make_c_pointer(sc, ref_path), s7_make_c_pointer(sc, ref_column), s7_make_integer(sc, ref_cell_x), s7_make_integer(sc, ref_cell_y)));
   }
}

static s7_pointer lg_gtk_window_set_has_user_ref_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_has_user_ref_count "void gtk_window_set_has_user_ref_count(GtkWindow* window, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_has_user_ref_count", 1, window, "GtkWindow*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_has_user_ref_count", 2, setting, "gboolean");
  gtk_window_set_has_user_ref_count((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gdk_rgba_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_copy "GdkRGBA* gdk_rgba_copy(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_copy", 1, rgba, "GdkRGBA*");
  return(lg_make_c_pointer_with_type(sc, GdkRGBA__sym, gdk_rgba_copy((GdkRGBA*)s7_c_pointer(rgba))));
}

static s7_pointer lg_gdk_rgba_free(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_free "void gdk_rgba_free(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_free", 1, rgba, "GdkRGBA*");
  gdk_rgba_free((GdkRGBA*)s7_c_pointer(rgba));
  return(lg_false);
}

static s7_pointer lg_gdk_rgba_parse(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_parse "gboolean gdk_rgba_parse(GdkRGBA* rgba, gchar* spec)"
  s7_pointer _p;
  s7_pointer rgba, spec;
  _p = args;
  rgba = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_parse", 1, rgba, "GdkRGBA*");
  spec = s7_car(_p);
  if (!s7_is_string(spec)) s7_wrong_type_arg_error(sc, "gdk_rgba_parse", 2, spec, "gchar*");
  return(s7_make_boolean(sc, gdk_rgba_parse((GdkRGBA*)s7_c_pointer(rgba), (const gchar*)s7_string(spec))));
}

static s7_pointer lg_gdk_rgba_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_to_string "gchar* gdk_rgba_to_string(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_to_string", 1, rgba, "GdkRGBA*");
  return(s7_make_string(sc, gdk_rgba_to_string((GdkRGBA*)s7_c_pointer(rgba))));
}

static s7_pointer lg_gtk_widget_set_state_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_state_flags "void gtk_widget_set_state_flags(GtkWidget* widget, GtkStateFlags flags, \
gboolean clear)"
  s7_pointer _p;
  s7_pointer widget, flags, clear;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_state_flags", 1, widget, "GtkWidget*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_widget_set_state_flags", 2, flags, "GtkStateFlags");
  clear = s7_car(_p);
  if (!s7_is_boolean(clear)) s7_wrong_type_arg_error(sc, "gtk_widget_set_state_flags", 3, clear, "gboolean");
  gtk_widget_set_state_flags((GtkWidget*)s7_c_pointer(widget), (GtkStateFlags)s7_integer(flags), (gboolean)lg_boolean(clear));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_unset_state_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_unset_state_flags "void gtk_widget_unset_state_flags(GtkWidget* widget, GtkStateFlags flags)"
  s7_pointer _p;
  s7_pointer widget, flags;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_unset_state_flags", 1, widget, "GtkWidget*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_widget_unset_state_flags", 2, flags, "GtkStateFlags");
  gtk_widget_unset_state_flags((GtkWidget*)s7_c_pointer(widget), (GtkStateFlags)s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_state_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_state_flags "GtkStateFlags gtk_widget_get_state_flags(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_state_flags", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_state_flags((GtkWidget*)s7_c_pointer(widget))));
}

#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static s7_pointer lg_gtk_entry_get_placeholder_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_placeholder_text "gchar* gtk_entry_get_placeholder_text(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_placeholder_text", 1, entry, "GtkEntry*");
  return(s7_make_string(sc, gtk_entry_get_placeholder_text((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_placeholder_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_placeholder_text "void gtk_entry_set_placeholder_text(GtkEntry* entry, gchar* text)"
  s7_pointer _p;
  s7_pointer entry, text;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_placeholder_text", 1, entry, "GtkEntry*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_entry_set_placeholder_text", 2, text, "gchar*");
  gtk_entry_set_placeholder_text((GtkEntry*)s7_c_pointer(entry), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_set_resize_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_set_resize_toplevel "void gtk_expander_set_resize_toplevel(GtkExpander* expander, \
gboolean resize_toplevel)"
  s7_pointer _p;
  s7_pointer expander, resize_toplevel;
  _p = args;
  expander = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_set_resize_toplevel", 1, expander, "GtkExpander*");
  resize_toplevel = s7_car(_p);
  if (!s7_is_boolean(resize_toplevel)) s7_wrong_type_arg_error(sc, "gtk_expander_set_resize_toplevel", 2, resize_toplevel, "gboolean");
  gtk_expander_set_resize_toplevel((GtkExpander*)s7_c_pointer(expander), (gboolean)lg_boolean(resize_toplevel));
  return(lg_false);
}

static s7_pointer lg_gtk_expander_get_resize_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_expander_get_resize_toplevel "gboolean gtk_expander_get_resize_toplevel(GtkExpander* expander)"
  s7_pointer expander;
  expander = s7_car(args);
  if (!s7_is_c_pointer_of_type(expander, GtkExpander__sym)) s7_wrong_type_arg_error(sc, "gtk_expander_get_resize_toplevel", 1, expander, "GtkExpander*");
  return(s7_make_boolean(sc, gtk_expander_get_resize_toplevel((GtkExpander*)s7_c_pointer(expander))));
}

static s7_pointer lg_gtk_combo_box_set_active_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_combo_box_set_active_id "gboolean gtk_combo_box_set_active_id(GtkComboBox* combo_box, \
gchar* active_id)"
  s7_pointer _p;
  s7_pointer combo_box, active_id;
  _p = args;
  combo_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(combo_box, GtkComboBox__sym)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_id", 1, combo_box, "GtkComboBox*");
  active_id = s7_car(_p);
  if (!s7_is_string(active_id)) s7_wrong_type_arg_error(sc, "gtk_combo_box_set_active_id", 2, active_id, "gchar*");
  return(s7_make_boolean(sc, gtk_combo_box_set_active_id((GtkComboBox*)s7_c_pointer(combo_box), (const gchar*)s7_string(active_id))));
}

static s7_pointer lg_gtk_tree_view_column_get_x_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_get_x_offset "gint gtk_tree_view_column_get_x_offset(GtkTreeViewColumn* tree_column)"
  s7_pointer tree_column;
  tree_column = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_get_x_offset", 1, tree_column, "GtkTreeViewColumn*");
  return(s7_make_integer(sc, gtk_tree_view_column_get_x_offset((GtkTreeViewColumn*)s7_c_pointer(tree_column))));
}

static s7_pointer lg_gtk_overlay_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_new "GtkWidget* gtk_overlay_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_overlay_new()));
}

static s7_pointer lg_gtk_overlay_add_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_overlay_add_overlay "void gtk_overlay_add_overlay(GtkOverlay* overlay, GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer overlay, widget;
  _p = args;
  overlay = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(overlay, GtkOverlay__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_add_overlay", 1, overlay, "GtkOverlay*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_overlay_add_overlay", 2, widget, "GtkWidget*");
  gtk_overlay_add_overlay((GtkOverlay*)s7_c_pointer(overlay), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_adjustment_get_minimum_increment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_adjustment_get_minimum_increment "gdouble gtk_adjustment_get_minimum_increment(GtkAdjustment* adjustment)"
  s7_pointer adjustment;
  adjustment = s7_car(args);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_adjustment_get_minimum_increment", 1, adjustment, "GtkAdjustment*");
  return(s7_make_real(sc, gtk_adjustment_get_minimum_increment((GtkAdjustment*)s7_c_pointer(adjustment))));
}

static s7_pointer lg_gtk_grid_insert_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_insert_row "void gtk_grid_insert_row(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_row", 1, grid, "GtkGrid*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_row", 2, position, "gint");
  gtk_grid_insert_row((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_insert_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_insert_column "void gtk_grid_insert_column(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_column", 1, grid, "GtkGrid*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_column", 2, position, "gint");
  gtk_grid_insert_column((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_insert_next_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_insert_next_to "void gtk_grid_insert_next_to(GtkGrid* grid, GtkWidget* sibling, \
GtkPositionType side)"
  s7_pointer _p;
  s7_pointer grid, sibling, side;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_next_to", 1, grid, "GtkGrid*");
  sibling = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_next_to", 2, sibling, "GtkWidget*");
  side = s7_car(_p);
  if (!s7_is_integer(side)) s7_wrong_type_arg_error(sc, "gtk_grid_insert_next_to", 3, side, "GtkPositionType");
  gtk_grid_insert_next_to((GtkGrid*)s7_c_pointer(grid), (GtkWidget*)s7_c_pointer(sibling), (GtkPositionType)s7_integer(side));
  return(lg_false);
}

static s7_pointer lg_gtk_text_iter_assign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_assign "void gtk_text_iter_assign(GtkTextIter* iter, GtkTextIter* other)"
  s7_pointer _p;
  s7_pointer iter, other;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_assign", 1, iter, "GtkTextIter*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_assign", 2, other, "GtkTextIter*");
  gtk_text_iter_assign((GtkTextIter*)s7_c_pointer(iter), (GtkTextIter*)s7_c_pointer(other));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_has_visible_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_visible_focus "gboolean gtk_widget_has_visible_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_visible_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_has_visible_focus((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_window_set_focus_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_focus_visible "void gtk_window_set_focus_visible(GtkWindow* window, gboolean setting)"
  s7_pointer _p;
  s7_pointer window, setting;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus_visible", 1, window, "GtkWindow*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_window_set_focus_visible", 2, setting, "gboolean");
  gtk_window_set_focus_visible((GtkWindow*)s7_c_pointer(window), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_focus_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_focus_visible "gboolean gtk_window_get_focus_visible(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_focus_visible", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_get_focus_visible((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_font_chooser_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_dialog_new "GtkWidget* gtk_font_chooser_dialog_new(gchar* title, GtkWindow* window)"
  s7_pointer _p;
  s7_pointer title, window;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_dialog_new", 1, title, "gchar*");
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_dialog_new", 2, window, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_font_chooser_dialog_new((const gchar*)s7_string(title), (GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gdk_event_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_button "gboolean gdk_event_get_button(GdkEvent* event, guint* button)"
  s7_pointer _p;
  s7_pointer event, button;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_button", 1, event, "GdkEvent*");
  button = s7_car(_p);
  if (!s7_is_c_pointer_of_type(button, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_button", 2, button, "guint*");
  return(s7_make_boolean(sc, gdk_event_get_button((GdkEvent*)s7_c_pointer(event), (guint*)s7_c_pointer(button))));
}

static s7_pointer lg_gdk_event_get_click_count(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_click_count "gboolean gdk_event_get_click_count(GdkEvent* event, guint* click_count)"
  s7_pointer _p;
  s7_pointer event, click_count;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_click_count", 1, event, "GdkEvent*");
  click_count = s7_car(_p);
  if (!s7_is_c_pointer_of_type(click_count, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_click_count", 2, click_count, "guint*");
  return(s7_make_boolean(sc, gdk_event_get_click_count((GdkEvent*)s7_c_pointer(event), (guint*)s7_c_pointer(click_count))));
}

static s7_pointer lg_gdk_event_get_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_keyval "gboolean gdk_event_get_keyval(GdkEvent* event, guint* keyval)"
  s7_pointer _p;
  s7_pointer event, keyval;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keyval", 1, event, "GdkEvent*");
  keyval = s7_car(_p);
  if (!s7_is_c_pointer_of_type(keyval, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keyval", 2, keyval, "guint*");
  return(s7_make_boolean(sc, gdk_event_get_keyval((GdkEvent*)s7_c_pointer(event), (guint*)s7_c_pointer(keyval))));
}

static s7_pointer lg_gdk_event_get_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_keycode "gboolean gdk_event_get_keycode(GdkEvent* event, guint16* keycode)"
  s7_pointer _p;
  s7_pointer event, keycode;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keycode", 1, event, "GdkEvent*");
  keycode = s7_car(_p);
  if (!s7_is_c_pointer_of_type(keycode, guint16__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_keycode", 2, keycode, "guint16*");
  return(s7_make_boolean(sc, gdk_event_get_keycode((GdkEvent*)s7_c_pointer(event), (guint16*)s7_c_pointer(keycode))));
}

static s7_pointer lg_gdk_event_get_scroll_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_scroll_direction "gboolean gdk_event_get_scroll_direction(GdkEvent* event, \
GdkScrollDirection* [direction])"
  s7_pointer _p;
  s7_pointer event;
  GdkScrollDirection ref_direction;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_scroll_direction", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_scroll_direction((GdkEvent*)s7_c_pointer(event), &ref_direction));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_direction)));
   }
}

static s7_pointer lg_gtk_grid_get_child_at(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_child_at "GtkWidget* gtk_grid_get_child_at(GtkGrid* grid, gint left, gint top)"
  s7_pointer _p;
  s7_pointer grid, left, top;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_child_at", 1, grid, "GtkGrid*");
  left = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left)) s7_wrong_type_arg_error(sc, "gtk_grid_get_child_at", 2, left, "gint");
  top = s7_car(_p);
  if (!s7_is_integer(top)) s7_wrong_type_arg_error(sc, "gtk_grid_get_child_at", 3, top, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_grid_get_child_at((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(left), (gint)s7_integer(top))));
}

static s7_pointer lg_gtk_font_chooser_get_font_family(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_family "PangoFontFamily* gtk_font_chooser_get_font_family(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_family", 1, fontchooser, "GtkFontChooser*");
  return(lg_make_c_pointer_with_type(sc, PangoFontFamily__sym, gtk_font_chooser_get_font_family((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_get_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_face "PangoFontFace* gtk_font_chooser_get_font_face(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_face", 1, fontchooser, "GtkFontChooser*");
  return(lg_make_c_pointer_with_type(sc, PangoFontFace__sym, gtk_font_chooser_get_font_face((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_get_font_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_size "gint gtk_font_chooser_get_font_size(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_size", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_integer(sc, gtk_font_chooser_get_font_size((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_get_font_desc(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_desc "PangoFontDescription* gtk_font_chooser_get_font_desc(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_desc", 1, fontchooser, "GtkFontChooser*");
  return(lg_make_c_pointer_with_type(sc, PangoFontDescription__sym, gtk_font_chooser_get_font_desc((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_font_desc(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_font_desc "void gtk_font_chooser_set_font_desc(GtkFontChooser* fontchooser, \
PangoFontDescription* font_desc)"
  s7_pointer _p;
  s7_pointer fontchooser, font_desc;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_desc", 1, fontchooser, "GtkFontChooser*");
  font_desc = s7_car(_p);
  if (!s7_is_c_pointer_of_type(font_desc, PangoFontDescription__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_desc", 2, font_desc, "PangoFontDescription*");
  gtk_font_chooser_set_font_desc((GtkFontChooser*)s7_c_pointer(fontchooser), (PangoFontDescription*)s7_c_pointer(font_desc));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font "gchar* gtk_font_chooser_get_font(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_string(sc, gtk_font_chooser_get_font((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_font(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_font "void gtk_font_chooser_set_font(GtkFontChooser* fontchooser, gchar* fontname)"
  s7_pointer _p;
  s7_pointer fontchooser, fontname;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font", 1, fontchooser, "GtkFontChooser*");
  fontname = s7_car(_p);
  if (!s7_is_string(fontname)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font", 2, fontname, "gchar*");
  gtk_font_chooser_set_font((GtkFontChooser*)s7_c_pointer(fontchooser), (const gchar*)s7_string(fontname));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_preview_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_preview_text "gchar* gtk_font_chooser_get_preview_text(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_preview_text", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_string(sc, gtk_font_chooser_get_preview_text((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_preview_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_preview_text "void gtk_font_chooser_set_preview_text(GtkFontChooser* fontchooser, \
gchar* text)"
  s7_pointer _p;
  s7_pointer fontchooser, text;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_preview_text", 1, fontchooser, "GtkFontChooser*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_preview_text", 2, text, "gchar*");
  gtk_font_chooser_set_preview_text((GtkFontChooser*)s7_c_pointer(fontchooser), (const gchar*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_show_preview_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_show_preview_entry "gboolean gtk_font_chooser_get_show_preview_entry(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_show_preview_entry", 1, fontchooser, "GtkFontChooser*");
  return(s7_make_boolean(sc, gtk_font_chooser_get_show_preview_entry((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_font_chooser_set_show_preview_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_show_preview_entry "void gtk_font_chooser_set_show_preview_entry(GtkFontChooser* fontchooser, \
gboolean show_preview_entry)"
  s7_pointer _p;
  s7_pointer fontchooser, show_preview_entry;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_show_preview_entry", 1, fontchooser, "GtkFontChooser*");
  show_preview_entry = s7_car(_p);
  if (!s7_is_boolean(show_preview_entry)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_show_preview_entry", 2, show_preview_entry, "gboolean");
  gtk_font_chooser_set_show_preview_entry((GtkFontChooser*)s7_c_pointer(fontchooser), (gboolean)lg_boolean(show_preview_entry));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_widget_new "GtkWidget* gtk_font_chooser_widget_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_font_chooser_widget_new()));
}

#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static s7_pointer lg_gtk_accelerator_parse_with_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_parse_with_keycode "void gtk_accelerator_parse_with_keycode(gchar* accelerator, \
guint* accelerator_key, guint** accelerator_codes, GdkModifierType* accelerator_mods)"
  s7_pointer _p;
  s7_pointer accelerator, accelerator_key, accelerator_codes, accelerator_mods;
  _p = args;
  accelerator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 1, accelerator, "gchar*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accelerator_key, guint__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 2, accelerator_key, "guint*");
  accelerator_codes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accelerator_codes, guint___sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 3, accelerator_codes, "guint**");
  accelerator_mods = s7_car(_p);
  if (!s7_is_c_pointer_of_type(accelerator_mods, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse_with_keycode", 4, accelerator_mods, "GdkModifierType*");
  gtk_accelerator_parse_with_keycode((const gchar*)s7_string(accelerator), (guint*)s7_c_pointer(accelerator_key), (guint**)s7_c_pointer(accelerator_codes), (GdkModifierType*)s7_c_pointer(accelerator_mods));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_name_with_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_name_with_keycode "gchar* gtk_accelerator_name_with_keycode(GdkDisplay* display, \
guint accelerator_key, guint keycode, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer display, accelerator_key, keycode, accelerator_mods;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 1, display, "GdkDisplay*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 2, accelerator_key, "guint");
  keycode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keycode)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 3, keycode, "guint");
  accelerator_mods = s7_car(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_name_with_keycode", 4, accelerator_mods, "GdkModifierType");
  return(s7_make_string(sc, gtk_accelerator_name_with_keycode((GdkDisplay*)s7_c_pointer(display), (guint)s7_integer(accelerator_key), (guint)s7_integer(keycode), (GdkModifierType)s7_integer(accelerator_mods))));
}

static s7_pointer lg_gtk_accelerator_get_label_with_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_get_label_with_keycode "gchar* gtk_accelerator_get_label_with_keycode(GdkDisplay* display, \
guint accelerator_key, guint keycode, GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer display, accelerator_key, keycode, accelerator_mods;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 1, display, "GdkDisplay*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 2, accelerator_key, "guint");
  keycode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keycode)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 3, keycode, "guint");
  accelerator_mods = s7_car(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accelerator_get_label_with_keycode", 4, accelerator_mods, "GdkModifierType");
  return(s7_make_string(sc, gtk_accelerator_get_label_with_keycode((GdkDisplay*)s7_c_pointer(display), (guint)s7_integer(accelerator_key), (guint)s7_integer(keycode), (GdkModifierType)s7_integer(accelerator_mods))));
}

static s7_pointer lg_gtk_application_get_app_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_app_menu "GMenuModel* gtk_application_get_app_menu(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_app_menu", 1, application, "GtkApplication*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_application_get_app_menu((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_set_app_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_set_app_menu "void gtk_application_set_app_menu(GtkApplication* application, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer application, model;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_app_menu", 1, application, "GtkApplication*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_app_menu", 2, model, "GMenuModel*");
  gtk_application_set_app_menu((GtkApplication*)s7_c_pointer(application), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_application_get_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_menubar "GMenuModel* gtk_application_get_menubar(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_menubar", 1, application, "GtkApplication*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_application_get_menubar((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_set_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_set_menubar "void gtk_application_set_menubar(GtkApplication* application, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer application, model;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_menubar", 1, application, "GtkApplication*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_application_set_menubar", 2, model, "GMenuModel*");
  gtk_application_set_menubar((GtkApplication*)s7_c_pointer(application), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_completion_compute_prefix(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_completion_compute_prefix "gchar* gtk_entry_completion_compute_prefix(GtkEntryCompletion* completion, \
char* key)"
  s7_pointer _p;
  s7_pointer completion, key;
  _p = args;
  completion = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(completion, GtkEntryCompletion__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_compute_prefix", 1, completion, "GtkEntryCompletion*");
  key = s7_car(_p);
  if (!s7_is_string(key)) s7_wrong_type_arg_error(sc, "gtk_entry_completion_compute_prefix", 2, key, "char*");
  return(s7_make_string(sc, gtk_entry_completion_compute_prefix((GtkEntryCompletion*)s7_c_pointer(completion), (const char*)(char*)s7_string(key))));
}

static s7_pointer lg_gtk_scale_set_has_origin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_has_origin "void gtk_scale_set_has_origin(GtkScale* scale, gboolean has_origin)"
  s7_pointer _p;
  s7_pointer scale, has_origin;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_has_origin", 1, scale, "GtkScale*");
  has_origin = s7_car(_p);
  if (!s7_is_boolean(has_origin)) s7_wrong_type_arg_error(sc, "gtk_scale_set_has_origin", 2, has_origin, "gboolean");
  gtk_scale_set_has_origin((GtkScale*)s7_c_pointer(scale), (gboolean)lg_boolean(has_origin));
  return(lg_false);
}

static s7_pointer lg_gtk_scale_get_has_origin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_get_has_origin "gboolean gtk_scale_get_has_origin(GtkScale* scale)"
  s7_pointer scale;
  scale = s7_car(args);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_get_has_origin", 1, scale, "GtkScale*");
  return(s7_make_boolean(sc, gtk_scale_get_has_origin((GtkScale*)s7_c_pointer(scale))));
}

static s7_pointer lg_gtk_application_window_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_new "GtkWidget* gtk_application_window_new(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_new", 1, application, "GtkApplication*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_application_window_new((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_window_set_show_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_set_show_menubar "void gtk_application_window_set_show_menubar(GtkApplicationWindow* window, \
gboolean show_menubar)"
  s7_pointer _p;
  s7_pointer window, show_menubar;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkApplicationWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_show_menubar", 1, window, "GtkApplicationWindow*");
  show_menubar = s7_car(_p);
  if (!s7_is_boolean(show_menubar)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_show_menubar", 2, show_menubar, "gboolean");
  gtk_application_window_set_show_menubar((GtkApplicationWindow*)s7_c_pointer(window), (gboolean)lg_boolean(show_menubar));
  return(lg_false);
}

static s7_pointer lg_gtk_application_window_get_show_menubar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_get_show_menubar "gboolean gtk_application_window_get_show_menubar(GtkApplicationWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkApplicationWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_get_show_menubar", 1, window, "GtkApplicationWindow*");
  return(s7_make_boolean(sc, gtk_application_window_get_show_menubar((GtkApplicationWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_image_new_from_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_resource "GtkWidget* gtk_image_new_from_resource(gchar* resource_path)"
  s7_pointer resource_path;
  resource_path = s7_car(args);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_resource", 1, resource_path, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_image_new_from_resource((const gchar*)s7_string(resource_path))));
}

static s7_pointer lg_gtk_image_set_from_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_resource "void gtk_image_set_from_resource(GtkImage* image, gchar* resource_path)"
  s7_pointer _p;
  s7_pointer image, resource_path;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_resource", 1, image, "GtkImage*");
  resource_path = s7_car(_p);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_resource", 2, resource_path, "gchar*");
  gtk_image_set_from_resource((GtkImage*)s7_c_pointer(image), (const gchar*)s7_string(resource_path));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_add_credit_section(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_add_credit_section "void gtk_about_dialog_add_credit_section(GtkAboutDialog* about, \
gchar* section_name, gchar** people)"
  s7_pointer _p;
  s7_pointer about, section_name, people;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_add_credit_section", 1, about, "GtkAboutDialog*");
  section_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(section_name)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_add_credit_section", 2, section_name, "gchar*");
  people = s7_car(_p);
  if (!s7_is_c_pointer_of_type(people, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_add_credit_section", 3, people, "gchar**");
  gtk_about_dialog_add_credit_section((GtkAboutDialog*)s7_c_pointer(about), (const gchar*)s7_string(section_name), (const gchar**)s7_c_pointer(people));
  return(lg_false);
}

static s7_pointer lg_gtk_hsv_to_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_hsv_to_rgb "void gtk_hsv_to_rgb(gdouble h, gdouble s, gdouble v, gdouble* [r], gdouble* [g], \
gdouble* [b])"
  s7_pointer _p;
  s7_pointer h, s, v;
  gdouble ref_r;
  gdouble ref_g;
  gdouble ref_b;
  _p = args;
  h = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(h)) s7_wrong_type_arg_error(sc, "gtk_hsv_to_rgb", 1, h, "gdouble");
  s = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(s)) s7_wrong_type_arg_error(sc, "gtk_hsv_to_rgb", 2, s, "gdouble");
  v = s7_car(_p);
  if (!s7_is_real(v)) s7_wrong_type_arg_error(sc, "gtk_hsv_to_rgb", 3, v, "gdouble");
  gtk_hsv_to_rgb((gdouble)s7_real(h), (gdouble)s7_real(s), (gdouble)s7_real(v), &ref_r, &ref_g, &ref_b);
    return(s7_list(sc, 3, s7_make_real(sc, ref_r), s7_make_real(sc, ref_g), s7_make_real(sc, ref_b)));
}

static s7_pointer lg_gtk_rgb_to_hsv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_rgb_to_hsv "void gtk_rgb_to_hsv(gdouble r, gdouble g, gdouble b, gdouble* [h], gdouble* [s], \
gdouble* [v])"
  s7_pointer _p;
  s7_pointer r, g, b;
  gdouble ref_h;
  gdouble ref_s;
  gdouble ref_v;
  _p = args;
  r = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(r)) s7_wrong_type_arg_error(sc, "gtk_rgb_to_hsv", 1, r, "gdouble");
  g = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(g)) s7_wrong_type_arg_error(sc, "gtk_rgb_to_hsv", 2, g, "gdouble");
  b = s7_car(_p);
  if (!s7_is_real(b)) s7_wrong_type_arg_error(sc, "gtk_rgb_to_hsv", 3, b, "gdouble");
  gtk_rgb_to_hsv((gdouble)s7_real(r), (gdouble)s7_real(g), (gdouble)s7_real(b), &ref_h, &ref_s, &ref_v);
    return(s7_list(sc, 3, s7_make_real(sc, ref_h), s7_make_real(sc, ref_s), s7_make_real(sc, ref_v)));
}

static s7_pointer lg_gtk_color_chooser_get_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_get_rgba "void gtk_color_chooser_get_rgba(GtkColorChooser* chooser, GdkRGBA* color)"
  s7_pointer _p;
  s7_pointer chooser, color;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_get_rgba", 1, chooser, "GtkColorChooser*");
  color = s7_car(_p);
  if (!s7_is_c_pointer_of_type(color, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_get_rgba", 2, color, "GdkRGBA*");
  gtk_color_chooser_get_rgba((GtkColorChooser*)s7_c_pointer(chooser), (GdkRGBA*)s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_gtk_color_chooser_set_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_set_rgba "void gtk_color_chooser_set_rgba(GtkColorChooser* chooser, GdkRGBA* color)"
  s7_pointer _p;
  s7_pointer chooser, color;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_rgba", 1, chooser, "GtkColorChooser*");
  color = s7_car(_p);
  if (!s7_is_c_pointer_of_type(color, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_rgba", 2, color, "GdkRGBA*");
  gtk_color_chooser_set_rgba((GtkColorChooser*)s7_c_pointer(chooser), (GdkRGBA*)s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_gtk_color_chooser_get_use_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_get_use_alpha "gboolean gtk_color_chooser_get_use_alpha(GtkColorChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_get_use_alpha", 1, chooser, "GtkColorChooser*");
  return(s7_make_boolean(sc, gtk_color_chooser_get_use_alpha((GtkColorChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_color_chooser_set_use_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_set_use_alpha "void gtk_color_chooser_set_use_alpha(GtkColorChooser* chooser, \
gboolean use_alpha)"
  s7_pointer _p;
  s7_pointer chooser, use_alpha;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_use_alpha", 1, chooser, "GtkColorChooser*");
  use_alpha = s7_car(_p);
  if (!s7_is_boolean(use_alpha)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_set_use_alpha", 2, use_alpha, "gboolean");
  gtk_color_chooser_set_use_alpha((GtkColorChooser*)s7_c_pointer(chooser), (gboolean)lg_boolean(use_alpha));
  return(lg_false);
}

static s7_pointer lg_gtk_color_chooser_dialog_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_dialog_new "GtkWidget* gtk_color_chooser_dialog_new(gchar* title, GtkWindow* parent)"
  s7_pointer _p;
  s7_pointer title, parent;
  _p = args;
  title = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_dialog_new", 1, title, "gchar*");
  parent = s7_car(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_dialog_new", 2, parent, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_color_chooser_dialog_new((const gchar*)s7_string(title), (GtkWindow*)s7_c_pointer(parent))));
}

static s7_pointer lg_gtk_color_chooser_widget_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_widget_new "GtkWidget* gtk_color_chooser_widget_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_color_chooser_widget_new()));
}

#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static s7_pointer lg_gdk_event_get_scroll_deltas(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_scroll_deltas "gboolean gdk_event_get_scroll_deltas(GdkEvent* event, gdouble* [delta_x], \
gdouble* [delta_y])"
  s7_pointer _p;
  s7_pointer event;
  gdouble ref_delta_x;
  gdouble ref_delta_y;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_scroll_deltas", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_scroll_deltas((GdkEvent*)s7_c_pointer(event), &ref_delta_x, &ref_delta_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_delta_x), s7_make_real(sc, ref_delta_y)));
   }
}

static s7_pointer lg_gtk_color_chooser_add_palette(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_chooser_add_palette "void gtk_color_chooser_add_palette(GtkColorChooser* chooser, \
GtkOrientation horizontal, gint colors_per_line, gint n_colors, GdkRGBA* colors)"
  s7_pointer _p;
  s7_pointer chooser, horizontal, colors_per_line, n_colors, colors;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkColorChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 1, chooser, "GtkColorChooser*");
  horizontal = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(horizontal)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 2, horizontal, "GtkOrientation");
  colors_per_line = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(colors_per_line)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 3, colors_per_line, "gint");
  n_colors = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_colors)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 4, n_colors, "gint");
  colors = s7_car(_p);
  if (!s7_is_c_pointer_of_type(colors, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_color_chooser_add_palette", 5, colors, "GdkRGBA*");
  gtk_color_chooser_add_palette((GtkColorChooser*)s7_c_pointer(chooser), (GtkOrientation)s7_integer(horizontal), (gint)s7_integer(colors_per_line), (gint)s7_integer(n_colors), (GdkRGBA*)s7_c_pointer(colors));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_n_columns(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_n_columns "guint gtk_tree_view_get_n_columns(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_n_columns", 1, tree_view, "GtkTreeView*");
  return(s7_make_integer(sc, gtk_tree_view_get_n_columns((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_menu_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_new "GtkWidget* gtk_menu_button_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_menu_button_new()));
}

static s7_pointer lg_gtk_menu_button_set_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_menu_model "void gtk_menu_button_set_menu_model(GtkMenuButton* menu_button, \
GMenuModel* menu_model)"
  s7_pointer _p;
  s7_pointer menu_button, menu_model;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_menu_model", 1, menu_button, "GtkMenuButton*");
  menu_model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(menu_model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_menu_model", 2, menu_model, "GMenuModel*");
  gtk_menu_button_set_menu_model((GtkMenuButton*)s7_c_pointer(menu_button), (GMenuModel*)s7_c_pointer(menu_model));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_menu_model "GMenuModel* gtk_menu_button_get_menu_model(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_menu_model", 1, menu_button, "GtkMenuButton*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_menu_button_get_menu_model((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_menu_button_set_align_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_align_widget "void gtk_menu_button_set_align_widget(GtkMenuButton* menu_button, \
GtkWidget* align_widget)"
  s7_pointer _p;
  s7_pointer menu_button, align_widget;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_align_widget", 1, menu_button, "GtkMenuButton*");
  align_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(align_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_align_widget", 2, align_widget, "GtkWidget*");
  gtk_menu_button_set_align_widget((GtkMenuButton*)s7_c_pointer(menu_button), (GtkWidget*)s7_c_pointer(align_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_align_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_align_widget "GtkWidget* gtk_menu_button_get_align_widget(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_align_widget", 1, menu_button, "GtkMenuButton*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_menu_button_get_align_widget((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_search_entry_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_entry_new "GtkWidget* gtk_search_entry_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_search_entry_new()));
}

static s7_pointer lg_gtk_level_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_new "GtkWidget* gtk_level_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_level_bar_new()));
}

static s7_pointer lg_gtk_level_bar_new_for_interval(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_new_for_interval "GtkWidget* gtk_level_bar_new_for_interval(gdouble min_value, \
gdouble max_value)"
  s7_pointer _p;
  s7_pointer min_value, max_value;
  _p = args;
  min_value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min_value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_new_for_interval", 1, min_value, "gdouble");
  max_value = s7_car(_p);
  if (!s7_is_real(max_value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_new_for_interval", 2, max_value, "gdouble");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_level_bar_new_for_interval((gdouble)s7_real(min_value), (gdouble)s7_real(max_value))));
}

static s7_pointer lg_gtk_level_bar_set_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_mode "void gtk_level_bar_set_mode(GtkLevelBar* self, GtkLevelBarMode mode)"
  s7_pointer _p;
  s7_pointer self, mode;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_mode", 1, self, "GtkLevelBar*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_mode", 2, mode, "GtkLevelBarMode");
  gtk_level_bar_set_mode((GtkLevelBar*)s7_c_pointer(self), (GtkLevelBarMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_mode "GtkLevelBarMode gtk_level_bar_get_mode(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_mode", 1, self, "GtkLevelBar*");
  return(s7_make_integer(sc, gtk_level_bar_get_mode((GtkLevelBar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_value "void gtk_level_bar_set_value(GtkLevelBar* self, gdouble value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_value", 1, self, "GtkLevelBar*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_value", 2, value, "gdouble");
  gtk_level_bar_set_value((GtkLevelBar*)s7_c_pointer(self), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_value "gdouble gtk_level_bar_get_value(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_value", 1, self, "GtkLevelBar*");
  return(s7_make_real(sc, gtk_level_bar_get_value((GtkLevelBar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_set_min_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_min_value "void gtk_level_bar_set_min_value(GtkLevelBar* self, gdouble value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_min_value", 1, self, "GtkLevelBar*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_min_value", 2, value, "gdouble");
  gtk_level_bar_set_min_value((GtkLevelBar*)s7_c_pointer(self), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_min_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_min_value "gdouble gtk_level_bar_get_min_value(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_min_value", 1, self, "GtkLevelBar*");
  return(s7_make_real(sc, gtk_level_bar_get_min_value((GtkLevelBar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_set_max_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_max_value "void gtk_level_bar_set_max_value(GtkLevelBar* self, gdouble value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_max_value", 1, self, "GtkLevelBar*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_max_value", 2, value, "gdouble");
  gtk_level_bar_set_max_value((GtkLevelBar*)s7_c_pointer(self), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_max_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_max_value "gdouble gtk_level_bar_get_max_value(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_max_value", 1, self, "GtkLevelBar*");
  return(s7_make_real(sc, gtk_level_bar_get_max_value((GtkLevelBar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_level_bar_add_offset_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_add_offset_value "void gtk_level_bar_add_offset_value(GtkLevelBar* self, gchar* name, \
gdouble value)"
  s7_pointer _p;
  s7_pointer self, name, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_add_offset_value", 1, self, "GtkLevelBar*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_level_bar_add_offset_value", 2, name, "gchar*");
  value = s7_car(_p);
  if (!s7_is_real(value)) s7_wrong_type_arg_error(sc, "gtk_level_bar_add_offset_value", 3, value, "gdouble");
  gtk_level_bar_add_offset_value((GtkLevelBar*)s7_c_pointer(self), (const gchar*)s7_string(name), (gdouble)s7_real(value));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_remove_offset_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_remove_offset_value "void gtk_level_bar_remove_offset_value(GtkLevelBar* self, \
gchar* name)"
  s7_pointer _p;
  s7_pointer self, name;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_remove_offset_value", 1, self, "GtkLevelBar*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_level_bar_remove_offset_value", 2, name, "gchar*");
  gtk_level_bar_remove_offset_value((GtkLevelBar*)s7_c_pointer(self), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_offset_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_offset_value "gboolean gtk_level_bar_get_offset_value(GtkLevelBar* self, \
gchar* name, gdouble* [value])"
  s7_pointer _p;
  s7_pointer self, name;
  gdouble ref_value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_offset_value", 1, self, "GtkLevelBar*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_offset_value", 2, name, "gchar*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_level_bar_get_offset_value((GtkLevelBar*)s7_c_pointer(self), (const gchar*)s7_string(name), &ref_value));
      return(s7_list(sc, 2, res_ult, s7_make_real(sc, ref_value)));
   }
}

static s7_pointer lg_gtk_application_get_active_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_active_window "GtkWindow* gtk_application_get_active_window(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_active_window", 1, application, "GtkApplication*");
  return(lg_make_c_pointer_with_type(sc, GtkWindow__sym, gtk_application_get_active_window((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_entry_set_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_input_purpose "void gtk_entry_set_input_purpose(GtkEntry* entry, GtkInputPurpose purpose)"
  s7_pointer _p;
  s7_pointer entry, purpose;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_purpose", 1, entry, "GtkEntry*");
  purpose = s7_car(_p);
  if (!s7_is_integer(purpose)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_purpose", 2, purpose, "GtkInputPurpose");
  gtk_entry_set_input_purpose((GtkEntry*)s7_c_pointer(entry), (GtkInputPurpose)s7_integer(purpose));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_input_purpose "GtkInputPurpose gtk_entry_get_input_purpose(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_input_purpose", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_input_purpose((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_entry_set_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_input_hints "void gtk_entry_set_input_hints(GtkEntry* entry, GtkInputHints hints)"
  s7_pointer _p;
  s7_pointer entry, hints;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_hints", 1, entry, "GtkEntry*");
  hints = s7_car(_p);
  if (!s7_is_integer(hints)) s7_wrong_type_arg_error(sc, "gtk_entry_set_input_hints", 2, hints, "GtkInputHints");
  gtk_entry_set_input_hints((GtkEntry*)s7_c_pointer(entry), (GtkInputHints)s7_integer(hints));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_input_hints "GtkInputHints gtk_entry_get_input_hints(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_input_hints", 1, entry, "GtkEntry*");
  return(s7_make_integer(sc, gtk_entry_get_input_hints((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_menu_button_get_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_popup "GtkMenu* gtk_menu_button_get_popup(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_popup", 1, menu_button, "GtkMenuButton*");
  return(lg_make_c_pointer_with_type(sc, GtkMenu__sym, gtk_menu_button_get_popup((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_text_view_set_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_input_purpose "void gtk_text_view_set_input_purpose(GtkTextView* text_view, \
GtkInputPurpose purpose)"
  s7_pointer _p;
  s7_pointer text_view, purpose;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_purpose", 1, text_view, "GtkTextView*");
  purpose = s7_car(_p);
  if (!s7_is_integer(purpose)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_purpose", 2, purpose, "GtkInputPurpose");
  gtk_text_view_set_input_purpose((GtkTextView*)s7_c_pointer(text_view), (GtkInputPurpose)s7_integer(purpose));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_input_purpose "GtkInputPurpose gtk_text_view_get_input_purpose(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_input_purpose", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_input_purpose((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_input_hints "void gtk_text_view_set_input_hints(GtkTextView* text_view, \
GtkInputHints hints)"
  s7_pointer _p;
  s7_pointer text_view, hints;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_hints", 1, text_view, "GtkTextView*");
  hints = s7_car(_p);
  if (!s7_is_integer(hints)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_input_hints", 2, hints, "GtkInputHints");
  gtk_text_view_set_input_hints((GtkTextView*)s7_c_pointer(text_view), (GtkInputHints)s7_integer(hints));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_input_hints "GtkInputHints gtk_text_view_get_input_hints(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_input_hints", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_input_hints((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_entry_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_attributes "void gtk_entry_set_attributes(GtkEntry* entry, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer entry, attrs;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_attributes", 1, entry, "GtkEntry*");
  attrs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_attributes", 2, attrs, "PangoAttrList*");
  gtk_entry_set_attributes((GtkEntry*)s7_c_pointer(entry), (PangoAttrList*)s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_attributes "PangoAttrList* gtk_entry_get_attributes(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_attributes", 1, entry, "GtkEntry*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, gtk_entry_get_attributes((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_accel_label_set_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_accel "void gtk_accel_label_set_accel(GtkAccelLabel* accel_label, guint accelerator_key, \
GdkModifierType accelerator_mods)"
  s7_pointer _p;
  s7_pointer accel_label, accelerator_key, accelerator_mods;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel", 1, accel_label, "GtkAccelLabel*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(accelerator_key)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel", 2, accelerator_key, "guint");
  accelerator_mods = s7_car(_p);
  if (!s7_is_integer(accelerator_mods)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_accel", 3, accelerator_mods, "GdkModifierType");
  gtk_accel_label_set_accel((GtkAccelLabel*)s7_c_pointer(accel_label), (guint)s7_integer(accelerator_key), (GdkModifierType)s7_integer(accelerator_mods));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 8, 0)
static s7_pointer lg_gtk_level_bar_set_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_set_inverted "void gtk_level_bar_set_inverted(GtkLevelBar* self, gboolean inverted)"
  s7_pointer _p;
  s7_pointer self, inverted;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_inverted", 1, self, "GtkLevelBar*");
  inverted = s7_car(_p);
  if (!s7_is_boolean(inverted)) s7_wrong_type_arg_error(sc, "gtk_level_bar_set_inverted", 2, inverted, "gboolean");
  gtk_level_bar_set_inverted((GtkLevelBar*)s7_c_pointer(self), (gboolean)lg_boolean(inverted));
  return(lg_false);
}

static s7_pointer lg_gtk_level_bar_get_inverted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_level_bar_get_inverted "gboolean gtk_level_bar_get_inverted(GtkLevelBar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkLevelBar__sym)) s7_wrong_type_arg_error(sc, "gtk_level_bar_get_inverted", 1, self, "GtkLevelBar*");
  return(s7_make_boolean(sc, gtk_level_bar_get_inverted((GtkLevelBar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_widget_is_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_is_visible "gboolean gtk_widget_is_visible(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_is_visible", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_is_visible((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_icon_view_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_set_activate_on_single_click "void gtk_icon_view_set_activate_on_single_click(GtkIconView* icon_view, \
gboolean single)"
  s7_pointer _p;
  s7_pointer icon_view, single;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_activate_on_single_click", 1, icon_view, "GtkIconView*");
  single = s7_car(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_icon_view_set_activate_on_single_click", 2, single, "gboolean");
  gtk_icon_view_set_activate_on_single_click((GtkIconView*)s7_c_pointer(icon_view), (gboolean)lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_get_activate_on_single_click "gboolean gtk_icon_view_get_activate_on_single_click(GtkIconView* icon_view)"
  s7_pointer icon_view;
  icon_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_get_activate_on_single_click", 1, icon_view, "GtkIconView*");
  return(s7_make_boolean(sc, gtk_icon_view_get_activate_on_single_click((GtkIconView*)s7_c_pointer(icon_view))));
}

static s7_pointer lg_gtk_tree_view_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_activate_on_single_click "gboolean gtk_tree_view_get_activate_on_single_click(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_activate_on_single_click", 1, tree_view, "GtkTreeView*");
  return(s7_make_boolean(sc, gtk_tree_view_get_activate_on_single_click((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_activate_on_single_click "void gtk_tree_view_set_activate_on_single_click(GtkTreeView* tree_view, \
gboolean single)"
  s7_pointer _p;
  s7_pointer tree_view, single;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_activate_on_single_click", 1, tree_view, "GtkTreeView*");
  single = s7_car(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_activate_on_single_click", 2, single, "gboolean");
  gtk_tree_view_set_activate_on_single_click((GtkTreeView*)s7_c_pointer(tree_view), (gboolean)lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_opacity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_opacity "void gtk_widget_set_opacity(GtkWidget* widget, double opacity)"
  s7_pointer _p;
  s7_pointer widget, opacity;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_opacity", 1, widget, "GtkWidget*");
  opacity = s7_car(_p);
  if (!s7_is_real(opacity)) s7_wrong_type_arg_error(sc, "gtk_widget_set_opacity", 2, opacity, "double");
  gtk_widget_set_opacity((GtkWidget*)s7_c_pointer(widget), (double)s7_real(opacity));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_opacity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_opacity "double gtk_widget_get_opacity(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_opacity", 1, widget, "GtkWidget*");
  return(s7_make_real(sc, gtk_widget_get_opacity((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_pango_font_map_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_pango_font_map_changed "void pango_font_map_changed(PangoFontMap* fontmap)"
  s7_pointer fontmap;
  fontmap = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "pango_font_map_changed", 1, fontmap, "PangoFontMap*");
  pango_font_map_changed((PangoFontMap*)s7_c_pointer(fontmap));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static s7_pointer lg_gtk_box_set_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_set_baseline_position "void gtk_box_set_baseline_position(GtkBox* box, GtkBaselinePosition position)"
  s7_pointer _p;
  s7_pointer box, position;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_set_baseline_position", 1, box, "GtkBox*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_box_set_baseline_position", 2, position, "GtkBaselinePosition");
  gtk_box_set_baseline_position((GtkBox*)s7_c_pointer(box), (GtkBaselinePosition)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_box_get_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_get_baseline_position "GtkBaselinePosition gtk_box_get_baseline_position(GtkBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_get_baseline_position", 1, box, "GtkBox*");
  return(s7_make_integer(sc, gtk_box_get_baseline_position((GtkBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_grid_remove_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_remove_row "void gtk_grid_remove_row(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_row", 1, grid, "GtkGrid*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_row", 2, position, "gint");
  gtk_grid_remove_row((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_remove_column(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_remove_column "void gtk_grid_remove_column(GtkGrid* grid, gint position)"
  s7_pointer _p;
  s7_pointer grid, position;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_column", 1, grid, "GtkGrid*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_grid_remove_column", 2, position, "gint");
  gtk_grid_remove_column((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_set_row_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_row_baseline_position "void gtk_grid_set_row_baseline_position(GtkGrid* grid, \
gint row, GtkBaselinePosition pos)"
  s7_pointer _p;
  s7_pointer grid, row, pos;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_baseline_position", 1, grid, "GtkGrid*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_baseline_position", 2, row, "gint");
  pos = s7_car(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_grid_set_row_baseline_position", 3, pos, "GtkBaselinePosition");
  gtk_grid_set_row_baseline_position((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(row), (GtkBaselinePosition)s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_row_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_row_baseline_position "GtkBaselinePosition gtk_grid_get_row_baseline_position(GtkGrid* grid, \
gint row)"
  s7_pointer _p;
  s7_pointer grid, row;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_baseline_position", 1, grid, "GtkGrid*");
  row = s7_car(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_get_row_baseline_position", 2, row, "gint");
  return(s7_make_integer(sc, gtk_grid_get_row_baseline_position((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(row))));
}

static s7_pointer lg_gtk_grid_set_baseline_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_set_baseline_row "void gtk_grid_set_baseline_row(GtkGrid* grid, gint row)"
  s7_pointer _p;
  s7_pointer grid, row;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_set_baseline_row", 1, grid, "GtkGrid*");
  row = s7_car(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_set_baseline_row", 2, row, "gint");
  gtk_grid_set_baseline_row((GtkGrid*)s7_c_pointer(grid), (gint)s7_integer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_get_baseline_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_get_baseline_row "gint gtk_grid_get_baseline_row(GtkGrid* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_get_baseline_row", 1, grid, "GtkGrid*");
  return(s7_make_integer(sc, gtk_grid_get_baseline_row((GtkGrid*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_widget_get_allocated_baseline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_allocated_baseline "int gtk_widget_get_allocated_baseline(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_allocated_baseline", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_allocated_baseline((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_init_template(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_init_template "void gtk_widget_init_template(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_init_template", 1, widget, "GtkWidget*");
  gtk_widget_init_template((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_set_titlebar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_titlebar "void gtk_window_set_titlebar(GtkWindow* window, GtkWidget* titlebar)"
  s7_pointer _p;
  s7_pointer window, titlebar;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_titlebar", 1, window, "GtkWindow*");
  titlebar = s7_car(_p);
  if (!s7_is_c_pointer_of_type(titlebar, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_titlebar", 2, titlebar, "GtkWidget*");
  gtk_window_set_titlebar((GtkWindow*)s7_c_pointer(window), (GtkWidget*)s7_c_pointer(titlebar));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_switcher_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_switcher_new "GtkWidget* gtk_stack_switcher_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_stack_switcher_new()));
}

static s7_pointer lg_gtk_stack_switcher_set_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_switcher_set_stack "void gtk_stack_switcher_set_stack(GtkStackSwitcher* switcher, \
GtkStack* stack)"
  s7_pointer _p;
  s7_pointer switcher, stack;
  _p = args;
  switcher = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(switcher, GtkStackSwitcher__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_switcher_set_stack", 1, switcher, "GtkStackSwitcher*");
  stack = s7_car(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_switcher_set_stack", 2, stack, "GtkStack*");
  gtk_stack_switcher_set_stack((GtkStackSwitcher*)s7_c_pointer(switcher), (GtkStack*)s7_c_pointer(stack));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_switcher_get_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_switcher_get_stack "GtkStack* gtk_stack_switcher_get_stack(GtkStackSwitcher* switcher)"
  s7_pointer switcher;
  switcher = s7_car(args);
  if (!s7_is_c_pointer_of_type(switcher, GtkStackSwitcher__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_switcher_get_stack", 1, switcher, "GtkStackSwitcher*");
  return(lg_make_c_pointer_with_type(sc, GtkStack__sym, gtk_stack_switcher_get_stack((GtkStackSwitcher*)s7_c_pointer(switcher))));
}

static s7_pointer lg_gtk_stack_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_new "GtkWidget* gtk_stack_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_stack_new()));
}

static s7_pointer lg_gtk_stack_set_visible_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_visible_child "void gtk_stack_set_visible_child(GtkStack* stack, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer stack, child;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child", 1, stack, "GtkStack*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child", 2, child, "GtkWidget*");
  gtk_stack_set_visible_child((GtkStack*)s7_c_pointer(stack), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_visible_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_visible_child "GtkWidget* gtk_stack_get_visible_child(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_visible_child", 1, stack, "GtkStack*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_stack_get_visible_child((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_visible_child_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_visible_child_name "void gtk_stack_set_visible_child_name(GtkStack* stack, \
gchar* name)"
  s7_pointer _p;
  s7_pointer stack, name;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_name", 1, stack, "GtkStack*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_name", 2, name, "gchar*");
  gtk_stack_set_visible_child_name((GtkStack*)s7_c_pointer(stack), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_visible_child_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_visible_child_name "gchar* gtk_stack_get_visible_child_name(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_visible_child_name", 1, stack, "GtkStack*");
  return(s7_make_string(sc, gtk_stack_get_visible_child_name((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_visible_child_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_visible_child_full "void gtk_stack_set_visible_child_full(GtkStack* stack, \
gchar* name, GtkStackTransitionType transition)"
  s7_pointer _p;
  s7_pointer stack, name, transition;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_full", 1, stack, "GtkStack*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_full", 2, name, "gchar*");
  transition = s7_car(_p);
  if (!s7_is_integer(transition)) s7_wrong_type_arg_error(sc, "gtk_stack_set_visible_child_full", 3, transition, "GtkStackTransitionType");
  gtk_stack_set_visible_child_full((GtkStack*)s7_c_pointer(stack), (const gchar*)s7_string(name), (GtkStackTransitionType)s7_integer(transition));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_homogeneous "void gtk_stack_set_homogeneous(GtkStack* stack, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer stack, homogeneous;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_homogeneous", 1, stack, "GtkStack*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_stack_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_stack_set_homogeneous((GtkStack*)s7_c_pointer(stack), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_homogeneous "gboolean gtk_stack_get_homogeneous(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_homogeneous", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_homogeneous((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_transition_duration "void gtk_stack_set_transition_duration(GtkStack* stack, \
guint duration)"
  s7_pointer _p;
  s7_pointer stack, duration;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_duration", 1, stack, "GtkStack*");
  duration = s7_car(_p);
  if (!s7_is_integer(duration)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_duration", 2, duration, "guint");
  gtk_stack_set_transition_duration((GtkStack*)s7_c_pointer(stack), (guint)s7_integer(duration));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_transition_duration "guint gtk_stack_get_transition_duration(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_transition_duration", 1, stack, "GtkStack*");
  return(s7_make_integer(sc, gtk_stack_get_transition_duration((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_transition_type "void gtk_stack_set_transition_type(GtkStack* stack, GtkStackTransitionType transition)"
  s7_pointer _p;
  s7_pointer stack, transition;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_type", 1, stack, "GtkStack*");
  transition = s7_car(_p);
  if (!s7_is_integer(transition)) s7_wrong_type_arg_error(sc, "gtk_stack_set_transition_type", 2, transition, "GtkStackTransitionType");
  gtk_stack_set_transition_type((GtkStack*)s7_c_pointer(stack), (GtkStackTransitionType)s7_integer(transition));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_transition_type "GtkStackTransitionType gtk_stack_get_transition_type(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_transition_type", 1, stack, "GtkStack*");
  return(s7_make_integer(sc, gtk_stack_get_transition_type((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_revealer_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_new "GtkWidget* gtk_revealer_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_revealer_new()));
}

static s7_pointer lg_gtk_revealer_get_reveal_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_reveal_child "gboolean gtk_revealer_get_reveal_child(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_reveal_child", 1, revealer, "GtkRevealer*");
  return(s7_make_boolean(sc, gtk_revealer_get_reveal_child((GtkRevealer*)s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_revealer_set_reveal_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_set_reveal_child "void gtk_revealer_set_reveal_child(GtkRevealer* revealer, \
gboolean reveal_child)"
  s7_pointer _p;
  s7_pointer revealer, reveal_child;
  _p = args;
  revealer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_reveal_child", 1, revealer, "GtkRevealer*");
  reveal_child = s7_car(_p);
  if (!s7_is_boolean(reveal_child)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_reveal_child", 2, reveal_child, "gboolean");
  gtk_revealer_set_reveal_child((GtkRevealer*)s7_c_pointer(revealer), (gboolean)lg_boolean(reveal_child));
  return(lg_false);
}

static s7_pointer lg_gtk_revealer_get_child_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_child_revealed "gboolean gtk_revealer_get_child_revealed(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_child_revealed", 1, revealer, "GtkRevealer*");
  return(s7_make_boolean(sc, gtk_revealer_get_child_revealed((GtkRevealer*)s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_revealer_get_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_transition_duration "guint gtk_revealer_get_transition_duration(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_transition_duration", 1, revealer, "GtkRevealer*");
  return(s7_make_integer(sc, gtk_revealer_get_transition_duration((GtkRevealer*)s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_revealer_set_transition_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_set_transition_duration "void gtk_revealer_set_transition_duration(GtkRevealer* revealer, \
guint duration)"
  s7_pointer _p;
  s7_pointer revealer, duration;
  _p = args;
  revealer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_duration", 1, revealer, "GtkRevealer*");
  duration = s7_car(_p);
  if (!s7_is_integer(duration)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_duration", 2, duration, "guint");
  gtk_revealer_set_transition_duration((GtkRevealer*)s7_c_pointer(revealer), (guint)s7_integer(duration));
  return(lg_false);
}

static s7_pointer lg_gtk_revealer_set_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_set_transition_type "void gtk_revealer_set_transition_type(GtkRevealer* revealer, \
GtkRevealerTransitionType transition)"
  s7_pointer _p;
  s7_pointer revealer, transition;
  _p = args;
  revealer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_type", 1, revealer, "GtkRevealer*");
  transition = s7_car(_p);
  if (!s7_is_integer(transition)) s7_wrong_type_arg_error(sc, "gtk_revealer_set_transition_type", 2, transition, "GtkRevealerTransitionType");
  gtk_revealer_set_transition_type((GtkRevealer*)s7_c_pointer(revealer), (GtkRevealerTransitionType)s7_integer(transition));
  return(lg_false);
}

static s7_pointer lg_gtk_revealer_get_transition_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_revealer_get_transition_type "GtkRevealerTransitionType gtk_revealer_get_transition_type(GtkRevealer* revealer)"
  s7_pointer revealer;
  revealer = s7_car(args);
  if (!s7_is_c_pointer_of_type(revealer, GtkRevealer__sym)) s7_wrong_type_arg_error(sc, "gtk_revealer_get_transition_type", 1, revealer, "GtkRevealer*");
  return(s7_make_integer(sc, gtk_revealer_get_transition_type((GtkRevealer*)s7_c_pointer(revealer))));
}

static s7_pointer lg_gtk_header_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_new "GtkWidget* gtk_header_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_header_bar_new()));
}

static s7_pointer lg_gtk_header_bar_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_title "void gtk_header_bar_set_title(GtkHeaderBar* bar, gchar* title)"
  s7_pointer _p;
  s7_pointer bar, title;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_title", 1, bar, "GtkHeaderBar*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_title", 2, title, "gchar*");
  gtk_header_bar_set_title((GtkHeaderBar*)s7_c_pointer(bar), (const gchar*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_title "gchar* gtk_header_bar_get_title(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_title", 1, bar, "GtkHeaderBar*");
  return(s7_make_string(sc, gtk_header_bar_get_title((GtkHeaderBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_subtitle "void gtk_header_bar_set_subtitle(GtkHeaderBar* bar, gchar* subtitle)"
  s7_pointer _p;
  s7_pointer bar, subtitle;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_subtitle", 1, bar, "GtkHeaderBar*");
  subtitle = s7_car(_p);
  if (!s7_is_string(subtitle)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_subtitle", 2, subtitle, "gchar*");
  gtk_header_bar_set_subtitle((GtkHeaderBar*)s7_c_pointer(bar), (const gchar*)s7_string(subtitle));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_subtitle "gchar* gtk_header_bar_get_subtitle(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_subtitle", 1, bar, "GtkHeaderBar*");
  return(s7_make_string(sc, gtk_header_bar_get_subtitle((GtkHeaderBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_custom_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_custom_title "void gtk_header_bar_set_custom_title(GtkHeaderBar* bar, \
GtkWidget* title_widget)"
  s7_pointer _p;
  s7_pointer bar, title_widget;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_custom_title", 1, bar, "GtkHeaderBar*");
  title_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(title_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_custom_title", 2, title_widget, "GtkWidget*");
  gtk_header_bar_set_custom_title((GtkHeaderBar*)s7_c_pointer(bar), (GtkWidget*)s7_c_pointer(title_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_custom_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_custom_title "GtkWidget* gtk_header_bar_get_custom_title(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_custom_title", 1, bar, "GtkHeaderBar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_header_bar_get_custom_title((GtkHeaderBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_pack_start "void gtk_header_bar_pack_start(GtkHeaderBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_start", 1, bar, "GtkHeaderBar*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_start", 2, child, "GtkWidget*");
  gtk_header_bar_pack_start((GtkHeaderBar*)s7_c_pointer(bar), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_pack_end "void gtk_header_bar_pack_end(GtkHeaderBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_end", 1, bar, "GtkHeaderBar*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_pack_end", 2, child, "GtkWidget*");
  gtk_header_bar_pack_end((GtkHeaderBar*)s7_c_pointer(bar), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_new "GtkWidget* gtk_list_box_row_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_list_box_row_new()));
}

static s7_pointer lg_gtk_list_box_row_get_header(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_header "GtkWidget* gtk_list_box_row_get_header(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_header", 1, row, "GtkListBoxRow*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_list_box_row_get_header((GtkListBoxRow*)s7_c_pointer(row))));
}

static s7_pointer lg_gtk_list_box_row_set_header(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_set_header "void gtk_list_box_row_set_header(GtkListBoxRow* row, GtkWidget* header)"
  s7_pointer _p;
  s7_pointer row, header;
  _p = args;
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_header", 1, row, "GtkListBoxRow*");
  header = s7_car(_p);
  if (!s7_is_c_pointer_of_type(header, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_header", 2, header, "GtkWidget*");
  gtk_list_box_row_set_header((GtkListBoxRow*)s7_c_pointer(row), (GtkWidget*)s7_c_pointer(header));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_changed "void gtk_list_box_row_changed(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_changed", 1, row, "GtkListBoxRow*");
  gtk_list_box_row_changed((GtkListBoxRow*)s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_selected_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_selected_row "GtkListBoxRow* gtk_list_box_get_selected_row(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_selected_row", 1, list_box, "GtkListBox*");
  return(lg_make_c_pointer_with_type(sc, GtkListBoxRow__sym, gtk_list_box_get_selected_row((GtkListBox*)s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_get_row_at_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_row_at_index "GtkListBoxRow* gtk_list_box_get_row_at_index(GtkListBox* list_box, \
gint index_)"
  s7_pointer _p;
  s7_pointer list_box, index_;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_index", 1, list_box, "GtkListBox*");
  index_ = s7_car(_p);
  if (!s7_is_integer(index_)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_index", 2, index_, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkListBoxRow__sym, gtk_list_box_get_row_at_index((GtkListBox*)s7_c_pointer(list_box), (gint)s7_integer(index_))));
}

static s7_pointer lg_gtk_list_box_get_row_at_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_row_at_y "GtkListBoxRow* gtk_list_box_get_row_at_y(GtkListBox* list_box, \
gint y)"
  s7_pointer _p;
  s7_pointer list_box, y;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_y", 1, list_box, "GtkListBox*");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_row_at_y", 2, y, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkListBoxRow__sym, gtk_list_box_get_row_at_y((GtkListBox*)s7_c_pointer(list_box), (gint)s7_integer(y))));
}

static s7_pointer lg_gtk_list_box_select_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_select_row "void gtk_list_box_select_row(GtkListBox* list_box, GtkListBoxRow* row)"
  s7_pointer _p;
  s7_pointer list_box, row;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_select_row", 1, list_box, "GtkListBox*");
  row = s7_car(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_select_row", 2, row, "GtkListBoxRow*");
  gtk_list_box_select_row((GtkListBox*)s7_c_pointer(list_box), (GtkListBoxRow*)s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_set_placeholder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_placeholder "void gtk_list_box_set_placeholder(GtkListBox* list_box, GtkWidget* placeholder)"
  s7_pointer _p;
  s7_pointer list_box, placeholder;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_placeholder", 1, list_box, "GtkListBox*");
  placeholder = s7_car(_p);
  if (!s7_is_c_pointer_of_type(placeholder, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_placeholder", 2, placeholder, "GtkWidget*");
  gtk_list_box_set_placeholder((GtkListBox*)s7_c_pointer(list_box), (GtkWidget*)s7_c_pointer(placeholder));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_adjustment "void gtk_list_box_set_adjustment(GtkListBox* list_box, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer list_box, adjustment;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_adjustment", 1, list_box, "GtkListBox*");
  adjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_list_box_set_adjustment((GtkListBox*)s7_c_pointer(list_box), (GtkAdjustment*)s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_adjustment "GtkAdjustment* gtk_list_box_get_adjustment(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_adjustment", 1, list_box, "GtkListBox*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_list_box_get_adjustment((GtkListBox*)s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_set_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_selection_mode "void gtk_list_box_set_selection_mode(GtkListBox* list_box, \
GtkSelectionMode mode)"
  s7_pointer _p;
  s7_pointer list_box, mode;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_selection_mode", 1, list_box, "GtkListBox*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_selection_mode", 2, mode, "GtkSelectionMode");
  gtk_list_box_set_selection_mode((GtkListBox*)s7_c_pointer(list_box), (GtkSelectionMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_selection_mode "GtkSelectionMode gtk_list_box_get_selection_mode(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_selection_mode", 1, list_box, "GtkListBox*");
  return(s7_make_integer(sc, gtk_list_box_get_selection_mode((GtkListBox*)s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_invalidate_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_invalidate_filter "void gtk_list_box_invalidate_filter(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_invalidate_filter", 1, list_box, "GtkListBox*");
  gtk_list_box_invalidate_filter((GtkListBox*)s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_invalidate_sort(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_invalidate_sort "void gtk_list_box_invalidate_sort(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_invalidate_sort", 1, list_box, "GtkListBox*");
  gtk_list_box_invalidate_sort((GtkListBox*)s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_invalidate_headers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_invalidate_headers "void gtk_list_box_invalidate_headers(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_invalidate_headers", 1, list_box, "GtkListBox*");
  gtk_list_box_invalidate_headers((GtkListBox*)s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_activate_on_single_click "void gtk_list_box_set_activate_on_single_click(GtkListBox* list_box, \
gboolean single)"
  s7_pointer _p;
  s7_pointer list_box, single;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_activate_on_single_click", 1, list_box, "GtkListBox*");
  single = s7_car(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_activate_on_single_click", 2, single, "gboolean");
  gtk_list_box_set_activate_on_single_click((GtkListBox*)s7_c_pointer(list_box), (gboolean)lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_activate_on_single_click "gboolean gtk_list_box_get_activate_on_single_click(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_activate_on_single_click", 1, list_box, "GtkListBox*");
  return(s7_make_boolean(sc, gtk_list_box_get_activate_on_single_click((GtkListBox*)s7_c_pointer(list_box))));
}

static s7_pointer lg_gtk_list_box_drag_unhighlight_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_drag_unhighlight_row "void gtk_list_box_drag_unhighlight_row(GtkListBox* list_box)"
  s7_pointer list_box;
  list_box = s7_car(args);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_drag_unhighlight_row", 1, list_box, "GtkListBox*");
  gtk_list_box_drag_unhighlight_row((GtkListBox*)s7_c_pointer(list_box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_drag_highlight_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_drag_highlight_row "void gtk_list_box_drag_highlight_row(GtkListBox* list_box, \
GtkListBoxRow* row)"
  s7_pointer _p;
  s7_pointer list_box, row;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_drag_highlight_row", 1, list_box, "GtkListBox*");
  row = s7_car(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_drag_highlight_row", 2, row, "GtkListBoxRow*");
  gtk_list_box_drag_highlight_row((GtkListBox*)s7_c_pointer(list_box), (GtkListBoxRow*)s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_new "GtkWidget* gtk_list_box_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_list_box_new()));
}

static s7_pointer lg_gtk_search_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_new "GtkWidget* gtk_search_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_search_bar_new()));
}

static s7_pointer lg_gtk_search_bar_get_search_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_get_search_mode "gboolean gtk_search_bar_get_search_mode(GtkSearchBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_get_search_mode", 1, bar, "GtkSearchBar*");
  return(s7_make_boolean(sc, gtk_search_bar_get_search_mode((GtkSearchBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_search_bar_set_search_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_set_search_mode "void gtk_search_bar_set_search_mode(GtkSearchBar* bar, gboolean search_mode)"
  s7_pointer _p;
  s7_pointer bar, search_mode;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_set_search_mode", 1, bar, "GtkSearchBar*");
  search_mode = s7_car(_p);
  if (!s7_is_boolean(search_mode)) s7_wrong_type_arg_error(sc, "gtk_search_bar_set_search_mode", 2, search_mode, "gboolean");
  gtk_search_bar_set_search_mode((GtkSearchBar*)s7_c_pointer(bar), (gboolean)lg_boolean(search_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_current_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_current_name "gchar* gtk_file_chooser_get_current_name(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_current_name", 1, chooser, "GtkFileChooser*");
  return(s7_make_string(sc, gtk_file_chooser_get_current_name((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_list_box_row_get_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_index "gint gtk_list_box_row_get_index(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_index", 1, row, "GtkListBoxRow*");
  return(s7_make_integer(sc, gtk_list_box_row_get_index((GtkListBoxRow*)s7_c_pointer(row))));
}

static s7_pointer lg_gtk_widget_get_scale_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_scale_factor "gint gtk_widget_get_scale_factor(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_scale_factor", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_scale_factor((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_window_close(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_close "void gtk_window_close(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_close", 1, window, "GtkWindow*");
  gtk_window_close((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_set_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_show_close_button "void gtk_info_bar_set_show_close_button(GtkInfoBar* info_bar, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer info_bar, setting;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_show_close_button", 1, info_bar, "GtkInfoBar*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_show_close_button", 2, setting, "gboolean");
  gtk_info_bar_set_show_close_button((GtkInfoBar*)s7_c_pointer(info_bar), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_get_show_close_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_show_close_button "gboolean gtk_info_bar_get_show_close_button(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_show_close_button", 1, info_bar, "GtkInfoBar*");
  return(s7_make_boolean(sc, gtk_info_bar_get_show_close_button((GtkInfoBar*)s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_tree_model_rows_reordered_with_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_model_rows_reordered_with_length "void gtk_tree_model_rows_reordered_with_length(GtkTreeModel* tree_model, \
GtkTreePath* path, GtkTreeIter* iter, gint* new_order, gint length)"
  s7_pointer _p;
  s7_pointer tree_model, path, iter, new_order, length;
  _p = args;
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 1, tree_model, "GtkTreeModel*");
  path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 2, path, "GtkTreePath*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTreeIter__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 3, iter, "GtkTreeIter*");
  new_order = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(new_order, gint__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 4, new_order, "gint*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_tree_model_rows_reordered_with_length", 5, length, "gint");
  gtk_tree_model_rows_reordered_with_length((GtkTreeModel*)s7_c_pointer(tree_model), (GtkTreePath*)s7_c_pointer(path), (GtkTreeIter*)s7_c_pointer(iter), (gint*)s7_c_pointer(new_order), (gint)s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_event_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_event_type "GdkEventType gdk_event_get_event_type(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_event_type", 1, event, "GdkEvent*");
  return(s7_make_integer(sc, gdk_event_get_event_type((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_entry_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_tabs "void gtk_entry_set_tabs(GtkEntry* entry, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer entry, tabs;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_tabs", 1, entry, "GtkEntry*");
  tabs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_tabs", 2, tabs, "PangoTabArray*");
  gtk_entry_set_tabs((GtkEntry*)s7_c_pointer(entry), (PangoTabArray*)s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_tabs "PangoTabArray* gtk_entry_get_tabs(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_tabs", 1, entry, "GtkEntry*");
  return(lg_make_c_pointer_with_type(sc, PangoTabArray__sym, gtk_entry_get_tabs((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_list_box_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_prepend "void gtk_list_box_prepend(GtkListBox* list_box, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer list_box, child;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_prepend", 1, list_box, "GtkListBox*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_prepend", 2, child, "GtkWidget*");
  gtk_list_box_prepend((GtkListBox*)s7_c_pointer(list_box), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_insert "void gtk_list_box_insert(GtkListBox* list_box, GtkWidget* child, gint position)"
  s7_pointer _p;
  s7_pointer list_box, child, position;
  _p = args;
  list_box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(list_box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_insert", 1, list_box, "GtkListBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_insert", 2, child, "GtkWidget*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_list_box_insert", 3, position, "gint");
  gtk_list_box_insert((GtkListBox*)s7_c_pointer(list_box), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_lines "void gtk_label_set_lines(GtkLabel* label, gint lines)"
  s7_pointer _p;
  s7_pointer label, lines;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_lines", 1, label, "GtkLabel*");
  lines = s7_car(_p);
  if (!s7_is_integer(lines)) s7_wrong_type_arg_error(sc, "gtk_label_set_lines", 2, lines, "gint");
  gtk_label_set_lines((GtkLabel*)s7_c_pointer(label), (gint)s7_integer(lines));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_lines(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_lines "gint gtk_label_get_lines(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_lines", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_lines((GtkLabel*)s7_c_pointer(label))));
}

#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static s7_pointer lg_gtk_flow_box_child_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_new "GtkWidget* gtk_flow_box_child_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_flow_box_child_new()));
}

static s7_pointer lg_gtk_flow_box_child_get_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_get_index "gint gtk_flow_box_child_get_index(GtkFlowBoxChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_child_get_index", 1, child, "GtkFlowBoxChild*");
  return(s7_make_integer(sc, gtk_flow_box_child_get_index((GtkFlowBoxChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_flow_box_child_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_is_selected "gboolean gtk_flow_box_child_is_selected(GtkFlowBoxChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_child_is_selected", 1, child, "GtkFlowBoxChild*");
  return(s7_make_boolean(sc, gtk_flow_box_child_is_selected((GtkFlowBoxChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_flow_box_child_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_child_changed "void gtk_flow_box_child_changed(GtkFlowBoxChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_child_changed", 1, child, "GtkFlowBoxChild*");
  gtk_flow_box_child_changed((GtkFlowBoxChild*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_new "GtkWidget* gtk_flow_box_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_flow_box_new()));
}

static s7_pointer lg_gtk_flow_box_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_homogeneous "void gtk_flow_box_set_homogeneous(GtkFlowBox* box, gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer box, homogeneous;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_homogeneous", 1, box, "GtkFlowBox*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_flow_box_set_homogeneous((GtkFlowBox*)s7_c_pointer(box), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_homogeneous "gboolean gtk_flow_box_get_homogeneous(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_homogeneous", 1, box, "GtkFlowBox*");
  return(s7_make_boolean(sc, gtk_flow_box_get_homogeneous((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_row_spacing "void gtk_flow_box_set_row_spacing(GtkFlowBox* box, guint spacing)"
  s7_pointer _p;
  s7_pointer box, spacing;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_row_spacing", 1, box, "GtkFlowBox*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_row_spacing", 2, spacing, "guint");
  gtk_flow_box_set_row_spacing((GtkFlowBox*)s7_c_pointer(box), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_row_spacing "guint gtk_flow_box_get_row_spacing(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_row_spacing", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_row_spacing((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_column_spacing "void gtk_flow_box_set_column_spacing(GtkFlowBox* box, guint spacing)"
  s7_pointer _p;
  s7_pointer box, spacing;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_column_spacing", 1, box, "GtkFlowBox*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_column_spacing", 2, spacing, "guint");
  gtk_flow_box_set_column_spacing((GtkFlowBox*)s7_c_pointer(box), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_column_spacing "guint gtk_flow_box_get_column_spacing(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_column_spacing", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_column_spacing((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_min_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_min_children_per_line "void gtk_flow_box_set_min_children_per_line(GtkFlowBox* box, \
guint n_children)"
  s7_pointer _p;
  s7_pointer box, n_children;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_min_children_per_line", 1, box, "GtkFlowBox*");
  n_children = s7_car(_p);
  if (!s7_is_integer(n_children)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_min_children_per_line", 2, n_children, "guint");
  gtk_flow_box_set_min_children_per_line((GtkFlowBox*)s7_c_pointer(box), (guint)s7_integer(n_children));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_min_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_min_children_per_line "guint gtk_flow_box_get_min_children_per_line(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_min_children_per_line", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_min_children_per_line((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_max_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_max_children_per_line "void gtk_flow_box_set_max_children_per_line(GtkFlowBox* box, \
guint n_children)"
  s7_pointer _p;
  s7_pointer box, n_children;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_max_children_per_line", 1, box, "GtkFlowBox*");
  n_children = s7_car(_p);
  if (!s7_is_integer(n_children)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_max_children_per_line", 2, n_children, "guint");
  gtk_flow_box_set_max_children_per_line((GtkFlowBox*)s7_c_pointer(box), (guint)s7_integer(n_children));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_max_children_per_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_max_children_per_line "guint gtk_flow_box_get_max_children_per_line(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_max_children_per_line", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_max_children_per_line((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_activate_on_single_click "void gtk_flow_box_set_activate_on_single_click(GtkFlowBox* box, \
gboolean single)"
  s7_pointer _p;
  s7_pointer box, single;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_activate_on_single_click", 1, box, "GtkFlowBox*");
  single = s7_car(_p);
  if (!s7_is_boolean(single)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_activate_on_single_click", 2, single, "gboolean");
  gtk_flow_box_set_activate_on_single_click((GtkFlowBox*)s7_c_pointer(box), (gboolean)lg_boolean(single));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_activate_on_single_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_activate_on_single_click "gboolean gtk_flow_box_get_activate_on_single_click(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_activate_on_single_click", 1, box, "GtkFlowBox*");
  return(s7_make_boolean(sc, gtk_flow_box_get_activate_on_single_click((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_insert "void gtk_flow_box_insert(GtkFlowBox* box, GtkWidget* widget, gint position)"
  s7_pointer _p;
  s7_pointer box, widget, position;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_insert", 1, box, "GtkFlowBox*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_insert", 2, widget, "GtkWidget*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_flow_box_insert", 3, position, "gint");
  gtk_flow_box_insert((GtkFlowBox*)s7_c_pointer(box), (GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_child_at_index(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_child_at_index "GtkFlowBoxChild* gtk_flow_box_get_child_at_index(GtkFlowBox* box, \
gint idx)"
  s7_pointer _p;
  s7_pointer box, idx;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_index", 1, box, "GtkFlowBox*");
  idx = s7_car(_p);
  if (!s7_is_integer(idx)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_index", 2, idx, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkFlowBoxChild__sym, gtk_flow_box_get_child_at_index((GtkFlowBox*)s7_c_pointer(box), (gint)s7_integer(idx))));
}

static s7_pointer lg_gtk_flow_box_get_selected_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_selected_children "GList* gtk_flow_box_get_selected_children(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_selected_children", 1, box, "GtkFlowBox*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_flow_box_get_selected_children((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_select_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_select_child "void gtk_flow_box_select_child(GtkFlowBox* box, GtkFlowBoxChild* child)"
  s7_pointer _p;
  s7_pointer box, child;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_select_child", 1, box, "GtkFlowBox*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_select_child", 2, child, "GtkFlowBoxChild*");
  gtk_flow_box_select_child((GtkFlowBox*)s7_c_pointer(box), (GtkFlowBoxChild*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_unselect_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_unselect_child "void gtk_flow_box_unselect_child(GtkFlowBox* box, GtkFlowBoxChild* child)"
  s7_pointer _p;
  s7_pointer box, child;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_unselect_child", 1, box, "GtkFlowBox*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkFlowBoxChild__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_unselect_child", 2, child, "GtkFlowBoxChild*");
  gtk_flow_box_unselect_child((GtkFlowBox*)s7_c_pointer(box), (GtkFlowBoxChild*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_select_all "void gtk_flow_box_select_all(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_select_all", 1, box, "GtkFlowBox*");
  gtk_flow_box_select_all((GtkFlowBox*)s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_unselect_all "void gtk_flow_box_unselect_all(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_unselect_all", 1, box, "GtkFlowBox*");
  gtk_flow_box_unselect_all((GtkFlowBox*)s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_set_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_selection_mode "void gtk_flow_box_set_selection_mode(GtkFlowBox* box, GtkSelectionMode mode)"
  s7_pointer _p;
  s7_pointer box, mode;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_selection_mode", 1, box, "GtkFlowBox*");
  mode = s7_car(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_selection_mode", 2, mode, "GtkSelectionMode");
  gtk_flow_box_set_selection_mode((GtkFlowBox*)s7_c_pointer(box), (GtkSelectionMode)s7_integer(mode));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_get_selection_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_selection_mode "GtkSelectionMode gtk_flow_box_get_selection_mode(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_selection_mode", 1, box, "GtkFlowBox*");
  return(s7_make_integer(sc, gtk_flow_box_get_selection_mode((GtkFlowBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_flow_box_set_hadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_hadjustment "void gtk_flow_box_set_hadjustment(GtkFlowBox* box, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer box, adjustment;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_hadjustment", 1, box, "GtkFlowBox*");
  adjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_hadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_flow_box_set_hadjustment((GtkFlowBox*)s7_c_pointer(box), (GtkAdjustment*)s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_set_vadjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_set_vadjustment "void gtk_flow_box_set_vadjustment(GtkFlowBox* box, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer box, adjustment;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_vadjustment", 1, box, "GtkFlowBox*");
  adjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_set_vadjustment", 2, adjustment, "GtkAdjustment*");
  gtk_flow_box_set_vadjustment((GtkFlowBox*)s7_c_pointer(box), (GtkAdjustment*)s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_invalidate_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_invalidate_filter "void gtk_flow_box_invalidate_filter(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_invalidate_filter", 1, box, "GtkFlowBox*");
  gtk_flow_box_invalidate_filter((GtkFlowBox*)s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_flow_box_invalidate_sort(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_invalidate_sort "void gtk_flow_box_invalidate_sort(GtkFlowBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_invalidate_sort", 1, box, "GtkFlowBox*");
  gtk_flow_box_invalidate_sort((GtkFlowBox*)s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_transition_running(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_transition_running "gboolean gtk_stack_get_transition_running(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_transition_running", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_transition_running((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_widget_get_margin_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_start "gint gtk_widget_get_margin_start(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_start", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_start((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_start "void gtk_widget_set_margin_start(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_start", 1, widget, "GtkWidget*");
  margin = s7_car(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_start", 2, margin, "gint");
  gtk_widget_set_margin_start((GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_margin_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_margin_end "gint gtk_widget_get_margin_end(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_margin_end", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_margin_end((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_margin_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_margin_end "void gtk_widget_set_margin_end(GtkWidget* widget, gint margin)"
  s7_pointer _p;
  s7_pointer widget, margin;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_end", 1, widget, "GtkWidget*");
  margin = s7_car(_p);
  if (!s7_is_integer(margin)) s7_wrong_type_arg_error(sc, "gtk_widget_set_margin_end", 2, margin, "gint");
  gtk_widget_set_margin_end((GtkWidget*)s7_c_pointer(widget), (gint)s7_integer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_accel "void gtk_accel_label_get_accel(GtkAccelLabel* accel_label, guint* [accelerator_key], \
GdkModifierType* [accelerator_mods])"
  s7_pointer _p;
  s7_pointer accel_label;
  guint ref_accelerator_key;
  GdkModifierType ref_accelerator_mods;
  _p = args;
  accel_label = s7_car(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_accel", 1, accel_label, "GtkAccelLabel*");
  gtk_accel_label_get_accel((GtkAccelLabel*)s7_c_pointer(accel_label), &ref_accelerator_key, &ref_accelerator_mods);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_accelerator_key), s7_make_integer(sc, ref_accelerator_mods)));
}

static s7_pointer lg_gtk_action_bar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_new "GtkWidget* gtk_action_bar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_action_bar_new()));
}

static s7_pointer lg_gtk_action_bar_get_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_get_center_widget "GtkWidget* gtk_action_bar_get_center_widget(GtkActionBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_get_center_widget", 1, bar, "GtkActionBar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_action_bar_get_center_widget((GtkActionBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_action_bar_set_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_set_center_widget "void gtk_action_bar_set_center_widget(GtkActionBar* bar, \
GtkWidget* center_widget)"
  s7_pointer _p;
  s7_pointer bar, center_widget;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_center_widget", 1, bar, "GtkActionBar*");
  center_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(center_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_center_widget", 2, center_widget, "GtkWidget*");
  gtk_action_bar_set_center_widget((GtkActionBar*)s7_c_pointer(bar), (GtkWidget*)s7_c_pointer(center_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_pack_start(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_pack_start "void gtk_action_bar_pack_start(GtkActionBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_start", 1, bar, "GtkActionBar*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_start", 2, child, "GtkWidget*");
  gtk_action_bar_pack_start((GtkActionBar*)s7_c_pointer(bar), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_pack_end(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_pack_end "void gtk_action_bar_pack_end(GtkActionBar* bar, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer bar, child;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_end", 1, bar, "GtkActionBar*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_pack_end", 2, child, "GtkWidget*");
  gtk_action_bar_pack_end((GtkActionBar*)s7_c_pointer(bar), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_set_has_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_has_subtitle "void gtk_header_bar_set_has_subtitle(GtkHeaderBar* bar, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer bar, setting;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_has_subtitle", 1, bar, "GtkHeaderBar*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_has_subtitle", 2, setting, "gboolean");
  gtk_header_bar_set_has_subtitle((GtkHeaderBar*)s7_c_pointer(bar), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_has_subtitle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_has_subtitle "gboolean gtk_header_bar_get_has_subtitle(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_has_subtitle", 1, bar, "GtkHeaderBar*");
  return(s7_make_boolean(sc, gtk_header_bar_get_has_subtitle((GtkHeaderBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_decoration_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_decoration_layout "void gtk_header_bar_set_decoration_layout(GtkHeaderBar* bar, \
gchar* layout)"
  s7_pointer _p;
  s7_pointer bar, layout;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_decoration_layout", 1, bar, "GtkHeaderBar*");
  layout = s7_car(_p);
  if (!s7_is_string(layout)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_decoration_layout", 2, layout, "gchar*");
  gtk_header_bar_set_decoration_layout((GtkHeaderBar*)s7_c_pointer(bar), (const gchar*)s7_string(layout));
  return(lg_false);
}

static s7_pointer lg_gtk_header_bar_get_decoration_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_decoration_layout "gchar* gtk_header_bar_get_decoration_layout(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_decoration_layout", 1, bar, "GtkHeaderBar*");
  return(s7_make_string(sc, gtk_header_bar_get_decoration_layout((GtkHeaderBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_icon_info_is_symbolic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_is_symbolic "gboolean gtk_icon_info_is_symbolic(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_is_symbolic", 1, icon_info, "GtkIconInfo*");
  return(s7_make_boolean(sc, gtk_icon_info_is_symbolic((GtkIconInfo*)s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_get_locale_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_get_locale_direction "GtkTextDirection gtk_get_locale_direction( void)"
  return(s7_make_integer(sc, gtk_get_locale_direction()));
}

static s7_pointer lg_gtk_window_is_maximized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_is_maximized "gboolean gtk_window_is_maximized(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_is_maximized", 1, window, "GtkWindow*");
  return(s7_make_boolean(sc, gtk_window_is_maximized((GtkWindow*)s7_c_pointer(window))));
}

#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static s7_pointer lg_gtk_list_box_row_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_is_selected "gboolean gtk_list_box_row_is_selected(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_is_selected", 1, row, "GtkListBoxRow*");
  return(s7_make_boolean(sc, gtk_list_box_row_is_selected((GtkListBoxRow*)s7_c_pointer(row))));
}

static s7_pointer lg_gtk_list_box_unselect_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_unselect_row "void gtk_list_box_unselect_row(GtkListBox* box, GtkListBoxRow* row)"
  s7_pointer _p;
  s7_pointer box, row;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_unselect_row", 1, box, "GtkListBox*");
  row = s7_car(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_unselect_row", 2, row, "GtkListBoxRow*");
  gtk_list_box_unselect_row((GtkListBox*)s7_c_pointer(box), (GtkListBoxRow*)s7_c_pointer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_select_all "void gtk_list_box_select_all(GtkListBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_select_all", 1, box, "GtkListBox*");
  gtk_list_box_select_all((GtkListBox*)s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_unselect_all "void gtk_list_box_unselect_all(GtkListBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_unselect_all", 1, box, "GtkListBox*");
  gtk_list_box_unselect_all((GtkListBox*)s7_c_pointer(box));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_set_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_set_state "void gtk_switch_set_state(GtkSwitch* sw, gboolean state)"
  s7_pointer _p;
  s7_pointer sw, state;
  _p = args;
  sw = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_set_state", 1, sw, "GtkSwitch*");
  state = s7_car(_p);
  if (!s7_is_boolean(state)) s7_wrong_type_arg_error(sc, "gtk_switch_set_state", 2, state, "gboolean");
  gtk_switch_set_state((GtkSwitch*)s7_c_pointer(sw), (gboolean)lg_boolean(state));
  return(lg_false);
}

static s7_pointer lg_gtk_switch_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_switch_get_state "gboolean gtk_switch_get_state(GtkSwitch* sw)"
  s7_pointer sw;
  sw = s7_car(args);
  if (!s7_is_c_pointer_of_type(sw, GtkSwitch__sym)) s7_wrong_type_arg_error(sc, "gtk_switch_get_state", 1, sw, "GtkSwitch*");
  return(s7_make_boolean(sc, gtk_switch_get_state((GtkSwitch*)s7_c_pointer(sw))));
}

static s7_pointer lg_gtk_gesture_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_device "GdkDevice* gtk_gesture_get_device(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_device", 1, gesture, "GtkGesture*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gtk_gesture_get_device((GtkGesture*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_set_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_set_state "gboolean gtk_gesture_set_state(GtkGesture* gesture, GtkEventSequenceState state)"
  s7_pointer _p;
  s7_pointer gesture, state;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_state", 1, gesture, "GtkGesture*");
  state = s7_car(_p);
  if (!s7_is_integer(state)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_state", 2, state, "GtkEventSequenceState");
  return(s7_make_boolean(sc, gtk_gesture_set_state((GtkGesture*)s7_c_pointer(gesture), (GtkEventSequenceState)s7_integer(state))));
}

static s7_pointer lg_gtk_gesture_get_sequence_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_sequence_state "GtkEventSequenceState gtk_gesture_get_sequence_state(GtkGesture* gesture, \
GdkEventSequence* sequence)"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_sequence_state", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_sequence_state", 2, sequence, "GdkEventSequence*");
  return(s7_make_integer(sc, gtk_gesture_get_sequence_state((GtkGesture*)s7_c_pointer(gesture), (GdkEventSequence*)s7_c_pointer(sequence))));
}

static s7_pointer lg_gtk_gesture_set_sequence_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_set_sequence_state "gboolean gtk_gesture_set_sequence_state(GtkGesture* gesture, \
GdkEventSequence* sequence, GtkEventSequenceState state)"
  s7_pointer _p;
  s7_pointer gesture, sequence, state;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_sequence_state", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_sequence_state", 2, sequence, "GdkEventSequence*");
  state = s7_car(_p);
  if (!s7_is_integer(state)) s7_wrong_type_arg_error(sc, "gtk_gesture_set_sequence_state", 3, state, "GtkEventSequenceState");
  return(s7_make_boolean(sc, gtk_gesture_set_sequence_state((GtkGesture*)s7_c_pointer(gesture), (GdkEventSequence*)s7_c_pointer(sequence), (GtkEventSequenceState)s7_integer(state))));
}

static s7_pointer lg_gtk_gesture_get_sequences(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_sequences "GList* gtk_gesture_get_sequences(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_sequences", 1, gesture, "GtkGesture*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_gesture_get_sequences((GtkGesture*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_get_last_updated_sequence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_last_updated_sequence "GdkEventSequence* gtk_gesture_get_last_updated_sequence(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_last_updated_sequence", 1, gesture, "GtkGesture*");
  return(lg_make_c_pointer_with_type(sc, GdkEventSequence__sym, gtk_gesture_get_last_updated_sequence((GtkGesture*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_handles_sequence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_handles_sequence "gboolean gtk_gesture_handles_sequence(GtkGesture* gesture, \
GdkEventSequence* sequence)"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_handles_sequence", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_handles_sequence", 2, sequence, "GdkEventSequence*");
  return(s7_make_boolean(sc, gtk_gesture_handles_sequence((GtkGesture*)s7_c_pointer(gesture), (GdkEventSequence*)s7_c_pointer(sequence))));
}

static s7_pointer lg_gtk_gesture_get_last_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_last_event "GdkEvent* gtk_gesture_get_last_event(GtkGesture* gesture, GdkEventSequence* sequence)"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_last_event", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_last_event", 2, sequence, "GdkEventSequence*");
    return(lg_make_c_pointer_with_type(sc, GdkEvent__sym, (GdkEvent*)gtk_gesture_get_last_event((GtkGesture*)s7_c_pointer(gesture), (GdkEventSequence*)s7_c_pointer(sequence))));
}

static s7_pointer lg_gtk_gesture_get_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_point "gboolean gtk_gesture_get_point(GtkGesture* gesture, GdkEventSequence* sequence, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture, sequence;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_point", 1, gesture, "GtkGesture*");
  sequence = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sequence, GdkEventSequence__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_point", 2, sequence, "GdkEventSequence*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_get_point((GtkGesture*)s7_c_pointer(gesture), (GdkEventSequence*)s7_c_pointer(sequence), &ref_x, &ref_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_get_bounding_box(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_bounding_box "gboolean gtk_gesture_get_bounding_box(GtkGesture* gesture, \
GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer gesture, rect;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_bounding_box", 1, gesture, "GtkGesture*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_bounding_box", 2, rect, "GdkRectangle*");
  return(s7_make_boolean(sc, gtk_gesture_get_bounding_box((GtkGesture*)s7_c_pointer(gesture), (GdkRectangle*)s7_c_pointer(rect))));
}

static s7_pointer lg_gtk_gesture_get_bounding_box_center(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_bounding_box_center "gboolean gtk_gesture_get_bounding_box_center(GtkGesture* gesture, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_bounding_box_center", 1, gesture, "GtkGesture*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_get_bounding_box_center((GtkGesture*)s7_c_pointer(gesture), &ref_x, &ref_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_is_active(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_is_active "gboolean gtk_gesture_is_active(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_active", 1, gesture, "GtkGesture*");
  return(s7_make_boolean(sc, gtk_gesture_is_active((GtkGesture*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_is_recognized(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_is_recognized "gboolean gtk_gesture_is_recognized(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_recognized", 1, gesture, "GtkGesture*");
  return(s7_make_boolean(sc, gtk_gesture_is_recognized((GtkGesture*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_group "void gtk_gesture_group(GtkGesture* group_gesture, GtkGesture* gesture)"
  s7_pointer _p;
  s7_pointer group_gesture, gesture;
  _p = args;
  group_gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group_gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_group", 1, group_gesture, "GtkGesture*");
  gesture = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_group", 2, gesture, "GtkGesture*");
  gtk_gesture_group((GtkGesture*)s7_c_pointer(group_gesture), (GtkGesture*)s7_c_pointer(gesture));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_ungroup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_ungroup "void gtk_gesture_ungroup(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_ungroup", 1, gesture, "GtkGesture*");
  gtk_gesture_ungroup((GtkGesture*)s7_c_pointer(gesture));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_get_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_get_group "GList* gtk_gesture_get_group(GtkGesture* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_get_group", 1, gesture, "GtkGesture*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_gesture_get_group((GtkGesture*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_is_grouped_with(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_is_grouped_with "gboolean gtk_gesture_is_grouped_with(GtkGesture* gesture, GtkGesture* other)"
  s7_pointer _p;
  s7_pointer gesture, other;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_grouped_with", 1, gesture, "GtkGesture*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, GtkGesture__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_is_grouped_with", 2, other, "GtkGesture*");
  return(s7_make_boolean(sc, gtk_gesture_is_grouped_with((GtkGesture*)s7_c_pointer(gesture), (GtkGesture*)s7_c_pointer(other))));
}

static s7_pointer lg_gtk_gesture_drag_get_start_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_drag_get_start_point "gboolean gtk_gesture_drag_get_start_point(GtkGestureDrag* gesture, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureDrag__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_drag_get_start_point", 1, gesture, "GtkGestureDrag*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_drag_get_start_point((GtkGestureDrag*)s7_c_pointer(gesture), &ref_x, &ref_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_drag_get_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_drag_get_offset "gboolean gtk_gesture_drag_get_offset(GtkGestureDrag* gesture, \
gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  gesture = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureDrag__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_drag_get_offset", 1, gesture, "GtkGestureDrag*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_drag_get_offset((GtkGestureDrag*)s7_c_pointer(gesture), &ref_x, &ref_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
   }
}

static s7_pointer lg_gtk_gesture_pan_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_pan_get_orientation "GtkOrientation gtk_gesture_pan_get_orientation(GtkGesturePan* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesturePan__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_get_orientation", 1, gesture, "GtkGesturePan*");
  return(s7_make_integer(sc, gtk_gesture_pan_get_orientation((GtkGesturePan*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_pan_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_pan_set_orientation "void gtk_gesture_pan_set_orientation(GtkGesturePan* gesture, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer gesture, orientation;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGesturePan__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_set_orientation", 1, gesture, "GtkGesturePan*");
  orientation = s7_car(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_set_orientation", 2, orientation, "GtkOrientation");
  gtk_gesture_pan_set_orientation((GtkGesturePan*)s7_c_pointer(gesture), (GtkOrientation)s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_rotate_get_angle_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_rotate_get_angle_delta "gdouble gtk_gesture_rotate_get_angle_delta(GtkGestureRotate* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureRotate__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_rotate_get_angle_delta", 1, gesture, "GtkGestureRotate*");
  return(s7_make_real(sc, gtk_gesture_rotate_get_angle_delta((GtkGestureRotate*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_get_touch_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_touch_only "gboolean gtk_gesture_single_get_touch_only(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_touch_only", 1, gesture, "GtkGestureSingle*");
  return(s7_make_boolean(sc, gtk_gesture_single_get_touch_only((GtkGestureSingle*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_set_touch_only(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_set_touch_only "void gtk_gesture_single_set_touch_only(GtkGestureSingle* gesture, \
gboolean touch_only)"
  s7_pointer _p;
  s7_pointer gesture, touch_only;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_touch_only", 1, gesture, "GtkGestureSingle*");
  touch_only = s7_car(_p);
  if (!s7_is_boolean(touch_only)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_touch_only", 2, touch_only, "gboolean");
  gtk_gesture_single_set_touch_only((GtkGestureSingle*)s7_c_pointer(gesture), (gboolean)lg_boolean(touch_only));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_single_get_exclusive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_exclusive "gboolean gtk_gesture_single_get_exclusive(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_exclusive", 1, gesture, "GtkGestureSingle*");
  return(s7_make_boolean(sc, gtk_gesture_single_get_exclusive((GtkGestureSingle*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_set_exclusive(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_set_exclusive "void gtk_gesture_single_set_exclusive(GtkGestureSingle* gesture, \
gboolean exclusive)"
  s7_pointer _p;
  s7_pointer gesture, exclusive;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_exclusive", 1, gesture, "GtkGestureSingle*");
  exclusive = s7_car(_p);
  if (!s7_is_boolean(exclusive)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_exclusive", 2, exclusive, "gboolean");
  gtk_gesture_single_set_exclusive((GtkGestureSingle*)s7_c_pointer(gesture), (gboolean)lg_boolean(exclusive));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_single_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_button "guint gtk_gesture_single_get_button(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_button", 1, gesture, "GtkGestureSingle*");
  return(s7_make_integer(sc, gtk_gesture_single_get_button((GtkGestureSingle*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_set_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_set_button "void gtk_gesture_single_set_button(GtkGestureSingle* gesture, \
guint button)"
  s7_pointer _p;
  s7_pointer gesture, button;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_button", 1, gesture, "GtkGestureSingle*");
  button = s7_car(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_set_button", 2, button, "guint");
  gtk_gesture_single_set_button((GtkGestureSingle*)s7_c_pointer(gesture), (guint)s7_integer(button));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_single_get_current_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_current_button "guint gtk_gesture_single_get_current_button(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_current_button", 1, gesture, "GtkGestureSingle*");
  return(s7_make_integer(sc, gtk_gesture_single_get_current_button((GtkGestureSingle*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_single_get_current_sequence(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_single_get_current_sequence "GdkEventSequence* gtk_gesture_single_get_current_sequence(GtkGestureSingle* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSingle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_single_get_current_sequence", 1, gesture, "GtkGestureSingle*");
  return(lg_make_c_pointer_with_type(sc, GdkEventSequence__sym, gtk_gesture_single_get_current_sequence((GtkGestureSingle*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_gesture_swipe_get_velocity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_swipe_get_velocity "gboolean gtk_gesture_swipe_get_velocity(GtkGestureSwipe* gesture, \
gdouble* [velocity_x], gdouble* [velocity_y])"
  s7_pointer _p;
  s7_pointer gesture;
  gdouble ref_velocity_x;
  gdouble ref_velocity_y;
  _p = args;
  gesture = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureSwipe__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_swipe_get_velocity", 1, gesture, "GtkGestureSwipe*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_swipe_get_velocity((GtkGestureSwipe*)s7_c_pointer(gesture), &ref_velocity_x, &ref_velocity_y));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_velocity_x), s7_make_real(sc, ref_velocity_y)));
   }
}

static s7_pointer lg_gtk_gesture_zoom_get_scale_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_zoom_get_scale_delta "gdouble gtk_gesture_zoom_get_scale_delta(GtkGestureZoom* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureZoom__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_zoom_get_scale_delta", 1, gesture, "GtkGestureZoom*");
  return(s7_make_real(sc, gtk_gesture_zoom_get_scale_delta((GtkGestureZoom*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_list_box_row_set_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_set_activatable "void gtk_list_box_row_set_activatable(GtkListBoxRow* row, \
gboolean activatable)"
  s7_pointer _p;
  s7_pointer row, activatable;
  _p = args;
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_activatable", 1, row, "GtkListBoxRow*");
  activatable = s7_car(_p);
  if (!s7_is_boolean(activatable)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_activatable", 2, activatable, "gboolean");
  gtk_list_box_row_set_activatable((GtkListBoxRow*)s7_c_pointer(row), (gboolean)lg_boolean(activatable));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_get_activatable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_activatable "gboolean gtk_list_box_row_get_activatable(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_activatable", 1, row, "GtkListBoxRow*");
  return(s7_make_boolean(sc, gtk_list_box_row_get_activatable((GtkListBoxRow*)s7_c_pointer(row))));
}

static s7_pointer lg_gtk_list_box_row_set_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_set_selectable "void gtk_list_box_row_set_selectable(GtkListBoxRow* row, \
gboolean selectable)"
  s7_pointer _p;
  s7_pointer row, selectable;
  _p = args;
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_selectable", 1, row, "GtkListBoxRow*");
  selectable = s7_car(_p);
  if (!s7_is_boolean(selectable)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_set_selectable", 2, selectable, "gboolean");
  gtk_list_box_row_set_selectable((GtkListBoxRow*)s7_c_pointer(row), (gboolean)lg_boolean(selectable));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_row_get_selectable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_row_get_selectable "gboolean gtk_list_box_row_get_selectable(GtkListBoxRow* row)"
  s7_pointer row;
  row = s7_car(args);
  if (!s7_is_c_pointer_of_type(row, GtkListBoxRow__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_row_get_selectable", 1, row, "GtkListBoxRow*");
  return(s7_make_boolean(sc, gtk_list_box_row_get_selectable((GtkListBoxRow*)s7_c_pointer(row))));
}

#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static s7_pointer lg_gtk_label_set_xalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_xalign "void gtk_label_set_xalign(GtkLabel* label, gfloat xalign)"
  s7_pointer _p;
  s7_pointer label, xalign;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_xalign", 1, label, "GtkLabel*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_label_set_xalign", 2, xalign, "gfloat");
  gtk_label_set_xalign((GtkLabel*)s7_c_pointer(label), (gfloat)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_xalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_xalign "gfloat gtk_label_get_xalign(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_xalign", 1, label, "GtkLabel*");
  return(s7_make_real(sc, gtk_label_get_xalign((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_yalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_yalign "void gtk_label_set_yalign(GtkLabel* label, gfloat xalign)"
  s7_pointer _p;
  s7_pointer label, xalign;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_yalign", 1, label, "GtkLabel*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_label_set_yalign", 2, xalign, "gfloat");
  gtk_label_set_yalign((GtkLabel*)s7_c_pointer(label), (gfloat)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_yalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_yalign "gfloat gtk_label_get_yalign(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_yalign", 1, label, "GtkLabel*");
  return(s7_make_real(sc, gtk_label_get_yalign((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_paned_set_wide_handle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_set_wide_handle "void gtk_paned_set_wide_handle(GtkPaned* paned, gboolean wide)"
  s7_pointer _p;
  s7_pointer paned, wide;
  _p = args;
  paned = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_set_wide_handle", 1, paned, "GtkPaned*");
  wide = s7_car(_p);
  if (!s7_is_boolean(wide)) s7_wrong_type_arg_error(sc, "gtk_paned_set_wide_handle", 2, wide, "gboolean");
  gtk_paned_set_wide_handle((GtkPaned*)s7_c_pointer(paned), (gboolean)lg_boolean(wide));
  return(lg_false);
}

static s7_pointer lg_gtk_paned_get_wide_handle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_paned_get_wide_handle "gboolean gtk_paned_get_wide_handle(GtkPaned* paned)"
  s7_pointer paned;
  paned = s7_car(args);
  if (!s7_is_c_pointer_of_type(paned, GtkPaned__sym)) s7_wrong_type_arg_error(sc, "gtk_paned_get_wide_handle", 1, paned, "GtkPaned*");
  return(s7_make_boolean(sc, gtk_paned_get_wide_handle((GtkPaned*)s7_c_pointer(paned))));
}

static s7_pointer lg_gtk_scrolled_window_set_overlay_scrolling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_overlay_scrolling "void gtk_scrolled_window_set_overlay_scrolling(GtkScrolledWindow* scrolled_window, \
gboolean overlay_scrolling)"
  s7_pointer _p;
  s7_pointer scrolled_window, overlay_scrolling;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_overlay_scrolling", 1, scrolled_window, "GtkScrolledWindow*");
  overlay_scrolling = s7_car(_p);
  if (!s7_is_boolean(overlay_scrolling)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_overlay_scrolling", 2, overlay_scrolling, "gboolean");
  gtk_scrolled_window_set_overlay_scrolling((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gboolean)lg_boolean(overlay_scrolling));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_overlay_scrolling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_overlay_scrolling "gboolean gtk_scrolled_window_get_overlay_scrolling(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_overlay_scrolling", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_overlay_scrolling((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_text_view_set_monospace(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_monospace "void gtk_text_view_set_monospace(GtkTextView* text_view, gboolean monospace)"
  s7_pointer _p;
  s7_pointer text_view, monospace;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_monospace", 1, text_view, "GtkTextView*");
  monospace = s7_car(_p);
  if (!s7_is_boolean(monospace)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_monospace", 2, monospace, "gboolean");
  gtk_text_view_set_monospace((GtkTextView*)s7_c_pointer(text_view), (gboolean)lg_boolean(monospace));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_monospace(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_monospace "gboolean gtk_text_view_get_monospace(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_monospace", 1, text_view, "GtkTextView*");
  return(s7_make_boolean(sc, gtk_text_view_get_monospace((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_window_get_titlebar(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_titlebar "GtkWidget* gtk_window_get_titlebar(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_get_titlebar", 1, window, "GtkWindow*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_window_get_titlebar((GtkWindow*)s7_c_pointer(window))));
}

static s7_pointer lg_gtk_gl_area_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_new "GtkWidget* gtk_gl_area_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_gl_area_new()));
}

static s7_pointer lg_gtk_gl_area_get_has_depth_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_has_depth_buffer "gboolean gtk_gl_area_get_has_depth_buffer(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_has_depth_buffer", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_has_depth_buffer((GtkGLArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_has_depth_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_has_depth_buffer "void gtk_gl_area_set_has_depth_buffer(GtkGLArea* area, \
gboolean has_depth_buffer)"
  s7_pointer _p;
  s7_pointer area, has_depth_buffer;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_depth_buffer", 1, area, "GtkGLArea*");
  has_depth_buffer = s7_car(_p);
  if (!s7_is_boolean(has_depth_buffer)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_depth_buffer", 2, has_depth_buffer, "gboolean");
  gtk_gl_area_set_has_depth_buffer((GtkGLArea*)s7_c_pointer(area), (gboolean)lg_boolean(has_depth_buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_context "GdkGLContext* gtk_gl_area_get_context(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_context", 1, area, "GtkGLArea*");
  return(lg_make_c_pointer_with_type(sc, GdkGLContext__sym, gtk_gl_area_get_context((GtkGLArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_make_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_make_current "void gtk_gl_area_make_current(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_make_current", 1, area, "GtkGLArea*");
  gtk_gl_area_make_current((GtkGLArea*)s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_render_check(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_check "void gtk_render_check(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_check", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_check", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_check", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_check", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_check", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_check", 6, height, "gdouble");
  gtk_render_check((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_option(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_option "void gtk_render_option(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_option", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_option", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_option", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_option", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_option", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_option", 6, height, "gdouble");
  gtk_render_option((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_arrow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_arrow "void gtk_render_arrow(GtkStyleContext* context, cairo_t* cr, gdouble angle, \
gdouble x, gdouble y, gdouble size)"
  s7_pointer _p;
  s7_pointer context, cr, angle, x, y, size;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 2, cr, "cairo_t*");
  angle = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 3, angle, "gdouble");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 4, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 5, y, "gdouble");
  size = s7_car(_p);
  if (!s7_is_real(size)) s7_wrong_type_arg_error(sc, "gtk_render_arrow", 6, size, "gdouble");
  gtk_render_arrow((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(angle), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(size));
  return(lg_false);
}

static s7_pointer lg_gtk_render_background(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_background "void gtk_render_background(GtkStyleContext* context, cairo_t* cr, \
gdouble x, gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_background", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_background", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_background", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_background", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_background", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_background", 6, height, "gdouble");
  gtk_render_background((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_frame "void gtk_render_frame(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_frame", 6, height, "gdouble");
  gtk_render_frame((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_expander(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_expander "void gtk_render_expander(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_expander", 6, height, "gdouble");
  gtk_render_expander((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_focus "void gtk_render_focus(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_focus", 6, height, "gdouble");
  gtk_render_focus((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_layout "void gtk_render_layout(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, PangoLayout* layout)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, layout;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 4, y, "gdouble");
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_render_layout", 5, layout, "PangoLayout*");
  gtk_render_layout((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (PangoLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_gtk_render_line(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_line "void gtk_render_line(GtkStyleContext* context, cairo_t* cr, gdouble x0, \
gdouble y0, gdouble x1, gdouble y1)"
  s7_pointer _p;
  s7_pointer context, cr, x0, y0, x1, y1;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_line", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_line", 2, cr, "cairo_t*");
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x0)) s7_wrong_type_arg_error(sc, "gtk_render_line", 3, x0, "gdouble");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y0)) s7_wrong_type_arg_error(sc, "gtk_render_line", 4, y0, "gdouble");
  x1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x1)) s7_wrong_type_arg_error(sc, "gtk_render_line", 5, x1, "gdouble");
  y1 = s7_car(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "gtk_render_line", 6, y1, "gdouble");
  gtk_render_line((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x0), (gdouble)s7_real(y0), (gdouble)s7_real(x1), (gdouble)s7_real(y1));
  return(lg_false);
}

static s7_pointer lg_gtk_render_handle(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_handle "void gtk_render_handle(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_handle", 6, height, "gdouble");
  gtk_render_handle((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gtk_render_activity(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_activity "void gtk_render_activity(GtkStyleContext* context, cairo_t* cr, gdouble x, \
gdouble y, gdouble width, gdouble height)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, width, height;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 4, y, "gdouble");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 5, width, "gdouble");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "gtk_render_activity", 6, height, "gdouble");
  gtk_render_activity((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (gdouble)s7_real(width), (gdouble)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_make_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_make_current "void gdk_gl_context_make_current(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_make_current", 1, context, "GdkGLContext*");
  gdk_gl_context_make_current((GdkGLContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_current "GdkGLContext* gdk_gl_context_get_current( void)"
  return(lg_make_c_pointer_with_type(sc, GdkGLContext__sym, gdk_gl_context_get_current()));
}

static s7_pointer lg_gdk_gl_context_clear_current(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_clear_current "void gdk_gl_context_clear_current( void)"
  gdk_gl_context_clear_current();
  return(lg_false);
}

static s7_pointer lg_gtk_stack_set_hhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_hhomogeneous "void gtk_stack_set_hhomogeneous(GtkStack* stack, gboolean hhomogeneous)"
  s7_pointer _p;
  s7_pointer stack, hhomogeneous;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_hhomogeneous", 1, stack, "GtkStack*");
  hhomogeneous = s7_car(_p);
  if (!s7_is_boolean(hhomogeneous)) s7_wrong_type_arg_error(sc, "gtk_stack_set_hhomogeneous", 2, hhomogeneous, "gboolean");
  gtk_stack_set_hhomogeneous((GtkStack*)s7_c_pointer(stack), (gboolean)lg_boolean(hhomogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_hhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_hhomogeneous "gboolean gtk_stack_get_hhomogeneous(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_hhomogeneous", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_hhomogeneous((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_stack_set_vhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_vhomogeneous "void gtk_stack_set_vhomogeneous(GtkStack* stack, gboolean vhomogeneous)"
  s7_pointer _p;
  s7_pointer stack, vhomogeneous;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_vhomogeneous", 1, stack, "GtkStack*");
  vhomogeneous = s7_car(_p);
  if (!s7_is_boolean(vhomogeneous)) s7_wrong_type_arg_error(sc, "gtk_stack_set_vhomogeneous", 2, vhomogeneous, "gboolean");
  gtk_stack_set_vhomogeneous((GtkStack*)s7_c_pointer(stack), (gboolean)lg_boolean(vhomogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_vhomogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_vhomogeneous "gboolean gtk_stack_get_vhomogeneous(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_vhomogeneous", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_vhomogeneous((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gdk_gl_context_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_display "GdkDisplay* gdk_gl_context_get_display(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_display", 1, context, "GdkGLContext*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_gl_context_get_display((GdkGLContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_gl_area_get_has_stencil_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_has_stencil_buffer "gboolean gtk_gl_area_get_has_stencil_buffer(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_has_stencil_buffer", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_has_stencil_buffer((GtkGLArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_has_stencil_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_has_stencil_buffer "void gtk_gl_area_set_has_stencil_buffer(GtkGLArea* area, \
gboolean has_stencil_buffer)"
  s7_pointer _p;
  s7_pointer area, has_stencil_buffer;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_stencil_buffer", 1, area, "GtkGLArea*");
  has_stencil_buffer = s7_car(_p);
  if (!s7_is_boolean(has_stencil_buffer)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_has_stencil_buffer", 2, has_stencil_buffer, "gboolean");
  gtk_gl_area_set_has_stencil_buffer((GtkGLArea*)s7_c_pointer(area), (gboolean)lg_boolean(has_stencil_buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_auto_render(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_auto_render "gboolean gtk_gl_area_get_auto_render(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_auto_render", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_auto_render((GtkGLArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_gl_area_set_auto_render(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_auto_render "void gtk_gl_area_set_auto_render(GtkGLArea* area, gboolean auto_render)"
  s7_pointer _p;
  s7_pointer area, auto_render;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_auto_render", 1, area, "GtkGLArea*");
  auto_render = s7_car(_p);
  if (!s7_is_boolean(auto_render)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_auto_render", 2, auto_render, "gboolean");
  gtk_gl_area_set_auto_render((GtkGLArea*)s7_c_pointer(area), (gboolean)lg_boolean(auto_render));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_queue_render(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_queue_render "void gtk_gl_area_queue_render(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_queue_render", 1, area, "GtkGLArea*");
  gtk_gl_area_queue_render((GtkGLArea*)s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_attach_buffers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_attach_buffers "void gtk_gl_area_attach_buffers(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_attach_buffers", 1, area, "GtkGLArea*");
  gtk_gl_area_attach_buffers((GtkGLArea*)s7_c_pointer(area));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_error "GError* gtk_gl_area_get_error(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_error", 1, area, "GtkGLArea*");
  return(lg_make_c_pointer_with_type(sc, GError__sym, gtk_gl_area_get_error((GtkGLArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gtk_scrollable_get_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollable_get_border "gboolean gtk_scrollable_get_border(GtkScrollable* scrollable, \
GtkBorder* border)"
  s7_pointer _p;
  s7_pointer scrollable, border;
  _p = args;
  scrollable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrollable, GtkScrollable__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_border", 1, scrollable, "GtkScrollable*");
  border = s7_car(_p);
  if (!s7_is_c_pointer_of_type(border, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollable_get_border", 2, border, "GtkBorder*");
  return(s7_make_boolean(sc, gtk_scrollable_get_border((GtkScrollable*)s7_c_pointer(scrollable), (GtkBorder*)s7_c_pointer(border))));
}

static s7_pointer lg_gtk_text_buffer_insert_markup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_markup "void gtk_text_buffer_insert_markup(GtkTextBuffer* buffer, \
GtkTextIter* iter, gchar* markup, gint len)"
  s7_pointer _p;
  s7_pointer buffer, iter, markup, len;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 2, iter, "GtkTextIter*");
  markup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(markup)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 3, markup, "gchar*");
  len = s7_car(_p);
  if (!s7_is_integer(len)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_markup", 4, len, "gint");
  gtk_text_buffer_insert_markup((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (const gchar*)s7_string(markup), (gint)s7_integer(len));
  return(lg_false);
}

static s7_pointer lg_gdk_device_get_vendor_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_vendor_id "gchar* gdk_device_get_vendor_id(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_vendor_id", 1, device, "GdkDevice*");
    return(s7_make_string(sc, (gchar*)gdk_device_get_vendor_id((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_product_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_product_id "gchar* gdk_device_get_product_id(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_product_id", 1, device, "GdkDevice*");
    return(s7_make_string(sc, (gchar*)gdk_device_get_product_id((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_gl_context_get_shared_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_shared_context "GdkGLContext* gdk_gl_context_get_shared_context(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_shared_context", 1, context, "GdkGLContext*");
  return(lg_make_c_pointer_with_type(sc, GdkGLContext__sym, gdk_gl_context_get_shared_context((GdkGLContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_set_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_required_version "void gdk_gl_context_set_required_version(GdkGLContext* context, \
int major, int minor)"
  s7_pointer _p;
  s7_pointer context, major, minor;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_required_version", 1, context, "GdkGLContext*");
  major = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(major)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_required_version", 2, major, "int");
  minor = s7_car(_p);
  if (!s7_is_integer(minor)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_required_version", 3, minor, "int");
  gdk_gl_context_set_required_version((GdkGLContext*)s7_c_pointer(context), (int)s7_integer(major), (int)s7_integer(minor));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_required_version "void gdk_gl_context_get_required_version(GdkGLContext* context, \
int* [major], int* [minor])"
  s7_pointer _p;
  s7_pointer context;
  int ref_major;
  int ref_minor;
  _p = args;
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_required_version", 1, context, "GdkGLContext*");
  gdk_gl_context_get_required_version((GdkGLContext*)s7_c_pointer(context), &ref_major, &ref_minor);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_major), s7_make_integer(sc, ref_minor)));
}

static s7_pointer lg_gdk_gl_context_set_debug_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_debug_enabled "void gdk_gl_context_set_debug_enabled(GdkGLContext* context, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer context, enabled;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_debug_enabled", 1, context, "GdkGLContext*");
  enabled = s7_car(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_debug_enabled", 2, enabled, "gboolean");
  gdk_gl_context_set_debug_enabled((GdkGLContext*)s7_c_pointer(context), (gboolean)lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_debug_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_debug_enabled "gboolean gdk_gl_context_get_debug_enabled(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_debug_enabled", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_get_debug_enabled((GdkGLContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_set_forward_compatible(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_forward_compatible "void gdk_gl_context_set_forward_compatible(GdkGLContext* context, \
gboolean compatible)"
  s7_pointer _p;
  s7_pointer context, compatible;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_forward_compatible", 1, context, "GdkGLContext*");
  compatible = s7_car(_p);
  if (!s7_is_boolean(compatible)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_forward_compatible", 2, compatible, "gboolean");
  gdk_gl_context_set_forward_compatible((GdkGLContext*)s7_c_pointer(context), (gboolean)lg_boolean(compatible));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_forward_compatible(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_forward_compatible "gboolean gdk_gl_context_get_forward_compatible(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_forward_compatible", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_get_forward_compatible((GdkGLContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gdk_gl_context_realize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_realize "gboolean gdk_gl_context_realize(GdkGLContext* context, GError** [error])"
  s7_pointer _p;
  s7_pointer context;
  GError* ref_error = NULL;
  _p = args;
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_realize", 1, context, "GdkGLContext*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_gl_context_realize((GdkGLContext*)s7_c_pointer(context), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_gl_context_get_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_version "void gdk_gl_context_get_version(GdkGLContext* context, int* [major], \
int* [minor])"
  s7_pointer _p;
  s7_pointer context;
  int ref_major;
  int ref_minor;
  _p = args;
  context = s7_car(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_version", 1, context, "GdkGLContext*");
  gdk_gl_context_get_version((GdkGLContext*)s7_c_pointer(context), &ref_major, &ref_minor);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_major), s7_make_integer(sc, ref_minor)));
}

static s7_pointer lg_gtk_gl_area_set_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_required_version "void gtk_gl_area_set_required_version(GtkGLArea* area, \
gint major, gint minor)"
  s7_pointer _p;
  s7_pointer area, major, minor;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_required_version", 1, area, "GtkGLArea*");
  major = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(major)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_required_version", 2, major, "gint");
  minor = s7_car(_p);
  if (!s7_is_integer(minor)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_required_version", 3, minor, "gint");
  gtk_gl_area_set_required_version((GtkGLArea*)s7_c_pointer(area), (gint)s7_integer(major), (gint)s7_integer(minor));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_required_version(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_required_version "void gtk_gl_area_get_required_version(GtkGLArea* area, \
gint* [major], gint* [minor])"
  s7_pointer _p;
  s7_pointer area;
  gint ref_major;
  gint ref_minor;
  _p = args;
  area = s7_car(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_required_version", 1, area, "GtkGLArea*");
  gtk_gl_area_get_required_version((GtkGLArea*)s7_c_pointer(area), &ref_major, &ref_minor);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_major), s7_make_integer(sc, ref_minor)));
}

static s7_pointer lg_gtk_notebook_detach_tab(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_detach_tab "void gtk_notebook_detach_tab(GtkNotebook* notebook, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_detach_tab", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_detach_tab", 2, child, "GtkWidget*");
  gtk_notebook_detach_tab((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_sidebar_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_sidebar_new "GtkWidget* gtk_stack_sidebar_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_stack_sidebar_new()));
}

static s7_pointer lg_gtk_stack_sidebar_set_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_sidebar_set_stack "void gtk_stack_sidebar_set_stack(GtkStackSidebar* self, GtkStack* stack)"
  s7_pointer _p;
  s7_pointer self, stack;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkStackSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_sidebar_set_stack", 1, self, "GtkStackSidebar*");
  stack = s7_car(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_sidebar_set_stack", 2, stack, "GtkStack*");
  gtk_stack_sidebar_set_stack((GtkStackSidebar*)s7_c_pointer(self), (GtkStack*)s7_c_pointer(stack));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_sidebar_get_stack(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_sidebar_get_stack "GtkStack* gtk_stack_sidebar_get_stack(GtkStackSidebar* selfr)"
  s7_pointer selfr;
  selfr = s7_car(args);
  if (!s7_is_c_pointer_of_type(selfr, GtkStackSidebar__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_sidebar_get_stack", 1, selfr, "GtkStackSidebar*");
  return(lg_make_c_pointer_with_type(sc, GtkStack__sym, gtk_stack_sidebar_get_stack((GtkStackSidebar*)s7_c_pointer(selfr))));
}

#endif

#if GTK_CHECK_VERSION(3, 18, 0)
static s7_pointer lg_gtk_font_chooser_set_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_set_font_map "void gtk_font_chooser_set_font_map(GtkFontChooser* fontchooser, \
PangoFontMap* fontmap)"
  s7_pointer _p;
  s7_pointer fontchooser, fontmap;
  _p = args;
  fontchooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_map", 1, fontchooser, "GtkFontChooser*");
  fontmap = s7_car(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_set_font_map", 2, fontmap, "PangoFontMap*");
  gtk_font_chooser_set_font_map((GtkFontChooser*)s7_c_pointer(fontchooser), (PangoFontMap*)s7_c_pointer(fontmap));
  return(lg_false);
}

static s7_pointer lg_gtk_font_chooser_get_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_chooser_get_font_map "PangoFontMap* gtk_font_chooser_get_font_map(GtkFontChooser* fontchooser)"
  s7_pointer fontchooser;
  fontchooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(fontchooser, GtkFontChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_font_chooser_get_font_map", 1, fontchooser, "GtkFontChooser*");
  return(lg_make_c_pointer_with_type(sc, PangoFontMap__sym, gtk_font_chooser_get_font_map((GtkFontChooser*)s7_c_pointer(fontchooser))));
}

static s7_pointer lg_gtk_stack_set_interpolate_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_set_interpolate_size "void gtk_stack_set_interpolate_size(GtkStack* stack, gboolean interpolate_size)"
  s7_pointer _p;
  s7_pointer stack, interpolate_size;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_set_interpolate_size", 1, stack, "GtkStack*");
  interpolate_size = s7_car(_p);
  if (!s7_is_boolean(interpolate_size)) s7_wrong_type_arg_error(sc, "gtk_stack_set_interpolate_size", 2, interpolate_size, "gboolean");
  gtk_stack_set_interpolate_size((GtkStack*)s7_c_pointer(stack), (gboolean)lg_boolean(interpolate_size));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_get_interpolate_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_interpolate_size "gboolean gtk_stack_get_interpolate_size(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_interpolate_size", 1, stack, "GtkStack*");
  return(s7_make_boolean(sc, gtk_stack_get_interpolate_size((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_widget_set_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_font_options "void gtk_widget_set_font_options(GtkWidget* widget, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer widget, options;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_options", 1, widget, "GtkWidget*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_options", 2, options, "cairo_font_options_t*");
  gtk_widget_set_font_options((GtkWidget*)s7_c_pointer(widget), (cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_font_options "cairo_font_options_t* gtk_widget_get_font_options(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_font_options", 1, widget, "GtkWidget*");
    return(lg_make_c_pointer_with_type(sc, cairo_font_options_t__sym, (cairo_font_options_t*)gtk_widget_get_font_options((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_font_map "void gtk_widget_set_font_map(GtkWidget* widget, PangoFontMap* fontmap)"
  s7_pointer _p;
  s7_pointer widget, fontmap;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_map", 1, widget, "GtkWidget*");
  fontmap = s7_car(_p);
  if (!s7_is_c_pointer_of_type(fontmap, PangoFontMap__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_font_map", 2, fontmap, "PangoFontMap*");
  gtk_widget_set_font_map((GtkWidget*)s7_c_pointer(widget), (PangoFontMap*)s7_c_pointer(fontmap));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_font_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_font_map "PangoFontMap* gtk_widget_get_font_map(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_font_map", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, PangoFontMap__sym, gtk_widget_get_font_map((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_text_view_set_top_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_top_margin "void gtk_text_view_set_top_margin(GtkTextView* text_view, gint top_margin)"
  s7_pointer _p;
  s7_pointer text_view, top_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_top_margin", 1, text_view, "GtkTextView*");
  top_margin = s7_car(_p);
  if (!s7_is_integer(top_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_top_margin", 2, top_margin, "gint");
  gtk_text_view_set_top_margin((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(top_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_top_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_top_margin "gint gtk_text_view_get_top_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_top_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_top_margin((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_text_view_set_bottom_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_bottom_margin "void gtk_text_view_set_bottom_margin(GtkTextView* text_view, \
gint bottom_margin)"
  s7_pointer _p;
  s7_pointer text_view, bottom_margin;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_bottom_margin", 1, text_view, "GtkTextView*");
  bottom_margin = s7_car(_p);
  if (!s7_is_integer(bottom_margin)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_bottom_margin", 2, bottom_margin, "gint");
  gtk_text_view_set_bottom_margin((GtkTextView*)s7_c_pointer(text_view), (gint)s7_integer(bottom_margin));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_bottom_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_bottom_margin "gint gtk_text_view_get_bottom_margin(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_bottom_margin", 1, text_view, "GtkTextView*");
  return(s7_make_integer(sc, gtk_text_view_get_bottom_margin((GtkTextView*)s7_c_pointer(text_view))));
}

#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static s7_pointer lg_gdk_gl_context_is_legacy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_is_legacy "gboolean gdk_gl_context_is_legacy(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_is_legacy", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_is_legacy((GdkGLContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gdk_rectangle_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_equal "gboolean gdk_rectangle_equal(GdkRectangle* rect1, GdkRectangle* rect2)"
  s7_pointer _p;
  s7_pointer rect1, rect2;
  _p = args;
  rect1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect1, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_equal", 1, rect1, "GdkRectangle*");
  rect2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect2, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_equal", 2, rect2, "GdkRectangle*");
  return(s7_make_boolean(sc, gdk_rectangle_equal((GdkRectangle*)s7_c_pointer(rect1), (GdkRectangle*)s7_c_pointer(rect2))));
}

static s7_pointer lg_gtk_application_window_set_help_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_window_set_help_overlay "void gtk_application_window_set_help_overlay(GtkApplicationWindow* window, \
GtkShortcutsWindow* help_overlay)"
  s7_pointer _p;
  s7_pointer window, help_overlay;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkApplicationWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_help_overlay", 1, window, "GtkApplicationWindow*");
  help_overlay = s7_car(_p);
  if (!s7_is_c_pointer_of_type(help_overlay, GtkShortcutsWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_window_set_help_overlay", 2, help_overlay, "GtkShortcutsWindow*");
  gtk_application_window_set_help_overlay((GtkApplicationWindow*)s7_c_pointer(window), (GtkShortcutsWindow*)s7_c_pointer(help_overlay));
  return(lg_false);
}

static s7_pointer lg_gtk_settings_reset_property(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_settings_reset_property "void gtk_settings_reset_property(GtkSettings* settings, gchar* name)"
  s7_pointer _p;
  s7_pointer settings, name;
  _p = args;
  settings = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(settings, GtkSettings__sym)) s7_wrong_type_arg_error(sc, "gtk_settings_reset_property", 1, settings, "GtkSettings*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_settings_reset_property", 2, name, "gchar*");
  gtk_settings_reset_property((GtkSettings*)s7_c_pointer(settings), (const gchar*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_text_tag_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_tag_changed "void gtk_text_tag_changed(GtkTextTag* tag, gboolean size_changed)"
  s7_pointer _p;
  s7_pointer tag, size_changed;
  _p = args;
  tag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) s7_wrong_type_arg_error(sc, "gtk_text_tag_changed", 1, tag, "GtkTextTag*");
  size_changed = s7_car(_p);
  if (!s7_is_boolean(size_changed)) s7_wrong_type_arg_error(sc, "gtk_text_tag_changed", 2, size_changed, "gboolean");
  gtk_text_tag_changed((GtkTextTag*)s7_c_pointer(tag), (gboolean)lg_boolean(size_changed));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_queue_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_queue_allocate "void gtk_widget_queue_allocate(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_queue_allocate", 1, widget, "GtkWidget*");
  gtk_widget_queue_allocate((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_focus_on_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_focus_on_click "void gtk_widget_set_focus_on_click(GtkWidget* widget, gboolean focus_on_click)"
  s7_pointer _p;
  s7_pointer widget, focus_on_click;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_on_click", 1, widget, "GtkWidget*");
  focus_on_click = s7_car(_p);
  if (!s7_is_boolean(focus_on_click)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_on_click", 2, focus_on_click, "gboolean");
  gtk_widget_set_focus_on_click((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(focus_on_click));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_focus_on_click(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_focus_on_click "gboolean gtk_widget_get_focus_on_click(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_focus_on_click", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_focus_on_click((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_text_iter_starts_tag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_starts_tag "gboolean gtk_text_iter_starts_tag(GtkTextIter* iter, GtkTextTag* tag)"
  s7_pointer _p;
  s7_pointer iter, tag;
  _p = args;
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_tag", 1, iter, "GtkTextIter*");
  tag = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(tag, GtkTextTag__sym)) && (tag != lg_false)) s7_wrong_type_arg_error(sc, "gtk_text_iter_starts_tag", 2, tag, "GtkTextTag*");
  return(s7_make_boolean(sc, gtk_text_iter_starts_tag((GtkTextIter*)s7_c_pointer(iter), (GtkTextTag*)s7_c_pointer(tag))));
}

static s7_pointer lg_gdk_device_get_seat(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_seat "GdkSeat* gdk_device_get_seat(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_seat", 1, device, "GdkDevice*");
  return(lg_make_c_pointer_with_type(sc, GdkSeat__sym, gdk_device_get_seat((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_display_get_default_seat(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default_seat "GdkSeat* gdk_display_get_default_seat(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_default_seat", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GdkSeat__sym, gdk_display_get_default_seat((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_list_seats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_list_seats "GList* gdk_display_list_seats(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_list_seats", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gdk_display_list_seats((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_seat_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_display "GdkDisplay* gdk_seat_get_display(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_display", 1, seat, "GdkSeat*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_seat_get_display((GdkSeat*)s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_seat_get_capabilities(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_capabilities "GdkSeatCapabilities gdk_seat_get_capabilities(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_capabilities", 1, seat, "GdkSeat*");
  return(s7_make_integer(sc, gdk_seat_get_capabilities((GdkSeat*)s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_seat_get_slaves(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_slaves "GList* gdk_seat_get_slaves(GdkSeat* seat, GdkSeatCapabilities capabilities)"
  s7_pointer _p;
  s7_pointer seat, capabilities;
  _p = args;
  seat = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_slaves", 1, seat, "GdkSeat*");
  capabilities = s7_car(_p);
  if (!s7_is_integer(capabilities)) s7_wrong_type_arg_error(sc, "gdk_seat_get_slaves", 2, capabilities, "GdkSeatCapabilities");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gdk_seat_get_slaves((GdkSeat*)s7_c_pointer(seat), (GdkSeatCapabilities)s7_integer(capabilities))));
}

static s7_pointer lg_gdk_seat_get_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_pointer "GdkDevice* gdk_seat_get_pointer(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_pointer", 1, seat, "GdkSeat*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gdk_seat_get_pointer((GdkSeat*)s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_seat_get_keyboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_keyboard "GdkDevice* gdk_seat_get_keyboard(GdkSeat* seat)"
  s7_pointer seat;
  seat = s7_car(args);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_keyboard", 1, seat, "GdkSeat*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gdk_seat_get_keyboard((GdkSeat*)s7_c_pointer(seat))));
}

static s7_pointer lg_gdk_event_is_scroll_stop_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_is_scroll_stop_event "gboolean gdk_event_is_scroll_stop_event(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_is_scroll_stop_event", 1, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_event_is_scroll_stop_event((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_text_view_reset_cursor_blink(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_reset_cursor_blink "void gtk_text_view_reset_cursor_blink(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_reset_cursor_blink", 1, text_view, "GtkTextView*");
  gtk_text_view_reset_cursor_blink((GtkTextView*)s7_c_pointer(text_view));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static s7_pointer lg_gdk_device_get_axes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_axes "GdkAxisFlags gdk_device_get_axes(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_axes", 1, device, "GdkDevice*");
  return(s7_make_integer(sc, gdk_device_get_axes((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_event_get_device_tool(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_device_tool "GdkDeviceTool* gdk_event_get_device_tool(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_device_tool", 1, event, "GdkEvent*");
  return(lg_make_c_pointer_with_type(sc, GdkDeviceTool__sym, gdk_event_get_device_tool((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_set_device_tool(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_device_tool "void gdk_event_set_device_tool(GdkEvent* event, GdkDeviceTool* tool)"
  s7_pointer _p;
  s7_pointer event, tool;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device_tool", 1, event, "GdkEvent*");
  tool = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tool, GdkDeviceTool__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_device_tool", 2, tool, "GdkDeviceTool*");
  gdk_event_set_device_tool((GdkEvent*)s7_c_pointer(event), (GdkDeviceTool*)s7_c_pointer(tool));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_set_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_set_use_es "void gdk_gl_context_set_use_es(GdkGLContext* context, int use_es)"
  s7_pointer _p;
  s7_pointer context, use_es;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_use_es", 1, context, "GdkGLContext*");
  use_es = s7_car(_p);
  if (!s7_is_integer(use_es)) s7_wrong_type_arg_error(sc, "gdk_gl_context_set_use_es", 2, use_es, "int");
  gdk_gl_context_set_use_es((GdkGLContext*)s7_c_pointer(context), (int)s7_integer(use_es));
  return(lg_false);
}

static s7_pointer lg_gdk_gl_context_get_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_context_get_use_es "gboolean gdk_gl_context_get_use_es(GdkGLContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkGLContext__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_context_get_use_es", 1, context, "GdkGLContext*");
  return(s7_make_boolean(sc, gdk_gl_context_get_use_es((GdkGLContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_gl_area_set_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_set_use_es "void gtk_gl_area_set_use_es(GtkGLArea* area, gboolean use_es)"
  s7_pointer _p;
  s7_pointer area, use_es;
  _p = args;
  area = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_use_es", 1, area, "GtkGLArea*");
  use_es = s7_car(_p);
  if (!s7_is_boolean(use_es)) s7_wrong_type_arg_error(sc, "gtk_gl_area_set_use_es", 2, use_es, "gboolean");
  gtk_gl_area_set_use_es((GtkGLArea*)s7_c_pointer(area), (gboolean)lg_boolean(use_es));
  return(lg_false);
}

static s7_pointer lg_gtk_gl_area_get_use_es(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gl_area_get_use_es "gboolean gtk_gl_area_get_use_es(GtkGLArea* area)"
  s7_pointer area;
  area = s7_car(args);
  if (!s7_is_c_pointer_of_type(area, GtkGLArea__sym)) s7_wrong_type_arg_error(sc, "gtk_gl_area_get_use_es", 1, area, "GtkGLArea*");
  return(s7_make_boolean(sc, gtk_gl_area_get_use_es((GtkGLArea*)s7_c_pointer(area))));
}

static s7_pointer lg_gdk_device_tool_get_serial(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_tool_get_serial "guint gdk_device_tool_get_serial(GdkDeviceTool* tool)"
  s7_pointer tool;
  tool = s7_car(args);
  if (!s7_is_c_pointer_of_type(tool, GdkDeviceTool__sym)) s7_wrong_type_arg_error(sc, "gdk_device_tool_get_serial", 1, tool, "GdkDeviceTool*");
  return(s7_make_integer(sc, gdk_device_tool_get_serial((GdkDeviceTool*)s7_c_pointer(tool))));
}

static s7_pointer lg_gdk_display_get_n_monitors(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_n_monitors "int gdk_display_get_n_monitors(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_n_monitors", 1, display, "GdkDisplay*");
  return(s7_make_integer(sc, gdk_display_get_n_monitors((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_monitor "GdkMonitor* gdk_display_get_monitor(GdkDisplay* display, int monitor_num)"
  s7_pointer _p;
  s7_pointer display, monitor_num;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor", 1, display, "GdkDisplay*");
  monitor_num = s7_car(_p);
  if (!s7_is_integer(monitor_num)) s7_wrong_type_arg_error(sc, "gdk_display_get_monitor", 2, monitor_num, "int");
  return(lg_make_c_pointer_with_type(sc, GdkMonitor__sym, gdk_display_get_monitor((GdkDisplay*)s7_c_pointer(display), (int)s7_integer(monitor_num))));
}

static s7_pointer lg_gdk_event_get_pointer_emulated(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_pointer_emulated "gboolean gdk_event_get_pointer_emulated(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_pointer_emulated", 1, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_event_get_pointer_emulated((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_monitor_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_display "GdkDisplay* gdk_monitor_get_display(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_display", 1, monitor, "GdkMonitor*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_monitor_get_display((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_geometry(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_geometry "void gdk_monitor_get_geometry(GdkMonitor* monitor, GdkRectangle* geometry)"
  s7_pointer _p;
  s7_pointer monitor, geometry;
  _p = args;
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_geometry", 1, monitor, "GdkMonitor*");
  geometry = s7_car(_p);
  if (!s7_is_c_pointer_of_type(geometry, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_geometry", 2, geometry, "GdkRectangle*");
  gdk_monitor_get_geometry((GdkMonitor*)s7_c_pointer(monitor), (GdkRectangle*)s7_c_pointer(geometry));
  return(lg_false);
}

static s7_pointer lg_gdk_monitor_get_workarea(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_workarea "void gdk_monitor_get_workarea(GdkMonitor* monitor, GdkRectangle* workarea)"
  s7_pointer _p;
  s7_pointer monitor, workarea;
  _p = args;
  monitor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_workarea", 1, monitor, "GdkMonitor*");
  workarea = s7_car(_p);
  if (!s7_is_c_pointer_of_type(workarea, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_workarea", 2, workarea, "GdkRectangle*");
  gdk_monitor_get_workarea((GdkMonitor*)s7_c_pointer(monitor), (GdkRectangle*)s7_c_pointer(workarea));
  return(lg_false);
}

static s7_pointer lg_gdk_monitor_get_width_mm(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_width_mm "int gdk_monitor_get_width_mm(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_width_mm", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_width_mm((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_height_mm(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_height_mm "int gdk_monitor_get_height_mm(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_height_mm", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_height_mm((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_manufacturer(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_manufacturer "char* gdk_monitor_get_manufacturer(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_manufacturer", 1, monitor, "GdkMonitor*");
  return(s7_make_string(sc, gdk_monitor_get_manufacturer((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_model "char* gdk_monitor_get_model(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_model", 1, monitor, "GdkMonitor*");
  return(s7_make_string(sc, gdk_monitor_get_model((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_scale_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_scale_factor "int gdk_monitor_get_scale_factor(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_scale_factor", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_scale_factor((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_refresh_rate(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_refresh_rate "int gdk_monitor_get_refresh_rate(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_refresh_rate", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_refresh_rate((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_monitor_get_subpixel_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_subpixel_layout "GdkSubpixelLayout gdk_monitor_get_subpixel_layout(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_subpixel_layout", 1, monitor, "GdkMonitor*");
  return(s7_make_integer(sc, gdk_monitor_get_subpixel_layout((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gtk_scrolled_window_set_max_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_max_content_width "void gtk_scrolled_window_set_max_content_width(GtkScrolledWindow* scrolled_window, \
gint width)"
  s7_pointer _p;
  s7_pointer scrolled_window, width;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  width = s7_car(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_width", 2, width, "gint");
  gtk_scrolled_window_set_max_content_width((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gint)s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_max_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_max_content_width "gint gtk_scrolled_window_get_max_content_width(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_max_content_width", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_max_content_width((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_max_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_max_content_height "void gtk_scrolled_window_set_max_content_height(GtkScrolledWindow* scrolled_window, \
gint height)"
  s7_pointer _p;
  s7_pointer scrolled_window, height;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_max_content_height", 2, height, "gint");
  gtk_scrolled_window_set_max_content_height((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gint)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_max_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_max_content_height "gint gtk_scrolled_window_get_max_content_height(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_max_content_height", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_integer(sc, gtk_scrolled_window_get_max_content_height((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gdk_device_pad_get_n_groups(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_n_groups "gint gdk_device_pad_get_n_groups(GdkDevicePad* pad)"
  s7_pointer pad;
  pad = s7_car(args);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_n_groups", 1, pad, "GdkDevicePad*");
  return(s7_make_integer(sc, gdk_device_pad_get_n_groups((GdkDevicePad*)s7_c_pointer(pad))));
}

static s7_pointer lg_gdk_device_pad_get_group_n_modes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_group_n_modes "gint gdk_device_pad_get_group_n_modes(GdkDevicePad* pad, \
gint group_idx)"
  s7_pointer _p;
  s7_pointer pad, group_idx;
  _p = args;
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_group_n_modes", 1, pad, "GdkDevicePad*");
  group_idx = s7_car(_p);
  if (!s7_is_integer(group_idx)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_group_n_modes", 2, group_idx, "gint");
  return(s7_make_integer(sc, gdk_device_pad_get_group_n_modes((GdkDevicePad*)s7_c_pointer(pad), (gint)s7_integer(group_idx))));
}

static s7_pointer lg_gdk_device_pad_get_n_features(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_n_features "gint gdk_device_pad_get_n_features(GdkDevicePad* pad, GdkDevicePadFeature feature)"
  s7_pointer _p;
  s7_pointer pad, feature;
  _p = args;
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_n_features", 1, pad, "GdkDevicePad*");
  feature = s7_car(_p);
  if (!s7_is_integer(feature)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_n_features", 2, feature, "GdkDevicePadFeature");
  return(s7_make_integer(sc, gdk_device_pad_get_n_features((GdkDevicePad*)s7_c_pointer(pad), (GdkDevicePadFeature)s7_integer(feature))));
}

static s7_pointer lg_gdk_device_pad_get_feature_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_pad_get_feature_group "gint gdk_device_pad_get_feature_group(GdkDevicePad* pad, \
GdkDevicePadFeature feature, gint feature_idx)"
  s7_pointer _p;
  s7_pointer pad, feature, feature_idx;
  _p = args;
  pad = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevicePad__sym)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_feature_group", 1, pad, "GdkDevicePad*");
  feature = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(feature)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_feature_group", 2, feature, "GdkDevicePadFeature");
  feature_idx = s7_car(_p);
  if (!s7_is_integer(feature_idx)) s7_wrong_type_arg_error(sc, "gdk_device_pad_get_feature_group", 3, feature_idx, "gint");
  return(s7_make_integer(sc, gdk_device_pad_get_feature_group((GdkDevicePad*)s7_c_pointer(pad), (GdkDevicePadFeature)s7_integer(feature), (gint)s7_integer(feature_idx))));
}

static s7_pointer lg_gtk_menu_popup_at_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popup_at_widget "void gtk_menu_popup_at_widget(GtkMenu* menu, GtkWidget* widget, \
GdkGravity widget_anchor, GdkGravity menu_anchor, GdkEvent* trigger_event)"
  s7_pointer _p;
  s7_pointer menu, widget, widget_anchor, menu_anchor, trigger_event;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 1, menu, "GtkMenu*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 2, widget, "GtkWidget*");
  widget_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(widget_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 3, widget_anchor, "GdkGravity");
  menu_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(menu_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 4, menu_anchor, "GdkGravity");
  trigger_event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(trigger_event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_widget", 5, trigger_event, "GdkEvent*");
  gtk_menu_popup_at_widget((GtkMenu*)s7_c_pointer(menu), (GtkWidget*)s7_c_pointer(widget), (GdkGravity)s7_integer(widget_anchor), (GdkGravity)s7_integer(menu_anchor), (GdkEvent*)s7_c_pointer(trigger_event));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_popup_at_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popup_at_pointer "void gtk_menu_popup_at_pointer(GtkMenu* menu, GdkEvent* trigger_event)"
  s7_pointer _p;
  s7_pointer menu, trigger_event;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_pointer", 1, menu, "GtkMenu*");
  trigger_event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(trigger_event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_pointer", 2, trigger_event, "GdkEvent*");
  gtk_menu_popup_at_pointer((GtkMenu*)s7_c_pointer(menu), (GdkEvent*)s7_c_pointer(trigger_event));
  return(lg_false);
}

static s7_pointer lg_gtk_pad_controller_set_action_entries(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_pad_controller_set_action_entries "void gtk_pad_controller_set_action_entries(GtkPadController* controller, \
GtkPadActionEntry* entries, gint n_entries)"
  s7_pointer _p;
  s7_pointer controller, entries, n_entries;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkPadController__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action_entries", 1, controller, "GtkPadController*");
  entries = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entries, GtkPadActionEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action_entries", 2, entries, "GtkPadActionEntry*");
  n_entries = s7_car(_p);
  if (!s7_is_integer(n_entries)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action_entries", 3, n_entries, "gint");
  gtk_pad_controller_set_action_entries((GtkPadController*)s7_c_pointer(controller), (GtkPadActionEntry*)s7_c_pointer(entries), (gint)s7_integer(n_entries));
  return(lg_false);
}

static s7_pointer lg_gtk_pad_controller_set_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_pad_controller_set_action "void gtk_pad_controller_set_action(GtkPadController* controller, \
GtkPadActionType type, gint index, gint mode, gchar* label, gchar* action_name)"
  s7_pointer _p;
  s7_pointer controller, type, index, mode, label, action_name;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkPadController__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 1, controller, "GtkPadController*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 2, type, "GtkPadActionType");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 3, index, "gint");
  mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(mode)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 4, mode, "gint");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 5, label, "gchar*");
  action_name = s7_car(_p);
  if (!s7_is_string(action_name)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_set_action", 6, action_name, "gchar*");
  gtk_pad_controller_set_action((GtkPadController*)s7_c_pointer(controller), (GtkPadActionType)s7_integer(type), (gint)s7_integer(index), (gint)s7_integer(mode), (const gchar*)s7_string(label), (const gchar*)s7_string(action_name));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_label_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_new "GtkWidget* gtk_shortcut_label_new(gchar* accelerator)"
  s7_pointer accelerator;
  accelerator = s7_car(args);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_new", 1, accelerator, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_shortcut_label_new((const gchar*)s7_string(accelerator))));
}

static s7_pointer lg_gtk_shortcut_label_get_accelerator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_get_accelerator "gchar* gtk_shortcut_label_get_accelerator(GtkShortcutLabel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_get_accelerator", 1, self, "GtkShortcutLabel*");
    return(s7_make_string(sc, (gchar*)gtk_shortcut_label_get_accelerator((GtkShortcutLabel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_label_set_accelerator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_set_accelerator "void gtk_shortcut_label_set_accelerator(GtkShortcutLabel* self, \
gchar* accelerator)"
  s7_pointer _p;
  s7_pointer self, accelerator;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_accelerator", 1, self, "GtkShortcutLabel*");
  accelerator = s7_car(_p);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_accelerator", 2, accelerator, "gchar*");
  gtk_shortcut_label_set_accelerator((GtkShortcutLabel*)s7_c_pointer(self), (const gchar*)s7_string(accelerator));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_label_get_disabled_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_get_disabled_text "gchar* gtk_shortcut_label_get_disabled_text(GtkShortcutLabel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_get_disabled_text", 1, self, "GtkShortcutLabel*");
    return(s7_make_string(sc, (gchar*)gtk_shortcut_label_get_disabled_text((GtkShortcutLabel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_label_set_disabled_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_label_set_disabled_text "void gtk_shortcut_label_set_disabled_text(GtkShortcutLabel* self, \
gchar* disabled_text)"
  s7_pointer _p;
  s7_pointer self, disabled_text;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_disabled_text", 1, self, "GtkShortcutLabel*");
  disabled_text = s7_car(_p);
  if (!s7_is_string(disabled_text)) s7_wrong_type_arg_error(sc, "gtk_shortcut_label_set_disabled_text", 2, disabled_text, "gchar*");
  gtk_shortcut_label_set_disabled_text((GtkShortcutLabel*)s7_c_pointer(self), (const gchar*)s7_string(disabled_text));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_set_propagate_natural_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_propagate_natural_width "void gtk_scrolled_window_set_propagate_natural_width(GtkScrolledWindow* scrolled_window, \
gboolean propagate)"
  s7_pointer _p;
  s7_pointer scrolled_window, propagate;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_width", 1, scrolled_window, "GtkScrolledWindow*");
  propagate = s7_car(_p);
  if (!s7_is_boolean(propagate)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_width", 2, propagate, "gboolean");
  gtk_scrolled_window_set_propagate_natural_width((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gboolean)lg_boolean(propagate));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_propagate_natural_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_propagate_natural_width "gboolean gtk_scrolled_window_get_propagate_natural_width(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_propagate_natural_width", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_propagate_natural_width((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_scrolled_window_set_propagate_natural_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_propagate_natural_height "void gtk_scrolled_window_set_propagate_natural_height(GtkScrolledWindow* scrolled_window, \
gboolean propagate)"
  s7_pointer _p;
  s7_pointer scrolled_window, propagate;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_height", 1, scrolled_window, "GtkScrolledWindow*");
  propagate = s7_car(_p);
  if (!s7_is_boolean(propagate)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_propagate_natural_height", 2, propagate, "gboolean");
  gtk_scrolled_window_set_propagate_natural_height((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gboolean)lg_boolean(propagate));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_propagate_natural_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_propagate_natural_height "gboolean gtk_scrolled_window_get_propagate_natural_height(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_propagate_natural_height", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_propagate_natural_height((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static s7_pointer lg_gdk_display_is_composited(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_is_composited "gboolean gdk_display_is_composited(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_is_composited", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_is_composited((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_is_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_is_rgba "gboolean gdk_display_is_rgba(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_is_rgba", 1, display, "GdkDisplay*");
  return(s7_make_boolean(sc, gdk_display_is_rgba((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_button_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_icon_name "void gtk_button_set_icon_name(GtkButton* button, char* icon_name)"
  s7_pointer _p;
  s7_pointer button, icon_name;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_icon_name", 1, button, "GtkButton*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_button_set_icon_name", 2, icon_name, "char*");
  gtk_button_set_icon_name((GtkButton*)s7_c_pointer(button), (char*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_icon_name "char* gtk_button_get_icon_name(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_icon_name", 1, button, "GtkButton*");
  return(s7_make_string(sc, gtk_button_get_icon_name((GtkButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_drawing_area_set_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_set_content_width "void gtk_drawing_area_set_content_width(GtkDrawingArea* self, \
int width)"
  s7_pointer _p;
  s7_pointer self, width;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_width", 1, self, "GtkDrawingArea*");
  width = s7_car(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_width", 2, width, "int");
  gtk_drawing_area_set_content_width((GtkDrawingArea*)s7_c_pointer(self), (int)s7_integer(width));
  return(lg_false);
}

static s7_pointer lg_gtk_drawing_area_get_content_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_get_content_width "int gtk_drawing_area_get_content_width(GtkDrawingArea* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_get_content_width", 1, self, "GtkDrawingArea*");
  return(s7_make_integer(sc, gtk_drawing_area_get_content_width((GtkDrawingArea*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drawing_area_set_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_set_content_height "void gtk_drawing_area_set_content_height(GtkDrawingArea* self, \
int height)"
  s7_pointer _p;
  s7_pointer self, height;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_height", 1, self, "GtkDrawingArea*");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_content_height", 2, height, "int");
  gtk_drawing_area_set_content_height((GtkDrawingArea*)s7_c_pointer(self), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_drawing_area_get_content_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_get_content_height "int gtk_drawing_area_get_content_height(GtkDrawingArea* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_get_content_height", 1, self, "GtkDrawingArea*");
  return(s7_make_integer(sc, gtk_drawing_area_get_content_height((GtkDrawingArea*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drawing_area_set_draw_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drawing_area_set_draw_func "void gtk_drawing_area_set_draw_func(GtkDrawingArea* self, \
GtkDrawingAreaDrawFunc func, lambda_data func_info, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer self, func, func_info, destroy;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDrawingArea__sym)) s7_wrong_type_arg_error(sc, "gtk_drawing_area_set_draw_func", 1, self, "GtkDrawingArea*");
  func = s7_car(_p); _p = s7_cdr(_p);
  func_info = s7_car(_p); _p = s7_cdr(_p);
  destroy = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    gtk_drawing_area_set_draw_func((GtkDrawingArea*)s7_c_pointer(self), lg_draw_func, (gpointer)lg_ptr, lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gdk_rgba_is_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_is_clear "gboolean gdk_rgba_is_clear(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_is_clear", 1, rgba, "GdkRGBA*");
  return(s7_make_boolean(sc, gdk_rgba_is_clear((GdkRGBA*)s7_c_pointer(rgba))));
}

static s7_pointer lg_gdk_rgba_is_opaque(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rgba_is_opaque "gboolean gdk_rgba_is_opaque(GdkRGBA* rgba)"
  s7_pointer rgba;
  rgba = s7_car(args);
  if (!s7_is_c_pointer_of_type(rgba, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gdk_rgba_is_opaque", 1, rgba, "GdkRGBA*");
  return(s7_make_boolean(sc, gdk_rgba_is_opaque((GdkRGBA*)s7_c_pointer(rgba))));
}

static s7_pointer lg_gtk_flow_box_get_child_at_pos(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flow_box_get_child_at_pos "GtkFlowBoxChild* gtk_flow_box_get_child_at_pos(GtkFlowBox* box, \
gint x, gint y)"
  s7_pointer _p;
  s7_pointer box, x, y;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkFlowBox__sym)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_pos", 1, box, "GtkFlowBox*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_pos", 2, x, "gint");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_flow_box_get_child_at_pos", 3, y, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkFlowBoxChild__sym, gtk_flow_box_get_child_at_pos((GtkFlowBox*)s7_c_pointer(box), (gint)s7_integer(x), (gint)s7_integer(y))));
}

static s7_pointer lg_gtk_about_dialog_get_system_information(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_system_information "gchar* gtk_about_dialog_get_system_information(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_system_information", 1, about, "GtkAboutDialog*");
    return(s7_make_string(sc, (gchar*)gtk_about_dialog_get_system_information((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_system_information(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_system_information "void gtk_about_dialog_set_system_information(GtkAboutDialog* about, \
gchar* system_information)"
  s7_pointer _p;
  s7_pointer about, system_information;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_system_information", 1, about, "GtkAboutDialog*");
  system_information = s7_car(_p);
  if (!s7_is_string(system_information)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_system_information", 2, system_information, "gchar*");
  gtk_about_dialog_set_system_information((GtkAboutDialog*)s7_c_pointer(about), (const gchar*)s7_string(system_information));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_set_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_set_revealed "void gtk_action_bar_set_revealed(GtkActionBar* action_bar, gboolean revealed)"
  s7_pointer _p;
  s7_pointer action_bar, revealed;
  _p = args;
  action_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(action_bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_revealed", 1, action_bar, "GtkActionBar*");
  revealed = s7_car(_p);
  if (!s7_is_boolean(revealed)) s7_wrong_type_arg_error(sc, "gtk_action_bar_set_revealed", 2, revealed, "gboolean");
  gtk_action_bar_set_revealed((GtkActionBar*)s7_c_pointer(action_bar), (gboolean)lg_boolean(revealed));
  return(lg_false);
}

static s7_pointer lg_gtk_action_bar_get_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_action_bar_get_revealed "gboolean gtk_action_bar_get_revealed(GtkActionBar* action_bar)"
  s7_pointer action_bar;
  action_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(action_bar, GtkActionBar__sym)) s7_wrong_type_arg_error(sc, "gtk_action_bar_get_revealed", 1, action_bar, "GtkActionBar*");
  return(s7_make_boolean(sc, gtk_action_bar_get_revealed((GtkActionBar*)s7_c_pointer(action_bar))));
}

static s7_pointer lg_gtk_check_button_set_draw_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_set_draw_indicator "void gtk_check_button_set_draw_indicator(GtkCheckButton* check_button, \
gboolean draw_indicator)"
  s7_pointer _p;
  s7_pointer check_button, draw_indicator;
  _p = args;
  check_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_draw_indicator", 1, check_button, "GtkCheckButton*");
  draw_indicator = s7_car(_p);
  if (!s7_is_boolean(draw_indicator)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_draw_indicator", 2, draw_indicator, "gboolean");
  gtk_check_button_set_draw_indicator((GtkCheckButton*)s7_c_pointer(check_button), (gboolean)lg_boolean(draw_indicator));
  return(lg_false);
}

static s7_pointer lg_gtk_check_button_get_draw_indicator(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_get_draw_indicator "gboolean gtk_check_button_get_draw_indicator(GtkCheckButton* check_button)"
  s7_pointer check_button;
  check_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_get_draw_indicator", 1, check_button, "GtkCheckButton*");
  return(s7_make_boolean(sc, gtk_check_button_get_draw_indicator((GtkCheckButton*)s7_c_pointer(check_button))));
}

static s7_pointer lg_gtk_check_button_set_inconsistent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_set_inconsistent "void gtk_check_button_set_inconsistent(GtkCheckButton* check_button, \
gboolean inconsistent)"
  s7_pointer _p;
  s7_pointer check_button, inconsistent;
  _p = args;
  check_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_inconsistent", 1, check_button, "GtkCheckButton*");
  inconsistent = s7_car(_p);
  if (!s7_is_boolean(inconsistent)) s7_wrong_type_arg_error(sc, "gtk_check_button_set_inconsistent", 2, inconsistent, "gboolean");
  gtk_check_button_set_inconsistent((GtkCheckButton*)s7_c_pointer(check_button), (gboolean)lg_boolean(inconsistent));
  return(lg_false);
}

static s7_pointer lg_gtk_check_button_get_inconsistent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_check_button_get_inconsistent "gboolean gtk_check_button_get_inconsistent(GtkCheckButton* check_button)"
  s7_pointer check_button;
  check_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(check_button, GtkCheckButton__sym)) s7_wrong_type_arg_error(sc, "gtk_check_button_get_inconsistent", 1, check_button, "GtkCheckButton*");
  return(s7_make_boolean(sc, gtk_check_button_get_inconsistent((GtkCheckButton*)s7_c_pointer(check_button))));
}

static s7_pointer lg_gtk_info_bar_set_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_set_revealed "void gtk_info_bar_set_revealed(GtkInfoBar* info_bar, gboolean revealed)"
  s7_pointer _p;
  s7_pointer info_bar, revealed;
  _p = args;
  info_bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_revealed", 1, info_bar, "GtkInfoBar*");
  revealed = s7_car(_p);
  if (!s7_is_boolean(revealed)) s7_wrong_type_arg_error(sc, "gtk_info_bar_set_revealed", 2, revealed, "gboolean");
  gtk_info_bar_set_revealed((GtkInfoBar*)s7_c_pointer(info_bar), (gboolean)lg_boolean(revealed));
  return(lg_false);
}

static s7_pointer lg_gtk_info_bar_get_revealed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_info_bar_get_revealed "gboolean gtk_info_bar_get_revealed(GtkInfoBar* info_bar)"
  s7_pointer info_bar;
  info_bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(info_bar, GtkInfoBar__sym)) s7_wrong_type_arg_error(sc, "gtk_info_bar_get_revealed", 1, info_bar, "GtkInfoBar*");
  return(s7_make_boolean(sc, gtk_info_bar_get_revealed((GtkInfoBar*)s7_c_pointer(info_bar))));
}

static s7_pointer lg_gtk_widget_get_first_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_first_child "GtkWidget* gtk_widget_get_first_child(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_first_child", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_first_child((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_last_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_last_child "GtkWidget* gtk_widget_get_last_child(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_last_child", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_last_child((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_next_sibling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_next_sibling "GtkWidget* gtk_widget_get_next_sibling(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_next_sibling", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_next_sibling((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_prev_sibling(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_prev_sibling "GtkWidget* gtk_widget_get_prev_sibling(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_prev_sibling", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_prev_sibling((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_focus_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_focus_child "void gtk_widget_set_focus_child(GtkWidget* widget, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer widget, child;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_child", 1, widget, "GtkWidget*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_focus_child", 2, child, "GtkWidget*");
  gtk_widget_set_focus_child((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_insert_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_insert_after "void gtk_widget_insert_after(GtkWidget* widget, GtkWidget* parent, \
GtkWidget* previous_sibling)"
  s7_pointer _p;
  s7_pointer widget, parent, previous_sibling;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_after", 1, widget, "GtkWidget*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_after", 2, parent, "GtkWidget*");
  previous_sibling = s7_car(_p);
  if (!s7_is_c_pointer_of_type(previous_sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_after", 3, previous_sibling, "GtkWidget*");
  gtk_widget_insert_after((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(parent), (GtkWidget*)s7_c_pointer(previous_sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_insert_before(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_insert_before "void gtk_widget_insert_before(GtkWidget* widget, GtkWidget* parent, \
GtkWidget* next_sibling)"
  s7_pointer _p;
  s7_pointer widget, parent, next_sibling;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_before", 1, widget, "GtkWidget*");
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_before", 2, parent, "GtkWidget*");
  next_sibling = s7_car(_p);
  if (!s7_is_c_pointer_of_type(next_sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_before", 3, next_sibling, "GtkWidget*");
  gtk_widget_insert_before((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(parent), (GtkWidget*)s7_c_pointer(next_sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_new "GtkWidget* gtk_center_box_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_box_new()));
}

static s7_pointer lg_gtk_center_box_set_start_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_start_widget "void gtk_center_box_set_start_widget(GtkCenterBox* self, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_start_widget", 1, self, "GtkCenterBox*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_start_widget", 2, child, "GtkWidget*");
  gtk_center_box_set_start_widget((GtkCenterBox*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_set_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_center_widget "void gtk_center_box_set_center_widget(GtkCenterBox* self, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_center_widget", 1, self, "GtkCenterBox*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_center_widget", 2, child, "GtkWidget*");
  gtk_center_box_set_center_widget((GtkCenterBox*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_set_end_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_end_widget "void gtk_center_box_set_end_widget(GtkCenterBox* self, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_end_widget", 1, self, "GtkCenterBox*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_end_widget", 2, child, "GtkWidget*");
  gtk_center_box_set_end_widget((GtkCenterBox*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_get_start_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_start_widget "GtkWidget* gtk_center_box_get_start_widget(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_start_widget", 1, self, "GtkCenterBox*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_box_get_start_widget((GtkCenterBox*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_box_get_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_center_widget "GtkWidget* gtk_center_box_get_center_widget(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_center_widget", 1, self, "GtkCenterBox*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_box_get_center_widget((GtkCenterBox*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_box_get_end_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_end_widget "GtkWidget* gtk_center_box_get_end_widget(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_end_widget", 1, self, "GtkCenterBox*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_box_get_end_widget((GtkCenterBox*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_box_set_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_set_baseline_position "void gtk_center_box_set_baseline_position(GtkCenterBox* self, \
GtkBaselinePosition position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_baseline_position", 1, self, "GtkCenterBox*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_center_box_set_baseline_position", 2, position, "GtkBaselinePosition");
  gtk_center_box_set_baseline_position((GtkCenterBox*)s7_c_pointer(self), (GtkBaselinePosition)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_center_box_get_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_box_get_baseline_position "GtkBaselinePosition gtk_center_box_get_baseline_position(GtkCenterBox* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterBox__sym)) s7_wrong_type_arg_error(sc, "gtk_center_box_get_baseline_position", 1, self, "GtkCenterBox*");
  return(s7_make_integer(sc, gtk_center_box_get_baseline_position((GtkCenterBox*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_event_set_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_coords "void gdk_event_set_coords(GdkEvent* event, gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer event, x, y;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_coords", 1, event, "GdkEvent*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gdk_event_set_coords", 2, x, "gdouble");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gdk_event_set_coords", 3, y, "gdouble");
  gdk_event_set_coords((GdkEvent*)s7_c_pointer(event), (gdouble)s7_real(x), (gdouble)s7_real(y));
  return(lg_false);
}

static s7_pointer lg_gdk_rectangle_contains_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_rectangle_contains_point "gboolean gdk_rectangle_contains_point(GdkRectangle* rect, int x, \
int y)"
  s7_pointer _p;
  s7_pointer rect, x, y;
  _p = args;
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_rectangle_contains_point", 1, rect, "GdkRectangle*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_rectangle_contains_point", 2, x, "int");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_rectangle_contains_point", 3, y, "int");
  return(s7_make_boolean(sc, gdk_rectangle_contains_point((GdkRectangle*)s7_c_pointer(rect), (int)s7_integer(x), (int)s7_integer(y))));
}

static s7_pointer lg_gtk_accel_label_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_label "void gtk_accel_label_set_label(GtkAccelLabel* accel_label, char* text)"
  s7_pointer _p;
  s7_pointer accel_label, text;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_label", 1, accel_label, "GtkAccelLabel*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_label", 2, text, "char*");
  gtk_accel_label_set_label((GtkAccelLabel*)s7_c_pointer(accel_label), (const char*)(char*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_label "char* gtk_accel_label_get_label(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_label", 1, accel_label, "GtkAccelLabel*");
    return(s7_make_string(sc, (char*)gtk_accel_label_get_label((GtkAccelLabel*)s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_accel_label_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_set_use_underline "void gtk_accel_label_set_use_underline(GtkAccelLabel* accel_label, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer accel_label, setting;
  _p = args;
  accel_label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_use_underline", 1, accel_label, "GtkAccelLabel*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_accel_label_set_use_underline", 2, setting, "gboolean");
  gtk_accel_label_set_use_underline((GtkAccelLabel*)s7_c_pointer(accel_label), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_use_underline "gboolean gtk_accel_label_get_use_underline(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_use_underline", 1, accel_label, "GtkAccelLabel*");
  return(s7_make_boolean(sc, gtk_accel_label_get_use_underline((GtkAccelLabel*)s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_scrollbar_set_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_set_adjustment "void gtk_scrollbar_set_adjustment(GtkScrollbar* self, GtkAdjustment* adjustment)"
  s7_pointer _p;
  s7_pointer self, adjustment;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkScrollbar__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_set_adjustment", 1, self, "GtkScrollbar*");
  adjustment = s7_car(_p);
  if (!s7_is_c_pointer_of_type(adjustment, GtkAdjustment__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_set_adjustment", 2, adjustment, "GtkAdjustment*");
  gtk_scrollbar_set_adjustment((GtkScrollbar*)s7_c_pointer(self), (GtkAdjustment*)s7_c_pointer(adjustment));
  return(lg_false);
}

static s7_pointer lg_gtk_scrollbar_get_adjustment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrollbar_get_adjustment "GtkAdjustment* gtk_scrollbar_get_adjustment(GtkScrollbar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkScrollbar__sym)) s7_wrong_type_arg_error(sc, "gtk_scrollbar_get_adjustment", 1, self, "GtkScrollbar*");
  return(lg_make_c_pointer_with_type(sc, GtkAdjustment__sym, gtk_scrollbar_get_adjustment((GtkScrollbar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_style_context_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_new "GtkStyleContext* gtk_style_context_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkStyleContext__sym, gtk_style_context_new()));
}

static s7_pointer lg_gtk_style_context_add_provider(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_add_provider "void gtk_style_context_add_provider(GtkStyleContext* context, \
GtkStyleProvider* provider, guint priority)"
  s7_pointer _p;
  s7_pointer context, provider, priority;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_provider", 1, context, "GtkStyleContext*");
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GtkStyleProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_provider", 2, provider, "GtkStyleProvider*");
  priority = s7_car(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_provider", 3, priority, "guint");
  gtk_style_context_add_provider((GtkStyleContext*)s7_c_pointer(context), (GtkStyleProvider*)s7_c_pointer(provider), (guint)s7_integer(priority));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_save(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_save "void gtk_style_context_save(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_save", 1, context, "GtkStyleContext*");
  gtk_style_context_save((GtkStyleContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_restore(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_restore "void gtk_style_context_restore(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_restore", 1, context, "GtkStyleContext*");
  gtk_style_context_restore((GtkStyleContext*)s7_c_pointer(context));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_section(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_section "GtkCssSection* gtk_style_context_get_section(GtkStyleContext* context, \
gchar* property)"
  s7_pointer _p;
  s7_pointer context, property;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_section", 1, context, "GtkStyleContext*");
  property = s7_car(_p);
  if (!s7_is_string(property)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_section", 2, property, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkCssSection__sym, gtk_style_context_get_section((GtkStyleContext*)s7_c_pointer(context), (const gchar*)s7_string(property))));
}

static s7_pointer lg_gtk_style_context_get_property(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_property "void gtk_style_context_get_property(GtkStyleContext* context, \
gchar* property, GValue* value)"
  s7_pointer _p;
  s7_pointer context, property, value;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_property", 1, context, "GtkStyleContext*");
  property = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(property)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_property", 2, property, "gchar*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_property", 3, value, "GValue*");
  gtk_style_context_get_property((GtkStyleContext*)s7_c_pointer(context), (gchar*)s7_string(property), (GValue*)s7_c_pointer(value));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_set_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_set_state "void gtk_style_context_set_state(GtkStyleContext* context, GtkStateFlags flags)"
  s7_pointer _p;
  s7_pointer context, flags;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_state", 1, context, "GtkStyleContext*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_state", 2, flags, "GtkStateFlags");
  gtk_style_context_set_state((GtkStyleContext*)s7_c_pointer(context), (GtkStateFlags)s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_state "GtkStateFlags gtk_style_context_get_state(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_state", 1, context, "GtkStyleContext*");
  return(s7_make_integer(sc, gtk_style_context_get_state((GtkStyleContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_style_context_set_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_set_scale "void gtk_style_context_set_scale(GtkStyleContext* context, gint scale)"
  s7_pointer _p;
  s7_pointer context, scale;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_scale", 1, context, "GtkStyleContext*");
  scale = s7_car(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_scale", 2, scale, "gint");
  gtk_style_context_set_scale((GtkStyleContext*)s7_c_pointer(context), (gint)s7_integer(scale));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_scale "gint gtk_style_context_get_scale(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_scale", 1, context, "GtkStyleContext*");
  return(s7_make_integer(sc, gtk_style_context_get_scale((GtkStyleContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_style_context_set_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_set_path "void gtk_style_context_set_path(GtkStyleContext* context, GtkWidgetPath* path)"
  s7_pointer _p;
  s7_pointer context, path;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_path", 1, context, "GtkStyleContext*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkWidgetPath__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_path", 2, path, "GtkWidgetPath*");
  gtk_style_context_set_path((GtkStyleContext*)s7_c_pointer(context), (GtkWidgetPath*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_path "GtkWidgetPath* gtk_style_context_get_path(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_path", 1, context, "GtkStyleContext*");
    return(lg_make_c_pointer_with_type(sc, GtkWidgetPath__sym, (GtkWidgetPath*)gtk_style_context_get_path((GtkStyleContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_style_context_set_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_set_parent "void gtk_style_context_set_parent(GtkStyleContext* context, \
GtkStyleContext* parent)"
  s7_pointer _p;
  s7_pointer context, parent;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_parent", 1, context, "GtkStyleContext*");
  parent = s7_car(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_parent", 2, parent, "GtkStyleContext*");
  gtk_style_context_set_parent((GtkStyleContext*)s7_c_pointer(context), (GtkStyleContext*)s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_parent "GtkStyleContext* gtk_style_context_get_parent(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_parent", 1, context, "GtkStyleContext*");
  return(lg_make_c_pointer_with_type(sc, GtkStyleContext__sym, gtk_style_context_get_parent((GtkStyleContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_style_context_list_classes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_list_classes "GList* gtk_style_context_list_classes(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_list_classes", 1, context, "GtkStyleContext*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_style_context_list_classes((GtkStyleContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_style_context_add_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_add_class "void gtk_style_context_add_class(GtkStyleContext* context, gchar* class_name)"
  s7_pointer _p;
  s7_pointer context, class_name;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_class", 1, context, "GtkStyleContext*");
  class_name = s7_car(_p);
  if (!s7_is_string(class_name)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_class", 2, class_name, "gchar*");
  gtk_style_context_add_class((GtkStyleContext*)s7_c_pointer(context), (const gchar*)s7_string(class_name));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_remove_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_remove_class "void gtk_style_context_remove_class(GtkStyleContext* context, \
gchar* class_name)"
  s7_pointer _p;
  s7_pointer context, class_name;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_remove_class", 1, context, "GtkStyleContext*");
  class_name = s7_car(_p);
  if (!s7_is_string(class_name)) s7_wrong_type_arg_error(sc, "gtk_style_context_remove_class", 2, class_name, "gchar*");
  gtk_style_context_remove_class((GtkStyleContext*)s7_c_pointer(context), (const gchar*)s7_string(class_name));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_has_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_has_class "gboolean gtk_style_context_has_class(GtkStyleContext* context, \
gchar* class_name)"
  s7_pointer _p;
  s7_pointer context, class_name;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_has_class", 1, context, "GtkStyleContext*");
  class_name = s7_car(_p);
  if (!s7_is_string(class_name)) s7_wrong_type_arg_error(sc, "gtk_style_context_has_class", 2, class_name, "gchar*");
  return(s7_make_boolean(sc, gtk_style_context_has_class((GtkStyleContext*)s7_c_pointer(context), (const gchar*)s7_string(class_name))));
}

static s7_pointer lg_gtk_style_context_lookup_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_lookup_color "gboolean gtk_style_context_lookup_color(GtkStyleContext* context, \
gchar* color_name, GdkRGBA* color)"
  s7_pointer _p;
  s7_pointer context, color_name, color;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_lookup_color", 1, context, "GtkStyleContext*");
  color_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(color_name)) s7_wrong_type_arg_error(sc, "gtk_style_context_lookup_color", 2, color_name, "gchar*");
  color = s7_car(_p);
  if (!s7_is_c_pointer_of_type(color, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_lookup_color", 3, color, "GdkRGBA*");
  return(s7_make_boolean(sc, gtk_style_context_lookup_color((GtkStyleContext*)s7_c_pointer(context), (const gchar*)s7_string(color_name), (GdkRGBA*)s7_c_pointer(color))));
}

static s7_pointer lg_gtk_style_context_get_color(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_color "void gtk_style_context_get_color(GtkStyleContext* context, GdkRGBA* color)"
  s7_pointer _p;
  s7_pointer context, color;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_color", 1, context, "GtkStyleContext*");
  color = s7_car(_p);
  if (!s7_is_c_pointer_of_type(color, GdkRGBA__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_color", 2, color, "GdkRGBA*");
  gtk_style_context_get_color((GtkStyleContext*)s7_c_pointer(context), (GdkRGBA*)s7_c_pointer(color));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_border(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_border "void gtk_style_context_get_border(GtkStyleContext* context, \
GtkBorder* border)"
  s7_pointer _p;
  s7_pointer context, border;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_border", 1, context, "GtkStyleContext*");
  border = s7_car(_p);
  if (!s7_is_c_pointer_of_type(border, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_border", 2, border, "GtkBorder*");
  gtk_style_context_get_border((GtkStyleContext*)s7_c_pointer(context), (GtkBorder*)s7_c_pointer(border));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_padding(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_padding "void gtk_style_context_get_padding(GtkStyleContext* context, \
GtkBorder* padding)"
  s7_pointer _p;
  s7_pointer context, padding;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_padding", 1, context, "GtkStyleContext*");
  padding = s7_car(_p);
  if (!s7_is_c_pointer_of_type(padding, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_padding", 2, padding, "GtkBorder*");
  gtk_style_context_get_padding((GtkStyleContext*)s7_c_pointer(context), (GtkBorder*)s7_c_pointer(padding));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_margin(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_margin "void gtk_style_context_get_margin(GtkStyleContext* context, \
GtkBorder* margin)"
  s7_pointer _p;
  s7_pointer context, margin;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_margin", 1, context, "GtkStyleContext*");
  margin = s7_car(_p);
  if (!s7_is_c_pointer_of_type(margin, GtkBorder__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_margin", 2, margin, "GtkBorder*");
  gtk_style_context_get_margin((GtkStyleContext*)s7_c_pointer(context), (GtkBorder*)s7_c_pointer(margin));
  return(lg_false);
}

static s7_pointer lg_gtk_render_insertion_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_insertion_cursor "void gtk_render_insertion_cursor(GtkStyleContext* context, cairo_t* cr, \
gdouble x, gdouble y, PangoLayout* layout, int index, PangoDirection direction)"
  s7_pointer _p;
  s7_pointer context, cr, x, y, layout, index, direction;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 2, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 3, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 4, y, "gdouble");
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, PangoLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 5, layout, "PangoLayout*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 6, index, "int");
  direction = s7_car(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_render_insertion_cursor", 7, direction, "PangoDirection");
  gtk_render_insertion_cursor((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (gdouble)s7_real(x), (gdouble)s7_real(y), (PangoLayout*)s7_c_pointer(layout), (int)s7_integer(index), (PangoDirection)s7_integer(direction));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_to_string "char* gtk_style_context_to_string(GtkStyleContext* context, \
GtkStyleContextPrintFlags flags)"
  s7_pointer _p;
  s7_pointer context, flags;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_to_string", 1, context, "GtkStyleContext*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_style_context_to_string", 2, flags, "GtkStyleContextPrintFlags");
  return(s7_make_string(sc, gtk_style_context_to_string((GtkStyleContext*)s7_c_pointer(context), (GtkStyleContextPrintFlags)s7_integer(flags))));
}

static s7_pointer lg_gtk_css_provider_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_new "GtkCssProvider* gtk_css_provider_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkCssProvider__sym, gtk_css_provider_new()));
}

static s7_pointer lg_gtk_css_provider_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_to_string "char* gtk_css_provider_to_string(GtkCssProvider* provider)"
  s7_pointer provider;
  provider = s7_car(args);
  if (!s7_is_c_pointer_of_type(provider, GtkCssProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_to_string", 1, provider, "GtkCssProvider*");
  return(s7_make_string(sc, gtk_css_provider_to_string((GtkCssProvider*)s7_c_pointer(provider))));
}

static s7_pointer lg_gtk_css_provider_load_from_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_load_from_data "void gtk_css_provider_load_from_data(GtkCssProvider* css_provider, \
gchar* data, gssize length)"
  s7_pointer _p;
  s7_pointer css_provider, data, length;
  _p = args;
  css_provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(css_provider, GtkCssProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_data", 1, css_provider, "GtkCssProvider*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(data)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_data", 2, data, "gchar*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_data", 3, length, "gssize");
  gtk_css_provider_load_from_data((GtkCssProvider*)s7_c_pointer(css_provider), (const gchar*)s7_string(data), (gssize)s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gtk_css_provider_load_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_load_from_file "void gtk_css_provider_load_from_file(GtkCssProvider* css_provider, \
GFile* file)"
  s7_pointer _p;
  s7_pointer css_provider, file;
  _p = args;
  css_provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(css_provider, GtkCssProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_file", 1, css_provider, "GtkCssProvider*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_file", 2, file, "GFile*");
  gtk_css_provider_load_from_file((GtkCssProvider*)s7_c_pointer(css_provider), (GFile*)s7_c_pointer(file));
  return(lg_false);
}

static s7_pointer lg_gtk_css_provider_load_from_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_load_from_path "void gtk_css_provider_load_from_path(GtkCssProvider* css_provider, \
gchar* path)"
  s7_pointer _p;
  s7_pointer css_provider, path;
  _p = args;
  css_provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(css_provider, GtkCssProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_path", 1, css_provider, "GtkCssProvider*");
  path = s7_car(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_path", 2, path, "gchar*");
  gtk_css_provider_load_from_path((GtkCssProvider*)s7_c_pointer(css_provider), (const gchar*)s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_css_provider_load_from_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_load_from_resource "void gtk_css_provider_load_from_resource(GtkCssProvider* css_provider, \
gchar* resource_path)"
  s7_pointer _p;
  s7_pointer css_provider, resource_path;
  _p = args;
  css_provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(css_provider, GtkCssProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_resource", 1, css_provider, "GtkCssProvider*");
  resource_path = s7_car(_p);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_from_resource", 2, resource_path, "gchar*");
  gtk_css_provider_load_from_resource((GtkCssProvider*)s7_c_pointer(css_provider), (const gchar*)s7_string(resource_path));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 94, 0)
static s7_pointer lg_gtk_gesture_drag_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_drag_new "GtkGesture* gtk_gesture_drag_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_drag_new()));
}

static s7_pointer lg_gtk_gesture_long_press_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_long_press_new "GtkGesture* gtk_gesture_long_press_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_long_press_new()));
}

static s7_pointer lg_gtk_gesture_pan_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_pan_new "GtkGesture* gtk_gesture_pan_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_gesture_pan_new", 1, orientation, "GtkOrientation");
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_pan_new((GtkOrientation)s7_integer(orientation))));
}

static s7_pointer lg_gtk_gesture_rotate_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_rotate_new "GtkGesture* gtk_gesture_rotate_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_rotate_new()));
}

static s7_pointer lg_gtk_gesture_swipe_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_swipe_new "GtkGesture* gtk_gesture_swipe_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_swipe_new()));
}

static s7_pointer lg_gtk_gesture_zoom_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_zoom_new "GtkGesture* gtk_gesture_zoom_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_zoom_new()));
}

static s7_pointer lg_gdk_event_set_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_set_keyval "void gdk_event_set_keyval(GdkEvent* event, guint keyval)"
  s7_pointer _p;
  s7_pointer event, keyval;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_set_keyval", 1, event, "GdkEvent*");
  keyval = s7_car(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_event_set_keyval", 2, keyval, "guint");
  gdk_event_set_keyval((GdkEvent*)s7_c_pointer(event), (guint)s7_integer(keyval));
  return(lg_false);
}

static s7_pointer lg_gdk_event_get_key_is_modifier(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_key_is_modifier "gboolean gdk_event_get_key_is_modifier(GdkEvent* event, gboolean* [is_modifier])"
  s7_pointer _p;
  s7_pointer event;
  gboolean ref_is_modifier;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_key_is_modifier", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_key_is_modifier((GdkEvent*)s7_c_pointer(event), &ref_is_modifier));
      return(s7_list(sc, 2, res_ult, s7_make_boolean(sc, ref_is_modifier)));
   }
}

static s7_pointer lg_gdk_event_get_key_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_key_group "gboolean gdk_event_get_key_group(GdkEvent* event, guint* [group])"
  s7_pointer _p;
  s7_pointer event;
  guint ref_group;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_key_group", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_key_group((GdkEvent*)s7_c_pointer(event), &ref_group));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_group)));
   }
}

static s7_pointer lg_gdk_event_is_sent(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_is_sent "gboolean gdk_event_is_sent(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_is_sent", 1, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_event_is_sent((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_event_get_crossing_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_crossing_mode "gboolean gdk_event_get_crossing_mode(GdkEvent* event, GdkCrossingMode* [mode])"
  s7_pointer _p;
  s7_pointer event;
  GdkCrossingMode ref_mode;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_crossing_mode", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_crossing_mode((GdkEvent*)s7_c_pointer(event), &ref_mode));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_mode)));
   }
}

static s7_pointer lg_gdk_event_get_crossing_detail(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_crossing_detail "gboolean gdk_event_get_crossing_detail(GdkEvent* event, GdkNotifyType* [detail])"
  s7_pointer _p;
  s7_pointer event;
  GdkNotifyType ref_detail;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_crossing_detail", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_crossing_detail((GdkEvent*)s7_c_pointer(event), &ref_detail));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_detail)));
   }
}

static s7_pointer lg_gdk_event_get_touchpad_gesture_phase(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_touchpad_gesture_phase "gboolean gdk_event_get_touchpad_gesture_phase(GdkEvent* event, \
GdkTouchpadGesturePhase* [phase])"
  s7_pointer _p;
  s7_pointer event;
  GdkTouchpadGesturePhase ref_phase;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_touchpad_gesture_phase", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_touchpad_gesture_phase((GdkEvent*)s7_c_pointer(event), &ref_phase));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_phase)));
   }
}

static s7_pointer lg_gdk_event_get_touchpad_gesture_n_fingers(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_touchpad_gesture_n_fingers "gboolean gdk_event_get_touchpad_gesture_n_fingers(GdkEvent* event, \
guint* [n_fingers])"
  s7_pointer _p;
  s7_pointer event;
  guint ref_n_fingers;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_touchpad_gesture_n_fingers", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_touchpad_gesture_n_fingers((GdkEvent*)s7_c_pointer(event), &ref_n_fingers));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_n_fingers)));
   }
}

static s7_pointer lg_gdk_event_get_touchpad_deltas(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_touchpad_deltas "gboolean gdk_event_get_touchpad_deltas(GdkEvent* event, double* [dx], \
double* [dy])"
  s7_pointer _p;
  s7_pointer event;
  double ref_dx;
  double ref_dy;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_touchpad_deltas", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_touchpad_deltas((GdkEvent*)s7_c_pointer(event), &ref_dx, &ref_dy));
      return(s7_list(sc, 3, res_ult, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
   }
}

static s7_pointer lg_gdk_event_get_touchpad_angle_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_touchpad_angle_delta "gboolean gdk_event_get_touchpad_angle_delta(GdkEvent* event, \
double* [delta])"
  s7_pointer _p;
  s7_pointer event;
  double ref_delta;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_touchpad_angle_delta", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_touchpad_angle_delta((GdkEvent*)s7_c_pointer(event), &ref_delta));
      return(s7_list(sc, 2, res_ult, s7_make_real(sc, ref_delta)));
   }
}

static s7_pointer lg_gdk_event_get_touchpad_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_touchpad_scale "gboolean gdk_event_get_touchpad_scale(GdkEvent* event, double* [scale])"
  s7_pointer _p;
  s7_pointer event;
  double ref_scale;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_touchpad_scale", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_touchpad_scale((GdkEvent*)s7_c_pointer(event), &ref_scale));
      return(s7_list(sc, 2, res_ult, s7_make_real(sc, ref_scale)));
   }
}

static s7_pointer lg_gdk_event_get_touch_emulating_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_touch_emulating_pointer "gboolean gdk_event_get_touch_emulating_pointer(GdkEvent* event, \
gboolean* [emulating])"
  s7_pointer _p;
  s7_pointer event;
  gboolean ref_emulating;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_touch_emulating_pointer", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_touch_emulating_pointer((GdkEvent*)s7_c_pointer(event), &ref_emulating));
      return(s7_list(sc, 2, res_ult, s7_make_boolean(sc, ref_emulating)));
   }
}

static s7_pointer lg_gdk_event_get_focus_in(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_focus_in "gboolean gdk_event_get_focus_in(GdkEvent* event, gboolean* [focus_in])"
  s7_pointer _p;
  s7_pointer event;
  gboolean ref_focus_in;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_focus_in", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_focus_in((GdkEvent*)s7_c_pointer(event), &ref_focus_in));
      return(s7_list(sc, 2, res_ult, s7_make_boolean(sc, ref_focus_in)));
   }
}

static s7_pointer lg_gdk_event_get_pad_group_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_pad_group_mode "gboolean gdk_event_get_pad_group_mode(GdkEvent* event, guint* [group], \
guint* [mode])"
  s7_pointer _p;
  s7_pointer event;
  guint ref_group;
  guint ref_mode;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_pad_group_mode", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_pad_group_mode((GdkEvent*)s7_c_pointer(event), &ref_group, &ref_mode));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_group), s7_make_integer(sc, ref_mode)));
   }
}

static s7_pointer lg_gdk_event_get_pad_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_pad_button "gboolean gdk_event_get_pad_button(GdkEvent* event, guint* [button])"
  s7_pointer _p;
  s7_pointer event;
  guint ref_button;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_pad_button", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_pad_button((GdkEvent*)s7_c_pointer(event), &ref_button));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_button)));
   }
}

static s7_pointer lg_gdk_event_get_pad_axis_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_pad_axis_value "gboolean gdk_event_get_pad_axis_value(GdkEvent* event, guint* [index], \
gdouble* [value])"
  s7_pointer _p;
  s7_pointer event;
  guint ref_index;
  gdouble ref_value;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_pad_axis_value", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_pad_axis_value((GdkEvent*)s7_c_pointer(event), &ref_index, &ref_value));
      return(s7_list(sc, 3, res_ult, s7_make_integer(sc, ref_index), s7_make_real(sc, ref_value)));
   }
}

static s7_pointer lg_gdk_event_get_axes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_event_get_axes "gboolean gdk_event_get_axes(GdkEvent* event, gdouble** [axes], guint* [n_axes])"
  s7_pointer _p;
  s7_pointer event;
  gdouble* ref_axes = NULL;
  guint ref_n_axes;
  _p = args;
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_event_get_axes", 1, event, "GdkEvent*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_event_get_axes((GdkEvent*)s7_c_pointer(event), &ref_axes, &ref_n_axes));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_axes), s7_make_integer(sc, ref_n_axes)));
   }
}

static s7_pointer lg_gtk_emoji_chooser_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_emoji_chooser_new "GtkWidget* gtk_emoji_chooser_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_emoji_chooser_new()));
}

static s7_pointer lg_gtk_event_controller_scroll_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_scroll_new "GtkEventController* gtk_event_controller_scroll_new(GtkEventControllerScrollFlags flags)"
  s7_pointer flags;
  flags = s7_car(args);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_event_controller_scroll_new", 1, flags, "GtkEventControllerScrollFlags");
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_event_controller_scroll_new((GtkEventControllerScrollFlags)s7_integer(flags))));
}

static s7_pointer lg_gtk_event_controller_scroll_set_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_scroll_set_flags "void gtk_event_controller_scroll_set_flags(GtkEventControllerScroll* controller, \
GtkEventControllerScrollFlags flags)"
  s7_pointer _p;
  s7_pointer controller, flags;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventControllerScroll__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_scroll_set_flags", 1, controller, "GtkEventControllerScroll*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_event_controller_scroll_set_flags", 2, flags, "GtkEventControllerScrollFlags");
  gtk_event_controller_scroll_set_flags((GtkEventControllerScroll*)s7_c_pointer(controller), (GtkEventControllerScrollFlags)s7_integer(flags));
  return(lg_false);
}

static s7_pointer lg_gtk_event_controller_scroll_get_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_scroll_get_flags "GtkEventControllerScrollFlags gtk_event_controller_scroll_get_flags(GtkEventControllerScroll* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventControllerScroll__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_scroll_get_flags", 1, controller, "GtkEventControllerScroll*");
  return(s7_make_integer(sc, gtk_event_controller_scroll_get_flags((GtkEventControllerScroll*)s7_c_pointer(controller))));
}

static s7_pointer lg_gdk_app_launch_context_set_desktop(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_app_launch_context_set_desktop "void gdk_app_launch_context_set_desktop(GdkAppLaunchContext* context, \
gint desktop)"
  s7_pointer _p;
  s7_pointer context, desktop;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkAppLaunchContext__sym)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_desktop", 1, context, "GdkAppLaunchContext*");
  desktop = s7_car(_p);
  if (!s7_is_integer(desktop)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_desktop", 2, desktop, "gint");
  gdk_app_launch_context_set_desktop((GdkAppLaunchContext*)s7_c_pointer(context), (gint)s7_integer(desktop));
  return(lg_false);
}

static s7_pointer lg_gdk_app_launch_context_set_timestamp(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_app_launch_context_set_timestamp "void gdk_app_launch_context_set_timestamp(GdkAppLaunchContext* context, \
guint32 timestamp)"
  s7_pointer _p;
  s7_pointer context, timestamp;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkAppLaunchContext__sym)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_timestamp", 1, context, "GdkAppLaunchContext*");
  timestamp = s7_car(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_timestamp", 2, timestamp, "guint32");
  gdk_app_launch_context_set_timestamp((GdkAppLaunchContext*)s7_c_pointer(context), (guint32)s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_app_launch_context_set_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_app_launch_context_set_icon "void gdk_app_launch_context_set_icon(GdkAppLaunchContext* context, \
GIcon* icon)"
  s7_pointer _p;
  s7_pointer context, icon;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkAppLaunchContext__sym)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_icon", 1, context, "GdkAppLaunchContext*");
  icon = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_icon", 2, icon, "GIcon*");
  gdk_app_launch_context_set_icon((GdkAppLaunchContext*)s7_c_pointer(context), (GIcon*)s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gdk_app_launch_context_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_app_launch_context_set_icon_name "void gdk_app_launch_context_set_icon_name(GdkAppLaunchContext* context, \
char* icon_name)"
  s7_pointer _p;
  s7_pointer context, icon_name;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GdkAppLaunchContext__sym)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_icon_name", 1, context, "GdkAppLaunchContext*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_set_icon_name", 2, icon_name, "char*");
  gdk_app_launch_context_set_icon_name((GdkAppLaunchContext*)s7_c_pointer(context), (const char*)(char*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_get_display "GdkDisplay* gdk_clipboard_get_display(GdkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_get_display", 1, clipboard, "GdkClipboard*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_clipboard_get_display((GdkClipboard*)s7_c_pointer(clipboard))));
}

static s7_pointer lg_gdk_clipboard_get_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_get_formats "GdkContentFormats* gdk_clipboard_get_formats(GdkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_get_formats", 1, clipboard, "GdkClipboard*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_clipboard_get_formats((GdkClipboard*)s7_c_pointer(clipboard))));
}

static s7_pointer lg_gdk_clipboard_is_local(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_is_local "gboolean gdk_clipboard_is_local(GdkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_is_local", 1, clipboard, "GdkClipboard*");
  return(s7_make_boolean(sc, gdk_clipboard_is_local((GdkClipboard*)s7_c_pointer(clipboard))));
}

static s7_pointer lg_gdk_clipboard_get_content(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_get_content "GdkContentProvider* gdk_clipboard_get_content(GdkClipboard* clipboard)"
  s7_pointer clipboard;
  clipboard = s7_car(args);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_get_content", 1, clipboard, "GdkClipboard*");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gdk_clipboard_get_content((GdkClipboard*)s7_c_pointer(clipboard))));
}

static s7_pointer lg_gdk_clipboard_store_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_store_async "void gdk_clipboard_store_async(GdkClipboard* clipboard, int io_priority, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  s7_pointer _p;
  s7_pointer clipboard, io_priority, cancellable, callback, user_data;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_async", 1, clipboard, "GdkClipboard*");
  io_priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(io_priority)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_async", 2, io_priority, "int");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_async", 3, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_async", 4, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_async", 5, user_data, "gpointer");
  gdk_clipboard_store_async((GdkClipboard*)s7_c_pointer(clipboard), (int)s7_integer(io_priority), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_store_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_store_finish "gboolean gdk_clipboard_store_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  s7_pointer _p;
  s7_pointer clipboard, result;
  GError* ref_error = NULL;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_finish", 1, clipboard, "GdkClipboard*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_store_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_clipboard_store_finish((GdkClipboard*)s7_c_pointer(clipboard), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_clipboard_read_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_async "void gdk_clipboard_read_async(GdkClipboard* clipboard, char** mime_types, \
int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  s7_pointer _p;
  s7_pointer clipboard, mime_types, io_priority, cancellable, callback, user_data;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_async", 1, clipboard, "GdkClipboard*");
  mime_types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mime_types, char___sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_async", 2, mime_types, "char**");
  io_priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(io_priority)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_async", 3, io_priority, "int");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_async", 4, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_async", 5, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_async", 6, user_data, "gpointer");
  gdk_clipboard_read_async((GdkClipboard*)s7_c_pointer(clipboard), (const char**)s7_c_pointer(mime_types), (int)s7_integer(io_priority), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_read_value_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_value_async "void gdk_clipboard_read_value_async(GdkClipboard* clipboard, \
GType type, int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  s7_pointer _p;
  s7_pointer clipboard, type, io_priority, cancellable, callback, user_data;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_async", 1, clipboard, "GdkClipboard*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_async", 2, type, "GType");
  io_priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(io_priority)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_async", 3, io_priority, "int");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_async", 4, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_async", 5, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_async", 6, user_data, "gpointer");
  gdk_clipboard_read_value_async((GdkClipboard*)s7_c_pointer(clipboard), (GType)s7_integer(type), (int)s7_integer(io_priority), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_read_value_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_value_finish "GValue* gdk_clipboard_read_value_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  s7_pointer _p;
  s7_pointer clipboard, result;
  GError* ref_error = NULL;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_finish", 1, clipboard, "GdkClipboard*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_value_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GValue__sym, gdk_clipboard_read_value_finish((GdkClipboard*)s7_c_pointer(clipboard), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_clipboard_read_texture_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_texture_async "void gdk_clipboard_read_texture_async(GdkClipboard* clipboard, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  s7_pointer _p;
  s7_pointer clipboard, cancellable, callback, user_data;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_texture_async", 1, clipboard, "GdkClipboard*");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_texture_async", 2, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_texture_async", 3, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_texture_async", 4, user_data, "gpointer");
  gdk_clipboard_read_texture_async((GdkClipboard*)s7_c_pointer(clipboard), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_read_texture_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_texture_finish "GdkTexture* gdk_clipboard_read_texture_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  s7_pointer _p;
  s7_pointer clipboard, result;
  GError* ref_error = NULL;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_texture_finish", 1, clipboard, "GdkClipboard*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_texture_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GdkTexture__sym, gdk_clipboard_read_texture_finish((GdkClipboard*)s7_c_pointer(clipboard), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_clipboard_read_text_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_text_async "void gdk_clipboard_read_text_async(GdkClipboard* clipboard, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  s7_pointer _p;
  s7_pointer clipboard, cancellable, callback, user_data;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_text_async", 1, clipboard, "GdkClipboard*");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_text_async", 2, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_text_async", 3, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_text_async", 4, user_data, "gpointer");
  gdk_clipboard_read_text_async((GdkClipboard*)s7_c_pointer(clipboard), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_read_text_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_text_finish "char* gdk_clipboard_read_text_finish(GdkClipboard* clipboard, \
GAsyncResult* result, GError** [error])"
  s7_pointer _p;
  s7_pointer clipboard, result;
  GError* ref_error = NULL;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_text_finish", 1, clipboard, "GdkClipboard*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_text_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_string(sc, gdk_clipboard_read_text_finish((GdkClipboard*)s7_c_pointer(clipboard), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_clipboard_set_content(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_set_content "gboolean gdk_clipboard_set_content(GdkClipboard* clipboard, GdkContentProvider* provider)"
  s7_pointer _p;
  s7_pointer clipboard, provider;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_content", 1, clipboard, "GdkClipboard*");
  provider = s7_car(_p);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_content", 2, provider, "GdkContentProvider*");
  return(s7_make_boolean(sc, gdk_clipboard_set_content((GdkClipboard*)s7_c_pointer(clipboard), (GdkContentProvider*)s7_c_pointer(provider))));
}

static s7_pointer lg_gdk_clipboard_set(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_set "void gdk_clipboard_set(GdkClipboard* clipboard, GType type, ...)"
  s7_pointer _p;
  s7_pointer clipboard, type;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set", 1, clipboard, "GdkClipboard*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set", 2, type, "GType");
  gdk_clipboard_set((GdkClipboard*)s7_c_pointer(clipboard), (GType)s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_set_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_set_value "void gdk_clipboard_set_value(GdkClipboard* clipboard, GValue* value)"
  s7_pointer _p;
  s7_pointer clipboard, value;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_value", 1, clipboard, "GdkClipboard*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_value", 2, value, "GValue*");
  gdk_clipboard_set_value((GdkClipboard*)s7_c_pointer(clipboard), (GValue*)s7_c_pointer(value));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_set_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_set_text "void gdk_clipboard_set_text(GdkClipboard* clipboard, char* text)"
  s7_pointer _p;
  s7_pointer clipboard, text;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_text", 1, clipboard, "GdkClipboard*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_text", 2, text, "char*");
  gdk_clipboard_set_text((GdkClipboard*)s7_c_pointer(clipboard), (char*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gdk_clipboard_set_texture(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_set_texture "void gdk_clipboard_set_texture(GdkClipboard* clipboard, GdkTexture* texture)"
  s7_pointer _p;
  s7_pointer clipboard, texture;
  _p = args;
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_texture", 1, clipboard, "GdkClipboard*");
  texture = s7_car(_p);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_set_texture", 2, texture, "GdkTexture*");
  gdk_clipboard_set_texture((GdkClipboard*)s7_c_pointer(clipboard), (GdkTexture*)s7_c_pointer(texture));
  return(lg_false);
}

static s7_pointer lg_gdk_intern_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_intern_mime_type "char* gdk_intern_mime_type(char* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "gdk_intern_mime_type", 1, string, "char*");
  return(s7_make_string(sc, gdk_intern_mime_type((const char*)(char*)s7_string(string))));
}

static s7_pointer lg_gdk_content_formats_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_new "GdkContentFormats* gdk_content_formats_new(char** mime_types, guint n_mime_types)"
  s7_pointer _p;
  s7_pointer mime_types, n_mime_types;
  _p = args;
  mime_types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(mime_types, char___sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_new", 1, mime_types, "char**");
  n_mime_types = s7_car(_p);
  if (!s7_is_integer(n_mime_types)) s7_wrong_type_arg_error(sc, "gdk_content_formats_new", 2, n_mime_types, "guint");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_new((const char**)s7_c_pointer(mime_types), (guint)s7_integer(n_mime_types))));
}

static s7_pointer lg_gdk_content_formats_new_for_gtype(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_new_for_gtype "GdkContentFormats* gdk_content_formats_new_for_gtype(GType type)"
  s7_pointer type;
  type = s7_car(args);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_content_formats_new_for_gtype", 1, type, "GType");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_new_for_gtype((GType)s7_integer(type))));
}

static s7_pointer lg_gdk_content_formats_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_ref "GdkContentFormats* gdk_content_formats_ref(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_ref", 1, formats, "GdkContentFormats*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_ref((GdkContentFormats*)s7_c_pointer(formats))));
}

static s7_pointer lg_gdk_content_formats_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_unref "void gdk_content_formats_unref(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_unref", 1, formats, "GdkContentFormats*");
  gdk_content_formats_unref((GdkContentFormats*)s7_c_pointer(formats));
  return(lg_false);
}

static s7_pointer lg_gdk_content_formats_print(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_print "void gdk_content_formats_print(GdkContentFormats* formats, GString* string)"
  s7_pointer _p;
  s7_pointer formats, string;
  _p = args;
  formats = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_print", 1, formats, "GdkContentFormats*");
  string = s7_car(_p);
  if (!s7_is_c_pointer_of_type(string, GString__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_print", 2, string, "GString*");
  gdk_content_formats_print((GdkContentFormats*)s7_c_pointer(formats), (GString*)s7_c_pointer(string));
  return(lg_false);
}

static s7_pointer lg_gdk_content_formats_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_to_string "char* gdk_content_formats_to_string(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_to_string", 1, formats, "GdkContentFormats*");
  return(s7_make_string(sc, gdk_content_formats_to_string((GdkContentFormats*)s7_c_pointer(formats))));
}

static s7_pointer lg_gdk_content_formats_get_gtypes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_get_gtypes "GType* gdk_content_formats_get_gtypes(GdkContentFormats* formats, \
gsize* [n_gtypes])"
  s7_pointer _p;
  s7_pointer formats;
  gsize ref_n_gtypes;
  _p = args;
  formats = s7_car(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_get_gtypes", 1, formats, "GdkContentFormats*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GType__sym, gdk_content_formats_get_gtypes((GdkContentFormats*)s7_c_pointer(formats), &ref_n_gtypes));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_n_gtypes)));
   }
}

static s7_pointer lg_gdk_content_formats_get_mime_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_get_mime_types "char** gdk_content_formats_get_mime_types(GdkContentFormats* formats, \
gsize* [n_mime_types])"
  s7_pointer _p;
  s7_pointer formats;
  gsize ref_n_mime_types;
  _p = args;
  formats = s7_car(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_get_mime_types", 1, formats, "GdkContentFormats*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, char___sym, gdk_content_formats_get_mime_types((GdkContentFormats*)s7_c_pointer(formats), &ref_n_mime_types));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_n_mime_types)));
   }
}

static s7_pointer lg_gdk_content_formats_union(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_union "GdkContentFormats* gdk_content_formats_union(GdkContentFormats* first, \
GdkContentFormats* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_union", 1, first, "GdkContentFormats*");
  second = s7_car(_p);
  if (!s7_is_c_pointer_of_type(second, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_union", 2, second, "GdkContentFormats*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_union((GdkContentFormats*)s7_c_pointer(first), (GdkContentFormats*)s7_c_pointer(second))));
}

static s7_pointer lg_gdk_content_formats_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_match "gboolean gdk_content_formats_match(GdkContentFormats* first, GdkContentFormats* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_match", 1, first, "GdkContentFormats*");
  second = s7_car(_p);
  if (!s7_is_c_pointer_of_type(second, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_match", 2, second, "GdkContentFormats*");
  return(s7_make_boolean(sc, gdk_content_formats_match((GdkContentFormats*)s7_c_pointer(first), (GdkContentFormats*)s7_c_pointer(second))));
}

static s7_pointer lg_gdk_content_formats_match_gtype(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_match_gtype "GType gdk_content_formats_match_gtype(GdkContentFormats* first, \
GdkContentFormats* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_match_gtype", 1, first, "GdkContentFormats*");
  second = s7_car(_p);
  if (!s7_is_c_pointer_of_type(second, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_match_gtype", 2, second, "GdkContentFormats*");
  return(s7_make_integer(sc, gdk_content_formats_match_gtype((GdkContentFormats*)s7_c_pointer(first), (GdkContentFormats*)s7_c_pointer(second))));
}

static s7_pointer lg_gdk_content_formats_match_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_match_mime_type "char* gdk_content_formats_match_mime_type(GdkContentFormats* first, \
GdkContentFormats* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_match_mime_type", 1, first, "GdkContentFormats*");
  second = s7_car(_p);
  if (!s7_is_c_pointer_of_type(second, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_match_mime_type", 2, second, "GdkContentFormats*");
    return(s7_make_string(sc, (char*)gdk_content_formats_match_mime_type((GdkContentFormats*)s7_c_pointer(first), (GdkContentFormats*)s7_c_pointer(second))));
}

static s7_pointer lg_gdk_content_formats_contain_gtype(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_contain_gtype "gboolean gdk_content_formats_contain_gtype(GdkContentFormats* formats, \
GType type)"
  s7_pointer _p;
  s7_pointer formats, type;
  _p = args;
  formats = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_contain_gtype", 1, formats, "GdkContentFormats*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_content_formats_contain_gtype", 2, type, "GType");
  return(s7_make_boolean(sc, gdk_content_formats_contain_gtype((GdkContentFormats*)s7_c_pointer(formats), (GType)s7_integer(type))));
}

static s7_pointer lg_gdk_content_formats_contain_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_contain_mime_type "gboolean gdk_content_formats_contain_mime_type(GdkContentFormats* formats, \
char* mime_type)"
  s7_pointer _p;
  s7_pointer formats, mime_type;
  _p = args;
  formats = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_contain_mime_type", 1, formats, "GdkContentFormats*");
  mime_type = s7_car(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gdk_content_formats_contain_mime_type", 2, mime_type, "char*");
  return(s7_make_boolean(sc, gdk_content_formats_contain_mime_type((GdkContentFormats*)s7_c_pointer(formats), (const char*)(char*)s7_string(mime_type))));
}

static s7_pointer lg_gdk_content_formats_builder_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_builder_new "GdkContentFormatsBuilder* gdk_content_formats_builder_new( void)"
  return(lg_make_c_pointer_with_type(sc, GdkContentFormatsBuilder__sym, gdk_content_formats_builder_new()));
}

static s7_pointer lg_gdk_content_formats_builder_add_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_builder_add_formats "void gdk_content_formats_builder_add_formats(GdkContentFormatsBuilder* builder, \
GdkContentFormats* formats)"
  s7_pointer _p;
  s7_pointer builder, formats;
  _p = args;
  builder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(builder, GdkContentFormatsBuilder__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_builder_add_formats", 1, builder, "GdkContentFormatsBuilder*");
  formats = s7_car(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_builder_add_formats", 2, formats, "GdkContentFormats*");
  gdk_content_formats_builder_add_formats((GdkContentFormatsBuilder*)s7_c_pointer(builder), (GdkContentFormats*)s7_c_pointer(formats));
  return(lg_false);
}

static s7_pointer lg_gdk_content_formats_builder_add_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_builder_add_mime_type "void gdk_content_formats_builder_add_mime_type(GdkContentFormatsBuilder* builder, \
char* mime_type)"
  s7_pointer _p;
  s7_pointer builder, mime_type;
  _p = args;
  builder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(builder, GdkContentFormatsBuilder__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_builder_add_mime_type", 1, builder, "GdkContentFormatsBuilder*");
  mime_type = s7_car(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gdk_content_formats_builder_add_mime_type", 2, mime_type, "char*");
  gdk_content_formats_builder_add_mime_type((GdkContentFormatsBuilder*)s7_c_pointer(builder), (const char*)(char*)s7_string(mime_type));
  return(lg_false);
}

static s7_pointer lg_gdk_content_formats_builder_add_gtype(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_builder_add_gtype "void gdk_content_formats_builder_add_gtype(GdkContentFormatsBuilder* builder, \
GType type)"
  s7_pointer _p;
  s7_pointer builder, type;
  _p = args;
  builder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(builder, GdkContentFormatsBuilder__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_builder_add_gtype", 1, builder, "GdkContentFormatsBuilder*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_content_formats_builder_add_gtype", 2, type, "GType");
  gdk_content_formats_builder_add_gtype((GdkContentFormatsBuilder*)s7_c_pointer(builder), (GType)s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gdk_content_provider_ref_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_ref_formats "GdkContentFormats* gdk_content_provider_ref_formats(GdkContentProvider* provider)"
  s7_pointer provider;
  provider = s7_car(args);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_ref_formats", 1, provider, "GdkContentProvider*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_provider_ref_formats((GdkContentProvider*)s7_c_pointer(provider))));
}

static s7_pointer lg_gdk_content_provider_ref_storable_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_ref_storable_formats "GdkContentFormats* gdk_content_provider_ref_storable_formats(GdkContentProvider* provider)"
  s7_pointer provider;
  provider = s7_car(args);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_ref_storable_formats", 1, provider, "GdkContentProvider*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_provider_ref_storable_formats((GdkContentProvider*)s7_c_pointer(provider))));
}

static s7_pointer lg_gdk_content_provider_content_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_content_changed "void gdk_content_provider_content_changed(GdkContentProvider* provider)"
  s7_pointer provider;
  provider = s7_car(args);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_content_changed", 1, provider, "GdkContentProvider*");
  gdk_content_provider_content_changed((GdkContentProvider*)s7_c_pointer(provider));
  return(lg_false);
}

static s7_pointer lg_gdk_content_provider_write_mime_type_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_write_mime_type_async "void gdk_content_provider_write_mime_type_async(GdkContentProvider* provider, \
char* mime_type, GOutputStream* stream, int io_priority, GCancellable* cancellable, GAsyncReadyCallback callback, \
gpointer user_data)"
  s7_pointer _p;
  s7_pointer provider, mime_type, stream, io_priority, cancellable, callback, user_data;
  _p = args;
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 1, provider, "GdkContentProvider*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 2, mime_type, "char*");
  stream = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stream, GOutputStream__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 3, stream, "GOutputStream*");
  io_priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(io_priority)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 4, io_priority, "int");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 5, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 6, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_async", 7, user_data, "gpointer");
  gdk_content_provider_write_mime_type_async((GdkContentProvider*)s7_c_pointer(provider), (const char*)(char*)s7_string(mime_type), (GOutputStream*)s7_c_pointer(stream), (int)s7_integer(io_priority), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_content_provider_write_mime_type_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_write_mime_type_finish "gboolean gdk_content_provider_write_mime_type_finish(GdkContentProvider* provider, \
GAsyncResult* result, GError** [error])"
  s7_pointer _p;
  s7_pointer provider, result;
  GError* ref_error = NULL;
  _p = args;
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_finish", 1, provider, "GdkContentProvider*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_write_mime_type_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_content_provider_write_mime_type_finish((GdkContentProvider*)s7_c_pointer(provider), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_content_provider_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_get_value "gboolean gdk_content_provider_get_value(GdkContentProvider* provider, \
GValue* value, GError** [error])"
  s7_pointer _p;
  s7_pointer provider, value;
  GError* ref_error = NULL;
  _p = args;
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_get_value", 1, provider, "GdkContentProvider*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_get_value", 2, value, "GValue*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_content_provider_get_value((GdkContentProvider*)s7_c_pointer(provider), (GValue*)s7_c_pointer(value), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_content_serializer_get_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_mime_type "char* gdk_content_serializer_get_mime_type(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_mime_type", 1, serializer, "GdkContentSerializer*");
    return(s7_make_string(sc, (char*)gdk_content_serializer_get_mime_type((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_value "GValue* gdk_content_serializer_get_value(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_value", 1, serializer, "GdkContentSerializer*");
    return(lg_make_c_pointer_with_type(sc, GValue__sym, (GValue*)gdk_content_serializer_get_value((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_get_output_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_output_stream "GOutputStream* gdk_content_serializer_get_output_stream(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_output_stream", 1, serializer, "GdkContentSerializer*");
  return(lg_make_c_pointer_with_type(sc, GOutputStream__sym, gdk_content_serializer_get_output_stream((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_get_priority(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_priority "int gdk_content_serializer_get_priority(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_priority", 1, serializer, "GdkContentSerializer*");
  return(s7_make_integer(sc, gdk_content_serializer_get_priority((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_get_cancellable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_cancellable "GCancellable* gdk_content_serializer_get_cancellable(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_cancellable", 1, serializer, "GdkContentSerializer*");
  return(lg_make_c_pointer_with_type(sc, GCancellable__sym, gdk_content_serializer_get_cancellable((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_user_data "gpointer gdk_content_serializer_get_user_data(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_user_data", 1, serializer, "GdkContentSerializer*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gdk_content_serializer_get_user_data((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_get_task_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_get_task_data "gpointer gdk_content_serializer_get_task_data(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_get_task_data", 1, serializer, "GdkContentSerializer*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gdk_content_serializer_get_task_data((GdkContentSerializer*)s7_c_pointer(serializer))));
}

static s7_pointer lg_gdk_content_serializer_return_success(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_return_success "void gdk_content_serializer_return_success(GdkContentSerializer* serializer)"
  s7_pointer serializer;
  serializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_return_success", 1, serializer, "GdkContentSerializer*");
  gdk_content_serializer_return_success((GdkContentSerializer*)s7_c_pointer(serializer));
  return(lg_false);
}

static s7_pointer lg_gdk_content_serializer_return_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serializer_return_error "void gdk_content_serializer_return_error(GdkContentSerializer* serializer, \
GError* error)"
  s7_pointer _p;
  s7_pointer serializer, error;
  _p = args;
  serializer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(serializer, GdkContentSerializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_return_error", 1, serializer, "GdkContentSerializer*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serializer_return_error", 2, error, "GError*");
  gdk_content_serializer_return_error((GdkContentSerializer*)s7_c_pointer(serializer), (GError*)s7_c_pointer(error));
  return(lg_false);
}

static s7_pointer lg_gdk_content_formats_union_serialize_gtypes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_union_serialize_gtypes "GdkContentFormats* gdk_content_formats_union_serialize_gtypes(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_union_serialize_gtypes", 1, formats, "GdkContentFormats*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_union_serialize_gtypes((GdkContentFormats*)s7_c_pointer(formats))));
}

static s7_pointer lg_gdk_content_formats_union_serialize_mime_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_union_serialize_mime_types "GdkContentFormats* gdk_content_formats_union_serialize_mime_types(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_union_serialize_mime_types", 1, formats, "GdkContentFormats*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_union_serialize_mime_types((GdkContentFormats*)s7_c_pointer(formats))));
}

static s7_pointer lg_gdk_content_serialize_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_serialize_finish "gboolean gdk_content_serialize_finish(GAsyncResult* result, \
GError** [error])"
  s7_pointer _p;
  s7_pointer result;
  GError* ref_error = NULL;
  _p = args;
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_content_serialize_finish", 1, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_content_serialize_finish((GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_content_deserializer_get_mime_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_mime_type "char* gdk_content_deserializer_get_mime_type(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_mime_type", 1, deserializer, "GdkContentDeserializer*");
    return(s7_make_string(sc, (char*)gdk_content_deserializer_get_mime_type((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_value "GValue* gdk_content_deserializer_get_value(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_value", 1, deserializer, "GdkContentDeserializer*");
  return(lg_make_c_pointer_with_type(sc, GValue__sym, gdk_content_deserializer_get_value((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_get_input_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_input_stream "GInputStream* gdk_content_deserializer_get_input_stream(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_input_stream", 1, deserializer, "GdkContentDeserializer*");
  return(lg_make_c_pointer_with_type(sc, GInputStream__sym, gdk_content_deserializer_get_input_stream((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_get_priority(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_priority "int gdk_content_deserializer_get_priority(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_priority", 1, deserializer, "GdkContentDeserializer*");
  return(s7_make_integer(sc, gdk_content_deserializer_get_priority((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_get_cancellable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_cancellable "GCancellable* gdk_content_deserializer_get_cancellable(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_cancellable", 1, deserializer, "GdkContentDeserializer*");
  return(lg_make_c_pointer_with_type(sc, GCancellable__sym, gdk_content_deserializer_get_cancellable((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_user_data "gpointer gdk_content_deserializer_get_user_data(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_user_data", 1, deserializer, "GdkContentDeserializer*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gdk_content_deserializer_get_user_data((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_get_task_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_get_task_data "gpointer gdk_content_deserializer_get_task_data(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_get_task_data", 1, deserializer, "GdkContentDeserializer*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gdk_content_deserializer_get_task_data((GdkContentDeserializer*)s7_c_pointer(deserializer))));
}

static s7_pointer lg_gdk_content_deserializer_return_success(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_return_success "void gdk_content_deserializer_return_success(GdkContentDeserializer* deserializer)"
  s7_pointer deserializer;
  deserializer = s7_car(args);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_return_success", 1, deserializer, "GdkContentDeserializer*");
  gdk_content_deserializer_return_success((GdkContentDeserializer*)s7_c_pointer(deserializer));
  return(lg_false);
}

static s7_pointer lg_gdk_content_deserializer_return_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserializer_return_error "void gdk_content_deserializer_return_error(GdkContentDeserializer* deserializer, \
GError* error)"
  s7_pointer _p;
  s7_pointer deserializer, error;
  _p = args;
  deserializer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(deserializer, GdkContentDeserializer__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_return_error", 1, deserializer, "GdkContentDeserializer*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserializer_return_error", 2, error, "GError*");
  gdk_content_deserializer_return_error((GdkContentDeserializer*)s7_c_pointer(deserializer), (GError*)s7_c_pointer(error));
  return(lg_false);
}

static s7_pointer lg_gdk_content_formats_union_deserialize_gtypes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_union_deserialize_gtypes "GdkContentFormats* gdk_content_formats_union_deserialize_gtypes(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_union_deserialize_gtypes", 1, formats, "GdkContentFormats*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_union_deserialize_gtypes((GdkContentFormats*)s7_c_pointer(formats))));
}

static s7_pointer lg_gdk_content_formats_union_deserialize_mime_types(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_formats_union_deserialize_mime_types "GdkContentFormats* gdk_content_formats_union_deserialize_mime_types(GdkContentFormats* formats)"
  s7_pointer formats;
  formats = s7_car(args);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gdk_content_formats_union_deserialize_mime_types", 1, formats, "GdkContentFormats*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_content_formats_union_deserialize_mime_types((GdkContentFormats*)s7_c_pointer(formats))));
}

static s7_pointer lg_gdk_content_deserialize_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_deserialize_finish "gboolean gdk_content_deserialize_finish(GAsyncResult* result, \
GValue* value, GError** [error])"
  s7_pointer _p;
  s7_pointer result, value;
  GError* ref_error = NULL;
  _p = args;
  result = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserialize_finish", 1, result, "GAsyncResult*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gdk_content_deserialize_finish", 2, value, "GValue*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_content_deserialize_finish((GAsyncResult*)s7_c_pointer(result), (GValue*)s7_c_pointer(value), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_content_provider_new_for_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_new_for_value "GdkContentProvider* gdk_content_provider_new_for_value(GValue* value)"
  s7_pointer value;
  value = s7_car(args);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_new_for_value", 1, value, "GValue*");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gdk_content_provider_new_for_value((GValue*)s7_c_pointer(value))));
}

static s7_pointer lg_gdk_content_provider_new_for_bytes(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_new_for_bytes "GdkContentProvider* gdk_content_provider_new_for_bytes(char* mime_type, \
GBytes* bytes)"
  s7_pointer _p;
  s7_pointer mime_type, bytes;
  _p = args;
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "gdk_content_provider_new_for_bytes", 1, mime_type, "char*");
  bytes = s7_car(_p);
  if (!s7_is_c_pointer_of_type(bytes, GBytes__sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_new_for_bytes", 2, bytes, "GBytes*");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gdk_content_provider_new_for_bytes((const char*)(char*)s7_string(mime_type), (GBytes*)s7_c_pointer(bytes))));
}

static s7_pointer lg_gtk_event_controller_motion_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_motion_new "GtkEventController* gtk_event_controller_motion_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_event_controller_motion_new()));
}

static s7_pointer lg_gdk_texture_new_for_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_texture_new_for_pixbuf "GdkTexture* gdk_texture_new_for_pixbuf(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gdk_texture_new_for_pixbuf", 1, pixbuf, "GdkPixbuf*");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gdk_texture_new_for_pixbuf((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gdk_texture_new_from_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_texture_new_from_resource "GdkTexture* gdk_texture_new_from_resource(char* resource_path)"
  s7_pointer resource_path;
  resource_path = s7_car(args);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gdk_texture_new_from_resource", 1, resource_path, "char*");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gdk_texture_new_from_resource((const char*)(char*)s7_string(resource_path))));
}

static s7_pointer lg_gdk_texture_new_from_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_texture_new_from_file "GdkTexture* gdk_texture_new_from_file(GFile* file, GError** [error])"
  s7_pointer _p;
  s7_pointer file;
  GError* ref_error = NULL;
  _p = args;
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gdk_texture_new_from_file", 1, file, "GFile*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GdkTexture__sym, gdk_texture_new_from_file((GFile*)s7_c_pointer(file), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_texture_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_texture_get_width "int gdk_texture_get_width(GdkTexture* texture)"
  s7_pointer texture;
  texture = s7_car(args);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_texture_get_width", 1, texture, "GdkTexture*");
  return(s7_make_integer(sc, gdk_texture_get_width((GdkTexture*)s7_c_pointer(texture))));
}

static s7_pointer lg_gdk_texture_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_texture_get_height "int gdk_texture_get_height(GdkTexture* texture)"
  s7_pointer texture;
  texture = s7_car(args);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_texture_get_height", 1, texture, "GdkTexture*");
  return(s7_make_integer(sc, gdk_texture_get_height((GdkTexture*)s7_c_pointer(texture))));
}

static s7_pointer lg_gdk_texture_download(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_texture_download "void gdk_texture_download(GdkTexture* texture, guchar* data, gsize stride)"
  s7_pointer _p;
  s7_pointer texture, data, stride;
  _p = args;
  texture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_texture_download", 1, texture, "GdkTexture*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "gdk_texture_download", 2, data, "guchar*");
  stride = s7_car(_p);
  if (!s7_is_integer(stride)) s7_wrong_type_arg_error(sc, "gdk_texture_download", 3, stride, "gsize");
  gdk_texture_download((GdkTexture*)s7_c_pointer(texture), (guchar*)s7_c_pointer(data), (gsize)s7_integer(stride));
  return(lg_false);
}

static s7_pointer lg_gdk_cursor_new_from_texture(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_new_from_texture "GdkCursor* gdk_cursor_new_from_texture(GdkTexture* texture, \
int hotspot_x, int hotspot_y, GdkCursor* fallback)"
  s7_pointer _p;
  s7_pointer texture, hotspot_x, hotspot_y, fallback;
  _p = args;
  texture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_texture", 1, texture, "GdkTexture*");
  hotspot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hotspot_x)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_texture", 2, hotspot_x, "int");
  hotspot_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hotspot_y)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_texture", 3, hotspot_y, "int");
  fallback = s7_car(_p);
  if (!s7_is_c_pointer_of_type(fallback, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_texture", 4, fallback, "GdkCursor*");
  return(lg_make_c_pointer_with_type(sc, GdkCursor__sym, gdk_cursor_new_from_texture((GdkTexture*)s7_c_pointer(texture), (int)s7_integer(hotspot_x), (int)s7_integer(hotspot_y), (GdkCursor*)s7_c_pointer(fallback))));
}

static s7_pointer lg_gdk_cursor_new_from_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_new_from_name "GdkCursor* gdk_cursor_new_from_name(gchar* name, GdkCursor* fallback)"
  s7_pointer _p;
  s7_pointer name, fallback;
  _p = args;
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_name", 1, name, "gchar*");
  fallback = s7_car(_p);
  if (!s7_is_c_pointer_of_type(fallback, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_new_from_name", 2, fallback, "GdkCursor*");
  return(lg_make_c_pointer_with_type(sc, GdkCursor__sym, gdk_cursor_new_from_name((const gchar*)s7_string(name), (GdkCursor*)s7_c_pointer(fallback))));
}

static s7_pointer lg_gdk_cursor_get_fallback(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_fallback "GdkCursor* gdk_cursor_get_fallback(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_fallback", 1, cursor, "GdkCursor*");
  return(lg_make_c_pointer_with_type(sc, GdkCursor__sym, gdk_cursor_get_fallback((GdkCursor*)s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_cursor_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_name "char* gdk_cursor_get_name(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_name", 1, cursor, "GdkCursor*");
  return(s7_make_string(sc, gdk_cursor_get_name((GdkCursor*)s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_cursor_get_texture(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_texture "GdkTexture* gdk_cursor_get_texture(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_texture", 1, cursor, "GdkCursor*");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gdk_cursor_get_texture((GdkCursor*)s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_cursor_get_hotspot_x(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_hotspot_x "int gdk_cursor_get_hotspot_x(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_hotspot_x", 1, cursor, "GdkCursor*");
  return(s7_make_integer(sc, gdk_cursor_get_hotspot_x((GdkCursor*)s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_cursor_get_hotspot_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cursor_get_hotspot_y "int gdk_cursor_get_hotspot_y(GdkCursor* cursor)"
  s7_pointer cursor;
  cursor = s7_car(args);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_cursor_get_hotspot_y", 1, cursor, "GdkCursor*");
  return(s7_make_integer(sc, gdk_cursor_get_hotspot_y((GdkCursor*)s7_c_pointer(cursor))));
}

static s7_pointer lg_gdk_display_get_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_clipboard "GdkClipboard* gdk_display_get_clipboard(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_clipboard", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GdkClipboard__sym, gdk_display_get_clipboard((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_display_get_primary_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_primary_clipboard "GdkClipboard* gdk_display_get_primary_clipboard(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_primary_clipboard", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GdkClipboard__sym, gdk_display_get_primary_clipboard((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gdk_monitor_is_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_is_valid "gboolean gdk_monitor_is_valid(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_is_valid", 1, monitor, "GdkMonitor*");
  return(s7_make_boolean(sc, gdk_monitor_is_valid((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_seat_get_master_pointers(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_seat_get_master_pointers "GList* gdk_seat_get_master_pointers(GdkSeat* seat, GdkSeatCapabilities capabilities)"
  s7_pointer _p;
  s7_pointer seat, capabilities;
  _p = args;
  seat = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(seat, GdkSeat__sym)) s7_wrong_type_arg_error(sc, "gdk_seat_get_master_pointers", 1, seat, "GdkSeat*");
  capabilities = s7_car(_p);
  if (!s7_is_integer(capabilities)) s7_wrong_type_arg_error(sc, "gdk_seat_get_master_pointers", 2, capabilities, "GdkSeatCapabilities");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gdk_seat_get_master_pointers((GdkSeat*)s7_c_pointer(seat), (GdkSeatCapabilities)s7_integer(capabilities))));
}

static s7_pointer lg_gtk_header_bar_get_show_title_buttons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_get_show_title_buttons "gboolean gtk_header_bar_get_show_title_buttons(GtkHeaderBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_get_show_title_buttons", 1, bar, "GtkHeaderBar*");
  return(s7_make_boolean(sc, gtk_header_bar_get_show_title_buttons((GtkHeaderBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_header_bar_set_show_title_buttons(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_header_bar_set_show_title_buttons "void gtk_header_bar_set_show_title_buttons(GtkHeaderBar* bar, \
gboolean setting)"
  s7_pointer _p;
  s7_pointer bar, setting;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkHeaderBar__sym)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_show_title_buttons", 1, bar, "GtkHeaderBar*");
  setting = s7_car(_p);
  if (!s7_is_boolean(setting)) s7_wrong_type_arg_error(sc, "gtk_header_bar_set_show_title_buttons", 2, setting, "gboolean");
  gtk_header_bar_set_show_title_buttons((GtkHeaderBar*)s7_c_pointer(bar), (gboolean)lg_boolean(setting));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_info_load_texture(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_info_load_texture "GdkTexture* gtk_icon_info_load_texture(GtkIconInfo* icon_info)"
  s7_pointer icon_info;
  icon_info = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon_info, GtkIconInfo__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_info_load_texture", 1, icon_info, "GtkIconInfo*");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gtk_icon_info_load_texture((GtkIconInfo*)s7_c_pointer(icon_info))));
}

static s7_pointer lg_gtk_image_new_from_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_icon_name "GtkWidget* gtk_image_new_from_icon_name(gchar* icon_name)"
  s7_pointer icon_name;
  icon_name = s7_car(args);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_icon_name", 1, icon_name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_image_new_from_icon_name((const gchar*)s7_string(icon_name))));
}

static s7_pointer lg_gtk_image_new_from_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_new_from_gicon "GtkWidget* gtk_image_new_from_gicon(GIcon* icon)"
  s7_pointer icon;
  icon = s7_car(args);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_image_new_from_gicon", 1, icon, "GIcon*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_image_new_from_gicon((GIcon*)s7_c_pointer(icon))));
}

static s7_pointer lg_gtk_image_set_from_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_icon_name "void gtk_image_set_from_icon_name(GtkImage* image, gchar* icon_name)"
  s7_pointer _p;
  s7_pointer image, icon_name;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_icon_name", 1, image, "GtkImage*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_icon_name", 2, icon_name, "gchar*");
  gtk_image_set_from_icon_name((GtkImage*)s7_c_pointer(image), (const gchar*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_from_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_from_gicon "void gtk_image_set_from_gicon(GtkImage* image, GIcon* icon)"
  s7_pointer _p;
  s7_pointer image, icon;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_gicon", 1, image, "GtkImage*");
  icon = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_from_gicon", 2, icon, "GIcon*");
  gtk_image_set_from_gicon((GtkImage*)s7_c_pointer(image), (GIcon*)s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gtk_image_set_icon_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_set_icon_size "void gtk_image_set_icon_size(GtkImage* image, GtkIconSize icon_size)"
  s7_pointer _p;
  s7_pointer image, icon_size;
  _p = args;
  image = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_set_icon_size", 1, image, "GtkImage*");
  icon_size = s7_car(_p);
  if (!s7_is_integer(icon_size)) s7_wrong_type_arg_error(sc, "gtk_image_set_icon_size", 2, icon_size, "GtkIconSize");
  gtk_image_set_icon_size((GtkImage*)s7_c_pointer(image), (GtkIconSize)s7_integer(icon_size));
  return(lg_false);
}

static s7_pointer lg_gtk_image_get_icon_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_icon_size "GtkIconSize gtk_image_get_icon_size(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_icon_size", 1, image, "GtkImage*");
  return(s7_make_integer(sc, gtk_image_get_icon_size((GtkImage*)s7_c_pointer(image))));
}

static s7_pointer lg_gtk_image_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_icon_name "char* gtk_image_get_icon_name(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_icon_name", 1, image, "GtkImage*");
    return(s7_make_string(sc, (char*)gtk_image_get_icon_name((GtkImage*)s7_c_pointer(image))));
}

static s7_pointer lg_gtk_image_get_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_image_get_gicon "GIcon* gtk_image_get_gicon(GtkImage* image)"
  s7_pointer image;
  image = s7_car(args);
  if (!s7_is_c_pointer_of_type(image, GtkImage__sym)) s7_wrong_type_arg_error(sc, "gtk_image_get_gicon", 1, image, "GtkImage*");
  return(lg_make_c_pointer_with_type(sc, GIcon__sym, gtk_image_get_gicon((GtkImage*)s7_c_pointer(image))));
}

static s7_pointer lg_gtk_render_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_render_icon "void gtk_render_icon(GtkStyleContext* context, cairo_t* cr, GdkTexture* texture, \
gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer context, cr, texture, x, y;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 1, context, "GtkStyleContext*");
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 2, cr, "cairo_t*");
  texture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 3, texture, "GdkTexture*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 4, x, "gdouble");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_render_icon", 5, y, "gdouble");
  gtk_render_icon((GtkStyleContext*)s7_c_pointer(context), (cairo_t*)s7_c_pointer(cr), (GdkTexture*)s7_c_pointer(texture), (gdouble)s7_real(x), (gdouble)s7_real(y));
  return(lg_false);
}

static s7_pointer lg_gtk_settings_get_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_settings_get_for_display "GtkSettings* gtk_settings_get_for_display(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_settings_get_for_display", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GtkSettings__sym, gtk_settings_get_for_display((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_style_context_add_provider_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_add_provider_for_display "void gtk_style_context_add_provider_for_display(GdkDisplay* display, \
GtkStyleProvider* provider, guint priority)"
  s7_pointer _p;
  s7_pointer display, provider, priority;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_provider_for_display", 1, display, "GdkDisplay*");
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GtkStyleProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_provider_for_display", 2, provider, "GtkStyleProvider*");
  priority = s7_car(_p);
  if (!s7_is_integer(priority)) s7_wrong_type_arg_error(sc, "gtk_style_context_add_provider_for_display", 3, priority, "guint");
  gtk_style_context_add_provider_for_display((GdkDisplay*)s7_c_pointer(display), (GtkStyleProvider*)s7_c_pointer(provider), (guint)s7_integer(priority));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_remove_provider_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_remove_provider_for_display "void gtk_style_context_remove_provider_for_display(GdkDisplay* display, \
GtkStyleProvider* provider)"
  s7_pointer _p;
  s7_pointer display, provider;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_remove_provider_for_display", 1, display, "GdkDisplay*");
  provider = s7_car(_p);
  if (!s7_is_c_pointer_of_type(provider, GtkStyleProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_remove_provider_for_display", 2, provider, "GtkStyleProvider*");
  gtk_style_context_remove_provider_for_display((GdkDisplay*)s7_c_pointer(display), (GtkStyleProvider*)s7_c_pointer(provider));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_set_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_set_display "void gtk_style_context_set_display(GtkStyleContext* context, \
GdkDisplay* display)"
  s7_pointer _p;
  s7_pointer context, display;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_display", 1, context, "GtkStyleContext*");
  display = s7_car(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_set_display", 2, display, "GdkDisplay*");
  gtk_style_context_set_display((GtkStyleContext*)s7_c_pointer(context), (GdkDisplay*)s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_display "GdkDisplay* gtk_style_context_get_display(GtkStyleContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_display", 1, context, "GtkStyleContext*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gtk_style_context_get_display((GtkStyleContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gtk_text_buffer_add_selection_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_add_selection_clipboard "void gtk_text_buffer_add_selection_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  s7_pointer _p;
  s7_pointer buffer, clipboard;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_selection_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_add_selection_clipboard", 2, clipboard, "GdkClipboard*");
  gtk_text_buffer_add_selection_clipboard((GtkTextBuffer*)s7_c_pointer(buffer), (GdkClipboard*)s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_remove_selection_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_remove_selection_clipboard "void gtk_text_buffer_remove_selection_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  s7_pointer _p;
  s7_pointer buffer, clipboard;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_selection_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_remove_selection_clipboard", 2, clipboard, "GdkClipboard*");
  gtk_text_buffer_remove_selection_clipboard((GtkTextBuffer*)s7_c_pointer(buffer), (GdkClipboard*)s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_cut_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_cut_clipboard "void gtk_text_buffer_cut_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, clipboard, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_cut_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_cut_clipboard", 2, clipboard, "GdkClipboard*");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_cut_clipboard", 3, default_editable, "gboolean");
  gtk_text_buffer_cut_clipboard((GtkTextBuffer*)s7_c_pointer(buffer), (GdkClipboard*)s7_c_pointer(clipboard), (gboolean)lg_boolean(default_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_copy_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_copy_clipboard "void gtk_text_buffer_copy_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard)"
  s7_pointer _p;
  s7_pointer buffer, clipboard;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_copy_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_copy_clipboard", 2, clipboard, "GdkClipboard*");
  gtk_text_buffer_copy_clipboard((GtkTextBuffer*)s7_c_pointer(buffer), (GdkClipboard*)s7_c_pointer(clipboard));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_paste_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_paste_clipboard "void gtk_text_buffer_paste_clipboard(GtkTextBuffer* buffer, \
GdkClipboard* clipboard, GtkTextIter* override_location, gboolean default_editable)"
  s7_pointer _p;
  s7_pointer buffer, clipboard, override_location, default_editable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 1, buffer, "GtkTextBuffer*");
  clipboard = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clipboard, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 2, clipboard, "GdkClipboard*");
  override_location = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(override_location, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 3, override_location, "GtkTextIter*");
  default_editable = s7_car(_p);
  if (!s7_is_boolean(default_editable)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_paste_clipboard", 4, default_editable, "gboolean");
  gtk_text_buffer_paste_clipboard((GtkTextBuffer*)s7_c_pointer(buffer), (GdkClipboard*)s7_c_pointer(clipboard), (GtkTextIter*)s7_c_pointer(override_location), (gboolean)lg_boolean(default_editable));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_icon "void gtk_tooltip_set_icon(GtkTooltip* tooltip, GdkPaintable* paintable)"
  s7_pointer _p;
  s7_pointer tooltip, paintable;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon", 1, tooltip, "GtkTooltip*");
  paintable = s7_car(_p);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon", 2, paintable, "GdkPaintable*");
  gtk_tooltip_set_icon((GtkTooltip*)s7_c_pointer(tooltip), (GdkPaintable*)s7_c_pointer(paintable));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_icon_from_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_icon_from_icon_name "void gtk_tooltip_set_icon_from_icon_name(GtkTooltip* tooltip, \
gchar* icon_name)"
  s7_pointer _p;
  s7_pointer tooltip, icon_name;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon_from_icon_name", 1, tooltip, "GtkTooltip*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon_from_icon_name", 2, icon_name, "gchar*");
  gtk_tooltip_set_icon_from_icon_name((GtkTooltip*)s7_c_pointer(tooltip), (const gchar*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_tooltip_set_icon_from_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tooltip_set_icon_from_gicon "void gtk_tooltip_set_icon_from_gicon(GtkTooltip* tooltip, \
GIcon* gicon)"
  s7_pointer _p;
  s7_pointer tooltip, gicon;
  _p = args;
  tooltip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tooltip, GtkTooltip__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon_from_gicon", 1, tooltip, "GtkTooltip*");
  gicon = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gicon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_tooltip_set_icon_from_gicon", 2, gicon, "GIcon*");
  gtk_tooltip_set_icon_from_gicon((GtkTooltip*)s7_c_pointer(tooltip), (GIcon*)s7_c_pointer(gicon));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_enable_model_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_enable_model_drag_source "void gtk_tree_view_enable_model_drag_source(GtkTreeView* tree_view, \
GdkModifierType start_button_mask, GdkContentFormats* formats, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer tree_view, start_button_mask, formats, actions;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 1, tree_view, "GtkTreeView*");
  start_button_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_button_mask)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 2, start_button_mask, "GdkModifierType");
  formats = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 3, formats, "GdkContentFormats*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_tree_view_enable_model_drag_source", 4, actions, "GdkDragAction");
  gtk_tree_view_enable_model_drag_source((GtkTreeView*)s7_c_pointer(tree_view), (GdkModifierType)s7_integer(start_button_mask), (GdkContentFormats*)s7_c_pointer(formats), (GdkDragAction)s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_width "int gtk_widget_get_width(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_width", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_width((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_height "int gtk_widget_get_height(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_height", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_height((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_clipboard "GdkClipboard* gtk_widget_get_clipboard(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_clipboard", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GdkClipboard__sym, gtk_widget_get_clipboard((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_primary_clipboard(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_primary_clipboard "GdkClipboard* gtk_widget_get_primary_clipboard(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_primary_clipboard", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GdkClipboard__sym, gtk_widget_get_primary_clipboard((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_contains(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_contains "gboolean gtk_widget_contains(GtkWidget* widget, gdouble x, gdouble y)"
  s7_pointer _p;
  s7_pointer widget, x, y;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_contains", 1, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_widget_contains", 2, x, "gdouble");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_widget_contains", 3, y, "gdouble");
  return(s7_make_boolean(sc, gtk_widget_contains((GtkWidget*)s7_c_pointer(widget), (gdouble)s7_real(x), (gdouble)s7_real(y))));
}

static s7_pointer lg_gtk_widget_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_cursor "void gtk_widget_set_cursor(GtkWidget* widget, GdkCursor* cursor)"
  s7_pointer _p;
  s7_pointer widget, cursor;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_cursor", 1, widget, "GtkWidget*");
  cursor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_cursor", 2, cursor, "GdkCursor*");
  gtk_widget_set_cursor((GtkWidget*)s7_c_pointer(widget), (GdkCursor*)s7_c_pointer(cursor));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_cursor_from_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_cursor_from_name "void gtk_widget_set_cursor_from_name(GtkWidget* widget, \
char* name)"
  s7_pointer _p;
  s7_pointer widget, name;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_cursor_from_name", 1, widget, "GtkWidget*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_set_cursor_from_name", 2, name, "char*");
  gtk_widget_set_cursor_from_name((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_cursor "GdkCursor* gtk_widget_get_cursor(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_cursor", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GdkCursor__sym, gtk_widget_get_cursor((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_window_set_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_display "void gtk_window_set_display(GtkWindow* window, GdkDisplay* display)"
  s7_pointer _p;
  s7_pointer window, display;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_display", 1, window, "GtkWindow*");
  display = s7_car(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_display", 2, display, "GdkDisplay*");
  gtk_window_set_display((GtkWindow*)s7_c_pointer(window), (GdkDisplay*)s7_c_pointer(display));
  return(lg_false);
}

static s7_pointer lg_gtk_window_fullscreen_on_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_fullscreen_on_monitor "void gtk_window_fullscreen_on_monitor(GtkWindow* window, \
GdkMonitor* monitor)"
  s7_pointer _p;
  s7_pointer window, monitor;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen_on_monitor", 1, window, "GtkWindow*");
  monitor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gtk_window_fullscreen_on_monitor", 2, monitor, "GdkMonitor*");
  gtk_window_fullscreen_on_monitor((GtkWindow*)s7_c_pointer(window), (GdkMonitor*)s7_c_pointer(monitor));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_view_enable_model_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_view_enable_model_drag_source "void gtk_icon_view_enable_model_drag_source(GtkIconView* icon_view, \
GdkModifierType start_button_mask, GdkContentFormats* targets, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer icon_view, start_button_mask, targets, actions;
  _p = args;
  icon_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon_view, GtkIconView__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 1, icon_view, "GtkIconView*");
  start_button_mask = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_button_mask)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 2, start_button_mask, "GdkModifierType");
  targets = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(targets, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 3, targets, "GdkContentFormats*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_icon_view_enable_model_drag_source", 4, actions, "GdkDragAction");
  gtk_icon_view_enable_model_drag_source((GtkIconView*)s7_c_pointer(icon_view), (GdkModifierType)s7_integer(start_button_mask), (GdkContentFormats*)s7_c_pointer(targets), (GdkDragAction)s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_about_dialog_get_logo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_get_logo "GdkTexture* gtk_about_dialog_get_logo(GtkAboutDialog* about)"
  s7_pointer about;
  about = s7_car(args);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_get_logo", 1, about, "GtkAboutDialog*");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gtk_about_dialog_get_logo((GtkAboutDialog*)s7_c_pointer(about))));
}

static s7_pointer lg_gtk_about_dialog_set_logo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_about_dialog_set_logo "void gtk_about_dialog_set_logo(GtkAboutDialog* about, GdkPaintable* logo)"
  s7_pointer _p;
  s7_pointer about, logo;
  _p = args;
  about = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(about, GtkAboutDialog__sym)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo", 1, about, "GtkAboutDialog*");
  logo = s7_car(_p);
  if ((!s7_is_c_pointer_of_type(logo, GdkPaintable__sym)) && (logo != lg_false)) s7_wrong_type_arg_error(sc, "gtk_about_dialog_set_logo", 2, logo, "GdkPaintable*");
  gtk_about_dialog_set_logo((GtkAboutDialog*)s7_c_pointer(about), (GdkPaintable*)s7_c_pointer(logo));
  return(lg_false);
}

static s7_pointer lg_gtk_button_new_from_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_new_from_icon_name "GtkWidget* gtk_button_new_from_icon_name(gchar* icon_name)"
  s7_pointer icon_name;
  icon_name = s7_car(args);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_button_new_from_icon_name", 1, icon_name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_button_new_from_icon_name((const gchar*)s7_string(icon_name))));
}

static s7_pointer lg_gtk_cell_view_new_with_texture(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_view_new_with_texture "GtkWidget* gtk_cell_view_new_with_texture(GdkTexture* texture)"
  s7_pointer texture;
  texture = s7_car(args);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_view_new_with_texture", 1, texture, "GdkTexture*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_cell_view_new_with_texture((GdkTexture*)s7_c_pointer(texture))));
}

static s7_pointer lg_gtk_scale_button_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_button_new "GtkWidget* gtk_scale_button_new(gdouble min, gdouble max, gdouble step, \
gchar** icons)"
  s7_pointer _p;
  s7_pointer min, max, step, icons;
  _p = args;
  min = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(min)) s7_wrong_type_arg_error(sc, "gtk_scale_button_new", 1, min, "gdouble");
  max = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(max)) s7_wrong_type_arg_error(sc, "gtk_scale_button_new", 2, max, "gdouble");
  step = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(step)) s7_wrong_type_arg_error(sc, "gtk_scale_button_new", 3, step, "gdouble");
  icons = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icons, gchar___sym)) s7_wrong_type_arg_error(sc, "gtk_scale_button_new", 4, icons, "gchar**");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_scale_button_new((gdouble)s7_real(min), (gdouble)s7_real(max), (gdouble)s7_real(step), (const gchar**)s7_c_pointer(icons))));
}

static s7_pointer lg_gtk_application_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_new "GtkApplication* gtk_application_new(gchar* application_id, GApplicationFlags flags)"
  s7_pointer _p;
  s7_pointer application_id, flags;
  _p = args;
  application_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(application_id)) s7_wrong_type_arg_error(sc, "gtk_application_new", 1, application_id, "gchar*");
  flags = s7_car(_p);
  if (!s7_is_c_pointer_of_type(flags, GApplicationFlags_sym)) s7_wrong_type_arg_error(sc, "gtk_application_new", 2, flags, "GApplicationFlags");
  return(lg_make_c_pointer_with_type(sc, GtkApplication__sym, gtk_application_new((const gchar*)s7_string(application_id), (GApplicationFlags)s7_c_pointer(flags))));
}

static s7_pointer lg_gtk_application_add_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_add_window "void gtk_application_add_window(GtkApplication* application, \
GtkWindow* window)"
  s7_pointer _p;
  s7_pointer application, window;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_add_window", 1, application, "GtkApplication*");
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_add_window", 2, window, "GtkWindow*");
  gtk_application_add_window((GtkApplication*)s7_c_pointer(application), (GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_application_remove_window(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_remove_window "void gtk_application_remove_window(GtkApplication* application, \
GtkWindow* window)"
  s7_pointer _p;
  s7_pointer application, window;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_remove_window", 1, application, "GtkApplication*");
  window = s7_car(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_remove_window", 2, window, "GtkWindow*");
  gtk_application_remove_window((GtkApplication*)s7_c_pointer(application), (GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_application_get_windows(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_windows "GList* gtk_application_get_windows(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_windows", 1, application, "GtkApplication*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_application_get_windows((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_inhibit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_inhibit "guint gtk_application_inhibit(GtkApplication* application, GtkWindow* window, \
GtkApplicationInhibitFlags flags, gchar* reason)"
  s7_pointer _p;
  s7_pointer application, window, flags, reason;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_inhibit", 1, application, "GtkApplication*");
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_application_inhibit", 2, window, "GtkWindow*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_application_inhibit", 3, flags, "GtkApplicationInhibitFlags");
  reason = s7_car(_p);
  if (!s7_is_string(reason)) s7_wrong_type_arg_error(sc, "gtk_application_inhibit", 4, reason, "gchar*");
  return(s7_make_integer(sc, gtk_application_inhibit((GtkApplication*)s7_c_pointer(application), (GtkWindow*)s7_c_pointer(window), (GtkApplicationInhibitFlags)s7_integer(flags), (const gchar*)s7_string(reason))));
}

static s7_pointer lg_gtk_application_uninhibit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_uninhibit "void gtk_application_uninhibit(GtkApplication* application, guint cookie)"
  s7_pointer _p;
  s7_pointer application, cookie;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_uninhibit", 1, application, "GtkApplication*");
  cookie = s7_car(_p);
  if (!s7_is_integer(cookie)) s7_wrong_type_arg_error(sc, "gtk_application_uninhibit", 2, cookie, "guint");
  gtk_application_uninhibit((GtkApplication*)s7_c_pointer(application), (guint)s7_integer(cookie));
  return(lg_false);
}

static s7_pointer lg_gtk_application_get_window_by_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_window_by_id "GtkWindow* gtk_application_get_window_by_id(GtkApplication* application, \
guint id)"
  s7_pointer _p;
  s7_pointer application, id;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_window_by_id", 1, application, "GtkApplication*");
  id = s7_car(_p);
  if (!s7_is_integer(id)) s7_wrong_type_arg_error(sc, "gtk_application_get_window_by_id", 2, id, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkWindow__sym, gtk_application_get_window_by_id((GtkApplication*)s7_c_pointer(application), (guint)s7_integer(id))));
}

static s7_pointer lg_gtk_application_list_action_descriptions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_list_action_descriptions "gchar** gtk_application_list_action_descriptions(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_list_action_descriptions", 1, application, "GtkApplication*");
  return(lg_make_c_pointer_with_type(sc, gchar___sym, gtk_application_list_action_descriptions((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_get_actions_for_accel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_actions_for_accel "gchar** gtk_application_get_actions_for_accel(GtkApplication* application, \
gchar* accel)"
  s7_pointer _p;
  s7_pointer application, accel;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_actions_for_accel", 1, application, "GtkApplication*");
  accel = s7_car(_p);
  if (!s7_is_string(accel)) s7_wrong_type_arg_error(sc, "gtk_application_get_actions_for_accel", 2, accel, "gchar*");
  return(lg_make_c_pointer_with_type(sc, gchar___sym, gtk_application_get_actions_for_accel((GtkApplication*)s7_c_pointer(application), (const gchar*)s7_string(accel))));
}

static s7_pointer lg_gtk_application_prefers_app_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_prefers_app_menu "gboolean gtk_application_prefers_app_menu(GtkApplication* application)"
  s7_pointer application;
  application = s7_car(args);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_prefers_app_menu", 1, application, "GtkApplication*");
  return(s7_make_boolean(sc, gtk_application_prefers_app_menu((GtkApplication*)s7_c_pointer(application))));
}

static s7_pointer lg_gtk_application_get_menu_by_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_application_get_menu_by_id "GMenu* gtk_application_get_menu_by_id(GtkApplication* application, \
gchar* id)"
  s7_pointer _p;
  s7_pointer application, id;
  _p = args;
  application = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(application, GtkApplication__sym)) s7_wrong_type_arg_error(sc, "gtk_application_get_menu_by_id", 1, application, "GtkApplication*");
  id = s7_car(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_application_get_menu_by_id", 2, id, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GMenu__sym, gtk_application_get_menu_by_id((GtkApplication*)s7_c_pointer(application), (const gchar*)s7_string(id))));
}

static s7_pointer lg_gdk_paintable_new_empty(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_new_empty "GdkPaintable* gdk_paintable_new_empty(int intrinsic_width, int intrinsic_height)"
  s7_pointer _p;
  s7_pointer intrinsic_width, intrinsic_height;
  _p = args;
  intrinsic_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(intrinsic_width)) s7_wrong_type_arg_error(sc, "gdk_paintable_new_empty", 1, intrinsic_width, "int");
  intrinsic_height = s7_car(_p);
  if (!s7_is_integer(intrinsic_height)) s7_wrong_type_arg_error(sc, "gdk_paintable_new_empty", 2, intrinsic_height, "int");
  return(lg_make_c_pointer_with_type(sc, GdkPaintable__sym, gdk_paintable_new_empty((int)s7_integer(intrinsic_width), (int)s7_integer(intrinsic_height))));
}

static s7_pointer lg_gdk_display_get_default_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_get_default_group "GdkSurface* gdk_display_get_default_group(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_get_default_group", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_display_get_default_group((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_menu_popup_at_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_popup_at_rect "void gtk_menu_popup_at_rect(GtkMenu* menu, GdkSurface* rect_window, \
GdkRectangle* rect, GdkGravity rect_anchor, GdkGravity menu_anchor, GdkEvent* trigger_event)"
  s7_pointer _p;
  s7_pointer menu, rect_window, rect, rect_anchor, menu_anchor, trigger_event;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GtkMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 1, menu, "GtkMenu*");
  rect_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect_window, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 2, rect_window, "GdkSurface*");
  rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 3, rect, "GdkRectangle*");
  rect_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(rect_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 4, rect_anchor, "GdkGravity");
  menu_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(menu_anchor)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 5, menu_anchor, "GdkGravity");
  trigger_event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(trigger_event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_popup_at_rect", 6, trigger_event, "GdkEvent*");
  gtk_menu_popup_at_rect((GtkMenu*)s7_c_pointer(menu), (GdkSurface*)s7_c_pointer(rect_window), (GdkRectangle*)s7_c_pointer(rect), (GdkGravity)s7_integer(rect_anchor), (GdkGravity)s7_integer(menu_anchor), (GdkEvent*)s7_c_pointer(trigger_event));
  return(lg_false);
}

static s7_pointer lg_gdk_memory_texture_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_memory_texture_new "GdkTexture* gdk_memory_texture_new(int width, int height, GdkMemoryFormat format, \
GBytes* bytes, gsize stride)"
  s7_pointer _p;
  s7_pointer width, height, format, bytes, stride;
  _p = args;
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_memory_texture_new", 1, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_memory_texture_new", 2, height, "int");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "gdk_memory_texture_new", 3, format, "GdkMemoryFormat");
  bytes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bytes, GBytes__sym)) s7_wrong_type_arg_error(sc, "gdk_memory_texture_new", 4, bytes, "GBytes*");
  stride = s7_car(_p);
  if (!s7_is_integer(stride)) s7_wrong_type_arg_error(sc, "gdk_memory_texture_new", 5, stride, "gsize");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gdk_memory_texture_new((int)s7_integer(width), (int)s7_integer(height), (GdkMemoryFormat)s7_integer(format), (GBytes*)s7_c_pointer(bytes), (gsize)s7_integer(stride))));
}

static s7_pointer lg_gdk_cairo_context_cairo_create(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_cairo_context_cairo_create "cairo_t* gdk_cairo_context_cairo_create(GdkCairoContext* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkCairoContext__sym)) s7_wrong_type_arg_error(sc, "gdk_cairo_context_cairo_create", 1, self, "GdkCairoContext*");
  return(lg_make_c_pointer_with_type(sc, cairo_t__sym, gdk_cairo_context_cairo_create((GdkCairoContext*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_get_display "GdkDisplay* gdk_drop_get_display(GdkDrop* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_get_display", 1, self, "GdkDrop*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_drop_get_display((GdkDrop*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_get_device "GdkDevice* gdk_drop_get_device(GdkDrop* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_get_device", 1, self, "GdkDrop*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gdk_drop_get_device((GdkDrop*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_get_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_get_surface "GdkSurface* gdk_drop_get_surface(GdkDrop* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_get_surface", 1, self, "GdkDrop*");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_drop_get_surface((GdkDrop*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_get_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_get_formats "GdkContentFormats* gdk_drop_get_formats(GdkDrop* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_get_formats", 1, self, "GdkDrop*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_drop_get_formats((GdkDrop*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_get_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_get_actions "GdkDragAction gdk_drop_get_actions(GdkDrop* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_get_actions", 1, self, "GdkDrop*");
  return(s7_make_integer(sc, gdk_drop_get_actions((GdkDrop*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_get_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_get_drag "GdkDrag* gdk_drop_get_drag(GdkDrop* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_get_drag", 1, self, "GdkDrop*");
  return(lg_make_c_pointer_with_type(sc, GdkDrag__sym, gdk_drop_get_drag((GdkDrop*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_drop_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_finish "void gdk_drop_finish(GdkDrop* self, GdkDragAction action)"
  s7_pointer _p;
  s7_pointer self, action;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_finish", 1, self, "GdkDrop*");
  action = s7_car(_p);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gdk_drop_finish", 2, action, "GdkDragAction");
  gdk_drop_finish((GdkDrop*)s7_c_pointer(self), (GdkDragAction)s7_integer(action));
  return(lg_false);
}

static s7_pointer lg_gdk_drop_read_value_async(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_read_value_async "void gdk_drop_read_value_async(GdkDrop* self, GType type, int io_priority, \
GCancellable* cancellable, GAsyncReadyCallback callback, gpointer user_data)"
  s7_pointer _p;
  s7_pointer self, type, io_priority, cancellable, callback, user_data;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_async", 1, self, "GdkDrop*");
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_async", 2, type, "GType");
  io_priority = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(io_priority)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_async", 3, io_priority, "int");
  cancellable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cancellable, GCancellable__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_async", 4, cancellable, "GCancellable*");
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GAsyncReadyCallback_sym)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_async", 5, callback, "GAsyncReadyCallback");
  user_data = s7_car(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_async", 6, user_data, "gpointer");
  gdk_drop_read_value_async((GdkDrop*)s7_c_pointer(self), (GType)s7_integer(type), (int)s7_integer(io_priority), (GCancellable*)s7_c_pointer(cancellable), (GAsyncReadyCallback)s7_c_pointer(callback), (gpointer)s7_c_pointer(user_data));
  return(lg_false);
}

static s7_pointer lg_gdk_drop_read_value_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_read_value_finish "GValue* gdk_drop_read_value_finish(GdkDrop* self, GAsyncResult* result, \
GError** [error])"
  s7_pointer _p;
  s7_pointer self, result;
  GError* ref_error = NULL;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_finish", 1, self, "GdkDrop*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_read_value_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GValue__sym, gdk_drop_read_value_finish((GdkDrop*)s7_c_pointer(self), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gdk_gl_texture_release(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_gl_texture_release "void gdk_gl_texture_release(GdkGLTexture* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GdkGLTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_gl_texture_release", 1, self, "GdkGLTexture*");
  gdk_gl_texture_release((GdkGLTexture*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gdk_paintable_get_current_image(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_get_current_image "GdkPaintable* gdk_paintable_get_current_image(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_get_current_image", 1, paintable, "GdkPaintable*");
  return(lg_make_c_pointer_with_type(sc, GdkPaintable__sym, gdk_paintable_get_current_image((GdkPaintable*)s7_c_pointer(paintable))));
}

static s7_pointer lg_gdk_paintable_get_flags(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_get_flags "GdkPaintableFlags gdk_paintable_get_flags(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_get_flags", 1, paintable, "GdkPaintable*");
  return(s7_make_integer(sc, gdk_paintable_get_flags((GdkPaintable*)s7_c_pointer(paintable))));
}

static s7_pointer lg_gdk_paintable_get_intrinsic_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_get_intrinsic_width "int gdk_paintable_get_intrinsic_width(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_get_intrinsic_width", 1, paintable, "GdkPaintable*");
  return(s7_make_integer(sc, gdk_paintable_get_intrinsic_width((GdkPaintable*)s7_c_pointer(paintable))));
}

static s7_pointer lg_gdk_paintable_get_intrinsic_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_get_intrinsic_height "int gdk_paintable_get_intrinsic_height(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_get_intrinsic_height", 1, paintable, "GdkPaintable*");
  return(s7_make_integer(sc, gdk_paintable_get_intrinsic_height((GdkPaintable*)s7_c_pointer(paintable))));
}

static s7_pointer lg_gdk_paintable_get_intrinsic_aspect_ratio(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_get_intrinsic_aspect_ratio "double gdk_paintable_get_intrinsic_aspect_ratio(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_get_intrinsic_aspect_ratio", 1, paintable, "GdkPaintable*");
  return(s7_make_real(sc, gdk_paintable_get_intrinsic_aspect_ratio((GdkPaintable*)s7_c_pointer(paintable))));
}

static s7_pointer lg_gdk_paintable_compute_concrete_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_compute_concrete_size "void gdk_paintable_compute_concrete_size(GdkPaintable* paintable, \
double specified_width, double specified_height, double default_width, double default_height, double* [concrete_width], \
double* [concrete_height])"
  s7_pointer _p;
  s7_pointer paintable, specified_width, specified_height, default_width, default_height;
  double ref_concrete_width;
  double ref_concrete_height;
  _p = args;
  paintable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_compute_concrete_size", 1, paintable, "GdkPaintable*");
  specified_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(specified_width)) s7_wrong_type_arg_error(sc, "gdk_paintable_compute_concrete_size", 2, specified_width, "double");
  specified_height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(specified_height)) s7_wrong_type_arg_error(sc, "gdk_paintable_compute_concrete_size", 3, specified_height, "double");
  default_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(default_width)) s7_wrong_type_arg_error(sc, "gdk_paintable_compute_concrete_size", 4, default_width, "double");
  default_height = s7_car(_p);
  if (!s7_is_real(default_height)) s7_wrong_type_arg_error(sc, "gdk_paintable_compute_concrete_size", 5, default_height, "double");
  gdk_paintable_compute_concrete_size((GdkPaintable*)s7_c_pointer(paintable), (double)s7_real(specified_width), (double)s7_real(specified_height), (double)s7_real(default_width), (double)s7_real(default_height), &ref_concrete_width, &ref_concrete_height);
    return(s7_list(sc, 2, s7_make_real(sc, ref_concrete_width), s7_make_real(sc, ref_concrete_height)));
}

static s7_pointer lg_gdk_paintable_invalidate_contents(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_invalidate_contents "void gdk_paintable_invalidate_contents(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_invalidate_contents", 1, paintable, "GdkPaintable*");
  gdk_paintable_invalidate_contents((GdkPaintable*)s7_c_pointer(paintable));
  return(lg_false);
}

static s7_pointer lg_gdk_paintable_invalidate_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_paintable_invalidate_size "void gdk_paintable_invalidate_size(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gdk_paintable_invalidate_size", 1, paintable, "GdkPaintable*");
  gdk_paintable_invalidate_size((GdkPaintable*)s7_c_pointer(paintable));
  return(lg_false);
}

static s7_pointer lg_gtk_event_controller_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_widget "GtkWidget* gtk_event_controller_get_widget(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_widget", 1, controller, "GtkEventController*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_event_controller_get_widget((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_reset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_reset "void gtk_event_controller_reset(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_reset", 1, controller, "GtkEventController*");
  gtk_event_controller_reset((GtkEventController*)s7_c_pointer(controller));
  return(lg_false);
}

static s7_pointer lg_gtk_event_controller_get_propagation_phase(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_propagation_phase "GtkPropagationPhase gtk_event_controller_get_propagation_phase(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_propagation_phase", 1, controller, "GtkEventController*");
  return(s7_make_integer(sc, gtk_event_controller_get_propagation_phase((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_set_propagation_phase(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_set_propagation_phase "void gtk_event_controller_set_propagation_phase(GtkEventController* controller, \
GtkPropagationPhase phase)"
  s7_pointer _p;
  s7_pointer controller, phase;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_propagation_phase", 1, controller, "GtkEventController*");
  phase = s7_car(_p);
  if (!s7_is_integer(phase)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_propagation_phase", 2, phase, "GtkPropagationPhase");
  gtk_event_controller_set_propagation_phase((GtkEventController*)s7_c_pointer(controller), (GtkPropagationPhase)s7_integer(phase));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_stylus_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_stylus_new "GtkGesture* gtk_gesture_stylus_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_stylus_new()));
}

static s7_pointer lg_gtk_gesture_stylus_get_axis(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_stylus_get_axis "gboolean gtk_gesture_stylus_get_axis(GtkGestureStylus* gesture, \
GdkAxisUse axis, gdouble* [value])"
  s7_pointer _p;
  s7_pointer gesture, axis;
  gdouble ref_value;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureStylus__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_stylus_get_axis", 1, gesture, "GtkGestureStylus*");
  axis = s7_car(_p);
  if (!s7_is_integer(axis)) s7_wrong_type_arg_error(sc, "gtk_gesture_stylus_get_axis", 2, axis, "GdkAxisUse");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_stylus_get_axis((GtkGestureStylus*)s7_c_pointer(gesture), (GdkAxisUse)s7_integer(axis), &ref_value));
      return(s7_list(sc, 2, res_ult, s7_make_real(sc, ref_value)));
   }
}

static s7_pointer lg_gtk_gesture_stylus_get_backlog(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_stylus_get_backlog "gboolean gtk_gesture_stylus_get_backlog(GtkGestureStylus* gesture, \
GdkTimeCoord** backlog, guint* [n_elems])"
  s7_pointer _p;
  s7_pointer gesture, backlog;
  guint ref_n_elems;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureStylus__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_stylus_get_backlog", 1, gesture, "GtkGestureStylus*");
  backlog = s7_car(_p);
  if (!s7_is_c_pointer_of_type(backlog, GdkTimeCoord___sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_stylus_get_backlog", 2, backlog, "GdkTimeCoord**");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_gesture_stylus_get_backlog((GtkGestureStylus*)s7_c_pointer(gesture), (GdkTimeCoord**)s7_c_pointer(backlog), &ref_n_elems));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_n_elems)));
   }
}

static s7_pointer lg_gtk_gesture_stylus_get_device_tool(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_stylus_get_device_tool "GdkDeviceTool* gtk_gesture_stylus_get_device_tool(GtkGestureStylus* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureStylus__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_stylus_get_device_tool", 1, gesture, "GtkGestureStylus*");
  return(lg_make_c_pointer_with_type(sc, GdkDeviceTool__sym, gtk_gesture_stylus_get_device_tool((GtkGestureStylus*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_media_controls_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_controls_new "GtkWidget* gtk_media_controls_new(GtkMediaStream* stream)"
  s7_pointer stream;
  stream = s7_car(args);
  if (!s7_is_c_pointer_of_type(stream, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_controls_new", 1, stream, "GtkMediaStream*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_media_controls_new((GtkMediaStream*)s7_c_pointer(stream))));
}

static s7_pointer lg_gtk_media_controls_get_media_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_controls_get_media_stream "GtkMediaStream* gtk_media_controls_get_media_stream(GtkMediaControls* controls)"
  s7_pointer controls;
  controls = s7_car(args);
  if (!s7_is_c_pointer_of_type(controls, GtkMediaControls__sym)) s7_wrong_type_arg_error(sc, "gtk_media_controls_get_media_stream", 1, controls, "GtkMediaControls*");
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_media_controls_get_media_stream((GtkMediaControls*)s7_c_pointer(controls))));
}

static s7_pointer lg_gtk_media_controls_set_media_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_controls_set_media_stream "void gtk_media_controls_set_media_stream(GtkMediaControls* controls, \
GtkMediaStream* stream)"
  s7_pointer _p;
  s7_pointer controls, stream;
  _p = args;
  controls = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controls, GtkMediaControls__sym)) s7_wrong_type_arg_error(sc, "gtk_media_controls_set_media_stream", 1, controls, "GtkMediaControls*");
  stream = s7_car(_p);
  if (!s7_is_c_pointer_of_type(stream, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_controls_set_media_stream", 2, stream, "GtkMediaStream*");
  gtk_media_controls_set_media_stream((GtkMediaControls*)s7_c_pointer(controls), (GtkMediaStream*)s7_c_pointer(stream));
  return(lg_false);
}

static s7_pointer lg_gtk_media_file_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_new "GtkMediaStream* gtk_media_file_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_media_file_new()));
}

static s7_pointer lg_gtk_media_file_new_for_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_new_for_filename "GtkMediaStream* gtk_media_file_new_for_filename(char* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_media_file_new_for_filename", 1, filename, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_media_file_new_for_filename((char*)s7_string(filename))));
}

static s7_pointer lg_gtk_media_file_new_for_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_new_for_resource "GtkMediaStream* gtk_media_file_new_for_resource(char* resource_path)"
  s7_pointer resource_path;
  resource_path = s7_car(args);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_media_file_new_for_resource", 1, resource_path, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_media_file_new_for_resource((char*)s7_string(resource_path))));
}

static s7_pointer lg_gtk_media_file_new_for_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_new_for_file "GtkMediaStream* gtk_media_file_new_for_file(GFile* file)"
  s7_pointer file;
  file = s7_car(args);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_new_for_file", 1, file, "GFile*");
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_media_file_new_for_file((GFile*)s7_c_pointer(file))));
}

static s7_pointer lg_gtk_media_file_new_for_input_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_new_for_input_stream "GtkMediaStream* gtk_media_file_new_for_input_stream(GInputStream* stream)"
  s7_pointer stream;
  stream = s7_car(args);
  if (!s7_is_c_pointer_of_type(stream, GInputStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_new_for_input_stream", 1, stream, "GInputStream*");
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_media_file_new_for_input_stream((GInputStream*)s7_c_pointer(stream))));
}

static s7_pointer lg_gtk_media_file_clear(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_clear "void gtk_media_file_clear(GtkMediaFile* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_clear", 1, self, "GtkMediaFile*");
  gtk_media_file_clear((GtkMediaFile*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_file_set_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_set_filename "void gtk_media_file_set_filename(GtkMediaFile* self, char* filename)"
  s7_pointer _p;
  s7_pointer self, filename;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_filename", 1, self, "GtkMediaFile*");
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_filename", 2, filename, "char*");
  gtk_media_file_set_filename((GtkMediaFile*)s7_c_pointer(self), (char*)s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_media_file_set_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_set_resource "void gtk_media_file_set_resource(GtkMediaFile* self, char* resource_path)"
  s7_pointer _p;
  s7_pointer self, resource_path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_resource", 1, self, "GtkMediaFile*");
  resource_path = s7_car(_p);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_resource", 2, resource_path, "char*");
  gtk_media_file_set_resource((GtkMediaFile*)s7_c_pointer(self), (char*)s7_string(resource_path));
  return(lg_false);
}

static s7_pointer lg_gtk_media_file_set_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_set_file "void gtk_media_file_set_file(GtkMediaFile* self, GFile* file)"
  s7_pointer _p;
  s7_pointer self, file;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_file", 1, self, "GtkMediaFile*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_file", 2, file, "GFile*");
  gtk_media_file_set_file((GtkMediaFile*)s7_c_pointer(self), (GFile*)s7_c_pointer(file));
  return(lg_false);
}

static s7_pointer lg_gtk_media_file_get_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_get_file "GFile* gtk_media_file_get_file(GtkMediaFile* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_get_file", 1, self, "GtkMediaFile*");
  return(lg_make_c_pointer_with_type(sc, GFile__sym, gtk_media_file_get_file((GtkMediaFile*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_file_set_input_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_set_input_stream "void gtk_media_file_set_input_stream(GtkMediaFile* self, \
GInputStream* stream)"
  s7_pointer _p;
  s7_pointer self, stream;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_input_stream", 1, self, "GtkMediaFile*");
  stream = s7_car(_p);
  if (!s7_is_c_pointer_of_type(stream, GInputStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_set_input_stream", 2, stream, "GInputStream*");
  gtk_media_file_set_input_stream((GtkMediaFile*)s7_c_pointer(self), (GInputStream*)s7_c_pointer(stream));
  return(lg_false);
}

static s7_pointer lg_gtk_media_file_get_input_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_file_get_input_stream "GInputStream* gtk_media_file_get_input_stream(GtkMediaFile* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaFile__sym)) s7_wrong_type_arg_error(sc, "gtk_media_file_get_input_stream", 1, self, "GtkMediaFile*");
  return(lg_make_c_pointer_with_type(sc, GInputStream__sym, gtk_media_file_get_input_stream((GtkMediaFile*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_is_prepared(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_is_prepared "gboolean gtk_media_stream_is_prepared(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_is_prepared", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_is_prepared((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_get_error(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_error "GError* gtk_media_stream_get_error(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_error", 1, self, "GtkMediaStream*");
    return(lg_make_c_pointer_with_type(sc, GError__sym, (GError*)gtk_media_stream_get_error((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_has_audio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_has_audio "gboolean gtk_media_stream_has_audio(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_has_audio", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_has_audio((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_has_video(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_has_video "gboolean gtk_media_stream_has_video(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_has_video", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_has_video((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_play(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_play "void gtk_media_stream_play(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_play", 1, self, "GtkMediaStream*");
  gtk_media_stream_play((GtkMediaStream*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_pause(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_pause "void gtk_media_stream_pause(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_pause", 1, self, "GtkMediaStream*");
  gtk_media_stream_pause((GtkMediaStream*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_get_playing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_playing "gboolean gtk_media_stream_get_playing(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_playing", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_get_playing((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_set_playing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_set_playing "void gtk_media_stream_set_playing(GtkMediaStream* self, gboolean playing)"
  s7_pointer _p;
  s7_pointer self, playing;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_playing", 1, self, "GtkMediaStream*");
  playing = s7_car(_p);
  if (!s7_is_boolean(playing)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_playing", 2, playing, "gboolean");
  gtk_media_stream_set_playing((GtkMediaStream*)s7_c_pointer(self), (gboolean)lg_boolean(playing));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_get_ended(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_ended "gboolean gtk_media_stream_get_ended(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_ended", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_get_ended((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_get_timestamp(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_timestamp "gint64 gtk_media_stream_get_timestamp(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_timestamp", 1, self, "GtkMediaStream*");
  return(lg_make_c_pointer_with_type(sc, gint64_sym, gtk_media_stream_get_timestamp((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_get_duration(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_duration "gint64 gtk_media_stream_get_duration(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_duration", 1, self, "GtkMediaStream*");
  return(lg_make_c_pointer_with_type(sc, gint64_sym, gtk_media_stream_get_duration((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_is_seekable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_is_seekable "gboolean gtk_media_stream_is_seekable(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_is_seekable", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_is_seekable((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_is_seeking(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_is_seeking "gboolean gtk_media_stream_is_seeking(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_is_seeking", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_is_seeking((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_seek(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_seek "void gtk_media_stream_seek(GtkMediaStream* self, gint64 timestamp)"
  s7_pointer _p;
  s7_pointer self, timestamp;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_seek", 1, self, "GtkMediaStream*");
  timestamp = s7_car(_p);
  if (!s7_is_c_pointer_of_type(timestamp, gint64_sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_seek", 2, timestamp, "gint64");
  gtk_media_stream_seek((GtkMediaStream*)s7_c_pointer(self), (gint64)s7_c_pointer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_get_loop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_loop "gboolean gtk_media_stream_get_loop(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_loop", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_get_loop((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_set_loop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_set_loop "void gtk_media_stream_set_loop(GtkMediaStream* self, gboolean loop)"
  s7_pointer _p;
  s7_pointer self, loop;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_loop", 1, self, "GtkMediaStream*");
  loop = s7_car(_p);
  if (!s7_is_boolean(loop)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_loop", 2, loop, "gboolean");
  gtk_media_stream_set_loop((GtkMediaStream*)s7_c_pointer(self), (gboolean)lg_boolean(loop));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_get_muted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_muted "gboolean gtk_media_stream_get_muted(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_muted", 1, self, "GtkMediaStream*");
  return(s7_make_boolean(sc, gtk_media_stream_get_muted((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_set_muted(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_set_muted "void gtk_media_stream_set_muted(GtkMediaStream* self, gboolean muted)"
  s7_pointer _p;
  s7_pointer self, muted;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_muted", 1, self, "GtkMediaStream*");
  muted = s7_car(_p);
  if (!s7_is_boolean(muted)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_muted", 2, muted, "gboolean");
  gtk_media_stream_set_muted((GtkMediaStream*)s7_c_pointer(self), (gboolean)lg_boolean(muted));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_get_volume(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_get_volume "double gtk_media_stream_get_volume(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_get_volume", 1, self, "GtkMediaStream*");
  return(s7_make_real(sc, gtk_media_stream_get_volume((GtkMediaStream*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_media_stream_set_volume(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_set_volume "void gtk_media_stream_set_volume(GtkMediaStream* self, double volume)"
  s7_pointer _p;
  s7_pointer self, volume;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_volume", 1, self, "GtkMediaStream*");
  volume = s7_car(_p);
  if (!s7_is_real(volume)) s7_wrong_type_arg_error(sc, "gtk_media_stream_set_volume", 2, volume, "double");
  gtk_media_stream_set_volume((GtkMediaStream*)s7_c_pointer(self), (double)s7_real(volume));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_realize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_realize "void gtk_media_stream_realize(GtkMediaStream* self, GdkSurface* surface)"
  s7_pointer _p;
  s7_pointer self, surface;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_realize", 1, self, "GtkMediaStream*");
  surface = s7_car(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_realize", 2, surface, "GdkSurface*");
  gtk_media_stream_realize((GtkMediaStream*)s7_c_pointer(self), (GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_unrealize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_unrealize "void gtk_media_stream_unrealize(GtkMediaStream* self, GdkSurface* surface)"
  s7_pointer _p;
  s7_pointer self, surface;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_unrealize", 1, self, "GtkMediaStream*");
  surface = s7_car(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_unrealize", 2, surface, "GdkSurface*");
  gtk_media_stream_unrealize((GtkMediaStream*)s7_c_pointer(self), (GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_prepared(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_prepared "void gtk_media_stream_prepared(GtkMediaStream* self, gboolean has_audio, \
gboolean has_video, gboolean seekable, gint64 duration)"
  s7_pointer _p;
  s7_pointer self, has_audio, has_video, seekable, duration;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_prepared", 1, self, "GtkMediaStream*");
  has_audio = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_audio)) s7_wrong_type_arg_error(sc, "gtk_media_stream_prepared", 2, has_audio, "gboolean");
  has_video = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(has_video)) s7_wrong_type_arg_error(sc, "gtk_media_stream_prepared", 3, has_video, "gboolean");
  seekable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(seekable)) s7_wrong_type_arg_error(sc, "gtk_media_stream_prepared", 4, seekable, "gboolean");
  duration = s7_car(_p);
  if (!s7_is_c_pointer_of_type(duration, gint64_sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_prepared", 5, duration, "gint64");
  gtk_media_stream_prepared((GtkMediaStream*)s7_c_pointer(self), (gboolean)lg_boolean(has_audio), (gboolean)lg_boolean(has_video), (gboolean)lg_boolean(seekable), (gint64)s7_c_pointer(duration));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_unprepared(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_unprepared "void gtk_media_stream_unprepared(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_unprepared", 1, self, "GtkMediaStream*");
  gtk_media_stream_unprepared((GtkMediaStream*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_update(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_update "void gtk_media_stream_update(GtkMediaStream* self, gint64 timestamp)"
  s7_pointer _p;
  s7_pointer self, timestamp;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_update", 1, self, "GtkMediaStream*");
  timestamp = s7_car(_p);
  if (!s7_is_c_pointer_of_type(timestamp, gint64_sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_update", 2, timestamp, "gint64");
  gtk_media_stream_update((GtkMediaStream*)s7_c_pointer(self), (gint64)s7_c_pointer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_ended(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_ended "void gtk_media_stream_ended(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_ended", 1, self, "GtkMediaStream*");
  gtk_media_stream_ended((GtkMediaStream*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_seek_success(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_seek_success "void gtk_media_stream_seek_success(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_seek_success", 1, self, "GtkMediaStream*");
  gtk_media_stream_seek_success((GtkMediaStream*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_seek_failed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_seek_failed "void gtk_media_stream_seek_failed(GtkMediaStream* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_seek_failed", 1, self, "GtkMediaStream*");
  gtk_media_stream_seek_failed((GtkMediaStream*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_media_stream_gerror(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_media_stream_gerror "void gtk_media_stream_gerror(GtkMediaStream* self, GError* error)"
  s7_pointer _p;
  s7_pointer self, error;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_gerror", 1, self, "GtkMediaStream*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError__sym)) s7_wrong_type_arg_error(sc, "gtk_media_stream_gerror", 2, error, "GError*");
  gtk_media_stream_gerror((GtkMediaStream*)s7_c_pointer(self), (GError*)s7_c_pointer(error));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_new "GtkWidget* gtk_picture_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_picture_new()));
}

static s7_pointer lg_gtk_picture_new_for_paintable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_new_for_paintable "GtkWidget* gtk_picture_new_for_paintable(GdkPaintable* paintable)"
  s7_pointer paintable;
  paintable = s7_car(args);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_new_for_paintable", 1, paintable, "GdkPaintable*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_picture_new_for_paintable((GdkPaintable*)s7_c_pointer(paintable))));
}

static s7_pointer lg_gtk_picture_new_for_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_new_for_pixbuf "GtkWidget* gtk_picture_new_for_pixbuf(GdkPixbuf* pixbuf)"
  s7_pointer pixbuf;
  pixbuf = s7_car(args);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_new_for_pixbuf", 1, pixbuf, "GdkPixbuf*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_picture_new_for_pixbuf((GdkPixbuf*)s7_c_pointer(pixbuf))));
}

static s7_pointer lg_gtk_picture_new_for_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_new_for_file "GtkWidget* gtk_picture_new_for_file(GFile* file)"
  s7_pointer file;
  file = s7_car(args);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_new_for_file", 1, file, "GFile*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_picture_new_for_file((GFile*)s7_c_pointer(file))));
}

static s7_pointer lg_gtk_picture_new_for_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_new_for_filename "GtkWidget* gtk_picture_new_for_filename(gchar* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_picture_new_for_filename", 1, filename, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_picture_new_for_filename((gchar*)s7_string(filename))));
}

static s7_pointer lg_gtk_picture_new_for_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_new_for_resource "GtkWidget* gtk_picture_new_for_resource(gchar* resource_path)"
  s7_pointer resource_path;
  resource_path = s7_car(args);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_picture_new_for_resource", 1, resource_path, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_picture_new_for_resource((gchar*)s7_string(resource_path))));
}

static s7_pointer lg_gtk_picture_set_paintable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_paintable "void gtk_picture_set_paintable(GtkPicture* self, GdkPaintable* paintable)"
  s7_pointer _p;
  s7_pointer self, paintable;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_paintable", 1, self, "GtkPicture*");
  paintable = s7_car(_p);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_paintable", 2, paintable, "GdkPaintable*");
  gtk_picture_set_paintable((GtkPicture*)s7_c_pointer(self), (GdkPaintable*)s7_c_pointer(paintable));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_get_paintable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_get_paintable "GdkPaintable* gtk_picture_get_paintable(GtkPicture* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_get_paintable", 1, self, "GtkPicture*");
  return(lg_make_c_pointer_with_type(sc, GdkPaintable__sym, gtk_picture_get_paintable((GtkPicture*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_picture_set_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_file "void gtk_picture_set_file(GtkPicture* self, GFile* file)"
  s7_pointer _p;
  s7_pointer self, file;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_file", 1, self, "GtkPicture*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_file", 2, file, "GFile*");
  gtk_picture_set_file((GtkPicture*)s7_c_pointer(self), (GFile*)s7_c_pointer(file));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_get_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_get_file "GFile* gtk_picture_get_file(GtkPicture* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_get_file", 1, self, "GtkPicture*");
  return(lg_make_c_pointer_with_type(sc, GFile__sym, gtk_picture_get_file((GtkPicture*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_picture_set_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_filename "void gtk_picture_set_filename(GtkPicture* self, gchar* filename)"
  s7_pointer _p;
  s7_pointer self, filename;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_filename", 1, self, "GtkPicture*");
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_picture_set_filename", 2, filename, "gchar*");
  gtk_picture_set_filename((GtkPicture*)s7_c_pointer(self), (gchar*)s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_set_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_resource "void gtk_picture_set_resource(GtkPicture* self, gchar* resource_path)"
  s7_pointer _p;
  s7_pointer self, resource_path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_resource", 1, self, "GtkPicture*");
  resource_path = s7_car(_p);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_picture_set_resource", 2, resource_path, "gchar*");
  gtk_picture_set_resource((GtkPicture*)s7_c_pointer(self), (gchar*)s7_string(resource_path));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_set_pixbuf(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_pixbuf "void gtk_picture_set_pixbuf(GtkPicture* self, GdkPixbuf* pixbuf)"
  s7_pointer _p;
  s7_pointer self, pixbuf;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_pixbuf", 1, self, "GtkPicture*");
  pixbuf = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pixbuf, GdkPixbuf__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_pixbuf", 2, pixbuf, "GdkPixbuf*");
  gtk_picture_set_pixbuf((GtkPicture*)s7_c_pointer(self), (GdkPixbuf*)s7_c_pointer(pixbuf));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_set_keep_aspect_ratio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_keep_aspect_ratio "void gtk_picture_set_keep_aspect_ratio(GtkPicture* self, \
gboolean keep_aspect_ratio)"
  s7_pointer _p;
  s7_pointer self, keep_aspect_ratio;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_keep_aspect_ratio", 1, self, "GtkPicture*");
  keep_aspect_ratio = s7_car(_p);
  if (!s7_is_boolean(keep_aspect_ratio)) s7_wrong_type_arg_error(sc, "gtk_picture_set_keep_aspect_ratio", 2, keep_aspect_ratio, "gboolean");
  gtk_picture_set_keep_aspect_ratio((GtkPicture*)s7_c_pointer(self), (gboolean)lg_boolean(keep_aspect_ratio));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_get_keep_aspect_ratio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_get_keep_aspect_ratio "gboolean gtk_picture_get_keep_aspect_ratio(GtkPicture* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_get_keep_aspect_ratio", 1, self, "GtkPicture*");
  return(s7_make_boolean(sc, gtk_picture_get_keep_aspect_ratio((GtkPicture*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_picture_set_can_shrink(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_can_shrink "void gtk_picture_set_can_shrink(GtkPicture* self, gboolean can_shrink)"
  s7_pointer _p;
  s7_pointer self, can_shrink;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_can_shrink", 1, self, "GtkPicture*");
  can_shrink = s7_car(_p);
  if (!s7_is_boolean(can_shrink)) s7_wrong_type_arg_error(sc, "gtk_picture_set_can_shrink", 2, can_shrink, "gboolean");
  gtk_picture_set_can_shrink((GtkPicture*)s7_c_pointer(self), (gboolean)lg_boolean(can_shrink));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_get_can_shrink(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_get_can_shrink "gboolean gtk_picture_get_can_shrink(GtkPicture* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_get_can_shrink", 1, self, "GtkPicture*");
  return(s7_make_boolean(sc, gtk_picture_get_can_shrink((GtkPicture*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_picture_set_alternative_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_set_alternative_text "void gtk_picture_set_alternative_text(GtkPicture* self, \
char* alternative_text)"
  s7_pointer _p;
  s7_pointer self, alternative_text;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_set_alternative_text", 1, self, "GtkPicture*");
  alternative_text = s7_car(_p);
  if (!s7_is_string(alternative_text)) s7_wrong_type_arg_error(sc, "gtk_picture_set_alternative_text", 2, alternative_text, "char*");
  gtk_picture_set_alternative_text((GtkPicture*)s7_c_pointer(self), (char*)s7_string(alternative_text));
  return(lg_false);
}

static s7_pointer lg_gtk_picture_get_alternative_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_picture_get_alternative_text "char* gtk_picture_get_alternative_text(GtkPicture* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkPicture__sym)) s7_wrong_type_arg_error(sc, "gtk_picture_get_alternative_text", 1, self, "GtkPicture*");
    return(s7_make_string(sc, (char*)gtk_picture_get_alternative_text((GtkPicture*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_video_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_new "GtkWidget* gtk_video_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_video_new()));
}

static s7_pointer lg_gtk_video_new_for_media_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_new_for_media_stream "GtkWidget* gtk_video_new_for_media_stream(GtkMediaStream* stream)"
  s7_pointer stream;
  stream = s7_car(args);
  if (!s7_is_c_pointer_of_type(stream, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_video_new_for_media_stream", 1, stream, "GtkMediaStream*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_video_new_for_media_stream((GtkMediaStream*)s7_c_pointer(stream))));
}

static s7_pointer lg_gtk_video_new_for_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_new_for_file "GtkWidget* gtk_video_new_for_file(GFile* file)"
  s7_pointer file;
  file = s7_car(args);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_video_new_for_file", 1, file, "GFile*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_video_new_for_file((GFile*)s7_c_pointer(file))));
}

static s7_pointer lg_gtk_video_new_for_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_new_for_filename "GtkWidget* gtk_video_new_for_filename(char* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_video_new_for_filename", 1, filename, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_video_new_for_filename((char*)s7_string(filename))));
}

static s7_pointer lg_gtk_video_new_for_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_new_for_resource "GtkWidget* gtk_video_new_for_resource(char* resource_path)"
  s7_pointer resource_path;
  resource_path = s7_car(args);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_video_new_for_resource", 1, resource_path, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_video_new_for_resource((char*)s7_string(resource_path))));
}

static s7_pointer lg_gtk_video_get_media_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_get_media_stream "GtkMediaStream* gtk_video_get_media_stream(GtkVideo* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_get_media_stream", 1, self, "GtkVideo*");
  return(lg_make_c_pointer_with_type(sc, GtkMediaStream__sym, gtk_video_get_media_stream((GtkVideo*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_video_set_media_stream(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_set_media_stream "void gtk_video_set_media_stream(GtkVideo* self, GtkMediaStream* stream)"
  s7_pointer _p;
  s7_pointer self, stream;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_media_stream", 1, self, "GtkVideo*");
  stream = s7_car(_p);
  if (!s7_is_c_pointer_of_type(stream, GtkMediaStream__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_media_stream", 2, stream, "GtkMediaStream*");
  gtk_video_set_media_stream((GtkVideo*)s7_c_pointer(self), (GtkMediaStream*)s7_c_pointer(stream));
  return(lg_false);
}

static s7_pointer lg_gtk_video_get_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_get_file "GFile* gtk_video_get_file(GtkVideo* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_get_file", 1, self, "GtkVideo*");
  return(lg_make_c_pointer_with_type(sc, GFile__sym, gtk_video_get_file((GtkVideo*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_video_set_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_set_file "void gtk_video_set_file(GtkVideo* self, GFile* file)"
  s7_pointer _p;
  s7_pointer self, file;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_file", 1, self, "GtkVideo*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_file", 2, file, "GFile*");
  gtk_video_set_file((GtkVideo*)s7_c_pointer(self), (GFile*)s7_c_pointer(file));
  return(lg_false);
}

static s7_pointer lg_gtk_video_set_filename(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_set_filename "void gtk_video_set_filename(GtkVideo* self, char* filename)"
  s7_pointer _p;
  s7_pointer self, filename;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_filename", 1, self, "GtkVideo*");
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "gtk_video_set_filename", 2, filename, "char*");
  gtk_video_set_filename((GtkVideo*)s7_c_pointer(self), (char*)s7_string(filename));
  return(lg_false);
}

static s7_pointer lg_gtk_video_set_resource(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_set_resource "void gtk_video_set_resource(GtkVideo* self, char* resource_path)"
  s7_pointer _p;
  s7_pointer self, resource_path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_resource", 1, self, "GtkVideo*");
  resource_path = s7_car(_p);
  if (!s7_is_string(resource_path)) s7_wrong_type_arg_error(sc, "gtk_video_set_resource", 2, resource_path, "char*");
  gtk_video_set_resource((GtkVideo*)s7_c_pointer(self), (char*)s7_string(resource_path));
  return(lg_false);
}

static s7_pointer lg_gtk_video_get_autoplay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_get_autoplay "gboolean gtk_video_get_autoplay(GtkVideo* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_get_autoplay", 1, self, "GtkVideo*");
  return(s7_make_boolean(sc, gtk_video_get_autoplay((GtkVideo*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_video_set_autoplay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_set_autoplay "void gtk_video_set_autoplay(GtkVideo* self, gboolean autoplay)"
  s7_pointer _p;
  s7_pointer self, autoplay;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_autoplay", 1, self, "GtkVideo*");
  autoplay = s7_car(_p);
  if (!s7_is_boolean(autoplay)) s7_wrong_type_arg_error(sc, "gtk_video_set_autoplay", 2, autoplay, "gboolean");
  gtk_video_set_autoplay((GtkVideo*)s7_c_pointer(self), (gboolean)lg_boolean(autoplay));
  return(lg_false);
}

static s7_pointer lg_gtk_video_get_loop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_get_loop "gboolean gtk_video_get_loop(GtkVideo* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_get_loop", 1, self, "GtkVideo*");
  return(s7_make_boolean(sc, gtk_video_get_loop((GtkVideo*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_video_set_loop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_video_set_loop "void gtk_video_set_loop(GtkVideo* self, gboolean loop)"
  s7_pointer _p;
  s7_pointer self, loop;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkVideo__sym)) s7_wrong_type_arg_error(sc, "gtk_video_set_loop", 1, self, "GtkVideo*");
  loop = s7_car(_p);
  if (!s7_is_boolean(loop)) s7_wrong_type_arg_error(sc, "gtk_video_set_loop", 2, loop, "gboolean");
  gtk_video_set_loop((GtkVideo*)s7_c_pointer(self), (gboolean)lg_boolean(loop));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_paintable_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_paintable_new "GdkPaintable* gtk_widget_paintable_new(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_paintable_new", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GdkPaintable__sym, gtk_widget_paintable_new((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_paintable_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_paintable_get_widget "GtkWidget* gtk_widget_paintable_get_widget(GtkWidgetPaintable* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkWidgetPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_paintable_get_widget", 1, self, "GtkWidgetPaintable*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_paintable_get_widget((GtkWidgetPaintable*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_widget_paintable_set_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_paintable_set_widget "void gtk_widget_paintable_set_widget(GtkWidgetPaintable* self, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer self, widget;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkWidgetPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_paintable_set_widget", 1, self, "GtkWidgetPaintable*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_paintable_set_widget", 2, widget, "GtkWidget*");
  gtk_widget_paintable_set_widget((GtkWidgetPaintable*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_set_label_align(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_set_label_align "void gtk_frame_set_label_align(GtkFrame* frame, gfloat xalign)"
  s7_pointer _p;
  s7_pointer frame, xalign;
  _p = args;
  frame = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_align", 1, frame, "GtkFrame*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_frame_set_label_align", 2, xalign, "gfloat");
  gtk_frame_set_label_align((GtkFrame*)s7_c_pointer(frame), (gfloat)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_frame_get_label_align(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_frame_get_label_align "gfloat gtk_frame_get_label_align(GtkFrame* frame)"
  s7_pointer frame;
  frame = s7_car(args);
  if (!s7_is_c_pointer_of_type(frame, GtkFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_frame_get_label_align", 1, frame, "GtkFrame*");
  return(s7_make_real(sc, gtk_frame_get_label_align((GtkFrame*)s7_c_pointer(frame))));
}

static s7_pointer lg_gtk_pad_controller_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_pad_controller_new "GtkPadController* gtk_pad_controller_new(GActionGroup* group, GdkDevice* pad)"
  s7_pointer _p;
  s7_pointer group, pad;
  _p = args;
  group = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(group, GActionGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_new", 1, group, "GActionGroup*");
  pad = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pad, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gtk_pad_controller_new", 2, pad, "GdkDevice*");
  return(lg_make_c_pointer_with_type(sc, GtkPadController__sym, gtk_pad_controller_new((GActionGroup*)s7_c_pointer(group), (GdkDevice*)s7_c_pointer(pad))));
}

static s7_pointer lg_gtk_widget_size_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_size_allocate "void gtk_widget_size_allocate(GtkWidget* widget, GtkAllocation* allocation, \
int baseline)"
  s7_pointer _p;
  s7_pointer widget, allocation, baseline;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 1, widget, "GtkWidget*");
  allocation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(allocation, GtkAllocation__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 2, allocation, "GtkAllocation*");
  baseline = s7_car(_p);
  if (!s7_is_integer(baseline)) s7_wrong_type_arg_error(sc, "gtk_widget_size_allocate", 3, baseline, "int");
  gtk_widget_size_allocate((GtkWidget*)s7_c_pointer(widget), (GtkAllocation*)s7_c_pointer(allocation), (int)s7_integer(baseline));
  return(lg_false);
}

#endif

#if GTK_CHECK_VERSION(3, 96, 0)
static s7_pointer lg_gtk_search_bar_connect_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_search_bar_connect_entry "void gtk_search_bar_connect_entry(GtkSearchBar* bar, GtkEditable* entry)"
  s7_pointer _p;
  s7_pointer bar, entry;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkSearchBar__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_connect_entry", 1, bar, "GtkSearchBar*");
  entry = s7_car(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_search_bar_connect_entry", 2, entry, "GtkEditable*");
  gtk_search_bar_connect_entry((GtkSearchBar*)s7_c_pointer(bar), (GtkEditable*)s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_view_get_search_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_get_search_entry "GtkEditable* gtk_tree_view_get_search_entry(GtkTreeView* tree_view)"
  s7_pointer tree_view;
  tree_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_get_search_entry", 1, tree_view, "GtkTreeView*");
  return(lg_make_c_pointer_with_type(sc, GtkEditable__sym, gtk_tree_view_get_search_entry((GtkTreeView*)s7_c_pointer(tree_view))));
}

static s7_pointer lg_gtk_tree_view_set_search_entry(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_set_search_entry "void gtk_tree_view_set_search_entry(GtkTreeView* tree_view, \
GtkEditable* entry)"
  s7_pointer _p;
  s7_pointer tree_view, entry;
  _p = args;
  tree_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_view, GtkTreeView__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_entry", 1, tree_view, "GtkTreeView*");
  entry = s7_car(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_set_search_entry", 2, entry, "GtkEditable*");
  gtk_tree_view_set_search_entry((GtkTreeView*)s7_c_pointer(tree_view), (GtkEditable*)s7_c_pointer(entry));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_bar_new_from_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_bar_new_from_model "GtkWidget* gtk_menu_bar_new_from_model(GMenuModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_bar_new_from_model", 1, model, "GMenuModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_menu_bar_new_from_model((GMenuModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_assistant_get_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_page "GtkAssistantPage* gtk_assistant_get_page(GtkAssistant* assistant, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer assistant, child;
  _p = args;
  assistant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page", 1, assistant, "GtkAssistant*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_page", 2, child, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkAssistantPage__sym, gtk_assistant_get_page((GtkAssistant*)s7_c_pointer(assistant), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_assistant_page_get_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_page_get_child "GtkWidget* gtk_assistant_page_get_child(GtkAssistantPage* page)"
  s7_pointer page;
  page = s7_car(args);
  if (!s7_is_c_pointer_of_type(page, GtkAssistantPage__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_page_get_child", 1, page, "GtkAssistantPage*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_assistant_page_get_child((GtkAssistantPage*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_assistant_get_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_assistant_get_pages "GListModel* gtk_assistant_get_pages(GtkAssistant* assistant)"
  s7_pointer assistant;
  assistant = s7_car(args);
  if (!s7_is_c_pointer_of_type(assistant, GtkAssistant__sym)) s7_wrong_type_arg_error(sc, "gtk_assistant_get_pages", 1, assistant, "GtkAssistant*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_assistant_get_pages((GtkAssistant*)s7_c_pointer(assistant))));
}

static s7_pointer lg_gtk_box_insert_child_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_insert_child_after "void gtk_box_insert_child_after(GtkBox* box, GtkWidget* child, \
GtkWidget* sibling)"
  s7_pointer _p;
  s7_pointer box, child, sibling;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_insert_child_after", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_insert_child_after", 2, child, "GtkWidget*");
  sibling = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_insert_child_after", 3, sibling, "GtkWidget*");
  gtk_box_insert_child_after((GtkBox*)s7_c_pointer(box), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_box_reorder_child_after(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_reorder_child_after "void gtk_box_reorder_child_after(GtkBox* box, GtkWidget* child, \
GtkWidget* sibling)"
  s7_pointer _p;
  s7_pointer box, child, sibling;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkBox__sym)) s7_wrong_type_arg_error(sc, "gtk_box_reorder_child_after", 1, box, "GtkBox*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_reorder_child_after", 2, child, "GtkWidget*");
  sibling = s7_car(_p);
  if (!s7_is_c_pointer_of_type(sibling, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_box_reorder_child_after", 3, sibling, "GtkWidget*");
  gtk_box_reorder_child_after((GtkBox*)s7_c_pointer(box), (GtkWidget*)s7_c_pointer(child), (GtkWidget*)s7_c_pointer(sibling));
  return(lg_false);
}

static s7_pointer lg_gtk_css_provider_load_named(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_css_provider_load_named "void gtk_css_provider_load_named(GtkCssProvider* provider, char* name, \
char* variant)"
  s7_pointer _p;
  s7_pointer provider, name, variant;
  _p = args;
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GtkCssProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_named", 1, provider, "GtkCssProvider*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_named", 2, name, "char*");
  variant = s7_car(_p);
  if (!s7_is_string(variant)) s7_wrong_type_arg_error(sc, "gtk_css_provider_load_named", 3, variant, "char*");
  gtk_css_provider_load_named((GtkCssProvider*)s7_c_pointer(provider), (char*)s7_string(name), (char*)s7_string(variant));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_set_alignment(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_alignment "void gtk_editable_set_alignment(GtkEditable* editable, float xalign)"
  s7_pointer _p;
  s7_pointer editable, xalign;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_alignment", 1, editable, "GtkEditable*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_editable_set_alignment", 2, xalign, "float");
  gtk_editable_set_alignment((GtkEditable*)s7_c_pointer(editable), (float)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_width_chars "int gtk_editable_get_width_chars(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_width_chars", 1, editable, "GtkEditable*");
  return(s7_make_integer(sc, gtk_editable_get_width_chars((GtkEditable*)s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_editable_set_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_width_chars "void gtk_editable_set_width_chars(GtkEditable* editable, int n_chars)"
  s7_pointer _p;
  s7_pointer editable, n_chars;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_width_chars", 1, editable, "GtkEditable*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_editable_set_width_chars", 2, n_chars, "int");
  gtk_editable_set_width_chars((GtkEditable*)s7_c_pointer(editable), (int)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_get_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_max_width_chars "int gtk_editable_get_max_width_chars(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_max_width_chars", 1, editable, "GtkEditable*");
  return(s7_make_integer(sc, gtk_editable_get_max_width_chars((GtkEditable*)s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_editable_set_max_width_chars(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_max_width_chars "void gtk_editable_set_max_width_chars(GtkEditable* editable, \
int n_chars)"
  s7_pointer _p;
  s7_pointer editable, n_chars;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_max_width_chars", 1, editable, "GtkEditable*");
  n_chars = s7_car(_p);
  if (!s7_is_integer(n_chars)) s7_wrong_type_arg_error(sc, "gtk_editable_set_max_width_chars", 2, n_chars, "int");
  gtk_editable_set_max_width_chars((GtkEditable*)s7_c_pointer(editable), (int)s7_integer(n_chars));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_install_properties(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_install_properties "guint gtk_editable_install_properties(GObjectClass* object_class, \
guint first_prop)"
  s7_pointer _p;
  s7_pointer object_class, first_prop;
  _p = args;
  object_class = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object_class, GObjectClass__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_install_properties", 1, object_class, "GObjectClass*");
  first_prop = s7_car(_p);
  if (!s7_is_integer(first_prop)) s7_wrong_type_arg_error(sc, "gtk_editable_install_properties", 2, first_prop, "guint");
  return(s7_make_integer(sc, gtk_editable_install_properties((GObjectClass*)s7_c_pointer(object_class), (guint)s7_integer(first_prop))));
}

static s7_pointer lg_gtk_editable_init_delegate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_init_delegate "void gtk_editable_init_delegate(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_init_delegate", 1, editable, "GtkEditable*");
  gtk_editable_init_delegate((GtkEditable*)s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_finish_delegate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_finish_delegate "void gtk_editable_finish_delegate(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_finish_delegate", 1, editable, "GtkEditable*");
  gtk_editable_finish_delegate((GtkEditable*)s7_c_pointer(editable));
  return(lg_false);
}

static s7_pointer lg_gtk_editable_delegate_set_property(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_delegate_set_property "gboolean gtk_editable_delegate_set_property(GObject* object, \
guint prop_id, GValue* value, GParamSpec* pspec)"
  s7_pointer _p;
  s7_pointer object, prop_id, value, pspec;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_set_property", 1, object, "GObject*");
  prop_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(prop_id)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_set_property", 2, prop_id, "guint");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_set_property", 3, value, "GValue*");
  pspec = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pspec, GParamSpec__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_set_property", 4, pspec, "GParamSpec*");
  return(s7_make_boolean(sc, gtk_editable_delegate_set_property((GObject*)s7_c_pointer(object), (guint)s7_integer(prop_id), (GValue*)s7_c_pointer(value), (GParamSpec*)s7_c_pointer(pspec))));
}

static s7_pointer lg_gtk_editable_delegate_get_property(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_delegate_get_property "gboolean gtk_editable_delegate_get_property(GObject* object, \
guint prop_id, GValue* value, GParamSpec* pspec)"
  s7_pointer _p;
  s7_pointer object, prop_id, value, pspec;
  _p = args;
  object = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(object, GObject__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_get_property", 1, object, "GObject*");
  prop_id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(prop_id)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_get_property", 2, prop_id, "guint");
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_get_property", 3, value, "GValue*");
  pspec = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pspec, GParamSpec__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_delegate_get_property", 4, pspec, "GParamSpec*");
  return(s7_make_boolean(sc, gtk_editable_delegate_get_property((GObject*)s7_c_pointer(object), (guint)s7_integer(prop_id), (GValue*)s7_c_pointer(value), (GParamSpec*)s7_c_pointer(pspec))));
}

static s7_pointer lg_gtk_fixed_get_child_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_get_child_position "void gtk_fixed_get_child_position(GtkFixed* fixed, GtkWidget* widget, \
gint* [x], gint* [y])"
  s7_pointer _p;
  s7_pointer fixed, widget;
  gint ref_x;
  gint ref_y;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_get_child_position", 1, fixed, "GtkFixed*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_get_child_position", 2, widget, "GtkWidget*");
  gtk_fixed_get_child_position((GtkFixed*)s7_c_pointer(fixed), (GtkWidget*)s7_c_pointer(widget), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_x), s7_make_integer(sc, ref_y)));
}

static s7_pointer lg_gtk_fixed_set_child_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_set_child_transform "void gtk_fixed_set_child_transform(GtkFixed* fixed, GtkWidget* widget, \
GskTransform* transform)"
  s7_pointer _p;
  s7_pointer fixed, widget, transform;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_set_child_transform", 1, fixed, "GtkFixed*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_set_child_transform", 2, widget, "GtkWidget*");
  transform = s7_car(_p);
  if (!s7_is_c_pointer_of_type(transform, GskTransform__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_set_child_transform", 3, transform, "GskTransform*");
  gtk_fixed_set_child_transform((GtkFixed*)s7_c_pointer(fixed), (GtkWidget*)s7_c_pointer(widget), (GskTransform*)s7_c_pointer(transform));
  return(lg_false);
}

static s7_pointer lg_gtk_fixed_get_child_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_get_child_transform "GskTransform* gtk_fixed_get_child_transform(GtkFixed* fixed, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer fixed, widget;
  _p = args;
  fixed = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(fixed, GtkFixed__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_get_child_transform", 1, fixed, "GtkFixed*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_get_child_transform", 2, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GskTransform__sym, gtk_fixed_get_child_transform((GtkFixed*)s7_c_pointer(fixed), (GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_grid_query_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_query_child "void gtk_grid_query_child(GtkGrid* grid, GtkWidget* child, gint* [left], \
gint* [top], gint* [width], gint* [height])"
  s7_pointer _p;
  s7_pointer grid, child;
  gint ref_left;
  gint ref_top;
  gint ref_width;
  gint ref_height;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGrid__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_query_child", 1, grid, "GtkGrid*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_query_child", 2, child, "GtkWidget*");
  gtk_grid_query_child((GtkGrid*)s7_c_pointer(grid), (GtkWidget*)s7_c_pointer(child), &ref_left, &ref_top, &ref_width, &ref_height);
    return(s7_list(sc, 4, s7_make_integer(sc, ref_left), s7_make_integer(sc, ref_top), s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_list_box_set_show_separators(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_set_show_separators "void gtk_list_box_set_show_separators(GtkListBox* box, \
gboolean show_separators)"
  s7_pointer _p;
  s7_pointer box, show_separators;
  _p = args;
  box = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_show_separators", 1, box, "GtkListBox*");
  show_separators = s7_car(_p);
  if (!s7_is_boolean(show_separators)) s7_wrong_type_arg_error(sc, "gtk_list_box_set_show_separators", 2, show_separators, "gboolean");
  gtk_list_box_set_show_separators((GtkListBox*)s7_c_pointer(box), (gboolean)lg_boolean(show_separators));
  return(lg_false);
}

static s7_pointer lg_gtk_list_box_get_show_separators(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_list_box_get_show_separators "gboolean gtk_list_box_get_show_separators(GtkListBox* box)"
  s7_pointer box;
  box = s7_car(args);
  if (!s7_is_c_pointer_of_type(box, GtkListBox__sym)) s7_wrong_type_arg_error(sc, "gtk_list_box_get_show_separators", 1, box, "GtkListBox*");
  return(s7_make_boolean(sc, gtk_list_box_get_show_separators((GtkListBox*)s7_c_pointer(box))));
}

static s7_pointer lg_gtk_notebook_get_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_page "GtkNotebookPage* gtk_notebook_get_page(GtkNotebook* notebook, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer notebook, child;
  _p = args;
  notebook = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_page", 1, notebook, "GtkNotebook*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_page", 2, child, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkNotebookPage__sym, gtk_notebook_get_page((GtkNotebook*)s7_c_pointer(notebook), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_notebook_page_get_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_page_get_child "GtkWidget* gtk_notebook_page_get_child(GtkNotebookPage* page)"
  s7_pointer page;
  page = s7_car(args);
  if (!s7_is_c_pointer_of_type(page, GtkNotebookPage__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_page_get_child", 1, page, "GtkNotebookPage*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_notebook_page_get_child((GtkNotebookPage*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_notebook_get_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_notebook_get_pages "GListModel* gtk_notebook_get_pages(GtkNotebook* notebook)"
  s7_pointer notebook;
  notebook = s7_car(args);
  if (!s7_is_c_pointer_of_type(notebook, GtkNotebook__sym)) s7_wrong_type_arg_error(sc, "gtk_notebook_get_pages", 1, notebook, "GtkNotebook*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_notebook_get_pages((GtkNotebook*)s7_c_pointer(notebook))));
}

static s7_pointer lg_gtk_stack_get_page(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_page "GtkStackPage* gtk_stack_get_page(GtkStack* stack, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer stack, child;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_page", 1, stack, "GtkStack*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_page", 2, child, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkStackPage__sym, gtk_stack_get_page((GtkStack*)s7_c_pointer(stack), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_stack_page_get_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_page_get_child "GtkWidget* gtk_stack_page_get_child(GtkStackPage* page)"
  s7_pointer page;
  page = s7_car(args);
  if (!s7_is_c_pointer_of_type(page, GtkStackPage__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_page_get_child", 1, page, "GtkStackPage*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_stack_page_get_child((GtkStackPage*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_stack_get_pages(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_get_pages "GtkSelectionModel* gtk_stack_get_pages(GtkStack* stack)"
  s7_pointer stack;
  stack = s7_car(args);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_get_pages", 1, stack, "GtkStack*");
  return(lg_make_c_pointer_with_type(sc, GtkSelectionModel__sym, gtk_stack_get_pages((GtkStack*)s7_c_pointer(stack))));
}

static s7_pointer lg_gtk_widget_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_allocate "void gtk_widget_allocate(GtkWidget* widget, int width, int height, int baseline, \
GskTransform* transform)"
  s7_pointer _p;
  s7_pointer widget, width, height, baseline, transform;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_allocate", 1, widget, "GtkWidget*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_widget_allocate", 2, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_widget_allocate", 3, height, "int");
  baseline = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(baseline)) s7_wrong_type_arg_error(sc, "gtk_widget_allocate", 4, baseline, "int");
  transform = s7_car(_p);
  if (!s7_is_c_pointer_of_type(transform, GskTransform__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_allocate", 5, transform, "GskTransform*");
  gtk_widget_allocate((GtkWidget*)s7_c_pointer(widget), (int)s7_integer(width), (int)s7_integer(height), (int)s7_integer(baseline), (GskTransform*)s7_c_pointer(transform));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_layout_manager(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_layout_manager "void gtk_widget_set_layout_manager(GtkWidget* widget, GtkLayoutManager* layout_manager)"
  s7_pointer _p;
  s7_pointer widget, layout_manager;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_layout_manager", 1, widget, "GtkWidget*");
  layout_manager = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout_manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_layout_manager", 2, layout_manager, "GtkLayoutManager*");
  gtk_widget_set_layout_manager((GtkWidget*)s7_c_pointer(widget), (GtkLayoutManager*)s7_c_pointer(layout_manager));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_layout_manager(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_layout_manager "GtkLayoutManager* gtk_widget_get_layout_manager(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_layout_manager", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_widget_get_layout_manager((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_class_set_layout_manager_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_class_set_layout_manager_type "void gtk_widget_class_set_layout_manager_type(GtkWidgetClass* widget_class, \
GType type)"
  s7_pointer _p;
  s7_pointer widget_class, type;
  _p = args;
  widget_class = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget_class, GtkWidgetClass__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_set_layout_manager_type", 1, widget_class, "GtkWidgetClass*");
  type = s7_car(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_widget_class_set_layout_manager_type", 2, type, "GType");
  gtk_widget_class_set_layout_manager_type((GtkWidgetClass*)s7_c_pointer(widget_class), (GType)s7_integer(type));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_set_can_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_can_target "void gtk_widget_set_can_target(GtkWidget* widget, gboolean can_target)"
  s7_pointer _p;
  s7_pointer widget, can_target;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_target", 1, widget, "GtkWidget*");
  can_target = s7_car(_p);
  if (!s7_is_boolean(can_target)) s7_wrong_type_arg_error(sc, "gtk_widget_set_can_target", 2, can_target, "gboolean");
  gtk_widget_set_can_target((GtkWidget*)s7_c_pointer(widget), (gboolean)lg_boolean(can_target));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_can_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_can_target "gboolean gtk_widget_get_can_target(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_can_target", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_get_can_target((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_root(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_root "GtkRoot* gtk_widget_get_root(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_root", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkRoot__sym, gtk_widget_get_root((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_compute_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_compute_transform "gboolean gtk_widget_compute_transform(GtkWidget* widget, GtkWidget* target, \
graphene_matrix_t* out_transform)"
  s7_pointer _p;
  s7_pointer widget, target, out_transform;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_transform", 1, widget, "GtkWidget*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_transform", 2, target, "GtkWidget*");
  out_transform = s7_car(_p);
  if (!s7_is_c_pointer_of_type(out_transform, graphene_matrix_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_transform", 3, out_transform, "graphene_matrix_t*");
  return(s7_make_boolean(sc, gtk_widget_compute_transform((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(target), (graphene_matrix_t*)s7_c_pointer(out_transform))));
}

static s7_pointer lg_gtk_widget_compute_point(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_compute_point "gboolean gtk_widget_compute_point(GtkWidget* widget, GtkWidget* target, \
graphene_point_t* point, graphene_point_t* out_point)"
  s7_pointer _p;
  s7_pointer widget, target, point, out_point;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_point", 1, widget, "GtkWidget*");
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_point", 2, target, "GtkWidget*");
  point = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(point, graphene_point_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_point", 3, point, "graphene_point_t*");
  out_point = s7_car(_p);
  if (!s7_is_c_pointer_of_type(out_point, graphene_point_t__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_compute_point", 4, out_point, "graphene_point_t*");
  return(s7_make_boolean(sc, gtk_widget_compute_point((GtkWidget*)s7_c_pointer(widget), (GtkWidget*)s7_c_pointer(target), (graphene_point_t*)s7_c_pointer(point), (graphene_point_t*)s7_c_pointer(out_point))));
}

static s7_pointer lg_gtk_widget_set_overflow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_overflow "void gtk_widget_set_overflow(GtkWidget* widget, GtkOverflow overflow)"
  s7_pointer _p;
  s7_pointer widget, overflow;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_overflow", 1, widget, "GtkWidget*");
  overflow = s7_car(_p);
  if (!s7_is_integer(overflow)) s7_wrong_type_arg_error(sc, "gtk_widget_set_overflow", 2, overflow, "GtkOverflow");
  gtk_widget_set_overflow((GtkWidget*)s7_c_pointer(widget), (GtkOverflow)s7_integer(overflow));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_get_overflow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_overflow "GtkOverflow gtk_widget_get_overflow(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_overflow", 1, widget, "GtkWidget*");
  return(s7_make_integer(sc, gtk_widget_get_overflow((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_pick(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_pick "GtkWidget* gtk_widget_pick(GtkWidget* widget, gdouble x, gdouble y, GtkPickFlags flags)"
  s7_pointer _p;
  s7_pointer widget, x, y, flags;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_pick", 1, widget, "GtkWidget*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "gtk_widget_pick", 2, x, "gdouble");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "gtk_widget_pick", 3, y, "gdouble");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_widget_pick", 4, flags, "GtkPickFlags");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_pick((GtkWidget*)s7_c_pointer(widget), (gdouble)s7_real(x), (gdouble)s7_real(y), (GtkPickFlags)s7_integer(flags))));
}

static s7_pointer lg_gtk_widget_activate_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_activate_default "void gtk_widget_activate_default(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_default", 1, widget, "GtkWidget*");
  gtk_widget_activate_default((GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_observe_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_observe_children "GListModel* gtk_widget_observe_children(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_observe_children", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_widget_observe_children((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_observe_controllers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_observe_controllers "GListModel* gtk_widget_observe_controllers(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_observe_controllers", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_widget_observe_controllers((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_focus_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_focus_child "GtkWidget* gtk_widget_get_focus_child(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_focus_child", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_widget_get_focus_child((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_window_set_default_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_set_default_widget "void gtk_window_set_default_widget(GtkWindow* window, GtkWidget* default_widget)"
  s7_pointer _p;
  s7_pointer window, default_widget;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_widget", 1, window, "GtkWindow*");
  default_widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(default_widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_window_set_default_widget", 2, default_widget, "GtkWidget*");
  gtk_window_set_default_widget((GtkWindow*)s7_c_pointer(window), (GtkWidget*)s7_c_pointer(default_widget));
  return(lg_false);
}

static s7_pointer lg_gtk_window_get_toplevels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_get_toplevels "GListModel* gtk_window_get_toplevels( void)"
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_window_get_toplevels()));
}

static s7_pointer lg_gdk_drag_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_display "GdkDisplay* gdk_drag_get_display(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_display", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_drag_get_display((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_device "GdkDevice* gdk_drag_get_device(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_device", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gdk_drag_get_device((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_get_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_formats "GdkContentFormats* gdk_drag_get_formats(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_formats", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gdk_drag_get_formats((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_get_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_actions "GdkDragAction gdk_drag_get_actions(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_actions", 1, drag, "GdkDrag*");
  return(s7_make_integer(sc, gdk_drag_get_actions((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_get_selected_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_selected_action "GdkDragAction gdk_drag_get_selected_action(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_selected_action", 1, drag, "GdkDrag*");
  return(s7_make_integer(sc, gdk_drag_get_selected_action((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_action_is_unique(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_action_is_unique "gboolean gdk_drag_action_is_unique(GdkDragAction action)"
  s7_pointer action;
  action = s7_car(args);
  if (!s7_is_integer(action)) s7_wrong_type_arg_error(sc, "gdk_drag_action_is_unique", 1, action, "GdkDragAction");
  return(s7_make_boolean(sc, gdk_drag_action_is_unique((GdkDragAction)s7_integer(action))));
}

static s7_pointer lg_gdk_drag_begin(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_begin "GdkDrag* gdk_drag_begin(GdkSurface* surface, GdkDevice* device, GdkContentProvider* content, \
GdkDragAction actions, gint dx, gint dy)"
  s7_pointer _p;
  s7_pointer surface, device, content, actions, dx, dy;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 1, surface, "GdkSurface*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 2, device, "GdkDevice*");
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(content, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 3, content, "GdkContentProvider*");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 4, actions, "GdkDragAction");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dx)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 5, dx, "gint");
  dy = s7_car(_p);
  if (!s7_is_integer(dy)) s7_wrong_type_arg_error(sc, "gdk_drag_begin", 6, dy, "gint");
  return(lg_make_c_pointer_with_type(sc, GdkDrag__sym, gdk_drag_begin((GdkSurface*)s7_c_pointer(surface), (GdkDevice*)s7_c_pointer(device), (GdkContentProvider*)s7_c_pointer(content), (GdkDragAction)s7_integer(actions), (gint)s7_integer(dx), (gint)s7_integer(dy))));
}

static s7_pointer lg_gdk_drag_drop_done(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_drop_done "void gdk_drag_drop_done(GdkDrag* drag, gboolean success)"
  s7_pointer _p;
  s7_pointer drag, success;
  _p = args;
  drag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_drop_done", 1, drag, "GdkDrag*");
  success = s7_car(_p);
  if (!s7_is_boolean(success)) s7_wrong_type_arg_error(sc, "gdk_drag_drop_done", 2, success, "gboolean");
  gdk_drag_drop_done((GdkDrag*)s7_c_pointer(drag), (gboolean)lg_boolean(success));
  return(lg_false);
}

static s7_pointer lg_gdk_drag_get_drag_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_drag_surface "GdkSurface* gdk_drag_get_drag_surface(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_drag_surface", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_drag_get_drag_surface((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_set_hotspot(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_set_hotspot "void gdk_drag_set_hotspot(GdkDrag* drag, gint hot_x, gint hot_y)"
  s7_pointer _p;
  s7_pointer drag, hot_x, hot_y;
  _p = args;
  drag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_set_hotspot", 1, drag, "GdkDrag*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gdk_drag_set_hotspot", 2, hot_x, "gint");
  hot_y = s7_car(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gdk_drag_set_hotspot", 3, hot_y, "gint");
  gdk_drag_set_hotspot((GdkDrag*)s7_c_pointer(drag), (gint)s7_integer(hot_x), (gint)s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_bin_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_bin_layout_new "GtkLayoutManager* gtk_bin_layout_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_bin_layout_new()));
}

static s7_pointer lg_gtk_box_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_new "GtkLayoutManager* gtk_box_layout_new(GtkOrientation orientation)"
  s7_pointer orientation;
  orientation = s7_car(args);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_box_layout_new", 1, orientation, "GtkOrientation");
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_box_layout_new((GtkOrientation)s7_integer(orientation))));
}

static s7_pointer lg_gtk_box_layout_set_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_set_homogeneous "void gtk_box_layout_set_homogeneous(GtkBoxLayout* box_layout, \
gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer box_layout, homogeneous;
  _p = args;
  box_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box_layout, GtkBoxLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_box_layout_set_homogeneous", 1, box_layout, "GtkBoxLayout*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_box_layout_set_homogeneous", 2, homogeneous, "gboolean");
  gtk_box_layout_set_homogeneous((GtkBoxLayout*)s7_c_pointer(box_layout), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_box_layout_get_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_get_homogeneous "gboolean gtk_box_layout_get_homogeneous(GtkBoxLayout* box_layout)"
  s7_pointer box_layout;
  box_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(box_layout, GtkBoxLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_box_layout_get_homogeneous", 1, box_layout, "GtkBoxLayout*");
  return(s7_make_boolean(sc, gtk_box_layout_get_homogeneous((GtkBoxLayout*)s7_c_pointer(box_layout))));
}

static s7_pointer lg_gtk_box_layout_set_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_set_spacing "void gtk_box_layout_set_spacing(GtkBoxLayout* box_layout, guint spacing)"
  s7_pointer _p;
  s7_pointer box_layout, spacing;
  _p = args;
  box_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box_layout, GtkBoxLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_box_layout_set_spacing", 1, box_layout, "GtkBoxLayout*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_box_layout_set_spacing", 2, spacing, "guint");
  gtk_box_layout_set_spacing((GtkBoxLayout*)s7_c_pointer(box_layout), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_box_layout_get_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_get_spacing "guint gtk_box_layout_get_spacing(GtkBoxLayout* box_layout)"
  s7_pointer box_layout;
  box_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(box_layout, GtkBoxLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_box_layout_get_spacing", 1, box_layout, "GtkBoxLayout*");
  return(s7_make_integer(sc, gtk_box_layout_get_spacing((GtkBoxLayout*)s7_c_pointer(box_layout))));
}

static s7_pointer lg_gtk_box_layout_set_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_set_baseline_position "void gtk_box_layout_set_baseline_position(GtkBoxLayout* box_layout, \
GtkBaselinePosition position)"
  s7_pointer _p;
  s7_pointer box_layout, position;
  _p = args;
  box_layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(box_layout, GtkBoxLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_box_layout_set_baseline_position", 1, box_layout, "GtkBoxLayout*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_box_layout_set_baseline_position", 2, position, "GtkBaselinePosition");
  gtk_box_layout_set_baseline_position((GtkBoxLayout*)s7_c_pointer(box_layout), (GtkBaselinePosition)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_box_layout_get_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_box_layout_get_baseline_position "GtkBaselinePosition gtk_box_layout_get_baseline_position(GtkBoxLayout* box_layout)"
  s7_pointer box_layout;
  box_layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(box_layout, GtkBoxLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_box_layout_get_baseline_position", 1, box_layout, "GtkBoxLayout*");
  return(s7_make_integer(sc, gtk_box_layout_get_baseline_position((GtkBoxLayout*)s7_c_pointer(box_layout))));
}

static s7_pointer lg_gtk_custom_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_custom_layout_new "GtkLayoutManager* gtk_custom_layout_new(GtkCustomRequestModeFunc request_mode, \
GtkCustomMeasureFunc measure, GtkCustomAllocateFunc allocate)"
  s7_pointer _p;
  s7_pointer request_mode, measure, allocate;
  _p = args;
  request_mode = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(request_mode, GtkCustomRequestModeFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_custom_layout_new", 1, request_mode, "GtkCustomRequestModeFunc");
  measure = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(measure, GtkCustomMeasureFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_custom_layout_new", 2, measure, "GtkCustomMeasureFunc");
  allocate = s7_car(_p);
  if (!s7_is_c_pointer_of_type(allocate, GtkCustomAllocateFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_custom_layout_new", 3, allocate, "GtkCustomAllocateFunc");
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_custom_layout_new((GtkCustomRequestModeFunc)s7_c_pointer(request_mode), (GtkCustomMeasureFunc)s7_c_pointer(measure), (GtkCustomAllocateFunc)s7_c_pointer(allocate))));
}

static s7_pointer lg_gtk_event_controller_legacy_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_legacy_new "GtkEventController* gtk_event_controller_legacy_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_event_controller_legacy_new()));
}

static s7_pointer lg_gtk_filter_list_model_new_for_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_filter_list_model_new_for_type "GtkFilterListModel* gtk_filter_list_model_new_for_type(GType item_type)"
  s7_pointer item_type;
  item_type = s7_car(args);
  if (!s7_is_integer(item_type)) s7_wrong_type_arg_error(sc, "gtk_filter_list_model_new_for_type", 1, item_type, "GType");
  return(lg_make_c_pointer_with_type(sc, GtkFilterListModel__sym, gtk_filter_list_model_new_for_type((GType)s7_integer(item_type))));
}

static s7_pointer lg_gtk_filter_list_model_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_filter_list_model_set_model "void gtk_filter_list_model_set_model(GtkFilterListModel* self, \
GListModel* model)"
  s7_pointer _p;
  s7_pointer self, model;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkFilterListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_filter_list_model_set_model", 1, self, "GtkFilterListModel*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_filter_list_model_set_model", 2, model, "GListModel*");
  gtk_filter_list_model_set_model((GtkFilterListModel*)s7_c_pointer(self), (GListModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_filter_list_model_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_filter_list_model_get_model "GListModel* gtk_filter_list_model_get_model(GtkFilterListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkFilterListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_filter_list_model_get_model", 1, self, "GtkFilterListModel*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_filter_list_model_get_model((GtkFilterListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_filter_list_model_has_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_filter_list_model_has_filter "gboolean gtk_filter_list_model_has_filter(GtkFilterListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkFilterListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_filter_list_model_has_filter", 1, self, "GtkFilterListModel*");
  return(s7_make_boolean(sc, gtk_filter_list_model_has_filter((GtkFilterListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_filter_list_model_refilter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_filter_list_model_refilter "void gtk_filter_list_model_refilter(GtkFilterListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkFilterListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_filter_list_model_refilter", 1, self, "GtkFilterListModel*");
  gtk_filter_list_model_refilter((GtkFilterListModel*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_fixed_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_layout_new "GtkLayoutManager* gtk_fixed_layout_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_fixed_layout_new()));
}

static s7_pointer lg_gtk_flatten_list_model_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flatten_list_model_new "GtkFlattenListModel* gtk_flatten_list_model_new(GType item_type, \
GListModel* model)"
  s7_pointer _p;
  s7_pointer item_type, model;
  _p = args;
  item_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(item_type)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_new", 1, item_type, "GType");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_new", 2, model, "GListModel*");
  return(lg_make_c_pointer_with_type(sc, GtkFlattenListModel__sym, gtk_flatten_list_model_new((GType)s7_integer(item_type), (GListModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_flatten_list_model_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flatten_list_model_set_model "void gtk_flatten_list_model_set_model(GtkFlattenListModel* self, \
GListModel* model)"
  s7_pointer _p;
  s7_pointer self, model;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkFlattenListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_set_model", 1, self, "GtkFlattenListModel*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_set_model", 2, model, "GListModel*");
  gtk_flatten_list_model_set_model((GtkFlattenListModel*)s7_c_pointer(self), (GListModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_flatten_list_model_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flatten_list_model_get_model "GListModel* gtk_flatten_list_model_get_model(GtkFlattenListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkFlattenListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_get_model", 1, self, "GtkFlattenListModel*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_flatten_list_model_get_model((GtkFlattenListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_grid_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_new "GtkLayoutManager* gtk_grid_layout_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_grid_layout_new()));
}

static s7_pointer lg_gtk_grid_layout_set_row_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_set_row_homogeneous "void gtk_grid_layout_set_row_homogeneous(GtkGridLayout* grid, \
gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer grid, homogeneous;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_homogeneous", 1, grid, "GtkGridLayout*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_homogeneous", 2, homogeneous, "gboolean");
  gtk_grid_layout_set_row_homogeneous((GtkGridLayout*)s7_c_pointer(grid), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_get_row_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_get_row_homogeneous "gboolean gtk_grid_layout_get_row_homogeneous(GtkGridLayout* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_row_homogeneous", 1, grid, "GtkGridLayout*");
  return(s7_make_boolean(sc, gtk_grid_layout_get_row_homogeneous((GtkGridLayout*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_layout_set_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_set_row_spacing "void gtk_grid_layout_set_row_spacing(GtkGridLayout* grid, \
guint spacing)"
  s7_pointer _p;
  s7_pointer grid, spacing;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_spacing", 1, grid, "GtkGridLayout*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_spacing", 2, spacing, "guint");
  gtk_grid_layout_set_row_spacing((GtkGridLayout*)s7_c_pointer(grid), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_get_row_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_get_row_spacing "guint gtk_grid_layout_get_row_spacing(GtkGridLayout* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_row_spacing", 1, grid, "GtkGridLayout*");
  return(s7_make_integer(sc, gtk_grid_layout_get_row_spacing((GtkGridLayout*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_layout_set_column_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_set_column_homogeneous "void gtk_grid_layout_set_column_homogeneous(GtkGridLayout* grid, \
gboolean homogeneous)"
  s7_pointer _p;
  s7_pointer grid, homogeneous;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_column_homogeneous", 1, grid, "GtkGridLayout*");
  homogeneous = s7_car(_p);
  if (!s7_is_boolean(homogeneous)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_column_homogeneous", 2, homogeneous, "gboolean");
  gtk_grid_layout_set_column_homogeneous((GtkGridLayout*)s7_c_pointer(grid), (gboolean)lg_boolean(homogeneous));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_get_column_homogeneous(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_get_column_homogeneous "gboolean gtk_grid_layout_get_column_homogeneous(GtkGridLayout* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_column_homogeneous", 1, grid, "GtkGridLayout*");
  return(s7_make_boolean(sc, gtk_grid_layout_get_column_homogeneous((GtkGridLayout*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_layout_set_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_set_column_spacing "void gtk_grid_layout_set_column_spacing(GtkGridLayout* grid, \
guint spacing)"
  s7_pointer _p;
  s7_pointer grid, spacing;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_column_spacing", 1, grid, "GtkGridLayout*");
  spacing = s7_car(_p);
  if (!s7_is_integer(spacing)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_column_spacing", 2, spacing, "guint");
  gtk_grid_layout_set_column_spacing((GtkGridLayout*)s7_c_pointer(grid), (guint)s7_integer(spacing));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_get_column_spacing(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_get_column_spacing "guint gtk_grid_layout_get_column_spacing(GtkGridLayout* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_column_spacing", 1, grid, "GtkGridLayout*");
  return(s7_make_integer(sc, gtk_grid_layout_get_column_spacing((GtkGridLayout*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_layout_set_row_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_set_row_baseline_position "void gtk_grid_layout_set_row_baseline_position(GtkGridLayout* grid, \
int row, GtkBaselinePosition pos)"
  s7_pointer _p;
  s7_pointer grid, row, pos;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_baseline_position", 1, grid, "GtkGridLayout*");
  row = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_baseline_position", 2, row, "int");
  pos = s7_car(_p);
  if (!s7_is_integer(pos)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_row_baseline_position", 3, pos, "GtkBaselinePosition");
  gtk_grid_layout_set_row_baseline_position((GtkGridLayout*)s7_c_pointer(grid), (int)s7_integer(row), (GtkBaselinePosition)s7_integer(pos));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_get_row_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_get_row_baseline_position "GtkBaselinePosition gtk_grid_layout_get_row_baseline_position(GtkGridLayout* grid, \
int row)"
  s7_pointer _p;
  s7_pointer grid, row;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_row_baseline_position", 1, grid, "GtkGridLayout*");
  row = s7_car(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_row_baseline_position", 2, row, "int");
  return(s7_make_integer(sc, gtk_grid_layout_get_row_baseline_position((GtkGridLayout*)s7_c_pointer(grid), (int)s7_integer(row))));
}

static s7_pointer lg_gtk_grid_layout_set_baseline_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_set_baseline_row "void gtk_grid_layout_set_baseline_row(GtkGridLayout* grid, \
int row)"
  s7_pointer _p;
  s7_pointer grid, row;
  _p = args;
  grid = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_baseline_row", 1, grid, "GtkGridLayout*");
  row = s7_car(_p);
  if (!s7_is_integer(row)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_set_baseline_row", 2, row, "int");
  gtk_grid_layout_set_baseline_row((GtkGridLayout*)s7_c_pointer(grid), (int)s7_integer(row));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_get_baseline_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_get_baseline_row "int gtk_grid_layout_get_baseline_row(GtkGridLayout* grid)"
  s7_pointer grid;
  grid = s7_car(args);
  if (!s7_is_c_pointer_of_type(grid, GtkGridLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_get_baseline_row", 1, grid, "GtkGridLayout*");
  return(s7_make_integer(sc, gtk_grid_layout_get_baseline_row((GtkGridLayout*)s7_c_pointer(grid))));
}

static s7_pointer lg_gtk_grid_layout_child_set_top_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_set_top_attach "void gtk_grid_layout_child_set_top_attach(GtkGridLayoutChild* child, \
int attach)"
  s7_pointer _p;
  s7_pointer child, attach;
  _p = args;
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_top_attach", 1, child, "GtkGridLayoutChild*");
  attach = s7_car(_p);
  if (!s7_is_integer(attach)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_top_attach", 2, attach, "int");
  gtk_grid_layout_child_set_top_attach((GtkGridLayoutChild*)s7_c_pointer(child), (int)s7_integer(attach));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_child_get_top_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_get_top_attach "int gtk_grid_layout_child_get_top_attach(GtkGridLayoutChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_get_top_attach", 1, child, "GtkGridLayoutChild*");
  return(s7_make_integer(sc, gtk_grid_layout_child_get_top_attach((GtkGridLayoutChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_grid_layout_child_set_left_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_set_left_attach "void gtk_grid_layout_child_set_left_attach(GtkGridLayoutChild* child, \
int attach)"
  s7_pointer _p;
  s7_pointer child, attach;
  _p = args;
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_left_attach", 1, child, "GtkGridLayoutChild*");
  attach = s7_car(_p);
  if (!s7_is_integer(attach)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_left_attach", 2, attach, "int");
  gtk_grid_layout_child_set_left_attach((GtkGridLayoutChild*)s7_c_pointer(child), (int)s7_integer(attach));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_child_get_left_attach(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_get_left_attach "int gtk_grid_layout_child_get_left_attach(GtkGridLayoutChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_get_left_attach", 1, child, "GtkGridLayoutChild*");
  return(s7_make_integer(sc, gtk_grid_layout_child_get_left_attach((GtkGridLayoutChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_grid_layout_child_set_column_span(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_set_column_span "void gtk_grid_layout_child_set_column_span(GtkGridLayoutChild* child, \
int span)"
  s7_pointer _p;
  s7_pointer child, span;
  _p = args;
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_column_span", 1, child, "GtkGridLayoutChild*");
  span = s7_car(_p);
  if (!s7_is_integer(span)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_column_span", 2, span, "int");
  gtk_grid_layout_child_set_column_span((GtkGridLayoutChild*)s7_c_pointer(child), (int)s7_integer(span));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_child_get_column_span(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_get_column_span "int gtk_grid_layout_child_get_column_span(GtkGridLayoutChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_get_column_span", 1, child, "GtkGridLayoutChild*");
  return(s7_make_integer(sc, gtk_grid_layout_child_get_column_span((GtkGridLayoutChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_grid_layout_child_set_row_span(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_set_row_span "void gtk_grid_layout_child_set_row_span(GtkGridLayoutChild* child, \
int span)"
  s7_pointer _p;
  s7_pointer child, span;
  _p = args;
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_row_span", 1, child, "GtkGridLayoutChild*");
  span = s7_car(_p);
  if (!s7_is_integer(span)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_set_row_span", 2, span, "int");
  gtk_grid_layout_child_set_row_span((GtkGridLayoutChild*)s7_c_pointer(child), (int)s7_integer(span));
  return(lg_false);
}

static s7_pointer lg_gtk_grid_layout_child_get_row_span(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_grid_layout_child_get_row_span "int gtk_grid_layout_child_get_row_span(GtkGridLayoutChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkGridLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_grid_layout_child_get_row_span", 1, child, "GtkGridLayoutChild*");
  return(s7_make_integer(sc, gtk_grid_layout_child_get_row_span((GtkGridLayoutChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_layout_child_get_layout_manager(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_child_get_layout_manager "GtkLayoutManager* gtk_layout_child_get_layout_manager(GtkLayoutChild* layout_child)"
  s7_pointer layout_child;
  layout_child = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout_child, GtkLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_child_get_layout_manager", 1, layout_child, "GtkLayoutChild*");
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_layout_child_get_layout_manager((GtkLayoutChild*)s7_c_pointer(layout_child))));
}

static s7_pointer lg_gtk_layout_child_get_child_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_child_get_child_widget "GtkWidget* gtk_layout_child_get_child_widget(GtkLayoutChild* layout_child)"
  s7_pointer layout_child;
  layout_child = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout_child, GtkLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_child_get_child_widget", 1, layout_child, "GtkLayoutChild*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_layout_child_get_child_widget((GtkLayoutChild*)s7_c_pointer(layout_child))));
}

static s7_pointer lg_gtk_layout_manager_measure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_manager_measure "void gtk_layout_manager_measure(GtkLayoutManager* manager, GtkWidget* widget, \
GtkOrientation orientation, int for_size, int* minimum, int* natural, int* minimum_baseline, int* natural_baseline)"
  s7_pointer _p;
  s7_pointer manager, widget, orientation, for_size, minimum, natural, minimum_baseline, natural_baseline;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 1, manager, "GtkLayoutManager*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 2, widget, "GtkWidget*");
  orientation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 3, orientation, "GtkOrientation");
  for_size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(for_size)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 4, for_size, "int");
  minimum = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(minimum, int__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 5, minimum, "int*");
  natural = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(natural, int__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 6, natural, "int*");
  minimum_baseline = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(minimum_baseline, int__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 7, minimum_baseline, "int*");
  natural_baseline = s7_car(_p);
  if (!s7_is_c_pointer_of_type(natural_baseline, int__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_measure", 8, natural_baseline, "int*");
  gtk_layout_manager_measure((GtkLayoutManager*)s7_c_pointer(manager), (GtkWidget*)s7_c_pointer(widget), (GtkOrientation)s7_integer(orientation), (int)s7_integer(for_size), (int*)s7_c_pointer(minimum), (int*)s7_c_pointer(natural), (int*)s7_c_pointer(minimum_baseline), (int*)s7_c_pointer(natural_baseline));
  return(lg_false);
}

static s7_pointer lg_gtk_layout_manager_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_manager_allocate "void gtk_layout_manager_allocate(GtkLayoutManager* manager, \
GtkWidget* widget, int width, int height, int baseline)"
  s7_pointer _p;
  s7_pointer manager, widget, width, height, baseline;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_allocate", 1, manager, "GtkLayoutManager*");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_allocate", 2, widget, "GtkWidget*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_allocate", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_allocate", 4, height, "int");
  baseline = s7_car(_p);
  if (!s7_is_integer(baseline)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_allocate", 5, baseline, "int");
  gtk_layout_manager_allocate((GtkLayoutManager*)s7_c_pointer(manager), (GtkWidget*)s7_c_pointer(widget), (int)s7_integer(width), (int)s7_integer(height), (int)s7_integer(baseline));
  return(lg_false);
}

static s7_pointer lg_gtk_layout_manager_get_request_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_manager_get_request_mode "GtkSizeRequestMode gtk_layout_manager_get_request_mode(GtkLayoutManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_get_request_mode", 1, manager, "GtkLayoutManager*");
  return(s7_make_integer(sc, gtk_layout_manager_get_request_mode((GtkLayoutManager*)s7_c_pointer(manager))));
}

static s7_pointer lg_gtk_layout_manager_get_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_manager_get_widget "GtkWidget* gtk_layout_manager_get_widget(GtkLayoutManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_get_widget", 1, manager, "GtkLayoutManager*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_layout_manager_get_widget((GtkLayoutManager*)s7_c_pointer(manager))));
}

static s7_pointer lg_gtk_layout_manager_layout_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_manager_layout_changed "void gtk_layout_manager_layout_changed(GtkLayoutManager* manager)"
  s7_pointer manager;
  manager = s7_car(args);
  if (!s7_is_c_pointer_of_type(manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_layout_changed", 1, manager, "GtkLayoutManager*");
  gtk_layout_manager_layout_changed((GtkLayoutManager*)s7_c_pointer(manager));
  return(lg_false);
}

static s7_pointer lg_gtk_layout_manager_get_layout_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_layout_manager_get_layout_child "GtkLayoutChild* gtk_layout_manager_get_layout_child(GtkLayoutManager* manager, \
GtkWidget* child)"
  s7_pointer _p;
  s7_pointer manager, child;
  _p = args;
  manager = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(manager, GtkLayoutManager__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_get_layout_child", 1, manager, "GtkLayoutManager*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_layout_manager_get_layout_child", 2, child, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkLayoutChild__sym, gtk_layout_manager_get_layout_child((GtkLayoutManager*)s7_c_pointer(manager), (GtkWidget*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_map_list_model_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_map_list_model_set_model "void gtk_map_list_model_set_model(GtkMapListModel* self, GListModel* model)"
  s7_pointer _p;
  s7_pointer self, model;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkMapListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_map_list_model_set_model", 1, self, "GtkMapListModel*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_map_list_model_set_model", 2, model, "GListModel*");
  gtk_map_list_model_set_model((GtkMapListModel*)s7_c_pointer(self), (GListModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_map_list_model_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_map_list_model_get_model "GListModel* gtk_map_list_model_get_model(GtkMapListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMapListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_map_list_model_get_model", 1, self, "GtkMapListModel*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_map_list_model_get_model((GtkMapListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_map_list_model_has_map(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_map_list_model_has_map "gboolean gtk_map_list_model_has_map(GtkMapListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMapListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_map_list_model_has_map", 1, self, "GtkMapListModel*");
  return(s7_make_boolean(sc, gtk_map_list_model_has_map((GtkMapListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_password_entry_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_password_entry_new "GtkWidget* gtk_password_entry_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_password_entry_new()));
}

static s7_pointer lg_gtk_password_entry_set_show_peek_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_password_entry_set_show_peek_icon "void gtk_password_entry_set_show_peek_icon(GtkPasswordEntry* entry, \
gboolean show_peek_icon)"
  s7_pointer _p;
  s7_pointer entry, show_peek_icon;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkPasswordEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_password_entry_set_show_peek_icon", 1, entry, "GtkPasswordEntry*");
  show_peek_icon = s7_car(_p);
  if (!s7_is_boolean(show_peek_icon)) s7_wrong_type_arg_error(sc, "gtk_password_entry_set_show_peek_icon", 2, show_peek_icon, "gboolean");
  gtk_password_entry_set_show_peek_icon((GtkPasswordEntry*)s7_c_pointer(entry), (gboolean)lg_boolean(show_peek_icon));
  return(lg_false);
}

static s7_pointer lg_gtk_password_entry_get_show_peek_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_password_entry_get_show_peek_icon "gboolean gtk_password_entry_get_show_peek_icon(GtkPasswordEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkPasswordEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_password_entry_get_show_peek_icon", 1, entry, "GtkPasswordEntry*");
  return(s7_make_boolean(sc, gtk_password_entry_get_show_peek_icon((GtkPasswordEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_root_set_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_root_set_focus "void gtk_root_set_focus(GtkRoot* self, GtkWidget* focus)"
  s7_pointer _p;
  s7_pointer self, focus;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkRoot__sym)) s7_wrong_type_arg_error(sc, "gtk_root_set_focus", 1, self, "GtkRoot*");
  focus = s7_car(_p);
  if (!s7_is_c_pointer_of_type(focus, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_root_set_focus", 2, focus, "GtkWidget*");
  gtk_root_set_focus((GtkRoot*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(focus));
  return(lg_false);
}

static s7_pointer lg_gtk_root_get_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_root_get_focus "GtkWidget* gtk_root_get_focus(GtkRoot* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkRoot__sym)) s7_wrong_type_arg_error(sc, "gtk_root_get_focus", 1, self, "GtkRoot*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_root_get_focus((GtkRoot*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_selection_model_is_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_is_selected "gboolean gtk_selection_model_is_selected(GtkSelectionModel* model, \
guint position)"
  s7_pointer _p;
  s7_pointer model, position;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_is_selected", 1, model, "GtkSelectionModel*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_is_selected", 2, position, "guint");
  return(s7_make_boolean(sc, gtk_selection_model_is_selected((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position))));
}

static s7_pointer lg_gtk_selection_model_select_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_select_item "gboolean gtk_selection_model_select_item(GtkSelectionModel* model, \
guint position, gboolean exclusive)"
  s7_pointer _p;
  s7_pointer model, position, exclusive;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_item", 1, model, "GtkSelectionModel*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_item", 2, position, "guint");
  exclusive = s7_car(_p);
  if (!s7_is_boolean(exclusive)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_item", 3, exclusive, "gboolean");
  return(s7_make_boolean(sc, gtk_selection_model_select_item((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position), (gboolean)lg_boolean(exclusive))));
}

static s7_pointer lg_gtk_selection_model_unselect_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_unselect_item "gboolean gtk_selection_model_unselect_item(GtkSelectionModel* model, \
guint position)"
  s7_pointer _p;
  s7_pointer model, position;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_unselect_item", 1, model, "GtkSelectionModel*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_unselect_item", 2, position, "guint");
  return(s7_make_boolean(sc, gtk_selection_model_unselect_item((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position))));
}

static s7_pointer lg_gtk_selection_model_select_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_select_range "gboolean gtk_selection_model_select_range(GtkSelectionModel* model, \
guint position, guint n_items, gboolean exclusive)"
  s7_pointer _p;
  s7_pointer model, position, n_items, exclusive;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_range", 1, model, "GtkSelectionModel*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_range", 2, position, "guint");
  n_items = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_items)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_range", 3, n_items, "guint");
  exclusive = s7_car(_p);
  if (!s7_is_boolean(exclusive)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_range", 4, exclusive, "gboolean");
  return(s7_make_boolean(sc, gtk_selection_model_select_range((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position), (guint)s7_integer(n_items), (gboolean)lg_boolean(exclusive))));
}

static s7_pointer lg_gtk_selection_model_unselect_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_unselect_range "gboolean gtk_selection_model_unselect_range(GtkSelectionModel* model, \
guint position, guint n_items)"
  s7_pointer _p;
  s7_pointer model, position, n_items;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_unselect_range", 1, model, "GtkSelectionModel*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_unselect_range", 2, position, "guint");
  n_items = s7_car(_p);
  if (!s7_is_integer(n_items)) s7_wrong_type_arg_error(sc, "gtk_selection_model_unselect_range", 3, n_items, "guint");
  return(s7_make_boolean(sc, gtk_selection_model_unselect_range((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position), (guint)s7_integer(n_items))));
}

static s7_pointer lg_gtk_selection_model_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_select_all "gboolean gtk_selection_model_select_all(GtkSelectionModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_select_all", 1, model, "GtkSelectionModel*");
  return(s7_make_boolean(sc, gtk_selection_model_select_all((GtkSelectionModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_selection_model_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_unselect_all "gboolean gtk_selection_model_unselect_all(GtkSelectionModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_unselect_all", 1, model, "GtkSelectionModel*");
  return(s7_make_boolean(sc, gtk_selection_model_unselect_all((GtkSelectionModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_selection_model_query_range(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_query_range "void gtk_selection_model_query_range(GtkSelectionModel* model, \
guint position, guint* [start_range], guint* [n_items], gboolean* [selected])"
  s7_pointer _p;
  s7_pointer model, position;
  guint ref_start_range;
  guint ref_n_items;
  gboolean ref_selected;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_query_range", 1, model, "GtkSelectionModel*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_query_range", 2, position, "guint");
  gtk_selection_model_query_range((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position), &ref_start_range, &ref_n_items, &ref_selected);
    return(s7_list(sc, 3, s7_make_integer(sc, ref_start_range), s7_make_integer(sc, ref_n_items), s7_make_boolean(sc, ref_selected)));
}

static s7_pointer lg_gtk_selection_model_selection_changed(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_selection_model_selection_changed "void gtk_selection_model_selection_changed(GtkSelectionModel* model, \
guint position, guint n_items)"
  s7_pointer _p;
  s7_pointer model, position, n_items;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GtkSelectionModel__sym)) s7_wrong_type_arg_error(sc, "gtk_selection_model_selection_changed", 1, model, "GtkSelectionModel*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_selection_model_selection_changed", 2, position, "guint");
  n_items = s7_car(_p);
  if (!s7_is_integer(n_items)) s7_wrong_type_arg_error(sc, "gtk_selection_model_selection_changed", 3, n_items, "guint");
  gtk_selection_model_selection_changed((GtkSelectionModel*)s7_c_pointer(model), (guint)s7_integer(position), (guint)s7_integer(n_items));
  return(lg_false);
}

static s7_pointer lg_gtk_single_selection_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_new "GtkSingleSelection* gtk_single_selection_new(GListModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_new", 1, model, "GListModel*");
  return(lg_make_c_pointer_with_type(sc, GtkSingleSelection__sym, gtk_single_selection_new((GListModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_single_selection_get_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_get_selected "guint gtk_single_selection_get_selected(GtkSingleSelection* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_get_selected", 1, self, "GtkSingleSelection*");
  return(s7_make_integer(sc, gtk_single_selection_get_selected((GtkSingleSelection*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_single_selection_set_selected(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_set_selected "void gtk_single_selection_set_selected(GtkSingleSelection* self, \
guint position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_set_selected", 1, self, "GtkSingleSelection*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_single_selection_set_selected", 2, position, "guint");
  gtk_single_selection_set_selected((GtkSingleSelection*)s7_c_pointer(self), (guint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_single_selection_get_selected_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_get_selected_item "gpointer gtk_single_selection_get_selected_item(GtkSingleSelection* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_get_selected_item", 1, self, "GtkSingleSelection*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gtk_single_selection_get_selected_item((GtkSingleSelection*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_single_selection_get_autoselect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_get_autoselect "gboolean gtk_single_selection_get_autoselect(GtkSingleSelection* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_get_autoselect", 1, self, "GtkSingleSelection*");
  return(s7_make_boolean(sc, gtk_single_selection_get_autoselect((GtkSingleSelection*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_single_selection_set_autoselect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_set_autoselect "void gtk_single_selection_set_autoselect(GtkSingleSelection* self, \
gboolean autoselect)"
  s7_pointer _p;
  s7_pointer self, autoselect;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_set_autoselect", 1, self, "GtkSingleSelection*");
  autoselect = s7_car(_p);
  if (!s7_is_boolean(autoselect)) s7_wrong_type_arg_error(sc, "gtk_single_selection_set_autoselect", 2, autoselect, "gboolean");
  gtk_single_selection_set_autoselect((GtkSingleSelection*)s7_c_pointer(self), (gboolean)lg_boolean(autoselect));
  return(lg_false);
}

static s7_pointer lg_gtk_single_selection_get_can_unselect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_get_can_unselect "gboolean gtk_single_selection_get_can_unselect(GtkSingleSelection* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_get_can_unselect", 1, self, "GtkSingleSelection*");
  return(s7_make_boolean(sc, gtk_single_selection_get_can_unselect((GtkSingleSelection*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_single_selection_set_can_unselect(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_set_can_unselect "void gtk_single_selection_set_can_unselect(GtkSingleSelection* self, \
gboolean can_unselect)"
  s7_pointer _p;
  s7_pointer self, can_unselect;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_set_can_unselect", 1, self, "GtkSingleSelection*");
  can_unselect = s7_car(_p);
  if (!s7_is_boolean(can_unselect)) s7_wrong_type_arg_error(sc, "gtk_single_selection_set_can_unselect", 2, can_unselect, "gboolean");
  gtk_single_selection_set_can_unselect((GtkSingleSelection*)s7_c_pointer(self), (gboolean)lg_boolean(can_unselect));
  return(lg_false);
}

static s7_pointer lg_gtk_slice_list_model_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_new "GtkSliceListModel* gtk_slice_list_model_new(GListModel* model, \
guint offset, guint size)"
  s7_pointer _p;
  s7_pointer model, offset, size;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_new", 1, model, "GListModel*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(offset)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_new", 2, offset, "guint");
  size = s7_car(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_new", 3, size, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkSliceListModel__sym, gtk_slice_list_model_new((GListModel*)s7_c_pointer(model), (guint)s7_integer(offset), (guint)s7_integer(size))));
}

static s7_pointer lg_gtk_slice_list_model_new_for_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_new_for_type "GtkSliceListModel* gtk_slice_list_model_new_for_type(GType item_type)"
  s7_pointer item_type;
  item_type = s7_car(args);
  if (!s7_is_integer(item_type)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_new_for_type", 1, item_type, "GType");
  return(lg_make_c_pointer_with_type(sc, GtkSliceListModel__sym, gtk_slice_list_model_new_for_type((GType)s7_integer(item_type))));
}

static s7_pointer lg_gtk_slice_list_model_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_set_model "void gtk_slice_list_model_set_model(GtkSliceListModel* self, \
GListModel* model)"
  s7_pointer _p;
  s7_pointer self, model;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSliceListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_set_model", 1, self, "GtkSliceListModel*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_set_model", 2, model, "GListModel*");
  gtk_slice_list_model_set_model((GtkSliceListModel*)s7_c_pointer(self), (GListModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_slice_list_model_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_get_model "GListModel* gtk_slice_list_model_get_model(GtkSliceListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSliceListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_get_model", 1, self, "GtkSliceListModel*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_slice_list_model_get_model((GtkSliceListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_slice_list_model_set_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_set_offset "void gtk_slice_list_model_set_offset(GtkSliceListModel* self, \
guint offset)"
  s7_pointer _p;
  s7_pointer self, offset;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSliceListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_set_offset", 1, self, "GtkSliceListModel*");
  offset = s7_car(_p);
  if (!s7_is_integer(offset)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_set_offset", 2, offset, "guint");
  gtk_slice_list_model_set_offset((GtkSliceListModel*)s7_c_pointer(self), (guint)s7_integer(offset));
  return(lg_false);
}

static s7_pointer lg_gtk_slice_list_model_get_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_get_offset "guint gtk_slice_list_model_get_offset(GtkSliceListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSliceListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_get_offset", 1, self, "GtkSliceListModel*");
  return(s7_make_integer(sc, gtk_slice_list_model_get_offset((GtkSliceListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_slice_list_model_set_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_set_size "void gtk_slice_list_model_set_size(GtkSliceListModel* self, \
guint size)"
  s7_pointer _p;
  s7_pointer self, size;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSliceListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_set_size", 1, self, "GtkSliceListModel*");
  size = s7_car(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_set_size", 2, size, "guint");
  gtk_slice_list_model_set_size((GtkSliceListModel*)s7_c_pointer(self), (guint)s7_integer(size));
  return(lg_false);
}

static s7_pointer lg_gtk_slice_list_model_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_slice_list_model_get_size "guint gtk_slice_list_model_get_size(GtkSliceListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSliceListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_slice_list_model_get_size", 1, self, "GtkSliceListModel*");
  return(s7_make_integer(sc, gtk_slice_list_model_get_size((GtkSliceListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_sort_list_model_new_for_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_sort_list_model_new_for_type "GtkSortListModel* gtk_sort_list_model_new_for_type(GType item_type)"
  s7_pointer item_type;
  item_type = s7_car(args);
  if (!s7_is_integer(item_type)) s7_wrong_type_arg_error(sc, "gtk_sort_list_model_new_for_type", 1, item_type, "GType");
  return(lg_make_c_pointer_with_type(sc, GtkSortListModel__sym, gtk_sort_list_model_new_for_type((GType)s7_integer(item_type))));
}

static s7_pointer lg_gtk_sort_list_model_has_sort(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_sort_list_model_has_sort "gboolean gtk_sort_list_model_has_sort(GtkSortListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSortListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_sort_list_model_has_sort", 1, self, "GtkSortListModel*");
  return(s7_make_boolean(sc, gtk_sort_list_model_has_sort((GtkSortListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_sort_list_model_set_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_sort_list_model_set_model "void gtk_sort_list_model_set_model(GtkSortListModel* self, \
GListModel* model)"
  s7_pointer _p;
  s7_pointer self, model;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkSortListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_sort_list_model_set_model", 1, self, "GtkSortListModel*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_sort_list_model_set_model", 2, model, "GListModel*");
  gtk_sort_list_model_set_model((GtkSortListModel*)s7_c_pointer(self), (GListModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_sort_list_model_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_sort_list_model_get_model "GListModel* gtk_sort_list_model_get_model(GtkSortListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSortListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_sort_list_model_get_model", 1, self, "GtkSortListModel*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_sort_list_model_get_model((GtkSortListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_sort_list_model_resort(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_sort_list_model_resort "void gtk_sort_list_model_resort(GtkSortListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSortListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_sort_list_model_resort", 1, self, "GtkSortListModel*");
  gtk_sort_list_model_resort((GtkSortListModel*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_text_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_new "GtkWidget* gtk_text_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_text_new()));
}

static s7_pointer lg_gtk_text_new_with_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_new_with_buffer "GtkWidget* gtk_text_new_with_buffer(GtkEntryBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_new_with_buffer", 1, buffer, "GtkEntryBuffer*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_text_new_with_buffer((GtkEntryBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_get_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_buffer "GtkEntryBuffer* gtk_text_get_buffer(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_buffer", 1, self, "GtkText*");
  return(lg_make_c_pointer_with_type(sc, GtkEntryBuffer__sym, gtk_text_get_buffer((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_buffer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_buffer "void gtk_text_set_buffer(GtkText* self, GtkEntryBuffer* buffer)"
  s7_pointer _p;
  s7_pointer self, buffer;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_buffer", 1, self, "GtkText*");
  buffer = s7_car(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkEntryBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_buffer", 2, buffer, "GtkEntryBuffer*");
  gtk_text_set_buffer((GtkText*)s7_c_pointer(self), (GtkEntryBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_set_visibility(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_visibility "void gtk_text_set_visibility(GtkText* self, gboolean visible)"
  s7_pointer _p;
  s7_pointer self, visible;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_visibility", 1, self, "GtkText*");
  visible = s7_car(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_text_set_visibility", 2, visible, "gboolean");
  gtk_text_set_visibility((GtkText*)s7_c_pointer(self), (gboolean)lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_visibility(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_visibility "gboolean gtk_text_get_visibility(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_visibility", 1, self, "GtkText*");
  return(s7_make_boolean(sc, gtk_text_get_visibility((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_invisible_char "void gtk_text_set_invisible_char(GtkText* self, gunichar ch)"
  s7_pointer _p;
  s7_pointer self, ch;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_invisible_char", 1, self, "GtkText*");
  ch = s7_car(_p);
  if (!s7_is_integer(ch)) s7_wrong_type_arg_error(sc, "gtk_text_set_invisible_char", 2, ch, "gunichar");
  gtk_text_set_invisible_char((GtkText*)s7_c_pointer(self), (gunichar)s7_integer(ch));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_invisible_char "gunichar gtk_text_get_invisible_char(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_invisible_char", 1, self, "GtkText*");
  return(s7_make_integer(sc, gtk_text_get_invisible_char((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_unset_invisible_char(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_unset_invisible_char "void gtk_text_unset_invisible_char(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_unset_invisible_char", 1, self, "GtkText*");
  gtk_text_unset_invisible_char((GtkText*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_text_set_overwrite_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_overwrite_mode "void gtk_text_set_overwrite_mode(GtkText* self, gboolean overwrite)"
  s7_pointer _p;
  s7_pointer self, overwrite;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_overwrite_mode", 1, self, "GtkText*");
  overwrite = s7_car(_p);
  if (!s7_is_boolean(overwrite)) s7_wrong_type_arg_error(sc, "gtk_text_set_overwrite_mode", 2, overwrite, "gboolean");
  gtk_text_set_overwrite_mode((GtkText*)s7_c_pointer(self), (gboolean)lg_boolean(overwrite));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_overwrite_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_overwrite_mode "gboolean gtk_text_get_overwrite_mode(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_overwrite_mode", 1, self, "GtkText*");
  return(s7_make_boolean(sc, gtk_text_get_overwrite_mode((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_max_length "void gtk_text_set_max_length(GtkText* self, int length)"
  s7_pointer _p;
  s7_pointer self, length;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_max_length", 1, self, "GtkText*");
  length = s7_car(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "gtk_text_set_max_length", 2, length, "int");
  gtk_text_set_max_length((GtkText*)s7_c_pointer(self), (int)s7_integer(length));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_max_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_max_length "gint gtk_text_get_max_length(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_max_length", 1, self, "GtkText*");
  return(s7_make_integer(sc, gtk_text_get_max_length((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_get_text_length(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_text_length "guint16 gtk_text_get_text_length(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_text_length", 1, self, "GtkText*");
  return(s7_make_integer(sc, gtk_text_get_text_length((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_activates_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_activates_default "void gtk_text_set_activates_default(GtkText* self, gboolean activates)"
  s7_pointer _p;
  s7_pointer self, activates;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_activates_default", 1, self, "GtkText*");
  activates = s7_car(_p);
  if (!s7_is_boolean(activates)) s7_wrong_type_arg_error(sc, "gtk_text_set_activates_default", 2, activates, "gboolean");
  gtk_text_set_activates_default((GtkText*)s7_c_pointer(self), (gboolean)lg_boolean(activates));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_activates_default(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_activates_default "gboolean gtk_text_get_activates_default(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_activates_default", 1, self, "GtkText*");
  return(s7_make_boolean(sc, gtk_text_get_activates_default((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_get_placeholder_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_placeholder_text "char* gtk_text_get_placeholder_text(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_placeholder_text", 1, self, "GtkText*");
  return(s7_make_string(sc, gtk_text_get_placeholder_text((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_placeholder_text(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_placeholder_text "void gtk_text_set_placeholder_text(GtkText* self, char* text)"
  s7_pointer _p;
  s7_pointer self, text;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_placeholder_text", 1, self, "GtkText*");
  text = s7_car(_p);
  if (!s7_is_string(text)) s7_wrong_type_arg_error(sc, "gtk_text_set_placeholder_text", 2, text, "char*");
  gtk_text_set_placeholder_text((GtkText*)s7_c_pointer(self), (char*)s7_string(text));
  return(lg_false);
}

static s7_pointer lg_gtk_text_set_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_input_purpose "void gtk_text_set_input_purpose(GtkText* self, GtkInputPurpose purpose)"
  s7_pointer _p;
  s7_pointer self, purpose;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_input_purpose", 1, self, "GtkText*");
  purpose = s7_car(_p);
  if (!s7_is_integer(purpose)) s7_wrong_type_arg_error(sc, "gtk_text_set_input_purpose", 2, purpose, "GtkInputPurpose");
  gtk_text_set_input_purpose((GtkText*)s7_c_pointer(self), (GtkInputPurpose)s7_integer(purpose));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_input_purpose(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_input_purpose "GtkInputPurpose gtk_text_get_input_purpose(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_input_purpose", 1, self, "GtkText*");
  return(s7_make_integer(sc, gtk_text_get_input_purpose((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_input_hints "void gtk_text_set_input_hints(GtkText* self, GtkInputHints hints)"
  s7_pointer _p;
  s7_pointer self, hints;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_input_hints", 1, self, "GtkText*");
  hints = s7_car(_p);
  if (!s7_is_integer(hints)) s7_wrong_type_arg_error(sc, "gtk_text_set_input_hints", 2, hints, "GtkInputHints");
  gtk_text_set_input_hints((GtkText*)s7_c_pointer(self), (GtkInputHints)s7_integer(hints));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_input_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_input_hints "GtkInputHints gtk_text_get_input_hints(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_input_hints", 1, self, "GtkText*");
  return(s7_make_integer(sc, gtk_text_get_input_hints((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_attributes "void gtk_text_set_attributes(GtkText* self, PangoAttrList* attrs)"
  s7_pointer _p;
  s7_pointer self, attrs;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_attributes", 1, self, "GtkText*");
  attrs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(attrs, PangoAttrList__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_attributes", 2, attrs, "PangoAttrList*");
  gtk_text_set_attributes((GtkText*)s7_c_pointer(self), (PangoAttrList*)s7_c_pointer(attrs));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_attributes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_attributes "PangoAttrList* gtk_text_get_attributes(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_attributes", 1, self, "GtkText*");
  return(lg_make_c_pointer_with_type(sc, PangoAttrList__sym, gtk_text_get_attributes((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_tabs "void gtk_text_set_tabs(GtkText* self, PangoTabArray* tabs)"
  s7_pointer _p;
  s7_pointer self, tabs;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_tabs", 1, self, "GtkText*");
  tabs = s7_car(_p);
  if (!s7_is_c_pointer_of_type(tabs, PangoTabArray__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_tabs", 2, tabs, "PangoTabArray*");
  gtk_text_set_tabs((GtkText*)s7_c_pointer(self), (PangoTabArray*)s7_c_pointer(tabs));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_tabs(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_tabs "PangoTabArray* gtk_text_get_tabs(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_tabs", 1, self, "GtkText*");
  return(lg_make_c_pointer_with_type(sc, PangoTabArray__sym, gtk_text_get_tabs((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_model_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_model_get_model "GListModel* gtk_tree_list_model_get_model(GtkTreeListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_model", 1, self, "GtkTreeListModel*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_tree_list_model_get_model((GtkTreeListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_model_get_passthrough(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_model_get_passthrough "gboolean gtk_tree_list_model_get_passthrough(GtkTreeListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_passthrough", 1, self, "GtkTreeListModel*");
  return(s7_make_boolean(sc, gtk_tree_list_model_get_passthrough((GtkTreeListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_model_set_autoexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_model_set_autoexpand "void gtk_tree_list_model_set_autoexpand(GtkTreeListModel* self, \
gboolean autoexpand)"
  s7_pointer _p;
  s7_pointer self, autoexpand;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_set_autoexpand", 1, self, "GtkTreeListModel*");
  autoexpand = s7_car(_p);
  if (!s7_is_boolean(autoexpand)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_set_autoexpand", 2, autoexpand, "gboolean");
  gtk_tree_list_model_set_autoexpand((GtkTreeListModel*)s7_c_pointer(self), (gboolean)lg_boolean(autoexpand));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_list_model_get_autoexpand(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_model_get_autoexpand "gboolean gtk_tree_list_model_get_autoexpand(GtkTreeListModel* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_autoexpand", 1, self, "GtkTreeListModel*");
  return(s7_make_boolean(sc, gtk_tree_list_model_get_autoexpand((GtkTreeListModel*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_model_get_child_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_model_get_child_row "GtkTreeListRow* gtk_tree_list_model_get_child_row(GtkTreeListModel* self, \
guint position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_child_row", 1, self, "GtkTreeListModel*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_child_row", 2, position, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkTreeListRow__sym, gtk_tree_list_model_get_child_row((GtkTreeListModel*)s7_c_pointer(self), (guint)s7_integer(position))));
}

static s7_pointer lg_gtk_tree_list_model_get_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_model_get_row "GtkTreeListRow* gtk_tree_list_model_get_row(GtkTreeListModel* self, \
guint position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_row", 1, self, "GtkTreeListModel*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_list_model_get_row", 2, position, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkTreeListRow__sym, gtk_tree_list_model_get_row((GtkTreeListModel*)s7_c_pointer(self), (guint)s7_integer(position))));
}

static s7_pointer lg_gtk_tree_list_row_get_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_item "gpointer gtk_tree_list_row_get_item(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_item", 1, self, "GtkTreeListRow*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, gtk_tree_list_row_get_item((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_set_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_set_expanded "void gtk_tree_list_row_set_expanded(GtkTreeListRow* self, \
gboolean expanded)"
  s7_pointer _p;
  s7_pointer self, expanded;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_set_expanded", 1, self, "GtkTreeListRow*");
  expanded = s7_car(_p);
  if (!s7_is_boolean(expanded)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_set_expanded", 2, expanded, "gboolean");
  gtk_tree_list_row_set_expanded((GtkTreeListRow*)s7_c_pointer(self), (gboolean)lg_boolean(expanded));
  return(lg_false);
}

static s7_pointer lg_gtk_tree_list_row_get_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_expanded "gboolean gtk_tree_list_row_get_expanded(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_expanded", 1, self, "GtkTreeListRow*");
  return(s7_make_boolean(sc, gtk_tree_list_row_get_expanded((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_is_expandable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_is_expandable "gboolean gtk_tree_list_row_is_expandable(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_is_expandable", 1, self, "GtkTreeListRow*");
  return(s7_make_boolean(sc, gtk_tree_list_row_is_expandable((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_position "guint gtk_tree_list_row_get_position(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_position", 1, self, "GtkTreeListRow*");
  return(s7_make_integer(sc, gtk_tree_list_row_get_position((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_get_depth(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_depth "guint gtk_tree_list_row_get_depth(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_depth", 1, self, "GtkTreeListRow*");
  return(s7_make_integer(sc, gtk_tree_list_row_get_depth((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_get_children(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_children "GListModel* gtk_tree_list_row_get_children(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_children", 1, self, "GtkTreeListRow*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_tree_list_row_get_children((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_get_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_parent "GtkTreeListRow* gtk_tree_list_row_get_parent(GtkTreeListRow* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_parent", 1, self, "GtkTreeListRow*");
  return(lg_make_c_pointer_with_type(sc, GtkTreeListRow__sym, gtk_tree_list_row_get_parent((GtkTreeListRow*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_tree_list_row_get_child_row(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_list_row_get_child_row "GtkTreeListRow* gtk_tree_list_row_get_child_row(GtkTreeListRow* self, \
guint position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkTreeListRow__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_child_row", 1, self, "GtkTreeListRow*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_tree_list_row_get_child_row", 2, position, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkTreeListRow__sym, gtk_tree_list_row_get_child_row((GtkTreeListRow*)s7_c_pointer(self), (guint)s7_integer(position))));
}

static s7_pointer lg_gdk_clipboard_read_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_clipboard_read_finish "GInputStream* gdk_clipboard_read_finish(GdkClipboard* clip, GAsyncResult* result, \
char** out_mime_type, GError** [error])"
  s7_pointer _p;
  s7_pointer clip, result, out_mime_type;
  GError* ref_error = NULL;
  _p = args;
  clip = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clip, GdkClipboard__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_finish", 1, clip, "GdkClipboard*");
  result = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_finish", 2, result, "GAsyncResult*");
  out_mime_type = s7_car(_p);
  if (!s7_is_c_pointer_of_type(out_mime_type, char___sym)) s7_wrong_type_arg_error(sc, "gdk_clipboard_read_finish", 3, out_mime_type, "char**");
  {
    s7_pointer res_ult;
    res_ult = lg_make_c_pointer_with_type(sc, GInputStream__sym, gdk_clipboard_read_finish((GdkClipboard*)s7_c_pointer(clip), (GAsyncResult*)s7_c_pointer(result), (const char**)s7_c_pointer(out_mime_type), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

#endif

#if GTK_CHECK_VERSION(3, 98, 0)
static s7_pointer lg_gtk_window_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_new "GtkWidget* gtk_window_new(GtkWindowType void)"
  s7_pointer void;
  void = s7_car(args);
  if (!s7_is_integer(void)) s7_wrong_type_arg_error(sc, "gtk_window_new", 1, void, "GtkWindowType");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_window_new((GtkWindowType)s7_integer(void))));
}

static s7_pointer lg_gtk_window_activate_key(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_activate_key "gboolean gtk_window_activate_key(GtkWindow* window, GdkEvent* event)"
  s7_pointer _p;
  s7_pointer window, event;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_activate_key", 1, window, "GtkWindow*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_window_activate_key", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_window_activate_key((GtkWindow*)s7_c_pointer(window), (GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_window_propagate_key_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_propagate_key_event "gboolean gtk_window_propagate_key_event(GtkWindow* window, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer window, event;
  _p = args;
  window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_propagate_key_event", 1, window, "GtkWindow*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_window_propagate_key_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_window_propagate_key_event((GtkWindow*)s7_c_pointer(window), (GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_text_iter_get_paintable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_iter_get_paintable "GdkTexture* gtk_text_iter_get_paintable(GtkTextIter* iter)"
  s7_pointer iter;
  iter = s7_car(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_iter_get_paintable", 1, iter, "GtkTextIter*");
  return(lg_make_c_pointer_with_type(sc, GdkTexture__sym, gtk_text_iter_get_paintable((GtkTextIter*)s7_c_pointer(iter))));
}

static s7_pointer lg_gtk_tree_view_column_cell_get_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_view_column_cell_get_size "void gtk_tree_view_column_cell_get_size(GtkTreeViewColumn* tree_column, \
GdkRectangle* cell_area, int* [x_offset], int* [y_offset], int* [width], int* [height])"
  s7_pointer _p;
  s7_pointer tree_column, cell_area;
  int ref_x_offset;
  int ref_y_offset;
  int ref_width;
  int ref_height;
  _p = args;
  tree_column = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_column, GtkTreeViewColumn__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_size", 1, tree_column, "GtkTreeViewColumn*");
  cell_area = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cell_area, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_view_column_cell_get_size", 2, cell_area, "GdkRectangle*");
  gtk_tree_view_column_cell_get_size((GtkTreeViewColumn*)s7_c_pointer(tree_column), (GdkRectangle*)s7_c_pointer(cell_area), &ref_x_offset, &ref_y_offset, &ref_width, &ref_height);
    return(s7_list(sc, 4, s7_make_integer(sc, ref_x_offset), s7_make_integer(sc, ref_y_offset), s7_make_integer(sc, ref_width), s7_make_integer(sc, ref_height)));
}

static s7_pointer lg_gtk_entry_set_icon_drag_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_icon_drag_source "void gtk_entry_set_icon_drag_source(GtkEntry* entry, GtkEntryIconPosition icon_pos, \
GdkContentProvider* provider, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer entry, icon_pos, provider, actions;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 1, entry, "GtkEntry*");
  icon_pos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(icon_pos)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 2, icon_pos, "GtkEntryIconPosition");
  provider = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(provider, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 3, provider, "GdkContentProvider*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_entry_set_icon_drag_source", 4, actions, "GdkDragAction");
  gtk_entry_set_icon_drag_source((GtkEntry*)s7_c_pointer(entry), (GtkEntryIconPosition)s7_integer(icon_pos), (GdkContentProvider*)s7_c_pointer(provider), (GdkDragAction)s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_grab_focus_without_selecting(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_grab_focus_without_selecting "gboolean gtk_entry_grab_focus_without_selecting(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_grab_focus_without_selecting", 1, entry, "GtkEntry*");
  return(s7_make_boolean(sc, gtk_entry_grab_focus_without_selecting((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_event_controller_handle_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_handle_event "gboolean gtk_event_controller_handle_event(GtkEventController* controller, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer controller, event;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_handle_event", 1, controller, "GtkEventController*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_handle_event", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gtk_event_controller_handle_event((GtkEventController*)s7_c_pointer(controller), (GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gtk_stack_add_named(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_add_named "GtkStackPage* gtk_stack_add_named(GtkStack* stack, GtkWidget* child, \
gchar* name)"
  s7_pointer _p;
  s7_pointer stack, child, name;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_named", 1, stack, "GtkStack*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_named", 2, child, "GtkWidget*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_add_named", 3, name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkStackPage__sym, gtk_stack_add_named((GtkStack*)s7_c_pointer(stack), (GtkWidget*)s7_c_pointer(child), (const gchar*)s7_string(name))));
}

static s7_pointer lg_gtk_stack_add_titled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_add_titled "GtkStackPage* gtk_stack_add_titled(GtkStack* stack, GtkWidget* child, \
gchar* name, gchar* title)"
  s7_pointer _p;
  s7_pointer stack, child, name, title;
  _p = args;
  stack = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(stack, GtkStack__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 1, stack, "GtkStack*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 2, child, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 3, name, "gchar*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gtk_stack_add_titled", 4, title, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GtkStackPage__sym, gtk_stack_add_titled((GtkStack*)s7_c_pointer(stack), (GtkWidget*)s7_c_pointer(child), (const gchar*)s7_string(name), (const gchar*)s7_string(title))));
}

static s7_pointer lg_gtk_widget_grab_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_grab_focus "gboolean gtk_widget_grab_focus(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_grab_focus", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_grab_focus((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_insert_action_group(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_insert_action_group "void gtk_widget_insert_action_group(GtkWidget* widget, gchar* name, \
GActionGroup* group)"
  s7_pointer _p;
  s7_pointer widget, name, group;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_action_group", 1, widget, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_action_group", 2, name, "gchar*");
  group = s7_car(_p);
  if (!s7_is_c_pointer_of_type(group, GActionGroup__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_insert_action_group", 3, group, "GActionGroup*");
  gtk_widget_insert_action_group((GtkWidget*)s7_c_pointer(widget), (const gchar*)s7_string(name), (GActionGroup*)s7_c_pointer(group));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_insert_paintable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_insert_paintable "void gtk_text_buffer_insert_paintable(GtkTextBuffer* buffer, \
GtkTextIter* iter, GdkPaintable* paintable)"
  s7_pointer _p;
  s7_pointer buffer, iter, paintable;
  _p = args;
  buffer = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_paintable", 1, buffer, "GtkTextBuffer*");
  iter = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_paintable", 2, iter, "GtkTextIter*");
  paintable = s7_car(_p);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_insert_paintable", 3, paintable, "GdkPaintable*");
  gtk_text_buffer_insert_paintable((GtkTextBuffer*)s7_c_pointer(buffer), (GtkTextIter*)s7_c_pointer(iter), (GdkPaintable*)s7_c_pointer(paintable));
  return(lg_false);
}

static s7_pointer lg_gtk_label_set_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_wrap "void gtk_label_set_wrap(GtkLabel* label, gboolean wrap)"
  s7_pointer _p;
  s7_pointer label, wrap;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_wrap", 1, label, "GtkLabel*");
  wrap = s7_car(_p);
  if (!s7_is_boolean(wrap)) s7_wrong_type_arg_error(sc, "gtk_label_set_wrap", 2, wrap, "gboolean");
  gtk_label_set_wrap((GtkLabel*)s7_c_pointer(label), (gboolean)lg_boolean(wrap));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_wrap(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_wrap "gboolean gtk_label_get_wrap(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_wrap", 1, label, "GtkLabel*");
  return(s7_make_boolean(sc, gtk_label_get_wrap((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_label_set_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_wrap_mode "void gtk_label_set_wrap_mode(GtkLabel* label, PangoWrapMode wrap_mode)"
  s7_pointer _p;
  s7_pointer label, wrap_mode;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_wrap_mode", 1, label, "GtkLabel*");
  wrap_mode = s7_car(_p);
  if (!s7_is_integer(wrap_mode)) s7_wrong_type_arg_error(sc, "gtk_label_set_wrap_mode", 2, wrap_mode, "PangoWrapMode");
  gtk_label_set_wrap_mode((GtkLabel*)s7_c_pointer(label), (PangoWrapMode)s7_integer(wrap_mode));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_wrap_mode(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_wrap_mode "PangoWrapMode gtk_label_get_wrap_mode(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_wrap_mode", 1, label, "GtkLabel*");
  return(s7_make_integer(sc, gtk_label_get_wrap_mode((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_gtk_tree_drag_dest_drag_data_received(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_dest_drag_data_received "gboolean gtk_tree_drag_dest_drag_data_received(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest, GValue* value)"
  s7_pointer _p;
  s7_pointer drag_dest, dest, value;
  _p = args;
  drag_dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_dest, GtkTreeDragDest__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_drag_data_received", 1, drag_dest, "GtkTreeDragDest*");
  dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_drag_data_received", 2, dest, "GtkTreePath*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_drag_data_received", 3, value, "GValue*");
  return(s7_make_boolean(sc, gtk_tree_drag_dest_drag_data_received((GtkTreeDragDest*)s7_c_pointer(drag_dest), (GtkTreePath*)s7_c_pointer(dest), (const GValue*)s7_c_pointer(value))));
}

static s7_pointer lg_gtk_tree_drag_dest_row_drop_possible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_drag_dest_row_drop_possible "gboolean gtk_tree_drag_dest_row_drop_possible(GtkTreeDragDest* drag_dest, \
GtkTreePath* dest_path, GValue* value)"
  s7_pointer _p;
  s7_pointer drag_dest, dest_path, value;
  _p = args;
  drag_dest = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_dest, GtkTreeDragDest__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_row_drop_possible", 1, drag_dest, "GtkTreeDragDest*");
  dest_path = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dest_path, GtkTreePath__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_row_drop_possible", 2, dest_path, "GtkTreePath*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_drag_dest_row_drop_possible", 3, value, "GValue*");
  return(s7_make_boolean(sc, gtk_tree_drag_dest_row_drop_possible((GtkTreeDragDest*)s7_c_pointer(drag_dest), (GtkTreePath*)s7_c_pointer(dest_path), (const GValue*)s7_c_pointer(value))));
}

static s7_pointer lg_gtk_fixed_layout_child_set_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_layout_child_set_transform "void gtk_fixed_layout_child_set_transform(GtkFixedLayoutChild* child, \
GskTransform* transform)"
  s7_pointer _p;
  s7_pointer child, transform;
  _p = args;
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkFixedLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_layout_child_set_transform", 1, child, "GtkFixedLayoutChild*");
  transform = s7_car(_p);
  if (!s7_is_c_pointer_of_type(transform, GskTransform__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_layout_child_set_transform", 2, transform, "GskTransform*");
  gtk_fixed_layout_child_set_transform((GtkFixedLayoutChild*)s7_c_pointer(child), (GskTransform*)s7_c_pointer(transform));
  return(lg_false);
}

static s7_pointer lg_gtk_fixed_layout_child_get_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_fixed_layout_child_get_transform "GskTransform* gtk_fixed_layout_child_get_transform(GtkFixedLayoutChild* child)"
  s7_pointer child;
  child = s7_car(args);
  if (!s7_is_c_pointer_of_type(child, GtkFixedLayoutChild__sym)) s7_wrong_type_arg_error(sc, "gtk_fixed_layout_child_get_transform", 1, child, "GtkFixedLayoutChild*");
  return(lg_make_c_pointer_with_type(sc, GskTransform__sym, gtk_fixed_layout_child_get_transform((GtkFixedLayoutChild*)s7_c_pointer(child))));
}

static s7_pointer lg_gtk_text_view_buffer_to_window_coords(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_buffer_to_window_coords "void gtk_text_view_buffer_to_window_coords(GtkTextView* text_view, \
GtkTextWindowType win, gint buffer_x, gint buffer_y, gint* [window_x], gint* [window_y])"
  s7_pointer _p;
  s7_pointer text_view, win, buffer_x, buffer_y;
  gint ref_window_x;
  gint ref_window_y;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 1, text_view, "GtkTextView*");
  win = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 2, win, "GtkTextWindowType");
  buffer_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(buffer_x)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 3, buffer_x, "gint");
  buffer_y = s7_car(_p);
  if (!s7_is_integer(buffer_y)) s7_wrong_type_arg_error(sc, "gtk_text_view_buffer_to_window_coords", 4, buffer_y, "gint");
  gtk_text_view_buffer_to_window_coords((GtkTextView*)s7_c_pointer(text_view), (GtkTextWindowType)s7_integer(win), (gint)s7_integer(buffer_x), (gint)s7_integer(buffer_y), &ref_window_x, &ref_window_y);
    return(s7_list(sc, 2, s7_make_integer(sc, ref_window_x), s7_make_integer(sc, ref_window_y)));
}

static s7_pointer lg_gtk_file_chooser_get_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_file "GFile* gtk_file_chooser_get_file(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_file", 1, chooser, "GtkFileChooser*");
  return(lg_make_c_pointer_with_type(sc, GFile__sym, gtk_file_chooser_get_file((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_file "gboolean gtk_file_chooser_set_file(GtkFileChooser* chooser, GFile* file, \
GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, file;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_file", 2, file, "GFile*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_file_chooser_set_file((GtkFileChooser*)s7_c_pointer(chooser), (GFile*)s7_c_pointer(file), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_select_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_select_file "gboolean gtk_file_chooser_select_file(GtkFileChooser* chooser, \
GFile* file, GError** [error])"
  s7_pointer _p;
  s7_pointer chooser, file;
  GError* ref_error = NULL;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_file", 2, file, "GFile*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_file_chooser_select_file((GtkFileChooser*)s7_c_pointer(chooser), (GFile*)s7_c_pointer(file), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_file_chooser_unselect_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_unselect_file "void gtk_file_chooser_unselect_file(GtkFileChooser* chooser, \
GFile* file)"
  s7_pointer _p;
  s7_pointer chooser, file;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_file", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_file", 2, file, "GFile*");
  gtk_file_chooser_unselect_file((GtkFileChooser*)s7_c_pointer(chooser), (GFile*)s7_c_pointer(file));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_files(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_files "GSList* gtk_file_chooser_get_files(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_files", 1, chooser, "GtkFileChooser*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_file_chooser_get_files((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_editable_get_enable_undo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_get_enable_undo "gboolean gtk_editable_get_enable_undo(GtkEditable* editable)"
  s7_pointer editable;
  editable = s7_car(args);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_get_enable_undo", 1, editable, "GtkEditable*");
  return(s7_make_boolean(sc, gtk_editable_get_enable_undo((GtkEditable*)s7_c_pointer(editable))));
}

static s7_pointer lg_gtk_editable_set_enable_undo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_editable_set_enable_undo "void gtk_editable_set_enable_undo(GtkEditable* editable, gboolean enable_undo)"
  s7_pointer _p;
  s7_pointer editable, enable_undo;
  _p = args;
  editable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(editable, GtkEditable__sym)) s7_wrong_type_arg_error(sc, "gtk_editable_set_enable_undo", 1, editable, "GtkEditable*");
  enable_undo = s7_car(_p);
  if (!s7_is_boolean(enable_undo)) s7_wrong_type_arg_error(sc, "gtk_editable_set_enable_undo", 2, enable_undo, "gboolean");
  gtk_editable_set_enable_undo((GtkEditable*)s7_c_pointer(editable), (gboolean)lg_boolean(enable_undo));
  return(lg_false);
}

static s7_pointer lg_gtk_window_minimize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_minimize "void gtk_window_minimize(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_minimize", 1, window, "GtkWindow*");
  gtk_window_minimize((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_window_unminimize(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_window_unminimize "void gtk_window_unminimize(GtkWindow* window)"
  s7_pointer window;
  window = s7_car(args);
  if (!s7_is_c_pointer_of_type(window, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_window_unminimize", 1, window, "GtkWindow*");
  gtk_window_unminimize((GtkWindow*)s7_c_pointer(window));
  return(lg_false);
}

static s7_pointer lg_gtk_text_grab_focus_without_selecting(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_grab_focus_without_selecting "gboolean gtk_text_grab_focus_without_selecting(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_grab_focus_without_selecting", 1, self, "GtkText*");
  return(s7_make_boolean(sc, gtk_text_grab_focus_without_selecting((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_text_set_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_set_extra_menu "void gtk_text_set_extra_menu(GtkText* self, GMenuModel* model)"
  s7_pointer _p;
  s7_pointer self, model;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_extra_menu", 1, self, "GtkText*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_text_set_extra_menu", 2, model, "GMenuModel*");
  gtk_text_set_extra_menu((GtkText*)s7_c_pointer(self), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_text_get_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_get_extra_menu "GMenuModel* gtk_text_get_extra_menu(GtkText* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkText__sym)) s7_wrong_type_arg_error(sc, "gtk_text_get_extra_menu", 1, self, "GtkText*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_text_get_extra_menu((GtkText*)s7_c_pointer(self))));
}

static s7_pointer lg_gdk_app_launch_context_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_app_launch_context_get_display "GdkDisplay* gdk_app_launch_context_get_display(GdkAppLaunchContext* context)"
  s7_pointer context;
  context = s7_car(args);
  if (!s7_is_c_pointer_of_type(context, GdkAppLaunchContext__sym)) s7_wrong_type_arg_error(sc, "gdk_app_launch_context_get_display", 1, context, "GdkAppLaunchContext*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_app_launch_context_get_display((GdkAppLaunchContext*)s7_c_pointer(context))));
}

static s7_pointer lg_gdk_content_provider_new_typed(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_new_typed "GdkContentProvider* gdk_content_provider_new_typed(GType type, \
...)"
  s7_pointer type;
  type = s7_car(args);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gdk_content_provider_new_typed", 1, type, "GType");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gdk_content_provider_new_typed((GType)s7_integer(type))));
}

static s7_pointer lg_gdk_content_provider_new_union(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_content_provider_new_union "GdkContentProvider* gdk_content_provider_new_union(GdkContentProvider** providers, \
gsize n_providers)"
  s7_pointer _p;
  s7_pointer providers, n_providers;
  _p = args;
  providers = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(providers, GdkContentProvider___sym)) s7_wrong_type_arg_error(sc, "gdk_content_provider_new_union", 1, providers, "GdkContentProvider**");
  n_providers = s7_car(_p);
  if (!s7_is_integer(n_providers)) s7_wrong_type_arg_error(sc, "gdk_content_provider_new_union", 2, n_providers, "gsize");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gdk_content_provider_new_union((GdkContentProvider**)s7_c_pointer(providers), (gsize)s7_integer(n_providers))));
}

static s7_pointer lg_gtk_spinner_set_spinning(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_set_spinning "void gtk_spinner_set_spinning(GtkSpinner* spinner, gboolean spinning)"
  s7_pointer _p;
  s7_pointer spinner, spinning;
  _p = args;
  spinner = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(spinner, GtkSpinner__sym)) s7_wrong_type_arg_error(sc, "gtk_spinner_set_spinning", 1, spinner, "GtkSpinner*");
  spinning = s7_car(_p);
  if (!s7_is_boolean(spinning)) s7_wrong_type_arg_error(sc, "gtk_spinner_set_spinning", 2, spinning, "gboolean");
  gtk_spinner_set_spinning((GtkSpinner*)s7_c_pointer(spinner), (gboolean)lg_boolean(spinning));
  return(lg_false);
}

static s7_pointer lg_gtk_spinner_get_spinning(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_spinner_get_spinning "gboolean gtk_spinner_get_spinning(GtkSpinner* spinner)"
  s7_pointer spinner;
  spinner = s7_car(args);
  if (!s7_is_c_pointer_of_type(spinner, GtkSpinner__sym)) s7_wrong_type_arg_error(sc, "gtk_spinner_get_spinning", 1, spinner, "GtkSpinner*");
  return(s7_make_boolean(sc, gtk_spinner_get_spinning((GtkSpinner*)s7_c_pointer(spinner))));
}

static s7_pointer lg_gtk_single_selection_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_single_selection_get_model "GListModel* gtk_single_selection_get_model(GtkSingleSelection* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSingleSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_single_selection_get_model", 1, self, "GtkSingleSelection*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_single_selection_get_model((GtkSingleSelection*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_scale_set_format_value_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scale_set_format_value_func "void gtk_scale_set_format_value_func(GtkScale* scale, GtkScaleFormatValueFunc func, \
gpointer user_data, GDestroyNotify destroy_notify)"
  s7_pointer _p;
  s7_pointer scale, func, user_data, destroy_notify;
  _p = args;
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scale, GtkScale__sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_format_value_func", 1, scale, "GtkScale*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkScaleFormatValueFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_format_value_func", 2, func, "GtkScaleFormatValueFunc");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_scale_set_format_value_func", 3, user_data, "gpointer");
  destroy_notify = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy_notify);
    gtk_scale_set_format_value_func((GtkScale*)s7_c_pointer(scale), (GtkScaleFormatValueFunc)s7_c_pointer(func), (gpointer)s7_c_pointer(user_data), lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_root_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_root_get_display "GdkDisplay* gtk_root_get_display(GtkRoot* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkRoot__sym)) s7_wrong_type_arg_error(sc, "gtk_root_get_display", 1, self, "GtkRoot*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gtk_root_get_display((GtkRoot*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_password_entry_set_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_password_entry_set_extra_menu "void gtk_password_entry_set_extra_menu(GtkPasswordEntry* entry, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer entry, model;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkPasswordEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_password_entry_set_extra_menu", 1, entry, "GtkPasswordEntry*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_password_entry_set_extra_menu", 2, model, "GMenuModel*");
  gtk_password_entry_set_extra_menu((GtkPasswordEntry*)s7_c_pointer(entry), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_password_entry_get_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_password_entry_get_extra_menu "GMenuModel* gtk_password_entry_get_extra_menu(GtkPasswordEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkPasswordEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_password_entry_get_extra_menu", 1, entry, "GtkPasswordEntry*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_password_entry_get_extra_menu((GtkPasswordEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_gesture_long_press_set_delay_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_long_press_set_delay_factor "void gtk_gesture_long_press_set_delay_factor(GtkGestureLongPress* gesture, \
double delay_factor)"
  s7_pointer _p;
  s7_pointer gesture, delay_factor;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureLongPress__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_long_press_set_delay_factor", 1, gesture, "GtkGestureLongPress*");
  delay_factor = s7_car(_p);
  if (!s7_is_real(delay_factor)) s7_wrong_type_arg_error(sc, "gtk_gesture_long_press_set_delay_factor", 2, delay_factor, "double");
  gtk_gesture_long_press_set_delay_factor((GtkGestureLongPress*)s7_c_pointer(gesture), (double)s7_real(delay_factor));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_long_press_get_delay_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_long_press_get_delay_factor "double gtk_gesture_long_press_get_delay_factor(GtkGestureLongPress* gesture)"
  s7_pointer gesture;
  gesture = s7_car(args);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureLongPress__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_long_press_get_delay_factor", 1, gesture, "GtkGestureLongPress*");
  return(s7_make_real(sc, gtk_gesture_long_press_get_delay_factor((GtkGestureLongPress*)s7_c_pointer(gesture))));
}

static s7_pointer lg_gtk_event_controller_get_propagation_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_propagation_limit "GtkPropagationLimit gtk_event_controller_get_propagation_limit(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_propagation_limit", 1, controller, "GtkEventController*");
  return(lg_make_c_pointer_with_type(sc, GtkPropagationLimit_sym, gtk_event_controller_get_propagation_limit((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_set_propagation_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_set_propagation_limit "void gtk_event_controller_set_propagation_limit(GtkEventController* controller, \
GtkPropagationLimit limit)"
  s7_pointer _p;
  s7_pointer controller, limit;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_propagation_limit", 1, controller, "GtkEventController*");
  limit = s7_car(_p);
  if (!s7_is_c_pointer_of_type(limit, GtkPropagationLimit_sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_propagation_limit", 2, limit, "GtkPropagationLimit");
  gtk_event_controller_set_propagation_limit((GtkEventController*)s7_c_pointer(controller), (GtkPropagationLimit)s7_c_pointer(limit));
  return(lg_false);
}

static s7_pointer lg_gtk_event_controller_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_name "char* gtk_event_controller_get_name(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_name", 1, controller, "GtkEventController*");
    return(s7_make_string(sc, (char*)gtk_event_controller_get_name((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_set_name "void gtk_event_controller_set_name(GtkEventController* controller, \
char* name)"
  s7_pointer _p;
  s7_pointer controller, name;
  _p = args;
  controller = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_name", 1, controller, "GtkEventController*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_event_controller_set_name", 2, name, "char*");
  gtk_event_controller_set_name((GtkEventController*)s7_c_pointer(controller), (const char*)(char*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gdk_device_get_num_touches(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_num_touches "guint gdk_device_get_num_touches(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_num_touches", 1, device, "GdkDevice*");
  return(s7_make_integer(sc, gdk_device_get_num_touches((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_device_tool(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_device_tool "GdkDeviceTool* gdk_device_get_device_tool(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_device_tool", 1, device, "GdkDevice*");
  return(lg_make_c_pointer_with_type(sc, GdkDeviceTool__sym, gdk_device_get_device_tool((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_drag_get_content(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_content "GdkContentProvider* gdk_drag_get_content(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_content", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gdk_drag_get_content((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_get_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_get_surface "GdkSurface* gdk_drag_get_surface(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_get_surface", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_drag_get_surface((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gdk_drag_surface_present(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drag_surface_present "gboolean gdk_drag_surface_present(GdkDragSurface* drag_icon, int width, \
int height)"
  s7_pointer _p;
  s7_pointer drag_icon, width, height;
  _p = args;
  drag_icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag_icon, GdkDragSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_drag_surface_present", 1, drag_icon, "GdkDragSurface*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_drag_surface_present", 2, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_drag_surface_present", 3, height, "int");
  return(s7_make_boolean(sc, gdk_drag_surface_present((GdkDragSurface*)s7_c_pointer(drag_icon), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_gdk_drop_status(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_drop_status "void gdk_drop_status(GdkDrop* self, GdkDragAction actions, GdkDragAction preferred)"
  s7_pointer _p;
  s7_pointer self, actions, preferred;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gdk_drop_status", 1, self, "GdkDrop*");
  actions = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gdk_drop_status", 2, actions, "GdkDragAction");
  preferred = s7_car(_p);
  if (!s7_is_integer(preferred)) s7_wrong_type_arg_error(sc, "gdk_drop_status", 3, preferred, "GdkDragAction");
  gdk_drop_status((GdkDrop*)s7_c_pointer(self), (GdkDragAction)s7_integer(actions), (GdkDragAction)s7_integer(preferred));
  return(lg_false);
}

static s7_pointer lg_gdk_monitor_get_connector(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_monitor_get_connector "char* gdk_monitor_get_connector(GdkMonitor* monitor)"
  s7_pointer monitor;
  monitor = s7_car(args);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_monitor_get_connector", 1, monitor, "GdkMonitor*");
    return(s7_make_string(sc, (char*)gdk_monitor_get_connector((GdkMonitor*)s7_c_pointer(monitor))));
}

static s7_pointer lg_gdk_pixbuf_get_from_texture(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pixbuf_get_from_texture "GdkPixbuf* gdk_pixbuf_get_from_texture(GdkTexture* texture)"
  s7_pointer texture;
  texture = s7_car(args);
  if (!s7_is_c_pointer_of_type(texture, GdkTexture__sym)) s7_wrong_type_arg_error(sc, "gdk_pixbuf_get_from_texture", 1, texture, "GdkTexture*");
  return(lg_make_c_pointer_with_type(sc, GdkPixbuf__sym, gdk_pixbuf_get_from_texture((GdkTexture*)s7_c_pointer(texture))));
}

static s7_pointer lg_gdk_popup_present(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_present "gboolean gdk_popup_present(GdkPopup* popup, int width, int height, GdkPopupLayout* layout)"
  s7_pointer _p;
  s7_pointer popup, width, height, layout;
  _p = args;
  popup = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_present", 1, popup, "GdkPopup*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_popup_present", 2, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_popup_present", 3, height, "int");
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_present", 4, layout, "GdkPopupLayout*");
  return(s7_make_boolean(sc, gdk_popup_present((GdkPopup*)s7_c_pointer(popup), (int)s7_integer(width), (int)s7_integer(height), (GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_get_surface_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_get_surface_anchor "GdkGravity gdk_popup_get_surface_anchor(GdkPopup* popup)"
  s7_pointer popup;
  popup = s7_car(args);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_get_surface_anchor", 1, popup, "GdkPopup*");
  return(s7_make_integer(sc, gdk_popup_get_surface_anchor((GdkPopup*)s7_c_pointer(popup))));
}

static s7_pointer lg_gdk_popup_get_rect_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_get_rect_anchor "GdkGravity gdk_popup_get_rect_anchor(GdkPopup* popup)"
  s7_pointer popup;
  popup = s7_car(args);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_get_rect_anchor", 1, popup, "GdkPopup*");
  return(s7_make_integer(sc, gdk_popup_get_rect_anchor((GdkPopup*)s7_c_pointer(popup))));
}

static s7_pointer lg_gdk_popup_get_parent(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_get_parent "GdkSurface* gdk_popup_get_parent(GdkPopup* popup)"
  s7_pointer popup;
  popup = s7_car(args);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_get_parent", 1, popup, "GdkPopup*");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_popup_get_parent((GdkPopup*)s7_c_pointer(popup))));
}

static s7_pointer lg_gdk_popup_get_position_x(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_get_position_x "int gdk_popup_get_position_x(GdkPopup* popup)"
  s7_pointer popup;
  popup = s7_car(args);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_get_position_x", 1, popup, "GdkPopup*");
  return(s7_make_integer(sc, gdk_popup_get_position_x((GdkPopup*)s7_c_pointer(popup))));
}

static s7_pointer lg_gdk_popup_get_position_y(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_get_position_y "int gdk_popup_get_position_y(GdkPopup* popup)"
  s7_pointer popup;
  popup = s7_car(args);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_get_position_y", 1, popup, "GdkPopup*");
  return(s7_make_integer(sc, gdk_popup_get_position_y((GdkPopup*)s7_c_pointer(popup))));
}

static s7_pointer lg_gdk_popup_get_autohide(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_get_autohide "gboolean gdk_popup_get_autohide(GdkPopup* popup)"
  s7_pointer popup;
  popup = s7_car(args);
  if (!s7_is_c_pointer_of_type(popup, GdkPopup__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_get_autohide", 1, popup, "GdkPopup*");
  return(s7_make_boolean(sc, gdk_popup_get_autohide((GdkPopup*)s7_c_pointer(popup))));
}

static s7_pointer lg_gdk_popup_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_new "GdkPopupLayout* gdk_popup_layout_new(GdkRectangle* anchor_rect, GdkGravity rect_anchor, \
GdkGravity surface_anchor)"
  s7_pointer _p;
  s7_pointer anchor_rect, rect_anchor, surface_anchor;
  _p = args;
  anchor_rect = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(anchor_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_new", 1, anchor_rect, "GdkRectangle*");
  rect_anchor = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(rect_anchor)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_new", 2, rect_anchor, "GdkGravity");
  surface_anchor = s7_car(_p);
  if (!s7_is_integer(surface_anchor)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_new", 3, surface_anchor, "GdkGravity");
  return(lg_make_c_pointer_with_type(sc, GdkPopupLayout__sym, gdk_popup_layout_new((GdkRectangle*)s7_c_pointer(anchor_rect), (GdkGravity)s7_integer(rect_anchor), (GdkGravity)s7_integer(surface_anchor))));
}

static s7_pointer lg_gdk_popup_layout_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_ref "GdkPopupLayout* gdk_popup_layout_ref(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_ref", 1, layout, "GdkPopupLayout*");
  return(lg_make_c_pointer_with_type(sc, GdkPopupLayout__sym, gdk_popup_layout_ref((GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_layout_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_unref "void gdk_popup_layout_unref(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_unref", 1, layout, "GdkPopupLayout*");
  gdk_popup_layout_unref((GdkPopupLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_gdk_popup_layout_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_copy "GdkPopupLayout* gdk_popup_layout_copy(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_copy", 1, layout, "GdkPopupLayout*");
  return(lg_make_c_pointer_with_type(sc, GdkPopupLayout__sym, gdk_popup_layout_copy((GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_layout_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_equal "gboolean gdk_popup_layout_equal(GdkPopupLayout* layout, GdkPopupLayout* other)"
  s7_pointer _p;
  s7_pointer layout, other;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_equal", 1, layout, "GdkPopupLayout*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_equal", 2, other, "GdkPopupLayout*");
  return(s7_make_boolean(sc, gdk_popup_layout_equal((GdkPopupLayout*)s7_c_pointer(layout), (GdkPopupLayout*)s7_c_pointer(other))));
}

static s7_pointer lg_gdk_popup_layout_set_anchor_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_set_anchor_rect "void gdk_popup_layout_set_anchor_rect(GdkPopupLayout* layout, \
GdkRectangle* anchor_rect)"
  s7_pointer _p;
  s7_pointer layout, anchor_rect;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_anchor_rect", 1, layout, "GdkPopupLayout*");
  anchor_rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(anchor_rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_anchor_rect", 2, anchor_rect, "GdkRectangle*");
  gdk_popup_layout_set_anchor_rect((GdkPopupLayout*)s7_c_pointer(layout), (GdkRectangle*)s7_c_pointer(anchor_rect));
  return(lg_false);
}

static s7_pointer lg_gdk_popup_layout_get_anchor_rect(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_get_anchor_rect "GdkRectangle* gdk_popup_layout_get_anchor_rect(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_anchor_rect", 1, layout, "GdkPopupLayout*");
    return(lg_make_c_pointer_with_type(sc, GdkRectangle__sym, (GdkRectangle*)gdk_popup_layout_get_anchor_rect((GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_layout_set_rect_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_set_rect_anchor "void gdk_popup_layout_set_rect_anchor(GdkPopupLayout* layout, \
GdkGravity anchor)"
  s7_pointer _p;
  s7_pointer layout, anchor;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_rect_anchor", 1, layout, "GdkPopupLayout*");
  anchor = s7_car(_p);
  if (!s7_is_integer(anchor)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_rect_anchor", 2, anchor, "GdkGravity");
  gdk_popup_layout_set_rect_anchor((GdkPopupLayout*)s7_c_pointer(layout), (GdkGravity)s7_integer(anchor));
  return(lg_false);
}

static s7_pointer lg_gdk_popup_layout_get_rect_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_get_rect_anchor "GdkGravity gdk_popup_layout_get_rect_anchor(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_rect_anchor", 1, layout, "GdkPopupLayout*");
  return(s7_make_integer(sc, gdk_popup_layout_get_rect_anchor((GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_layout_set_surface_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_set_surface_anchor "void gdk_popup_layout_set_surface_anchor(GdkPopupLayout* layout, \
GdkGravity anchor)"
  s7_pointer _p;
  s7_pointer layout, anchor;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_surface_anchor", 1, layout, "GdkPopupLayout*");
  anchor = s7_car(_p);
  if (!s7_is_integer(anchor)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_surface_anchor", 2, anchor, "GdkGravity");
  gdk_popup_layout_set_surface_anchor((GdkPopupLayout*)s7_c_pointer(layout), (GdkGravity)s7_integer(anchor));
  return(lg_false);
}

static s7_pointer lg_gdk_popup_layout_get_surface_anchor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_get_surface_anchor "GdkGravity gdk_popup_layout_get_surface_anchor(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_surface_anchor", 1, layout, "GdkPopupLayout*");
  return(s7_make_integer(sc, gdk_popup_layout_get_surface_anchor((GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_layout_set_anchor_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_set_anchor_hints "void gdk_popup_layout_set_anchor_hints(GdkPopupLayout* layout, \
GdkAnchorHints anchor_hints)"
  s7_pointer _p;
  s7_pointer layout, anchor_hints;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_anchor_hints", 1, layout, "GdkPopupLayout*");
  anchor_hints = s7_car(_p);
  if (!s7_is_integer(anchor_hints)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_anchor_hints", 2, anchor_hints, "GdkAnchorHints");
  gdk_popup_layout_set_anchor_hints((GdkPopupLayout*)s7_c_pointer(layout), (GdkAnchorHints)s7_integer(anchor_hints));
  return(lg_false);
}

static s7_pointer lg_gdk_popup_layout_get_anchor_hints(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_get_anchor_hints "GdkAnchorHints gdk_popup_layout_get_anchor_hints(GdkPopupLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_anchor_hints", 1, layout, "GdkPopupLayout*");
  return(s7_make_integer(sc, gdk_popup_layout_get_anchor_hints((GdkPopupLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_popup_layout_set_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_set_offset "void gdk_popup_layout_set_offset(GdkPopupLayout* layout, int dx, \
int dy)"
  s7_pointer _p;
  s7_pointer layout, dx, dy;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_offset", 1, layout, "GdkPopupLayout*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dx)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_offset", 2, dx, "int");
  dy = s7_car(_p);
  if (!s7_is_integer(dy)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_set_offset", 3, dy, "int");
  gdk_popup_layout_set_offset((GdkPopupLayout*)s7_c_pointer(layout), (int)s7_integer(dx), (int)s7_integer(dy));
  return(lg_false);
}

static s7_pointer lg_gdk_popup_layout_get_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_popup_layout_get_offset "void gdk_popup_layout_get_offset(GdkPopupLayout* layout, int* dx, \
int* dy)"
  s7_pointer _p;
  s7_pointer layout, dx, dy;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkPopupLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_offset", 1, layout, "GdkPopupLayout*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dx, int__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_offset", 2, dx, "int*");
  dy = s7_car(_p);
  if (!s7_is_c_pointer_of_type(dy, int__sym)) s7_wrong_type_arg_error(sc, "gdk_popup_layout_get_offset", 3, dy, "int*");
  gdk_popup_layout_get_offset((GdkPopupLayout*)s7_c_pointer(layout), (int*)s7_c_pointer(dx), (int*)s7_c_pointer(dy));
  return(lg_false);
}

static s7_pointer lg_gtk_accel_label_get_accel_closure(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accel_label_get_accel_closure "GClosure* gtk_accel_label_get_accel_closure(GtkAccelLabel* accel_label)"
  s7_pointer accel_label;
  accel_label = s7_car(args);
  if (!s7_is_c_pointer_of_type(accel_label, GtkAccelLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_accel_label_get_accel_closure", 1, accel_label, "GtkAccelLabel*");
  return(lg_make_c_pointer_with_type(sc, GClosure__sym, gtk_accel_label_get_accel_closure((GtkAccelLabel*)s7_c_pointer(accel_label))));
}

static s7_pointer lg_gtk_cell_renderer_set_is_expander(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_is_expander "void gtk_cell_renderer_set_is_expander(GtkCellRenderer* cell, \
gboolean is_expander)"
  s7_pointer _p;
  s7_pointer cell, is_expander;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_is_expander", 1, cell, "GtkCellRenderer*");
  is_expander = s7_car(_p);
  if (!s7_is_boolean(is_expander)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_is_expander", 2, is_expander, "gboolean");
  gtk_cell_renderer_set_is_expander((GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(is_expander));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_is_expander(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_is_expander "gboolean gtk_cell_renderer_get_is_expander(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_is_expander", 1, cell, "GtkCellRenderer*");
  return(s7_make_boolean(sc, gtk_cell_renderer_get_is_expander((GtkCellRenderer*)s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_cell_renderer_set_is_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_set_is_expanded "void gtk_cell_renderer_set_is_expanded(GtkCellRenderer* cell, \
gboolean is_expander)"
  s7_pointer _p;
  s7_pointer cell, is_expander;
  _p = args;
  cell = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_is_expanded", 1, cell, "GtkCellRenderer*");
  is_expander = s7_car(_p);
  if (!s7_is_boolean(is_expander)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_set_is_expanded", 2, is_expander, "gboolean");
  gtk_cell_renderer_set_is_expanded((GtkCellRenderer*)s7_c_pointer(cell), (gboolean)lg_boolean(is_expander));
  return(lg_false);
}

static s7_pointer lg_gtk_cell_renderer_get_is_expanded(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_cell_renderer_get_is_expanded "gboolean gtk_cell_renderer_get_is_expanded(GtkCellRenderer* cell)"
  s7_pointer cell;
  cell = s7_car(args);
  if (!s7_is_c_pointer_of_type(cell, GtkCellRenderer__sym)) s7_wrong_type_arg_error(sc, "gtk_cell_renderer_get_is_expanded", 1, cell, "GtkCellRenderer*");
  return(s7_make_boolean(sc, gtk_cell_renderer_get_is_expanded((GtkCellRenderer*)s7_c_pointer(cell))));
}

static s7_pointer lg_gtk_drag_source_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_new "GtkDragSource* gtk_drag_source_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkDragSource__sym, gtk_drag_source_new()));
}

static s7_pointer lg_gtk_drag_source_set_content(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_content "void gtk_drag_source_set_content(GtkDragSource* source, GdkContentProvider* content)"
  s7_pointer _p;
  s7_pointer source, content;
  _p = args;
  source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_content", 1, source, "GtkDragSource*");
  content = s7_car(_p);
  if (!s7_is_c_pointer_of_type(content, GdkContentProvider__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_content", 2, content, "GdkContentProvider*");
  gtk_drag_source_set_content((GtkDragSource*)s7_c_pointer(source), (GdkContentProvider*)s7_c_pointer(content));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_get_content(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_get_content "GdkContentProvider* gtk_drag_source_get_content(GtkDragSource* source)"
  s7_pointer source;
  source = s7_car(args);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_get_content", 1, source, "GtkDragSource*");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gtk_drag_source_get_content((GtkDragSource*)s7_c_pointer(source))));
}

static s7_pointer lg_gtk_drag_source_set_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_actions "void gtk_drag_source_set_actions(GtkDragSource* source, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer source, actions;
  _p = args;
  source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_actions", 1, source, "GtkDragSource*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_actions", 2, actions, "GdkDragAction");
  gtk_drag_source_set_actions((GtkDragSource*)s7_c_pointer(source), (GdkDragAction)s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_get_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_get_actions "GdkDragAction gtk_drag_source_get_actions(GtkDragSource* source)"
  s7_pointer source;
  source = s7_car(args);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_get_actions", 1, source, "GtkDragSource*");
  return(s7_make_integer(sc, gtk_drag_source_get_actions((GtkDragSource*)s7_c_pointer(source))));
}

static s7_pointer lg_gtk_drag_source_set_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_set_icon "void gtk_drag_source_set_icon(GtkDragSource* source, GdkPaintable* paintable, \
int hot_x, int hot_y)"
  s7_pointer _p;
  s7_pointer source, paintable, hot_x, hot_y;
  _p = args;
  source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon", 1, source, "GtkDragSource*");
  paintable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon", 2, paintable, "GdkPaintable*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon", 3, hot_x, "int");
  hot_y = s7_car(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gtk_drag_source_set_icon", 4, hot_y, "int");
  gtk_drag_source_set_icon((GtkDragSource*)s7_c_pointer(source), (GdkPaintable*)s7_c_pointer(paintable), (int)s7_integer(hot_x), (int)s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_drag_cancel(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_drag_cancel "void gtk_drag_source_drag_cancel(GtkDragSource* source)"
  s7_pointer source;
  source = s7_car(args);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_drag_cancel", 1, source, "GtkDragSource*");
  gtk_drag_source_drag_cancel((GtkDragSource*)s7_c_pointer(source));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_source_get_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_source_get_drag "GdkDrag* gtk_drag_source_get_drag(GtkDragSource* source)"
  s7_pointer source;
  source = s7_car(args);
  if (!s7_is_c_pointer_of_type(source, GtkDragSource__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_source_get_drag", 1, source, "GtkDragSource*");
  return(lg_make_c_pointer_with_type(sc, GdkDrag__sym, gtk_drag_source_get_drag((GtkDragSource*)s7_c_pointer(source))));
}

static s7_pointer lg_gtk_drag_check_threshold(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_check_threshold "gboolean gtk_drag_check_threshold(GtkWidget* widget, int start_x, \
int start_y, int current_x, int current_y)"
  s7_pointer _p;
  s7_pointer widget, start_x, start_y, current_x, current_y;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 1, widget, "GtkWidget*");
  start_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_x)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 2, start_x, "int");
  start_y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(start_y)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 3, start_y, "int");
  current_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(current_x)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 4, current_x, "int");
  current_y = s7_car(_p);
  if (!s7_is_integer(current_y)) s7_wrong_type_arg_error(sc, "gtk_drag_check_threshold", 5, current_y, "int");
  return(s7_make_boolean(sc, gtk_drag_check_threshold((GtkWidget*)s7_c_pointer(widget), (int)s7_integer(start_x), (int)s7_integer(start_y), (int)s7_integer(current_x), (int)s7_integer(current_y))));
}

static s7_pointer lg_gtk_entry_set_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_set_extra_menu "void gtk_entry_set_extra_menu(GtkEntry* entry, GMenuModel* model)"
  s7_pointer _p;
  s7_pointer entry, model;
  _p = args;
  entry = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_extra_menu", 1, entry, "GtkEntry*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_set_extra_menu", 2, model, "GMenuModel*");
  gtk_entry_set_extra_menu((GtkEntry*)s7_c_pointer(entry), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_entry_get_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_entry_get_extra_menu "GMenuModel* gtk_entry_get_extra_menu(GtkEntry* entry)"
  s7_pointer entry;
  entry = s7_car(args);
  if (!s7_is_c_pointer_of_type(entry, GtkEntry__sym)) s7_wrong_type_arg_error(sc, "gtk_entry_get_extra_menu", 1, entry, "GtkEntry*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_entry_get_extra_menu((GtkEntry*)s7_c_pointer(entry))));
}

static s7_pointer lg_gtk_no_selection_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_no_selection_new "GtkNoSelection* gtk_no_selection_new(GListModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_no_selection_new", 1, model, "GListModel*");
  return(lg_make_c_pointer_with_type(sc, GtkNoSelection__sym, gtk_no_selection_new((GListModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_no_selection_get_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_no_selection_get_model "GListModel* gtk_no_selection_get_model(GtkNoSelection* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkNoSelection__sym)) s7_wrong_type_arg_error(sc, "gtk_no_selection_get_model", 1, self, "GtkNoSelection*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_no_selection_get_model((GtkNoSelection*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_popover_menu_bar_new_from_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_bar_new_from_model "GtkWidget* gtk_popover_menu_bar_new_from_model(GMenuModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_bar_new_from_model", 1, model, "GMenuModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_popover_menu_bar_new_from_model((GMenuModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_popover_menu_bar_set_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_bar_set_menu_model "void gtk_popover_menu_bar_set_menu_model(GtkPopoverMenuBar* bar, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer bar, model;
  _p = args;
  bar = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(bar, GtkPopoverMenuBar__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_bar_set_menu_model", 1, bar, "GtkPopoverMenuBar*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_bar_set_menu_model", 2, model, "GMenuModel*");
  gtk_popover_menu_bar_set_menu_model((GtkPopoverMenuBar*)s7_c_pointer(bar), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_menu_bar_get_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_bar_get_menu_model "GMenuModel* gtk_popover_menu_bar_get_menu_model(GtkPopoverMenuBar* bar)"
  s7_pointer bar;
  bar = s7_car(args);
  if (!s7_is_c_pointer_of_type(bar, GtkPopoverMenuBar__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_bar_get_menu_model", 1, bar, "GtkPopoverMenuBar*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_popover_menu_bar_get_menu_model((GtkPopoverMenuBar*)s7_c_pointer(bar))));
}

static s7_pointer lg_gtk_gesture_click_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_click_new "GtkGesture* gtk_gesture_click_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkGesture__sym, gtk_gesture_click_new()));
}

static s7_pointer lg_gtk_gesture_click_set_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_click_set_area "void gtk_gesture_click_set_area(GtkGestureClick* gesture, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer gesture, rect;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureClick__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_click_set_area", 1, gesture, "GtkGestureClick*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_click_set_area", 2, rect, "GdkRectangle*");
  gtk_gesture_click_set_area((GtkGestureClick*)s7_c_pointer(gesture), (GdkRectangle*)s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_gesture_click_get_area(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_gesture_click_get_area "gboolean gtk_gesture_click_get_area(GtkGestureClick* gesture, \
GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer gesture, rect;
  _p = args;
  gesture = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gesture, GtkGestureClick__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_click_get_area", 1, gesture, "GtkGestureClick*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_gesture_click_get_area", 2, rect, "GdkRectangle*");
  return(s7_make_boolean(sc, gtk_gesture_click_get_area((GtkGestureClick*)s7_c_pointer(gesture), (GdkRectangle*)s7_c_pointer(rect))));
}

static s7_pointer lg_gtk_center_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_new "GtkLayoutManager* gtk_center_layout_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_center_layout_new()));
}

static s7_pointer lg_gtk_center_layout_set_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_set_orientation "void gtk_center_layout_set_orientation(GtkCenterLayout* self, \
GtkOrientation orientation)"
  s7_pointer _p;
  s7_pointer self, orientation;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_orientation", 1, self, "GtkCenterLayout*");
  orientation = s7_car(_p);
  if (!s7_is_integer(orientation)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_orientation", 2, orientation, "GtkOrientation");
  gtk_center_layout_set_orientation((GtkCenterLayout*)s7_c_pointer(self), (GtkOrientation)s7_integer(orientation));
  return(lg_false);
}

static s7_pointer lg_gtk_center_layout_get_orientation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_get_orientation "GtkOrientation gtk_center_layout_get_orientation(GtkCenterLayout* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_get_orientation", 1, self, "GtkCenterLayout*");
  return(s7_make_integer(sc, gtk_center_layout_get_orientation((GtkCenterLayout*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_layout_set_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_set_baseline_position "void gtk_center_layout_set_baseline_position(GtkCenterLayout* self, \
GtkBaselinePosition baseline_position)"
  s7_pointer _p;
  s7_pointer self, baseline_position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_baseline_position", 1, self, "GtkCenterLayout*");
  baseline_position = s7_car(_p);
  if (!s7_is_integer(baseline_position)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_baseline_position", 2, baseline_position, "GtkBaselinePosition");
  gtk_center_layout_set_baseline_position((GtkCenterLayout*)s7_c_pointer(self), (GtkBaselinePosition)s7_integer(baseline_position));
  return(lg_false);
}

static s7_pointer lg_gtk_center_layout_get_baseline_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_get_baseline_position "GtkBaselinePosition gtk_center_layout_get_baseline_position(GtkCenterLayout* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_get_baseline_position", 1, self, "GtkCenterLayout*");
  return(s7_make_integer(sc, gtk_center_layout_get_baseline_position((GtkCenterLayout*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_layout_set_start_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_set_start_widget "void gtk_center_layout_set_start_widget(GtkCenterLayout* self, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer self, widget;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_start_widget", 1, self, "GtkCenterLayout*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_start_widget", 2, widget, "GtkWidget*");
  gtk_center_layout_set_start_widget((GtkCenterLayout*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_center_layout_get_start_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_get_start_widget "GtkWidget* gtk_center_layout_get_start_widget(GtkCenterLayout* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_get_start_widget", 1, self, "GtkCenterLayout*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_layout_get_start_widget((GtkCenterLayout*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_layout_set_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_set_center_widget "void gtk_center_layout_set_center_widget(GtkCenterLayout* self, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer self, widget;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_center_widget", 1, self, "GtkCenterLayout*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_center_widget", 2, widget, "GtkWidget*");
  gtk_center_layout_set_center_widget((GtkCenterLayout*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_center_layout_get_center_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_get_center_widget "GtkWidget* gtk_center_layout_get_center_widget(GtkCenterLayout* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_get_center_widget", 1, self, "GtkCenterLayout*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_layout_get_center_widget((GtkCenterLayout*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_center_layout_set_end_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_set_end_widget "void gtk_center_layout_set_end_widget(GtkCenterLayout* self, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer self, widget;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_end_widget", 1, self, "GtkCenterLayout*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_set_end_widget", 2, widget, "GtkWidget*");
  gtk_center_layout_set_end_widget((GtkCenterLayout*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_center_layout_get_end_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_center_layout_get_end_widget "GtkWidget* gtk_center_layout_get_end_widget(GtkCenterLayout* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCenterLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_center_layout_get_end_widget", 1, self, "GtkCenterLayout*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_center_layout_get_end_widget((GtkCenterLayout*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_popover_menu_new_from_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_new_from_model "GtkWidget* gtk_popover_menu_new_from_model(GMenuModel* model)"
  s7_pointer model;
  model = s7_car(args);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_new_from_model", 1, model, "GMenuModel*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_popover_menu_new_from_model((GMenuModel*)s7_c_pointer(model))));
}

static s7_pointer lg_gtk_popover_menu_new_from_model_full(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_new_from_model_full "GtkWidget* gtk_popover_menu_new_from_model_full(GMenuModel* model, \
GtkPopoverMenuFlags flags)"
  s7_pointer _p;
  s7_pointer model, flags;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_new_from_model_full", 1, model, "GMenuModel*");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_new_from_model_full", 2, flags, "GtkPopoverMenuFlags");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_popover_menu_new_from_model_full((GMenuModel*)s7_c_pointer(model), (GtkPopoverMenuFlags)s7_integer(flags))));
}

static s7_pointer lg_gtk_popover_menu_set_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_set_menu_model "void gtk_popover_menu_set_menu_model(GtkPopoverMenu* popover, \
GMenuModel* model)"
  s7_pointer _p;
  s7_pointer popover, model;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopoverMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_set_menu_model", 1, popover, "GtkPopoverMenu*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_set_menu_model", 2, model, "GMenuModel*");
  gtk_popover_menu_set_menu_model((GtkPopoverMenu*)s7_c_pointer(popover), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_menu_get_menu_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_menu_get_menu_model "GMenuModel* gtk_popover_menu_get_menu_model(GtkPopoverMenu* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopoverMenu__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_menu_get_menu_model", 1, popover, "GtkPopoverMenu*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_popover_menu_get_menu_model((GtkPopoverMenu*)s7_c_pointer(popover))));
}

static s7_pointer lg_gdk_toplevel_present(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_present "gboolean gdk_toplevel_present(GdkToplevel* toplevel, int width, int height, \
GdkToplevelLayout* layout)"
  s7_pointer _p;
  s7_pointer toplevel, width, height, layout;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_present", 1, toplevel, "GdkToplevel*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_toplevel_present", 2, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_toplevel_present", 3, height, "int");
  layout = s7_car(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_present", 4, layout, "GdkToplevelLayout*");
  return(s7_make_boolean(sc, gdk_toplevel_present((GdkToplevel*)s7_c_pointer(toplevel), (int)s7_integer(width), (int)s7_integer(height), (GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_minimize(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_minimize "gboolean gdk_toplevel_minimize(GdkToplevel* toplevel)"
  s7_pointer toplevel;
  toplevel = s7_car(args);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_minimize", 1, toplevel, "GdkToplevel*");
  return(s7_make_boolean(sc, gdk_toplevel_minimize((GdkToplevel*)s7_c_pointer(toplevel))));
}

static s7_pointer lg_gdk_toplevel_lower(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_lower "gboolean gdk_toplevel_lower(GdkToplevel* toplevel)"
  s7_pointer toplevel;
  toplevel = s7_car(args);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_lower", 1, toplevel, "GdkToplevel*");
  return(s7_make_boolean(sc, gdk_toplevel_lower((GdkToplevel*)s7_c_pointer(toplevel))));
}

static s7_pointer lg_gdk_toplevel_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_focus "void gdk_toplevel_focus(GdkToplevel* toplevel, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer toplevel, timestamp;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_focus", 1, toplevel, "GdkToplevel*");
  timestamp = s7_car(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_toplevel_focus", 2, timestamp, "guint32");
  gdk_toplevel_focus((GdkToplevel*)s7_c_pointer(toplevel), (guint32)s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_get_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_get_state "GdkSurfaceState gdk_toplevel_get_state(GdkToplevel* toplevel)"
  s7_pointer toplevel;
  toplevel = s7_car(args);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_get_state", 1, toplevel, "GdkToplevel*");
  return(s7_make_integer(sc, gdk_toplevel_get_state((GdkToplevel*)s7_c_pointer(toplevel))));
}

static s7_pointer lg_gdk_toplevel_set_title(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_title "void gdk_toplevel_set_title(GdkToplevel* toplevel, char* title)"
  s7_pointer _p;
  s7_pointer toplevel, title;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_title", 1, toplevel, "GdkToplevel*");
  title = s7_car(_p);
  if (!s7_is_string(title)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_title", 2, title, "char*");
  gdk_toplevel_set_title((GdkToplevel*)s7_c_pointer(toplevel), (const char*)(char*)s7_string(title));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_set_startup_id(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_startup_id "void gdk_toplevel_set_startup_id(GdkToplevel* toplevel, char* startup_id)"
  s7_pointer _p;
  s7_pointer toplevel, startup_id;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_startup_id", 1, toplevel, "GdkToplevel*");
  startup_id = s7_car(_p);
  if (!s7_is_string(startup_id)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_startup_id", 2, startup_id, "char*");
  gdk_toplevel_set_startup_id((GdkToplevel*)s7_c_pointer(toplevel), (const char*)(char*)s7_string(startup_id));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_set_transient_for(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_transient_for "void gdk_toplevel_set_transient_for(GdkToplevel* toplevel, \
GdkSurface* parent)"
  s7_pointer _p;
  s7_pointer toplevel, parent;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_transient_for", 1, toplevel, "GdkToplevel*");
  parent = s7_car(_p);
  if (!s7_is_c_pointer_of_type(parent, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_transient_for", 2, parent, "GdkSurface*");
  gdk_toplevel_set_transient_for((GdkToplevel*)s7_c_pointer(toplevel), (GdkSurface*)s7_c_pointer(parent));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_modal "void gdk_toplevel_set_modal(GdkToplevel* toplevel, gboolean modal)"
  s7_pointer _p;
  s7_pointer toplevel, modal;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_modal", 1, toplevel, "GdkToplevel*");
  modal = s7_car(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_modal", 2, modal, "gboolean");
  gdk_toplevel_set_modal((GdkToplevel*)s7_c_pointer(toplevel), (gboolean)lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_set_icon_list(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_icon_list "void gdk_toplevel_set_icon_list(GdkToplevel* toplevel, GList* surfaces)"
  s7_pointer _p;
  s7_pointer toplevel, surfaces;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_icon_list", 1, toplevel, "GdkToplevel*");
  surfaces = s7_car(_p);
  if (!s7_is_c_pointer_of_type(surfaces, GList__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_icon_list", 2, surfaces, "GList*");
  gdk_toplevel_set_icon_list((GdkToplevel*)s7_c_pointer(toplevel), (GList*)s7_c_pointer(surfaces));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_show_window_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_show_window_menu "gboolean gdk_toplevel_show_window_menu(GdkToplevel* toplevel, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer toplevel, event;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_show_window_menu", 1, toplevel, "GdkToplevel*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_show_window_menu", 2, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_toplevel_show_window_menu((GdkToplevel*)s7_c_pointer(toplevel), (GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_toplevel_set_decorated(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_decorated "void gdk_toplevel_set_decorated(GdkToplevel* toplevel, gboolean decorated)"
  s7_pointer _p;
  s7_pointer toplevel, decorated;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_decorated", 1, toplevel, "GdkToplevel*");
  decorated = s7_car(_p);
  if (!s7_is_boolean(decorated)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_decorated", 2, decorated, "gboolean");
  gdk_toplevel_set_decorated((GdkToplevel*)s7_c_pointer(toplevel), (gboolean)lg_boolean(decorated));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_set_deletable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_set_deletable "void gdk_toplevel_set_deletable(GdkToplevel* toplevel, gboolean deletable)"
  s7_pointer _p;
  s7_pointer toplevel, deletable;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_deletable", 1, toplevel, "GdkToplevel*");
  deletable = s7_car(_p);
  if (!s7_is_boolean(deletable)) s7_wrong_type_arg_error(sc, "gdk_toplevel_set_deletable", 2, deletable, "gboolean");
  gdk_toplevel_set_deletable((GdkToplevel*)s7_c_pointer(toplevel), (gboolean)lg_boolean(deletable));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_supports_edge_constraints(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_supports_edge_constraints "gboolean gdk_toplevel_supports_edge_constraints(GdkToplevel* toplevel)"
  s7_pointer toplevel;
  toplevel = s7_car(args);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_supports_edge_constraints", 1, toplevel, "GdkToplevel*");
  return(s7_make_boolean(sc, gdk_toplevel_supports_edge_constraints((GdkToplevel*)s7_c_pointer(toplevel))));
}

static s7_pointer lg_gdk_toplevel_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_new "GdkToplevelLayout* gdk_toplevel_layout_new(int min_width, int min_height)"
  s7_pointer _p;
  s7_pointer min_width, min_height;
  _p = args;
  min_width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(min_width)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_new", 1, min_width, "int");
  min_height = s7_car(_p);
  if (!s7_is_integer(min_height)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_new", 2, min_height, "int");
  return(lg_make_c_pointer_with_type(sc, GdkToplevelLayout__sym, gdk_toplevel_layout_new((int)s7_integer(min_width), (int)s7_integer(min_height))));
}

static s7_pointer lg_gdk_toplevel_layout_ref(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_ref "GdkToplevelLayout* gdk_toplevel_layout_ref(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_ref", 1, layout, "GdkToplevelLayout*");
  return(lg_make_c_pointer_with_type(sc, GdkToplevelLayout__sym, gdk_toplevel_layout_ref((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_unref(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_unref "void gdk_toplevel_layout_unref(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_unref", 1, layout, "GdkToplevelLayout*");
  gdk_toplevel_layout_unref((GdkToplevelLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_layout_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_copy "GdkToplevelLayout* gdk_toplevel_layout_copy(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_copy", 1, layout, "GdkToplevelLayout*");
  return(lg_make_c_pointer_with_type(sc, GdkToplevelLayout__sym, gdk_toplevel_layout_copy((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_equal "gboolean gdk_toplevel_layout_equal(GdkToplevelLayout* layout, \
GdkToplevelLayout* other)"
  s7_pointer _p;
  s7_pointer layout, other;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_equal", 1, layout, "GdkToplevelLayout*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_equal", 2, other, "GdkToplevelLayout*");
  return(s7_make_boolean(sc, gdk_toplevel_layout_equal((GdkToplevelLayout*)s7_c_pointer(layout), (GdkToplevelLayout*)s7_c_pointer(other))));
}

static s7_pointer lg_gdk_toplevel_layout_set_maximized(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_set_maximized "void gdk_toplevel_layout_set_maximized(GdkToplevelLayout* layout, \
gboolean maximized)"
  s7_pointer _p;
  s7_pointer layout, maximized;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_maximized", 1, layout, "GdkToplevelLayout*");
  maximized = s7_car(_p);
  if (!s7_is_boolean(maximized)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_maximized", 2, maximized, "gboolean");
  gdk_toplevel_layout_set_maximized((GdkToplevelLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(maximized));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_layout_set_fullscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_set_fullscreen "void gdk_toplevel_layout_set_fullscreen(GdkToplevelLayout* layout, \
gboolean fullscreen, GdkMonitor* monitor)"
  s7_pointer _p;
  s7_pointer layout, fullscreen, monitor;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_fullscreen", 1, layout, "GdkToplevelLayout*");
  fullscreen = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_boolean(fullscreen)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_fullscreen", 2, fullscreen, "gboolean");
  monitor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(monitor, GdkMonitor__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_fullscreen", 3, monitor, "GdkMonitor*");
  gdk_toplevel_layout_set_fullscreen((GdkToplevelLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(fullscreen), (GdkMonitor*)s7_c_pointer(monitor));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_layout_get_min_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_get_min_width "int gdk_toplevel_layout_get_min_width(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_get_min_width", 1, layout, "GdkToplevelLayout*");
  return(s7_make_integer(sc, gdk_toplevel_layout_get_min_width((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_get_min_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_get_min_height "int gdk_toplevel_layout_get_min_height(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_get_min_height", 1, layout, "GdkToplevelLayout*");
  return(s7_make_integer(sc, gdk_toplevel_layout_get_min_height((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_get_maximized(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_get_maximized "gboolean gdk_toplevel_layout_get_maximized(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_get_maximized", 1, layout, "GdkToplevelLayout*");
  return(s7_make_boolean(sc, gdk_toplevel_layout_get_maximized((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_get_fullscreen(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_get_fullscreen "gboolean gdk_toplevel_layout_get_fullscreen(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_get_fullscreen", 1, layout, "GdkToplevelLayout*");
  return(s7_make_boolean(sc, gdk_toplevel_layout_get_fullscreen((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_get_fullscreen_monitor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_get_fullscreen_monitor "GdkMonitor* gdk_toplevel_layout_get_fullscreen_monitor(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_get_fullscreen_monitor", 1, layout, "GdkToplevelLayout*");
  return(lg_make_c_pointer_with_type(sc, GdkMonitor__sym, gdk_toplevel_layout_get_fullscreen_monitor((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_toplevel_layout_set_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_set_resizable "void gdk_toplevel_layout_set_resizable(GdkToplevelLayout* layout, \
gboolean resizable)"
  s7_pointer _p;
  s7_pointer layout, resizable;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_resizable", 1, layout, "GdkToplevelLayout*");
  resizable = s7_car(_p);
  if (!s7_is_boolean(resizable)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_set_resizable", 2, resizable, "gboolean");
  gdk_toplevel_layout_set_resizable((GdkToplevelLayout*)s7_c_pointer(layout), (gboolean)lg_boolean(resizable));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_layout_get_resizable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_layout_get_resizable "gboolean gdk_toplevel_layout_get_resizable(GdkToplevelLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GdkToplevelLayout__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_layout_get_resizable", 1, layout, "GdkToplevelLayout*");
  return(s7_make_boolean(sc, gdk_toplevel_layout_get_resizable((GdkToplevelLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gdk_surface_new_toplevel(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_new_toplevel "GdkSurface* gdk_surface_new_toplevel(GdkDisplay* display, int width, \
int height)"
  s7_pointer _p;
  s7_pointer display, width, height;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_new_toplevel", 1, display, "GdkDisplay*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_surface_new_toplevel", 2, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_surface_new_toplevel", 3, height, "int");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_surface_new_toplevel((GdkDisplay*)s7_c_pointer(display), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_gdk_surface_new_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_new_popup "GdkSurface* gdk_surface_new_popup(GdkSurface* parent, gboolean autohide)"
  s7_pointer _p;
  s7_pointer parent, autohide;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_new_popup", 1, parent, "GdkSurface*");
  autohide = s7_car(_p);
  if (!s7_is_boolean(autohide)) s7_wrong_type_arg_error(sc, "gdk_surface_new_popup", 2, autohide, "gboolean");
  return(lg_make_c_pointer_with_type(sc, GdkSurface__sym, gdk_surface_new_popup((GdkSurface*)s7_c_pointer(parent), (gboolean)lg_boolean(autohide))));
}

static s7_pointer lg_gdk_surface_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_destroy "void gdk_surface_destroy(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_destroy", 1, surface, "GdkSurface*");
  gdk_surface_destroy((GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_is_destroyed(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_is_destroyed "gboolean gdk_surface_is_destroyed(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_is_destroyed", 1, surface, "GdkSurface*");
  return(s7_make_boolean(sc, gdk_surface_is_destroyed((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_get_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_display "GdkDisplay* gdk_surface_get_display(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_display", 1, surface, "GdkSurface*");
  return(lg_make_c_pointer_with_type(sc, GdkDisplay__sym, gdk_surface_get_display((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_hide(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_hide "void gdk_surface_hide(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_hide", 1, surface, "GdkSurface*");
  gdk_surface_hide((GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_set_input_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_set_input_region "void gdk_surface_set_input_region(GdkSurface* surface, cairo_region_t* region)"
  s7_pointer _p;
  s7_pointer surface, region;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_input_region", 1, surface, "GdkSurface*");
  region = s7_car(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_input_region", 2, region, "cairo_region_t*");
  gdk_surface_set_input_region((GdkSurface*)s7_c_pointer(surface), (cairo_region_t*)s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_is_viewable(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_is_viewable "gboolean gdk_surface_is_viewable(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_is_viewable", 1, surface, "GdkSurface*");
  return(s7_make_boolean(sc, gdk_surface_is_viewable((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_get_mapped(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_mapped "gboolean gdk_surface_get_mapped(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_mapped", 1, surface, "GdkSurface*");
  return(s7_make_boolean(sc, gdk_surface_get_mapped((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_set_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_set_cursor "void gdk_surface_set_cursor(GdkSurface* surface, GdkCursor* cursor)"
  s7_pointer _p;
  s7_pointer surface, cursor;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_cursor", 1, surface, "GdkSurface*");
  cursor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_cursor", 2, cursor, "GdkCursor*");
  gdk_surface_set_cursor((GdkSurface*)s7_c_pointer(surface), (GdkCursor*)s7_c_pointer(cursor));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_get_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_cursor "GdkCursor* gdk_surface_get_cursor(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_cursor", 1, surface, "GdkSurface*");
  return(lg_make_c_pointer_with_type(sc, GdkCursor__sym, gdk_surface_get_cursor((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_set_device_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_set_device_cursor "void gdk_surface_set_device_cursor(GdkSurface* surface, GdkDevice* device, \
GdkCursor* cursor)"
  s7_pointer _p;
  s7_pointer surface, device, cursor;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_device_cursor", 1, surface, "GdkSurface*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_device_cursor", 2, device, "GdkDevice*");
  cursor = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cursor, GdkCursor__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_device_cursor", 3, cursor, "GdkCursor*");
  gdk_surface_set_device_cursor((GdkSurface*)s7_c_pointer(surface), (GdkDevice*)s7_c_pointer(device), (GdkCursor*)s7_c_pointer(cursor));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_get_device_cursor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_device_cursor "GdkCursor* gdk_surface_get_device_cursor(GdkSurface* surface, \
GdkDevice* device)"
  s7_pointer _p;
  s7_pointer surface, device;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_cursor", 1, surface, "GdkSurface*");
  device = s7_car(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_cursor", 2, device, "GdkDevice*");
  return(lg_make_c_pointer_with_type(sc, GdkCursor__sym, gdk_surface_get_device_cursor((GdkSurface*)s7_c_pointer(surface), (GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_surface_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_width "int gdk_surface_get_width(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_width", 1, surface, "GdkSurface*");
  return(s7_make_integer(sc, gdk_surface_get_width((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_height "int gdk_surface_get_height(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_height", 1, surface, "GdkSurface*");
  return(s7_make_integer(sc, gdk_surface_get_height((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_translate_coordinates(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_translate_coordinates "gboolean gdk_surface_translate_coordinates(GdkSurface* from, \
GdkSurface* to, double* x, double* y)"
  s7_pointer _p;
  s7_pointer from, to, x, y;
  _p = args;
  from = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(from, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_translate_coordinates", 1, from, "GdkSurface*");
  to = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(to, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_translate_coordinates", 2, to, "GdkSurface*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(x, double__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_translate_coordinates", 3, x, "double*");
  y = s7_car(_p);
  if (!s7_is_c_pointer_of_type(y, double__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_translate_coordinates", 4, y, "double*");
  return(s7_make_boolean(sc, gdk_surface_translate_coordinates((GdkSurface*)s7_c_pointer(from), (GdkSurface*)s7_c_pointer(to), (double*)s7_c_pointer(x), (double*)s7_c_pointer(y))));
}

static s7_pointer lg_gdk_surface_get_scale_factor(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_scale_factor "gint gdk_surface_get_scale_factor(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_scale_factor", 1, surface, "GdkSurface*");
  return(s7_make_integer(sc, gdk_surface_get_scale_factor((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_get_device_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_device_position "void gdk_surface_get_device_position(GdkSurface* surface, \
GdkDevice* device, double* x, double* y, GdkModifierType* mask)"
  s7_pointer _p;
  s7_pointer surface, device, x, y, mask;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_position", 1, surface, "GdkSurface*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_position", 2, device, "GdkDevice*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(x, double__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_position", 3, x, "double*");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(y, double__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_position", 4, y, "double*");
  mask = s7_car(_p);
  if (!s7_is_c_pointer_of_type(mask, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_device_position", 5, mask, "GdkModifierType*");
  gdk_surface_get_device_position((GdkSurface*)s7_c_pointer(surface), (GdkDevice*)s7_c_pointer(device), (double*)s7_c_pointer(x), (double*)s7_c_pointer(y), (GdkModifierType*)s7_c_pointer(mask));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_create_similar_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_create_similar_surface "cairo_surface_t* gdk_surface_create_similar_surface(GdkSurface* surface, \
cairo_content_t content, int width, int height)"
  s7_pointer _p;
  s7_pointer surface, content, width, height;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_create_similar_surface", 1, surface, "GdkSurface*");
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "gdk_surface_create_similar_surface", 2, content, "cairo_content_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gdk_surface_create_similar_surface", 3, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gdk_surface_create_similar_surface", 4, height, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, gdk_surface_create_similar_surface((GdkSurface*)s7_c_pointer(surface), (cairo_content_t)s7_integer(content), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_gdk_surface_beep(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_beep "void gdk_surface_beep(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_beep", 1, surface, "GdkSurface*");
  gdk_surface_beep((GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_begin_resize_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_begin_resize_drag "void gdk_surface_begin_resize_drag(GdkSurface* surface, GdkSurfaceEdge edge, \
GdkDevice* device, gint button, gint x, gint y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer surface, edge, device, button, x, y, timestamp;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 1, surface, "GdkSurface*");
  edge = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(edge)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 2, edge, "GdkSurfaceEdge");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 3, device, "GdkDevice*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 4, button, "gint");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 5, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 6, y, "gint");
  timestamp = s7_car(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_resize_drag", 7, timestamp, "guint32");
  gdk_surface_begin_resize_drag((GdkSurface*)s7_c_pointer(surface), (GdkSurfaceEdge)s7_integer(edge), (GdkDevice*)s7_c_pointer(device), (gint)s7_integer(button), (gint)s7_integer(x), (gint)s7_integer(y), (guint32)s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_begin_move_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_begin_move_drag "void gdk_surface_begin_move_drag(GdkSurface* surface, GdkDevice* device, \
gint button, gint x, gint y, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer surface, device, button, x, y, timestamp;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_move_drag", 1, surface, "GdkSurface*");
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_move_drag", 2, device, "GdkDevice*");
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(button)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_move_drag", 3, button, "gint");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_move_drag", 4, x, "gint");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_move_drag", 5, y, "gint");
  timestamp = s7_car(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gdk_surface_begin_move_drag", 6, timestamp, "guint32");
  gdk_surface_begin_move_drag((GdkSurface*)s7_c_pointer(surface), (GdkDevice*)s7_c_pointer(device), (gint)s7_integer(button), (gint)s7_integer(x), (gint)s7_integer(y), (guint32)s7_integer(timestamp));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_queue_expose(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_queue_expose "void gdk_surface_queue_expose(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_queue_expose", 1, surface, "GdkSurface*");
  gdk_surface_queue_expose((GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_freeze_updates(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_freeze_updates "void gdk_surface_freeze_updates(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_freeze_updates", 1, surface, "GdkSurface*");
  gdk_surface_freeze_updates((GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_thaw_updates(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_thaw_updates "void gdk_surface_thaw_updates(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_thaw_updates", 1, surface, "GdkSurface*");
  gdk_surface_thaw_updates((GdkSurface*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_set_support_multidevice(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_set_support_multidevice "void gdk_surface_set_support_multidevice(GdkSurface* surface, \
gboolean support_multidevice)"
  s7_pointer _p;
  s7_pointer surface, support_multidevice;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_support_multidevice", 1, surface, "GdkSurface*");
  support_multidevice = s7_car(_p);
  if (!s7_is_boolean(support_multidevice)) s7_wrong_type_arg_error(sc, "gdk_surface_set_support_multidevice", 2, support_multidevice, "gboolean");
  gdk_surface_set_support_multidevice((GdkSurface*)s7_c_pointer(surface), (gboolean)lg_boolean(support_multidevice));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_get_support_multidevice(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_support_multidevice "gboolean gdk_surface_get_support_multidevice(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_support_multidevice", 1, surface, "GdkSurface*");
  return(s7_make_boolean(sc, gdk_surface_get_support_multidevice((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_get_frame_clock(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_get_frame_clock "GdkFrameClock* gdk_surface_get_frame_clock(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_get_frame_clock", 1, surface, "GdkSurface*");
  return(lg_make_c_pointer_with_type(sc, GdkFrameClock__sym, gdk_surface_get_frame_clock((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_set_opaque_region(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_set_opaque_region "void gdk_surface_set_opaque_region(GdkSurface* surface, cairo_region_t* region)"
  s7_pointer _p;
  s7_pointer surface, region;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_opaque_region", 1, surface, "GdkSurface*");
  region = s7_car(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_opaque_region", 2, region, "cairo_region_t*");
  gdk_surface_set_opaque_region((GdkSurface*)s7_c_pointer(surface), (cairo_region_t*)s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_set_shadow_width(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_set_shadow_width "void gdk_surface_set_shadow_width(GdkSurface* surface, gint left, \
gint right, gint top, gint bottom)"
  s7_pointer _p;
  s7_pointer surface, left, right, top, bottom;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_set_shadow_width", 1, surface, "GdkSurface*");
  left = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(left)) s7_wrong_type_arg_error(sc, "gdk_surface_set_shadow_width", 2, left, "gint");
  right = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(right)) s7_wrong_type_arg_error(sc, "gdk_surface_set_shadow_width", 3, right, "gint");
  top = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(top)) s7_wrong_type_arg_error(sc, "gdk_surface_set_shadow_width", 4, top, "gint");
  bottom = s7_car(_p);
  if (!s7_is_integer(bottom)) s7_wrong_type_arg_error(sc, "gdk_surface_set_shadow_width", 5, bottom, "gint");
  gdk_surface_set_shadow_width((GdkSurface*)s7_c_pointer(surface), (gint)s7_integer(left), (gint)s7_integer(right), (gint)s7_integer(top), (gint)s7_integer(bottom));
  return(lg_false);
}

static s7_pointer lg_gdk_surface_create_cairo_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_create_cairo_context "GdkCairoContext* gdk_surface_create_cairo_context(GdkSurface* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_create_cairo_context", 1, surface, "GdkSurface*");
  return(lg_make_c_pointer_with_type(sc, GdkCairoContext__sym, gdk_surface_create_cairo_context((GdkSurface*)s7_c_pointer(surface))));
}

static s7_pointer lg_gdk_surface_create_gl_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_create_gl_context "GdkGLContext* gdk_surface_create_gl_context(GdkSurface* surface, \
GError** error)"
  s7_pointer _p;
  s7_pointer surface, error;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_create_gl_context", 1, surface, "GdkSurface*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gdk_surface_create_gl_context", 2, error, "GError**");
  return(lg_make_c_pointer_with_type(sc, GdkGLContext__sym, gdk_surface_create_gl_context((GdkSurface*)s7_c_pointer(surface), (GError**)s7_c_pointer(error))));
}

static s7_pointer lg_gdk_surface_create_vulkan_context(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_surface_create_vulkan_context "GdkVulkanContext* gdk_surface_create_vulkan_context(GdkSurface* surface, \
GError** error)"
  s7_pointer _p;
  s7_pointer surface, error;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, GdkSurface__sym)) s7_wrong_type_arg_error(sc, "gdk_surface_create_vulkan_context", 1, surface, "GdkSurface*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gdk_surface_create_vulkan_context", 2, error, "GError**");
  return(lg_make_c_pointer_with_type(sc, GdkVulkanContext__sym, gdk_surface_create_vulkan_context((GdkSurface*)s7_c_pointer(surface), (GError**)s7_c_pointer(error))));
}

static s7_pointer lg_gboolean(s7_scheme *sc, s7_pointer args)
{
  #define H_gboolean " gboolean(gtk_event_controller_motion_contains_pointer GtkEventControllerMotion*, \
self)"
  s7_pointer GtkEventControllerMotion*;
  GtkEventControllerMotion* = s7_car(args);
  if (!s7_is_c_pointer_of_type(GtkEventControllerMotion*, gtk_event_controller_motion_contains_pointer_sym)) s7_wrong_type_arg_error(sc, "gboolean", 1, GtkEventControllerMotion*, "gtk_event_controller_motion_contains_pointer");
  return(lg_make_c_pointer_with_type(sc, _sym, gboolean((gtk_event_controller_motion_contains_pointer)s7_c_pointer(GtkEventControllerMotion*))));
}

static s7_pointer lg_gtk_calendar_get_type(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_type "GType gtk_calendar_get_type( void)"
  return(s7_make_integer(sc, gtk_calendar_get_type()));
}

static s7_pointer lg_gtk_calendar_set_show_week_numbers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_show_week_numbers "void gtk_calendar_set_show_week_numbers(GtkCalendar* self, \
gboolean value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_show_week_numbers", 1, self, "GtkCalendar*");
  value = s7_car(_p);
  if (!s7_is_boolean(value)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_show_week_numbers", 2, value, "gboolean");
  gtk_calendar_set_show_week_numbers((GtkCalendar*)s7_c_pointer(self), (gboolean)lg_boolean(value));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_show_week_numbers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_show_week_numbers "gboolean gtk_calendar_get_show_week_numbers(GtkCalendar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_show_week_numbers", 1, self, "GtkCalendar*");
  return(s7_make_boolean(sc, gtk_calendar_get_show_week_numbers((GtkCalendar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_calendar_set_show_heading(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_show_heading "void gtk_calendar_set_show_heading(GtkCalendar* self, gboolean value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_show_heading", 1, self, "GtkCalendar*");
  value = s7_car(_p);
  if (!s7_is_boolean(value)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_show_heading", 2, value, "gboolean");
  gtk_calendar_set_show_heading((GtkCalendar*)s7_c_pointer(self), (gboolean)lg_boolean(value));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_show_heading(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_show_heading "gboolean gtk_calendar_get_show_heading(GtkCalendar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_show_heading", 1, self, "GtkCalendar*");
  return(s7_make_boolean(sc, gtk_calendar_get_show_heading((GtkCalendar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_calendar_set_show_day_names(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_set_show_day_names "void gtk_calendar_set_show_day_names(GtkCalendar* self, \
gboolean value)"
  s7_pointer _p;
  s7_pointer self, value;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_show_day_names", 1, self, "GtkCalendar*");
  value = s7_car(_p);
  if (!s7_is_boolean(value)) s7_wrong_type_arg_error(sc, "gtk_calendar_set_show_day_names", 2, value, "gboolean");
  gtk_calendar_set_show_day_names((GtkCalendar*)s7_c_pointer(self), (gboolean)lg_boolean(value));
  return(lg_false);
}

static s7_pointer lg_gtk_calendar_get_show_day_names(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_calendar_get_show_day_names "gboolean gtk_calendar_get_show_day_names(GtkCalendar* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkCalendar__sym)) s7_wrong_type_arg_error(sc, "gtk_calendar_get_show_day_names", 1, self, "GtkCalendar*");
  return(s7_make_boolean(sc, gtk_calendar_get_show_day_names((GtkCalendar*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_constraint_guide_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_new "GtkConstraintGuide* gtk_constraint_guide_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkConstraintGuide__sym, gtk_constraint_guide_new()));
}

static s7_pointer lg_gtk_constraint_guide_set_min_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_set_min_size "void gtk_constraint_guide_set_min_size(GtkConstraintGuide* guide, \
int width, int height)"
  s7_pointer _p;
  s7_pointer guide, width, height;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_min_size", 1, guide, "GtkConstraintGuide*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_min_size", 2, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_min_size", 3, height, "int");
  gtk_constraint_guide_set_min_size((GtkConstraintGuide*)s7_c_pointer(guide), (int)s7_integer(width), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_get_min_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_get_min_size "void gtk_constraint_guide_get_min_size(GtkConstraintGuide* guide, \
int* width, int* height)"
  s7_pointer _p;
  s7_pointer guide, width, height;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_min_size", 1, guide, "GtkConstraintGuide*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(width, int__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_min_size", 2, width, "int*");
  height = s7_car(_p);
  if (!s7_is_c_pointer_of_type(height, int__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_min_size", 3, height, "int*");
  gtk_constraint_guide_get_min_size((GtkConstraintGuide*)s7_c_pointer(guide), (int*)s7_c_pointer(width), (int*)s7_c_pointer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_set_nat_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_set_nat_size "void gtk_constraint_guide_set_nat_size(GtkConstraintGuide* guide, \
int width, int height)"
  s7_pointer _p;
  s7_pointer guide, width, height;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_nat_size", 1, guide, "GtkConstraintGuide*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_nat_size", 2, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_nat_size", 3, height, "int");
  gtk_constraint_guide_set_nat_size((GtkConstraintGuide*)s7_c_pointer(guide), (int)s7_integer(width), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_get_nat_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_get_nat_size "void gtk_constraint_guide_get_nat_size(GtkConstraintGuide* guide, \
int* width, int* height)"
  s7_pointer _p;
  s7_pointer guide, width, height;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_nat_size", 1, guide, "GtkConstraintGuide*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(width, int__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_nat_size", 2, width, "int*");
  height = s7_car(_p);
  if (!s7_is_c_pointer_of_type(height, int__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_nat_size", 3, height, "int*");
  gtk_constraint_guide_get_nat_size((GtkConstraintGuide*)s7_c_pointer(guide), (int*)s7_c_pointer(width), (int*)s7_c_pointer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_set_max_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_set_max_size "void gtk_constraint_guide_set_max_size(GtkConstraintGuide* guide, \
int width, int height)"
  s7_pointer _p;
  s7_pointer guide, width, height;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_max_size", 1, guide, "GtkConstraintGuide*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_max_size", 2, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_max_size", 3, height, "int");
  gtk_constraint_guide_set_max_size((GtkConstraintGuide*)s7_c_pointer(guide), (int)s7_integer(width), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_get_max_size(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_get_max_size "void gtk_constraint_guide_get_max_size(GtkConstraintGuide* guide, \
int* width, int* height)"
  s7_pointer _p;
  s7_pointer guide, width, height;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_max_size", 1, guide, "GtkConstraintGuide*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(width, int__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_max_size", 2, width, "int*");
  height = s7_car(_p);
  if (!s7_is_c_pointer_of_type(height, int__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_max_size", 3, height, "int*");
  gtk_constraint_guide_get_max_size((GtkConstraintGuide*)s7_c_pointer(guide), (int*)s7_c_pointer(width), (int*)s7_c_pointer(height));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_get_strength(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_get_strength "GtkConstraintStrength gtk_constraint_guide_get_strength(GtkConstraintGuide* guide)"
  s7_pointer guide;
  guide = s7_car(args);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_strength", 1, guide, "GtkConstraintGuide*");
  return(s7_make_integer(sc, gtk_constraint_guide_get_strength((GtkConstraintGuide*)s7_c_pointer(guide))));
}

static s7_pointer lg_gtk_constraint_guide_set_strength(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_set_strength "void gtk_constraint_guide_set_strength(GtkConstraintGuide* guide, \
GtkConstraintStrength strength)"
  s7_pointer _p;
  s7_pointer guide, strength;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_strength", 1, guide, "GtkConstraintGuide*");
  strength = s7_car(_p);
  if (!s7_is_integer(strength)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_strength", 2, strength, "GtkConstraintStrength");
  gtk_constraint_guide_set_strength((GtkConstraintGuide*)s7_c_pointer(guide), (GtkConstraintStrength)s7_integer(strength));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_set_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_set_name "void gtk_constraint_guide_set_name(GtkConstraintGuide* guide, \
char* name)"
  s7_pointer _p;
  s7_pointer guide, name;
  _p = args;
  guide = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_name", 1, guide, "GtkConstraintGuide*");
  name = s7_car(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_set_name", 2, name, "char*");
  gtk_constraint_guide_set_name((GtkConstraintGuide*)s7_c_pointer(guide), (const char*)(char*)s7_string(name));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_guide_get_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_guide_get_name "char* gtk_constraint_guide_get_name(GtkConstraintGuide* guide)"
  s7_pointer guide;
  guide = s7_car(args);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_guide_get_name", 1, guide, "GtkConstraintGuide*");
    return(s7_make_string(sc, (char*)gtk_constraint_guide_get_name((GtkConstraintGuide*)s7_c_pointer(guide))));
}

static s7_pointer lg_gtk_icon_theme_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_new "GtkIconTheme* gtk_icon_theme_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkIconTheme__sym, gtk_icon_theme_new()));
}

static s7_pointer lg_gtk_icon_theme_get_for_display(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_for_display "GtkIconTheme* gtk_icon_theme_get_for_display(GdkDisplay* display)"
  s7_pointer display;
  display = s7_car(args);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_for_display", 1, display, "GdkDisplay*");
  return(lg_make_c_pointer_with_type(sc, GtkIconTheme__sym, gtk_icon_theme_get_for_display((GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_icon_theme_set_search_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_set_search_path "void gtk_icon_theme_set_search_path(GtkIconTheme* self, char* path)"
  s7_pointer _p;
  s7_pointer self, path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_search_path", 1, self, "GtkIconTheme*");
  path = s7_car(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_search_path", 2, path, "char*");
  gtk_icon_theme_set_search_path((GtkIconTheme*)s7_c_pointer(self), (const char*)(char*)s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_get_search_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_search_path "char** gtk_icon_theme_get_search_path(GtkIconTheme* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_search_path", 1, self, "GtkIconTheme*");
  return(lg_make_c_pointer_with_type(sc, char___sym, gtk_icon_theme_get_search_path((GtkIconTheme*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_icon_theme_add_search_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_add_search_path "void gtk_icon_theme_add_search_path(GtkIconTheme* self, char* path)"
  s7_pointer _p;
  s7_pointer self, path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_add_search_path", 1, self, "GtkIconTheme*");
  path = s7_car(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_add_search_path", 2, path, "char*");
  gtk_icon_theme_add_search_path((GtkIconTheme*)s7_c_pointer(self), (const char*)(char*)s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_set_resource_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_set_resource_path "void gtk_icon_theme_set_resource_path(GtkIconTheme* self, \
char* path)"
  s7_pointer _p;
  s7_pointer self, path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_resource_path", 1, self, "GtkIconTheme*");
  path = s7_car(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_resource_path", 2, path, "char*");
  gtk_icon_theme_set_resource_path((GtkIconTheme*)s7_c_pointer(self), (const char*)(char*)s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_get_resource_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_resource_path "char** gtk_icon_theme_get_resource_path(GtkIconTheme* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_resource_path", 1, self, "GtkIconTheme*");
  return(lg_make_c_pointer_with_type(sc, char___sym, gtk_icon_theme_get_resource_path((GtkIconTheme*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_icon_theme_add_resource_path(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_add_resource_path "void gtk_icon_theme_add_resource_path(GtkIconTheme* self, \
char* path)"
  s7_pointer _p;
  s7_pointer self, path;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_add_resource_path", 1, self, "GtkIconTheme*");
  path = s7_car(_p);
  if (!s7_is_string(path)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_add_resource_path", 2, path, "char*");
  gtk_icon_theme_add_resource_path((GtkIconTheme*)s7_c_pointer(self), (const char*)(char*)s7_string(path));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_set_theme_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_set_theme_name "void gtk_icon_theme_set_theme_name(GtkIconTheme* self, char* theme_name)"
  s7_pointer _p;
  s7_pointer self, theme_name;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_theme_name", 1, self, "GtkIconTheme*");
  theme_name = s7_car(_p);
  if (!s7_is_string(theme_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_set_theme_name", 2, theme_name, "char*");
  gtk_icon_theme_set_theme_name((GtkIconTheme*)s7_c_pointer(self), (const char*)(char*)s7_string(theme_name));
  return(lg_false);
}

static s7_pointer lg_gtk_icon_theme_get_theme_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_theme_name "char* gtk_icon_theme_get_theme_name(GtkIconTheme* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_theme_name", 1, self, "GtkIconTheme*");
  return(s7_make_string(sc, gtk_icon_theme_get_theme_name((GtkIconTheme*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_icon_theme_has_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_has_icon "gboolean gtk_icon_theme_has_icon(GtkIconTheme* self, gchar* icon_name)"
  s7_pointer _p;
  s7_pointer self, icon_name;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_has_icon", 1, self, "GtkIconTheme*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_has_icon", 2, icon_name, "gchar*");
  return(s7_make_boolean(sc, gtk_icon_theme_has_icon((GtkIconTheme*)s7_c_pointer(self), (const gchar*)s7_string(icon_name))));
}

static s7_pointer lg_gtk_icon_theme_get_icon_sizes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_icon_sizes "gint* gtk_icon_theme_get_icon_sizes(GtkIconTheme* self, gchar* icon_name)"
  s7_pointer _p;
  s7_pointer self, icon_name;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_icon_sizes", 1, self, "GtkIconTheme*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_icon_sizes", 2, icon_name, "gchar*");
  return(lg_make_c_pointer_with_type(sc, gint__sym, gtk_icon_theme_get_icon_sizes((GtkIconTheme*)s7_c_pointer(self), (const gchar*)s7_string(icon_name))));
}

static s7_pointer lg_gtk_icon_theme_lookup_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_lookup_icon "GtkIconPaintable* gtk_icon_theme_lookup_icon(GtkIconTheme* self, \
char* icon_name, char* fallbacks, gint size, gint scale, GtkTextDirection direction, GtkIconLookupFlags flags)"
  s7_pointer _p;
  s7_pointer self, icon_name, fallbacks, size, scale, direction, flags;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 1, self, "GtkIconTheme*");
  icon_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 2, icon_name, "char*");
  fallbacks = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(fallbacks)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 3, fallbacks, "char*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 4, size, "gint");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 5, scale, "gint");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 6, direction, "GtkTextDirection");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_icon", 7, flags, "GtkIconLookupFlags");
  return(lg_make_c_pointer_with_type(sc, GtkIconPaintable__sym, gtk_icon_theme_lookup_icon((GtkIconTheme*)s7_c_pointer(self), (char*)s7_string(icon_name), (char*)s7_string(fallbacks), (gint)s7_integer(size), (gint)s7_integer(scale), (GtkTextDirection)s7_integer(direction), (GtkIconLookupFlags)s7_integer(flags))));
}

static s7_pointer lg_gtk_icon_theme_lookup_by_gicon(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_lookup_by_gicon "GtkIconPaintable* gtk_icon_theme_lookup_by_gicon(GtkIconTheme* self, \
GIcon* icon, gint size, gint scale, GtkTextDirection direction, GtkIconLookupFlags flags)"
  s7_pointer _p;
  s7_pointer self, icon, size, scale, direction, flags;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 1, self, "GtkIconTheme*");
  icon = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 2, icon, "GIcon*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 3, size, "gint");
  scale = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 4, scale, "gint");
  direction = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(direction)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 5, direction, "GtkTextDirection");
  flags = s7_car(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_lookup_by_gicon", 6, flags, "GtkIconLookupFlags");
  return(lg_make_c_pointer_with_type(sc, GtkIconPaintable__sym, gtk_icon_theme_lookup_by_gicon((GtkIconTheme*)s7_c_pointer(self), (GIcon*)s7_c_pointer(icon), (gint)s7_integer(size), (gint)s7_integer(scale), (GtkTextDirection)s7_integer(direction), (GtkIconLookupFlags)s7_integer(flags))));
}

static s7_pointer lg_gtk_icon_paintable_new_for_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_paintable_new_for_file "GtkIconPaintable* gtk_icon_paintable_new_for_file(GFile* file, \
gint size, gint scale)"
  s7_pointer _p;
  s7_pointer file, size, scale;
  _p = args;
  file = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_paintable_new_for_file", 1, file, "GFile*");
  size = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(size)) s7_wrong_type_arg_error(sc, "gtk_icon_paintable_new_for_file", 2, size, "gint");
  scale = s7_car(_p);
  if (!s7_is_integer(scale)) s7_wrong_type_arg_error(sc, "gtk_icon_paintable_new_for_file", 3, scale, "gint");
  return(lg_make_c_pointer_with_type(sc, GtkIconPaintable__sym, gtk_icon_paintable_new_for_file((GFile*)s7_c_pointer(file), (gint)s7_integer(size), (gint)s7_integer(scale))));
}

static s7_pointer lg_gtk_icon_theme_get_icon_names(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_theme_get_icon_names "char** gtk_icon_theme_get_icon_names(GtkIconTheme* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconTheme__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_theme_get_icon_names", 1, self, "GtkIconTheme*");
  return(lg_make_c_pointer_with_type(sc, char___sym, gtk_icon_theme_get_icon_names((GtkIconTheme*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_icon_paintable_get_file(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_paintable_get_file "GFile* gtk_icon_paintable_get_file(GtkIconPaintable* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_paintable_get_file", 1, self, "GtkIconPaintable*");
  return(lg_make_c_pointer_with_type(sc, GFile__sym, gtk_icon_paintable_get_file((GtkIconPaintable*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_icon_paintable_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_paintable_get_icon_name "gchar* gtk_icon_paintable_get_icon_name(GtkIconPaintable* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_paintable_get_icon_name", 1, self, "GtkIconPaintable*");
    return(s7_make_string(sc, (gchar*)gtk_icon_paintable_get_icon_name((GtkIconPaintable*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_icon_paintable_is_symbolic(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_icon_paintable_is_symbolic "gboolean gtk_icon_paintable_is_symbolic(GtkIconPaintable* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkIconPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_icon_paintable_is_symbolic", 1, self, "GtkIconPaintable*");
  return(s7_make_boolean(sc, gtk_icon_paintable_is_symbolic((GtkIconPaintable*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_constraint_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_new "GtkConstraint* gtk_constraint_new(gpointer target, GtkConstraintAttribute target_attribute, \
GtkConstraintRelation relation, gpointer source, GtkConstraintAttribute source_attribute, double multiplier, \
double constant, int strength)"
  s7_pointer _p;
  s7_pointer target, target_attribute, relation, source, source_attribute, multiplier, constant, strength;
  _p = args;
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 1, target, "gpointer");
  target_attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(target_attribute)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 2, target_attribute, "GtkConstraintAttribute");
  relation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(relation)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 3, relation, "GtkConstraintRelation");
  source = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(source, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 4, source, "gpointer");
  source_attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(source_attribute)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 5, source_attribute, "GtkConstraintAttribute");
  multiplier = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(multiplier)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 6, multiplier, "double");
  constant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(constant)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 7, constant, "double");
  strength = s7_car(_p);
  if (!s7_is_integer(strength)) s7_wrong_type_arg_error(sc, "gtk_constraint_new", 8, strength, "int");
  return(lg_make_c_pointer_with_type(sc, GtkConstraint__sym, gtk_constraint_new((gpointer)s7_c_pointer(target), (GtkConstraintAttribute)s7_integer(target_attribute), (GtkConstraintRelation)s7_integer(relation), (gpointer)s7_c_pointer(source), (GtkConstraintAttribute)s7_integer(source_attribute), (double)s7_real(multiplier), (double)s7_real(constant), (int)s7_integer(strength))));
}

static s7_pointer lg_gtk_constraint_new_constant(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_new_constant "GtkConstraint* gtk_constraint_new_constant(gpointer target, \
GtkConstraintAttribute target_attribute, GtkConstraintRelation relation, double constant, int strength)"
  s7_pointer _p;
  s7_pointer target, target_attribute, relation, constant, strength;
  _p = args;
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_new_constant", 1, target, "gpointer");
  target_attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(target_attribute)) s7_wrong_type_arg_error(sc, "gtk_constraint_new_constant", 2, target_attribute, "GtkConstraintAttribute");
  relation = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(relation)) s7_wrong_type_arg_error(sc, "gtk_constraint_new_constant", 3, relation, "GtkConstraintRelation");
  constant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(constant)) s7_wrong_type_arg_error(sc, "gtk_constraint_new_constant", 4, constant, "double");
  strength = s7_car(_p);
  if (!s7_is_integer(strength)) s7_wrong_type_arg_error(sc, "gtk_constraint_new_constant", 5, strength, "int");
  return(lg_make_c_pointer_with_type(sc, GtkConstraint__sym, gtk_constraint_new_constant((gpointer)s7_c_pointer(target), (GtkConstraintAttribute)s7_integer(target_attribute), (GtkConstraintRelation)s7_integer(relation), (double)s7_real(constant), (int)s7_integer(strength))));
}

static s7_pointer lg_gtk_constraint_get_target(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_target "GtkConstraintTarget* gtk_constraint_get_target(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_target", 1, constraint, "GtkConstraint*");
  return(lg_make_c_pointer_with_type(sc, GtkConstraintTarget__sym, gtk_constraint_get_target((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_target_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_target_attribute "GtkConstraintAttribute gtk_constraint_get_target_attribute(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_target_attribute", 1, constraint, "GtkConstraint*");
  return(s7_make_integer(sc, gtk_constraint_get_target_attribute((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_source(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_source "GtkConstraintTarget* gtk_constraint_get_source(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_source", 1, constraint, "GtkConstraint*");
  return(lg_make_c_pointer_with_type(sc, GtkConstraintTarget__sym, gtk_constraint_get_source((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_source_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_source_attribute "GtkConstraintAttribute gtk_constraint_get_source_attribute(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_source_attribute", 1, constraint, "GtkConstraint*");
  return(s7_make_integer(sc, gtk_constraint_get_source_attribute((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_relation(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_relation "GtkConstraintRelation gtk_constraint_get_relation(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_relation", 1, constraint, "GtkConstraint*");
  return(s7_make_integer(sc, gtk_constraint_get_relation((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_multiplier(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_multiplier "double gtk_constraint_get_multiplier(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_multiplier", 1, constraint, "GtkConstraint*");
  return(s7_make_real(sc, gtk_constraint_get_multiplier((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_constant(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_constant "double gtk_constraint_get_constant(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_constant", 1, constraint, "GtkConstraint*");
  return(s7_make_real(sc, gtk_constraint_get_constant((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_get_strength(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_get_strength "int gtk_constraint_get_strength(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_get_strength", 1, constraint, "GtkConstraint*");
  return(s7_make_integer(sc, gtk_constraint_get_strength((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_is_required(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_is_required "gboolean gtk_constraint_is_required(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_is_required", 1, constraint, "GtkConstraint*");
  return(s7_make_boolean(sc, gtk_constraint_is_required((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_is_attached(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_is_attached "gboolean gtk_constraint_is_attached(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_is_attached", 1, constraint, "GtkConstraint*");
  return(s7_make_boolean(sc, gtk_constraint_is_attached((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_is_constant(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_is_constant "gboolean gtk_constraint_is_constant(GtkConstraint* constraint)"
  s7_pointer constraint;
  constraint = s7_car(args);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_is_constant", 1, constraint, "GtkConstraint*");
  return(s7_make_boolean(sc, gtk_constraint_is_constant((GtkConstraint*)s7_c_pointer(constraint))));
}

static s7_pointer lg_gtk_constraint_layout_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_new "GtkLayoutManager* gtk_constraint_layout_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkLayoutManager__sym, gtk_constraint_layout_new()));
}

static s7_pointer lg_gtk_constraint_layout_add_constraint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_add_constraint "void gtk_constraint_layout_add_constraint(GtkConstraintLayout* layout, \
GtkConstraint* constraint)"
  s7_pointer _p;
  s7_pointer layout, constraint;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraint", 1, layout, "GtkConstraintLayout*");
  constraint = s7_car(_p);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraint", 2, constraint, "GtkConstraint*");
  gtk_constraint_layout_add_constraint((GtkConstraintLayout*)s7_c_pointer(layout), (GtkConstraint*)s7_c_pointer(constraint));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_layout_remove_constraint(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_remove_constraint "void gtk_constraint_layout_remove_constraint(GtkConstraintLayout* layout, \
GtkConstraint* constraint)"
  s7_pointer _p;
  s7_pointer layout, constraint;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_remove_constraint", 1, layout, "GtkConstraintLayout*");
  constraint = s7_car(_p);
  if (!s7_is_c_pointer_of_type(constraint, GtkConstraint__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_remove_constraint", 2, constraint, "GtkConstraint*");
  gtk_constraint_layout_remove_constraint((GtkConstraintLayout*)s7_c_pointer(layout), (GtkConstraint*)s7_c_pointer(constraint));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_layout_add_guide(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_add_guide "void gtk_constraint_layout_add_guide(GtkConstraintLayout* layout, \
GtkConstraintGuide* guide)"
  s7_pointer _p;
  s7_pointer layout, guide;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_guide", 1, layout, "GtkConstraintLayout*");
  guide = s7_car(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_guide", 2, guide, "GtkConstraintGuide*");
  gtk_constraint_layout_add_guide((GtkConstraintLayout*)s7_c_pointer(layout), (GtkConstraintGuide*)s7_c_pointer(guide));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_layout_remove_guide(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_remove_guide "void gtk_constraint_layout_remove_guide(GtkConstraintLayout* layout, \
GtkConstraintGuide* guide)"
  s7_pointer _p;
  s7_pointer layout, guide;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_remove_guide", 1, layout, "GtkConstraintLayout*");
  guide = s7_car(_p);
  if (!s7_is_c_pointer_of_type(guide, GtkConstraintGuide__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_remove_guide", 2, guide, "GtkConstraintGuide*");
  gtk_constraint_layout_remove_guide((GtkConstraintLayout*)s7_c_pointer(layout), (GtkConstraintGuide*)s7_c_pointer(guide));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_layout_remove_all_constraints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_remove_all_constraints "void gtk_constraint_layout_remove_all_constraints(GtkConstraintLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_remove_all_constraints", 1, layout, "GtkConstraintLayout*");
  gtk_constraint_layout_remove_all_constraints((GtkConstraintLayout*)s7_c_pointer(layout));
  return(lg_false);
}

static s7_pointer lg_gtk_constraint_layout_add_constraints_from_description(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_add_constraints_from_description "GList* gtk_constraint_layout_add_constraints_from_description(GtkConstraintLayout* layout, \
char* lines, gsize n_lines, int hspacing, int vspacing, GError** error, char* first_view, ...)"
  s7_pointer _p;
  s7_pointer layout, lines, n_lines, hspacing, vspacing, error, first_view;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 1, layout, "GtkConstraintLayout*");
  lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(lines)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 2, lines, "char*");
  n_lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_lines)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 3, n_lines, "gsize");
  hspacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hspacing)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 4, hspacing, "int");
  vspacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(vspacing)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 5, vspacing, "int");
  error = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 6, error, "GError**");
  first_view = s7_car(_p);
  if (!s7_is_string(first_view)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_description", 7, first_view, "char*");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_constraint_layout_add_constraints_from_description((GtkConstraintLayout*)s7_c_pointer(layout), (char*)s7_string(lines), (gsize)s7_integer(n_lines), (int)s7_integer(hspacing), (int)s7_integer(vspacing), (GError**)s7_c_pointer(error), (char*)s7_string(first_view))));
}

static s7_pointer lg_gtk_constraint_layout_add_constraints_from_descriptionv(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_add_constraints_from_descriptionv "GList* gtk_constraint_layout_add_constraints_from_descriptionv(GtkConstraintLayout* layout, \
char* lines, gsize n_lines, int hspacing, int vspacing, GHashTable* views, GError** error)"
  s7_pointer _p;
  s7_pointer layout, lines, n_lines, hspacing, vspacing, views, error;
  _p = args;
  layout = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 1, layout, "GtkConstraintLayout*");
  lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(lines)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 2, lines, "char*");
  n_lines = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(n_lines)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 3, n_lines, "gsize");
  hspacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hspacing)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 4, hspacing, "int");
  vspacing = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(vspacing)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 5, vspacing, "int");
  views = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(views, GHashTable__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 6, views, "GHashTable*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", 7, error, "GError**");
  return(lg_make_c_pointer_with_type(sc, GList__sym, gtk_constraint_layout_add_constraints_from_descriptionv((GtkConstraintLayout*)s7_c_pointer(layout), (char*)s7_string(lines), (gsize)s7_integer(n_lines), (int)s7_integer(hspacing), (int)s7_integer(vspacing), (GHashTable*)s7_c_pointer(views), (GError**)s7_c_pointer(error))));
}

static s7_pointer lg_gtk_constraint_layout_observe_constraints(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_observe_constraints "GListModel* gtk_constraint_layout_observe_constraints(GtkConstraintLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_observe_constraints", 1, layout, "GtkConstraintLayout*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_constraint_layout_observe_constraints((GtkConstraintLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gtk_constraint_layout_observe_guides(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_constraint_layout_observe_guides "GListModel* gtk_constraint_layout_observe_guides(GtkConstraintLayout* layout)"
  s7_pointer layout;
  layout = s7_car(args);
  if (!s7_is_c_pointer_of_type(layout, GtkConstraintLayout__sym)) s7_wrong_type_arg_error(sc, "gtk_constraint_layout_observe_guides", 1, layout, "GtkConstraintLayout*");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_constraint_layout_observe_guides((GtkConstraintLayout*)s7_c_pointer(layout))));
}

static s7_pointer lg_gtk_event_controller_focus_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_focus_new "GtkEventController* gtk_event_controller_focus_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_event_controller_focus_new()));
}

static s7_pointer lg_gtk_event_controller_focus_contains_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_focus_contains_focus "gboolean gtk_event_controller_focus_contains_focus(GtkEventControllerFocus* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkEventControllerFocus__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_focus_contains_focus", 1, self, "GtkEventControllerFocus*");
  return(s7_make_boolean(sc, gtk_event_controller_focus_contains_focus((GtkEventControllerFocus*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_event_controller_focus_is_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_focus_is_focus "gboolean gtk_event_controller_focus_is_focus(GtkEventControllerFocus* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkEventControllerFocus__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_focus_is_focus", 1, self, "GtkEventControllerFocus*");
  return(s7_make_boolean(sc, gtk_event_controller_focus_is_focus((GtkEventControllerFocus*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drag_icon_get_for_drag(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_icon_get_for_drag "GtkWidget* gtk_drag_icon_get_for_drag(GdkDrag* drag)"
  s7_pointer drag;
  drag = s7_car(args);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_get_for_drag", 1, drag, "GdkDrag*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_drag_icon_get_for_drag((GdkDrag*)s7_c_pointer(drag))));
}

static s7_pointer lg_gtk_drag_icon_set_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_icon_set_child "void gtk_drag_icon_set_child(GtkDragIcon* self, GtkWidget* child)"
  s7_pointer _p;
  s7_pointer self, child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDragIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_set_child", 1, self, "GtkDragIcon*");
  child = s7_car(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_set_child", 2, child, "GtkWidget*");
  gtk_drag_icon_set_child((GtkDragIcon*)s7_c_pointer(self), (GtkWidget*)s7_c_pointer(child));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_icon_get_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_icon_get_child "GtkWidget* gtk_drag_icon_get_child(GtkDragIcon* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDragIcon__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_get_child", 1, self, "GtkDragIcon*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_drag_icon_get_child((GtkDragIcon*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drag_icon_set_from_paintable(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_icon_set_from_paintable "void gtk_drag_icon_set_from_paintable(GdkDrag* drag, GdkPaintable* paintable, \
int hot_x, int hot_y)"
  s7_pointer _p;
  s7_pointer drag, paintable, hot_x, hot_y;
  _p = args;
  drag = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(drag, GdkDrag__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_set_from_paintable", 1, drag, "GdkDrag*");
  paintable = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(paintable, GdkPaintable__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_set_from_paintable", 2, paintable, "GdkPaintable*");
  hot_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(hot_x)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_set_from_paintable", 3, hot_x, "int");
  hot_y = s7_car(_p);
  if (!s7_is_integer(hot_y)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_set_from_paintable", 4, hot_y, "int");
  gtk_drag_icon_set_from_paintable((GdkDrag*)s7_c_pointer(drag), (GdkPaintable*)s7_c_pointer(paintable), (int)s7_integer(hot_x), (int)s7_integer(hot_y));
  return(lg_false);
}

static s7_pointer lg_gtk_drag_icon_create_widget_for_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drag_icon_create_widget_for_value "GtkWidget* gtk_drag_icon_create_widget_for_value(GValue* value)"
  s7_pointer value;
  value = s7_car(args);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_drag_icon_create_widget_for_value", 1, value, "GValue*");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_drag_icon_create_widget_for_value((const GValue*)s7_c_pointer(value))));
}

static s7_pointer lg_gtk_drop_controller_motion_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_controller_motion_new "GtkEventController* gtk_drop_controller_motion_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_drop_controller_motion_new()));
}

static s7_pointer lg_gtk_drop_controller_motion_contains_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_controller_motion_contains_pointer "gboolean gtk_drop_controller_motion_contains_pointer(GtkDropControllerMotion* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropControllerMotion__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_controller_motion_contains_pointer", 1, self, "GtkDropControllerMotion*");
  return(s7_make_boolean(sc, gtk_drop_controller_motion_contains_pointer((GtkDropControllerMotion*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_controller_motion_get_drop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_controller_motion_get_drop "GdkDrop* gtk_drop_controller_motion_get_drop(GtkDropControllerMotion* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropControllerMotion__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_controller_motion_get_drop", 1, self, "GtkDropControllerMotion*");
  return(lg_make_c_pointer_with_type(sc, GdkDrop__sym, gtk_drop_controller_motion_get_drop((GtkDropControllerMotion*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_controller_motion_is_pointer(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_controller_motion_is_pointer "gboolean gtk_drop_controller_motion_is_pointer(GtkDropControllerMotion* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropControllerMotion__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_controller_motion_is_pointer", 1, self, "GtkDropControllerMotion*");
  return(s7_make_boolean(sc, gtk_drop_controller_motion_is_pointer((GtkDropControllerMotion*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_new "GtkDropTarget* gtk_drop_target_new(GType type, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer type, actions;
  _p = args;
  type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(type)) s7_wrong_type_arg_error(sc, "gtk_drop_target_new", 1, type, "GType");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drop_target_new", 2, actions, "GdkDragAction");
  return(lg_make_c_pointer_with_type(sc, GtkDropTarget__sym, gtk_drop_target_new((GType)s7_integer(type), (GdkDragAction)s7_integer(actions))));
}

static s7_pointer lg_gtk_drop_target_set_gtypes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_set_gtypes "void gtk_drop_target_set_gtypes(GtkDropTarget* self, GType* types, \
gsize n_types)"
  s7_pointer _p;
  s7_pointer self, types, n_types;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_gtypes", 1, self, "GtkDropTarget*");
  types = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(types, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_gtypes", 2, types, "GType*");
  n_types = s7_car(_p);
  if (!s7_is_integer(n_types)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_gtypes", 3, n_types, "gsize");
  gtk_drop_target_set_gtypes((GtkDropTarget*)s7_c_pointer(self), (GType*)s7_c_pointer(types), (gsize)s7_integer(n_types));
  return(lg_false);
}

static s7_pointer lg_gtk_drop_target_get_gtypes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_get_gtypes "GType* gtk_drop_target_get_gtypes(GtkDropTarget* self, gsize* n_types)"
  s7_pointer _p;
  s7_pointer self, n_types;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_gtypes", 1, self, "GtkDropTarget*");
  n_types = s7_car(_p);
  if (!s7_is_c_pointer_of_type(n_types, gsize__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_gtypes", 2, n_types, "gsize*");
    return(lg_make_c_pointer_with_type(sc, GType__sym, (GType*)gtk_drop_target_get_gtypes((GtkDropTarget*)s7_c_pointer(self), (gsize*)s7_c_pointer(n_types))));
}

static s7_pointer lg_gtk_drop_target_get_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_get_formats "GdkContentFormats* gtk_drop_target_get_formats(GtkDropTarget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_formats", 1, self, "GtkDropTarget*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gtk_drop_target_get_formats((GtkDropTarget*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_set_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_set_actions "void gtk_drop_target_set_actions(GtkDropTarget* self, GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer self, actions;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_actions", 1, self, "GtkDropTarget*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_actions", 2, actions, "GdkDragAction");
  gtk_drop_target_set_actions((GtkDropTarget*)s7_c_pointer(self), (GdkDragAction)s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_drop_target_get_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_get_actions "GdkDragAction gtk_drop_target_get_actions(GtkDropTarget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_actions", 1, self, "GtkDropTarget*");
  return(s7_make_integer(sc, gtk_drop_target_get_actions((GtkDropTarget*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_set_preload(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_set_preload "void gtk_drop_target_set_preload(GtkDropTarget* self, gboolean preload)"
  s7_pointer _p;
  s7_pointer self, preload;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_preload", 1, self, "GtkDropTarget*");
  preload = s7_car(_p);
  if (!s7_is_boolean(preload)) s7_wrong_type_arg_error(sc, "gtk_drop_target_set_preload", 2, preload, "gboolean");
  gtk_drop_target_set_preload((GtkDropTarget*)s7_c_pointer(self), (gboolean)lg_boolean(preload));
  return(lg_false);
}

static s7_pointer lg_gtk_drop_target_get_preload(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_get_preload "gboolean gtk_drop_target_get_preload(GtkDropTarget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_preload", 1, self, "GtkDropTarget*");
  return(s7_make_boolean(sc, gtk_drop_target_get_preload((GtkDropTarget*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_get_drop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_get_drop "GdkDrop* gtk_drop_target_get_drop(GtkDropTarget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_drop", 1, self, "GtkDropTarget*");
  return(lg_make_c_pointer_with_type(sc, GdkDrop__sym, gtk_drop_target_get_drop((GtkDropTarget*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_get_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_get_value "GValue* gtk_drop_target_get_value(GtkDropTarget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_get_value", 1, self, "GtkDropTarget*");
    return(lg_make_c_pointer_with_type(sc, GValue__sym, (GValue*)gtk_drop_target_get_value((GtkDropTarget*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_reject(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_reject "void gtk_drop_target_reject(GtkDropTarget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTarget__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_reject", 1, self, "GtkDropTarget*");
  gtk_drop_target_reject((GtkDropTarget*)s7_c_pointer(self));
  return(lg_false);
}

static s7_pointer lg_gtk_drop_target_async_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_async_new "GtkDropTargetAsync* gtk_drop_target_async_new(GdkContentFormats* formats, \
GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer formats, actions;
  _p = args;
  formats = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_new", 1, formats, "GdkContentFormats*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_new", 2, actions, "GdkDragAction");
  return(lg_make_c_pointer_with_type(sc, GtkDropTargetAsync__sym, gtk_drop_target_async_new((GdkContentFormats*)s7_c_pointer(formats), (GdkDragAction)s7_integer(actions))));
}

static s7_pointer lg_gtk_drop_target_async_set_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_async_set_formats "void gtk_drop_target_async_set_formats(GtkDropTargetAsync* self, \
GdkContentFormats* formats)"
  s7_pointer _p;
  s7_pointer self, formats;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTargetAsync__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_set_formats", 1, self, "GtkDropTargetAsync*");
  formats = s7_car(_p);
  if (!s7_is_c_pointer_of_type(formats, GdkContentFormats__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_set_formats", 2, formats, "GdkContentFormats*");
  gtk_drop_target_async_set_formats((GtkDropTargetAsync*)s7_c_pointer(self), (GdkContentFormats*)s7_c_pointer(formats));
  return(lg_false);
}

static s7_pointer lg_gtk_drop_target_async_get_formats(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_async_get_formats "GdkContentFormats* gtk_drop_target_async_get_formats(GtkDropTargetAsync* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTargetAsync__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_get_formats", 1, self, "GtkDropTargetAsync*");
  return(lg_make_c_pointer_with_type(sc, GdkContentFormats__sym, gtk_drop_target_async_get_formats((GtkDropTargetAsync*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_async_set_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_async_set_actions "void gtk_drop_target_async_set_actions(GtkDropTargetAsync* self, \
GdkDragAction actions)"
  s7_pointer _p;
  s7_pointer self, actions;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTargetAsync__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_set_actions", 1, self, "GtkDropTargetAsync*");
  actions = s7_car(_p);
  if (!s7_is_integer(actions)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_set_actions", 2, actions, "GdkDragAction");
  gtk_drop_target_async_set_actions((GtkDropTargetAsync*)s7_c_pointer(self), (GdkDragAction)s7_integer(actions));
  return(lg_false);
}

static s7_pointer lg_gtk_drop_target_async_get_actions(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_async_get_actions "GdkDragAction gtk_drop_target_async_get_actions(GtkDropTargetAsync* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkDropTargetAsync__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_get_actions", 1, self, "GtkDropTargetAsync*");
  return(s7_make_integer(sc, gtk_drop_target_async_get_actions((GtkDropTargetAsync*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_drop_target_async_reject_drop(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_drop_target_async_reject_drop "void gtk_drop_target_async_reject_drop(GtkDropTargetAsync* self, \
GdkDrop* drop)"
  s7_pointer _p;
  s7_pointer self, drop;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkDropTargetAsync__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_reject_drop", 1, self, "GtkDropTargetAsync*");
  drop = s7_car(_p);
  if (!s7_is_c_pointer_of_type(drop, GdkDrop__sym)) s7_wrong_type_arg_error(sc, "gtk_drop_target_async_reject_drop", 2, drop, "GdkDrop*");
  gtk_drop_target_async_reject_drop((GtkDropTargetAsync*)s7_c_pointer(self), (GdkDrop*)s7_c_pointer(drop));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_set_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_icon_name "void gtk_menu_button_set_icon_name(GtkMenuButton* menu_button, \
char* icon_name)"
  s7_pointer _p;
  s7_pointer menu_button, icon_name;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_icon_name", 1, menu_button, "GtkMenuButton*");
  icon_name = s7_car(_p);
  if (!s7_is_string(icon_name)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_icon_name", 2, icon_name, "char*");
  gtk_menu_button_set_icon_name((GtkMenuButton*)s7_c_pointer(menu_button), (const char*)(char*)s7_string(icon_name));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_icon_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_icon_name "char* gtk_menu_button_get_icon_name(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_icon_name", 1, menu_button, "GtkMenuButton*");
    return(s7_make_string(sc, (char*)gtk_menu_button_get_icon_name((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_menu_button_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_label "void gtk_menu_button_set_label(GtkMenuButton* menu_button, const char*, \
label)"
  s7_pointer _p;
  s7_pointer menu_button, char*;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_label", 1, menu_button, "GtkMenuButton*");
  char* = s7_car(_p);
  if (!s7_is_c_pointer_of_type(char*, const_sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_label", 2, char*, "const");
  gtk_menu_button_set_label((GtkMenuButton*)s7_c_pointer(menu_button), (const)s7_c_pointer(char*));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_label "char* gtk_menu_button_get_label(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_label", 1, menu_button, "GtkMenuButton*");
    return(s7_make_string(sc, (char*)gtk_menu_button_get_label((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_menu_button_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_popup "void gtk_menu_button_popup(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_popup", 1, menu_button, "GtkMenuButton*");
  gtk_menu_button_popup((GtkMenuButton*)s7_c_pointer(menu_button));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_popdown(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_popdown "void gtk_menu_button_popdown(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_popdown", 1, menu_button, "GtkMenuButton*");
  gtk_menu_button_popdown((GtkMenuButton*)s7_c_pointer(menu_button));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_set_create_popup_func(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_create_popup_func "void gtk_menu_button_set_create_popup_func(GtkMenuButton* menu_button, \
GtkMenuButtonCreatePopupFunc func, gpointer user_data, GDestroyNotify destroy_notify)"
  s7_pointer _p;
  s7_pointer menu_button, func, user_data, destroy_notify;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_create_popup_func", 1, menu_button, "GtkMenuButton*");
  func = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(func, GtkMenuButtonCreatePopupFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_create_popup_func", 2, func, "GtkMenuButtonCreatePopupFunc");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_create_popup_func", 3, user_data, "gpointer");
  destroy_notify = s7_car(_p);
  {
    s7_pointer lg_ptr = s7_list(sc, 5, func, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy_notify);
    gtk_menu_button_set_create_popup_func((GtkMenuButton*)s7_c_pointer(menu_button), (GtkMenuButtonCreatePopupFunc)s7_c_pointer(func), (gpointer)s7_c_pointer(user_data), lg_destroy_func);
    return(lg_false);
   }
}

static s7_pointer lg_gtk_style_context_get_valist(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get_valist "void gtk_style_context_get_valist(GtkStyleContext* context, \
char* first_property_name, va_list args)"
  s7_pointer _p;
  s7_pointer context, first_property_name, args;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_valist", 1, context, "GtkStyleContext*");
  first_property_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(first_property_name)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_valist", 2, first_property_name, "char*");
  args = s7_car(_p);
  if (!s7_is_c_pointer_of_type(args, va_list_sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get_valist", 3, args, "va_list");
  gtk_style_context_get_valist((GtkStyleContext*)s7_c_pointer(context), (const char*)(char*)s7_string(first_property_name), (va_list)s7_c_pointer(args));
  return(lg_false);
}

static s7_pointer lg_gtk_style_context_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_style_context_get "void gtk_style_context_get(GtkStyleContext* context, char* first_property_name, \
...)"
  s7_pointer _p;
  s7_pointer context, first_property_name;
  _p = args;
  context = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(context, GtkStyleContext__sym)) s7_wrong_type_arg_error(sc, "gtk_style_context_get", 1, context, "GtkStyleContext*");
  first_property_name = s7_car(_p);
  if (!s7_is_string(first_property_name)) s7_wrong_type_arg_error(sc, "gtk_style_context_get", 2, first_property_name, "char*");
  gtk_style_context_get((GtkStyleContext*)s7_c_pointer(context), (const char*)(char*)s7_string(first_property_name));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_gutter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_gutter "GtkWidget* gtk_text_view_get_gutter(GtkTextView* text_view, GtkTextWindowType win)"
  s7_pointer _p;
  s7_pointer text_view, win;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_gutter", 1, text_view, "GtkTextView*");
  win = s7_car(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_gutter", 2, win, "GtkTextWindowType");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_text_view_get_gutter((GtkTextView*)s7_c_pointer(text_view), (GtkTextWindowType)s7_integer(win))));
}

static s7_pointer lg_gtk_text_view_set_gutter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_gutter "void gtk_text_view_set_gutter(GtkTextView* text_view, GtkTextWindowType win, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer text_view, win, widget;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_gutter", 1, text_view, "GtkTextView*");
  win = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(win)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_gutter", 2, win, "GtkTextWindowType");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_gutter", 3, widget, "GtkWidget*");
  gtk_text_view_set_gutter((GtkTextView*)s7_c_pointer(text_view), (GtkTextWindowType)s7_integer(win), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_add_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_add_overlay "void gtk_text_view_add_overlay(GtkTextView* text_view, GtkWidget* child, \
gint xpos, gint ypos)"
  s7_pointer _p;
  s7_pointer text_view, child, xpos, ypos;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_overlay", 1, text_view, "GtkTextView*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_overlay", 2, child, "GtkWidget*");
  xpos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(xpos)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_overlay", 3, xpos, "gint");
  ypos = s7_car(_p);
  if (!s7_is_integer(ypos)) s7_wrong_type_arg_error(sc, "gtk_text_view_add_overlay", 4, ypos, "gint");
  gtk_text_view_add_overlay((GtkTextView*)s7_c_pointer(text_view), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(xpos), (gint)s7_integer(ypos));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_move_overlay(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_move_overlay "void gtk_text_view_move_overlay(GtkTextView* text_view, GtkWidget* child, \
gint xpos, gint ypos)"
  s7_pointer _p;
  s7_pointer text_view, child, xpos, ypos;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_overlay", 1, text_view, "GtkTextView*");
  child = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(child, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_overlay", 2, child, "GtkWidget*");
  xpos = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(xpos)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_overlay", 3, xpos, "gint");
  ypos = s7_car(_p);
  if (!s7_is_integer(ypos)) s7_wrong_type_arg_error(sc, "gtk_text_view_move_overlay", 4, ypos, "gint");
  gtk_text_view_move_overlay((GtkTextView*)s7_c_pointer(text_view), (GtkWidget*)s7_c_pointer(child), (gint)s7_integer(xpos), (gint)s7_integer(ypos));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_set_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_set_extra_menu "void gtk_text_view_set_extra_menu(GtkTextView* text_view, GMenuModel* model)"
  s7_pointer _p;
  s7_pointer text_view, model;
  _p = args;
  text_view = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_extra_menu", 1, text_view, "GtkTextView*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_set_extra_menu", 2, model, "GMenuModel*");
  gtk_text_view_set_extra_menu((GtkTextView*)s7_c_pointer(text_view), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_text_view_get_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_extra_menu "GMenuModel* gtk_text_view_get_extra_menu(GtkTextView* text_view)"
  s7_pointer text_view;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_extra_menu", 1, text_view, "GtkTextView*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_text_view_get_extra_menu((GtkTextView*)s7_c_pointer(text_view))));
}

static s7_pointer lg_gtk_label_set_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_set_extra_menu "void gtk_label_set_extra_menu(GtkLabel* label, GMenuModel* model)"
  s7_pointer _p;
  s7_pointer label, model;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_extra_menu", 1, label, "GtkLabel*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_set_extra_menu", 2, model, "GMenuModel*");
  gtk_label_set_extra_menu((GtkLabel*)s7_c_pointer(label), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_gtk_label_get_extra_menu(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_label_get_extra_menu "GMenuModel* gtk_label_get_extra_menu(GtkLabel* label)"
  s7_pointer label;
  label = s7_car(args);
  if (!s7_is_c_pointer_of_type(label, GtkLabel__sym)) s7_wrong_type_arg_error(sc, "gtk_label_get_extra_menu", 1, label, "GtkLabel*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, gtk_label_get_extra_menu((GtkLabel*)s7_c_pointer(label))));
}

static s7_pointer lg_GtkTreeModel*(s7_scheme *sc, s7_pointer args)
{
  #define H_GtkTreeModel* "gtk_tree_create_row_drag_content GtkTreeModel*(tree_model GtkTreePath*, path)"
  s7_pointer GtkTreePath*;
  GtkTreePath* = s7_car(args);
  if (!s7_is_c_pointer_of_type(GtkTreePath*, tree_model_sym)) s7_wrong_type_arg_error(sc, "GtkTreeModel*", 1, GtkTreePath*, "tree_model");
  return(lg_make_c_pointer_with_type(sc, gtk_tree_create_row_drag_content_sym, GtkTreeModel*((tree_model)s7_c_pointer(GtkTreePath*))));
}

static s7_pointer lg_gtk_tree_get_row_drag_data(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_tree_get_row_drag_data "gboolean gtk_tree_get_row_drag_data(GValue* value, GtkTreeModel** tree_model, \
GtkTreePath** path)"
  s7_pointer _p;
  s7_pointer value, tree_model, path;
  _p = args;
  value = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(value, GValue__sym)) s7_wrong_type_arg_error(sc, "gtk_tree_get_row_drag_data", 1, value, "GValue*");
  tree_model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(tree_model, GtkTreeModel___sym)) s7_wrong_type_arg_error(sc, "gtk_tree_get_row_drag_data", 2, tree_model, "GtkTreeModel**");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, GtkTreePath___sym)) s7_wrong_type_arg_error(sc, "gtk_tree_get_row_drag_data", 3, path, "GtkTreePath**");
  return(s7_make_boolean(sc, gtk_tree_get_row_drag_data((GValue*)s7_c_pointer(value), (GtkTreeModel**)s7_c_pointer(tree_model), (GtkTreePath**)s7_c_pointer(path))));
}

static s7_pointer lg_GtkTreeDragSource*(s7_scheme *sc, s7_pointer args)
{
  #define H_GtkTreeDragSource* "gtk_tree_drag_source_drag_data_get GtkTreeDragSource*(drag_source GtkTreePath*, \
path)"
  s7_pointer GtkTreePath*;
  GtkTreePath* = s7_car(args);
  if (!s7_is_c_pointer_of_type(GtkTreePath*, drag_source_sym)) s7_wrong_type_arg_error(sc, "GtkTreeDragSource*", 1, GtkTreePath*, "drag_source");
  return(lg_make_c_pointer_with_type(sc, gtk_tree_drag_source_drag_data_get_sym, GtkTreeDragSource*((drag_source)s7_c_pointer(GtkTreePath*))));
}

static s7_pointer lg_gtk_text_buffer_get_selection_content(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_selection_content "GdkContentProvider* gtk_text_buffer_get_selection_content(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_selection_content", 1, buffer, "GtkTextBuffer*");
  return(lg_make_c_pointer_with_type(sc, GdkContentProvider__sym, gtk_text_buffer_get_selection_content((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_can_undo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_can_undo "gboolean gtk_text_buffer_get_can_undo(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_can_undo", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_can_undo((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_can_redo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_can_redo "gboolean gtk_text_buffer_get_can_redo(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_can_redo", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_can_redo((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_get_enable_undo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_enable_undo "gboolean gtk_text_buffer_get_enable_undo(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_enable_undo", 1, buffer, "GtkTextBuffer*");
  return(s7_make_boolean(sc, gtk_text_buffer_get_enable_undo((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_set_enable_undo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_set_enable_undo "void gtk_text_buffer_set_enable_undo(GtkTextBuffer* buffer, \
)"
  s7_pointer buffer ;
  buffer  = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer , GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_enable_undo", 1, buffer , "GtkTextBuffer*");
  gtk_text_buffer_set_enable_undo((GtkTextBuffer*)s7_c_pointer(buffer ));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_get_max_undo_levels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_get_max_undo_levels "guint gtk_text_buffer_get_max_undo_levels(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_get_max_undo_levels", 1, buffer, "GtkTextBuffer*");
  return(s7_make_integer(sc, gtk_text_buffer_get_max_undo_levels((GtkTextBuffer*)s7_c_pointer(buffer))));
}

static s7_pointer lg_gtk_text_buffer_set_max_undo_levels(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_set_max_undo_levels "void gtk_text_buffer_set_max_undo_levels(GtkTextBuffer* buffer, \
)"
  s7_pointer buffer ;
  buffer  = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer , GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_set_max_undo_levels", 1, buffer , "GtkTextBuffer*");
  gtk_text_buffer_set_max_undo_levels((GtkTextBuffer*)s7_c_pointer(buffer ));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_undo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_undo "void gtk_text_buffer_undo(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_undo", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_undo((GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_redo(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_redo "void gtk_text_buffer_redo(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_redo", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_redo((GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_begin_irreversible_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_begin_irreversible_action "void gtk_text_buffer_begin_irreversible_action(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_begin_irreversible_action", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_begin_irreversible_action((GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_text_buffer_end_irreversible_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_buffer_end_irreversible_action "void gtk_text_buffer_end_irreversible_action(GtkTextBuffer* buffer)"
  s7_pointer buffer;
  buffer = s7_car(args);
  if (!s7_is_c_pointer_of_type(buffer, GtkTextBuffer__sym)) s7_wrong_type_arg_error(sc, "gtk_text_buffer_end_irreversible_action", 1, buffer, "GtkTextBuffer*");
  gtk_text_buffer_end_irreversible_action((GtkTextBuffer*)s7_c_pointer(buffer));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_select_multiple(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_select_multiple "void gtk_file_chooser_set_select_multiple(GtkFileChooser* chooser, \
gboolean select_multiple)"
  s7_pointer _p;
  s7_pointer chooser, select_multiple;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_select_multiple", 1, chooser, "GtkFileChooser*");
  select_multiple = s7_car(_p);
  if (!s7_is_boolean(select_multiple)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_select_multiple", 2, select_multiple, "gboolean");
  gtk_file_chooser_set_select_multiple((GtkFileChooser*)s7_c_pointer(chooser), (gboolean)lg_boolean(select_multiple));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_select_multiple(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_select_multiple "gboolean gtk_file_chooser_get_select_multiple(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_select_multiple", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_select_multiple((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_create_folders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_create_folders "void gtk_file_chooser_set_create_folders(GtkFileChooser* chooser, \
gboolean create_folders)"
  s7_pointer _p;
  s7_pointer chooser, create_folders;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_create_folders", 1, chooser, "GtkFileChooser*");
  create_folders = s7_car(_p);
  if (!s7_is_boolean(create_folders)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_create_folders", 2, create_folders, "gboolean");
  gtk_file_chooser_set_create_folders((GtkFileChooser*)s7_c_pointer(chooser), (gboolean)lg_boolean(create_folders));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_create_folders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_create_folders "gboolean gtk_file_chooser_get_create_folders(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_create_folders", 1, chooser, "GtkFileChooser*");
  return(s7_make_boolean(sc, gtk_file_chooser_get_create_folders((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_select_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_select_all "void gtk_file_chooser_select_all(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_select_all", 1, chooser, "GtkFileChooser*");
  gtk_file_chooser_select_all((GtkFileChooser*)s7_c_pointer(chooser));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_unselect_all(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_unselect_all "void gtk_file_chooser_unselect_all(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_unselect_all", 1, chooser, "GtkFileChooser*");
  gtk_file_chooser_unselect_all((GtkFileChooser*)s7_c_pointer(chooser));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_current_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_current_folder "gboolean gtk_file_chooser_set_current_folder(GtkFileChooser* chooser, \
GFile* file, GError** error)"
  s7_pointer _p;
  s7_pointer chooser, file, error;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder", 1, chooser, "GtkFileChooser*");
  file = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(file, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder", 2, file, "GFile*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_current_folder", 3, error, "GError**");
  return(s7_make_boolean(sc, gtk_file_chooser_set_current_folder((GtkFileChooser*)s7_c_pointer(chooser), (GFile*)s7_c_pointer(file), (GError**)s7_c_pointer(error))));
}

static s7_pointer lg_gtk_file_chooser_get_current_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_current_folder "GFile* gtk_file_chooser_get_current_folder(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_current_folder", 1, chooser, "GtkFileChooser*");
  return(lg_make_c_pointer_with_type(sc, GFile__sym, gtk_file_chooser_get_current_folder((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_add_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_filter "void gtk_file_chooser_add_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_filter", 1, chooser, "GtkFileChooser*");
  filter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_filter", 2, filter, "GtkFileFilter*");
  gtk_file_chooser_add_filter((GtkFileChooser*)s7_c_pointer(chooser), (GtkFileFilter*)s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_remove_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_filter "void gtk_file_chooser_remove_filter(GtkFileChooser* chooser, \
GtkFileFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_filter", 1, chooser, "GtkFileChooser*");
  filter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_filter", 2, filter, "GtkFileFilter*");
  gtk_file_chooser_remove_filter((GtkFileChooser*)s7_c_pointer(chooser), (GtkFileFilter*)s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_list_filters(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_list_filters "GSList* gtk_file_chooser_list_filters(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_list_filters", 1, chooser, "GtkFileChooser*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_file_chooser_list_filters((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_set_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_filter "void gtk_file_chooser_set_filter(GtkFileChooser* chooser, GtkFileFilter* filter)"
  s7_pointer _p;
  s7_pointer chooser, filter;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_filter", 1, chooser, "GtkFileChooser*");
  filter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(filter, GtkFileFilter__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_filter", 2, filter, "GtkFileFilter*");
  gtk_file_chooser_set_filter((GtkFileChooser*)s7_c_pointer(chooser), (GtkFileFilter*)s7_c_pointer(filter));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_filter "GtkFileFilter* gtk_file_chooser_get_filter(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_filter", 1, chooser, "GtkFileChooser*");
  return(lg_make_c_pointer_with_type(sc, GtkFileFilter__sym, gtk_file_chooser_get_filter((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_add_shortcut_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_shortcut_folder "gboolean gtk_file_chooser_add_shortcut_folder(GtkFileChooser* chooser, \
GFile* folder, GError** error)"
  s7_pointer _p;
  s7_pointer chooser, folder, error;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder", 1, chooser, "GtkFileChooser*");
  folder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(folder, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder", 2, folder, "GFile*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_shortcut_folder", 3, error, "GError**");
  return(s7_make_boolean(sc, gtk_file_chooser_add_shortcut_folder((GtkFileChooser*)s7_c_pointer(chooser), (GFile*)s7_c_pointer(folder), (GError**)s7_c_pointer(error))));
}

static s7_pointer lg_gtk_file_chooser_remove_shortcut_folder(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_shortcut_folder "gboolean gtk_file_chooser_remove_shortcut_folder(GtkFileChooser* chooser, \
GFile* folder, GError** error)"
  s7_pointer _p;
  s7_pointer chooser, folder, error;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder", 1, chooser, "GtkFileChooser*");
  folder = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(folder, GFile__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder", 2, folder, "GFile*");
  error = s7_car(_p);
  if (!s7_is_c_pointer_of_type(error, GError___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_shortcut_folder", 3, error, "GError**");
  return(s7_make_boolean(sc, gtk_file_chooser_remove_shortcut_folder((GtkFileChooser*)s7_c_pointer(chooser), (GFile*)s7_c_pointer(folder), (GError**)s7_c_pointer(error))));
}

static s7_pointer lg_gtk_file_chooser_list_shortcut_folders(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_list_shortcut_folders "GSList* gtk_file_chooser_list_shortcut_folders(GtkFileChooser* chooser)"
  s7_pointer chooser;
  chooser = s7_car(args);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_list_shortcut_folders", 1, chooser, "GtkFileChooser*");
  return(lg_make_c_pointer_with_type(sc, GSList__sym, gtk_file_chooser_list_shortcut_folders((GtkFileChooser*)s7_c_pointer(chooser))));
}

static s7_pointer lg_gtk_file_chooser_add_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_add_choice "void gtk_file_chooser_add_choice(GtkFileChooser* chooser, char* id, \
char* label, char** options, char** option_labels)"
  s7_pointer _p;
  s7_pointer chooser, id, label, options, option_labels;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 2, id, "char*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 3, label, "char*");
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, char___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 4, options, "char**");
  option_labels = s7_car(_p);
  if (!s7_is_c_pointer_of_type(option_labels, char___sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_add_choice", 5, option_labels, "char**");
  gtk_file_chooser_add_choice((GtkFileChooser*)s7_c_pointer(chooser), (char*)s7_string(id), (char*)s7_string(label), (char**)s7_c_pointer(options), (char**)s7_c_pointer(option_labels));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_remove_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_remove_choice "void gtk_file_chooser_remove_choice(GtkFileChooser* chooser, \
char* id)"
  s7_pointer _p;
  s7_pointer chooser, id;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_remove_choice", 2, id, "char*");
  gtk_file_chooser_remove_choice((GtkFileChooser*)s7_c_pointer(chooser), (const char*)(char*)s7_string(id));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_set_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_set_choice "void gtk_file_chooser_set_choice(GtkFileChooser* chooser, const char*, \
id char*, option)"
  s7_pointer _p;
  s7_pointer chooser, char*, char*;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_choice", 1, chooser, "GtkFileChooser*");
  char* = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(char*, const_sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_choice", 2, char*, "const");
  char* = s7_car(_p);
  if (!s7_is_c_pointer_of_type(char*, id_sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_set_choice", 3, char*, "id");
  gtk_file_chooser_set_choice((GtkFileChooser*)s7_c_pointer(chooser), (const)s7_c_pointer(char*), (id)s7_c_pointer(char*));
  return(lg_false);
}

static s7_pointer lg_gtk_file_chooser_get_choice(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_get_choice "char* gtk_file_chooser_get_choice(GtkFileChooser* chooser, char* id)"
  s7_pointer _p;
  s7_pointer chooser, id;
  _p = args;
  chooser = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(chooser, GtkFileChooser__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_choice", 1, chooser, "GtkFileChooser*");
  id = s7_car(_p);
  if (!s7_is_string(id)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_get_choice", 2, id, "char*");
    return(s7_make_string(sc, (char*)gtk_file_chooser_get_choice((GtkFileChooser*)s7_c_pointer(chooser), (char*)s7_string(id))));
}

static s7_pointer lg_gtk_popover_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_new "GtkWidget* gtk_popover_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_popover_new()));
}

static s7_pointer lg_gtk_popover_set_pointing_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_pointing_to "void gtk_popover_set_pointing_to(GtkPopover* popover, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer popover, rect;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_pointing_to", 1, popover, "GtkPopover*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_pointing_to", 2, rect, "GdkRectangle*");
  gtk_popover_set_pointing_to((GtkPopover*)s7_c_pointer(popover), (GdkRectangle*)s7_c_pointer(rect));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_pointing_to(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_pointing_to "gboolean gtk_popover_get_pointing_to(GtkPopover* popover, GdkRectangle* rect)"
  s7_pointer _p;
  s7_pointer popover, rect;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_pointing_to", 1, popover, "GtkPopover*");
  rect = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rect, GdkRectangle__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_pointing_to", 2, rect, "GdkRectangle*");
  return(s7_make_boolean(sc, gtk_popover_get_pointing_to((GtkPopover*)s7_c_pointer(popover), (GdkRectangle*)s7_c_pointer(rect))));
}

static s7_pointer lg_gtk_popover_set_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_position "void gtk_popover_set_position(GtkPopover* popover, GtkPositionType position)"
  s7_pointer _p;
  s7_pointer popover, position;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_position", 1, popover, "GtkPopover*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_popover_set_position", 2, position, "GtkPositionType");
  gtk_popover_set_position((GtkPopover*)s7_c_pointer(popover), (GtkPositionType)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_position "GtkPositionType gtk_popover_get_position(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_position", 1, popover, "GtkPopover*");
  return(s7_make_integer(sc, gtk_popover_get_position((GtkPopover*)s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_popover_set_autohide(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_autohide "void gtk_popover_set_autohide(GtkPopover* popover, gboolean autohide)"
  s7_pointer _p;
  s7_pointer popover, autohide;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_autohide", 1, popover, "GtkPopover*");
  autohide = s7_car(_p);
  if (!s7_is_boolean(autohide)) s7_wrong_type_arg_error(sc, "gtk_popover_set_autohide", 2, autohide, "gboolean");
  gtk_popover_set_autohide((GtkPopover*)s7_c_pointer(popover), (gboolean)lg_boolean(autohide));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_autohide(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_autohide "gboolean gtk_popover_get_autohide(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_autohide", 1, popover, "GtkPopover*");
  return(s7_make_boolean(sc, gtk_popover_get_autohide((GtkPopover*)s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_popover_set_has_arrow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_has_arrow "void gtk_popover_set_has_arrow(GtkPopover* popover, gboolean has_arrow)"
  s7_pointer _p;
  s7_pointer popover, has_arrow;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_has_arrow", 1, popover, "GtkPopover*");
  has_arrow = s7_car(_p);
  if (!s7_is_boolean(has_arrow)) s7_wrong_type_arg_error(sc, "gtk_popover_set_has_arrow", 2, has_arrow, "gboolean");
  gtk_popover_set_has_arrow((GtkPopover*)s7_c_pointer(popover), (gboolean)lg_boolean(has_arrow));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_has_arrow(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_has_arrow "gboolean gtk_popover_get_has_arrow(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_has_arrow", 1, popover, "GtkPopover*");
  return(s7_make_boolean(sc, gtk_popover_get_has_arrow((GtkPopover*)s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_popover_popup(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_popup "void gtk_popover_popup(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_popup", 1, popover, "GtkPopover*");
  gtk_popover_popup((GtkPopover*)s7_c_pointer(popover));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_popdown(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_popdown "void gtk_popover_popdown(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_popdown", 1, popover, "GtkPopover*");
  gtk_popover_popdown((GtkPopover*)s7_c_pointer(popover));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_set_default_widget(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_default_widget "void gtk_popover_set_default_widget(GtkPopover* popover, \
GtkWidget* widget)"
  s7_pointer _p;
  s7_pointer popover, widget;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_default_widget", 1, popover, "GtkPopover*");
  widget = s7_car(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_default_widget", 2, widget, "GtkWidget*");
  gtk_popover_set_default_widget((GtkPopover*)s7_c_pointer(popover), (GtkWidget*)s7_c_pointer(widget));
  return(lg_false);
}

static s7_pointer lg_gtk_stack_page_get_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_page_get_visible "gboolean gtk_stack_page_get_visible(GtkStackPage* page)"
  s7_pointer page;
  page = s7_car(args);
  if (!s7_is_c_pointer_of_type(page, GtkStackPage__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_page_get_visible", 1, page, "GtkStackPage*");
  return(s7_make_boolean(sc, gtk_stack_page_get_visible((GtkStackPage*)s7_c_pointer(page))));
}

static s7_pointer lg_gtk_stack_page_set_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_stack_page_set_visible "void gtk_stack_page_set_visible(GtkStackPage* page, gboolean visible)"
  s7_pointer _p;
  s7_pointer page, visible;
  _p = args;
  page = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(page, GtkStackPage__sym)) s7_wrong_type_arg_error(sc, "gtk_stack_page_set_visible", 1, page, "GtkStackPage*");
  visible = s7_car(_p);
  if (!s7_is_boolean(visible)) s7_wrong_type_arg_error(sc, "gtk_stack_page_set_visible", 2, visible, "gboolean");
  gtk_stack_page_set_visible((GtkStackPage*)s7_c_pointer(page), (gboolean)lg_boolean(visible));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_class_set_template(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_class_set_template "void gtk_widget_class_set_template(GtkWidgetClass* widget_class, \
GBytes* template_bytes)"
  s7_pointer _p;
  s7_pointer widget_class, template_bytes;
  _p = args;
  widget_class = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget_class, GtkWidgetClass__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_set_template", 1, widget_class, "GtkWidgetClass*");
  template_bytes = s7_car(_p);
  if (!s7_is_c_pointer_of_type(template_bytes, GBytes__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_set_template", 2, template_bytes, "GBytes*");
  gtk_widget_class_set_template((GtkWidgetClass*)s7_c_pointer(widget_class), (GBytes*)s7_c_pointer(template_bytes));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_should_layout(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_should_layout "gboolean gtk_widget_should_layout(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_should_layout", 1, widget, "GtkWidget*");
  return(s7_make_boolean(sc, gtk_widget_should_layout((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_get_css_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_css_name "char* gtk_widget_get_css_name(GtkWidget* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_css_name", 1, self, "GtkWidget*");
    return(s7_make_string(sc, (char*)gtk_widget_get_css_name((GtkWidget*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_widget_add_css_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_add_css_class "void gtk_widget_add_css_class(GtkWidget* widget, char* css_class)"
  s7_pointer _p;
  s7_pointer widget, css_class;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_add_css_class", 1, widget, "GtkWidget*");
  css_class = s7_car(_p);
  if (!s7_is_string(css_class)) s7_wrong_type_arg_error(sc, "gtk_widget_add_css_class", 2, css_class, "char*");
  gtk_widget_add_css_class((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(css_class));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_remove_css_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_remove_css_class "void gtk_widget_remove_css_class(GtkWidget* widget, char* css_class)"
  s7_pointer _p;
  s7_pointer widget, css_class;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_css_class", 1, widget, "GtkWidget*");
  css_class = s7_car(_p);
  if (!s7_is_string(css_class)) s7_wrong_type_arg_error(sc, "gtk_widget_remove_css_class", 2, css_class, "char*");
  gtk_widget_remove_css_class((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(css_class));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_has_css_class(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_has_css_class "gboolean gtk_widget_has_css_class(GtkWidget* widget, char* css_class)"
  s7_pointer _p;
  s7_pointer widget, css_class;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_has_css_class", 1, widget, "GtkWidget*");
  css_class = s7_car(_p);
  if (!s7_is_string(css_class)) s7_wrong_type_arg_error(sc, "gtk_widget_has_css_class", 2, css_class, "char*");
  return(s7_make_boolean(sc, gtk_widget_has_css_class((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(css_class))));
}

static s7_pointer lg_gtk_widget_get_css_classes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_css_classes "char** gtk_widget_get_css_classes(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_css_classes", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, char___sym, gtk_widget_get_css_classes((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_gtk_widget_set_css_classes(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_set_css_classes "void gtk_widget_set_css_classes(GtkWidget* widget, char** classes)"
  s7_pointer _p;
  s7_pointer widget, classes;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_css_classes", 1, widget, "GtkWidget*");
  classes = s7_car(_p);
  if (!s7_is_c_pointer_of_type(classes, char___sym)) s7_wrong_type_arg_error(sc, "gtk_widget_set_css_classes", 2, classes, "char**");
  gtk_widget_set_css_classes((GtkWidget*)s7_c_pointer(widget), (const char**)s7_c_pointer(classes));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_class_install_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_class_install_action "void gtk_widget_class_install_action(GtkWidgetClass* widget_class, \
char* action_name, char* parameter_type, GtkWidgetActionActivateFunc activate)"
  s7_pointer _p;
  s7_pointer widget_class, action_name, parameter_type, activate;
  _p = args;
  widget_class = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget_class, GtkWidgetClass__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_action", 1, widget_class, "GtkWidgetClass*");
  action_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(action_name)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_action", 2, action_name, "char*");
  parameter_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(parameter_type)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_action", 3, parameter_type, "char*");
  activate = s7_car(_p);
  if (!s7_is_c_pointer_of_type(activate, GtkWidgetActionActivateFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_action", 4, activate, "GtkWidgetActionActivateFunc");
  gtk_widget_class_install_action((GtkWidgetClass*)s7_c_pointer(widget_class), (char*)s7_string(action_name), (char*)s7_string(parameter_type), (GtkWidgetActionActivateFunc)s7_c_pointer(activate));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_class_install_property_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_class_install_property_action "void gtk_widget_class_install_property_action(GtkWidgetClass* widget_class, \
char* action_name, char* property_name)"
  s7_pointer _p;
  s7_pointer widget_class, action_name, property_name;
  _p = args;
  widget_class = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget_class, GtkWidgetClass__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_property_action", 1, widget_class, "GtkWidgetClass*");
  action_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(action_name)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_property_action", 2, action_name, "char*");
  property_name = s7_car(_p);
  if (!s7_is_string(property_name)) s7_wrong_type_arg_error(sc, "gtk_widget_class_install_property_action", 3, property_name, "char*");
  gtk_widget_class_install_property_action((GtkWidgetClass*)s7_c_pointer(widget_class), (const char*)(char*)s7_string(action_name), (const char*)(char*)s7_string(property_name));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_class_query_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_class_query_action "gboolean gtk_widget_class_query_action(GtkWidgetClass* widget_class, \
guint index_, GType* owner, char** action_name, GVariantType** parameter_type, const char**, property_name)"
  s7_pointer _p;
  s7_pointer widget_class, index_, owner, action_name, parameter_type, char**;
  _p = args;
  widget_class = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget_class, GtkWidgetClass__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_query_action", 1, widget_class, "GtkWidgetClass*");
  index_ = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(index_)) s7_wrong_type_arg_error(sc, "gtk_widget_class_query_action", 2, index_, "guint");
  owner = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(owner, GType__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_query_action", 3, owner, "GType*");
  action_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(action_name, char___sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_query_action", 4, action_name, "char**");
  parameter_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parameter_type, GVariantType___sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_query_action", 5, parameter_type, "GVariantType**");
  char** = s7_car(_p);
  if (!s7_is_c_pointer_of_type(char**, const_sym)) s7_wrong_type_arg_error(sc, "gtk_widget_class_query_action", 6, char**, "const");
  return(s7_make_boolean(sc, gtk_widget_class_query_action((GtkWidgetClass*)s7_c_pointer(widget_class), (guint)s7_integer(index_), (GType*)s7_c_pointer(owner), (char**)s7_c_pointer(action_name), (GVariantType**)s7_c_pointer(parameter_type), (const)s7_c_pointer(char**))));
}

static s7_pointer lg_gtk_widget_action_set_enabled(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_action_set_enabled "void gtk_widget_action_set_enabled(GtkWidget* widget, char* action_name, \
gboolean enabled)"
  s7_pointer _p;
  s7_pointer widget, action_name, enabled;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_action_set_enabled", 1, widget, "GtkWidget*");
  action_name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(action_name)) s7_wrong_type_arg_error(sc, "gtk_widget_action_set_enabled", 2, action_name, "char*");
  enabled = s7_car(_p);
  if (!s7_is_boolean(enabled)) s7_wrong_type_arg_error(sc, "gtk_widget_action_set_enabled", 3, enabled, "gboolean");
  gtk_widget_action_set_enabled((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(action_name), (gboolean)lg_boolean(enabled));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_activate_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_activate_action "void gtk_widget_activate_action(GtkWidget* widget, char* name, \
GVariant* parameter)"
  s7_pointer _p;
  s7_pointer widget, name, parameter;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_action", 1, widget, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_action", 2, name, "char*");
  parameter = s7_car(_p);
  if (!s7_is_c_pointer_of_type(parameter, GVariant__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_action", 3, parameter, "GVariant*");
  gtk_widget_activate_action((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(name), (GVariant*)s7_c_pointer(parameter));
  return(lg_false);
}

static s7_pointer lg_gtk_widget_activate_action_variant(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_activate_action_variant "gboolean gtk_widget_activate_action_variant(GtkWidget* widget, \
char* name, GVariant* args)"
  s7_pointer _p;
  s7_pointer widget, name, args;
  _p = args;
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_action_variant", 1, widget, "GtkWidget*");
  name = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_action_variant", 2, name, "char*");
  args = s7_car(_p);
  if (!s7_is_c_pointer_of_type(args, GVariant__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_activate_action_variant", 3, args, "GVariant*");
  return(s7_make_boolean(sc, gtk_widget_activate_action_variant((GtkWidget*)s7_c_pointer(widget), (const char*)(char*)s7_string(name), (GVariant*)s7_c_pointer(args))));
}

static s7_pointer lg_gtk_widget_get_native(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_widget_get_native "GtkNative* gtk_widget_get_native(GtkWidget* widget)"
  s7_pointer widget;
  widget = s7_car(args);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_widget_get_native", 1, widget, "GtkWidget*");
  return(lg_make_c_pointer_with_type(sc, GtkNative__sym, gtk_widget_get_native((GtkWidget*)s7_c_pointer(widget))));
}

static s7_pointer lg_g_menu_new(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_new "GMenu* g_menu_new( void)"
  return(lg_make_c_pointer_with_type(sc, GMenu__sym, g_menu_new()));
}

static s7_pointer lg_g_menu_freeze(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_freeze "void g_menu_freeze(GMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_freeze", 1, menu, "GMenu*");
  g_menu_freeze((GMenu*)s7_c_pointer(menu));
  return(lg_false);
}

static s7_pointer lg_g_menu_insert_item(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_insert_item "void g_menu_insert_item(GMenu* menu, gint position, GMenuItem* item)"
  s7_pointer _p;
  s7_pointer menu, position, item;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert_item", 1, menu, "GMenu*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "g_menu_insert_item", 2, position, "gint");
  item = s7_car(_p);
  if (!s7_is_c_pointer_of_type(item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert_item", 3, item, "GMenuItem*");
  g_menu_insert_item((GMenu*)s7_c_pointer(menu), (gint)s7_integer(position), (GMenuItem*)s7_c_pointer(item));
  return(lg_false);
}

static s7_pointer lg_g_menu_prepend_item(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_prepend_item "void g_menu_prepend_item(GMenu* menu, GMenuItem* item)"
  s7_pointer _p;
  s7_pointer menu, item;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend_item", 1, menu, "GMenu*");
  item = s7_car(_p);
  if (!s7_is_c_pointer_of_type(item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend_item", 2, item, "GMenuItem*");
  g_menu_prepend_item((GMenu*)s7_c_pointer(menu), (GMenuItem*)s7_c_pointer(item));
  return(lg_false);
}

static s7_pointer lg_g_menu_append_item(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_append_item "void g_menu_append_item(GMenu* menu, GMenuItem* item)"
  s7_pointer _p;
  s7_pointer menu, item;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_append_item", 1, menu, "GMenu*");
  item = s7_car(_p);
  if (!s7_is_c_pointer_of_type(item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_append_item", 2, item, "GMenuItem*");
  g_menu_append_item((GMenu*)s7_c_pointer(menu), (GMenuItem*)s7_c_pointer(item));
  return(lg_false);
}

static s7_pointer lg_g_menu_remove(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_remove "void g_menu_remove(GMenu* menu, gint position)"
  s7_pointer _p;
  s7_pointer menu, position;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_remove", 1, menu, "GMenu*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "g_menu_remove", 2, position, "gint");
  g_menu_remove((GMenu*)s7_c_pointer(menu), (gint)s7_integer(position));
  return(lg_false);
}

static s7_pointer lg_g_menu_remove_all(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_remove_all "void g_menu_remove_all(GMenu* menu)"
  s7_pointer menu;
  menu = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_remove_all", 1, menu, "GMenu*");
  g_menu_remove_all((GMenu*)s7_c_pointer(menu));
  return(lg_false);
}

static s7_pointer lg_g_menu_insert(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_insert "void g_menu_insert(GMenu* menu, gint position, gchar* label, gchar* detailed_action)"
  s7_pointer _p;
  s7_pointer menu, position, label, detailed_action;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert", 1, menu, "GMenu*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "g_menu_insert", 2, position, "gint");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_insert", 3, label, "gchar*");
  detailed_action = s7_car(_p);
  if (!s7_is_string(detailed_action)) s7_wrong_type_arg_error(sc, "g_menu_insert", 4, detailed_action, "gchar*");
  g_menu_insert((GMenu*)s7_c_pointer(menu), (gint)s7_integer(position), (gchar*)s7_string(label), (gchar*)s7_string(detailed_action));
  return(lg_false);
}

static s7_pointer lg_g_menu_prepend(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_prepend "void g_menu_prepend(GMenu* menu, gchar* label, gchar* detailed_action)"
  s7_pointer _p;
  s7_pointer menu, label, detailed_action;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend", 1, menu, "GMenu*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_prepend", 2, label, "gchar*");
  detailed_action = s7_car(_p);
  if (!s7_is_string(detailed_action)) s7_wrong_type_arg_error(sc, "g_menu_prepend", 3, detailed_action, "gchar*");
  g_menu_prepend((GMenu*)s7_c_pointer(menu), (gchar*)s7_string(label), (gchar*)s7_string(detailed_action));
  return(lg_false);
}

static s7_pointer lg_g_menu_append(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_append "void g_menu_append(GMenu* menu, gchar* label, gchar* detailed_action)"
  s7_pointer _p;
  s7_pointer menu, label, detailed_action;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_append", 1, menu, "GMenu*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_append", 2, label, "gchar*");
  detailed_action = s7_car(_p);
  if (!s7_is_string(detailed_action)) s7_wrong_type_arg_error(sc, "g_menu_append", 3, detailed_action, "gchar*");
  g_menu_append((GMenu*)s7_c_pointer(menu), (gchar*)s7_string(label), (gchar*)s7_string(detailed_action));
  return(lg_false);
}

static s7_pointer lg_g_menu_insert_section(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_insert_section "void g_menu_insert_section(GMenu* menu, gint position, gchar* label, \
GMenuModel* section)"
  s7_pointer _p;
  s7_pointer menu, position, label, section;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert_section", 1, menu, "GMenu*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "g_menu_insert_section", 2, position, "gint");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_insert_section", 3, label, "gchar*");
  section = s7_car(_p);
  if (!s7_is_c_pointer_of_type(section, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert_section", 4, section, "GMenuModel*");
  g_menu_insert_section((GMenu*)s7_c_pointer(menu), (gint)s7_integer(position), (gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(section));
  return(lg_false);
}

static s7_pointer lg_g_menu_prepend_section(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_prepend_section "void g_menu_prepend_section(GMenu* menu, gchar* label, GMenuModel* section)"
  s7_pointer _p;
  s7_pointer menu, label, section;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend_section", 1, menu, "GMenu*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_prepend_section", 2, label, "gchar*");
  section = s7_car(_p);
  if (!s7_is_c_pointer_of_type(section, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend_section", 3, section, "GMenuModel*");
  g_menu_prepend_section((GMenu*)s7_c_pointer(menu), (gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(section));
  return(lg_false);
}

static s7_pointer lg_g_menu_append_section(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_append_section "void g_menu_append_section(GMenu* menu, gchar* label, GMenuModel* section)"
  s7_pointer _p;
  s7_pointer menu, label, section;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_append_section", 1, menu, "GMenu*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_append_section", 2, label, "gchar*");
  section = s7_car(_p);
  if (!s7_is_c_pointer_of_type(section, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_append_section", 3, section, "GMenuModel*");
  g_menu_append_section((GMenu*)s7_c_pointer(menu), (gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(section));
  return(lg_false);
}

static s7_pointer lg_g_menu_insert_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_insert_submenu "void g_menu_insert_submenu(GMenu* menu, gint position, gchar* label, \
GMenuModel* submenu)"
  s7_pointer _p;
  s7_pointer menu, position, label, submenu;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert_submenu", 1, menu, "GMenu*");
  position = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "g_menu_insert_submenu", 2, position, "gint");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_insert_submenu", 3, label, "gchar*");
  submenu = s7_car(_p);
  if (!s7_is_c_pointer_of_type(submenu, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_insert_submenu", 4, submenu, "GMenuModel*");
  g_menu_insert_submenu((GMenu*)s7_c_pointer(menu), (gint)s7_integer(position), (gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(submenu));
  return(lg_false);
}

static s7_pointer lg_g_menu_prepend_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_prepend_submenu "void g_menu_prepend_submenu(GMenu* menu, gchar* label, GMenuModel* submenu)"
  s7_pointer _p;
  s7_pointer menu, label, submenu;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend_submenu", 1, menu, "GMenu*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_prepend_submenu", 2, label, "gchar*");
  submenu = s7_car(_p);
  if (!s7_is_c_pointer_of_type(submenu, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_prepend_submenu", 3, submenu, "GMenuModel*");
  g_menu_prepend_submenu((GMenu*)s7_c_pointer(menu), (gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(submenu));
  return(lg_false);
}

static s7_pointer lg_g_menu_append_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_append_submenu "void g_menu_append_submenu(GMenu* menu, gchar* label, GMenuModel* submenu)"
  s7_pointer _p;
  s7_pointer menu, label, submenu;
  _p = args;
  menu = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu, GMenu__sym)) s7_wrong_type_arg_error(sc, "g_menu_append_submenu", 1, menu, "GMenu*");
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_append_submenu", 2, label, "gchar*");
  submenu = s7_car(_p);
  if (!s7_is_c_pointer_of_type(submenu, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_append_submenu", 3, submenu, "GMenuModel*");
  g_menu_append_submenu((GMenu*)s7_c_pointer(menu), (gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(submenu));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_new(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_new "GMenuItem* g_menu_item_new(gchar* label, gchar* detailed_action)"
  s7_pointer _p;
  s7_pointer label, detailed_action;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_item_new", 1, label, "gchar*");
  detailed_action = s7_car(_p);
  if (!s7_is_string(detailed_action)) s7_wrong_type_arg_error(sc, "g_menu_item_new", 2, detailed_action, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GMenuItem__sym, g_menu_item_new((gchar*)s7_string(label), (gchar*)s7_string(detailed_action))));
}

static s7_pointer lg_g_menu_item_new_from_model(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_new_from_model "GMenuItem* g_menu_item_new_from_model(GMenuModel* model, gint item_index)"
  s7_pointer _p;
  s7_pointer model, item_index;
  _p = args;
  model = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_new_from_model", 1, model, "GMenuModel*");
  item_index = s7_car(_p);
  if (!s7_is_integer(item_index)) s7_wrong_type_arg_error(sc, "g_menu_item_new_from_model", 2, item_index, "gint");
  return(lg_make_c_pointer_with_type(sc, GMenuItem__sym, g_menu_item_new_from_model((GMenuModel*)s7_c_pointer(model), (gint)s7_integer(item_index))));
}

static s7_pointer lg_g_menu_item_new_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_new_submenu "GMenuItem* g_menu_item_new_submenu(gchar* label, GMenuModel* submenu)"
  s7_pointer _p;
  s7_pointer label, submenu;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_item_new_submenu", 1, label, "gchar*");
  submenu = s7_car(_p);
  if (!s7_is_c_pointer_of_type(submenu, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_new_submenu", 2, submenu, "GMenuModel*");
  return(lg_make_c_pointer_with_type(sc, GMenuItem__sym, g_menu_item_new_submenu((gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(submenu))));
}

static s7_pointer lg_g_menu_item_new_section(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_new_section "GMenuItem* g_menu_item_new_section(gchar* label, GMenuModel* section)"
  s7_pointer _p;
  s7_pointer label, section;
  _p = args;
  label = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(label)) s7_wrong_type_arg_error(sc, "g_menu_item_new_section", 1, label, "gchar*");
  section = s7_car(_p);
  if (!s7_is_c_pointer_of_type(section, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_new_section", 2, section, "GMenuModel*");
  return(lg_make_c_pointer_with_type(sc, GMenuItem__sym, g_menu_item_new_section((gchar*)s7_string(label), (GMenuModel*)s7_c_pointer(section))));
}

static s7_pointer lg_g_menu_item_get_attribute_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_get_attribute_value "GVariant* g_menu_item_get_attribute_value(GMenuItem* menu_item, \
gchar* attribute, GVariantType* expected_type)"
  s7_pointer _p;
  s7_pointer menu_item, attribute, expected_type;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_get_attribute_value", 1, menu_item, "GMenuItem*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "g_menu_item_get_attribute_value", 2, attribute, "gchar*");
  expected_type = s7_car(_p);
  if (!s7_is_c_pointer_of_type(expected_type, GVariantType__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_get_attribute_value", 3, expected_type, "GVariantType*");
  return(lg_make_c_pointer_with_type(sc, GVariant__sym, g_menu_item_get_attribute_value((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(attribute), (GVariantType*)s7_c_pointer(expected_type))));
}

static s7_pointer lg_g_menu_item_get_link(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_get_link "GMenuModel* g_menu_item_get_link(GMenuItem* menu_item, gchar* link)"
  s7_pointer _p;
  s7_pointer menu_item, link;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_get_link", 1, menu_item, "GMenuItem*");
  link = s7_car(_p);
  if (!s7_is_string(link)) s7_wrong_type_arg_error(sc, "g_menu_item_get_link", 2, link, "gchar*");
  return(lg_make_c_pointer_with_type(sc, GMenuModel__sym, g_menu_item_get_link((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(link))));
}

static s7_pointer lg_g_menu_item_set_attribute_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_attribute_value "void g_menu_item_set_attribute_value(GMenuItem* menu_item, \
gchar* attribute, GVariant* value)"
  s7_pointer _p;
  s7_pointer menu_item, attribute, value;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_attribute_value", 1, menu_item, "GMenuItem*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "g_menu_item_set_attribute_value", 2, attribute, "gchar*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, GVariant__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_attribute_value", 3, value, "GVariant*");
  g_menu_item_set_attribute_value((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(attribute), (GVariant*)s7_c_pointer(value));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_attribute(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_attribute "void g_menu_item_set_attribute(GMenuItem* menu_item, gchar* attribute, \
gchar* format_string, )"
  s7_pointer _p;
  s7_pointer menu_item, attribute, format_string ;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_attribute", 1, menu_item, "GMenuItem*");
  attribute = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(attribute)) s7_wrong_type_arg_error(sc, "g_menu_item_set_attribute", 2, attribute, "gchar*");
  format_string  = s7_car(_p);
  if (!s7_is_string(format_string )) s7_wrong_type_arg_error(sc, "g_menu_item_set_attribute", 3, format_string , "gchar*");
  g_menu_item_set_attribute((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(attribute), (gchar*)s7_string(format_string ));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_link(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_link "void g_menu_item_set_link(GMenuItem* menu_item, gchar* link, GMenuModel* model)"
  s7_pointer _p;
  s7_pointer menu_item, link, model;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_link", 1, menu_item, "GMenuItem*");
  link = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(link)) s7_wrong_type_arg_error(sc, "g_menu_item_set_link", 2, link, "gchar*");
  model = s7_car(_p);
  if (!s7_is_c_pointer_of_type(model, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_link", 3, model, "GMenuModel*");
  g_menu_item_set_link((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(link), (GMenuModel*)s7_c_pointer(model));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_label(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_label "void g_menu_item_set_label(GMenuItem* menu_item, dd gchar*, label)"
  s7_pointer _p;
  s7_pointer menu_item, gchar*;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_label", 1, menu_item, "GMenuItem*");
  gchar* = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gchar*, dd_sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_label", 2, gchar*, "dd");
  g_menu_item_set_label((GMenuItem*)s7_c_pointer(menu_item), (dd)s7_c_pointer(gchar*));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_submenu(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_submenu "void g_menu_item_set_submenu(GMenuItem* menu_item, GMenuModel* submenu)"
  s7_pointer _p;
  s7_pointer menu_item, submenu;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_submenu", 1, menu_item, "GMenuItem*");
  submenu = s7_car(_p);
  if (!s7_is_c_pointer_of_type(submenu, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_submenu", 2, submenu, "GMenuModel*");
  g_menu_item_set_submenu((GMenuItem*)s7_c_pointer(menu_item), (GMenuModel*)s7_c_pointer(submenu));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_section(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_section "void g_menu_item_set_section(GMenuItem* menu_item, GMenuModel* section)"
  s7_pointer _p;
  s7_pointer menu_item, section;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_section", 1, menu_item, "GMenuItem*");
  section = s7_car(_p);
  if (!s7_is_c_pointer_of_type(section, GMenuModel__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_section", 2, section, "GMenuModel*");
  g_menu_item_set_section((GMenuItem*)s7_c_pointer(menu_item), (GMenuModel*)s7_c_pointer(section));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_action_and_target_value(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_action_and_target_value "void g_menu_item_set_action_and_target_value(GMenuItem* menu_item, \
d gchar*, action d, GVariant* target_value)"
  s7_pointer _p;
  s7_pointer menu_item, gchar*, d, target_value;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target_value", 1, menu_item, "GMenuItem*");
  gchar* = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(gchar*, d_sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target_value", 2, gchar*, "d");
  d = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(d, action_sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target_value", 3, d, "action");
  target_value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(target_value, GVariant__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target_value", 4, target_value, "GVariant*");
  g_menu_item_set_action_and_target_value((GMenuItem*)s7_c_pointer(menu_item), (d)s7_c_pointer(gchar*), (action)s7_c_pointer(d), (GVariant*)s7_c_pointer(target_value));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_action_and_target(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_action_and_target "void g_menu_item_set_action_and_target(GMenuItem* menu_item, \
gchar* action, d gchar*, format_string )"
  s7_pointer _p;
  s7_pointer menu_item, action, gchar*;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target", 1, menu_item, "GMenuItem*");
  action = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(action)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target", 2, action, "gchar*");
  gchar* = s7_car(_p);
  if (!s7_is_c_pointer_of_type(gchar*, d_sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_action_and_target", 3, gchar*, "d");
  g_menu_item_set_action_and_target((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(action), (d)s7_c_pointer(gchar*));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_detailed_action(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_detailed_action "void g_menu_item_set_detailed_action(GMenuItem* menu_item, \
gchar* detailed_action)"
  s7_pointer _p;
  s7_pointer menu_item, detailed_action;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_detailed_action", 1, menu_item, "GMenuItem*");
  detailed_action = s7_car(_p);
  if (!s7_is_string(detailed_action)) s7_wrong_type_arg_error(sc, "g_menu_item_set_detailed_action", 2, detailed_action, "gchar*");
  g_menu_item_set_detailed_action((GMenuItem*)s7_c_pointer(menu_item), (gchar*)s7_string(detailed_action));
  return(lg_false);
}

static s7_pointer lg_g_menu_item_set_icon(s7_scheme *sc, s7_pointer args)
{
  #define H_g_menu_item_set_icon "void g_menu_item_set_icon(GMenuItem* menu_item, GIcon* icon)"
  s7_pointer _p;
  s7_pointer menu_item, icon;
  _p = args;
  menu_item = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_item, GMenuItem__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_icon", 1, menu_item, "GMenuItem*");
  icon = s7_car(_p);
  if (!s7_is_c_pointer_of_type(icon, GIcon__sym)) s7_wrong_type_arg_error(sc, "g_menu_item_set_icon", 2, icon, "GIcon*");
  g_menu_item_set_icon((GMenuItem*)s7_c_pointer(menu_item), (GIcon*)s7_c_pointer(icon));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_get_default_mod_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_get_default_mod_mask "GdkModifierType gtk_accelerator_get_default_mod_mask( void)"
  return(s7_make_integer(sc, gtk_accelerator_get_default_mod_mask()));
}

static s7_pointer lg_gdk_toplevel_inhibit_system_shortcuts(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_inhibit_system_shortcuts "void gdk_toplevel_inhibit_system_shortcuts(GdkToplevel* toplevel, \
GdkEvent* event)"
  s7_pointer _p;
  s7_pointer toplevel, event;
  _p = args;
  toplevel = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_inhibit_system_shortcuts", 1, toplevel, "GdkToplevel*");
  event = s7_car(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_inhibit_system_shortcuts", 2, event, "GdkEvent*");
  gdk_toplevel_inhibit_system_shortcuts((GdkToplevel*)s7_c_pointer(toplevel), (GdkEvent*)s7_c_pointer(event));
  return(lg_false);
}

static s7_pointer lg_gdk_toplevel_restore_system_shortcuts(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_toplevel_restore_system_shortcuts "void gdk_toplevel_restore_system_shortcuts(GdkToplevel* toplevel)"
  s7_pointer toplevel;
  toplevel = s7_car(args);
  if (!s7_is_c_pointer_of_type(toplevel, GdkToplevel__sym)) s7_wrong_type_arg_error(sc, "gdk_toplevel_restore_system_shortcuts", 1, toplevel, "GdkToplevel*");
  gdk_toplevel_restore_system_shortcuts((GdkToplevel*)s7_c_pointer(toplevel));
  return(lg_false);
}

static s7_pointer lg_gtk_accelerator_valid(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_valid "gboolean gtk_accelerator_valid(guint keyval, GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer keyval, modifiers;
  _p = args;
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_accelerator_valid", 1, keyval, "guint");
  modifiers = s7_car(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_accelerator_valid", 2, modifiers, "GdkModifierType");
  return(s7_make_boolean(sc, gtk_accelerator_valid((guint)s7_integer(keyval), (GdkModifierType)s7_integer(modifiers))));
}

static s7_pointer lg_gtk_accelerator_parse(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_parse "gboolean gtk_accelerator_parse(gchar* accelerator, guint* accelerator_key, \
GdkModifierType* accelerator_mods)"
  s7_pointer _p;
  s7_pointer accelerator, accelerator_key, accelerator_mods;
  _p = args;
  accelerator = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(accelerator)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse", 1, accelerator, "gchar*");
  accelerator_key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(accelerator_key, guint__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse", 2, accelerator_key, "guint*");
  accelerator_mods = s7_car(_p);
  if (!s7_is_c_pointer_of_type(accelerator_mods, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gtk_accelerator_parse", 3, accelerator_mods, "GdkModifierType*");
  return(s7_make_boolean(sc, gtk_accelerator_parse((const gchar*)s7_string(accelerator), (guint*)s7_c_pointer(accelerator_key), (GdkModifierType*)s7_c_pointer(accelerator_mods))));
}

static s7_pointer lg_gtk_accelerator_set_default_mod_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_accelerator_set_default_mod_mask "void gtk_accelerator_set_default_mod_mask(GdkModifierType default_mod_mask)"
  s7_pointer default_mod_mask;
  default_mod_mask = s7_car(args);
  if (!s7_is_integer(default_mod_mask)) s7_wrong_type_arg_error(sc, "gtk_accelerator_set_default_mod_mask", 1, default_mod_mask, "GdkModifierType");
  gtk_accelerator_set_default_mod_mask((GdkModifierType)s7_integer(default_mod_mask));
  return(lg_false);
}

static s7_pointer lg_gtk_flatten_list_model_get_model_for_item(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_flatten_list_model_get_model_for_item "GListModel* gtk_flatten_list_model_get_model_for_item(GtkFlattenListModel* self, \
guint position)"
  s7_pointer _p;
  s7_pointer self, position;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkFlattenListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_get_model_for_item", 1, self, "GtkFlattenListModel*");
  position = s7_car(_p);
  if (!s7_is_integer(position)) s7_wrong_type_arg_error(sc, "gtk_flatten_list_model_get_model_for_item", 2, position, "guint");
  return(lg_make_c_pointer_with_type(sc, GListModel__sym, gtk_flatten_list_model_get_model_for_item((GtkFlattenListModel*)s7_c_pointer(self), (guint)s7_integer(position))));
}

static s7_pointer lg_gtk_menu_button_set_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_use_underline "void gtk_menu_button_set_use_underline(GtkMenuButton* menu_button, \
gboolean use_underline)"
  s7_pointer _p;
  s7_pointer menu_button, use_underline;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_use_underline", 1, menu_button, "GtkMenuButton*");
  use_underline = s7_car(_p);
  if (!s7_is_boolean(use_underline)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_use_underline", 2, use_underline, "gboolean");
  gtk_menu_button_set_use_underline((GtkMenuButton*)s7_c_pointer(menu_button), (gboolean)lg_boolean(use_underline));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_use_underline(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_use_underline "gboolean gtk_menu_button_get_use_underline(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_use_underline", 1, menu_button, "GtkMenuButton*");
  return(s7_make_boolean(sc, gtk_menu_button_get_use_underline((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_popover_set_mnemonics_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_set_mnemonics_visible "void gtk_popover_set_mnemonics_visible(GtkPopover* popover, \
gboolean mnemonics_visible)"
  s7_pointer _p;
  s7_pointer popover, mnemonics_visible;
  _p = args;
  popover = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_set_mnemonics_visible", 1, popover, "GtkPopover*");
  mnemonics_visible = s7_car(_p);
  if (!s7_is_boolean(mnemonics_visible)) s7_wrong_type_arg_error(sc, "gtk_popover_set_mnemonics_visible", 2, mnemonics_visible, "gboolean");
  gtk_popover_set_mnemonics_visible((GtkPopover*)s7_c_pointer(popover), (gboolean)lg_boolean(mnemonics_visible));
  return(lg_false);
}

static s7_pointer lg_gtk_popover_get_mnemonics_visible(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_popover_get_mnemonics_visible "gboolean gtk_popover_get_mnemonics_visible(GtkPopover* popover)"
  s7_pointer popover;
  popover = s7_car(args);
  if (!s7_is_c_pointer_of_type(popover, GtkPopover__sym)) s7_wrong_type_arg_error(sc, "gtk_popover_get_mnemonics_visible", 1, popover, "GtkPopover*");
  return(s7_make_boolean(sc, gtk_popover_get_mnemonics_visible((GtkPopover*)s7_c_pointer(popover))));
}

static s7_pointer lg_gtk_shortcut_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_new "GtkShortcut* gtk_shortcut_new(GtkShortcutTrigger* trigger, GtkShortcutAction* action)"
  s7_pointer _p;
  s7_pointer trigger, action;
  _p = args;
  trigger = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(trigger, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_new", 1, trigger, "GtkShortcutTrigger*");
  action = s7_car(_p);
  if (!s7_is_c_pointer_of_type(action, GtkShortcutAction__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_new", 2, action, "GtkShortcutAction*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcut__sym, gtk_shortcut_new((GtkShortcutTrigger*)s7_c_pointer(trigger), (GtkShortcutAction*)s7_c_pointer(action))));
}

static s7_pointer lg_gtk_shortcut_get_trigger(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_get_trigger "GtkShortcutTrigger* gtk_shortcut_get_trigger(GtkShortcut* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_get_trigger", 1, self, "GtkShortcut*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_shortcut_get_trigger((GtkShortcut*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_set_trigger(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_set_trigger "void gtk_shortcut_set_trigger(GtkShortcut* self, GtkShortcutTrigger* trigger)"
  s7_pointer _p;
  s7_pointer self, trigger;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_set_trigger", 1, self, "GtkShortcut*");
  trigger = s7_car(_p);
  if (!s7_is_c_pointer_of_type(trigger, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_set_trigger", 2, trigger, "GtkShortcutTrigger*");
  gtk_shortcut_set_trigger((GtkShortcut*)s7_c_pointer(self), (GtkShortcutTrigger*)s7_c_pointer(trigger));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_get_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_get_action "GtkShortcutAction* gtk_shortcut_get_action(GtkShortcut* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_get_action", 1, self, "GtkShortcut*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_shortcut_get_action((GtkShortcut*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_set_action(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_set_action "void gtk_shortcut_set_action(GtkShortcut* self, GtkShortcutAction* action)"
  s7_pointer _p;
  s7_pointer self, action;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_set_action", 1, self, "GtkShortcut*");
  action = s7_car(_p);
  if (!s7_is_c_pointer_of_type(action, GtkShortcutAction__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_set_action", 2, action, "GtkShortcutAction*");
  gtk_shortcut_set_action((GtkShortcut*)s7_c_pointer(self), (GtkShortcutAction*)s7_c_pointer(action));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_get_arguments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_get_arguments "GVariant* gtk_shortcut_get_arguments(GtkShortcut* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_get_arguments", 1, self, "GtkShortcut*");
  return(lg_make_c_pointer_with_type(sc, GVariant__sym, gtk_shortcut_get_arguments((GtkShortcut*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_set_arguments(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_set_arguments "void gtk_shortcut_set_arguments(GtkShortcut* self, GVariant* args)"
  s7_pointer _p;
  s7_pointer self, args;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_set_arguments", 1, self, "GtkShortcut*");
  args = s7_car(_p);
  if (!s7_is_c_pointer_of_type(args, GVariant__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_set_arguments", 2, args, "GVariant*");
  gtk_shortcut_set_arguments((GtkShortcut*)s7_c_pointer(self), (GVariant*)s7_c_pointer(args));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_action_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_action_to_string "char* gtk_shortcut_action_to_string(GtkShortcutAction* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutAction__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_to_string", 1, self, "GtkShortcutAction*");
  return(s7_make_string(sc, gtk_shortcut_action_to_string((GtkShortcutAction*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_action_print(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_action_print "void gtk_shortcut_action_print(GtkShortcutAction* self, GString* string)"
  s7_pointer _p;
  s7_pointer self, string;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutAction__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_print", 1, self, "GtkShortcutAction*");
  string = s7_car(_p);
  if (!s7_is_c_pointer_of_type(string, GString__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_print", 2, string, "GString*");
  gtk_shortcut_action_print((GtkShortcutAction*)s7_c_pointer(self), (GString*)s7_c_pointer(string));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_action_activate(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_action_activate "gboolean gtk_shortcut_action_activate(GtkShortcutAction* self, \
GtkShortcutActionFlags flags, GtkWidget* widget, GVariant* args)"
  s7_pointer _p;
  s7_pointer self, flags, widget, args;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutAction__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_activate", 1, self, "GtkShortcutAction*");
  flags = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(flags)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_activate", 2, flags, "GtkShortcutActionFlags");
  widget = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(widget, GtkWidget__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_activate", 3, widget, "GtkWidget*");
  args = s7_car(_p);
  if (!s7_is_c_pointer_of_type(args, GVariant__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_activate", 4, args, "GVariant*");
  return(s7_make_boolean(sc, gtk_shortcut_action_activate((GtkShortcutAction*)s7_c_pointer(self), (GtkShortcutActionFlags)s7_integer(flags), (GtkWidget*)s7_c_pointer(widget), (GVariant*)s7_c_pointer(args))));
}

static s7_pointer lg_gtk_nothing_action_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_nothing_action_get "GtkShortcutAction* gtk_nothing_action_get( void)"
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_nothing_action_get()));
}

static s7_pointer lg_gtk_callback_action_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_callback_action_new "GtkShortcutAction* gtk_callback_action_new(GtkShortcutFunc callback, \
gpointer data, GDestroyNotify destroy)"
  s7_pointer _p;
  s7_pointer callback, data, destroy;
  _p = args;
  callback = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(callback, GtkShortcutFunc_sym)) s7_wrong_type_arg_error(sc, "gtk_callback_action_new", 1, callback, "GtkShortcutFunc");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, gpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_callback_action_new", 2, data, "gpointer");
  destroy = s7_car(_p);
  {
    s7_pointer res_ult;
    s7_pointer lg_ptr = s7_list(sc, 5, lg_false, func_info, lg_false, lg_false, lg_false);
    s7_gc_protect(sc, lg_ptr);
    s7_list_set(sc, lg_ptr, 3, destroy);
    res_ult = lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_callback_action_new((GtkShortcutFunc)s7_c_pointer(callback), (gpointer)s7_c_pointer(data), lg_destroy_func));
    return(res_ult);
   }
}

static s7_pointer lg_gtk_mnemonic_action_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_mnemonic_action_get "GtkShortcutAction* gtk_mnemonic_action_get( void)"
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_mnemonic_action_get()));
}

static s7_pointer lg_gtk_activate_action_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_activate_action_get "GtkShortcutAction* gtk_activate_action_get( void)"
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_activate_action_get()));
}

static s7_pointer lg_gtk_signal_action_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_signal_action_new "GtkShortcutAction* gtk_signal_action_new(char* signal_name)"
  s7_pointer signal_name;
  signal_name = s7_car(args);
  if (!s7_is_string(signal_name)) s7_wrong_type_arg_error(sc, "gtk_signal_action_new", 1, signal_name, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_signal_action_new((const char*)(char*)s7_string(signal_name))));
}

static s7_pointer lg_gtk_signal_action_get_signal_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_signal_action_get_signal_name "char* gtk_signal_action_get_signal_name(GtkSignalAction* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkSignalAction__sym)) s7_wrong_type_arg_error(sc, "gtk_signal_action_get_signal_name", 1, self, "GtkSignalAction*");
  return(s7_make_string(sc, gtk_signal_action_get_signal_name((GtkSignalAction*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_named_action_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_named_action_new "GtkShortcutAction* gtk_named_action_new(char* name)"
  s7_pointer name;
  name = s7_car(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "gtk_named_action_new", 1, name, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_named_action_new((const char*)(char*)s7_string(name))));
}

static s7_pointer lg_gtk_named_action_get_action_name(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_named_action_get_action_name "char* gtk_named_action_get_action_name(GtkNamedAction* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkNamedAction__sym)) s7_wrong_type_arg_error(sc, "gtk_named_action_get_action_name", 1, self, "GtkNamedAction*");
  return(s7_make_string(sc, gtk_named_action_get_action_name((GtkNamedAction*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_controller_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_new "GtkEventController* gtk_shortcut_controller_new( void)"
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_shortcut_controller_new()));
}

static s7_pointer lg_gtk_shortcut_controller_new_for_model(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_new_for_model "GtkEventController* gtk_shortcut_controller_new_for_model(GListModel* list)"
  s7_pointer list;
  list = s7_car(args);
  if (!s7_is_c_pointer_of_type(list, GListModel__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_new_for_model", 1, list, "GListModel*");
  return(lg_make_c_pointer_with_type(sc, GtkEventController__sym, gtk_shortcut_controller_new_for_model((GListModel*)s7_c_pointer(list))));
}

static s7_pointer lg_gtk_shortcut_controller_set_mnemonics_modifiers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_set_mnemonics_modifiers "void gtk_shortcut_controller_set_mnemonics_modifiers(GtkShortcutController* self, \
GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer self, modifiers;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutController__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_set_mnemonics_modifiers", 1, self, "GtkShortcutController*");
  modifiers = s7_car(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_set_mnemonics_modifiers", 2, modifiers, "GdkModifierType");
  gtk_shortcut_controller_set_mnemonics_modifiers((GtkShortcutController*)s7_c_pointer(self), (GdkModifierType)s7_integer(modifiers));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_controller_get_mnemonics_modifiers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_get_mnemonics_modifiers "GdkModifierType gtk_shortcut_controller_get_mnemonics_modifiers(GtkShortcutController* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutController__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_get_mnemonics_modifiers", 1, self, "GtkShortcutController*");
  return(s7_make_integer(sc, gtk_shortcut_controller_get_mnemonics_modifiers((GtkShortcutController*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_controller_set_scope(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_set_scope "void gtk_shortcut_controller_set_scope(GtkShortcutController* self, \
GtkShortcutScope scope)"
  s7_pointer _p;
  s7_pointer self, scope;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutController__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_set_scope", 1, self, "GtkShortcutController*");
  scope = s7_car(_p);
  if (!s7_is_integer(scope)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_set_scope", 2, scope, "GtkShortcutScope");
  gtk_shortcut_controller_set_scope((GtkShortcutController*)s7_c_pointer(self), (GtkShortcutScope)s7_integer(scope));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_controller_get_scope(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_get_scope "GtkShortcutScope gtk_shortcut_controller_get_scope(GtkShortcutController* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutController__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_get_scope", 1, self, "GtkShortcutController*");
  return(s7_make_integer(sc, gtk_shortcut_controller_get_scope((GtkShortcutController*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_controller_add_shortcut(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_add_shortcut "void gtk_shortcut_controller_add_shortcut(GtkShortcutController* self, \
GtkShortcut* shortcut)"
  s7_pointer _p;
  s7_pointer self, shortcut;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutController__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_add_shortcut", 1, self, "GtkShortcutController*");
  shortcut = s7_car(_p);
  if (!s7_is_c_pointer_of_type(shortcut, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_add_shortcut", 2, shortcut, "GtkShortcut*");
  gtk_shortcut_controller_add_shortcut((GtkShortcutController*)s7_c_pointer(self), (GtkShortcut*)s7_c_pointer(shortcut));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_controller_remove_shortcut(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_controller_remove_shortcut "void gtk_shortcut_controller_remove_shortcut(GtkShortcutController* self, \
GtkShortcut* shortcut)"
  s7_pointer _p;
  s7_pointer self, shortcut;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutController__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_remove_shortcut", 1, self, "GtkShortcutController*");
  shortcut = s7_car(_p);
  if (!s7_is_c_pointer_of_type(shortcut, GtkShortcut__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_controller_remove_shortcut", 2, shortcut, "GtkShortcut*");
  gtk_shortcut_controller_remove_shortcut((GtkShortcutController*)s7_c_pointer(self), (GtkShortcut*)s7_c_pointer(shortcut));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_trigger_parse_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_parse_string "GtkShortcutTrigger* gtk_shortcut_trigger_parse_string(char* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_parse_string", 1, string, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_shortcut_trigger_parse_string((const char*)(char*)s7_string(string))));
}

static s7_pointer lg_gtk_shortcut_trigger_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_to_string "char* gtk_shortcut_trigger_to_string(GtkShortcutTrigger* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_to_string", 1, self, "GtkShortcutTrigger*");
  return(s7_make_string(sc, gtk_shortcut_trigger_to_string((GtkShortcutTrigger*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_trigger_print(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_print "void gtk_shortcut_trigger_print(GtkShortcutTrigger* self, GString* string)"
  s7_pointer _p;
  s7_pointer self, string;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_print", 1, self, "GtkShortcutTrigger*");
  string = s7_car(_p);
  if (!s7_is_c_pointer_of_type(string, GString__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_print", 2, string, "GString*");
  gtk_shortcut_trigger_print((GtkShortcutTrigger*)s7_c_pointer(self), (GString*)s7_c_pointer(string));
  return(lg_false);
}

static s7_pointer lg_gtk_shortcut_trigger_to_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_to_label "char* gtk_shortcut_trigger_to_label(GtkShortcutTrigger* self, \
GdkDisplay* display)"
  s7_pointer _p;
  s7_pointer self, display;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_to_label", 1, self, "GtkShortcutTrigger*");
  display = s7_car(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_to_label", 2, display, "GdkDisplay*");
  return(s7_make_string(sc, gtk_shortcut_trigger_to_label((GtkShortcutTrigger*)s7_c_pointer(self), (GdkDisplay*)s7_c_pointer(display))));
}

static s7_pointer lg_gtk_shortcut_trigger_print_label(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_print_label "gboolean gtk_shortcut_trigger_print_label(GtkShortcutTrigger* self, \
GdkDisplay* display, GString* string)"
  s7_pointer _p;
  s7_pointer self, display, string;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_print_label", 1, self, "GtkShortcutTrigger*");
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_print_label", 2, display, "GdkDisplay*");
  string = s7_car(_p);
  if (!s7_is_c_pointer_of_type(string, GString__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_print_label", 3, string, "GString*");
  return(s7_make_boolean(sc, gtk_shortcut_trigger_print_label((GtkShortcutTrigger*)s7_c_pointer(self), (GdkDisplay*)s7_c_pointer(display), (GString*)s7_c_pointer(string))));
}

static s7_pointer lg_gtk_shortcut_trigger_hash(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_hash "guint gtk_shortcut_trigger_hash(gconstpointer trigger)"
  s7_pointer trigger;
  trigger = s7_car(args);
  if (!s7_is_c_pointer_of_type(trigger, gconstpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_hash", 1, trigger, "gconstpointer");
  return(s7_make_integer(sc, gtk_shortcut_trigger_hash((gconstpointer)s7_c_pointer(trigger))));
}

static s7_pointer lg_gtk_shortcut_trigger_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_equal "gboolean gtk_shortcut_trigger_equal(gconstpointer trigger1, gconstpointer trigger2)"
  s7_pointer _p;
  s7_pointer trigger1, trigger2;
  _p = args;
  trigger1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(trigger1, gconstpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_equal", 1, trigger1, "gconstpointer");
  trigger2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(trigger2, gconstpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_equal", 2, trigger2, "gconstpointer");
  return(s7_make_boolean(sc, gtk_shortcut_trigger_equal((gconstpointer)s7_c_pointer(trigger1), (gconstpointer)s7_c_pointer(trigger2))));
}

static s7_pointer lg_gtk_shortcut_trigger_compare(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_compare "gint gtk_shortcut_trigger_compare(gconstpointer trigger1, gconstpointer trigger2)"
  s7_pointer _p;
  s7_pointer trigger1, trigger2;
  _p = args;
  trigger1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(trigger1, gconstpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_compare", 1, trigger1, "gconstpointer");
  trigger2 = s7_car(_p);
  if (!s7_is_c_pointer_of_type(trigger2, gconstpointer_sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_compare", 2, trigger2, "gconstpointer");
  return(s7_make_integer(sc, gtk_shortcut_trigger_compare((gconstpointer)s7_c_pointer(trigger1), (gconstpointer)s7_c_pointer(trigger2))));
}

static s7_pointer lg_gtk_never_trigger_get(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_never_trigger_get "GtkShortcutTrigger* gtk_never_trigger_get( void)"
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_never_trigger_get()));
}

static s7_pointer lg_gtk_keyval_trigger_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_keyval_trigger_new "GtkShortcutTrigger* gtk_keyval_trigger_new(guint keyval, GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer keyval, modifiers;
  _p = args;
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_keyval_trigger_new", 1, keyval, "guint");
  modifiers = s7_car(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gtk_keyval_trigger_new", 2, modifiers, "GdkModifierType");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_keyval_trigger_new((guint)s7_integer(keyval), (GdkModifierType)s7_integer(modifiers))));
}

static s7_pointer lg_gtk_keyval_trigger_get_modifiers(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_keyval_trigger_get_modifiers "GdkModifierType gtk_keyval_trigger_get_modifiers(GtkKeyvalTrigger* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkKeyvalTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_keyval_trigger_get_modifiers", 1, self, "GtkKeyvalTrigger*");
  return(s7_make_integer(sc, gtk_keyval_trigger_get_modifiers((GtkKeyvalTrigger*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_keyval_trigger_get_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_keyval_trigger_get_keyval "guint gtk_keyval_trigger_get_keyval(GtkKeyvalTrigger* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkKeyvalTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_keyval_trigger_get_keyval", 1, self, "GtkKeyvalTrigger*");
  return(s7_make_integer(sc, gtk_keyval_trigger_get_keyval((GtkKeyvalTrigger*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_mnemonic_trigger_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_mnemonic_trigger_new "GtkShortcutTrigger* gtk_mnemonic_trigger_new(guint keyval)"
  s7_pointer keyval;
  keyval = s7_car(args);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gtk_mnemonic_trigger_new", 1, keyval, "guint");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_mnemonic_trigger_new((guint)s7_integer(keyval))));
}

static s7_pointer lg_gtk_mnemonic_trigger_get_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_mnemonic_trigger_get_keyval "guint gtk_mnemonic_trigger_get_keyval(GtkMnemonicTrigger* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkMnemonicTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_mnemonic_trigger_get_keyval", 1, self, "GtkMnemonicTrigger*");
  return(s7_make_integer(sc, gtk_mnemonic_trigger_get_keyval((GtkMnemonicTrigger*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_alternative_trigger_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_alternative_trigger_new "GtkShortcutTrigger* gtk_alternative_trigger_new(GtkShortcutTrigger* first, \
GtkShortcutTrigger* second)"
  s7_pointer _p;
  s7_pointer first, second;
  _p = args;
  first = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(first, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_alternative_trigger_new", 1, first, "GtkShortcutTrigger*");
  second = s7_car(_p);
  if (!s7_is_c_pointer_of_type(second, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_alternative_trigger_new", 2, second, "GtkShortcutTrigger*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_alternative_trigger_new((GtkShortcutTrigger*)s7_c_pointer(first), (GtkShortcutTrigger*)s7_c_pointer(second))));
}

static s7_pointer lg_gtk_alternative_trigger_get_first(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_alternative_trigger_get_first "GtkShortcutTrigger* gtk_alternative_trigger_get_first(GtkAlternativeTrigger* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkAlternativeTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_alternative_trigger_get_first", 1, self, "GtkAlternativeTrigger*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_alternative_trigger_get_first((GtkAlternativeTrigger*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_alternative_trigger_get_second(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_alternative_trigger_get_second "GtkShortcutTrigger* gtk_alternative_trigger_get_second(GtkAlternativeTrigger* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkAlternativeTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_alternative_trigger_get_second", 1, self, "GtkAlternativeTrigger*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutTrigger__sym, gtk_alternative_trigger_get_second((GtkAlternativeTrigger*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_shortcut_trigger_trigger(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_trigger_trigger "GdkKeyMatch gtk_shortcut_trigger_trigger(GtkShortcutTrigger* self, \
GdkEvent* event, gboolean enable_mnemonics)"
  s7_pointer _p;
  s7_pointer self, event, enable_mnemonics;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkShortcutTrigger__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_trigger", 1, self, "GtkShortcutTrigger*");
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_trigger", 2, event, "GdkEvent*");
  enable_mnemonics = s7_car(_p);
  if (!s7_is_boolean(enable_mnemonics)) s7_wrong_type_arg_error(sc, "gtk_shortcut_trigger_trigger", 3, enable_mnemonics, "gboolean");
  return(s7_make_integer(sc, gtk_shortcut_trigger_trigger((GtkShortcutTrigger*)s7_c_pointer(self), (GdkEvent*)s7_c_pointer(event), (gboolean)lg_boolean(enable_mnemonics))));
}

static s7_pointer lg_gdk_device_get_caps_lock_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_caps_lock_state "gboolean gdk_device_get_caps_lock_state(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_caps_lock_state", 1, device, "GdkDevice*");
  return(s7_make_boolean(sc, gdk_device_get_caps_lock_state((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_num_lock_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_num_lock_state "gboolean gdk_device_get_num_lock_state(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_num_lock_state", 1, device, "GdkDevice*");
  return(s7_make_boolean(sc, gdk_device_get_num_lock_state((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_scroll_lock_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_scroll_lock_state "gboolean gdk_device_get_scroll_lock_state(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_scroll_lock_state", 1, device, "GdkDevice*");
  return(s7_make_boolean(sc, gdk_device_get_scroll_lock_state((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_modifier_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_modifier_state "GdkModifierType gdk_device_get_modifier_state(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_modifier_state", 1, device, "GdkDevice*");
  return(s7_make_integer(sc, gdk_device_get_modifier_state((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_get_direction(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_get_direction "PangoDirection gdk_device_get_direction(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_get_direction", 1, device, "GdkDevice*");
  return(s7_make_integer(sc, gdk_device_get_direction((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_device_has_bidi_layouts(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_device_has_bidi_layouts "gboolean gdk_device_has_bidi_layouts(GdkDevice* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, GdkDevice__sym)) s7_wrong_type_arg_error(sc, "gdk_device_has_bidi_layouts", 1, device, "GdkDevice*");
  return(s7_make_boolean(sc, gdk_device_has_bidi_layouts((GdkDevice*)s7_c_pointer(device))));
}

static s7_pointer lg_gdk_display_map_keyval(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_map_keyval "gboolean gdk_display_map_keyval(GdkDisplay* display, guint keyval, \
GdkKeymapKey** [keys], int* [n_keys])"
  s7_pointer _p;
  s7_pointer display, keyval;
  GdkKeymapKey* ref_keys = NULL;
  int ref_n_keys;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_map_keyval", 1, display, "GdkDisplay*");
  keyval = s7_car(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_display_map_keyval", 2, keyval, "guint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_display_map_keyval((GdkDisplay*)s7_c_pointer(display), (guint)s7_integer(keyval), &ref_keys, &ref_n_keys));
      return(s7_list(sc, 3, res_ult, s7_make_c_pointer(sc, ref_keys), s7_make_integer(sc, ref_n_keys)));
   }
}

static s7_pointer lg_gdk_display_map_keycode(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_display_map_keycode "gboolean gdk_display_map_keycode(GdkDisplay* display, guint keycode, \
GdkKeymapKey** [keys], guint** [keyvals], int* [n_entries])"
  s7_pointer _p;
  s7_pointer display, keycode;
  GdkKeymapKey* ref_keys = NULL;
  guint* ref_keyvals = NULL;
  int ref_n_entries;
  _p = args;
  display = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(display, GdkDisplay__sym)) s7_wrong_type_arg_error(sc, "gdk_display_map_keycode", 1, display, "GdkDisplay*");
  keycode = s7_car(_p);
  if (!s7_is_integer(keycode)) s7_wrong_type_arg_error(sc, "gdk_display_map_keycode", 2, keycode, "guint");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gdk_display_map_keycode((GdkDisplay*)s7_c_pointer(display), (guint)s7_integer(keycode), &ref_keys, &ref_keyvals, &ref_n_entries));
      return(s7_list(sc, 4, res_ult, s7_make_c_pointer(sc, ref_keys), s7_make_c_pointer(sc, ref_keyvals), s7_make_integer(sc, ref_n_entries)));
   }
}

static s7_pointer lg_gdk_touchpad_event_get_pinch_angle_delta(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_touchpad_event_get_pinch_angle_delta "double gdk_touchpad_event_get_pinch_angle_delta(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_touchpad_event_get_pinch_angle_delta", 1, event, "GdkEvent*");
  return(s7_make_real(sc, gdk_touchpad_event_get_pinch_angle_delta((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_touchpad_event_get_pinch_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_touchpad_event_get_pinch_scale "double gdk_touchpad_event_get_pinch_scale(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_touchpad_event_get_pinch_scale", 1, event, "GdkEvent*");
  return(s7_make_real(sc, gdk_touchpad_event_get_pinch_scale((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_pad_event_get_button(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pad_event_get_button "guint gdk_pad_event_get_button(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_pad_event_get_button", 1, event, "GdkEvent*");
  return(s7_make_integer(sc, gdk_pad_event_get_button((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_pad_event_get_axis_value(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_pad_event_get_axis_value "void gdk_pad_event_get_axis_value(GdkEvent* event, guint* index, \
double* value)"
  s7_pointer _p;
  s7_pointer event, index, value;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_pad_event_get_axis_value", 1, event, "GdkEvent*");
  index = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(index, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_pad_event_get_axis_value", 2, index, "guint*");
  value = s7_car(_p);
  if (!s7_is_c_pointer_of_type(value, double__sym)) s7_wrong_type_arg_error(sc, "gdk_pad_event_get_axis_value", 3, value, "double*");
  gdk_pad_event_get_axis_value((GdkEvent*)s7_c_pointer(event), (guint*)s7_c_pointer(index), (double*)s7_c_pointer(value));
  return(lg_false);
}

static s7_pointer lg_gdk_dnd_event_get_drop(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_dnd_event_get_drop "GdkDrop* gdk_dnd_event_get_drop(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_dnd_event_get_drop", 1, event, "GdkEvent*");
  return(lg_make_c_pointer_with_type(sc, GdkDrop__sym, gdk_dnd_event_get_drop((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_grab_broken_event_get_implicit(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_grab_broken_event_get_implicit "gboolean gdk_grab_broken_event_get_implicit(GdkEvent* event)"
  s7_pointer event;
  event = s7_car(args);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_grab_broken_event_get_implicit", 1, event, "GdkEvent*");
  return(s7_make_boolean(sc, gdk_grab_broken_event_get_implicit((GdkEvent*)s7_c_pointer(event))));
}

static s7_pointer lg_gdk_key_event_matches(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_key_event_matches "GdkKeyMatch gdk_key_event_matches(GdkEvent* event, guint keyval, GdkModifierType modifiers)"
  s7_pointer _p;
  s7_pointer event, keyval, modifiers;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_key_event_matches", 1, event, "GdkEvent*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(keyval)) s7_wrong_type_arg_error(sc, "gdk_key_event_matches", 2, keyval, "guint");
  modifiers = s7_car(_p);
  if (!s7_is_integer(modifiers)) s7_wrong_type_arg_error(sc, "gdk_key_event_matches", 3, modifiers, "GdkModifierType");
  return(s7_make_integer(sc, gdk_key_event_matches((GdkEvent*)s7_c_pointer(event), (guint)s7_integer(keyval), (GdkModifierType)s7_integer(modifiers))));
}

static s7_pointer lg_gdk_key_event_get_match(s7_scheme *sc, s7_pointer args)
{
  #define H_gdk_key_event_get_match "gboolean gdk_key_event_get_match(GdkEvent* event, guint* keyval, \
GdkModifierType* modifiers)"
  s7_pointer _p;
  s7_pointer event, keyval, modifiers;
  _p = args;
  event = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(event, GdkEvent__sym)) s7_wrong_type_arg_error(sc, "gdk_key_event_get_match", 1, event, "GdkEvent*");
  keyval = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(keyval, guint__sym)) s7_wrong_type_arg_error(sc, "gdk_key_event_get_match", 2, keyval, "guint*");
  modifiers = s7_car(_p);
  if (!s7_is_c_pointer_of_type(modifiers, GdkModifierType__sym)) s7_wrong_type_arg_error(sc, "gdk_key_event_get_match", 3, modifiers, "GdkModifierType*");
  return(s7_make_boolean(sc, gdk_key_event_get_match((GdkEvent*)s7_c_pointer(event), (guint*)s7_c_pointer(keyval), (GdkModifierType*)s7_c_pointer(modifiers))));
}

static s7_pointer lg_gtk_aspect_frame_new(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_new "GtkWidget* gtk_aspect_frame_new(float xalign, float yalign, float ratio, \
gboolean obey_child)"
  s7_pointer _p;
  s7_pointer xalign, yalign, ratio, obey_child;
  _p = args;
  xalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 1, xalign, "float");
  yalign = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 2, yalign, "float");
  ratio = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(ratio)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 3, ratio, "float");
  obey_child = s7_car(_p);
  if (!s7_is_boolean(obey_child)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_new", 4, obey_child, "gboolean");
  return(lg_make_c_pointer_with_type(sc, GtkWidget__sym, gtk_aspect_frame_new((float)s7_real(xalign), (float)s7_real(yalign), (float)s7_real(ratio), (gboolean)lg_boolean(obey_child))));
}

static s7_pointer lg_gtk_aspect_frame_set_xalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_set_xalign "void gtk_aspect_frame_set_xalign(GtkAspectFrame* self, float xalign)"
  s7_pointer _p;
  s7_pointer self, xalign;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_xalign", 1, self, "GtkAspectFrame*");
  xalign = s7_car(_p);
  if (!s7_is_real(xalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_xalign", 2, xalign, "float");
  gtk_aspect_frame_set_xalign((GtkAspectFrame*)s7_c_pointer(self), (float)s7_real(xalign));
  return(lg_false);
}

static s7_pointer lg_gtk_aspect_frame_get_xalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_get_xalign "float gtk_aspect_frame_get_xalign(GtkAspectFrame* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_get_xalign", 1, self, "GtkAspectFrame*");
  return(s7_make_real(sc, gtk_aspect_frame_get_xalign((GtkAspectFrame*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_aspect_frame_set_yalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_set_yalign "void gtk_aspect_frame_set_yalign(GtkAspectFrame* self, float yalign)"
  s7_pointer _p;
  s7_pointer self, yalign;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_yalign", 1, self, "GtkAspectFrame*");
  yalign = s7_car(_p);
  if (!s7_is_real(yalign)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_yalign", 2, yalign, "float");
  gtk_aspect_frame_set_yalign((GtkAspectFrame*)s7_c_pointer(self), (float)s7_real(yalign));
  return(lg_false);
}

static s7_pointer lg_gtk_aspect_frame_get_yalign(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_get_yalign "float gtk_aspect_frame_get_yalign(GtkAspectFrame* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_get_yalign", 1, self, "GtkAspectFrame*");
  return(s7_make_real(sc, gtk_aspect_frame_get_yalign((GtkAspectFrame*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_aspect_frame_set_ratio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_set_ratio "void gtk_aspect_frame_set_ratio(GtkAspectFrame* self, float ratio)"
  s7_pointer _p;
  s7_pointer self, ratio;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_ratio", 1, self, "GtkAspectFrame*");
  ratio = s7_car(_p);
  if (!s7_is_real(ratio)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_ratio", 2, ratio, "float");
  gtk_aspect_frame_set_ratio((GtkAspectFrame*)s7_c_pointer(self), (float)s7_real(ratio));
  return(lg_false);
}

static s7_pointer lg_gtk_aspect_frame_get_ratio(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_get_ratio "float gtk_aspect_frame_get_ratio(GtkAspectFrame* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_get_ratio", 1, self, "GtkAspectFrame*");
  return(s7_make_real(sc, gtk_aspect_frame_get_ratio((GtkAspectFrame*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_aspect_frame_set_obey_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_set_obey_child "void gtk_aspect_frame_set_obey_child(GtkAspectFrame* self, \
gboolean obey_child)"
  s7_pointer _p;
  s7_pointer self, obey_child;
  _p = args;
  self = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_obey_child", 1, self, "GtkAspectFrame*");
  obey_child = s7_car(_p);
  if (!s7_is_boolean(obey_child)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_set_obey_child", 2, obey_child, "gboolean");
  gtk_aspect_frame_set_obey_child((GtkAspectFrame*)s7_c_pointer(self), (gboolean)lg_boolean(obey_child));
  return(lg_false);
}

static s7_pointer lg_gtk_aspect_frame_get_obey_child(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_aspect_frame_get_obey_child "gboolean gtk_aspect_frame_get_obey_child(GtkAspectFrame* self)"
  s7_pointer self;
  self = s7_car(args);
  if (!s7_is_c_pointer_of_type(self, GtkAspectFrame__sym)) s7_wrong_type_arg_error(sc, "gtk_aspect_frame_get_obey_child", 1, self, "GtkAspectFrame*");
  return(s7_make_boolean(sc, gtk_aspect_frame_get_obey_child((GtkAspectFrame*)s7_c_pointer(self))));
}

static s7_pointer lg_gtk_viewport_get_scroll_to_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_viewport_get_scroll_to_focus "gboolean gtk_viewport_get_scroll_to_focus(GtkViewport* viewport)"
  s7_pointer viewport;
  viewport = s7_car(args);
  if (!s7_is_c_pointer_of_type(viewport, GtkViewport__sym)) s7_wrong_type_arg_error(sc, "gtk_viewport_get_scroll_to_focus", 1, viewport, "GtkViewport*");
  return(s7_make_boolean(sc, gtk_viewport_get_scroll_to_focus((GtkViewport*)s7_c_pointer(viewport))));
}

static s7_pointer lg_gtk_viewport_set_scroll_to_focus(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_viewport_set_scroll_to_focus "void gtk_viewport_set_scroll_to_focus(GtkViewport* viewport, \
gboolean scroll_to_focus)"
  s7_pointer _p;
  s7_pointer viewport, scroll_to_focus;
  _p = args;
  viewport = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(viewport, GtkViewport__sym)) s7_wrong_type_arg_error(sc, "gtk_viewport_set_scroll_to_focus", 1, viewport, "GtkViewport*");
  scroll_to_focus = s7_car(_p);
  if (!s7_is_boolean(scroll_to_focus)) s7_wrong_type_arg_error(sc, "gtk_viewport_set_scroll_to_focus", 2, scroll_to_focus, "gboolean");
  gtk_viewport_set_scroll_to_focus((GtkViewport*)s7_c_pointer(viewport), (gboolean)lg_boolean(scroll_to_focus));
  return(lg_false);
}

static s7_pointer lg_gtk_button_set_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_set_has_frame "void gtk_button_set_has_frame(GtkButton* button, gboolean has_frame)"
  s7_pointer _p;
  s7_pointer button, has_frame;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_set_has_frame", 1, button, "GtkButton*");
  has_frame = s7_car(_p);
  if (!s7_is_boolean(has_frame)) s7_wrong_type_arg_error(sc, "gtk_button_set_has_frame", 2, has_frame, "gboolean");
  gtk_button_set_has_frame((GtkButton*)s7_c_pointer(button), (gboolean)lg_boolean(has_frame));
  return(lg_false);
}

static s7_pointer lg_gtk_button_get_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_button_get_has_frame "gboolean gtk_button_get_has_frame(GtkButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkButton__sym)) s7_wrong_type_arg_error(sc, "gtk_button_get_has_frame", 1, button, "GtkButton*");
  return(s7_make_boolean(sc, gtk_button_get_has_frame((GtkButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_color_button_get_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_button_get_modal "gboolean gtk_color_button_get_modal(GtkColorButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkColorButton__sym)) s7_wrong_type_arg_error(sc, "gtk_color_button_get_modal", 1, button, "GtkColorButton*");
  return(s7_make_boolean(sc, gtk_color_button_get_modal((GtkColorButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_color_button_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_color_button_set_modal "void gtk_color_button_set_modal(GtkColorButton* button, gboolean modal)"
  s7_pointer _p;
  s7_pointer button, modal;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkColorButton__sym)) s7_wrong_type_arg_error(sc, "gtk_color_button_set_modal", 1, button, "GtkColorButton*");
  modal = s7_car(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gtk_color_button_set_modal", 2, modal, "gboolean");
  gtk_color_button_set_modal((GtkColorButton*)s7_c_pointer(button), (gboolean)lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gtk_event_controller_get_current_event(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_current_event "GdkEvent* gtk_event_controller_get_current_event(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_current_event", 1, controller, "GtkEventController*");
  return(lg_make_c_pointer_with_type(sc, GdkEvent__sym, gtk_event_controller_get_current_event((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_get_current_event_time(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_current_event_time "guint32 gtk_event_controller_get_current_event_time(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_current_event_time", 1, controller, "GtkEventController*");
  return(s7_make_integer(sc, gtk_event_controller_get_current_event_time((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_get_current_event_device(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_current_event_device "GdkDevice* gtk_event_controller_get_current_event_device(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_current_event_device", 1, controller, "GtkEventController*");
  return(lg_make_c_pointer_with_type(sc, GdkDevice__sym, gtk_event_controller_get_current_event_device((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_event_controller_get_current_event_state(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_event_controller_get_current_event_state "GdkModifierType gtk_event_controller_get_current_event_state(GtkEventController* controller)"
  s7_pointer controller;
  controller = s7_car(args);
  if (!s7_is_c_pointer_of_type(controller, GtkEventController__sym)) s7_wrong_type_arg_error(sc, "gtk_event_controller_get_current_event_state", 1, controller, "GtkEventController*");
  return(s7_make_integer(sc, gtk_event_controller_get_current_event_state((GtkEventController*)s7_c_pointer(controller))));
}

static s7_pointer lg_gtk_file_chooser_button_get_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_get_modal "gboolean gtk_file_chooser_button_get_modal(GtkFileChooserButton* button)"
  s7_pointer button;
  button = s7_car(args);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_get_modal", 1, button, "GtkFileChooserButton*");
  return(s7_make_boolean(sc, gtk_file_chooser_button_get_modal((GtkFileChooserButton*)s7_c_pointer(button))));
}

static s7_pointer lg_gtk_file_chooser_button_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_file_chooser_button_set_modal "void gtk_file_chooser_button_set_modal(GtkFileChooserButton* button, \
gboolean modal)"
  s7_pointer _p;
  s7_pointer button, modal;
  _p = args;
  button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(button, GtkFileChooserButton__sym)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_modal", 1, button, "GtkFileChooserButton*");
  modal = s7_car(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gtk_file_chooser_button_set_modal", 2, modal, "gboolean");
  gtk_file_chooser_button_set_modal((GtkFileChooserButton*)s7_c_pointer(button), (gboolean)lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gtk_font_button_get_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_get_modal "gboolean gtk_font_button_get_modal(GtkFontButton* font_button)"
  s7_pointer font_button;
  font_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_get_modal", 1, font_button, "GtkFontButton*");
  return(s7_make_boolean(sc, gtk_font_button_get_modal((GtkFontButton*)s7_c_pointer(font_button))));
}

static s7_pointer lg_gtk_font_button_set_modal(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_font_button_set_modal "void gtk_font_button_set_modal(GtkFontButton* font_button, gboolean modal)"
  s7_pointer _p;
  s7_pointer font_button, modal;
  _p = args;
  font_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_button, GtkFontButton__sym)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_modal", 1, font_button, "GtkFontButton*");
  modal = s7_car(_p);
  if (!s7_is_boolean(modal)) s7_wrong_type_arg_error(sc, "gtk_font_button_set_modal", 2, modal, "gboolean");
  gtk_font_button_set_modal((GtkFontButton*)s7_c_pointer(font_button), (gboolean)lg_boolean(modal));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_set_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_set_has_frame "void gtk_menu_button_set_has_frame(GtkMenuButton* menu_button, \
gboolean has_frame)"
  s7_pointer _p;
  s7_pointer menu_button, has_frame;
  _p = args;
  menu_button = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_has_frame", 1, menu_button, "GtkMenuButton*");
  has_frame = s7_car(_p);
  if (!s7_is_boolean(has_frame)) s7_wrong_type_arg_error(sc, "gtk_menu_button_set_has_frame", 2, has_frame, "gboolean");
  gtk_menu_button_set_has_frame((GtkMenuButton*)s7_c_pointer(menu_button), (gboolean)lg_boolean(has_frame));
  return(lg_false);
}

static s7_pointer lg_gtk_menu_button_get_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_menu_button_get_has_frame "gboolean gtk_menu_button_get_has_frame(GtkMenuButton* menu_button)"
  s7_pointer menu_button;
  menu_button = s7_car(args);
  if (!s7_is_c_pointer_of_type(menu_button, GtkMenuButton__sym)) s7_wrong_type_arg_error(sc, "gtk_menu_button_get_has_frame", 1, menu_button, "GtkMenuButton*");
  return(s7_make_boolean(sc, gtk_menu_button_get_has_frame((GtkMenuButton*)s7_c_pointer(menu_button))));
}

static s7_pointer lg_gtk_scrolled_window_set_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_set_has_frame "void gtk_scrolled_window_set_has_frame(GtkScrolledWindow* scrolled_window, \
gboolean has_frame)"
  s7_pointer _p;
  s7_pointer scrolled_window, has_frame;
  _p = args;
  scrolled_window = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_has_frame", 1, scrolled_window, "GtkScrolledWindow*");
  has_frame = s7_car(_p);
  if (!s7_is_boolean(has_frame)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_set_has_frame", 2, has_frame, "gboolean");
  gtk_scrolled_window_set_has_frame((GtkScrolledWindow*)s7_c_pointer(scrolled_window), (gboolean)lg_boolean(has_frame));
  return(lg_false);
}

static s7_pointer lg_gtk_scrolled_window_get_has_frame(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_scrolled_window_get_has_frame "gboolean gtk_scrolled_window_get_has_frame(GtkScrolledWindow* scrolled_window)"
  s7_pointer scrolled_window;
  scrolled_window = s7_car(args);
  if (!s7_is_c_pointer_of_type(scrolled_window, GtkScrolledWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_scrolled_window_get_has_frame", 1, scrolled_window, "GtkScrolledWindow*");
  return(s7_make_boolean(sc, gtk_scrolled_window_get_has_frame((GtkScrolledWindow*)s7_c_pointer(scrolled_window))));
}

static s7_pointer lg_gtk_shortcut_action_parse_string(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_shortcut_action_parse_string "GtkShortcutAction* gtk_shortcut_action_parse_string(char* string)"
  s7_pointer string;
  string = s7_car(args);
  if (!s7_is_string(string)) s7_wrong_type_arg_error(sc, "gtk_shortcut_action_parse_string", 1, string, "char*");
  return(lg_make_c_pointer_with_type(sc, GtkShortcutAction__sym, gtk_shortcut_action_parse_string((const char*)(char*)s7_string(string))));
}

static s7_pointer lg_gtk_show_uri_full_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_show_uri_full_finish "gboolean gtk_show_uri_full_finish(GtkWindow* parent, GAsyncResult* result, \
GError** [error])"
  s7_pointer _p;
  s7_pointer parent, result;
  GError* ref_error = NULL;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_show_uri_full_finish", 1, parent, "GtkWindow*");
  result = s7_car(_p);
  if (!s7_is_c_pointer_of_type(result, GAsyncResult__sym)) s7_wrong_type_arg_error(sc, "gtk_show_uri_full_finish", 2, result, "GAsyncResult*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_boolean(sc, gtk_show_uri_full_finish((GtkWindow*)s7_c_pointer(parent), (GAsyncResult*)s7_c_pointer(result), &ref_error));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_error)));
   }
}

static s7_pointer lg_gtk_show_uri(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_show_uri "void gtk_show_uri(GtkWindow* parent, char* uri, guint32 timestamp)"
  s7_pointer _p;
  s7_pointer parent, uri, timestamp;
  _p = args;
  parent = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(parent, GtkWindow__sym)) s7_wrong_type_arg_error(sc, "gtk_show_uri", 1, parent, "GtkWindow*");
  uri = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(uri)) s7_wrong_type_arg_error(sc, "gtk_show_uri", 2, uri, "char*");
  timestamp = s7_car(_p);
  if (!s7_is_integer(timestamp)) s7_wrong_type_arg_error(sc, "gtk_show_uri", 3, timestamp, "guint32");
  gtk_show_uri((GtkWindow*)s7_c_pointer(parent), (const char*)(char*)s7_string(uri), (guint32)s7_integer(timestamp));
  return(lg_false);
}

#endif

static s7_pointer lg_cairo_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_create "cairo_t* cairo_create(cairo_surface_t* target)"
  s7_pointer target;
  target = s7_car(args);
  if (!s7_is_c_pointer_of_type(target, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_create", 1, target, "cairo_surface_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_t__sym, cairo_create((cairo_surface_t*)s7_c_pointer(target))));
}

static s7_pointer lg_cairo_version(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_version "int cairo_version( void)"
  return(s7_make_integer(sc, cairo_version()));
}

static s7_pointer lg_cairo_version_string(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_version_string "char* cairo_version_string( void)"
  return(s7_make_string(sc, cairo_version_string()));
}

static s7_pointer lg_cairo_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_reference "cairo_t* cairo_reference(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_reference", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_t__sym, cairo_reference((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_destroy "void cairo_destroy(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_destroy", 1, cr, "cairo_t*");
  cairo_destroy((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_save(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_save "void cairo_save(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_save", 1, cr, "cairo_t*");
  cairo_save((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_restore(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_restore "void cairo_restore(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_restore", 1, cr, "cairo_t*");
  cairo_restore((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_push_group(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_push_group "void cairo_push_group(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_push_group", 1, cr, "cairo_t*");
  cairo_push_group((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_push_group_with_content(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_push_group_with_content "void cairo_push_group_with_content(cairo_t* cr, cairo_content_t content)"
  s7_pointer _p;
  s7_pointer cr, content;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_push_group_with_content", 1, cr, "cairo_t*");
  content = s7_car(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "cairo_push_group_with_content", 2, content, "cairo_content_t");
  cairo_push_group_with_content((cairo_t*)s7_c_pointer(cr), (cairo_content_t)s7_integer(content));
  return(lg_false);
}

static s7_pointer lg_cairo_pop_group(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pop_group "cairo_pattern_t* cairo_pop_group(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pop_group", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pop_group((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_pop_group_to_source(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pop_group_to_source "void cairo_pop_group_to_source(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pop_group_to_source", 1, cr, "cairo_t*");
  cairo_pop_group_to_source((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_set_operator(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_operator "void cairo_set_operator(cairo_t* cr, cairo_operator_t op)"
  s7_pointer _p;
  s7_pointer cr, op;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_operator", 1, cr, "cairo_t*");
  op = s7_car(_p);
  if (!s7_is_integer(op)) s7_wrong_type_arg_error(sc, "cairo_set_operator", 2, op, "cairo_operator_t");
  cairo_set_operator((cairo_t*)s7_c_pointer(cr), (cairo_operator_t)s7_integer(op));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source "void cairo_set_source(cairo_t* cr, cairo_pattern_t* source)"
  s7_pointer _p;
  s7_pointer cr, source;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source", 1, cr, "cairo_t*");
  source = s7_car(_p);
  if (!s7_is_c_pointer_of_type(source, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source", 2, source, "cairo_pattern_t*");
  cairo_set_source((cairo_t*)s7_c_pointer(cr), (cairo_pattern_t*)s7_c_pointer(source));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source_rgb "void cairo_set_source_rgb(cairo_t* cr, double red, double green, double blue)"
  s7_pointer _p;
  s7_pointer cr, red, green, blue;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 1, cr, "cairo_t*");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 2, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 3, green, "double");
  blue = s7_car(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgb", 4, blue, "double");
  cairo_set_source_rgb((cairo_t*)s7_c_pointer(cr), (double)s7_real(red), (double)s7_real(green), (double)s7_real(blue));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source_rgba "void cairo_set_source_rgba(cairo_t* cr, double red, double green, \
double blue, double alpha)"
  s7_pointer _p;
  s7_pointer cr, red, green, blue, alpha;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 1, cr, "cairo_t*");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 2, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 3, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 4, blue, "double");
  alpha = s7_car(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_set_source_rgba", 5, alpha, "double");
  cairo_set_source_rgba((cairo_t*)s7_c_pointer(cr), (double)s7_real(red), (double)s7_real(green), (double)s7_real(blue), (double)s7_real(alpha));
  return(lg_false);
}

static s7_pointer lg_cairo_set_source_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_source_surface "void cairo_set_source_surface(cairo_t* cr, cairo_surface_t* surface, \
double x, double y)"
  s7_pointer _p;
  s7_pointer cr, surface, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 1, cr, "cairo_t*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 2, surface, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 3, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_set_source_surface", 4, y, "double");
  cairo_set_source_surface((cairo_t*)s7_c_pointer(cr), (cairo_surface_t*)s7_c_pointer(surface), (double)s7_real(x), (double)s7_real(y));
  return(lg_false);
}

static s7_pointer lg_cairo_set_tolerance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_tolerance "void cairo_set_tolerance(cairo_t* cr, double tolerance)"
  s7_pointer _p;
  s7_pointer cr, tolerance;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_tolerance", 1, cr, "cairo_t*");
  tolerance = s7_car(_p);
  if (!s7_is_real(tolerance)) s7_wrong_type_arg_error(sc, "cairo_set_tolerance", 2, tolerance, "double");
  cairo_set_tolerance((cairo_t*)s7_c_pointer(cr), (double)s7_real(tolerance));
  return(lg_false);
}

static s7_pointer lg_cairo_set_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_antialias "void cairo_set_antialias(cairo_t* cr, cairo_antialias_t antialias)"
  s7_pointer _p;
  s7_pointer cr, antialias;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_antialias", 1, cr, "cairo_t*");
  antialias = s7_car(_p);
  if (!s7_is_integer(antialias)) s7_wrong_type_arg_error(sc, "cairo_set_antialias", 2, antialias, "cairo_antialias_t");
  cairo_set_antialias((cairo_t*)s7_c_pointer(cr), (cairo_antialias_t)s7_integer(antialias));
  return(lg_false);
}

static s7_pointer lg_cairo_set_fill_rule(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_fill_rule "void cairo_set_fill_rule(cairo_t* cr, cairo_fill_rule_t fill_rule)"
  s7_pointer _p;
  s7_pointer cr, fill_rule;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_fill_rule", 1, cr, "cairo_t*");
  fill_rule = s7_car(_p);
  if (!s7_is_integer(fill_rule)) s7_wrong_type_arg_error(sc, "cairo_set_fill_rule", 2, fill_rule, "cairo_fill_rule_t");
  cairo_set_fill_rule((cairo_t*)s7_c_pointer(cr), (cairo_fill_rule_t)s7_integer(fill_rule));
  return(lg_false);
}

static s7_pointer lg_cairo_set_line_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_line_width "void cairo_set_line_width(cairo_t* cr, double width)"
  s7_pointer _p;
  s7_pointer cr, width;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_line_width", 1, cr, "cairo_t*");
  width = s7_car(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "cairo_set_line_width", 2, width, "double");
  cairo_set_line_width((cairo_t*)s7_c_pointer(cr), (double)s7_real(width));
  return(lg_false);
}

static s7_pointer lg_cairo_set_line_cap(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_line_cap "void cairo_set_line_cap(cairo_t* cr, cairo_line_cap_t line_cap)"
  s7_pointer _p;
  s7_pointer cr, line_cap;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_line_cap", 1, cr, "cairo_t*");
  line_cap = s7_car(_p);
  if (!s7_is_integer(line_cap)) s7_wrong_type_arg_error(sc, "cairo_set_line_cap", 2, line_cap, "cairo_line_cap_t");
  cairo_set_line_cap((cairo_t*)s7_c_pointer(cr), (cairo_line_cap_t)s7_integer(line_cap));
  return(lg_false);
}

static s7_pointer lg_cairo_set_line_join(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_line_join "void cairo_set_line_join(cairo_t* cr, cairo_line_join_t line_join)"
  s7_pointer _p;
  s7_pointer cr, line_join;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_line_join", 1, cr, "cairo_t*");
  line_join = s7_car(_p);
  if (!s7_is_integer(line_join)) s7_wrong_type_arg_error(sc, "cairo_set_line_join", 2, line_join, "cairo_line_join_t");
  cairo_set_line_join((cairo_t*)s7_c_pointer(cr), (cairo_line_join_t)s7_integer(line_join));
  return(lg_false);
}

static s7_pointer lg_cairo_set_dash(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_dash "void cairo_set_dash(cairo_t* cr, gdouble* dashes, int num_dashes, double offset)"
  s7_pointer _p;
  s7_pointer cr, dashes, num_dashes, offset;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 1, cr, "cairo_t*");
  dashes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dashes, gdouble__sym)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 2, dashes, "gdouble*");
  num_dashes = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_dashes)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 3, num_dashes, "int");
  offset = s7_car(_p);
  if (!s7_is_real(offset)) s7_wrong_type_arg_error(sc, "cairo_set_dash", 4, offset, "double");
  cairo_set_dash((cairo_t*)s7_c_pointer(cr), (gdouble*)s7_c_pointer(dashes), (int)s7_integer(num_dashes), (double)s7_real(offset));
  return(lg_false);
}

static s7_pointer lg_cairo_set_miter_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_miter_limit "void cairo_set_miter_limit(cairo_t* cr, double limit)"
  s7_pointer _p;
  s7_pointer cr, limit;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_miter_limit", 1, cr, "cairo_t*");
  limit = s7_car(_p);
  if (!s7_is_real(limit)) s7_wrong_type_arg_error(sc, "cairo_set_miter_limit", 2, limit, "double");
  cairo_set_miter_limit((cairo_t*)s7_c_pointer(cr), (double)s7_real(limit));
  return(lg_false);
}

static s7_pointer lg_cairo_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_translate "void cairo_translate(cairo_t* cr, double tx, double ty)"
  s7_pointer _p;
  s7_pointer cr, tx, ty;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_translate", 1, cr, "cairo_t*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tx)) s7_wrong_type_arg_error(sc, "cairo_translate", 2, tx, "double");
  ty = s7_car(_p);
  if (!s7_is_real(ty)) s7_wrong_type_arg_error(sc, "cairo_translate", 3, ty, "double");
  cairo_translate((cairo_t*)s7_c_pointer(cr), (double)s7_real(tx), (double)s7_real(ty));
  return(lg_false);
}

static s7_pointer lg_cairo_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scale "void cairo_scale(cairo_t* cr, double sx, double sy)"
  s7_pointer _p;
  s7_pointer cr, sx, sy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scale", 1, cr, "cairo_t*");
  sx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sx)) s7_wrong_type_arg_error(sc, "cairo_scale", 2, sx, "double");
  sy = s7_car(_p);
  if (!s7_is_real(sy)) s7_wrong_type_arg_error(sc, "cairo_scale", 3, sy, "double");
  cairo_scale((cairo_t*)s7_c_pointer(cr), (double)s7_real(sx), (double)s7_real(sy));
  return(lg_false);
}

static s7_pointer lg_cairo_rotate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rotate "void cairo_rotate(cairo_t* cr, double angle)"
  s7_pointer _p;
  s7_pointer cr, angle;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rotate", 1, cr, "cairo_t*");
  angle = s7_car(_p);
  if (!s7_is_real(angle)) s7_wrong_type_arg_error(sc, "cairo_rotate", 2, angle, "double");
  cairo_rotate((cairo_t*)s7_c_pointer(cr), (double)s7_real(angle));
  return(lg_false);
}

static s7_pointer lg_cairo_transform(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_transform "void cairo_transform(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_transform", 1, cr, "cairo_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_transform", 2, matrix, "cairo_matrix_t*");
  cairo_transform((cairo_t*)s7_c_pointer(cr), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_set_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_matrix "void cairo_set_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_set_matrix((cairo_t*)s7_c_pointer(cr), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_identity_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_identity_matrix "void cairo_identity_matrix(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_identity_matrix", 1, cr, "cairo_t*");
  cairo_identity_matrix((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_user_to_device(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_user_to_device "void cairo_user_to_device(cairo_t* cr, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_user_to_device", 1, cr, "cairo_t*");
  cairo_user_to_device((cairo_t*)s7_c_pointer(cr), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_user_to_device_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_user_to_device_distance "void cairo_user_to_device_distance(cairo_t* cr, gdouble* [dx], \
gdouble* [dy])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_dx;
  gdouble ref_dy;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_user_to_device_distance", 1, cr, "cairo_t*");
  cairo_user_to_device_distance((cairo_t*)s7_c_pointer(cr), &ref_dx, &ref_dy);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
}

static s7_pointer lg_cairo_device_to_user(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_to_user "void cairo_device_to_user(cairo_t* cr, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_to_user", 1, cr, "cairo_t*");
  cairo_device_to_user((cairo_t*)s7_c_pointer(cr), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_device_to_user_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_to_user_distance "void cairo_device_to_user_distance(cairo_t* cr, gdouble* [dx], \
gdouble* [dy])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_dx;
  gdouble ref_dy;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_to_user_distance", 1, cr, "cairo_t*");
  cairo_device_to_user_distance((cairo_t*)s7_c_pointer(cr), &ref_dx, &ref_dy);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
}

static s7_pointer lg_cairo_new_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_new_path "void cairo_new_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_new_path", 1, cr, "cairo_t*");
  cairo_new_path((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_move_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_move_to "void cairo_move_to(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_move_to", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_move_to", 2, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_move_to", 3, y, "double");
  cairo_move_to((cairo_t*)s7_c_pointer(cr), (double)s7_real(x), (double)s7_real(y));
  return(lg_false);
}

static s7_pointer lg_cairo_new_sub_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_new_sub_path "void cairo_new_sub_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_new_sub_path", 1, cr, "cairo_t*");
  cairo_new_sub_path((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_line_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_line_to "void cairo_line_to(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_line_to", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_line_to", 2, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_line_to", 3, y, "double");
  cairo_line_to((cairo_t*)s7_c_pointer(cr), (double)s7_real(x), (double)s7_real(y));
  return(lg_false);
}

static s7_pointer lg_cairo_curve_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_curve_to "void cairo_curve_to(cairo_t* cr, double x1, double y1, double x2, double y2, \
double x3, double y3)"
  s7_pointer _p;
  s7_pointer cr, x1, y1, x2, y2, x3, y3;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 1, cr, "cairo_t*");
  x1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x1)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 2, x1, "double");
  y1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 3, y1, "double");
  x2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x2)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 4, x2, "double");
  y2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y2)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 5, y2, "double");
  x3 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x3)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 6, x3, "double");
  y3 = s7_car(_p);
  if (!s7_is_real(y3)) s7_wrong_type_arg_error(sc, "cairo_curve_to", 7, y3, "double");
  cairo_curve_to((cairo_t*)s7_c_pointer(cr), (double)s7_real(x1), (double)s7_real(y1), (double)s7_real(x2), (double)s7_real(y2), (double)s7_real(x3), (double)s7_real(y3));
  return(lg_false);
}

static s7_pointer lg_cairo_arc(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_arc "void cairo_arc(cairo_t* cr, double xc, double yc, double radius, double angle1, \
double angle2)"
  s7_pointer _p;
  s7_pointer cr, xc, yc, radius, angle1, angle2;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_arc", 1, cr, "cairo_t*");
  xc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xc)) s7_wrong_type_arg_error(sc, "cairo_arc", 2, xc, "double");
  yc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yc)) s7_wrong_type_arg_error(sc, "cairo_arc", 3, yc, "double");
  radius = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius)) s7_wrong_type_arg_error(sc, "cairo_arc", 4, radius, "double");
  angle1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle1)) s7_wrong_type_arg_error(sc, "cairo_arc", 5, angle1, "double");
  angle2 = s7_car(_p);
  if (!s7_is_real(angle2)) s7_wrong_type_arg_error(sc, "cairo_arc", 6, angle2, "double");
  cairo_arc((cairo_t*)s7_c_pointer(cr), (double)s7_real(xc), (double)s7_real(yc), (double)s7_real(radius), (double)s7_real(angle1), (double)s7_real(angle2));
  return(lg_false);
}

static s7_pointer lg_cairo_arc_negative(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_arc_negative "void cairo_arc_negative(cairo_t* cr, double xc, double yc, double radius, \
double angle1, double angle2)"
  s7_pointer _p;
  s7_pointer cr, xc, yc, radius, angle1, angle2;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 1, cr, "cairo_t*");
  xc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xc)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 2, xc, "double");
  yc = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yc)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 3, yc, "double");
  radius = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 4, radius, "double");
  angle1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(angle1)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 5, angle1, "double");
  angle2 = s7_car(_p);
  if (!s7_is_real(angle2)) s7_wrong_type_arg_error(sc, "cairo_arc_negative", 6, angle2, "double");
  cairo_arc_negative((cairo_t*)s7_c_pointer(cr), (double)s7_real(xc), (double)s7_real(yc), (double)s7_real(radius), (double)s7_real(angle1), (double)s7_real(angle2));
  return(lg_false);
}

static s7_pointer lg_cairo_rel_move_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rel_move_to "void cairo_rel_move_to(cairo_t* cr, double dx, double dy)"
  s7_pointer _p;
  s7_pointer cr, dx, dy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rel_move_to", 1, cr, "cairo_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx)) s7_wrong_type_arg_error(sc, "cairo_rel_move_to", 2, dx, "double");
  dy = s7_car(_p);
  if (!s7_is_real(dy)) s7_wrong_type_arg_error(sc, "cairo_rel_move_to", 3, dy, "double");
  cairo_rel_move_to((cairo_t*)s7_c_pointer(cr), (double)s7_real(dx), (double)s7_real(dy));
  return(lg_false);
}

static s7_pointer lg_cairo_rel_line_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rel_line_to "void cairo_rel_line_to(cairo_t* cr, double dx, double dy)"
  s7_pointer _p;
  s7_pointer cr, dx, dy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rel_line_to", 1, cr, "cairo_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx)) s7_wrong_type_arg_error(sc, "cairo_rel_line_to", 2, dx, "double");
  dy = s7_car(_p);
  if (!s7_is_real(dy)) s7_wrong_type_arg_error(sc, "cairo_rel_line_to", 3, dy, "double");
  cairo_rel_line_to((cairo_t*)s7_c_pointer(cr), (double)s7_real(dx), (double)s7_real(dy));
  return(lg_false);
}

static s7_pointer lg_cairo_rel_curve_to(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rel_curve_to "void cairo_rel_curve_to(cairo_t* cr, double dx1, double dy1, double dx2, \
double dy2, double dx3, double dy3)"
  s7_pointer _p;
  s7_pointer cr, dx1, dy1, dx2, dy2, dx3, dy3;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 1, cr, "cairo_t*");
  dx1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx1)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 2, dx1, "double");
  dy1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy1)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 3, dy1, "double");
  dx2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx2)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 4, dx2, "double");
  dy2 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dy2)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 5, dy2, "double");
  dx3 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(dx3)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 6, dx3, "double");
  dy3 = s7_car(_p);
  if (!s7_is_real(dy3)) s7_wrong_type_arg_error(sc, "cairo_rel_curve_to", 7, dy3, "double");
  cairo_rel_curve_to((cairo_t*)s7_c_pointer(cr), (double)s7_real(dx1), (double)s7_real(dy1), (double)s7_real(dx2), (double)s7_real(dy2), (double)s7_real(dx3), (double)s7_real(dy3));
  return(lg_false);
}

static s7_pointer lg_cairo_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rectangle "void cairo_rectangle(cairo_t* cr, double x, double y, double width, double height)"
  s7_pointer _p;
  s7_pointer cr, x, y, width, height;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 3, y, "double");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 4, width, "double");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "cairo_rectangle", 5, height, "double");
  cairo_rectangle((cairo_t*)s7_c_pointer(cr), (double)s7_real(x), (double)s7_real(y), (double)s7_real(width), (double)s7_real(height));
  return(lg_false);
}

static s7_pointer lg_cairo_close_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_close_path "void cairo_close_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_close_path", 1, cr, "cairo_t*");
  cairo_close_path((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_paint(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_paint "void cairo_paint(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_paint", 1, cr, "cairo_t*");
  cairo_paint((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_paint_with_alpha(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_paint_with_alpha "void cairo_paint_with_alpha(cairo_t* cr, double alpha)"
  s7_pointer _p;
  s7_pointer cr, alpha;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_paint_with_alpha", 1, cr, "cairo_t*");
  alpha = s7_car(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_paint_with_alpha", 2, alpha, "double");
  cairo_paint_with_alpha((cairo_t*)s7_c_pointer(cr), (double)s7_real(alpha));
  return(lg_false);
}

static s7_pointer lg_cairo_mask(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_mask "void cairo_mask(cairo_t* cr, cairo_pattern_t* pattern)"
  s7_pointer _p;
  s7_pointer cr, pattern;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask", 1, cr, "cairo_t*");
  pattern = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask", 2, pattern, "cairo_pattern_t*");
  cairo_mask((cairo_t*)s7_c_pointer(cr), (cairo_pattern_t*)s7_c_pointer(pattern));
  return(lg_false);
}

static s7_pointer lg_cairo_mask_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_mask_surface "void cairo_mask_surface(cairo_t* cr, cairo_surface_t* surface, double surface_x, \
double surface_y)"
  s7_pointer _p;
  s7_pointer cr, surface, surface_x, surface_y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 1, cr, "cairo_t*");
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 2, surface, "cairo_surface_t*");
  surface_x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(surface_x)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 3, surface_x, "double");
  surface_y = s7_car(_p);
  if (!s7_is_real(surface_y)) s7_wrong_type_arg_error(sc, "cairo_mask_surface", 4, surface_y, "double");
  cairo_mask_surface((cairo_t*)s7_c_pointer(cr), (cairo_surface_t*)s7_c_pointer(surface), (double)s7_real(surface_x), (double)s7_real(surface_y));
  return(lg_false);
}

static s7_pointer lg_cairo_stroke(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_stroke "void cairo_stroke(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_stroke", 1, cr, "cairo_t*");
  cairo_stroke((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_stroke_preserve(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_stroke_preserve "void cairo_stroke_preserve(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_stroke_preserve", 1, cr, "cairo_t*");
  cairo_stroke_preserve((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_fill "void cairo_fill(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_fill", 1, cr, "cairo_t*");
  cairo_fill((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_fill_preserve(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_fill_preserve "void cairo_fill_preserve(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_fill_preserve", 1, cr, "cairo_t*");
  cairo_fill_preserve((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_copy_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_page "void cairo_copy_page(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_page", 1, cr, "cairo_t*");
  cairo_copy_page((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_show_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_page "void cairo_show_page(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_page", 1, cr, "cairo_t*");
  cairo_show_page((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_in_stroke(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_in_stroke "bool cairo_in_stroke(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_in_stroke", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_in_stroke", 2, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_in_stroke", 3, y, "double");
  return(s7_make_boolean(sc, cairo_in_stroke((cairo_t*)s7_c_pointer(cr), (double)s7_real(x), (double)s7_real(y))));
}

static s7_pointer lg_cairo_in_fill(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_in_fill "bool cairo_in_fill(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_in_fill", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_in_fill", 2, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_in_fill", 3, y, "double");
  return(s7_make_boolean(sc, cairo_in_fill((cairo_t*)s7_c_pointer(cr), (double)s7_real(x), (double)s7_real(y))));
}

static s7_pointer lg_cairo_reset_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_reset_clip "void cairo_reset_clip(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_reset_clip", 1, cr, "cairo_t*");
  cairo_reset_clip((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_clip "void cairo_clip(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_clip", 1, cr, "cairo_t*");
  cairo_clip((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_clip_preserve(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_clip_preserve "void cairo_clip_preserve(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_clip_preserve", 1, cr, "cairo_t*");
  cairo_clip_preserve((cairo_t*)s7_c_pointer(cr));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_create "cairo_font_options_t* cairo_font_options_create( void)"
  return(lg_make_c_pointer_with_type(sc, cairo_font_options_t__sym, cairo_font_options_create()));
}

static s7_pointer lg_cairo_font_options_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_copy "cairo_font_options_t* cairo_font_options_copy(cairo_font_options_t* original)"
  s7_pointer original;
  original = s7_car(args);
  if (!s7_is_c_pointer_of_type(original, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_copy", 1, original, "cairo_font_options_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_font_options_t__sym, cairo_font_options_copy((cairo_font_options_t*)s7_c_pointer(original))));
}

static s7_pointer lg_cairo_font_options_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_destroy "void cairo_font_options_destroy(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_destroy", 1, options, "cairo_font_options_t*");
  cairo_font_options_destroy((cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_status "cairo_status_t cairo_font_options_status(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_status", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_status((cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_merge(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_merge "void cairo_font_options_merge(cairo_font_options_t* options, cairo_font_options_t* other)"
  s7_pointer _p;
  s7_pointer options, other;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_merge", 1, options, "cairo_font_options_t*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_merge", 2, other, "cairo_font_options_t*");
  cairo_font_options_merge((cairo_font_options_t*)s7_c_pointer(options), (cairo_font_options_t*)s7_c_pointer(other));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_equal "bool cairo_font_options_equal(cairo_font_options_t* options, cairo_font_options_t* other)"
  s7_pointer _p;
  s7_pointer options, other;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_equal", 1, options, "cairo_font_options_t*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_equal", 2, other, "cairo_font_options_t*");
  return(s7_make_boolean(sc, cairo_font_options_equal((cairo_font_options_t*)s7_c_pointer(options), (cairo_font_options_t*)s7_c_pointer(other))));
}

static s7_pointer lg_cairo_font_options_hash(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_hash "gulong cairo_font_options_hash(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_hash", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_hash((cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_antialias "void cairo_font_options_set_antialias(cairo_font_options_t* options, \
cairo_antialias_t antialias)"
  s7_pointer _p;
  s7_pointer options, antialias;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_antialias", 1, options, "cairo_font_options_t*");
  antialias = s7_car(_p);
  if (!s7_is_integer(antialias)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_antialias", 2, antialias, "cairo_antialias_t");
  cairo_font_options_set_antialias((cairo_font_options_t*)s7_c_pointer(options), (cairo_antialias_t)s7_integer(antialias));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_antialias "cairo_antialias_t cairo_font_options_get_antialias(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_antialias", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_antialias((cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_subpixel_order(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_subpixel_order "void cairo_font_options_set_subpixel_order(cairo_font_options_t* options, \
cairo_subpixel_order_t subpixel_order)"
  s7_pointer _p;
  s7_pointer options, subpixel_order;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_subpixel_order", 1, options, "cairo_font_options_t*");
  subpixel_order = s7_car(_p);
  if (!s7_is_integer(subpixel_order)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_subpixel_order", 2, subpixel_order, "cairo_subpixel_order_t");
  cairo_font_options_set_subpixel_order((cairo_font_options_t*)s7_c_pointer(options), (cairo_subpixel_order_t)s7_integer(subpixel_order));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_subpixel_order(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_subpixel_order "cairo_subpixel_order_t cairo_font_options_get_subpixel_order(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_subpixel_order", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_subpixel_order((cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_hint_style(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_hint_style "void cairo_font_options_set_hint_style(cairo_font_options_t* options, \
cairo_hint_style_t hint_style)"
  s7_pointer _p;
  s7_pointer options, hint_style;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_style", 1, options, "cairo_font_options_t*");
  hint_style = s7_car(_p);
  if (!s7_is_integer(hint_style)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_style", 2, hint_style, "cairo_hint_style_t");
  cairo_font_options_set_hint_style((cairo_font_options_t*)s7_c_pointer(options), (cairo_hint_style_t)s7_integer(hint_style));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_hint_style(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_hint_style "cairo_hint_style_t cairo_font_options_get_hint_style(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_hint_style", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_hint_style((cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_font_options_set_hint_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_set_hint_metrics "void cairo_font_options_set_hint_metrics(cairo_font_options_t* options, \
cairo_hint_metrics_t hint_metrics)"
  s7_pointer _p;
  s7_pointer options, hint_metrics;
  _p = args;
  options = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_metrics", 1, options, "cairo_font_options_t*");
  hint_metrics = s7_car(_p);
  if (!s7_is_integer(hint_metrics)) s7_wrong_type_arg_error(sc, "cairo_font_options_set_hint_metrics", 2, hint_metrics, "cairo_hint_metrics_t");
  cairo_font_options_set_hint_metrics((cairo_font_options_t*)s7_c_pointer(options), (cairo_hint_metrics_t)s7_integer(hint_metrics));
  return(lg_false);
}

static s7_pointer lg_cairo_font_options_get_hint_metrics(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_options_get_hint_metrics "cairo_hint_metrics_t cairo_font_options_get_hint_metrics(cairo_font_options_t* options)"
  s7_pointer options;
  options = s7_car(args);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_options_get_hint_metrics", 1, options, "cairo_font_options_t*");
  return(s7_make_integer(sc, cairo_font_options_get_hint_metrics((cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_select_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_select_font_face "void cairo_select_font_face(cairo_t* cr, char* family, cairo_font_slant_t slant, \
cairo_font_weight_t weight)"
  s7_pointer _p;
  s7_pointer cr, family, slant, weight;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 1, cr, "cairo_t*");
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 2, family, "char*");
  slant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(slant)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 3, slant, "cairo_font_slant_t");
  weight = s7_car(_p);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "cairo_select_font_face", 4, weight, "cairo_font_weight_t");
  cairo_select_font_face((cairo_t*)s7_c_pointer(cr), (char*)s7_string(family), (cairo_font_slant_t)s7_integer(slant), (cairo_font_weight_t)s7_integer(weight));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_size(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_size "void cairo_set_font_size(cairo_t* cr, double size)"
  s7_pointer _p;
  s7_pointer cr, size;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_size", 1, cr, "cairo_t*");
  size = s7_car(_p);
  if (!s7_is_real(size)) s7_wrong_type_arg_error(sc, "cairo_set_font_size", 2, size, "double");
  cairo_set_font_size((cairo_t*)s7_c_pointer(cr), (double)s7_real(size));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_matrix "void cairo_set_font_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_set_font_matrix((cairo_t*)s7_c_pointer(cr), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_get_font_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_font_matrix "void cairo_get_font_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_get_font_matrix((cairo_t*)s7_c_pointer(cr), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_options "void cairo_set_font_options(cairo_t* cr, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer cr, options;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_options", 1, cr, "cairo_t*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_options", 2, options, "cairo_font_options_t*");
  cairo_set_font_options((cairo_t*)s7_c_pointer(cr), (cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_font_options "void cairo_get_font_options(cairo_t* cr, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer cr, options;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_options", 1, cr, "cairo_t*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_options", 2, options, "cairo_font_options_t*");
  cairo_get_font_options((cairo_t*)s7_c_pointer(cr), (cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_set_scaled_font(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_scaled_font "void cairo_set_scaled_font(cairo_t* cr, cairo_scaled_font_t* scaled_font)"
  s7_pointer _p;
  s7_pointer cr, scaled_font;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_scaled_font", 1, cr, "cairo_t*");
  scaled_font = s7_car(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_scaled_font", 2, scaled_font, "cairo_scaled_font_t*");
  cairo_set_scaled_font((cairo_t*)s7_c_pointer(cr), (cairo_scaled_font_t*)s7_c_pointer(scaled_font));
  return(lg_false);
}

static s7_pointer lg_cairo_show_text(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_text "void cairo_show_text(cairo_t* cr, char* utf8)"
  s7_pointer _p;
  s7_pointer cr, utf8;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text", 1, cr, "cairo_t*");
  utf8 = s7_car(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_show_text", 2, utf8, "char*");
  cairo_show_text((cairo_t*)s7_c_pointer(cr), (char*)s7_string(utf8));
  return(lg_false);
}

static s7_pointer lg_cairo_show_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_glyphs "void cairo_show_glyphs(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs)"
  s7_pointer _p;
  s7_pointer cr, glyphs, num_glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_glyphs", 1, cr, "cairo_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_glyphs", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_show_glyphs", 3, num_glyphs, "int");
  cairo_show_glyphs((cairo_t*)s7_c_pointer(cr), (cairo_glyph_t*)s7_c_pointer(glyphs), (int)s7_integer(num_glyphs));
  return(lg_false);
}

static s7_pointer lg_cairo_get_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_font_face "cairo_font_face_t* cairo_get_font_face(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_font_face", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_font_face_t__sym, cairo_get_font_face((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_font_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_extents "void cairo_font_extents(cairo_t* cr, cairo_font_extents_t* extents)"
  s7_pointer _p;
  s7_pointer cr, extents;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_extents", 1, cr, "cairo_t*");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_font_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_extents", 2, extents, "cairo_font_extents_t*");
  cairo_font_extents((cairo_t*)s7_c_pointer(cr), (cairo_font_extents_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_set_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_font_face "void cairo_set_font_face(cairo_t* cr, cairo_font_face_t* font_face)"
  s7_pointer _p;
  s7_pointer cr, font_face;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_face", 1, cr, "cairo_t*");
  font_face = s7_car(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_font_face", 2, font_face, "cairo_font_face_t*");
  cairo_set_font_face((cairo_t*)s7_c_pointer(cr), (cairo_font_face_t*)s7_c_pointer(font_face));
  return(lg_false);
}

static s7_pointer lg_cairo_text_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_extents "void cairo_text_extents(cairo_t* cr, char* utf8, cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer cr, utf8, extents;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_extents", 1, cr, "cairo_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_text_extents", 2, utf8, "char*");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_extents", 3, extents, "cairo_text_extents_t*");
  cairo_text_extents((cairo_t*)s7_c_pointer(cr), (char*)s7_string(utf8), (cairo_text_extents_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_glyph_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_extents "void cairo_glyph_extents(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs, \
cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer cr, glyphs, num_glyphs, extents;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 1, cr, "cairo_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 3, num_glyphs, "int");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_extents", 4, extents, "cairo_text_extents_t*");
  cairo_glyph_extents((cairo_t*)s7_c_pointer(cr), (cairo_glyph_t*)s7_c_pointer(glyphs), (int)s7_integer(num_glyphs), (cairo_text_extents_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_text_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_path "void cairo_text_path(cairo_t* cr, char* utf8)"
  s7_pointer _p;
  s7_pointer cr, utf8;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_path", 1, cr, "cairo_t*");
  utf8 = s7_car(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_text_path", 2, utf8, "char*");
  cairo_text_path((cairo_t*)s7_c_pointer(cr), (char*)s7_string(utf8));
  return(lg_false);
}

static s7_pointer lg_cairo_glyph_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_path "void cairo_glyph_path(cairo_t* cr, cairo_glyph_t* glyphs, int num_glyphs)"
  s7_pointer _p;
  s7_pointer cr, glyphs, num_glyphs;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_path", 1, cr, "cairo_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_path", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_glyph_path", 3, num_glyphs, "int");
  cairo_glyph_path((cairo_t*)s7_c_pointer(cr), (cairo_glyph_t*)s7_c_pointer(glyphs), (int)s7_integer(num_glyphs));
  return(lg_false);
}

static s7_pointer lg_cairo_font_face_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_reference "cairo_font_face_t* cairo_font_face_reference(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_reference", 1, font_face, "cairo_font_face_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_font_face_t__sym, cairo_font_face_reference((cairo_font_face_t*)s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_font_face_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_destroy "void cairo_font_face_destroy(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_destroy", 1, font_face, "cairo_font_face_t*");
  cairo_font_face_destroy((cairo_font_face_t*)s7_c_pointer(font_face));
  return(lg_false);
}

static s7_pointer lg_cairo_font_face_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_status "cairo_status_t cairo_font_face_status(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_status", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_font_face_status((cairo_font_face_t*)s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_font_face_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_get_user_data "gpointer cairo_font_face_get_user_data(cairo_font_face_t* font_face, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer font_face, key;
  _p = args;
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_get_user_data", 1, font_face, "cairo_font_face_t*");
  key = s7_car(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(lg_make_c_pointer_with_type(sc, gpointer_sym, cairo_font_face_get_user_data((cairo_font_face_t*)s7_c_pointer(font_face), (cairo_user_data_key_t*)s7_c_pointer(key))));
}

static s7_pointer lg_cairo_font_face_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_set_user_data "cairo_status_t cairo_font_face_set_user_data(cairo_font_face_t* font_face, \
cairo_user_data_key_t* key, gpointer user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer font_face, key, user_data, destroy;
  _p = args;
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 1, font_face, "cairo_font_face_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, gpointer_sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 3, user_data, "gpointer");
  destroy = s7_car(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_font_face_set_user_data((cairo_font_face_t*)s7_c_pointer(font_face), (cairo_user_data_key_t*)s7_c_pointer(key), (gpointer)s7_c_pointer(user_data), (cairo_destroy_func_t)s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_scaled_font_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_create "cairo_scaled_font_t* cairo_scaled_font_create(cairo_font_face_t* font_face, \
cairo_matrix_t* font_matrix, cairo_matrix_t* ctm, cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer font_face, font_matrix, ctm, options;
  _p = args;
  font_face = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 1, font_face, "cairo_font_face_t*");
  font_matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(font_matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 2, font_matrix, "cairo_matrix_t*");
  ctm = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(ctm, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 3, ctm, "cairo_matrix_t*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_create", 4, options, "cairo_font_options_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_scaled_font_t__sym, cairo_scaled_font_create((cairo_font_face_t*)s7_c_pointer(font_face), (cairo_matrix_t*)s7_c_pointer(font_matrix), (cairo_matrix_t*)s7_c_pointer(ctm), (cairo_font_options_t*)s7_c_pointer(options))));
}

static s7_pointer lg_cairo_scaled_font_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_reference "cairo_scaled_font_t* cairo_scaled_font_reference(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_reference", 1, scaled_font, "cairo_scaled_font_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_scaled_font_t__sym, cairo_scaled_font_reference((cairo_scaled_font_t*)s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_destroy "void cairo_scaled_font_destroy(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_destroy", 1, scaled_font, "cairo_scaled_font_t*");
  cairo_scaled_font_destroy((cairo_scaled_font_t*)s7_c_pointer(scaled_font));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_status "cairo_status_t cairo_scaled_font_status(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_status", 1, scaled_font, "cairo_scaled_font_t*");
  return(s7_make_integer(sc, cairo_scaled_font_status((cairo_scaled_font_t*)s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_extents "void cairo_scaled_font_extents(cairo_scaled_font_t* scaled_font, \
cairo_font_extents_t* extents)"
  s7_pointer _p;
  s7_pointer scaled_font, extents;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_extents", 1, scaled_font, "cairo_scaled_font_t*");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_font_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_extents", 2, extents, "cairo_font_extents_t*");
  cairo_scaled_font_extents((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_font_extents_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_text_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_text_extents "void cairo_scaled_font_text_extents(cairo_scaled_font_t* scaled_font, \
char* utf8, cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer scaled_font, utf8, extents;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_extents", 1, scaled_font, "cairo_scaled_font_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_extents", 2, utf8, "char*");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_extents", 3, extents, "cairo_text_extents_t*");
  cairo_scaled_font_text_extents((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (char*)s7_string(utf8), (cairo_text_extents_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_glyph_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_glyph_extents "void cairo_scaled_font_glyph_extents(cairo_scaled_font_t* scaled_font, \
cairo_glyph_t* glyphs, int num_glyphs, cairo_text_extents_t* extents)"
  s7_pointer _p;
  s7_pointer scaled_font, glyphs, num_glyphs, extents;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 1, scaled_font, "cairo_scaled_font_t*");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 2, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 3, num_glyphs, "int");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_text_extents_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_glyph_extents", 4, extents, "cairo_text_extents_t*");
  cairo_scaled_font_glyph_extents((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_glyph_t*)s7_c_pointer(glyphs), (int)s7_integer(num_glyphs), (cairo_text_extents_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_get_font_face(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_font_face "cairo_font_face_t* cairo_scaled_font_get_font_face(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_face", 1, scaled_font, "cairo_scaled_font_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_font_face_t__sym, cairo_scaled_font_get_font_face((cairo_scaled_font_t*)s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_get_font_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_font_matrix "void cairo_scaled_font_get_font_matrix(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* font_matrix)"
  s7_pointer _p;
  s7_pointer scaled_font, font_matrix;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_matrix", 1, scaled_font, "cairo_scaled_font_t*");
  font_matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(font_matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_matrix", 2, font_matrix, "cairo_matrix_t*");
  cairo_scaled_font_get_font_matrix((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_matrix_t*)s7_c_pointer(font_matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_get_ctm(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_ctm "void cairo_scaled_font_get_ctm(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* ctm)"
  s7_pointer _p;
  s7_pointer scaled_font, ctm;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_ctm", 1, scaled_font, "cairo_scaled_font_t*");
  ctm = s7_car(_p);
  if (!s7_is_c_pointer_of_type(ctm, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_ctm", 2, ctm, "cairo_matrix_t*");
  cairo_scaled_font_get_ctm((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_matrix_t*)s7_c_pointer(ctm));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_font_options "void cairo_scaled_font_get_font_options(cairo_scaled_font_t* scaled_font, \
cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer scaled_font, options;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_options", 1, scaled_font, "cairo_scaled_font_t*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_font_options", 2, options, "cairo_font_options_t*");
  cairo_scaled_font_get_font_options((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_get_operator(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_operator "cairo_operator_t cairo_get_operator(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_operator", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_operator((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_source(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_source "cairo_pattern_t* cairo_get_source(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_source", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_get_source((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_tolerance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_tolerance "gdouble cairo_get_tolerance(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_tolerance", 1, cr, "cairo_t*");
  return(s7_make_real(sc, cairo_get_tolerance((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_antialias(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_antialias "cairo_antialias_t cairo_get_antialias(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_antialias", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_antialias((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_current_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_current_point "void cairo_get_current_point(cairo_t* cr, gdouble* [x], gdouble* [y])"
  s7_pointer _p;
  s7_pointer cr;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_current_point", 1, cr, "cairo_t*");
  cairo_get_current_point((cairo_t*)s7_c_pointer(cr), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_get_fill_rule(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_fill_rule "cairo_fill_rule_t cairo_get_fill_rule(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_fill_rule", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_fill_rule((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_line_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_line_width "gdouble cairo_get_line_width(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_line_width", 1, cr, "cairo_t*");
  return(s7_make_real(sc, cairo_get_line_width((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_line_cap(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_line_cap "cairo_line_cap_t cairo_get_line_cap(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_line_cap", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_line_cap((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_line_join(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_line_join "cairo_line_join_t cairo_get_line_join(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_line_join", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_line_join((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_miter_limit(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_miter_limit "gdouble cairo_get_miter_limit(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_miter_limit", 1, cr, "cairo_t*");
  return(s7_make_real(sc, cairo_get_miter_limit((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_matrix "void cairo_get_matrix(cairo_t* cr, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer cr, matrix;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_matrix", 1, cr, "cairo_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_get_matrix((cairo_t*)s7_c_pointer(cr), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_get_target(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_target "cairo_surface_t* cairo_get_target(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_target", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_get_target((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_group_target(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_group_target "cairo_surface_t* cairo_get_group_target(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_group_target", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_get_group_target((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_copy_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_path "cairo_path_t* cairo_copy_path(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_path", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_path_t__sym, cairo_copy_path((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_copy_path_flat(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_path_flat "cairo_path_t* cairo_copy_path_flat(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_path_flat", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_path_t__sym, cairo_copy_path_flat((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_append_path(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_append_path "void cairo_append_path(cairo_t* cr, cairo_path_t* path)"
  s7_pointer _p;
  s7_pointer cr, path;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_append_path", 1, cr, "cairo_t*");
  path = s7_car(_p);
  if (!s7_is_c_pointer_of_type(path, cairo_path_t__sym)) s7_wrong_type_arg_error(sc, "cairo_append_path", 2, path, "cairo_path_t*");
  cairo_append_path((cairo_t*)s7_c_pointer(cr), (cairo_path_t*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_cairo_path_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_path_destroy "void cairo_path_destroy(cairo_path_t* path)"
  s7_pointer path;
  path = s7_car(args);
  if (!s7_is_c_pointer_of_type(path, cairo_path_t__sym)) s7_wrong_type_arg_error(sc, "cairo_path_destroy", 1, path, "cairo_path_t*");
  cairo_path_destroy((cairo_path_t*)s7_c_pointer(path));
  return(lg_false);
}

static s7_pointer lg_cairo_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_status "cairo_status_t cairo_status(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_status", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_status((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_status_to_string(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_status_to_string "char* cairo_status_to_string(cairo_status_t status)"
  s7_pointer status;
  status = s7_car(args);
  if (!s7_is_integer(status)) s7_wrong_type_arg_error(sc, "cairo_status_to_string", 1, status, "cairo_status_t");
  return(s7_make_string(sc, cairo_status_to_string((cairo_status_t)s7_integer(status))));
}

static s7_pointer lg_cairo_surface_create_similar(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_create_similar "cairo_surface_t* cairo_surface_create_similar(cairo_surface_t* other, \
cairo_content_t content, int width, int height)"
  s7_pointer _p;
  s7_pointer other, content, width, height;
  _p = args;
  other = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 1, other, "cairo_surface_t*");
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 2, content, "cairo_content_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 3, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_surface_create_similar", 4, height, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_surface_create_similar((cairo_surface_t*)s7_c_pointer(other), (cairo_content_t)s7_integer(content), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_cairo_surface_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_reference "cairo_surface_t* cairo_surface_reference(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_reference", 1, surface, "cairo_surface_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_surface_reference((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_finish "void cairo_surface_finish(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_finish", 1, surface, "cairo_surface_t*");
  cairo_surface_finish((cairo_surface_t*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_destroy "void cairo_surface_destroy(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_destroy", 1, surface, "cairo_surface_t*");
  cairo_surface_destroy((cairo_surface_t*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_status "cairo_status_t cairo_surface_status(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_status", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_status((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_get_content(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_content "cairo_content_t cairo_surface_get_content(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_content", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_get_content((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_get_font_options(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_font_options "void cairo_surface_get_font_options(cairo_surface_t* surface, \
cairo_font_options_t* options)"
  s7_pointer _p;
  s7_pointer surface, options;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_font_options", 1, surface, "cairo_surface_t*");
  options = s7_car(_p);
  if (!s7_is_c_pointer_of_type(options, cairo_font_options_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_font_options", 2, options, "cairo_font_options_t*");
  cairo_surface_get_font_options((cairo_surface_t*)s7_c_pointer(surface), (cairo_font_options_t*)s7_c_pointer(options));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_flush "void cairo_surface_flush(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_flush", 1, surface, "cairo_surface_t*");
  cairo_surface_flush((cairo_surface_t*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_mark_dirty(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_mark_dirty "void cairo_surface_mark_dirty(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty", 1, surface, "cairo_surface_t*");
  cairo_surface_mark_dirty((cairo_surface_t*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_mark_dirty_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_mark_dirty_rectangle "void cairo_surface_mark_dirty_rectangle(cairo_surface_t* surface, \
int x, int y, int width, int height)"
  s7_pointer _p;
  s7_pointer surface, x, y, width, height;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 1, surface, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 2, x, "int");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 3, y, "int");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 4, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_surface_mark_dirty_rectangle", 5, height, "int");
  cairo_surface_mark_dirty_rectangle((cairo_surface_t*)s7_c_pointer(surface), (int)s7_integer(x), (int)s7_integer(y), (int)s7_integer(width), (int)s7_integer(height));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_set_device_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_device_offset "void cairo_surface_set_device_offset(cairo_surface_t* surface, \
double x_offset, double y_offset)"
  s7_pointer _p;
  s7_pointer surface, x_offset, y_offset;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_device_offset", 1, surface, "cairo_surface_t*");
  x_offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x_offset)) s7_wrong_type_arg_error(sc, "cairo_surface_set_device_offset", 2, x_offset, "double");
  y_offset = s7_car(_p);
  if (!s7_is_real(y_offset)) s7_wrong_type_arg_error(sc, "cairo_surface_set_device_offset", 3, y_offset, "double");
  cairo_surface_set_device_offset((cairo_surface_t*)s7_c_pointer(surface), (double)s7_real(x_offset), (double)s7_real(y_offset));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_get_device_offset(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_device_offset "void cairo_surface_get_device_offset(cairo_surface_t* surface, \
gdouble* [x_offset], gdouble* [y_offset])"
  s7_pointer _p;
  s7_pointer surface;
  gdouble ref_x_offset;
  gdouble ref_y_offset;
  _p = args;
  surface = s7_car(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_device_offset", 1, surface, "cairo_surface_t*");
  cairo_surface_get_device_offset((cairo_surface_t*)s7_c_pointer(surface), &ref_x_offset, &ref_y_offset);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x_offset), s7_make_real(sc, ref_y_offset)));
}

static s7_pointer lg_cairo_surface_set_fallback_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_fallback_resolution "void cairo_surface_set_fallback_resolution(cairo_surface_t* surface, \
double x_pixels_per_inch, double y_pixels_per_inch)"
  s7_pointer _p;
  s7_pointer surface, x_pixels_per_inch, y_pixels_per_inch;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_fallback_resolution", 1, surface, "cairo_surface_t*");
  x_pixels_per_inch = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x_pixels_per_inch)) s7_wrong_type_arg_error(sc, "cairo_surface_set_fallback_resolution", 2, x_pixels_per_inch, "double");
  y_pixels_per_inch = s7_car(_p);
  if (!s7_is_real(y_pixels_per_inch)) s7_wrong_type_arg_error(sc, "cairo_surface_set_fallback_resolution", 3, y_pixels_per_inch, "double");
  cairo_surface_set_fallback_resolution((cairo_surface_t*)s7_c_pointer(surface), (double)s7_real(x_pixels_per_inch), (double)s7_real(y_pixels_per_inch));
  return(lg_false);
}

static s7_pointer lg_cairo_image_surface_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_create "cairo_surface_t* cairo_image_surface_create(cairo_format_t format, \
int width, int height)"
  s7_pointer _p;
  s7_pointer format, width, height;
  _p = args;
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create", 1, format, "cairo_format_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create", 2, width, "int");
  height = s7_car(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create", 3, height, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_image_surface_create((cairo_format_t)s7_integer(format), (int)s7_integer(width), (int)s7_integer(height))));
}

static s7_pointer lg_cairo_image_surface_create_for_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_create_for_data "cairo_surface_t* cairo_image_surface_create_for_data(guchar* data, \
cairo_format_t format, int width, int height, int stride)"
  s7_pointer _p;
  s7_pointer data, format, width, height, stride;
  _p = args;
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 1, data, "guchar*");
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 2, format, "cairo_format_t");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 3, width, "int");
  height = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(height)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 4, height, "int");
  stride = s7_car(_p);
  if (!s7_is_integer(stride)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_for_data", 5, stride, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_image_surface_create_for_data((guchar*)s7_c_pointer(data), (cairo_format_t)s7_integer(format), (int)s7_integer(width), (int)s7_integer(height), (int)s7_integer(stride))));
}

static s7_pointer lg_cairo_image_surface_get_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_data "guchar* cairo_image_surface_get_data(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_data", 1, surface, "cairo_surface_t*");
  return(lg_make_c_pointer_with_type(sc, guchar__sym, cairo_image_surface_get_data((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_format(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_format "cairo_format_t cairo_image_surface_get_format(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_format", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_format((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_width "int cairo_image_surface_get_width(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_width", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_width((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_height(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_height "int cairo_image_surface_get_height(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_height", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_height((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_image_surface_get_stride(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_get_stride "int cairo_image_surface_get_stride(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_image_surface_get_stride", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_image_surface_get_stride((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_pattern_create_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_rgb "cairo_pattern_t* cairo_pattern_create_rgb(double red, double green, \
double blue)"
  s7_pointer _p;
  s7_pointer red, green, blue;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgb", 1, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgb", 2, green, "double");
  blue = s7_car(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgb", 3, blue, "double");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pattern_create_rgb((double)s7_real(red), (double)s7_real(green), (double)s7_real(blue))));
}

static s7_pointer lg_cairo_pattern_create_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_rgba "cairo_pattern_t* cairo_pattern_create_rgba(double red, double green, \
double blue, double alpha)"
  s7_pointer _p;
  s7_pointer red, green, blue, alpha;
  _p = args;
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 1, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 2, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 3, blue, "double");
  alpha = s7_car(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_rgba", 4, alpha, "double");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pattern_create_rgba((double)s7_real(red), (double)s7_real(green), (double)s7_real(blue), (double)s7_real(alpha))));
}

static s7_pointer lg_cairo_pattern_create_for_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_for_surface "cairo_pattern_t* cairo_pattern_create_for_surface(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_for_surface", 1, surface, "cairo_surface_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pattern_create_for_surface((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_pattern_create_linear(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_linear "cairo_pattern_t* cairo_pattern_create_linear(double x0, double y0, \
double x1, double y1)"
  s7_pointer _p;
  s7_pointer x0, y0, x1, y1;
  _p = args;
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 1, x0, "double");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 2, y0, "double");
  x1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 3, x1, "double");
  y1 = s7_car(_p);
  if (!s7_is_real(y1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_linear", 4, y1, "double");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pattern_create_linear((double)s7_real(x0), (double)s7_real(y0), (double)s7_real(x1), (double)s7_real(y1))));
}

static s7_pointer lg_cairo_pattern_create_radial(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_create_radial "cairo_pattern_t* cairo_pattern_create_radial(double cx0, double cy0, \
double radius0, double cx1, double cy1, double radius1)"
  s7_pointer _p;
  s7_pointer cx0, cy0, radius0, cx1, cy1, radius1;
  _p = args;
  cx0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cx0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 1, cx0, "double");
  cy0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cy0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 2, cy0, "double");
  radius0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(radius0)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 3, radius0, "double");
  cx1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cx1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 4, cx1, "double");
  cy1 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(cy1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 5, cy1, "double");
  radius1 = s7_car(_p);
  if (!s7_is_real(radius1)) s7_wrong_type_arg_error(sc, "cairo_pattern_create_radial", 6, radius1, "double");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pattern_create_radial((double)s7_real(cx0), (double)s7_real(cy0), (double)s7_real(radius0), (double)s7_real(cx1), (double)s7_real(cy1), (double)s7_real(radius1))));
}

static s7_pointer lg_cairo_pattern_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_reference "cairo_pattern_t* cairo_pattern_reference(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_reference", 1, pattern, "cairo_pattern_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_pattern_t__sym, cairo_pattern_reference((cairo_pattern_t*)s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_destroy "void cairo_pattern_destroy(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_destroy", 1, pattern, "cairo_pattern_t*");
  cairo_pattern_destroy((cairo_pattern_t*)s7_c_pointer(pattern));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_status "cairo_status_t cairo_pattern_status(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_status", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_status((cairo_pattern_t*)s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_add_color_stop_rgb(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_add_color_stop_rgb "void cairo_pattern_add_color_stop_rgb(cairo_pattern_t* pattern, \
double offset, double red, double green, double blue)"
  s7_pointer _p;
  s7_pointer pattern, offset, red, green, blue;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 1, pattern, "cairo_pattern_t*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 2, offset, "double");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 3, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 4, green, "double");
  blue = s7_car(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgb", 5, blue, "double");
  cairo_pattern_add_color_stop_rgb((cairo_pattern_t*)s7_c_pointer(pattern), (double)s7_real(offset), (double)s7_real(red), (double)s7_real(green), (double)s7_real(blue));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_add_color_stop_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_add_color_stop_rgba "void cairo_pattern_add_color_stop_rgba(cairo_pattern_t* pattern, \
double offset, double red, double green, double blue, double alpha)"
  s7_pointer _p;
  s7_pointer pattern, offset, red, green, blue, alpha;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 1, pattern, "cairo_pattern_t*");
  offset = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(offset)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 2, offset, "double");
  red = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(red)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 3, red, "double");
  green = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(green)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 4, green, "double");
  blue = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(blue)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 5, blue, "double");
  alpha = s7_car(_p);
  if (!s7_is_real(alpha)) s7_wrong_type_arg_error(sc, "cairo_pattern_add_color_stop_rgba", 6, alpha, "double");
  cairo_pattern_add_color_stop_rgba((cairo_pattern_t*)s7_c_pointer(pattern), (double)s7_real(offset), (double)s7_real(red), (double)s7_real(green), (double)s7_real(blue), (double)s7_real(alpha));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_set_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_matrix "void cairo_pattern_set_matrix(cairo_pattern_t* pattern, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer pattern, matrix;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_matrix", 1, pattern, "cairo_pattern_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_pattern_set_matrix((cairo_pattern_t*)s7_c_pointer(pattern), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_get_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_matrix "void cairo_pattern_get_matrix(cairo_pattern_t* pattern, cairo_matrix_t* matrix)"
  s7_pointer _p;
  s7_pointer pattern, matrix;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_matrix", 1, pattern, "cairo_pattern_t*");
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_matrix", 2, matrix, "cairo_matrix_t*");
  cairo_pattern_get_matrix((cairo_pattern_t*)s7_c_pointer(pattern), (cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_set_extend(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_extend "void cairo_pattern_set_extend(cairo_pattern_t* pattern, cairo_extend_t extend)"
  s7_pointer _p;
  s7_pointer pattern, extend;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_extend", 1, pattern, "cairo_pattern_t*");
  extend = s7_car(_p);
  if (!s7_is_integer(extend)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_extend", 2, extend, "cairo_extend_t");
  cairo_pattern_set_extend((cairo_pattern_t*)s7_c_pointer(pattern), (cairo_extend_t)s7_integer(extend));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_get_extend(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_extend "cairo_extend_t cairo_pattern_get_extend(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_extend", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_get_extend((cairo_pattern_t*)s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_set_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_filter "void cairo_pattern_set_filter(cairo_pattern_t* pattern, cairo_filter_t filter)"
  s7_pointer _p;
  s7_pointer pattern, filter;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_filter", 1, pattern, "cairo_pattern_t*");
  filter = s7_car(_p);
  if (!s7_is_integer(filter)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_filter", 2, filter, "cairo_filter_t");
  cairo_pattern_set_filter((cairo_pattern_t*)s7_c_pointer(pattern), (cairo_filter_t)s7_integer(filter));
  return(lg_false);
}

static s7_pointer lg_cairo_pattern_get_filter(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_filter "cairo_filter_t cairo_pattern_get_filter(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_filter", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_get_filter((cairo_pattern_t*)s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_matrix_init(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init "void cairo_matrix_init(cairo_matrix_t* matrix, double xx, double yx, double xy, \
double yy, double x0, double y0)"
  s7_pointer _p;
  s7_pointer matrix, xx, yx, xy, yy, x0, y0;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 1, matrix, "cairo_matrix_t*");
  xx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 2, xx, "double");
  yx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 3, yx, "double");
  xy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(xy)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 4, xy, "double");
  yy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(yy)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 5, yy, "double");
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x0)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 6, x0, "double");
  y0 = s7_car(_p);
  if (!s7_is_real(y0)) s7_wrong_type_arg_error(sc, "cairo_matrix_init", 7, y0, "double");
  cairo_matrix_init((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(xx), (double)s7_real(yx), (double)s7_real(xy), (double)s7_real(yy), (double)s7_real(x0), (double)s7_real(y0));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_identity(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_identity "void cairo_matrix_init_identity(cairo_matrix_t* matrix)"
  s7_pointer matrix;
  matrix = s7_car(args);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_identity", 1, matrix, "cairo_matrix_t*");
  cairo_matrix_init_identity((cairo_matrix_t*)s7_c_pointer(matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_translate "void cairo_matrix_init_translate(cairo_matrix_t* matrix, double tx, \
double ty)"
  s7_pointer _p;
  s7_pointer matrix, tx, ty;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_translate", 1, matrix, "cairo_matrix_t*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_translate", 2, tx, "double");
  ty = s7_car(_p);
  if (!s7_is_real(ty)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_translate", 3, ty, "double");
  cairo_matrix_init_translate((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(tx), (double)s7_real(ty));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_scale "void cairo_matrix_init_scale(cairo_matrix_t* matrix, double sx, \
double sy)"
  s7_pointer _p;
  s7_pointer matrix, sx, sy;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_scale", 1, matrix, "cairo_matrix_t*");
  sx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sx)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_scale", 2, sx, "double");
  sy = s7_car(_p);
  if (!s7_is_real(sy)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_scale", 3, sy, "double");
  cairo_matrix_init_scale((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(sx), (double)s7_real(sy));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_init_rotate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_init_rotate "void cairo_matrix_init_rotate(cairo_matrix_t* matrix, double radians)"
  s7_pointer _p;
  s7_pointer matrix, radians;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_rotate", 1, matrix, "cairo_matrix_t*");
  radians = s7_car(_p);
  if (!s7_is_real(radians)) s7_wrong_type_arg_error(sc, "cairo_matrix_init_rotate", 2, radians, "double");
  cairo_matrix_init_rotate((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(radians));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_translate "void cairo_matrix_translate(cairo_matrix_t* matrix, double tx, double ty)"
  s7_pointer _p;
  s7_pointer matrix, tx, ty;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_translate", 1, matrix, "cairo_matrix_t*");
  tx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(tx)) s7_wrong_type_arg_error(sc, "cairo_matrix_translate", 2, tx, "double");
  ty = s7_car(_p);
  if (!s7_is_real(ty)) s7_wrong_type_arg_error(sc, "cairo_matrix_translate", 3, ty, "double");
  cairo_matrix_translate((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(tx), (double)s7_real(ty));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_scale(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_scale "void cairo_matrix_scale(cairo_matrix_t* matrix, double sx, double sy)"
  s7_pointer _p;
  s7_pointer matrix, sx, sy;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_scale", 1, matrix, "cairo_matrix_t*");
  sx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(sx)) s7_wrong_type_arg_error(sc, "cairo_matrix_scale", 2, sx, "double");
  sy = s7_car(_p);
  if (!s7_is_real(sy)) s7_wrong_type_arg_error(sc, "cairo_matrix_scale", 3, sy, "double");
  cairo_matrix_scale((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(sx), (double)s7_real(sy));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_rotate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_rotate "void cairo_matrix_rotate(cairo_matrix_t* matrix, double radians)"
  s7_pointer _p;
  s7_pointer matrix, radians;
  _p = args;
  matrix = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_rotate", 1, matrix, "cairo_matrix_t*");
  radians = s7_car(_p);
  if (!s7_is_real(radians)) s7_wrong_type_arg_error(sc, "cairo_matrix_rotate", 2, radians, "double");
  cairo_matrix_rotate((cairo_matrix_t*)s7_c_pointer(matrix), (double)s7_real(radians));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_invert(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_invert "cairo_status_t cairo_matrix_invert(cairo_matrix_t* matrix)"
  s7_pointer matrix;
  matrix = s7_car(args);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_invert", 1, matrix, "cairo_matrix_t*");
  return(s7_make_integer(sc, cairo_matrix_invert((cairo_matrix_t*)s7_c_pointer(matrix))));
}

static s7_pointer lg_cairo_matrix_multiply(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_multiply "void cairo_matrix_multiply(cairo_matrix_t* result, cairo_matrix_t* a, \
cairo_matrix_t* b)"
  s7_pointer _p;
  s7_pointer result, a, b;
  _p = args;
  result = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(result, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_multiply", 1, result, "cairo_matrix_t*");
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_multiply", 2, a, "cairo_matrix_t*");
  b = s7_car(_p);
  if (!s7_is_c_pointer_of_type(b, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_multiply", 3, b, "cairo_matrix_t*");
  cairo_matrix_multiply((cairo_matrix_t*)s7_c_pointer(result), (cairo_matrix_t*)s7_c_pointer(a), (cairo_matrix_t*)s7_c_pointer(b));
  return(lg_false);
}

static s7_pointer lg_cairo_matrix_transform_distance(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_transform_distance "void cairo_matrix_transform_distance(cairo_matrix_t* matrix, \
gdouble* [dx], gdouble* [dy])"
  s7_pointer _p;
  s7_pointer matrix;
  gdouble ref_dx;
  gdouble ref_dy;
  _p = args;
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_transform_distance", 1, matrix, "cairo_matrix_t*");
  cairo_matrix_transform_distance((cairo_matrix_t*)s7_c_pointer(matrix), &ref_dx, &ref_dy);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dx), s7_make_real(sc, ref_dy)));
}

static s7_pointer lg_cairo_matrix_transform_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_matrix_transform_point "void cairo_matrix_transform_point(cairo_matrix_t* matrix, gdouble* [x], \
gdouble* [y])"
  s7_pointer _p;
  s7_pointer matrix;
  gdouble ref_x;
  gdouble ref_y;
  _p = args;
  matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_matrix_transform_point", 1, matrix, "cairo_matrix_t*");
  cairo_matrix_transform_point((cairo_matrix_t*)s7_c_pointer(matrix), &ref_x, &ref_y);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x), s7_make_real(sc, ref_y)));
}

static s7_pointer lg_cairo_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_reference_count "guint cairo_get_reference_count(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_reference_count", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_reference_count((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_user_data "void* cairo_get_user_data(cairo_t* cr, cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer cr, key;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_user_data", 1, cr, "cairo_t*");
  key = s7_car(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(lg_make_c_pointer_with_type(sc, void__sym, cairo_get_user_data((cairo_t*)s7_c_pointer(cr), (cairo_user_data_key_t*)s7_c_pointer(key))));
}

static s7_pointer lg_cairo_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_set_user_data "cairo_status_t cairo_set_user_data(cairo_t* cr, cairo_user_data_key_t* key, \
void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer cr, key, user_data, destroy;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 1, cr, "cairo_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_set_user_data((cairo_t*)s7_c_pointer(cr), (cairo_user_data_key_t*)s7_c_pointer(key), (void*)s7_c_pointer(user_data), (cairo_destroy_func_t)s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_clip_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_clip_extents "void cairo_clip_extents(cairo_t* cr, double* [x1], double* [y1], double* [x2], \
double* [y2])"
  s7_pointer _p;
  s7_pointer cr;
  double ref_x1;
  double ref_y1;
  double ref_x2;
  double ref_y2;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_clip_extents", 1, cr, "cairo_t*");
  cairo_clip_extents((cairo_t*)s7_c_pointer(cr), &ref_x1, &ref_y1, &ref_x2, &ref_y2);
    return(s7_list(sc, 4, s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1), s7_make_real(sc, ref_x2), s7_make_real(sc, ref_y2)));
}

static s7_pointer lg_cairo_copy_clip_rectangle_list(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_copy_clip_rectangle_list "cairo_rectangle_list_t* cairo_copy_clip_rectangle_list(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_copy_clip_rectangle_list", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_rectangle_list_t__sym, cairo_copy_clip_rectangle_list((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_rectangle_list_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_rectangle_list_destroy "void cairo_rectangle_list_destroy(cairo_rectangle_list_t* rectangle_list)"
  s7_pointer rectangle_list;
  rectangle_list = s7_car(args);
  if (!s7_is_c_pointer_of_type(rectangle_list, cairo_rectangle_list_t__sym)) s7_wrong_type_arg_error(sc, "cairo_rectangle_list_destroy", 1, rectangle_list, "cairo_rectangle_list_t*");
  cairo_rectangle_list_destroy((cairo_rectangle_list_t*)s7_c_pointer(rectangle_list));
  return(lg_false);
}

static s7_pointer lg_cairo_font_face_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_font_face_get_reference_count "guint cairo_font_face_get_reference_count(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_font_face_get_reference_count", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_font_face_get_reference_count((cairo_font_face_t*)s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_scaled_font_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_reference_count "guint cairo_scaled_font_get_reference_count(cairo_scaled_font_t* scaled_font)"
  s7_pointer scaled_font;
  scaled_font = s7_car(args);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_reference_count", 1, scaled_font, "cairo_scaled_font_t*");
  return(s7_make_integer(sc, cairo_scaled_font_get_reference_count((cairo_scaled_font_t*)s7_c_pointer(scaled_font))));
}

static s7_pointer lg_cairo_scaled_font_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_user_data "void* cairo_scaled_font_get_user_data(cairo_scaled_font_t* scaled_font, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer scaled_font, key;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_user_data", 1, scaled_font, "cairo_scaled_font_t*");
  key = s7_car(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(lg_make_c_pointer_with_type(sc, void__sym, cairo_scaled_font_get_user_data((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_user_data_key_t*)s7_c_pointer(key))));
}

static s7_pointer lg_cairo_scaled_font_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_set_user_data "cairo_status_t cairo_scaled_font_set_user_data(cairo_scaled_font_t* scaled_font, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer scaled_font, key, user_data, destroy;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 1, scaled_font, "cairo_scaled_font_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_scaled_font_set_user_data((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_user_data_key_t*)s7_c_pointer(key), (void*)s7_c_pointer(user_data), (cairo_destroy_func_t)s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_get_dash_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_dash_count "int cairo_get_dash_count(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_dash_count", 1, cr, "cairo_t*");
  return(s7_make_integer(sc, cairo_get_dash_count((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_get_dash(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_dash "void cairo_get_dash(cairo_t* cr, double* [dashes], double* [offset])"
  s7_pointer _p;
  s7_pointer cr;
  double ref_dashes;
  double ref_offset;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_dash", 1, cr, "cairo_t*");
  cairo_get_dash((cairo_t*)s7_c_pointer(cr), &ref_dashes, &ref_offset);
    return(s7_list(sc, 2, s7_make_real(sc, ref_dashes), s7_make_real(sc, ref_offset)));
}

static s7_pointer lg_cairo_surface_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_reference_count "guint cairo_surface_get_reference_count(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_reference_count", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_get_reference_count((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_pattern_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_reference_count "guint cairo_pattern_get_reference_count(cairo_pattern_t* pattern)"
  s7_pointer pattern;
  pattern = s7_car(args);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_reference_count", 1, pattern, "cairo_pattern_t*");
  return(s7_make_integer(sc, cairo_pattern_get_reference_count((cairo_pattern_t*)s7_c_pointer(pattern))));
}

static s7_pointer lg_cairo_pattern_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_user_data "void* cairo_pattern_get_user_data(cairo_pattern_t* pattern, \
cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer pattern, key;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_user_data", 1, pattern, "cairo_pattern_t*");
  key = s7_car(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(lg_make_c_pointer_with_type(sc, void__sym, cairo_pattern_get_user_data((cairo_pattern_t*)s7_c_pointer(pattern), (cairo_user_data_key_t*)s7_c_pointer(key))));
}

static s7_pointer lg_cairo_pattern_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_set_user_data "cairo_status_t cairo_pattern_set_user_data(cairo_pattern_t* pattern, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer pattern, key, user_data, destroy;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 1, pattern, "cairo_pattern_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_pattern_set_user_data((cairo_pattern_t*)s7_c_pointer(pattern), (cairo_user_data_key_t*)s7_c_pointer(key), (void*)s7_c_pointer(user_data), (cairo_destroy_func_t)s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_pattern_get_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_rgba "cairo_status_t cairo_pattern_get_rgba(cairo_pattern_t* pattern, double* [red], \
double* [green], double* [blue], double* [alpha])"
  s7_pointer _p;
  s7_pointer pattern;
  double ref_red;
  double ref_green;
  double ref_blue;
  double ref_alpha;
  _p = args;
  pattern = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_rgba", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, cairo_pattern_get_rgba((cairo_pattern_t*)s7_c_pointer(pattern), &ref_red, &ref_green, &ref_blue, &ref_alpha));
      return(s7_list(sc, 5, res_ult, s7_make_real(sc, ref_red), s7_make_real(sc, ref_green), s7_make_real(sc, ref_blue), s7_make_real(sc, ref_alpha)));
   }
}

static s7_pointer lg_cairo_pattern_get_surface(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_surface "cairo_status_t cairo_pattern_get_surface(cairo_pattern_t* pattern, \
cairo_surface_t** [surface])"
  s7_pointer _p;
  s7_pointer pattern;
  cairo_surface_t* ref_surface = NULL;
  _p = args;
  pattern = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_surface", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, cairo_pattern_get_surface((cairo_pattern_t*)s7_c_pointer(pattern), &ref_surface));
      return(s7_list(sc, 2, res_ult, s7_make_c_pointer(sc, ref_surface)));
   }
}

static s7_pointer lg_cairo_pattern_get_color_stop_rgba(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_color_stop_rgba "cairo_status_t cairo_pattern_get_color_stop_rgba(cairo_pattern_t* pattern, \
int index, double* [offset], double* [red], double* [green], double* [blue], double* [alpha])"
  s7_pointer _p;
  s7_pointer pattern, index;
  double ref_offset;
  double ref_red;
  double ref_green;
  double ref_blue;
  double ref_alpha;
  _p = args;
  pattern = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_color_stop_rgba", 1, pattern, "cairo_pattern_t*");
  index = s7_car(_p);
  if (!s7_is_integer(index)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_color_stop_rgba", 2, index, "int");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, cairo_pattern_get_color_stop_rgba((cairo_pattern_t*)s7_c_pointer(pattern), (int)s7_integer(index), &ref_offset, &ref_red, &ref_green, &ref_blue, &ref_alpha));
      return(s7_list(sc, 6, res_ult, s7_make_real(sc, ref_offset), s7_make_real(sc, ref_red), s7_make_real(sc, ref_green), s7_make_real(sc, ref_blue), s7_make_real(sc, ref_alpha)));
   }
}

static s7_pointer lg_cairo_pattern_get_color_stop_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_color_stop_count "cairo_status_t cairo_pattern_get_color_stop_count(cairo_pattern_t* pattern, \
int* [count])"
  s7_pointer _p;
  s7_pointer pattern;
  int ref_count;
  _p = args;
  pattern = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_color_stop_count", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, cairo_pattern_get_color_stop_count((cairo_pattern_t*)s7_c_pointer(pattern), &ref_count));
      return(s7_list(sc, 2, res_ult, s7_make_integer(sc, ref_count)));
   }
}

static s7_pointer lg_cairo_pattern_get_linear_points(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_linear_points "cairo_status_t cairo_pattern_get_linear_points(cairo_pattern_t* pattern, \
double* [x0], double* [y0], double* [x1], double* [y1])"
  s7_pointer _p;
  s7_pointer pattern;
  double ref_x0;
  double ref_y0;
  double ref_x1;
  double ref_y1;
  _p = args;
  pattern = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_linear_points", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, cairo_pattern_get_linear_points((cairo_pattern_t*)s7_c_pointer(pattern), &ref_x0, &ref_y0, &ref_x1, &ref_y1));
      return(s7_list(sc, 5, res_ult, s7_make_real(sc, ref_x0), s7_make_real(sc, ref_y0), s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1)));
   }
}

static s7_pointer lg_cairo_pattern_get_radial_circles(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_pattern_get_radial_circles "cairo_status_t cairo_pattern_get_radial_circles(cairo_pattern_t* pattern, \
double* [x0], double* [y0], double* [r0], double* [x1], double* [y1], double* [r1])"
  s7_pointer _p;
  s7_pointer pattern;
  double ref_x0;
  double ref_y0;
  double ref_r0;
  double ref_x1;
  double ref_y1;
  double ref_r1;
  _p = args;
  pattern = s7_car(_p);
  if (!s7_is_c_pointer_of_type(pattern, cairo_pattern_t__sym)) s7_wrong_type_arg_error(sc, "cairo_pattern_get_radial_circles", 1, pattern, "cairo_pattern_t*");
  {
    s7_pointer res_ult;
    res_ult = s7_make_integer(sc, cairo_pattern_get_radial_circles((cairo_pattern_t*)s7_c_pointer(pattern), &ref_x0, &ref_y0, &ref_r0, &ref_x1, &ref_y1, &ref_r1));
      return(s7_list(sc, 7, res_ult, s7_make_real(sc, ref_x0), s7_make_real(sc, ref_y0), s7_make_real(sc, ref_r0), s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1), s7_make_real(sc, ref_r1)));
   }
}

static s7_pointer lg_cairo_get_scaled_font(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_get_scaled_font "cairo_scaled_font_t* cairo_get_scaled_font(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_get_scaled_font", 1, cr, "cairo_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_scaled_font_t__sym, cairo_get_scaled_font((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_path_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_path_extents "void cairo_path_extents(cairo_t* cr, double* [x1], double* [y1], double* [x2], \
double* [y2])"
  s7_pointer _p;
  s7_pointer cr;
  double ref_x1;
  double ref_y1;
  double ref_x2;
  double ref_y2;
  _p = args;
  cr = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_path_extents", 1, cr, "cairo_t*");
  cairo_path_extents((cairo_t*)s7_c_pointer(cr), &ref_x1, &ref_y1, &ref_x2, &ref_y2);
    return(s7_list(sc, 4, s7_make_real(sc, ref_x1), s7_make_real(sc, ref_y1), s7_make_real(sc, ref_x2), s7_make_real(sc, ref_y2)));
}

static s7_pointer lg_cairo_has_current_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_has_current_point "bool cairo_has_current_point(cairo_t* cr)"
  s7_pointer cr;
  cr = s7_car(args);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_has_current_point", 1, cr, "cairo_t*");
  return(s7_make_boolean(sc, cairo_has_current_point((cairo_t*)s7_c_pointer(cr))));
}

static s7_pointer lg_cairo_surface_copy_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_copy_page "void cairo_surface_copy_page(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_copy_page", 1, surface, "cairo_surface_t*");
  cairo_surface_copy_page((cairo_surface_t*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_surface_show_page(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_show_page "void cairo_surface_show_page(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_show_page", 1, surface, "cairo_surface_t*");
  cairo_surface_show_page((cairo_surface_t*)s7_c_pointer(surface));
  return(lg_false);
}

static s7_pointer lg_cairo_format_stride_for_width(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_format_stride_for_width "int cairo_format_stride_for_width(cairo_format_t format, int width)"
  s7_pointer _p;
  s7_pointer format, width;
  _p = args;
  format = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(format)) s7_wrong_type_arg_error(sc, "cairo_format_stride_for_width", 1, format, "cairo_format_t");
  width = s7_car(_p);
  if (!s7_is_integer(width)) s7_wrong_type_arg_error(sc, "cairo_format_stride_for_width", 2, width, "int");
  return(s7_make_integer(sc, cairo_format_stride_for_width((cairo_format_t)s7_integer(format), (int)s7_integer(width))));
}

static s7_pointer lg_cairo_glyph_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_allocate "cairo_glyph_t* cairo_glyph_allocate(int num_glyphs)"
  s7_pointer num_glyphs;
  num_glyphs = s7_car(args);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_glyph_allocate", 1, num_glyphs, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_glyph_t__sym, cairo_glyph_allocate((int)s7_integer(num_glyphs))));
}

static s7_pointer lg_cairo_glyph_free(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_glyph_free "void cairo_glyph_free(cairo_glyph_t* glyphs)"
  s7_pointer glyphs;
  glyphs = s7_car(args);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_glyph_free", 1, glyphs, "cairo_glyph_t*");
  cairo_glyph_free((cairo_glyph_t*)s7_c_pointer(glyphs));
  return(lg_false);
}

static s7_pointer lg_cairo_text_cluster_allocate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_cluster_allocate "cairo_text_cluster_t* cairo_text_cluster_allocate(int num_clusters)"
  s7_pointer num_clusters;
  num_clusters = s7_car(args);
  if (!s7_is_integer(num_clusters)) s7_wrong_type_arg_error(sc, "cairo_text_cluster_allocate", 1, num_clusters, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_text_cluster_t__sym, cairo_text_cluster_allocate((int)s7_integer(num_clusters))));
}

static s7_pointer lg_cairo_text_cluster_free(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_text_cluster_free "void cairo_text_cluster_free(cairo_text_cluster_t* clusters)"
  s7_pointer clusters;
  clusters = s7_car(args);
  if (!s7_is_c_pointer_of_type(clusters, cairo_text_cluster_t__sym)) s7_wrong_type_arg_error(sc, "cairo_text_cluster_free", 1, clusters, "cairo_text_cluster_t*");
  cairo_text_cluster_free((cairo_text_cluster_t*)s7_c_pointer(clusters));
  return(lg_false);
}

static s7_pointer lg_cairo_show_text_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_show_text_glyphs "void cairo_show_text_glyphs(cairo_t* cr, char* utf8, int utf8_len, \
cairo_glyph_t* glyphs, int num_glyphs, cairo_text_cluster_t* clusters, int num_clusters, cairo_text_cluster_flags_t cluster_flags)"
  s7_pointer _p;
  s7_pointer cr, utf8, utf8_len, glyphs, num_glyphs, clusters, num_clusters, cluster_flags;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 1, cr, "cairo_t*");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 2, utf8, "char*");
  utf8_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(utf8_len)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 3, utf8_len, "int");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 4, glyphs, "cairo_glyph_t*");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_glyphs)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 5, num_glyphs, "int");
  clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clusters, cairo_text_cluster_t__sym)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 6, clusters, "cairo_text_cluster_t*");
  num_clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(num_clusters)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 7, num_clusters, "int");
  cluster_flags = s7_car(_p);
  if (!s7_is_integer(cluster_flags)) s7_wrong_type_arg_error(sc, "cairo_show_text_glyphs", 8, cluster_flags, "cairo_text_cluster_flags_t");
  cairo_show_text_glyphs((cairo_t*)s7_c_pointer(cr), (const char*)(char*)s7_string(utf8), (int)s7_integer(utf8_len), (cairo_glyph_t*)s7_c_pointer(glyphs), (int)s7_integer(num_glyphs), (cairo_text_cluster_t*)s7_c_pointer(clusters), (int)s7_integer(num_clusters), (cairo_text_cluster_flags_t)s7_integer(cluster_flags));
  return(lg_false);
}

static s7_pointer lg_cairo_scaled_font_text_to_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_text_to_glyphs "cairo_status_t cairo_scaled_font_text_to_glyphs(cairo_scaled_font_t* scaled_font, \
double x, double y, char* utf8, int utf8_len, cairo_glyph_t** glyphs, int* num_glyphs, cairo_text_cluster_t** clusters, \
int* num_clusters, cairo_text_cluster_flags_t* cluster_flags)"
  s7_pointer _p;
  s7_pointer scaled_font, x, y, utf8, utf8_len, glyphs, num_glyphs, clusters, num_clusters, cluster_flags;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 1, scaled_font, "cairo_scaled_font_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 3, y, "double");
  utf8 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(utf8)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 4, utf8, "char*");
  utf8_len = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(utf8_len)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 5, utf8_len, "int");
  glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(glyphs, cairo_glyph_t___sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 6, glyphs, "cairo_glyph_t**");
  num_glyphs = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(num_glyphs, int__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 7, num_glyphs, "int*");
  clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(clusters, cairo_text_cluster_t___sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 8, clusters, "cairo_text_cluster_t**");
  num_clusters = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(num_clusters, int__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 9, num_clusters, "int*");
  cluster_flags = s7_car(_p);
  if (!s7_is_c_pointer_of_type(cluster_flags, cairo_text_cluster_flags_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_text_to_glyphs", 10, cluster_flags, "cairo_text_cluster_flags_t*");
  return(s7_make_integer(sc, cairo_scaled_font_text_to_glyphs((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (double)s7_real(x), (double)s7_real(y), (const char*)(char*)s7_string(utf8), (int)s7_integer(utf8_len), (cairo_glyph_t**)s7_c_pointer(glyphs), (int*)s7_c_pointer(num_glyphs), (cairo_text_cluster_t**)s7_c_pointer(clusters), (int*)s7_c_pointer(num_clusters), (cairo_text_cluster_flags_t*)s7_c_pointer(cluster_flags))));
}

static s7_pointer lg_cairo_scaled_font_get_scale_matrix(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_scaled_font_get_scale_matrix "void cairo_scaled_font_get_scale_matrix(cairo_scaled_font_t* scaled_font, \
cairo_matrix_t* scale_matrix)"
  s7_pointer _p;
  s7_pointer scaled_font, scale_matrix;
  _p = args;
  scaled_font = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(scaled_font, cairo_scaled_font_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_scale_matrix", 1, scaled_font, "cairo_scaled_font_t*");
  scale_matrix = s7_car(_p);
  if (!s7_is_c_pointer_of_type(scale_matrix, cairo_matrix_t__sym)) s7_wrong_type_arg_error(sc, "cairo_scaled_font_get_scale_matrix", 2, scale_matrix, "cairo_matrix_t*");
  cairo_scaled_font_get_scale_matrix((cairo_scaled_font_t*)s7_c_pointer(scaled_font), (cairo_matrix_t*)s7_c_pointer(scale_matrix));
  return(lg_false);
}

static s7_pointer lg_cairo_toy_font_face_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_create "cairo_font_face_t* cairo_toy_font_face_create(char* family, cairo_font_slant_t slant, \
cairo_font_weight_t weight)"
  s7_pointer _p;
  s7_pointer family, slant, weight;
  _p = args;
  family = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(family)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_create", 1, family, "char*");
  slant = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(slant)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_create", 2, slant, "cairo_font_slant_t");
  weight = s7_car(_p);
  if (!s7_is_integer(weight)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_create", 3, weight, "cairo_font_weight_t");
  return(lg_make_c_pointer_with_type(sc, cairo_font_face_t__sym, cairo_toy_font_face_create((const char*)(char*)s7_string(family), (cairo_font_slant_t)s7_integer(slant), (cairo_font_weight_t)s7_integer(weight))));
}

static s7_pointer lg_cairo_toy_font_face_get_family(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_get_family "char* cairo_toy_font_face_get_family(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_get_family", 1, font_face, "cairo_font_face_t*");
  return(s7_make_string(sc, cairo_toy_font_face_get_family((cairo_font_face_t*)s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_toy_font_face_get_slant(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_get_slant "cairo_font_slant_t cairo_toy_font_face_get_slant(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_get_slant", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_toy_font_face_get_slant((cairo_font_face_t*)s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_toy_font_face_get_weight(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_toy_font_face_get_weight "cairo_font_weight_t cairo_toy_font_face_get_weight(cairo_font_face_t* font_face)"
  s7_pointer font_face;
  font_face = s7_car(args);
  if (!s7_is_c_pointer_of_type(font_face, cairo_font_face_t__sym)) s7_wrong_type_arg_error(sc, "cairo_toy_font_face_get_weight", 1, font_face, "cairo_font_face_t*");
  return(s7_make_integer(sc, cairo_toy_font_face_get_weight((cairo_font_face_t*)s7_c_pointer(font_face))));
}

static s7_pointer lg_cairo_user_font_face_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_user_font_face_create "cairo_font_face_t* cairo_user_font_face_create( void)"
  return(lg_make_c_pointer_with_type(sc, cairo_font_face_t__sym, cairo_user_font_face_create()));
}

static s7_pointer lg_cairo_surface_get_fallback_resolution(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_fallback_resolution "void cairo_surface_get_fallback_resolution(cairo_surface_t* surface, \
double* [x_pixels_per_inch], double* [y_pixels_per_inch])"
  s7_pointer _p;
  s7_pointer surface;
  double ref_x_pixels_per_inch;
  double ref_y_pixels_per_inch;
  _p = args;
  surface = s7_car(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_fallback_resolution", 1, surface, "cairo_surface_t*");
  cairo_surface_get_fallback_resolution((cairo_surface_t*)s7_c_pointer(surface), &ref_x_pixels_per_inch, &ref_y_pixels_per_inch);
    return(s7_list(sc, 2, s7_make_real(sc, ref_x_pixels_per_inch), s7_make_real(sc, ref_y_pixels_per_inch)));
}

static s7_pointer lg_cairo_surface_has_show_text_glyphs(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_has_show_text_glyphs "cairo_bool_t cairo_surface_has_show_text_glyphs(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_has_show_text_glyphs", 1, surface, "cairo_surface_t*");
  return(s7_make_integer(sc, cairo_surface_has_show_text_glyphs((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_in_clip(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_in_clip "cairo_bool_t cairo_in_clip(cairo_t* cr, double x, double y)"
  s7_pointer _p;
  s7_pointer cr, x, y;
  _p = args;
  cr = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(cr, cairo_t__sym)) s7_wrong_type_arg_error(sc, "cairo_in_clip", 1, cr, "cairo_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_in_clip", 2, x, "double");
  y = s7_car(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_in_clip", 3, y, "double");
  return(s7_make_integer(sc, cairo_in_clip((cairo_t*)s7_c_pointer(cr), (double)s7_real(x), (double)s7_real(y))));
}

static s7_pointer lg_cairo_device_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_reference "cairo_device_t* cairo_device_reference(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_reference", 1, device, "cairo_device_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_device_t__sym, cairo_device_reference((cairo_device_t*)s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_status "cairo_status_t cairo_device_status(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_status", 1, device, "cairo_device_t*");
  return(s7_make_integer(sc, cairo_device_status((cairo_device_t*)s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_acquire(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_acquire "cairo_status_t cairo_device_acquire(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_acquire", 1, device, "cairo_device_t*");
  return(s7_make_integer(sc, cairo_device_acquire((cairo_device_t*)s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_release(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_release "void cairo_device_release(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_release", 1, device, "cairo_device_t*");
  cairo_device_release((cairo_device_t*)s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_flush(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_flush "void cairo_device_flush(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_flush", 1, device, "cairo_device_t*");
  cairo_device_flush((cairo_device_t*)s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_finish(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_finish "void cairo_device_finish(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_finish", 1, device, "cairo_device_t*");
  cairo_device_finish((cairo_device_t*)s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_destroy "void cairo_device_destroy(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_destroy", 1, device, "cairo_device_t*");
  cairo_device_destroy((cairo_device_t*)s7_c_pointer(device));
  return(lg_false);
}

static s7_pointer lg_cairo_device_get_reference_count(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_get_reference_count "guint cairo_device_get_reference_count(cairo_device_t* device)"
  s7_pointer device;
  device = s7_car(args);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_get_reference_count", 1, device, "cairo_device_t*");
  return(s7_make_integer(sc, cairo_device_get_reference_count((cairo_device_t*)s7_c_pointer(device))));
}

static s7_pointer lg_cairo_device_get_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_get_user_data "void* cairo_device_get_user_data(cairo_device_t* device, cairo_user_data_key_t* key)"
  s7_pointer _p;
  s7_pointer device, key;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_get_user_data", 1, device, "cairo_device_t*");
  key = s7_car(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_get_user_data", 2, key, "cairo_user_data_key_t*");
  return(lg_make_c_pointer_with_type(sc, void__sym, cairo_device_get_user_data((cairo_device_t*)s7_c_pointer(device), (cairo_user_data_key_t*)s7_c_pointer(key))));
}

static s7_pointer lg_cairo_device_set_user_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_device_set_user_data "cairo_status_t cairo_device_set_user_data(cairo_device_t* device, \
cairo_user_data_key_t* key, void* user_data, cairo_destroy_func_t destroy)"
  s7_pointer _p;
  s7_pointer device, key, user_data, destroy;
  _p = args;
  device = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(device, cairo_device_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 1, device, "cairo_device_t*");
  key = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(key, cairo_user_data_key_t__sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 2, key, "cairo_user_data_key_t*");
  user_data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(user_data, void__sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 3, user_data, "void*");
  destroy = s7_car(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_device_set_user_data", 4, destroy, "cairo_destroy_func_t");
  return(s7_make_integer(sc, cairo_device_set_user_data((cairo_device_t*)s7_c_pointer(device), (cairo_user_data_key_t*)s7_c_pointer(key), (void*)s7_c_pointer(user_data), (cairo_destroy_func_t)s7_c_pointer(destroy))));
}

static s7_pointer lg_cairo_surface_create_for_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_create_for_rectangle "cairo_surface_t* cairo_surface_create_for_rectangle(cairo_surface_t* target, \
double x, double y, double width, double height)"
  s7_pointer _p;
  s7_pointer target, x, y, width, height;
  _p = args;
  target = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(target, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 1, target, "cairo_surface_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(x)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 2, x, "double");
  y = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(y)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 3, y, "double");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_real(width)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 4, width, "double");
  height = s7_car(_p);
  if (!s7_is_real(height)) s7_wrong_type_arg_error(sc, "cairo_surface_create_for_rectangle", 5, height, "double");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_surface_create_for_rectangle((cairo_surface_t*)s7_c_pointer(target), (double)s7_real(x), (double)s7_real(y), (double)s7_real(width), (double)s7_real(height))));
}

static s7_pointer lg_cairo_surface_get_device(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_get_device "cairo_device_t* cairo_surface_get_device(cairo_surface_t* surface)"
  s7_pointer surface;
  surface = s7_car(args);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_get_device", 1, surface, "cairo_surface_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_device_t__sym, cairo_surface_get_device((cairo_surface_t*)s7_c_pointer(surface))));
}

static s7_pointer lg_cairo_surface_set_mime_data(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_set_mime_data "cairo_status_t cairo_surface_set_mime_data(cairo_surface_t* surface, \
char* mime_type, guchar* data, gulong length, cairo_destroy_func_t destroy, void* closure)"
  s7_pointer _p;
  s7_pointer surface, mime_type, data, length, destroy, closure;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 1, surface, "cairo_surface_t*");
  mime_type = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_string(mime_type)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 2, mime_type, "char*");
  data = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(data, guchar__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 3, data, "guchar*");
  length = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(length)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 4, length, "gulong");
  destroy = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(destroy, cairo_destroy_func_t_sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 5, destroy, "cairo_destroy_func_t");
  closure = s7_car(_p);
  if (!s7_is_c_pointer_of_type(closure, void__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_set_mime_data", 6, closure, "void*");
  return(s7_make_integer(sc, cairo_surface_set_mime_data((cairo_surface_t*)s7_c_pointer(surface), (const char*)(char*)s7_string(mime_type), (guchar*)s7_c_pointer(data), (gulong)s7_integer(length), (cairo_destroy_func_t)s7_c_pointer(destroy), (void*)s7_c_pointer(closure))));
}

static s7_pointer lg_cairo_recording_surface_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_recording_surface_create "cairo_surface_t* cairo_recording_surface_create(cairo_content_t content, \
cairo_rectangle_t* extents)"
  s7_pointer _p;
  s7_pointer content, extents;
  _p = args;
  content = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(content)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_create", 1, content, "cairo_content_t");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_rectangle_t__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_create", 2, extents, "cairo_rectangle_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_recording_surface_create((cairo_content_t)s7_integer(content), (cairo_rectangle_t*)s7_c_pointer(extents))));
}

static s7_pointer lg_cairo_recording_surface_ink_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_recording_surface_ink_extents "void cairo_recording_surface_ink_extents(cairo_surface_t* surface, \
double* x0, double* y0, double* width, double* height)"
  s7_pointer _p;
  s7_pointer surface, x0, y0, width, height;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 1, surface, "cairo_surface_t*");
  x0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(x0, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 2, x0, "double*");
  y0 = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(y0, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 3, y0, "double*");
  width = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(width, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 4, width, "double*");
  height = s7_car(_p);
  if (!s7_is_c_pointer_of_type(height, double__sym)) s7_wrong_type_arg_error(sc, "cairo_recording_surface_ink_extents", 5, height, "double*");
  cairo_recording_surface_ink_extents((cairo_surface_t*)s7_c_pointer(surface), (double*)s7_c_pointer(x0), (double*)s7_c_pointer(y0), (double*)s7_c_pointer(width), (double*)s7_c_pointer(height));
  return(lg_false);
}

static s7_pointer lg_cairo_region_create(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_create "cairo_region_t* cairo_region_create( void)"
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, cairo_region_create()));
}

static s7_pointer lg_cairo_region_create_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_create_rectangle "cairo_region_t* cairo_region_create_rectangle(cairo_rectangle_int_t* rectangle)"
  s7_pointer rectangle;
  rectangle = s7_car(args);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_create_rectangle", 1, rectangle, "cairo_rectangle_int_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, cairo_region_create_rectangle((cairo_rectangle_int_t*)s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_create_rectangles(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_create_rectangles "cairo_region_t* cairo_region_create_rectangles(cairo_rectangle_int_t* rects, \
int count)"
  s7_pointer _p;
  s7_pointer rects, count;
  _p = args;
  rects = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(rects, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_create_rectangles", 1, rects, "cairo_rectangle_int_t*");
  count = s7_car(_p);
  if (!s7_is_integer(count)) s7_wrong_type_arg_error(sc, "cairo_region_create_rectangles", 2, count, "int");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, cairo_region_create_rectangles((cairo_rectangle_int_t*)s7_c_pointer(rects), (int)s7_integer(count))));
}

static s7_pointer lg_cairo_region_copy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_copy "cairo_region_t* cairo_region_copy(cairo_region_t* original)"
  s7_pointer original;
  original = s7_car(args);
  if (!s7_is_c_pointer_of_type(original, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_copy", 1, original, "cairo_region_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, cairo_region_copy((cairo_region_t*)s7_c_pointer(original))));
}

static s7_pointer lg_cairo_region_reference(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_reference "cairo_region_t* cairo_region_reference(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_reference", 1, region, "cairo_region_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_region_t__sym, cairo_region_reference((cairo_region_t*)s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_destroy(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_destroy "void cairo_region_destroy(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_destroy", 1, region, "cairo_region_t*");
  cairo_region_destroy((cairo_region_t*)s7_c_pointer(region));
  return(lg_false);
}

static s7_pointer lg_cairo_region_equal(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_equal "cairo_bool_t cairo_region_equal(cairo_region_t* a, cairo_region_t* b)"
  s7_pointer _p;
  s7_pointer a, b;
  _p = args;
  a = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(a, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_equal", 1, a, "cairo_region_t*");
  b = s7_car(_p);
  if (!s7_is_c_pointer_of_type(b, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_equal", 2, b, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_equal((cairo_region_t*)s7_c_pointer(a), (cairo_region_t*)s7_c_pointer(b))));
}

static s7_pointer lg_cairo_region_status(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_status "cairo_status_t cairo_region_status(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_status", 1, region, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_status((cairo_region_t*)s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_get_extents(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_get_extents "void cairo_region_get_extents(cairo_region_t* region, cairo_rectangle_int_t* extents)"
  s7_pointer _p;
  s7_pointer region, extents;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_extents", 1, region, "cairo_region_t*");
  extents = s7_car(_p);
  if (!s7_is_c_pointer_of_type(extents, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_extents", 2, extents, "cairo_rectangle_int_t*");
  cairo_region_get_extents((cairo_region_t*)s7_c_pointer(region), (cairo_rectangle_int_t*)s7_c_pointer(extents));
  return(lg_false);
}

static s7_pointer lg_cairo_region_num_rectangles(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_num_rectangles "int cairo_region_num_rectangles(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_num_rectangles", 1, region, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_num_rectangles((cairo_region_t*)s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_get_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_get_rectangle "void cairo_region_get_rectangle(cairo_region_t* region, int nth, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer region, nth, rectangle;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_rectangle", 1, region, "cairo_region_t*");
  nth = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(nth)) s7_wrong_type_arg_error(sc, "cairo_region_get_rectangle", 2, nth, "int");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_get_rectangle", 3, rectangle, "cairo_rectangle_int_t*");
  cairo_region_get_rectangle((cairo_region_t*)s7_c_pointer(region), (int)s7_integer(nth), (cairo_rectangle_int_t*)s7_c_pointer(rectangle));
  return(lg_false);
}

static s7_pointer lg_cairo_region_is_empty(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_is_empty "cairo_bool_t cairo_region_is_empty(cairo_region_t* region)"
  s7_pointer region;
  region = s7_car(args);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_is_empty", 1, region, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_is_empty((cairo_region_t*)s7_c_pointer(region))));
}

static s7_pointer lg_cairo_region_contains_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_contains_rectangle "cairo_region_overlap_t cairo_region_contains_rectangle(cairo_region_t* region, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer region, rectangle;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_contains_rectangle", 1, region, "cairo_region_t*");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_contains_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(lg_make_c_pointer_with_type(sc, cairo_region_overlap_t_sym, cairo_region_contains_rectangle((cairo_region_t*)s7_c_pointer(region), (cairo_rectangle_int_t*)s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_contains_point(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_contains_point "cairo_bool_t cairo_region_contains_point(cairo_region_t* region, \
int x, int y)"
  s7_pointer _p;
  s7_pointer region, x, y;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_contains_point", 1, region, "cairo_region_t*");
  x = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "cairo_region_contains_point", 2, x, "int");
  y = s7_car(_p);
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "cairo_region_contains_point", 3, y, "int");
  return(s7_make_integer(sc, cairo_region_contains_point((cairo_region_t*)s7_c_pointer(region), (int)s7_integer(x), (int)s7_integer(y))));
}

static s7_pointer lg_cairo_region_translate(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_translate "void cairo_region_translate(cairo_region_t* region, int dx, int dy)"
  s7_pointer _p;
  s7_pointer region, dx, dy;
  _p = args;
  region = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(region, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_translate", 1, region, "cairo_region_t*");
  dx = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_integer(dx)) s7_wrong_type_arg_error(sc, "cairo_region_translate", 2, dx, "int");
  dy = s7_car(_p);
  if (!s7_is_integer(dy)) s7_wrong_type_arg_error(sc, "cairo_region_translate", 3, dy, "int");
  cairo_region_translate((cairo_region_t*)s7_c_pointer(region), (int)s7_integer(dx), (int)s7_integer(dy));
  return(lg_false);
}

static s7_pointer lg_cairo_region_subtract(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_subtract "cairo_status_t cairo_region_subtract(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract", 1, dst, "cairo_region_t*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_subtract((cairo_region_t*)s7_c_pointer(dst), (cairo_region_t*)s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_subtract_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_subtract_rectangle "cairo_status_t cairo_region_subtract_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_subtract_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_subtract_rectangle((cairo_region_t*)s7_c_pointer(dst), (cairo_rectangle_int_t*)s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_intersect(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_intersect "cairo_status_t cairo_region_intersect(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect", 1, dst, "cairo_region_t*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_intersect((cairo_region_t*)s7_c_pointer(dst), (cairo_region_t*)s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_intersect_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_intersect_rectangle "cairo_status_t cairo_region_intersect_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_intersect_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_intersect_rectangle((cairo_region_t*)s7_c_pointer(dst), (cairo_rectangle_int_t*)s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_union(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_union "cairo_status_t cairo_region_union(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union", 1, dst, "cairo_region_t*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_union((cairo_region_t*)s7_c_pointer(dst), (cairo_region_t*)s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_union_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_union_rectangle "cairo_status_t cairo_region_union_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_union_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_union_rectangle((cairo_region_t*)s7_c_pointer(dst), (cairo_rectangle_int_t*)s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_region_xor(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_xor "cairo_status_t cairo_region_xor(cairo_region_t* dst, cairo_region_t* other)"
  s7_pointer _p;
  s7_pointer dst, other;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor", 1, dst, "cairo_region_t*");
  other = s7_car(_p);
  if (!s7_is_c_pointer_of_type(other, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor", 2, other, "cairo_region_t*");
  return(s7_make_integer(sc, cairo_region_xor((cairo_region_t*)s7_c_pointer(dst), (cairo_region_t*)s7_c_pointer(other))));
}

static s7_pointer lg_cairo_region_xor_rectangle(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_region_xor_rectangle "cairo_status_t cairo_region_xor_rectangle(cairo_region_t* dst, \
cairo_rectangle_int_t* rectangle)"
  s7_pointer _p;
  s7_pointer dst, rectangle;
  _p = args;
  dst = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(dst, cairo_region_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor_rectangle", 1, dst, "cairo_region_t*");
  rectangle = s7_car(_p);
  if (!s7_is_c_pointer_of_type(rectangle, cairo_rectangle_int_t__sym)) s7_wrong_type_arg_error(sc, "cairo_region_xor_rectangle", 2, rectangle, "cairo_rectangle_int_t*");
  return(s7_make_integer(sc, cairo_region_xor_rectangle((cairo_region_t*)s7_c_pointer(dst), (cairo_rectangle_int_t*)s7_c_pointer(rectangle))));
}

static s7_pointer lg_cairo_image_surface_create_from_png(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_image_surface_create_from_png "cairo_surface_t* cairo_image_surface_create_from_png(char* filename)"
  s7_pointer filename;
  filename = s7_car(args);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "cairo_image_surface_create_from_png", 1, filename, "char*");
  return(lg_make_c_pointer_with_type(sc, cairo_surface_t__sym, cairo_image_surface_create_from_png((const char*)(char*)s7_string(filename))));
}

static s7_pointer lg_cairo_surface_write_to_png(s7_scheme *sc, s7_pointer args)
{
  #define H_cairo_surface_write_to_png "cairo_status_t cairo_surface_write_to_png(cairo_surface_t* surface, \
char* filename)"
  s7_pointer _p;
  s7_pointer surface, filename;
  _p = args;
  surface = s7_car(_p); _p = s7_cdr(_p);
  if (!s7_is_c_pointer_of_type(surface, cairo_surface_t__sym)) s7_wrong_type_arg_error(sc, "cairo_surface_write_to_png", 1, surface, "cairo_surface_t*");
  filename = s7_car(_p);
  if (!s7_is_string(filename)) s7_wrong_type_arg_error(sc, "cairo_surface_write_to_png", 2, filename, "char*");
  return(s7_make_integer(sc, cairo_surface_write_to_png((cairo_surface_t*)s7_c_pointer(surface), (const char*)(char*)s7_string(filename))));
}

static s7_pointer lg_g_signal_connect(s7_scheme *sc, s7_pointer args)
{
  #define H_g_signal_connect "gulong g_signal_connect(gpointer instance, gchar* signal_name, GCallback func, lambda_data func_info)"
  s7_pointer obj, name, func, data;
  GCallback callf;
  obj = s7_car(args);
  name = s7_cadr(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_signal_connect", 2, name, "gchar*");
  func = s7_caddr(args);
  if (s7_is_aritable(sc, func, 4)) callf = (GCallback)lg_func4;
  else {if (s7_is_aritable(sc, func, 3)) callf = (GCallback)lg_func3; else callf = (GCallback)lg_func2;}
  if (s7_is_pair(s7_cdddr(args))) data = s7_cadddr(args); else data = s7_nil(sc);
  if (data == lg_false) data = s7_nil(sc);
  return(s7_make_integer(sc, 
            g_signal_connect_data((gpointer)s7_c_pointer(obj),
                                  (gchar *)s7_string(name),
                                  callf,
                                  (gpointer)s7_cons(sc, func, data), 
                                  NULL, (GConnectFlags)0)));
}
static s7_pointer lg_GPOINTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), gpointer_sym, lg_false));}
static s7_pointer lg_GDK_DEVICE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDevice__sym, lg_false));}
static s7_pointer lg_GDK_KEYMAP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkKeymap__sym, lg_false));}
static s7_pointer lg_GDK_PIXBUF(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkPixbuf__sym, lg_false));}
static s7_pointer lg_GTK_ACCEL_LABEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAccelLabel__sym, lg_false));}
static s7_pointer lg_GTK_ACCESSIBLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAccessible__sym, lg_false));}
static s7_pointer lg_GTK_ADJUSTMENT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAdjustment__sym, lg_false));}
static s7_pointer lg_GTK_ASPECT_FRAME(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAspectFrame__sym, lg_false));}
static s7_pointer lg_GTK_BIN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkBin__sym, lg_false));}
static s7_pointer lg_GTK_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkBox__sym, lg_false));}
static s7_pointer lg_GTK_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkButton__sym, lg_false));}
static s7_pointer lg_GTK_CALENDAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCalendar__sym, lg_false));}
static s7_pointer lg_GTK_CELL_EDITABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellEditable__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRenderer__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_PIXBUF(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererPixbuf__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_TEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererText__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_TOGGLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererToggle__sym, lg_false));}
static s7_pointer lg_GTK_CHECK_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCheckButton__sym, lg_false));}
static s7_pointer lg_GTK_CONTAINER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkContainer__sym, lg_false));}
static s7_pointer lg_GTK_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDialog__sym, lg_false));}
static s7_pointer lg_GTK_DRAWING_AREA(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDrawingArea__sym, lg_false));}
static s7_pointer lg_GTK_EDITABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEditable__sym, lg_false));}
static s7_pointer lg_GTK_ENTRY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEntry__sym, lg_false));}
static s7_pointer lg_GTK_FIXED(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFixed__sym, lg_false));}
static s7_pointer lg_GTK_FRAME(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFrame__sym, lg_false));}
static s7_pointer lg_GTK_IMAGE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkImage__sym, lg_false));}
static s7_pointer lg_GTK_IM_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIMContext__sym, lg_false));}
static s7_pointer lg_GTK_IM_CONTEXT_SIMPLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIMContextSimple__sym, lg_false));}
static s7_pointer lg_GTK_LABEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLabel__sym, lg_false));}
static s7_pointer lg_GTK_LIST_STORE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkListStore__sym, lg_false));}
static s7_pointer lg_GTK_NOTEBOOK(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkNotebook__sym, lg_false));}
static s7_pointer lg_GTK_PANED(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPaned__sym, lg_false));}
static s7_pointer lg_GTK_PROGRESS_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkProgressBar__sym, lg_false));}
static s7_pointer lg_GTK_RADIO_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRadioButton__sym, lg_false));}
static s7_pointer lg_GTK_RANGE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRange__sym, lg_false));}
static s7_pointer lg_GTK_SCALE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScale__sym, lg_false));}
static s7_pointer lg_GTK_SCROLLBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScrollbar__sym, lg_false));}
static s7_pointer lg_GTK_SCROLLED_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScrolledWindow__sym, lg_false));}
static s7_pointer lg_GTK_SEPARATOR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSeparator__sym, lg_false));}
static s7_pointer lg_GTK_SETTINGS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSettings__sym, lg_false));}
static s7_pointer lg_GTK_SIZE_GROUP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSizeGroup__sym, lg_false));}
static s7_pointer lg_GTK_SPIN_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSpinButton__sym, lg_false));}
static s7_pointer lg_GTK_STATUSBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStatusbar__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_BUFFER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextBuffer__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_CHILD_ANCHOR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextChildAnchor__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_MARK(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextMark__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_TAG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextTag__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_TAG_TABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextTagTable__sym, lg_false));}
static s7_pointer lg_GTK_TEXT_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTextView__sym, lg_false));}
static s7_pointer lg_GTK_TOGGLE_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkToggleButton__sym, lg_false));}
static s7_pointer lg_GTK_TREE_DRAG_SOURCE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeDragSource__sym, lg_false));}
static s7_pointer lg_GTK_TREE_MODEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeModel__sym, lg_false));}
static s7_pointer lg_GTK_TREE_MODEL_SORT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeModelSort__sym, lg_false));}
static s7_pointer lg_GTK_TREE_SELECTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeSelection__sym, lg_false));}
static s7_pointer lg_GTK_TREE_SORTABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeSortable__sym, lg_false));}
static s7_pointer lg_GTK_TREE_STORE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeStore__sym, lg_false));}
static s7_pointer lg_GTK_TREE_VIEW_COLUMN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeViewColumn__sym, lg_false));}
static s7_pointer lg_GTK_TREE_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeView__sym, lg_false));}
static s7_pointer lg_GTK_VIEWPORT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkViewport__sym, lg_false));}
static s7_pointer lg_GTK_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWidget__sym, lg_false));}
static s7_pointer lg_GTK_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWindow__sym, lg_false));}
static s7_pointer lg_PANGO_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoContext__sym, lg_false));}
static s7_pointer lg_PANGO_FONT_FAMILY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFontFamily__sym, lg_false));}
static s7_pointer lg_PANGO_FONT_FACE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFontFace__sym, lg_false));}
static s7_pointer lg_PANGO_FONT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFont__sym, lg_false));}
static s7_pointer lg_PANGO_FONT_MAP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoFontMap__sym, lg_false));}
static s7_pointer lg_PANGO_LAYOUT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), PangoLayout__sym, lg_false));}
static s7_pointer lg_G_OBJECT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GObject__sym, lg_false));}
static s7_pointer lg_GDK_DISPLAY_OBJECT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDisplay__sym, lg_false));}
static s7_pointer lg_GDK_EVENT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEvent__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_ANY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventAny__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_EXPOSE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventExpose__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_NOEXPOSE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventNoExpose__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_VISIBILITY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventVisibility__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_MOTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventMotion__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventButton__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_KEY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventKey__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_CROSSING(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventCrossing__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_FOCUS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventFocus__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_CONFIGURE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventConfigure__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_PROPERTY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventProperty__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_SELECTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventSelection__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_PROXIMITY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventProximity__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_SETTING(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventSetting__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_WINDOWSTATE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventWindowState__sym, lg_false));}
static s7_pointer lg_GDK_EVENT_DND(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEventDND__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooserWidget__sym, lg_false));}
static s7_pointer lg_GTK_TREE_MODEL_FILTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTreeModelFilter__sym, lg_false));}
static s7_pointer lg_GTK_COMBO_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkComboBox__sym, lg_false));}
static s7_pointer lg_GTK_EXPANDER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkExpander__sym, lg_false));}
static s7_pointer lg_GTK_FONT_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontButton__sym, lg_false));}
static s7_pointer lg_GTK_COLOR_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkColorButton__sym, lg_false));}
static s7_pointer lg_GTK_ENTRY_COMPLETION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEntryCompletion__sym, lg_false));}
static s7_pointer lg_GTK_FILE_FILTER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileFilter__sym, lg_false));}
static s7_pointer lg_GTK_CELL_LAYOUT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellLayout__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooser__sym, lg_false));}
static s7_pointer lg_GTK_CELL_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellView__sym, lg_false));}
static s7_pointer lg_GTK_ABOUT_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAboutDialog__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_COMBO(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererCombo__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_PROGRESS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererProgress__sym, lg_false));}
static s7_pointer lg_GTK_ICON_VIEW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkIconView__sym, lg_false));}
static s7_pointer lg_GTK_FILE_CHOOSER_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFileChooserButton__sym, lg_false));}
static s7_pointer lg_GTK_ASSISTANT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkAssistant__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_ACCEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererAccel__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_SPIN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererSpin__sym, lg_false));}
static s7_pointer lg_GTK_LINK_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLinkButton__sym, lg_false));}
static s7_pointer lg_GTK_RECENT_MANAGER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRecentManager__sym, lg_false));}
static s7_pointer lg_GTK_PRINT_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPrintContext__sym, lg_false));}
static s7_pointer lg_GTK_PRINT_OPERATION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPrintOperation__sym, lg_false));}
static s7_pointer lg_GTK_PRINT_SETTINGS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPrintSettings__sym, lg_false));}
static s7_pointer lg_GTK_TOOLTIP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkTooltip__sym, lg_false));}
static s7_pointer lg_GTK_INFO_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkInfoBar__sym, lg_false));}
static s7_pointer lg_GTK_ENTRY_BUFFER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEntryBuffer__sym, lg_false));}
static s7_pointer lg_GTK_SPINNER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSpinner__sym, lg_false));}
static s7_pointer lg_GTK_CELL_RENDERER_SPINNER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCellRendererSpinner__sym, lg_false));}
#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_GTK_COMBO_BOX_TEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkComboBoxText__sym, lg_false));}
static s7_pointer lg_GTK_GRID(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGrid__sym, lg_false));}
static s7_pointer lg_GTK_SCROLLABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkScrollable__sym, lg_false));}
static s7_pointer lg_GDK_RGBA(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkRGBA__sym, lg_false));}
static s7_pointer lg_GTK_SWITCH(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSwitch__sym, lg_false));}
static s7_pointer lg_GTK_ORIENTABLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkOrientable__sym, lg_false));}
static s7_pointer lg_GTK_WINDOW_GROUP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWindowGroup__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static s7_pointer lg_GTK_OVERLAY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkOverlay__sym, lg_false));}
static s7_pointer lg_GTK_FONT_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontChooser__sym, lg_false));}
static s7_pointer lg_GTK_FONT_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_FONT_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFontChooserWidget__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static s7_pointer lg_GTK_APPLICATION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkApplication__sym, lg_false));}
static s7_pointer lg_GTK_APPLICATION_WINDOW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkApplicationWindow__sym, lg_false));}
static s7_pointer lg_GTK_COLOR_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkColorChooserDialog__sym, lg_false));}
static s7_pointer lg_GTK_COLOR_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkColorWidget__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static s7_pointer lg_GTK_MENU_BUTTON(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkMenuButton__sym, lg_false));}
static s7_pointer lg_GTK_SEARCH_ENTRY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkWidget__sym, lg_false));}
static s7_pointer lg_GTK_LEVEL_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkLevelBar__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static s7_pointer lg_GTK_STACK_SWITCHER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStackSwitcher__sym, lg_false));}
static s7_pointer lg_GTK_STACK(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStack__sym, lg_false));}
static s7_pointer lg_GTK_REVEALER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkRevealer__sym, lg_false));}
static s7_pointer lg_GTK_HEADER_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkHeaderBar__sym, lg_false));}
static s7_pointer lg_GTK_LIST_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkListBox__sym, lg_false));}
static s7_pointer lg_GTK_LIST_BOX_ROW(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkListBoxRow__sym, lg_false));}
static s7_pointer lg_GTK_SEARCH_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkSearchBar__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static s7_pointer lg_GTK_FLOW_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFlowBox__sym, lg_false));}
static s7_pointer lg_GTK_FLOW_BOX_CHILD(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkFlowBoxChild__sym, lg_false));}
static s7_pointer lg_GTK_ACTION_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkActionBar__sym, lg_false));}
static s7_pointer lg_GTK_POPOVER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPopover__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static s7_pointer lg_GTK_GESTURE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGesture__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_DRAG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureDrag__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_LONG_PRESS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureLongPress__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_ZOOM(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureZoom__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_SWIPE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureSwipe__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_SINGLE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureSingle__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_PAN(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGesturePan__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_ROTATE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureRotate__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static s7_pointer lg_GTK_GL_AREA(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGLArea__sym, lg_false));}
static s7_pointer lg_GDK_GL_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkGLContext__sym, lg_false));}
static s7_pointer lg_GTK_STACK_SIDEBAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStackSidebar__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static s7_pointer lg_GDK_SEAT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkSeat__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static s7_pointer lg_GDK_DEVICE_TOOL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDeviceTool__sym, lg_false));}
static s7_pointer lg_GDK_MONITOR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkMonitor__sym, lg_false));}
static s7_pointer lg_GDK_DEVICE_PAD(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDevicePad__sym, lg_false));}
static s7_pointer lg_GTK_PAD_CONTROLLER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPadController__sym, lg_false));}
static s7_pointer lg_GTK_SHORTCUT_LABEL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkShortcutLabel__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static s7_pointer lg_GTK_CENTER_BOX(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCenterBox__sym, lg_false));}
static s7_pointer lg_GTK_STYLE_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStyleContext__sym, lg_false));}
static s7_pointer lg_GTK_STYLE_PROVIDER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkStyleProvider__sym, lg_false));}
static s7_pointer lg_GTK_CSS_PROVIDER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCssProvider__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
static s7_pointer lg_GTK_EMOJI_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEmojiChooser__sym, lg_false));}
static s7_pointer lg_GTK_EVENT_CONTROLLER_SCROLL(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventControllerScroll__sym, lg_false));}
static s7_pointer lg_GTK_EVENT_CONTROLLER_MOTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventControllerMotion__sym, lg_false));}
static s7_pointer lg_GDK_TEXTURE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkTexture__sym, lg_false));}
static s7_pointer lg_GDK_EVENT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkEvent__sym, lg_false));}
static s7_pointer lg_GDK_APP_LAUNCH_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkAppLaunchContext__sym, lg_false));}
static s7_pointer lg_GDK_CLIPBOARD(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkClipboard__sym, lg_false));}
static s7_pointer lg_GDK_CONTENT_PROVIDER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkContentProvider__sym, lg_false));}
static s7_pointer lg_GDK_CONTENT_SERIALIZER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkContentSerializer__sym, lg_false));}
static s7_pointer lg_GDK_CONTENT_DESERIALIZER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkContentDeserializer__sym, lg_false));}
static s7_pointer lg_GDK_SURFACE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkSurface__sym, lg_false));}
static s7_pointer lg_GTK_GESTURE_STYLUS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkGestureStylus__sym, lg_false));}
static s7_pointer lg_GTK_EVENT_CONTROLLER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventController__sym, lg_false));}
static s7_pointer lg_GDK_CAIRO_CONTEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkCairoContext__sym, lg_false));}
static s7_pointer lg_GDK_DROP(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDrop__sym, lg_false));}
static s7_pointer lg_GDK_GL_TEXTURE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkGLTexture__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
static s7_pointer lg_GTK_NOTEBOOK_PAGE(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkNotebookPage__sym, lg_false));}
static s7_pointer lg_GDK_DRAG(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GdkDrag__sym, lg_false));}
static s7_pointer lg_GTK_EVENT_CONTROLLER_LEGACY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventControllerLegacy__sym, lg_false));}
static s7_pointer lg_GTK_PASSWORD_ENTRY(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPasswordEntry__sym, lg_false));}
static s7_pointer lg_GTK_TEXT(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkText__sym, lg_false));}
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
static s7_pointer lg_GTK_EVENT_CONTROLLER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventController__sym, lg_false));}
static s7_pointer lg_GTK_POPOVER_MENU_BAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPopoverMenuBar__sym, lg_false));}
static s7_pointer lg_GTK_CALENDAR(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkCalendar__sym, lg_false));}
static s7_pointer lg_GTK_EVENT_CONTROLLER_FOCUS(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEventControllerFocus__sym, lg_false));}
static s7_pointer lg_GTK_DROP_CONTROLLER_MOTION(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDropControllerMotion__sym, lg_false));}
static s7_pointer lg_GTK_DROP_TARGET(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDropTarget__sym, lg_false));}
static s7_pointer lg_GTK_EMOJI_CHOOSER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkEmojiChooser__sym, lg_false));}
static s7_pointer lg_GTK_DROP_TARGET_ASYNC(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkDropTargetAsync__sym, lg_false));}
static s7_pointer lg_GTK_POPOVER_MENU(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkPopoverMenu__sym, lg_false));}
static s7_pointer lg_GTK_SHORTCUT_CONTROLLER(s7_scheme *sc, s7_pointer args) {return(s7_make_c_pointer_with_type(sc, s7_c_pointer(s7_car(args)), GtkShortcutController__sym, lg_false));}
#endif

static s7_pointer lg_GDK_IS_DEVICE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DEVICE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_KEYMAP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_KEYMAP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_PIXBUF(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_PIXBUF((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACCEL_LABEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACCEL_LABEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACCESSIBLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACCESSIBLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ADJUSTMENT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ADJUSTMENT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ASPECT_FRAME(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ASPECT_FRAME((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BIN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BIN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CALENDAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CALENDAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_EDITABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_EDITABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_PIXBUF(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_PIXBUF((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_TEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_TEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_TOGGLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_TOGGLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CHECK_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CHECK_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CONTAINER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CONTAINER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DRAWING_AREA(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DRAWING_AREA((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EDITABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EDITABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ENTRY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ENTRY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FIXED(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FIXED((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FRAME(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FRAME((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_IMAGE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_IMAGE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_IM_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_IM_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_IM_CONTEXT_SIMPLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_IM_CONTEXT_SIMPLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LABEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LABEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LIST_STORE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LIST_STORE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_NOTEBOOK(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_NOTEBOOK((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PANED(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PANED((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PROGRESS_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PROGRESS_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RADIO_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RADIO_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RANGE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RANGE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCALE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCALE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCROLLBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCROLLBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCROLLED_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCROLLED_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEPARATOR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEPARATOR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SETTINGS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SETTINGS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SIZE_GROUP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SIZE_GROUP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SPIN_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SPIN_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STATUSBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STATUSBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_BUFFER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_BUFFER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_CHILD_ANCHOR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_CHILD_ANCHOR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_MARK(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_MARK((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_TAG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_TAG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_TAG_TABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_TAG_TABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOGGLE_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOGGLE_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_DRAG_SOURCE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_DRAG_SOURCE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_MODEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_MODEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_MODEL_SORT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_MODEL_SORT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_SELECTION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_SELECTION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_SORTABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_SORTABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_STORE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_STORE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_VIEW_COLUMN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_VIEW_COLUMN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_VIEWPORT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_VIEWPORT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT_FAMILY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT_FAMILY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT_FACE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT_FACE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_FONT_MAP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_FONT_MAP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_PANGO_IS_LAYOUT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (PANGO_IS_LAYOUT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_G_IS_OBJECT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (G_IS_OBJECT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DISPLAY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DISPLAY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TREE_MODEL_FILTER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TREE_MODEL_FILTER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COMBO_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COMBO_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EXPANDER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EXPANDER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COLOR_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COLOR_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ENTRY_COMPLETION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ENTRY_COMPLETION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_FILTER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_FILTER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_LAYOUT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_LAYOUT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ABOUT_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ABOUT_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_COMBO(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_COMBO((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_PROGRESS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_PROGRESS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ICON_VIEW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ICON_VIEW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FILE_CHOOSER_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FILE_CHOOSER_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ASSISTANT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ASSISTANT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_ACCEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_ACCEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_SPIN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_SPIN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LINK_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LINK_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_RECENT_MANAGER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_RECENT_MANAGER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PRINT_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PRINT_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PRINT_OPERATION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PRINT_OPERATION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PRINT_SETTINGS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PRINT_SETTINGS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TOOLTIP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TOOLTIP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_INFO_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_INFO_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ENTRY_BUFFER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ENTRY_BUFFER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SPINNER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SPINNER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CELL_RENDERER_SPINNER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CELL_RENDERER_SPINNER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_GTK_IS_COMBO_BOX_TEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COMBO_BOX_TEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GRID(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GRID((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SCROLLABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SCROLLABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SWITCH(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SWITCH((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ORIENTABLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ORIENTABLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_WINDOW_GROUP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_WINDOW_GROUP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
static s7_pointer lg_GTK_IS_OVERLAY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_OVERLAY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FONT_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FONT_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
static s7_pointer lg_GTK_IS_APPLICATION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_APPLICATION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_APPLICATION_WINDOW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_APPLICATION_WINDOW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COLOR_CHOOSER_DIALOG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COLOR_CHOOSER_DIALOG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_COLOR_CHOOSER_WIDGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_COLOR_CHOOSER_WIDGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
static s7_pointer lg_GTK_IS_MENU_BUTTON(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_MENU_BUTTON((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEARCH_ENTRY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEARCH_ENTRY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LEVEL_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LEVEL_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
static s7_pointer lg_GTK_IS_STACK_SWITCHER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STACK_SWITCHER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STACK(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STACK((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_REVEALER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_REVEALER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_HEADER_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_HEADER_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LIST_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LIST_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_LIST_BOX_ROW(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_LIST_BOX_ROW((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SEARCH_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SEARCH_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
static s7_pointer lg_GTK_IS_FLOW_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FLOW_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_FLOW_BOX_CHILD(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_FLOW_BOX_CHILD((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_ACTION_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_ACTION_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_POPOVER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_POPOVER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
static s7_pointer lg_GTK_IS_GESTURE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_DRAG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_DRAG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_LONG_PRESS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_LONG_PRESS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_ZOOM(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_ZOOM((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_SWIPE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_SWIPE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_SINGLE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_SINGLE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_PAN(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_PAN((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_ROTATE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_ROTATE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
static s7_pointer lg_GTK_IS_GL_AREA(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GL_AREA((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_GL_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_GL_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STACK_SIDEBAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STACK_SIDEBAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
static s7_pointer lg_GDK_IS_SEAT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_SEAT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
static s7_pointer lg_GDK_IS_DEVICE_TOOL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DEVICE_TOOL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_MONITOR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_MONITOR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DEVICE_PAD(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DEVICE_PAD((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PAD_CONTROLLER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PAD_CONTROLLER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SHORTCUT_LABEL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SHORTCUT_LABEL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
static s7_pointer lg_GTK_IS_CENTER_BOX(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CENTER_BOX((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STYLE_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STYLE_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_STYLE_PROVIDER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_STYLE_PROVIDER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CSS_PROVIDER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CSS_PROVIDER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
static s7_pointer lg_GTK_IS_EMOJI_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EMOJI_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER_SCROLL(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER_SCROLL((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER_MOTION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER_MOTION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_TEXTURE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_TEXTURE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_EVENT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_EVENT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_APP_LAUNCH_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_APP_LAUNCH_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_CLIPBOARD(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_CLIPBOARD((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_CONTENT_PROVIDER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_CONTENT_PROVIDER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_CONTENT_SERIALIZER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_CONTENT_SERIALIZER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_CONTENT_DESERIALIZER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_CONTENT_DESERIALIZER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_GESTURE_STYLUS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_GESTURE_STYLUS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_SURFACE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_SURFACE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_CAIRO_CONTEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_CAIRO_CONTEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DROP(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DROP((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_GL_TEXTURE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_GL_TEXTURE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
static s7_pointer lg_GTK_IS_NOTEBOOK_PAGE(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_NOTEBOOK_PAGE((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GDK_IS_DRAG(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GDK_IS_DRAG((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER_LEGACY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER_LEGACY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_PASSWORD_ENTRY(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_PASSWORD_ENTRY((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_TEXT(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_TEXT((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_POPOVER_MENU_BAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_POPOVER_MENU_BAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_CALENDAR(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_CALENDAR((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EVENT_CONTROLLER_FOCUS(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EVENT_CONTROLLER_FOCUS((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DROP_CONTROLLER_MOTION(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DROP_CONTROLLER_MOTION((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DROP_TARGET(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DROP_TARGET((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_EMOJI_CHOOSER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_EMOJI_CHOOSER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_DROP_TARGET_ASYNC(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_DROP_TARGET_ASYNC((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_POPOVER_MENU(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_POPOVER_MENU((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
static s7_pointer lg_GTK_IS_SHORTCUT_CONTROLLER(s7_scheme *sc, s7_pointer args)
{
  return(((s7_is_c_pointer(s7_car(args))) && (GTK_IS_SHORTCUT_CONTROLLER((GTypeInstance *)s7_c_pointer(s7_car(args))))) ? lg_true : lg_false);
}
#endif

#if (!GTK_CHECK_VERSION(3, 90, 0))
static s7_pointer lg_gtk_init(s7_scheme *sc, s7_pointer args)
{ 
  #define H_gtk_init "void gtk_init(int* argc, char*** argv)" 
  int ref_argc = 0; 
  char** ref_argv = NULL; 
  s7_pointer argc = NULL, argv = NULL; 
  if (s7_is_pair(args)) {argc = s7_car(args); ref_argc = s7_integer(argc); if (s7_is_pair(s7_cdr(args))) argv = s7_cadr(args);}
  if ((argv) && (ref_argc > 0) && (s7_is_pair(argv)) && (ref_argc <= s7_list_length(sc, argv))) {
  ref_argv = (char**)calloc(ref_argc, sizeof(char*)); 
  { 
    int i; 
    for (i = 0; i < ref_argc; i++, argv = s7_cdr(argv)) ref_argv[i] = (char *)s7_string(s7_car(argv));}
  }
  gtk_init(&ref_argc, &ref_argv);
  return(argc);
} 

static s7_pointer lg_gtk_init_check(s7_scheme *sc, s7_pointer args)
{ 
  #define H_gtk_init_check "gboolean gtk_init_check(int* argc, char*** argv)" 
  int ref_argc = 0; 
  char** ref_argv = NULL; 
  s7_pointer argc = NULL, argv = NULL;
  if (s7_is_pair(args)) {argc = s7_car(args); ref_argc = s7_integer(argc); if (s7_is_pair(s7_cdr(args))) argv = s7_cadr(args);}
  if ((argv) && (ref_argc > 0) && (s7_is_pair(argv)) && (ref_argc <= s7_list_length(sc, argv))) {
  ref_argv = (char**)calloc(ref_argc, sizeof(char*)); 
  { 
    int i; 
    for (i = 0; i < ref_argc; i++, argv = s7_cdr(argv)) ref_argv[i] = (char *)s7_string(s7_car(argv));}
  }
  gtk_init(&ref_argc, &ref_argv);
  return(argc);
} 

#else
static s7_pointer lg_gtk_init(s7_scheme *sc, s7_pointer args)
{ 
  gtk_init();
  return(lg_false);
}
#endif

static s7_pointer lg_g_object_get(s7_scheme *sc, s7_pointer args)
{
  s7_pointer val, name, string_type;
  gint temp; gchar *str;
  val = s7_car(args);
  if (!s7_is_c_pointer(val)) s7_wrong_type_arg_error(sc, "g_object_get", 1, val, "gpointer");
  name = s7_cadr(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_object_get", 2, name, "string");
  string_type = s7_caddr(args);
  if (string_type == lg_false)
    {g_object_get((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), &temp, NULL); return(s7_make_integer(sc, temp));}
  else {g_object_get((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), &str, NULL); return(s7_make_string(sc, str));}
}

static s7_pointer lg_g_object_set(s7_scheme *sc, s7_pointer args)
{
  s7_pointer val, name, new_val;
  val = s7_car(args);
  if (!s7_is_c_pointer(val)) s7_wrong_type_arg_error(sc, "g_object_set", 1, val, "gpointer");
  name = s7_cadr(args);
  if (!s7_is_string(name)) s7_wrong_type_arg_error(sc, "g_object_set", 2, name, "string");
  new_val = s7_caddr(args);
  if (s7_is_boolean(new_val))
    g_object_set((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), s7_boolean(sc, new_val), NULL);
  else
    {
      if (s7_is_number(new_val))
        g_object_set((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), s7_integer(new_val), NULL);
      else g_object_set((gpointer)s7_c_pointer(val), (const gchar *)s7_string(name), s7_string(new_val), NULL);
    }
  return(new_val);
}

static s7_pointer lg_gtk_event_keyval(s7_scheme *sc, s7_pointer args)
{
#if (GTK_CHECK_VERSION(3, 92, 1))
  GdkEvent *e;
  e = (GdkEvent*)s7_c_pointer(s7_car(args));
  if (e) {guint val = 0; gdk_event_get_keyval(e, &val); return(s7_make_integer(sc, (int)val));}
 return(s7_make_integer(sc, 0));
#else
  GdkEventKey *e;
  e = (GdkEventKey*)s7_c_pointer(s7_car(args));
 if (e) return(s7_make_integer(sc, (int)(e->keyval)));
 return(s7_make_integer(sc, 0));
#endif
}

static s7_pointer lg_make_GtkTextIter(s7_scheme *sc, s7_pointer args)
{
  GtkTextIter* result;
  result = (GtkTextIter*)calloc(1, sizeof(GtkTextIter));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "GtkTextIter_"), make_xm_obj(sc, result)));
}

static s7_pointer lg_make_GtkTreeIter(s7_scheme *sc, s7_pointer args)
{
  GtkTreeIter* result;
  result = (GtkTreeIter*)calloc(1, sizeof(GtkTreeIter));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "GtkTreeIter_"), make_xm_obj(sc, result)));
}

static s7_pointer lg_make_PangoRectangle(s7_scheme *sc, s7_pointer args)
{
  PangoRectangle* result;
  result = (PangoRectangle*)calloc(1, sizeof(PangoRectangle));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "PangoRectangle_"), make_xm_obj(sc, result)));
}

static s7_pointer lg_make_cairo_matrix_t(s7_scheme *sc, s7_pointer args)
{
  cairo_matrix_t* result;
  result = (cairo_matrix_t*)calloc(1, sizeof(cairo_matrix_t));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "cairo_matrix_t_"), make_xm_obj(sc, result)));
}

#if GTK_CHECK_VERSION(3, 0, 0)
static s7_pointer lg_make_GdkRGBA(s7_scheme *sc, s7_pointer args)
{
  GdkRGBA* result;
  result = (GdkRGBA*)calloc(1, sizeof(GdkRGBA));
  return(s7_make_c_pointer_with_type(sc, result, s7_make_symbol(sc, "GdkRGBA_"), make_xm_obj(sc, result)));
}
#endif

static s7_pointer lg_gtk_text_view_get_iter_at_position(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_iter_at_position "gboolean gtk_text_view_get_iter_at_position(GtkTextView* text_view, GtkTextIter* iter, gint* [trailing], gint x, gint y)"
  gint ref_trailing;
  s7_pointer text_view, iter, x, y, p;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 1, text_view, "GtkTextView*");
  iter = s7_cadr(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 2, iter, "GtkTextIter*");
  p = s7_cdddr(args); x = s7_car(p); y = s7_cadr(p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 4, x, "gint");
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_position", 5, y, "gint");
#if GTK_CHECK_VERSION(3, 20, 0)
  {
    s7_pointer result;
    result = s7_make_boolean(sc, gtk_text_view_get_iter_at_position((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), 
                                                                  &ref_trailing, s7_integer(x), s7_integer(y)));
    return(s7_list(sc, 2, result, s7_make_integer(sc, ref_trailing)));
   }
#else
  gtk_text_view_get_iter_at_position((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), &ref_trailing, s7_integer(x), s7_integer(y));
  return(s7_list(sc, 1, s7_make_integer(sc, ref_trailing)));
#endif
}

static s7_pointer lg_gtk_text_view_get_iter_at_location(s7_scheme *sc, s7_pointer args)
{
  #define H_gtk_text_view_get_iter_at_location "gboolean gtk_text_view_get_iter_at_location(GtkTextView* text_view, GtkTextIter* iter, gint x, gint y)"
  s7_pointer text_view, iter, x, y, p;
  text_view = s7_car(args);
  if (!s7_is_c_pointer_of_type(text_view, GtkTextView__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 1, text_view, "GtkTextView*");
  iter = s7_cadr(args);
  if (!s7_is_c_pointer_of_type(iter, GtkTextIter__sym)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 2, iter, "GtkTextIter*");
  p = s7_cddr(args); x = s7_car(p); y = s7_cadr(p);
  if (!s7_is_integer(x)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 4, x, "gint");
  if (!s7_is_integer(y)) s7_wrong_type_arg_error(sc, "gtk_text_view_get_iter_at_location", 5, y, "gint");
#if GTK_CHECK_VERSION(3, 20, 0)
  return(s7_make_boolean(sc, gtk_text_view_get_iter_at_location((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), s7_integer(x), s7_integer(y))));
#else
  gtk_text_view_get_iter_at_location((GtkTextView*)s7_c_pointer(text_view), (GtkTextIter*)s7_c_pointer(iter), s7_integer(x), s7_integer(y));
  return(lg_false);
#endif
}



static void define_structs(s7_scheme *sc)
{
  s7_define_function(sc, "GtkTextIter", lg_make_GtkTextIter, 0, 0, 0, "(GtkTextIter): a new GtkTextIter struct");
  s7_define_function(sc, "GtkTreeIter", lg_make_GtkTreeIter, 0, 0, 0, "(GtkTreeIter): a new GtkTreeIter struct");
  s7_define_function(sc, "PangoRectangle", lg_make_PangoRectangle, 0, 0, 0, "(PangoRectangle): a new PangoRectangle struct");
  s7_define_function(sc, "cairo_matrix_t", lg_make_cairo_matrix_t, 0, 0, 0, "(cairo_matrix_t): a new cairo_matrix_t struct");
  s7_define_function(sc, "gtk_text_view_get_iter_at_location", lg_gtk_text_view_get_iter_at_location, 4, 0, 0, H_gtk_text_view_get_iter_at_location);
  s7_define_function(sc, "gtk_text_view_get_iter_at_position", lg_gtk_text_view_get_iter_at_position, 4, 1, 0, H_gtk_text_view_get_iter_at_position);
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_function(sc, "GdkRGBA", lg_make_GdkRGBA, 0, 0, 0, "(GdkRGBA): a new GdkRGBA struct");
#endif
}

static void define_functions(s7_scheme *sc)
{
  s7_pointer s_boolean, s_integer, s_real, s_string, s_any, s_pair, s_float, s_gtk_enum_t, s_pair_false;
  s7_pointer pl_pu, pl_pur, pl_pub, pl_pug, pl_pui, pl_put, pl_pus, pl_pugi, pl_pubi, pl_puri, pl_pust, pl_pusi, pl_pusu, pl_pugu, pl_puiu, pl_puiig, pl_pusiu, pl_pusub, pl_puiiu, pl_pussu, pl_puibu, pl_puuiu, pl_puiigi, pl_puuubu, pl_pusiiu, pl_puuiiu, pl_pugiiu, pl_pusiuiu, pl_puuusuug, pl_pusiuibu, pl_g, pl_bt, pl_tb, pl_bti, pl_btiib, pl_t, pl_tg, pl_bi, pl_i, pl_tts, pl_tti, pl_igi, pl_ti, pl_it, pl_tiu, pl_itsub, pl_itiiub, pl_itstttg, pl_itgiiut, pl_buuusuug, pl_bu, pl_pb, pl_bur, pl_bug, pl_bus, pl_bui, pl_bub, pl_busu, pl_buub, pl_buus, pl_buui, pl_busib, pl_buuub, pl_buttu, pl_busgu, pl_buuui, pl_buusib, pl_buuuub, pl_buurbr, pl_s, pl_iit, pl_iiit, pl_p, pl_sg, pl_gs, pl_gu, pl_pg, pl_gus, pl_pgi, pl_pgu, pl_gui, pl_guut, pl_pgbi, pl_guuut, pl_gurrsiu, pl_gussitu, pl_ts, pl_tsi, pl_tsiu, pl_tsiiuui, pl_tusiuiui, pl_tuiiiiui, pl_tuuiiiirrrrg, pl_tuuiiiirrrrgi, pl_pt, pl_tu, pl_tus, pl_tut, pl_tug, pl_tur, pl_tui, pl_tub, pl_tusg, pl_tusu, pl_tugb, pl_tugs, pl_tuui, pl_tuib, pl_tusi, pl_tuug, pl_tuur, pl_turi, pl_tusr, pl_tusb, pl_tuub, pl_tuus, pl_tugu, pl_tugr, pl_tugi, pl_tuut, pl_tugt, pl_tuis, pl_tust, pl_tuiu, pl_tuig, pl_tuit, pl_tuuiu, pl_tuurb, pl_tuuri, pl_turgs, pl_tuisi, pl_tusri, pl_tuuut, pl_tuubr, pl_tuuub, pl_tuuir, pl_tuuui, pl_tuusi, pl_tuiiu, pl_tuusit, pl_tusiis, pl_tuuubr, pl_tuurbr, pl_tuuiuui, pl_tubiiiu, pl_si, pl_is, pl_isi, pl_sig, pl_isgt, pl_isigutttiiu, pl_iu, pl_pi, pl_iur, pl_iui, pl_ius, pl_piu, pl_pit, pl_iug, pl_iuis, pl_iusi, pl_iuui, pl_iuuui, pl_iuisi, pl_iuuuui, pl_iuisut, pl_du, pl_pr, pl_dui, pl_dus, pl_dusi, pl_dusr, pl_b, pl_ssi, pl_ssig, pl_psgbiiiit, pl_psiiuusu, pl_su, pl_ps, pl_sui, pl_sug, pl_psi, pl_psb, pl_psu, pl_sus, pl_psg, pl_psgi, pl_psiu, pl_psut, pl_suuub, pl_psugt, pl_psiuub, pl_bpt;
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_pointer pl_puiiui, pl_pgr, pl_gug, pl_tuuugi, pl_tuuuub;
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_pointer pl_tsu, pl_prrru, pl_suiig;
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_pointer pl_tugiiu;
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_pointer pl_tuuuui;
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_pointer pl_tuurru;
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_pointer pl_tuuiiu, pl_tugiis, pl_iugi;
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  s7_pointer pl_tuurruig;
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
  s7_pointer pl_purrrru, pl_tuiut, pl_tuuur, pl_tugug, pl_tuuiut, pl_tuiiut, pl_tubbbt, pl_tusuiut, pl_tuuuiiu, pl_iuugs, pl_piigui, pl_pst;
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
  s7_pointer pl_purrg, pl_puuugi, pl_buiu, pl_buib, pl_buiib, pl_tuiiiu, pl_tuugiu, pl_bg;
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
  s7_pointer pl_puus, pl_puuiig, pl_pussiig, pl_pusiiiu, pl_pusiiius, pl_big, pl_bsu, pl_bugu, pl_buiiu, pl_buiuuut, pl_guub, pl_guig, pl_ptggtgrri, pl_tubu, pl_tugui, pl_tussu, pl_tusst, pl_tuisu, pl_tuttu, pl_ptggri, pl_pig, pl_prrrb;
#endif


  s_boolean = s7_make_symbol(sc, "boolean?");
  s_integer = s7_make_symbol(sc, "integer?");
  s_real = s7_make_symbol(sc, "real?");
  s_float = s7_make_symbol(sc, "float?");
  s_string = s7_make_symbol(sc, "string?");
  s_pair = s7_make_symbol(sc, "pair?");
  s_pair_false = s7_make_signature(sc, 2, s_pair, s_boolean);
  s_gtk_enum_t = s7_make_symbol(sc, "gtk_enum_t?");
  s_any = s7_t(sc);

  pl_pu = s7_make_circular_signature(sc, 1, 2, s_pair, s_pair_false);
  pl_pur = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_real);
  pl_pub = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_boolean);
  pl_pug = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_gtk_enum_t);
  pl_pui = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_integer);
  pl_put = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_any);
  pl_pus = s7_make_circular_signature(sc, 2, 3, s_pair, s_pair_false, s_string);
  pl_pugi = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_gtk_enum_t, s_integer);
  pl_pubi = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_boolean, s_integer);
  pl_puri = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_real, s_integer);
  pl_pust = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_string, s_any);
  pl_pusi = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_string, s_integer);
  pl_pusu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_string, s_pair_false);
  pl_pugu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_puiu = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_integer, s_pair_false);
  pl_puiig = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_pusiu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_integer, s_pair_false);
  pl_pusub = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_pair_false, s_boolean);
  pl_puiiu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_pussu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_string, s_string, s_pair_false);
  pl_puibu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_puuiu = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_puiigi = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_integer, s_integer, s_gtk_enum_t, s_integer);
  pl_puuubu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_pair_false, s_boolean, s_pair_false);
  pl_pusiiu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_string, s_integer, s_integer, s_pair_false);
  pl_puuiiu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_pugiiu = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_pair_false);
  pl_pusiuiu = s7_make_circular_signature(sc, 6, 7, s_pair, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_pair_false);
  pl_puuusuug = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_pair_false, s_pair_false, s_string, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_pusiuibu = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_boolean, s_pair_false);
  pl_g = s7_make_circular_signature(sc, 0, 1, s_gtk_enum_t);
  pl_bt = s7_make_circular_signature(sc, 1, 2, s_boolean, s_any);
  pl_tb = s7_make_circular_signature(sc, 1, 2, s_any, s_boolean);
  pl_bti = s7_make_circular_signature(sc, 2, 3, s_boolean, s_any, s_integer);
  pl_btiib = s7_make_circular_signature(sc, 4, 5, s_boolean, s_any, s_integer, s_integer, s_boolean);
  pl_t = s7_make_circular_signature(sc, 0, 1, s_any);
  pl_tg = s7_make_circular_signature(sc, 1, 2, s_any, s_gtk_enum_t);
  pl_bi = s7_make_circular_signature(sc, 1, 2, s_boolean, s_integer);
  pl_i = s7_make_circular_signature(sc, 0, 1, s_integer);
  pl_tts = s7_make_circular_signature(sc, 2, 3, s_any, s_any, s_string);
  pl_tti = s7_make_circular_signature(sc, 2, 3, s_any, s_any, s_integer);
  pl_igi = s7_make_circular_signature(sc, 2, 3, s_integer, s_gtk_enum_t, s_integer);
  pl_ti = s7_make_circular_signature(sc, 1, 2, s_any, s_integer);
  pl_it = s7_make_circular_signature(sc, 1, 2, s_integer, s_any);
  pl_tiu = s7_make_circular_signature(sc, 2, 3, s_any, s_integer, s_pair_false);
  pl_itsub = s7_make_circular_signature(sc, 4, 5, s_integer, s_any, s_string, s_pair_false, s_boolean);
  pl_itiiub = s7_make_circular_signature(sc, 5, 6, s_integer, s_any, s_integer, s_integer, s_pair_false, s_boolean);
  pl_itstttg = s7_make_circular_signature(sc, 6, 7, s_integer, s_any, s_string, s_any, s_any, s_any, s_gtk_enum_t);
  pl_itgiiut = s7_make_circular_signature(sc, 6, 7, s_integer, s_any, s_gtk_enum_t, s_integer, s_integer, s_pair_false, s_any);
  pl_buuusuug = s7_make_circular_signature(sc, 7, 8, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_string, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_bu = s7_make_circular_signature(sc, 1, 2, s_boolean, s_pair_false);
  pl_pb = s7_make_circular_signature(sc, 1, 2, s_pair, s_boolean);
  pl_bur = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_real);
  pl_bug = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_gtk_enum_t);
  pl_bus = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_string);
  pl_bui = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_integer);
  pl_bub = s7_make_circular_signature(sc, 2, 3, s_boolean, s_pair_false, s_boolean);
  pl_busu = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_string, s_pair_false);
  pl_buub = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_boolean);
  pl_buus = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_string);
  pl_buui = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_pair_false, s_integer);
  pl_busib = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_string, s_integer, s_boolean);
  pl_buuub = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_buttu = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_any, s_any, s_pair_false);
  pl_busgu = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_string, s_gtk_enum_t, s_pair_false);
  pl_buuui = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_buusib = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_pair_false, s_string, s_integer, s_boolean);
  pl_buuuub = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_buurbr = s7_make_circular_signature(sc, 5, 6, s_boolean, s_pair_false, s_pair_false, s_real, s_boolean, s_real);
  pl_s = s7_make_circular_signature(sc, 0, 1, s_string);
  pl_iit = s7_make_circular_signature(sc, 2, 3, s_integer, s_integer, s_any);
  pl_iiit = s7_make_circular_signature(sc, 3, 4, s_integer, s_integer, s_integer, s_any);
  pl_p = s7_make_circular_signature(sc, 0, 1, s_pair);
  pl_sg = s7_make_circular_signature(sc, 1, 2, s_string, s_gtk_enum_t);
  pl_gs = s7_make_circular_signature(sc, 1, 2, s_gtk_enum_t, s_string);
  pl_gu = s7_make_circular_signature(sc, 1, 2, s_gtk_enum_t, s_pair_false);
  pl_pg = s7_make_circular_signature(sc, 1, 2, s_pair, s_gtk_enum_t);
  pl_gus = s7_make_circular_signature(sc, 2, 3, s_gtk_enum_t, s_pair_false, s_string);
  pl_pgi = s7_make_circular_signature(sc, 2, 3, s_pair, s_gtk_enum_t, s_integer);
  pl_pgu = s7_make_circular_signature(sc, 2, 3, s_pair, s_gtk_enum_t, s_pair_false);
  pl_gui = s7_make_circular_signature(sc, 2, 3, s_gtk_enum_t, s_pair_false, s_integer);
  pl_guut = s7_make_circular_signature(sc, 3, 4, s_gtk_enum_t, s_pair_false, s_pair_false, s_any);
  pl_pgbi = s7_make_circular_signature(sc, 3, 4, s_pair, s_gtk_enum_t, s_boolean, s_integer);
  pl_guuut = s7_make_circular_signature(sc, 4, 5, s_gtk_enum_t, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_gurrsiu = s7_make_circular_signature(sc, 6, 7, s_gtk_enum_t, s_pair_false, s_real, s_real, s_string, s_integer, s_pair_false);
  pl_gussitu = s7_make_circular_signature(sc, 6, 7, s_gtk_enum_t, s_pair_false, s_string, s_string, s_integer, s_any, s_pair_false);
  pl_ts = s7_make_circular_signature(sc, 1, 2, s_any, s_string);
  pl_tsi = s7_make_circular_signature(sc, 2, 3, s_any, s_string, s_integer);
  pl_tsiu = s7_make_circular_signature(sc, 3, 4, s_any, s_string, s_integer, s_pair_false);
  pl_tsiiuui = s7_make_circular_signature(sc, 6, 7, s_any, s_string, s_integer, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_tusiuiui = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_string, s_integer, s_pair_false, s_integer, s_pair_false, s_integer);
  pl_tuiiiiui = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_pair_false, s_integer);
  pl_tuuiiiirrrrg = s7_make_circular_signature(sc, 11, 12, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_real, s_real, s_real, s_real, s_gtk_enum_t);
  pl_tuuiiiirrrrgi = s7_make_circular_signature(sc, 12, 13, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_integer, s_integer, s_real, s_real, s_real, s_real, s_gtk_enum_t, s_integer);
  pl_pt = s7_make_circular_signature(sc, 1, 2, s_pair, s_any);
  pl_tu = s7_make_circular_signature(sc, 1, 2, s_any, s_pair_false);
  pl_tus = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_string);
  pl_tut = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_any);
  pl_tug = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_gtk_enum_t);
  pl_tur = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_real);
  pl_tui = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_integer);
  pl_tub = s7_make_circular_signature(sc, 2, 3, s_any, s_pair_false, s_boolean);
  pl_tusg = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_gtk_enum_t);
  pl_tusu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_pair_false);
  pl_tugb = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_boolean);
  pl_tugs = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_string);
  pl_tuui = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_integer);
  pl_tuib = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_boolean);
  pl_tusi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_integer);
  pl_tuug = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_gtk_enum_t);
  pl_tuur = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_real);
  pl_turi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_real, s_integer);
  pl_tusr = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_real);
  pl_tusb = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_boolean);
  pl_tuub = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_boolean);
  pl_tuus = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_string);
  pl_tugu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_tugr = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_real);
  pl_tugi = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuut = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_pair_false, s_any);
  pl_tugt = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_gtk_enum_t, s_any);
  pl_tuis = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_string);
  pl_tust = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_string, s_any);
  pl_tuiu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_pair_false);
  pl_tuig = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_gtk_enum_t);
  pl_tuit = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_integer, s_any);
  pl_tuuiu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false);
  pl_tuurb = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_real, s_boolean);
  pl_tuuri = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_real, s_integer);
  pl_turgs = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_real, s_gtk_enum_t, s_string);
  pl_tuisi = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_string, s_integer);
  pl_tusri = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_string, s_real, s_integer);
  pl_tuuut = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_tuubr = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_boolean, s_real);
  pl_tuuub = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_tuuir = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_integer, s_real);
  pl_tuuui = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_tuusi = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_string, s_integer);
  pl_tuiiu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_tuusit = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_string, s_integer, s_any);
  pl_tusiis = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_string, s_integer, s_integer, s_string);
  pl_tuuubr = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_boolean, s_real);
  pl_tuurbr = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_real, s_boolean, s_real);
  pl_tuuiuui = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_tubiiiu = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_boolean, s_integer, s_integer, s_integer, s_pair_false);
  pl_si = s7_make_circular_signature(sc, 1, 2, s_string, s_integer);
  pl_is = s7_make_circular_signature(sc, 1, 2, s_integer, s_string);
  pl_isi = s7_make_circular_signature(sc, 2, 3, s_integer, s_string, s_integer);
  pl_sig = s7_make_circular_signature(sc, 2, 3, s_string, s_integer, s_gtk_enum_t);
  pl_isgt = s7_make_circular_signature(sc, 3, 4, s_integer, s_string, s_gtk_enum_t, s_any);
  pl_isigutttiiu = s7_make_circular_signature(sc, 10, 11, s_integer, s_string, s_integer, s_gtk_enum_t, s_pair_false, s_any, s_any, s_any, s_integer, s_integer, s_pair_false);
  pl_iu = s7_make_circular_signature(sc, 1, 2, s_integer, s_pair_false);
  pl_pi = s7_make_circular_signature(sc, 1, 2, s_pair, s_integer);
  pl_iur = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_real);
  pl_iui = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_integer);
  pl_ius = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_string);
  pl_piu = s7_make_circular_signature(sc, 2, 3, s_pair, s_integer, s_pair_false);
  pl_pit = s7_make_circular_signature(sc, 2, 3, s_pair, s_integer, s_any);
  pl_iug = s7_make_circular_signature(sc, 2, 3, s_integer, s_pair_false, s_gtk_enum_t);
  pl_iuis = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_integer, s_string);
  pl_iusi = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_string, s_integer);
  pl_iuui = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_pair_false, s_integer);
  pl_iuuui = s7_make_circular_signature(sc, 4, 5, s_integer, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_iuisi = s7_make_circular_signature(sc, 4, 5, s_integer, s_pair_false, s_integer, s_string, s_integer);
  pl_iuuuui = s7_make_circular_signature(sc, 5, 6, s_integer, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_integer);
  pl_iuisut = s7_make_circular_signature(sc, 5, 6, s_integer, s_pair_false, s_integer, s_string, s_pair_false, s_any);
  pl_du = s7_make_circular_signature(sc, 1, 2, s_float, s_pair_false);
  pl_pr = s7_make_circular_signature(sc, 1, 2, s_pair, s_real);
  pl_dui = s7_make_circular_signature(sc, 2, 3, s_float, s_pair_false, s_integer);
  pl_dus = s7_make_circular_signature(sc, 2, 3, s_float, s_pair_false, s_string);
  pl_dusi = s7_make_circular_signature(sc, 3, 4, s_float, s_pair_false, s_string, s_integer);
  pl_dusr = s7_make_circular_signature(sc, 3, 4, s_float, s_pair_false, s_string, s_real);
  pl_b = s7_make_circular_signature(sc, 0, 1, s_boolean);
  pl_ssi = s7_make_circular_signature(sc, 2, 3, s_string, s_string, s_integer);
  pl_ssig = s7_make_circular_signature(sc, 3, 4, s_string, s_string, s_integer, s_gtk_enum_t);
  pl_psgbiiiit = s7_make_circular_signature(sc, 8, 9, s_pair, s_string, s_gtk_enum_t, s_boolean, s_integer, s_integer, s_integer, s_integer, s_any);
  pl_psiiuusu = s7_make_circular_signature(sc, 7, 8, s_pair, s_string, s_integer, s_integer, s_pair_false, s_pair_false, s_string, s_pair_false);
  pl_su = s7_make_circular_signature(sc, 1, 2, s_string, s_pair_false);
  pl_ps = s7_make_circular_signature(sc, 1, 2, s_pair, s_string);
  pl_sui = s7_make_circular_signature(sc, 2, 3, s_string, s_pair_false, s_integer);
  pl_sug = s7_make_circular_signature(sc, 2, 3, s_string, s_pair_false, s_gtk_enum_t);
  pl_psi = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_integer);
  pl_psb = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_boolean);
  pl_psu = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_pair_false);
  pl_sus = s7_make_circular_signature(sc, 2, 3, s_string, s_pair_false, s_string);
  pl_psg = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_gtk_enum_t);
  pl_psgi = s7_make_circular_signature(sc, 3, 4, s_pair, s_string, s_gtk_enum_t, s_integer);
  pl_psiu = s7_make_circular_signature(sc, 3, 4, s_pair, s_string, s_integer, s_pair_false);
  pl_psut = s7_make_circular_signature(sc, 3, 4, s_pair, s_string, s_pair_false, s_any);
  pl_suuub = s7_make_circular_signature(sc, 4, 5, s_string, s_pair_false, s_pair_false, s_pair_false, s_boolean);
  pl_psugt = s7_make_circular_signature(sc, 4, 5, s_pair, s_string, s_pair_false, s_gtk_enum_t, s_any);
  pl_psiuub = s7_make_circular_signature(sc, 5, 6, s_pair, s_string, s_integer, s_pair_false, s_pair_false, s_boolean);
  pl_bpt = s7_make_signature(sc, 2, s_pair_false, s_any);
#if GTK_CHECK_VERSION(3, 0, 0)
  pl_puiiui = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_integer, s_integer, s_pair_false, s_integer);
  pl_pgr = s7_make_circular_signature(sc, 2, 3, s_pair, s_gtk_enum_t, s_real);
  pl_gug = s7_make_circular_signature(sc, 2, 3, s_gtk_enum_t, s_pair_false, s_gtk_enum_t);
  pl_tuuugi = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_tuuuub = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_boolean);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  pl_tsu = s7_make_circular_signature(sc, 2, 3, s_any, s_string, s_pair_false);
  pl_prrru = s7_make_circular_signature(sc, 4, 5, s_pair, s_real, s_real, s_real, s_pair_false);
  pl_suiig = s7_make_circular_signature(sc, 4, 5, s_string, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  pl_tugiiu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_pair_false);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  pl_tuuuui = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_pair_false, s_pair_false, s_integer);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  pl_tuurru = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_real, s_real, s_pair_false);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  pl_tuuiiu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_tugiis = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_gtk_enum_t, s_integer, s_integer, s_string);
  pl_iugi = s7_make_circular_signature(sc, 3, 4, s_integer, s_pair_false, s_gtk_enum_t, s_integer);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  pl_tuurruig = s7_make_circular_signature(sc, 7, 8, s_any, s_pair_false, s_pair_false, s_real, s_real, s_pair_false, s_integer, s_gtk_enum_t);
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
  pl_purrrru = s7_make_circular_signature(sc, 6, 7, s_pair, s_pair_false, s_real, s_real, s_real, s_real, s_pair_false);
  pl_tuiut = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_pair_false, s_any);
  pl_tuuur = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_pair_false, s_pair_false, s_real);
  pl_tugug = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_gtk_enum_t);
  pl_tuuiut = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_integer, s_pair_false, s_any);
  pl_tuiiut = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_integer, s_integer, s_pair_false, s_any);
  pl_tubbbt = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_boolean, s_boolean, s_boolean, s_any);
  pl_tusuiut = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_string, s_pair_false, s_integer, s_pair_false, s_any);
  pl_tuuuiiu = s7_make_circular_signature(sc, 6, 7, s_any, s_pair_false, s_pair_false, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_iuugs = s7_make_circular_signature(sc, 4, 5, s_integer, s_pair_false, s_pair_false, s_gtk_enum_t, s_string);
  pl_piigui = s7_make_circular_signature(sc, 5, 6, s_pair, s_integer, s_integer, s_gtk_enum_t, s_pair_false, s_integer);
  pl_pst = s7_make_circular_signature(sc, 2, 3, s_pair, s_string, s_any);
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
  pl_purrg = s7_make_circular_signature(sc, 4, 5, s_pair, s_pair_false, s_real, s_real, s_gtk_enum_t);
  pl_puuugi = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer);
  pl_buiu = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_integer, s_pair_false);
  pl_buib = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_integer, s_boolean);
  pl_buiib = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_integer, s_integer, s_boolean);
  pl_tuiiiu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_integer, s_integer, s_integer, s_pair_false);
  pl_tuugiu = s7_make_circular_signature(sc, 5, 6, s_any, s_pair_false, s_pair_false, s_gtk_enum_t, s_integer, s_pair_false);
  pl_bg = s7_make_circular_signature(sc, 1, 2, s_boolean, s_gtk_enum_t);
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
  pl_puus = s7_make_circular_signature(sc, 3, 4, s_pair, s_pair_false, s_pair_false, s_string);
  pl_puuiig = s7_make_circular_signature(sc, 5, 6, s_pair, s_pair_false, s_pair_false, s_integer, s_integer, s_gtk_enum_t);
  pl_pussiig = s7_make_circular_signature(sc, 6, 7, s_pair, s_pair_false, s_string, s_string, s_integer, s_integer, s_gtk_enum_t);
  pl_pusiiiu = s7_make_circular_signature(sc, 6, 7, s_pair, s_pair_false, s_string, s_integer, s_integer, s_integer, s_pair_false);
  pl_pusiiius = s7_make_circular_signature(sc, 7, 8, s_pair, s_pair_false, s_string, s_integer, s_integer, s_integer, s_pair_false, s_string);
  pl_big = s7_make_circular_signature(sc, 2, 3, s_boolean, s_integer, s_gtk_enum_t);
  pl_bsu = s7_make_circular_signature(sc, 2, 3, s_boolean, s_string, s_pair_false);
  pl_bugu = s7_make_circular_signature(sc, 3, 4, s_boolean, s_pair_false, s_gtk_enum_t, s_pair_false);
  pl_buiiu = s7_make_circular_signature(sc, 4, 5, s_boolean, s_pair_false, s_integer, s_integer, s_pair_false);
  pl_buiuuut = s7_make_circular_signature(sc, 6, 7, s_boolean, s_pair_false, s_integer, s_pair_false, s_pair_false, s_pair_false, s_any);
  pl_guub = s7_make_circular_signature(sc, 3, 4, s_gtk_enum_t, s_pair_false, s_pair_false, s_boolean);
  pl_guig = s7_make_circular_signature(sc, 3, 4, s_gtk_enum_t, s_pair_false, s_integer, s_gtk_enum_t);
  pl_ptggtgrri = s7_make_circular_signature(sc, 8, 9, s_pair, s_any, s_gtk_enum_t, s_gtk_enum_t, s_any, s_gtk_enum_t, s_real, s_real, s_integer);
  pl_tubu = s7_make_circular_signature(sc, 3, 4, s_any, s_pair_false, s_boolean, s_pair_false);
  pl_tugui = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_gtk_enum_t, s_pair_false, s_integer);
  pl_tussu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_string, s_string, s_pair_false);
  pl_tusst = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_string, s_string, s_any);
  pl_tuisu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_integer, s_string, s_pair_false);
  pl_tuttu = s7_make_circular_signature(sc, 4, 5, s_any, s_pair_false, s_any, s_any, s_pair_false);
  pl_ptggri = s7_make_circular_signature(sc, 5, 6, s_pair, s_any, s_gtk_enum_t, s_gtk_enum_t, s_real, s_integer);
  pl_pig = s7_make_circular_signature(sc, 2, 3, s_pair, s_integer, s_gtk_enum_t);
  pl_prrrb = s7_make_circular_signature(sc, 4, 5, s_pair, s_real, s_real, s_real, s_boolean);
#endif


  s7_define_typed_function(sc, "g_unichar_validate", lg_g_unichar_validate, 1, 0, 0, H_g_unichar_validate, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isalnum", lg_g_unichar_isalnum, 1, 0, 0, H_g_unichar_isalnum, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isalpha", lg_g_unichar_isalpha, 1, 0, 0, H_g_unichar_isalpha, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iscntrl", lg_g_unichar_iscntrl, 1, 0, 0, H_g_unichar_iscntrl, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isdefined", lg_g_unichar_isdefined, 1, 0, 0, H_g_unichar_isdefined, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isdigit", lg_g_unichar_isdigit, 1, 0, 0, H_g_unichar_isdigit, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isgraph", lg_g_unichar_isgraph, 1, 0, 0, H_g_unichar_isgraph, pl_bi);
  s7_define_typed_function(sc, "g_unichar_islower", lg_g_unichar_islower, 1, 0, 0, H_g_unichar_islower, pl_bi);
  s7_define_typed_function(sc, "g_unichar_ismark", lg_g_unichar_ismark, 1, 0, 0, H_g_unichar_ismark, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isprint", lg_g_unichar_isprint, 1, 0, 0, H_g_unichar_isprint, pl_bi);
  s7_define_typed_function(sc, "g_unichar_ispunct", lg_g_unichar_ispunct, 1, 0, 0, H_g_unichar_ispunct, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isspace", lg_g_unichar_isspace, 1, 0, 0, H_g_unichar_isspace, pl_bi);
  s7_define_typed_function(sc, "g_unichar_istitle", lg_g_unichar_istitle, 1, 0, 0, H_g_unichar_istitle, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isupper", lg_g_unichar_isupper, 1, 0, 0, H_g_unichar_isupper, pl_bi);
  s7_define_typed_function(sc, "g_unichar_isxdigit", lg_g_unichar_isxdigit, 1, 0, 0, H_g_unichar_isxdigit, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iswide", lg_g_unichar_iswide, 1, 0, 0, H_g_unichar_iswide, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iswide_cjk", lg_g_unichar_iswide_cjk, 1, 0, 0, H_g_unichar_iswide_cjk, pl_bi);
  s7_define_typed_function(sc, "g_unichar_iszerowidth", lg_g_unichar_iszerowidth, 1, 0, 0, H_g_unichar_iszerowidth, pl_bi);
  s7_define_typed_function(sc, "g_unichar_toupper", lg_g_unichar_toupper, 1, 0, 0, H_g_unichar_toupper, pl_i);
  s7_define_typed_function(sc, "g_unichar_tolower", lg_g_unichar_tolower, 1, 0, 0, H_g_unichar_tolower, pl_i);
  s7_define_typed_function(sc, "g_unichar_totitle", lg_g_unichar_totitle, 1, 0, 0, H_g_unichar_totitle, pl_i);
  s7_define_typed_function(sc, "g_unichar_digit_value", lg_g_unichar_digit_value, 1, 0, 0, H_g_unichar_digit_value, pl_i);
  s7_define_typed_function(sc, "g_unichar_xdigit_value", lg_g_unichar_xdigit_value, 1, 0, 0, H_g_unichar_xdigit_value, pl_i);
  s7_define_typed_function(sc, "g_unichar_combining_class", lg_g_unichar_combining_class, 1, 0, 0, H_g_unichar_combining_class, pl_i);
  s7_define_typed_function(sc, "g_unicode_canonical_ordering", lg_g_unicode_canonical_ordering, 2, 0, 0, H_g_unicode_canonical_ordering, pl_tsi);
  s7_define_typed_function(sc, "g_utf8_get_char", lg_g_utf8_get_char, 1, 0, 0, H_g_utf8_get_char, pl_is);
  s7_define_typed_function(sc, "g_utf8_get_char_validated", lg_g_utf8_get_char_validated, 2, 0, 0, H_g_utf8_get_char_validated, pl_isi);
  s7_define_typed_function(sc, "g_utf8_prev_char", lg_g_utf8_prev_char, 1, 0, 0, H_g_utf8_prev_char, pl_s);
  s7_define_typed_function(sc, "g_utf8_find_next_char", lg_g_utf8_find_next_char, 2, 0, 0, H_g_utf8_find_next_char, pl_s);
  s7_define_typed_function(sc, "g_utf8_find_prev_char", lg_g_utf8_find_prev_char, 2, 0, 0, H_g_utf8_find_prev_char, pl_s);
  s7_define_typed_function(sc, "g_utf8_strlen", lg_g_utf8_strlen, 2, 0, 0, H_g_utf8_strlen, pl_isi);
  s7_define_typed_function(sc, "g_utf8_strchr", lg_g_utf8_strchr, 3, 0, 0, H_g_utf8_strchr, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_strrchr", lg_g_utf8_strrchr, 3, 0, 0, H_g_utf8_strrchr, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_strreverse", lg_g_utf8_strreverse, 2, 0, 0, H_g_utf8_strreverse, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_validate", lg_g_utf8_validate, 2, 1, 0, H_g_utf8_validate, pl_psiu);
  s7_define_typed_function(sc, "g_utf8_strup", lg_g_utf8_strup, 2, 0, 0, H_g_utf8_strup, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_strdown", lg_g_utf8_strdown, 2, 0, 0, H_g_utf8_strdown, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_casefold", lg_g_utf8_casefold, 2, 0, 0, H_g_utf8_casefold, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_normalize", lg_g_utf8_normalize, 3, 0, 0, H_g_utf8_normalize, pl_ssig);
  s7_define_typed_function(sc, "g_utf8_collate", lg_g_utf8_collate, 2, 0, 0, H_g_utf8_collate, pl_is);
  s7_define_typed_function(sc, "g_utf8_collate_key", lg_g_utf8_collate_key, 2, 0, 0, H_g_utf8_collate_key, pl_ssi);
  s7_define_typed_function(sc, "g_utf8_collate_key_for_filename", lg_g_utf8_collate_key_for_filename, 2, 0, 0, H_g_utf8_collate_key_for_filename, pl_ssi);
  s7_define_typed_function(sc, "g_cclosure_new", lg_g_cclosure_new, 3, 0, 0, H_g_cclosure_new, pl_pt);
  s7_define_typed_function(sc, "g_signal_newv", lg_g_signal_newv, 0, 0, 1, H_g_signal_newv, pl_isigutttiiu);
  s7_define_typed_function(sc, "g_signal_lookup", lg_g_signal_lookup, 2, 0, 0, H_g_signal_lookup, pl_isi);
  s7_define_typed_function(sc, "g_signal_name", lg_g_signal_name, 1, 0, 0, H_g_signal_name, pl_si);
  s7_define_typed_function(sc, "g_signal_query", lg_g_signal_query, 2, 0, 0, H_g_signal_query, pl_tiu);
  s7_define_typed_function(sc, "g_signal_list_ids", lg_g_signal_list_ids, 2, 0, 0, H_g_signal_list_ids, pl_piu);
  s7_define_typed_function(sc, "g_signal_parse_name", lg_g_signal_parse_name, 3, 2, 0, H_g_signal_parse_name, pl_psiuub);
  s7_define_typed_function(sc, "g_signal_get_invocation_hint", lg_g_signal_get_invocation_hint, 1, 0, 0, H_g_signal_get_invocation_hint, pl_pt);
  s7_define_typed_function(sc, "g_signal_stop_emission", lg_g_signal_stop_emission, 3, 0, 0, H_g_signal_stop_emission, pl_tti);
  s7_define_typed_function(sc, "g_signal_stop_emission_by_name", lg_g_signal_stop_emission_by_name, 2, 0, 0, H_g_signal_stop_emission_by_name, pl_tts);
  s7_define_typed_function(sc, "g_signal_add_emission_hook", lg_g_signal_add_emission_hook, 5, 0, 0, H_g_signal_add_emission_hook, pl_iiit);
  s7_define_typed_function(sc, "g_signal_remove_emission_hook", lg_g_signal_remove_emission_hook, 2, 0, 0, H_g_signal_remove_emission_hook, pl_ti);
  s7_define_typed_function(sc, "g_signal_has_handler_pending", lg_g_signal_has_handler_pending, 4, 0, 0, H_g_signal_has_handler_pending, pl_btiib);
  s7_define_typed_function(sc, "g_signal_connect_closure_by_id", lg_g_signal_connect_closure_by_id, 5, 0, 0, H_g_signal_connect_closure_by_id, pl_itiiub);
  s7_define_typed_function(sc, "g_signal_connect_closure", lg_g_signal_connect_closure, 4, 0, 0, H_g_signal_connect_closure, pl_itsub);
  s7_define_typed_function(sc, "g_signal_connect_data", lg_g_signal_connect_data, 6, 0, 0, H_g_signal_connect_data, pl_itstttg);
  s7_define_typed_function(sc, "g_signal_handler_block", lg_g_signal_handler_block, 2, 0, 0, H_g_signal_handler_block, pl_tti);
  s7_define_typed_function(sc, "g_signal_handler_unblock", lg_g_signal_handler_unblock, 2, 0, 0, H_g_signal_handler_unblock, pl_tti);
  s7_define_typed_function(sc, "g_signal_handler_disconnect", lg_g_signal_handler_disconnect, 2, 0, 0, H_g_signal_handler_disconnect, pl_tti);
  s7_define_typed_function(sc, "g_signal_handler_is_connected", lg_g_signal_handler_is_connected, 2, 0, 0, H_g_signal_handler_is_connected, pl_bti);
  s7_define_typed_function(sc, "g_signal_handler_find", lg_g_signal_handler_find, 7, 0, 0, H_g_signal_handler_find, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_block_matched", lg_g_signal_handlers_block_matched, 7, 0, 0, H_g_signal_handlers_block_matched, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_unblock_matched", lg_g_signal_handlers_unblock_matched, 7, 0, 0, H_g_signal_handlers_unblock_matched, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_disconnect_matched", lg_g_signal_handlers_disconnect_matched, 7, 0, 0, H_g_signal_handlers_disconnect_matched, pl_itgiiut);
  s7_define_typed_function(sc, "g_signal_handlers_destroy", lg_g_signal_handlers_destroy, 1, 0, 0, H_g_signal_handlers_destroy, pl_t);
  s7_define_typed_function(sc, "g_object_ref", lg_g_object_ref, 1, 0, 0, H_g_object_ref, pl_t);
  s7_define_typed_function(sc, "g_object_unref", lg_g_object_unref, 1, 0, 0, H_g_object_unref, pl_t);
  s7_define_typed_function(sc, "gdk_event_copy", lg_gdk_event_copy, 1, 0, 0, H_gdk_event_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_time", lg_gdk_event_get_time, 1, 0, 0, H_gdk_event_get_time, pl_iu);
  s7_define_typed_function(sc, "gdk_event_get_state", lg_gdk_event_get_state, 1, 1, 0, H_gdk_event_get_state, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_coords", lg_gdk_event_get_coords, 1, 2, 0, H_gdk_event_get_coords, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_root_coords", lg_gdk_event_get_root_coords, 1, 2, 0, H_gdk_event_get_root_coords, pl_pu);
  s7_define_typed_function(sc, "gdk_set_show_events", lg_gdk_set_show_events, 1, 0, 0, H_gdk_set_show_events, pl_tb);
  s7_define_typed_function(sc, "gdk_get_show_events", lg_gdk_get_show_events, 0, 0, 0, H_gdk_get_show_events, pl_b);
  s7_define_typed_function(sc, "gdk_rectangle_intersect", lg_gdk_rectangle_intersect, 3, 0, 0, H_gdk_rectangle_intersect, pl_bu);
  s7_define_typed_function(sc, "gdk_rectangle_union", lg_gdk_rectangle_union, 3, 0, 0, H_gdk_rectangle_union, pl_tu);
  s7_define_typed_function(sc, "gdk_keymap_lookup_key", lg_gdk_keymap_lookup_key, 2, 0, 0, H_gdk_keymap_lookup_key, pl_iu);
  s7_define_typed_function(sc, "gdk_keyval_name", lg_gdk_keyval_name, 1, 0, 0, H_gdk_keyval_name, pl_si);
  s7_define_typed_function(sc, "gdk_keyval_from_name", lg_gdk_keyval_from_name, 1, 0, 0, H_gdk_keyval_from_name, pl_is);
  s7_define_typed_function(sc, "gdk_keyval_convert_case", lg_gdk_keyval_convert_case, 1, 2, 0, H_gdk_keyval_convert_case, pl_piu);
  s7_define_typed_function(sc, "gdk_keyval_to_upper", lg_gdk_keyval_to_upper, 1, 0, 0, H_gdk_keyval_to_upper, pl_i);
  s7_define_typed_function(sc, "gdk_keyval_to_lower", lg_gdk_keyval_to_lower, 1, 0, 0, H_gdk_keyval_to_lower, pl_i);
  s7_define_typed_function(sc, "gdk_keyval_is_upper", lg_gdk_keyval_is_upper, 1, 0, 0, H_gdk_keyval_is_upper, pl_bi);
  s7_define_typed_function(sc, "gdk_keyval_is_lower", lg_gdk_keyval_is_lower, 1, 0, 0, H_gdk_keyval_is_lower, pl_bi);
  s7_define_typed_function(sc, "gdk_keyval_to_unicode", lg_gdk_keyval_to_unicode, 1, 0, 0, H_gdk_keyval_to_unicode, pl_i);
  s7_define_typed_function(sc, "gdk_unicode_to_keyval", lg_gdk_unicode_to_keyval, 1, 0, 0, H_gdk_unicode_to_keyval, pl_i);
  s7_define_typed_function(sc, "gdk_utf8_to_string_target", lg_gdk_utf8_to_string_target, 1, 0, 0, H_gdk_utf8_to_string_target, pl_s);
  s7_define_typed_function(sc, "gdk_pixbuf_error_quark", lg_gdk_pixbuf_error_quark, 0, 0, 0, H_gdk_pixbuf_error_quark, pl_i);
  s7_define_typed_function(sc, "gdk_pixbuf_get_colorspace", lg_gdk_pixbuf_get_colorspace, 1, 0, 0, H_gdk_pixbuf_get_colorspace, pl_gu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_n_channels", lg_gdk_pixbuf_get_n_channels, 1, 0, 0, H_gdk_pixbuf_get_n_channels, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_has_alpha", lg_gdk_pixbuf_get_has_alpha, 1, 0, 0, H_gdk_pixbuf_get_has_alpha, pl_bu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_bits_per_sample", lg_gdk_pixbuf_get_bits_per_sample, 1, 0, 0, H_gdk_pixbuf_get_bits_per_sample, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_pixels", lg_gdk_pixbuf_get_pixels, 1, 0, 0, H_gdk_pixbuf_get_pixels, pl_su);
  s7_define_typed_function(sc, "gdk_pixbuf_get_width", lg_gdk_pixbuf_get_width, 1, 0, 0, H_gdk_pixbuf_get_width, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_height", lg_gdk_pixbuf_get_height, 1, 0, 0, H_gdk_pixbuf_get_height, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_get_rowstride", lg_gdk_pixbuf_get_rowstride, 1, 0, 0, H_gdk_pixbuf_get_rowstride, pl_iu);
  s7_define_typed_function(sc, "gdk_pixbuf_new", lg_gdk_pixbuf_new, 5, 0, 0, H_gdk_pixbuf_new, pl_pgbi);
  s7_define_typed_function(sc, "gdk_pixbuf_copy", lg_gdk_pixbuf_copy, 1, 0, 0, H_gdk_pixbuf_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_new_subpixbuf", lg_gdk_pixbuf_new_subpixbuf, 5, 0, 0, H_gdk_pixbuf_new_subpixbuf, pl_pui);
  s7_define_typed_function(sc, "gdk_pixbuf_new_from_file", lg_gdk_pixbuf_new_from_file, 1, 1, 0, H_gdk_pixbuf_new_from_file, pl_psu);
  s7_define_typed_function(sc, "gdk_pixbuf_new_from_data", lg_gdk_pixbuf_new_from_data, 0, 0, 1, H_gdk_pixbuf_new_from_data, pl_psgbiiiit);
  s7_define_typed_function(sc, "gdk_pixbuf_new_from_xpm_data", lg_gdk_pixbuf_new_from_xpm_data, 1, 0, 0, H_gdk_pixbuf_new_from_xpm_data, pl_pu);
  s7_define_typed_function(sc, "gdk_pixbuf_fill", lg_gdk_pixbuf_fill, 2, 0, 0, H_gdk_pixbuf_fill, pl_tui);
  s7_define_typed_function(sc, "gdk_pixbuf_savev", lg_gdk_pixbuf_savev, 5, 1, 0, H_gdk_pixbuf_savev, pl_pussu);
  s7_define_typed_function(sc, "gdk_pixbuf_add_alpha", lg_gdk_pixbuf_add_alpha, 5, 0, 0, H_gdk_pixbuf_add_alpha, pl_pubi);
  s7_define_typed_function(sc, "gdk_pixbuf_copy_area", lg_gdk_pixbuf_copy_area, 0, 0, 1, H_gdk_pixbuf_copy_area, pl_tuiiiiui);
  s7_define_typed_function(sc, "gdk_pixbuf_saturate_and_pixelate", lg_gdk_pixbuf_saturate_and_pixelate, 4, 0, 0, H_gdk_pixbuf_saturate_and_pixelate, pl_tuurb);
  s7_define_typed_function(sc, "gdk_pixbuf_scale", lg_gdk_pixbuf_scale, 0, 0, 1, H_gdk_pixbuf_scale, pl_tuuiiiirrrrg);
  s7_define_typed_function(sc, "gdk_pixbuf_composite", lg_gdk_pixbuf_composite, 0, 0, 1, H_gdk_pixbuf_composite, pl_tuuiiiirrrrgi);
  s7_define_typed_function(sc, "gdk_pixbuf_composite_color", lg_gdk_pixbuf_composite_color, 0, 0, 1, H_gdk_pixbuf_composite_color, pl_tuuiiiirrrrgi);
  s7_define_typed_function(sc, "gdk_pixbuf_scale_simple", lg_gdk_pixbuf_scale_simple, 4, 0, 0, H_gdk_pixbuf_scale_simple, pl_puiig);
  s7_define_typed_function(sc, "gdk_pixbuf_composite_color_simple", lg_gdk_pixbuf_composite_color_simple, 0, 0, 1, H_gdk_pixbuf_composite_color_simple, pl_puiigi);
  s7_define_typed_function(sc, "gdk_pixbuf_get_option", lg_gdk_pixbuf_get_option, 2, 0, 0, H_gdk_pixbuf_get_option, pl_sus);
  s7_define_typed_function(sc, "gtk_accel_label_new", lg_gtk_accel_label_new, 1, 0, 0, H_gtk_accel_label_new, pl_ps);
  s7_define_typed_function(sc, "gtk_accel_label_get_accel_width", lg_gtk_accel_label_get_accel_width, 1, 0, 0, H_gtk_accel_label_get_accel_width, pl_iu);
  s7_define_typed_function(sc, "gtk_accel_label_refetch", lg_gtk_accel_label_refetch, 1, 0, 0, H_gtk_accel_label_refetch, pl_bu);
  s7_define_typed_function(sc, "gtk_adjustment_clamp_page", lg_gtk_adjustment_clamp_page, 3, 0, 0, H_gtk_adjustment_clamp_page, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_value", lg_gtk_adjustment_get_value, 1, 0, 0, H_gtk_adjustment_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_value", lg_gtk_adjustment_set_value, 2, 0, 0, H_gtk_adjustment_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_bin_get_child", lg_gtk_bin_get_child, 1, 0, 0, H_gtk_bin_get_child, pl_pu);
  s7_define_typed_function(sc, "gtk_box_set_homogeneous", lg_gtk_box_set_homogeneous, 2, 0, 0, H_gtk_box_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_box_get_homogeneous", lg_gtk_box_get_homogeneous, 1, 0, 0, H_gtk_box_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_box_set_spacing", lg_gtk_box_set_spacing, 2, 0, 0, H_gtk_box_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_box_get_spacing", lg_gtk_box_get_spacing, 1, 0, 0, H_gtk_box_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_button_new", lg_gtk_button_new, 0, 0, 0, H_gtk_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_button_new_with_label", lg_gtk_button_new_with_label, 1, 0, 0, H_gtk_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_button_new_with_mnemonic", lg_gtk_button_new_with_mnemonic, 1, 0, 0, H_gtk_button_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_button_set_label", lg_gtk_button_set_label, 2, 0, 0, H_gtk_button_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_button_get_label", lg_gtk_button_get_label, 1, 0, 0, H_gtk_button_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_button_set_use_underline", lg_gtk_button_set_use_underline, 2, 0, 0, H_gtk_button_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_button_get_use_underline", lg_gtk_button_get_use_underline, 1, 0, 0, H_gtk_button_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_new", lg_gtk_calendar_new, 0, 0, 0, H_gtk_calendar_new, pl_p);
  s7_define_typed_function(sc, "gtk_calendar_select_day", lg_gtk_calendar_select_day, 2, 0, 0, H_gtk_calendar_select_day, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_clear_marks", lg_gtk_calendar_clear_marks, 1, 0, 0, H_gtk_calendar_clear_marks, pl_tu);
  s7_define_typed_function(sc, "gtk_calendar_get_date", lg_gtk_calendar_get_date, 1, 3, 0, H_gtk_calendar_get_date, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_editable_start_editing", lg_gtk_cell_editable_start_editing, 2, 0, 0, H_gtk_cell_editable_start_editing, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_editable_editing_done", lg_gtk_cell_editable_editing_done, 1, 0, 0, H_gtk_cell_editable_editing_done, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_editable_remove_widget", lg_gtk_cell_editable_remove_widget, 1, 0, 0, H_gtk_cell_editable_remove_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_activate", lg_gtk_cell_renderer_activate, 7, 0, 0, H_gtk_cell_renderer_activate, pl_buuusuug);
  s7_define_typed_function(sc, "gtk_cell_renderer_start_editing", lg_gtk_cell_renderer_start_editing, 7, 0, 0, H_gtk_cell_renderer_start_editing, pl_puuusuug);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_fixed_size", lg_gtk_cell_renderer_set_fixed_size, 3, 0, 0, H_gtk_cell_renderer_set_fixed_size, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_fixed_size", lg_gtk_cell_renderer_get_fixed_size, 1, 2, 0, H_gtk_cell_renderer_get_fixed_size, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_pixbuf_new", lg_gtk_cell_renderer_pixbuf_new, 0, 0, 0, H_gtk_cell_renderer_pixbuf_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_text_new", lg_gtk_cell_renderer_text_new, 0, 0, 0, H_gtk_cell_renderer_text_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_text_set_fixed_height_from_font", lg_gtk_cell_renderer_text_set_fixed_height_from_font, 2, 0, 0, H_gtk_cell_renderer_text_set_fixed_height_from_font, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_new", lg_gtk_cell_renderer_toggle_new, 0, 0, 0, H_gtk_cell_renderer_toggle_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_get_radio", lg_gtk_cell_renderer_toggle_get_radio, 1, 0, 0, H_gtk_cell_renderer_toggle_get_radio, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_set_radio", lg_gtk_cell_renderer_toggle_set_radio, 2, 0, 0, H_gtk_cell_renderer_toggle_set_radio, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_get_active", lg_gtk_cell_renderer_toggle_get_active, 1, 0, 0, H_gtk_cell_renderer_toggle_get_active, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_set_active", lg_gtk_cell_renderer_toggle_set_active, 2, 0, 0, H_gtk_cell_renderer_toggle_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_check_button_new", lg_gtk_check_button_new, 0, 0, 0, H_gtk_check_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_check_button_new_with_label", lg_gtk_check_button_new_with_label, 1, 0, 0, H_gtk_check_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_check_button_new_with_mnemonic", lg_gtk_check_button_new_with_mnemonic, 1, 0, 0, H_gtk_check_button_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_container_add", lg_gtk_container_add, 2, 0, 0, H_gtk_container_add, pl_tu);
  s7_define_typed_function(sc, "gtk_container_remove", lg_gtk_container_remove, 2, 0, 0, H_gtk_container_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_container_foreach", lg_gtk_container_foreach, 3, 0, 0, H_gtk_container_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_container_get_children", lg_gtk_container_get_children, 1, 0, 0, H_gtk_container_get_children, pl_pu);
  s7_define_typed_function(sc, "gtk_dialog_new", lg_gtk_dialog_new, 0, 0, 0, H_gtk_dialog_new, pl_p);
  s7_define_typed_function(sc, "gtk_dialog_add_action_widget", lg_gtk_dialog_add_action_widget, 3, 0, 0, H_gtk_dialog_add_action_widget, pl_tuui);
  s7_define_typed_function(sc, "gtk_dialog_add_button", lg_gtk_dialog_add_button, 3, 0, 0, H_gtk_dialog_add_button, pl_pusi);
  s7_define_typed_function(sc, "gtk_dialog_add_buttons", lg_gtk_dialog_add_buttons, 2, 0, 0, H_gtk_dialog_add_buttons, pl_tut);
  s7_define_typed_function(sc, "gtk_dialog_set_response_sensitive", lg_gtk_dialog_set_response_sensitive, 3, 0, 0, H_gtk_dialog_set_response_sensitive, pl_tuib);
  s7_define_typed_function(sc, "gtk_dialog_set_default_response", lg_gtk_dialog_set_default_response, 2, 0, 0, H_gtk_dialog_set_default_response, pl_tui);
  s7_define_typed_function(sc, "gtk_dialog_response", lg_gtk_dialog_response, 2, 0, 0, H_gtk_dialog_response, pl_tui);
  s7_define_typed_function(sc, "gtk_dialog_run", lg_gtk_dialog_run, 1, 0, 0, H_gtk_dialog_run, pl_iu);
  s7_define_typed_function(sc, "gtk_drawing_area_new", lg_gtk_drawing_area_new, 0, 0, 0, H_gtk_drawing_area_new, pl_p);
  s7_define_typed_function(sc, "gtk_editable_select_region", lg_gtk_editable_select_region, 3, 0, 0, H_gtk_editable_select_region, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_selection_bounds", lg_gtk_editable_get_selection_bounds, 1, 2, 0, H_gtk_editable_get_selection_bounds, pl_pu);
  s7_define_typed_function(sc, "gtk_editable_insert_text", lg_gtk_editable_insert_text, 3, 1, 0, H_gtk_editable_insert_text, pl_pusiu);
  s7_define_typed_function(sc, "gtk_editable_delete_text", lg_gtk_editable_delete_text, 3, 0, 0, H_gtk_editable_delete_text, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_chars", lg_gtk_editable_get_chars, 3, 0, 0, H_gtk_editable_get_chars, pl_sui);
  s7_define_typed_function(sc, "gtk_editable_delete_selection", lg_gtk_editable_delete_selection, 1, 0, 0, H_gtk_editable_delete_selection, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_set_position", lg_gtk_editable_set_position, 2, 0, 0, H_gtk_editable_set_position, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_position", lg_gtk_editable_get_position, 1, 0, 0, H_gtk_editable_get_position, pl_iu);
  s7_define_typed_function(sc, "gtk_editable_set_editable", lg_gtk_editable_set_editable, 2, 0, 0, H_gtk_editable_set_editable, pl_tub);
  s7_define_typed_function(sc, "gtk_editable_get_editable", lg_gtk_editable_get_editable, 1, 0, 0, H_gtk_editable_get_editable, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_new", lg_gtk_entry_new, 0, 0, 0, H_gtk_entry_new, pl_p);
  s7_define_typed_function(sc, "gtk_entry_set_visibility", lg_gtk_entry_set_visibility, 2, 0, 0, H_gtk_entry_set_visibility, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_visibility", lg_gtk_entry_get_visibility, 1, 0, 0, H_gtk_entry_get_visibility, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_invisible_char", lg_gtk_entry_set_invisible_char, 2, 0, 0, H_gtk_entry_set_invisible_char, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_get_invisible_char", lg_gtk_entry_get_invisible_char, 1, 0, 0, H_gtk_entry_get_invisible_char, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_set_has_frame", lg_gtk_entry_set_has_frame, 2, 0, 0, H_gtk_entry_set_has_frame, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_has_frame", lg_gtk_entry_get_has_frame, 1, 0, 0, H_gtk_entry_get_has_frame, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_set_max_length", lg_gtk_entry_set_max_length, 2, 0, 0, H_gtk_entry_set_max_length, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_get_max_length", lg_gtk_entry_get_max_length, 1, 0, 0, H_gtk_entry_get_max_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_set_activates_default", lg_gtk_entry_set_activates_default, 2, 0, 0, H_gtk_entry_set_activates_default, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_activates_default", lg_gtk_entry_get_activates_default, 1, 0, 0, H_gtk_entry_get_activates_default, pl_bu);
  s7_define_typed_function(sc, "gtk_fixed_new", lg_gtk_fixed_new, 0, 0, 0, H_gtk_fixed_new, pl_p);
  s7_define_typed_function(sc, "gtk_fixed_put", lg_gtk_fixed_put, 4, 0, 0, H_gtk_fixed_put, pl_tuui);
  s7_define_typed_function(sc, "gtk_fixed_move", lg_gtk_fixed_move, 4, 0, 0, H_gtk_fixed_move, pl_tuui);
  s7_define_typed_function(sc, "gtk_frame_new", lg_gtk_frame_new, 1, 0, 0, H_gtk_frame_new, pl_ps);
  s7_define_typed_function(sc, "gtk_frame_set_label", lg_gtk_frame_set_label, 2, 0, 0, H_gtk_frame_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_frame_get_label", lg_gtk_frame_get_label, 1, 0, 0, H_gtk_frame_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_frame_set_label_widget", lg_gtk_frame_set_label_widget, 2, 0, 0, H_gtk_frame_set_label_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_frame_get_label_widget", lg_gtk_frame_get_label_widget, 1, 0, 0, H_gtk_frame_get_label_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_image_new", lg_gtk_image_new, 0, 0, 0, H_gtk_image_new, pl_p);
  s7_define_typed_function(sc, "gtk_image_new_from_file", lg_gtk_image_new_from_file, 1, 0, 0, H_gtk_image_new_from_file, pl_ps);
  s7_define_typed_function(sc, "gtk_image_new_from_pixbuf", lg_gtk_image_new_from_pixbuf, 1, 0, 0, H_gtk_image_new_from_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_image_set_from_file", lg_gtk_image_set_from_file, 2, 0, 0, H_gtk_image_set_from_file, pl_tus);
  s7_define_typed_function(sc, "gtk_image_set_from_pixbuf", lg_gtk_image_set_from_pixbuf, 2, 0, 0, H_gtk_image_set_from_pixbuf, pl_tu);
  s7_define_typed_function(sc, "gtk_image_get_storage_type", lg_gtk_image_get_storage_type, 1, 0, 0, H_gtk_image_get_storage_type, pl_gu);
  s7_define_typed_function(sc, "gtk_im_context_get_preedit_string", lg_gtk_im_context_get_preedit_string, 1, 3, 0, H_gtk_im_context_get_preedit_string, pl_pu);
  s7_define_typed_function(sc, "gtk_im_context_filter_keypress", lg_gtk_im_context_filter_keypress, 2, 0, 0, H_gtk_im_context_filter_keypress, pl_bu);
  s7_define_typed_function(sc, "gtk_im_context_focus_in", lg_gtk_im_context_focus_in, 1, 0, 0, H_gtk_im_context_focus_in, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_focus_out", lg_gtk_im_context_focus_out, 1, 0, 0, H_gtk_im_context_focus_out, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_reset", lg_gtk_im_context_reset, 1, 0, 0, H_gtk_im_context_reset, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_set_cursor_location", lg_gtk_im_context_set_cursor_location, 2, 0, 0, H_gtk_im_context_set_cursor_location, pl_tu);
  s7_define_typed_function(sc, "gtk_im_context_set_use_preedit", lg_gtk_im_context_set_use_preedit, 2, 0, 0, H_gtk_im_context_set_use_preedit, pl_tub);
  s7_define_typed_function(sc, "gtk_im_context_set_surrounding", lg_gtk_im_context_set_surrounding, 4, 0, 0, H_gtk_im_context_set_surrounding, pl_tusi);
  s7_define_typed_function(sc, "gtk_im_context_get_surrounding", lg_gtk_im_context_get_surrounding, 1, 2, 0, H_gtk_im_context_get_surrounding, pl_pu);
  s7_define_typed_function(sc, "gtk_im_context_delete_surrounding", lg_gtk_im_context_delete_surrounding, 3, 0, 0, H_gtk_im_context_delete_surrounding, pl_bui);
  s7_define_typed_function(sc, "gtk_im_context_simple_new", lg_gtk_im_context_simple_new, 0, 0, 0, H_gtk_im_context_simple_new, pl_p);
  s7_define_typed_function(sc, "gtk_im_context_simple_add_table", lg_gtk_im_context_simple_add_table, 4, 0, 0, H_gtk_im_context_simple_add_table, pl_tuui);
  s7_define_typed_function(sc, "gtk_label_new", lg_gtk_label_new, 1, 0, 0, H_gtk_label_new, pl_ps);
  s7_define_typed_function(sc, "gtk_label_new_with_mnemonic", lg_gtk_label_new_with_mnemonic, 1, 0, 0, H_gtk_label_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_label_set_text", lg_gtk_label_set_text, 2, 0, 0, H_gtk_label_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_label_get_text", lg_gtk_label_get_text, 1, 0, 0, H_gtk_label_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_label_set_attributes", lg_gtk_label_set_attributes, 2, 0, 0, H_gtk_label_set_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_label_get_attributes", lg_gtk_label_get_attributes, 1, 0, 0, H_gtk_label_get_attributes, pl_pu);
  s7_define_typed_function(sc, "gtk_label_set_label", lg_gtk_label_set_label, 2, 0, 0, H_gtk_label_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_label_get_label", lg_gtk_label_get_label, 1, 0, 0, H_gtk_label_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_label_set_markup", lg_gtk_label_set_markup, 2, 0, 0, H_gtk_label_set_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_label_set_use_markup", lg_gtk_label_set_use_markup, 2, 0, 0, H_gtk_label_set_use_markup, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_use_markup", lg_gtk_label_get_use_markup, 1, 0, 0, H_gtk_label_get_use_markup, pl_bu);
  s7_define_typed_function(sc, "gtk_label_set_use_underline", lg_gtk_label_set_use_underline, 2, 0, 0, H_gtk_label_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_use_underline", lg_gtk_label_get_use_underline, 1, 0, 0, H_gtk_label_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_label_set_markup_with_mnemonic", lg_gtk_label_set_markup_with_mnemonic, 2, 0, 0, H_gtk_label_set_markup_with_mnemonic, pl_tus);
  s7_define_typed_function(sc, "gtk_label_get_mnemonic_keyval", lg_gtk_label_get_mnemonic_keyval, 1, 0, 0, H_gtk_label_get_mnemonic_keyval, pl_iu);
  s7_define_typed_function(sc, "gtk_label_set_mnemonic_widget", lg_gtk_label_set_mnemonic_widget, 2, 0, 0, H_gtk_label_set_mnemonic_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_label_get_mnemonic_widget", lg_gtk_label_get_mnemonic_widget, 1, 0, 0, H_gtk_label_get_mnemonic_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_label_set_text_with_mnemonic", lg_gtk_label_set_text_with_mnemonic, 2, 0, 0, H_gtk_label_set_text_with_mnemonic, pl_tus);
  s7_define_typed_function(sc, "gtk_label_set_justify", lg_gtk_label_set_justify, 2, 0, 0, H_gtk_label_set_justify, pl_tug);
  s7_define_typed_function(sc, "gtk_label_get_justify", lg_gtk_label_get_justify, 1, 0, 0, H_gtk_label_get_justify, pl_gu);
  s7_define_typed_function(sc, "gtk_label_set_pattern", lg_gtk_label_set_pattern, 2, 0, 0, H_gtk_label_set_pattern, pl_tus);
  s7_define_typed_function(sc, "gtk_label_set_selectable", lg_gtk_label_set_selectable, 2, 0, 0, H_gtk_label_set_selectable, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_selectable", lg_gtk_label_get_selectable, 1, 0, 0, H_gtk_label_get_selectable, pl_bu);
  s7_define_typed_function(sc, "gtk_label_select_region", lg_gtk_label_select_region, 3, 0, 0, H_gtk_label_select_region, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_selection_bounds", lg_gtk_label_get_selection_bounds, 1, 2, 0, H_gtk_label_get_selection_bounds, pl_pu);
  s7_define_typed_function(sc, "gtk_label_get_layout", lg_gtk_label_get_layout, 1, 0, 0, H_gtk_label_get_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_label_get_layout_offsets", lg_gtk_label_get_layout_offsets, 1, 2, 0, H_gtk_label_get_layout_offsets, pl_pu);
  s7_define_typed_function(sc, "gtk_list_store_new", lg_gtk_list_store_new, 2, 0, 0, H_gtk_list_store_new, pl_pit);
  s7_define_typed_function(sc, "gtk_list_store_newv", lg_gtk_list_store_newv, 2, 0, 0, H_gtk_list_store_newv, pl_piu);
  s7_define_typed_function(sc, "gtk_list_store_set_column_types", lg_gtk_list_store_set_column_types, 3, 0, 0, H_gtk_list_store_set_column_types, pl_tuiu);
  s7_define_typed_function(sc, "gtk_list_store_set", lg_gtk_list_store_set, 3, 0, 0, H_gtk_list_store_set, pl_tuut);
  s7_define_typed_function(sc, "gtk_list_store_insert", lg_gtk_list_store_insert, 3, 0, 0, H_gtk_list_store_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_list_store_insert_before", lg_gtk_list_store_insert_before, 3, 0, 0, H_gtk_list_store_insert_before, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_insert_after", lg_gtk_list_store_insert_after, 3, 0, 0, H_gtk_list_store_insert_after, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_prepend", lg_gtk_list_store_prepend, 2, 0, 0, H_gtk_list_store_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_append", lg_gtk_list_store_append, 2, 0, 0, H_gtk_list_store_append, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_clear", lg_gtk_list_store_clear, 1, 0, 0, H_gtk_list_store_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_check_version", lg_gtk_check_version, 3, 0, 0, H_gtk_check_version, pl_si);
  s7_define_typed_function(sc, "gtk_disable_setlocale", lg_gtk_disable_setlocale, 0, 0, 0, H_gtk_disable_setlocale, pl_t);
  s7_define_typed_function(sc, "gtk_get_default_language", lg_gtk_get_default_language, 0, 0, 0, H_gtk_get_default_language, pl_p);
  s7_define_typed_function(sc, "gtk_events_pending", lg_gtk_events_pending, 0, 0, 0, H_gtk_events_pending, pl_i);
  s7_define_typed_function(sc, "gtk_menu_bar_new", lg_gtk_menu_bar_new, 0, 0, 0, H_gtk_menu_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_notebook_new", lg_gtk_notebook_new, 0, 0, 0, H_gtk_notebook_new, pl_p);
  s7_define_typed_function(sc, "gtk_notebook_remove_page", lg_gtk_notebook_remove_page, 2, 0, 0, H_gtk_notebook_remove_page, pl_tui);
  s7_define_typed_function(sc, "gtk_notebook_get_current_page", lg_gtk_notebook_get_current_page, 1, 0, 0, H_gtk_notebook_get_current_page, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_get_nth_page", lg_gtk_notebook_get_nth_page, 2, 0, 0, H_gtk_notebook_get_nth_page, pl_pui);
  s7_define_typed_function(sc, "gtk_notebook_page_num", lg_gtk_notebook_page_num, 2, 0, 0, H_gtk_notebook_page_num, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_set_current_page", lg_gtk_notebook_set_current_page, 2, 0, 0, H_gtk_notebook_set_current_page, pl_tui);
  s7_define_typed_function(sc, "gtk_notebook_next_page", lg_gtk_notebook_next_page, 1, 0, 0, H_gtk_notebook_next_page, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_prev_page", lg_gtk_notebook_prev_page, 1, 0, 0, H_gtk_notebook_prev_page, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_show_border", lg_gtk_notebook_set_show_border, 2, 0, 0, H_gtk_notebook_set_show_border, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_show_border", lg_gtk_notebook_get_show_border, 1, 0, 0, H_gtk_notebook_get_show_border, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_show_tabs", lg_gtk_notebook_set_show_tabs, 2, 0, 0, H_gtk_notebook_set_show_tabs, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_show_tabs", lg_gtk_notebook_get_show_tabs, 1, 0, 0, H_gtk_notebook_get_show_tabs, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_pos", lg_gtk_notebook_set_tab_pos, 2, 0, 0, H_gtk_notebook_set_tab_pos, pl_tug);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_pos", lg_gtk_notebook_get_tab_pos, 1, 0, 0, H_gtk_notebook_get_tab_pos, pl_gu);
  s7_define_typed_function(sc, "gtk_notebook_set_scrollable", lg_gtk_notebook_set_scrollable, 2, 0, 0, H_gtk_notebook_set_scrollable, pl_tub);
  s7_define_typed_function(sc, "gtk_notebook_get_scrollable", lg_gtk_notebook_get_scrollable, 1, 0, 0, H_gtk_notebook_get_scrollable, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_popup_enable", lg_gtk_notebook_popup_enable, 1, 0, 0, H_gtk_notebook_popup_enable, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_popup_disable", lg_gtk_notebook_popup_disable, 1, 0, 0, H_gtk_notebook_popup_disable, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_label", lg_gtk_notebook_get_tab_label, 2, 0, 0, H_gtk_notebook_get_tab_label, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_label", lg_gtk_notebook_set_tab_label, 3, 0, 0, H_gtk_notebook_set_tab_label, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_label_text", lg_gtk_notebook_set_tab_label_text, 3, 0, 0, H_gtk_notebook_set_tab_label_text, pl_tuus);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_label_text", lg_gtk_notebook_get_tab_label_text, 2, 0, 0, H_gtk_notebook_get_tab_label_text, pl_su);
  s7_define_typed_function(sc, "gtk_notebook_get_menu_label", lg_gtk_notebook_get_menu_label, 2, 0, 0, H_gtk_notebook_get_menu_label, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_set_menu_label", lg_gtk_notebook_set_menu_label, 3, 0, 0, H_gtk_notebook_set_menu_label, pl_tu);
  s7_define_typed_function(sc, "gtk_notebook_set_menu_label_text", lg_gtk_notebook_set_menu_label_text, 3, 0, 0, H_gtk_notebook_set_menu_label_text, pl_tuus);
  s7_define_typed_function(sc, "gtk_notebook_get_menu_label_text", lg_gtk_notebook_get_menu_label_text, 2, 0, 0, H_gtk_notebook_get_menu_label_text, pl_su);
  s7_define_typed_function(sc, "gtk_notebook_reorder_child", lg_gtk_notebook_reorder_child, 3, 0, 0, H_gtk_notebook_reorder_child, pl_tuui);
  s7_define_typed_function(sc, "gtk_notebook_append_page", lg_gtk_notebook_append_page, 3, 0, 0, H_gtk_notebook_append_page, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_append_page_menu", lg_gtk_notebook_append_page_menu, 4, 0, 0, H_gtk_notebook_append_page_menu, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_prepend_page", lg_gtk_notebook_prepend_page, 3, 0, 0, H_gtk_notebook_prepend_page, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_prepend_page_menu", lg_gtk_notebook_prepend_page_menu, 4, 0, 0, H_gtk_notebook_prepend_page_menu, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_insert_page", lg_gtk_notebook_insert_page, 4, 0, 0, H_gtk_notebook_insert_page, pl_iuuui);
  s7_define_typed_function(sc, "gtk_notebook_insert_page_menu", lg_gtk_notebook_insert_page_menu, 5, 0, 0, H_gtk_notebook_insert_page_menu, pl_iuuuui);
  s7_define_typed_function(sc, "gtk_paned_add1", lg_gtk_paned_add1, 2, 0, 0, H_gtk_paned_add1, pl_tu);
  s7_define_typed_function(sc, "gtk_paned_add2", lg_gtk_paned_add2, 2, 0, 0, H_gtk_paned_add2, pl_tu);
  s7_define_typed_function(sc, "gtk_paned_pack1", lg_gtk_paned_pack1, 4, 0, 0, H_gtk_paned_pack1, pl_tuub);
  s7_define_typed_function(sc, "gtk_paned_pack2", lg_gtk_paned_pack2, 4, 0, 0, H_gtk_paned_pack2, pl_tuub);
  s7_define_typed_function(sc, "gtk_paned_get_position", lg_gtk_paned_get_position, 1, 0, 0, H_gtk_paned_get_position, pl_iu);
  s7_define_typed_function(sc, "gtk_paned_set_position", lg_gtk_paned_set_position, 2, 0, 0, H_gtk_paned_set_position, pl_tui);
  s7_define_typed_function(sc, "gtk_progress_bar_new", lg_gtk_progress_bar_new, 0, 0, 0, H_gtk_progress_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_progress_bar_pulse", lg_gtk_progress_bar_pulse, 1, 0, 0, H_gtk_progress_bar_pulse, pl_tu);
  s7_define_typed_function(sc, "gtk_progress_bar_set_text", lg_gtk_progress_bar_set_text, 2, 0, 0, H_gtk_progress_bar_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_progress_bar_set_fraction", lg_gtk_progress_bar_set_fraction, 2, 0, 0, H_gtk_progress_bar_set_fraction, pl_tur);
  s7_define_typed_function(sc, "gtk_progress_bar_set_pulse_step", lg_gtk_progress_bar_set_pulse_step, 2, 0, 0, H_gtk_progress_bar_set_pulse_step, pl_tur);
  s7_define_typed_function(sc, "gtk_progress_bar_get_text", lg_gtk_progress_bar_get_text, 1, 0, 0, H_gtk_progress_bar_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_progress_bar_get_fraction", lg_gtk_progress_bar_get_fraction, 1, 0, 0, H_gtk_progress_bar_get_fraction, pl_du);
  s7_define_typed_function(sc, "gtk_progress_bar_get_pulse_step", lg_gtk_progress_bar_get_pulse_step, 1, 0, 0, H_gtk_progress_bar_get_pulse_step, pl_du);
  s7_define_typed_function(sc, "gtk_radio_button_new", lg_gtk_radio_button_new, 1, 0, 0, H_gtk_radio_button_new, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_button_new_from_widget", lg_gtk_radio_button_new_from_widget, 1, 0, 0, H_gtk_radio_button_new_from_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_label", lg_gtk_radio_button_new_with_label, 2, 0, 0, H_gtk_radio_button_new_with_label, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_label_from_widget", lg_gtk_radio_button_new_with_label_from_widget, 2, 0, 0, H_gtk_radio_button_new_with_label_from_widget, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_mnemonic", lg_gtk_radio_button_new_with_mnemonic, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_new_with_mnemonic_from_widget", lg_gtk_radio_button_new_with_mnemonic_from_widget, 2, 0, 0, H_gtk_radio_button_new_with_mnemonic_from_widget, pl_pus);
  s7_define_typed_function(sc, "gtk_radio_button_get_group", lg_gtk_radio_button_get_group, 1, 0, 0, H_gtk_radio_button_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_radio_button_set_group", lg_gtk_radio_button_set_group, 2, 0, 0, H_gtk_radio_button_set_group, pl_tu);
  s7_define_typed_function(sc, "gtk_range_set_adjustment", lg_gtk_range_set_adjustment, 2, 0, 0, H_gtk_range_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_range_get_adjustment", lg_gtk_range_get_adjustment, 1, 0, 0, H_gtk_range_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_range_set_inverted", lg_gtk_range_set_inverted, 2, 0, 0, H_gtk_range_set_inverted, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_inverted", lg_gtk_range_get_inverted, 1, 0, 0, H_gtk_range_get_inverted, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_increments", lg_gtk_range_set_increments, 3, 0, 0, H_gtk_range_set_increments, pl_tur);
  s7_define_typed_function(sc, "gtk_range_set_range", lg_gtk_range_set_range, 3, 0, 0, H_gtk_range_set_range, pl_tur);
  s7_define_typed_function(sc, "gtk_range_set_value", lg_gtk_range_set_value, 2, 0, 0, H_gtk_range_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_range_get_value", lg_gtk_range_get_value, 1, 0, 0, H_gtk_range_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_scale_set_digits", lg_gtk_scale_set_digits, 2, 0, 0, H_gtk_scale_set_digits, pl_tui);
  s7_define_typed_function(sc, "gtk_scale_get_digits", lg_gtk_scale_get_digits, 1, 0, 0, H_gtk_scale_get_digits, pl_iu);
  s7_define_typed_function(sc, "gtk_scale_set_draw_value", lg_gtk_scale_set_draw_value, 2, 0, 0, H_gtk_scale_set_draw_value, pl_tub);
  s7_define_typed_function(sc, "gtk_scale_get_draw_value", lg_gtk_scale_get_draw_value, 1, 0, 0, H_gtk_scale_get_draw_value, pl_bu);
  s7_define_typed_function(sc, "gtk_scale_set_value_pos", lg_gtk_scale_set_value_pos, 2, 0, 0, H_gtk_scale_set_value_pos, pl_tug);
  s7_define_typed_function(sc, "gtk_scale_get_value_pos", lg_gtk_scale_get_value_pos, 1, 0, 0, H_gtk_scale_get_value_pos, pl_gu);
  s7_define_typed_function(sc, "gtk_scrolled_window_new", lg_gtk_scrolled_window_new, 2, 0, 0, H_gtk_scrolled_window_new, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_hadjustment", lg_gtk_scrolled_window_set_hadjustment, 2, 0, 0, H_gtk_scrolled_window_set_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_vadjustment", lg_gtk_scrolled_window_set_vadjustment, 2, 0, 0, H_gtk_scrolled_window_set_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_hadjustment", lg_gtk_scrolled_window_get_hadjustment, 1, 0, 0, H_gtk_scrolled_window_get_hadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_vadjustment", lg_gtk_scrolled_window_get_vadjustment, 1, 0, 0, H_gtk_scrolled_window_get_vadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_policy", lg_gtk_scrolled_window_set_policy, 3, 0, 0, H_gtk_scrolled_window_set_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_policy", lg_gtk_scrolled_window_get_policy, 1, 2, 0, H_gtk_scrolled_window_get_policy, pl_pu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_placement", lg_gtk_scrolled_window_set_placement, 2, 0, 0, H_gtk_scrolled_window_set_placement, pl_tug);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_placement", lg_gtk_scrolled_window_get_placement, 1, 0, 0, H_gtk_scrolled_window_get_placement, pl_gu);
  s7_define_typed_function(sc, "gtk_settings_get_default", lg_gtk_settings_get_default, 0, 0, 0, H_gtk_settings_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_size_group_new", lg_gtk_size_group_new, 1, 0, 0, H_gtk_size_group_new, pl_pg);
  s7_define_typed_function(sc, "gtk_size_group_set_mode", lg_gtk_size_group_set_mode, 2, 0, 0, H_gtk_size_group_set_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_size_group_get_mode", lg_gtk_size_group_get_mode, 1, 0, 0, H_gtk_size_group_get_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_size_group_add_widget", lg_gtk_size_group_add_widget, 2, 0, 0, H_gtk_size_group_add_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_size_group_remove_widget", lg_gtk_size_group_remove_widget, 2, 0, 0, H_gtk_size_group_remove_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_spin_button_configure", lg_gtk_spin_button_configure, 4, 0, 0, H_gtk_spin_button_configure, pl_tuuri);
  s7_define_typed_function(sc, "gtk_spin_button_new", lg_gtk_spin_button_new, 3, 0, 0, H_gtk_spin_button_new, pl_puri);
  s7_define_typed_function(sc, "gtk_spin_button_new_with_range", lg_gtk_spin_button_new_with_range, 3, 0, 0, H_gtk_spin_button_new_with_range, pl_pr);
  s7_define_typed_function(sc, "gtk_spin_button_set_adjustment", lg_gtk_spin_button_set_adjustment, 2, 0, 0, H_gtk_spin_button_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_spin_button_get_adjustment", lg_gtk_spin_button_get_adjustment, 1, 0, 0, H_gtk_spin_button_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_spin_button_set_digits", lg_gtk_spin_button_set_digits, 2, 0, 0, H_gtk_spin_button_set_digits, pl_tui);
  s7_define_typed_function(sc, "gtk_spin_button_get_digits", lg_gtk_spin_button_get_digits, 1, 0, 0, H_gtk_spin_button_get_digits, pl_iu);
  s7_define_typed_function(sc, "gtk_spin_button_set_increments", lg_gtk_spin_button_set_increments, 3, 0, 0, H_gtk_spin_button_set_increments, pl_tur);
  s7_define_typed_function(sc, "gtk_spin_button_get_increments", lg_gtk_spin_button_get_increments, 1, 2, 0, H_gtk_spin_button_get_increments, pl_pu);
  s7_define_typed_function(sc, "gtk_spin_button_set_range", lg_gtk_spin_button_set_range, 3, 0, 0, H_gtk_spin_button_set_range, pl_tur);
  s7_define_typed_function(sc, "gtk_spin_button_get_range", lg_gtk_spin_button_get_range, 1, 2, 0, H_gtk_spin_button_get_range, pl_pu);
  s7_define_typed_function(sc, "gtk_spin_button_get_value", lg_gtk_spin_button_get_value, 1, 0, 0, H_gtk_spin_button_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_spin_button_get_value_as_int", lg_gtk_spin_button_get_value_as_int, 1, 0, 0, H_gtk_spin_button_get_value_as_int, pl_iu);
  s7_define_typed_function(sc, "gtk_spin_button_set_value", lg_gtk_spin_button_set_value, 2, 0, 0, H_gtk_spin_button_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_spin_button_set_update_policy", lg_gtk_spin_button_set_update_policy, 2, 0, 0, H_gtk_spin_button_set_update_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_spin_button_get_update_policy", lg_gtk_spin_button_get_update_policy, 1, 0, 0, H_gtk_spin_button_get_update_policy, pl_gu);
  s7_define_typed_function(sc, "gtk_spin_button_set_numeric", lg_gtk_spin_button_set_numeric, 2, 0, 0, H_gtk_spin_button_set_numeric, pl_tub);
  s7_define_typed_function(sc, "gtk_spin_button_get_numeric", lg_gtk_spin_button_get_numeric, 1, 0, 0, H_gtk_spin_button_get_numeric, pl_bu);
  s7_define_typed_function(sc, "gtk_spin_button_spin", lg_gtk_spin_button_spin, 3, 0, 0, H_gtk_spin_button_spin, pl_tugr);
  s7_define_typed_function(sc, "gtk_spin_button_set_wrap", lg_gtk_spin_button_set_wrap, 2, 0, 0, H_gtk_spin_button_set_wrap, pl_tub);
  s7_define_typed_function(sc, "gtk_spin_button_get_wrap", lg_gtk_spin_button_get_wrap, 1, 0, 0, H_gtk_spin_button_get_wrap, pl_bu);
  s7_define_typed_function(sc, "gtk_spin_button_set_snap_to_ticks", lg_gtk_spin_button_set_snap_to_ticks, 2, 0, 0, H_gtk_spin_button_set_snap_to_ticks, pl_tub);
  s7_define_typed_function(sc, "gtk_spin_button_get_snap_to_ticks", lg_gtk_spin_button_get_snap_to_ticks, 1, 0, 0, H_gtk_spin_button_get_snap_to_ticks, pl_bu);
  s7_define_typed_function(sc, "gtk_spin_button_update", lg_gtk_spin_button_update, 1, 0, 0, H_gtk_spin_button_update, pl_tu);
  s7_define_typed_function(sc, "gtk_statusbar_new", lg_gtk_statusbar_new, 0, 0, 0, H_gtk_statusbar_new, pl_p);
  s7_define_typed_function(sc, "gtk_statusbar_get_context_id", lg_gtk_statusbar_get_context_id, 2, 0, 0, H_gtk_statusbar_get_context_id, pl_ius);
  s7_define_typed_function(sc, "gtk_statusbar_push", lg_gtk_statusbar_push, 3, 0, 0, H_gtk_statusbar_push, pl_iuis);
  s7_define_typed_function(sc, "gtk_statusbar_pop", lg_gtk_statusbar_pop, 2, 0, 0, H_gtk_statusbar_pop, pl_tui);
  s7_define_typed_function(sc, "gtk_statusbar_remove", lg_gtk_statusbar_remove, 3, 0, 0, H_gtk_statusbar_remove, pl_tui);
  s7_define_typed_function(sc, "gtk_text_buffer_new", lg_gtk_text_buffer_new, 1, 0, 0, H_gtk_text_buffer_new, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_line_count", lg_gtk_text_buffer_get_line_count, 1, 0, 0, H_gtk_text_buffer_get_line_count, pl_iu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_char_count", lg_gtk_text_buffer_get_char_count, 1, 0, 0, H_gtk_text_buffer_get_char_count, pl_iu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_tag_table", lg_gtk_text_buffer_get_tag_table, 1, 0, 0, H_gtk_text_buffer_get_tag_table, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_set_text", lg_gtk_text_buffer_set_text, 3, 0, 0, H_gtk_text_buffer_set_text, pl_tusi);
  s7_define_typed_function(sc, "gtk_text_buffer_insert", lg_gtk_text_buffer_insert, 4, 0, 0, H_gtk_text_buffer_insert, pl_tuusi);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_at_cursor", lg_gtk_text_buffer_insert_at_cursor, 3, 0, 0, H_gtk_text_buffer_insert_at_cursor, pl_tusi);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_interactive", lg_gtk_text_buffer_insert_interactive, 5, 0, 0, H_gtk_text_buffer_insert_interactive, pl_buusib);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_interactive_at_cursor", lg_gtk_text_buffer_insert_interactive_at_cursor, 4, 0, 0, H_gtk_text_buffer_insert_interactive_at_cursor, pl_busib);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_range", lg_gtk_text_buffer_insert_range, 4, 0, 0, H_gtk_text_buffer_insert_range, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_range_interactive", lg_gtk_text_buffer_insert_range_interactive, 5, 0, 0, H_gtk_text_buffer_insert_range_interactive, pl_buuuub);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_with_tags", lg_gtk_text_buffer_insert_with_tags, 5, 0, 0, H_gtk_text_buffer_insert_with_tags, pl_tuusit);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_with_tags_by_name", lg_gtk_text_buffer_insert_with_tags_by_name, 5, 0, 0, H_gtk_text_buffer_insert_with_tags_by_name, pl_tuusit);
  s7_define_typed_function(sc, "gtk_text_buffer_delete", lg_gtk_text_buffer_delete, 3, 0, 0, H_gtk_text_buffer_delete, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_interactive", lg_gtk_text_buffer_delete_interactive, 4, 0, 0, H_gtk_text_buffer_delete_interactive, pl_buuub);
  s7_define_typed_function(sc, "gtk_text_buffer_get_text", lg_gtk_text_buffer_get_text, 4, 0, 0, H_gtk_text_buffer_get_text, pl_suuub);
  s7_define_typed_function(sc, "gtk_text_buffer_get_slice", lg_gtk_text_buffer_get_slice, 4, 0, 0, H_gtk_text_buffer_get_slice, pl_suuub);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_child_anchor", lg_gtk_text_buffer_insert_child_anchor, 3, 0, 0, H_gtk_text_buffer_insert_child_anchor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_create_child_anchor", lg_gtk_text_buffer_create_child_anchor, 2, 0, 0, H_gtk_text_buffer_create_child_anchor, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_create_mark", lg_gtk_text_buffer_create_mark, 4, 0, 0, H_gtk_text_buffer_create_mark, pl_pusub);
  s7_define_typed_function(sc, "gtk_text_buffer_move_mark", lg_gtk_text_buffer_move_mark, 3, 0, 0, H_gtk_text_buffer_move_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_mark", lg_gtk_text_buffer_delete_mark, 2, 0, 0, H_gtk_text_buffer_delete_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_mark", lg_gtk_text_buffer_get_mark, 2, 0, 0, H_gtk_text_buffer_get_mark, pl_pus);
  s7_define_typed_function(sc, "gtk_text_buffer_move_mark_by_name", lg_gtk_text_buffer_move_mark_by_name, 3, 0, 0, H_gtk_text_buffer_move_mark_by_name, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_mark_by_name", lg_gtk_text_buffer_delete_mark_by_name, 2, 0, 0, H_gtk_text_buffer_delete_mark_by_name, pl_tus);
  s7_define_typed_function(sc, "gtk_text_buffer_get_insert", lg_gtk_text_buffer_get_insert, 1, 0, 0, H_gtk_text_buffer_get_insert, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_selection_bound", lg_gtk_text_buffer_get_selection_bound, 1, 0, 0, H_gtk_text_buffer_get_selection_bound, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_place_cursor", lg_gtk_text_buffer_place_cursor, 2, 0, 0, H_gtk_text_buffer_place_cursor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_apply_tag", lg_gtk_text_buffer_apply_tag, 4, 0, 0, H_gtk_text_buffer_apply_tag, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_tag", lg_gtk_text_buffer_remove_tag, 4, 0, 0, H_gtk_text_buffer_remove_tag, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_apply_tag_by_name", lg_gtk_text_buffer_apply_tag_by_name, 4, 0, 0, H_gtk_text_buffer_apply_tag_by_name, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_tag_by_name", lg_gtk_text_buffer_remove_tag_by_name, 4, 0, 0, H_gtk_text_buffer_remove_tag_by_name, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_all_tags", lg_gtk_text_buffer_remove_all_tags, 3, 0, 0, H_gtk_text_buffer_remove_all_tags, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_create_tag", lg_gtk_text_buffer_create_tag, 2, 1, 0, H_gtk_text_buffer_create_tag, pl_pust);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_line_offset", lg_gtk_text_buffer_get_iter_at_line_offset, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_offset, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_line_index", lg_gtk_text_buffer_get_iter_at_line_index, 4, 0, 0, H_gtk_text_buffer_get_iter_at_line_index, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_offset", lg_gtk_text_buffer_get_iter_at_offset, 3, 0, 0, H_gtk_text_buffer_get_iter_at_offset, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_line", lg_gtk_text_buffer_get_iter_at_line, 3, 0, 0, H_gtk_text_buffer_get_iter_at_line, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_buffer_get_start_iter", lg_gtk_text_buffer_get_start_iter, 2, 0, 0, H_gtk_text_buffer_get_start_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_end_iter", lg_gtk_text_buffer_get_end_iter, 2, 0, 0, H_gtk_text_buffer_get_end_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_bounds", lg_gtk_text_buffer_get_bounds, 3, 0, 0, H_gtk_text_buffer_get_bounds, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_mark", lg_gtk_text_buffer_get_iter_at_mark, 3, 0, 0, H_gtk_text_buffer_get_iter_at_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_iter_at_child_anchor", lg_gtk_text_buffer_get_iter_at_child_anchor, 3, 0, 0, H_gtk_text_buffer_get_iter_at_child_anchor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_modified", lg_gtk_text_buffer_get_modified, 1, 0, 0, H_gtk_text_buffer_get_modified, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_set_modified", lg_gtk_text_buffer_set_modified, 2, 0, 0, H_gtk_text_buffer_set_modified, pl_tub);
  s7_define_typed_function(sc, "gtk_text_buffer_get_selection_bounds", lg_gtk_text_buffer_get_selection_bounds, 3, 0, 0, H_gtk_text_buffer_get_selection_bounds, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_delete_selection", lg_gtk_text_buffer_delete_selection, 3, 0, 0, H_gtk_text_buffer_delete_selection, pl_bub);
  s7_define_typed_function(sc, "gtk_text_buffer_begin_user_action", lg_gtk_text_buffer_begin_user_action, 1, 0, 0, H_gtk_text_buffer_begin_user_action, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_end_user_action", lg_gtk_text_buffer_end_user_action, 1, 0, 0, H_gtk_text_buffer_end_user_action, pl_tu);
  s7_define_typed_function(sc, "gtk_text_child_anchor_new", lg_gtk_text_child_anchor_new, 0, 0, 0, H_gtk_text_child_anchor_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_child_anchor_get_widgets", lg_gtk_text_child_anchor_get_widgets, 1, 0, 0, H_gtk_text_child_anchor_get_widgets, pl_pu);
  s7_define_typed_function(sc, "gtk_text_child_anchor_get_deleted", lg_gtk_text_child_anchor_get_deleted, 1, 0, 0, H_gtk_text_child_anchor_get_deleted, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_buffer", lg_gtk_text_iter_get_buffer, 1, 0, 0, H_gtk_text_iter_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_copy", lg_gtk_text_iter_copy, 1, 0, 0, H_gtk_text_iter_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_free", lg_gtk_text_iter_free, 1, 0, 0, H_gtk_text_iter_free, pl_tu);
  s7_define_typed_function(sc, "gtk_text_iter_get_offset", lg_gtk_text_iter_get_offset, 1, 0, 0, H_gtk_text_iter_get_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_line", lg_gtk_text_iter_get_line, 1, 0, 0, H_gtk_text_iter_get_line, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_line_offset", lg_gtk_text_iter_get_line_offset, 1, 0, 0, H_gtk_text_iter_get_line_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_line_index", lg_gtk_text_iter_get_line_index, 1, 0, 0, H_gtk_text_iter_get_line_index, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_line_offset", lg_gtk_text_iter_get_visible_line_offset, 1, 0, 0, H_gtk_text_iter_get_visible_line_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_line_index", lg_gtk_text_iter_get_visible_line_index, 1, 0, 0, H_gtk_text_iter_get_visible_line_index, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_char", lg_gtk_text_iter_get_char, 1, 0, 0, H_gtk_text_iter_get_char, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_slice", lg_gtk_text_iter_get_slice, 2, 0, 0, H_gtk_text_iter_get_slice, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_text", lg_gtk_text_iter_get_text, 2, 0, 0, H_gtk_text_iter_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_slice", lg_gtk_text_iter_get_visible_slice, 2, 0, 0, H_gtk_text_iter_get_visible_slice, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_visible_text", lg_gtk_text_iter_get_visible_text, 2, 0, 0, H_gtk_text_iter_get_visible_text, pl_su);
  s7_define_typed_function(sc, "gtk_text_iter_get_marks", lg_gtk_text_iter_get_marks, 1, 0, 0, H_gtk_text_iter_get_marks, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_get_child_anchor", lg_gtk_text_iter_get_child_anchor, 1, 0, 0, H_gtk_text_iter_get_child_anchor, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_get_toggled_tags", lg_gtk_text_iter_get_toggled_tags, 2, 0, 0, H_gtk_text_iter_get_toggled_tags, pl_pub);
  s7_define_typed_function(sc, "gtk_text_iter_ends_tag", lg_gtk_text_iter_ends_tag, 2, 0, 0, H_gtk_text_iter_ends_tag, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_toggles_tag", lg_gtk_text_iter_toggles_tag, 2, 0, 0, H_gtk_text_iter_toggles_tag, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_has_tag", lg_gtk_text_iter_has_tag, 2, 0, 0, H_gtk_text_iter_has_tag, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_tags", lg_gtk_text_iter_get_tags, 1, 0, 0, H_gtk_text_iter_get_tags, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_editable", lg_gtk_text_iter_editable, 2, 0, 0, H_gtk_text_iter_editable, pl_bub);
  s7_define_typed_function(sc, "gtk_text_iter_can_insert", lg_gtk_text_iter_can_insert, 2, 0, 0, H_gtk_text_iter_can_insert, pl_bub);
  s7_define_typed_function(sc, "gtk_text_iter_starts_word", lg_gtk_text_iter_starts_word, 1, 0, 0, H_gtk_text_iter_starts_word, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_ends_word", lg_gtk_text_iter_ends_word, 1, 0, 0, H_gtk_text_iter_ends_word, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_inside_word", lg_gtk_text_iter_inside_word, 1, 0, 0, H_gtk_text_iter_inside_word, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_starts_sentence", lg_gtk_text_iter_starts_sentence, 1, 0, 0, H_gtk_text_iter_starts_sentence, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_ends_sentence", lg_gtk_text_iter_ends_sentence, 1, 0, 0, H_gtk_text_iter_ends_sentence, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_inside_sentence", lg_gtk_text_iter_inside_sentence, 1, 0, 0, H_gtk_text_iter_inside_sentence, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_starts_line", lg_gtk_text_iter_starts_line, 1, 0, 0, H_gtk_text_iter_starts_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_ends_line", lg_gtk_text_iter_ends_line, 1, 0, 0, H_gtk_text_iter_ends_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_is_cursor_position", lg_gtk_text_iter_is_cursor_position, 1, 0, 0, H_gtk_text_iter_is_cursor_position, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_chars_in_line", lg_gtk_text_iter_get_chars_in_line, 1, 0, 0, H_gtk_text_iter_get_chars_in_line, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_bytes_in_line", lg_gtk_text_iter_get_bytes_in_line, 1, 0, 0, H_gtk_text_iter_get_bytes_in_line, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_get_language", lg_gtk_text_iter_get_language, 1, 0, 0, H_gtk_text_iter_get_language, pl_pu);
  s7_define_typed_function(sc, "gtk_text_iter_is_end", lg_gtk_text_iter_is_end, 1, 0, 0, H_gtk_text_iter_is_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_is_start", lg_gtk_text_iter_is_start, 1, 0, 0, H_gtk_text_iter_is_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_char", lg_gtk_text_iter_forward_char, 1, 0, 0, H_gtk_text_iter_forward_char, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_char", lg_gtk_text_iter_backward_char, 1, 0, 0, H_gtk_text_iter_backward_char, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_chars", lg_gtk_text_iter_forward_chars, 2, 0, 0, H_gtk_text_iter_forward_chars, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_chars", lg_gtk_text_iter_backward_chars, 2, 0, 0, H_gtk_text_iter_backward_chars, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_line", lg_gtk_text_iter_forward_line, 1, 0, 0, H_gtk_text_iter_forward_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_line", lg_gtk_text_iter_backward_line, 1, 0, 0, H_gtk_text_iter_backward_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_lines", lg_gtk_text_iter_forward_lines, 2, 0, 0, H_gtk_text_iter_forward_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_lines", lg_gtk_text_iter_backward_lines, 2, 0, 0, H_gtk_text_iter_backward_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_word_end", lg_gtk_text_iter_forward_word_end, 1, 0, 0, H_gtk_text_iter_forward_word_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_word_start", lg_gtk_text_iter_backward_word_start, 1, 0, 0, H_gtk_text_iter_backward_word_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_word_ends", lg_gtk_text_iter_forward_word_ends, 2, 0, 0, H_gtk_text_iter_forward_word_ends, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_word_starts", lg_gtk_text_iter_backward_word_starts, 2, 0, 0, H_gtk_text_iter_backward_word_starts, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_sentence_end", lg_gtk_text_iter_forward_sentence_end, 1, 0, 0, H_gtk_text_iter_forward_sentence_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_sentence_start", lg_gtk_text_iter_backward_sentence_start, 1, 0, 0, H_gtk_text_iter_backward_sentence_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_sentence_ends", lg_gtk_text_iter_forward_sentence_ends, 2, 0, 0, H_gtk_text_iter_forward_sentence_ends, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_sentence_starts", lg_gtk_text_iter_backward_sentence_starts, 2, 0, 0, H_gtk_text_iter_backward_sentence_starts, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_cursor_position", lg_gtk_text_iter_forward_cursor_position, 1, 0, 0, H_gtk_text_iter_forward_cursor_position, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_cursor_position", lg_gtk_text_iter_backward_cursor_position, 1, 0, 0, H_gtk_text_iter_backward_cursor_position, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_cursor_positions", lg_gtk_text_iter_forward_cursor_positions, 2, 0, 0, H_gtk_text_iter_forward_cursor_positions, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_cursor_positions", lg_gtk_text_iter_backward_cursor_positions, 2, 0, 0, H_gtk_text_iter_backward_cursor_positions, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_set_offset", lg_gtk_text_iter_set_offset, 2, 0, 0, H_gtk_text_iter_set_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_line", lg_gtk_text_iter_set_line, 2, 0, 0, H_gtk_text_iter_set_line, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_line_offset", lg_gtk_text_iter_set_line_offset, 2, 0, 0, H_gtk_text_iter_set_line_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_line_index", lg_gtk_text_iter_set_line_index, 2, 0, 0, H_gtk_text_iter_set_line_index, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_to_end", lg_gtk_text_iter_forward_to_end, 1, 0, 0, H_gtk_text_iter_forward_to_end, pl_tu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_to_line_end", lg_gtk_text_iter_forward_to_line_end, 1, 0, 0, H_gtk_text_iter_forward_to_line_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_set_visible_line_offset", lg_gtk_text_iter_set_visible_line_offset, 2, 0, 0, H_gtk_text_iter_set_visible_line_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_set_visible_line_index", lg_gtk_text_iter_set_visible_line_index, 2, 0, 0, H_gtk_text_iter_set_visible_line_index, pl_tui);
  s7_define_typed_function(sc, "gtk_text_iter_forward_to_tag_toggle", lg_gtk_text_iter_forward_to_tag_toggle, 2, 0, 0, H_gtk_text_iter_forward_to_tag_toggle, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_to_tag_toggle", lg_gtk_text_iter_backward_to_tag_toggle, 2, 0, 0, H_gtk_text_iter_backward_to_tag_toggle, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_find_char", lg_gtk_text_iter_forward_find_char, 4, 0, 0, H_gtk_text_iter_forward_find_char, pl_buttu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_find_char", lg_gtk_text_iter_backward_find_char, 4, 0, 0, H_gtk_text_iter_backward_find_char, pl_buttu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_search", lg_gtk_text_iter_forward_search, 6, 0, 0, H_gtk_text_iter_forward_search, pl_busgu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_search", lg_gtk_text_iter_backward_search, 6, 0, 0, H_gtk_text_iter_backward_search, pl_busgu);
  s7_define_typed_function(sc, "gtk_text_iter_equal", lg_gtk_text_iter_equal, 2, 0, 0, H_gtk_text_iter_equal, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_compare", lg_gtk_text_iter_compare, 2, 0, 0, H_gtk_text_iter_compare, pl_iu);
  s7_define_typed_function(sc, "gtk_text_iter_in_range", lg_gtk_text_iter_in_range, 3, 0, 0, H_gtk_text_iter_in_range, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_order", lg_gtk_text_iter_order, 2, 0, 0, H_gtk_text_iter_order, pl_tu);
  s7_define_typed_function(sc, "gtk_text_mark_set_visible", lg_gtk_text_mark_set_visible, 2, 0, 0, H_gtk_text_mark_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_text_mark_get_visible", lg_gtk_text_mark_get_visible, 1, 0, 0, H_gtk_text_mark_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_text_mark_get_name", lg_gtk_text_mark_get_name, 1, 0, 0, H_gtk_text_mark_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_text_mark_get_deleted", lg_gtk_text_mark_get_deleted, 1, 0, 0, H_gtk_text_mark_get_deleted, pl_bu);
  s7_define_typed_function(sc, "gtk_text_mark_get_buffer", lg_gtk_text_mark_get_buffer, 1, 0, 0, H_gtk_text_mark_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_mark_get_left_gravity", lg_gtk_text_mark_get_left_gravity, 1, 0, 0, H_gtk_text_mark_get_left_gravity, pl_bu);
  s7_define_typed_function(sc, "gtk_text_tag_new", lg_gtk_text_tag_new, 1, 0, 0, H_gtk_text_tag_new, pl_ps);
  s7_define_typed_function(sc, "gtk_text_tag_get_priority", lg_gtk_text_tag_get_priority, 1, 0, 0, H_gtk_text_tag_get_priority, pl_iu);
  s7_define_typed_function(sc, "gtk_text_tag_set_priority", lg_gtk_text_tag_set_priority, 2, 0, 0, H_gtk_text_tag_set_priority, pl_tui);
  s7_define_typed_function(sc, "gtk_text_tag_table_new", lg_gtk_text_tag_table_new, 0, 0, 0, H_gtk_text_tag_table_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_tag_table_add", lg_gtk_text_tag_table_add, 2, 0, 0, H_gtk_text_tag_table_add, pl_tu);
  s7_define_typed_function(sc, "gtk_text_tag_table_remove", lg_gtk_text_tag_table_remove, 2, 0, 0, H_gtk_text_tag_table_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_text_tag_table_lookup", lg_gtk_text_tag_table_lookup, 2, 0, 0, H_gtk_text_tag_table_lookup, pl_pus);
  s7_define_typed_function(sc, "gtk_text_tag_table_foreach", lg_gtk_text_tag_table_foreach, 3, 0, 0, H_gtk_text_tag_table_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_text_tag_table_get_size", lg_gtk_text_tag_table_get_size, 1, 0, 0, H_gtk_text_tag_table_get_size, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_new", lg_gtk_text_view_new, 0, 0, 0, H_gtk_text_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_view_new_with_buffer", lg_gtk_text_view_new_with_buffer, 1, 0, 0, H_gtk_text_view_new_with_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_set_buffer", lg_gtk_text_view_set_buffer, 2, 0, 0, H_gtk_text_view_set_buffer, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_buffer", lg_gtk_text_view_get_buffer, 1, 0, 0, H_gtk_text_view_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_scroll_to_iter", lg_gtk_text_view_scroll_to_iter, 6, 0, 0, H_gtk_text_view_scroll_to_iter, pl_buurbr);
  s7_define_typed_function(sc, "gtk_text_view_scroll_to_mark", lg_gtk_text_view_scroll_to_mark, 6, 0, 0, H_gtk_text_view_scroll_to_mark, pl_tuurbr);
  s7_define_typed_function(sc, "gtk_text_view_scroll_mark_onscreen", lg_gtk_text_view_scroll_mark_onscreen, 2, 0, 0, H_gtk_text_view_scroll_mark_onscreen, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_move_mark_onscreen", lg_gtk_text_view_move_mark_onscreen, 2, 0, 0, H_gtk_text_view_move_mark_onscreen, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_place_cursor_onscreen", lg_gtk_text_view_place_cursor_onscreen, 1, 0, 0, H_gtk_text_view_place_cursor_onscreen, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_get_visible_rect", lg_gtk_text_view_get_visible_rect, 2, 0, 0, H_gtk_text_view_get_visible_rect, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_set_cursor_visible", lg_gtk_text_view_set_cursor_visible, 2, 0, 0, H_gtk_text_view_set_cursor_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_cursor_visible", lg_gtk_text_view_get_cursor_visible, 1, 0, 0, H_gtk_text_view_get_cursor_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_get_iter_location", lg_gtk_text_view_get_iter_location, 3, 0, 0, H_gtk_text_view_get_iter_location, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_line_yrange", lg_gtk_text_view_get_line_yrange, 2, 2, 0, H_gtk_text_view_get_line_yrange, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_get_line_at_y", lg_gtk_text_view_get_line_at_y, 3, 1, 0, H_gtk_text_view_get_line_at_y, pl_puuiu);
  s7_define_typed_function(sc, "gtk_text_view_window_to_buffer_coords", lg_gtk_text_view_window_to_buffer_coords, 4, 2, 0, H_gtk_text_view_window_to_buffer_coords, pl_pugiiu);
  s7_define_typed_function(sc, "gtk_text_view_set_border_window_size", lg_gtk_text_view_set_border_window_size, 3, 0, 0, H_gtk_text_view_set_border_window_size, pl_tugi);
  s7_define_typed_function(sc, "gtk_text_view_get_border_window_size", lg_gtk_text_view_get_border_window_size, 2, 0, 0, H_gtk_text_view_get_border_window_size, pl_iug);
  s7_define_typed_function(sc, "gtk_text_view_forward_display_line", lg_gtk_text_view_forward_display_line, 2, 0, 0, H_gtk_text_view_forward_display_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_backward_display_line", lg_gtk_text_view_backward_display_line, 2, 0, 0, H_gtk_text_view_backward_display_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_forward_display_line_end", lg_gtk_text_view_forward_display_line_end, 2, 0, 0, H_gtk_text_view_forward_display_line_end, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_backward_display_line_start", lg_gtk_text_view_backward_display_line_start, 2, 0, 0, H_gtk_text_view_backward_display_line_start, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_starts_display_line", lg_gtk_text_view_starts_display_line, 2, 0, 0, H_gtk_text_view_starts_display_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_move_visually", lg_gtk_text_view_move_visually, 3, 0, 0, H_gtk_text_view_move_visually, pl_buui);
  s7_define_typed_function(sc, "gtk_text_view_add_child_at_anchor", lg_gtk_text_view_add_child_at_anchor, 3, 0, 0, H_gtk_text_view_add_child_at_anchor, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_set_wrap_mode", lg_gtk_text_view_set_wrap_mode, 2, 0, 0, H_gtk_text_view_set_wrap_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_wrap_mode", lg_gtk_text_view_get_wrap_mode, 1, 0, 0, H_gtk_text_view_get_wrap_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_editable", lg_gtk_text_view_set_editable, 2, 0, 0, H_gtk_text_view_set_editable, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_editable", lg_gtk_text_view_get_editable, 1, 0, 0, H_gtk_text_view_get_editable, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_set_pixels_above_lines", lg_gtk_text_view_set_pixels_above_lines, 2, 0, 0, H_gtk_text_view_set_pixels_above_lines, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_pixels_above_lines", lg_gtk_text_view_get_pixels_above_lines, 1, 0, 0, H_gtk_text_view_get_pixels_above_lines, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_pixels_below_lines", lg_gtk_text_view_set_pixels_below_lines, 2, 0, 0, H_gtk_text_view_set_pixels_below_lines, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_pixels_below_lines", lg_gtk_text_view_get_pixels_below_lines, 1, 0, 0, H_gtk_text_view_get_pixels_below_lines, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_pixels_inside_wrap", lg_gtk_text_view_set_pixels_inside_wrap, 2, 0, 0, H_gtk_text_view_set_pixels_inside_wrap, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_pixels_inside_wrap", lg_gtk_text_view_get_pixels_inside_wrap, 1, 0, 0, H_gtk_text_view_get_pixels_inside_wrap, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_justification", lg_gtk_text_view_set_justification, 2, 0, 0, H_gtk_text_view_set_justification, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_justification", lg_gtk_text_view_get_justification, 1, 0, 0, H_gtk_text_view_get_justification, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_left_margin", lg_gtk_text_view_set_left_margin, 2, 0, 0, H_gtk_text_view_set_left_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_left_margin", lg_gtk_text_view_get_left_margin, 1, 0, 0, H_gtk_text_view_get_left_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_right_margin", lg_gtk_text_view_set_right_margin, 2, 0, 0, H_gtk_text_view_set_right_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_right_margin", lg_gtk_text_view_get_right_margin, 1, 0, 0, H_gtk_text_view_get_right_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_indent", lg_gtk_text_view_set_indent, 2, 0, 0, H_gtk_text_view_set_indent, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_indent", lg_gtk_text_view_get_indent, 1, 0, 0, H_gtk_text_view_get_indent, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_tabs", lg_gtk_text_view_set_tabs, 2, 0, 0, H_gtk_text_view_set_tabs, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_tabs", lg_gtk_text_view_get_tabs, 1, 0, 0, H_gtk_text_view_get_tabs, pl_pu);
  s7_define_typed_function(sc, "gtk_toggle_button_new", lg_gtk_toggle_button_new, 0, 0, 0, H_gtk_toggle_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_toggle_button_new_with_label", lg_gtk_toggle_button_new_with_label, 1, 0, 0, H_gtk_toggle_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_toggle_button_new_with_mnemonic", lg_gtk_toggle_button_new_with_mnemonic, 1, 0, 0, H_gtk_toggle_button_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_toggle_button_set_active", lg_gtk_toggle_button_set_active, 2, 0, 0, H_gtk_toggle_button_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_toggle_button_get_active", lg_gtk_toggle_button_get_active, 1, 0, 0, H_gtk_toggle_button_get_active, pl_bu);
  s7_define_typed_function(sc, "gtk_toggle_button_toggled", lg_gtk_toggle_button_toggled, 1, 0, 0, H_gtk_toggle_button_toggled, pl_tu);
  s7_define_typed_function(sc, "gtk_toolbar_new", lg_gtk_toolbar_new, 0, 0, 0, H_gtk_toolbar_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_drag_source_row_draggable", lg_gtk_tree_drag_source_row_draggable, 2, 0, 0, H_gtk_tree_drag_source_row_draggable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_drag_source_drag_data_delete", lg_gtk_tree_drag_source_drag_data_delete, 2, 0, 0, H_gtk_tree_drag_source_drag_data_delete, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_new", lg_gtk_tree_path_new, 0, 0, 0, H_gtk_tree_path_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_path_new_from_string", lg_gtk_tree_path_new_from_string, 1, 0, 0, H_gtk_tree_path_new_from_string, pl_ps);
  s7_define_typed_function(sc, "gtk_tree_path_to_string", lg_gtk_tree_path_to_string, 1, 0, 0, H_gtk_tree_path_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_tree_path_new_first", lg_gtk_tree_path_new_first, 0, 0, 0, H_gtk_tree_path_new_first, pl_p);
  s7_define_typed_function(sc, "gtk_tree_path_append_index", lg_gtk_tree_path_append_index, 2, 0, 0, H_gtk_tree_path_append_index, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_path_prepend_index", lg_gtk_tree_path_prepend_index, 2, 0, 0, H_gtk_tree_path_prepend_index, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_path_get_depth", lg_gtk_tree_path_get_depth, 1, 0, 0, H_gtk_tree_path_get_depth, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_path_get_indices", lg_gtk_tree_path_get_indices, 1, 0, 0, H_gtk_tree_path_get_indices, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_path_free", lg_gtk_tree_path_free, 1, 0, 0, H_gtk_tree_path_free, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_path_copy", lg_gtk_tree_path_copy, 1, 0, 0, H_gtk_tree_path_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_path_compare", lg_gtk_tree_path_compare, 2, 0, 0, H_gtk_tree_path_compare, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_path_next", lg_gtk_tree_path_next, 1, 0, 0, H_gtk_tree_path_next, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_path_prev", lg_gtk_tree_path_prev, 1, 0, 0, H_gtk_tree_path_prev, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_up", lg_gtk_tree_path_up, 1, 0, 0, H_gtk_tree_path_up, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_down", lg_gtk_tree_path_down, 1, 0, 0, H_gtk_tree_path_down, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_path_is_ancestor", lg_gtk_tree_path_is_ancestor, 2, 0, 0, H_gtk_tree_path_is_ancestor, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_path_is_descendant", lg_gtk_tree_path_is_descendant, 2, 0, 0, H_gtk_tree_path_is_descendant, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_new", lg_gtk_tree_row_reference_new, 2, 0, 0, H_gtk_tree_row_reference_new, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_new_proxy", lg_gtk_tree_row_reference_new_proxy, 3, 0, 0, H_gtk_tree_row_reference_new_proxy, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_get_path", lg_gtk_tree_row_reference_get_path, 1, 0, 0, H_gtk_tree_row_reference_get_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_valid", lg_gtk_tree_row_reference_valid, 1, 0, 0, H_gtk_tree_row_reference_valid, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_free", lg_gtk_tree_row_reference_free, 1, 0, 0, H_gtk_tree_row_reference_free, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_inserted", lg_gtk_tree_row_reference_inserted, 2, 0, 0, H_gtk_tree_row_reference_inserted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_deleted", lg_gtk_tree_row_reference_deleted, 2, 0, 0, H_gtk_tree_row_reference_deleted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_row_reference_reordered", lg_gtk_tree_row_reference_reordered, 4, 0, 0, H_gtk_tree_row_reference_reordered, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_iter_copy", lg_gtk_tree_iter_copy, 1, 0, 0, H_gtk_tree_iter_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_iter_free", lg_gtk_tree_iter_free, 1, 0, 0, H_gtk_tree_iter_free, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_get_flags", lg_gtk_tree_model_get_flags, 1, 0, 0, H_gtk_tree_model_get_flags, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_model_get_n_columns", lg_gtk_tree_model_get_n_columns, 1, 0, 0, H_gtk_tree_model_get_n_columns, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_model_get_column_type", lg_gtk_tree_model_get_column_type, 2, 0, 0, H_gtk_tree_model_get_column_type, pl_iui);
  s7_define_typed_function(sc, "gtk_tree_model_get_iter", lg_gtk_tree_model_get_iter, 3, 0, 0, H_gtk_tree_model_get_iter, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_get_iter_from_string", lg_gtk_tree_model_get_iter_from_string, 3, 0, 0, H_gtk_tree_model_get_iter_from_string, pl_buus);
  s7_define_typed_function(sc, "gtk_tree_model_get_iter_first", lg_gtk_tree_model_get_iter_first, 2, 0, 0, H_gtk_tree_model_get_iter_first, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_get_path", lg_gtk_tree_model_get_path, 2, 0, 0, H_gtk_tree_model_get_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_next", lg_gtk_tree_model_iter_next, 2, 0, 0, H_gtk_tree_model_iter_next, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_children", lg_gtk_tree_model_iter_children, 3, 0, 0, H_gtk_tree_model_iter_children, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_has_child", lg_gtk_tree_model_iter_has_child, 2, 0, 0, H_gtk_tree_model_iter_has_child, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_n_children", lg_gtk_tree_model_iter_n_children, 2, 0, 0, H_gtk_tree_model_iter_n_children, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_nth_child", lg_gtk_tree_model_iter_nth_child, 4, 0, 0, H_gtk_tree_model_iter_nth_child, pl_buuui);
  s7_define_typed_function(sc, "gtk_tree_model_iter_parent", lg_gtk_tree_model_iter_parent, 3, 0, 0, H_gtk_tree_model_iter_parent, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_ref_node", lg_gtk_tree_model_ref_node, 2, 0, 0, H_gtk_tree_model_ref_node, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_unref_node", lg_gtk_tree_model_unref_node, 2, 0, 0, H_gtk_tree_model_unref_node, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_foreach", lg_gtk_tree_model_foreach, 3, 0, 0, H_gtk_tree_model_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_model_row_changed", lg_gtk_tree_model_row_changed, 3, 0, 0, H_gtk_tree_model_row_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_row_inserted", lg_gtk_tree_model_row_inserted, 3, 0, 0, H_gtk_tree_model_row_inserted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_row_has_child_toggled", lg_gtk_tree_model_row_has_child_toggled, 3, 0, 0, H_gtk_tree_model_row_has_child_toggled, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_row_deleted", lg_gtk_tree_model_row_deleted, 2, 0, 0, H_gtk_tree_model_row_deleted, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_rows_reordered", lg_gtk_tree_model_rows_reordered, 4, 0, 0, H_gtk_tree_model_rows_reordered, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_new_with_model", lg_gtk_tree_model_sort_new_with_model, 1, 0, 0, H_gtk_tree_model_sort_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_get_model", lg_gtk_tree_model_sort_get_model, 1, 0, 0, H_gtk_tree_model_sort_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_child_path_to_path", lg_gtk_tree_model_sort_convert_child_path_to_path, 2, 0, 0, H_gtk_tree_model_sort_convert_child_path_to_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_child_iter_to_iter", lg_gtk_tree_model_sort_convert_child_iter_to_iter, 3, 0, 0, H_gtk_tree_model_sort_convert_child_iter_to_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_path_to_child_path", lg_gtk_tree_model_sort_convert_path_to_child_path, 2, 0, 0, H_gtk_tree_model_sort_convert_path_to_child_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_convert_iter_to_child_iter", lg_gtk_tree_model_sort_convert_iter_to_child_iter, 3, 0, 0, H_gtk_tree_model_sort_convert_iter_to_child_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_reset_default_sort_func", lg_gtk_tree_model_sort_reset_default_sort_func, 1, 0, 0, H_gtk_tree_model_sort_reset_default_sort_func, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_sort_clear_cache", lg_gtk_tree_model_sort_clear_cache, 1, 0, 0, H_gtk_tree_model_sort_clear_cache, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_set_mode", lg_gtk_tree_selection_set_mode, 2, 0, 0, H_gtk_tree_selection_set_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_selection_get_mode", lg_gtk_tree_selection_get_mode, 1, 0, 0, H_gtk_tree_selection_get_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_selection_set_select_function", lg_gtk_tree_selection_set_select_function, 4, 0, 0, H_gtk_tree_selection_set_select_function, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_selection_get_user_data", lg_gtk_tree_selection_get_user_data, 1, 0, 0, H_gtk_tree_selection_get_user_data, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_get_tree_view", lg_gtk_tree_selection_get_tree_view, 1, 0, 0, H_gtk_tree_selection_get_tree_view, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_selection_get_selected", lg_gtk_tree_selection_get_selected, 3, 0, 0, H_gtk_tree_selection_get_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_selection_selected_foreach", lg_gtk_tree_selection_selected_foreach, 3, 0, 0, H_gtk_tree_selection_selected_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_selection_select_path", lg_gtk_tree_selection_select_path, 2, 0, 0, H_gtk_tree_selection_select_path, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_unselect_path", lg_gtk_tree_selection_unselect_path, 2, 0, 0, H_gtk_tree_selection_unselect_path, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_select_iter", lg_gtk_tree_selection_select_iter, 2, 0, 0, H_gtk_tree_selection_select_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_unselect_iter", lg_gtk_tree_selection_unselect_iter, 2, 0, 0, H_gtk_tree_selection_unselect_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_path_is_selected", lg_gtk_tree_selection_path_is_selected, 2, 0, 0, H_gtk_tree_selection_path_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_selection_iter_is_selected", lg_gtk_tree_selection_iter_is_selected, 2, 0, 0, H_gtk_tree_selection_iter_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_selection_select_all", lg_gtk_tree_selection_select_all, 1, 0, 0, H_gtk_tree_selection_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_unselect_all", lg_gtk_tree_selection_unselect_all, 1, 0, 0, H_gtk_tree_selection_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_select_range", lg_gtk_tree_selection_select_range, 3, 0, 0, H_gtk_tree_selection_select_range, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_sortable_sort_column_changed", lg_gtk_tree_sortable_sort_column_changed, 1, 0, 0, H_gtk_tree_sortable_sort_column_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_sortable_get_sort_column_id", lg_gtk_tree_sortable_get_sort_column_id, 1, 2, 0, H_gtk_tree_sortable_get_sort_column_id, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_sortable_set_sort_column_id", lg_gtk_tree_sortable_set_sort_column_id, 3, 0, 0, H_gtk_tree_sortable_set_sort_column_id, pl_tuig);
  s7_define_typed_function(sc, "gtk_tree_sortable_set_sort_func", lg_gtk_tree_sortable_set_sort_func, 5, 0, 0, H_gtk_tree_sortable_set_sort_func, pl_tuit);
  s7_define_typed_function(sc, "gtk_tree_sortable_set_default_sort_func", lg_gtk_tree_sortable_set_default_sort_func, 4, 0, 0, H_gtk_tree_sortable_set_default_sort_func, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_sortable_has_default_sort_func", lg_gtk_tree_sortable_has_default_sort_func, 1, 0, 0, H_gtk_tree_sortable_has_default_sort_func, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_store_new", lg_gtk_tree_store_new, 2, 0, 0, H_gtk_tree_store_new, pl_pit);
  s7_define_typed_function(sc, "gtk_tree_store_newv", lg_gtk_tree_store_newv, 2, 0, 0, H_gtk_tree_store_newv, pl_piu);
  s7_define_typed_function(sc, "gtk_tree_store_set_column_types", lg_gtk_tree_store_set_column_types, 3, 0, 0, H_gtk_tree_store_set_column_types, pl_tuiu);
  s7_define_typed_function(sc, "gtk_tree_store_set", lg_gtk_tree_store_set, 3, 0, 0, H_gtk_tree_store_set, pl_tuut);
  s7_define_typed_function(sc, "gtk_tree_store_remove", lg_gtk_tree_store_remove, 2, 0, 0, H_gtk_tree_store_remove, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_insert", lg_gtk_tree_store_insert, 4, 0, 0, H_gtk_tree_store_insert, pl_tuuui);
  s7_define_typed_function(sc, "gtk_tree_store_insert_before", lg_gtk_tree_store_insert_before, 4, 0, 0, H_gtk_tree_store_insert_before, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_insert_after", lg_gtk_tree_store_insert_after, 4, 0, 0, H_gtk_tree_store_insert_after, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_prepend", lg_gtk_tree_store_prepend, 3, 0, 0, H_gtk_tree_store_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_append", lg_gtk_tree_store_append, 3, 0, 0, H_gtk_tree_store_append, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_is_ancestor", lg_gtk_tree_store_is_ancestor, 3, 0, 0, H_gtk_tree_store_is_ancestor, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_store_iter_depth", lg_gtk_tree_store_iter_depth, 2, 0, 0, H_gtk_tree_store_iter_depth, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_store_clear", lg_gtk_tree_store_clear, 1, 0, 0, H_gtk_tree_store_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_new", lg_gtk_tree_view_column_new, 0, 0, 0, H_gtk_tree_view_column_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_view_column_new_with_attributes", lg_gtk_tree_view_column_new_with_attributes, 3, 0, 0, H_gtk_tree_view_column_new_with_attributes, pl_psut);
  s7_define_typed_function(sc, "gtk_tree_view_column_pack_start", lg_gtk_tree_view_column_pack_start, 3, 0, 0, H_gtk_tree_view_column_pack_start, pl_tuub);
  s7_define_typed_function(sc, "gtk_tree_view_column_pack_end", lg_gtk_tree_view_column_pack_end, 3, 0, 0, H_gtk_tree_view_column_pack_end, pl_tuub);
  s7_define_typed_function(sc, "gtk_tree_view_column_clear", lg_gtk_tree_view_column_clear, 1, 0, 0, H_gtk_tree_view_column_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_add_attribute", lg_gtk_tree_view_column_add_attribute, 4, 0, 0, H_gtk_tree_view_column_add_attribute, pl_tuusi);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_attributes", lg_gtk_tree_view_column_set_attributes, 3, 0, 0, H_gtk_tree_view_column_set_attributes, pl_tuut);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_cell_data_func", lg_gtk_tree_view_column_set_cell_data_func, 5, 0, 0, H_gtk_tree_view_column_set_cell_data_func, pl_tuut);
  s7_define_typed_function(sc, "gtk_tree_view_column_clear_attributes", lg_gtk_tree_view_column_clear_attributes, 2, 0, 0, H_gtk_tree_view_column_clear_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_spacing", lg_gtk_tree_view_column_set_spacing, 2, 0, 0, H_gtk_tree_view_column_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_spacing", lg_gtk_tree_view_column_get_spacing, 1, 0, 0, H_gtk_tree_view_column_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_visible", lg_gtk_tree_view_column_set_visible, 2, 0, 0, H_gtk_tree_view_column_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_visible", lg_gtk_tree_view_column_get_visible, 1, 0, 0, H_gtk_tree_view_column_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_resizable", lg_gtk_tree_view_column_set_resizable, 2, 0, 0, H_gtk_tree_view_column_set_resizable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_resizable", lg_gtk_tree_view_column_get_resizable, 1, 0, 0, H_gtk_tree_view_column_get_resizable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sizing", lg_gtk_tree_view_column_set_sizing, 2, 0, 0, H_gtk_tree_view_column_set_sizing, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sizing", lg_gtk_tree_view_column_get_sizing, 1, 0, 0, H_gtk_tree_view_column_get_sizing, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_width", lg_gtk_tree_view_column_get_width, 1, 0, 0, H_gtk_tree_view_column_get_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_fixed_width", lg_gtk_tree_view_column_get_fixed_width, 1, 0, 0, H_gtk_tree_view_column_get_fixed_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_fixed_width", lg_gtk_tree_view_column_set_fixed_width, 2, 0, 0, H_gtk_tree_view_column_set_fixed_width, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_min_width", lg_gtk_tree_view_column_set_min_width, 2, 0, 0, H_gtk_tree_view_column_set_min_width, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_min_width", lg_gtk_tree_view_column_get_min_width, 1, 0, 0, H_gtk_tree_view_column_get_min_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_max_width", lg_gtk_tree_view_column_set_max_width, 2, 0, 0, H_gtk_tree_view_column_set_max_width, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_max_width", lg_gtk_tree_view_column_get_max_width, 1, 0, 0, H_gtk_tree_view_column_get_max_width, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_clicked", lg_gtk_tree_view_column_clicked, 1, 0, 0, H_gtk_tree_view_column_clicked, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_title", lg_gtk_tree_view_column_set_title, 2, 0, 0, H_gtk_tree_view_column_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_title", lg_gtk_tree_view_column_get_title, 1, 0, 0, H_gtk_tree_view_column_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_clickable", lg_gtk_tree_view_column_set_clickable, 2, 0, 0, H_gtk_tree_view_column_set_clickable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_clickable", lg_gtk_tree_view_column_get_clickable, 1, 0, 0, H_gtk_tree_view_column_get_clickable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_widget", lg_gtk_tree_view_column_set_widget, 2, 0, 0, H_gtk_tree_view_column_set_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_widget", lg_gtk_tree_view_column_get_widget, 1, 0, 0, H_gtk_tree_view_column_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_alignment", lg_gtk_tree_view_column_set_alignment, 2, 0, 0, H_gtk_tree_view_column_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_alignment", lg_gtk_tree_view_column_get_alignment, 1, 0, 0, H_gtk_tree_view_column_get_alignment, pl_du);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_reorderable", lg_gtk_tree_view_column_set_reorderable, 2, 0, 0, H_gtk_tree_view_column_set_reorderable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_reorderable", lg_gtk_tree_view_column_get_reorderable, 1, 0, 0, H_gtk_tree_view_column_get_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sort_column_id", lg_gtk_tree_view_column_set_sort_column_id, 2, 0, 0, H_gtk_tree_view_column_set_sort_column_id, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sort_column_id", lg_gtk_tree_view_column_get_sort_column_id, 1, 0, 0, H_gtk_tree_view_column_get_sort_column_id, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sort_indicator", lg_gtk_tree_view_column_set_sort_indicator, 2, 0, 0, H_gtk_tree_view_column_set_sort_indicator, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sort_indicator", lg_gtk_tree_view_column_get_sort_indicator, 1, 0, 0, H_gtk_tree_view_column_get_sort_indicator, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_sort_order", lg_gtk_tree_view_column_set_sort_order, 2, 0, 0, H_gtk_tree_view_column_set_sort_order, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_sort_order", lg_gtk_tree_view_column_get_sort_order, 1, 0, 0, H_gtk_tree_view_column_get_sort_order, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_set_cell_data", lg_gtk_tree_view_column_cell_set_cell_data, 5, 0, 0, H_gtk_tree_view_column_cell_set_cell_data, pl_tuuub);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_is_visible", lg_gtk_tree_view_column_cell_is_visible, 1, 0, 0, H_gtk_tree_view_column_cell_is_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_get_position", lg_gtk_tree_view_column_cell_get_position, 2, 2, 0, H_gtk_tree_view_column_cell_get_position, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_new", lg_gtk_tree_view_new, 0, 0, 0, H_gtk_tree_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_tree_view_new_with_model", lg_gtk_tree_view_new_with_model, 1, 0, 0, H_gtk_tree_view_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_model", lg_gtk_tree_view_get_model, 1, 0, 0, H_gtk_tree_view_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_model", lg_gtk_tree_view_set_model, 2, 0, 0, H_gtk_tree_view_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_selection", lg_gtk_tree_view_get_selection, 1, 0, 0, H_gtk_tree_view_get_selection, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_headers_visible", lg_gtk_tree_view_get_headers_visible, 1, 0, 0, H_gtk_tree_view_get_headers_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_headers_visible", lg_gtk_tree_view_set_headers_visible, 2, 0, 0, H_gtk_tree_view_set_headers_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_columns_autosize", lg_gtk_tree_view_columns_autosize, 1, 0, 0, H_gtk_tree_view_columns_autosize, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_headers_clickable", lg_gtk_tree_view_set_headers_clickable, 2, 0, 0, H_gtk_tree_view_set_headers_clickable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_append_column", lg_gtk_tree_view_append_column, 2, 0, 0, H_gtk_tree_view_append_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_remove_column", lg_gtk_tree_view_remove_column, 2, 0, 0, H_gtk_tree_view_remove_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_insert_column", lg_gtk_tree_view_insert_column, 3, 0, 0, H_gtk_tree_view_insert_column, pl_iuui);
  s7_define_typed_function(sc, "gtk_tree_view_insert_column_with_attributes", lg_gtk_tree_view_insert_column_with_attributes, 5, 0, 0, H_gtk_tree_view_insert_column_with_attributes, pl_iuisut);
  s7_define_typed_function(sc, "gtk_tree_view_insert_column_with_data_func", lg_gtk_tree_view_insert_column_with_data_func, 7, 0, 0, H_gtk_tree_view_insert_column_with_data_func, pl_iuisut);
  s7_define_typed_function(sc, "gtk_tree_view_get_column", lg_gtk_tree_view_get_column, 2, 0, 0, H_gtk_tree_view_get_column, pl_pui);
  s7_define_typed_function(sc, "gtk_tree_view_get_columns", lg_gtk_tree_view_get_columns, 1, 0, 0, H_gtk_tree_view_get_columns, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_move_column_after", lg_gtk_tree_view_move_column_after, 3, 0, 0, H_gtk_tree_view_move_column_after, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_expander_column", lg_gtk_tree_view_set_expander_column, 2, 0, 0, H_gtk_tree_view_set_expander_column, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_expander_column", lg_gtk_tree_view_get_expander_column, 1, 0, 0, H_gtk_tree_view_get_expander_column, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_column_drag_function", lg_gtk_tree_view_set_column_drag_function, 4, 0, 0, H_gtk_tree_view_set_column_drag_function, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_view_scroll_to_point", lg_gtk_tree_view_scroll_to_point, 3, 0, 0, H_gtk_tree_view_scroll_to_point, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_scroll_to_cell", lg_gtk_tree_view_scroll_to_cell, 6, 0, 0, H_gtk_tree_view_scroll_to_cell, pl_tuuubr);
  s7_define_typed_function(sc, "gtk_tree_view_row_activated", lg_gtk_tree_view_row_activated, 3, 0, 0, H_gtk_tree_view_row_activated, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_expand_all", lg_gtk_tree_view_expand_all, 1, 0, 0, H_gtk_tree_view_expand_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_collapse_all", lg_gtk_tree_view_collapse_all, 1, 0, 0, H_gtk_tree_view_collapse_all, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_expand_row", lg_gtk_tree_view_expand_row, 3, 0, 0, H_gtk_tree_view_expand_row, pl_buub);
  s7_define_typed_function(sc, "gtk_tree_view_collapse_row", lg_gtk_tree_view_collapse_row, 2, 0, 0, H_gtk_tree_view_collapse_row, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_map_expanded_rows", lg_gtk_tree_view_map_expanded_rows, 3, 0, 0, H_gtk_tree_view_map_expanded_rows, pl_tut);
  s7_define_typed_function(sc, "gtk_tree_view_row_expanded", lg_gtk_tree_view_row_expanded, 2, 0, 0, H_gtk_tree_view_row_expanded, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_reorderable", lg_gtk_tree_view_set_reorderable, 2, 0, 0, H_gtk_tree_view_set_reorderable, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_reorderable", lg_gtk_tree_view_get_reorderable, 1, 0, 0, H_gtk_tree_view_get_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_cursor", lg_gtk_tree_view_set_cursor, 4, 0, 0, H_gtk_tree_view_set_cursor, pl_tuuub);
  s7_define_typed_function(sc, "gtk_tree_view_get_cursor", lg_gtk_tree_view_get_cursor, 1, 2, 0, H_gtk_tree_view_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_get_path_at_pos", lg_gtk_tree_view_get_path_at_pos, 3, 4, 0, H_gtk_tree_view_get_path_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_get_cell_area", lg_gtk_tree_view_get_cell_area, 4, 0, 0, H_gtk_tree_view_get_cell_area, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_background_area", lg_gtk_tree_view_get_background_area, 4, 0, 0, H_gtk_tree_view_get_background_area, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_visible_rect", lg_gtk_tree_view_get_visible_rect, 2, 0, 0, H_gtk_tree_view_get_visible_rect, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_unset_rows_drag_source", lg_gtk_tree_view_unset_rows_drag_source, 1, 0, 0, H_gtk_tree_view_unset_rows_drag_source, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_dest_row_at_pos", lg_gtk_tree_view_get_dest_row_at_pos, 3, 2, 0, H_gtk_tree_view_get_dest_row_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_set_enable_search", lg_gtk_tree_view_set_enable_search, 2, 0, 0, H_gtk_tree_view_set_enable_search, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_enable_search", lg_gtk_tree_view_get_enable_search, 1, 0, 0, H_gtk_tree_view_get_enable_search, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_column", lg_gtk_tree_view_get_search_column, 1, 0, 0, H_gtk_tree_view_get_search_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_column", lg_gtk_tree_view_set_search_column, 2, 0, 0, H_gtk_tree_view_set_search_column, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_equal_func", lg_gtk_tree_view_get_search_equal_func, 1, 0, 0, H_gtk_tree_view_get_search_equal_func, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_equal_func", lg_gtk_tree_view_set_search_equal_func, 4, 0, 0, H_gtk_tree_view_set_search_equal_func, pl_tut);
  s7_define_typed_function(sc, "gtk_viewport_new", lg_gtk_viewport_new, 2, 0, 0, H_gtk_viewport_new, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_destroy", lg_gtk_widget_destroy, 1, 0, 0, H_gtk_widget_destroy, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_destroyed", lg_gtk_widget_destroyed, 1, 1, 0, H_gtk_widget_destroyed, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_unparent", lg_gtk_widget_unparent, 1, 0, 0, H_gtk_widget_unparent, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_show", lg_gtk_widget_show, 1, 0, 0, H_gtk_widget_show, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_hide", lg_gtk_widget_hide, 1, 0, 0, H_gtk_widget_hide, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_map", lg_gtk_widget_map, 1, 0, 0, H_gtk_widget_map, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_unmap", lg_gtk_widget_unmap, 1, 0, 0, H_gtk_widget_unmap, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_realize", lg_gtk_widget_realize, 1, 0, 0, H_gtk_widget_realize, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_unrealize", lg_gtk_widget_unrealize, 1, 0, 0, H_gtk_widget_unrealize, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_queue_draw", lg_gtk_widget_queue_draw, 1, 0, 0, H_gtk_widget_queue_draw, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_queue_resize", lg_gtk_widget_queue_resize, 1, 0, 0, H_gtk_widget_queue_resize, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_mnemonic_activate", lg_gtk_widget_mnemonic_activate, 2, 0, 0, H_gtk_widget_mnemonic_activate, pl_bub);
  s7_define_typed_function(sc, "gtk_widget_event", lg_gtk_widget_event, 2, 0, 0, H_gtk_widget_event, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_activate", lg_gtk_widget_activate, 1, 0, 0, H_gtk_widget_activate, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_focus", lg_gtk_widget_is_focus, 1, 0, 0, H_gtk_widget_is_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_name", lg_gtk_widget_set_name, 2, 0, 0, H_gtk_widget_set_name, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_name", lg_gtk_widget_get_name, 1, 0, 0, H_gtk_widget_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_widget_set_sensitive", lg_gtk_widget_set_sensitive, 2, 0, 0, H_gtk_widget_set_sensitive, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_parent", lg_gtk_widget_set_parent, 2, 0, 0, H_gtk_widget_set_parent, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_child_visible", lg_gtk_widget_set_child_visible, 2, 0, 0, H_gtk_widget_set_child_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_child_visible", lg_gtk_widget_get_child_visible, 1, 0, 0, H_gtk_widget_get_child_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_parent", lg_gtk_widget_get_parent, 1, 0, 0, H_gtk_widget_get_parent, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_child_focus", lg_gtk_widget_child_focus, 2, 0, 0, H_gtk_widget_child_focus, pl_bug);
  s7_define_typed_function(sc, "gtk_widget_set_size_request", lg_gtk_widget_set_size_request, 3, 0, 0, H_gtk_widget_set_size_request, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_get_size_request", lg_gtk_widget_get_size_request, 1, 2, 0, H_gtk_widget_get_size_request, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_ancestor", lg_gtk_widget_get_ancestor, 2, 0, 0, H_gtk_widget_get_ancestor, pl_pui);
  s7_define_typed_function(sc, "gtk_widget_get_settings", lg_gtk_widget_get_settings, 1, 0, 0, H_gtk_widget_get_settings, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_accessible", lg_gtk_widget_get_accessible, 1, 0, 0, H_gtk_widget_get_accessible, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_is_ancestor", lg_gtk_widget_is_ancestor, 2, 0, 0, H_gtk_widget_is_ancestor, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_translate_coordinates", lg_gtk_widget_translate_coordinates, 4, 2, 0, H_gtk_widget_translate_coordinates, pl_puuiiu);
  s7_define_typed_function(sc, "gtk_widget_create_pango_context", lg_gtk_widget_create_pango_context, 1, 0, 0, H_gtk_widget_create_pango_context, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_pango_context", lg_gtk_widget_get_pango_context, 1, 0, 0, H_gtk_widget_get_pango_context, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_create_pango_layout", lg_gtk_widget_create_pango_layout, 2, 0, 0, H_gtk_widget_create_pango_layout, pl_pus);
  s7_define_typed_function(sc, "gtk_widget_set_direction", lg_gtk_widget_set_direction, 2, 0, 0, H_gtk_widget_set_direction, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_direction", lg_gtk_widget_get_direction, 1, 0, 0, H_gtk_widget_get_direction, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_set_default_direction", lg_gtk_widget_set_default_direction, 1, 0, 0, H_gtk_widget_set_default_direction, pl_tg);
  s7_define_typed_function(sc, "gtk_widget_get_default_direction", lg_gtk_widget_get_default_direction, 0, 0, 0, H_gtk_widget_get_default_direction, pl_g);
  s7_define_typed_function(sc, "gtk_window_is_active", lg_gtk_window_is_active, 1, 0, 0, H_gtk_window_is_active, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_title", lg_gtk_window_set_title, 2, 0, 0, H_gtk_window_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_window_set_auto_startup_notification", lg_gtk_window_set_auto_startup_notification, 1, 0, 0, H_gtk_window_set_auto_startup_notification, pl_tb);
  s7_define_typed_function(sc, "gtk_window_get_title", lg_gtk_window_get_title, 1, 0, 0, H_gtk_window_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_window_set_focus", lg_gtk_window_set_focus, 2, 0, 0, H_gtk_window_set_focus, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_focus", lg_gtk_window_get_focus, 1, 0, 0, H_gtk_window_get_focus, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_transient_for", lg_gtk_window_set_transient_for, 2, 0, 0, H_gtk_window_set_transient_for, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_transient_for", lg_gtk_window_get_transient_for, 1, 0, 0, H_gtk_window_get_transient_for, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_destroy_with_parent", lg_gtk_window_set_destroy_with_parent, 2, 0, 0, H_gtk_window_set_destroy_with_parent, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_destroy_with_parent", lg_gtk_window_get_destroy_with_parent, 1, 0, 0, H_gtk_window_get_destroy_with_parent, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_resizable", lg_gtk_window_set_resizable, 2, 0, 0, H_gtk_window_set_resizable, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_resizable", lg_gtk_window_get_resizable, 1, 0, 0, H_gtk_window_get_resizable, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_decorated", lg_gtk_window_set_decorated, 2, 0, 0, H_gtk_window_set_decorated, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_decorated", lg_gtk_window_get_decorated, 1, 0, 0, H_gtk_window_get_decorated, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_modal", lg_gtk_window_set_modal, 2, 0, 0, H_gtk_window_set_modal, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_modal", lg_gtk_window_get_modal, 1, 0, 0, H_gtk_window_get_modal, pl_bu);
  s7_define_typed_function(sc, "gtk_window_list_toplevels", lg_gtk_window_list_toplevels, 0, 0, 0, H_gtk_window_list_toplevels, pl_p);
  s7_define_typed_function(sc, "gtk_window_present", lg_gtk_window_present, 1, 0, 0, H_gtk_window_present, pl_tu);
  s7_define_typed_function(sc, "gtk_window_maximize", lg_gtk_window_maximize, 1, 0, 0, H_gtk_window_maximize, pl_tu);
  s7_define_typed_function(sc, "gtk_window_unmaximize", lg_gtk_window_unmaximize, 1, 0, 0, H_gtk_window_unmaximize, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_default_size", lg_gtk_window_set_default_size, 3, 0, 0, H_gtk_window_set_default_size, pl_tui);
  s7_define_typed_function(sc, "gtk_window_get_default_size", lg_gtk_window_get_default_size, 1, 2, 0, H_gtk_window_get_default_size, pl_pu);
  s7_define_typed_function(sc, "gtk_window_resize", lg_gtk_window_resize, 3, 0, 0, H_gtk_window_resize, pl_tui);
  s7_define_typed_function(sc, "gtk_window_get_size", lg_gtk_window_get_size, 1, 2, 0, H_gtk_window_get_size, pl_pu);
  s7_define_typed_function(sc, "pango_color_copy", lg_pango_color_copy, 1, 0, 0, H_pango_color_copy, pl_pu);
  s7_define_typed_function(sc, "pango_color_free", lg_pango_color_free, 1, 0, 0, H_pango_color_free, pl_tu);
  s7_define_typed_function(sc, "pango_color_parse", lg_pango_color_parse, 2, 0, 0, H_pango_color_parse, pl_bus);
  s7_define_typed_function(sc, "pango_attr_type_register", lg_pango_attr_type_register, 1, 0, 0, H_pango_attr_type_register, pl_gs);
  s7_define_typed_function(sc, "pango_attribute_copy", lg_pango_attribute_copy, 1, 0, 0, H_pango_attribute_copy, pl_pu);
  s7_define_typed_function(sc, "pango_attribute_destroy", lg_pango_attribute_destroy, 1, 0, 0, H_pango_attribute_destroy, pl_tu);
  s7_define_typed_function(sc, "pango_attribute_equal", lg_pango_attribute_equal, 2, 0, 0, H_pango_attribute_equal, pl_bu);
  s7_define_typed_function(sc, "pango_attr_language_new", lg_pango_attr_language_new, 1, 0, 0, H_pango_attr_language_new, pl_pu);
  s7_define_typed_function(sc, "pango_attr_family_new", lg_pango_attr_family_new, 1, 0, 0, H_pango_attr_family_new, pl_ps);
  s7_define_typed_function(sc, "pango_attr_foreground_new", lg_pango_attr_foreground_new, 3, 0, 0, H_pango_attr_foreground_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_background_new", lg_pango_attr_background_new, 3, 0, 0, H_pango_attr_background_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_size_new", lg_pango_attr_size_new, 1, 0, 0, H_pango_attr_size_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_style_new", lg_pango_attr_style_new, 1, 0, 0, H_pango_attr_style_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_weight_new", lg_pango_attr_weight_new, 1, 0, 0, H_pango_attr_weight_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_variant_new", lg_pango_attr_variant_new, 1, 0, 0, H_pango_attr_variant_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_stretch_new", lg_pango_attr_stretch_new, 1, 0, 0, H_pango_attr_stretch_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_font_desc_new", lg_pango_attr_font_desc_new, 1, 0, 0, H_pango_attr_font_desc_new, pl_pu);
  s7_define_typed_function(sc, "pango_attr_underline_new", lg_pango_attr_underline_new, 1, 0, 0, H_pango_attr_underline_new, pl_pg);
  s7_define_typed_function(sc, "pango_attr_strikethrough_new", lg_pango_attr_strikethrough_new, 1, 0, 0, H_pango_attr_strikethrough_new, pl_pb);
  s7_define_typed_function(sc, "pango_attr_rise_new", lg_pango_attr_rise_new, 1, 0, 0, H_pango_attr_rise_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_shape_new", lg_pango_attr_shape_new, 2, 0, 0, H_pango_attr_shape_new, pl_pu);
  s7_define_typed_function(sc, "pango_attr_scale_new", lg_pango_attr_scale_new, 1, 0, 0, H_pango_attr_scale_new, pl_pr);
  s7_define_typed_function(sc, "pango_attr_list_new", lg_pango_attr_list_new, 0, 0, 0, H_pango_attr_list_new, pl_p);
  s7_define_typed_function(sc, "pango_attr_list_unref", lg_pango_attr_list_unref, 1, 0, 0, H_pango_attr_list_unref, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_copy", lg_pango_attr_list_copy, 1, 0, 0, H_pango_attr_list_copy, pl_pu);
  s7_define_typed_function(sc, "pango_attr_list_insert", lg_pango_attr_list_insert, 2, 0, 0, H_pango_attr_list_insert, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_insert_before", lg_pango_attr_list_insert_before, 2, 0, 0, H_pango_attr_list_insert_before, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_change", lg_pango_attr_list_change, 2, 0, 0, H_pango_attr_list_change, pl_tu);
  s7_define_typed_function(sc, "pango_attr_list_splice", lg_pango_attr_list_splice, 4, 0, 0, H_pango_attr_list_splice, pl_tuui);
  s7_define_typed_function(sc, "pango_attr_list_get_iterator", lg_pango_attr_list_get_iterator, 1, 0, 0, H_pango_attr_list_get_iterator, pl_pu);
  s7_define_typed_function(sc, "pango_attr_iterator_range", lg_pango_attr_iterator_range, 1, 2, 0, H_pango_attr_iterator_range, pl_pu);
  s7_define_typed_function(sc, "pango_attr_iterator_next", lg_pango_attr_iterator_next, 1, 0, 0, H_pango_attr_iterator_next, pl_bu);
  s7_define_typed_function(sc, "pango_attr_iterator_copy", lg_pango_attr_iterator_copy, 1, 0, 0, H_pango_attr_iterator_copy, pl_pu);
  s7_define_typed_function(sc, "pango_attr_iterator_destroy", lg_pango_attr_iterator_destroy, 1, 0, 0, H_pango_attr_iterator_destroy, pl_tu);
  s7_define_typed_function(sc, "pango_attr_iterator_get", lg_pango_attr_iterator_get, 2, 0, 0, H_pango_attr_iterator_get, pl_pug);
  s7_define_typed_function(sc, "pango_attr_iterator_get_font", lg_pango_attr_iterator_get_font, 2, 2, 0, H_pango_attr_iterator_get_font, pl_pu);
  s7_define_typed_function(sc, "pango_parse_markup", lg_pango_parse_markup, 6, 1, 0, H_pango_parse_markup, pl_psiiuusu);
  s7_define_typed_function(sc, "pango_find_paragraph_boundary", lg_pango_find_paragraph_boundary, 2, 2, 0, H_pango_find_paragraph_boundary, pl_psiu);
  s7_define_typed_function(sc, "pango_get_log_attrs", lg_pango_get_log_attrs, 6, 0, 0, H_pango_get_log_attrs, pl_tsiiuui);
  s7_define_typed_function(sc, "pango_context_list_families", lg_pango_context_list_families, 1, 2, 0, H_pango_context_list_families, pl_pu);
  s7_define_typed_function(sc, "pango_context_load_font", lg_pango_context_load_font, 2, 0, 0, H_pango_context_load_font, pl_pu);
  s7_define_typed_function(sc, "pango_context_load_fontset", lg_pango_context_load_fontset, 3, 0, 0, H_pango_context_load_fontset, pl_pu);
  s7_define_typed_function(sc, "pango_context_get_metrics", lg_pango_context_get_metrics, 3, 0, 0, H_pango_context_get_metrics, pl_pu);
  s7_define_typed_function(sc, "pango_context_set_font_description", lg_pango_context_set_font_description, 2, 0, 0, H_pango_context_set_font_description, pl_tu);
  s7_define_typed_function(sc, "pango_context_get_font_description", lg_pango_context_get_font_description, 1, 0, 0, H_pango_context_get_font_description, pl_pu);
  s7_define_typed_function(sc, "pango_context_get_language", lg_pango_context_get_language, 1, 0, 0, H_pango_context_get_language, pl_pu);
  s7_define_typed_function(sc, "pango_context_set_language", lg_pango_context_set_language, 2, 0, 0, H_pango_context_set_language, pl_tu);
  s7_define_typed_function(sc, "pango_context_set_base_dir", lg_pango_context_set_base_dir, 2, 0, 0, H_pango_context_set_base_dir, pl_tug);
  s7_define_typed_function(sc, "pango_context_get_base_dir", lg_pango_context_get_base_dir, 1, 0, 0, H_pango_context_get_base_dir, pl_gu);
  s7_define_typed_function(sc, "pango_itemize", lg_pango_itemize, 6, 0, 0, H_pango_itemize, pl_pusiiu);
  s7_define_typed_function(sc, "pango_coverage_new", lg_pango_coverage_new, 0, 0, 0, H_pango_coverage_new, pl_p);
  s7_define_typed_function(sc, "pango_coverage_ref", lg_pango_coverage_ref, 1, 0, 0, H_pango_coverage_ref, pl_pu);
  s7_define_typed_function(sc, "pango_coverage_unref", lg_pango_coverage_unref, 1, 0, 0, H_pango_coverage_unref, pl_tu);
  s7_define_typed_function(sc, "pango_coverage_copy", lg_pango_coverage_copy, 1, 0, 0, H_pango_coverage_copy, pl_pu);
  s7_define_typed_function(sc, "pango_coverage_get", lg_pango_coverage_get, 2, 0, 0, H_pango_coverage_get, pl_gui);
  s7_define_typed_function(sc, "pango_coverage_set", lg_pango_coverage_set, 3, 0, 0, H_pango_coverage_set, pl_tuig);
  s7_define_typed_function(sc, "pango_font_description_new", lg_pango_font_description_new, 0, 0, 0, H_pango_font_description_new, pl_p);
  s7_define_typed_function(sc, "pango_font_description_copy", lg_pango_font_description_copy, 1, 0, 0, H_pango_font_description_copy, pl_pu);
  s7_define_typed_function(sc, "pango_font_description_copy_static", lg_pango_font_description_copy_static, 1, 0, 0, H_pango_font_description_copy_static, pl_pu);
  s7_define_typed_function(sc, "pango_font_description_hash", lg_pango_font_description_hash, 1, 0, 0, H_pango_font_description_hash, pl_iu);
  s7_define_typed_function(sc, "pango_font_description_equal", lg_pango_font_description_equal, 2, 0, 0, H_pango_font_description_equal, pl_bu);
  s7_define_typed_function(sc, "pango_font_description_free", lg_pango_font_description_free, 1, 0, 0, H_pango_font_description_free, pl_tu);
  s7_define_typed_function(sc, "pango_font_descriptions_free", lg_pango_font_descriptions_free, 2, 0, 0, H_pango_font_descriptions_free, pl_tui);
  s7_define_typed_function(sc, "pango_font_description_set_family", lg_pango_font_description_set_family, 2, 0, 0, H_pango_font_description_set_family, pl_tus);
  s7_define_typed_function(sc, "pango_font_description_set_family_static", lg_pango_font_description_set_family_static, 2, 0, 0, H_pango_font_description_set_family_static, pl_tus);
  s7_define_typed_function(sc, "pango_font_description_get_family", lg_pango_font_description_get_family, 1, 0, 0, H_pango_font_description_get_family, pl_su);
  s7_define_typed_function(sc, "pango_font_description_set_style", lg_pango_font_description_set_style, 2, 0, 0, H_pango_font_description_set_style, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_style", lg_pango_font_description_get_style, 1, 0, 0, H_pango_font_description_get_style, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_variant", lg_pango_font_description_set_variant, 2, 0, 0, H_pango_font_description_set_variant, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_variant", lg_pango_font_description_get_variant, 1, 0, 0, H_pango_font_description_get_variant, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_weight", lg_pango_font_description_set_weight, 2, 0, 0, H_pango_font_description_set_weight, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_weight", lg_pango_font_description_get_weight, 1, 0, 0, H_pango_font_description_get_weight, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_stretch", lg_pango_font_description_set_stretch, 2, 0, 0, H_pango_font_description_set_stretch, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_get_stretch", lg_pango_font_description_get_stretch, 1, 0, 0, H_pango_font_description_get_stretch, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_set_size", lg_pango_font_description_set_size, 2, 0, 0, H_pango_font_description_set_size, pl_tui);
  s7_define_typed_function(sc, "pango_font_description_get_size", lg_pango_font_description_get_size, 1, 0, 0, H_pango_font_description_get_size, pl_iu);
  s7_define_typed_function(sc, "pango_font_description_get_set_fields", lg_pango_font_description_get_set_fields, 1, 0, 0, H_pango_font_description_get_set_fields, pl_gu);
  s7_define_typed_function(sc, "pango_font_description_unset_fields", lg_pango_font_description_unset_fields, 2, 0, 0, H_pango_font_description_unset_fields, pl_tug);
  s7_define_typed_function(sc, "pango_font_description_merge", lg_pango_font_description_merge, 3, 0, 0, H_pango_font_description_merge, pl_tuub);
  s7_define_typed_function(sc, "pango_font_description_merge_static", lg_pango_font_description_merge_static, 3, 0, 0, H_pango_font_description_merge_static, pl_tuub);
  s7_define_typed_function(sc, "pango_font_description_better_match", lg_pango_font_description_better_match, 3, 0, 0, H_pango_font_description_better_match, pl_bu);
  s7_define_typed_function(sc, "pango_font_description_from_string", lg_pango_font_description_from_string, 1, 0, 0, H_pango_font_description_from_string, pl_ps);
  s7_define_typed_function(sc, "pango_font_description_to_string", lg_pango_font_description_to_string, 1, 0, 0, H_pango_font_description_to_string, pl_su);
  s7_define_typed_function(sc, "pango_font_description_to_filename", lg_pango_font_description_to_filename, 1, 0, 0, H_pango_font_description_to_filename, pl_su);
  s7_define_typed_function(sc, "pango_font_metrics_ref", lg_pango_font_metrics_ref, 1, 0, 0, H_pango_font_metrics_ref, pl_pu);
  s7_define_typed_function(sc, "pango_font_metrics_unref", lg_pango_font_metrics_unref, 1, 0, 0, H_pango_font_metrics_unref, pl_tu);
  s7_define_typed_function(sc, "pango_font_metrics_get_ascent", lg_pango_font_metrics_get_ascent, 1, 0, 0, H_pango_font_metrics_get_ascent, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_descent", lg_pango_font_metrics_get_descent, 1, 0, 0, H_pango_font_metrics_get_descent, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_approximate_char_width", lg_pango_font_metrics_get_approximate_char_width, 1, 0, 0, H_pango_font_metrics_get_approximate_char_width, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_approximate_digit_width", lg_pango_font_metrics_get_approximate_digit_width, 1, 0, 0, H_pango_font_metrics_get_approximate_digit_width, pl_iu);
  s7_define_typed_function(sc, "pango_font_family_list_faces", lg_pango_font_family_list_faces, 1, 2, 0, H_pango_font_family_list_faces, pl_pu);
  s7_define_typed_function(sc, "pango_font_family_get_name", lg_pango_font_family_get_name, 1, 0, 0, H_pango_font_family_get_name, pl_su);
  s7_define_typed_function(sc, "pango_font_face_describe", lg_pango_font_face_describe, 1, 0, 0, H_pango_font_face_describe, pl_pu);
  s7_define_typed_function(sc, "pango_font_face_get_face_name", lg_pango_font_face_get_face_name, 1, 0, 0, H_pango_font_face_get_face_name, pl_su);
  s7_define_typed_function(sc, "pango_font_describe", lg_pango_font_describe, 1, 0, 0, H_pango_font_describe, pl_pu);
  s7_define_typed_function(sc, "pango_font_get_coverage", lg_pango_font_get_coverage, 2, 0, 0, H_pango_font_get_coverage, pl_pu);
  s7_define_typed_function(sc, "pango_font_get_metrics", lg_pango_font_get_metrics, 2, 0, 0, H_pango_font_get_metrics, pl_pu);
  s7_define_typed_function(sc, "pango_font_get_glyph_extents", lg_pango_font_get_glyph_extents, 4, 0, 0, H_pango_font_get_glyph_extents, pl_tuiu);
  s7_define_typed_function(sc, "pango_font_map_load_font", lg_pango_font_map_load_font, 3, 0, 0, H_pango_font_map_load_font, pl_pu);
  s7_define_typed_function(sc, "pango_font_map_load_fontset", lg_pango_font_map_load_fontset, 4, 0, 0, H_pango_font_map_load_fontset, pl_pu);
  s7_define_typed_function(sc, "pango_font_map_list_families", lg_pango_font_map_list_families, 1, 2, 0, H_pango_font_map_list_families, pl_pu);
  s7_define_typed_function(sc, "pango_glyph_string_new", lg_pango_glyph_string_new, 0, 0, 0, H_pango_glyph_string_new, pl_p);
  s7_define_typed_function(sc, "pango_glyph_string_set_size", lg_pango_glyph_string_set_size, 2, 0, 0, H_pango_glyph_string_set_size, pl_tui);
  s7_define_typed_function(sc, "pango_glyph_string_copy", lg_pango_glyph_string_copy, 1, 0, 0, H_pango_glyph_string_copy, pl_pu);
  s7_define_typed_function(sc, "pango_glyph_string_free", lg_pango_glyph_string_free, 1, 0, 0, H_pango_glyph_string_free, pl_tu);
  s7_define_typed_function(sc, "pango_glyph_string_extents", lg_pango_glyph_string_extents, 4, 0, 0, H_pango_glyph_string_extents, pl_tu);
  s7_define_typed_function(sc, "pango_glyph_string_extents_range", lg_pango_glyph_string_extents_range, 6, 0, 0, H_pango_glyph_string_extents_range, pl_tuiiu);
  s7_define_typed_function(sc, "pango_glyph_string_get_logical_widths", lg_pango_glyph_string_get_logical_widths, 4, 1, 0, H_pango_glyph_string_get_logical_widths, pl_pusiiu);
  s7_define_typed_function(sc, "pango_glyph_string_index_to_x", lg_pango_glyph_string_index_to_x, 6, 1, 0, H_pango_glyph_string_index_to_x, pl_pusiuibu);
  s7_define_typed_function(sc, "pango_glyph_string_x_to_index", lg_pango_glyph_string_x_to_index, 5, 2, 0, H_pango_glyph_string_x_to_index, pl_pusiuiu);
  s7_define_typed_function(sc, "pango_shape", lg_pango_shape, 4, 0, 0, H_pango_shape, pl_tsiu);
  s7_define_typed_function(sc, "pango_reorder_items", lg_pango_reorder_items, 1, 0, 0, H_pango_reorder_items, pl_pu);
  s7_define_typed_function(sc, "pango_item_new", lg_pango_item_new, 0, 0, 0, H_pango_item_new, pl_p);
  s7_define_typed_function(sc, "pango_item_copy", lg_pango_item_copy, 1, 0, 0, H_pango_item_copy, pl_pu);
  s7_define_typed_function(sc, "pango_item_free", lg_pango_item_free, 1, 0, 0, H_pango_item_free, pl_tu);
  s7_define_typed_function(sc, "pango_item_split", lg_pango_item_split, 3, 0, 0, H_pango_item_split, pl_pui);
  s7_define_typed_function(sc, "pango_layout_new", lg_pango_layout_new, 1, 0, 0, H_pango_layout_new, pl_pu);
  s7_define_typed_function(sc, "pango_layout_copy", lg_pango_layout_copy, 1, 0, 0, H_pango_layout_copy, pl_pu);
  s7_define_typed_function(sc, "pango_layout_get_context", lg_pango_layout_get_context, 1, 0, 0, H_pango_layout_get_context, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_attributes", lg_pango_layout_set_attributes, 2, 0, 0, H_pango_layout_set_attributes, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_attributes", lg_pango_layout_get_attributes, 1, 0, 0, H_pango_layout_get_attributes, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_text", lg_pango_layout_set_text, 3, 0, 0, H_pango_layout_set_text, pl_tusi);
  s7_define_typed_function(sc, "pango_layout_get_text", lg_pango_layout_get_text, 1, 0, 0, H_pango_layout_get_text, pl_su);
  s7_define_typed_function(sc, "pango_layout_set_markup", lg_pango_layout_set_markup, 3, 0, 0, H_pango_layout_set_markup, pl_tusi);
  s7_define_typed_function(sc, "pango_layout_set_markup_with_accel", lg_pango_layout_set_markup_with_accel, 5, 0, 0, H_pango_layout_set_markup_with_accel, pl_tusiis);
  s7_define_typed_function(sc, "pango_layout_set_font_description", lg_pango_layout_set_font_description, 2, 0, 0, H_pango_layout_set_font_description, pl_tu);
  s7_define_typed_function(sc, "pango_layout_set_width", lg_pango_layout_set_width, 2, 0, 0, H_pango_layout_set_width, pl_tui);
  s7_define_typed_function(sc, "pango_layout_get_width", lg_pango_layout_get_width, 1, 0, 0, H_pango_layout_get_width, pl_iu);
  s7_define_typed_function(sc, "pango_layout_set_wrap", lg_pango_layout_set_wrap, 2, 0, 0, H_pango_layout_set_wrap, pl_tug);
  s7_define_typed_function(sc, "pango_layout_get_wrap", lg_pango_layout_get_wrap, 1, 0, 0, H_pango_layout_get_wrap, pl_gu);
  s7_define_typed_function(sc, "pango_layout_set_indent", lg_pango_layout_set_indent, 2, 0, 0, H_pango_layout_set_indent, pl_tui);
  s7_define_typed_function(sc, "pango_layout_get_indent", lg_pango_layout_get_indent, 1, 0, 0, H_pango_layout_get_indent, pl_iu);
  s7_define_typed_function(sc, "pango_layout_set_spacing", lg_pango_layout_set_spacing, 2, 0, 0, H_pango_layout_set_spacing, pl_tui);
  s7_define_typed_function(sc, "pango_layout_get_spacing", lg_pango_layout_get_spacing, 1, 0, 0, H_pango_layout_get_spacing, pl_iu);
  s7_define_typed_function(sc, "pango_layout_set_justify", lg_pango_layout_set_justify, 2, 0, 0, H_pango_layout_set_justify, pl_tub);
  s7_define_typed_function(sc, "pango_layout_get_justify", lg_pango_layout_get_justify, 1, 0, 0, H_pango_layout_get_justify, pl_bu);
  s7_define_typed_function(sc, "pango_layout_set_alignment", lg_pango_layout_set_alignment, 2, 0, 0, H_pango_layout_set_alignment, pl_tug);
  s7_define_typed_function(sc, "pango_layout_get_alignment", lg_pango_layout_get_alignment, 1, 0, 0, H_pango_layout_get_alignment, pl_gu);
  s7_define_typed_function(sc, "pango_layout_set_tabs", lg_pango_layout_set_tabs, 2, 0, 0, H_pango_layout_set_tabs, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_tabs", lg_pango_layout_get_tabs, 1, 0, 0, H_pango_layout_get_tabs, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_single_paragraph_mode", lg_pango_layout_set_single_paragraph_mode, 2, 0, 0, H_pango_layout_set_single_paragraph_mode, pl_tub);
  s7_define_typed_function(sc, "pango_layout_get_single_paragraph_mode", lg_pango_layout_get_single_paragraph_mode, 1, 0, 0, H_pango_layout_get_single_paragraph_mode, pl_bu);
  s7_define_typed_function(sc, "pango_layout_context_changed", lg_pango_layout_context_changed, 1, 0, 0, H_pango_layout_context_changed, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_log_attrs", lg_pango_layout_get_log_attrs, 1, 2, 0, H_pango_layout_get_log_attrs, pl_pu);
  s7_define_typed_function(sc, "pango_layout_index_to_pos", lg_pango_layout_index_to_pos, 3, 0, 0, H_pango_layout_index_to_pos, pl_tuiu);
  s7_define_typed_function(sc, "pango_layout_get_cursor_pos", lg_pango_layout_get_cursor_pos, 4, 0, 0, H_pango_layout_get_cursor_pos, pl_tuiu);
  s7_define_typed_function(sc, "pango_layout_move_cursor_visually", lg_pango_layout_move_cursor_visually, 7, 0, 0, H_pango_layout_move_cursor_visually, pl_tubiiiu);
  s7_define_typed_function(sc, "pango_layout_xy_to_index", lg_pango_layout_xy_to_index, 3, 2, 0, H_pango_layout_xy_to_index, pl_puiiu);
  s7_define_typed_function(sc, "pango_layout_get_extents", lg_pango_layout_get_extents, 3, 0, 0, H_pango_layout_get_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_pixel_extents", lg_pango_layout_get_pixel_extents, 3, 0, 0, H_pango_layout_get_pixel_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_size", lg_pango_layout_get_size, 1, 2, 0, H_pango_layout_get_size, pl_pu);
  s7_define_typed_function(sc, "pango_layout_get_pixel_size", lg_pango_layout_get_pixel_size, 1, 2, 0, H_pango_layout_get_pixel_size, pl_pu);
  s7_define_typed_function(sc, "pango_layout_get_line_count", lg_pango_layout_get_line_count, 1, 0, 0, H_pango_layout_get_line_count, pl_iu);
  s7_define_typed_function(sc, "pango_layout_get_line", lg_pango_layout_get_line, 2, 0, 0, H_pango_layout_get_line, pl_pui);
  s7_define_typed_function(sc, "pango_layout_get_lines", lg_pango_layout_get_lines, 1, 0, 0, H_pango_layout_get_lines, pl_pu);
  s7_define_typed_function(sc, "pango_layout_line_unref", lg_pango_layout_line_unref, 1, 0, 0, H_pango_layout_line_unref, pl_tu);
  s7_define_typed_function(sc, "pango_layout_line_x_to_index", lg_pango_layout_line_x_to_index, 2, 2, 0, H_pango_layout_line_x_to_index, pl_puiu);
  s7_define_typed_function(sc, "pango_layout_line_index_to_x", lg_pango_layout_line_index_to_x, 3, 1, 0, H_pango_layout_line_index_to_x, pl_puibu);
  s7_define_typed_function(sc, "pango_layout_line_get_x_ranges", lg_pango_layout_line_get_x_ranges, 3, 2, 0, H_pango_layout_line_get_x_ranges, pl_puiiu);
  s7_define_typed_function(sc, "pango_layout_line_get_extents", lg_pango_layout_line_get_extents, 3, 0, 0, H_pango_layout_line_get_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_line_get_pixel_extents", lg_pango_layout_line_get_pixel_extents, 3, 0, 0, H_pango_layout_line_get_pixel_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_get_iter", lg_pango_layout_get_iter, 1, 0, 0, H_pango_layout_get_iter, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_free", lg_pango_layout_iter_free, 1, 0, 0, H_pango_layout_iter_free, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_index", lg_pango_layout_iter_get_index, 1, 0, 0, H_pango_layout_iter_get_index, pl_iu);
  s7_define_typed_function(sc, "pango_layout_iter_get_run", lg_pango_layout_iter_get_run, 1, 0, 0, H_pango_layout_iter_get_run, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_get_line", lg_pango_layout_iter_get_line, 1, 0, 0, H_pango_layout_iter_get_line, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_at_last_line", lg_pango_layout_iter_at_last_line, 1, 0, 0, H_pango_layout_iter_at_last_line, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_char", lg_pango_layout_iter_next_char, 1, 0, 0, H_pango_layout_iter_next_char, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_cluster", lg_pango_layout_iter_next_cluster, 1, 0, 0, H_pango_layout_iter_next_cluster, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_run", lg_pango_layout_iter_next_run, 1, 0, 0, H_pango_layout_iter_next_run, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_next_line", lg_pango_layout_iter_next_line, 1, 0, 0, H_pango_layout_iter_next_line, pl_bu);
  s7_define_typed_function(sc, "pango_layout_iter_get_char_extents", lg_pango_layout_iter_get_char_extents, 2, 0, 0, H_pango_layout_iter_get_char_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_cluster_extents", lg_pango_layout_iter_get_cluster_extents, 3, 0, 0, H_pango_layout_iter_get_cluster_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_run_extents", lg_pango_layout_iter_get_run_extents, 3, 0, 0, H_pango_layout_iter_get_run_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_line_extents", lg_pango_layout_iter_get_line_extents, 3, 0, 0, H_pango_layout_iter_get_line_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_line_yrange", lg_pango_layout_iter_get_line_yrange, 1, 2, 0, H_pango_layout_iter_get_line_yrange, pl_pu);
  s7_define_typed_function(sc, "pango_layout_iter_get_layout_extents", lg_pango_layout_iter_get_layout_extents, 3, 0, 0, H_pango_layout_iter_get_layout_extents, pl_tu);
  s7_define_typed_function(sc, "pango_layout_iter_get_baseline", lg_pango_layout_iter_get_baseline, 1, 0, 0, H_pango_layout_iter_get_baseline, pl_iu);
  s7_define_typed_function(sc, "pango_language_from_string", lg_pango_language_from_string, 1, 0, 0, H_pango_language_from_string, pl_ps);
  s7_define_typed_function(sc, "pango_language_matches", lg_pango_language_matches, 2, 0, 0, H_pango_language_matches, pl_bus);
  s7_define_typed_function(sc, "G_OBJECT_TYPE", lg_G_OBJECT_TYPE, 1, 0, 0, H_G_OBJECT_TYPE, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_model_get_string_from_iter", lg_gtk_tree_model_get_string_from_iter, 2, 0, 0, H_gtk_tree_model_get_string_from_iter, pl_su);
  s7_define_typed_function(sc, "gtk_tree_model_sort_iter_is_valid", lg_gtk_tree_model_sort_iter_is_valid, 2, 0, 0, H_gtk_tree_model_sort_iter_is_valid, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_expand_to_path", lg_gtk_tree_view_expand_to_path, 2, 0, 0, H_gtk_tree_view_expand_to_path, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_selection_get_selected_rows", lg_gtk_tree_selection_get_selected_rows, 2, 0, 0, H_gtk_tree_selection_get_selected_rows, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_selection_count_selected_rows", lg_gtk_tree_selection_count_selected_rows, 1, 0, 0, H_gtk_tree_selection_count_selected_rows, pl_iu);
  s7_define_typed_function(sc, "gtk_notebook_get_n_pages", lg_gtk_notebook_get_n_pages, 1, 0, 0, H_gtk_notebook_get_n_pages, pl_iu);
  s7_define_typed_function(sc, "gtk_list_store_reorder", lg_gtk_list_store_reorder, 2, 0, 0, H_gtk_list_store_reorder, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_swap", lg_gtk_list_store_swap, 3, 0, 0, H_gtk_list_store_swap, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_move_after", lg_gtk_list_store_move_after, 3, 0, 0, H_gtk_list_store_move_after, pl_tu);
  s7_define_typed_function(sc, "gtk_list_store_move_before", lg_gtk_list_store_move_before, 3, 0, 0, H_gtk_list_store_move_before, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_reorder", lg_gtk_tree_store_reorder, 3, 0, 0, H_gtk_tree_store_reorder, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_store_swap", lg_gtk_tree_store_swap, 3, 0, 0, H_gtk_tree_store_swap, pl_tu);
  s7_define_typed_function(sc, "gdk_display_open", lg_gdk_display_open, 1, 0, 0, H_gdk_display_open, pl_ps);
  s7_define_typed_function(sc, "gdk_display_get_name", lg_gdk_display_get_name, 1, 0, 0, H_gdk_display_get_name, pl_su);
  s7_define_typed_function(sc, "gdk_display_beep", lg_gdk_display_beep, 1, 0, 0, H_gdk_display_beep, pl_tu);
  s7_define_typed_function(sc, "gdk_display_sync", lg_gdk_display_sync, 1, 0, 0, H_gdk_display_sync, pl_tu);
  s7_define_typed_function(sc, "gdk_display_close", lg_gdk_display_close, 1, 0, 0, H_gdk_display_close, pl_tu);
  s7_define_typed_function(sc, "gdk_display_get_event", lg_gdk_display_get_event, 1, 0, 0, H_gdk_display_get_event, pl_pu);
  s7_define_typed_function(sc, "gdk_display_peek_event", lg_gdk_display_peek_event, 1, 0, 0, H_gdk_display_peek_event, pl_pu);
  s7_define_typed_function(sc, "gdk_display_put_event", lg_gdk_display_put_event, 2, 0, 0, H_gdk_display_put_event, pl_tu);
  s7_define_typed_function(sc, "gdk_display_get_default", lg_gdk_display_get_default, 0, 0, 0, H_gdk_display_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_widget_get_display", lg_gtk_widget_get_display, 1, 0, 0, H_gtk_widget_get_display, pl_pu);
  s7_define_typed_function(sc, "g_list_free", lg_g_list_free, 1, 0, 0, H_g_list_free, pl_tu);
  s7_define_typed_function(sc, "g_list_reverse", lg_g_list_reverse, 1, 0, 0, H_g_list_reverse, pl_pu);
  s7_define_typed_function(sc, "g_list_copy", lg_g_list_copy, 1, 0, 0, H_g_list_copy, pl_pu);
  s7_define_typed_function(sc, "g_list_last", lg_g_list_last, 1, 0, 0, H_g_list_last, pl_pu);
  s7_define_typed_function(sc, "g_list_first", lg_g_list_first, 1, 0, 0, H_g_list_first, pl_pu);
  s7_define_typed_function(sc, "g_list_length", lg_g_list_length, 1, 0, 0, H_g_list_length, pl_iu);
  s7_define_typed_function(sc, "g_free", lg_g_free, 1, 0, 0, H_g_free, pl_t);
  s7_define_typed_function(sc, "g_list_remove_link", lg_g_list_remove_link, 2, 0, 0, H_g_list_remove_link, pl_pu);
  s7_define_typed_function(sc, "g_object_get_data", lg_g_object_get_data, 2, 0, 0, H_g_object_get_data, pl_tus);
  s7_define_typed_function(sc, "g_object_set_data", lg_g_object_set_data, 3, 0, 0, H_g_object_set_data, pl_tust);
  s7_define_typed_function(sc, "gdk_display_flush", lg_gdk_display_flush, 1, 0, 0, H_gdk_display_flush, pl_tu);
  s7_define_typed_function(sc, "gtk_calendar_set_display_options", lg_gtk_calendar_set_display_options, 2, 0, 0, H_gtk_calendar_set_display_options, pl_tug);
  s7_define_typed_function(sc, "gtk_calendar_get_display_options", lg_gtk_calendar_get_display_options, 1, 0, 0, H_gtk_calendar_get_display_options, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_completion", lg_gtk_entry_set_completion, 2, 0, 0, H_gtk_entry_set_completion, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_completion", lg_gtk_entry_get_completion, 1, 0, 0, H_gtk_entry_get_completion, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_select_range", lg_gtk_text_buffer_select_range, 3, 0, 0, H_gtk_text_buffer_select_range, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_set_overwrite", lg_gtk_text_view_set_overwrite, 2, 0, 0, H_gtk_text_view_set_overwrite, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_overwrite", lg_gtk_text_view_get_overwrite, 1, 0, 0, H_gtk_text_view_get_overwrite, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_set_accepts_tab", lg_gtk_text_view_set_accepts_tab, 2, 0, 0, H_gtk_text_view_set_accepts_tab, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_accepts_tab", lg_gtk_text_view_get_accepts_tab, 1, 0, 0, H_gtk_text_view_get_accepts_tab, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_column_set_expand", lg_gtk_tree_view_column_set_expand, 2, 0, 0, H_gtk_tree_view_column_set_expand, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_expand", lg_gtk_tree_view_column_get_expand, 1, 0, 0, H_gtk_tree_view_column_get_expand, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_dialog_new", lg_gtk_file_chooser_dialog_new, 3, 1, 0, H_gtk_file_chooser_dialog_new, pl_psugt);
  s7_define_typed_function(sc, "gtk_file_chooser_widget_new", lg_gtk_file_chooser_widget_new, 1, 0, 0, H_gtk_file_chooser_widget_new, pl_pg);
  s7_define_typed_function(sc, "gtk_tree_model_filter_new", lg_gtk_tree_model_filter_new, 2, 0, 0, H_gtk_tree_model_filter_new, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_set_visible_column", lg_gtk_tree_model_filter_set_visible_column, 2, 0, 0, H_gtk_tree_model_filter_set_visible_column, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_model_filter_get_model", lg_gtk_tree_model_filter_get_model, 1, 0, 0, H_gtk_tree_model_filter_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_iter_to_child_iter", lg_gtk_tree_model_filter_convert_iter_to_child_iter, 3, 0, 0, H_gtk_tree_model_filter_convert_iter_to_child_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_child_path_to_path", lg_gtk_tree_model_filter_convert_child_path_to_path, 2, 0, 0, H_gtk_tree_model_filter_convert_child_path_to_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_path_to_child_path", lg_gtk_tree_model_filter_convert_path_to_child_path, 2, 0, 0, H_gtk_tree_model_filter_convert_path_to_child_path, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_refilter", lg_gtk_tree_model_filter_refilter, 1, 0, 0, H_gtk_tree_model_filter_refilter, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_clear_cache", lg_gtk_tree_model_filter_clear_cache, 1, 0, 0, H_gtk_tree_model_filter_clear_cache, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_new", lg_gtk_combo_box_new, 0, 0, 0, H_gtk_combo_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_new_with_model", lg_gtk_combo_box_new_with_model, 1, 0, 0, H_gtk_combo_box_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_combo_box_set_model", lg_gtk_combo_box_set_model, 2, 0, 0, H_gtk_combo_box_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_get_active", lg_gtk_combo_box_get_active, 1, 0, 0, H_gtk_combo_box_get_active, pl_iu);
  s7_define_typed_function(sc, "gtk_combo_box_set_active", lg_gtk_combo_box_set_active, 2, 0, 0, H_gtk_combo_box_set_active, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_active_iter", lg_gtk_combo_box_get_active_iter, 2, 0, 0, H_gtk_combo_box_get_active_iter, pl_bu);
  s7_define_typed_function(sc, "gtk_combo_box_set_active_iter", lg_gtk_combo_box_set_active_iter, 2, 0, 0, H_gtk_combo_box_set_active_iter, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_get_model", lg_gtk_combo_box_get_model, 1, 0, 0, H_gtk_combo_box_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_expander_new", lg_gtk_expander_new, 1, 0, 0, H_gtk_expander_new, pl_ps);
  s7_define_typed_function(sc, "gtk_expander_new_with_mnemonic", lg_gtk_expander_new_with_mnemonic, 1, 0, 0, H_gtk_expander_new_with_mnemonic, pl_ps);
  s7_define_typed_function(sc, "gtk_expander_set_expanded", lg_gtk_expander_set_expanded, 2, 0, 0, H_gtk_expander_set_expanded, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_expanded", lg_gtk_expander_get_expanded, 1, 0, 0, H_gtk_expander_get_expanded, pl_bu);
  s7_define_typed_function(sc, "gtk_expander_set_label", lg_gtk_expander_set_label, 2, 0, 0, H_gtk_expander_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_expander_get_label", lg_gtk_expander_get_label, 1, 0, 0, H_gtk_expander_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_expander_set_use_underline", lg_gtk_expander_set_use_underline, 2, 0, 0, H_gtk_expander_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_use_underline", lg_gtk_expander_get_use_underline, 1, 0, 0, H_gtk_expander_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_expander_set_label_widget", lg_gtk_expander_set_label_widget, 2, 0, 0, H_gtk_expander_set_label_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_expander_get_label_widget", lg_gtk_expander_get_label_widget, 1, 0, 0, H_gtk_expander_get_label_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_expander_set_use_markup", lg_gtk_expander_set_use_markup, 2, 0, 0, H_gtk_expander_set_use_markup, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_use_markup", lg_gtk_expander_get_use_markup, 1, 0, 0, H_gtk_expander_get_use_markup, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_new", lg_gtk_font_button_new, 0, 0, 0, H_gtk_font_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_font_button_new_with_font", lg_gtk_font_button_new_with_font, 1, 0, 0, H_gtk_font_button_new_with_font, pl_ps);
  s7_define_typed_function(sc, "gtk_font_button_get_title", lg_gtk_font_button_get_title, 1, 0, 0, H_gtk_font_button_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_font_button_set_title", lg_gtk_font_button_set_title, 2, 0, 0, H_gtk_font_button_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_font_button_get_use_font", lg_gtk_font_button_get_use_font, 1, 0, 0, H_gtk_font_button_get_use_font, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_use_font", lg_gtk_font_button_set_use_font, 2, 0, 0, H_gtk_font_button_set_use_font, pl_tub);
  s7_define_typed_function(sc, "gtk_font_button_get_use_size", lg_gtk_font_button_get_use_size, 1, 0, 0, H_gtk_font_button_get_use_size, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_use_size", lg_gtk_font_button_set_use_size, 2, 0, 0, H_gtk_font_button_set_use_size, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_new", lg_gtk_entry_completion_new, 0, 0, 0, H_gtk_entry_completion_new, pl_p);
  s7_define_typed_function(sc, "gtk_entry_completion_get_entry", lg_gtk_entry_completion_get_entry, 1, 0, 0, H_gtk_entry_completion_get_entry, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_model", lg_gtk_entry_completion_set_model, 2, 0, 0, H_gtk_entry_completion_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_get_model", lg_gtk_entry_completion_get_model, 1, 0, 0, H_gtk_entry_completion_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_match_func", lg_gtk_entry_completion_set_match_func, 4, 0, 0, H_gtk_entry_completion_set_match_func, pl_tut);
  s7_define_typed_function(sc, "gtk_entry_completion_set_minimum_key_length", lg_gtk_entry_completion_set_minimum_key_length, 2, 0, 0, H_gtk_entry_completion_set_minimum_key_length, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_completion_get_minimum_key_length", lg_gtk_entry_completion_get_minimum_key_length, 1, 0, 0, H_gtk_entry_completion_get_minimum_key_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_completion_complete", lg_gtk_entry_completion_complete, 1, 0, 0, H_gtk_entry_completion_complete, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_insert_action_text", lg_gtk_entry_completion_insert_action_text, 3, 0, 0, H_gtk_entry_completion_insert_action_text, pl_tuis);
  s7_define_typed_function(sc, "gtk_entry_completion_insert_action_markup", lg_gtk_entry_completion_insert_action_markup, 3, 0, 0, H_gtk_entry_completion_insert_action_markup, pl_tuis);
  s7_define_typed_function(sc, "gtk_entry_completion_delete_action", lg_gtk_entry_completion_delete_action, 2, 0, 0, H_gtk_entry_completion_delete_action, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_completion_set_text_column", lg_gtk_entry_completion_set_text_column, 2, 0, 0, H_gtk_entry_completion_set_text_column, pl_tui);
  s7_define_typed_function(sc, "g_timeout_add_full", lg_g_timeout_add_full, 5, 0, 0, H_g_timeout_add_full, pl_iiit);
  s7_define_typed_function(sc, "g_timeout_add", lg_g_timeout_add, 3, 0, 0, H_g_timeout_add, pl_iit);
  s7_define_typed_function(sc, "g_idle_add", lg_g_idle_add, 2, 0, 0, H_g_idle_add, pl_it);
  s7_define_typed_function(sc, "g_idle_add_full", lg_g_idle_add_full, 4, 0, 0, H_g_idle_add_full, pl_iit);
  s7_define_typed_function(sc, "g_idle_remove_by_data", lg_g_idle_remove_by_data, 1, 0, 0, H_g_idle_remove_by_data, pl_bt);
  s7_define_typed_function(sc, "g_source_remove", lg_g_source_remove, 1, 0, 0, H_g_source_remove, pl_bi);
  s7_define_typed_function(sc, "gtk_file_filter_new", lg_gtk_file_filter_new, 0, 0, 0, H_gtk_file_filter_new, pl_p);
  s7_define_typed_function(sc, "gtk_file_filter_set_name", lg_gtk_file_filter_set_name, 2, 0, 0, H_gtk_file_filter_set_name, pl_tus);
  s7_define_typed_function(sc, "gtk_file_filter_get_name", lg_gtk_file_filter_get_name, 1, 0, 0, H_gtk_file_filter_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_file_filter_add_mime_type", lg_gtk_file_filter_add_mime_type, 2, 0, 0, H_gtk_file_filter_add_mime_type, pl_tus);
  s7_define_typed_function(sc, "gtk_file_filter_add_pattern", lg_gtk_file_filter_add_pattern, 2, 0, 0, H_gtk_file_filter_add_pattern, pl_tus);
  s7_define_typed_function(sc, "gtk_file_filter_add_custom", lg_gtk_file_filter_add_custom, 5, 0, 0, H_gtk_file_filter_add_custom, pl_tugt);
  s7_define_typed_function(sc, "gtk_file_filter_get_needed", lg_gtk_file_filter_get_needed, 1, 0, 0, H_gtk_file_filter_get_needed, pl_gu);
  s7_define_typed_function(sc, "gtk_file_filter_filter", lg_gtk_file_filter_filter, 2, 0, 0, H_gtk_file_filter_filter, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_layout_pack_start", lg_gtk_cell_layout_pack_start, 3, 0, 0, H_gtk_cell_layout_pack_start, pl_tuub);
  s7_define_typed_function(sc, "gtk_cell_layout_pack_end", lg_gtk_cell_layout_pack_end, 3, 0, 0, H_gtk_cell_layout_pack_end, pl_tuub);
  s7_define_typed_function(sc, "gtk_cell_layout_clear", lg_gtk_cell_layout_clear, 1, 0, 0, H_gtk_cell_layout_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_layout_set_attributes", lg_gtk_cell_layout_set_attributes, 3, 0, 0, H_gtk_cell_layout_set_attributes, pl_tuut);
  s7_define_typed_function(sc, "gtk_cell_layout_add_attribute", lg_gtk_cell_layout_add_attribute, 4, 0, 0, H_gtk_cell_layout_add_attribute, pl_tuusi);
  s7_define_typed_function(sc, "gtk_cell_layout_set_cell_data_func", lg_gtk_cell_layout_set_cell_data_func, 5, 0, 0, H_gtk_cell_layout_set_cell_data_func, pl_tuut);
  s7_define_typed_function(sc, "gtk_cell_layout_clear_attributes", lg_gtk_cell_layout_clear_attributes, 2, 0, 0, H_gtk_cell_layout_clear_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_action", lg_gtk_file_chooser_set_action, 2, 0, 0, H_gtk_file_chooser_set_action, pl_tug);
  s7_define_typed_function(sc, "gtk_file_chooser_get_action", lg_gtk_file_chooser_get_action, 1, 0, 0, H_gtk_file_chooser_get_action, pl_gu);
  s7_define_typed_function(sc, "gtk_icon_info_get_base_size", lg_gtk_icon_info_get_base_size, 1, 0, 0, H_gtk_icon_info_get_base_size, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_info_get_filename", lg_gtk_icon_info_get_filename, 1, 0, 0, H_gtk_icon_info_get_filename, pl_su);
  s7_define_typed_function(sc, "gtk_icon_info_load_icon", lg_gtk_icon_info_load_icon, 1, 1, 0, H_gtk_icon_info_load_icon, pl_pu);
  s7_define_typed_function(sc, "gtk_list_store_remove", lg_gtk_list_store_remove, 2, 0, 0, H_gtk_list_store_remove, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_layout_reorder", lg_gtk_cell_layout_reorder, 3, 0, 0, H_gtk_cell_layout_reorder, pl_tuui);
  s7_define_typed_function(sc, "gtk_paned_get_child1", lg_gtk_paned_get_child1, 1, 0, 0, H_gtk_paned_get_child1, pl_pu);
  s7_define_typed_function(sc, "gtk_paned_get_child2", lg_gtk_paned_get_child2, 1, 0, 0, H_gtk_paned_get_child2, pl_pu);
  s7_define_typed_function(sc, "g_list_nth_data", lg_g_list_nth_data, 2, 0, 0, H_g_list_nth_data, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_popup", lg_gtk_combo_box_popup, 1, 0, 0, H_gtk_combo_box_popup, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_popdown", lg_gtk_combo_box_popdown, 1, 0, 0, H_gtk_combo_box_popdown, pl_tu);
  s7_define_typed_function(sc, "gtk_scale_get_layout", lg_gtk_scale_get_layout, 1, 0, 0, H_gtk_scale_get_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_get_layout_offsets", lg_gtk_scale_get_layout_offsets, 1, 2, 0, H_gtk_scale_get_layout_offsets, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_alignment", lg_gtk_entry_set_alignment, 2, 0, 0, H_gtk_entry_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_entry_get_alignment", lg_gtk_entry_get_alignment, 1, 0, 0, H_gtk_entry_get_alignment, pl_du);
  s7_define_typed_function(sc, "gtk_widget_list_mnemonic_labels", lg_gtk_widget_list_mnemonic_labels, 1, 0, 0, H_gtk_widget_list_mnemonic_labels, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_add_mnemonic_label", lg_gtk_widget_add_mnemonic_label, 2, 0, 0, H_gtk_widget_add_mnemonic_label, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_remove_mnemonic_label", lg_gtk_widget_remove_mnemonic_label, 2, 0, 0, H_gtk_widget_remove_mnemonic_label, pl_tu);
  s7_define_typed_function(sc, "g_quark_from_string", lg_g_quark_from_string, 1, 0, 0, H_g_quark_from_string, pl_is);
  s7_define_typed_function(sc, "g_quark_to_string", lg_g_quark_to_string, 1, 0, 0, H_g_quark_to_string, pl_si);
  s7_define_typed_function(sc, "gtk_cell_view_new", lg_gtk_cell_view_new, 0, 0, 0, H_gtk_cell_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_view_new_with_text", lg_gtk_cell_view_new_with_text, 1, 0, 0, H_gtk_cell_view_new_with_text, pl_ps);
  s7_define_typed_function(sc, "gtk_cell_view_new_with_markup", lg_gtk_cell_view_new_with_markup, 1, 0, 0, H_gtk_cell_view_new_with_markup, pl_ps);
  s7_define_typed_function(sc, "gtk_cell_view_set_model", lg_gtk_cell_view_set_model, 2, 0, 0, H_gtk_cell_view_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_view_set_displayed_row", lg_gtk_cell_view_set_displayed_row, 2, 0, 0, H_gtk_cell_view_set_displayed_row, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_view_get_displayed_row", lg_gtk_cell_view_get_displayed_row, 1, 0, 0, H_gtk_cell_view_get_displayed_row, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_insert_prefix", lg_gtk_entry_completion_insert_prefix, 1, 0, 0, H_gtk_entry_completion_insert_prefix, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_inline_completion", lg_gtk_entry_completion_set_inline_completion, 2, 0, 0, H_gtk_entry_completion_set_inline_completion, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_inline_completion", lg_gtk_entry_completion_get_inline_completion, 1, 0, 0, H_gtk_entry_completion_get_inline_completion, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_popup_completion", lg_gtk_entry_completion_set_popup_completion, 2, 0, 0, H_gtk_entry_completion_set_popup_completion, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_popup_completion", lg_gtk_entry_completion_get_popup_completion, 1, 0, 0, H_gtk_entry_completion_get_popup_completion, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_get_text_column", lg_gtk_entry_completion_get_text_column, 1, 0, 0, H_gtk_entry_completion_get_text_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_view_set_fixed_height_mode", lg_gtk_tree_view_set_fixed_height_mode, 2, 0, 0, H_gtk_tree_view_set_fixed_height_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_fixed_height_mode", lg_gtk_tree_view_get_fixed_height_mode, 1, 0, 0, H_gtk_tree_view_get_fixed_height_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_hover_selection", lg_gtk_tree_view_set_hover_selection, 2, 0, 0, H_gtk_tree_view_set_hover_selection, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_hover_selection", lg_gtk_tree_view_get_hover_selection, 1, 0, 0, H_gtk_tree_view_get_hover_selection, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_row_separator_func", lg_gtk_tree_view_set_row_separator_func, 4, 0, 0, H_gtk_tree_view_set_row_separator_func, pl_tut);
  s7_define_typed_function(sc, "gtk_window_set_icon_name", lg_gtk_window_set_icon_name, 2, 0, 0, H_gtk_window_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_window_get_icon_name", lg_gtk_window_get_icon_name, 1, 0, 0, H_gtk_window_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_window_set_default_icon_name", lg_gtk_window_set_default_icon_name, 1, 0, 0, H_gtk_window_set_default_icon_name, pl_ts);
  s7_define_typed_function(sc, "gtk_about_dialog_new", lg_gtk_about_dialog_new, 0, 0, 0, H_gtk_about_dialog_new, pl_p);
  s7_define_typed_function(sc, "gtk_about_dialog_get_version", lg_gtk_about_dialog_get_version, 1, 0, 0, H_gtk_about_dialog_get_version, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_version", lg_gtk_about_dialog_set_version, 2, 0, 0, H_gtk_about_dialog_set_version, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_copyright", lg_gtk_about_dialog_get_copyright, 1, 0, 0, H_gtk_about_dialog_get_copyright, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_copyright", lg_gtk_about_dialog_set_copyright, 2, 0, 0, H_gtk_about_dialog_set_copyright, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_comments", lg_gtk_about_dialog_get_comments, 1, 0, 0, H_gtk_about_dialog_get_comments, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_comments", lg_gtk_about_dialog_set_comments, 2, 0, 0, H_gtk_about_dialog_set_comments, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_website", lg_gtk_about_dialog_get_website, 1, 0, 0, H_gtk_about_dialog_get_website, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_website", lg_gtk_about_dialog_set_website, 2, 0, 0, H_gtk_about_dialog_set_website, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_website_label", lg_gtk_about_dialog_get_website_label, 1, 0, 0, H_gtk_about_dialog_get_website_label, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_website_label", lg_gtk_about_dialog_set_website_label, 2, 0, 0, H_gtk_about_dialog_set_website_label, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_authors", lg_gtk_about_dialog_get_authors, 1, 0, 0, H_gtk_about_dialog_get_authors, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_authors", lg_gtk_about_dialog_set_authors, 2, 0, 0, H_gtk_about_dialog_set_authors, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_documenters", lg_gtk_about_dialog_get_documenters, 1, 0, 0, H_gtk_about_dialog_get_documenters, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_documenters", lg_gtk_about_dialog_set_documenters, 2, 0, 0, H_gtk_about_dialog_set_documenters, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_artists", lg_gtk_about_dialog_get_artists, 1, 0, 0, H_gtk_about_dialog_get_artists, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_artists", lg_gtk_about_dialog_set_artists, 2, 0, 0, H_gtk_about_dialog_set_artists, pl_tu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_translator_credits", lg_gtk_about_dialog_get_translator_credits, 1, 0, 0, H_gtk_about_dialog_get_translator_credits, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_translator_credits", lg_gtk_about_dialog_set_translator_credits, 2, 0, 0, H_gtk_about_dialog_set_translator_credits, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_get_program_name", lg_gtk_about_dialog_get_program_name, 1, 0, 0, H_gtk_about_dialog_get_program_name, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_program_name", lg_gtk_about_dialog_set_program_name, 2, 0, 0, H_gtk_about_dialog_set_program_name, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_view_new", lg_gtk_icon_view_new, 0, 0, 0, H_gtk_icon_view_new, pl_p);
  s7_define_typed_function(sc, "gtk_icon_view_new_with_model", lg_gtk_icon_view_new_with_model, 1, 0, 0, H_gtk_icon_view_new_with_model, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_model", lg_gtk_icon_view_set_model, 2, 0, 0, H_gtk_icon_view_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_get_model", lg_gtk_icon_view_get_model, 1, 0, 0, H_gtk_icon_view_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_text_column", lg_gtk_icon_view_set_text_column, 2, 0, 0, H_gtk_icon_view_set_text_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_text_column", lg_gtk_icon_view_get_text_column, 1, 0, 0, H_gtk_icon_view_get_text_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_markup_column", lg_gtk_icon_view_set_markup_column, 2, 0, 0, H_gtk_icon_view_set_markup_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_markup_column", lg_gtk_icon_view_get_markup_column, 1, 0, 0, H_gtk_icon_view_get_markup_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_pixbuf_column", lg_gtk_icon_view_set_pixbuf_column, 2, 0, 0, H_gtk_icon_view_set_pixbuf_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_pixbuf_column", lg_gtk_icon_view_get_pixbuf_column, 1, 0, 0, H_gtk_icon_view_get_pixbuf_column, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_get_path_at_pos", lg_gtk_icon_view_get_path_at_pos, 3, 0, 0, H_gtk_icon_view_get_path_at_pos, pl_pui);
  s7_define_typed_function(sc, "gtk_icon_view_selected_foreach", lg_gtk_icon_view_selected_foreach, 3, 0, 0, H_gtk_icon_view_selected_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_icon_view_set_selection_mode", lg_gtk_icon_view_set_selection_mode, 2, 0, 0, H_gtk_icon_view_set_selection_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_icon_view_get_selection_mode", lg_gtk_icon_view_get_selection_mode, 1, 0, 0, H_gtk_icon_view_get_selection_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_icon_view_select_path", lg_gtk_icon_view_select_path, 2, 0, 0, H_gtk_icon_view_select_path, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_unselect_path", lg_gtk_icon_view_unselect_path, 2, 0, 0, H_gtk_icon_view_unselect_path, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_path_is_selected", lg_gtk_icon_view_path_is_selected, 2, 0, 0, H_gtk_icon_view_path_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_get_selected_items", lg_gtk_icon_view_get_selected_items, 1, 0, 0, H_gtk_icon_view_get_selected_items, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_select_all", lg_gtk_icon_view_select_all, 1, 0, 0, H_gtk_icon_view_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_unselect_all", lg_gtk_icon_view_unselect_all, 1, 0, 0, H_gtk_icon_view_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_item_activated", lg_gtk_icon_view_item_activated, 2, 0, 0, H_gtk_icon_view_item_activated, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_combo_new", lg_gtk_cell_renderer_combo_new, 0, 0, 0, H_gtk_cell_renderer_combo_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_progress_new", lg_gtk_cell_renderer_progress_new, 0, 0, 0, H_gtk_cell_renderer_progress_new, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_set_row_separator_func", lg_gtk_combo_box_set_row_separator_func, 4, 0, 0, H_gtk_combo_box_set_row_separator_func, pl_tut);
  s7_define_typed_function(sc, "gtk_label_set_ellipsize", lg_gtk_label_set_ellipsize, 2, 0, 0, H_gtk_label_set_ellipsize, pl_tug);
  s7_define_typed_function(sc, "gtk_label_get_ellipsize", lg_gtk_label_get_ellipsize, 1, 0, 0, H_gtk_label_get_ellipsize, pl_gu);
  s7_define_typed_function(sc, "pango_attr_fallback_new", lg_pango_attr_fallback_new, 1, 0, 0, H_pango_attr_fallback_new, pl_pb);
  s7_define_typed_function(sc, "pango_attr_letter_spacing_new", lg_pango_attr_letter_spacing_new, 1, 0, 0, H_pango_attr_letter_spacing_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_list_filter", lg_pango_attr_list_filter, 3, 0, 0, H_pango_attr_list_filter, pl_put);
  s7_define_typed_function(sc, "pango_attr_iterator_get_attrs", lg_pango_attr_iterator_get_attrs, 1, 0, 0, H_pango_attr_iterator_get_attrs, pl_pu);
  s7_define_typed_function(sc, "pango_font_metrics_get_underline_position", lg_pango_font_metrics_get_underline_position, 1, 0, 0, H_pango_font_metrics_get_underline_position, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_underline_thickness", lg_pango_font_metrics_get_underline_thickness, 1, 0, 0, H_pango_font_metrics_get_underline_thickness, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_strikethrough_position", lg_pango_font_metrics_get_strikethrough_position, 1, 0, 0, H_pango_font_metrics_get_strikethrough_position, pl_iu);
  s7_define_typed_function(sc, "pango_font_metrics_get_strikethrough_thickness", lg_pango_font_metrics_get_strikethrough_thickness, 1, 0, 0, H_pango_font_metrics_get_strikethrough_thickness, pl_iu);
  s7_define_typed_function(sc, "pango_font_family_is_monospace", lg_pango_font_family_is_monospace, 1, 0, 0, H_pango_font_family_is_monospace, pl_bu);
  s7_define_typed_function(sc, "pango_font_face_list_sizes", lg_pango_font_face_list_sizes, 1, 2, 0, H_pango_font_face_list_sizes, pl_pu);
  s7_define_typed_function(sc, "pango_layout_set_auto_dir", lg_pango_layout_set_auto_dir, 2, 0, 0, H_pango_layout_set_auto_dir, pl_tub);
  s7_define_typed_function(sc, "pango_layout_get_auto_dir", lg_pango_layout_get_auto_dir, 1, 0, 0, H_pango_layout_get_auto_dir, pl_bu);
  s7_define_typed_function(sc, "pango_script_iter_new", lg_pango_script_iter_new, 2, 0, 0, H_pango_script_iter_new, pl_psi);
  s7_define_typed_function(sc, "pango_script_iter_get_range", lg_pango_script_iter_get_range, 1, 3, 0, H_pango_script_iter_get_range, pl_pu);
  s7_define_typed_function(sc, "pango_script_iter_next", lg_pango_script_iter_next, 1, 0, 0, H_pango_script_iter_next, pl_bu);
  s7_define_typed_function(sc, "pango_script_iter_free", lg_pango_script_iter_free, 1, 0, 0, H_pango_script_iter_free, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_new_with_dialog", lg_gtk_file_chooser_button_new_with_dialog, 1, 0, 0, H_gtk_file_chooser_button_new_with_dialog, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_get_title", lg_gtk_file_chooser_button_get_title, 1, 0, 0, H_gtk_file_chooser_button_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_file_chooser_button_set_title", lg_gtk_file_chooser_button_set_title, 2, 0, 0, H_gtk_file_chooser_button_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_tree_view_set_hover_expand", lg_gtk_tree_view_set_hover_expand, 2, 0, 0, H_gtk_tree_view_set_hover_expand, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_hover_expand", lg_gtk_tree_view_get_hover_expand, 1, 0, 0, H_gtk_tree_view_get_hover_expand, pl_bu);
  s7_define_typed_function(sc, "gtk_about_dialog_get_logo_icon_name", lg_gtk_about_dialog_get_logo_icon_name, 1, 0, 0, H_gtk_about_dialog_get_logo_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_logo_icon_name", lg_gtk_about_dialog_set_logo_icon_name, 2, 0, 0, H_gtk_about_dialog_set_logo_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_accelerator_get_label", lg_gtk_accelerator_get_label, 2, 0, 0, H_gtk_accelerator_get_label, pl_sig);
  s7_define_typed_function(sc, "gtk_file_chooser_button_get_width_chars", lg_gtk_file_chooser_button_get_width_chars, 1, 0, 0, H_gtk_file_chooser_button_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_set_width_chars", lg_gtk_file_chooser_button_set_width_chars, 2, 0, 0, H_gtk_file_chooser_button_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_image_set_pixel_size", lg_gtk_image_set_pixel_size, 2, 0, 0, H_gtk_image_set_pixel_size, pl_tui);
  s7_define_typed_function(sc, "gtk_image_get_pixel_size", lg_gtk_image_get_pixel_size, 1, 0, 0, H_gtk_image_get_pixel_size, pl_iu);
  s7_define_typed_function(sc, "gtk_label_set_width_chars", lg_gtk_label_set_width_chars, 2, 0, 0, H_gtk_label_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_width_chars", lg_gtk_label_get_width_chars, 1, 0, 0, H_gtk_label_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_text_buffer_backspace", lg_gtk_text_buffer_backspace, 4, 0, 0, H_gtk_text_buffer_backspace, pl_buub);
  s7_define_typed_function(sc, "gtk_file_filter_add_pixbuf_formats", lg_gtk_file_filter_add_pixbuf_formats, 1, 0, 0, H_gtk_file_filter_add_pixbuf_formats, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_single_line_mode", lg_gtk_label_set_single_line_mode, 2, 0, 0, H_gtk_label_set_single_line_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_single_line_mode", lg_gtk_label_get_single_line_mode, 1, 0, 0, H_gtk_label_get_single_line_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_progress_bar_set_ellipsize", lg_gtk_progress_bar_set_ellipsize, 2, 0, 0, H_gtk_progress_bar_set_ellipsize, pl_tug);
  s7_define_typed_function(sc, "gtk_progress_bar_get_ellipsize", lg_gtk_progress_bar_get_ellipsize, 1, 0, 0, H_gtk_progress_bar_get_ellipsize, pl_gu);
  s7_define_typed_function(sc, "pango_attr_underline_color_new", lg_pango_attr_underline_color_new, 3, 0, 0, H_pango_attr_underline_color_new, pl_pi);
  s7_define_typed_function(sc, "pango_attr_strikethrough_color_new", lg_pango_attr_strikethrough_color_new, 3, 0, 0, H_pango_attr_strikethrough_color_new, pl_pi);
  s7_define_typed_function(sc, "pango_renderer_draw_layout", lg_pango_renderer_draw_layout, 4, 0, 0, H_pango_renderer_draw_layout, pl_tuui);
  s7_define_typed_function(sc, "pango_renderer_draw_layout_line", lg_pango_renderer_draw_layout_line, 4, 0, 0, H_pango_renderer_draw_layout_line, pl_tuui);
  s7_define_typed_function(sc, "pango_renderer_draw_glyphs", lg_pango_renderer_draw_glyphs, 5, 0, 0, H_pango_renderer_draw_glyphs, pl_tuuui);
  s7_define_typed_function(sc, "pango_renderer_draw_rectangle", lg_pango_renderer_draw_rectangle, 6, 0, 0, H_pango_renderer_draw_rectangle, pl_tugi);
  s7_define_typed_function(sc, "pango_renderer_draw_error_underline", lg_pango_renderer_draw_error_underline, 5, 0, 0, H_pango_renderer_draw_error_underline, pl_tui);
  s7_define_typed_function(sc, "pango_renderer_draw_trapezoid", lg_pango_renderer_draw_trapezoid, 0, 0, 1, H_pango_renderer_draw_trapezoid, pl_tugr);
  s7_define_typed_function(sc, "pango_renderer_draw_glyph", lg_pango_renderer_draw_glyph, 5, 0, 0, H_pango_renderer_draw_glyph, pl_tuuir);
  s7_define_typed_function(sc, "pango_renderer_activate", lg_pango_renderer_activate, 1, 0, 0, H_pango_renderer_activate, pl_tu);
  s7_define_typed_function(sc, "pango_renderer_deactivate", lg_pango_renderer_deactivate, 1, 0, 0, H_pango_renderer_deactivate, pl_tu);
  s7_define_typed_function(sc, "pango_renderer_part_changed", lg_pango_renderer_part_changed, 2, 0, 0, H_pango_renderer_part_changed, pl_tug);
  s7_define_typed_function(sc, "pango_renderer_set_color", lg_pango_renderer_set_color, 3, 0, 0, H_pango_renderer_set_color, pl_tugu);
  s7_define_typed_function(sc, "pango_renderer_get_color", lg_pango_renderer_get_color, 2, 0, 0, H_pango_renderer_get_color, pl_pug);
  s7_define_typed_function(sc, "pango_renderer_set_matrix", lg_pango_renderer_set_matrix, 2, 0, 0, H_pango_renderer_set_matrix, pl_tu);
  s7_define_typed_function(sc, "g_log_set_handler", lg_g_log_set_handler, 4, 0, 0, H_g_log_set_handler, pl_isgt);
  s7_define_typed_function(sc, "g_log_remove_handler", lg_g_log_remove_handler, 2, 0, 0, H_g_log_remove_handler, pl_tsi);
  s7_define_typed_function(sc, "gtk_cell_renderer_stop_editing", lg_gtk_cell_renderer_stop_editing, 2, 0, 0, H_gtk_cell_renderer_stop_editing, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_button_new", lg_gtk_file_chooser_button_new, 2, 0, 0, H_gtk_file_chooser_button_new, pl_psg);
  s7_define_typed_function(sc, "gtk_icon_view_set_columns", lg_gtk_icon_view_set_columns, 2, 0, 0, H_gtk_icon_view_set_columns, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_columns", lg_gtk_icon_view_get_columns, 1, 0, 0, H_gtk_icon_view_get_columns, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_item_width", lg_gtk_icon_view_set_item_width, 2, 0, 0, H_gtk_icon_view_set_item_width, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_width", lg_gtk_icon_view_get_item_width, 1, 0, 0, H_gtk_icon_view_get_item_width, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_spacing", lg_gtk_icon_view_set_spacing, 2, 0, 0, H_gtk_icon_view_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_spacing", lg_gtk_icon_view_get_spacing, 1, 0, 0, H_gtk_icon_view_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_row_spacing", lg_gtk_icon_view_set_row_spacing, 2, 0, 0, H_gtk_icon_view_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_row_spacing", lg_gtk_icon_view_get_row_spacing, 1, 0, 0, H_gtk_icon_view_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_column_spacing", lg_gtk_icon_view_set_column_spacing, 2, 0, 0, H_gtk_icon_view_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_column_spacing", lg_gtk_icon_view_get_column_spacing, 1, 0, 0, H_gtk_icon_view_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_set_margin", lg_gtk_icon_view_set_margin, 2, 0, 0, H_gtk_icon_view_set_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_margin", lg_gtk_icon_view_get_margin, 1, 0, 0, H_gtk_icon_view_get_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_label_set_max_width_chars", lg_gtk_label_set_max_width_chars, 2, 0, 0, H_gtk_label_set_max_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_max_width_chars", lg_gtk_label_get_max_width_chars, 1, 0, 0, H_gtk_label_get_max_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_list_store_insert_with_values", lg_gtk_list_store_insert_with_values, 3, 0, 0, H_gtk_list_store_insert_with_values, pl_tuui);
  s7_define_typed_function(sc, "gtk_list_store_insert_with_valuesv", lg_gtk_list_store_insert_with_valuesv, 6, 0, 0, H_gtk_list_store_insert_with_valuesv, pl_tuuiuui);
  s7_define_typed_function(sc, "pango_attr_size_new_absolute", lg_pango_attr_size_new_absolute, 1, 0, 0, H_pango_attr_size_new_absolute, pl_pi);
  s7_define_typed_function(sc, "pango_font_description_set_absolute_size", lg_pango_font_description_set_absolute_size, 2, 0, 0, H_pango_font_description_set_absolute_size, pl_tur);
  s7_define_typed_function(sc, "pango_layout_get_font_description", lg_pango_layout_get_font_description, 1, 0, 0, H_pango_layout_get_font_description, pl_pu);
  s7_define_typed_function(sc, "gtk_dialog_get_response_for_widget", lg_gtk_dialog_get_response_for_widget, 2, 0, 0, H_gtk_dialog_get_response_for_widget, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_popup_set_width", lg_gtk_entry_completion_set_popup_set_width, 2, 0, 0, H_gtk_entry_completion_set_popup_set_width, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_popup_set_width", lg_gtk_entry_completion_get_popup_set_width, 1, 0, 0, H_gtk_entry_completion_get_popup_set_width, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_popup_single_match", lg_gtk_entry_completion_set_popup_single_match, 2, 0, 0, H_gtk_entry_completion_set_popup_single_match, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_popup_single_match", lg_gtk_entry_completion_get_popup_single_match, 1, 0, 0, H_gtk_entry_completion_get_popup_single_match, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_at_pos", lg_gtk_icon_view_get_item_at_pos, 3, 2, 0, H_gtk_icon_view_get_item_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_icon_view_get_visible_range", lg_gtk_icon_view_get_visible_range, 1, 2, 0, H_gtk_icon_view_get_visible_range, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_cursor", lg_gtk_icon_view_set_cursor, 4, 0, 0, H_gtk_icon_view_set_cursor, pl_tuuub);
  s7_define_typed_function(sc, "gtk_icon_view_get_cursor", lg_gtk_icon_view_get_cursor, 1, 2, 0, H_gtk_icon_view_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_scroll_to_path", lg_gtk_icon_view_scroll_to_path, 5, 0, 0, H_gtk_icon_view_scroll_to_path, pl_tuubr);
  s7_define_typed_function(sc, "gtk_icon_view_unset_model_drag_source", lg_gtk_icon_view_unset_model_drag_source, 1, 0, 0, H_gtk_icon_view_unset_model_drag_source, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_set_reorderable", lg_gtk_icon_view_set_reorderable, 2, 0, 0, H_gtk_icon_view_set_reorderable, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_get_reorderable", lg_gtk_icon_view_get_reorderable, 1, 0, 0, H_gtk_icon_view_get_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_get_dest_item_at_pos", lg_gtk_icon_view_get_dest_item_at_pos, 3, 2, 0, H_gtk_icon_view_get_dest_item_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_image_clear", lg_gtk_image_clear, 1, 0, 0, H_gtk_image_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_visible_line", lg_gtk_text_iter_forward_visible_line, 1, 0, 0, H_gtk_text_iter_forward_visible_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_backward_visible_line", lg_gtk_text_iter_backward_visible_line, 1, 0, 0, H_gtk_text_iter_backward_visible_line, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_forward_visible_lines", lg_gtk_text_iter_forward_visible_lines, 2, 0, 0, H_gtk_text_iter_forward_visible_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_text_iter_backward_visible_lines", lg_gtk_text_iter_backward_visible_lines, 2, 0, 0, H_gtk_text_iter_backward_visible_lines, pl_bui);
  s7_define_typed_function(sc, "gtk_window_present_with_time", lg_gtk_window_present_with_time, 2, 0, 0, H_gtk_window_present_with_time, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_row_reference_get_model", lg_gtk_tree_row_reference_get_model, 1, 0, 0, H_gtk_tree_row_reference_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_queue_resize", lg_gtk_tree_view_column_queue_resize, 1, 0, 0, H_gtk_tree_view_column_queue_resize, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_visible_range", lg_gtk_tree_view_get_visible_range, 1, 2, 0, H_gtk_tree_view_get_visible_range, pl_pu);
  s7_define_typed_function(sc, "pango_attr_list_ref", lg_pango_attr_list_ref, 1, 0, 0, H_pango_attr_list_ref, pl_pu);
  s7_define_typed_function(sc, "pango_layout_line_ref", lg_pango_layout_line_ref, 1, 0, 0, H_pango_layout_line_ref, pl_pu);
  s7_define_typed_function(sc, "pango_layout_index_to_line_x", lg_pango_layout_index_to_line_x, 3, 2, 0, H_pango_layout_index_to_line_x, pl_puibu);
  s7_define_typed_function(sc, "gdk_display_supports_shapes", lg_gdk_display_supports_shapes, 1, 0, 0, H_gdk_display_supports_shapes, pl_bu);
  s7_define_typed_function(sc, "gdk_display_supports_input_shapes", lg_gdk_display_supports_input_shapes, 1, 0, 0, H_gdk_display_supports_input_shapes, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_reorderable", lg_gtk_notebook_get_tab_reorderable, 2, 0, 0, H_gtk_notebook_get_tab_reorderable, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_reorderable", lg_gtk_notebook_set_tab_reorderable, 3, 0, 0, H_gtk_notebook_set_tab_reorderable, pl_tuub);
  s7_define_typed_function(sc, "gtk_notebook_get_tab_detachable", lg_gtk_notebook_get_tab_detachable, 2, 0, 0, H_gtk_notebook_get_tab_detachable, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_set_tab_detachable", lg_gtk_notebook_set_tab_detachable, 3, 0, 0, H_gtk_notebook_set_tab_detachable, pl_tuub);
  s7_define_typed_function(sc, "gtk_scrolled_window_unset_placement", lg_gtk_scrolled_window_unset_placement, 1, 0, 0, H_gtk_scrolled_window_unset_placement, pl_tu);
  s7_define_typed_function(sc, "gtk_size_group_get_widgets", lg_gtk_size_group_get_widgets, 1, 0, 0, H_gtk_size_group_get_widgets, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_has_selection", lg_gtk_text_buffer_get_has_selection, 1, 0, 0, H_gtk_text_buffer_get_has_selection, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_headers_clickable", lg_gtk_tree_view_get_headers_clickable, 1, 0, 0, H_gtk_tree_view_get_headers_clickable, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_deletable", lg_gtk_window_set_deletable, 2, 0, 0, H_gtk_window_set_deletable, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_deletable", lg_gtk_window_get_deletable, 1, 0, 0, H_gtk_window_get_deletable, pl_bu);
  s7_define_typed_function(sc, "gtk_assistant_new", lg_gtk_assistant_new, 0, 0, 0, H_gtk_assistant_new, pl_p);
  s7_define_typed_function(sc, "gtk_assistant_get_current_page", lg_gtk_assistant_get_current_page, 1, 0, 0, H_gtk_assistant_get_current_page, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_set_current_page", lg_gtk_assistant_set_current_page, 2, 0, 0, H_gtk_assistant_set_current_page, pl_tui);
  s7_define_typed_function(sc, "gtk_assistant_get_n_pages", lg_gtk_assistant_get_n_pages, 1, 0, 0, H_gtk_assistant_get_n_pages, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_get_nth_page", lg_gtk_assistant_get_nth_page, 2, 0, 0, H_gtk_assistant_get_nth_page, pl_pui);
  s7_define_typed_function(sc, "gtk_assistant_prepend_page", lg_gtk_assistant_prepend_page, 2, 0, 0, H_gtk_assistant_prepend_page, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_append_page", lg_gtk_assistant_append_page, 2, 0, 0, H_gtk_assistant_append_page, pl_iu);
  s7_define_typed_function(sc, "gtk_assistant_insert_page", lg_gtk_assistant_insert_page, 3, 0, 0, H_gtk_assistant_insert_page, pl_iuui);
  s7_define_typed_function(sc, "gtk_assistant_set_forward_page_func", lg_gtk_assistant_set_forward_page_func, 4, 0, 0, H_gtk_assistant_set_forward_page_func, pl_tut);
  s7_define_typed_function(sc, "gtk_assistant_set_page_type", lg_gtk_assistant_set_page_type, 3, 0, 0, H_gtk_assistant_set_page_type, pl_tuug);
  s7_define_typed_function(sc, "gtk_assistant_get_page_type", lg_gtk_assistant_get_page_type, 2, 0, 0, H_gtk_assistant_get_page_type, pl_gu);
  s7_define_typed_function(sc, "gtk_assistant_set_page_title", lg_gtk_assistant_set_page_title, 3, 0, 0, H_gtk_assistant_set_page_title, pl_tuus);
  s7_define_typed_function(sc, "gtk_assistant_get_page_title", lg_gtk_assistant_get_page_title, 2, 0, 0, H_gtk_assistant_get_page_title, pl_su);
  s7_define_typed_function(sc, "gtk_assistant_set_page_complete", lg_gtk_assistant_set_page_complete, 3, 0, 0, H_gtk_assistant_set_page_complete, pl_tuub);
  s7_define_typed_function(sc, "gtk_assistant_get_page_complete", lg_gtk_assistant_get_page_complete, 2, 0, 0, H_gtk_assistant_get_page_complete, pl_bu);
  s7_define_typed_function(sc, "gtk_assistant_add_action_widget", lg_gtk_assistant_add_action_widget, 2, 0, 0, H_gtk_assistant_add_action_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_remove_action_widget", lg_gtk_assistant_remove_action_widget, 2, 0, 0, H_gtk_assistant_remove_action_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_update_buttons_state", lg_gtk_assistant_update_buttons_state, 1, 0, 0, H_gtk_assistant_update_buttons_state, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_accel_new", lg_gtk_cell_renderer_accel_new, 0, 0, 0, H_gtk_cell_renderer_accel_new, pl_p);
  s7_define_typed_function(sc, "gtk_cell_renderer_spin_new", lg_gtk_cell_renderer_spin_new, 0, 0, 0, H_gtk_cell_renderer_spin_new, pl_p);
  s7_define_typed_function(sc, "gtk_link_button_new", lg_gtk_link_button_new, 1, 0, 0, H_gtk_link_button_new, pl_ps);
  s7_define_typed_function(sc, "gtk_link_button_new_with_label", lg_gtk_link_button_new_with_label, 2, 0, 0, H_gtk_link_button_new_with_label, pl_ps);
  s7_define_typed_function(sc, "gtk_link_button_get_uri", lg_gtk_link_button_get_uri, 1, 0, 0, H_gtk_link_button_get_uri, pl_su);
  s7_define_typed_function(sc, "gtk_link_button_set_uri", lg_gtk_link_button_set_uri, 2, 0, 0, H_gtk_link_button_set_uri, pl_tus);
  s7_define_typed_function(sc, "gtk_recent_manager_error_quark", lg_gtk_recent_manager_error_quark, 0, 0, 0, H_gtk_recent_manager_error_quark, pl_i);
  s7_define_typed_function(sc, "gtk_recent_manager_new", lg_gtk_recent_manager_new, 0, 0, 0, H_gtk_recent_manager_new, pl_p);
  s7_define_typed_function(sc, "gtk_recent_manager_get_default", lg_gtk_recent_manager_get_default, 0, 0, 0, H_gtk_recent_manager_get_default, pl_p);
  s7_define_typed_function(sc, "gtk_recent_manager_remove_item", lg_gtk_recent_manager_remove_item, 2, 1, 0, H_gtk_recent_manager_remove_item, pl_pusu);
  s7_define_typed_function(sc, "gtk_recent_manager_lookup_item", lg_gtk_recent_manager_lookup_item, 2, 1, 0, H_gtk_recent_manager_lookup_item, pl_pusu);
  s7_define_typed_function(sc, "gtk_recent_manager_has_item", lg_gtk_recent_manager_has_item, 2, 0, 0, H_gtk_recent_manager_has_item, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_manager_move_item", lg_gtk_recent_manager_move_item, 3, 1, 0, H_gtk_recent_manager_move_item, pl_pussu);
  s7_define_typed_function(sc, "gtk_recent_manager_get_items", lg_gtk_recent_manager_get_items, 1, 0, 0, H_gtk_recent_manager_get_items, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_manager_purge_items", lg_gtk_recent_manager_purge_items, 1, 1, 0, H_gtk_recent_manager_purge_items, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_ref", lg_gtk_recent_info_ref, 1, 0, 0, H_gtk_recent_info_ref, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_unref", lg_gtk_recent_info_unref, 1, 0, 0, H_gtk_recent_info_unref, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_uri", lg_gtk_recent_info_get_uri, 1, 0, 0, H_gtk_recent_info_get_uri, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_display_name", lg_gtk_recent_info_get_display_name, 1, 0, 0, H_gtk_recent_info_get_display_name, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_description", lg_gtk_recent_info_get_description, 1, 0, 0, H_gtk_recent_info_get_description, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_mime_type", lg_gtk_recent_info_get_mime_type, 1, 0, 0, H_gtk_recent_info_get_mime_type, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_added", lg_gtk_recent_info_get_added, 1, 0, 0, H_gtk_recent_info_get_added, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_modified", lg_gtk_recent_info_get_modified, 1, 0, 0, H_gtk_recent_info_get_modified, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_visited", lg_gtk_recent_info_get_visited, 1, 0, 0, H_gtk_recent_info_get_visited, pl_tu);
  s7_define_typed_function(sc, "gtk_recent_info_get_private_hint", lg_gtk_recent_info_get_private_hint, 1, 0, 0, H_gtk_recent_info_get_private_hint, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_info_get_applications", lg_gtk_recent_info_get_applications, 1, 1, 0, H_gtk_recent_info_get_applications, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_last_application", lg_gtk_recent_info_last_application, 1, 0, 0, H_gtk_recent_info_last_application, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_has_application", lg_gtk_recent_info_has_application, 2, 0, 0, H_gtk_recent_info_has_application, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_info_get_groups", lg_gtk_recent_info_get_groups, 1, 1, 0, H_gtk_recent_info_get_groups, pl_pu);
  s7_define_typed_function(sc, "gtk_recent_info_has_group", lg_gtk_recent_info_has_group, 2, 0, 0, H_gtk_recent_info_has_group, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_info_get_short_name", lg_gtk_recent_info_get_short_name, 1, 0, 0, H_gtk_recent_info_get_short_name, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_uri_display", lg_gtk_recent_info_get_uri_display, 1, 0, 0, H_gtk_recent_info_get_uri_display, pl_su);
  s7_define_typed_function(sc, "gtk_recent_info_get_age", lg_gtk_recent_info_get_age, 1, 0, 0, H_gtk_recent_info_get_age, pl_iu);
  s7_define_typed_function(sc, "gtk_recent_info_is_local", lg_gtk_recent_info_is_local, 1, 0, 0, H_gtk_recent_info_is_local, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_info_exists", lg_gtk_recent_info_exists, 1, 0, 0, H_gtk_recent_info_exists, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_info_match", lg_gtk_recent_info_match, 2, 0, 0, H_gtk_recent_info_match, pl_bu);
  s7_define_typed_function(sc, "gtk_recent_manager_add_item", lg_gtk_recent_manager_add_item, 2, 0, 0, H_gtk_recent_manager_add_item, pl_bus);
  s7_define_typed_function(sc, "gtk_recent_manager_add_full", lg_gtk_recent_manager_add_full, 3, 0, 0, H_gtk_recent_manager_add_full, pl_busu);
  s7_define_typed_function(sc, "gtk_tree_model_filter_convert_child_iter_to_iter", lg_gtk_tree_model_filter_convert_child_iter_to_iter, 3, 0, 0, H_gtk_tree_model_filter_convert_child_iter_to_iter, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_grid_lines", lg_gtk_tree_view_get_grid_lines, 1, 0, 0, H_gtk_tree_view_get_grid_lines, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_view_set_grid_lines", lg_gtk_tree_view_set_grid_lines, 2, 0, 0, H_gtk_tree_view_set_grid_lines, pl_tug);
  s7_define_typed_function(sc, "gtk_tree_view_get_enable_tree_lines", lg_gtk_tree_view_get_enable_tree_lines, 1, 0, 0, H_gtk_tree_view_get_enable_tree_lines, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_enable_tree_lines", lg_gtk_tree_view_set_enable_tree_lines, 2, 0, 0, H_gtk_tree_view_set_enable_tree_lines, pl_tub);
  s7_define_typed_function(sc, "gtk_print_context_get_cairo_context", lg_gtk_print_context_get_cairo_context, 1, 0, 0, H_gtk_print_context_get_cairo_context, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_get_page_setup", lg_gtk_print_context_get_page_setup, 1, 0, 0, H_gtk_print_context_get_page_setup, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_get_width", lg_gtk_print_context_get_width, 1, 0, 0, H_gtk_print_context_get_width, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_get_height", lg_gtk_print_context_get_height, 1, 0, 0, H_gtk_print_context_get_height, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_get_dpi_x", lg_gtk_print_context_get_dpi_x, 1, 0, 0, H_gtk_print_context_get_dpi_x, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_get_dpi_y", lg_gtk_print_context_get_dpi_y, 1, 0, 0, H_gtk_print_context_get_dpi_y, pl_du);
  s7_define_typed_function(sc, "gtk_print_context_create_pango_context", lg_gtk_print_context_create_pango_context, 1, 0, 0, H_gtk_print_context_create_pango_context, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_create_pango_layout", lg_gtk_print_context_create_pango_layout, 1, 0, 0, H_gtk_print_context_create_pango_layout, pl_pu);
  s7_define_typed_function(sc, "gtk_print_context_set_cairo_context", lg_gtk_print_context_set_cairo_context, 4, 0, 0, H_gtk_print_context_set_cairo_context, pl_tuur);
  s7_define_typed_function(sc, "gtk_print_operation_new", lg_gtk_print_operation_new, 0, 0, 0, H_gtk_print_operation_new, pl_p);
  s7_define_typed_function(sc, "gtk_print_operation_set_default_page_setup", lg_gtk_print_operation_set_default_page_setup, 2, 0, 0, H_gtk_print_operation_set_default_page_setup, pl_tu);
  s7_define_typed_function(sc, "gtk_print_operation_get_default_page_setup", lg_gtk_print_operation_get_default_page_setup, 1, 0, 0, H_gtk_print_operation_get_default_page_setup, pl_pu);
  s7_define_typed_function(sc, "gtk_print_operation_set_print_settings", lg_gtk_print_operation_set_print_settings, 2, 0, 0, H_gtk_print_operation_set_print_settings, pl_tu);
  s7_define_typed_function(sc, "gtk_print_operation_get_print_settings", lg_gtk_print_operation_get_print_settings, 1, 0, 0, H_gtk_print_operation_get_print_settings, pl_pu);
  s7_define_typed_function(sc, "gtk_print_operation_set_job_name", lg_gtk_print_operation_set_job_name, 2, 0, 0, H_gtk_print_operation_set_job_name, pl_tus);
  s7_define_typed_function(sc, "gtk_print_operation_set_n_pages", lg_gtk_print_operation_set_n_pages, 2, 0, 0, H_gtk_print_operation_set_n_pages, pl_tui);
  s7_define_typed_function(sc, "gtk_print_operation_set_current_page", lg_gtk_print_operation_set_current_page, 2, 0, 0, H_gtk_print_operation_set_current_page, pl_tui);
  s7_define_typed_function(sc, "gtk_print_operation_set_use_full_page", lg_gtk_print_operation_set_use_full_page, 2, 0, 0, H_gtk_print_operation_set_use_full_page, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_unit", lg_gtk_print_operation_set_unit, 2, 0, 0, H_gtk_print_operation_set_unit, pl_tui);
  s7_define_typed_function(sc, "gtk_print_operation_set_export_filename", lg_gtk_print_operation_set_export_filename, 2, 0, 0, H_gtk_print_operation_set_export_filename, pl_tus);
  s7_define_typed_function(sc, "gtk_print_operation_set_track_print_status", lg_gtk_print_operation_set_track_print_status, 2, 0, 0, H_gtk_print_operation_set_track_print_status, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_show_progress", lg_gtk_print_operation_set_show_progress, 2, 0, 0, H_gtk_print_operation_set_show_progress, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_allow_async", lg_gtk_print_operation_set_allow_async, 2, 0, 0, H_gtk_print_operation_set_allow_async, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_set_custom_tab_label", lg_gtk_print_operation_set_custom_tab_label, 2, 0, 0, H_gtk_print_operation_set_custom_tab_label, pl_tus);
  s7_define_typed_function(sc, "gtk_print_operation_run", lg_gtk_print_operation_run, 3, 1, 0, H_gtk_print_operation_run, pl_pugu);
  s7_define_typed_function(sc, "gtk_print_operation_get_error", lg_gtk_print_operation_get_error, 1, 1, 0, H_gtk_print_operation_get_error, pl_pu);
  s7_define_typed_function(sc, "gtk_print_operation_get_status", lg_gtk_print_operation_get_status, 1, 0, 0, H_gtk_print_operation_get_status, pl_gu);
  s7_define_typed_function(sc, "gtk_print_operation_get_status_string", lg_gtk_print_operation_get_status_string, 1, 0, 0, H_gtk_print_operation_get_status_string, pl_su);
  s7_define_typed_function(sc, "gtk_print_operation_is_finished", lg_gtk_print_operation_is_finished, 1, 0, 0, H_gtk_print_operation_is_finished, pl_bu);
  s7_define_typed_function(sc, "gtk_print_operation_cancel", lg_gtk_print_operation_cancel, 1, 0, 0, H_gtk_print_operation_cancel, pl_tu);
  s7_define_typed_function(sc, "gtk_print_run_page_setup_dialog", lg_gtk_print_run_page_setup_dialog, 3, 0, 0, H_gtk_print_run_page_setup_dialog, pl_pu);
  s7_define_typed_function(sc, "gtk_print_run_page_setup_dialog_async", lg_gtk_print_run_page_setup_dialog_async, 5, 0, 0, H_gtk_print_run_page_setup_dialog_async, pl_tuuut);
  s7_define_typed_function(sc, "gtk_print_settings_new", lg_gtk_print_settings_new, 0, 0, 0, H_gtk_print_settings_new, pl_p);
  s7_define_typed_function(sc, "gtk_print_settings_copy", lg_gtk_print_settings_copy, 1, 0, 0, H_gtk_print_settings_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_has_key", lg_gtk_print_settings_has_key, 2, 0, 0, H_gtk_print_settings_has_key, pl_bus);
  s7_define_typed_function(sc, "gtk_print_settings_get", lg_gtk_print_settings_get, 2, 0, 0, H_gtk_print_settings_get, pl_sus);
  s7_define_typed_function(sc, "gtk_print_settings_set", lg_gtk_print_settings_set, 3, 0, 0, H_gtk_print_settings_set, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_unset", lg_gtk_print_settings_unset, 2, 0, 0, H_gtk_print_settings_unset, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_foreach", lg_gtk_print_settings_foreach, 3, 0, 0, H_gtk_print_settings_foreach, pl_tut);
  s7_define_typed_function(sc, "gtk_print_settings_get_bool", lg_gtk_print_settings_get_bool, 2, 0, 0, H_gtk_print_settings_get_bool, pl_bus);
  s7_define_typed_function(sc, "gtk_print_settings_set_bool", lg_gtk_print_settings_set_bool, 3, 0, 0, H_gtk_print_settings_set_bool, pl_tusb);
  s7_define_typed_function(sc, "gtk_print_settings_get_double", lg_gtk_print_settings_get_double, 2, 0, 0, H_gtk_print_settings_get_double, pl_dus);
  s7_define_typed_function(sc, "gtk_print_settings_get_double_with_default", lg_gtk_print_settings_get_double_with_default, 3, 0, 0, H_gtk_print_settings_get_double_with_default, pl_dusr);
  s7_define_typed_function(sc, "gtk_print_settings_set_double", lg_gtk_print_settings_set_double, 3, 0, 0, H_gtk_print_settings_set_double, pl_tusr);
  s7_define_typed_function(sc, "gtk_print_settings_get_length", lg_gtk_print_settings_get_length, 3, 0, 0, H_gtk_print_settings_get_length, pl_dusi);
  s7_define_typed_function(sc, "gtk_print_settings_set_length", lg_gtk_print_settings_set_length, 4, 0, 0, H_gtk_print_settings_set_length, pl_tusri);
  s7_define_typed_function(sc, "gtk_print_settings_get_int", lg_gtk_print_settings_get_int, 2, 0, 0, H_gtk_print_settings_get_int, pl_ius);
  s7_define_typed_function(sc, "gtk_print_settings_get_int_with_default", lg_gtk_print_settings_get_int_with_default, 3, 0, 0, H_gtk_print_settings_get_int_with_default, pl_iusi);
  s7_define_typed_function(sc, "gtk_print_settings_set_int", lg_gtk_print_settings_set_int, 3, 0, 0, H_gtk_print_settings_set_int, pl_tusi);
  s7_define_typed_function(sc, "gtk_print_settings_get_printer", lg_gtk_print_settings_get_printer, 1, 0, 0, H_gtk_print_settings_get_printer, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_printer", lg_gtk_print_settings_set_printer, 2, 0, 0, H_gtk_print_settings_set_printer, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_orientation", lg_gtk_print_settings_get_orientation, 1, 0, 0, H_gtk_print_settings_get_orientation, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_orientation", lg_gtk_print_settings_set_orientation, 2, 0, 0, H_gtk_print_settings_set_orientation, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_paper_size", lg_gtk_print_settings_get_paper_size, 1, 0, 0, H_gtk_print_settings_get_paper_size, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_set_paper_size", lg_gtk_print_settings_set_paper_size, 2, 0, 0, H_gtk_print_settings_set_paper_size, pl_tu);
  s7_define_typed_function(sc, "gtk_print_settings_get_paper_width", lg_gtk_print_settings_get_paper_width, 2, 0, 0, H_gtk_print_settings_get_paper_width, pl_dui);
  s7_define_typed_function(sc, "gtk_print_settings_set_paper_width", lg_gtk_print_settings_set_paper_width, 3, 0, 0, H_gtk_print_settings_set_paper_width, pl_turi);
  s7_define_typed_function(sc, "gtk_print_settings_get_paper_height", lg_gtk_print_settings_get_paper_height, 2, 0, 0, H_gtk_print_settings_get_paper_height, pl_dui);
  s7_define_typed_function(sc, "gtk_print_settings_set_paper_height", lg_gtk_print_settings_set_paper_height, 3, 0, 0, H_gtk_print_settings_set_paper_height, pl_turi);
  s7_define_typed_function(sc, "gtk_print_settings_get_use_color", lg_gtk_print_settings_get_use_color, 1, 0, 0, H_gtk_print_settings_get_use_color, pl_bu);
  s7_define_typed_function(sc, "gtk_print_settings_set_use_color", lg_gtk_print_settings_set_use_color, 2, 0, 0, H_gtk_print_settings_set_use_color, pl_tub);
  s7_define_typed_function(sc, "gtk_print_settings_get_collate", lg_gtk_print_settings_get_collate, 1, 0, 0, H_gtk_print_settings_get_collate, pl_bu);
  s7_define_typed_function(sc, "gtk_print_settings_set_collate", lg_gtk_print_settings_set_collate, 2, 0, 0, H_gtk_print_settings_set_collate, pl_tub);
  s7_define_typed_function(sc, "gtk_print_settings_get_reverse", lg_gtk_print_settings_get_reverse, 1, 0, 0, H_gtk_print_settings_get_reverse, pl_bu);
  s7_define_typed_function(sc, "gtk_print_settings_set_reverse", lg_gtk_print_settings_set_reverse, 2, 0, 0, H_gtk_print_settings_set_reverse, pl_tub);
  s7_define_typed_function(sc, "gtk_print_settings_get_duplex", lg_gtk_print_settings_get_duplex, 1, 0, 0, H_gtk_print_settings_get_duplex, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_duplex", lg_gtk_print_settings_set_duplex, 2, 0, 0, H_gtk_print_settings_set_duplex, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_quality", lg_gtk_print_settings_get_quality, 1, 0, 0, H_gtk_print_settings_get_quality, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_quality", lg_gtk_print_settings_set_quality, 2, 0, 0, H_gtk_print_settings_set_quality, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_n_copies", lg_gtk_print_settings_get_n_copies, 1, 0, 0, H_gtk_print_settings_get_n_copies, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_n_copies", lg_gtk_print_settings_set_n_copies, 2, 0, 0, H_gtk_print_settings_set_n_copies, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_number_up", lg_gtk_print_settings_get_number_up, 1, 0, 0, H_gtk_print_settings_get_number_up, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_number_up", lg_gtk_print_settings_set_number_up, 2, 0, 0, H_gtk_print_settings_set_number_up, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_resolution", lg_gtk_print_settings_get_resolution, 1, 0, 0, H_gtk_print_settings_get_resolution, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_resolution", lg_gtk_print_settings_set_resolution, 2, 0, 0, H_gtk_print_settings_set_resolution, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_scale", lg_gtk_print_settings_get_scale, 1, 0, 0, H_gtk_print_settings_get_scale, pl_du);
  s7_define_typed_function(sc, "gtk_print_settings_set_scale", lg_gtk_print_settings_set_scale, 2, 0, 0, H_gtk_print_settings_set_scale, pl_tur);
  s7_define_typed_function(sc, "gtk_print_settings_get_print_pages", lg_gtk_print_settings_get_print_pages, 1, 0, 0, H_gtk_print_settings_get_print_pages, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_print_pages", lg_gtk_print_settings_set_print_pages, 2, 0, 0, H_gtk_print_settings_set_print_pages, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_page_ranges", lg_gtk_print_settings_get_page_ranges, 2, 0, 0, H_gtk_print_settings_get_page_ranges, pl_pu);
  s7_define_typed_function(sc, "gtk_print_settings_set_page_ranges", lg_gtk_print_settings_set_page_ranges, 3, 0, 0, H_gtk_print_settings_set_page_ranges, pl_tuui);
  s7_define_typed_function(sc, "gtk_print_settings_get_page_set", lg_gtk_print_settings_get_page_set, 1, 0, 0, H_gtk_print_settings_get_page_set, pl_iu);
  s7_define_typed_function(sc, "gtk_print_settings_set_page_set", lg_gtk_print_settings_set_page_set, 2, 0, 0, H_gtk_print_settings_set_page_set, pl_tui);
  s7_define_typed_function(sc, "gtk_print_settings_get_default_source", lg_gtk_print_settings_get_default_source, 1, 0, 0, H_gtk_print_settings_get_default_source, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_default_source", lg_gtk_print_settings_set_default_source, 2, 0, 0, H_gtk_print_settings_set_default_source, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_media_type", lg_gtk_print_settings_get_media_type, 1, 0, 0, H_gtk_print_settings_get_media_type, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_media_type", lg_gtk_print_settings_set_media_type, 2, 0, 0, H_gtk_print_settings_set_media_type, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_dither", lg_gtk_print_settings_get_dither, 1, 0, 0, H_gtk_print_settings_get_dither, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_dither", lg_gtk_print_settings_set_dither, 2, 0, 0, H_gtk_print_settings_set_dither, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_finishings", lg_gtk_print_settings_get_finishings, 1, 0, 0, H_gtk_print_settings_get_finishings, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_finishings", lg_gtk_print_settings_set_finishings, 2, 0, 0, H_gtk_print_settings_set_finishings, pl_tus);
  s7_define_typed_function(sc, "gtk_print_settings_get_output_bin", lg_gtk_print_settings_get_output_bin, 1, 0, 0, H_gtk_print_settings_get_output_bin, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_set_output_bin", lg_gtk_print_settings_set_output_bin, 2, 0, 0, H_gtk_print_settings_set_output_bin, pl_tus);
  s7_define_typed_function(sc, "pango_cairo_create_layout", lg_pango_cairo_create_layout, 1, 0, 0, H_pango_cairo_create_layout, pl_pu);
  s7_define_typed_function(sc, "pango_cairo_update_layout", lg_pango_cairo_update_layout, 2, 0, 0, H_pango_cairo_update_layout, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_update_context", lg_pango_cairo_update_context, 2, 0, 0, H_pango_cairo_update_context, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_context_set_font_options", lg_pango_cairo_context_set_font_options, 2, 0, 0, H_pango_cairo_context_set_font_options, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_context_get_font_options", lg_pango_cairo_context_get_font_options, 1, 0, 0, H_pango_cairo_context_get_font_options, pl_pu);
  s7_define_typed_function(sc, "pango_cairo_context_set_resolution", lg_pango_cairo_context_set_resolution, 2, 0, 0, H_pango_cairo_context_set_resolution, pl_tur);
  s7_define_typed_function(sc, "pango_cairo_context_get_resolution", lg_pango_cairo_context_get_resolution, 1, 0, 0, H_pango_cairo_context_get_resolution, pl_du);
  s7_define_typed_function(sc, "pango_cairo_show_glyph_string", lg_pango_cairo_show_glyph_string, 3, 0, 0, H_pango_cairo_show_glyph_string, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_show_layout_line", lg_pango_cairo_show_layout_line, 2, 0, 0, H_pango_cairo_show_layout_line, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_show_layout", lg_pango_cairo_show_layout, 2, 0, 0, H_pango_cairo_show_layout, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_show_error_underline", lg_pango_cairo_show_error_underline, 5, 0, 0, H_pango_cairo_show_error_underline, pl_tur);
  s7_define_typed_function(sc, "pango_cairo_glyph_string_path", lg_pango_cairo_glyph_string_path, 3, 0, 0, H_pango_cairo_glyph_string_path, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_layout_line_path", lg_pango_cairo_layout_line_path, 2, 0, 0, H_pango_cairo_layout_line_path, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_layout_path", lg_pango_cairo_layout_path, 2, 0, 0, H_pango_cairo_layout_path, pl_tu);
  s7_define_typed_function(sc, "pango_cairo_error_underline_path", lg_pango_cairo_error_underline_path, 5, 0, 0, H_pango_cairo_error_underline_path, pl_tur);
  s7_define_typed_function(sc, "gdk_cairo_set_source_pixbuf", lg_gdk_cairo_set_source_pixbuf, 4, 0, 0, H_gdk_cairo_set_source_pixbuf, pl_tuur);
  s7_define_typed_function(sc, "gdk_cairo_rectangle", lg_gdk_cairo_rectangle, 2, 0, 0, H_gdk_cairo_rectangle, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_layout_get_cells", lg_gtk_cell_layout_get_cells, 1, 0, 0, H_gtk_cell_layout_get_cells, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_completion_set_inline_selection", lg_gtk_entry_completion_set_inline_selection, 2, 0, 0, H_gtk_entry_completion_set_inline_selection, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_completion_get_inline_selection", lg_gtk_entry_completion_get_inline_selection, 1, 0, 0, H_gtk_entry_completion_get_inline_selection, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_completion_get_completion_prefix", lg_gtk_entry_completion_get_completion_prefix, 1, 0, 0, H_gtk_entry_completion_get_completion_prefix, pl_su);
  s7_define_typed_function(sc, "gtk_print_settings_new_from_file", lg_gtk_print_settings_new_from_file, 1, 1, 0, H_gtk_print_settings_new_from_file, pl_psu);
  s7_define_typed_function(sc, "gtk_print_settings_to_file", lg_gtk_print_settings_to_file, 2, 1, 0, H_gtk_print_settings_to_file, pl_pusu);
  s7_define_typed_function(sc, "gtk_range_set_show_fill_level", lg_gtk_range_set_show_fill_level, 2, 0, 0, H_gtk_range_set_show_fill_level, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_show_fill_level", lg_gtk_range_get_show_fill_level, 1, 0, 0, H_gtk_range_get_show_fill_level, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_restrict_to_fill_level", lg_gtk_range_set_restrict_to_fill_level, 2, 0, 0, H_gtk_range_set_restrict_to_fill_level, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_restrict_to_fill_level", lg_gtk_range_get_restrict_to_fill_level, 1, 0, 0, H_gtk_range_get_restrict_to_fill_level, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_fill_level", lg_gtk_range_set_fill_level, 2, 0, 0, H_gtk_range_set_fill_level, pl_tur);
  s7_define_typed_function(sc, "gtk_range_get_fill_level", lg_gtk_range_get_fill_level, 1, 0, 0, H_gtk_range_get_fill_level, pl_du);
  s7_define_typed_function(sc, "gtk_tree_view_set_show_expanders", lg_gtk_tree_view_set_show_expanders, 2, 0, 0, H_gtk_tree_view_set_show_expanders, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_show_expanders", lg_gtk_tree_view_get_show_expanders, 1, 0, 0, H_gtk_tree_view_get_show_expanders, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_level_indentation", lg_gtk_tree_view_set_level_indentation, 2, 0, 0, H_gtk_tree_view_set_level_indentation, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_get_level_indentation", lg_gtk_tree_view_get_level_indentation, 1, 0, 0, H_gtk_tree_view_get_level_indentation, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_keynav_failed", lg_gtk_widget_keynav_failed, 2, 0, 0, H_gtk_widget_keynav_failed, pl_bug);
  s7_define_typed_function(sc, "gtk_widget_error_bell", lg_gtk_widget_error_bell, 1, 0, 0, H_gtk_widget_error_bell, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_trigger_tooltip_query", lg_gtk_widget_trigger_tooltip_query, 1, 0, 0, H_gtk_widget_trigger_tooltip_query, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_startup_id", lg_gtk_window_set_startup_id, 2, 0, 0, H_gtk_window_set_startup_id, pl_tus);
  s7_define_typed_function(sc, "gtk_text_buffer_add_mark", lg_gtk_text_buffer_add_mark, 3, 0, 0, H_gtk_text_buffer_add_mark, pl_tu);
  s7_define_typed_function(sc, "gtk_text_mark_new", lg_gtk_text_mark_new, 2, 0, 0, H_gtk_text_mark_new, pl_psb);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_tree_view", lg_gtk_tree_view_column_get_tree_view, 1, 0, 0, H_gtk_tree_view_column_get_tree_view, pl_pu);
  s7_define_typed_function(sc, "gtk_tooltip_set_text", lg_gtk_tooltip_set_text, 2, 0, 0, H_gtk_tooltip_set_text, pl_tus);
  s7_define_typed_function(sc, "gtk_tree_view_convert_widget_to_tree_coords", lg_gtk_tree_view_convert_widget_to_tree_coords, 3, 2, 0, H_gtk_tree_view_convert_widget_to_tree_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_tree_to_widget_coords", lg_gtk_tree_view_convert_tree_to_widget_coords, 3, 2, 0, H_gtk_tree_view_convert_tree_to_widget_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_widget_to_bin_window_coords", lg_gtk_tree_view_convert_widget_to_bin_window_coords, 3, 2, 0, H_gtk_tree_view_convert_widget_to_bin_window_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_bin_window_to_widget_coords", lg_gtk_tree_view_convert_bin_window_to_widget_coords, 3, 2, 0, H_gtk_tree_view_convert_bin_window_to_widget_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_tree_to_bin_window_coords", lg_gtk_tree_view_convert_tree_to_bin_window_coords, 3, 2, 0, H_gtk_tree_view_convert_tree_to_bin_window_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_tree_view_convert_bin_window_to_tree_coords", lg_gtk_tree_view_convert_bin_window_to_tree_coords, 3, 2, 0, H_gtk_tree_view_convert_bin_window_to_tree_coords, pl_puiiu);
  s7_define_typed_function(sc, "gtk_widget_set_tooltip_text", lg_gtk_widget_set_tooltip_text, 2, 0, 0, H_gtk_widget_set_tooltip_text, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_tooltip_text", lg_gtk_widget_get_tooltip_text, 1, 0, 0, H_gtk_widget_get_tooltip_text, pl_su);
  s7_define_typed_function(sc, "gtk_widget_set_tooltip_markup", lg_gtk_widget_set_tooltip_markup, 2, 0, 0, H_gtk_widget_set_tooltip_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_tooltip_markup", lg_gtk_widget_get_tooltip_markup, 1, 0, 0, H_gtk_widget_get_tooltip_markup, pl_su);
  s7_define_typed_function(sc, "gtk_tree_view_is_rubber_banding_active", lg_gtk_tree_view_is_rubber_banding_active, 1, 0, 0, H_gtk_tree_view_is_rubber_banding_active, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_set_tooltip_item", lg_gtk_icon_view_set_tooltip_item, 3, 0, 0, H_gtk_icon_view_set_tooltip_item, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_set_tooltip_cell", lg_gtk_icon_view_set_tooltip_cell, 4, 0, 0, H_gtk_icon_view_set_tooltip_cell, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_get_tooltip_context", lg_gtk_icon_view_get_tooltip_context, 3, 4, 0, H_gtk_icon_view_get_tooltip_context, pl_puuubu);
  s7_define_typed_function(sc, "gtk_icon_view_set_tooltip_column", lg_gtk_icon_view_set_tooltip_column, 2, 0, 0, H_gtk_icon_view_set_tooltip_column, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_tooltip_column", lg_gtk_icon_view_get_tooltip_column, 1, 0, 0, H_gtk_icon_view_get_tooltip_column, pl_iu);
  s7_define_typed_function(sc, "gtk_tooltip_set_tip_area", lg_gtk_tooltip_set_tip_area, 2, 0, 0, H_gtk_tooltip_set_tip_area, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_tooltip_row", lg_gtk_tree_view_set_tooltip_row, 3, 0, 0, H_gtk_tree_view_set_tooltip_row, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_set_tooltip_cell", lg_gtk_tree_view_set_tooltip_cell, 5, 0, 0, H_gtk_tree_view_set_tooltip_cell, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_tooltip_context", lg_gtk_tree_view_get_tooltip_context, 3, 4, 0, H_gtk_tree_view_get_tooltip_context, pl_puuubu);
  s7_define_typed_function(sc, "gtk_tree_view_set_tooltip_column", lg_gtk_tree_view_set_tooltip_column, 2, 0, 0, H_gtk_tree_view_set_tooltip_column, pl_tui);
  s7_define_typed_function(sc, "gtk_tree_view_get_tooltip_column", lg_gtk_tree_view_get_tooltip_column, 1, 0, 0, H_gtk_tree_view_get_tooltip_column, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_has_tooltip", lg_gtk_widget_set_has_tooltip, 2, 0, 0, H_gtk_widget_set_has_tooltip, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_has_tooltip", lg_gtk_widget_get_has_tooltip, 1, 0, 0, H_gtk_widget_get_has_tooltip, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_set_detail_func", lg_gtk_calendar_set_detail_func, 4, 0, 0, H_gtk_calendar_set_detail_func, pl_tut);
  s7_define_typed_function(sc, "gtk_calendar_set_detail_width_chars", lg_gtk_calendar_set_detail_width_chars, 2, 0, 0, H_gtk_calendar_set_detail_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_set_detail_height_rows", lg_gtk_calendar_set_detail_height_rows, 2, 0, 0, H_gtk_calendar_set_detail_height_rows, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_get_detail_width_chars", lg_gtk_calendar_get_detail_width_chars, 1, 0, 0, H_gtk_calendar_get_detail_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_calendar_get_detail_height_rows", lg_gtk_calendar_get_detail_height_rows, 1, 0, 0, H_gtk_calendar_get_detail_height_rows, pl_iu);
  s7_define_typed_function(sc, "gtk_dialog_get_content_area", lg_gtk_dialog_get_content_area, 1, 0, 0, H_gtk_dialog_get_content_area, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_overwrite_mode", lg_gtk_entry_set_overwrite_mode, 2, 0, 0, H_gtk_entry_set_overwrite_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_entry_get_overwrite_mode", lg_gtk_entry_get_overwrite_mode, 1, 0, 0, H_gtk_entry_get_overwrite_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_get_text_length", lg_gtk_entry_get_text_length, 1, 0, 0, H_gtk_entry_get_text_length, pl_iu);
  s7_define_typed_function(sc, "gtk_scale_button_get_plus_button", lg_gtk_scale_button_get_plus_button, 1, 0, 0, H_gtk_scale_button_get_plus_button, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_button_get_minus_button", lg_gtk_scale_button_get_minus_button, 1, 0, 0, H_gtk_scale_button_get_minus_button, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_button_get_popup", lg_gtk_scale_button_get_popup, 1, 0, 0, H_gtk_scale_button_get_popup, pl_pu);
  s7_define_typed_function(sc, "gtk_adjustment_get_lower", lg_gtk_adjustment_get_lower, 1, 0, 0, H_gtk_adjustment_get_lower, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_lower", lg_gtk_adjustment_set_lower, 2, 0, 0, H_gtk_adjustment_set_lower, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_upper", lg_gtk_adjustment_get_upper, 1, 0, 0, H_gtk_adjustment_get_upper, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_upper", lg_gtk_adjustment_set_upper, 2, 0, 0, H_gtk_adjustment_set_upper, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_step_increment", lg_gtk_adjustment_get_step_increment, 1, 0, 0, H_gtk_adjustment_get_step_increment, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_step_increment", lg_gtk_adjustment_set_step_increment, 2, 0, 0, H_gtk_adjustment_set_step_increment, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_page_increment", lg_gtk_adjustment_get_page_increment, 1, 0, 0, H_gtk_adjustment_get_page_increment, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_page_increment", lg_gtk_adjustment_set_page_increment, 2, 0, 0, H_gtk_adjustment_set_page_increment, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_get_page_size", lg_gtk_adjustment_get_page_size, 1, 0, 0, H_gtk_adjustment_get_page_size, pl_du);
  s7_define_typed_function(sc, "gtk_adjustment_set_page_size", lg_gtk_adjustment_set_page_size, 2, 0, 0, H_gtk_adjustment_set_page_size, pl_tur);
  s7_define_typed_function(sc, "gtk_adjustment_configure", lg_gtk_adjustment_configure, 7, 0, 0, H_gtk_adjustment_configure, pl_tur);
  s7_define_typed_function(sc, "gtk_combo_box_set_button_sensitivity", lg_gtk_combo_box_set_button_sensitivity, 2, 0, 0, H_gtk_combo_box_set_button_sensitivity, pl_tug);
  s7_define_typed_function(sc, "gtk_combo_box_get_button_sensitivity", lg_gtk_combo_box_get_button_sensitivity, 1, 0, 0, H_gtk_combo_box_get_button_sensitivity, pl_gu);
  s7_define_typed_function(sc, "gtk_window_get_default_widget", lg_gtk_window_get_default_widget, 1, 0, 0, H_gtk_window_get_default_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_link_button_get_visited", lg_gtk_link_button_get_visited, 1, 0, 0, H_gtk_link_button_get_visited, pl_bu);
  s7_define_typed_function(sc, "gtk_link_button_set_visited", lg_gtk_link_button_set_visited, 2, 0, 0, H_gtk_link_button_set_visited, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_view_get_model", lg_gtk_cell_view_get_model, 1, 0, 0, H_gtk_cell_view_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_unset_invisible_char", lg_gtk_entry_unset_invisible_char, 1, 0, 0, H_gtk_entry_unset_invisible_char, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_set_progress_fraction", lg_gtk_entry_set_progress_fraction, 2, 0, 0, H_gtk_entry_set_progress_fraction, pl_tur);
  s7_define_typed_function(sc, "gtk_entry_get_progress_fraction", lg_gtk_entry_get_progress_fraction, 1, 0, 0, H_gtk_entry_get_progress_fraction, pl_du);
  s7_define_typed_function(sc, "gtk_entry_set_progress_pulse_step", lg_gtk_entry_set_progress_pulse_step, 2, 0, 0, H_gtk_entry_set_progress_pulse_step, pl_tur);
  s7_define_typed_function(sc, "gtk_entry_get_progress_pulse_step", lg_gtk_entry_get_progress_pulse_step, 1, 0, 0, H_gtk_entry_get_progress_pulse_step, pl_du);
  s7_define_typed_function(sc, "gtk_entry_progress_pulse", lg_gtk_entry_progress_pulse, 1, 0, 0, H_gtk_entry_progress_pulse, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_icon_name", lg_gtk_entry_get_icon_name, 2, 0, 0, H_gtk_entry_get_icon_name, pl_sug);
  s7_define_typed_function(sc, "gtk_entry_set_icon_activatable", lg_gtk_entry_set_icon_activatable, 3, 0, 0, H_gtk_entry_set_icon_activatable, pl_tugb);
  s7_define_typed_function(sc, "gtk_entry_get_icon_activatable", lg_gtk_entry_get_icon_activatable, 2, 0, 0, H_gtk_entry_get_icon_activatable, pl_bug);
  s7_define_typed_function(sc, "gtk_entry_set_icon_sensitive", lg_gtk_entry_set_icon_sensitive, 3, 0, 0, H_gtk_entry_set_icon_sensitive, pl_tugb);
  s7_define_typed_function(sc, "gtk_entry_get_icon_sensitive", lg_gtk_entry_get_icon_sensitive, 2, 0, 0, H_gtk_entry_get_icon_sensitive, pl_bug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_at_pos", lg_gtk_entry_get_icon_at_pos, 3, 0, 0, H_gtk_entry_get_icon_at_pos, pl_iui);
  s7_define_typed_function(sc, "gtk_entry_set_icon_tooltip_text", lg_gtk_entry_set_icon_tooltip_text, 3, 0, 0, H_gtk_entry_set_icon_tooltip_text, pl_tugs);
  s7_define_typed_function(sc, "gtk_entry_set_icon_tooltip_markup", lg_gtk_entry_set_icon_tooltip_markup, 3, 0, 0, H_gtk_entry_set_icon_tooltip_markup, pl_tugs);
  s7_define_typed_function(sc, "gtk_entry_get_icon_tooltip_text", lg_gtk_entry_get_icon_tooltip_text, 2, 0, 0, H_gtk_entry_get_icon_tooltip_text, pl_sug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_tooltip_markup", lg_gtk_entry_get_icon_tooltip_markup, 2, 0, 0, H_gtk_entry_get_icon_tooltip_markup, pl_sug);
  s7_define_typed_function(sc, "gtk_scale_add_mark", lg_gtk_scale_add_mark, 4, 0, 0, H_gtk_scale_add_mark, pl_turgs);
  s7_define_typed_function(sc, "gtk_scale_clear_marks", lg_gtk_scale_clear_marks, 1, 0, 0, H_gtk_scale_clear_marks, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_default_icon_name", lg_gtk_window_get_default_icon_name, 0, 0, 0, H_gtk_window_get_default_icon_name, pl_s);
  s7_define_typed_function(sc, "gtk_label_get_current_uri", lg_gtk_label_get_current_uri, 1, 0, 0, H_gtk_label_get_current_uri, pl_su);
  s7_define_typed_function(sc, "gtk_info_bar_new", lg_gtk_info_bar_new, 0, 0, 0, H_gtk_info_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_info_bar_add_action_widget", lg_gtk_info_bar_add_action_widget, 3, 0, 0, H_gtk_info_bar_add_action_widget, pl_tuui);
  s7_define_typed_function(sc, "gtk_info_bar_add_button", lg_gtk_info_bar_add_button, 3, 0, 0, H_gtk_info_bar_add_button, pl_pusi);
  s7_define_typed_function(sc, "gtk_info_bar_set_response_sensitive", lg_gtk_info_bar_set_response_sensitive, 3, 0, 0, H_gtk_info_bar_set_response_sensitive, pl_tuib);
  s7_define_typed_function(sc, "gtk_info_bar_set_default_response", lg_gtk_info_bar_set_default_response, 2, 0, 0, H_gtk_info_bar_set_default_response, pl_tui);
  s7_define_typed_function(sc, "gtk_info_bar_response", lg_gtk_info_bar_response, 2, 0, 0, H_gtk_info_bar_response, pl_tui);
  s7_define_typed_function(sc, "gtk_info_bar_set_message_type", lg_gtk_info_bar_set_message_type, 2, 0, 0, H_gtk_info_bar_set_message_type, pl_tug);
  s7_define_typed_function(sc, "gtk_info_bar_get_message_type", lg_gtk_info_bar_get_message_type, 1, 0, 0, H_gtk_info_bar_get_message_type, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_new_with_buffer", lg_gtk_entry_new_with_buffer, 1, 0, 0, H_gtk_entry_new_with_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_get_buffer", lg_gtk_entry_get_buffer, 1, 0, 0, H_gtk_entry_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_buffer", lg_gtk_entry_set_buffer, 2, 0, 0, H_gtk_entry_set_buffer, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_track_visited_links", lg_gtk_label_set_track_visited_links, 2, 0, 0, H_gtk_label_set_track_visited_links, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_track_visited_links", lg_gtk_label_get_track_visited_links, 1, 0, 0, H_gtk_label_get_track_visited_links, pl_bu);
  s7_define_typed_function(sc, "gtk_print_operation_set_embed_page_setup", lg_gtk_print_operation_set_embed_page_setup, 2, 0, 0, H_gtk_print_operation_set_embed_page_setup, pl_tub);
  s7_define_typed_function(sc, "gtk_print_operation_get_embed_page_setup", lg_gtk_print_operation_get_embed_page_setup, 1, 0, 0, H_gtk_print_operation_get_embed_page_setup, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_buffer_new", lg_gtk_entry_buffer_new, 2, 0, 0, H_gtk_entry_buffer_new, pl_psi);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_bytes", lg_gtk_entry_buffer_get_bytes, 1, 0, 0, H_gtk_entry_buffer_get_bytes, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_length", lg_gtk_entry_buffer_get_length, 1, 0, 0, H_gtk_entry_buffer_get_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_text", lg_gtk_entry_buffer_get_text, 1, 0, 0, H_gtk_entry_buffer_get_text, pl_su);
  s7_define_typed_function(sc, "gtk_entry_buffer_set_text", lg_gtk_entry_buffer_set_text, 3, 0, 0, H_gtk_entry_buffer_set_text, pl_tusi);
  s7_define_typed_function(sc, "gtk_entry_buffer_set_max_length", lg_gtk_entry_buffer_set_max_length, 2, 0, 0, H_gtk_entry_buffer_set_max_length, pl_tui);
  s7_define_typed_function(sc, "gtk_entry_buffer_get_max_length", lg_gtk_entry_buffer_get_max_length, 1, 0, 0, H_gtk_entry_buffer_get_max_length, pl_iu);
  s7_define_typed_function(sc, "gtk_entry_buffer_insert_text", lg_gtk_entry_buffer_insert_text, 4, 0, 0, H_gtk_entry_buffer_insert_text, pl_iuisi);
  s7_define_typed_function(sc, "gtk_entry_buffer_delete_text", lg_gtk_entry_buffer_delete_text, 3, 0, 0, H_gtk_entry_buffer_delete_text, pl_iui);
  s7_define_typed_function(sc, "gtk_entry_buffer_emit_inserted_text", lg_gtk_entry_buffer_emit_inserted_text, 4, 0, 0, H_gtk_entry_buffer_emit_inserted_text, pl_tuisi);
  s7_define_typed_function(sc, "gtk_entry_buffer_emit_deleted_text", lg_gtk_entry_buffer_emit_deleted_text, 3, 0, 0, H_gtk_entry_buffer_emit_deleted_text, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_alignment", lg_gtk_cell_renderer_set_alignment, 3, 0, 0, H_gtk_cell_renderer_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_alignment", lg_gtk_cell_renderer_get_alignment, 1, 2, 0, H_gtk_cell_renderer_get_alignment, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_padding", lg_gtk_cell_renderer_set_padding, 3, 0, 0, H_gtk_cell_renderer_set_padding, pl_tui);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_padding", lg_gtk_cell_renderer_get_padding, 1, 2, 0, H_gtk_cell_renderer_get_padding, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_visible", lg_gtk_cell_renderer_set_visible, 2, 0, 0, H_gtk_cell_renderer_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_visible", lg_gtk_cell_renderer_get_visible, 1, 0, 0, H_gtk_cell_renderer_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_sensitive", lg_gtk_cell_renderer_set_sensitive, 2, 0, 0, H_gtk_cell_renderer_set_sensitive, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_sensitive", lg_gtk_cell_renderer_get_sensitive, 1, 0, 0, H_gtk_cell_renderer_get_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_get_activatable", lg_gtk_cell_renderer_toggle_get_activatable, 1, 0, 0, H_gtk_cell_renderer_toggle_get_activatable, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_toggle_set_activatable", lg_gtk_cell_renderer_toggle_set_activatable, 2, 0, 0, H_gtk_cell_renderer_toggle_set_activatable, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_can_focus", lg_gtk_widget_set_can_focus, 2, 0, 0, H_gtk_widget_set_can_focus, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_can_focus", lg_gtk_widget_get_can_focus, 1, 0, 0, H_gtk_widget_get_can_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_has_focus", lg_gtk_widget_has_focus, 1, 0, 0, H_gtk_widget_has_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_has_default", lg_gtk_widget_has_default, 1, 0, 0, H_gtk_widget_has_default, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_sensitive", lg_gtk_widget_get_sensitive, 1, 0, 0, H_gtk_widget_get_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_sensitive", lg_gtk_widget_is_sensitive, 1, 0, 0, H_gtk_widget_is_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_set_item_padding", lg_gtk_icon_view_set_item_padding, 2, 0, 0, H_gtk_icon_view_set_item_padding, pl_tui);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_padding", lg_gtk_icon_view_get_item_padding, 1, 0, 0, H_gtk_icon_view_get_item_padding, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_has_grab", lg_gtk_widget_has_grab, 1, 0, 0, H_gtk_widget_has_grab, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_visible", lg_gtk_widget_set_visible, 2, 0, 0, H_gtk_widget_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_visible", lg_gtk_widget_get_visible, 1, 0, 0, H_gtk_widget_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_flippable", lg_gtk_range_set_flippable, 2, 0, 0, H_gtk_range_set_flippable, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_flippable", lg_gtk_range_get_flippable, 1, 0, 0, H_gtk_range_get_flippable, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_drawable", lg_gtk_widget_is_drawable, 1, 0, 0, H_gtk_widget_is_drawable, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_receives_default", lg_gtk_widget_set_receives_default, 2, 0, 0, H_gtk_widget_set_receives_default, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_receives_default", lg_gtk_widget_get_receives_default, 1, 0, 0, H_gtk_widget_get_receives_default, pl_bu);
  s7_define_typed_function(sc, "gtk_dialog_get_widget_for_response", lg_gtk_dialog_get_widget_for_response, 2, 0, 0, H_gtk_dialog_get_widget_for_response, pl_pui);
  s7_define_typed_function(sc, "gtk_spinner_new", lg_gtk_spinner_new, 0, 0, 0, H_gtk_spinner_new, pl_p);
  s7_define_typed_function(sc, "gtk_spinner_start", lg_gtk_spinner_start, 1, 0, 0, H_gtk_spinner_start, pl_tu);
  s7_define_typed_function(sc, "gtk_spinner_stop", lg_gtk_spinner_stop, 1, 0, 0, H_gtk_spinner_stop, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_renderer_spinner_new", lg_gtk_cell_renderer_spinner_new, 0, 0, 0, H_gtk_cell_renderer_spinner_new, pl_p);
  s7_define_typed_function(sc, "gtk_notebook_get_action_widget", lg_gtk_notebook_get_action_widget, 2, 0, 0, H_gtk_notebook_get_action_widget, pl_pug);
  s7_define_typed_function(sc, "gtk_notebook_set_action_widget", lg_gtk_notebook_set_action_widget, 3, 0, 0, H_gtk_notebook_set_action_widget, pl_tuug);
  s7_define_typed_function(sc, "gtk_window_set_mnemonics_visible", lg_gtk_window_set_mnemonics_visible, 2, 0, 0, H_gtk_window_set_mnemonics_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_mnemonics_visible", lg_gtk_window_get_mnemonics_visible, 1, 0, 0, H_gtk_window_get_mnemonics_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_range_set_slider_size_fixed", lg_gtk_range_set_slider_size_fixed, 2, 0, 0, H_gtk_range_set_slider_size_fixed, pl_tub);
  s7_define_typed_function(sc, "gtk_range_get_slider_size_fixed", lg_gtk_range_get_slider_size_fixed, 1, 0, 0, H_gtk_range_get_slider_size_fixed, pl_bu);
  s7_define_typed_function(sc, "gtk_range_get_range_rect", lg_gtk_range_get_range_rect, 2, 0, 0, H_gtk_range_get_range_rect, pl_tu);
  s7_define_typed_function(sc, "gtk_range_get_slider_range", lg_gtk_range_get_slider_range, 1, 2, 0, H_gtk_range_get_slider_range, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_realized", lg_gtk_widget_get_realized, 1, 0, 0, H_gtk_widget_get_realized, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_mapped", lg_gtk_widget_get_mapped, 1, 0, 0, H_gtk_widget_get_mapped, pl_bu);
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "gdk_keymap_add_virtual_modifiers", lg_gdk_keymap_add_virtual_modifiers, 2, 0, 0, H_gdk_keymap_add_virtual_modifiers, pl_tu);
  s7_define_typed_function(sc, "gtk_accessible_get_widget", lg_gtk_accessible_get_widget, 1, 0, 0, H_gtk_accessible_get_widget, pl_pu);
  s7_define_typed_function(sc, "gdk_event_set_device", lg_gdk_event_set_device, 2, 0, 0, H_gdk_event_set_device, pl_tu);
  s7_define_typed_function(sc, "gdk_event_get_device", lg_gdk_event_get_device, 1, 0, 0, H_gdk_event_get_device, pl_pu);
  s7_define_typed_function(sc, "gdk_events_get_distance", lg_gdk_events_get_distance, 2, 1, 0, H_gdk_events_get_distance, pl_pu);
  s7_define_typed_function(sc, "gdk_events_get_angle", lg_gdk_events_get_angle, 2, 1, 0, H_gdk_events_get_angle, pl_pu);
  s7_define_typed_function(sc, "gdk_events_get_center", lg_gdk_events_get_center, 2, 2, 0, H_gdk_events_get_center, pl_pu);
  s7_define_typed_function(sc, "gtk_combo_box_popup_for_device", lg_gtk_combo_box_popup_for_device, 2, 0, 0, H_gtk_combo_box_popup_for_device, pl_tu);
  s7_define_typed_function(sc, "gtk_paned_new", lg_gtk_paned_new, 1, 0, 0, H_gtk_paned_new, pl_pg);
  s7_define_typed_function(sc, "gtk_scale_new", lg_gtk_scale_new, 2, 0, 0, H_gtk_scale_new, pl_pgu);
  s7_define_typed_function(sc, "gtk_scale_new_with_range", lg_gtk_scale_new_with_range, 4, 0, 0, H_gtk_scale_new_with_range, pl_pgr);
  s7_define_typed_function(sc, "gtk_scrollbar_new", lg_gtk_scrollbar_new, 2, 0, 0, H_gtk_scrollbar_new, pl_pgu);
  s7_define_typed_function(sc, "gtk_separator_new", lg_gtk_separator_new, 1, 0, 0, H_gtk_separator_new, pl_pg);
  s7_define_typed_function(sc, "gtk_widget_device_is_shadowed", lg_gtk_widget_device_is_shadowed, 2, 0, 0, H_gtk_widget_device_is_shadowed, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_support_multidevice", lg_gtk_widget_get_support_multidevice, 1, 0, 0, H_gtk_widget_get_support_multidevice, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_support_multidevice", lg_gtk_widget_set_support_multidevice, 2, 0, 0, H_gtk_widget_set_support_multidevice, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_row", lg_gtk_icon_view_get_item_row, 2, 0, 0, H_gtk_icon_view_get_item_row, pl_iu);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_column", lg_gtk_icon_view_get_item_column, 2, 0, 0, H_gtk_icon_view_get_item_column, pl_iu);
  s7_define_typed_function(sc, "gtk_statusbar_remove_all", lg_gtk_statusbar_remove_all, 2, 0, 0, H_gtk_statusbar_remove_all, pl_tui);
  s7_define_typed_function(sc, "gtk_window_has_group", lg_gtk_window_has_group, 1, 0, 0, H_gtk_window_has_group, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_select_month", lg_gtk_calendar_select_month, 3, 0, 0, H_gtk_calendar_select_month, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_mark_day", lg_gtk_calendar_mark_day, 2, 0, 0, H_gtk_calendar_mark_day, pl_tui);
  s7_define_typed_function(sc, "gtk_calendar_unmark_day", lg_gtk_calendar_unmark_day, 2, 0, 0, H_gtk_calendar_unmark_day, pl_tui);
  s7_define_typed_function(sc, "gtk_accessible_set_widget", lg_gtk_accessible_set_widget, 2, 0, 0, H_gtk_accessible_set_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_message_dialog_get_message_area", lg_gtk_message_dialog_get_message_area, 1, 0, 0, H_gtk_message_dialog_get_message_area, pl_pu);
  s7_define_typed_function(sc, "gdk_pango_layout_line_get_clip_region", lg_gdk_pango_layout_line_get_clip_region, 5, 0, 0, H_gdk_pango_layout_line_get_clip_region, pl_puiiui);
  s7_define_typed_function(sc, "gdk_pango_layout_get_clip_region", lg_gdk_pango_layout_get_clip_region, 5, 0, 0, H_gdk_pango_layout_get_clip_region, pl_puiiui);
  s7_define_typed_function(sc, "gdk_display_is_closed", lg_gdk_display_is_closed, 1, 0, 0, H_gdk_display_is_closed, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_get_day_is_marked", lg_gtk_calendar_get_day_is_marked, 2, 0, 0, H_gtk_calendar_get_day_is_marked, pl_bui);
  s7_define_typed_function(sc, "gtk_progress_bar_set_inverted", lg_gtk_progress_bar_set_inverted, 2, 0, 0, H_gtk_progress_bar_set_inverted, pl_tub);
  s7_define_typed_function(sc, "gtk_progress_bar_get_inverted", lg_gtk_progress_bar_get_inverted, 1, 0, 0, H_gtk_progress_bar_get_inverted, pl_bu);
  s7_define_typed_function(sc, "gtk_radio_button_join_group", lg_gtk_radio_button_join_group, 2, 0, 0, H_gtk_radio_button_join_group, pl_tu);
  s7_define_typed_function(sc, "gtk_adjustment_new", lg_gtk_adjustment_new, 6, 0, 0, H_gtk_adjustment_new, pl_pr);
  s7_define_typed_function(sc, "gtk_icon_view_create_drag_icon", lg_gtk_icon_view_create_drag_icon, 2, 0, 0, H_gtk_icon_view_create_drag_icon, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_create_row_drag_icon", lg_gtk_tree_view_create_row_drag_icon, 2, 0, 0, H_gtk_tree_view_create_row_drag_icon, pl_pu);
  s7_define_typed_function(sc, "gdk_cairo_region_create_from_surface", lg_gdk_cairo_region_create_from_surface, 1, 0, 0, H_gdk_cairo_region_create_from_surface, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_request_mode", lg_gtk_cell_renderer_get_request_mode, 1, 0, 0, H_gtk_cell_renderer_get_request_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_width", lg_gtk_cell_renderer_get_preferred_width, 2, 2, 0, H_gtk_cell_renderer_get_preferred_width, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_height_for_width", lg_gtk_cell_renderer_get_preferred_height_for_width, 3, 2, 0, H_gtk_cell_renderer_get_preferred_height_for_width, pl_puuiu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_height", lg_gtk_cell_renderer_get_preferred_height, 2, 2, 0, H_gtk_cell_renderer_get_preferred_height, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_preferred_width_for_height", lg_gtk_cell_renderer_get_preferred_width_for_height, 3, 2, 0, H_gtk_cell_renderer_get_preferred_width_for_height, pl_puuiu);
  s7_define_typed_function(sc, "gtk_notebook_set_group_name", lg_gtk_notebook_set_group_name, 2, 0, 0, H_gtk_notebook_set_group_name, pl_tus);
  s7_define_typed_function(sc, "gtk_notebook_get_group_name", lg_gtk_notebook_get_group_name, 1, 0, 0, H_gtk_notebook_get_group_name, pl_su);
  s7_define_typed_function(sc, "gtk_widget_get_request_mode", lg_gtk_widget_get_request_mode, 1, 0, 0, H_gtk_widget_get_request_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_get_allocated_width", lg_gtk_widget_get_allocated_width, 1, 0, 0, H_gtk_widget_get_allocated_width, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_allocated_height", lg_gtk_widget_get_allocated_height, 1, 0, 0, H_gtk_widget_get_allocated_height, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_halign", lg_gtk_widget_get_halign, 1, 0, 0, H_gtk_widget_get_halign, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_set_halign", lg_gtk_widget_set_halign, 2, 0, 0, H_gtk_widget_set_halign, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_valign", lg_gtk_widget_get_valign, 1, 0, 0, H_gtk_widget_get_valign, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_set_valign", lg_gtk_widget_set_valign, 2, 0, 0, H_gtk_widget_set_valign, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_margin_top", lg_gtk_widget_get_margin_top, 1, 0, 0, H_gtk_widget_get_margin_top, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_top", lg_gtk_widget_set_margin_top, 2, 0, 0, H_gtk_widget_set_margin_top, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_get_margin_bottom", lg_gtk_widget_get_margin_bottom, 1, 0, 0, H_gtk_widget_get_margin_bottom, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_bottom", lg_gtk_widget_set_margin_bottom, 2, 0, 0, H_gtk_widget_set_margin_bottom, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_new_with_entry", lg_gtk_combo_box_new_with_entry, 0, 0, 0, H_gtk_combo_box_new_with_entry, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_get_has_entry", lg_gtk_combo_box_get_has_entry, 1, 0, 0, H_gtk_combo_box_get_has_entry, pl_bu);
  s7_define_typed_function(sc, "gtk_combo_box_set_entry_text_column", lg_gtk_combo_box_set_entry_text_column, 2, 0, 0, H_gtk_combo_box_set_entry_text_column, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_entry_text_column", lg_gtk_combo_box_get_entry_text_column, 1, 0, 0, H_gtk_combo_box_get_entry_text_column, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_hexpand", lg_gtk_widget_get_hexpand, 1, 0, 0, H_gtk_widget_get_hexpand, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_hexpand", lg_gtk_widget_set_hexpand, 2, 0, 0, H_gtk_widget_set_hexpand, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_hexpand_set", lg_gtk_widget_get_hexpand_set, 1, 0, 0, H_gtk_widget_get_hexpand_set, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_hexpand_set", lg_gtk_widget_set_hexpand_set, 2, 0, 0, H_gtk_widget_set_hexpand_set, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_vexpand", lg_gtk_widget_get_vexpand, 1, 0, 0, H_gtk_widget_get_vexpand, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_vexpand", lg_gtk_widget_set_vexpand, 2, 0, 0, H_gtk_widget_set_vexpand, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_vexpand_set", lg_gtk_widget_get_vexpand_set, 1, 0, 0, H_gtk_widget_get_vexpand_set, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_vexpand_set", lg_gtk_widget_set_vexpand_set, 2, 0, 0, H_gtk_widget_set_vexpand_set, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_compute_expand", lg_gtk_widget_compute_expand, 2, 0, 0, H_gtk_widget_compute_expand, pl_bug);
  s7_define_typed_function(sc, "gtk_combo_box_text_new", lg_gtk_combo_box_text_new, 0, 0, 0, H_gtk_combo_box_text_new, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_text_new_with_entry", lg_gtk_combo_box_text_new_with_entry, 0, 0, 0, H_gtk_combo_box_text_new_with_entry, pl_p);
  s7_define_typed_function(sc, "gtk_combo_box_text_append_text", lg_gtk_combo_box_text_append_text, 2, 0, 0, H_gtk_combo_box_text_append_text, pl_tus);
  s7_define_typed_function(sc, "gtk_combo_box_text_insert_text", lg_gtk_combo_box_text_insert_text, 3, 0, 0, H_gtk_combo_box_text_insert_text, pl_tuis);
  s7_define_typed_function(sc, "gtk_combo_box_text_prepend_text", lg_gtk_combo_box_text_prepend_text, 2, 0, 0, H_gtk_combo_box_text_prepend_text, pl_tus);
  s7_define_typed_function(sc, "gtk_combo_box_text_remove", lg_gtk_combo_box_text_remove, 2, 0, 0, H_gtk_combo_box_text_remove, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_text_get_active_text", lg_gtk_combo_box_text_get_active_text, 1, 0, 0, H_gtk_combo_box_text_get_active_text, pl_su);
  s7_define_typed_function(sc, "gdk_cairo_set_source_rgba", lg_gdk_cairo_set_source_rgba, 2, 0, 0, H_gdk_cairo_set_source_rgba, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_text_remove_all", lg_gtk_combo_box_text_remove_all, 1, 0, 0, H_gtk_combo_box_text_remove_all, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_set_popup_fixed_width", lg_gtk_combo_box_set_popup_fixed_width, 2, 0, 0, H_gtk_combo_box_set_popup_fixed_width, pl_tub);
  s7_define_typed_function(sc, "gtk_combo_box_get_popup_fixed_width", lg_gtk_combo_box_get_popup_fixed_width, 1, 0, 0, H_gtk_combo_box_get_popup_fixed_width, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_min_content_width", lg_gtk_scrolled_window_get_min_content_width, 1, 0, 0, H_gtk_scrolled_window_get_min_content_width, pl_iu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_min_content_width", lg_gtk_scrolled_window_set_min_content_width, 2, 0, 0, H_gtk_scrolled_window_set_min_content_width, pl_tui);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_min_content_height", lg_gtk_scrolled_window_get_min_content_height, 1, 0, 0, H_gtk_scrolled_window_get_min_content_height, pl_iu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_min_content_height", lg_gtk_scrolled_window_set_min_content_height, 2, 0, 0, H_gtk_scrolled_window_set_min_content_height, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_new", lg_gtk_grid_new, 0, 0, 0, H_gtk_grid_new, pl_p);
  s7_define_typed_function(sc, "gtk_grid_attach", lg_gtk_grid_attach, 6, 0, 0, H_gtk_grid_attach, pl_tuui);
  s7_define_typed_function(sc, "gtk_grid_attach_next_to", lg_gtk_grid_attach_next_to, 6, 0, 0, H_gtk_grid_attach_next_to, pl_tuuugi);
  s7_define_typed_function(sc, "gtk_grid_set_row_homogeneous", lg_gtk_grid_set_row_homogeneous, 2, 0, 0, H_gtk_grid_set_row_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_grid_get_row_homogeneous", lg_gtk_grid_get_row_homogeneous, 1, 0, 0, H_gtk_grid_get_row_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_grid_set_row_spacing", lg_gtk_grid_set_row_spacing, 2, 0, 0, H_gtk_grid_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_get_row_spacing", lg_gtk_grid_get_row_spacing, 1, 0, 0, H_gtk_grid_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_set_column_homogeneous", lg_gtk_grid_set_column_homogeneous, 2, 0, 0, H_gtk_grid_set_column_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_grid_get_column_homogeneous", lg_gtk_grid_get_column_homogeneous, 1, 0, 0, H_gtk_grid_get_column_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_grid_set_column_spacing", lg_gtk_grid_set_column_spacing, 2, 0, 0, H_gtk_grid_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_get_column_spacing", lg_gtk_grid_get_column_spacing, 1, 0, 0, H_gtk_grid_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_scrollable_get_hadjustment", lg_gtk_scrollable_get_hadjustment, 1, 0, 0, H_gtk_scrollable_get_hadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_set_hadjustment", lg_gtk_scrollable_set_hadjustment, 2, 0, 0, H_gtk_scrollable_set_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrollable_get_vadjustment", lg_gtk_scrollable_get_vadjustment, 1, 0, 0, H_gtk_scrollable_get_vadjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_set_vadjustment", lg_gtk_scrollable_set_vadjustment, 2, 0, 0, H_gtk_scrollable_set_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_next_page", lg_gtk_assistant_next_page, 1, 0, 0, H_gtk_assistant_next_page, pl_tu);
  s7_define_typed_function(sc, "gtk_assistant_previous_page", lg_gtk_assistant_previous_page, 1, 0, 0, H_gtk_assistant_previous_page, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_new_with_model_and_entry", lg_gtk_combo_box_new_with_model_and_entry, 1, 0, 0, H_gtk_combo_box_new_with_model_and_entry, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_get_hscroll_policy", lg_gtk_scrollable_get_hscroll_policy, 1, 0, 0, H_gtk_scrollable_get_hscroll_policy, pl_gu);
  s7_define_typed_function(sc, "gtk_scrollable_set_hscroll_policy", lg_gtk_scrollable_set_hscroll_policy, 2, 0, 0, H_gtk_scrollable_set_hscroll_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_scrollable_get_vscroll_policy", lg_gtk_scrollable_get_vscroll_policy, 1, 0, 0, H_gtk_scrollable_get_vscroll_policy, pl_gu);
  s7_define_typed_function(sc, "gtk_scrollable_set_vscroll_policy", lg_gtk_scrollable_set_vscroll_policy, 2, 0, 0, H_gtk_scrollable_set_vscroll_policy, pl_tug);
  s7_define_typed_function(sc, "gtk_switch_new", lg_gtk_switch_new, 0, 0, 0, H_gtk_switch_new, pl_p);
  s7_define_typed_function(sc, "gtk_switch_set_active", lg_gtk_switch_set_active, 2, 0, 0, H_gtk_switch_set_active, pl_tub);
  s7_define_typed_function(sc, "gtk_switch_get_active", lg_gtk_switch_get_active, 1, 0, 0, H_gtk_switch_get_active, pl_bu);
  s7_define_typed_function(sc, "gtk_border_new", lg_gtk_border_new, 0, 0, 0, H_gtk_border_new, pl_p);
  s7_define_typed_function(sc, "gtk_border_copy", lg_gtk_border_copy, 1, 0, 0, H_gtk_border_copy, pl_pu);
  s7_define_typed_function(sc, "gtk_border_free", lg_gtk_border_free, 1, 0, 0, H_gtk_border_free, pl_tu);
  s7_define_typed_function(sc, "gtk_combo_box_get_id_column", lg_gtk_combo_box_get_id_column, 1, 0, 0, H_gtk_combo_box_get_id_column, pl_iu);
  s7_define_typed_function(sc, "gtk_combo_box_set_id_column", lg_gtk_combo_box_set_id_column, 2, 0, 0, H_gtk_combo_box_set_id_column, pl_tui);
  s7_define_typed_function(sc, "gtk_combo_box_get_active_id", lg_gtk_combo_box_get_active_id, 1, 0, 0, H_gtk_combo_box_get_active_id, pl_su);
  s7_define_typed_function(sc, "gtk_combo_box_text_insert", lg_gtk_combo_box_text_insert, 4, 0, 0, H_gtk_combo_box_text_insert, pl_tuis);
  s7_define_typed_function(sc, "gtk_combo_box_text_append", lg_gtk_combo_box_text_append, 3, 0, 0, H_gtk_combo_box_text_append, pl_tus);
  s7_define_typed_function(sc, "gtk_combo_box_text_prepend", lg_gtk_combo_box_text_prepend, 3, 0, 0, H_gtk_combo_box_text_prepend, pl_tus);
  s7_define_typed_function(sc, "gtk_box_new", lg_gtk_box_new, 2, 0, 0, H_gtk_box_new, pl_pgi);
  s7_define_typed_function(sc, "gtk_tree_view_set_cursor_on_cell", lg_gtk_tree_view_set_cursor_on_cell, 5, 0, 0, H_gtk_tree_view_set_cursor_on_cell, pl_tuuuub);
  s7_define_typed_function(sc, "gtk_tree_view_set_rubber_banding", lg_gtk_tree_view_set_rubber_banding, 2, 0, 0, H_gtk_tree_view_set_rubber_banding, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_view_get_rubber_banding", lg_gtk_tree_view_get_rubber_banding, 1, 0, 0, H_gtk_tree_view_get_rubber_banding, pl_bu);
  s7_define_typed_function(sc, "gtk_tooltip_set_markup", lg_gtk_tooltip_set_markup, 2, 0, 0, H_gtk_tooltip_set_markup, pl_tus);
  s7_define_typed_function(sc, "gtk_tooltip_set_custom", lg_gtk_tooltip_set_custom, 2, 0, 0, H_gtk_tooltip_set_custom, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_column_new_with_area", lg_gtk_tree_view_column_new_with_area, 1, 0, 0, H_gtk_tree_view_column_new_with_area, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_button", lg_gtk_tree_view_column_get_button, 1, 0, 0, H_gtk_tree_view_column_get_button, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_focus_cell", lg_gtk_tree_view_column_focus_cell, 2, 0, 0, H_gtk_tree_view_column_focus_cell, pl_tu);
  s7_define_typed_function(sc, "gtk_orientable_set_orientation", lg_gtk_orientable_set_orientation, 2, 0, 0, H_gtk_orientable_set_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_orientable_get_orientation", lg_gtk_orientable_get_orientation, 1, 0, 0, H_gtk_orientable_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_get_major_version", lg_gtk_get_major_version, 0, 0, 0, H_gtk_get_major_version, pl_i);
  s7_define_typed_function(sc, "gtk_get_minor_version", lg_gtk_get_minor_version, 0, 0, 0, H_gtk_get_minor_version, pl_i);
  s7_define_typed_function(sc, "gtk_get_micro_version", lg_gtk_get_micro_version, 0, 0, 0, H_gtk_get_micro_version, pl_i);
  s7_define_typed_function(sc, "gtk_get_binary_age", lg_gtk_get_binary_age, 0, 0, 0, H_gtk_get_binary_age, pl_i);
  s7_define_typed_function(sc, "gtk_get_interface_age", lg_gtk_get_interface_age, 0, 0, 0, H_gtk_get_interface_age, pl_i);
  s7_define_typed_function(sc, "gtk_progress_bar_set_show_text", lg_gtk_progress_bar_set_show_text, 2, 0, 0, H_gtk_progress_bar_set_show_text, pl_tub);
  s7_define_typed_function(sc, "gtk_progress_bar_get_show_text", lg_gtk_progress_bar_get_show_text, 1, 0, 0, H_gtk_progress_bar_get_show_text, pl_bu);
  s7_define_typed_function(sc, "gtk_entry_get_icon_storage_type", lg_gtk_entry_get_icon_storage_type, 2, 0, 0, H_gtk_entry_get_icon_storage_type, pl_gug);
  s7_define_typed_function(sc, "gtk_entry_get_icon_gicon", lg_gtk_entry_get_icon_gicon, 2, 0, 0, H_gtk_entry_get_icon_gicon, pl_pug);
  s7_define_typed_function(sc, "gtk_assistant_commit", lg_gtk_assistant_commit, 1, 0, 0, H_gtk_assistant_commit, pl_tu);
  s7_define_typed_function(sc, "gtk_window_fullscreen", lg_gtk_window_fullscreen, 1, 0, 0, H_gtk_window_fullscreen, pl_tu);
  s7_define_typed_function(sc, "gtk_window_unfullscreen", lg_gtk_window_unfullscreen, 1, 0, 0, H_gtk_window_unfullscreen, pl_tu);
  s7_define_typed_function(sc, "gtk_window_group_add_window", lg_gtk_window_group_add_window, 2, 0, 0, H_gtk_window_group_add_window, pl_tu);
  s7_define_typed_function(sc, "gtk_window_group_remove_window", lg_gtk_window_group_remove_window, 2, 0, 0, H_gtk_window_group_remove_window, pl_tu);
  s7_define_typed_function(sc, "gtk_window_group_new", lg_gtk_window_group_new, 0, 0, 0, H_gtk_window_group_new, pl_p);
  s7_define_typed_function(sc, "gtk_window_get_group", lg_gtk_window_get_group, 1, 0, 0, H_gtk_window_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_window_group_list_windows", lg_gtk_window_group_list_windows, 1, 0, 0, H_gtk_window_group_list_windows, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_view_set_item_orientation", lg_gtk_icon_view_set_item_orientation, 2, 0, 0, H_gtk_icon_view_set_item_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_icon_view_get_item_orientation", lg_gtk_icon_view_get_item_orientation, 1, 0, 0, H_gtk_icon_view_get_item_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_im_context_filter_keypress", lg_gtk_text_view_im_context_filter_keypress, 2, 0, 0, H_gtk_text_view_im_context_filter_keypress, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_reset_im_context", lg_gtk_text_view_reset_im_context, 1, 0, 0, H_gtk_text_view_reset_im_context, pl_tu);
  s7_define_typed_function(sc, "gtk_cell_view_get_draw_sensitive", lg_gtk_cell_view_get_draw_sensitive, 1, 0, 0, H_gtk_cell_view_get_draw_sensitive, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_view_set_draw_sensitive", lg_gtk_cell_view_set_draw_sensitive, 2, 0, 0, H_gtk_cell_view_set_draw_sensitive, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_view_get_fit_model", lg_gtk_cell_view_get_fit_model, 1, 0, 0, H_gtk_cell_view_get_fit_model, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_view_set_fit_model", lg_gtk_cell_view_set_fit_model, 2, 0, 0, H_gtk_cell_view_set_fit_model, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_new_with_area", lg_gtk_icon_view_new_with_area, 1, 0, 0, H_gtk_icon_view_new_with_area, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_model_iter_previous", lg_gtk_tree_model_iter_previous, 2, 0, 0, H_gtk_tree_model_iter_previous, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_is_blank_at_pos", lg_gtk_tree_view_is_blank_at_pos, 3, 4, 0, H_gtk_tree_view_is_blank_at_pos, pl_puiiu);
  s7_define_typed_function(sc, "gtk_window_set_has_user_ref_count", lg_gtk_window_set_has_user_ref_count, 2, 0, 0, H_gtk_window_set_has_user_ref_count, pl_tub);
  s7_define_typed_function(sc, "gdk_rgba_copy", lg_gdk_rgba_copy, 1, 0, 0, H_gdk_rgba_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_rgba_free", lg_gdk_rgba_free, 1, 0, 0, H_gdk_rgba_free, pl_tu);
  s7_define_typed_function(sc, "gdk_rgba_parse", lg_gdk_rgba_parse, 2, 0, 0, H_gdk_rgba_parse, pl_bus);
  s7_define_typed_function(sc, "gdk_rgba_to_string", lg_gdk_rgba_to_string, 1, 0, 0, H_gdk_rgba_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_widget_set_state_flags", lg_gtk_widget_set_state_flags, 3, 0, 0, H_gtk_widget_set_state_flags, pl_tugb);
  s7_define_typed_function(sc, "gtk_widget_unset_state_flags", lg_gtk_widget_unset_state_flags, 2, 0, 0, H_gtk_widget_unset_state_flags, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_state_flags", lg_gtk_widget_get_state_flags, 1, 0, 0, H_gtk_widget_get_state_flags, pl_gu);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define_typed_function(sc, "gtk_entry_get_placeholder_text", lg_gtk_entry_get_placeholder_text, 1, 0, 0, H_gtk_entry_get_placeholder_text, pl_su);
  s7_define_typed_function(sc, "gtk_entry_set_placeholder_text", lg_gtk_entry_set_placeholder_text, 2, 0, 0, H_gtk_entry_set_placeholder_text, pl_tus);
  s7_define_typed_function(sc, "gtk_expander_set_resize_toplevel", lg_gtk_expander_set_resize_toplevel, 2, 0, 0, H_gtk_expander_set_resize_toplevel, pl_tub);
  s7_define_typed_function(sc, "gtk_expander_get_resize_toplevel", lg_gtk_expander_get_resize_toplevel, 1, 0, 0, H_gtk_expander_get_resize_toplevel, pl_bu);
  s7_define_typed_function(sc, "gtk_combo_box_set_active_id", lg_gtk_combo_box_set_active_id, 2, 0, 0, H_gtk_combo_box_set_active_id, pl_bus);
  s7_define_typed_function(sc, "gtk_tree_view_column_get_x_offset", lg_gtk_tree_view_column_get_x_offset, 1, 0, 0, H_gtk_tree_view_column_get_x_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_overlay_new", lg_gtk_overlay_new, 0, 0, 0, H_gtk_overlay_new, pl_p);
  s7_define_typed_function(sc, "gtk_overlay_add_overlay", lg_gtk_overlay_add_overlay, 2, 0, 0, H_gtk_overlay_add_overlay, pl_tu);
  s7_define_typed_function(sc, "gtk_adjustment_get_minimum_increment", lg_gtk_adjustment_get_minimum_increment, 1, 0, 0, H_gtk_adjustment_get_minimum_increment, pl_du);
  s7_define_typed_function(sc, "gtk_grid_insert_row", lg_gtk_grid_insert_row, 2, 0, 0, H_gtk_grid_insert_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_insert_column", lg_gtk_grid_insert_column, 2, 0, 0, H_gtk_grid_insert_column, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_insert_next_to", lg_gtk_grid_insert_next_to, 3, 0, 0, H_gtk_grid_insert_next_to, pl_tuug);
  s7_define_typed_function(sc, "gtk_text_iter_assign", lg_gtk_text_iter_assign, 2, 0, 0, H_gtk_text_iter_assign, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_has_visible_focus", lg_gtk_widget_has_visible_focus, 1, 0, 0, H_gtk_widget_has_visible_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_window_set_focus_visible", lg_gtk_window_set_focus_visible, 2, 0, 0, H_gtk_window_set_focus_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_window_get_focus_visible", lg_gtk_window_get_focus_visible, 1, 0, 0, H_gtk_window_get_focus_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_font_chooser_dialog_new", lg_gtk_font_chooser_dialog_new, 2, 0, 0, H_gtk_font_chooser_dialog_new, pl_psu);
  s7_define_typed_function(sc, "gdk_event_get_button", lg_gdk_event_get_button, 2, 0, 0, H_gdk_event_get_button, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_click_count", lg_gdk_event_get_click_count, 2, 0, 0, H_gdk_event_get_click_count, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_keyval", lg_gdk_event_get_keyval, 2, 0, 0, H_gdk_event_get_keyval, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_keycode", lg_gdk_event_get_keycode, 2, 0, 0, H_gdk_event_get_keycode, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_scroll_direction", lg_gdk_event_get_scroll_direction, 1, 1, 0, H_gdk_event_get_scroll_direction, pl_pu);
  s7_define_typed_function(sc, "gtk_grid_get_child_at", lg_gtk_grid_get_child_at, 3, 0, 0, H_gtk_grid_get_child_at, pl_pui);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_family", lg_gtk_font_chooser_get_font_family, 1, 0, 0, H_gtk_font_chooser_get_font_family, pl_pu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_face", lg_gtk_font_chooser_get_font_face, 1, 0, 0, H_gtk_font_chooser_get_font_face, pl_pu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_size", lg_gtk_font_chooser_get_font_size, 1, 0, 0, H_gtk_font_chooser_get_font_size, pl_iu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_desc", lg_gtk_font_chooser_get_font_desc, 1, 0, 0, H_gtk_font_chooser_get_font_desc, pl_pu);
  s7_define_typed_function(sc, "gtk_font_chooser_set_font_desc", lg_gtk_font_chooser_set_font_desc, 2, 0, 0, H_gtk_font_chooser_set_font_desc, pl_tu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font", lg_gtk_font_chooser_get_font, 1, 0, 0, H_gtk_font_chooser_get_font, pl_su);
  s7_define_typed_function(sc, "gtk_font_chooser_set_font", lg_gtk_font_chooser_set_font, 2, 0, 0, H_gtk_font_chooser_set_font, pl_tus);
  s7_define_typed_function(sc, "gtk_font_chooser_get_preview_text", lg_gtk_font_chooser_get_preview_text, 1, 0, 0, H_gtk_font_chooser_get_preview_text, pl_su);
  s7_define_typed_function(sc, "gtk_font_chooser_set_preview_text", lg_gtk_font_chooser_set_preview_text, 2, 0, 0, H_gtk_font_chooser_set_preview_text, pl_tus);
  s7_define_typed_function(sc, "gtk_font_chooser_get_show_preview_entry", lg_gtk_font_chooser_get_show_preview_entry, 1, 0, 0, H_gtk_font_chooser_get_show_preview_entry, pl_bu);
  s7_define_typed_function(sc, "gtk_font_chooser_set_show_preview_entry", lg_gtk_font_chooser_set_show_preview_entry, 2, 0, 0, H_gtk_font_chooser_set_show_preview_entry, pl_tub);
  s7_define_typed_function(sc, "gtk_font_chooser_widget_new", lg_gtk_font_chooser_widget_new, 0, 0, 0, H_gtk_font_chooser_widget_new, pl_p);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define_typed_function(sc, "gtk_accelerator_parse_with_keycode", lg_gtk_accelerator_parse_with_keycode, 4, 0, 0, H_gtk_accelerator_parse_with_keycode, pl_tsu);
  s7_define_typed_function(sc, "gtk_accelerator_name_with_keycode", lg_gtk_accelerator_name_with_keycode, 4, 0, 0, H_gtk_accelerator_name_with_keycode, pl_suiig);
  s7_define_typed_function(sc, "gtk_accelerator_get_label_with_keycode", lg_gtk_accelerator_get_label_with_keycode, 4, 0, 0, H_gtk_accelerator_get_label_with_keycode, pl_suiig);
  s7_define_typed_function(sc, "gtk_application_get_app_menu", lg_gtk_application_get_app_menu, 1, 0, 0, H_gtk_application_get_app_menu, pl_pu);
  s7_define_typed_function(sc, "gtk_application_set_app_menu", lg_gtk_application_set_app_menu, 2, 0, 0, H_gtk_application_set_app_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_application_get_menubar", lg_gtk_application_get_menubar, 1, 0, 0, H_gtk_application_get_menubar, pl_pu);
  s7_define_typed_function(sc, "gtk_application_set_menubar", lg_gtk_application_set_menubar, 2, 0, 0, H_gtk_application_set_menubar, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_completion_compute_prefix", lg_gtk_entry_completion_compute_prefix, 2, 0, 0, H_gtk_entry_completion_compute_prefix, pl_sus);
  s7_define_typed_function(sc, "gtk_scale_set_has_origin", lg_gtk_scale_set_has_origin, 2, 0, 0, H_gtk_scale_set_has_origin, pl_tub);
  s7_define_typed_function(sc, "gtk_scale_get_has_origin", lg_gtk_scale_get_has_origin, 1, 0, 0, H_gtk_scale_get_has_origin, pl_bu);
  s7_define_typed_function(sc, "gtk_application_window_new", lg_gtk_application_window_new, 1, 0, 0, H_gtk_application_window_new, pl_pu);
  s7_define_typed_function(sc, "gtk_application_window_set_show_menubar", lg_gtk_application_window_set_show_menubar, 2, 0, 0, H_gtk_application_window_set_show_menubar, pl_tub);
  s7_define_typed_function(sc, "gtk_application_window_get_show_menubar", lg_gtk_application_window_get_show_menubar, 1, 0, 0, H_gtk_application_window_get_show_menubar, pl_bu);
  s7_define_typed_function(sc, "gtk_image_new_from_resource", lg_gtk_image_new_from_resource, 1, 0, 0, H_gtk_image_new_from_resource, pl_ps);
  s7_define_typed_function(sc, "gtk_image_set_from_resource", lg_gtk_image_set_from_resource, 2, 0, 0, H_gtk_image_set_from_resource, pl_tus);
  s7_define_typed_function(sc, "gtk_about_dialog_add_credit_section", lg_gtk_about_dialog_add_credit_section, 3, 0, 0, H_gtk_about_dialog_add_credit_section, pl_tusu);
  s7_define_typed_function(sc, "gtk_hsv_to_rgb", lg_gtk_hsv_to_rgb, 3, 3, 0, H_gtk_hsv_to_rgb, pl_prrru);
  s7_define_typed_function(sc, "gtk_rgb_to_hsv", lg_gtk_rgb_to_hsv, 3, 3, 0, H_gtk_rgb_to_hsv, pl_prrru);
  s7_define_typed_function(sc, "gtk_color_chooser_get_rgba", lg_gtk_color_chooser_get_rgba, 2, 0, 0, H_gtk_color_chooser_get_rgba, pl_tu);
  s7_define_typed_function(sc, "gtk_color_chooser_set_rgba", lg_gtk_color_chooser_set_rgba, 2, 0, 0, H_gtk_color_chooser_set_rgba, pl_tu);
  s7_define_typed_function(sc, "gtk_color_chooser_get_use_alpha", lg_gtk_color_chooser_get_use_alpha, 1, 0, 0, H_gtk_color_chooser_get_use_alpha, pl_bu);
  s7_define_typed_function(sc, "gtk_color_chooser_set_use_alpha", lg_gtk_color_chooser_set_use_alpha, 2, 0, 0, H_gtk_color_chooser_set_use_alpha, pl_tub);
  s7_define_typed_function(sc, "gtk_color_chooser_dialog_new", lg_gtk_color_chooser_dialog_new, 2, 0, 0, H_gtk_color_chooser_dialog_new, pl_psu);
  s7_define_typed_function(sc, "gtk_color_chooser_widget_new", lg_gtk_color_chooser_widget_new, 0, 0, 0, H_gtk_color_chooser_widget_new, pl_p);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define_typed_function(sc, "gdk_event_get_scroll_deltas", lg_gdk_event_get_scroll_deltas, 1, 2, 0, H_gdk_event_get_scroll_deltas, pl_pu);
  s7_define_typed_function(sc, "gtk_color_chooser_add_palette", lg_gtk_color_chooser_add_palette, 5, 0, 0, H_gtk_color_chooser_add_palette, pl_tugiiu);
  s7_define_typed_function(sc, "gtk_tree_view_get_n_columns", lg_gtk_tree_view_get_n_columns, 1, 0, 0, H_gtk_tree_view_get_n_columns, pl_iu);
  s7_define_typed_function(sc, "gtk_menu_button_new", lg_gtk_menu_button_new, 0, 0, 0, H_gtk_menu_button_new, pl_p);
  s7_define_typed_function(sc, "gtk_menu_button_set_menu_model", lg_gtk_menu_button_set_menu_model, 2, 0, 0, H_gtk_menu_button_set_menu_model, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_get_menu_model", lg_gtk_menu_button_get_menu_model, 1, 0, 0, H_gtk_menu_button_get_menu_model, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_button_set_align_widget", lg_gtk_menu_button_set_align_widget, 2, 0, 0, H_gtk_menu_button_set_align_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_get_align_widget", lg_gtk_menu_button_get_align_widget, 1, 0, 0, H_gtk_menu_button_get_align_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_search_entry_new", lg_gtk_search_entry_new, 0, 0, 0, H_gtk_search_entry_new, pl_p);
  s7_define_typed_function(sc, "gtk_level_bar_new", lg_gtk_level_bar_new, 0, 0, 0, H_gtk_level_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_level_bar_new_for_interval", lg_gtk_level_bar_new_for_interval, 2, 0, 0, H_gtk_level_bar_new_for_interval, pl_pr);
  s7_define_typed_function(sc, "gtk_level_bar_set_mode", lg_gtk_level_bar_set_mode, 2, 0, 0, H_gtk_level_bar_set_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_level_bar_get_mode", lg_gtk_level_bar_get_mode, 1, 0, 0, H_gtk_level_bar_get_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_level_bar_set_value", lg_gtk_level_bar_set_value, 2, 0, 0, H_gtk_level_bar_set_value, pl_tur);
  s7_define_typed_function(sc, "gtk_level_bar_get_value", lg_gtk_level_bar_get_value, 1, 0, 0, H_gtk_level_bar_get_value, pl_du);
  s7_define_typed_function(sc, "gtk_level_bar_set_min_value", lg_gtk_level_bar_set_min_value, 2, 0, 0, H_gtk_level_bar_set_min_value, pl_tur);
  s7_define_typed_function(sc, "gtk_level_bar_get_min_value", lg_gtk_level_bar_get_min_value, 1, 0, 0, H_gtk_level_bar_get_min_value, pl_du);
  s7_define_typed_function(sc, "gtk_level_bar_set_max_value", lg_gtk_level_bar_set_max_value, 2, 0, 0, H_gtk_level_bar_set_max_value, pl_tur);
  s7_define_typed_function(sc, "gtk_level_bar_get_max_value", lg_gtk_level_bar_get_max_value, 1, 0, 0, H_gtk_level_bar_get_max_value, pl_du);
  s7_define_typed_function(sc, "gtk_level_bar_add_offset_value", lg_gtk_level_bar_add_offset_value, 3, 0, 0, H_gtk_level_bar_add_offset_value, pl_tusr);
  s7_define_typed_function(sc, "gtk_level_bar_remove_offset_value", lg_gtk_level_bar_remove_offset_value, 2, 0, 0, H_gtk_level_bar_remove_offset_value, pl_tus);
  s7_define_typed_function(sc, "gtk_level_bar_get_offset_value", lg_gtk_level_bar_get_offset_value, 2, 1, 0, H_gtk_level_bar_get_offset_value, pl_pusu);
  s7_define_typed_function(sc, "gtk_application_get_active_window", lg_gtk_application_get_active_window, 1, 0, 0, H_gtk_application_get_active_window, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_input_purpose", lg_gtk_entry_set_input_purpose, 2, 0, 0, H_gtk_entry_set_input_purpose, pl_tug);
  s7_define_typed_function(sc, "gtk_entry_get_input_purpose", lg_gtk_entry_get_input_purpose, 1, 0, 0, H_gtk_entry_get_input_purpose, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_input_hints", lg_gtk_entry_set_input_hints, 2, 0, 0, H_gtk_entry_set_input_hints, pl_tug);
  s7_define_typed_function(sc, "gtk_entry_get_input_hints", lg_gtk_entry_get_input_hints, 1, 0, 0, H_gtk_entry_get_input_hints, pl_gu);
  s7_define_typed_function(sc, "gtk_menu_button_get_popup", lg_gtk_menu_button_get_popup, 1, 0, 0, H_gtk_menu_button_get_popup, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_set_input_purpose", lg_gtk_text_view_set_input_purpose, 2, 0, 0, H_gtk_text_view_set_input_purpose, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_input_purpose", lg_gtk_text_view_get_input_purpose, 1, 0, 0, H_gtk_text_view_get_input_purpose, pl_gu);
  s7_define_typed_function(sc, "gtk_text_view_set_input_hints", lg_gtk_text_view_set_input_hints, 2, 0, 0, H_gtk_text_view_set_input_hints, pl_tug);
  s7_define_typed_function(sc, "gtk_text_view_get_input_hints", lg_gtk_text_view_get_input_hints, 1, 0, 0, H_gtk_text_view_get_input_hints, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_attributes", lg_gtk_entry_set_attributes, 2, 0, 0, H_gtk_entry_set_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_attributes", lg_gtk_entry_get_attributes, 1, 0, 0, H_gtk_entry_get_attributes, pl_pu);
  s7_define_typed_function(sc, "gtk_accel_label_set_accel", lg_gtk_accel_label_set_accel, 3, 0, 0, H_gtk_accel_label_set_accel, pl_tuig);
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
  s7_define_typed_function(sc, "gtk_level_bar_set_inverted", lg_gtk_level_bar_set_inverted, 2, 0, 0, H_gtk_level_bar_set_inverted, pl_tub);
  s7_define_typed_function(sc, "gtk_level_bar_get_inverted", lg_gtk_level_bar_get_inverted, 1, 0, 0, H_gtk_level_bar_get_inverted, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_is_visible", lg_gtk_widget_is_visible, 1, 0, 0, H_gtk_widget_is_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_icon_view_set_activate_on_single_click", lg_gtk_icon_view_set_activate_on_single_click, 2, 0, 0, H_gtk_icon_view_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_view_get_activate_on_single_click", lg_gtk_icon_view_get_activate_on_single_click, 1, 0, 0, H_gtk_icon_view_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_get_activate_on_single_click", lg_gtk_tree_view_get_activate_on_single_click, 1, 0, 0, H_gtk_tree_view_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_view_set_activate_on_single_click", lg_gtk_tree_view_set_activate_on_single_click, 2, 0, 0, H_gtk_tree_view_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_set_opacity", lg_gtk_widget_set_opacity, 2, 0, 0, H_gtk_widget_set_opacity, pl_tur);
  s7_define_typed_function(sc, "gtk_widget_get_opacity", lg_gtk_widget_get_opacity, 1, 0, 0, H_gtk_widget_get_opacity, pl_du);
  s7_define_typed_function(sc, "pango_font_map_changed", lg_pango_font_map_changed, 1, 0, 0, H_pango_font_map_changed, pl_tu);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define_typed_function(sc, "gtk_box_set_baseline_position", lg_gtk_box_set_baseline_position, 2, 0, 0, H_gtk_box_set_baseline_position, pl_tug);
  s7_define_typed_function(sc, "gtk_box_get_baseline_position", lg_gtk_box_get_baseline_position, 1, 0, 0, H_gtk_box_get_baseline_position, pl_gu);
  s7_define_typed_function(sc, "gtk_grid_remove_row", lg_gtk_grid_remove_row, 2, 0, 0, H_gtk_grid_remove_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_remove_column", lg_gtk_grid_remove_column, 2, 0, 0, H_gtk_grid_remove_column, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_set_row_baseline_position", lg_gtk_grid_set_row_baseline_position, 3, 0, 0, H_gtk_grid_set_row_baseline_position, pl_tuig);
  s7_define_typed_function(sc, "gtk_grid_get_row_baseline_position", lg_gtk_grid_get_row_baseline_position, 2, 0, 0, H_gtk_grid_get_row_baseline_position, pl_gui);
  s7_define_typed_function(sc, "gtk_grid_set_baseline_row", lg_gtk_grid_set_baseline_row, 2, 0, 0, H_gtk_grid_set_baseline_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_get_baseline_row", lg_gtk_grid_get_baseline_row, 1, 0, 0, H_gtk_grid_get_baseline_row, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_allocated_baseline", lg_gtk_widget_get_allocated_baseline, 1, 0, 0, H_gtk_widget_get_allocated_baseline, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_init_template", lg_gtk_widget_init_template, 1, 0, 0, H_gtk_widget_init_template, pl_tu);
  s7_define_typed_function(sc, "gtk_window_set_titlebar", lg_gtk_window_set_titlebar, 2, 0, 0, H_gtk_window_set_titlebar, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_switcher_new", lg_gtk_stack_switcher_new, 0, 0, 0, H_gtk_stack_switcher_new, pl_p);
  s7_define_typed_function(sc, "gtk_stack_switcher_set_stack", lg_gtk_stack_switcher_set_stack, 2, 0, 0, H_gtk_stack_switcher_set_stack, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_switcher_get_stack", lg_gtk_stack_switcher_get_stack, 1, 0, 0, H_gtk_stack_switcher_get_stack, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_new", lg_gtk_stack_new, 0, 0, 0, H_gtk_stack_new, pl_p);
  s7_define_typed_function(sc, "gtk_stack_set_visible_child", lg_gtk_stack_set_visible_child, 2, 0, 0, H_gtk_stack_set_visible_child, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_get_visible_child", lg_gtk_stack_get_visible_child, 1, 0, 0, H_gtk_stack_get_visible_child, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_set_visible_child_name", lg_gtk_stack_set_visible_child_name, 2, 0, 0, H_gtk_stack_set_visible_child_name, pl_tus);
  s7_define_typed_function(sc, "gtk_stack_get_visible_child_name", lg_gtk_stack_get_visible_child_name, 1, 0, 0, H_gtk_stack_get_visible_child_name, pl_su);
  s7_define_typed_function(sc, "gtk_stack_set_visible_child_full", lg_gtk_stack_set_visible_child_full, 3, 0, 0, H_gtk_stack_set_visible_child_full, pl_tusg);
  s7_define_typed_function(sc, "gtk_stack_set_homogeneous", lg_gtk_stack_set_homogeneous, 2, 0, 0, H_gtk_stack_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_homogeneous", lg_gtk_stack_get_homogeneous, 1, 0, 0, H_gtk_stack_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_set_transition_duration", lg_gtk_stack_set_transition_duration, 2, 0, 0, H_gtk_stack_set_transition_duration, pl_tui);
  s7_define_typed_function(sc, "gtk_stack_get_transition_duration", lg_gtk_stack_get_transition_duration, 1, 0, 0, H_gtk_stack_get_transition_duration, pl_iu);
  s7_define_typed_function(sc, "gtk_stack_set_transition_type", lg_gtk_stack_set_transition_type, 2, 0, 0, H_gtk_stack_set_transition_type, pl_tug);
  s7_define_typed_function(sc, "gtk_stack_get_transition_type", lg_gtk_stack_get_transition_type, 1, 0, 0, H_gtk_stack_get_transition_type, pl_gu);
  s7_define_typed_function(sc, "gtk_revealer_new", lg_gtk_revealer_new, 0, 0, 0, H_gtk_revealer_new, pl_p);
  s7_define_typed_function(sc, "gtk_revealer_get_reveal_child", lg_gtk_revealer_get_reveal_child, 1, 0, 0, H_gtk_revealer_get_reveal_child, pl_bu);
  s7_define_typed_function(sc, "gtk_revealer_set_reveal_child", lg_gtk_revealer_set_reveal_child, 2, 0, 0, H_gtk_revealer_set_reveal_child, pl_tub);
  s7_define_typed_function(sc, "gtk_revealer_get_child_revealed", lg_gtk_revealer_get_child_revealed, 1, 0, 0, H_gtk_revealer_get_child_revealed, pl_bu);
  s7_define_typed_function(sc, "gtk_revealer_get_transition_duration", lg_gtk_revealer_get_transition_duration, 1, 0, 0, H_gtk_revealer_get_transition_duration, pl_iu);
  s7_define_typed_function(sc, "gtk_revealer_set_transition_duration", lg_gtk_revealer_set_transition_duration, 2, 0, 0, H_gtk_revealer_set_transition_duration, pl_tui);
  s7_define_typed_function(sc, "gtk_revealer_set_transition_type", lg_gtk_revealer_set_transition_type, 2, 0, 0, H_gtk_revealer_set_transition_type, pl_tug);
  s7_define_typed_function(sc, "gtk_revealer_get_transition_type", lg_gtk_revealer_get_transition_type, 1, 0, 0, H_gtk_revealer_get_transition_type, pl_gu);
  s7_define_typed_function(sc, "gtk_header_bar_new", lg_gtk_header_bar_new, 0, 0, 0, H_gtk_header_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_header_bar_set_title", lg_gtk_header_bar_set_title, 2, 0, 0, H_gtk_header_bar_set_title, pl_tus);
  s7_define_typed_function(sc, "gtk_header_bar_get_title", lg_gtk_header_bar_get_title, 1, 0, 0, H_gtk_header_bar_get_title, pl_su);
  s7_define_typed_function(sc, "gtk_header_bar_set_subtitle", lg_gtk_header_bar_set_subtitle, 2, 0, 0, H_gtk_header_bar_set_subtitle, pl_tus);
  s7_define_typed_function(sc, "gtk_header_bar_get_subtitle", lg_gtk_header_bar_get_subtitle, 1, 0, 0, H_gtk_header_bar_get_subtitle, pl_su);
  s7_define_typed_function(sc, "gtk_header_bar_set_custom_title", lg_gtk_header_bar_set_custom_title, 2, 0, 0, H_gtk_header_bar_set_custom_title, pl_tu);
  s7_define_typed_function(sc, "gtk_header_bar_get_custom_title", lg_gtk_header_bar_get_custom_title, 1, 0, 0, H_gtk_header_bar_get_custom_title, pl_pu);
  s7_define_typed_function(sc, "gtk_header_bar_pack_start", lg_gtk_header_bar_pack_start, 2, 0, 0, H_gtk_header_bar_pack_start, pl_tu);
  s7_define_typed_function(sc, "gtk_header_bar_pack_end", lg_gtk_header_bar_pack_end, 2, 0, 0, H_gtk_header_bar_pack_end, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_row_new", lg_gtk_list_box_row_new, 0, 0, 0, H_gtk_list_box_row_new, pl_p);
  s7_define_typed_function(sc, "gtk_list_box_row_get_header", lg_gtk_list_box_row_get_header, 1, 0, 0, H_gtk_list_box_row_get_header, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_row_set_header", lg_gtk_list_box_row_set_header, 2, 0, 0, H_gtk_list_box_row_set_header, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_row_changed", lg_gtk_list_box_row_changed, 1, 0, 0, H_gtk_list_box_row_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_get_selected_row", lg_gtk_list_box_get_selected_row, 1, 0, 0, H_gtk_list_box_get_selected_row, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_get_row_at_index", lg_gtk_list_box_get_row_at_index, 2, 0, 0, H_gtk_list_box_get_row_at_index, pl_pui);
  s7_define_typed_function(sc, "gtk_list_box_get_row_at_y", lg_gtk_list_box_get_row_at_y, 2, 0, 0, H_gtk_list_box_get_row_at_y, pl_pui);
  s7_define_typed_function(sc, "gtk_list_box_select_row", lg_gtk_list_box_select_row, 2, 0, 0, H_gtk_list_box_select_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_set_placeholder", lg_gtk_list_box_set_placeholder, 2, 0, 0, H_gtk_list_box_set_placeholder, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_set_adjustment", lg_gtk_list_box_set_adjustment, 2, 0, 0, H_gtk_list_box_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_get_adjustment", lg_gtk_list_box_get_adjustment, 1, 0, 0, H_gtk_list_box_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_set_selection_mode", lg_gtk_list_box_set_selection_mode, 2, 0, 0, H_gtk_list_box_set_selection_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_list_box_get_selection_mode", lg_gtk_list_box_get_selection_mode, 1, 0, 0, H_gtk_list_box_get_selection_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_list_box_invalidate_filter", lg_gtk_list_box_invalidate_filter, 1, 0, 0, H_gtk_list_box_invalidate_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_invalidate_sort", lg_gtk_list_box_invalidate_sort, 1, 0, 0, H_gtk_list_box_invalidate_sort, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_invalidate_headers", lg_gtk_list_box_invalidate_headers, 1, 0, 0, H_gtk_list_box_invalidate_headers, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_set_activate_on_single_click", lg_gtk_list_box_set_activate_on_single_click, 2, 0, 0, H_gtk_list_box_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_get_activate_on_single_click", lg_gtk_list_box_get_activate_on_single_click, 1, 0, 0, H_gtk_list_box_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_list_box_drag_unhighlight_row", lg_gtk_list_box_drag_unhighlight_row, 1, 0, 0, H_gtk_list_box_drag_unhighlight_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_drag_highlight_row", lg_gtk_list_box_drag_highlight_row, 2, 0, 0, H_gtk_list_box_drag_highlight_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_new", lg_gtk_list_box_new, 0, 0, 0, H_gtk_list_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_search_bar_new", lg_gtk_search_bar_new, 0, 0, 0, H_gtk_search_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_search_bar_get_search_mode", lg_gtk_search_bar_get_search_mode, 1, 0, 0, H_gtk_search_bar_get_search_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_search_bar_set_search_mode", lg_gtk_search_bar_set_search_mode, 2, 0, 0, H_gtk_search_bar_set_search_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_current_name", lg_gtk_file_chooser_get_current_name, 1, 0, 0, H_gtk_file_chooser_get_current_name, pl_su);
  s7_define_typed_function(sc, "gtk_list_box_row_get_index", lg_gtk_list_box_row_get_index, 1, 0, 0, H_gtk_list_box_row_get_index, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_scale_factor", lg_gtk_widget_get_scale_factor, 1, 0, 0, H_gtk_widget_get_scale_factor, pl_iu);
  s7_define_typed_function(sc, "gtk_window_close", lg_gtk_window_close, 1, 0, 0, H_gtk_window_close, pl_tu);
  s7_define_typed_function(sc, "gtk_info_bar_set_show_close_button", lg_gtk_info_bar_set_show_close_button, 2, 0, 0, H_gtk_info_bar_set_show_close_button, pl_tub);
  s7_define_typed_function(sc, "gtk_info_bar_get_show_close_button", lg_gtk_info_bar_get_show_close_button, 1, 0, 0, H_gtk_info_bar_get_show_close_button, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_model_rows_reordered_with_length", lg_gtk_tree_model_rows_reordered_with_length, 5, 0, 0, H_gtk_tree_model_rows_reordered_with_length, pl_tuuuui);
  s7_define_typed_function(sc, "gdk_event_get_event_type", lg_gdk_event_get_event_type, 1, 0, 0, H_gdk_event_get_event_type, pl_gu);
  s7_define_typed_function(sc, "gtk_entry_set_tabs", lg_gtk_entry_set_tabs, 2, 0, 0, H_gtk_entry_set_tabs, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_tabs", lg_gtk_entry_get_tabs, 1, 0, 0, H_gtk_entry_get_tabs, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_prepend", lg_gtk_list_box_prepend, 2, 0, 0, H_gtk_list_box_prepend, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_insert", lg_gtk_list_box_insert, 3, 0, 0, H_gtk_list_box_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_label_set_lines", lg_gtk_label_set_lines, 2, 0, 0, H_gtk_label_set_lines, pl_tui);
  s7_define_typed_function(sc, "gtk_label_get_lines", lg_gtk_label_get_lines, 1, 0, 0, H_gtk_label_get_lines, pl_iu);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define_typed_function(sc, "gtk_flow_box_child_new", lg_gtk_flow_box_child_new, 0, 0, 0, H_gtk_flow_box_child_new, pl_p);
  s7_define_typed_function(sc, "gtk_flow_box_child_get_index", lg_gtk_flow_box_child_get_index, 1, 0, 0, H_gtk_flow_box_child_get_index, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_child_is_selected", lg_gtk_flow_box_child_is_selected, 1, 0, 0, H_gtk_flow_box_child_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_child_changed", lg_gtk_flow_box_child_changed, 1, 0, 0, H_gtk_flow_box_child_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_new", lg_gtk_flow_box_new, 0, 0, 0, H_gtk_flow_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_flow_box_set_homogeneous", lg_gtk_flow_box_set_homogeneous, 2, 0, 0, H_gtk_flow_box_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_flow_box_get_homogeneous", lg_gtk_flow_box_get_homogeneous, 1, 0, 0, H_gtk_flow_box_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_set_row_spacing", lg_gtk_flow_box_set_row_spacing, 2, 0, 0, H_gtk_flow_box_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_row_spacing", lg_gtk_flow_box_get_row_spacing, 1, 0, 0, H_gtk_flow_box_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_column_spacing", lg_gtk_flow_box_set_column_spacing, 2, 0, 0, H_gtk_flow_box_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_column_spacing", lg_gtk_flow_box_get_column_spacing, 1, 0, 0, H_gtk_flow_box_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_min_children_per_line", lg_gtk_flow_box_set_min_children_per_line, 2, 0, 0, H_gtk_flow_box_set_min_children_per_line, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_min_children_per_line", lg_gtk_flow_box_get_min_children_per_line, 1, 0, 0, H_gtk_flow_box_get_min_children_per_line, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_max_children_per_line", lg_gtk_flow_box_set_max_children_per_line, 2, 0, 0, H_gtk_flow_box_set_max_children_per_line, pl_tui);
  s7_define_typed_function(sc, "gtk_flow_box_get_max_children_per_line", lg_gtk_flow_box_get_max_children_per_line, 1, 0, 0, H_gtk_flow_box_get_max_children_per_line, pl_iu);
  s7_define_typed_function(sc, "gtk_flow_box_set_activate_on_single_click", lg_gtk_flow_box_set_activate_on_single_click, 2, 0, 0, H_gtk_flow_box_set_activate_on_single_click, pl_tub);
  s7_define_typed_function(sc, "gtk_flow_box_get_activate_on_single_click", lg_gtk_flow_box_get_activate_on_single_click, 1, 0, 0, H_gtk_flow_box_get_activate_on_single_click, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_insert", lg_gtk_flow_box_insert, 3, 0, 0, H_gtk_flow_box_insert, pl_tuui);
  s7_define_typed_function(sc, "gtk_flow_box_get_child_at_index", lg_gtk_flow_box_get_child_at_index, 2, 0, 0, H_gtk_flow_box_get_child_at_index, pl_pui);
  s7_define_typed_function(sc, "gtk_flow_box_get_selected_children", lg_gtk_flow_box_get_selected_children, 1, 0, 0, H_gtk_flow_box_get_selected_children, pl_pu);
  s7_define_typed_function(sc, "gtk_flow_box_select_child", lg_gtk_flow_box_select_child, 2, 0, 0, H_gtk_flow_box_select_child, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_unselect_child", lg_gtk_flow_box_unselect_child, 2, 0, 0, H_gtk_flow_box_unselect_child, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_select_all", lg_gtk_flow_box_select_all, 1, 0, 0, H_gtk_flow_box_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_unselect_all", lg_gtk_flow_box_unselect_all, 1, 0, 0, H_gtk_flow_box_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_set_selection_mode", lg_gtk_flow_box_set_selection_mode, 2, 0, 0, H_gtk_flow_box_set_selection_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_flow_box_get_selection_mode", lg_gtk_flow_box_get_selection_mode, 1, 0, 0, H_gtk_flow_box_get_selection_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_flow_box_set_hadjustment", lg_gtk_flow_box_set_hadjustment, 2, 0, 0, H_gtk_flow_box_set_hadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_set_vadjustment", lg_gtk_flow_box_set_vadjustment, 2, 0, 0, H_gtk_flow_box_set_vadjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_invalidate_filter", lg_gtk_flow_box_invalidate_filter, 1, 0, 0, H_gtk_flow_box_invalidate_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_flow_box_invalidate_sort", lg_gtk_flow_box_invalidate_sort, 1, 0, 0, H_gtk_flow_box_invalidate_sort, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_get_transition_running", lg_gtk_stack_get_transition_running, 1, 0, 0, H_gtk_stack_get_transition_running, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_margin_start", lg_gtk_widget_get_margin_start, 1, 0, 0, H_gtk_widget_get_margin_start, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_start", lg_gtk_widget_set_margin_start, 2, 0, 0, H_gtk_widget_set_margin_start, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_get_margin_end", lg_gtk_widget_get_margin_end, 1, 0, 0, H_gtk_widget_get_margin_end, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_set_margin_end", lg_gtk_widget_set_margin_end, 2, 0, 0, H_gtk_widget_set_margin_end, pl_tui);
  s7_define_typed_function(sc, "gtk_accel_label_get_accel", lg_gtk_accel_label_get_accel, 1, 2, 0, H_gtk_accel_label_get_accel, pl_pu);
  s7_define_typed_function(sc, "gtk_action_bar_new", lg_gtk_action_bar_new, 0, 0, 0, H_gtk_action_bar_new, pl_p);
  s7_define_typed_function(sc, "gtk_action_bar_get_center_widget", lg_gtk_action_bar_get_center_widget, 1, 0, 0, H_gtk_action_bar_get_center_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_action_bar_set_center_widget", lg_gtk_action_bar_set_center_widget, 2, 0, 0, H_gtk_action_bar_set_center_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_action_bar_pack_start", lg_gtk_action_bar_pack_start, 2, 0, 0, H_gtk_action_bar_pack_start, pl_tu);
  s7_define_typed_function(sc, "gtk_action_bar_pack_end", lg_gtk_action_bar_pack_end, 2, 0, 0, H_gtk_action_bar_pack_end, pl_tu);
  s7_define_typed_function(sc, "gtk_header_bar_set_has_subtitle", lg_gtk_header_bar_set_has_subtitle, 2, 0, 0, H_gtk_header_bar_set_has_subtitle, pl_tub);
  s7_define_typed_function(sc, "gtk_header_bar_get_has_subtitle", lg_gtk_header_bar_get_has_subtitle, 1, 0, 0, H_gtk_header_bar_get_has_subtitle, pl_bu);
  s7_define_typed_function(sc, "gtk_header_bar_set_decoration_layout", lg_gtk_header_bar_set_decoration_layout, 2, 0, 0, H_gtk_header_bar_set_decoration_layout, pl_tus);
  s7_define_typed_function(sc, "gtk_header_bar_get_decoration_layout", lg_gtk_header_bar_get_decoration_layout, 1, 0, 0, H_gtk_header_bar_get_decoration_layout, pl_su);
  s7_define_typed_function(sc, "gtk_icon_info_is_symbolic", lg_gtk_icon_info_is_symbolic, 1, 0, 0, H_gtk_icon_info_is_symbolic, pl_bu);
  s7_define_typed_function(sc, "gtk_get_locale_direction", lg_gtk_get_locale_direction, 0, 0, 0, H_gtk_get_locale_direction, pl_g);
  s7_define_typed_function(sc, "gtk_window_is_maximized", lg_gtk_window_is_maximized, 1, 0, 0, H_gtk_window_is_maximized, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define_typed_function(sc, "gtk_list_box_row_is_selected", lg_gtk_list_box_row_is_selected, 1, 0, 0, H_gtk_list_box_row_is_selected, pl_bu);
  s7_define_typed_function(sc, "gtk_list_box_unselect_row", lg_gtk_list_box_unselect_row, 2, 0, 0, H_gtk_list_box_unselect_row, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_select_all", lg_gtk_list_box_select_all, 1, 0, 0, H_gtk_list_box_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_list_box_unselect_all", lg_gtk_list_box_unselect_all, 1, 0, 0, H_gtk_list_box_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_switch_set_state", lg_gtk_switch_set_state, 2, 0, 0, H_gtk_switch_set_state, pl_tub);
  s7_define_typed_function(sc, "gtk_switch_get_state", lg_gtk_switch_get_state, 1, 0, 0, H_gtk_switch_get_state, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_get_device", lg_gtk_gesture_get_device, 1, 0, 0, H_gtk_gesture_get_device, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_set_state", lg_gtk_gesture_set_state, 2, 0, 0, H_gtk_gesture_set_state, pl_bui);
  s7_define_typed_function(sc, "gtk_gesture_get_sequence_state", lg_gtk_gesture_get_sequence_state, 2, 0, 0, H_gtk_gesture_get_sequence_state, pl_iu);
  s7_define_typed_function(sc, "gtk_gesture_set_sequence_state", lg_gtk_gesture_set_sequence_state, 3, 0, 0, H_gtk_gesture_set_sequence_state, pl_buui);
  s7_define_typed_function(sc, "gtk_gesture_get_sequences", lg_gtk_gesture_get_sequences, 1, 0, 0, H_gtk_gesture_get_sequences, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_get_last_updated_sequence", lg_gtk_gesture_get_last_updated_sequence, 1, 0, 0, H_gtk_gesture_get_last_updated_sequence, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_handles_sequence", lg_gtk_gesture_handles_sequence, 2, 0, 0, H_gtk_gesture_handles_sequence, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_get_last_event", lg_gtk_gesture_get_last_event, 2, 0, 0, H_gtk_gesture_get_last_event, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_get_point", lg_gtk_gesture_get_point, 2, 2, 0, H_gtk_gesture_get_point, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_get_bounding_box", lg_gtk_gesture_get_bounding_box, 2, 0, 0, H_gtk_gesture_get_bounding_box, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_get_bounding_box_center", lg_gtk_gesture_get_bounding_box_center, 1, 2, 0, H_gtk_gesture_get_bounding_box_center, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_is_active", lg_gtk_gesture_is_active, 1, 0, 0, H_gtk_gesture_is_active, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_is_recognized", lg_gtk_gesture_is_recognized, 1, 0, 0, H_gtk_gesture_is_recognized, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_group", lg_gtk_gesture_group, 2, 0, 0, H_gtk_gesture_group, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_ungroup", lg_gtk_gesture_ungroup, 1, 0, 0, H_gtk_gesture_ungroup, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_get_group", lg_gtk_gesture_get_group, 1, 0, 0, H_gtk_gesture_get_group, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_is_grouped_with", lg_gtk_gesture_is_grouped_with, 2, 0, 0, H_gtk_gesture_is_grouped_with, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_drag_get_start_point", lg_gtk_gesture_drag_get_start_point, 1, 2, 0, H_gtk_gesture_drag_get_start_point, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_drag_get_offset", lg_gtk_gesture_drag_get_offset, 1, 2, 0, H_gtk_gesture_drag_get_offset, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_pan_get_orientation", lg_gtk_gesture_pan_get_orientation, 1, 0, 0, H_gtk_gesture_pan_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_gesture_pan_set_orientation", lg_gtk_gesture_pan_set_orientation, 2, 0, 0, H_gtk_gesture_pan_set_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_gesture_rotate_get_angle_delta", lg_gtk_gesture_rotate_get_angle_delta, 1, 0, 0, H_gtk_gesture_rotate_get_angle_delta, pl_du);
  s7_define_typed_function(sc, "gtk_gesture_single_get_touch_only", lg_gtk_gesture_single_get_touch_only, 1, 0, 0, H_gtk_gesture_single_get_touch_only, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_single_set_touch_only", lg_gtk_gesture_single_set_touch_only, 2, 0, 0, H_gtk_gesture_single_set_touch_only, pl_tub);
  s7_define_typed_function(sc, "gtk_gesture_single_get_exclusive", lg_gtk_gesture_single_get_exclusive, 1, 0, 0, H_gtk_gesture_single_get_exclusive, pl_bu);
  s7_define_typed_function(sc, "gtk_gesture_single_set_exclusive", lg_gtk_gesture_single_set_exclusive, 2, 0, 0, H_gtk_gesture_single_set_exclusive, pl_tub);
  s7_define_typed_function(sc, "gtk_gesture_single_get_button", lg_gtk_gesture_single_get_button, 1, 0, 0, H_gtk_gesture_single_get_button, pl_iu);
  s7_define_typed_function(sc, "gtk_gesture_single_set_button", lg_gtk_gesture_single_set_button, 2, 0, 0, H_gtk_gesture_single_set_button, pl_tui);
  s7_define_typed_function(sc, "gtk_gesture_single_get_current_button", lg_gtk_gesture_single_get_current_button, 1, 0, 0, H_gtk_gesture_single_get_current_button, pl_iu);
  s7_define_typed_function(sc, "gtk_gesture_single_get_current_sequence", lg_gtk_gesture_single_get_current_sequence, 1, 0, 0, H_gtk_gesture_single_get_current_sequence, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_swipe_get_velocity", lg_gtk_gesture_swipe_get_velocity, 1, 2, 0, H_gtk_gesture_swipe_get_velocity, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_zoom_get_scale_delta", lg_gtk_gesture_zoom_get_scale_delta, 1, 0, 0, H_gtk_gesture_zoom_get_scale_delta, pl_du);
  s7_define_typed_function(sc, "gtk_list_box_row_set_activatable", lg_gtk_list_box_row_set_activatable, 2, 0, 0, H_gtk_list_box_row_set_activatable, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_row_get_activatable", lg_gtk_list_box_row_get_activatable, 1, 0, 0, H_gtk_list_box_row_get_activatable, pl_bu);
  s7_define_typed_function(sc, "gtk_list_box_row_set_selectable", lg_gtk_list_box_row_set_selectable, 2, 0, 0, H_gtk_list_box_row_set_selectable, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_row_get_selectable", lg_gtk_list_box_row_get_selectable, 1, 0, 0, H_gtk_list_box_row_get_selectable, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define_typed_function(sc, "gtk_label_set_xalign", lg_gtk_label_set_xalign, 2, 0, 0, H_gtk_label_set_xalign, pl_tur);
  s7_define_typed_function(sc, "gtk_label_get_xalign", lg_gtk_label_get_xalign, 1, 0, 0, H_gtk_label_get_xalign, pl_du);
  s7_define_typed_function(sc, "gtk_label_set_yalign", lg_gtk_label_set_yalign, 2, 0, 0, H_gtk_label_set_yalign, pl_tur);
  s7_define_typed_function(sc, "gtk_label_get_yalign", lg_gtk_label_get_yalign, 1, 0, 0, H_gtk_label_get_yalign, pl_du);
  s7_define_typed_function(sc, "gtk_paned_set_wide_handle", lg_gtk_paned_set_wide_handle, 2, 0, 0, H_gtk_paned_set_wide_handle, pl_tub);
  s7_define_typed_function(sc, "gtk_paned_get_wide_handle", lg_gtk_paned_get_wide_handle, 1, 0, 0, H_gtk_paned_get_wide_handle, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_overlay_scrolling", lg_gtk_scrolled_window_set_overlay_scrolling, 2, 0, 0, H_gtk_scrolled_window_set_overlay_scrolling, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_overlay_scrolling", lg_gtk_scrolled_window_get_overlay_scrolling, 1, 0, 0, H_gtk_scrolled_window_get_overlay_scrolling, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_set_monospace", lg_gtk_text_view_set_monospace, 2, 0, 0, H_gtk_text_view_set_monospace, pl_tub);
  s7_define_typed_function(sc, "gtk_text_view_get_monospace", lg_gtk_text_view_get_monospace, 1, 0, 0, H_gtk_text_view_get_monospace, pl_bu);
  s7_define_typed_function(sc, "gtk_window_get_titlebar", lg_gtk_window_get_titlebar, 1, 0, 0, H_gtk_window_get_titlebar, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_new", lg_gtk_gl_area_new, 0, 0, 0, H_gtk_gl_area_new, pl_p);
  s7_define_typed_function(sc, "gtk_gl_area_get_has_depth_buffer", lg_gtk_gl_area_get_has_depth_buffer, 1, 0, 0, H_gtk_gl_area_get_has_depth_buffer, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_has_depth_buffer", lg_gtk_gl_area_set_has_depth_buffer, 2, 0, 0, H_gtk_gl_area_set_has_depth_buffer, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_context", lg_gtk_gl_area_get_context, 1, 0, 0, H_gtk_gl_area_get_context, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_make_current", lg_gtk_gl_area_make_current, 1, 0, 0, H_gtk_gl_area_make_current, pl_tu);
  s7_define_typed_function(sc, "gtk_render_check", lg_gtk_render_check, 6, 0, 0, H_gtk_render_check, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_option", lg_gtk_render_option, 6, 0, 0, H_gtk_render_option, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_arrow", lg_gtk_render_arrow, 6, 0, 0, H_gtk_render_arrow, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_background", lg_gtk_render_background, 6, 0, 0, H_gtk_render_background, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_frame", lg_gtk_render_frame, 6, 0, 0, H_gtk_render_frame, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_expander", lg_gtk_render_expander, 6, 0, 0, H_gtk_render_expander, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_focus", lg_gtk_render_focus, 6, 0, 0, H_gtk_render_focus, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_layout", lg_gtk_render_layout, 5, 0, 0, H_gtk_render_layout, pl_tuurru);
  s7_define_typed_function(sc, "gtk_render_line", lg_gtk_render_line, 6, 0, 0, H_gtk_render_line, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_handle", lg_gtk_render_handle, 6, 0, 0, H_gtk_render_handle, pl_tuur);
  s7_define_typed_function(sc, "gtk_render_activity", lg_gtk_render_activity, 6, 0, 0, H_gtk_render_activity, pl_tuur);
  s7_define_typed_function(sc, "gdk_gl_context_make_current", lg_gdk_gl_context_make_current, 1, 0, 0, H_gdk_gl_context_make_current, pl_tu);
  s7_define_typed_function(sc, "gdk_gl_context_get_current", lg_gdk_gl_context_get_current, 0, 0, 0, H_gdk_gl_context_get_current, pl_p);
  s7_define_typed_function(sc, "gdk_gl_context_clear_current", lg_gdk_gl_context_clear_current, 0, 0, 0, H_gdk_gl_context_clear_current, pl_t);
  s7_define_typed_function(sc, "gtk_stack_set_hhomogeneous", lg_gtk_stack_set_hhomogeneous, 2, 0, 0, H_gtk_stack_set_hhomogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_hhomogeneous", lg_gtk_stack_get_hhomogeneous, 1, 0, 0, H_gtk_stack_get_hhomogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_set_vhomogeneous", lg_gtk_stack_set_vhomogeneous, 2, 0, 0, H_gtk_stack_set_vhomogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_vhomogeneous", lg_gtk_stack_get_vhomogeneous, 1, 0, 0, H_gtk_stack_get_vhomogeneous, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_get_display", lg_gdk_gl_context_get_display, 1, 0, 0, H_gdk_gl_context_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_get_has_stencil_buffer", lg_gtk_gl_area_get_has_stencil_buffer, 1, 0, 0, H_gtk_gl_area_get_has_stencil_buffer, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_has_stencil_buffer", lg_gtk_gl_area_set_has_stencil_buffer, 2, 0, 0, H_gtk_gl_area_set_has_stencil_buffer, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_auto_render", lg_gtk_gl_area_get_auto_render, 1, 0, 0, H_gtk_gl_area_get_auto_render, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_auto_render", lg_gtk_gl_area_set_auto_render, 2, 0, 0, H_gtk_gl_area_set_auto_render, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_queue_render", lg_gtk_gl_area_queue_render, 1, 0, 0, H_gtk_gl_area_queue_render, pl_tu);
  s7_define_typed_function(sc, "gtk_gl_area_attach_buffers", lg_gtk_gl_area_attach_buffers, 1, 0, 0, H_gtk_gl_area_attach_buffers, pl_tu);
  s7_define_typed_function(sc, "gtk_gl_area_get_error", lg_gtk_gl_area_get_error, 1, 0, 0, H_gtk_gl_area_get_error, pl_pu);
  s7_define_typed_function(sc, "gtk_scrollable_get_border", lg_gtk_scrollable_get_border, 2, 0, 0, H_gtk_scrollable_get_border, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_markup", lg_gtk_text_buffer_insert_markup, 4, 0, 0, H_gtk_text_buffer_insert_markup, pl_tuusi);
  s7_define_typed_function(sc, "gdk_device_get_vendor_id", lg_gdk_device_get_vendor_id, 1, 0, 0, H_gdk_device_get_vendor_id, pl_su);
  s7_define_typed_function(sc, "gdk_device_get_product_id", lg_gdk_device_get_product_id, 1, 0, 0, H_gdk_device_get_product_id, pl_su);
  s7_define_typed_function(sc, "gdk_gl_context_get_shared_context", lg_gdk_gl_context_get_shared_context, 1, 0, 0, H_gdk_gl_context_get_shared_context, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_set_required_version", lg_gdk_gl_context_set_required_version, 3, 0, 0, H_gdk_gl_context_set_required_version, pl_tui);
  s7_define_typed_function(sc, "gdk_gl_context_get_required_version", lg_gdk_gl_context_get_required_version, 1, 2, 0, H_gdk_gl_context_get_required_version, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_set_debug_enabled", lg_gdk_gl_context_set_debug_enabled, 2, 0, 0, H_gdk_gl_context_set_debug_enabled, pl_tub);
  s7_define_typed_function(sc, "gdk_gl_context_get_debug_enabled", lg_gdk_gl_context_get_debug_enabled, 1, 0, 0, H_gdk_gl_context_get_debug_enabled, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_set_forward_compatible", lg_gdk_gl_context_set_forward_compatible, 2, 0, 0, H_gdk_gl_context_set_forward_compatible, pl_tub);
  s7_define_typed_function(sc, "gdk_gl_context_get_forward_compatible", lg_gdk_gl_context_get_forward_compatible, 1, 0, 0, H_gdk_gl_context_get_forward_compatible, pl_bu);
  s7_define_typed_function(sc, "gdk_gl_context_realize", lg_gdk_gl_context_realize, 1, 1, 0, H_gdk_gl_context_realize, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_context_get_version", lg_gdk_gl_context_get_version, 1, 2, 0, H_gdk_gl_context_get_version, pl_pu);
  s7_define_typed_function(sc, "gtk_gl_area_set_required_version", lg_gtk_gl_area_set_required_version, 3, 0, 0, H_gtk_gl_area_set_required_version, pl_tui);
  s7_define_typed_function(sc, "gtk_gl_area_get_required_version", lg_gtk_gl_area_get_required_version, 1, 2, 0, H_gtk_gl_area_get_required_version, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_detach_tab", lg_gtk_notebook_detach_tab, 2, 0, 0, H_gtk_notebook_detach_tab, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_sidebar_new", lg_gtk_stack_sidebar_new, 0, 0, 0, H_gtk_stack_sidebar_new, pl_p);
  s7_define_typed_function(sc, "gtk_stack_sidebar_set_stack", lg_gtk_stack_sidebar_set_stack, 2, 0, 0, H_gtk_stack_sidebar_set_stack, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_sidebar_get_stack", lg_gtk_stack_sidebar_get_stack, 1, 0, 0, H_gtk_stack_sidebar_get_stack, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
  s7_define_typed_function(sc, "gtk_font_chooser_set_font_map", lg_gtk_font_chooser_set_font_map, 2, 0, 0, H_gtk_font_chooser_set_font_map, pl_tu);
  s7_define_typed_function(sc, "gtk_font_chooser_get_font_map", lg_gtk_font_chooser_get_font_map, 1, 0, 0, H_gtk_font_chooser_get_font_map, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_set_interpolate_size", lg_gtk_stack_set_interpolate_size, 2, 0, 0, H_gtk_stack_set_interpolate_size, pl_tub);
  s7_define_typed_function(sc, "gtk_stack_get_interpolate_size", lg_gtk_stack_get_interpolate_size, 1, 0, 0, H_gtk_stack_get_interpolate_size, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_font_options", lg_gtk_widget_set_font_options, 2, 0, 0, H_gtk_widget_set_font_options, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_font_options", lg_gtk_widget_get_font_options, 1, 0, 0, H_gtk_widget_get_font_options, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_set_font_map", lg_gtk_widget_set_font_map, 2, 0, 0, H_gtk_widget_set_font_map, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_font_map", lg_gtk_widget_get_font_map, 1, 0, 0, H_gtk_widget_get_font_map, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_set_top_margin", lg_gtk_text_view_set_top_margin, 2, 0, 0, H_gtk_text_view_set_top_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_top_margin", lg_gtk_text_view_get_top_margin, 1, 0, 0, H_gtk_text_view_get_top_margin, pl_iu);
  s7_define_typed_function(sc, "gtk_text_view_set_bottom_margin", lg_gtk_text_view_set_bottom_margin, 2, 0, 0, H_gtk_text_view_set_bottom_margin, pl_tui);
  s7_define_typed_function(sc, "gtk_text_view_get_bottom_margin", lg_gtk_text_view_get_bottom_margin, 1, 0, 0, H_gtk_text_view_get_bottom_margin, pl_iu);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define_typed_function(sc, "gdk_gl_context_is_legacy", lg_gdk_gl_context_is_legacy, 1, 0, 0, H_gdk_gl_context_is_legacy, pl_bu);
  s7_define_typed_function(sc, "gdk_rectangle_equal", lg_gdk_rectangle_equal, 2, 0, 0, H_gdk_rectangle_equal, pl_bu);
  s7_define_typed_function(sc, "gtk_application_window_set_help_overlay", lg_gtk_application_window_set_help_overlay, 2, 0, 0, H_gtk_application_window_set_help_overlay, pl_tu);
  s7_define_typed_function(sc, "gtk_settings_reset_property", lg_gtk_settings_reset_property, 2, 0, 0, H_gtk_settings_reset_property, pl_tus);
  s7_define_typed_function(sc, "gtk_text_tag_changed", lg_gtk_text_tag_changed, 2, 0, 0, H_gtk_text_tag_changed, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_queue_allocate", lg_gtk_widget_queue_allocate, 1, 0, 0, H_gtk_widget_queue_allocate, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_focus_on_click", lg_gtk_widget_set_focus_on_click, 2, 0, 0, H_gtk_widget_set_focus_on_click, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_focus_on_click", lg_gtk_widget_get_focus_on_click, 1, 0, 0, H_gtk_widget_get_focus_on_click, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_starts_tag", lg_gtk_text_iter_starts_tag, 2, 0, 0, H_gtk_text_iter_starts_tag, pl_bu);
  s7_define_typed_function(sc, "gdk_device_get_seat", lg_gdk_device_get_seat, 1, 0, 0, H_gdk_device_get_seat, pl_pu);
  s7_define_typed_function(sc, "gdk_display_get_default_seat", lg_gdk_display_get_default_seat, 1, 0, 0, H_gdk_display_get_default_seat, pl_pu);
  s7_define_typed_function(sc, "gdk_display_list_seats", lg_gdk_display_list_seats, 1, 0, 0, H_gdk_display_list_seats, pl_pu);
  s7_define_typed_function(sc, "gdk_seat_get_display", lg_gdk_seat_get_display, 1, 0, 0, H_gdk_seat_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_seat_get_capabilities", lg_gdk_seat_get_capabilities, 1, 0, 0, H_gdk_seat_get_capabilities, pl_gu);
  s7_define_typed_function(sc, "gdk_seat_get_slaves", lg_gdk_seat_get_slaves, 2, 0, 0, H_gdk_seat_get_slaves, pl_pug);
  s7_define_typed_function(sc, "gdk_seat_get_pointer", lg_gdk_seat_get_pointer, 1, 0, 0, H_gdk_seat_get_pointer, pl_pu);
  s7_define_typed_function(sc, "gdk_seat_get_keyboard", lg_gdk_seat_get_keyboard, 1, 0, 0, H_gdk_seat_get_keyboard, pl_pu);
  s7_define_typed_function(sc, "gdk_event_is_scroll_stop_event", lg_gdk_event_is_scroll_stop_event, 1, 0, 0, H_gdk_event_is_scroll_stop_event, pl_bu);
  s7_define_typed_function(sc, "gtk_text_view_reset_cursor_blink", lg_gtk_text_view_reset_cursor_blink, 1, 0, 0, H_gtk_text_view_reset_cursor_blink, pl_tu);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define_typed_function(sc, "gdk_device_get_axes", lg_gdk_device_get_axes, 1, 0, 0, H_gdk_device_get_axes, pl_gu);
  s7_define_typed_function(sc, "gdk_event_get_device_tool", lg_gdk_event_get_device_tool, 1, 0, 0, H_gdk_event_get_device_tool, pl_pu);
  s7_define_typed_function(sc, "gdk_event_set_device_tool", lg_gdk_event_set_device_tool, 2, 0, 0, H_gdk_event_set_device_tool, pl_tu);
  s7_define_typed_function(sc, "gdk_gl_context_set_use_es", lg_gdk_gl_context_set_use_es, 2, 0, 0, H_gdk_gl_context_set_use_es, pl_tui);
  s7_define_typed_function(sc, "gdk_gl_context_get_use_es", lg_gdk_gl_context_get_use_es, 1, 0, 0, H_gdk_gl_context_get_use_es, pl_bu);
  s7_define_typed_function(sc, "gtk_gl_area_set_use_es", lg_gtk_gl_area_set_use_es, 2, 0, 0, H_gtk_gl_area_set_use_es, pl_tub);
  s7_define_typed_function(sc, "gtk_gl_area_get_use_es", lg_gtk_gl_area_get_use_es, 1, 0, 0, H_gtk_gl_area_get_use_es, pl_bu);
  s7_define_typed_function(sc, "gdk_device_tool_get_serial", lg_gdk_device_tool_get_serial, 1, 0, 0, H_gdk_device_tool_get_serial, pl_iu);
  s7_define_typed_function(sc, "gdk_display_get_n_monitors", lg_gdk_display_get_n_monitors, 1, 0, 0, H_gdk_display_get_n_monitors, pl_iu);
  s7_define_typed_function(sc, "gdk_display_get_monitor", lg_gdk_display_get_monitor, 2, 0, 0, H_gdk_display_get_monitor, pl_pui);
  s7_define_typed_function(sc, "gdk_event_get_pointer_emulated", lg_gdk_event_get_pointer_emulated, 1, 0, 0, H_gdk_event_get_pointer_emulated, pl_bu);
  s7_define_typed_function(sc, "gdk_monitor_get_display", lg_gdk_monitor_get_display, 1, 0, 0, H_gdk_monitor_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_monitor_get_geometry", lg_gdk_monitor_get_geometry, 2, 0, 0, H_gdk_monitor_get_geometry, pl_tu);
  s7_define_typed_function(sc, "gdk_monitor_get_workarea", lg_gdk_monitor_get_workarea, 2, 0, 0, H_gdk_monitor_get_workarea, pl_tu);
  s7_define_typed_function(sc, "gdk_monitor_get_width_mm", lg_gdk_monitor_get_width_mm, 1, 0, 0, H_gdk_monitor_get_width_mm, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_height_mm", lg_gdk_monitor_get_height_mm, 1, 0, 0, H_gdk_monitor_get_height_mm, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_manufacturer", lg_gdk_monitor_get_manufacturer, 1, 0, 0, H_gdk_monitor_get_manufacturer, pl_su);
  s7_define_typed_function(sc, "gdk_monitor_get_model", lg_gdk_monitor_get_model, 1, 0, 0, H_gdk_monitor_get_model, pl_su);
  s7_define_typed_function(sc, "gdk_monitor_get_scale_factor", lg_gdk_monitor_get_scale_factor, 1, 0, 0, H_gdk_monitor_get_scale_factor, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_refresh_rate", lg_gdk_monitor_get_refresh_rate, 1, 0, 0, H_gdk_monitor_get_refresh_rate, pl_iu);
  s7_define_typed_function(sc, "gdk_monitor_get_subpixel_layout", lg_gdk_monitor_get_subpixel_layout, 1, 0, 0, H_gdk_monitor_get_subpixel_layout, pl_gu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_max_content_width", lg_gtk_scrolled_window_set_max_content_width, 2, 0, 0, H_gtk_scrolled_window_set_max_content_width, pl_tui);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_max_content_width", lg_gtk_scrolled_window_get_max_content_width, 1, 0, 0, H_gtk_scrolled_window_get_max_content_width, pl_iu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_max_content_height", lg_gtk_scrolled_window_set_max_content_height, 2, 0, 0, H_gtk_scrolled_window_set_max_content_height, pl_tui);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_max_content_height", lg_gtk_scrolled_window_get_max_content_height, 1, 0, 0, H_gtk_scrolled_window_get_max_content_height, pl_iu);
  s7_define_typed_function(sc, "gdk_device_pad_get_n_groups", lg_gdk_device_pad_get_n_groups, 1, 0, 0, H_gdk_device_pad_get_n_groups, pl_iu);
  s7_define_typed_function(sc, "gdk_device_pad_get_group_n_modes", lg_gdk_device_pad_get_group_n_modes, 2, 0, 0, H_gdk_device_pad_get_group_n_modes, pl_iui);
  s7_define_typed_function(sc, "gdk_device_pad_get_n_features", lg_gdk_device_pad_get_n_features, 2, 0, 0, H_gdk_device_pad_get_n_features, pl_iug);
  s7_define_typed_function(sc, "gdk_device_pad_get_feature_group", lg_gdk_device_pad_get_feature_group, 3, 0, 0, H_gdk_device_pad_get_feature_group, pl_iugi);
  s7_define_typed_function(sc, "gtk_menu_popup_at_widget", lg_gtk_menu_popup_at_widget, 5, 0, 0, H_gtk_menu_popup_at_widget, pl_tuuiiu);
  s7_define_typed_function(sc, "gtk_menu_popup_at_pointer", lg_gtk_menu_popup_at_pointer, 2, 0, 0, H_gtk_menu_popup_at_pointer, pl_tu);
  s7_define_typed_function(sc, "gtk_pad_controller_set_action_entries", lg_gtk_pad_controller_set_action_entries, 3, 0, 0, H_gtk_pad_controller_set_action_entries, pl_tuui);
  s7_define_typed_function(sc, "gtk_pad_controller_set_action", lg_gtk_pad_controller_set_action, 6, 0, 0, H_gtk_pad_controller_set_action, pl_tugiis);
  s7_define_typed_function(sc, "gtk_shortcut_label_new", lg_gtk_shortcut_label_new, 1, 0, 0, H_gtk_shortcut_label_new, pl_ps);
  s7_define_typed_function(sc, "gtk_shortcut_label_get_accelerator", lg_gtk_shortcut_label_get_accelerator, 1, 0, 0, H_gtk_shortcut_label_get_accelerator, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_label_set_accelerator", lg_gtk_shortcut_label_set_accelerator, 2, 0, 0, H_gtk_shortcut_label_set_accelerator, pl_tus);
  s7_define_typed_function(sc, "gtk_shortcut_label_get_disabled_text", lg_gtk_shortcut_label_get_disabled_text, 1, 0, 0, H_gtk_shortcut_label_get_disabled_text, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_label_set_disabled_text", lg_gtk_shortcut_label_set_disabled_text, 2, 0, 0, H_gtk_shortcut_label_set_disabled_text, pl_tus);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_propagate_natural_width", lg_gtk_scrolled_window_set_propagate_natural_width, 2, 0, 0, H_gtk_scrolled_window_set_propagate_natural_width, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_propagate_natural_width", lg_gtk_scrolled_window_get_propagate_natural_width, 1, 0, 0, H_gtk_scrolled_window_get_propagate_natural_width, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_propagate_natural_height", lg_gtk_scrolled_window_set_propagate_natural_height, 2, 0, 0, H_gtk_scrolled_window_set_propagate_natural_height, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_propagate_natural_height", lg_gtk_scrolled_window_get_propagate_natural_height, 1, 0, 0, H_gtk_scrolled_window_get_propagate_natural_height, pl_bu);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  s7_define_typed_function(sc, "gdk_display_is_composited", lg_gdk_display_is_composited, 1, 0, 0, H_gdk_display_is_composited, pl_bu);
  s7_define_typed_function(sc, "gdk_display_is_rgba", lg_gdk_display_is_rgba, 1, 0, 0, H_gdk_display_is_rgba, pl_bu);
  s7_define_typed_function(sc, "gtk_button_set_icon_name", lg_gtk_button_set_icon_name, 2, 0, 0, H_gtk_button_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_button_get_icon_name", lg_gtk_button_get_icon_name, 1, 0, 0, H_gtk_button_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_drawing_area_set_content_width", lg_gtk_drawing_area_set_content_width, 2, 0, 0, H_gtk_drawing_area_set_content_width, pl_tui);
  s7_define_typed_function(sc, "gtk_drawing_area_get_content_width", lg_gtk_drawing_area_get_content_width, 1, 0, 0, H_gtk_drawing_area_get_content_width, pl_iu);
  s7_define_typed_function(sc, "gtk_drawing_area_set_content_height", lg_gtk_drawing_area_set_content_height, 2, 0, 0, H_gtk_drawing_area_set_content_height, pl_tui);
  s7_define_typed_function(sc, "gtk_drawing_area_get_content_height", lg_gtk_drawing_area_get_content_height, 1, 0, 0, H_gtk_drawing_area_get_content_height, pl_iu);
  s7_define_typed_function(sc, "gtk_drawing_area_set_draw_func", lg_gtk_drawing_area_set_draw_func, 4, 0, 0, H_gtk_drawing_area_set_draw_func, pl_tut);
  s7_define_typed_function(sc, "gdk_rgba_is_clear", lg_gdk_rgba_is_clear, 1, 0, 0, H_gdk_rgba_is_clear, pl_bu);
  s7_define_typed_function(sc, "gdk_rgba_is_opaque", lg_gdk_rgba_is_opaque, 1, 0, 0, H_gdk_rgba_is_opaque, pl_bu);
  s7_define_typed_function(sc, "gtk_flow_box_get_child_at_pos", lg_gtk_flow_box_get_child_at_pos, 3, 0, 0, H_gtk_flow_box_get_child_at_pos, pl_pui);
  s7_define_typed_function(sc, "gtk_about_dialog_get_system_information", lg_gtk_about_dialog_get_system_information, 1, 0, 0, H_gtk_about_dialog_get_system_information, pl_su);
  s7_define_typed_function(sc, "gtk_about_dialog_set_system_information", lg_gtk_about_dialog_set_system_information, 2, 0, 0, H_gtk_about_dialog_set_system_information, pl_tus);
  s7_define_typed_function(sc, "gtk_action_bar_set_revealed", lg_gtk_action_bar_set_revealed, 2, 0, 0, H_gtk_action_bar_set_revealed, pl_tub);
  s7_define_typed_function(sc, "gtk_action_bar_get_revealed", lg_gtk_action_bar_get_revealed, 1, 0, 0, H_gtk_action_bar_get_revealed, pl_bu);
  s7_define_typed_function(sc, "gtk_check_button_set_draw_indicator", lg_gtk_check_button_set_draw_indicator, 2, 0, 0, H_gtk_check_button_set_draw_indicator, pl_tub);
  s7_define_typed_function(sc, "gtk_check_button_get_draw_indicator", lg_gtk_check_button_get_draw_indicator, 1, 0, 0, H_gtk_check_button_get_draw_indicator, pl_bu);
  s7_define_typed_function(sc, "gtk_check_button_set_inconsistent", lg_gtk_check_button_set_inconsistent, 2, 0, 0, H_gtk_check_button_set_inconsistent, pl_tub);
  s7_define_typed_function(sc, "gtk_check_button_get_inconsistent", lg_gtk_check_button_get_inconsistent, 1, 0, 0, H_gtk_check_button_get_inconsistent, pl_bu);
  s7_define_typed_function(sc, "gtk_info_bar_set_revealed", lg_gtk_info_bar_set_revealed, 2, 0, 0, H_gtk_info_bar_set_revealed, pl_tub);
  s7_define_typed_function(sc, "gtk_info_bar_get_revealed", lg_gtk_info_bar_get_revealed, 1, 0, 0, H_gtk_info_bar_get_revealed, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_first_child", lg_gtk_widget_get_first_child, 1, 0, 0, H_gtk_widget_get_first_child, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_last_child", lg_gtk_widget_get_last_child, 1, 0, 0, H_gtk_widget_get_last_child, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_next_sibling", lg_gtk_widget_get_next_sibling, 1, 0, 0, H_gtk_widget_get_next_sibling, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_prev_sibling", lg_gtk_widget_get_prev_sibling, 1, 0, 0, H_gtk_widget_get_prev_sibling, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_set_focus_child", lg_gtk_widget_set_focus_child, 2, 0, 0, H_gtk_widget_set_focus_child, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_insert_after", lg_gtk_widget_insert_after, 3, 0, 0, H_gtk_widget_insert_after, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_insert_before", lg_gtk_widget_insert_before, 3, 0, 0, H_gtk_widget_insert_before, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_new", lg_gtk_center_box_new, 0, 0, 0, H_gtk_center_box_new, pl_p);
  s7_define_typed_function(sc, "gtk_center_box_set_start_widget", lg_gtk_center_box_set_start_widget, 2, 0, 0, H_gtk_center_box_set_start_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_set_center_widget", lg_gtk_center_box_set_center_widget, 2, 0, 0, H_gtk_center_box_set_center_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_set_end_widget", lg_gtk_center_box_set_end_widget, 2, 0, 0, H_gtk_center_box_set_end_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_box_get_start_widget", lg_gtk_center_box_get_start_widget, 1, 0, 0, H_gtk_center_box_get_start_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_box_get_center_widget", lg_gtk_center_box_get_center_widget, 1, 0, 0, H_gtk_center_box_get_center_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_box_get_end_widget", lg_gtk_center_box_get_end_widget, 1, 0, 0, H_gtk_center_box_get_end_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_box_set_baseline_position", lg_gtk_center_box_set_baseline_position, 2, 0, 0, H_gtk_center_box_set_baseline_position, pl_tug);
  s7_define_typed_function(sc, "gtk_center_box_get_baseline_position", lg_gtk_center_box_get_baseline_position, 1, 0, 0, H_gtk_center_box_get_baseline_position, pl_gu);
  s7_define_typed_function(sc, "gdk_event_set_coords", lg_gdk_event_set_coords, 3, 0, 0, H_gdk_event_set_coords, pl_tur);
  s7_define_typed_function(sc, "gdk_rectangle_contains_point", lg_gdk_rectangle_contains_point, 3, 0, 0, H_gdk_rectangle_contains_point, pl_bui);
  s7_define_typed_function(sc, "gtk_accel_label_set_label", lg_gtk_accel_label_set_label, 2, 0, 0, H_gtk_accel_label_set_label, pl_tus);
  s7_define_typed_function(sc, "gtk_accel_label_get_label", lg_gtk_accel_label_get_label, 1, 0, 0, H_gtk_accel_label_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_accel_label_set_use_underline", lg_gtk_accel_label_set_use_underline, 2, 0, 0, H_gtk_accel_label_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_accel_label_get_use_underline", lg_gtk_accel_label_get_use_underline, 1, 0, 0, H_gtk_accel_label_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_scrollbar_set_adjustment", lg_gtk_scrollbar_set_adjustment, 2, 0, 0, H_gtk_scrollbar_set_adjustment, pl_tu);
  s7_define_typed_function(sc, "gtk_scrollbar_get_adjustment", lg_gtk_scrollbar_get_adjustment, 1, 0, 0, H_gtk_scrollbar_get_adjustment, pl_pu);
  s7_define_typed_function(sc, "gtk_style_context_new", lg_gtk_style_context_new, 0, 0, 0, H_gtk_style_context_new, pl_p);
  s7_define_typed_function(sc, "gtk_style_context_add_provider", lg_gtk_style_context_add_provider, 3, 0, 0, H_gtk_style_context_add_provider, pl_tuui);
  s7_define_typed_function(sc, "gtk_style_context_save", lg_gtk_style_context_save, 1, 0, 0, H_gtk_style_context_save, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_restore", lg_gtk_style_context_restore, 1, 0, 0, H_gtk_style_context_restore, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_section", lg_gtk_style_context_get_section, 2, 0, 0, H_gtk_style_context_get_section, pl_pus);
  s7_define_typed_function(sc, "gtk_style_context_get_property", lg_gtk_style_context_get_property, 3, 0, 0, H_gtk_style_context_get_property, pl_tusu);
  s7_define_typed_function(sc, "gtk_style_context_set_state", lg_gtk_style_context_set_state, 2, 0, 0, H_gtk_style_context_set_state, pl_tug);
  s7_define_typed_function(sc, "gtk_style_context_get_state", lg_gtk_style_context_get_state, 1, 0, 0, H_gtk_style_context_get_state, pl_gu);
  s7_define_typed_function(sc, "gtk_style_context_set_scale", lg_gtk_style_context_set_scale, 2, 0, 0, H_gtk_style_context_set_scale, pl_tui);
  s7_define_typed_function(sc, "gtk_style_context_get_scale", lg_gtk_style_context_get_scale, 1, 0, 0, H_gtk_style_context_get_scale, pl_iu);
  s7_define_typed_function(sc, "gtk_style_context_set_path", lg_gtk_style_context_set_path, 2, 0, 0, H_gtk_style_context_set_path, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_path", lg_gtk_style_context_get_path, 1, 0, 0, H_gtk_style_context_get_path, pl_pu);
  s7_define_typed_function(sc, "gtk_style_context_set_parent", lg_gtk_style_context_set_parent, 2, 0, 0, H_gtk_style_context_set_parent, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_parent", lg_gtk_style_context_get_parent, 1, 0, 0, H_gtk_style_context_get_parent, pl_pu);
  s7_define_typed_function(sc, "gtk_style_context_list_classes", lg_gtk_style_context_list_classes, 1, 0, 0, H_gtk_style_context_list_classes, pl_pu);
  s7_define_typed_function(sc, "gtk_style_context_add_class", lg_gtk_style_context_add_class, 2, 0, 0, H_gtk_style_context_add_class, pl_tus);
  s7_define_typed_function(sc, "gtk_style_context_remove_class", lg_gtk_style_context_remove_class, 2, 0, 0, H_gtk_style_context_remove_class, pl_tus);
  s7_define_typed_function(sc, "gtk_style_context_has_class", lg_gtk_style_context_has_class, 2, 0, 0, H_gtk_style_context_has_class, pl_bus);
  s7_define_typed_function(sc, "gtk_style_context_lookup_color", lg_gtk_style_context_lookup_color, 3, 0, 0, H_gtk_style_context_lookup_color, pl_busu);
  s7_define_typed_function(sc, "gtk_style_context_get_color", lg_gtk_style_context_get_color, 2, 0, 0, H_gtk_style_context_get_color, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_border", lg_gtk_style_context_get_border, 2, 0, 0, H_gtk_style_context_get_border, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_padding", lg_gtk_style_context_get_padding, 2, 0, 0, H_gtk_style_context_get_padding, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_margin", lg_gtk_style_context_get_margin, 2, 0, 0, H_gtk_style_context_get_margin, pl_tu);
  s7_define_typed_function(sc, "gtk_render_insertion_cursor", lg_gtk_render_insertion_cursor, 7, 0, 0, H_gtk_render_insertion_cursor, pl_tuurruig);
  s7_define_typed_function(sc, "gtk_style_context_to_string", lg_gtk_style_context_to_string, 2, 0, 0, H_gtk_style_context_to_string, pl_sug);
  s7_define_typed_function(sc, "gtk_css_provider_new", lg_gtk_css_provider_new, 0, 0, 0, H_gtk_css_provider_new, pl_p);
  s7_define_typed_function(sc, "gtk_css_provider_to_string", lg_gtk_css_provider_to_string, 1, 0, 0, H_gtk_css_provider_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_css_provider_load_from_data", lg_gtk_css_provider_load_from_data, 3, 0, 0, H_gtk_css_provider_load_from_data, pl_tusi);
  s7_define_typed_function(sc, "gtk_css_provider_load_from_file", lg_gtk_css_provider_load_from_file, 2, 0, 0, H_gtk_css_provider_load_from_file, pl_tu);
  s7_define_typed_function(sc, "gtk_css_provider_load_from_path", lg_gtk_css_provider_load_from_path, 2, 0, 0, H_gtk_css_provider_load_from_path, pl_tus);
  s7_define_typed_function(sc, "gtk_css_provider_load_from_resource", lg_gtk_css_provider_load_from_resource, 2, 0, 0, H_gtk_css_provider_load_from_resource, pl_tus);
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
  s7_define_typed_function(sc, "gtk_gesture_drag_new", lg_gtk_gesture_drag_new, 0, 0, 0, H_gtk_gesture_drag_new, pl_p);
  s7_define_typed_function(sc, "gtk_gesture_long_press_new", lg_gtk_gesture_long_press_new, 0, 0, 0, H_gtk_gesture_long_press_new, pl_p);
  s7_define_typed_function(sc, "gtk_gesture_pan_new", lg_gtk_gesture_pan_new, 1, 0, 0, H_gtk_gesture_pan_new, pl_pg);
  s7_define_typed_function(sc, "gtk_gesture_rotate_new", lg_gtk_gesture_rotate_new, 0, 0, 0, H_gtk_gesture_rotate_new, pl_p);
  s7_define_typed_function(sc, "gtk_gesture_swipe_new", lg_gtk_gesture_swipe_new, 0, 0, 0, H_gtk_gesture_swipe_new, pl_p);
  s7_define_typed_function(sc, "gtk_gesture_zoom_new", lg_gtk_gesture_zoom_new, 0, 0, 0, H_gtk_gesture_zoom_new, pl_p);
  s7_define_typed_function(sc, "gdk_event_set_keyval", lg_gdk_event_set_keyval, 2, 0, 0, H_gdk_event_set_keyval, pl_tui);
  s7_define_typed_function(sc, "gdk_event_get_key_is_modifier", lg_gdk_event_get_key_is_modifier, 1, 1, 0, H_gdk_event_get_key_is_modifier, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_key_group", lg_gdk_event_get_key_group, 1, 1, 0, H_gdk_event_get_key_group, pl_pu);
  s7_define_typed_function(sc, "gdk_event_is_sent", lg_gdk_event_is_sent, 1, 0, 0, H_gdk_event_is_sent, pl_bu);
  s7_define_typed_function(sc, "gdk_event_get_crossing_mode", lg_gdk_event_get_crossing_mode, 1, 1, 0, H_gdk_event_get_crossing_mode, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_crossing_detail", lg_gdk_event_get_crossing_detail, 1, 1, 0, H_gdk_event_get_crossing_detail, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_touchpad_gesture_phase", lg_gdk_event_get_touchpad_gesture_phase, 1, 1, 0, H_gdk_event_get_touchpad_gesture_phase, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_touchpad_gesture_n_fingers", lg_gdk_event_get_touchpad_gesture_n_fingers, 1, 1, 0, H_gdk_event_get_touchpad_gesture_n_fingers, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_touchpad_deltas", lg_gdk_event_get_touchpad_deltas, 1, 2, 0, H_gdk_event_get_touchpad_deltas, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_touchpad_angle_delta", lg_gdk_event_get_touchpad_angle_delta, 1, 1, 0, H_gdk_event_get_touchpad_angle_delta, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_touchpad_scale", lg_gdk_event_get_touchpad_scale, 1, 1, 0, H_gdk_event_get_touchpad_scale, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_touch_emulating_pointer", lg_gdk_event_get_touch_emulating_pointer, 1, 1, 0, H_gdk_event_get_touch_emulating_pointer, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_focus_in", lg_gdk_event_get_focus_in, 1, 1, 0, H_gdk_event_get_focus_in, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_pad_group_mode", lg_gdk_event_get_pad_group_mode, 1, 2, 0, H_gdk_event_get_pad_group_mode, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_pad_button", lg_gdk_event_get_pad_button, 1, 1, 0, H_gdk_event_get_pad_button, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_pad_axis_value", lg_gdk_event_get_pad_axis_value, 1, 2, 0, H_gdk_event_get_pad_axis_value, pl_pu);
  s7_define_typed_function(sc, "gdk_event_get_axes", lg_gdk_event_get_axes, 1, 2, 0, H_gdk_event_get_axes, pl_pu);
  s7_define_typed_function(sc, "gtk_emoji_chooser_new", lg_gtk_emoji_chooser_new, 0, 0, 0, H_gtk_emoji_chooser_new, pl_p);
  s7_define_typed_function(sc, "gtk_event_controller_scroll_new", lg_gtk_event_controller_scroll_new, 1, 0, 0, H_gtk_event_controller_scroll_new, pl_pg);
  s7_define_typed_function(sc, "gtk_event_controller_scroll_set_flags", lg_gtk_event_controller_scroll_set_flags, 2, 0, 0, H_gtk_event_controller_scroll_set_flags, pl_tug);
  s7_define_typed_function(sc, "gtk_event_controller_scroll_get_flags", lg_gtk_event_controller_scroll_get_flags, 1, 0, 0, H_gtk_event_controller_scroll_get_flags, pl_gu);
  s7_define_typed_function(sc, "gdk_app_launch_context_set_desktop", lg_gdk_app_launch_context_set_desktop, 2, 0, 0, H_gdk_app_launch_context_set_desktop, pl_tui);
  s7_define_typed_function(sc, "gdk_app_launch_context_set_timestamp", lg_gdk_app_launch_context_set_timestamp, 2, 0, 0, H_gdk_app_launch_context_set_timestamp, pl_tui);
  s7_define_typed_function(sc, "gdk_app_launch_context_set_icon", lg_gdk_app_launch_context_set_icon, 2, 0, 0, H_gdk_app_launch_context_set_icon, pl_tu);
  s7_define_typed_function(sc, "gdk_app_launch_context_set_icon_name", lg_gdk_app_launch_context_set_icon_name, 2, 0, 0, H_gdk_app_launch_context_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gdk_clipboard_get_display", lg_gdk_clipboard_get_display, 1, 0, 0, H_gdk_clipboard_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_get_formats", lg_gdk_clipboard_get_formats, 1, 0, 0, H_gdk_clipboard_get_formats, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_is_local", lg_gdk_clipboard_is_local, 1, 0, 0, H_gdk_clipboard_is_local, pl_bu);
  s7_define_typed_function(sc, "gdk_clipboard_get_content", lg_gdk_clipboard_get_content, 1, 0, 0, H_gdk_clipboard_get_content, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_store_async", lg_gdk_clipboard_store_async, 5, 0, 0, H_gdk_clipboard_store_async, pl_tuiut);
  s7_define_typed_function(sc, "gdk_clipboard_store_finish", lg_gdk_clipboard_store_finish, 2, 1, 0, H_gdk_clipboard_store_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_read_async", lg_gdk_clipboard_read_async, 6, 0, 0, H_gdk_clipboard_read_async, pl_tuuiut);
  s7_define_typed_function(sc, "gdk_clipboard_read_value_async", lg_gdk_clipboard_read_value_async, 6, 0, 0, H_gdk_clipboard_read_value_async, pl_tuiiut);
  s7_define_typed_function(sc, "gdk_clipboard_read_value_finish", lg_gdk_clipboard_read_value_finish, 2, 1, 0, H_gdk_clipboard_read_value_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_read_texture_async", lg_gdk_clipboard_read_texture_async, 4, 0, 0, H_gdk_clipboard_read_texture_async, pl_tuut);
  s7_define_typed_function(sc, "gdk_clipboard_read_texture_finish", lg_gdk_clipboard_read_texture_finish, 2, 1, 0, H_gdk_clipboard_read_texture_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_read_text_async", lg_gdk_clipboard_read_text_async, 4, 0, 0, H_gdk_clipboard_read_text_async, pl_tuut);
  s7_define_typed_function(sc, "gdk_clipboard_read_text_finish", lg_gdk_clipboard_read_text_finish, 2, 1, 0, H_gdk_clipboard_read_text_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_clipboard_set_content", lg_gdk_clipboard_set_content, 2, 0, 0, H_gdk_clipboard_set_content, pl_bu);
  s7_define_typed_function(sc, "gdk_clipboard_set", lg_gdk_clipboard_set, 2, 0, 0, H_gdk_clipboard_set, pl_tui);
  s7_define_typed_function(sc, "gdk_clipboard_set_value", lg_gdk_clipboard_set_value, 2, 0, 0, H_gdk_clipboard_set_value, pl_tu);
  s7_define_typed_function(sc, "gdk_clipboard_set_text", lg_gdk_clipboard_set_text, 2, 0, 0, H_gdk_clipboard_set_text, pl_tus);
  s7_define_typed_function(sc, "gdk_clipboard_set_texture", lg_gdk_clipboard_set_texture, 2, 0, 0, H_gdk_clipboard_set_texture, pl_tu);
  s7_define_typed_function(sc, "gdk_intern_mime_type", lg_gdk_intern_mime_type, 1, 0, 0, H_gdk_intern_mime_type, pl_s);
  s7_define_typed_function(sc, "gdk_content_formats_new", lg_gdk_content_formats_new, 2, 0, 0, H_gdk_content_formats_new, pl_pui);
  s7_define_typed_function(sc, "gdk_content_formats_new_for_gtype", lg_gdk_content_formats_new_for_gtype, 1, 0, 0, H_gdk_content_formats_new_for_gtype, pl_pi);
  s7_define_typed_function(sc, "gdk_content_formats_ref", lg_gdk_content_formats_ref, 1, 0, 0, H_gdk_content_formats_ref, pl_pu);
  s7_define_typed_function(sc, "gdk_content_formats_unref", lg_gdk_content_formats_unref, 1, 0, 0, H_gdk_content_formats_unref, pl_tu);
  s7_define_typed_function(sc, "gdk_content_formats_print", lg_gdk_content_formats_print, 2, 0, 0, H_gdk_content_formats_print, pl_tu);
  s7_define_typed_function(sc, "gdk_content_formats_to_string", lg_gdk_content_formats_to_string, 1, 0, 0, H_gdk_content_formats_to_string, pl_su);
  s7_define_typed_function(sc, "gdk_content_formats_get_gtypes", lg_gdk_content_formats_get_gtypes, 1, 1, 0, H_gdk_content_formats_get_gtypes, pl_pu);
  s7_define_typed_function(sc, "gdk_content_formats_get_mime_types", lg_gdk_content_formats_get_mime_types, 1, 1, 0, H_gdk_content_formats_get_mime_types, pl_pu);
  s7_define_typed_function(sc, "gdk_content_formats_union", lg_gdk_content_formats_union, 2, 0, 0, H_gdk_content_formats_union, pl_pu);
  s7_define_typed_function(sc, "gdk_content_formats_match", lg_gdk_content_formats_match, 2, 0, 0, H_gdk_content_formats_match, pl_bu);
  s7_define_typed_function(sc, "gdk_content_formats_match_gtype", lg_gdk_content_formats_match_gtype, 2, 0, 0, H_gdk_content_formats_match_gtype, pl_iu);
  s7_define_typed_function(sc, "gdk_content_formats_match_mime_type", lg_gdk_content_formats_match_mime_type, 2, 0, 0, H_gdk_content_formats_match_mime_type, pl_su);
  s7_define_typed_function(sc, "gdk_content_formats_contain_gtype", lg_gdk_content_formats_contain_gtype, 2, 0, 0, H_gdk_content_formats_contain_gtype, pl_bui);
  s7_define_typed_function(sc, "gdk_content_formats_contain_mime_type", lg_gdk_content_formats_contain_mime_type, 2, 0, 0, H_gdk_content_formats_contain_mime_type, pl_bus);
  s7_define_typed_function(sc, "gdk_content_formats_builder_new", lg_gdk_content_formats_builder_new, 0, 0, 0, H_gdk_content_formats_builder_new, pl_p);
  s7_define_typed_function(sc, "gdk_content_formats_builder_add_formats", lg_gdk_content_formats_builder_add_formats, 2, 0, 0, H_gdk_content_formats_builder_add_formats, pl_tu);
  s7_define_typed_function(sc, "gdk_content_formats_builder_add_mime_type", lg_gdk_content_formats_builder_add_mime_type, 2, 0, 0, H_gdk_content_formats_builder_add_mime_type, pl_tus);
  s7_define_typed_function(sc, "gdk_content_formats_builder_add_gtype", lg_gdk_content_formats_builder_add_gtype, 2, 0, 0, H_gdk_content_formats_builder_add_gtype, pl_tui);
  s7_define_typed_function(sc, "gdk_content_provider_ref_formats", lg_gdk_content_provider_ref_formats, 1, 0, 0, H_gdk_content_provider_ref_formats, pl_pu);
  s7_define_typed_function(sc, "gdk_content_provider_ref_storable_formats", lg_gdk_content_provider_ref_storable_formats, 1, 0, 0, H_gdk_content_provider_ref_storable_formats, pl_pu);
  s7_define_typed_function(sc, "gdk_content_provider_content_changed", lg_gdk_content_provider_content_changed, 1, 0, 0, H_gdk_content_provider_content_changed, pl_tu);
  s7_define_typed_function(sc, "gdk_content_provider_write_mime_type_async", lg_gdk_content_provider_write_mime_type_async, 7, 0, 0, H_gdk_content_provider_write_mime_type_async, pl_tusuiut);
  s7_define_typed_function(sc, "gdk_content_provider_write_mime_type_finish", lg_gdk_content_provider_write_mime_type_finish, 2, 1, 0, H_gdk_content_provider_write_mime_type_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_content_provider_get_value", lg_gdk_content_provider_get_value, 2, 1, 0, H_gdk_content_provider_get_value, pl_pu);
  s7_define_typed_function(sc, "gdk_content_serializer_get_mime_type", lg_gdk_content_serializer_get_mime_type, 1, 0, 0, H_gdk_content_serializer_get_mime_type, pl_su);
  s7_define_typed_function(sc, "gdk_content_serializer_get_value", lg_gdk_content_serializer_get_value, 1, 0, 0, H_gdk_content_serializer_get_value, pl_pu);
  s7_define_typed_function(sc, "gdk_content_serializer_get_output_stream", lg_gdk_content_serializer_get_output_stream, 1, 0, 0, H_gdk_content_serializer_get_output_stream, pl_pu);
  s7_define_typed_function(sc, "gdk_content_serializer_get_priority", lg_gdk_content_serializer_get_priority, 1, 0, 0, H_gdk_content_serializer_get_priority, pl_iu);
  s7_define_typed_function(sc, "gdk_content_serializer_get_cancellable", lg_gdk_content_serializer_get_cancellable, 1, 0, 0, H_gdk_content_serializer_get_cancellable, pl_pu);
  s7_define_typed_function(sc, "gdk_content_serializer_get_user_data", lg_gdk_content_serializer_get_user_data, 1, 0, 0, H_gdk_content_serializer_get_user_data, pl_tu);
  s7_define_typed_function(sc, "gdk_content_serializer_get_task_data", lg_gdk_content_serializer_get_task_data, 1, 0, 0, H_gdk_content_serializer_get_task_data, pl_tu);
  s7_define_typed_function(sc, "gdk_content_serializer_return_success", lg_gdk_content_serializer_return_success, 1, 0, 0, H_gdk_content_serializer_return_success, pl_tu);
  s7_define_typed_function(sc, "gdk_content_serializer_return_error", lg_gdk_content_serializer_return_error, 2, 0, 0, H_gdk_content_serializer_return_error, pl_tu);
  s7_define_typed_function(sc, "gdk_content_formats_union_serialize_gtypes", lg_gdk_content_formats_union_serialize_gtypes, 1, 0, 0, H_gdk_content_formats_union_serialize_gtypes, pl_pu);
  s7_define_typed_function(sc, "gdk_content_formats_union_serialize_mime_types", lg_gdk_content_formats_union_serialize_mime_types, 1, 0, 0, H_gdk_content_formats_union_serialize_mime_types, pl_pu);
  s7_define_typed_function(sc, "gdk_content_serialize_finish", lg_gdk_content_serialize_finish, 1, 1, 0, H_gdk_content_serialize_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_mime_type", lg_gdk_content_deserializer_get_mime_type, 1, 0, 0, H_gdk_content_deserializer_get_mime_type, pl_su);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_value", lg_gdk_content_deserializer_get_value, 1, 0, 0, H_gdk_content_deserializer_get_value, pl_pu);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_input_stream", lg_gdk_content_deserializer_get_input_stream, 1, 0, 0, H_gdk_content_deserializer_get_input_stream, pl_pu);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_priority", lg_gdk_content_deserializer_get_priority, 1, 0, 0, H_gdk_content_deserializer_get_priority, pl_iu);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_cancellable", lg_gdk_content_deserializer_get_cancellable, 1, 0, 0, H_gdk_content_deserializer_get_cancellable, pl_pu);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_user_data", lg_gdk_content_deserializer_get_user_data, 1, 0, 0, H_gdk_content_deserializer_get_user_data, pl_tu);
  s7_define_typed_function(sc, "gdk_content_deserializer_get_task_data", lg_gdk_content_deserializer_get_task_data, 1, 0, 0, H_gdk_content_deserializer_get_task_data, pl_tu);
  s7_define_typed_function(sc, "gdk_content_deserializer_return_success", lg_gdk_content_deserializer_return_success, 1, 0, 0, H_gdk_content_deserializer_return_success, pl_tu);
  s7_define_typed_function(sc, "gdk_content_deserializer_return_error", lg_gdk_content_deserializer_return_error, 2, 0, 0, H_gdk_content_deserializer_return_error, pl_tu);
  s7_define_typed_function(sc, "gdk_content_formats_union_deserialize_gtypes", lg_gdk_content_formats_union_deserialize_gtypes, 1, 0, 0, H_gdk_content_formats_union_deserialize_gtypes, pl_pu);
  s7_define_typed_function(sc, "gdk_content_formats_union_deserialize_mime_types", lg_gdk_content_formats_union_deserialize_mime_types, 1, 0, 0, H_gdk_content_formats_union_deserialize_mime_types, pl_pu);
  s7_define_typed_function(sc, "gdk_content_deserialize_finish", lg_gdk_content_deserialize_finish, 2, 1, 0, H_gdk_content_deserialize_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_content_provider_new_for_value", lg_gdk_content_provider_new_for_value, 1, 0, 0, H_gdk_content_provider_new_for_value, pl_pu);
  s7_define_typed_function(sc, "gdk_content_provider_new_for_bytes", lg_gdk_content_provider_new_for_bytes, 2, 0, 0, H_gdk_content_provider_new_for_bytes, pl_psu);
  s7_define_typed_function(sc, "gtk_event_controller_motion_new", lg_gtk_event_controller_motion_new, 0, 0, 0, H_gtk_event_controller_motion_new, pl_p);
  s7_define_typed_function(sc, "gdk_texture_new_for_pixbuf", lg_gdk_texture_new_for_pixbuf, 1, 0, 0, H_gdk_texture_new_for_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gdk_texture_new_from_resource", lg_gdk_texture_new_from_resource, 1, 0, 0, H_gdk_texture_new_from_resource, pl_ps);
  s7_define_typed_function(sc, "gdk_texture_new_from_file", lg_gdk_texture_new_from_file, 1, 1, 0, H_gdk_texture_new_from_file, pl_pu);
  s7_define_typed_function(sc, "gdk_texture_get_width", lg_gdk_texture_get_width, 1, 0, 0, H_gdk_texture_get_width, pl_iu);
  s7_define_typed_function(sc, "gdk_texture_get_height", lg_gdk_texture_get_height, 1, 0, 0, H_gdk_texture_get_height, pl_iu);
  s7_define_typed_function(sc, "gdk_texture_download", lg_gdk_texture_download, 3, 0, 0, H_gdk_texture_download, pl_tusi);
  s7_define_typed_function(sc, "gdk_cursor_new_from_texture", lg_gdk_cursor_new_from_texture, 4, 0, 0, H_gdk_cursor_new_from_texture, pl_puiiu);
  s7_define_typed_function(sc, "gdk_cursor_new_from_name", lg_gdk_cursor_new_from_name, 2, 0, 0, H_gdk_cursor_new_from_name, pl_psu);
  s7_define_typed_function(sc, "gdk_cursor_get_fallback", lg_gdk_cursor_get_fallback, 1, 0, 0, H_gdk_cursor_get_fallback, pl_pu);
  s7_define_typed_function(sc, "gdk_cursor_get_name", lg_gdk_cursor_get_name, 1, 0, 0, H_gdk_cursor_get_name, pl_su);
  s7_define_typed_function(sc, "gdk_cursor_get_texture", lg_gdk_cursor_get_texture, 1, 0, 0, H_gdk_cursor_get_texture, pl_pu);
  s7_define_typed_function(sc, "gdk_cursor_get_hotspot_x", lg_gdk_cursor_get_hotspot_x, 1, 0, 0, H_gdk_cursor_get_hotspot_x, pl_iu);
  s7_define_typed_function(sc, "gdk_cursor_get_hotspot_y", lg_gdk_cursor_get_hotspot_y, 1, 0, 0, H_gdk_cursor_get_hotspot_y, pl_iu);
  s7_define_typed_function(sc, "gdk_display_get_clipboard", lg_gdk_display_get_clipboard, 1, 0, 0, H_gdk_display_get_clipboard, pl_pu);
  s7_define_typed_function(sc, "gdk_display_get_primary_clipboard", lg_gdk_display_get_primary_clipboard, 1, 0, 0, H_gdk_display_get_primary_clipboard, pl_pu);
  s7_define_typed_function(sc, "gdk_monitor_is_valid", lg_gdk_monitor_is_valid, 1, 0, 0, H_gdk_monitor_is_valid, pl_bu);
  s7_define_typed_function(sc, "gdk_seat_get_master_pointers", lg_gdk_seat_get_master_pointers, 2, 0, 0, H_gdk_seat_get_master_pointers, pl_pug);
  s7_define_typed_function(sc, "gtk_header_bar_get_show_title_buttons", lg_gtk_header_bar_get_show_title_buttons, 1, 0, 0, H_gtk_header_bar_get_show_title_buttons, pl_bu);
  s7_define_typed_function(sc, "gtk_header_bar_set_show_title_buttons", lg_gtk_header_bar_set_show_title_buttons, 2, 0, 0, H_gtk_header_bar_set_show_title_buttons, pl_tub);
  s7_define_typed_function(sc, "gtk_icon_info_load_texture", lg_gtk_icon_info_load_texture, 1, 0, 0, H_gtk_icon_info_load_texture, pl_pu);
  s7_define_typed_function(sc, "gtk_image_new_from_icon_name", lg_gtk_image_new_from_icon_name, 1, 0, 0, H_gtk_image_new_from_icon_name, pl_ps);
  s7_define_typed_function(sc, "gtk_image_new_from_gicon", lg_gtk_image_new_from_gicon, 1, 0, 0, H_gtk_image_new_from_gicon, pl_pu);
  s7_define_typed_function(sc, "gtk_image_set_from_icon_name", lg_gtk_image_set_from_icon_name, 2, 0, 0, H_gtk_image_set_from_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_image_set_from_gicon", lg_gtk_image_set_from_gicon, 2, 0, 0, H_gtk_image_set_from_gicon, pl_tu);
  s7_define_typed_function(sc, "gtk_image_set_icon_size", lg_gtk_image_set_icon_size, 2, 0, 0, H_gtk_image_set_icon_size, pl_tug);
  s7_define_typed_function(sc, "gtk_image_get_icon_size", lg_gtk_image_get_icon_size, 1, 0, 0, H_gtk_image_get_icon_size, pl_gu);
  s7_define_typed_function(sc, "gtk_image_get_icon_name", lg_gtk_image_get_icon_name, 1, 0, 0, H_gtk_image_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_image_get_gicon", lg_gtk_image_get_gicon, 1, 0, 0, H_gtk_image_get_gicon, pl_pu);
  s7_define_typed_function(sc, "gtk_render_icon", lg_gtk_render_icon, 5, 0, 0, H_gtk_render_icon, pl_tuuur);
  s7_define_typed_function(sc, "gtk_settings_get_for_display", lg_gtk_settings_get_for_display, 1, 0, 0, H_gtk_settings_get_for_display, pl_pu);
  s7_define_typed_function(sc, "gtk_style_context_add_provider_for_display", lg_gtk_style_context_add_provider_for_display, 3, 0, 0, H_gtk_style_context_add_provider_for_display, pl_tuui);
  s7_define_typed_function(sc, "gtk_style_context_remove_provider_for_display", lg_gtk_style_context_remove_provider_for_display, 2, 0, 0, H_gtk_style_context_remove_provider_for_display, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_set_display", lg_gtk_style_context_set_display, 2, 0, 0, H_gtk_style_context_set_display, pl_tu);
  s7_define_typed_function(sc, "gtk_style_context_get_display", lg_gtk_style_context_get_display, 1, 0, 0, H_gtk_style_context_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_add_selection_clipboard", lg_gtk_text_buffer_add_selection_clipboard, 2, 0, 0, H_gtk_text_buffer_add_selection_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_remove_selection_clipboard", lg_gtk_text_buffer_remove_selection_clipboard, 2, 0, 0, H_gtk_text_buffer_remove_selection_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_cut_clipboard", lg_gtk_text_buffer_cut_clipboard, 3, 0, 0, H_gtk_text_buffer_cut_clipboard, pl_tuub);
  s7_define_typed_function(sc, "gtk_text_buffer_copy_clipboard", lg_gtk_text_buffer_copy_clipboard, 2, 0, 0, H_gtk_text_buffer_copy_clipboard, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_paste_clipboard", lg_gtk_text_buffer_paste_clipboard, 4, 0, 0, H_gtk_text_buffer_paste_clipboard, pl_tuuub);
  s7_define_typed_function(sc, "gtk_tooltip_set_icon", lg_gtk_tooltip_set_icon, 2, 0, 0, H_gtk_tooltip_set_icon, pl_tu);
  s7_define_typed_function(sc, "gtk_tooltip_set_icon_from_icon_name", lg_gtk_tooltip_set_icon_from_icon_name, 2, 0, 0, H_gtk_tooltip_set_icon_from_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_tooltip_set_icon_from_gicon", lg_gtk_tooltip_set_icon_from_gicon, 2, 0, 0, H_gtk_tooltip_set_icon_from_gicon, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_enable_model_drag_source", lg_gtk_tree_view_enable_model_drag_source, 4, 0, 0, H_gtk_tree_view_enable_model_drag_source, pl_tugug);
  s7_define_typed_function(sc, "gtk_widget_get_width", lg_gtk_widget_get_width, 1, 0, 0, H_gtk_widget_get_width, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_height", lg_gtk_widget_get_height, 1, 0, 0, H_gtk_widget_get_height, pl_iu);
  s7_define_typed_function(sc, "gtk_widget_get_clipboard", lg_gtk_widget_get_clipboard, 1, 0, 0, H_gtk_widget_get_clipboard, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_primary_clipboard", lg_gtk_widget_get_primary_clipboard, 1, 0, 0, H_gtk_widget_get_primary_clipboard, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_contains", lg_gtk_widget_contains, 3, 0, 0, H_gtk_widget_contains, pl_bur);
  s7_define_typed_function(sc, "gtk_widget_set_cursor", lg_gtk_widget_set_cursor, 2, 0, 0, H_gtk_widget_set_cursor, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_set_cursor_from_name", lg_gtk_widget_set_cursor_from_name, 2, 0, 0, H_gtk_widget_set_cursor_from_name, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_get_cursor", lg_gtk_widget_get_cursor, 1, 0, 0, H_gtk_widget_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_display", lg_gtk_window_set_display, 2, 0, 0, H_gtk_window_set_display, pl_tu);
  s7_define_typed_function(sc, "gtk_window_fullscreen_on_monitor", lg_gtk_window_fullscreen_on_monitor, 2, 0, 0, H_gtk_window_fullscreen_on_monitor, pl_tu);
  s7_define_typed_function(sc, "gtk_icon_view_enable_model_drag_source", lg_gtk_icon_view_enable_model_drag_source, 4, 0, 0, H_gtk_icon_view_enable_model_drag_source, pl_tugug);
  s7_define_typed_function(sc, "gtk_about_dialog_get_logo", lg_gtk_about_dialog_get_logo, 1, 0, 0, H_gtk_about_dialog_get_logo, pl_pu);
  s7_define_typed_function(sc, "gtk_about_dialog_set_logo", lg_gtk_about_dialog_set_logo, 2, 0, 0, H_gtk_about_dialog_set_logo, pl_tu);
  s7_define_typed_function(sc, "gtk_button_new_from_icon_name", lg_gtk_button_new_from_icon_name, 1, 0, 0, H_gtk_button_new_from_icon_name, pl_ps);
  s7_define_typed_function(sc, "gtk_cell_view_new_with_texture", lg_gtk_cell_view_new_with_texture, 1, 0, 0, H_gtk_cell_view_new_with_texture, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_button_new", lg_gtk_scale_button_new, 4, 0, 0, H_gtk_scale_button_new, pl_prrru);
  s7_define_typed_function(sc, "gtk_application_new", lg_gtk_application_new, 2, 0, 0, H_gtk_application_new, pl_pst);
  s7_define_typed_function(sc, "gtk_application_add_window", lg_gtk_application_add_window, 2, 0, 0, H_gtk_application_add_window, pl_tu);
  s7_define_typed_function(sc, "gtk_application_remove_window", lg_gtk_application_remove_window, 2, 0, 0, H_gtk_application_remove_window, pl_tu);
  s7_define_typed_function(sc, "gtk_application_get_windows", lg_gtk_application_get_windows, 1, 0, 0, H_gtk_application_get_windows, pl_pu);
  s7_define_typed_function(sc, "gtk_application_inhibit", lg_gtk_application_inhibit, 4, 0, 0, H_gtk_application_inhibit, pl_iuugs);
  s7_define_typed_function(sc, "gtk_application_uninhibit", lg_gtk_application_uninhibit, 2, 0, 0, H_gtk_application_uninhibit, pl_tui);
  s7_define_typed_function(sc, "gtk_application_get_window_by_id", lg_gtk_application_get_window_by_id, 2, 0, 0, H_gtk_application_get_window_by_id, pl_pui);
  s7_define_typed_function(sc, "gtk_application_list_action_descriptions", lg_gtk_application_list_action_descriptions, 1, 0, 0, H_gtk_application_list_action_descriptions, pl_pu);
  s7_define_typed_function(sc, "gtk_application_get_actions_for_accel", lg_gtk_application_get_actions_for_accel, 2, 0, 0, H_gtk_application_get_actions_for_accel, pl_pus);
  s7_define_typed_function(sc, "gtk_application_prefers_app_menu", lg_gtk_application_prefers_app_menu, 1, 0, 0, H_gtk_application_prefers_app_menu, pl_bu);
  s7_define_typed_function(sc, "gtk_application_get_menu_by_id", lg_gtk_application_get_menu_by_id, 2, 0, 0, H_gtk_application_get_menu_by_id, pl_pus);
  s7_define_typed_function(sc, "gdk_paintable_new_empty", lg_gdk_paintable_new_empty, 2, 0, 0, H_gdk_paintable_new_empty, pl_pi);
  s7_define_typed_function(sc, "gdk_display_get_default_group", lg_gdk_display_get_default_group, 1, 0, 0, H_gdk_display_get_default_group, pl_pu);
  s7_define_typed_function(sc, "gtk_menu_popup_at_rect", lg_gtk_menu_popup_at_rect, 6, 0, 0, H_gtk_menu_popup_at_rect, pl_tuuuiiu);
  s7_define_typed_function(sc, "gdk_memory_texture_new", lg_gdk_memory_texture_new, 5, 0, 0, H_gdk_memory_texture_new, pl_piigui);
  s7_define_typed_function(sc, "gdk_cairo_context_cairo_create", lg_gdk_cairo_context_cairo_create, 1, 0, 0, H_gdk_cairo_context_cairo_create, pl_pu);
  s7_define_typed_function(sc, "gdk_drop_get_display", lg_gdk_drop_get_display, 1, 0, 0, H_gdk_drop_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_drop_get_device", lg_gdk_drop_get_device, 1, 0, 0, H_gdk_drop_get_device, pl_pu);
  s7_define_typed_function(sc, "gdk_drop_get_surface", lg_gdk_drop_get_surface, 1, 0, 0, H_gdk_drop_get_surface, pl_pu);
  s7_define_typed_function(sc, "gdk_drop_get_formats", lg_gdk_drop_get_formats, 1, 0, 0, H_gdk_drop_get_formats, pl_pu);
  s7_define_typed_function(sc, "gdk_drop_get_actions", lg_gdk_drop_get_actions, 1, 0, 0, H_gdk_drop_get_actions, pl_gu);
  s7_define_typed_function(sc, "gdk_drop_get_drag", lg_gdk_drop_get_drag, 1, 0, 0, H_gdk_drop_get_drag, pl_pu);
  s7_define_typed_function(sc, "gdk_drop_finish", lg_gdk_drop_finish, 2, 0, 0, H_gdk_drop_finish, pl_tug);
  s7_define_typed_function(sc, "gdk_drop_read_value_async", lg_gdk_drop_read_value_async, 6, 0, 0, H_gdk_drop_read_value_async, pl_tuiiut);
  s7_define_typed_function(sc, "gdk_drop_read_value_finish", lg_gdk_drop_read_value_finish, 2, 1, 0, H_gdk_drop_read_value_finish, pl_pu);
  s7_define_typed_function(sc, "gdk_gl_texture_release", lg_gdk_gl_texture_release, 1, 0, 0, H_gdk_gl_texture_release, pl_tu);
  s7_define_typed_function(sc, "gdk_paintable_get_current_image", lg_gdk_paintable_get_current_image, 1, 0, 0, H_gdk_paintable_get_current_image, pl_pu);
  s7_define_typed_function(sc, "gdk_paintable_get_flags", lg_gdk_paintable_get_flags, 1, 0, 0, H_gdk_paintable_get_flags, pl_gu);
  s7_define_typed_function(sc, "gdk_paintable_get_intrinsic_width", lg_gdk_paintable_get_intrinsic_width, 1, 0, 0, H_gdk_paintable_get_intrinsic_width, pl_iu);
  s7_define_typed_function(sc, "gdk_paintable_get_intrinsic_height", lg_gdk_paintable_get_intrinsic_height, 1, 0, 0, H_gdk_paintable_get_intrinsic_height, pl_iu);
  s7_define_typed_function(sc, "gdk_paintable_get_intrinsic_aspect_ratio", lg_gdk_paintable_get_intrinsic_aspect_ratio, 1, 0, 0, H_gdk_paintable_get_intrinsic_aspect_ratio, pl_du);
  s7_define_typed_function(sc, "gdk_paintable_compute_concrete_size", lg_gdk_paintable_compute_concrete_size, 5, 2, 0, H_gdk_paintable_compute_concrete_size, pl_purrrru);
  s7_define_typed_function(sc, "gdk_paintable_invalidate_contents", lg_gdk_paintable_invalidate_contents, 1, 0, 0, H_gdk_paintable_invalidate_contents, pl_tu);
  s7_define_typed_function(sc, "gdk_paintable_invalidate_size", lg_gdk_paintable_invalidate_size, 1, 0, 0, H_gdk_paintable_invalidate_size, pl_tu);
  s7_define_typed_function(sc, "gtk_event_controller_get_widget", lg_gtk_event_controller_get_widget, 1, 0, 0, H_gtk_event_controller_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_event_controller_reset", lg_gtk_event_controller_reset, 1, 0, 0, H_gtk_event_controller_reset, pl_tu);
  s7_define_typed_function(sc, "gtk_event_controller_get_propagation_phase", lg_gtk_event_controller_get_propagation_phase, 1, 0, 0, H_gtk_event_controller_get_propagation_phase, pl_gu);
  s7_define_typed_function(sc, "gtk_event_controller_set_propagation_phase", lg_gtk_event_controller_set_propagation_phase, 2, 0, 0, H_gtk_event_controller_set_propagation_phase, pl_tug);
  s7_define_typed_function(sc, "gtk_gesture_stylus_new", lg_gtk_gesture_stylus_new, 0, 0, 0, H_gtk_gesture_stylus_new, pl_p);
  s7_define_typed_function(sc, "gtk_gesture_stylus_get_axis", lg_gtk_gesture_stylus_get_axis, 2, 1, 0, H_gtk_gesture_stylus_get_axis, pl_pugu);
  s7_define_typed_function(sc, "gtk_gesture_stylus_get_backlog", lg_gtk_gesture_stylus_get_backlog, 2, 1, 0, H_gtk_gesture_stylus_get_backlog, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_stylus_get_device_tool", lg_gtk_gesture_stylus_get_device_tool, 1, 0, 0, H_gtk_gesture_stylus_get_device_tool, pl_pu);
  s7_define_typed_function(sc, "gtk_media_controls_new", lg_gtk_media_controls_new, 1, 0, 0, H_gtk_media_controls_new, pl_pu);
  s7_define_typed_function(sc, "gtk_media_controls_get_media_stream", lg_gtk_media_controls_get_media_stream, 1, 0, 0, H_gtk_media_controls_get_media_stream, pl_pu);
  s7_define_typed_function(sc, "gtk_media_controls_set_media_stream", lg_gtk_media_controls_set_media_stream, 2, 0, 0, H_gtk_media_controls_set_media_stream, pl_tu);
  s7_define_typed_function(sc, "gtk_media_file_new", lg_gtk_media_file_new, 0, 0, 0, H_gtk_media_file_new, pl_p);
  s7_define_typed_function(sc, "gtk_media_file_new_for_filename", lg_gtk_media_file_new_for_filename, 1, 0, 0, H_gtk_media_file_new_for_filename, pl_ps);
  s7_define_typed_function(sc, "gtk_media_file_new_for_resource", lg_gtk_media_file_new_for_resource, 1, 0, 0, H_gtk_media_file_new_for_resource, pl_ps);
  s7_define_typed_function(sc, "gtk_media_file_new_for_file", lg_gtk_media_file_new_for_file, 1, 0, 0, H_gtk_media_file_new_for_file, pl_pu);
  s7_define_typed_function(sc, "gtk_media_file_new_for_input_stream", lg_gtk_media_file_new_for_input_stream, 1, 0, 0, H_gtk_media_file_new_for_input_stream, pl_pu);
  s7_define_typed_function(sc, "gtk_media_file_clear", lg_gtk_media_file_clear, 1, 0, 0, H_gtk_media_file_clear, pl_tu);
  s7_define_typed_function(sc, "gtk_media_file_set_filename", lg_gtk_media_file_set_filename, 2, 0, 0, H_gtk_media_file_set_filename, pl_tus);
  s7_define_typed_function(sc, "gtk_media_file_set_resource", lg_gtk_media_file_set_resource, 2, 0, 0, H_gtk_media_file_set_resource, pl_tus);
  s7_define_typed_function(sc, "gtk_media_file_set_file", lg_gtk_media_file_set_file, 2, 0, 0, H_gtk_media_file_set_file, pl_tu);
  s7_define_typed_function(sc, "gtk_media_file_get_file", lg_gtk_media_file_get_file, 1, 0, 0, H_gtk_media_file_get_file, pl_pu);
  s7_define_typed_function(sc, "gtk_media_file_set_input_stream", lg_gtk_media_file_set_input_stream, 2, 0, 0, H_gtk_media_file_set_input_stream, pl_tu);
  s7_define_typed_function(sc, "gtk_media_file_get_input_stream", lg_gtk_media_file_get_input_stream, 1, 0, 0, H_gtk_media_file_get_input_stream, pl_pu);
  s7_define_typed_function(sc, "gtk_media_stream_is_prepared", lg_gtk_media_stream_is_prepared, 1, 0, 0, H_gtk_media_stream_is_prepared, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_get_error", lg_gtk_media_stream_get_error, 1, 0, 0, H_gtk_media_stream_get_error, pl_pu);
  s7_define_typed_function(sc, "gtk_media_stream_has_audio", lg_gtk_media_stream_has_audio, 1, 0, 0, H_gtk_media_stream_has_audio, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_has_video", lg_gtk_media_stream_has_video, 1, 0, 0, H_gtk_media_stream_has_video, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_play", lg_gtk_media_stream_play, 1, 0, 0, H_gtk_media_stream_play, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_pause", lg_gtk_media_stream_pause, 1, 0, 0, H_gtk_media_stream_pause, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_get_playing", lg_gtk_media_stream_get_playing, 1, 0, 0, H_gtk_media_stream_get_playing, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_set_playing", lg_gtk_media_stream_set_playing, 2, 0, 0, H_gtk_media_stream_set_playing, pl_tub);
  s7_define_typed_function(sc, "gtk_media_stream_get_ended", lg_gtk_media_stream_get_ended, 1, 0, 0, H_gtk_media_stream_get_ended, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_get_timestamp", lg_gtk_media_stream_get_timestamp, 1, 0, 0, H_gtk_media_stream_get_timestamp, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_get_duration", lg_gtk_media_stream_get_duration, 1, 0, 0, H_gtk_media_stream_get_duration, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_is_seekable", lg_gtk_media_stream_is_seekable, 1, 0, 0, H_gtk_media_stream_is_seekable, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_is_seeking", lg_gtk_media_stream_is_seeking, 1, 0, 0, H_gtk_media_stream_is_seeking, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_seek", lg_gtk_media_stream_seek, 2, 0, 0, H_gtk_media_stream_seek, pl_tut);
  s7_define_typed_function(sc, "gtk_media_stream_get_loop", lg_gtk_media_stream_get_loop, 1, 0, 0, H_gtk_media_stream_get_loop, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_set_loop", lg_gtk_media_stream_set_loop, 2, 0, 0, H_gtk_media_stream_set_loop, pl_tub);
  s7_define_typed_function(sc, "gtk_media_stream_get_muted", lg_gtk_media_stream_get_muted, 1, 0, 0, H_gtk_media_stream_get_muted, pl_bu);
  s7_define_typed_function(sc, "gtk_media_stream_set_muted", lg_gtk_media_stream_set_muted, 2, 0, 0, H_gtk_media_stream_set_muted, pl_tub);
  s7_define_typed_function(sc, "gtk_media_stream_get_volume", lg_gtk_media_stream_get_volume, 1, 0, 0, H_gtk_media_stream_get_volume, pl_du);
  s7_define_typed_function(sc, "gtk_media_stream_set_volume", lg_gtk_media_stream_set_volume, 2, 0, 0, H_gtk_media_stream_set_volume, pl_tur);
  s7_define_typed_function(sc, "gtk_media_stream_realize", lg_gtk_media_stream_realize, 2, 0, 0, H_gtk_media_stream_realize, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_unrealize", lg_gtk_media_stream_unrealize, 2, 0, 0, H_gtk_media_stream_unrealize, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_prepared", lg_gtk_media_stream_prepared, 5, 0, 0, H_gtk_media_stream_prepared, pl_tubbbt);
  s7_define_typed_function(sc, "gtk_media_stream_unprepared", lg_gtk_media_stream_unprepared, 1, 0, 0, H_gtk_media_stream_unprepared, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_update", lg_gtk_media_stream_update, 2, 0, 0, H_gtk_media_stream_update, pl_tut);
  s7_define_typed_function(sc, "gtk_media_stream_ended", lg_gtk_media_stream_ended, 1, 0, 0, H_gtk_media_stream_ended, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_seek_success", lg_gtk_media_stream_seek_success, 1, 0, 0, H_gtk_media_stream_seek_success, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_seek_failed", lg_gtk_media_stream_seek_failed, 1, 0, 0, H_gtk_media_stream_seek_failed, pl_tu);
  s7_define_typed_function(sc, "gtk_media_stream_gerror", lg_gtk_media_stream_gerror, 2, 0, 0, H_gtk_media_stream_gerror, pl_tu);
  s7_define_typed_function(sc, "gtk_picture_new", lg_gtk_picture_new, 0, 0, 0, H_gtk_picture_new, pl_p);
  s7_define_typed_function(sc, "gtk_picture_new_for_paintable", lg_gtk_picture_new_for_paintable, 1, 0, 0, H_gtk_picture_new_for_paintable, pl_pu);
  s7_define_typed_function(sc, "gtk_picture_new_for_pixbuf", lg_gtk_picture_new_for_pixbuf, 1, 0, 0, H_gtk_picture_new_for_pixbuf, pl_pu);
  s7_define_typed_function(sc, "gtk_picture_new_for_file", lg_gtk_picture_new_for_file, 1, 0, 0, H_gtk_picture_new_for_file, pl_pu);
  s7_define_typed_function(sc, "gtk_picture_new_for_filename", lg_gtk_picture_new_for_filename, 1, 0, 0, H_gtk_picture_new_for_filename, pl_ps);
  s7_define_typed_function(sc, "gtk_picture_new_for_resource", lg_gtk_picture_new_for_resource, 1, 0, 0, H_gtk_picture_new_for_resource, pl_ps);
  s7_define_typed_function(sc, "gtk_picture_set_paintable", lg_gtk_picture_set_paintable, 2, 0, 0, H_gtk_picture_set_paintable, pl_tu);
  s7_define_typed_function(sc, "gtk_picture_get_paintable", lg_gtk_picture_get_paintable, 1, 0, 0, H_gtk_picture_get_paintable, pl_pu);
  s7_define_typed_function(sc, "gtk_picture_set_file", lg_gtk_picture_set_file, 2, 0, 0, H_gtk_picture_set_file, pl_tu);
  s7_define_typed_function(sc, "gtk_picture_get_file", lg_gtk_picture_get_file, 1, 0, 0, H_gtk_picture_get_file, pl_pu);
  s7_define_typed_function(sc, "gtk_picture_set_filename", lg_gtk_picture_set_filename, 2, 0, 0, H_gtk_picture_set_filename, pl_tus);
  s7_define_typed_function(sc, "gtk_picture_set_resource", lg_gtk_picture_set_resource, 2, 0, 0, H_gtk_picture_set_resource, pl_tus);
  s7_define_typed_function(sc, "gtk_picture_set_pixbuf", lg_gtk_picture_set_pixbuf, 2, 0, 0, H_gtk_picture_set_pixbuf, pl_tu);
  s7_define_typed_function(sc, "gtk_picture_set_keep_aspect_ratio", lg_gtk_picture_set_keep_aspect_ratio, 2, 0, 0, H_gtk_picture_set_keep_aspect_ratio, pl_tub);
  s7_define_typed_function(sc, "gtk_picture_get_keep_aspect_ratio", lg_gtk_picture_get_keep_aspect_ratio, 1, 0, 0, H_gtk_picture_get_keep_aspect_ratio, pl_bu);
  s7_define_typed_function(sc, "gtk_picture_set_can_shrink", lg_gtk_picture_set_can_shrink, 2, 0, 0, H_gtk_picture_set_can_shrink, pl_tub);
  s7_define_typed_function(sc, "gtk_picture_get_can_shrink", lg_gtk_picture_get_can_shrink, 1, 0, 0, H_gtk_picture_get_can_shrink, pl_bu);
  s7_define_typed_function(sc, "gtk_picture_set_alternative_text", lg_gtk_picture_set_alternative_text, 2, 0, 0, H_gtk_picture_set_alternative_text, pl_tus);
  s7_define_typed_function(sc, "gtk_picture_get_alternative_text", lg_gtk_picture_get_alternative_text, 1, 0, 0, H_gtk_picture_get_alternative_text, pl_su);
  s7_define_typed_function(sc, "gtk_video_new", lg_gtk_video_new, 0, 0, 0, H_gtk_video_new, pl_p);
  s7_define_typed_function(sc, "gtk_video_new_for_media_stream", lg_gtk_video_new_for_media_stream, 1, 0, 0, H_gtk_video_new_for_media_stream, pl_pu);
  s7_define_typed_function(sc, "gtk_video_new_for_file", lg_gtk_video_new_for_file, 1, 0, 0, H_gtk_video_new_for_file, pl_pu);
  s7_define_typed_function(sc, "gtk_video_new_for_filename", lg_gtk_video_new_for_filename, 1, 0, 0, H_gtk_video_new_for_filename, pl_ps);
  s7_define_typed_function(sc, "gtk_video_new_for_resource", lg_gtk_video_new_for_resource, 1, 0, 0, H_gtk_video_new_for_resource, pl_ps);
  s7_define_typed_function(sc, "gtk_video_get_media_stream", lg_gtk_video_get_media_stream, 1, 0, 0, H_gtk_video_get_media_stream, pl_pu);
  s7_define_typed_function(sc, "gtk_video_set_media_stream", lg_gtk_video_set_media_stream, 2, 0, 0, H_gtk_video_set_media_stream, pl_tu);
  s7_define_typed_function(sc, "gtk_video_get_file", lg_gtk_video_get_file, 1, 0, 0, H_gtk_video_get_file, pl_pu);
  s7_define_typed_function(sc, "gtk_video_set_file", lg_gtk_video_set_file, 2, 0, 0, H_gtk_video_set_file, pl_tu);
  s7_define_typed_function(sc, "gtk_video_set_filename", lg_gtk_video_set_filename, 2, 0, 0, H_gtk_video_set_filename, pl_tus);
  s7_define_typed_function(sc, "gtk_video_set_resource", lg_gtk_video_set_resource, 2, 0, 0, H_gtk_video_set_resource, pl_tus);
  s7_define_typed_function(sc, "gtk_video_get_autoplay", lg_gtk_video_get_autoplay, 1, 0, 0, H_gtk_video_get_autoplay, pl_bu);
  s7_define_typed_function(sc, "gtk_video_set_autoplay", lg_gtk_video_set_autoplay, 2, 0, 0, H_gtk_video_set_autoplay, pl_tub);
  s7_define_typed_function(sc, "gtk_video_get_loop", lg_gtk_video_get_loop, 1, 0, 0, H_gtk_video_get_loop, pl_bu);
  s7_define_typed_function(sc, "gtk_video_set_loop", lg_gtk_video_set_loop, 2, 0, 0, H_gtk_video_set_loop, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_paintable_new", lg_gtk_widget_paintable_new, 1, 0, 0, H_gtk_widget_paintable_new, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_paintable_get_widget", lg_gtk_widget_paintable_get_widget, 1, 0, 0, H_gtk_widget_paintable_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_paintable_set_widget", lg_gtk_widget_paintable_set_widget, 2, 0, 0, H_gtk_widget_paintable_set_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_frame_set_label_align", lg_gtk_frame_set_label_align, 2, 0, 0, H_gtk_frame_set_label_align, pl_tur);
  s7_define_typed_function(sc, "gtk_frame_get_label_align", lg_gtk_frame_get_label_align, 1, 0, 0, H_gtk_frame_get_label_align, pl_du);
  s7_define_typed_function(sc, "gtk_pad_controller_new", lg_gtk_pad_controller_new, 2, 0, 0, H_gtk_pad_controller_new, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_size_allocate", lg_gtk_widget_size_allocate, 3, 0, 0, H_gtk_widget_size_allocate, pl_tuui);
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
  s7_define_typed_function(sc, "gtk_search_bar_connect_entry", lg_gtk_search_bar_connect_entry, 2, 0, 0, H_gtk_search_bar_connect_entry, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_view_get_search_entry", lg_gtk_tree_view_get_search_entry, 1, 0, 0, H_gtk_tree_view_get_search_entry, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_set_search_entry", lg_gtk_tree_view_set_search_entry, 2, 0, 0, H_gtk_tree_view_set_search_entry, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_bar_new_from_model", lg_gtk_menu_bar_new_from_model, 1, 0, 0, H_gtk_menu_bar_new_from_model, pl_pu);
  s7_define_typed_function(sc, "gtk_assistant_get_page", lg_gtk_assistant_get_page, 2, 0, 0, H_gtk_assistant_get_page, pl_pu);
  s7_define_typed_function(sc, "gtk_assistant_page_get_child", lg_gtk_assistant_page_get_child, 1, 0, 0, H_gtk_assistant_page_get_child, pl_pu);
  s7_define_typed_function(sc, "gtk_assistant_get_pages", lg_gtk_assistant_get_pages, 1, 0, 0, H_gtk_assistant_get_pages, pl_pu);
  s7_define_typed_function(sc, "gtk_box_insert_child_after", lg_gtk_box_insert_child_after, 3, 0, 0, H_gtk_box_insert_child_after, pl_tu);
  s7_define_typed_function(sc, "gtk_box_reorder_child_after", lg_gtk_box_reorder_child_after, 3, 0, 0, H_gtk_box_reorder_child_after, pl_tu);
  s7_define_typed_function(sc, "gtk_css_provider_load_named", lg_gtk_css_provider_load_named, 3, 0, 0, H_gtk_css_provider_load_named, pl_tus);
  s7_define_typed_function(sc, "gtk_editable_set_alignment", lg_gtk_editable_set_alignment, 2, 0, 0, H_gtk_editable_set_alignment, pl_tur);
  s7_define_typed_function(sc, "gtk_editable_get_width_chars", lg_gtk_editable_get_width_chars, 1, 0, 0, H_gtk_editable_get_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_editable_set_width_chars", lg_gtk_editable_set_width_chars, 2, 0, 0, H_gtk_editable_set_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_get_max_width_chars", lg_gtk_editable_get_max_width_chars, 1, 0, 0, H_gtk_editable_get_max_width_chars, pl_iu);
  s7_define_typed_function(sc, "gtk_editable_set_max_width_chars", lg_gtk_editable_set_max_width_chars, 2, 0, 0, H_gtk_editable_set_max_width_chars, pl_tui);
  s7_define_typed_function(sc, "gtk_editable_install_properties", lg_gtk_editable_install_properties, 2, 0, 0, H_gtk_editable_install_properties, pl_iui);
  s7_define_typed_function(sc, "gtk_editable_init_delegate", lg_gtk_editable_init_delegate, 1, 0, 0, H_gtk_editable_init_delegate, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_finish_delegate", lg_gtk_editable_finish_delegate, 1, 0, 0, H_gtk_editable_finish_delegate, pl_tu);
  s7_define_typed_function(sc, "gtk_editable_delegate_set_property", lg_gtk_editable_delegate_set_property, 4, 0, 0, H_gtk_editable_delegate_set_property, pl_buiu);
  s7_define_typed_function(sc, "gtk_editable_delegate_get_property", lg_gtk_editable_delegate_get_property, 4, 0, 0, H_gtk_editable_delegate_get_property, pl_buiu);
  s7_define_typed_function(sc, "gtk_fixed_get_child_position", lg_gtk_fixed_get_child_position, 2, 2, 0, H_gtk_fixed_get_child_position, pl_pu);
  s7_define_typed_function(sc, "gtk_fixed_set_child_transform", lg_gtk_fixed_set_child_transform, 3, 0, 0, H_gtk_fixed_set_child_transform, pl_tu);
  s7_define_typed_function(sc, "gtk_fixed_get_child_transform", lg_gtk_fixed_get_child_transform, 2, 0, 0, H_gtk_fixed_get_child_transform, pl_pu);
  s7_define_typed_function(sc, "gtk_grid_query_child", lg_gtk_grid_query_child, 2, 4, 0, H_gtk_grid_query_child, pl_pu);
  s7_define_typed_function(sc, "gtk_list_box_set_show_separators", lg_gtk_list_box_set_show_separators, 2, 0, 0, H_gtk_list_box_set_show_separators, pl_tub);
  s7_define_typed_function(sc, "gtk_list_box_get_show_separators", lg_gtk_list_box_get_show_separators, 1, 0, 0, H_gtk_list_box_get_show_separators, pl_bu);
  s7_define_typed_function(sc, "gtk_notebook_get_page", lg_gtk_notebook_get_page, 2, 0, 0, H_gtk_notebook_get_page, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_page_get_child", lg_gtk_notebook_page_get_child, 1, 0, 0, H_gtk_notebook_page_get_child, pl_pu);
  s7_define_typed_function(sc, "gtk_notebook_get_pages", lg_gtk_notebook_get_pages, 1, 0, 0, H_gtk_notebook_get_pages, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_get_page", lg_gtk_stack_get_page, 2, 0, 0, H_gtk_stack_get_page, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_page_get_child", lg_gtk_stack_page_get_child, 1, 0, 0, H_gtk_stack_page_get_child, pl_pu);
  s7_define_typed_function(sc, "gtk_stack_get_pages", lg_gtk_stack_get_pages, 1, 0, 0, H_gtk_stack_get_pages, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_allocate", lg_gtk_widget_allocate, 5, 0, 0, H_gtk_widget_allocate, pl_tuiiiu);
  s7_define_typed_function(sc, "gtk_widget_set_layout_manager", lg_gtk_widget_set_layout_manager, 2, 0, 0, H_gtk_widget_set_layout_manager, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_get_layout_manager", lg_gtk_widget_get_layout_manager, 1, 0, 0, H_gtk_widget_get_layout_manager, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_class_set_layout_manager_type", lg_gtk_widget_class_set_layout_manager_type, 2, 0, 0, H_gtk_widget_class_set_layout_manager_type, pl_tui);
  s7_define_typed_function(sc, "gtk_widget_set_can_target", lg_gtk_widget_set_can_target, 2, 0, 0, H_gtk_widget_set_can_target, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_get_can_target", lg_gtk_widget_get_can_target, 1, 0, 0, H_gtk_widget_get_can_target, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_root", lg_gtk_widget_get_root, 1, 0, 0, H_gtk_widget_get_root, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_compute_transform", lg_gtk_widget_compute_transform, 3, 0, 0, H_gtk_widget_compute_transform, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_compute_point", lg_gtk_widget_compute_point, 4, 0, 0, H_gtk_widget_compute_point, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_set_overflow", lg_gtk_widget_set_overflow, 2, 0, 0, H_gtk_widget_set_overflow, pl_tug);
  s7_define_typed_function(sc, "gtk_widget_get_overflow", lg_gtk_widget_get_overflow, 1, 0, 0, H_gtk_widget_get_overflow, pl_gu);
  s7_define_typed_function(sc, "gtk_widget_pick", lg_gtk_widget_pick, 4, 0, 0, H_gtk_widget_pick, pl_purrg);
  s7_define_typed_function(sc, "gtk_widget_activate_default", lg_gtk_widget_activate_default, 1, 0, 0, H_gtk_widget_activate_default, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_observe_children", lg_gtk_widget_observe_children, 1, 0, 0, H_gtk_widget_observe_children, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_observe_controllers", lg_gtk_widget_observe_controllers, 1, 0, 0, H_gtk_widget_observe_controllers, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_get_focus_child", lg_gtk_widget_get_focus_child, 1, 0, 0, H_gtk_widget_get_focus_child, pl_pu);
  s7_define_typed_function(sc, "gtk_window_set_default_widget", lg_gtk_window_set_default_widget, 2, 0, 0, H_gtk_window_set_default_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_window_get_toplevels", lg_gtk_window_get_toplevels, 0, 0, 0, H_gtk_window_get_toplevels, pl_p);
  s7_define_typed_function(sc, "gdk_drag_get_display", lg_gdk_drag_get_display, 1, 0, 0, H_gdk_drag_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_get_device", lg_gdk_drag_get_device, 1, 0, 0, H_gdk_drag_get_device, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_get_formats", lg_gdk_drag_get_formats, 1, 0, 0, H_gdk_drag_get_formats, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_get_actions", lg_gdk_drag_get_actions, 1, 0, 0, H_gdk_drag_get_actions, pl_gu);
  s7_define_typed_function(sc, "gdk_drag_get_selected_action", lg_gdk_drag_get_selected_action, 1, 0, 0, H_gdk_drag_get_selected_action, pl_gu);
  s7_define_typed_function(sc, "gdk_drag_action_is_unique", lg_gdk_drag_action_is_unique, 1, 0, 0, H_gdk_drag_action_is_unique, pl_bg);
  s7_define_typed_function(sc, "gdk_drag_begin", lg_gdk_drag_begin, 6, 0, 0, H_gdk_drag_begin, pl_puuugi);
  s7_define_typed_function(sc, "gdk_drag_drop_done", lg_gdk_drag_drop_done, 2, 0, 0, H_gdk_drag_drop_done, pl_tub);
  s7_define_typed_function(sc, "gdk_drag_get_drag_surface", lg_gdk_drag_get_drag_surface, 1, 0, 0, H_gdk_drag_get_drag_surface, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_set_hotspot", lg_gdk_drag_set_hotspot, 3, 0, 0, H_gdk_drag_set_hotspot, pl_tui);
  s7_define_typed_function(sc, "gtk_bin_layout_new", lg_gtk_bin_layout_new, 0, 0, 0, H_gtk_bin_layout_new, pl_p);
  s7_define_typed_function(sc, "gtk_box_layout_new", lg_gtk_box_layout_new, 1, 0, 0, H_gtk_box_layout_new, pl_pg);
  s7_define_typed_function(sc, "gtk_box_layout_set_homogeneous", lg_gtk_box_layout_set_homogeneous, 2, 0, 0, H_gtk_box_layout_set_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_box_layout_get_homogeneous", lg_gtk_box_layout_get_homogeneous, 1, 0, 0, H_gtk_box_layout_get_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_box_layout_set_spacing", lg_gtk_box_layout_set_spacing, 2, 0, 0, H_gtk_box_layout_set_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_box_layout_get_spacing", lg_gtk_box_layout_get_spacing, 1, 0, 0, H_gtk_box_layout_get_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_box_layout_set_baseline_position", lg_gtk_box_layout_set_baseline_position, 2, 0, 0, H_gtk_box_layout_set_baseline_position, pl_tug);
  s7_define_typed_function(sc, "gtk_box_layout_get_baseline_position", lg_gtk_box_layout_get_baseline_position, 1, 0, 0, H_gtk_box_layout_get_baseline_position, pl_gu);
  s7_define_typed_function(sc, "gtk_custom_layout_new", lg_gtk_custom_layout_new, 3, 0, 0, H_gtk_custom_layout_new, pl_pt);
  s7_define_typed_function(sc, "gtk_event_controller_legacy_new", lg_gtk_event_controller_legacy_new, 0, 0, 0, H_gtk_event_controller_legacy_new, pl_p);
  s7_define_typed_function(sc, "gtk_filter_list_model_new_for_type", lg_gtk_filter_list_model_new_for_type, 1, 0, 0, H_gtk_filter_list_model_new_for_type, pl_pi);
  s7_define_typed_function(sc, "gtk_filter_list_model_set_model", lg_gtk_filter_list_model_set_model, 2, 0, 0, H_gtk_filter_list_model_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_filter_list_model_get_model", lg_gtk_filter_list_model_get_model, 1, 0, 0, H_gtk_filter_list_model_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_filter_list_model_has_filter", lg_gtk_filter_list_model_has_filter, 1, 0, 0, H_gtk_filter_list_model_has_filter, pl_bu);
  s7_define_typed_function(sc, "gtk_filter_list_model_refilter", lg_gtk_filter_list_model_refilter, 1, 0, 0, H_gtk_filter_list_model_refilter, pl_tu);
  s7_define_typed_function(sc, "gtk_fixed_layout_new", lg_gtk_fixed_layout_new, 0, 0, 0, H_gtk_fixed_layout_new, pl_p);
  s7_define_typed_function(sc, "gtk_flatten_list_model_new", lg_gtk_flatten_list_model_new, 2, 0, 0, H_gtk_flatten_list_model_new, pl_piu);
  s7_define_typed_function(sc, "gtk_flatten_list_model_set_model", lg_gtk_flatten_list_model_set_model, 2, 0, 0, H_gtk_flatten_list_model_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_flatten_list_model_get_model", lg_gtk_flatten_list_model_get_model, 1, 0, 0, H_gtk_flatten_list_model_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_grid_layout_new", lg_gtk_grid_layout_new, 0, 0, 0, H_gtk_grid_layout_new, pl_p);
  s7_define_typed_function(sc, "gtk_grid_layout_set_row_homogeneous", lg_gtk_grid_layout_set_row_homogeneous, 2, 0, 0, H_gtk_grid_layout_set_row_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_grid_layout_get_row_homogeneous", lg_gtk_grid_layout_get_row_homogeneous, 1, 0, 0, H_gtk_grid_layout_get_row_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_grid_layout_set_row_spacing", lg_gtk_grid_layout_set_row_spacing, 2, 0, 0, H_gtk_grid_layout_set_row_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_get_row_spacing", lg_gtk_grid_layout_get_row_spacing, 1, 0, 0, H_gtk_grid_layout_get_row_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_layout_set_column_homogeneous", lg_gtk_grid_layout_set_column_homogeneous, 2, 0, 0, H_gtk_grid_layout_set_column_homogeneous, pl_tub);
  s7_define_typed_function(sc, "gtk_grid_layout_get_column_homogeneous", lg_gtk_grid_layout_get_column_homogeneous, 1, 0, 0, H_gtk_grid_layout_get_column_homogeneous, pl_bu);
  s7_define_typed_function(sc, "gtk_grid_layout_set_column_spacing", lg_gtk_grid_layout_set_column_spacing, 2, 0, 0, H_gtk_grid_layout_set_column_spacing, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_get_column_spacing", lg_gtk_grid_layout_get_column_spacing, 1, 0, 0, H_gtk_grid_layout_get_column_spacing, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_layout_set_row_baseline_position", lg_gtk_grid_layout_set_row_baseline_position, 3, 0, 0, H_gtk_grid_layout_set_row_baseline_position, pl_tuig);
  s7_define_typed_function(sc, "gtk_grid_layout_get_row_baseline_position", lg_gtk_grid_layout_get_row_baseline_position, 2, 0, 0, H_gtk_grid_layout_get_row_baseline_position, pl_gui);
  s7_define_typed_function(sc, "gtk_grid_layout_set_baseline_row", lg_gtk_grid_layout_set_baseline_row, 2, 0, 0, H_gtk_grid_layout_set_baseline_row, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_get_baseline_row", lg_gtk_grid_layout_get_baseline_row, 1, 0, 0, H_gtk_grid_layout_get_baseline_row, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_layout_child_set_top_attach", lg_gtk_grid_layout_child_set_top_attach, 2, 0, 0, H_gtk_grid_layout_child_set_top_attach, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_child_get_top_attach", lg_gtk_grid_layout_child_get_top_attach, 1, 0, 0, H_gtk_grid_layout_child_get_top_attach, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_layout_child_set_left_attach", lg_gtk_grid_layout_child_set_left_attach, 2, 0, 0, H_gtk_grid_layout_child_set_left_attach, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_child_get_left_attach", lg_gtk_grid_layout_child_get_left_attach, 1, 0, 0, H_gtk_grid_layout_child_get_left_attach, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_layout_child_set_column_span", lg_gtk_grid_layout_child_set_column_span, 2, 0, 0, H_gtk_grid_layout_child_set_column_span, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_child_get_column_span", lg_gtk_grid_layout_child_get_column_span, 1, 0, 0, H_gtk_grid_layout_child_get_column_span, pl_iu);
  s7_define_typed_function(sc, "gtk_grid_layout_child_set_row_span", lg_gtk_grid_layout_child_set_row_span, 2, 0, 0, H_gtk_grid_layout_child_set_row_span, pl_tui);
  s7_define_typed_function(sc, "gtk_grid_layout_child_get_row_span", lg_gtk_grid_layout_child_get_row_span, 1, 0, 0, H_gtk_grid_layout_child_get_row_span, pl_iu);
  s7_define_typed_function(sc, "gtk_layout_child_get_layout_manager", lg_gtk_layout_child_get_layout_manager, 1, 0, 0, H_gtk_layout_child_get_layout_manager, pl_pu);
  s7_define_typed_function(sc, "gtk_layout_child_get_child_widget", lg_gtk_layout_child_get_child_widget, 1, 0, 0, H_gtk_layout_child_get_child_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_layout_manager_measure", lg_gtk_layout_manager_measure, 0, 0, 1, H_gtk_layout_manager_measure, pl_tuugiu);
  s7_define_typed_function(sc, "gtk_layout_manager_allocate", lg_gtk_layout_manager_allocate, 5, 0, 0, H_gtk_layout_manager_allocate, pl_tuui);
  s7_define_typed_function(sc, "gtk_layout_manager_get_request_mode", lg_gtk_layout_manager_get_request_mode, 1, 0, 0, H_gtk_layout_manager_get_request_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_layout_manager_get_widget", lg_gtk_layout_manager_get_widget, 1, 0, 0, H_gtk_layout_manager_get_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_layout_manager_layout_changed", lg_gtk_layout_manager_layout_changed, 1, 0, 0, H_gtk_layout_manager_layout_changed, pl_tu);
  s7_define_typed_function(sc, "gtk_layout_manager_get_layout_child", lg_gtk_layout_manager_get_layout_child, 2, 0, 0, H_gtk_layout_manager_get_layout_child, pl_pu);
  s7_define_typed_function(sc, "gtk_map_list_model_set_model", lg_gtk_map_list_model_set_model, 2, 0, 0, H_gtk_map_list_model_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_map_list_model_get_model", lg_gtk_map_list_model_get_model, 1, 0, 0, H_gtk_map_list_model_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_map_list_model_has_map", lg_gtk_map_list_model_has_map, 1, 0, 0, H_gtk_map_list_model_has_map, pl_bu);
  s7_define_typed_function(sc, "gtk_password_entry_new", lg_gtk_password_entry_new, 0, 0, 0, H_gtk_password_entry_new, pl_p);
  s7_define_typed_function(sc, "gtk_password_entry_set_show_peek_icon", lg_gtk_password_entry_set_show_peek_icon, 2, 0, 0, H_gtk_password_entry_set_show_peek_icon, pl_tub);
  s7_define_typed_function(sc, "gtk_password_entry_get_show_peek_icon", lg_gtk_password_entry_get_show_peek_icon, 1, 0, 0, H_gtk_password_entry_get_show_peek_icon, pl_bu);
  s7_define_typed_function(sc, "gtk_root_set_focus", lg_gtk_root_set_focus, 2, 0, 0, H_gtk_root_set_focus, pl_tu);
  s7_define_typed_function(sc, "gtk_root_get_focus", lg_gtk_root_get_focus, 1, 0, 0, H_gtk_root_get_focus, pl_pu);
  s7_define_typed_function(sc, "gtk_selection_model_is_selected", lg_gtk_selection_model_is_selected, 2, 0, 0, H_gtk_selection_model_is_selected, pl_bui);
  s7_define_typed_function(sc, "gtk_selection_model_select_item", lg_gtk_selection_model_select_item, 3, 0, 0, H_gtk_selection_model_select_item, pl_buib);
  s7_define_typed_function(sc, "gtk_selection_model_unselect_item", lg_gtk_selection_model_unselect_item, 2, 0, 0, H_gtk_selection_model_unselect_item, pl_bui);
  s7_define_typed_function(sc, "gtk_selection_model_select_range", lg_gtk_selection_model_select_range, 4, 0, 0, H_gtk_selection_model_select_range, pl_buiib);
  s7_define_typed_function(sc, "gtk_selection_model_unselect_range", lg_gtk_selection_model_unselect_range, 3, 0, 0, H_gtk_selection_model_unselect_range, pl_bui);
  s7_define_typed_function(sc, "gtk_selection_model_select_all", lg_gtk_selection_model_select_all, 1, 0, 0, H_gtk_selection_model_select_all, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_model_unselect_all", lg_gtk_selection_model_unselect_all, 1, 0, 0, H_gtk_selection_model_unselect_all, pl_bu);
  s7_define_typed_function(sc, "gtk_selection_model_query_range", lg_gtk_selection_model_query_range, 2, 3, 0, H_gtk_selection_model_query_range, pl_puiu);
  s7_define_typed_function(sc, "gtk_selection_model_selection_changed", lg_gtk_selection_model_selection_changed, 3, 0, 0, H_gtk_selection_model_selection_changed, pl_tui);
  s7_define_typed_function(sc, "gtk_single_selection_new", lg_gtk_single_selection_new, 1, 0, 0, H_gtk_single_selection_new, pl_pu);
  s7_define_typed_function(sc, "gtk_single_selection_get_selected", lg_gtk_single_selection_get_selected, 1, 0, 0, H_gtk_single_selection_get_selected, pl_iu);
  s7_define_typed_function(sc, "gtk_single_selection_set_selected", lg_gtk_single_selection_set_selected, 2, 0, 0, H_gtk_single_selection_set_selected, pl_tui);
  s7_define_typed_function(sc, "gtk_single_selection_get_selected_item", lg_gtk_single_selection_get_selected_item, 1, 0, 0, H_gtk_single_selection_get_selected_item, pl_tu);
  s7_define_typed_function(sc, "gtk_single_selection_get_autoselect", lg_gtk_single_selection_get_autoselect, 1, 0, 0, H_gtk_single_selection_get_autoselect, pl_bu);
  s7_define_typed_function(sc, "gtk_single_selection_set_autoselect", lg_gtk_single_selection_set_autoselect, 2, 0, 0, H_gtk_single_selection_set_autoselect, pl_tub);
  s7_define_typed_function(sc, "gtk_single_selection_get_can_unselect", lg_gtk_single_selection_get_can_unselect, 1, 0, 0, H_gtk_single_selection_get_can_unselect, pl_bu);
  s7_define_typed_function(sc, "gtk_single_selection_set_can_unselect", lg_gtk_single_selection_set_can_unselect, 2, 0, 0, H_gtk_single_selection_set_can_unselect, pl_tub);
  s7_define_typed_function(sc, "gtk_slice_list_model_new", lg_gtk_slice_list_model_new, 3, 0, 0, H_gtk_slice_list_model_new, pl_pui);
  s7_define_typed_function(sc, "gtk_slice_list_model_new_for_type", lg_gtk_slice_list_model_new_for_type, 1, 0, 0, H_gtk_slice_list_model_new_for_type, pl_pi);
  s7_define_typed_function(sc, "gtk_slice_list_model_set_model", lg_gtk_slice_list_model_set_model, 2, 0, 0, H_gtk_slice_list_model_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_slice_list_model_get_model", lg_gtk_slice_list_model_get_model, 1, 0, 0, H_gtk_slice_list_model_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_slice_list_model_set_offset", lg_gtk_slice_list_model_set_offset, 2, 0, 0, H_gtk_slice_list_model_set_offset, pl_tui);
  s7_define_typed_function(sc, "gtk_slice_list_model_get_offset", lg_gtk_slice_list_model_get_offset, 1, 0, 0, H_gtk_slice_list_model_get_offset, pl_iu);
  s7_define_typed_function(sc, "gtk_slice_list_model_set_size", lg_gtk_slice_list_model_set_size, 2, 0, 0, H_gtk_slice_list_model_set_size, pl_tui);
  s7_define_typed_function(sc, "gtk_slice_list_model_get_size", lg_gtk_slice_list_model_get_size, 1, 0, 0, H_gtk_slice_list_model_get_size, pl_iu);
  s7_define_typed_function(sc, "gtk_sort_list_model_new_for_type", lg_gtk_sort_list_model_new_for_type, 1, 0, 0, H_gtk_sort_list_model_new_for_type, pl_pi);
  s7_define_typed_function(sc, "gtk_sort_list_model_has_sort", lg_gtk_sort_list_model_has_sort, 1, 0, 0, H_gtk_sort_list_model_has_sort, pl_bu);
  s7_define_typed_function(sc, "gtk_sort_list_model_set_model", lg_gtk_sort_list_model_set_model, 2, 0, 0, H_gtk_sort_list_model_set_model, pl_tu);
  s7_define_typed_function(sc, "gtk_sort_list_model_get_model", lg_gtk_sort_list_model_get_model, 1, 0, 0, H_gtk_sort_list_model_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_sort_list_model_resort", lg_gtk_sort_list_model_resort, 1, 0, 0, H_gtk_sort_list_model_resort, pl_tu);
  s7_define_typed_function(sc, "gtk_text_new", lg_gtk_text_new, 0, 0, 0, H_gtk_text_new, pl_p);
  s7_define_typed_function(sc, "gtk_text_new_with_buffer", lg_gtk_text_new_with_buffer, 1, 0, 0, H_gtk_text_new_with_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_get_buffer", lg_gtk_text_get_buffer, 1, 0, 0, H_gtk_text_get_buffer, pl_pu);
  s7_define_typed_function(sc, "gtk_text_set_buffer", lg_gtk_text_set_buffer, 2, 0, 0, H_gtk_text_set_buffer, pl_tu);
  s7_define_typed_function(sc, "gtk_text_set_visibility", lg_gtk_text_set_visibility, 2, 0, 0, H_gtk_text_set_visibility, pl_tub);
  s7_define_typed_function(sc, "gtk_text_get_visibility", lg_gtk_text_get_visibility, 1, 0, 0, H_gtk_text_get_visibility, pl_bu);
  s7_define_typed_function(sc, "gtk_text_set_invisible_char", lg_gtk_text_set_invisible_char, 2, 0, 0, H_gtk_text_set_invisible_char, pl_tui);
  s7_define_typed_function(sc, "gtk_text_get_invisible_char", lg_gtk_text_get_invisible_char, 1, 0, 0, H_gtk_text_get_invisible_char, pl_iu);
  s7_define_typed_function(sc, "gtk_text_unset_invisible_char", lg_gtk_text_unset_invisible_char, 1, 0, 0, H_gtk_text_unset_invisible_char, pl_tu);
  s7_define_typed_function(sc, "gtk_text_set_overwrite_mode", lg_gtk_text_set_overwrite_mode, 2, 0, 0, H_gtk_text_set_overwrite_mode, pl_tub);
  s7_define_typed_function(sc, "gtk_text_get_overwrite_mode", lg_gtk_text_get_overwrite_mode, 1, 0, 0, H_gtk_text_get_overwrite_mode, pl_bu);
  s7_define_typed_function(sc, "gtk_text_set_max_length", lg_gtk_text_set_max_length, 2, 0, 0, H_gtk_text_set_max_length, pl_tui);
  s7_define_typed_function(sc, "gtk_text_get_max_length", lg_gtk_text_get_max_length, 1, 0, 0, H_gtk_text_get_max_length, pl_iu);
  s7_define_typed_function(sc, "gtk_text_get_text_length", lg_gtk_text_get_text_length, 1, 0, 0, H_gtk_text_get_text_length, pl_iu);
  s7_define_typed_function(sc, "gtk_text_set_activates_default", lg_gtk_text_set_activates_default, 2, 0, 0, H_gtk_text_set_activates_default, pl_tub);
  s7_define_typed_function(sc, "gtk_text_get_activates_default", lg_gtk_text_get_activates_default, 1, 0, 0, H_gtk_text_get_activates_default, pl_bu);
  s7_define_typed_function(sc, "gtk_text_get_placeholder_text", lg_gtk_text_get_placeholder_text, 1, 0, 0, H_gtk_text_get_placeholder_text, pl_su);
  s7_define_typed_function(sc, "gtk_text_set_placeholder_text", lg_gtk_text_set_placeholder_text, 2, 0, 0, H_gtk_text_set_placeholder_text, pl_tus);
  s7_define_typed_function(sc, "gtk_text_set_input_purpose", lg_gtk_text_set_input_purpose, 2, 0, 0, H_gtk_text_set_input_purpose, pl_tug);
  s7_define_typed_function(sc, "gtk_text_get_input_purpose", lg_gtk_text_get_input_purpose, 1, 0, 0, H_gtk_text_get_input_purpose, pl_gu);
  s7_define_typed_function(sc, "gtk_text_set_input_hints", lg_gtk_text_set_input_hints, 2, 0, 0, H_gtk_text_set_input_hints, pl_tug);
  s7_define_typed_function(sc, "gtk_text_get_input_hints", lg_gtk_text_get_input_hints, 1, 0, 0, H_gtk_text_get_input_hints, pl_gu);
  s7_define_typed_function(sc, "gtk_text_set_attributes", lg_gtk_text_set_attributes, 2, 0, 0, H_gtk_text_set_attributes, pl_tu);
  s7_define_typed_function(sc, "gtk_text_get_attributes", lg_gtk_text_get_attributes, 1, 0, 0, H_gtk_text_get_attributes, pl_pu);
  s7_define_typed_function(sc, "gtk_text_set_tabs", lg_gtk_text_set_tabs, 2, 0, 0, H_gtk_text_set_tabs, pl_tu);
  s7_define_typed_function(sc, "gtk_text_get_tabs", lg_gtk_text_get_tabs, 1, 0, 0, H_gtk_text_get_tabs, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_list_model_get_model", lg_gtk_tree_list_model_get_model, 1, 0, 0, H_gtk_tree_list_model_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_list_model_get_passthrough", lg_gtk_tree_list_model_get_passthrough, 1, 0, 0, H_gtk_tree_list_model_get_passthrough, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_list_model_set_autoexpand", lg_gtk_tree_list_model_set_autoexpand, 2, 0, 0, H_gtk_tree_list_model_set_autoexpand, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_list_model_get_autoexpand", lg_gtk_tree_list_model_get_autoexpand, 1, 0, 0, H_gtk_tree_list_model_get_autoexpand, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_list_model_get_child_row", lg_gtk_tree_list_model_get_child_row, 2, 0, 0, H_gtk_tree_list_model_get_child_row, pl_pui);
  s7_define_typed_function(sc, "gtk_tree_list_model_get_row", lg_gtk_tree_list_model_get_row, 2, 0, 0, H_gtk_tree_list_model_get_row, pl_pui);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_item", lg_gtk_tree_list_row_get_item, 1, 0, 0, H_gtk_tree_list_row_get_item, pl_tu);
  s7_define_typed_function(sc, "gtk_tree_list_row_set_expanded", lg_gtk_tree_list_row_set_expanded, 2, 0, 0, H_gtk_tree_list_row_set_expanded, pl_tub);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_expanded", lg_gtk_tree_list_row_get_expanded, 1, 0, 0, H_gtk_tree_list_row_get_expanded, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_list_row_is_expandable", lg_gtk_tree_list_row_is_expandable, 1, 0, 0, H_gtk_tree_list_row_is_expandable, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_position", lg_gtk_tree_list_row_get_position, 1, 0, 0, H_gtk_tree_list_row_get_position, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_depth", lg_gtk_tree_list_row_get_depth, 1, 0, 0, H_gtk_tree_list_row_get_depth, pl_iu);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_children", lg_gtk_tree_list_row_get_children, 1, 0, 0, H_gtk_tree_list_row_get_children, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_parent", lg_gtk_tree_list_row_get_parent, 1, 0, 0, H_gtk_tree_list_row_get_parent, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_list_row_get_child_row", lg_gtk_tree_list_row_get_child_row, 2, 0, 0, H_gtk_tree_list_row_get_child_row, pl_pui);
  s7_define_typed_function(sc, "gdk_clipboard_read_finish", lg_gdk_clipboard_read_finish, 3, 1, 0, H_gdk_clipboard_read_finish, pl_pu);
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
  s7_define_typed_function(sc, "gtk_window_new", lg_gtk_window_new, 1, 0, 0, H_gtk_window_new, pl_pi);
  s7_define_typed_function(sc, "gtk_window_activate_key", lg_gtk_window_activate_key, 2, 0, 0, H_gtk_window_activate_key, pl_bu);
  s7_define_typed_function(sc, "gtk_window_propagate_key_event", lg_gtk_window_propagate_key_event, 2, 0, 0, H_gtk_window_propagate_key_event, pl_bu);
  s7_define_typed_function(sc, "gtk_text_iter_get_paintable", lg_gtk_text_iter_get_paintable, 1, 0, 0, H_gtk_text_iter_get_paintable, pl_pu);
  s7_define_typed_function(sc, "gtk_tree_view_column_cell_get_size", lg_gtk_tree_view_column_cell_get_size, 2, 4, 0, H_gtk_tree_view_column_cell_get_size, pl_pu);
  s7_define_typed_function(sc, "gtk_entry_set_icon_drag_source", lg_gtk_entry_set_icon_drag_source, 4, 0, 0, H_gtk_entry_set_icon_drag_source, pl_tugug);
  s7_define_typed_function(sc, "gtk_entry_grab_focus_without_selecting", lg_gtk_entry_grab_focus_without_selecting, 1, 0, 0, H_gtk_entry_grab_focus_without_selecting, pl_bu);
  s7_define_typed_function(sc, "gtk_event_controller_handle_event", lg_gtk_event_controller_handle_event, 2, 0, 0, H_gtk_event_controller_handle_event, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_add_named", lg_gtk_stack_add_named, 3, 0, 0, H_gtk_stack_add_named, pl_puus);
  s7_define_typed_function(sc, "gtk_stack_add_titled", lg_gtk_stack_add_titled, 4, 0, 0, H_gtk_stack_add_titled, pl_puus);
  s7_define_typed_function(sc, "gtk_widget_grab_focus", lg_gtk_widget_grab_focus, 1, 0, 0, H_gtk_widget_grab_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_insert_action_group", lg_gtk_widget_insert_action_group, 3, 0, 0, H_gtk_widget_insert_action_group, pl_tusu);
  s7_define_typed_function(sc, "gtk_text_buffer_insert_paintable", lg_gtk_text_buffer_insert_paintable, 3, 0, 0, H_gtk_text_buffer_insert_paintable, pl_tu);
  s7_define_typed_function(sc, "gtk_label_set_wrap", lg_gtk_label_set_wrap, 2, 0, 0, H_gtk_label_set_wrap, pl_tub);
  s7_define_typed_function(sc, "gtk_label_get_wrap", lg_gtk_label_get_wrap, 1, 0, 0, H_gtk_label_get_wrap, pl_bu);
  s7_define_typed_function(sc, "gtk_label_set_wrap_mode", lg_gtk_label_set_wrap_mode, 2, 0, 0, H_gtk_label_set_wrap_mode, pl_tug);
  s7_define_typed_function(sc, "gtk_label_get_wrap_mode", lg_gtk_label_get_wrap_mode, 1, 0, 0, H_gtk_label_get_wrap_mode, pl_gu);
  s7_define_typed_function(sc, "gtk_tree_drag_dest_drag_data_received", lg_gtk_tree_drag_dest_drag_data_received, 3, 0, 0, H_gtk_tree_drag_dest_drag_data_received, pl_bu);
  s7_define_typed_function(sc, "gtk_tree_drag_dest_row_drop_possible", lg_gtk_tree_drag_dest_row_drop_possible, 3, 0, 0, H_gtk_tree_drag_dest_row_drop_possible, pl_bu);
  s7_define_typed_function(sc, "gtk_fixed_layout_child_set_transform", lg_gtk_fixed_layout_child_set_transform, 2, 0, 0, H_gtk_fixed_layout_child_set_transform, pl_tu);
  s7_define_typed_function(sc, "gtk_fixed_layout_child_get_transform", lg_gtk_fixed_layout_child_get_transform, 1, 0, 0, H_gtk_fixed_layout_child_get_transform, pl_pu);
  s7_define_typed_function(sc, "gtk_text_view_buffer_to_window_coords", lg_gtk_text_view_buffer_to_window_coords, 4, 2, 0, H_gtk_text_view_buffer_to_window_coords, pl_pugiiu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_file", lg_gtk_file_chooser_get_file, 1, 0, 0, H_gtk_file_chooser_get_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_file", lg_gtk_file_chooser_set_file, 2, 1, 0, H_gtk_file_chooser_set_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_select_file", lg_gtk_file_chooser_select_file, 2, 1, 0, H_gtk_file_chooser_select_file, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_unselect_file", lg_gtk_file_chooser_unselect_file, 2, 0, 0, H_gtk_file_chooser_unselect_file, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_files", lg_gtk_file_chooser_get_files, 1, 0, 0, H_gtk_file_chooser_get_files, pl_pu);
  s7_define_typed_function(sc, "gtk_editable_get_enable_undo", lg_gtk_editable_get_enable_undo, 1, 0, 0, H_gtk_editable_get_enable_undo, pl_bu);
  s7_define_typed_function(sc, "gtk_editable_set_enable_undo", lg_gtk_editable_set_enable_undo, 2, 0, 0, H_gtk_editable_set_enable_undo, pl_tub);
  s7_define_typed_function(sc, "gtk_window_minimize", lg_gtk_window_minimize, 1, 0, 0, H_gtk_window_minimize, pl_tu);
  s7_define_typed_function(sc, "gtk_window_unminimize", lg_gtk_window_unminimize, 1, 0, 0, H_gtk_window_unminimize, pl_tu);
  s7_define_typed_function(sc, "gtk_text_grab_focus_without_selecting", lg_gtk_text_grab_focus_without_selecting, 1, 0, 0, H_gtk_text_grab_focus_without_selecting, pl_bu);
  s7_define_typed_function(sc, "gtk_text_set_extra_menu", lg_gtk_text_set_extra_menu, 2, 0, 0, H_gtk_text_set_extra_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_text_get_extra_menu", lg_gtk_text_get_extra_menu, 1, 0, 0, H_gtk_text_get_extra_menu, pl_pu);
  s7_define_typed_function(sc, "gdk_app_launch_context_get_display", lg_gdk_app_launch_context_get_display, 1, 0, 0, H_gdk_app_launch_context_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_content_provider_new_typed", lg_gdk_content_provider_new_typed, 1, 0, 0, H_gdk_content_provider_new_typed, pl_pi);
  s7_define_typed_function(sc, "gdk_content_provider_new_union", lg_gdk_content_provider_new_union, 2, 0, 0, H_gdk_content_provider_new_union, pl_pui);
  s7_define_typed_function(sc, "gtk_spinner_set_spinning", lg_gtk_spinner_set_spinning, 2, 0, 0, H_gtk_spinner_set_spinning, pl_tub);
  s7_define_typed_function(sc, "gtk_spinner_get_spinning", lg_gtk_spinner_get_spinning, 1, 0, 0, H_gtk_spinner_get_spinning, pl_bu);
  s7_define_typed_function(sc, "gtk_single_selection_get_model", lg_gtk_single_selection_get_model, 1, 0, 0, H_gtk_single_selection_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_scale_set_format_value_func", lg_gtk_scale_set_format_value_func, 4, 0, 0, H_gtk_scale_set_format_value_func, pl_tut);
  s7_define_typed_function(sc, "gtk_root_get_display", lg_gtk_root_get_display, 1, 0, 0, H_gtk_root_get_display, pl_pu);
  s7_define_typed_function(sc, "gtk_password_entry_set_extra_menu", lg_gtk_password_entry_set_extra_menu, 2, 0, 0, H_gtk_password_entry_set_extra_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_password_entry_get_extra_menu", lg_gtk_password_entry_get_extra_menu, 1, 0, 0, H_gtk_password_entry_get_extra_menu, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_long_press_set_delay_factor", lg_gtk_gesture_long_press_set_delay_factor, 2, 0, 0, H_gtk_gesture_long_press_set_delay_factor, pl_tur);
  s7_define_typed_function(sc, "gtk_gesture_long_press_get_delay_factor", lg_gtk_gesture_long_press_get_delay_factor, 1, 0, 0, H_gtk_gesture_long_press_get_delay_factor, pl_du);
  s7_define_typed_function(sc, "gtk_event_controller_get_propagation_limit", lg_gtk_event_controller_get_propagation_limit, 1, 0, 0, H_gtk_event_controller_get_propagation_limit, pl_tu);
  s7_define_typed_function(sc, "gtk_event_controller_set_propagation_limit", lg_gtk_event_controller_set_propagation_limit, 2, 0, 0, H_gtk_event_controller_set_propagation_limit, pl_tut);
  s7_define_typed_function(sc, "gtk_event_controller_get_name", lg_gtk_event_controller_get_name, 1, 0, 0, H_gtk_event_controller_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_event_controller_set_name", lg_gtk_event_controller_set_name, 2, 0, 0, H_gtk_event_controller_set_name, pl_tus);
  s7_define_typed_function(sc, "gdk_device_get_num_touches", lg_gdk_device_get_num_touches, 1, 0, 0, H_gdk_device_get_num_touches, pl_iu);
  s7_define_typed_function(sc, "gdk_device_get_device_tool", lg_gdk_device_get_device_tool, 1, 0, 0, H_gdk_device_get_device_tool, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_get_content", lg_gdk_drag_get_content, 1, 0, 0, H_gdk_drag_get_content, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_get_surface", lg_gdk_drag_get_surface, 1, 0, 0, H_gdk_drag_get_surface, pl_pu);
  s7_define_typed_function(sc, "gdk_drag_surface_present", lg_gdk_drag_surface_present, 3, 0, 0, H_gdk_drag_surface_present, pl_bui);
  s7_define_typed_function(sc, "gdk_drop_status", lg_gdk_drop_status, 3, 0, 0, H_gdk_drop_status, pl_tug);
  s7_define_typed_function(sc, "gdk_monitor_get_connector", lg_gdk_monitor_get_connector, 1, 0, 0, H_gdk_monitor_get_connector, pl_su);
  s7_define_typed_function(sc, "gdk_pixbuf_get_from_texture", lg_gdk_pixbuf_get_from_texture, 1, 0, 0, H_gdk_pixbuf_get_from_texture, pl_pu);
  s7_define_typed_function(sc, "gdk_popup_present", lg_gdk_popup_present, 4, 0, 0, H_gdk_popup_present, pl_buiiu);
  s7_define_typed_function(sc, "gdk_popup_get_surface_anchor", lg_gdk_popup_get_surface_anchor, 1, 0, 0, H_gdk_popup_get_surface_anchor, pl_iu);
  s7_define_typed_function(sc, "gdk_popup_get_rect_anchor", lg_gdk_popup_get_rect_anchor, 1, 0, 0, H_gdk_popup_get_rect_anchor, pl_iu);
  s7_define_typed_function(sc, "gdk_popup_get_parent", lg_gdk_popup_get_parent, 1, 0, 0, H_gdk_popup_get_parent, pl_pu);
  s7_define_typed_function(sc, "gdk_popup_get_position_x", lg_gdk_popup_get_position_x, 1, 0, 0, H_gdk_popup_get_position_x, pl_iu);
  s7_define_typed_function(sc, "gdk_popup_get_position_y", lg_gdk_popup_get_position_y, 1, 0, 0, H_gdk_popup_get_position_y, pl_iu);
  s7_define_typed_function(sc, "gdk_popup_get_autohide", lg_gdk_popup_get_autohide, 1, 0, 0, H_gdk_popup_get_autohide, pl_bu);
  s7_define_typed_function(sc, "gdk_popup_layout_new", lg_gdk_popup_layout_new, 3, 0, 0, H_gdk_popup_layout_new, pl_pui);
  s7_define_typed_function(sc, "gdk_popup_layout_ref", lg_gdk_popup_layout_ref, 1, 0, 0, H_gdk_popup_layout_ref, pl_pu);
  s7_define_typed_function(sc, "gdk_popup_layout_unref", lg_gdk_popup_layout_unref, 1, 0, 0, H_gdk_popup_layout_unref, pl_tu);
  s7_define_typed_function(sc, "gdk_popup_layout_copy", lg_gdk_popup_layout_copy, 1, 0, 0, H_gdk_popup_layout_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_popup_layout_equal", lg_gdk_popup_layout_equal, 2, 0, 0, H_gdk_popup_layout_equal, pl_bu);
  s7_define_typed_function(sc, "gdk_popup_layout_set_anchor_rect", lg_gdk_popup_layout_set_anchor_rect, 2, 0, 0, H_gdk_popup_layout_set_anchor_rect, pl_tu);
  s7_define_typed_function(sc, "gdk_popup_layout_get_anchor_rect", lg_gdk_popup_layout_get_anchor_rect, 1, 0, 0, H_gdk_popup_layout_get_anchor_rect, pl_pu);
  s7_define_typed_function(sc, "gdk_popup_layout_set_rect_anchor", lg_gdk_popup_layout_set_rect_anchor, 2, 0, 0, H_gdk_popup_layout_set_rect_anchor, pl_tui);
  s7_define_typed_function(sc, "gdk_popup_layout_get_rect_anchor", lg_gdk_popup_layout_get_rect_anchor, 1, 0, 0, H_gdk_popup_layout_get_rect_anchor, pl_iu);
  s7_define_typed_function(sc, "gdk_popup_layout_set_surface_anchor", lg_gdk_popup_layout_set_surface_anchor, 2, 0, 0, H_gdk_popup_layout_set_surface_anchor, pl_tui);
  s7_define_typed_function(sc, "gdk_popup_layout_get_surface_anchor", lg_gdk_popup_layout_get_surface_anchor, 1, 0, 0, H_gdk_popup_layout_get_surface_anchor, pl_iu);
  s7_define_typed_function(sc, "gdk_popup_layout_set_anchor_hints", lg_gdk_popup_layout_set_anchor_hints, 2, 0, 0, H_gdk_popup_layout_set_anchor_hints, pl_tug);
  s7_define_typed_function(sc, "gdk_popup_layout_get_anchor_hints", lg_gdk_popup_layout_get_anchor_hints, 1, 0, 0, H_gdk_popup_layout_get_anchor_hints, pl_gu);
  s7_define_typed_function(sc, "gdk_popup_layout_set_offset", lg_gdk_popup_layout_set_offset, 3, 0, 0, H_gdk_popup_layout_set_offset, pl_tui);
  s7_define_typed_function(sc, "gdk_popup_layout_get_offset", lg_gdk_popup_layout_get_offset, 3, 0, 0, H_gdk_popup_layout_get_offset, pl_tu);
  s7_define_typed_function(sc, "gtk_accel_label_get_accel_closure", lg_gtk_accel_label_get_accel_closure, 1, 0, 0, H_gtk_accel_label_get_accel_closure, pl_pu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_is_expander", lg_gtk_cell_renderer_set_is_expander, 2, 0, 0, H_gtk_cell_renderer_set_is_expander, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_is_expander", lg_gtk_cell_renderer_get_is_expander, 1, 0, 0, H_gtk_cell_renderer_get_is_expander, pl_bu);
  s7_define_typed_function(sc, "gtk_cell_renderer_set_is_expanded", lg_gtk_cell_renderer_set_is_expanded, 2, 0, 0, H_gtk_cell_renderer_set_is_expanded, pl_tub);
  s7_define_typed_function(sc, "gtk_cell_renderer_get_is_expanded", lg_gtk_cell_renderer_get_is_expanded, 1, 0, 0, H_gtk_cell_renderer_get_is_expanded, pl_bu);
  s7_define_typed_function(sc, "gtk_drag_source_new", lg_gtk_drag_source_new, 0, 0, 0, H_gtk_drag_source_new, pl_p);
  s7_define_typed_function(sc, "gtk_drag_source_set_content", lg_gtk_drag_source_set_content, 2, 0, 0, H_gtk_drag_source_set_content, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_get_content", lg_gtk_drag_source_get_content, 1, 0, 0, H_gtk_drag_source_get_content, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_source_set_actions", lg_gtk_drag_source_set_actions, 2, 0, 0, H_gtk_drag_source_set_actions, pl_tug);
  s7_define_typed_function(sc, "gtk_drag_source_get_actions", lg_gtk_drag_source_get_actions, 1, 0, 0, H_gtk_drag_source_get_actions, pl_gu);
  s7_define_typed_function(sc, "gtk_drag_source_set_icon", lg_gtk_drag_source_set_icon, 4, 0, 0, H_gtk_drag_source_set_icon, pl_tuui);
  s7_define_typed_function(sc, "gtk_drag_source_drag_cancel", lg_gtk_drag_source_drag_cancel, 1, 0, 0, H_gtk_drag_source_drag_cancel, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_source_get_drag", lg_gtk_drag_source_get_drag, 1, 0, 0, H_gtk_drag_source_get_drag, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_check_threshold", lg_gtk_drag_check_threshold, 5, 0, 0, H_gtk_drag_check_threshold, pl_bui);
  s7_define_typed_function(sc, "gtk_entry_set_extra_menu", lg_gtk_entry_set_extra_menu, 2, 0, 0, H_gtk_entry_set_extra_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_entry_get_extra_menu", lg_gtk_entry_get_extra_menu, 1, 0, 0, H_gtk_entry_get_extra_menu, pl_pu);
  s7_define_typed_function(sc, "gtk_no_selection_new", lg_gtk_no_selection_new, 1, 0, 0, H_gtk_no_selection_new, pl_pu);
  s7_define_typed_function(sc, "gtk_no_selection_get_model", lg_gtk_no_selection_get_model, 1, 0, 0, H_gtk_no_selection_get_model, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_menu_bar_new_from_model", lg_gtk_popover_menu_bar_new_from_model, 1, 0, 0, H_gtk_popover_menu_bar_new_from_model, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_menu_bar_set_menu_model", lg_gtk_popover_menu_bar_set_menu_model, 2, 0, 0, H_gtk_popover_menu_bar_set_menu_model, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_menu_bar_get_menu_model", lg_gtk_popover_menu_bar_get_menu_model, 1, 0, 0, H_gtk_popover_menu_bar_get_menu_model, pl_pu);
  s7_define_typed_function(sc, "gtk_gesture_click_new", lg_gtk_gesture_click_new, 0, 0, 0, H_gtk_gesture_click_new, pl_p);
  s7_define_typed_function(sc, "gtk_gesture_click_set_area", lg_gtk_gesture_click_set_area, 2, 0, 0, H_gtk_gesture_click_set_area, pl_tu);
  s7_define_typed_function(sc, "gtk_gesture_click_get_area", lg_gtk_gesture_click_get_area, 2, 0, 0, H_gtk_gesture_click_get_area, pl_bu);
  s7_define_typed_function(sc, "gtk_center_layout_new", lg_gtk_center_layout_new, 0, 0, 0, H_gtk_center_layout_new, pl_p);
  s7_define_typed_function(sc, "gtk_center_layout_set_orientation", lg_gtk_center_layout_set_orientation, 2, 0, 0, H_gtk_center_layout_set_orientation, pl_tug);
  s7_define_typed_function(sc, "gtk_center_layout_get_orientation", lg_gtk_center_layout_get_orientation, 1, 0, 0, H_gtk_center_layout_get_orientation, pl_gu);
  s7_define_typed_function(sc, "gtk_center_layout_set_baseline_position", lg_gtk_center_layout_set_baseline_position, 2, 0, 0, H_gtk_center_layout_set_baseline_position, pl_tug);
  s7_define_typed_function(sc, "gtk_center_layout_get_baseline_position", lg_gtk_center_layout_get_baseline_position, 1, 0, 0, H_gtk_center_layout_get_baseline_position, pl_gu);
  s7_define_typed_function(sc, "gtk_center_layout_set_start_widget", lg_gtk_center_layout_set_start_widget, 2, 0, 0, H_gtk_center_layout_set_start_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_layout_get_start_widget", lg_gtk_center_layout_get_start_widget, 1, 0, 0, H_gtk_center_layout_get_start_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_layout_set_center_widget", lg_gtk_center_layout_set_center_widget, 2, 0, 0, H_gtk_center_layout_set_center_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_layout_get_center_widget", lg_gtk_center_layout_get_center_widget, 1, 0, 0, H_gtk_center_layout_get_center_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_center_layout_set_end_widget", lg_gtk_center_layout_set_end_widget, 2, 0, 0, H_gtk_center_layout_set_end_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_center_layout_get_end_widget", lg_gtk_center_layout_get_end_widget, 1, 0, 0, H_gtk_center_layout_get_end_widget, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_menu_new_from_model", lg_gtk_popover_menu_new_from_model, 1, 0, 0, H_gtk_popover_menu_new_from_model, pl_pu);
  s7_define_typed_function(sc, "gtk_popover_menu_new_from_model_full", lg_gtk_popover_menu_new_from_model_full, 2, 0, 0, H_gtk_popover_menu_new_from_model_full, pl_pug);
  s7_define_typed_function(sc, "gtk_popover_menu_set_menu_model", lg_gtk_popover_menu_set_menu_model, 2, 0, 0, H_gtk_popover_menu_set_menu_model, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_menu_get_menu_model", lg_gtk_popover_menu_get_menu_model, 1, 0, 0, H_gtk_popover_menu_get_menu_model, pl_pu);
  s7_define_typed_function(sc, "gdk_toplevel_present", lg_gdk_toplevel_present, 4, 0, 0, H_gdk_toplevel_present, pl_buiiu);
  s7_define_typed_function(sc, "gdk_toplevel_minimize", lg_gdk_toplevel_minimize, 1, 0, 0, H_gdk_toplevel_minimize, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_lower", lg_gdk_toplevel_lower, 1, 0, 0, H_gdk_toplevel_lower, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_focus", lg_gdk_toplevel_focus, 2, 0, 0, H_gdk_toplevel_focus, pl_tui);
  s7_define_typed_function(sc, "gdk_toplevel_get_state", lg_gdk_toplevel_get_state, 1, 0, 0, H_gdk_toplevel_get_state, pl_gu);
  s7_define_typed_function(sc, "gdk_toplevel_set_title", lg_gdk_toplevel_set_title, 2, 0, 0, H_gdk_toplevel_set_title, pl_tus);
  s7_define_typed_function(sc, "gdk_toplevel_set_startup_id", lg_gdk_toplevel_set_startup_id, 2, 0, 0, H_gdk_toplevel_set_startup_id, pl_tus);
  s7_define_typed_function(sc, "gdk_toplevel_set_transient_for", lg_gdk_toplevel_set_transient_for, 2, 0, 0, H_gdk_toplevel_set_transient_for, pl_tu);
  s7_define_typed_function(sc, "gdk_toplevel_set_modal", lg_gdk_toplevel_set_modal, 2, 0, 0, H_gdk_toplevel_set_modal, pl_tub);
  s7_define_typed_function(sc, "gdk_toplevel_set_icon_list", lg_gdk_toplevel_set_icon_list, 2, 0, 0, H_gdk_toplevel_set_icon_list, pl_tu);
  s7_define_typed_function(sc, "gdk_toplevel_show_window_menu", lg_gdk_toplevel_show_window_menu, 2, 0, 0, H_gdk_toplevel_show_window_menu, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_set_decorated", lg_gdk_toplevel_set_decorated, 2, 0, 0, H_gdk_toplevel_set_decorated, pl_tub);
  s7_define_typed_function(sc, "gdk_toplevel_set_deletable", lg_gdk_toplevel_set_deletable, 2, 0, 0, H_gdk_toplevel_set_deletable, pl_tub);
  s7_define_typed_function(sc, "gdk_toplevel_supports_edge_constraints", lg_gdk_toplevel_supports_edge_constraints, 1, 0, 0, H_gdk_toplevel_supports_edge_constraints, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_new", lg_gdk_toplevel_layout_new, 2, 0, 0, H_gdk_toplevel_layout_new, pl_pi);
  s7_define_typed_function(sc, "gdk_toplevel_layout_ref", lg_gdk_toplevel_layout_ref, 1, 0, 0, H_gdk_toplevel_layout_ref, pl_pu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_unref", lg_gdk_toplevel_layout_unref, 1, 0, 0, H_gdk_toplevel_layout_unref, pl_tu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_copy", lg_gdk_toplevel_layout_copy, 1, 0, 0, H_gdk_toplevel_layout_copy, pl_pu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_equal", lg_gdk_toplevel_layout_equal, 2, 0, 0, H_gdk_toplevel_layout_equal, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_set_maximized", lg_gdk_toplevel_layout_set_maximized, 2, 0, 0, H_gdk_toplevel_layout_set_maximized, pl_tub);
  s7_define_typed_function(sc, "gdk_toplevel_layout_set_fullscreen", lg_gdk_toplevel_layout_set_fullscreen, 3, 0, 0, H_gdk_toplevel_layout_set_fullscreen, pl_tubu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_get_min_width", lg_gdk_toplevel_layout_get_min_width, 1, 0, 0, H_gdk_toplevel_layout_get_min_width, pl_iu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_get_min_height", lg_gdk_toplevel_layout_get_min_height, 1, 0, 0, H_gdk_toplevel_layout_get_min_height, pl_iu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_get_maximized", lg_gdk_toplevel_layout_get_maximized, 1, 0, 0, H_gdk_toplevel_layout_get_maximized, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_get_fullscreen", lg_gdk_toplevel_layout_get_fullscreen, 1, 0, 0, H_gdk_toplevel_layout_get_fullscreen, pl_bu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_get_fullscreen_monitor", lg_gdk_toplevel_layout_get_fullscreen_monitor, 1, 0, 0, H_gdk_toplevel_layout_get_fullscreen_monitor, pl_pu);
  s7_define_typed_function(sc, "gdk_toplevel_layout_set_resizable", lg_gdk_toplevel_layout_set_resizable, 2, 0, 0, H_gdk_toplevel_layout_set_resizable, pl_tub);
  s7_define_typed_function(sc, "gdk_toplevel_layout_get_resizable", lg_gdk_toplevel_layout_get_resizable, 1, 0, 0, H_gdk_toplevel_layout_get_resizable, pl_bu);
  s7_define_typed_function(sc, "gdk_surface_new_toplevel", lg_gdk_surface_new_toplevel, 3, 0, 0, H_gdk_surface_new_toplevel, pl_pui);
  s7_define_typed_function(sc, "gdk_surface_new_popup", lg_gdk_surface_new_popup, 2, 0, 0, H_gdk_surface_new_popup, pl_pub);
  s7_define_typed_function(sc, "gdk_surface_destroy", lg_gdk_surface_destroy, 1, 0, 0, H_gdk_surface_destroy, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_is_destroyed", lg_gdk_surface_is_destroyed, 1, 0, 0, H_gdk_surface_is_destroyed, pl_bu);
  s7_define_typed_function(sc, "gdk_surface_get_display", lg_gdk_surface_get_display, 1, 0, 0, H_gdk_surface_get_display, pl_pu);
  s7_define_typed_function(sc, "gdk_surface_hide", lg_gdk_surface_hide, 1, 0, 0, H_gdk_surface_hide, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_set_input_region", lg_gdk_surface_set_input_region, 2, 0, 0, H_gdk_surface_set_input_region, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_is_viewable", lg_gdk_surface_is_viewable, 1, 0, 0, H_gdk_surface_is_viewable, pl_bu);
  s7_define_typed_function(sc, "gdk_surface_get_mapped", lg_gdk_surface_get_mapped, 1, 0, 0, H_gdk_surface_get_mapped, pl_bu);
  s7_define_typed_function(sc, "gdk_surface_set_cursor", lg_gdk_surface_set_cursor, 2, 0, 0, H_gdk_surface_set_cursor, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_get_cursor", lg_gdk_surface_get_cursor, 1, 0, 0, H_gdk_surface_get_cursor, pl_pu);
  s7_define_typed_function(sc, "gdk_surface_set_device_cursor", lg_gdk_surface_set_device_cursor, 3, 0, 0, H_gdk_surface_set_device_cursor, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_get_device_cursor", lg_gdk_surface_get_device_cursor, 2, 0, 0, H_gdk_surface_get_device_cursor, pl_pu);
  s7_define_typed_function(sc, "gdk_surface_get_width", lg_gdk_surface_get_width, 1, 0, 0, H_gdk_surface_get_width, pl_iu);
  s7_define_typed_function(sc, "gdk_surface_get_height", lg_gdk_surface_get_height, 1, 0, 0, H_gdk_surface_get_height, pl_iu);
  s7_define_typed_function(sc, "gdk_surface_translate_coordinates", lg_gdk_surface_translate_coordinates, 4, 0, 0, H_gdk_surface_translate_coordinates, pl_bu);
  s7_define_typed_function(sc, "gdk_surface_get_scale_factor", lg_gdk_surface_get_scale_factor, 1, 0, 0, H_gdk_surface_get_scale_factor, pl_iu);
  s7_define_typed_function(sc, "gdk_surface_get_device_position", lg_gdk_surface_get_device_position, 5, 0, 0, H_gdk_surface_get_device_position, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_create_similar_surface", lg_gdk_surface_create_similar_surface, 4, 0, 0, H_gdk_surface_create_similar_surface, pl_pugi);
  s7_define_typed_function(sc, "gdk_surface_beep", lg_gdk_surface_beep, 1, 0, 0, H_gdk_surface_beep, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_begin_resize_drag", lg_gdk_surface_begin_resize_drag, 7, 0, 0, H_gdk_surface_begin_resize_drag, pl_tugui);
  s7_define_typed_function(sc, "gdk_surface_begin_move_drag", lg_gdk_surface_begin_move_drag, 6, 0, 0, H_gdk_surface_begin_move_drag, pl_tuui);
  s7_define_typed_function(sc, "gdk_surface_queue_expose", lg_gdk_surface_queue_expose, 1, 0, 0, H_gdk_surface_queue_expose, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_freeze_updates", lg_gdk_surface_freeze_updates, 1, 0, 0, H_gdk_surface_freeze_updates, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_thaw_updates", lg_gdk_surface_thaw_updates, 1, 0, 0, H_gdk_surface_thaw_updates, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_set_support_multidevice", lg_gdk_surface_set_support_multidevice, 2, 0, 0, H_gdk_surface_set_support_multidevice, pl_tub);
  s7_define_typed_function(sc, "gdk_surface_get_support_multidevice", lg_gdk_surface_get_support_multidevice, 1, 0, 0, H_gdk_surface_get_support_multidevice, pl_bu);
  s7_define_typed_function(sc, "gdk_surface_get_frame_clock", lg_gdk_surface_get_frame_clock, 1, 0, 0, H_gdk_surface_get_frame_clock, pl_pu);
  s7_define_typed_function(sc, "gdk_surface_set_opaque_region", lg_gdk_surface_set_opaque_region, 2, 0, 0, H_gdk_surface_set_opaque_region, pl_tu);
  s7_define_typed_function(sc, "gdk_surface_set_shadow_width", lg_gdk_surface_set_shadow_width, 5, 0, 0, H_gdk_surface_set_shadow_width, pl_tui);
  s7_define_typed_function(sc, "gdk_surface_create_cairo_context", lg_gdk_surface_create_cairo_context, 1, 0, 0, H_gdk_surface_create_cairo_context, pl_pu);
  s7_define_typed_function(sc, "gdk_surface_create_gl_context", lg_gdk_surface_create_gl_context, 2, 0, 0, H_gdk_surface_create_gl_context, pl_pu);
  s7_define_typed_function(sc, "gdk_surface_create_vulkan_context", lg_gdk_surface_create_vulkan_context, 2, 0, 0, H_gdk_surface_create_vulkan_context, pl_pu);
  s7_define_typed_function(sc, "gboolean", lg_gboolean, 1, 0, 0, H_gboolean, pl_t);
  s7_define_typed_function(sc, "gtk_calendar_get_type", lg_gtk_calendar_get_type, 0, 0, 0, H_gtk_calendar_get_type, pl_i);
  s7_define_typed_function(sc, "gtk_calendar_set_show_week_numbers", lg_gtk_calendar_set_show_week_numbers, 2, 0, 0, H_gtk_calendar_set_show_week_numbers, pl_tub);
  s7_define_typed_function(sc, "gtk_calendar_get_show_week_numbers", lg_gtk_calendar_get_show_week_numbers, 1, 0, 0, H_gtk_calendar_get_show_week_numbers, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_set_show_heading", lg_gtk_calendar_set_show_heading, 2, 0, 0, H_gtk_calendar_set_show_heading, pl_tub);
  s7_define_typed_function(sc, "gtk_calendar_get_show_heading", lg_gtk_calendar_get_show_heading, 1, 0, 0, H_gtk_calendar_get_show_heading, pl_bu);
  s7_define_typed_function(sc, "gtk_calendar_set_show_day_names", lg_gtk_calendar_set_show_day_names, 2, 0, 0, H_gtk_calendar_set_show_day_names, pl_tub);
  s7_define_typed_function(sc, "gtk_calendar_get_show_day_names", lg_gtk_calendar_get_show_day_names, 1, 0, 0, H_gtk_calendar_get_show_day_names, pl_bu);
  s7_define_typed_function(sc, "gtk_constraint_guide_new", lg_gtk_constraint_guide_new, 0, 0, 0, H_gtk_constraint_guide_new, pl_p);
  s7_define_typed_function(sc, "gtk_constraint_guide_set_min_size", lg_gtk_constraint_guide_set_min_size, 3, 0, 0, H_gtk_constraint_guide_set_min_size, pl_tui);
  s7_define_typed_function(sc, "gtk_constraint_guide_get_min_size", lg_gtk_constraint_guide_get_min_size, 3, 0, 0, H_gtk_constraint_guide_get_min_size, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_guide_set_nat_size", lg_gtk_constraint_guide_set_nat_size, 3, 0, 0, H_gtk_constraint_guide_set_nat_size, pl_tui);
  s7_define_typed_function(sc, "gtk_constraint_guide_get_nat_size", lg_gtk_constraint_guide_get_nat_size, 3, 0, 0, H_gtk_constraint_guide_get_nat_size, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_guide_set_max_size", lg_gtk_constraint_guide_set_max_size, 3, 0, 0, H_gtk_constraint_guide_set_max_size, pl_tui);
  s7_define_typed_function(sc, "gtk_constraint_guide_get_max_size", lg_gtk_constraint_guide_get_max_size, 3, 0, 0, H_gtk_constraint_guide_get_max_size, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_guide_get_strength", lg_gtk_constraint_guide_get_strength, 1, 0, 0, H_gtk_constraint_guide_get_strength, pl_gu);
  s7_define_typed_function(sc, "gtk_constraint_guide_set_strength", lg_gtk_constraint_guide_set_strength, 2, 0, 0, H_gtk_constraint_guide_set_strength, pl_tug);
  s7_define_typed_function(sc, "gtk_constraint_guide_set_name", lg_gtk_constraint_guide_set_name, 2, 0, 0, H_gtk_constraint_guide_set_name, pl_tus);
  s7_define_typed_function(sc, "gtk_constraint_guide_get_name", lg_gtk_constraint_guide_get_name, 1, 0, 0, H_gtk_constraint_guide_get_name, pl_su);
  s7_define_typed_function(sc, "gtk_icon_theme_new", lg_gtk_icon_theme_new, 0, 0, 0, H_gtk_icon_theme_new, pl_p);
  s7_define_typed_function(sc, "gtk_icon_theme_get_for_display", lg_gtk_icon_theme_get_for_display, 1, 0, 0, H_gtk_icon_theme_get_for_display, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_set_search_path", lg_gtk_icon_theme_set_search_path, 2, 0, 0, H_gtk_icon_theme_set_search_path, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_get_search_path", lg_gtk_icon_theme_get_search_path, 1, 0, 0, H_gtk_icon_theme_get_search_path, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_add_search_path", lg_gtk_icon_theme_add_search_path, 2, 0, 0, H_gtk_icon_theme_add_search_path, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_set_resource_path", lg_gtk_icon_theme_set_resource_path, 2, 0, 0, H_gtk_icon_theme_set_resource_path, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_get_resource_path", lg_gtk_icon_theme_get_resource_path, 1, 0, 0, H_gtk_icon_theme_get_resource_path, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_theme_add_resource_path", lg_gtk_icon_theme_add_resource_path, 2, 0, 0, H_gtk_icon_theme_add_resource_path, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_set_theme_name", lg_gtk_icon_theme_set_theme_name, 2, 0, 0, H_gtk_icon_theme_set_theme_name, pl_tus);
  s7_define_typed_function(sc, "gtk_icon_theme_get_theme_name", lg_gtk_icon_theme_get_theme_name, 1, 0, 0, H_gtk_icon_theme_get_theme_name, pl_su);
  s7_define_typed_function(sc, "gtk_icon_theme_has_icon", lg_gtk_icon_theme_has_icon, 2, 0, 0, H_gtk_icon_theme_has_icon, pl_bus);
  s7_define_typed_function(sc, "gtk_icon_theme_get_icon_sizes", lg_gtk_icon_theme_get_icon_sizes, 2, 0, 0, H_gtk_icon_theme_get_icon_sizes, pl_pus);
  s7_define_typed_function(sc, "gtk_icon_theme_lookup_icon", lg_gtk_icon_theme_lookup_icon, 7, 0, 0, H_gtk_icon_theme_lookup_icon, pl_pussiig);
  s7_define_typed_function(sc, "gtk_icon_theme_lookup_by_gicon", lg_gtk_icon_theme_lookup_by_gicon, 6, 0, 0, H_gtk_icon_theme_lookup_by_gicon, pl_puuiig);
  s7_define_typed_function(sc, "gtk_icon_paintable_new_for_file", lg_gtk_icon_paintable_new_for_file, 3, 0, 0, H_gtk_icon_paintable_new_for_file, pl_pui);
  s7_define_typed_function(sc, "gtk_icon_theme_get_icon_names", lg_gtk_icon_theme_get_icon_names, 1, 0, 0, H_gtk_icon_theme_get_icon_names, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_paintable_get_file", lg_gtk_icon_paintable_get_file, 1, 0, 0, H_gtk_icon_paintable_get_file, pl_pu);
  s7_define_typed_function(sc, "gtk_icon_paintable_get_icon_name", lg_gtk_icon_paintable_get_icon_name, 1, 0, 0, H_gtk_icon_paintable_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_icon_paintable_is_symbolic", lg_gtk_icon_paintable_is_symbolic, 1, 0, 0, H_gtk_icon_paintable_is_symbolic, pl_bu);
  s7_define_typed_function(sc, "gtk_constraint_new", lg_gtk_constraint_new, 0, 0, 1, H_gtk_constraint_new, pl_ptggtgrri);
  s7_define_typed_function(sc, "gtk_constraint_new_constant", lg_gtk_constraint_new_constant, 5, 0, 0, H_gtk_constraint_new_constant, pl_ptggri);
  s7_define_typed_function(sc, "gtk_constraint_get_target", lg_gtk_constraint_get_target, 1, 0, 0, H_gtk_constraint_get_target, pl_pu);
  s7_define_typed_function(sc, "gtk_constraint_get_target_attribute", lg_gtk_constraint_get_target_attribute, 1, 0, 0, H_gtk_constraint_get_target_attribute, pl_gu);
  s7_define_typed_function(sc, "gtk_constraint_get_source", lg_gtk_constraint_get_source, 1, 0, 0, H_gtk_constraint_get_source, pl_pu);
  s7_define_typed_function(sc, "gtk_constraint_get_source_attribute", lg_gtk_constraint_get_source_attribute, 1, 0, 0, H_gtk_constraint_get_source_attribute, pl_gu);
  s7_define_typed_function(sc, "gtk_constraint_get_relation", lg_gtk_constraint_get_relation, 1, 0, 0, H_gtk_constraint_get_relation, pl_gu);
  s7_define_typed_function(sc, "gtk_constraint_get_multiplier", lg_gtk_constraint_get_multiplier, 1, 0, 0, H_gtk_constraint_get_multiplier, pl_du);
  s7_define_typed_function(sc, "gtk_constraint_get_constant", lg_gtk_constraint_get_constant, 1, 0, 0, H_gtk_constraint_get_constant, pl_du);
  s7_define_typed_function(sc, "gtk_constraint_get_strength", lg_gtk_constraint_get_strength, 1, 0, 0, H_gtk_constraint_get_strength, pl_iu);
  s7_define_typed_function(sc, "gtk_constraint_is_required", lg_gtk_constraint_is_required, 1, 0, 0, H_gtk_constraint_is_required, pl_bu);
  s7_define_typed_function(sc, "gtk_constraint_is_attached", lg_gtk_constraint_is_attached, 1, 0, 0, H_gtk_constraint_is_attached, pl_bu);
  s7_define_typed_function(sc, "gtk_constraint_is_constant", lg_gtk_constraint_is_constant, 1, 0, 0, H_gtk_constraint_is_constant, pl_bu);
  s7_define_typed_function(sc, "gtk_constraint_layout_new", lg_gtk_constraint_layout_new, 0, 0, 0, H_gtk_constraint_layout_new, pl_p);
  s7_define_typed_function(sc, "gtk_constraint_layout_add_constraint", lg_gtk_constraint_layout_add_constraint, 2, 0, 0, H_gtk_constraint_layout_add_constraint, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_layout_remove_constraint", lg_gtk_constraint_layout_remove_constraint, 2, 0, 0, H_gtk_constraint_layout_remove_constraint, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_layout_add_guide", lg_gtk_constraint_layout_add_guide, 2, 0, 0, H_gtk_constraint_layout_add_guide, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_layout_remove_guide", lg_gtk_constraint_layout_remove_guide, 2, 0, 0, H_gtk_constraint_layout_remove_guide, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_layout_remove_all_constraints", lg_gtk_constraint_layout_remove_all_constraints, 1, 0, 0, H_gtk_constraint_layout_remove_all_constraints, pl_tu);
  s7_define_typed_function(sc, "gtk_constraint_layout_add_constraints_from_description", lg_gtk_constraint_layout_add_constraints_from_description, 7, 0, 0, H_gtk_constraint_layout_add_constraints_from_description, pl_pusiiius);
  s7_define_typed_function(sc, "gtk_constraint_layout_add_constraints_from_descriptionv", lg_gtk_constraint_layout_add_constraints_from_descriptionv, 7, 0, 0, H_gtk_constraint_layout_add_constraints_from_descriptionv, pl_pusiiiu);
  s7_define_typed_function(sc, "gtk_constraint_layout_observe_constraints", lg_gtk_constraint_layout_observe_constraints, 1, 0, 0, H_gtk_constraint_layout_observe_constraints, pl_pu);
  s7_define_typed_function(sc, "gtk_constraint_layout_observe_guides", lg_gtk_constraint_layout_observe_guides, 1, 0, 0, H_gtk_constraint_layout_observe_guides, pl_pu);
  s7_define_typed_function(sc, "gtk_event_controller_focus_new", lg_gtk_event_controller_focus_new, 0, 0, 0, H_gtk_event_controller_focus_new, pl_p);
  s7_define_typed_function(sc, "gtk_event_controller_focus_contains_focus", lg_gtk_event_controller_focus_contains_focus, 1, 0, 0, H_gtk_event_controller_focus_contains_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_event_controller_focus_is_focus", lg_gtk_event_controller_focus_is_focus, 1, 0, 0, H_gtk_event_controller_focus_is_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_drag_icon_get_for_drag", lg_gtk_drag_icon_get_for_drag, 1, 0, 0, H_gtk_drag_icon_get_for_drag, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_icon_set_child", lg_gtk_drag_icon_set_child, 2, 0, 0, H_gtk_drag_icon_set_child, pl_tu);
  s7_define_typed_function(sc, "gtk_drag_icon_get_child", lg_gtk_drag_icon_get_child, 1, 0, 0, H_gtk_drag_icon_get_child, pl_pu);
  s7_define_typed_function(sc, "gtk_drag_icon_set_from_paintable", lg_gtk_drag_icon_set_from_paintable, 4, 0, 0, H_gtk_drag_icon_set_from_paintable, pl_tuui);
  s7_define_typed_function(sc, "gtk_drag_icon_create_widget_for_value", lg_gtk_drag_icon_create_widget_for_value, 1, 0, 0, H_gtk_drag_icon_create_widget_for_value, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_controller_motion_new", lg_gtk_drop_controller_motion_new, 0, 0, 0, H_gtk_drop_controller_motion_new, pl_p);
  s7_define_typed_function(sc, "gtk_drop_controller_motion_contains_pointer", lg_gtk_drop_controller_motion_contains_pointer, 1, 0, 0, H_gtk_drop_controller_motion_contains_pointer, pl_bu);
  s7_define_typed_function(sc, "gtk_drop_controller_motion_get_drop", lg_gtk_drop_controller_motion_get_drop, 1, 0, 0, H_gtk_drop_controller_motion_get_drop, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_controller_motion_is_pointer", lg_gtk_drop_controller_motion_is_pointer, 1, 0, 0, H_gtk_drop_controller_motion_is_pointer, pl_bu);
  s7_define_typed_function(sc, "gtk_drop_target_new", lg_gtk_drop_target_new, 2, 0, 0, H_gtk_drop_target_new, pl_pig);
  s7_define_typed_function(sc, "gtk_drop_target_set_gtypes", lg_gtk_drop_target_set_gtypes, 3, 0, 0, H_gtk_drop_target_set_gtypes, pl_tuui);
  s7_define_typed_function(sc, "gtk_drop_target_get_gtypes", lg_gtk_drop_target_get_gtypes, 2, 0, 0, H_gtk_drop_target_get_gtypes, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_target_get_formats", lg_gtk_drop_target_get_formats, 1, 0, 0, H_gtk_drop_target_get_formats, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_target_set_actions", lg_gtk_drop_target_set_actions, 2, 0, 0, H_gtk_drop_target_set_actions, pl_tug);
  s7_define_typed_function(sc, "gtk_drop_target_get_actions", lg_gtk_drop_target_get_actions, 1, 0, 0, H_gtk_drop_target_get_actions, pl_gu);
  s7_define_typed_function(sc, "gtk_drop_target_set_preload", lg_gtk_drop_target_set_preload, 2, 0, 0, H_gtk_drop_target_set_preload, pl_tub);
  s7_define_typed_function(sc, "gtk_drop_target_get_preload", lg_gtk_drop_target_get_preload, 1, 0, 0, H_gtk_drop_target_get_preload, pl_bu);
  s7_define_typed_function(sc, "gtk_drop_target_get_drop", lg_gtk_drop_target_get_drop, 1, 0, 0, H_gtk_drop_target_get_drop, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_target_get_value", lg_gtk_drop_target_get_value, 1, 0, 0, H_gtk_drop_target_get_value, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_target_reject", lg_gtk_drop_target_reject, 1, 0, 0, H_gtk_drop_target_reject, pl_tu);
  s7_define_typed_function(sc, "gtk_drop_target_async_new", lg_gtk_drop_target_async_new, 2, 0, 0, H_gtk_drop_target_async_new, pl_pug);
  s7_define_typed_function(sc, "gtk_drop_target_async_set_formats", lg_gtk_drop_target_async_set_formats, 2, 0, 0, H_gtk_drop_target_async_set_formats, pl_tu);
  s7_define_typed_function(sc, "gtk_drop_target_async_get_formats", lg_gtk_drop_target_async_get_formats, 1, 0, 0, H_gtk_drop_target_async_get_formats, pl_pu);
  s7_define_typed_function(sc, "gtk_drop_target_async_set_actions", lg_gtk_drop_target_async_set_actions, 2, 0, 0, H_gtk_drop_target_async_set_actions, pl_tug);
  s7_define_typed_function(sc, "gtk_drop_target_async_get_actions", lg_gtk_drop_target_async_get_actions, 1, 0, 0, H_gtk_drop_target_async_get_actions, pl_gu);
  s7_define_typed_function(sc, "gtk_drop_target_async_reject_drop", lg_gtk_drop_target_async_reject_drop, 2, 0, 0, H_gtk_drop_target_async_reject_drop, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_set_icon_name", lg_gtk_menu_button_set_icon_name, 2, 0, 0, H_gtk_menu_button_set_icon_name, pl_tus);
  s7_define_typed_function(sc, "gtk_menu_button_get_icon_name", lg_gtk_menu_button_get_icon_name, 1, 0, 0, H_gtk_menu_button_get_icon_name, pl_su);
  s7_define_typed_function(sc, "gtk_menu_button_set_label", lg_gtk_menu_button_set_label, 2, 0, 0, H_gtk_menu_button_set_label, pl_tut);
  s7_define_typed_function(sc, "gtk_menu_button_get_label", lg_gtk_menu_button_get_label, 1, 0, 0, H_gtk_menu_button_get_label, pl_su);
  s7_define_typed_function(sc, "gtk_menu_button_popup", lg_gtk_menu_button_popup, 1, 0, 0, H_gtk_menu_button_popup, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_popdown", lg_gtk_menu_button_popdown, 1, 0, 0, H_gtk_menu_button_popdown, pl_tu);
  s7_define_typed_function(sc, "gtk_menu_button_set_create_popup_func", lg_gtk_menu_button_set_create_popup_func, 4, 0, 0, H_gtk_menu_button_set_create_popup_func, pl_tut);
  s7_define_typed_function(sc, "gtk_style_context_get_valist", lg_gtk_style_context_get_valist, 3, 0, 0, H_gtk_style_context_get_valist, pl_tust);
  s7_define_typed_function(sc, "gtk_style_context_get", lg_gtk_style_context_get, 2, 0, 0, H_gtk_style_context_get, pl_tus);
  s7_define_typed_function(sc, "gtk_text_view_get_gutter", lg_gtk_text_view_get_gutter, 2, 0, 0, H_gtk_text_view_get_gutter, pl_pug);
  s7_define_typed_function(sc, "gtk_text_view_set_gutter", lg_gtk_text_view_set_gutter, 3, 0, 0, H_gtk_text_view_set_gutter, pl_tugu);
  s7_define_typed_function(sc, "gtk_text_view_add_overlay", lg_gtk_text_view_add_overlay, 4, 0, 0, H_gtk_text_view_add_overlay, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_view_move_overlay", lg_gtk_text_view_move_overlay, 4, 0, 0, H_gtk_text_view_move_overlay, pl_tuui);
  s7_define_typed_function(sc, "gtk_text_view_set_extra_menu", lg_gtk_text_view_set_extra_menu, 2, 0, 0, H_gtk_text_view_set_extra_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_text_view_get_extra_menu", lg_gtk_text_view_get_extra_menu, 1, 0, 0, H_gtk_text_view_get_extra_menu, pl_pu);
  s7_define_typed_function(sc, "gtk_label_set_extra_menu", lg_gtk_label_set_extra_menu, 2, 0, 0, H_gtk_label_set_extra_menu, pl_tu);
  s7_define_typed_function(sc, "gtk_label_get_extra_menu", lg_gtk_label_get_extra_menu, 1, 0, 0, H_gtk_label_get_extra_menu, pl_pu);
  s7_define_typed_function(sc, "GtkTreeModel*", lg_GtkTreeModel*, 1, 0, 0, H_GtkTreeModel*, pl_t);
  s7_define_typed_function(sc, "gtk_tree_get_row_drag_data", lg_gtk_tree_get_row_drag_data, 3, 0, 0, H_gtk_tree_get_row_drag_data, pl_bu);
  s7_define_typed_function(sc, "GtkTreeDragSource*", lg_GtkTreeDragSource*, 1, 0, 0, H_GtkTreeDragSource*, pl_t);
  s7_define_typed_function(sc, "gtk_text_buffer_get_selection_content", lg_gtk_text_buffer_get_selection_content, 1, 0, 0, H_gtk_text_buffer_get_selection_content, pl_pu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_can_undo", lg_gtk_text_buffer_get_can_undo, 1, 0, 0, H_gtk_text_buffer_get_can_undo, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_can_redo", lg_gtk_text_buffer_get_can_redo, 1, 0, 0, H_gtk_text_buffer_get_can_redo, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_enable_undo", lg_gtk_text_buffer_get_enable_undo, 1, 0, 0, H_gtk_text_buffer_get_enable_undo, pl_bu);
  s7_define_typed_function(sc, "gtk_text_buffer_set_enable_undo", lg_gtk_text_buffer_set_enable_undo, 1, 0, 0, H_gtk_text_buffer_set_enable_undo, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_get_max_undo_levels", lg_gtk_text_buffer_get_max_undo_levels, 1, 0, 0, H_gtk_text_buffer_get_max_undo_levels, pl_iu);
  s7_define_typed_function(sc, "gtk_text_buffer_set_max_undo_levels", lg_gtk_text_buffer_set_max_undo_levels, 1, 0, 0, H_gtk_text_buffer_set_max_undo_levels, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_undo", lg_gtk_text_buffer_undo, 1, 0, 0, H_gtk_text_buffer_undo, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_redo", lg_gtk_text_buffer_redo, 1, 0, 0, H_gtk_text_buffer_redo, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_begin_irreversible_action", lg_gtk_text_buffer_begin_irreversible_action, 1, 0, 0, H_gtk_text_buffer_begin_irreversible_action, pl_tu);
  s7_define_typed_function(sc, "gtk_text_buffer_end_irreversible_action", lg_gtk_text_buffer_end_irreversible_action, 1, 0, 0, H_gtk_text_buffer_end_irreversible_action, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_select_multiple", lg_gtk_file_chooser_set_select_multiple, 2, 0, 0, H_gtk_file_chooser_set_select_multiple, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_select_multiple", lg_gtk_file_chooser_get_select_multiple, 1, 0, 0, H_gtk_file_chooser_get_select_multiple, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_create_folders", lg_gtk_file_chooser_set_create_folders, 2, 0, 0, H_gtk_file_chooser_set_create_folders, pl_tub);
  s7_define_typed_function(sc, "gtk_file_chooser_get_create_folders", lg_gtk_file_chooser_get_create_folders, 1, 0, 0, H_gtk_file_chooser_get_create_folders, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_select_all", lg_gtk_file_chooser_select_all, 1, 0, 0, H_gtk_file_chooser_select_all, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_unselect_all", lg_gtk_file_chooser_unselect_all, 1, 0, 0, H_gtk_file_chooser_unselect_all, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_current_folder", lg_gtk_file_chooser_set_current_folder, 3, 0, 0, H_gtk_file_chooser_set_current_folder, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_current_folder", lg_gtk_file_chooser_get_current_folder, 1, 0, 0, H_gtk_file_chooser_get_current_folder, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_filter", lg_gtk_file_chooser_add_filter, 2, 0, 0, H_gtk_file_chooser_add_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_filter", lg_gtk_file_chooser_remove_filter, 2, 0, 0, H_gtk_file_chooser_remove_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_list_filters", lg_gtk_file_chooser_list_filters, 1, 0, 0, H_gtk_file_chooser_list_filters, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_set_filter", lg_gtk_file_chooser_set_filter, 2, 0, 0, H_gtk_file_chooser_set_filter, pl_tu);
  s7_define_typed_function(sc, "gtk_file_chooser_get_filter", lg_gtk_file_chooser_get_filter, 1, 0, 0, H_gtk_file_chooser_get_filter, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_shortcut_folder", lg_gtk_file_chooser_add_shortcut_folder, 3, 0, 0, H_gtk_file_chooser_add_shortcut_folder, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_shortcut_folder", lg_gtk_file_chooser_remove_shortcut_folder, 3, 0, 0, H_gtk_file_chooser_remove_shortcut_folder, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_list_shortcut_folders", lg_gtk_file_chooser_list_shortcut_folders, 1, 0, 0, H_gtk_file_chooser_list_shortcut_folders, pl_pu);
  s7_define_typed_function(sc, "gtk_file_chooser_add_choice", lg_gtk_file_chooser_add_choice, 5, 0, 0, H_gtk_file_chooser_add_choice, pl_tussu);
  s7_define_typed_function(sc, "gtk_file_chooser_remove_choice", lg_gtk_file_chooser_remove_choice, 2, 0, 0, H_gtk_file_chooser_remove_choice, pl_tus);
  s7_define_typed_function(sc, "gtk_file_chooser_set_choice", lg_gtk_file_chooser_set_choice, 3, 0, 0, H_gtk_file_chooser_set_choice, pl_tut);
  s7_define_typed_function(sc, "gtk_file_chooser_get_choice", lg_gtk_file_chooser_get_choice, 2, 0, 0, H_gtk_file_chooser_get_choice, pl_sus);
  s7_define_typed_function(sc, "gtk_popover_new", lg_gtk_popover_new, 0, 0, 0, H_gtk_popover_new, pl_p);
  s7_define_typed_function(sc, "gtk_popover_set_pointing_to", lg_gtk_popover_set_pointing_to, 2, 0, 0, H_gtk_popover_set_pointing_to, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_get_pointing_to", lg_gtk_popover_get_pointing_to, 2, 0, 0, H_gtk_popover_get_pointing_to, pl_bu);
  s7_define_typed_function(sc, "gtk_popover_set_position", lg_gtk_popover_set_position, 2, 0, 0, H_gtk_popover_set_position, pl_tug);
  s7_define_typed_function(sc, "gtk_popover_get_position", lg_gtk_popover_get_position, 1, 0, 0, H_gtk_popover_get_position, pl_gu);
  s7_define_typed_function(sc, "gtk_popover_set_autohide", lg_gtk_popover_set_autohide, 2, 0, 0, H_gtk_popover_set_autohide, pl_tub);
  s7_define_typed_function(sc, "gtk_popover_get_autohide", lg_gtk_popover_get_autohide, 1, 0, 0, H_gtk_popover_get_autohide, pl_bu);
  s7_define_typed_function(sc, "gtk_popover_set_has_arrow", lg_gtk_popover_set_has_arrow, 2, 0, 0, H_gtk_popover_set_has_arrow, pl_tub);
  s7_define_typed_function(sc, "gtk_popover_get_has_arrow", lg_gtk_popover_get_has_arrow, 1, 0, 0, H_gtk_popover_get_has_arrow, pl_bu);
  s7_define_typed_function(sc, "gtk_popover_popup", lg_gtk_popover_popup, 1, 0, 0, H_gtk_popover_popup, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_popdown", lg_gtk_popover_popdown, 1, 0, 0, H_gtk_popover_popdown, pl_tu);
  s7_define_typed_function(sc, "gtk_popover_set_default_widget", lg_gtk_popover_set_default_widget, 2, 0, 0, H_gtk_popover_set_default_widget, pl_tu);
  s7_define_typed_function(sc, "gtk_stack_page_get_visible", lg_gtk_stack_page_get_visible, 1, 0, 0, H_gtk_stack_page_get_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_stack_page_set_visible", lg_gtk_stack_page_set_visible, 2, 0, 0, H_gtk_stack_page_set_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_widget_class_set_template", lg_gtk_widget_class_set_template, 2, 0, 0, H_gtk_widget_class_set_template, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_should_layout", lg_gtk_widget_should_layout, 1, 0, 0, H_gtk_widget_should_layout, pl_bu);
  s7_define_typed_function(sc, "gtk_widget_get_css_name", lg_gtk_widget_get_css_name, 1, 0, 0, H_gtk_widget_get_css_name, pl_su);
  s7_define_typed_function(sc, "gtk_widget_add_css_class", lg_gtk_widget_add_css_class, 2, 0, 0, H_gtk_widget_add_css_class, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_remove_css_class", lg_gtk_widget_remove_css_class, 2, 0, 0, H_gtk_widget_remove_css_class, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_has_css_class", lg_gtk_widget_has_css_class, 2, 0, 0, H_gtk_widget_has_css_class, pl_bus);
  s7_define_typed_function(sc, "gtk_widget_get_css_classes", lg_gtk_widget_get_css_classes, 1, 0, 0, H_gtk_widget_get_css_classes, pl_pu);
  s7_define_typed_function(sc, "gtk_widget_set_css_classes", lg_gtk_widget_set_css_classes, 2, 0, 0, H_gtk_widget_set_css_classes, pl_tu);
  s7_define_typed_function(sc, "gtk_widget_class_install_action", lg_gtk_widget_class_install_action, 4, 0, 0, H_gtk_widget_class_install_action, pl_tusst);
  s7_define_typed_function(sc, "gtk_widget_class_install_property_action", lg_gtk_widget_class_install_property_action, 3, 0, 0, H_gtk_widget_class_install_property_action, pl_tus);
  s7_define_typed_function(sc, "gtk_widget_class_query_action", lg_gtk_widget_class_query_action, 6, 0, 0, H_gtk_widget_class_query_action, pl_buiuuut);
  s7_define_typed_function(sc, "gtk_widget_action_set_enabled", lg_gtk_widget_action_set_enabled, 3, 0, 0, H_gtk_widget_action_set_enabled, pl_tusb);
  s7_define_typed_function(sc, "gtk_widget_activate_action", lg_gtk_widget_activate_action, 3, 0, 0, H_gtk_widget_activate_action, pl_tusu);
  s7_define_typed_function(sc, "gtk_widget_activate_action_variant", lg_gtk_widget_activate_action_variant, 3, 0, 0, H_gtk_widget_activate_action_variant, pl_busu);
  s7_define_typed_function(sc, "gtk_widget_get_native", lg_gtk_widget_get_native, 1, 0, 0, H_gtk_widget_get_native, pl_pu);
  s7_define_typed_function(sc, "g_menu_new", lg_g_menu_new, 0, 0, 0, H_g_menu_new, pl_p);
  s7_define_typed_function(sc, "g_menu_freeze", lg_g_menu_freeze, 1, 0, 0, H_g_menu_freeze, pl_tu);
  s7_define_typed_function(sc, "g_menu_insert_item", lg_g_menu_insert_item, 3, 0, 0, H_g_menu_insert_item, pl_tuiu);
  s7_define_typed_function(sc, "g_menu_prepend_item", lg_g_menu_prepend_item, 2, 0, 0, H_g_menu_prepend_item, pl_tu);
  s7_define_typed_function(sc, "g_menu_append_item", lg_g_menu_append_item, 2, 0, 0, H_g_menu_append_item, pl_tu);
  s7_define_typed_function(sc, "g_menu_remove", lg_g_menu_remove, 2, 0, 0, H_g_menu_remove, pl_tui);
  s7_define_typed_function(sc, "g_menu_remove_all", lg_g_menu_remove_all, 1, 0, 0, H_g_menu_remove_all, pl_tu);
  s7_define_typed_function(sc, "g_menu_insert", lg_g_menu_insert, 4, 0, 0, H_g_menu_insert, pl_tuis);
  s7_define_typed_function(sc, "g_menu_prepend", lg_g_menu_prepend, 3, 0, 0, H_g_menu_prepend, pl_tus);
  s7_define_typed_function(sc, "g_menu_append", lg_g_menu_append, 3, 0, 0, H_g_menu_append, pl_tus);
  s7_define_typed_function(sc, "g_menu_insert_section", lg_g_menu_insert_section, 4, 0, 0, H_g_menu_insert_section, pl_tuisu);
  s7_define_typed_function(sc, "g_menu_prepend_section", lg_g_menu_prepend_section, 3, 0, 0, H_g_menu_prepend_section, pl_tusu);
  s7_define_typed_function(sc, "g_menu_append_section", lg_g_menu_append_section, 3, 0, 0, H_g_menu_append_section, pl_tusu);
  s7_define_typed_function(sc, "g_menu_insert_submenu", lg_g_menu_insert_submenu, 4, 0, 0, H_g_menu_insert_submenu, pl_tuisu);
  s7_define_typed_function(sc, "g_menu_prepend_submenu", lg_g_menu_prepend_submenu, 3, 0, 0, H_g_menu_prepend_submenu, pl_tusu);
  s7_define_typed_function(sc, "g_menu_append_submenu", lg_g_menu_append_submenu, 3, 0, 0, H_g_menu_append_submenu, pl_tusu);
  s7_define_typed_function(sc, "g_menu_item_new", lg_g_menu_item_new, 2, 0, 0, H_g_menu_item_new, pl_ps);
  s7_define_typed_function(sc, "g_menu_item_new_from_model", lg_g_menu_item_new_from_model, 2, 0, 0, H_g_menu_item_new_from_model, pl_pui);
  s7_define_typed_function(sc, "g_menu_item_new_submenu", lg_g_menu_item_new_submenu, 2, 0, 0, H_g_menu_item_new_submenu, pl_psu);
  s7_define_typed_function(sc, "g_menu_item_new_section", lg_g_menu_item_new_section, 2, 0, 0, H_g_menu_item_new_section, pl_psu);
  s7_define_typed_function(sc, "g_menu_item_get_attribute_value", lg_g_menu_item_get_attribute_value, 3, 0, 0, H_g_menu_item_get_attribute_value, pl_pusu);
  s7_define_typed_function(sc, "g_menu_item_get_link", lg_g_menu_item_get_link, 2, 0, 0, H_g_menu_item_get_link, pl_pus);
  s7_define_typed_function(sc, "g_menu_item_set_attribute_value", lg_g_menu_item_set_attribute_value, 3, 0, 0, H_g_menu_item_set_attribute_value, pl_tusu);
  s7_define_typed_function(sc, "g_menu_item_set_attribute", lg_g_menu_item_set_attribute, 3, 0, 0, H_g_menu_item_set_attribute, pl_tus);
  s7_define_typed_function(sc, "g_menu_item_set_link", lg_g_menu_item_set_link, 3, 0, 0, H_g_menu_item_set_link, pl_tusu);
  s7_define_typed_function(sc, "g_menu_item_set_label", lg_g_menu_item_set_label, 2, 0, 0, H_g_menu_item_set_label, pl_tut);
  s7_define_typed_function(sc, "g_menu_item_set_submenu", lg_g_menu_item_set_submenu, 2, 0, 0, H_g_menu_item_set_submenu, pl_tu);
  s7_define_typed_function(sc, "g_menu_item_set_section", lg_g_menu_item_set_section, 2, 0, 0, H_g_menu_item_set_section, pl_tu);
  s7_define_typed_function(sc, "g_menu_item_set_action_and_target_value", lg_g_menu_item_set_action_and_target_value, 4, 0, 0, H_g_menu_item_set_action_and_target_value, pl_tuttu);
  s7_define_typed_function(sc, "g_menu_item_set_action_and_target", lg_g_menu_item_set_action_and_target, 3, 0, 0, H_g_menu_item_set_action_and_target, pl_tust);
  s7_define_typed_function(sc, "g_menu_item_set_detailed_action", lg_g_menu_item_set_detailed_action, 2, 0, 0, H_g_menu_item_set_detailed_action, pl_tus);
  s7_define_typed_function(sc, "g_menu_item_set_icon", lg_g_menu_item_set_icon, 2, 0, 0, H_g_menu_item_set_icon, pl_tu);
  s7_define_typed_function(sc, "gtk_accelerator_get_default_mod_mask", lg_gtk_accelerator_get_default_mod_mask, 0, 0, 0, H_gtk_accelerator_get_default_mod_mask, pl_g);
  s7_define_typed_function(sc, "gdk_toplevel_inhibit_system_shortcuts", lg_gdk_toplevel_inhibit_system_shortcuts, 2, 0, 0, H_gdk_toplevel_inhibit_system_shortcuts, pl_tu);
  s7_define_typed_function(sc, "gdk_toplevel_restore_system_shortcuts", lg_gdk_toplevel_restore_system_shortcuts, 1, 0, 0, H_gdk_toplevel_restore_system_shortcuts, pl_tu);
  s7_define_typed_function(sc, "gtk_accelerator_valid", lg_gtk_accelerator_valid, 2, 0, 0, H_gtk_accelerator_valid, pl_big);
  s7_define_typed_function(sc, "gtk_accelerator_parse", lg_gtk_accelerator_parse, 3, 0, 0, H_gtk_accelerator_parse, pl_bsu);
  s7_define_typed_function(sc, "gtk_accelerator_set_default_mod_mask", lg_gtk_accelerator_set_default_mod_mask, 1, 0, 0, H_gtk_accelerator_set_default_mod_mask, pl_tg);
  s7_define_typed_function(sc, "gtk_flatten_list_model_get_model_for_item", lg_gtk_flatten_list_model_get_model_for_item, 2, 0, 0, H_gtk_flatten_list_model_get_model_for_item, pl_pui);
  s7_define_typed_function(sc, "gtk_menu_button_set_use_underline", lg_gtk_menu_button_set_use_underline, 2, 0, 0, H_gtk_menu_button_set_use_underline, pl_tub);
  s7_define_typed_function(sc, "gtk_menu_button_get_use_underline", lg_gtk_menu_button_get_use_underline, 1, 0, 0, H_gtk_menu_button_get_use_underline, pl_bu);
  s7_define_typed_function(sc, "gtk_popover_set_mnemonics_visible", lg_gtk_popover_set_mnemonics_visible, 2, 0, 0, H_gtk_popover_set_mnemonics_visible, pl_tub);
  s7_define_typed_function(sc, "gtk_popover_get_mnemonics_visible", lg_gtk_popover_get_mnemonics_visible, 1, 0, 0, H_gtk_popover_get_mnemonics_visible, pl_bu);
  s7_define_typed_function(sc, "gtk_shortcut_new", lg_gtk_shortcut_new, 2, 0, 0, H_gtk_shortcut_new, pl_pu);
  s7_define_typed_function(sc, "gtk_shortcut_get_trigger", lg_gtk_shortcut_get_trigger, 1, 0, 0, H_gtk_shortcut_get_trigger, pl_pu);
  s7_define_typed_function(sc, "gtk_shortcut_set_trigger", lg_gtk_shortcut_set_trigger, 2, 0, 0, H_gtk_shortcut_set_trigger, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_get_action", lg_gtk_shortcut_get_action, 1, 0, 0, H_gtk_shortcut_get_action, pl_pu);
  s7_define_typed_function(sc, "gtk_shortcut_set_action", lg_gtk_shortcut_set_action, 2, 0, 0, H_gtk_shortcut_set_action, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_get_arguments", lg_gtk_shortcut_get_arguments, 1, 0, 0, H_gtk_shortcut_get_arguments, pl_pu);
  s7_define_typed_function(sc, "gtk_shortcut_set_arguments", lg_gtk_shortcut_set_arguments, 2, 0, 0, H_gtk_shortcut_set_arguments, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_action_to_string", lg_gtk_shortcut_action_to_string, 1, 0, 0, H_gtk_shortcut_action_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_action_print", lg_gtk_shortcut_action_print, 2, 0, 0, H_gtk_shortcut_action_print, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_action_activate", lg_gtk_shortcut_action_activate, 4, 0, 0, H_gtk_shortcut_action_activate, pl_bugu);
  s7_define_typed_function(sc, "gtk_nothing_action_get", lg_gtk_nothing_action_get, 0, 0, 0, H_gtk_nothing_action_get, pl_p);
  s7_define_typed_function(sc, "gtk_callback_action_new", lg_gtk_callback_action_new, 3, 0, 0, H_gtk_callback_action_new, pl_pt);
  s7_define_typed_function(sc, "gtk_mnemonic_action_get", lg_gtk_mnemonic_action_get, 0, 0, 0, H_gtk_mnemonic_action_get, pl_p);
  s7_define_typed_function(sc, "gtk_activate_action_get", lg_gtk_activate_action_get, 0, 0, 0, H_gtk_activate_action_get, pl_p);
  s7_define_typed_function(sc, "gtk_signal_action_new", lg_gtk_signal_action_new, 1, 0, 0, H_gtk_signal_action_new, pl_ps);
  s7_define_typed_function(sc, "gtk_signal_action_get_signal_name", lg_gtk_signal_action_get_signal_name, 1, 0, 0, H_gtk_signal_action_get_signal_name, pl_su);
  s7_define_typed_function(sc, "gtk_named_action_new", lg_gtk_named_action_new, 1, 0, 0, H_gtk_named_action_new, pl_ps);
  s7_define_typed_function(sc, "gtk_named_action_get_action_name", lg_gtk_named_action_get_action_name, 1, 0, 0, H_gtk_named_action_get_action_name, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_controller_new", lg_gtk_shortcut_controller_new, 0, 0, 0, H_gtk_shortcut_controller_new, pl_p);
  s7_define_typed_function(sc, "gtk_shortcut_controller_new_for_model", lg_gtk_shortcut_controller_new_for_model, 1, 0, 0, H_gtk_shortcut_controller_new_for_model, pl_pu);
  s7_define_typed_function(sc, "gtk_shortcut_controller_set_mnemonics_modifiers", lg_gtk_shortcut_controller_set_mnemonics_modifiers, 2, 0, 0, H_gtk_shortcut_controller_set_mnemonics_modifiers, pl_tug);
  s7_define_typed_function(sc, "gtk_shortcut_controller_get_mnemonics_modifiers", lg_gtk_shortcut_controller_get_mnemonics_modifiers, 1, 0, 0, H_gtk_shortcut_controller_get_mnemonics_modifiers, pl_gu);
  s7_define_typed_function(sc, "gtk_shortcut_controller_set_scope", lg_gtk_shortcut_controller_set_scope, 2, 0, 0, H_gtk_shortcut_controller_set_scope, pl_tug);
  s7_define_typed_function(sc, "gtk_shortcut_controller_get_scope", lg_gtk_shortcut_controller_get_scope, 1, 0, 0, H_gtk_shortcut_controller_get_scope, pl_gu);
  s7_define_typed_function(sc, "gtk_shortcut_controller_add_shortcut", lg_gtk_shortcut_controller_add_shortcut, 2, 0, 0, H_gtk_shortcut_controller_add_shortcut, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_controller_remove_shortcut", lg_gtk_shortcut_controller_remove_shortcut, 2, 0, 0, H_gtk_shortcut_controller_remove_shortcut, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_parse_string", lg_gtk_shortcut_trigger_parse_string, 1, 0, 0, H_gtk_shortcut_trigger_parse_string, pl_ps);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_to_string", lg_gtk_shortcut_trigger_to_string, 1, 0, 0, H_gtk_shortcut_trigger_to_string, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_print", lg_gtk_shortcut_trigger_print, 2, 0, 0, H_gtk_shortcut_trigger_print, pl_tu);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_to_label", lg_gtk_shortcut_trigger_to_label, 2, 0, 0, H_gtk_shortcut_trigger_to_label, pl_su);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_print_label", lg_gtk_shortcut_trigger_print_label, 3, 0, 0, H_gtk_shortcut_trigger_print_label, pl_bu);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_hash", lg_gtk_shortcut_trigger_hash, 1, 0, 0, H_gtk_shortcut_trigger_hash, pl_it);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_equal", lg_gtk_shortcut_trigger_equal, 2, 0, 0, H_gtk_shortcut_trigger_equal, pl_bt);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_compare", lg_gtk_shortcut_trigger_compare, 2, 0, 0, H_gtk_shortcut_trigger_compare, pl_it);
  s7_define_typed_function(sc, "gtk_never_trigger_get", lg_gtk_never_trigger_get, 0, 0, 0, H_gtk_never_trigger_get, pl_p);
  s7_define_typed_function(sc, "gtk_keyval_trigger_new", lg_gtk_keyval_trigger_new, 2, 0, 0, H_gtk_keyval_trigger_new, pl_pig);
  s7_define_typed_function(sc, "gtk_keyval_trigger_get_modifiers", lg_gtk_keyval_trigger_get_modifiers, 1, 0, 0, H_gtk_keyval_trigger_get_modifiers, pl_gu);
  s7_define_typed_function(sc, "gtk_keyval_trigger_get_keyval", lg_gtk_keyval_trigger_get_keyval, 1, 0, 0, H_gtk_keyval_trigger_get_keyval, pl_iu);
  s7_define_typed_function(sc, "gtk_mnemonic_trigger_new", lg_gtk_mnemonic_trigger_new, 1, 0, 0, H_gtk_mnemonic_trigger_new, pl_pi);
  s7_define_typed_function(sc, "gtk_mnemonic_trigger_get_keyval", lg_gtk_mnemonic_trigger_get_keyval, 1, 0, 0, H_gtk_mnemonic_trigger_get_keyval, pl_iu);
  s7_define_typed_function(sc, "gtk_alternative_trigger_new", lg_gtk_alternative_trigger_new, 2, 0, 0, H_gtk_alternative_trigger_new, pl_pu);
  s7_define_typed_function(sc, "gtk_alternative_trigger_get_first", lg_gtk_alternative_trigger_get_first, 1, 0, 0, H_gtk_alternative_trigger_get_first, pl_pu);
  s7_define_typed_function(sc, "gtk_alternative_trigger_get_second", lg_gtk_alternative_trigger_get_second, 1, 0, 0, H_gtk_alternative_trigger_get_second, pl_pu);
  s7_define_typed_function(sc, "gtk_shortcut_trigger_trigger", lg_gtk_shortcut_trigger_trigger, 3, 0, 0, H_gtk_shortcut_trigger_trigger, pl_guub);
  s7_define_typed_function(sc, "gdk_device_get_caps_lock_state", lg_gdk_device_get_caps_lock_state, 1, 0, 0, H_gdk_device_get_caps_lock_state, pl_bu);
  s7_define_typed_function(sc, "gdk_device_get_num_lock_state", lg_gdk_device_get_num_lock_state, 1, 0, 0, H_gdk_device_get_num_lock_state, pl_bu);
  s7_define_typed_function(sc, "gdk_device_get_scroll_lock_state", lg_gdk_device_get_scroll_lock_state, 1, 0, 0, H_gdk_device_get_scroll_lock_state, pl_bu);
  s7_define_typed_function(sc, "gdk_device_get_modifier_state", lg_gdk_device_get_modifier_state, 1, 0, 0, H_gdk_device_get_modifier_state, pl_gu);
  s7_define_typed_function(sc, "gdk_device_get_direction", lg_gdk_device_get_direction, 1, 0, 0, H_gdk_device_get_direction, pl_gu);
  s7_define_typed_function(sc, "gdk_device_has_bidi_layouts", lg_gdk_device_has_bidi_layouts, 1, 0, 0, H_gdk_device_has_bidi_layouts, pl_bu);
  s7_define_typed_function(sc, "gdk_display_map_keyval", lg_gdk_display_map_keyval, 2, 2, 0, H_gdk_display_map_keyval, pl_puiu);
  s7_define_typed_function(sc, "gdk_display_map_keycode", lg_gdk_display_map_keycode, 2, 3, 0, H_gdk_display_map_keycode, pl_puiu);
  s7_define_typed_function(sc, "gdk_touchpad_event_get_pinch_angle_delta", lg_gdk_touchpad_event_get_pinch_angle_delta, 1, 0, 0, H_gdk_touchpad_event_get_pinch_angle_delta, pl_du);
  s7_define_typed_function(sc, "gdk_touchpad_event_get_pinch_scale", lg_gdk_touchpad_event_get_pinch_scale, 1, 0, 0, H_gdk_touchpad_event_get_pinch_scale, pl_du);
  s7_define_typed_function(sc, "gdk_pad_event_get_button", lg_gdk_pad_event_get_button, 1, 0, 0, H_gdk_pad_event_get_button, pl_iu);
  s7_define_typed_function(sc, "gdk_pad_event_get_axis_value", lg_gdk_pad_event_get_axis_value, 3, 0, 0, H_gdk_pad_event_get_axis_value, pl_tu);
  s7_define_typed_function(sc, "gdk_dnd_event_get_drop", lg_gdk_dnd_event_get_drop, 1, 0, 0, H_gdk_dnd_event_get_drop, pl_pu);
  s7_define_typed_function(sc, "gdk_grab_broken_event_get_implicit", lg_gdk_grab_broken_event_get_implicit, 1, 0, 0, H_gdk_grab_broken_event_get_implicit, pl_bu);
  s7_define_typed_function(sc, "gdk_key_event_matches", lg_gdk_key_event_matches, 3, 0, 0, H_gdk_key_event_matches, pl_guig);
  s7_define_typed_function(sc, "gdk_key_event_get_match", lg_gdk_key_event_get_match, 3, 0, 0, H_gdk_key_event_get_match, pl_bu);
  s7_define_typed_function(sc, "gtk_aspect_frame_new", lg_gtk_aspect_frame_new, 4, 0, 0, H_gtk_aspect_frame_new, pl_prrrb);
  s7_define_typed_function(sc, "gtk_aspect_frame_set_xalign", lg_gtk_aspect_frame_set_xalign, 2, 0, 0, H_gtk_aspect_frame_set_xalign, pl_tur);
  s7_define_typed_function(sc, "gtk_aspect_frame_get_xalign", lg_gtk_aspect_frame_get_xalign, 1, 0, 0, H_gtk_aspect_frame_get_xalign, pl_du);
  s7_define_typed_function(sc, "gtk_aspect_frame_set_yalign", lg_gtk_aspect_frame_set_yalign, 2, 0, 0, H_gtk_aspect_frame_set_yalign, pl_tur);
  s7_define_typed_function(sc, "gtk_aspect_frame_get_yalign", lg_gtk_aspect_frame_get_yalign, 1, 0, 0, H_gtk_aspect_frame_get_yalign, pl_du);
  s7_define_typed_function(sc, "gtk_aspect_frame_set_ratio", lg_gtk_aspect_frame_set_ratio, 2, 0, 0, H_gtk_aspect_frame_set_ratio, pl_tur);
  s7_define_typed_function(sc, "gtk_aspect_frame_get_ratio", lg_gtk_aspect_frame_get_ratio, 1, 0, 0, H_gtk_aspect_frame_get_ratio, pl_du);
  s7_define_typed_function(sc, "gtk_aspect_frame_set_obey_child", lg_gtk_aspect_frame_set_obey_child, 2, 0, 0, H_gtk_aspect_frame_set_obey_child, pl_tub);
  s7_define_typed_function(sc, "gtk_aspect_frame_get_obey_child", lg_gtk_aspect_frame_get_obey_child, 1, 0, 0, H_gtk_aspect_frame_get_obey_child, pl_bu);
  s7_define_typed_function(sc, "gtk_viewport_get_scroll_to_focus", lg_gtk_viewport_get_scroll_to_focus, 1, 0, 0, H_gtk_viewport_get_scroll_to_focus, pl_bu);
  s7_define_typed_function(sc, "gtk_viewport_set_scroll_to_focus", lg_gtk_viewport_set_scroll_to_focus, 2, 0, 0, H_gtk_viewport_set_scroll_to_focus, pl_tub);
  s7_define_typed_function(sc, "gtk_button_set_has_frame", lg_gtk_button_set_has_frame, 2, 0, 0, H_gtk_button_set_has_frame, pl_tub);
  s7_define_typed_function(sc, "gtk_button_get_has_frame", lg_gtk_button_get_has_frame, 1, 0, 0, H_gtk_button_get_has_frame, pl_bu);
  s7_define_typed_function(sc, "gtk_color_button_get_modal", lg_gtk_color_button_get_modal, 1, 0, 0, H_gtk_color_button_get_modal, pl_bu);
  s7_define_typed_function(sc, "gtk_color_button_set_modal", lg_gtk_color_button_set_modal, 2, 0, 0, H_gtk_color_button_set_modal, pl_tub);
  s7_define_typed_function(sc, "gtk_event_controller_get_current_event", lg_gtk_event_controller_get_current_event, 1, 0, 0, H_gtk_event_controller_get_current_event, pl_pu);
  s7_define_typed_function(sc, "gtk_event_controller_get_current_event_time", lg_gtk_event_controller_get_current_event_time, 1, 0, 0, H_gtk_event_controller_get_current_event_time, pl_iu);
  s7_define_typed_function(sc, "gtk_event_controller_get_current_event_device", lg_gtk_event_controller_get_current_event_device, 1, 0, 0, H_gtk_event_controller_get_current_event_device, pl_pu);
  s7_define_typed_function(sc, "gtk_event_controller_get_current_event_state", lg_gtk_event_controller_get_current_event_state, 1, 0, 0, H_gtk_event_controller_get_current_event_state, pl_gu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_get_modal", lg_gtk_file_chooser_button_get_modal, 1, 0, 0, H_gtk_file_chooser_button_get_modal, pl_bu);
  s7_define_typed_function(sc, "gtk_file_chooser_button_set_modal", lg_gtk_file_chooser_button_set_modal, 2, 0, 0, H_gtk_file_chooser_button_set_modal, pl_tub);
  s7_define_typed_function(sc, "gtk_font_button_get_modal", lg_gtk_font_button_get_modal, 1, 0, 0, H_gtk_font_button_get_modal, pl_bu);
  s7_define_typed_function(sc, "gtk_font_button_set_modal", lg_gtk_font_button_set_modal, 2, 0, 0, H_gtk_font_button_set_modal, pl_tub);
  s7_define_typed_function(sc, "gtk_menu_button_set_has_frame", lg_gtk_menu_button_set_has_frame, 2, 0, 0, H_gtk_menu_button_set_has_frame, pl_tub);
  s7_define_typed_function(sc, "gtk_menu_button_get_has_frame", lg_gtk_menu_button_get_has_frame, 1, 0, 0, H_gtk_menu_button_get_has_frame, pl_bu);
  s7_define_typed_function(sc, "gtk_scrolled_window_set_has_frame", lg_gtk_scrolled_window_set_has_frame, 2, 0, 0, H_gtk_scrolled_window_set_has_frame, pl_tub);
  s7_define_typed_function(sc, "gtk_scrolled_window_get_has_frame", lg_gtk_scrolled_window_get_has_frame, 1, 0, 0, H_gtk_scrolled_window_get_has_frame, pl_bu);
  s7_define_typed_function(sc, "gtk_shortcut_action_parse_string", lg_gtk_shortcut_action_parse_string, 1, 0, 0, H_gtk_shortcut_action_parse_string, pl_ps);
  s7_define_typed_function(sc, "gtk_show_uri_full_finish", lg_gtk_show_uri_full_finish, 2, 1, 0, H_gtk_show_uri_full_finish, pl_pu);
  s7_define_typed_function(sc, "gtk_show_uri", lg_gtk_show_uri, 3, 0, 0, H_gtk_show_uri, pl_tusi);
#endif

  s7_define_typed_function(sc, "cairo_create", lg_cairo_create, 1, 0, 0, H_cairo_create, pl_pu);
  s7_define_typed_function(sc, "cairo_version", lg_cairo_version, 0, 0, 0, H_cairo_version, pl_i);
  s7_define_typed_function(sc, "cairo_version_string", lg_cairo_version_string, 0, 0, 0, H_cairo_version_string, pl_s);
  s7_define_typed_function(sc, "cairo_reference", lg_cairo_reference, 1, 0, 0, H_cairo_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_destroy", lg_cairo_destroy, 1, 0, 0, H_cairo_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_save", lg_cairo_save, 1, 0, 0, H_cairo_save, pl_tu);
  s7_define_typed_function(sc, "cairo_restore", lg_cairo_restore, 1, 0, 0, H_cairo_restore, pl_tu);
  s7_define_typed_function(sc, "cairo_push_group", lg_cairo_push_group, 1, 0, 0, H_cairo_push_group, pl_tu);
  s7_define_typed_function(sc, "cairo_push_group_with_content", lg_cairo_push_group_with_content, 2, 0, 0, H_cairo_push_group_with_content, pl_tug);
  s7_define_typed_function(sc, "cairo_pop_group", lg_cairo_pop_group, 1, 0, 0, H_cairo_pop_group, pl_pu);
  s7_define_typed_function(sc, "cairo_pop_group_to_source", lg_cairo_pop_group_to_source, 1, 0, 0, H_cairo_pop_group_to_source, pl_tu);
  s7_define_typed_function(sc, "cairo_set_operator", lg_cairo_set_operator, 2, 0, 0, H_cairo_set_operator, pl_tug);
  s7_define_typed_function(sc, "cairo_set_source", lg_cairo_set_source, 2, 0, 0, H_cairo_set_source, pl_tu);
  s7_define_typed_function(sc, "cairo_set_source_rgb", lg_cairo_set_source_rgb, 4, 0, 0, H_cairo_set_source_rgb, pl_tur);
  s7_define_typed_function(sc, "cairo_set_source_rgba", lg_cairo_set_source_rgba, 5, 0, 0, H_cairo_set_source_rgba, pl_tur);
  s7_define_typed_function(sc, "cairo_set_source_surface", lg_cairo_set_source_surface, 4, 0, 0, H_cairo_set_source_surface, pl_tuur);
  s7_define_typed_function(sc, "cairo_set_tolerance", lg_cairo_set_tolerance, 2, 0, 0, H_cairo_set_tolerance, pl_tur);
  s7_define_typed_function(sc, "cairo_set_antialias", lg_cairo_set_antialias, 2, 0, 0, H_cairo_set_antialias, pl_tug);
  s7_define_typed_function(sc, "cairo_set_fill_rule", lg_cairo_set_fill_rule, 2, 0, 0, H_cairo_set_fill_rule, pl_tug);
  s7_define_typed_function(sc, "cairo_set_line_width", lg_cairo_set_line_width, 2, 0, 0, H_cairo_set_line_width, pl_tur);
  s7_define_typed_function(sc, "cairo_set_line_cap", lg_cairo_set_line_cap, 2, 0, 0, H_cairo_set_line_cap, pl_tug);
  s7_define_typed_function(sc, "cairo_set_line_join", lg_cairo_set_line_join, 2, 0, 0, H_cairo_set_line_join, pl_tug);
  s7_define_typed_function(sc, "cairo_set_dash", lg_cairo_set_dash, 4, 0, 0, H_cairo_set_dash, pl_tuuir);
  s7_define_typed_function(sc, "cairo_set_miter_limit", lg_cairo_set_miter_limit, 2, 0, 0, H_cairo_set_miter_limit, pl_tur);
  s7_define_typed_function(sc, "cairo_translate", lg_cairo_translate, 3, 0, 0, H_cairo_translate, pl_tur);
  s7_define_typed_function(sc, "cairo_scale", lg_cairo_scale, 3, 0, 0, H_cairo_scale, pl_tur);
  s7_define_typed_function(sc, "cairo_rotate", lg_cairo_rotate, 2, 0, 0, H_cairo_rotate, pl_tur);
  s7_define_typed_function(sc, "cairo_transform", lg_cairo_transform, 2, 0, 0, H_cairo_transform, pl_tu);
  s7_define_typed_function(sc, "cairo_set_matrix", lg_cairo_set_matrix, 2, 0, 0, H_cairo_set_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_identity_matrix", lg_cairo_identity_matrix, 1, 0, 0, H_cairo_identity_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_user_to_device", lg_cairo_user_to_device, 1, 2, 0, H_cairo_user_to_device, pl_pu);
  s7_define_typed_function(sc, "cairo_user_to_device_distance", lg_cairo_user_to_device_distance, 1, 2, 0, H_cairo_user_to_device_distance, pl_pu);
  s7_define_typed_function(sc, "cairo_device_to_user", lg_cairo_device_to_user, 1, 2, 0, H_cairo_device_to_user, pl_pu);
  s7_define_typed_function(sc, "cairo_device_to_user_distance", lg_cairo_device_to_user_distance, 1, 2, 0, H_cairo_device_to_user_distance, pl_pu);
  s7_define_typed_function(sc, "cairo_new_path", lg_cairo_new_path, 1, 0, 0, H_cairo_new_path, pl_tu);
  s7_define_typed_function(sc, "cairo_move_to", lg_cairo_move_to, 3, 0, 0, H_cairo_move_to, pl_tur);
  s7_define_typed_function(sc, "cairo_new_sub_path", lg_cairo_new_sub_path, 1, 0, 0, H_cairo_new_sub_path, pl_tu);
  s7_define_typed_function(sc, "cairo_line_to", lg_cairo_line_to, 3, 0, 0, H_cairo_line_to, pl_tur);
  s7_define_typed_function(sc, "cairo_curve_to", lg_cairo_curve_to, 7, 0, 0, H_cairo_curve_to, pl_tur);
  s7_define_typed_function(sc, "cairo_arc", lg_cairo_arc, 6, 0, 0, H_cairo_arc, pl_tur);
  s7_define_typed_function(sc, "cairo_arc_negative", lg_cairo_arc_negative, 6, 0, 0, H_cairo_arc_negative, pl_tur);
  s7_define_typed_function(sc, "cairo_rel_move_to", lg_cairo_rel_move_to, 3, 0, 0, H_cairo_rel_move_to, pl_tur);
  s7_define_typed_function(sc, "cairo_rel_line_to", lg_cairo_rel_line_to, 3, 0, 0, H_cairo_rel_line_to, pl_tur);
  s7_define_typed_function(sc, "cairo_rel_curve_to", lg_cairo_rel_curve_to, 7, 0, 0, H_cairo_rel_curve_to, pl_tur);
  s7_define_typed_function(sc, "cairo_rectangle", lg_cairo_rectangle, 5, 0, 0, H_cairo_rectangle, pl_tur);
  s7_define_typed_function(sc, "cairo_close_path", lg_cairo_close_path, 1, 0, 0, H_cairo_close_path, pl_tu);
  s7_define_typed_function(sc, "cairo_paint", lg_cairo_paint, 1, 0, 0, H_cairo_paint, pl_tu);
  s7_define_typed_function(sc, "cairo_paint_with_alpha", lg_cairo_paint_with_alpha, 2, 0, 0, H_cairo_paint_with_alpha, pl_tur);
  s7_define_typed_function(sc, "cairo_mask", lg_cairo_mask, 2, 0, 0, H_cairo_mask, pl_tu);
  s7_define_typed_function(sc, "cairo_mask_surface", lg_cairo_mask_surface, 4, 0, 0, H_cairo_mask_surface, pl_tuur);
  s7_define_typed_function(sc, "cairo_stroke", lg_cairo_stroke, 1, 0, 0, H_cairo_stroke, pl_tu);
  s7_define_typed_function(sc, "cairo_stroke_preserve", lg_cairo_stroke_preserve, 1, 0, 0, H_cairo_stroke_preserve, pl_tu);
  s7_define_typed_function(sc, "cairo_fill", lg_cairo_fill, 1, 0, 0, H_cairo_fill, pl_tu);
  s7_define_typed_function(sc, "cairo_fill_preserve", lg_cairo_fill_preserve, 1, 0, 0, H_cairo_fill_preserve, pl_tu);
  s7_define_typed_function(sc, "cairo_copy_page", lg_cairo_copy_page, 1, 0, 0, H_cairo_copy_page, pl_tu);
  s7_define_typed_function(sc, "cairo_show_page", lg_cairo_show_page, 1, 0, 0, H_cairo_show_page, pl_tu);
  s7_define_typed_function(sc, "cairo_in_stroke", lg_cairo_in_stroke, 3, 0, 0, H_cairo_in_stroke, pl_bur);
  s7_define_typed_function(sc, "cairo_in_fill", lg_cairo_in_fill, 3, 0, 0, H_cairo_in_fill, pl_bur);
  s7_define_typed_function(sc, "cairo_reset_clip", lg_cairo_reset_clip, 1, 0, 0, H_cairo_reset_clip, pl_tu);
  s7_define_typed_function(sc, "cairo_clip", lg_cairo_clip, 1, 0, 0, H_cairo_clip, pl_tu);
  s7_define_typed_function(sc, "cairo_clip_preserve", lg_cairo_clip_preserve, 1, 0, 0, H_cairo_clip_preserve, pl_tu);
  s7_define_typed_function(sc, "cairo_font_options_create", lg_cairo_font_options_create, 0, 0, 0, H_cairo_font_options_create, pl_p);
  s7_define_typed_function(sc, "cairo_font_options_copy", lg_cairo_font_options_copy, 1, 0, 0, H_cairo_font_options_copy, pl_pu);
  s7_define_typed_function(sc, "cairo_font_options_destroy", lg_cairo_font_options_destroy, 1, 0, 0, H_cairo_font_options_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_font_options_status", lg_cairo_font_options_status, 1, 0, 0, H_cairo_font_options_status, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_merge", lg_cairo_font_options_merge, 2, 0, 0, H_cairo_font_options_merge, pl_tu);
  s7_define_typed_function(sc, "cairo_font_options_equal", lg_cairo_font_options_equal, 2, 0, 0, H_cairo_font_options_equal, pl_bu);
  s7_define_typed_function(sc, "cairo_font_options_hash", lg_cairo_font_options_hash, 1, 0, 0, H_cairo_font_options_hash, pl_iu);
  s7_define_typed_function(sc, "cairo_font_options_set_antialias", lg_cairo_font_options_set_antialias, 2, 0, 0, H_cairo_font_options_set_antialias, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_antialias", lg_cairo_font_options_get_antialias, 1, 0, 0, H_cairo_font_options_get_antialias, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_set_subpixel_order", lg_cairo_font_options_set_subpixel_order, 2, 0, 0, H_cairo_font_options_set_subpixel_order, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_subpixel_order", lg_cairo_font_options_get_subpixel_order, 1, 0, 0, H_cairo_font_options_get_subpixel_order, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_set_hint_style", lg_cairo_font_options_set_hint_style, 2, 0, 0, H_cairo_font_options_set_hint_style, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_hint_style", lg_cairo_font_options_get_hint_style, 1, 0, 0, H_cairo_font_options_get_hint_style, pl_gu);
  s7_define_typed_function(sc, "cairo_font_options_set_hint_metrics", lg_cairo_font_options_set_hint_metrics, 2, 0, 0, H_cairo_font_options_set_hint_metrics, pl_tug);
  s7_define_typed_function(sc, "cairo_font_options_get_hint_metrics", lg_cairo_font_options_get_hint_metrics, 1, 0, 0, H_cairo_font_options_get_hint_metrics, pl_gu);
  s7_define_typed_function(sc, "cairo_select_font_face", lg_cairo_select_font_face, 4, 0, 0, H_cairo_select_font_face, pl_tusg);
  s7_define_typed_function(sc, "cairo_set_font_size", lg_cairo_set_font_size, 2, 0, 0, H_cairo_set_font_size, pl_tur);
  s7_define_typed_function(sc, "cairo_set_font_matrix", lg_cairo_set_font_matrix, 2, 0, 0, H_cairo_set_font_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_get_font_matrix", lg_cairo_get_font_matrix, 2, 0, 0, H_cairo_get_font_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_set_font_options", lg_cairo_set_font_options, 2, 0, 0, H_cairo_set_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_get_font_options", lg_cairo_get_font_options, 2, 0, 0, H_cairo_get_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_set_scaled_font", lg_cairo_set_scaled_font, 2, 0, 0, H_cairo_set_scaled_font, pl_tu);
  s7_define_typed_function(sc, "cairo_show_text", lg_cairo_show_text, 2, 0, 0, H_cairo_show_text, pl_tus);
  s7_define_typed_function(sc, "cairo_show_glyphs", lg_cairo_show_glyphs, 3, 0, 0, H_cairo_show_glyphs, pl_tuui);
  s7_define_typed_function(sc, "cairo_get_font_face", lg_cairo_get_font_face, 1, 0, 0, H_cairo_get_font_face, pl_pu);
  s7_define_typed_function(sc, "cairo_font_extents", lg_cairo_font_extents, 2, 0, 0, H_cairo_font_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_set_font_face", lg_cairo_set_font_face, 2, 0, 0, H_cairo_set_font_face, pl_tu);
  s7_define_typed_function(sc, "cairo_text_extents", lg_cairo_text_extents, 3, 0, 0, H_cairo_text_extents, pl_tusu);
  s7_define_typed_function(sc, "cairo_glyph_extents", lg_cairo_glyph_extents, 4, 0, 0, H_cairo_glyph_extents, pl_tuuiu);
  s7_define_typed_function(sc, "cairo_text_path", lg_cairo_text_path, 2, 0, 0, H_cairo_text_path, pl_tus);
  s7_define_typed_function(sc, "cairo_glyph_path", lg_cairo_glyph_path, 3, 0, 0, H_cairo_glyph_path, pl_tuui);
  s7_define_typed_function(sc, "cairo_font_face_reference", lg_cairo_font_face_reference, 1, 0, 0, H_cairo_font_face_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_font_face_destroy", lg_cairo_font_face_destroy, 1, 0, 0, H_cairo_font_face_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_font_face_status", lg_cairo_font_face_status, 1, 0, 0, H_cairo_font_face_status, pl_gu);
  s7_define_typed_function(sc, "cairo_font_face_get_user_data", lg_cairo_font_face_get_user_data, 2, 0, 0, H_cairo_font_face_get_user_data, pl_tu);
  s7_define_typed_function(sc, "cairo_font_face_set_user_data", lg_cairo_font_face_set_user_data, 4, 0, 0, H_cairo_font_face_set_user_data, pl_guut);
  s7_define_typed_function(sc, "cairo_scaled_font_create", lg_cairo_scaled_font_create, 4, 0, 0, H_cairo_scaled_font_create, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_reference", lg_cairo_scaled_font_reference, 1, 0, 0, H_cairo_scaled_font_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_destroy", lg_cairo_scaled_font_destroy, 1, 0, 0, H_cairo_scaled_font_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_status", lg_cairo_scaled_font_status, 1, 0, 0, H_cairo_scaled_font_status, pl_gu);
  s7_define_typed_function(sc, "cairo_scaled_font_extents", lg_cairo_scaled_font_extents, 2, 0, 0, H_cairo_scaled_font_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_text_extents", lg_cairo_scaled_font_text_extents, 3, 0, 0, H_cairo_scaled_font_text_extents, pl_tusu);
  s7_define_typed_function(sc, "cairo_scaled_font_glyph_extents", lg_cairo_scaled_font_glyph_extents, 4, 0, 0, H_cairo_scaled_font_glyph_extents, pl_tuuiu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_font_face", lg_cairo_scaled_font_get_font_face, 1, 0, 0, H_cairo_scaled_font_get_font_face, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_font_matrix", lg_cairo_scaled_font_get_font_matrix, 2, 0, 0, H_cairo_scaled_font_get_font_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_ctm", lg_cairo_scaled_font_get_ctm, 2, 0, 0, H_cairo_scaled_font_get_ctm, pl_tu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_font_options", lg_cairo_scaled_font_get_font_options, 2, 0, 0, H_cairo_scaled_font_get_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_get_operator", lg_cairo_get_operator, 1, 0, 0, H_cairo_get_operator, pl_gu);
  s7_define_typed_function(sc, "cairo_get_source", lg_cairo_get_source, 1, 0, 0, H_cairo_get_source, pl_pu);
  s7_define_typed_function(sc, "cairo_get_tolerance", lg_cairo_get_tolerance, 1, 0, 0, H_cairo_get_tolerance, pl_du);
  s7_define_typed_function(sc, "cairo_get_antialias", lg_cairo_get_antialias, 1, 0, 0, H_cairo_get_antialias, pl_gu);
  s7_define_typed_function(sc, "cairo_get_current_point", lg_cairo_get_current_point, 1, 2, 0, H_cairo_get_current_point, pl_pu);
  s7_define_typed_function(sc, "cairo_get_fill_rule", lg_cairo_get_fill_rule, 1, 0, 0, H_cairo_get_fill_rule, pl_gu);
  s7_define_typed_function(sc, "cairo_get_line_width", lg_cairo_get_line_width, 1, 0, 0, H_cairo_get_line_width, pl_du);
  s7_define_typed_function(sc, "cairo_get_line_cap", lg_cairo_get_line_cap, 1, 0, 0, H_cairo_get_line_cap, pl_gu);
  s7_define_typed_function(sc, "cairo_get_line_join", lg_cairo_get_line_join, 1, 0, 0, H_cairo_get_line_join, pl_gu);
  s7_define_typed_function(sc, "cairo_get_miter_limit", lg_cairo_get_miter_limit, 1, 0, 0, H_cairo_get_miter_limit, pl_du);
  s7_define_typed_function(sc, "cairo_get_matrix", lg_cairo_get_matrix, 2, 0, 0, H_cairo_get_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_get_target", lg_cairo_get_target, 1, 0, 0, H_cairo_get_target, pl_pu);
  s7_define_typed_function(sc, "cairo_get_group_target", lg_cairo_get_group_target, 1, 0, 0, H_cairo_get_group_target, pl_pu);
  s7_define_typed_function(sc, "cairo_copy_path", lg_cairo_copy_path, 1, 0, 0, H_cairo_copy_path, pl_pu);
  s7_define_typed_function(sc, "cairo_copy_path_flat", lg_cairo_copy_path_flat, 1, 0, 0, H_cairo_copy_path_flat, pl_pu);
  s7_define_typed_function(sc, "cairo_append_path", lg_cairo_append_path, 2, 0, 0, H_cairo_append_path, pl_tu);
  s7_define_typed_function(sc, "cairo_path_destroy", lg_cairo_path_destroy, 1, 0, 0, H_cairo_path_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_status", lg_cairo_status, 1, 0, 0, H_cairo_status, pl_gu);
  s7_define_typed_function(sc, "cairo_status_to_string", lg_cairo_status_to_string, 1, 0, 0, H_cairo_status_to_string, pl_sg);
  s7_define_typed_function(sc, "cairo_surface_create_similar", lg_cairo_surface_create_similar, 4, 0, 0, H_cairo_surface_create_similar, pl_pugi);
  s7_define_typed_function(sc, "cairo_surface_reference", lg_cairo_surface_reference, 1, 0, 0, H_cairo_surface_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_finish", lg_cairo_surface_finish, 1, 0, 0, H_cairo_surface_finish, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_destroy", lg_cairo_surface_destroy, 1, 0, 0, H_cairo_surface_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_status", lg_cairo_surface_status, 1, 0, 0, H_cairo_surface_status, pl_gu);
  s7_define_typed_function(sc, "cairo_surface_get_content", lg_cairo_surface_get_content, 1, 0, 0, H_cairo_surface_get_content, pl_gu);
  s7_define_typed_function(sc, "cairo_surface_get_font_options", lg_cairo_surface_get_font_options, 2, 0, 0, H_cairo_surface_get_font_options, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_flush", lg_cairo_surface_flush, 1, 0, 0, H_cairo_surface_flush, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_mark_dirty", lg_cairo_surface_mark_dirty, 1, 0, 0, H_cairo_surface_mark_dirty, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_mark_dirty_rectangle", lg_cairo_surface_mark_dirty_rectangle, 5, 0, 0, H_cairo_surface_mark_dirty_rectangle, pl_tui);
  s7_define_typed_function(sc, "cairo_surface_set_device_offset", lg_cairo_surface_set_device_offset, 3, 0, 0, H_cairo_surface_set_device_offset, pl_tur);
  s7_define_typed_function(sc, "cairo_surface_get_device_offset", lg_cairo_surface_get_device_offset, 1, 2, 0, H_cairo_surface_get_device_offset, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_set_fallback_resolution", lg_cairo_surface_set_fallback_resolution, 3, 0, 0, H_cairo_surface_set_fallback_resolution, pl_tur);
  s7_define_typed_function(sc, "cairo_image_surface_create", lg_cairo_image_surface_create, 3, 0, 0, H_cairo_image_surface_create, pl_pgi);
  s7_define_typed_function(sc, "cairo_image_surface_create_for_data", lg_cairo_image_surface_create_for_data, 5, 0, 0, H_cairo_image_surface_create_for_data, pl_psgi);
  s7_define_typed_function(sc, "cairo_image_surface_get_data", lg_cairo_image_surface_get_data, 1, 0, 0, H_cairo_image_surface_get_data, pl_su);
  s7_define_typed_function(sc, "cairo_image_surface_get_format", lg_cairo_image_surface_get_format, 1, 0, 0, H_cairo_image_surface_get_format, pl_gu);
  s7_define_typed_function(sc, "cairo_image_surface_get_width", lg_cairo_image_surface_get_width, 1, 0, 0, H_cairo_image_surface_get_width, pl_iu);
  s7_define_typed_function(sc, "cairo_image_surface_get_height", lg_cairo_image_surface_get_height, 1, 0, 0, H_cairo_image_surface_get_height, pl_iu);
  s7_define_typed_function(sc, "cairo_image_surface_get_stride", lg_cairo_image_surface_get_stride, 1, 0, 0, H_cairo_image_surface_get_stride, pl_iu);
  s7_define_typed_function(sc, "cairo_pattern_create_rgb", lg_cairo_pattern_create_rgb, 3, 0, 0, H_cairo_pattern_create_rgb, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_create_rgba", lg_cairo_pattern_create_rgba, 4, 0, 0, H_cairo_pattern_create_rgba, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_create_for_surface", lg_cairo_pattern_create_for_surface, 1, 0, 0, H_cairo_pattern_create_for_surface, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_create_linear", lg_cairo_pattern_create_linear, 4, 0, 0, H_cairo_pattern_create_linear, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_create_radial", lg_cairo_pattern_create_radial, 6, 0, 0, H_cairo_pattern_create_radial, pl_pr);
  s7_define_typed_function(sc, "cairo_pattern_reference", lg_cairo_pattern_reference, 1, 0, 0, H_cairo_pattern_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_destroy", lg_cairo_pattern_destroy, 1, 0, 0, H_cairo_pattern_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_pattern_status", lg_cairo_pattern_status, 1, 0, 0, H_cairo_pattern_status, pl_gu);
  s7_define_typed_function(sc, "cairo_pattern_add_color_stop_rgb", lg_cairo_pattern_add_color_stop_rgb, 5, 0, 0, H_cairo_pattern_add_color_stop_rgb, pl_tur);
  s7_define_typed_function(sc, "cairo_pattern_add_color_stop_rgba", lg_cairo_pattern_add_color_stop_rgba, 6, 0, 0, H_cairo_pattern_add_color_stop_rgba, pl_tur);
  s7_define_typed_function(sc, "cairo_pattern_set_matrix", lg_cairo_pattern_set_matrix, 2, 0, 0, H_cairo_pattern_set_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_pattern_get_matrix", lg_cairo_pattern_get_matrix, 2, 0, 0, H_cairo_pattern_get_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_pattern_set_extend", lg_cairo_pattern_set_extend, 2, 0, 0, H_cairo_pattern_set_extend, pl_tug);
  s7_define_typed_function(sc, "cairo_pattern_get_extend", lg_cairo_pattern_get_extend, 1, 0, 0, H_cairo_pattern_get_extend, pl_gu);
  s7_define_typed_function(sc, "cairo_pattern_set_filter", lg_cairo_pattern_set_filter, 2, 0, 0, H_cairo_pattern_set_filter, pl_tug);
  s7_define_typed_function(sc, "cairo_pattern_get_filter", lg_cairo_pattern_get_filter, 1, 0, 0, H_cairo_pattern_get_filter, pl_gu);
  s7_define_typed_function(sc, "cairo_matrix_init", lg_cairo_matrix_init, 7, 0, 0, H_cairo_matrix_init, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_init_identity", lg_cairo_matrix_init_identity, 1, 0, 0, H_cairo_matrix_init_identity, pl_tu);
  s7_define_typed_function(sc, "cairo_matrix_init_translate", lg_cairo_matrix_init_translate, 3, 0, 0, H_cairo_matrix_init_translate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_init_scale", lg_cairo_matrix_init_scale, 3, 0, 0, H_cairo_matrix_init_scale, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_init_rotate", lg_cairo_matrix_init_rotate, 2, 0, 0, H_cairo_matrix_init_rotate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_translate", lg_cairo_matrix_translate, 3, 0, 0, H_cairo_matrix_translate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_scale", lg_cairo_matrix_scale, 3, 0, 0, H_cairo_matrix_scale, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_rotate", lg_cairo_matrix_rotate, 2, 0, 0, H_cairo_matrix_rotate, pl_tur);
  s7_define_typed_function(sc, "cairo_matrix_invert", lg_cairo_matrix_invert, 1, 0, 0, H_cairo_matrix_invert, pl_gu);
  s7_define_typed_function(sc, "cairo_matrix_multiply", lg_cairo_matrix_multiply, 3, 0, 0, H_cairo_matrix_multiply, pl_tu);
  s7_define_typed_function(sc, "cairo_matrix_transform_distance", lg_cairo_matrix_transform_distance, 1, 2, 0, H_cairo_matrix_transform_distance, pl_pu);
  s7_define_typed_function(sc, "cairo_matrix_transform_point", lg_cairo_matrix_transform_point, 1, 2, 0, H_cairo_matrix_transform_point, pl_pu);
  s7_define_typed_function(sc, "cairo_get_reference_count", lg_cairo_get_reference_count, 1, 0, 0, H_cairo_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_get_user_data", lg_cairo_get_user_data, 2, 0, 0, H_cairo_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_set_user_data", lg_cairo_set_user_data, 4, 0, 0, H_cairo_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_clip_extents", lg_cairo_clip_extents, 1, 4, 0, H_cairo_clip_extents, pl_pu);
  s7_define_typed_function(sc, "cairo_copy_clip_rectangle_list", lg_cairo_copy_clip_rectangle_list, 1, 0, 0, H_cairo_copy_clip_rectangle_list, pl_pu);
  s7_define_typed_function(sc, "cairo_rectangle_list_destroy", lg_cairo_rectangle_list_destroy, 1, 0, 0, H_cairo_rectangle_list_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_font_face_get_reference_count", lg_cairo_font_face_get_reference_count, 1, 0, 0, H_cairo_font_face_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_reference_count", lg_cairo_scaled_font_get_reference_count, 1, 0, 0, H_cairo_scaled_font_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_user_data", lg_cairo_scaled_font_get_user_data, 2, 0, 0, H_cairo_scaled_font_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_scaled_font_set_user_data", lg_cairo_scaled_font_set_user_data, 4, 0, 0, H_cairo_scaled_font_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_get_dash_count", lg_cairo_get_dash_count, 1, 0, 0, H_cairo_get_dash_count, pl_iu);
  s7_define_typed_function(sc, "cairo_get_dash", lg_cairo_get_dash, 1, 2, 0, H_cairo_get_dash, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_get_reference_count", lg_cairo_surface_get_reference_count, 1, 0, 0, H_cairo_surface_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_pattern_get_reference_count", lg_cairo_pattern_get_reference_count, 1, 0, 0, H_cairo_pattern_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_pattern_get_user_data", lg_cairo_pattern_get_user_data, 2, 0, 0, H_cairo_pattern_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_set_user_data", lg_cairo_pattern_set_user_data, 4, 0, 0, H_cairo_pattern_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_pattern_get_rgba", lg_cairo_pattern_get_rgba, 1, 4, 0, H_cairo_pattern_get_rgba, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_surface", lg_cairo_pattern_get_surface, 1, 1, 0, H_cairo_pattern_get_surface, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_color_stop_rgba", lg_cairo_pattern_get_color_stop_rgba, 2, 5, 0, H_cairo_pattern_get_color_stop_rgba, pl_puiu);
  s7_define_typed_function(sc, "cairo_pattern_get_color_stop_count", lg_cairo_pattern_get_color_stop_count, 1, 1, 0, H_cairo_pattern_get_color_stop_count, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_linear_points", lg_cairo_pattern_get_linear_points, 1, 4, 0, H_cairo_pattern_get_linear_points, pl_pu);
  s7_define_typed_function(sc, "cairo_pattern_get_radial_circles", lg_cairo_pattern_get_radial_circles, 1, 6, 0, H_cairo_pattern_get_radial_circles, pl_pu);
  s7_define_typed_function(sc, "cairo_get_scaled_font", lg_cairo_get_scaled_font, 1, 0, 0, H_cairo_get_scaled_font, pl_pu);
  s7_define_typed_function(sc, "cairo_path_extents", lg_cairo_path_extents, 1, 4, 0, H_cairo_path_extents, pl_pu);
  s7_define_typed_function(sc, "cairo_has_current_point", lg_cairo_has_current_point, 1, 0, 0, H_cairo_has_current_point, pl_bu);
  s7_define_typed_function(sc, "cairo_surface_copy_page", lg_cairo_surface_copy_page, 1, 0, 0, H_cairo_surface_copy_page, pl_tu);
  s7_define_typed_function(sc, "cairo_surface_show_page", lg_cairo_surface_show_page, 1, 0, 0, H_cairo_surface_show_page, pl_tu);
  s7_define_typed_function(sc, "cairo_format_stride_for_width", lg_cairo_format_stride_for_width, 2, 0, 0, H_cairo_format_stride_for_width, pl_igi);
  s7_define_typed_function(sc, "cairo_glyph_allocate", lg_cairo_glyph_allocate, 1, 0, 0, H_cairo_glyph_allocate, pl_pi);
  s7_define_typed_function(sc, "cairo_glyph_free", lg_cairo_glyph_free, 1, 0, 0, H_cairo_glyph_free, pl_tu);
  s7_define_typed_function(sc, "cairo_text_cluster_allocate", lg_cairo_text_cluster_allocate, 1, 0, 0, H_cairo_text_cluster_allocate, pl_pi);
  s7_define_typed_function(sc, "cairo_text_cluster_free", lg_cairo_text_cluster_free, 1, 0, 0, H_cairo_text_cluster_free, pl_tu);
  s7_define_typed_function(sc, "cairo_show_text_glyphs", lg_cairo_show_text_glyphs, 0, 0, 1, H_cairo_show_text_glyphs, pl_tusiuiui);
  s7_define_typed_function(sc, "cairo_scaled_font_text_to_glyphs", lg_cairo_scaled_font_text_to_glyphs, 0, 0, 1, H_cairo_scaled_font_text_to_glyphs, pl_gurrsiu);
  s7_define_typed_function(sc, "cairo_scaled_font_get_scale_matrix", lg_cairo_scaled_font_get_scale_matrix, 2, 0, 0, H_cairo_scaled_font_get_scale_matrix, pl_tu);
  s7_define_typed_function(sc, "cairo_toy_font_face_create", lg_cairo_toy_font_face_create, 3, 0, 0, H_cairo_toy_font_face_create, pl_psg);
  s7_define_typed_function(sc, "cairo_toy_font_face_get_family", lg_cairo_toy_font_face_get_family, 1, 0, 0, H_cairo_toy_font_face_get_family, pl_su);
  s7_define_typed_function(sc, "cairo_toy_font_face_get_slant", lg_cairo_toy_font_face_get_slant, 1, 0, 0, H_cairo_toy_font_face_get_slant, pl_gu);
  s7_define_typed_function(sc, "cairo_toy_font_face_get_weight", lg_cairo_toy_font_face_get_weight, 1, 0, 0, H_cairo_toy_font_face_get_weight, pl_gu);
  s7_define_typed_function(sc, "cairo_user_font_face_create", lg_cairo_user_font_face_create, 0, 0, 0, H_cairo_user_font_face_create, pl_p);
  s7_define_typed_function(sc, "cairo_surface_get_fallback_resolution", lg_cairo_surface_get_fallback_resolution, 1, 2, 0, H_cairo_surface_get_fallback_resolution, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_has_show_text_glyphs", lg_cairo_surface_has_show_text_glyphs, 1, 0, 0, H_cairo_surface_has_show_text_glyphs, pl_iu);
  s7_define_typed_function(sc, "cairo_in_clip", lg_cairo_in_clip, 3, 0, 0, H_cairo_in_clip, pl_iur);
  s7_define_typed_function(sc, "cairo_device_reference", lg_cairo_device_reference, 1, 0, 0, H_cairo_device_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_device_status", lg_cairo_device_status, 1, 0, 0, H_cairo_device_status, pl_gu);
  s7_define_typed_function(sc, "cairo_device_acquire", lg_cairo_device_acquire, 1, 0, 0, H_cairo_device_acquire, pl_gu);
  s7_define_typed_function(sc, "cairo_device_release", lg_cairo_device_release, 1, 0, 0, H_cairo_device_release, pl_tu);
  s7_define_typed_function(sc, "cairo_device_flush", lg_cairo_device_flush, 1, 0, 0, H_cairo_device_flush, pl_tu);
  s7_define_typed_function(sc, "cairo_device_finish", lg_cairo_device_finish, 1, 0, 0, H_cairo_device_finish, pl_tu);
  s7_define_typed_function(sc, "cairo_device_destroy", lg_cairo_device_destroy, 1, 0, 0, H_cairo_device_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_device_get_reference_count", lg_cairo_device_get_reference_count, 1, 0, 0, H_cairo_device_get_reference_count, pl_iu);
  s7_define_typed_function(sc, "cairo_device_get_user_data", lg_cairo_device_get_user_data, 2, 0, 0, H_cairo_device_get_user_data, pl_pu);
  s7_define_typed_function(sc, "cairo_device_set_user_data", lg_cairo_device_set_user_data, 4, 0, 0, H_cairo_device_set_user_data, pl_guuut);
  s7_define_typed_function(sc, "cairo_surface_create_for_rectangle", lg_cairo_surface_create_for_rectangle, 5, 0, 0, H_cairo_surface_create_for_rectangle, pl_pur);
  s7_define_typed_function(sc, "cairo_surface_get_device", lg_cairo_surface_get_device, 1, 0, 0, H_cairo_surface_get_device, pl_pu);
  s7_define_typed_function(sc, "cairo_surface_set_mime_data", lg_cairo_surface_set_mime_data, 6, 0, 0, H_cairo_surface_set_mime_data, pl_gussitu);
  s7_define_typed_function(sc, "cairo_recording_surface_create", lg_cairo_recording_surface_create, 2, 0, 0, H_cairo_recording_surface_create, pl_pgu);
  s7_define_typed_function(sc, "cairo_recording_surface_ink_extents", lg_cairo_recording_surface_ink_extents, 5, 0, 0, H_cairo_recording_surface_ink_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_region_create", lg_cairo_region_create, 0, 0, 0, H_cairo_region_create, pl_p);
  s7_define_typed_function(sc, "cairo_region_create_rectangle", lg_cairo_region_create_rectangle, 1, 0, 0, H_cairo_region_create_rectangle, pl_pu);
  s7_define_typed_function(sc, "cairo_region_create_rectangles", lg_cairo_region_create_rectangles, 2, 0, 0, H_cairo_region_create_rectangles, pl_pui);
  s7_define_typed_function(sc, "cairo_region_copy", lg_cairo_region_copy, 1, 0, 0, H_cairo_region_copy, pl_pu);
  s7_define_typed_function(sc, "cairo_region_reference", lg_cairo_region_reference, 1, 0, 0, H_cairo_region_reference, pl_pu);
  s7_define_typed_function(sc, "cairo_region_destroy", lg_cairo_region_destroy, 1, 0, 0, H_cairo_region_destroy, pl_tu);
  s7_define_typed_function(sc, "cairo_region_equal", lg_cairo_region_equal, 2, 0, 0, H_cairo_region_equal, pl_iu);
  s7_define_typed_function(sc, "cairo_region_status", lg_cairo_region_status, 1, 0, 0, H_cairo_region_status, pl_gu);
  s7_define_typed_function(sc, "cairo_region_get_extents", lg_cairo_region_get_extents, 2, 0, 0, H_cairo_region_get_extents, pl_tu);
  s7_define_typed_function(sc, "cairo_region_num_rectangles", lg_cairo_region_num_rectangles, 1, 0, 0, H_cairo_region_num_rectangles, pl_iu);
  s7_define_typed_function(sc, "cairo_region_get_rectangle", lg_cairo_region_get_rectangle, 3, 0, 0, H_cairo_region_get_rectangle, pl_tuiu);
  s7_define_typed_function(sc, "cairo_region_is_empty", lg_cairo_region_is_empty, 1, 0, 0, H_cairo_region_is_empty, pl_iu);
  s7_define_typed_function(sc, "cairo_region_contains_rectangle", lg_cairo_region_contains_rectangle, 2, 0, 0, H_cairo_region_contains_rectangle, pl_tu);
  s7_define_typed_function(sc, "cairo_region_contains_point", lg_cairo_region_contains_point, 3, 0, 0, H_cairo_region_contains_point, pl_iui);
  s7_define_typed_function(sc, "cairo_region_translate", lg_cairo_region_translate, 3, 0, 0, H_cairo_region_translate, pl_tui);
  s7_define_typed_function(sc, "cairo_region_subtract", lg_cairo_region_subtract, 2, 0, 0, H_cairo_region_subtract, pl_gu);
  s7_define_typed_function(sc, "cairo_region_subtract_rectangle", lg_cairo_region_subtract_rectangle, 2, 0, 0, H_cairo_region_subtract_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_region_intersect", lg_cairo_region_intersect, 2, 0, 0, H_cairo_region_intersect, pl_gu);
  s7_define_typed_function(sc, "cairo_region_intersect_rectangle", lg_cairo_region_intersect_rectangle, 2, 0, 0, H_cairo_region_intersect_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_region_union", lg_cairo_region_union, 2, 0, 0, H_cairo_region_union, pl_gu);
  s7_define_typed_function(sc, "cairo_region_union_rectangle", lg_cairo_region_union_rectangle, 2, 0, 0, H_cairo_region_union_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_region_xor", lg_cairo_region_xor, 2, 0, 0, H_cairo_region_xor, pl_gu);
  s7_define_typed_function(sc, "cairo_region_xor_rectangle", lg_cairo_region_xor_rectangle, 2, 0, 0, H_cairo_region_xor_rectangle, pl_gu);
  s7_define_typed_function(sc, "cairo_image_surface_create_from_png", lg_cairo_image_surface_create_from_png, 1, 0, 0, H_cairo_image_surface_create_from_png, pl_ps);
  s7_define_typed_function(sc, "cairo_surface_write_to_png", lg_cairo_surface_write_to_png, 2, 0, 0, H_cairo_surface_write_to_png, pl_gus);
  s7_define_typed_function(sc, "GPOINTER", lg_GPOINTER, 1, 0, 0, "(GPOINTER obj) casts obj to GPOINTER", NULL);
  s7_define_typed_function(sc, "GDK_DEVICE", lg_GDK_DEVICE, 1, 0, 0, "(GDK_DEVICE obj) casts obj to GDK_DEVICE", pl_bpt);
  s7_define_typed_function(sc, "GDK_KEYMAP", lg_GDK_KEYMAP, 1, 0, 0, "(GDK_KEYMAP obj) casts obj to GDK_KEYMAP", pl_bpt);
  s7_define_typed_function(sc, "GDK_PIXBUF", lg_GDK_PIXBUF, 1, 0, 0, "(GDK_PIXBUF obj) casts obj to GDK_PIXBUF", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACCEL_LABEL", lg_GTK_ACCEL_LABEL, 1, 0, 0, "(GTK_ACCEL_LABEL obj) casts obj to GTK_ACCEL_LABEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACCESSIBLE", lg_GTK_ACCESSIBLE, 1, 0, 0, "(GTK_ACCESSIBLE obj) casts obj to GTK_ACCESSIBLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_ADJUSTMENT", lg_GTK_ADJUSTMENT, 1, 0, 0, "(GTK_ADJUSTMENT obj) casts obj to GTK_ADJUSTMENT", pl_bpt);
  s7_define_typed_function(sc, "GTK_ASPECT_FRAME", lg_GTK_ASPECT_FRAME, 1, 0, 0, "(GTK_ASPECT_FRAME obj) casts obj to GTK_ASPECT_FRAME", pl_bpt);
  s7_define_typed_function(sc, "GTK_BIN", lg_GTK_BIN, 1, 0, 0, "(GTK_BIN obj) casts obj to GTK_BIN", pl_bpt);
  s7_define_typed_function(sc, "GTK_BOX", lg_GTK_BOX, 1, 0, 0, "(GTK_BOX obj) casts obj to GTK_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_BUTTON", lg_GTK_BUTTON, 1, 0, 0, "(GTK_BUTTON obj) casts obj to GTK_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_CALENDAR", lg_GTK_CALENDAR, 1, 0, 0, "(GTK_CALENDAR obj) casts obj to GTK_CALENDAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_EDITABLE", lg_GTK_CELL_EDITABLE, 1, 0, 0, "(GTK_CELL_EDITABLE obj) casts obj to GTK_CELL_EDITABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER", lg_GTK_CELL_RENDERER, 1, 0, 0, "(GTK_CELL_RENDERER obj) casts obj to GTK_CELL_RENDERER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_PIXBUF", lg_GTK_CELL_RENDERER_PIXBUF, 1, 0, 0, "(GTK_CELL_RENDERER_PIXBUF obj) casts obj to GTK_CELL_RENDERER_PIXBUF", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_TEXT", lg_GTK_CELL_RENDERER_TEXT, 1, 0, 0, "(GTK_CELL_RENDERER_TEXT obj) casts obj to GTK_CELL_RENDERER_TEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_TOGGLE", lg_GTK_CELL_RENDERER_TOGGLE, 1, 0, 0, "(GTK_CELL_RENDERER_TOGGLE obj) casts obj to GTK_CELL_RENDERER_TOGGLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_CHECK_BUTTON", lg_GTK_CHECK_BUTTON, 1, 0, 0, "(GTK_CHECK_BUTTON obj) casts obj to GTK_CHECK_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_CONTAINER", lg_GTK_CONTAINER, 1, 0, 0, "(GTK_CONTAINER obj) casts obj to GTK_CONTAINER", pl_bpt);
  s7_define_typed_function(sc, "GTK_DIALOG", lg_GTK_DIALOG, 1, 0, 0, "(GTK_DIALOG obj) casts obj to GTK_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_DRAWING_AREA", lg_GTK_DRAWING_AREA, 1, 0, 0, "(GTK_DRAWING_AREA obj) casts obj to GTK_DRAWING_AREA", pl_bpt);
  s7_define_typed_function(sc, "GTK_EDITABLE", lg_GTK_EDITABLE, 1, 0, 0, "(GTK_EDITABLE obj) casts obj to GTK_EDITABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_ENTRY", lg_GTK_ENTRY, 1, 0, 0, "(GTK_ENTRY obj) casts obj to GTK_ENTRY", pl_bpt);
  s7_define_typed_function(sc, "GTK_FIXED", lg_GTK_FIXED, 1, 0, 0, "(GTK_FIXED obj) casts obj to GTK_FIXED", pl_bpt);
  s7_define_typed_function(sc, "GTK_FRAME", lg_GTK_FRAME, 1, 0, 0, "(GTK_FRAME obj) casts obj to GTK_FRAME", pl_bpt);
  s7_define_typed_function(sc, "GTK_IMAGE", lg_GTK_IMAGE, 1, 0, 0, "(GTK_IMAGE obj) casts obj to GTK_IMAGE", pl_bpt);
  s7_define_typed_function(sc, "GTK_IM_CONTEXT", lg_GTK_IM_CONTEXT, 1, 0, 0, "(GTK_IM_CONTEXT obj) casts obj to GTK_IM_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_IM_CONTEXT_SIMPLE", lg_GTK_IM_CONTEXT_SIMPLE, 1, 0, 0, "(GTK_IM_CONTEXT_SIMPLE obj) casts obj to GTK_IM_CONTEXT_SIMPLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_LABEL", lg_GTK_LABEL, 1, 0, 0, "(GTK_LABEL obj) casts obj to GTK_LABEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_LIST_STORE", lg_GTK_LIST_STORE, 1, 0, 0, "(GTK_LIST_STORE obj) casts obj to GTK_LIST_STORE", pl_bpt);
  s7_define_typed_function(sc, "GTK_NOTEBOOK", lg_GTK_NOTEBOOK, 1, 0, 0, "(GTK_NOTEBOOK obj) casts obj to GTK_NOTEBOOK", pl_bpt);
  s7_define_typed_function(sc, "GTK_PANED", lg_GTK_PANED, 1, 0, 0, "(GTK_PANED obj) casts obj to GTK_PANED", pl_bpt);
  s7_define_typed_function(sc, "GTK_PROGRESS_BAR", lg_GTK_PROGRESS_BAR, 1, 0, 0, "(GTK_PROGRESS_BAR obj) casts obj to GTK_PROGRESS_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_RADIO_BUTTON", lg_GTK_RADIO_BUTTON, 1, 0, 0, "(GTK_RADIO_BUTTON obj) casts obj to GTK_RADIO_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_RANGE", lg_GTK_RANGE, 1, 0, 0, "(GTK_RANGE obj) casts obj to GTK_RANGE", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCALE", lg_GTK_SCALE, 1, 0, 0, "(GTK_SCALE obj) casts obj to GTK_SCALE", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCROLLBAR", lg_GTK_SCROLLBAR, 1, 0, 0, "(GTK_SCROLLBAR obj) casts obj to GTK_SCROLLBAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCROLLED_WINDOW", lg_GTK_SCROLLED_WINDOW, 1, 0, 0, "(GTK_SCROLLED_WINDOW obj) casts obj to GTK_SCROLLED_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEPARATOR", lg_GTK_SEPARATOR, 1, 0, 0, "(GTK_SEPARATOR obj) casts obj to GTK_SEPARATOR", pl_bpt);
  s7_define_typed_function(sc, "GTK_SETTINGS", lg_GTK_SETTINGS, 1, 0, 0, "(GTK_SETTINGS obj) casts obj to GTK_SETTINGS", pl_bpt);
  s7_define_typed_function(sc, "GTK_SIZE_GROUP", lg_GTK_SIZE_GROUP, 1, 0, 0, "(GTK_SIZE_GROUP obj) casts obj to GTK_SIZE_GROUP", pl_bpt);
  s7_define_typed_function(sc, "GTK_SPIN_BUTTON", lg_GTK_SPIN_BUTTON, 1, 0, 0, "(GTK_SPIN_BUTTON obj) casts obj to GTK_SPIN_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_STATUSBAR", lg_GTK_STATUSBAR, 1, 0, 0, "(GTK_STATUSBAR obj) casts obj to GTK_STATUSBAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_BUFFER", lg_GTK_TEXT_BUFFER, 1, 0, 0, "(GTK_TEXT_BUFFER obj) casts obj to GTK_TEXT_BUFFER", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_CHILD_ANCHOR", lg_GTK_TEXT_CHILD_ANCHOR, 1, 0, 0, "(GTK_TEXT_CHILD_ANCHOR obj) casts obj to GTK_TEXT_CHILD_ANCHOR", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_MARK", lg_GTK_TEXT_MARK, 1, 0, 0, "(GTK_TEXT_MARK obj) casts obj to GTK_TEXT_MARK", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_TAG", lg_GTK_TEXT_TAG, 1, 0, 0, "(GTK_TEXT_TAG obj) casts obj to GTK_TEXT_TAG", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_TAG_TABLE", lg_GTK_TEXT_TAG_TABLE, 1, 0, 0, "(GTK_TEXT_TAG_TABLE obj) casts obj to GTK_TEXT_TAG_TABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT_VIEW", lg_GTK_TEXT_VIEW, 1, 0, 0, "(GTK_TEXT_VIEW obj) casts obj to GTK_TEXT_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOGGLE_BUTTON", lg_GTK_TOGGLE_BUTTON, 1, 0, 0, "(GTK_TOGGLE_BUTTON obj) casts obj to GTK_TOGGLE_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_DRAG_SOURCE", lg_GTK_TREE_DRAG_SOURCE, 1, 0, 0, "(GTK_TREE_DRAG_SOURCE obj) casts obj to GTK_TREE_DRAG_SOURCE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_MODEL", lg_GTK_TREE_MODEL, 1, 0, 0, "(GTK_TREE_MODEL obj) casts obj to GTK_TREE_MODEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_MODEL_SORT", lg_GTK_TREE_MODEL_SORT, 1, 0, 0, "(GTK_TREE_MODEL_SORT obj) casts obj to GTK_TREE_MODEL_SORT", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_SELECTION", lg_GTK_TREE_SELECTION, 1, 0, 0, "(GTK_TREE_SELECTION obj) casts obj to GTK_TREE_SELECTION", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_SORTABLE", lg_GTK_TREE_SORTABLE, 1, 0, 0, "(GTK_TREE_SORTABLE obj) casts obj to GTK_TREE_SORTABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_STORE", lg_GTK_TREE_STORE, 1, 0, 0, "(GTK_TREE_STORE obj) casts obj to GTK_TREE_STORE", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_VIEW_COLUMN", lg_GTK_TREE_VIEW_COLUMN, 1, 0, 0, "(GTK_TREE_VIEW_COLUMN obj) casts obj to GTK_TREE_VIEW_COLUMN", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_VIEW", lg_GTK_TREE_VIEW, 1, 0, 0, "(GTK_TREE_VIEW obj) casts obj to GTK_TREE_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_VIEWPORT", lg_GTK_VIEWPORT, 1, 0, 0, "(GTK_VIEWPORT obj) casts obj to GTK_VIEWPORT", pl_bpt);
  s7_define_typed_function(sc, "GTK_WIDGET", lg_GTK_WIDGET, 1, 0, 0, "(GTK_WIDGET obj) casts obj to GTK_WIDGET", pl_bpt);
  s7_define_typed_function(sc, "GTK_WINDOW", lg_GTK_WINDOW, 1, 0, 0, "(GTK_WINDOW obj) casts obj to GTK_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "PANGO_CONTEXT", lg_PANGO_CONTEXT, 1, 0, 0, "(PANGO_CONTEXT obj) casts obj to PANGO_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT_FAMILY", lg_PANGO_FONT_FAMILY, 1, 0, 0, "(PANGO_FONT_FAMILY obj) casts obj to PANGO_FONT_FAMILY", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT_FACE", lg_PANGO_FONT_FACE, 1, 0, 0, "(PANGO_FONT_FACE obj) casts obj to PANGO_FONT_FACE", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT", lg_PANGO_FONT, 1, 0, 0, "(PANGO_FONT obj) casts obj to PANGO_FONT", pl_bpt);
  s7_define_typed_function(sc, "PANGO_FONT_MAP", lg_PANGO_FONT_MAP, 1, 0, 0, "(PANGO_FONT_MAP obj) casts obj to PANGO_FONT_MAP", pl_bpt);
  s7_define_typed_function(sc, "PANGO_LAYOUT", lg_PANGO_LAYOUT, 1, 0, 0, "(PANGO_LAYOUT obj) casts obj to PANGO_LAYOUT", pl_bpt);
  s7_define_typed_function(sc, "G_OBJECT", lg_G_OBJECT, 1, 0, 0, "(G_OBJECT obj) casts obj to G_OBJECT", pl_bpt);
  s7_define_typed_function(sc, "GDK_DISPLAY_OBJECT", lg_GDK_DISPLAY_OBJECT, 1, 0, 0, "(GDK_DISPLAY_OBJECT obj) casts obj to GDK_DISPLAY_OBJECT", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT", lg_GDK_EVENT, 1, 0, 0, "(GDK_EVENT obj) casts obj to GDK_EVENT", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_ANY", lg_GDK_EVENT_ANY, 1, 0, 0, "(GDK_EVENT_ANY obj) casts obj to GDK_EVENT_ANY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_EXPOSE", lg_GDK_EVENT_EXPOSE, 1, 0, 0, "(GDK_EVENT_EXPOSE obj) casts obj to GDK_EVENT_EXPOSE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_NOEXPOSE", lg_GDK_EVENT_NOEXPOSE, 1, 0, 0, "(GDK_EVENT_NOEXPOSE obj) casts obj to GDK_EVENT_NOEXPOSE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_VISIBILITY", lg_GDK_EVENT_VISIBILITY, 1, 0, 0, "(GDK_EVENT_VISIBILITY obj) casts obj to GDK_EVENT_VISIBILITY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_MOTION", lg_GDK_EVENT_MOTION, 1, 0, 0, "(GDK_EVENT_MOTION obj) casts obj to GDK_EVENT_MOTION", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_BUTTON", lg_GDK_EVENT_BUTTON, 1, 0, 0, "(GDK_EVENT_BUTTON obj) casts obj to GDK_EVENT_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_KEY", lg_GDK_EVENT_KEY, 1, 0, 0, "(GDK_EVENT_KEY obj) casts obj to GDK_EVENT_KEY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_CROSSING", lg_GDK_EVENT_CROSSING, 1, 0, 0, "(GDK_EVENT_CROSSING obj) casts obj to GDK_EVENT_CROSSING", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_FOCUS", lg_GDK_EVENT_FOCUS, 1, 0, 0, "(GDK_EVENT_FOCUS obj) casts obj to GDK_EVENT_FOCUS", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_CONFIGURE", lg_GDK_EVENT_CONFIGURE, 1, 0, 0, "(GDK_EVENT_CONFIGURE obj) casts obj to GDK_EVENT_CONFIGURE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_PROPERTY", lg_GDK_EVENT_PROPERTY, 1, 0, 0, "(GDK_EVENT_PROPERTY obj) casts obj to GDK_EVENT_PROPERTY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_SELECTION", lg_GDK_EVENT_SELECTION, 1, 0, 0, "(GDK_EVENT_SELECTION obj) casts obj to GDK_EVENT_SELECTION", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_PROXIMITY", lg_GDK_EVENT_PROXIMITY, 1, 0, 0, "(GDK_EVENT_PROXIMITY obj) casts obj to GDK_EVENT_PROXIMITY", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_SETTING", lg_GDK_EVENT_SETTING, 1, 0, 0, "(GDK_EVENT_SETTING obj) casts obj to GDK_EVENT_SETTING", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_WINDOWSTATE", lg_GDK_EVENT_WINDOWSTATE, 1, 0, 0, "(GDK_EVENT_WINDOWSTATE obj) casts obj to GDK_EVENT_WINDOWSTATE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT_DND", lg_GDK_EVENT_DND, 1, 0, 0, "(GDK_EVENT_DND obj) casts obj to GDK_EVENT_DND", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER_DIALOG", lg_GTK_FILE_CHOOSER_DIALOG, 1, 0, 0, "(GTK_FILE_CHOOSER_DIALOG obj) casts obj to GTK_FILE_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER_WIDGET", lg_GTK_FILE_CHOOSER_WIDGET, 1, 0, 0, "(GTK_FILE_CHOOSER_WIDGET obj) casts obj to GTK_FILE_CHOOSER_WIDGET", pl_bpt);
  s7_define_typed_function(sc, "GTK_TREE_MODEL_FILTER", lg_GTK_TREE_MODEL_FILTER, 1, 0, 0, "(GTK_TREE_MODEL_FILTER obj) casts obj to GTK_TREE_MODEL_FILTER", pl_bpt);
  s7_define_typed_function(sc, "GTK_COMBO_BOX", lg_GTK_COMBO_BOX, 1, 0, 0, "(GTK_COMBO_BOX obj) casts obj to GTK_COMBO_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_EXPANDER", lg_GTK_EXPANDER, 1, 0, 0, "(GTK_EXPANDER obj) casts obj to GTK_EXPANDER", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_BUTTON", lg_GTK_FONT_BUTTON, 1, 0, 0, "(GTK_FONT_BUTTON obj) casts obj to GTK_FONT_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_COLOR_BUTTON", lg_GTK_COLOR_BUTTON, 1, 0, 0, "(GTK_COLOR_BUTTON obj) casts obj to GTK_COLOR_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_ENTRY_COMPLETION", lg_GTK_ENTRY_COMPLETION, 1, 0, 0, "(GTK_ENTRY_COMPLETION obj) casts obj to GTK_ENTRY_COMPLETION", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_FILTER", lg_GTK_FILE_FILTER, 1, 0, 0, "(GTK_FILE_FILTER obj) casts obj to GTK_FILE_FILTER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_LAYOUT", lg_GTK_CELL_LAYOUT, 1, 0, 0, "(GTK_CELL_LAYOUT obj) casts obj to GTK_CELL_LAYOUT", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER", lg_GTK_FILE_CHOOSER, 1, 0, 0, "(GTK_FILE_CHOOSER obj) casts obj to GTK_FILE_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_VIEW", lg_GTK_CELL_VIEW, 1, 0, 0, "(GTK_CELL_VIEW obj) casts obj to GTK_CELL_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_ABOUT_DIALOG", lg_GTK_ABOUT_DIALOG, 1, 0, 0, "(GTK_ABOUT_DIALOG obj) casts obj to GTK_ABOUT_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_COMBO", lg_GTK_CELL_RENDERER_COMBO, 1, 0, 0, "(GTK_CELL_RENDERER_COMBO obj) casts obj to GTK_CELL_RENDERER_COMBO", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_PROGRESS", lg_GTK_CELL_RENDERER_PROGRESS, 1, 0, 0, "(GTK_CELL_RENDERER_PROGRESS obj) casts obj to GTK_CELL_RENDERER_PROGRESS", pl_bpt);
  s7_define_typed_function(sc, "GTK_ICON_VIEW", lg_GTK_ICON_VIEW, 1, 0, 0, "(GTK_ICON_VIEW obj) casts obj to GTK_ICON_VIEW", pl_bpt);
  s7_define_typed_function(sc, "GTK_FILE_CHOOSER_BUTTON", lg_GTK_FILE_CHOOSER_BUTTON, 1, 0, 0, "(GTK_FILE_CHOOSER_BUTTON obj) casts obj to GTK_FILE_CHOOSER_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_ASSISTANT", lg_GTK_ASSISTANT, 1, 0, 0, "(GTK_ASSISTANT obj) casts obj to GTK_ASSISTANT", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_ACCEL", lg_GTK_CELL_RENDERER_ACCEL, 1, 0, 0, "(GTK_CELL_RENDERER_ACCEL obj) casts obj to GTK_CELL_RENDERER_ACCEL", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_SPIN", lg_GTK_CELL_RENDERER_SPIN, 1, 0, 0, "(GTK_CELL_RENDERER_SPIN obj) casts obj to GTK_CELL_RENDERER_SPIN", pl_bpt);
  s7_define_typed_function(sc, "GTK_LINK_BUTTON", lg_GTK_LINK_BUTTON, 1, 0, 0, "(GTK_LINK_BUTTON obj) casts obj to GTK_LINK_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_RECENT_MANAGER", lg_GTK_RECENT_MANAGER, 1, 0, 0, "(GTK_RECENT_MANAGER obj) casts obj to GTK_RECENT_MANAGER", pl_bpt);
  s7_define_typed_function(sc, "GTK_PRINT_CONTEXT", lg_GTK_PRINT_CONTEXT, 1, 0, 0, "(GTK_PRINT_CONTEXT obj) casts obj to GTK_PRINT_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_PRINT_OPERATION", lg_GTK_PRINT_OPERATION, 1, 0, 0, "(GTK_PRINT_OPERATION obj) casts obj to GTK_PRINT_OPERATION", pl_bpt);
  s7_define_typed_function(sc, "GTK_PRINT_SETTINGS", lg_GTK_PRINT_SETTINGS, 1, 0, 0, "(GTK_PRINT_SETTINGS obj) casts obj to GTK_PRINT_SETTINGS", pl_bpt);
  s7_define_typed_function(sc, "GTK_TOOLTIP", lg_GTK_TOOLTIP, 1, 0, 0, "(GTK_TOOLTIP obj) casts obj to GTK_TOOLTIP", pl_bpt);
  s7_define_typed_function(sc, "GTK_INFO_BAR", lg_GTK_INFO_BAR, 1, 0, 0, "(GTK_INFO_BAR obj) casts obj to GTK_INFO_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_ENTRY_BUFFER", lg_GTK_ENTRY_BUFFER, 1, 0, 0, "(GTK_ENTRY_BUFFER obj) casts obj to GTK_ENTRY_BUFFER", pl_bpt);
  s7_define_typed_function(sc, "GTK_SPINNER", lg_GTK_SPINNER, 1, 0, 0, "(GTK_SPINNER obj) casts obj to GTK_SPINNER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CELL_RENDERER_SPINNER", lg_GTK_CELL_RENDERER_SPINNER, 1, 0, 0, "(GTK_CELL_RENDERER_SPINNER obj) casts obj to GTK_CELL_RENDERER_SPINNER", pl_bpt);
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "GTK_COMBO_BOX_TEXT", lg_GTK_COMBO_BOX_TEXT, 1, 0, 0, "(GTK_COMBO_BOX_TEXT obj) casts obj to GTK_COMBO_BOX_TEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_GRID", lg_GTK_GRID, 1, 0, 0, "(GTK_GRID obj) casts obj to GTK_GRID", pl_bpt);
  s7_define_typed_function(sc, "GTK_SCROLLABLE", lg_GTK_SCROLLABLE, 1, 0, 0, "(GTK_SCROLLABLE obj) casts obj to GTK_SCROLLABLE", pl_bpt);
  s7_define_typed_function(sc, "GDK_RGBA", lg_GDK_RGBA, 1, 0, 0, "(GDK_RGBA obj) casts obj to GDK_RGBA", pl_bpt);
  s7_define_typed_function(sc, "GTK_SWITCH", lg_GTK_SWITCH, 1, 0, 0, "(GTK_SWITCH obj) casts obj to GTK_SWITCH", pl_bpt);
  s7_define_typed_function(sc, "GTK_ORIENTABLE", lg_GTK_ORIENTABLE, 1, 0, 0, "(GTK_ORIENTABLE obj) casts obj to GTK_ORIENTABLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_WINDOW_GROUP", lg_GTK_WINDOW_GROUP, 1, 0, 0, "(GTK_WINDOW_GROUP obj) casts obj to GTK_WINDOW_GROUP", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define_typed_function(sc, "GTK_OVERLAY", lg_GTK_OVERLAY, 1, 0, 0, "(GTK_OVERLAY obj) casts obj to GTK_OVERLAY", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_CHOOSER", lg_GTK_FONT_CHOOSER, 1, 0, 0, "(GTK_FONT_CHOOSER obj) casts obj to GTK_FONT_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_CHOOSER_DIALOG", lg_GTK_FONT_CHOOSER_DIALOG, 1, 0, 0, "(GTK_FONT_CHOOSER_DIALOG obj) casts obj to GTK_FONT_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_FONT_CHOOSER_WIDGET", lg_GTK_FONT_CHOOSER_WIDGET, 1, 0, 0, "(GTK_FONT_CHOOSER_WIDGET obj) casts obj to GTK_FONT_CHOOSER_WIDGET", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define_typed_function(sc, "GTK_APPLICATION", lg_GTK_APPLICATION, 1, 0, 0, "(GTK_APPLICATION obj) casts obj to GTK_APPLICATION", pl_bpt);
  s7_define_typed_function(sc, "GTK_APPLICATION_WINDOW", lg_GTK_APPLICATION_WINDOW, 1, 0, 0, "(GTK_APPLICATION_WINDOW obj) casts obj to GTK_APPLICATION_WINDOW", pl_bpt);
  s7_define_typed_function(sc, "GTK_COLOR_CHOOSER_DIALOG", lg_GTK_COLOR_CHOOSER_DIALOG, 1, 0, 0, "(GTK_COLOR_CHOOSER_DIALOG obj) casts obj to GTK_COLOR_CHOOSER_DIALOG", pl_bpt);
  s7_define_typed_function(sc, "GTK_COLOR_CHOOSER_WIDGET", lg_GTK_COLOR_CHOOSER_WIDGET, 1, 0, 0, "(GTK_COLOR_CHOOSER_WIDGET obj) casts obj to GTK_COLOR_CHOOSER_WIDGET", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define_typed_function(sc, "GTK_MENU_BUTTON", lg_GTK_MENU_BUTTON, 1, 0, 0, "(GTK_MENU_BUTTON obj) casts obj to GTK_MENU_BUTTON", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEARCH_ENTRY", lg_GTK_SEARCH_ENTRY, 1, 0, 0, "(GTK_SEARCH_ENTRY obj) casts obj to GTK_SEARCH_ENTRY", pl_bpt);
  s7_define_typed_function(sc, "GTK_LEVEL_BAR", lg_GTK_LEVEL_BAR, 1, 0, 0, "(GTK_LEVEL_BAR obj) casts obj to GTK_LEVEL_BAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define_typed_function(sc, "GTK_STACK_SWITCHER", lg_GTK_STACK_SWITCHER, 1, 0, 0, "(GTK_STACK_SWITCHER obj) casts obj to GTK_STACK_SWITCHER", pl_bpt);
  s7_define_typed_function(sc, "GTK_STACK", lg_GTK_STACK, 1, 0, 0, "(GTK_STACK obj) casts obj to GTK_STACK", pl_bpt);
  s7_define_typed_function(sc, "GTK_REVEALER", lg_GTK_REVEALER, 1, 0, 0, "(GTK_REVEALER obj) casts obj to GTK_REVEALER", pl_bpt);
  s7_define_typed_function(sc, "GTK_HEADER_BAR", lg_GTK_HEADER_BAR, 1, 0, 0, "(GTK_HEADER_BAR obj) casts obj to GTK_HEADER_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_LIST_BOX", lg_GTK_LIST_BOX, 1, 0, 0, "(GTK_LIST_BOX obj) casts obj to GTK_LIST_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_LIST_BOX_ROW", lg_GTK_LIST_BOX_ROW, 1, 0, 0, "(GTK_LIST_BOX_ROW obj) casts obj to GTK_LIST_BOX_ROW", pl_bpt);
  s7_define_typed_function(sc, "GTK_SEARCH_BAR", lg_GTK_SEARCH_BAR, 1, 0, 0, "(GTK_SEARCH_BAR obj) casts obj to GTK_SEARCH_BAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define_typed_function(sc, "GTK_FLOW_BOX", lg_GTK_FLOW_BOX, 1, 0, 0, "(GTK_FLOW_BOX obj) casts obj to GTK_FLOW_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_FLOW_BOX_CHILD", lg_GTK_FLOW_BOX_CHILD, 1, 0, 0, "(GTK_FLOW_BOX_CHILD obj) casts obj to GTK_FLOW_BOX_CHILD", pl_bpt);
  s7_define_typed_function(sc, "GTK_ACTION_BAR", lg_GTK_ACTION_BAR, 1, 0, 0, "(GTK_ACTION_BAR obj) casts obj to GTK_ACTION_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_POPOVER", lg_GTK_POPOVER, 1, 0, 0, "(GTK_POPOVER obj) casts obj to GTK_POPOVER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define_typed_function(sc, "GTK_GESTURE", lg_GTK_GESTURE, 1, 0, 0, "(GTK_GESTURE obj) casts obj to GTK_GESTURE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_DRAG", lg_GTK_GESTURE_DRAG, 1, 0, 0, "(GTK_GESTURE_DRAG obj) casts obj to GTK_GESTURE_DRAG", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_LONG_PRESS", lg_GTK_GESTURE_LONG_PRESS, 1, 0, 0, "(GTK_GESTURE_LONG_PRESS obj) casts obj to GTK_GESTURE_LONG_PRESS", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_ZOOM", lg_GTK_GESTURE_ZOOM, 1, 0, 0, "(GTK_GESTURE_ZOOM obj) casts obj to GTK_GESTURE_ZOOM", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_SWIPE", lg_GTK_GESTURE_SWIPE, 1, 0, 0, "(GTK_GESTURE_SWIPE obj) casts obj to GTK_GESTURE_SWIPE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_SINGLE", lg_GTK_GESTURE_SINGLE, 1, 0, 0, "(GTK_GESTURE_SINGLE obj) casts obj to GTK_GESTURE_SINGLE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_PAN", lg_GTK_GESTURE_PAN, 1, 0, 0, "(GTK_GESTURE_PAN obj) casts obj to GTK_GESTURE_PAN", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_ROTATE", lg_GTK_GESTURE_ROTATE, 1, 0, 0, "(GTK_GESTURE_ROTATE obj) casts obj to GTK_GESTURE_ROTATE", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define_typed_function(sc, "GTK_GL_AREA", lg_GTK_GL_AREA, 1, 0, 0, "(GTK_GL_AREA obj) casts obj to GTK_GL_AREA", pl_bpt);
  s7_define_typed_function(sc, "GDK_GL_CONTEXT", lg_GDK_GL_CONTEXT, 1, 0, 0, "(GDK_GL_CONTEXT obj) casts obj to GDK_GL_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_STACK_SIDEBAR", lg_GTK_STACK_SIDEBAR, 1, 0, 0, "(GTK_STACK_SIDEBAR obj) casts obj to GTK_STACK_SIDEBAR", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define_typed_function(sc, "GDK_SEAT", lg_GDK_SEAT, 1, 0, 0, "(GDK_SEAT obj) casts obj to GDK_SEAT", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define_typed_function(sc, "GDK_DEVICE_TOOL", lg_GDK_DEVICE_TOOL, 1, 0, 0, "(GDK_DEVICE_TOOL obj) casts obj to GDK_DEVICE_TOOL", pl_bpt);
  s7_define_typed_function(sc, "GDK_MONITOR", lg_GDK_MONITOR, 1, 0, 0, "(GDK_MONITOR obj) casts obj to GDK_MONITOR", pl_bpt);
  s7_define_typed_function(sc, "GDK_DEVICE_PAD", lg_GDK_DEVICE_PAD, 1, 0, 0, "(GDK_DEVICE_PAD obj) casts obj to GDK_DEVICE_PAD", pl_bpt);
  s7_define_typed_function(sc, "GTK_PAD_CONTROLLER", lg_GTK_PAD_CONTROLLER, 1, 0, 0, "(GTK_PAD_CONTROLLER obj) casts obj to GTK_PAD_CONTROLLER", pl_bpt);
  s7_define_typed_function(sc, "GTK_SHORTCUT_LABEL", lg_GTK_SHORTCUT_LABEL, 1, 0, 0, "(GTK_SHORTCUT_LABEL obj) casts obj to GTK_SHORTCUT_LABEL", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  s7_define_typed_function(sc, "GTK_CENTER_BOX", lg_GTK_CENTER_BOX, 1, 0, 0, "(GTK_CENTER_BOX obj) casts obj to GTK_CENTER_BOX", pl_bpt);
  s7_define_typed_function(sc, "GTK_STYLE_CONTEXT", lg_GTK_STYLE_CONTEXT, 1, 0, 0, "(GTK_STYLE_CONTEXT obj) casts obj to GTK_STYLE_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GTK_STYLE_PROVIDER", lg_GTK_STYLE_PROVIDER, 1, 0, 0, "(GTK_STYLE_PROVIDER obj) casts obj to GTK_STYLE_PROVIDER", pl_bpt);
  s7_define_typed_function(sc, "GTK_CSS_PROVIDER", lg_GTK_CSS_PROVIDER, 1, 0, 0, "(GTK_CSS_PROVIDER obj) casts obj to GTK_CSS_PROVIDER", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
  s7_define_typed_function(sc, "GTK_EMOJI_CHOOSER", lg_GTK_EMOJI_CHOOSER, 1, 0, 0, "(GTK_EMOJI_CHOOSER obj) casts obj to GTK_EMOJI_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER_SCROLL", lg_GTK_EVENT_CONTROLLER_SCROLL, 1, 0, 0, "(GTK_EVENT_CONTROLLER_SCROLL obj) casts obj to GTK_EVENT_CONTROLLER_SCROLL", pl_bpt);
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER_MOTION", lg_GTK_EVENT_CONTROLLER_MOTION, 1, 0, 0, "(GTK_EVENT_CONTROLLER_MOTION obj) casts obj to GTK_EVENT_CONTROLLER_MOTION", pl_bpt);
  s7_define_typed_function(sc, "GDK_TEXTURE", lg_GDK_TEXTURE, 1, 0, 0, "(GDK_TEXTURE obj) casts obj to GDK_TEXTURE", pl_bpt);
  s7_define_typed_function(sc, "GDK_EVENT", lg_GDK_EVENT, 1, 0, 0, "(GDK_EVENT obj) casts obj to GDK_EVENT", pl_bpt);
  s7_define_typed_function(sc, "GDK_APP_LAUNCH_CONTEXT", lg_GDK_APP_LAUNCH_CONTEXT, 1, 0, 0, "(GDK_APP_LAUNCH_CONTEXT obj) casts obj to GDK_APP_LAUNCH_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GDK_CLIPBOARD", lg_GDK_CLIPBOARD, 1, 0, 0, "(GDK_CLIPBOARD obj) casts obj to GDK_CLIPBOARD", pl_bpt);
  s7_define_typed_function(sc, "GDK_CONTENT_PROVIDER", lg_GDK_CONTENT_PROVIDER, 1, 0, 0, "(GDK_CONTENT_PROVIDER obj) casts obj to GDK_CONTENT_PROVIDER", pl_bpt);
  s7_define_typed_function(sc, "GDK_CONTENT_SERIALIZER", lg_GDK_CONTENT_SERIALIZER, 1, 0, 0, "(GDK_CONTENT_SERIALIZER obj) casts obj to GDK_CONTENT_SERIALIZER", pl_bpt);
  s7_define_typed_function(sc, "GDK_CONTENT_DESERIALIZER", lg_GDK_CONTENT_DESERIALIZER, 1, 0, 0, "(GDK_CONTENT_DESERIALIZER obj) casts obj to GDK_CONTENT_DESERIALIZER", pl_bpt);
  s7_define_typed_function(sc, "GDK_SURFACE", lg_GDK_SURFACE, 1, 0, 0, "(GDK_SURFACE obj) casts obj to GDK_SURFACE", pl_bpt);
  s7_define_typed_function(sc, "GTK_GESTURE_STYLUS", lg_GTK_GESTURE_STYLUS, 1, 0, 0, "(GTK_GESTURE_STYLUS obj) casts obj to GTK_GESTURE_STYLUS", pl_bpt);
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER", lg_GTK_EVENT_CONTROLLER, 1, 0, 0, "(GTK_EVENT_CONTROLLER obj) casts obj to GTK_EVENT_CONTROLLER", pl_bpt);
  s7_define_typed_function(sc, "GDK_CAIRO_CONTEXT", lg_GDK_CAIRO_CONTEXT, 1, 0, 0, "(GDK_CAIRO_CONTEXT obj) casts obj to GDK_CAIRO_CONTEXT", pl_bpt);
  s7_define_typed_function(sc, "GDK_DROP", lg_GDK_DROP, 1, 0, 0, "(GDK_DROP obj) casts obj to GDK_DROP", pl_bpt);
  s7_define_typed_function(sc, "GDK_GL_TEXTURE", lg_GDK_GL_TEXTURE, 1, 0, 0, "(GDK_GL_TEXTURE obj) casts obj to GDK_GL_TEXTURE", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
  s7_define_typed_function(sc, "GTK_NOTEBOOK_PAGE", lg_GTK_NOTEBOOK_PAGE, 1, 0, 0, "(GTK_NOTEBOOK_PAGE obj) casts obj to GTK_NOTEBOOK_PAGE", pl_bpt);
  s7_define_typed_function(sc, "GDK_DRAG", lg_GDK_DRAG, 1, 0, 0, "(GDK_DRAG obj) casts obj to GDK_DRAG", pl_bpt);
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER_LEGACY", lg_GTK_EVENT_CONTROLLER_LEGACY, 1, 0, 0, "(GTK_EVENT_CONTROLLER_LEGACY obj) casts obj to GTK_EVENT_CONTROLLER_LEGACY", pl_bpt);
  s7_define_typed_function(sc, "GTK_PASSWORD_ENTRY", lg_GTK_PASSWORD_ENTRY, 1, 0, 0, "(GTK_PASSWORD_ENTRY obj) casts obj to GTK_PASSWORD_ENTRY", pl_bpt);
  s7_define_typed_function(sc, "GTK_TEXT", lg_GTK_TEXT, 1, 0, 0, "(GTK_TEXT obj) casts obj to GTK_TEXT", pl_bpt);
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER", lg_GTK_EVENT_CONTROLLER, 1, 0, 0, "(GTK_EVENT_CONTROLLER obj) casts obj to GTK_EVENT_CONTROLLER", pl_bpt);
  s7_define_typed_function(sc, "GTK_POPOVER_MENU_BAR", lg_GTK_POPOVER_MENU_BAR, 1, 0, 0, "(GTK_POPOVER_MENU_BAR obj) casts obj to GTK_POPOVER_MENU_BAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_CALENDAR", lg_GTK_CALENDAR, 1, 0, 0, "(GTK_CALENDAR obj) casts obj to GTK_CALENDAR", pl_bpt);
  s7_define_typed_function(sc, "GTK_EVENT_CONTROLLER_FOCUS", lg_GTK_EVENT_CONTROLLER_FOCUS, 1, 0, 0, "(GTK_EVENT_CONTROLLER_FOCUS obj) casts obj to GTK_EVENT_CONTROLLER_FOCUS", pl_bpt);
  s7_define_typed_function(sc, "GTK_DROP_CONTROLLER_MOTION", lg_GTK_DROP_CONTROLLER_MOTION, 1, 0, 0, "(GTK_DROP_CONTROLLER_MOTION obj) casts obj to GTK_DROP_CONTROLLER_MOTION", pl_bpt);
  s7_define_typed_function(sc, "GTK_DROP_TARGET", lg_GTK_DROP_TARGET, 1, 0, 0, "(GTK_DROP_TARGET obj) casts obj to GTK_DROP_TARGET", pl_bpt);
  s7_define_typed_function(sc, "GTK_EMOJI_CHOOSER", lg_GTK_EMOJI_CHOOSER, 1, 0, 0, "(GTK_EMOJI_CHOOSER obj) casts obj to GTK_EMOJI_CHOOSER", pl_bpt);
  s7_define_typed_function(sc, "GTK_DROP_TARGET_ASYNC", lg_GTK_DROP_TARGET_ASYNC, 1, 0, 0, "(GTK_DROP_TARGET_ASYNC obj) casts obj to GTK_DROP_TARGET_ASYNC", pl_bpt);
  s7_define_typed_function(sc, "GTK_POPOVER_MENU", lg_GTK_POPOVER_MENU, 1, 0, 0, "(GTK_POPOVER_MENU obj) casts obj to GTK_POPOVER_MENU", pl_bpt);
  s7_define_typed_function(sc, "GTK_SHORTCUT_CONTROLLER", lg_GTK_SHORTCUT_CONTROLLER, 1, 0, 0, "(GTK_SHORTCUT_CONTROLLER obj) casts obj to GTK_SHORTCUT_CONTROLLER", pl_bpt);
#endif

  s7_define_function(sc, "g_object_get", lg_g_object_get, 3, 0, 0, NULL);
  s7_define_function(sc, "g_object_set", lg_g_object_set, 3, 0, 0, NULL);
  s7_define_function(sc, "gtk_event_keyval", lg_gtk_event_keyval, 1, 0, 0, NULL);
#if (!GTK_CHECK_VERSION(3, 90, 0))
  s7_define_function(sc, "gtk_init", lg_gtk_init, 0, 2, 0, NULL);
  s7_define_function(sc, "gtk_init_check", lg_gtk_init_check, 0, 2, 0, NULL);
#else
  s7_define_function(sc, "gtk_init", lg_gtk_init, 0, 0, 0, NULL);
#endif
  s7_define_typed_function(sc, "GDK_IS_DEVICE", lg_GDK_IS_DEVICE, 1, 0, 0, "(GDK_IS_DEVICE obj): #t if obj is a GdkDevice*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_KEYMAP", lg_GDK_IS_KEYMAP, 1, 0, 0, "(GDK_IS_KEYMAP obj): #t if obj is a GdkKeymap*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_PIXBUF", lg_GDK_IS_PIXBUF, 1, 0, 0, "(GDK_IS_PIXBUF obj): #t if obj is a GdkPixbuf*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACCEL_LABEL", lg_GTK_IS_ACCEL_LABEL, 1, 0, 0, "(GTK_IS_ACCEL_LABEL obj): #t if obj is a GtkAccelLabel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACCESSIBLE", lg_GTK_IS_ACCESSIBLE, 1, 0, 0, "(GTK_IS_ACCESSIBLE obj): #t if obj is a GtkAccessible*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ADJUSTMENT", lg_GTK_IS_ADJUSTMENT, 1, 0, 0, "(GTK_IS_ADJUSTMENT obj): #t if obj is a GtkAdjustment*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ASPECT_FRAME", lg_GTK_IS_ASPECT_FRAME, 1, 0, 0, "(GTK_IS_ASPECT_FRAME obj): #t if obj is a GtkAspectFrame*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BIN", lg_GTK_IS_BIN, 1, 0, 0, "(GTK_IS_BIN obj): #t if obj is a GtkBin*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BOX", lg_GTK_IS_BOX, 1, 0, 0, "(GTK_IS_BOX obj): #t if obj is a GtkBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_BUTTON", lg_GTK_IS_BUTTON, 1, 0, 0, "(GTK_IS_BUTTON obj): #t if obj is a GtkButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CALENDAR", lg_GTK_IS_CALENDAR, 1, 0, 0, "(GTK_IS_CALENDAR obj): #t if obj is a GtkCalendar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_EDITABLE", lg_GTK_IS_CELL_EDITABLE, 1, 0, 0, "(GTK_IS_CELL_EDITABLE obj): #t if obj is a GtkCellEditable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER", lg_GTK_IS_CELL_RENDERER, 1, 0, 0, "(GTK_IS_CELL_RENDERER obj): #t if obj is a GtkCellRenderer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_PIXBUF", lg_GTK_IS_CELL_RENDERER_PIXBUF, 1, 0, 0, "(GTK_IS_CELL_RENDERER_PIXBUF obj): #t if obj is a GtkCellRendererPixbuf*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_TEXT", lg_GTK_IS_CELL_RENDERER_TEXT, 1, 0, 0, "(GTK_IS_CELL_RENDERER_TEXT obj): #t if obj is a GtkCellRendererText*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_TOGGLE", lg_GTK_IS_CELL_RENDERER_TOGGLE, 1, 0, 0, "(GTK_IS_CELL_RENDERER_TOGGLE obj): #t if obj is a GtkCellRendererToggle*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CHECK_BUTTON", lg_GTK_IS_CHECK_BUTTON, 1, 0, 0, "(GTK_IS_CHECK_BUTTON obj): #t if obj is a GtkCheckButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CONTAINER", lg_GTK_IS_CONTAINER, 1, 0, 0, "(GTK_IS_CONTAINER obj): #t if obj is a GtkContainer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DIALOG", lg_GTK_IS_DIALOG, 1, 0, 0, "(GTK_IS_DIALOG obj): #t if obj is a GtkDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DRAWING_AREA", lg_GTK_IS_DRAWING_AREA, 1, 0, 0, "(GTK_IS_DRAWING_AREA obj): #t if obj is a GtkDrawingArea*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EDITABLE", lg_GTK_IS_EDITABLE, 1, 0, 0, "(GTK_IS_EDITABLE obj): #t if obj is a GtkEditable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ENTRY", lg_GTK_IS_ENTRY, 1, 0, 0, "(GTK_IS_ENTRY obj): #t if obj is a GtkEntry*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FIXED", lg_GTK_IS_FIXED, 1, 0, 0, "(GTK_IS_FIXED obj): #t if obj is a GtkFixed*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FRAME", lg_GTK_IS_FRAME, 1, 0, 0, "(GTK_IS_FRAME obj): #t if obj is a GtkFrame*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_IMAGE", lg_GTK_IS_IMAGE, 1, 0, 0, "(GTK_IS_IMAGE obj): #t if obj is a GtkImage*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_IM_CONTEXT", lg_GTK_IS_IM_CONTEXT, 1, 0, 0, "(GTK_IS_IM_CONTEXT obj): #t if obj is a GtkIMContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_IM_CONTEXT_SIMPLE", lg_GTK_IS_IM_CONTEXT_SIMPLE, 1, 0, 0, "(GTK_IS_IM_CONTEXT_SIMPLE obj): #t if obj is a GtkIMContextSimple*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LABEL", lg_GTK_IS_LABEL, 1, 0, 0, "(GTK_IS_LABEL obj): #t if obj is a GtkLabel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LIST_STORE", lg_GTK_IS_LIST_STORE, 1, 0, 0, "(GTK_IS_LIST_STORE obj): #t if obj is a GtkListStore*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_NOTEBOOK", lg_GTK_IS_NOTEBOOK, 1, 0, 0, "(GTK_IS_NOTEBOOK obj): #t if obj is a GtkNotebook*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PANED", lg_GTK_IS_PANED, 1, 0, 0, "(GTK_IS_PANED obj): #t if obj is a GtkPaned*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PROGRESS_BAR", lg_GTK_IS_PROGRESS_BAR, 1, 0, 0, "(GTK_IS_PROGRESS_BAR obj): #t if obj is a GtkProgressBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RADIO_BUTTON", lg_GTK_IS_RADIO_BUTTON, 1, 0, 0, "(GTK_IS_RADIO_BUTTON obj): #t if obj is a GtkRadioButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RANGE", lg_GTK_IS_RANGE, 1, 0, 0, "(GTK_IS_RANGE obj): #t if obj is a GtkRange*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCALE", lg_GTK_IS_SCALE, 1, 0, 0, "(GTK_IS_SCALE obj): #t if obj is a GtkScale*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCROLLBAR", lg_GTK_IS_SCROLLBAR, 1, 0, 0, "(GTK_IS_SCROLLBAR obj): #t if obj is a GtkScrollbar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCROLLED_WINDOW", lg_GTK_IS_SCROLLED_WINDOW, 1, 0, 0, "(GTK_IS_SCROLLED_WINDOW obj): #t if obj is a GtkScrolledWindow*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEPARATOR", lg_GTK_IS_SEPARATOR, 1, 0, 0, "(GTK_IS_SEPARATOR obj): #t if obj is a GtkSeparator*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SETTINGS", lg_GTK_IS_SETTINGS, 1, 0, 0, "(GTK_IS_SETTINGS obj): #t if obj is a GtkSettings*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SIZE_GROUP", lg_GTK_IS_SIZE_GROUP, 1, 0, 0, "(GTK_IS_SIZE_GROUP obj): #t if obj is a GtkSizeGroup*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SPIN_BUTTON", lg_GTK_IS_SPIN_BUTTON, 1, 0, 0, "(GTK_IS_SPIN_BUTTON obj): #t if obj is a GtkSpinButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STATUSBAR", lg_GTK_IS_STATUSBAR, 1, 0, 0, "(GTK_IS_STATUSBAR obj): #t if obj is a GtkStatusbar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_BUFFER", lg_GTK_IS_TEXT_BUFFER, 1, 0, 0, "(GTK_IS_TEXT_BUFFER obj): #t if obj is a GtkTextBuffer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_CHILD_ANCHOR", lg_GTK_IS_TEXT_CHILD_ANCHOR, 1, 0, 0, "(GTK_IS_TEXT_CHILD_ANCHOR obj): #t if obj is a GtkTextChildAnchor*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_MARK", lg_GTK_IS_TEXT_MARK, 1, 0, 0, "(GTK_IS_TEXT_MARK obj): #t if obj is a GtkTextMark*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_TAG", lg_GTK_IS_TEXT_TAG, 1, 0, 0, "(GTK_IS_TEXT_TAG obj): #t if obj is a GtkTextTag*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_TAG_TABLE", lg_GTK_IS_TEXT_TAG_TABLE, 1, 0, 0, "(GTK_IS_TEXT_TAG_TABLE obj): #t if obj is a GtkTextTagTable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT_VIEW", lg_GTK_IS_TEXT_VIEW, 1, 0, 0, "(GTK_IS_TEXT_VIEW obj): #t if obj is a GtkTextView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOGGLE_BUTTON", lg_GTK_IS_TOGGLE_BUTTON, 1, 0, 0, "(GTK_IS_TOGGLE_BUTTON obj): #t if obj is a GtkToggleButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_DRAG_SOURCE", lg_GTK_IS_TREE_DRAG_SOURCE, 1, 0, 0, "(GTK_IS_TREE_DRAG_SOURCE obj): #t if obj is a GtkTreeDragSource*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_MODEL", lg_GTK_IS_TREE_MODEL, 1, 0, 0, "(GTK_IS_TREE_MODEL obj): #t if obj is a GtkTreeModel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_MODEL_SORT", lg_GTK_IS_TREE_MODEL_SORT, 1, 0, 0, "(GTK_IS_TREE_MODEL_SORT obj): #t if obj is a GtkTreeModelSort*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_SELECTION", lg_GTK_IS_TREE_SELECTION, 1, 0, 0, "(GTK_IS_TREE_SELECTION obj): #t if obj is a GtkTreeSelection*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_SORTABLE", lg_GTK_IS_TREE_SORTABLE, 1, 0, 0, "(GTK_IS_TREE_SORTABLE obj): #t if obj is a GtkTreeSortable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_STORE", lg_GTK_IS_TREE_STORE, 1, 0, 0, "(GTK_IS_TREE_STORE obj): #t if obj is a GtkTreeStore*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_VIEW_COLUMN", lg_GTK_IS_TREE_VIEW_COLUMN, 1, 0, 0, "(GTK_IS_TREE_VIEW_COLUMN obj): #t if obj is a GtkTreeViewColumn*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_VIEW", lg_GTK_IS_TREE_VIEW, 1, 0, 0, "(GTK_IS_TREE_VIEW obj): #t if obj is a GtkTreeView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_VIEWPORT", lg_GTK_IS_VIEWPORT, 1, 0, 0, "(GTK_IS_VIEWPORT obj): #t if obj is a GtkViewport*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_WIDGET", lg_GTK_IS_WIDGET, 1, 0, 0, "(GTK_IS_WIDGET obj): #t if obj is a GtkWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_WINDOW", lg_GTK_IS_WINDOW, 1, 0, 0, "(GTK_IS_WINDOW obj): #t if obj is a GtkWindow*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_CONTEXT", lg_PANGO_IS_CONTEXT, 1, 0, 0, "(PANGO_IS_CONTEXT obj): #t if obj is a PangoContext*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT_FAMILY", lg_PANGO_IS_FONT_FAMILY, 1, 0, 0, "(PANGO_IS_FONT_FAMILY obj): #t if obj is a PangoFontFamily*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT_FACE", lg_PANGO_IS_FONT_FACE, 1, 0, 0, "(PANGO_IS_FONT_FACE obj): #t if obj is a PangoFontFace*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT", lg_PANGO_IS_FONT, 1, 0, 0, "(PANGO_IS_FONT obj): #t if obj is a PangoFont*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_FONT_MAP", lg_PANGO_IS_FONT_MAP, 1, 0, 0, "(PANGO_IS_FONT_MAP obj): #t if obj is a PangoFontMap*", pl_bt);
  s7_define_typed_function(sc, "PANGO_IS_LAYOUT", lg_PANGO_IS_LAYOUT, 1, 0, 0, "(PANGO_IS_LAYOUT obj): #t if obj is a PangoLayout*", pl_bt);
  s7_define_typed_function(sc, "G_IS_OBJECT", lg_G_IS_OBJECT, 1, 0, 0, "(G_IS_OBJECT obj): #t if obj is a GObject*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DISPLAY", lg_GDK_IS_DISPLAY, 1, 0, 0, "(GDK_IS_DISPLAY obj): #t if obj is a GdkDisplay*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER_DIALOG", lg_GTK_IS_FILE_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_DIALOG obj): #t if obj is a GtkFileChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER_WIDGET", lg_GTK_IS_FILE_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_WIDGET obj): #t if obj is a GtkFileChooserWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TREE_MODEL_FILTER", lg_GTK_IS_TREE_MODEL_FILTER, 1, 0, 0, "(GTK_IS_TREE_MODEL_FILTER obj): #t if obj is a GtkTreeModelFilter*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COMBO_BOX", lg_GTK_IS_COMBO_BOX, 1, 0, 0, "(GTK_IS_COMBO_BOX obj): #t if obj is a GtkComboBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EXPANDER", lg_GTK_IS_EXPANDER, 1, 0, 0, "(GTK_IS_EXPANDER obj): #t if obj is a GtkExpander*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_BUTTON", lg_GTK_IS_FONT_BUTTON, 1, 0, 0, "(GTK_IS_FONT_BUTTON obj): #t if obj is a GtkFontButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COLOR_BUTTON", lg_GTK_IS_COLOR_BUTTON, 1, 0, 0, "(GTK_IS_COLOR_BUTTON obj): #t if obj is a GtkColorButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ENTRY_COMPLETION", lg_GTK_IS_ENTRY_COMPLETION, 1, 0, 0, "(GTK_IS_ENTRY_COMPLETION obj): #t if obj is a GtkEntryCompletion*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_FILTER", lg_GTK_IS_FILE_FILTER, 1, 0, 0, "(GTK_IS_FILE_FILTER obj): #t if obj is a GtkFileFilter*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_LAYOUT", lg_GTK_IS_CELL_LAYOUT, 1, 0, 0, "(GTK_IS_CELL_LAYOUT obj): #t if obj is a GtkCellLayout*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER", lg_GTK_IS_FILE_CHOOSER, 1, 0, 0, "(GTK_IS_FILE_CHOOSER obj): #t if obj is a GtkFileChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_VIEW", lg_GTK_IS_CELL_VIEW, 1, 0, 0, "(GTK_IS_CELL_VIEW obj): #t if obj is a GtkCellView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ABOUT_DIALOG", lg_GTK_IS_ABOUT_DIALOG, 1, 0, 0, "(GTK_IS_ABOUT_DIALOG obj): #t if obj is a GtkAboutDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_COMBO", lg_GTK_IS_CELL_RENDERER_COMBO, 1, 0, 0, "(GTK_IS_CELL_RENDERER_COMBO obj): #t if obj is a GtkCellRendererCombo*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_PROGRESS", lg_GTK_IS_CELL_RENDERER_PROGRESS, 1, 0, 0, "(GTK_IS_CELL_RENDERER_PROGRESS obj): #t if obj is a GtkCellRendererProgress*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ICON_VIEW", lg_GTK_IS_ICON_VIEW, 1, 0, 0, "(GTK_IS_ICON_VIEW obj): #t if obj is a GtkIconView*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FILE_CHOOSER_BUTTON", lg_GTK_IS_FILE_CHOOSER_BUTTON, 1, 0, 0, "(GTK_IS_FILE_CHOOSER_BUTTON obj): #t if obj is a GtkFileChooserButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ASSISTANT", lg_GTK_IS_ASSISTANT, 1, 0, 0, "(GTK_IS_ASSISTANT obj): #t if obj is a GtkAssistant*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_ACCEL", lg_GTK_IS_CELL_RENDERER_ACCEL, 1, 0, 0, "(GTK_IS_CELL_RENDERER_ACCEL obj): #t if obj is a GtkCellRendererAccel*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_SPIN", lg_GTK_IS_CELL_RENDERER_SPIN, 1, 0, 0, "(GTK_IS_CELL_RENDERER_SPIN obj): #t if obj is a GtkCellRendererSpin*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LINK_BUTTON", lg_GTK_IS_LINK_BUTTON, 1, 0, 0, "(GTK_IS_LINK_BUTTON obj): #t if obj is a GtkLinkButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_RECENT_MANAGER", lg_GTK_IS_RECENT_MANAGER, 1, 0, 0, "(GTK_IS_RECENT_MANAGER obj): #t if obj is a GtkRecentManager*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PRINT_CONTEXT", lg_GTK_IS_PRINT_CONTEXT, 1, 0, 0, "(GTK_IS_PRINT_CONTEXT obj): #t if obj is a GtkPrintContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PRINT_OPERATION", lg_GTK_IS_PRINT_OPERATION, 1, 0, 0, "(GTK_IS_PRINT_OPERATION obj): #t if obj is a GtkPrintOperation*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PRINT_SETTINGS", lg_GTK_IS_PRINT_SETTINGS, 1, 0, 0, "(GTK_IS_PRINT_SETTINGS obj): #t if obj is a GtkPrintSettings*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TOOLTIP", lg_GTK_IS_TOOLTIP, 1, 0, 0, "(GTK_IS_TOOLTIP obj): #t if obj is a GtkTooltip*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_INFO_BAR", lg_GTK_IS_INFO_BAR, 1, 0, 0, "(GTK_IS_INFO_BAR obj): #t if obj is a GtkInfoBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ENTRY_BUFFER", lg_GTK_IS_ENTRY_BUFFER, 1, 0, 0, "(GTK_IS_ENTRY_BUFFER obj): #t if obj is a GtkEntryBuffer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SPINNER", lg_GTK_IS_SPINNER, 1, 0, 0, "(GTK_IS_SPINNER obj): #t if obj is a GtkSpinner*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CELL_RENDERER_SPINNER", lg_GTK_IS_CELL_RENDERER_SPINNER, 1, 0, 0, "(GTK_IS_CELL_RENDERER_SPINNER obj): #t if obj is a GtkCellRendererSpinner*", pl_bt);
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define_typed_function(sc, "GTK_IS_COMBO_BOX_TEXT", lg_GTK_IS_COMBO_BOX_TEXT, 1, 0, 0, "(GTK_IS_COMBO_BOX_TEXT obj): #t if obj is a GtkComboBoxText*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GRID", lg_GTK_IS_GRID, 1, 0, 0, "(GTK_IS_GRID obj): #t if obj is a GtkGrid*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SCROLLABLE", lg_GTK_IS_SCROLLABLE, 1, 0, 0, "(GTK_IS_SCROLLABLE obj): #t if obj is a GtkScrollable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SWITCH", lg_GTK_IS_SWITCH, 1, 0, 0, "(GTK_IS_SWITCH obj): #t if obj is a GtkSwitch*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ORIENTABLE", lg_GTK_IS_ORIENTABLE, 1, 0, 0, "(GTK_IS_ORIENTABLE obj): #t if obj is a GtkOrientable*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_WINDOW_GROUP", lg_GTK_IS_WINDOW_GROUP, 1, 0, 0, "(GTK_IS_WINDOW_GROUP obj): #t if obj is a GtkWindowGroup*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define_typed_function(sc, "GTK_IS_OVERLAY", lg_GTK_IS_OVERLAY, 1, 0, 0, "(GTK_IS_OVERLAY obj): #t if obj is a GtkOverlay*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_CHOOSER", lg_GTK_IS_FONT_CHOOSER, 1, 0, 0, "(GTK_IS_FONT_CHOOSER obj): #t if obj is a GtkFontChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_CHOOSER_DIALOG", lg_GTK_IS_FONT_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_FONT_CHOOSER_DIALOG obj): #t if obj is a GtkFontChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FONT_CHOOSER_WIDGET", lg_GTK_IS_FONT_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_FONT_CHOOSER_WIDGET obj): #t if obj is a GtkFontChooserWidget*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define_typed_function(sc, "GTK_IS_APPLICATION", lg_GTK_IS_APPLICATION, 1, 0, 0, "(GTK_IS_APPLICATION obj): #t if obj is a GtkApplication*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_APPLICATION_WINDOW", lg_GTK_IS_APPLICATION_WINDOW, 1, 0, 0, "(GTK_IS_APPLICATION_WINDOW obj): #t if obj is a GtkApplicationWindow*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COLOR_CHOOSER_DIALOG", lg_GTK_IS_COLOR_CHOOSER_DIALOG, 1, 0, 0, "(GTK_IS_COLOR_CHOOSER_DIALOG obj): #t if obj is a GtkColorChooserDialog*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_COLOR_CHOOSER_WIDGET", lg_GTK_IS_COLOR_CHOOSER_WIDGET, 1, 0, 0, "(GTK_IS_COLOR_CHOOSER_WIDGET obj): #t if obj is a GtkColorWidget*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define_typed_function(sc, "GTK_IS_MENU_BUTTON", lg_GTK_IS_MENU_BUTTON, 1, 0, 0, "(GTK_IS_MENU_BUTTON obj): #t if obj is a GtkMenuButton*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEARCH_ENTRY", lg_GTK_IS_SEARCH_ENTRY, 1, 0, 0, "(GTK_IS_SEARCH_ENTRY obj): #t if obj is a GtkWidget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LEVEL_BAR", lg_GTK_IS_LEVEL_BAR, 1, 0, 0, "(GTK_IS_LEVEL_BAR obj): #t if obj is a GtkLevelBar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define_typed_function(sc, "GTK_IS_STACK_SWITCHER", lg_GTK_IS_STACK_SWITCHER, 1, 0, 0, "(GTK_IS_STACK_SWITCHER obj): #t if obj is a GtkStackSwitcher*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STACK", lg_GTK_IS_STACK, 1, 0, 0, "(GTK_IS_STACK obj): #t if obj is a GtkStack*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_REVEALER", lg_GTK_IS_REVEALER, 1, 0, 0, "(GTK_IS_REVEALER obj): #t if obj is a GtkRevealer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_HEADER_BAR", lg_GTK_IS_HEADER_BAR, 1, 0, 0, "(GTK_IS_HEADER_BAR obj): #t if obj is a GtkHeaderBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LIST_BOX", lg_GTK_IS_LIST_BOX, 1, 0, 0, "(GTK_IS_LIST_BOX obj): #t if obj is a GtkListBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_LIST_BOX_ROW", lg_GTK_IS_LIST_BOX_ROW, 1, 0, 0, "(GTK_IS_LIST_BOX_ROW obj): #t if obj is a GtkListBoxRow*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SEARCH_BAR", lg_GTK_IS_SEARCH_BAR, 1, 0, 0, "(GTK_IS_SEARCH_BAR obj): #t if obj is a GtkSearchBar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define_typed_function(sc, "GTK_IS_FLOW_BOX", lg_GTK_IS_FLOW_BOX, 1, 0, 0, "(GTK_IS_FLOW_BOX obj): #t if obj is a GtkFlowBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_FLOW_BOX_CHILD", lg_GTK_IS_FLOW_BOX_CHILD, 1, 0, 0, "(GTK_IS_FLOW_BOX_CHILD obj): #t if obj is a GtkFlowBoxChild*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_ACTION_BAR", lg_GTK_IS_ACTION_BAR, 1, 0, 0, "(GTK_IS_ACTION_BAR obj): #t if obj is a GtkActionBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_POPOVER", lg_GTK_IS_POPOVER, 1, 0, 0, "(GTK_IS_POPOVER obj): #t if obj is a GtkPopover*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define_typed_function(sc, "GTK_IS_GESTURE", lg_GTK_IS_GESTURE, 1, 0, 0, "(GTK_IS_GESTURE obj): #t if obj is a GtkGesture*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_DRAG", lg_GTK_IS_GESTURE_DRAG, 1, 0, 0, "(GTK_IS_GESTURE_DRAG obj): #t if obj is a GtkGestureDrag*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_LONG_PRESS", lg_GTK_IS_GESTURE_LONG_PRESS, 1, 0, 0, "(GTK_IS_GESTURE_LONG_PRESS obj): #t if obj is a GtkGestureLongPress*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_ZOOM", lg_GTK_IS_GESTURE_ZOOM, 1, 0, 0, "(GTK_IS_GESTURE_ZOOM obj): #t if obj is a GtkGestureZoom*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_SWIPE", lg_GTK_IS_GESTURE_SWIPE, 1, 0, 0, "(GTK_IS_GESTURE_SWIPE obj): #t if obj is a GtkGestureSwipe*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_SINGLE", lg_GTK_IS_GESTURE_SINGLE, 1, 0, 0, "(GTK_IS_GESTURE_SINGLE obj): #t if obj is a GtkGestureSingle*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_PAN", lg_GTK_IS_GESTURE_PAN, 1, 0, 0, "(GTK_IS_GESTURE_PAN obj): #t if obj is a GtkGesturePan*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_ROTATE", lg_GTK_IS_GESTURE_ROTATE, 1, 0, 0, "(GTK_IS_GESTURE_ROTATE obj): #t if obj is a GtkGestureRotate*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define_typed_function(sc, "GTK_IS_GL_AREA", lg_GTK_IS_GL_AREA, 1, 0, 0, "(GTK_IS_GL_AREA obj): #t if obj is a GtkGLArea*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_GL_CONTEXT", lg_GDK_IS_GL_CONTEXT, 1, 0, 0, "(GDK_IS_GL_CONTEXT obj): #t if obj is a GdkGLContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STACK_SIDEBAR", lg_GTK_IS_STACK_SIDEBAR, 1, 0, 0, "(GTK_IS_STACK_SIDEBAR obj): #t if obj is a GtkStackSidebar*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define_typed_function(sc, "GDK_IS_SEAT", lg_GDK_IS_SEAT, 1, 0, 0, "(GDK_IS_SEAT obj): #t if obj is a GdkSeat*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define_typed_function(sc, "GDK_IS_DEVICE_TOOL", lg_GDK_IS_DEVICE_TOOL, 1, 0, 0, "(GDK_IS_DEVICE_TOOL obj): #t if obj is a GdkDeviceTool*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_MONITOR", lg_GDK_IS_MONITOR, 1, 0, 0, "(GDK_IS_MONITOR obj): #t if obj is a GdkMonitor*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DEVICE_PAD", lg_GDK_IS_DEVICE_PAD, 1, 0, 0, "(GDK_IS_DEVICE_PAD obj): #t if obj is a GdkDevicePad*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PAD_CONTROLLER", lg_GTK_IS_PAD_CONTROLLER, 1, 0, 0, "(GTK_IS_PAD_CONTROLLER obj): #t if obj is a GtkPadController*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SHORTCUT_LABEL", lg_GTK_IS_SHORTCUT_LABEL, 1, 0, 0, "(GTK_IS_SHORTCUT_LABEL obj): #t if obj is a GtkShortcutLabel*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  s7_define_typed_function(sc, "GTK_IS_CENTER_BOX", lg_GTK_IS_CENTER_BOX, 1, 0, 0, "(GTK_IS_CENTER_BOX obj): #t if obj is a GtkCenterBox*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STYLE_CONTEXT", lg_GTK_IS_STYLE_CONTEXT, 1, 0, 0, "(GTK_IS_STYLE_CONTEXT obj): #t if obj is a GtkStyleContext*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_STYLE_PROVIDER", lg_GTK_IS_STYLE_PROVIDER, 1, 0, 0, "(GTK_IS_STYLE_PROVIDER obj): #t if obj is a GtkStyleProvider*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CSS_PROVIDER", lg_GTK_IS_CSS_PROVIDER, 1, 0, 0, "(GTK_IS_CSS_PROVIDER obj): #t if obj is a GtkCssProvider*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
  s7_define_typed_function(sc, "GTK_IS_EMOJI_CHOOSER", lg_GTK_IS_EMOJI_CHOOSER, 1, 0, 0, "(GTK_IS_EMOJI_CHOOSER obj): #t if obj is a GtkEmojiChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER_SCROLL", lg_GTK_IS_EVENT_CONTROLLER_SCROLL, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER_SCROLL obj): #t if obj is a GtkEventControllerScroll*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER_MOTION", lg_GTK_IS_EVENT_CONTROLLER_MOTION, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER_MOTION obj): #t if obj is a GtkEventControllerMotion*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_TEXTURE", lg_GDK_IS_TEXTURE, 1, 0, 0, "(GDK_IS_TEXTURE obj): #t if obj is a GdkTexture*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_EVENT", lg_GDK_IS_EVENT, 1, 0, 0, "(GDK_IS_EVENT obj): #t if obj is a GdkEvent*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_APP_LAUNCH_CONTEXT", lg_GDK_IS_APP_LAUNCH_CONTEXT, 1, 0, 0, "(GDK_IS_APP_LAUNCH_CONTEXT obj): #t if obj is a GdkAppLaunchContext*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_CLIPBOARD", lg_GDK_IS_CLIPBOARD, 1, 0, 0, "(GDK_IS_CLIPBOARD obj): #t if obj is a GdkClipboard*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_CONTENT_PROVIDER", lg_GDK_IS_CONTENT_PROVIDER, 1, 0, 0, "(GDK_IS_CONTENT_PROVIDER obj): #t if obj is a GdkContentProvider*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_CONTENT_SERIALIZER", lg_GDK_IS_CONTENT_SERIALIZER, 1, 0, 0, "(GDK_IS_CONTENT_SERIALIZER obj): #t if obj is a GdkContentSerializer*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_CONTENT_DESERIALIZER", lg_GDK_IS_CONTENT_DESERIALIZER, 1, 0, 0, "(GDK_IS_CONTENT_DESERIALIZER obj): #t if obj is a GdkContentDeserializer*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_GESTURE_STYLUS", lg_GTK_IS_GESTURE_STYLUS, 1, 0, 0, "(GTK_IS_GESTURE_STYLUS obj): #t if obj is a GtkGestureStylus*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER", lg_GTK_IS_EVENT_CONTROLLER, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER obj): #t if obj is a GtkEventController*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_SURFACE", lg_GDK_IS_SURFACE, 1, 0, 0, "(GDK_IS_SURFACE obj): #t if obj is a GdkSurface*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_CAIRO_CONTEXT", lg_GDK_IS_CAIRO_CONTEXT, 1, 0, 0, "(GDK_IS_CAIRO_CONTEXT obj): #t if obj is a GdkCairoContext*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DROP", lg_GDK_IS_DROP, 1, 0, 0, "(GDK_IS_DROP obj): #t if obj is a GdkDrop*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_GL_TEXTURE", lg_GDK_IS_GL_TEXTURE, 1, 0, 0, "(GDK_IS_GL_TEXTURE obj): #t if obj is a GdkGLTexture*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
  s7_define_typed_function(sc, "GTK_IS_NOTEBOOK_PAGE", lg_GTK_IS_NOTEBOOK_PAGE, 1, 0, 0, "(GTK_IS_NOTEBOOK_PAGE obj): #t if obj is a GtkNotebookPage*", pl_bt);
  s7_define_typed_function(sc, "GDK_IS_DRAG", lg_GDK_IS_DRAG, 1, 0, 0, "(GDK_IS_DRAG obj): #t if obj is a GdkDrag*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER_LEGACY", lg_GTK_IS_EVENT_CONTROLLER_LEGACY, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER_LEGACY obj): #t if obj is a GtkEventControllerLegacy*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_PASSWORD_ENTRY", lg_GTK_IS_PASSWORD_ENTRY, 1, 0, 0, "(GTK_IS_PASSWORD_ENTRY obj): #t if obj is a GtkPasswordEntry*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_TEXT", lg_GTK_IS_TEXT, 1, 0, 0, "(GTK_IS_TEXT obj): #t if obj is a GtkText*", pl_bt);
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER", lg_GTK_IS_EVENT_CONTROLLER, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER obj): #t if obj is a GtkEventController*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_POPOVER_MENU_BAR", lg_GTK_IS_POPOVER_MENU_BAR, 1, 0, 0, "(GTK_IS_POPOVER_MENU_BAR obj): #t if obj is a GtkPopoverMenuBar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_CALENDAR", lg_GTK_IS_CALENDAR, 1, 0, 0, "(GTK_IS_CALENDAR obj): #t if obj is a GtkCalendar*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EVENT_CONTROLLER_FOCUS", lg_GTK_IS_EVENT_CONTROLLER_FOCUS, 1, 0, 0, "(GTK_IS_EVENT_CONTROLLER_FOCUS obj): #t if obj is a GtkEventControllerFocus*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DROP_CONTROLLER_MOTION", lg_GTK_IS_DROP_CONTROLLER_MOTION, 1, 0, 0, "(GTK_IS_DROP_CONTROLLER_MOTION obj): #t if obj is a GtkDropControllerMotion*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DROP_TARGET", lg_GTK_IS_DROP_TARGET, 1, 0, 0, "(GTK_IS_DROP_TARGET obj): #t if obj is a GtkDropTarget*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_EMOJI_CHOOSER", lg_GTK_IS_EMOJI_CHOOSER, 1, 0, 0, "(GTK_IS_EMOJI_CHOOSER obj): #t if obj is a GtkEmojiChooser*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_DROP_TARGET_ASYNC", lg_GTK_IS_DROP_TARGET_ASYNC, 1, 0, 0, "(GTK_IS_DROP_TARGET_ASYNC obj): #t if obj is a GtkDropTargetAsync*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_POPOVER_MENU", lg_GTK_IS_POPOVER_MENU, 1, 0, 0, "(GTK_IS_POPOVER_MENU obj): #t if obj is a GtkPopoverMenu*", pl_bt);
  s7_define_typed_function(sc, "GTK_IS_SHORTCUT_CONTROLLER", lg_GTK_IS_SHORTCUT_CONTROLLER, 1, 0, 0, "(GTK_IS_SHORTCUT_CONTROLLER obj): #t if obj is a GtkShortcutController*", pl_bt);
#endif

}

static void define_integers(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

#if !GLIB_CHECK_VERSION(2,35,0)
  g_type_init();
#endif
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_DEFAULT"), s7_make_integer(sc, G_NORMALIZE_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFD"), s7_make_integer(sc, G_NORMALIZE_NFD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_DEFAULT_COMPOSE"), s7_make_integer(sc, G_NORMALIZE_DEFAULT_COMPOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFC"), s7_make_integer(sc, G_NORMALIZE_NFC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_ALL"), s7_make_integer(sc, G_NORMALIZE_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFKD"), s7_make_integer(sc, G_NORMALIZE_NFKD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_ALL_COMPOSE"), s7_make_integer(sc, G_NORMALIZE_ALL_COMPOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_NORMALIZE_NFKC"), s7_make_integer(sc, G_NORMALIZE_NFKC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_RUN_FIRST"), s7_make_integer(sc, G_SIGNAL_RUN_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_RUN_LAST"), s7_make_integer(sc, G_SIGNAL_RUN_LAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_RUN_CLEANUP"), s7_make_integer(sc, G_SIGNAL_RUN_CLEANUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_NO_RECURSE"), s7_make_integer(sc, G_SIGNAL_NO_RECURSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_DETAILED"), s7_make_integer(sc, G_SIGNAL_DETAILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_ACTION"), s7_make_integer(sc, G_SIGNAL_ACTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_NO_HOOKS"), s7_make_integer(sc, G_SIGNAL_NO_HOOKS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_CONNECT_AFTER"), s7_make_integer(sc, G_CONNECT_AFTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_CONNECT_SWAPPED"), s7_make_integer(sc, G_CONNECT_SWAPPED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_ID"), s7_make_integer(sc, G_SIGNAL_MATCH_ID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_DETAIL"), s7_make_integer(sc, G_SIGNAL_MATCH_DETAIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_CLOSURE"), s7_make_integer(sc, G_SIGNAL_MATCH_CLOSURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_FUNC"), s7_make_integer(sc, G_SIGNAL_MATCH_FUNC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_DATA"), s7_make_integer(sc, G_SIGNAL_MATCH_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_SIGNAL_MATCH_UNBLOCKED"), s7_make_integer(sc, G_SIGNAL_MATCH_UNBLOCKED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_COPY"), s7_make_integer(sc, GDK_ACTION_COPY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_MOVE"), s7_make_integer(sc, GDK_ACTION_MOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_LINK"), s7_make_integer(sc, GDK_ACTION_LINK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ACTION_ASK"), s7_make_integer(sc, GDK_ACTION_ASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PRIORITY_EVENTS"), s7_make_integer(sc, GDK_PRIORITY_EVENTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PRIORITY_REDRAW"), s7_make_integer(sc, GDK_PRIORITY_REDRAW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DELETE"), s7_make_integer(sc, GDK_DELETE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MOTION_NOTIFY"), s7_make_integer(sc, GDK_MOTION_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_PRESS"), s7_make_integer(sc, GDK_BUTTON_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_RELEASE"), s7_make_integer(sc, GDK_BUTTON_RELEASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_PRESS"), s7_make_integer(sc, GDK_KEY_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_RELEASE"), s7_make_integer(sc, GDK_KEY_RELEASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ENTER_NOTIFY"), s7_make_integer(sc, GDK_ENTER_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEAVE_NOTIFY"), s7_make_integer(sc, GDK_LEAVE_NOTIFY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FOCUS_CHANGE"), s7_make_integer(sc, GDK_FOCUS_CHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CONFIGURE"), s7_make_integer(sc, GDK_CONFIGURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_IN"), s7_make_integer(sc, GDK_PROXIMITY_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_OUT"), s7_make_integer(sc, GDK_PROXIMITY_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_ENTER"), s7_make_integer(sc, GDK_DRAG_ENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_LEAVE"), s7_make_integer(sc, GDK_DRAG_LEAVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_MOTION"), s7_make_integer(sc, GDK_DRAG_MOTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DROP_START"), s7_make_integer(sc, GDK_DROP_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL"), s7_make_integer(sc, GDK_SCROLL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_GRAB_BROKEN"), s7_make_integer(sc, GDK_GRAB_BROKEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_EXPOSURE_MASK"), s7_make_integer(sc, GDK_EXPOSURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_POINTER_MOTION_MASK"), s7_make_integer(sc, GDK_POINTER_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON1_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON1_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON2_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON2_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON3_MOTION_MASK"), s7_make_integer(sc, GDK_BUTTON3_MOTION_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_PRESS_MASK"), s7_make_integer(sc, GDK_BUTTON_PRESS_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON_RELEASE_MASK"), s7_make_integer(sc, GDK_BUTTON_RELEASE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_PRESS_MASK"), s7_make_integer(sc, GDK_KEY_PRESS_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_RELEASE_MASK"), s7_make_integer(sc, GDK_KEY_RELEASE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ENTER_NOTIFY_MASK"), s7_make_integer(sc, GDK_ENTER_NOTIFY_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LEAVE_NOTIFY_MASK"), s7_make_integer(sc, GDK_LEAVE_NOTIFY_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FOCUS_CHANGE_MASK"), s7_make_integer(sc, GDK_FOCUS_CHANGE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_STRUCTURE_MASK"), s7_make_integer(sc, GDK_STRUCTURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROPERTY_CHANGE_MASK"), s7_make_integer(sc, GDK_PROPERTY_CHANGE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_IN_MASK"), s7_make_integer(sc, GDK_PROXIMITY_IN_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PROXIMITY_OUT_MASK"), s7_make_integer(sc, GDK_PROXIMITY_OUT_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBSTRUCTURE_MASK"), s7_make_integer(sc, GDK_SUBSTRUCTURE_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_MASK"), s7_make_integer(sc, GDK_SCROLL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_UP"), s7_make_integer(sc, GDK_SCROLL_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_DOWN"), s7_make_integer(sc, GDK_SCROLL_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_LEFT"), s7_make_integer(sc, GDK_SCROLL_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_RIGHT"), s7_make_integer(sc, GDK_SCROLL_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_ANCESTOR"), s7_make_integer(sc, GDK_NOTIFY_ANCESTOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_VIRTUAL"), s7_make_integer(sc, GDK_NOTIFY_VIRTUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_INFERIOR"), s7_make_integer(sc, GDK_NOTIFY_INFERIOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_NONLINEAR"), s7_make_integer(sc, GDK_NOTIFY_NONLINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_NONLINEAR_VIRTUAL"), s7_make_integer(sc, GDK_NOTIFY_NONLINEAR_VIRTUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_NOTIFY_UNKNOWN"), s7_make_integer(sc, GDK_NOTIFY_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_NORMAL"), s7_make_integer(sc, GDK_CROSSING_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_GRAB"), s7_make_integer(sc, GDK_CROSSING_GRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_UNGRAB"), s7_make_integer(sc, GDK_CROSSING_UNGRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CURRENT_TIME"), s7_make_integer(sc, GDK_CURRENT_TIME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PARENT_RELATIVE"), s7_make_integer(sc, GDK_PARENT_RELATIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LSB_FIRST"), s7_make_integer(sc, GDK_LSB_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MSB_FIRST"), s7_make_integer(sc, GDK_MSB_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SHIFT_MASK"), s7_make_integer(sc, GDK_SHIFT_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_LOCK_MASK"), s7_make_integer(sc, GDK_LOCK_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CONTROL_MASK"), s7_make_integer(sc, GDK_CONTROL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON1_MASK"), s7_make_integer(sc, GDK_BUTTON1_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON2_MASK"), s7_make_integer(sc, GDK_BUTTON2_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON3_MASK"), s7_make_integer(sc, GDK_BUTTON3_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON4_MASK"), s7_make_integer(sc, GDK_BUTTON4_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_BUTTON5_MASK"), s7_make_integer(sc, GDK_BUTTON5_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MODIFIER_MASK"), s7_make_integer(sc, GDK_MODIFIER_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ALPHA_BILEVEL"), s7_make_integer(sc, GDK_PIXBUF_ALPHA_BILEVEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ALPHA_FULL"), s7_make_integer(sc, GDK_PIXBUF_ALPHA_FULL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_COLORSPACE_RGB"), s7_make_integer(sc, GDK_COLORSPACE_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_CORRUPT_IMAGE"), s7_make_integer(sc, GDK_PIXBUF_ERROR_CORRUPT_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY"), s7_make_integer(sc, GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_BAD_OPTION"), s7_make_integer(sc, GDK_PIXBUF_ERROR_BAD_OPTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_UNKNOWN_TYPE"), s7_make_integer(sc, GDK_PIXBUF_ERROR_UNKNOWN_TYPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION"), s7_make_integer(sc, GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PIXBUF_ERROR_FAILED"), s7_make_integer(sc, GDK_PIXBUF_ERROR_FAILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_NEAREST"), s7_make_integer(sc, GDK_INTERP_NEAREST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_TILES"), s7_make_integer(sc, GDK_INTERP_TILES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_BILINEAR"), s7_make_integer(sc, GDK_INTERP_BILINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_INTERP_HYPER"), s7_make_integer(sc, GDK_INTERP_HYPER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_HEADING"), s7_make_integer(sc, GTK_CALENDAR_SHOW_HEADING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_DAY_NAMES"), s7_make_integer(sc, GTK_CALENDAR_SHOW_DAY_NAMES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_NO_MONTH_CHANGE"), s7_make_integer(sc, GTK_CALENDAR_NO_MONTH_CHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_WEEK_NUMBERS"), s7_make_integer(sc, GTK_CALENDAR_SHOW_WEEK_NUMBERS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_SELECTED"), s7_make_integer(sc, GTK_CELL_RENDERER_SELECTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_PRELIT"), s7_make_integer(sc, GTK_CELL_RENDERER_PRELIT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_INSENSITIVE"), s7_make_integer(sc, GTK_CELL_RENDERER_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_SORTED"), s7_make_integer(sc, GTK_CELL_RENDERER_SORTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_FOCUSED"), s7_make_integer(sc, GTK_CELL_RENDERER_FOCUSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIALOG_MODAL"), s7_make_integer(sc, GTK_DIALOG_MODAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIALOG_DESTROY_WITH_PARENT"), s7_make_integer(sc, GTK_DIALOG_DESTROY_WITH_PARENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_NONE"), s7_make_integer(sc, GTK_RESPONSE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_REJECT"), s7_make_integer(sc, GTK_RESPONSE_REJECT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_ACCEPT"), s7_make_integer(sc, GTK_RESPONSE_ACCEPT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_DELETE_EVENT"), s7_make_integer(sc, GTK_RESPONSE_DELETE_EVENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_OK"), s7_make_integer(sc, GTK_RESPONSE_OK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_CANCEL"), s7_make_integer(sc, GTK_RESPONSE_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_CLOSE"), s7_make_integer(sc, GTK_RESPONSE_CLOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_YES"), s7_make_integer(sc, GTK_RESPONSE_YES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_NO"), s7_make_integer(sc, GTK_RESPONSE_NO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_APPLY"), s7_make_integer(sc, GTK_RESPONSE_APPLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RESPONSE_HELP"), s7_make_integer(sc, GTK_RESPONSE_HELP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_MOTION"), s7_make_integer(sc, GTK_DEST_DEFAULT_MOTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_HIGHLIGHT"), s7_make_integer(sc, GTK_DEST_DEFAULT_HIGHLIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_DROP"), s7_make_integer(sc, GTK_DEST_DEFAULT_DROP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DEST_DEFAULT_ALL"), s7_make_integer(sc, GTK_DEST_DEFAULT_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_CHARS"), s7_make_integer(sc, GTK_DELETE_CHARS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_WORD_ENDS"), s7_make_integer(sc, GTK_DELETE_WORD_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_WORDS"), s7_make_integer(sc, GTK_DELETE_WORDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_DISPLAY_LINES"), s7_make_integer(sc, GTK_DELETE_DISPLAY_LINES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_DISPLAY_LINE_ENDS"), s7_make_integer(sc, GTK_DELETE_DISPLAY_LINE_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_PARAGRAPH_ENDS"), s7_make_integer(sc, GTK_DELETE_PARAGRAPH_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_PARAGRAPHS"), s7_make_integer(sc, GTK_DELETE_PARAGRAPHS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DELETE_WHITESPACE"), s7_make_integer(sc, GTK_DELETE_WHITESPACE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_TAB_FORWARD"), s7_make_integer(sc, GTK_DIR_TAB_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_TAB_BACKWARD"), s7_make_integer(sc, GTK_DIR_TAB_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_UP"), s7_make_integer(sc, GTK_DIR_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_DOWN"), s7_make_integer(sc, GTK_DIR_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_LEFT"), s7_make_integer(sc, GTK_DIR_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_DIR_RIGHT"), s7_make_integer(sc, GTK_DIR_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_DIR_NONE"), s7_make_integer(sc, GTK_TEXT_DIR_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_DIR_LTR"), s7_make_integer(sc, GTK_TEXT_DIR_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_DIR_RTL"), s7_make_integer(sc, GTK_TEXT_DIR_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_LEFT"), s7_make_integer(sc, GTK_JUSTIFY_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_RIGHT"), s7_make_integer(sc, GTK_JUSTIFY_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_CENTER"), s7_make_integer(sc, GTK_JUSTIFY_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_JUSTIFY_FILL"), s7_make_integer(sc, GTK_JUSTIFY_FILL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_PARENT"), s7_make_integer(sc, GTK_MENU_DIR_PARENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_CHILD"), s7_make_integer(sc, GTK_MENU_DIR_CHILD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_NEXT"), s7_make_integer(sc, GTK_MENU_DIR_NEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MENU_DIR_PREV"), s7_make_integer(sc, GTK_MENU_DIR_PREV));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_LOGICAL_POSITIONS"), s7_make_integer(sc, GTK_MOVEMENT_LOGICAL_POSITIONS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_VISUAL_POSITIONS"), s7_make_integer(sc, GTK_MOVEMENT_VISUAL_POSITIONS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_WORDS"), s7_make_integer(sc, GTK_MOVEMENT_WORDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_DISPLAY_LINES"), s7_make_integer(sc, GTK_MOVEMENT_DISPLAY_LINES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_DISPLAY_LINE_ENDS"), s7_make_integer(sc, GTK_MOVEMENT_DISPLAY_LINE_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_PARAGRAPHS"), s7_make_integer(sc, GTK_MOVEMENT_PARAGRAPHS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_PARAGRAPH_ENDS"), s7_make_integer(sc, GTK_MOVEMENT_PARAGRAPH_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_PAGES"), s7_make_integer(sc, GTK_MOVEMENT_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_BUFFER_ENDS"), s7_make_integer(sc, GTK_MOVEMENT_BUFFER_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ORIENTATION_HORIZONTAL"), s7_make_integer(sc, GTK_ORIENTATION_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ORIENTATION_VERTICAL"), s7_make_integer(sc, GTK_ORIENTATION_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_TOP_LEFT"), s7_make_integer(sc, GTK_CORNER_TOP_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_BOTTOM_LEFT"), s7_make_integer(sc, GTK_CORNER_BOTTOM_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_TOP_RIGHT"), s7_make_integer(sc, GTK_CORNER_TOP_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CORNER_BOTTOM_RIGHT"), s7_make_integer(sc, GTK_CORNER_BOTTOM_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_START"), s7_make_integer(sc, GTK_PACK_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PACK_END"), s7_make_integer(sc, GTK_PACK_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_ALWAYS"), s7_make_integer(sc, GTK_POLICY_ALWAYS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_AUTOMATIC"), s7_make_integer(sc, GTK_POLICY_AUTOMATIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_NEVER"), s7_make_integer(sc, GTK_POLICY_NEVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_LEFT"), s7_make_integer(sc, GTK_POS_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_RIGHT"), s7_make_integer(sc, GTK_POS_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_TOP"), s7_make_integer(sc, GTK_POS_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POS_BOTTOM"), s7_make_integer(sc, GTK_POS_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_NONE"), s7_make_integer(sc, GTK_SCROLL_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_JUMP"), s7_make_integer(sc, GTK_SCROLL_JUMP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_BACKWARD"), s7_make_integer(sc, GTK_SCROLL_STEP_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_FORWARD"), s7_make_integer(sc, GTK_SCROLL_STEP_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_BACKWARD"), s7_make_integer(sc, GTK_SCROLL_PAGE_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_FORWARD"), s7_make_integer(sc, GTK_SCROLL_PAGE_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_UP"), s7_make_integer(sc, GTK_SCROLL_STEP_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_DOWN"), s7_make_integer(sc, GTK_SCROLL_STEP_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_UP"), s7_make_integer(sc, GTK_SCROLL_PAGE_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_DOWN"), s7_make_integer(sc, GTK_SCROLL_PAGE_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_LEFT"), s7_make_integer(sc, GTK_SCROLL_STEP_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEP_RIGHT"), s7_make_integer(sc, GTK_SCROLL_STEP_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_LEFT"), s7_make_integer(sc, GTK_SCROLL_PAGE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGE_RIGHT"), s7_make_integer(sc, GTK_SCROLL_PAGE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_START"), s7_make_integer(sc, GTK_SCROLL_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_END"), s7_make_integer(sc, GTK_SCROLL_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_NONE"), s7_make_integer(sc, GTK_SELECTION_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_SINGLE"), s7_make_integer(sc, GTK_SELECTION_SINGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_BROWSE"), s7_make_integer(sc, GTK_SELECTION_BROWSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SELECTION_MULTIPLE"), s7_make_integer(sc, GTK_SELECTION_MULTIPLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_NONE"), s7_make_integer(sc, GTK_WRAP_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_CHAR"), s7_make_integer(sc, GTK_WRAP_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_WORD"), s7_make_integer(sc, GTK_WRAP_WORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SORT_ASCENDING"), s7_make_integer(sc, GTK_SORT_ASCENDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SORT_DESCENDING"), s7_make_integer(sc, GTK_SORT_DESCENDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_EMPTY"), s7_make_integer(sc, GTK_IMAGE_EMPTY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MAX_COMPOSE_LEN"), s7_make_integer(sc, GTK_MAX_COMPOSE_LEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRIORITY_RESIZE"), s7_make_integer(sc, GTK_PRIORITY_RESIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_INFO"), s7_make_integer(sc, GTK_MESSAGE_INFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_WARNING"), s7_make_integer(sc, GTK_MESSAGE_WARNING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_QUESTION"), s7_make_integer(sc, GTK_MESSAGE_QUESTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_ERROR"), s7_make_integer(sc, GTK_MESSAGE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_NONE"), s7_make_integer(sc, GTK_BUTTONS_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_OK"), s7_make_integer(sc, GTK_BUTTONS_OK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_CLOSE"), s7_make_integer(sc, GTK_BUTTONS_CLOSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_CANCEL"), s7_make_integer(sc, GTK_BUTTONS_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_YES_NO"), s7_make_integer(sc, GTK_BUTTONS_YES_NO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BUTTONS_OK_CANCEL"), s7_make_integer(sc, GTK_BUTTONS_OK_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_NOTEBOOK_TAB_FIRST"), s7_make_integer(sc, GTK_NOTEBOOK_TAB_FIRST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_NOTEBOOK_TAB_LAST"), s7_make_integer(sc, GTK_NOTEBOOK_TAB_LAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_NONE"), s7_make_integer(sc, GTK_SIZE_GROUP_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_HORIZONTAL"), s7_make_integer(sc, GTK_SIZE_GROUP_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_VERTICAL"), s7_make_integer(sc, GTK_SIZE_GROUP_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_GROUP_BOTH"), s7_make_integer(sc, GTK_SIZE_GROUP_BOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_ERROR"), s7_make_integer(sc, GTK_INPUT_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_UPDATE_ALWAYS"), s7_make_integer(sc, GTK_UPDATE_ALWAYS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_UPDATE_IF_VALID"), s7_make_integer(sc, GTK_UPDATE_IF_VALID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_STEP_FORWARD"), s7_make_integer(sc, GTK_SPIN_STEP_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_STEP_BACKWARD"), s7_make_integer(sc, GTK_SPIN_STEP_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_PAGE_FORWARD"), s7_make_integer(sc, GTK_SPIN_PAGE_FORWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_PAGE_BACKWARD"), s7_make_integer(sc, GTK_SPIN_PAGE_BACKWARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_HOME"), s7_make_integer(sc, GTK_SPIN_HOME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_END"), s7_make_integer(sc, GTK_SPIN_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SPIN_USER_DEFINED"), s7_make_integer(sc, GTK_SPIN_USER_DEFINED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_SEARCH_VISIBLE_ONLY"), s7_make_integer(sc, GTK_TEXT_SEARCH_VISIBLE_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_SEARCH_TEXT_ONLY"), s7_make_integer(sc, GTK_TEXT_SEARCH_TEXT_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_WIDGET"), s7_make_integer(sc, GTK_TEXT_WINDOW_WIDGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_TEXT"), s7_make_integer(sc, GTK_TEXT_WINDOW_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_LEFT"), s7_make_integer(sc, GTK_TEXT_WINDOW_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_RIGHT"), s7_make_integer(sc, GTK_TEXT_WINDOW_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_TOP"), s7_make_integer(sc, GTK_TEXT_WINDOW_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_WINDOW_BOTTOM"), s7_make_integer(sc, GTK_TEXT_WINDOW_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_VIEW_PRIORITY_VALIDATE"), s7_make_integer(sc, GTK_TEXT_VIEW_PRIORITY_VALIDATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_MODEL_ITERS_PERSIST"), s7_make_integer(sc, GTK_TREE_MODEL_ITERS_PERSIST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_MODEL_LIST_ONLY"), s7_make_integer(sc, GTK_TREE_MODEL_LIST_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_COLUMN_GROW_ONLY"), s7_make_integer(sc, GTK_TREE_VIEW_COLUMN_GROW_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_COLUMN_AUTOSIZE"), s7_make_integer(sc, GTK_TREE_VIEW_COLUMN_AUTOSIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_COLUMN_FIXED"), s7_make_integer(sc, GTK_TREE_VIEW_COLUMN_FIXED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_BEFORE"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_BEFORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_AFTER"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_AFTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_INTO_OR_BEFORE"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_INTO_OR_BEFORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_DROP_INTO_OR_AFTER"), s7_make_integer(sc, GTK_TREE_VIEW_DROP_INTO_OR_AFTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MAJOR_VERSION"), s7_make_integer(sc, GTK_MAJOR_VERSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MINOR_VERSION"), s7_make_integer(sc, GTK_MINOR_VERSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MICRO_VERSION"), s7_make_integer(sc, GTK_MICRO_VERSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_INVALID"), s7_make_integer(sc, PANGO_ATTR_INVALID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_LANGUAGE"), s7_make_integer(sc, PANGO_ATTR_LANGUAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FAMILY"), s7_make_integer(sc, PANGO_ATTR_FAMILY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STYLE"), s7_make_integer(sc, PANGO_ATTR_STYLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_WEIGHT"), s7_make_integer(sc, PANGO_ATTR_WEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_VARIANT"), s7_make_integer(sc, PANGO_ATTR_VARIANT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STRETCH"), s7_make_integer(sc, PANGO_ATTR_STRETCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_SIZE"), s7_make_integer(sc, PANGO_ATTR_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FONT_DESC"), s7_make_integer(sc, PANGO_ATTR_FONT_DESC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FOREGROUND"), s7_make_integer(sc, PANGO_ATTR_FOREGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_BACKGROUND"), s7_make_integer(sc, PANGO_ATTR_BACKGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_UNDERLINE"), s7_make_integer(sc, PANGO_ATTR_UNDERLINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STRIKETHROUGH"), s7_make_integer(sc, PANGO_ATTR_STRIKETHROUGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_RISE"), s7_make_integer(sc, PANGO_ATTR_RISE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_SHAPE"), s7_make_integer(sc, PANGO_ATTR_SHAPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_SCALE"), s7_make_integer(sc, PANGO_ATTR_SCALE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_NONE"), s7_make_integer(sc, PANGO_UNDERLINE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_SINGLE"), s7_make_integer(sc, PANGO_UNDERLINE_SINGLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_DOUBLE"), s7_make_integer(sc, PANGO_UNDERLINE_DOUBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_LOW"), s7_make_integer(sc, PANGO_UNDERLINE_LOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_NONE"), s7_make_integer(sc, PANGO_COVERAGE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_FALLBACK"), s7_make_integer(sc, PANGO_COVERAGE_FALLBACK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_APPROXIMATE"), s7_make_integer(sc, PANGO_COVERAGE_APPROXIMATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_COVERAGE_EXACT"), s7_make_integer(sc, PANGO_COVERAGE_EXACT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STYLE_NORMAL"), s7_make_integer(sc, PANGO_STYLE_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STYLE_OBLIQUE"), s7_make_integer(sc, PANGO_STYLE_OBLIQUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STYLE_ITALIC"), s7_make_integer(sc, PANGO_STYLE_ITALIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_VARIANT_NORMAL"), s7_make_integer(sc, PANGO_VARIANT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_VARIANT_SMALL_CAPS"), s7_make_integer(sc, PANGO_VARIANT_SMALL_CAPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_ULTRALIGHT"), s7_make_integer(sc, PANGO_WEIGHT_ULTRALIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_LIGHT"), s7_make_integer(sc, PANGO_WEIGHT_LIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_NORMAL"), s7_make_integer(sc, PANGO_WEIGHT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_BOLD"), s7_make_integer(sc, PANGO_WEIGHT_BOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_ULTRABOLD"), s7_make_integer(sc, PANGO_WEIGHT_ULTRABOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_HEAVY"), s7_make_integer(sc, PANGO_WEIGHT_HEAVY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_ULTRA_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_ULTRA_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_EXTRA_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_EXTRA_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_SEMI_CONDENSED"), s7_make_integer(sc, PANGO_STRETCH_SEMI_CONDENSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_NORMAL"), s7_make_integer(sc, PANGO_STRETCH_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_SEMI_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_SEMI_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_EXTRA_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_EXTRA_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_STRETCH_ULTRA_EXPANDED"), s7_make_integer(sc, PANGO_STRETCH_ULTRA_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_FAMILY"), s7_make_integer(sc, PANGO_FONT_MASK_FAMILY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_STYLE"), s7_make_integer(sc, PANGO_FONT_MASK_STYLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_VARIANT"), s7_make_integer(sc, PANGO_FONT_MASK_VARIANT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_WEIGHT"), s7_make_integer(sc, PANGO_FONT_MASK_WEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_STRETCH"), s7_make_integer(sc, PANGO_FONT_MASK_STRETCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_FONT_MASK_SIZE"), s7_make_integer(sc, PANGO_FONT_MASK_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ALIGN_LEFT"), s7_make_integer(sc, PANGO_ALIGN_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ALIGN_CENTER"), s7_make_integer(sc, PANGO_ALIGN_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ALIGN_RIGHT"), s7_make_integer(sc, PANGO_ALIGN_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WRAP_WORD"), s7_make_integer(sc, PANGO_WRAP_WORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WRAP_CHAR"), s7_make_integer(sc, PANGO_WRAP_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_LTR"), s7_make_integer(sc, PANGO_DIRECTION_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_RTL"), s7_make_integer(sc, PANGO_DIRECTION_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_TTB_LTR"), s7_make_integer(sc, PANGO_DIRECTION_TTB_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_TTB_RTL"), s7_make_integer(sc, PANGO_DIRECTION_TTB_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MOVEMENT_HORIZONTAL_PAGES"), s7_make_integer(sc, GTK_MOVEMENT_HORIZONTAL_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_STEPS"), s7_make_integer(sc, GTK_SCROLL_STEPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_PAGES"), s7_make_integer(sc, GTK_SCROLL_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_ENDS"), s7_make_integer(sc, GTK_SCROLL_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_HORIZONTAL_STEPS"), s7_make_integer(sc, GTK_SCROLL_HORIZONTAL_STEPS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_HORIZONTAL_PAGES"), s7_make_integer(sc, GTK_SCROLL_HORIZONTAL_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_HORIZONTAL_ENDS"), s7_make_integer(sc, GTK_SCROLL_HORIZONTAL_ENDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_WRAP_WORD_CHAR"), s7_make_integer(sc, GTK_WRAP_WORD_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_FILENAME"), s7_make_integer(sc, GTK_FILE_FILTER_FILENAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_URI"), s7_make_integer(sc, GTK_FILE_FILTER_URI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_DISPLAY_NAME"), s7_make_integer(sc, GTK_FILE_FILTER_DISPLAY_NAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_FILTER_MIME_TYPE"), s7_make_integer(sc, GTK_FILE_FILTER_MIME_TYPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_OPEN"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_OPEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_SAVE"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_SAVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER"), s7_make_integer(sc, GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_HIGH"), s7_make_integer(sc, G_PRIORITY_HIGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_DEFAULT"), s7_make_integer(sc, G_PRIORITY_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_HIGH_IDLE"), s7_make_integer(sc, G_PRIORITY_HIGH_IDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_DEFAULT_IDLE"), s7_make_integer(sc, G_PRIORITY_DEFAULT_IDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_PRIORITY_LOW"), s7_make_integer(sc, G_PRIORITY_LOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_FALLBACK"), s7_make_integer(sc, PANGO_ATTR_FALLBACK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_LETTER_SPACING"), s7_make_integer(sc, PANGO_ATTR_LETTER_SPACING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_UNDERLINE_ERROR"), s7_make_integer(sc, PANGO_UNDERLINE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WRAP_WORD_CHAR"), s7_make_integer(sc, PANGO_WRAP_WORD_CHAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_NONE"), s7_make_integer(sc, PANGO_ELLIPSIZE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_START"), s7_make_integer(sc, PANGO_ELLIPSIZE_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_MIDDLE"), s7_make_integer(sc, PANGO_ELLIPSIZE_MIDDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ELLIPSIZE_END"), s7_make_integer(sc, PANGO_ELLIPSIZE_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_INVALID_CODE"), s7_make_integer(sc, PANGO_SCRIPT_INVALID_CODE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_COMMON"), s7_make_integer(sc, PANGO_SCRIPT_COMMON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_INHERITED"), s7_make_integer(sc, PANGO_SCRIPT_INHERITED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ARABIC"), s7_make_integer(sc, PANGO_SCRIPT_ARABIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ARMENIAN"), s7_make_integer(sc, PANGO_SCRIPT_ARMENIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BENGALI"), s7_make_integer(sc, PANGO_SCRIPT_BENGALI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BOPOMOFO"), s7_make_integer(sc, PANGO_SCRIPT_BOPOMOFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CHEROKEE"), s7_make_integer(sc, PANGO_SCRIPT_CHEROKEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_COPTIC"), s7_make_integer(sc, PANGO_SCRIPT_COPTIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CYRILLIC"), s7_make_integer(sc, PANGO_SCRIPT_CYRILLIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_DESERET"), s7_make_integer(sc, PANGO_SCRIPT_DESERET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_DEVANAGARI"), s7_make_integer(sc, PANGO_SCRIPT_DEVANAGARI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ETHIOPIC"), s7_make_integer(sc, PANGO_SCRIPT_ETHIOPIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GEORGIAN"), s7_make_integer(sc, PANGO_SCRIPT_GEORGIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GOTHIC"), s7_make_integer(sc, PANGO_SCRIPT_GOTHIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GREEK"), s7_make_integer(sc, PANGO_SCRIPT_GREEK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GUJARATI"), s7_make_integer(sc, PANGO_SCRIPT_GUJARATI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GURMUKHI"), s7_make_integer(sc, PANGO_SCRIPT_GURMUKHI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HAN"), s7_make_integer(sc, PANGO_SCRIPT_HAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HANGUL"), s7_make_integer(sc, PANGO_SCRIPT_HANGUL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HEBREW"), s7_make_integer(sc, PANGO_SCRIPT_HEBREW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HIRAGANA"), s7_make_integer(sc, PANGO_SCRIPT_HIRAGANA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KANNADA"), s7_make_integer(sc, PANGO_SCRIPT_KANNADA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KATAKANA"), s7_make_integer(sc, PANGO_SCRIPT_KATAKANA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KHMER"), s7_make_integer(sc, PANGO_SCRIPT_KHMER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LAO"), s7_make_integer(sc, PANGO_SCRIPT_LAO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LATIN"), s7_make_integer(sc, PANGO_SCRIPT_LATIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_MALAYALAM"), s7_make_integer(sc, PANGO_SCRIPT_MALAYALAM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_MONGOLIAN"), s7_make_integer(sc, PANGO_SCRIPT_MONGOLIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_MYANMAR"), s7_make_integer(sc, PANGO_SCRIPT_MYANMAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OGHAM"), s7_make_integer(sc, PANGO_SCRIPT_OGHAM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OLD_ITALIC"), s7_make_integer(sc, PANGO_SCRIPT_OLD_ITALIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_ORIYA"), s7_make_integer(sc, PANGO_SCRIPT_ORIYA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_RUNIC"), s7_make_integer(sc, PANGO_SCRIPT_RUNIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SINHALA"), s7_make_integer(sc, PANGO_SCRIPT_SINHALA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SYRIAC"), s7_make_integer(sc, PANGO_SCRIPT_SYRIAC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAMIL"), s7_make_integer(sc, PANGO_SCRIPT_TAMIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TELUGU"), s7_make_integer(sc, PANGO_SCRIPT_TELUGU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_THAANA"), s7_make_integer(sc, PANGO_SCRIPT_THAANA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_THAI"), s7_make_integer(sc, PANGO_SCRIPT_THAI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TIBETAN"), s7_make_integer(sc, PANGO_SCRIPT_TIBETAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CANADIAN_ABORIGINAL"), s7_make_integer(sc, PANGO_SCRIPT_CANADIAN_ABORIGINAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_YI"), s7_make_integer(sc, PANGO_SCRIPT_YI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAGALOG"), s7_make_integer(sc, PANGO_SCRIPT_TAGALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_HANUNOO"), s7_make_integer(sc, PANGO_SCRIPT_HANUNOO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BUHID"), s7_make_integer(sc, PANGO_SCRIPT_BUHID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAGBANWA"), s7_make_integer(sc, PANGO_SCRIPT_TAGBANWA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BRAILLE"), s7_make_integer(sc, PANGO_SCRIPT_BRAILLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_CYPRIOT"), s7_make_integer(sc, PANGO_SCRIPT_CYPRIOT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LIMBU"), s7_make_integer(sc, PANGO_SCRIPT_LIMBU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OSMANYA"), s7_make_integer(sc, PANGO_SCRIPT_OSMANYA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SHAVIAN"), s7_make_integer(sc, PANGO_SCRIPT_SHAVIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_LINEAR_B"), s7_make_integer(sc, PANGO_SCRIPT_LINEAR_B));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TAI_LE"), s7_make_integer(sc, PANGO_SCRIPT_TAI_LE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_UGARITIC"), s7_make_integer(sc, PANGO_SCRIPT_UGARITIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_TAB_LEFT"), s7_make_integer(sc, PANGO_TAB_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_WEAK_LTR"), s7_make_integer(sc, PANGO_DIRECTION_WEAK_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_WEAK_RTL"), s7_make_integer(sc, PANGO_DIRECTION_WEAK_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_DIRECTION_NEUTRAL"), s7_make_integer(sc, PANGO_DIRECTION_NEUTRAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID"), s7_make_integer(sc, GTK_TREE_SORTABLE_DEFAULT_SORT_COLUMN_ID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID"), s7_make_integer(sc, GTK_TREE_SORTABLE_UNSORTED_SORT_COLUMN_ID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_ICON_NAME"), s7_make_integer(sc, GTK_IMAGE_ICON_NAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_UNDERLINE_COLOR"), s7_make_integer(sc, PANGO_ATTR_UNDERLINE_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_ATTR_STRIKETHROUGH_COLOR"), s7_make_integer(sc, PANGO_ATTR_STRIKETHROUGH_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_FOREGROUND"), s7_make_integer(sc, PANGO_RENDER_PART_FOREGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_BACKGROUND"), s7_make_integer(sc, PANGO_RENDER_PART_BACKGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_UNDERLINE"), s7_make_integer(sc, PANGO_RENDER_PART_UNDERLINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_RENDER_PART_STRIKETHROUGH"), s7_make_integer(sc, PANGO_RENDER_PART_STRIKETHROUGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_FLAG_RECURSION"), s7_make_integer(sc, G_LOG_FLAG_RECURSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_FLAG_FATAL"), s7_make_integer(sc, G_LOG_FLAG_FATAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_ERROR"), s7_make_integer(sc, G_LOG_LEVEL_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_CRITICAL"), s7_make_integer(sc, G_LOG_LEVEL_CRITICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_WARNING"), s7_make_integer(sc, G_LOG_LEVEL_WARNING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_MESSAGE"), s7_make_integer(sc, G_LOG_LEVEL_MESSAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_INFO"), s7_make_integer(sc, G_LOG_LEVEL_INFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_DEBUG"), s7_make_integer(sc, G_LOG_LEVEL_DEBUG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_LEVEL_MASK"), s7_make_integer(sc, G_LOG_LEVEL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "G_LOG_FATAL_MASK"), s7_make_integer(sc, G_LOG_FATAL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_SEMIBOLD"), s7_make_integer(sc, PANGO_WEIGHT_SEMIBOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_NO_DROP"), s7_make_integer(sc, GTK_ICON_VIEW_NO_DROP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_INTO"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_INTO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_LEFT"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_RIGHT"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_ABOVE"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_ABOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_VIEW_DROP_BELOW"), s7_make_integer(sc, GTK_ICON_VIEW_DROP_BELOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_NEW_TAI_LUE"), s7_make_integer(sc, PANGO_SCRIPT_NEW_TAI_LUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_BUGINESE"), s7_make_integer(sc, PANGO_SCRIPT_BUGINESE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_GLAGOLITIC"), s7_make_integer(sc, PANGO_SCRIPT_GLAGOLITIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_TIFINAGH"), s7_make_integer(sc, PANGO_SCRIPT_TIFINAGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_SYLOTI_NAGRI"), s7_make_integer(sc, PANGO_SCRIPT_SYLOTI_NAGRI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_OLD_PERSIAN"), s7_make_integer(sc, PANGO_SCRIPT_OLD_PERSIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCRIPT_KHAROSHTHI"), s7_make_integer(sc, PANGO_SCRIPT_KHAROSHTHI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUPER_MASK"), s7_make_integer(sc, GDK_SUPER_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_HYPER_MASK"), s7_make_integer(sc, GDK_HYPER_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_META_MASK"), s7_make_integer(sc, GDK_META_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SENSITIVITY_AUTO"), s7_make_integer(sc, GTK_SENSITIVITY_AUTO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SENSITIVITY_ON"), s7_make_integer(sc, GTK_SENSITIVITY_ON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SENSITIVITY_OFF"), s7_make_integer(sc, GTK_SENSITIVITY_OFF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS"), s7_make_integer(sc, GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT"), s7_make_integer(sc, GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_BUFFER_TARGET_INFO_TEXT"), s7_make_integer(sc, GTK_TEXT_BUFFER_TARGET_INFO_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_CONTENT"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_CONTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_INTRO"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_INTRO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_CONFIRM"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_CONFIRM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_SUMMARY"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_SUMMARY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_PROGRESS"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_PROGRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_ACCEL_MODE_GTK"), s7_make_integer(sc, GTK_CELL_RENDERER_ACCEL_MODE_GTK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_ACCEL_MODE_OTHER"), s7_make_integer(sc, GTK_CELL_RENDERER_ACCEL_MODE_OTHER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_NOT_FOUND"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_NOT_FOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_INVALID_URI"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_INVALID_URI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_READ"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_READ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_WRITE"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_WRITE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_RECENT_MANAGER_ERROR_UNKNOWN"), s7_make_integer(sc, GTK_RECENT_MANAGER_ERROR_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_MESSAGE_OTHER"), s7_make_integer(sc, GTK_MESSAGE_OTHER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_NONE"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_HORIZONTAL"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_VERTICAL"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TREE_VIEW_GRID_LINES_BOTH"), s7_make_integer(sc, GTK_TREE_VIEW_GRID_LINES_BOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_INITIAL"), s7_make_integer(sc, GTK_PRINT_STATUS_INITIAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PREPARING"), s7_make_integer(sc, GTK_PRINT_STATUS_PREPARING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_GENERATING_DATA"), s7_make_integer(sc, GTK_PRINT_STATUS_GENERATING_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_SENDING_DATA"), s7_make_integer(sc, GTK_PRINT_STATUS_SENDING_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PENDING"), s7_make_integer(sc, GTK_PRINT_STATUS_PENDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PENDING_ISSUE"), s7_make_integer(sc, GTK_PRINT_STATUS_PENDING_ISSUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_PRINTING"), s7_make_integer(sc, GTK_PRINT_STATUS_PRINTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_FINISHED"), s7_make_integer(sc, GTK_PRINT_STATUS_FINISHED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_STATUS_FINISHED_ABORTED"), s7_make_integer(sc, GTK_PRINT_STATUS_FINISHED_ABORTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_ERROR"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_APPLY"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_APPLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_CANCEL"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_RESULT_IN_PROGRESS"), s7_make_integer(sc, GTK_PRINT_OPERATION_RESULT_IN_PROGRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_PRINT"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_PRINT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_PREVIEW"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_PREVIEW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_OPERATION_ACTION_EXPORT"), s7_make_integer(sc, GTK_PRINT_OPERATION_ACTION_EXPORT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_GENERAL"), s7_make_integer(sc, GTK_PRINT_ERROR_GENERAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_INTERNAL_ERROR"), s7_make_integer(sc, GTK_PRINT_ERROR_INTERNAL_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_NOMEM"), s7_make_integer(sc, GTK_PRINT_ERROR_NOMEM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_ERROR_INVALID_FILE"), s7_make_integer(sc, GTK_PRINT_ERROR_INVALID_FILE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CALENDAR_SHOW_DETAILS"), s7_make_integer(sc, GTK_CALENDAR_SHOW_DETAILS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_GTK_GRAB"), s7_make_integer(sc, GDK_CROSSING_GTK_GRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_GTK_UNGRAB"), s7_make_integer(sc, GDK_CROSSING_GTK_UNGRAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_STATE_CHANGED"), s7_make_integer(sc, GDK_CROSSING_STATE_CHANGED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ENTRY_ICON_PRIMARY"), s7_make_integer(sc, GTK_ENTRY_ICON_PRIMARY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ENTRY_ICON_SECONDARY"), s7_make_integer(sc, GTK_ENTRY_ICON_SECONDARY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_THIN"), s7_make_integer(sc, PANGO_WEIGHT_THIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_BOOK"), s7_make_integer(sc, PANGO_WEIGHT_BOOK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_MEDIUM"), s7_make_integer(sc, PANGO_WEIGHT_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ENTRY_BUFFER_MAX_SIZE"), s7_make_integer(sc, GTK_ENTRY_BUFFER_MAX_SIZE));
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_VoidSymbol"), s7_make_integer(sc, GDK_KEY_VoidSymbol));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_BackSpace"), s7_make_integer(sc, GDK_KEY_BackSpace));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Tab"), s7_make_integer(sc, GDK_KEY_Tab));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Linefeed"), s7_make_integer(sc, GDK_KEY_Linefeed));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Clear"), s7_make_integer(sc, GDK_KEY_Clear));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Return"), s7_make_integer(sc, GDK_KEY_Return));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Pause"), s7_make_integer(sc, GDK_KEY_Pause));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Scroll_Lock"), s7_make_integer(sc, GDK_KEY_Scroll_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Sys_Req"), s7_make_integer(sc, GDK_KEY_Sys_Req));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Escape"), s7_make_integer(sc, GDK_KEY_Escape));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Delete"), s7_make_integer(sc, GDK_KEY_Delete));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Home"), s7_make_integer(sc, GDK_KEY_Home));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Left"), s7_make_integer(sc, GDK_KEY_Left));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Up"), s7_make_integer(sc, GDK_KEY_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Right"), s7_make_integer(sc, GDK_KEY_Right));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Down"), s7_make_integer(sc, GDK_KEY_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Prior"), s7_make_integer(sc, GDK_KEY_Prior));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Page_Up"), s7_make_integer(sc, GDK_KEY_Page_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Next"), s7_make_integer(sc, GDK_KEY_Next));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Page_Down"), s7_make_integer(sc, GDK_KEY_Page_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_End"), s7_make_integer(sc, GDK_KEY_End));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Begin"), s7_make_integer(sc, GDK_KEY_Begin));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Select"), s7_make_integer(sc, GDK_KEY_Select));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Print"), s7_make_integer(sc, GDK_KEY_Print));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Execute"), s7_make_integer(sc, GDK_KEY_Execute));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Insert"), s7_make_integer(sc, GDK_KEY_Insert));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Undo"), s7_make_integer(sc, GDK_KEY_Undo));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Redo"), s7_make_integer(sc, GDK_KEY_Redo));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Menu"), s7_make_integer(sc, GDK_KEY_Menu));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Find"), s7_make_integer(sc, GDK_KEY_Find));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Cancel"), s7_make_integer(sc, GDK_KEY_Cancel));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Help"), s7_make_integer(sc, GDK_KEY_Help));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Break"), s7_make_integer(sc, GDK_KEY_Break));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Mode_switch"), s7_make_integer(sc, GDK_KEY_Mode_switch));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_script_switch"), s7_make_integer(sc, GDK_KEY_script_switch));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Num_Lock"), s7_make_integer(sc, GDK_KEY_Num_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Space"), s7_make_integer(sc, GDK_KEY_KP_Space));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Tab"), s7_make_integer(sc, GDK_KEY_KP_Tab));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Enter"), s7_make_integer(sc, GDK_KEY_KP_Enter));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F1"), s7_make_integer(sc, GDK_KEY_KP_F1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F2"), s7_make_integer(sc, GDK_KEY_KP_F2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F3"), s7_make_integer(sc, GDK_KEY_KP_F3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_F4"), s7_make_integer(sc, GDK_KEY_KP_F4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Home"), s7_make_integer(sc, GDK_KEY_KP_Home));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Left"), s7_make_integer(sc, GDK_KEY_KP_Left));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Up"), s7_make_integer(sc, GDK_KEY_KP_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Right"), s7_make_integer(sc, GDK_KEY_KP_Right));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Down"), s7_make_integer(sc, GDK_KEY_KP_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Prior"), s7_make_integer(sc, GDK_KEY_KP_Prior));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Page_Up"), s7_make_integer(sc, GDK_KEY_KP_Page_Up));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Next"), s7_make_integer(sc, GDK_KEY_KP_Next));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Page_Down"), s7_make_integer(sc, GDK_KEY_KP_Page_Down));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_End"), s7_make_integer(sc, GDK_KEY_KP_End));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Begin"), s7_make_integer(sc, GDK_KEY_KP_Begin));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Insert"), s7_make_integer(sc, GDK_KEY_KP_Insert));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Delete"), s7_make_integer(sc, GDK_KEY_KP_Delete));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Equal"), s7_make_integer(sc, GDK_KEY_KP_Equal));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Multiply"), s7_make_integer(sc, GDK_KEY_KP_Multiply));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Add"), s7_make_integer(sc, GDK_KEY_KP_Add));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Separator"), s7_make_integer(sc, GDK_KEY_KP_Separator));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Subtract"), s7_make_integer(sc, GDK_KEY_KP_Subtract));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Decimal"), s7_make_integer(sc, GDK_KEY_KP_Decimal));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_Divide"), s7_make_integer(sc, GDK_KEY_KP_Divide));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_0"), s7_make_integer(sc, GDK_KEY_KP_0));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_1"), s7_make_integer(sc, GDK_KEY_KP_1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_2"), s7_make_integer(sc, GDK_KEY_KP_2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_3"), s7_make_integer(sc, GDK_KEY_KP_3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_4"), s7_make_integer(sc, GDK_KEY_KP_4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_5"), s7_make_integer(sc, GDK_KEY_KP_5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_6"), s7_make_integer(sc, GDK_KEY_KP_6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_7"), s7_make_integer(sc, GDK_KEY_KP_7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_8"), s7_make_integer(sc, GDK_KEY_KP_8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_KP_9"), s7_make_integer(sc, GDK_KEY_KP_9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F1"), s7_make_integer(sc, GDK_KEY_F1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F2"), s7_make_integer(sc, GDK_KEY_F2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F3"), s7_make_integer(sc, GDK_KEY_F3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F4"), s7_make_integer(sc, GDK_KEY_F4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F5"), s7_make_integer(sc, GDK_KEY_F5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F6"), s7_make_integer(sc, GDK_KEY_F6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F7"), s7_make_integer(sc, GDK_KEY_F7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F8"), s7_make_integer(sc, GDK_KEY_F8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F9"), s7_make_integer(sc, GDK_KEY_F9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F10"), s7_make_integer(sc, GDK_KEY_F10));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F11"), s7_make_integer(sc, GDK_KEY_F11));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L1"), s7_make_integer(sc, GDK_KEY_L1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F12"), s7_make_integer(sc, GDK_KEY_F12));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L2"), s7_make_integer(sc, GDK_KEY_L2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F13"), s7_make_integer(sc, GDK_KEY_F13));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L3"), s7_make_integer(sc, GDK_KEY_L3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F14"), s7_make_integer(sc, GDK_KEY_F14));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L4"), s7_make_integer(sc, GDK_KEY_L4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F15"), s7_make_integer(sc, GDK_KEY_F15));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L5"), s7_make_integer(sc, GDK_KEY_L5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F16"), s7_make_integer(sc, GDK_KEY_F16));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L6"), s7_make_integer(sc, GDK_KEY_L6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F17"), s7_make_integer(sc, GDK_KEY_F17));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L7"), s7_make_integer(sc, GDK_KEY_L7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F18"), s7_make_integer(sc, GDK_KEY_F18));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L8"), s7_make_integer(sc, GDK_KEY_L8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F19"), s7_make_integer(sc, GDK_KEY_F19));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L9"), s7_make_integer(sc, GDK_KEY_L9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F20"), s7_make_integer(sc, GDK_KEY_F20));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L10"), s7_make_integer(sc, GDK_KEY_L10));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F21"), s7_make_integer(sc, GDK_KEY_F21));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R1"), s7_make_integer(sc, GDK_KEY_R1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F22"), s7_make_integer(sc, GDK_KEY_F22));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R2"), s7_make_integer(sc, GDK_KEY_R2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F23"), s7_make_integer(sc, GDK_KEY_F23));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R3"), s7_make_integer(sc, GDK_KEY_R3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F24"), s7_make_integer(sc, GDK_KEY_F24));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R4"), s7_make_integer(sc, GDK_KEY_R4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F25"), s7_make_integer(sc, GDK_KEY_F25));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R5"), s7_make_integer(sc, GDK_KEY_R5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F26"), s7_make_integer(sc, GDK_KEY_F26));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R6"), s7_make_integer(sc, GDK_KEY_R6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F27"), s7_make_integer(sc, GDK_KEY_F27));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R7"), s7_make_integer(sc, GDK_KEY_R7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F28"), s7_make_integer(sc, GDK_KEY_F28));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R8"), s7_make_integer(sc, GDK_KEY_R8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F29"), s7_make_integer(sc, GDK_KEY_F29));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R9"), s7_make_integer(sc, GDK_KEY_R9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F30"), s7_make_integer(sc, GDK_KEY_F30));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R10"), s7_make_integer(sc, GDK_KEY_R10));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F31"), s7_make_integer(sc, GDK_KEY_F31));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R11"), s7_make_integer(sc, GDK_KEY_R11));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F32"), s7_make_integer(sc, GDK_KEY_F32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R12"), s7_make_integer(sc, GDK_KEY_R12));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F33"), s7_make_integer(sc, GDK_KEY_F33));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R13"), s7_make_integer(sc, GDK_KEY_R13));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F34"), s7_make_integer(sc, GDK_KEY_F34));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R14"), s7_make_integer(sc, GDK_KEY_R14));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F35"), s7_make_integer(sc, GDK_KEY_F35));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R15"), s7_make_integer(sc, GDK_KEY_R15));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Shift_L"), s7_make_integer(sc, GDK_KEY_Shift_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Shift_R"), s7_make_integer(sc, GDK_KEY_Shift_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Control_L"), s7_make_integer(sc, GDK_KEY_Control_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Control_R"), s7_make_integer(sc, GDK_KEY_Control_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Caps_Lock"), s7_make_integer(sc, GDK_KEY_Caps_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Shift_Lock"), s7_make_integer(sc, GDK_KEY_Shift_Lock));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Meta_L"), s7_make_integer(sc, GDK_KEY_Meta_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Meta_R"), s7_make_integer(sc, GDK_KEY_Meta_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Alt_L"), s7_make_integer(sc, GDK_KEY_Alt_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Alt_R"), s7_make_integer(sc, GDK_KEY_Alt_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_space"), s7_make_integer(sc, GDK_KEY_space));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_exclam"), s7_make_integer(sc, GDK_KEY_exclam));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_quotedbl"), s7_make_integer(sc, GDK_KEY_quotedbl));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_numbersign"), s7_make_integer(sc, GDK_KEY_numbersign));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_dollar"), s7_make_integer(sc, GDK_KEY_dollar));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_percent"), s7_make_integer(sc, GDK_KEY_percent));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_ampersand"), s7_make_integer(sc, GDK_KEY_ampersand));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_apostrophe"), s7_make_integer(sc, GDK_KEY_apostrophe));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_quoteright"), s7_make_integer(sc, GDK_KEY_quoteright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_parenleft"), s7_make_integer(sc, GDK_KEY_parenleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_parenright"), s7_make_integer(sc, GDK_KEY_parenright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_asterisk"), s7_make_integer(sc, GDK_KEY_asterisk));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_plus"), s7_make_integer(sc, GDK_KEY_plus));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_comma"), s7_make_integer(sc, GDK_KEY_comma));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_minus"), s7_make_integer(sc, GDK_KEY_minus));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_period"), s7_make_integer(sc, GDK_KEY_period));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_slash"), s7_make_integer(sc, GDK_KEY_slash));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_0"), s7_make_integer(sc, GDK_KEY_0));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_1"), s7_make_integer(sc, GDK_KEY_1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_2"), s7_make_integer(sc, GDK_KEY_2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_3"), s7_make_integer(sc, GDK_KEY_3));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_4"), s7_make_integer(sc, GDK_KEY_4));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_5"), s7_make_integer(sc, GDK_KEY_5));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_6"), s7_make_integer(sc, GDK_KEY_6));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_7"), s7_make_integer(sc, GDK_KEY_7));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_8"), s7_make_integer(sc, GDK_KEY_8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_9"), s7_make_integer(sc, GDK_KEY_9));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_colon"), s7_make_integer(sc, GDK_KEY_colon));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_semicolon"), s7_make_integer(sc, GDK_KEY_semicolon));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_less"), s7_make_integer(sc, GDK_KEY_less));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_equal"), s7_make_integer(sc, GDK_KEY_equal));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_greater"), s7_make_integer(sc, GDK_KEY_greater));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_question"), s7_make_integer(sc, GDK_KEY_question));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_at"), s7_make_integer(sc, GDK_KEY_at));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_A"), s7_make_integer(sc, GDK_KEY_A));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_B"), s7_make_integer(sc, GDK_KEY_B));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_C"), s7_make_integer(sc, GDK_KEY_C));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_D"), s7_make_integer(sc, GDK_KEY_D));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_E"), s7_make_integer(sc, GDK_KEY_E));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_F"), s7_make_integer(sc, GDK_KEY_F));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_G"), s7_make_integer(sc, GDK_KEY_G));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_H"), s7_make_integer(sc, GDK_KEY_H));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_I"), s7_make_integer(sc, GDK_KEY_I));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_J"), s7_make_integer(sc, GDK_KEY_J));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_K"), s7_make_integer(sc, GDK_KEY_K));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_L"), s7_make_integer(sc, GDK_KEY_L));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_M"), s7_make_integer(sc, GDK_KEY_M));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_N"), s7_make_integer(sc, GDK_KEY_N));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_O"), s7_make_integer(sc, GDK_KEY_O));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_P"), s7_make_integer(sc, GDK_KEY_P));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Q"), s7_make_integer(sc, GDK_KEY_Q));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_R"), s7_make_integer(sc, GDK_KEY_R));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_S"), s7_make_integer(sc, GDK_KEY_S));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_T"), s7_make_integer(sc, GDK_KEY_T));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_U"), s7_make_integer(sc, GDK_KEY_U));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_V"), s7_make_integer(sc, GDK_KEY_V));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_W"), s7_make_integer(sc, GDK_KEY_W));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_X"), s7_make_integer(sc, GDK_KEY_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Y"), s7_make_integer(sc, GDK_KEY_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_Z"), s7_make_integer(sc, GDK_KEY_Z));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_bracketleft"), s7_make_integer(sc, GDK_KEY_bracketleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_backslash"), s7_make_integer(sc, GDK_KEY_backslash));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_bracketright"), s7_make_integer(sc, GDK_KEY_bracketright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_asciicircum"), s7_make_integer(sc, GDK_KEY_asciicircum));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_underscore"), s7_make_integer(sc, GDK_KEY_underscore));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_grave"), s7_make_integer(sc, GDK_KEY_grave));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_quoteleft"), s7_make_integer(sc, GDK_KEY_quoteleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_a"), s7_make_integer(sc, GDK_KEY_a));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_b"), s7_make_integer(sc, GDK_KEY_b));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_c"), s7_make_integer(sc, GDK_KEY_c));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_d"), s7_make_integer(sc, GDK_KEY_d));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_e"), s7_make_integer(sc, GDK_KEY_e));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_f"), s7_make_integer(sc, GDK_KEY_f));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_g"), s7_make_integer(sc, GDK_KEY_g));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_h"), s7_make_integer(sc, GDK_KEY_h));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_i"), s7_make_integer(sc, GDK_KEY_i));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_j"), s7_make_integer(sc, GDK_KEY_j));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_k"), s7_make_integer(sc, GDK_KEY_k));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_l"), s7_make_integer(sc, GDK_KEY_l));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_m"), s7_make_integer(sc, GDK_KEY_m));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_n"), s7_make_integer(sc, GDK_KEY_n));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_o"), s7_make_integer(sc, GDK_KEY_o));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_p"), s7_make_integer(sc, GDK_KEY_p));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_q"), s7_make_integer(sc, GDK_KEY_q));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_r"), s7_make_integer(sc, GDK_KEY_r));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_s"), s7_make_integer(sc, GDK_KEY_s));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_t"), s7_make_integer(sc, GDK_KEY_t));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_u"), s7_make_integer(sc, GDK_KEY_u));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_v"), s7_make_integer(sc, GDK_KEY_v));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_w"), s7_make_integer(sc, GDK_KEY_w));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_x"), s7_make_integer(sc, GDK_KEY_x));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_y"), s7_make_integer(sc, GDK_KEY_y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_z"), s7_make_integer(sc, GDK_KEY_z));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_braceleft"), s7_make_integer(sc, GDK_KEY_braceleft));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_bar"), s7_make_integer(sc, GDK_KEY_bar));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_braceright"), s7_make_integer(sc, GDK_KEY_braceright));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_asciitilde"), s7_make_integer(sc, GDK_KEY_asciitilde));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH"), s7_make_integer(sc, GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT"), s7_make_integer(sc, GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ASSISTANT_PAGE_CUSTOM"), s7_make_integer(sc, GTK_ASSISTANT_PAGE_CUSTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_SEARCH_CASE_INSENSITIVE"), s7_make_integer(sc, GTK_TEXT_SEARCH_CASE_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_MINIMUM"), s7_make_integer(sc, GTK_SCROLL_MINIMUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SCROLL_NATURAL"), s7_make_integer(sc, GTK_SCROLL_NATURAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_FILL"), s7_make_integer(sc, GTK_ALIGN_FILL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_START"), s7_make_integer(sc, GTK_ALIGN_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_END"), s7_make_integer(sc, GTK_ALIGN_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_CENTER"), s7_make_integer(sc, GTK_ALIGN_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_IMAGE_GICON"), s7_make_integer(sc, GTK_IMAGE_GICON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_NONEXISTENT"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_NONEXISTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_BAD_FILENAME"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_BAD_FILENAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME"), s7_make_integer(sc, GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_NORMAL"), s7_make_integer(sc, GTK_STATE_FLAG_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_ACTIVE"), s7_make_integer(sc, GTK_STATE_FLAG_ACTIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_PRELIGHT"), s7_make_integer(sc, GTK_STATE_FLAG_PRELIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_SELECTED"), s7_make_integer(sc, GTK_STATE_FLAG_SELECTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_INSENSITIVE"), s7_make_integer(sc, GTK_STATE_FLAG_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_INCONSISTENT"), s7_make_integer(sc, GTK_STATE_FLAG_INCONSISTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_FOCUSED"), s7_make_integer(sc, GTK_STATE_FLAG_FOCUSED));
#endif

#if GTK_CHECK_VERSION(3, 2, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SIZE_REQUEST_CONSTANT_SIZE"), s7_make_integer(sc, GTK_SIZE_REQUEST_CONSTANT_SIZE));
#endif

#if GTK_CHECK_VERSION(3, 4, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_EXPANDABLE"), s7_make_integer(sc, GTK_CELL_RENDERER_EXPANDABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CELL_RENDERER_EXPANDED"), s7_make_integer(sc, GTK_CELL_RENDERER_EXPANDED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_BACKDROP"), s7_make_integer(sc, GTK_STATE_FLAG_BACKDROP));
#endif

#if GTK_CHECK_VERSION(3, 6, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_BEGIN"), s7_make_integer(sc, GDK_TOUCH_BEGIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_UPDATE"), s7_make_integer(sc, GDK_TOUCH_UPDATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_END"), s7_make_integer(sc, GDK_TOUCH_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_CANCEL"), s7_make_integer(sc, GDK_TOUCH_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SCROLL_SMOOTH"), s7_make_integer(sc, GDK_SCROLL_SMOOTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_TOUCH_BEGIN"), s7_make_integer(sc, GDK_CROSSING_TOUCH_BEGIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_TOUCH_END"), s7_make_integer(sc, GDK_CROSSING_TOUCH_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_CROSSING_DEVICE_SWITCH"), s7_make_integer(sc, GDK_CROSSING_DEVICE_SWITCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCH_MASK"), s7_make_integer(sc, GDK_TOUCH_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SMOOTH_SCROLL_MASK"), s7_make_integer(sc, GDK_SMOOTH_SCROLL_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_LEVEL_BAR_MODE_CONTINUOUS"), s7_make_integer(sc, GTK_LEVEL_BAR_MODE_CONTINUOUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_LEVEL_BAR_MODE_DISCRETE"), s7_make_integer(sc, GTK_LEVEL_BAR_MODE_DISCRETE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_FREE_FORM"), s7_make_integer(sc, GTK_INPUT_PURPOSE_FREE_FORM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_ALPHA"), s7_make_integer(sc, GTK_INPUT_PURPOSE_ALPHA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_DIGITS"), s7_make_integer(sc, GTK_INPUT_PURPOSE_DIGITS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_NUMBER"), s7_make_integer(sc, GTK_INPUT_PURPOSE_NUMBER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_PHONE"), s7_make_integer(sc, GTK_INPUT_PURPOSE_PHONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_URL"), s7_make_integer(sc, GTK_INPUT_PURPOSE_URL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_EMAIL"), s7_make_integer(sc, GTK_INPUT_PURPOSE_EMAIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_NAME"), s7_make_integer(sc, GTK_INPUT_PURPOSE_NAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_PASSWORD"), s7_make_integer(sc, GTK_INPUT_PURPOSE_PASSWORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_PIN"), s7_make_integer(sc, GTK_INPUT_PURPOSE_PIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_NONE"), s7_make_integer(sc, GTK_INPUT_HINT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_SPELLCHECK"), s7_make_integer(sc, GTK_INPUT_HINT_SPELLCHECK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_NO_SPELLCHECK"), s7_make_integer(sc, GTK_INPUT_HINT_NO_SPELLCHECK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_WORD_COMPLETION"), s7_make_integer(sc, GTK_INPUT_HINT_WORD_COMPLETION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_LOWERCASE"), s7_make_integer(sc, GTK_INPUT_HINT_LOWERCASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_UPPERCASE_CHARS"), s7_make_integer(sc, GTK_INPUT_HINT_UPPERCASE_CHARS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_UPPERCASE_WORDS"), s7_make_integer(sc, GTK_INPUT_HINT_UPPERCASE_WORDS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_UPPERCASE_SENTENCES"), s7_make_integer(sc, GTK_INPUT_HINT_UPPERCASE_SENTENCES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_INHIBIT_OSK"), s7_make_integer(sc, GTK_INPUT_HINT_INHIBIT_OSK));
#endif

#if GTK_CHECK_VERSION(3, 8, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_DIR_LTR"), s7_make_integer(sc, GTK_STATE_FLAG_DIR_LTR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_DIR_RTL"), s7_make_integer(sc, GTK_STATE_FLAG_DIR_RTL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FULLSCREEN_ON_CURRENT_MONITOR"), s7_make_integer(sc, GDK_FULLSCREEN_ON_CURRENT_MONITOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_FULLSCREEN_ON_ALL_MONITORS"), s7_make_integer(sc, GDK_FULLSCREEN_ON_ALL_MONITORS));
#endif

#if GTK_CHECK_VERSION(3, 10, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ALIGN_BASELINE"), s7_make_integer(sc, GTK_ALIGN_BASELINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BASELINE_POSITION_TOP"), s7_make_integer(sc, GTK_BASELINE_POSITION_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BASELINE_POSITION_CENTER"), s7_make_integer(sc, GTK_BASELINE_POSITION_CENTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_BASELINE_POSITION_BOTTOM"), s7_make_integer(sc, GTK_BASELINE_POSITION_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PLACES_OPEN_NORMAL"), s7_make_integer(sc, GTK_PLACES_OPEN_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PLACES_OPEN_NEW_TAB"), s7_make_integer(sc, GTK_PLACES_OPEN_NEW_TAB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PLACES_OPEN_NEW_WINDOW"), s7_make_integer(sc, GTK_PLACES_OPEN_NEW_WINDOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_NONE"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_CROSSFADE"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_CROSSFADE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_NONE"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_CROSSFADE"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN));
#endif

#if GTK_CHECK_VERSION(3, 12, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN));
#endif

#if GTK_CHECK_VERSION(3, 14, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_NONE"), s7_make_integer(sc, GTK_PHASE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_CAPTURE"), s7_make_integer(sc, GTK_PHASE_CAPTURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_BUBBLE"), s7_make_integer(sc, GTK_PHASE_BUBBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PHASE_TARGET"), s7_make_integer(sc, GTK_PHASE_TARGET));
#endif

#if GTK_CHECK_VERSION(3, 16, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POLICY_EXTERNAL"), s7_make_integer(sc, GTK_POLICY_EXTERNAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_WEIGHT_SEMILIGHT"), s7_make_integer(sc, PANGO_WEIGHT_SEMILIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_EXTEND_SELECTION_WORD"), s7_make_integer(sc, GTK_TEXT_EXTEND_SELECTION_WORD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_TEXT_EXTEND_SELECTION_LINE"), s7_make_integer(sc, GTK_TEXT_EXTEND_SELECTION_LINE));
#endif

#if GTK_CHECK_VERSION(3, 18, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_SWIPE"), s7_make_integer(sc, GDK_TOUCHPAD_SWIPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_PINCH"), s7_make_integer(sc, GDK_TOUCHPAD_PINCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_BEGIN"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_BEGIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_UPDATE"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_UPDATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_END"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_PHASE_CANCEL"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_PHASE_CANCEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TOUCHPAD_GESTURE_MASK"), s7_make_integer(sc, GDK_TOUCHPAD_GESTURE_MASK));
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_ACCELERATOR"), s7_make_integer(sc, GTK_SHORTCUT_ACCELERATOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_PINCH"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_PINCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_STRETCH"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_STRETCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POPOVER_CONSTRAINT_NONE"), s7_make_integer(sc, GTK_POPOVER_CONSTRAINT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POPOVER_CONSTRAINT_WINDOW"), s7_make_integer(sc, GTK_POPOVER_CONSTRAINT_WINDOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_NONE"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_POINTER"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_POINTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_TOUCH"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_TOUCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_TABLET_STYLUS"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_TABLET_STYLUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_KEYBOARD"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_KEYBOARD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_ALL_POINTING"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_ALL_POINTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_ALL"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_ALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_DROP_ACTIVE"), s7_make_integer(sc, GTK_STATE_FLAG_DROP_ACTIVE));
#endif

#if GTK_CHECK_VERSION(3, 22, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_IGNORE"), s7_make_integer(sc, GDK_AXIS_IGNORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_X"), s7_make_integer(sc, GDK_AXIS_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_Y"), s7_make_integer(sc, GDK_AXIS_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_PRESSURE"), s7_make_integer(sc, GDK_AXIS_PRESSURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_XTILT"), s7_make_integer(sc, GDK_AXIS_XTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_YTILT"), s7_make_integer(sc, GDK_AXIS_YTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_WHEEL"), s7_make_integer(sc, GDK_AXIS_WHEEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_LAST"), s7_make_integer(sc, GDK_AXIS_LAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_X"), s7_make_integer(sc, GDK_AXIS_FLAG_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_Y"), s7_make_integer(sc, GDK_AXIS_FLAG_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_PRESSURE"), s7_make_integer(sc, GDK_AXIS_FLAG_PRESSURE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_XTILT"), s7_make_integer(sc, GDK_AXIS_FLAG_XTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_YTILT"), s7_make_integer(sc, GDK_AXIS_FLAG_YTILT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_WHEEL"), s7_make_integer(sc, GDK_AXIS_FLAG_WHEEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_DISTANCE"), s7_make_integer(sc, GDK_AXIS_FLAG_DISTANCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_ROTATION"), s7_make_integer(sc, GDK_AXIS_FLAG_ROTATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_AXIS_FLAG_SLIDER"), s7_make_integer(sc, GDK_AXIS_FLAG_SLIDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_UNKNOWN"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_PEN"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_PEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_ERASER"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_ERASER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_BRUSH"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_BRUSH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_PENCIL"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_PENCIL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_AIRBRUSH"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_AIRBRUSH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_MOUSE"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_MOUSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TOOL_TYPE_LENS"), s7_make_integer(sc, GDK_DEVICE_TOOL_TYPE_LENS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_UNKNOWN"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_UNKNOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_NONE"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR"), s7_make_integer(sc, GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_PAD_FEATURE_BUTTON"), s7_make_integer(sc, GDK_DEVICE_PAD_FEATURE_BUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_PAD_FEATURE_RING"), s7_make_integer(sc, GDK_DEVICE_PAD_FEATURE_RING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_PAD_FEATURE_STRIP"), s7_make_integer(sc, GDK_DEVICE_PAD_FEATURE_STRIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_BUTTON_PRESS"), s7_make_integer(sc, GDK_PAD_BUTTON_PRESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_BUTTON_RELEASE"), s7_make_integer(sc, GDK_PAD_BUTTON_RELEASE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_RING"), s7_make_integer(sc, GDK_PAD_RING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_STRIP"), s7_make_integer(sc, GDK_PAD_STRIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAD_GROUP_MODE"), s7_make_integer(sc, GDK_PAD_GROUP_MODE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_TABLET_PAD_MASK"), s7_make_integer(sc, GDK_TABLET_PAD_MASK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_FLIP_X"), s7_make_integer(sc, GDK_ANCHOR_FLIP_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_FLIP_Y"), s7_make_integer(sc, GDK_ANCHOR_FLIP_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_SLIDE_X"), s7_make_integer(sc, GDK_ANCHOR_SLIDE_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_SLIDE_Y"), s7_make_integer(sc, GDK_ANCHOR_SLIDE_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_RESIZE_X"), s7_make_integer(sc, GDK_ANCHOR_RESIZE_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_RESIZE_Y"), s7_make_integer(sc, GDK_ANCHOR_RESIZE_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_FLIP"), s7_make_integer(sc, GDK_ANCHOR_FLIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_SLIDE"), s7_make_integer(sc, GDK_ANCHOR_SLIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_ANCHOR_RESIZE"), s7_make_integer(sc, GDK_ANCHOR_RESIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PAD_ACTION_BUTTON"), s7_make_integer(sc, GTK_PAD_ACTION_BUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PAD_ACTION_RING"), s7_make_integer(sc, GTK_PAD_ACTION_RING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PAD_ACTION_STRIP"), s7_make_integer(sc, GTK_PAD_ACTION_STRIP));
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_SWIPE_LEFT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_SWIPE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_GESTURE_SWIPE_RIGHT"), s7_make_integer(sc, GTK_SHORTCUT_GESTURE_SWIPE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_PROVIDER_PRIORITY_FALLBACK"), s7_make_integer(sc, GTK_STYLE_PROVIDER_PRIORITY_FALLBACK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_PROVIDER_PRIORITY_THEME"), s7_make_integer(sc, GTK_STYLE_PROVIDER_PRIORITY_THEME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_PROVIDER_PRIORITY_SETTINGS"), s7_make_integer(sc, GTK_STYLE_PROVIDER_PRIORITY_SETTINGS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_PROVIDER_PRIORITY_APPLICATION"), s7_make_integer(sc, GTK_STYLE_PROVIDER_PRIORITY_APPLICATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_PROVIDER_PRIORITY_USER"), s7_make_integer(sc, GTK_STYLE_PROVIDER_PRIORITY_USER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CONTEXT_PRINT_NONE"), s7_make_integer(sc, GTK_STYLE_CONTEXT_PRINT_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CONTEXT_PRINT_RECURSE"), s7_make_integer(sc, GTK_STYLE_CONTEXT_PRINT_RECURSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE"), s7_make_integer(sc, GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE));
#endif

#if GTK_CHECK_VERSION(3, 94, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_VERTICAL_WRITING"), s7_make_integer(sc, GTK_INPUT_HINT_VERTICAL_WRITING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_EMOJI"), s7_make_integer(sc, GTK_INPUT_HINT_EMOJI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_HINT_NO_EMOJI"), s7_make_integer(sc, GTK_INPUT_HINT_NO_EMOJI));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EVENT_CONTROLLER_SCROLL_NONE"), s7_make_integer(sc, GTK_EVENT_CONTROLLER_SCROLL_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EVENT_CONTROLLER_SCROLL_VERTICAL"), s7_make_integer(sc, GTK_EVENT_CONTROLLER_SCROLL_VERTICAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL"), s7_make_integer(sc, GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EVENT_CONTROLLER_SCROLL_DISCRETE"), s7_make_integer(sc, GTK_EVENT_CONTROLLER_SCROLL_DISCRETE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EVENT_CONTROLLER_SCROLL_KINETIC"), s7_make_integer(sc, GTK_EVENT_CONTROLLER_SCROLL_KINETIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES"), s7_make_integer(sc, GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TYPE_MASTER"), s7_make_integer(sc, GDK_DEVICE_TYPE_MASTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TYPE_SLAVE"), s7_make_integer(sc, GDK_DEVICE_TYPE_SLAVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DEVICE_TYPE_FLOATING"), s7_make_integer(sc, GDK_DEVICE_TYPE_FLOATING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SEAT_CAPABILITY_TABLET_PAD"), s7_make_integer(sc, GDK_SEAT_CAPABILITY_TABLET_PAD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_SIZE_INHERIT"), s7_make_integer(sc, GTK_ICON_SIZE_INHERIT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_SIZE_NORMAL"), s7_make_integer(sc, GTK_ICON_SIZE_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_SIZE_LARGE"), s7_make_integer(sc, GTK_ICON_SIZE_LARGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_FOCUS_VISIBLE"), s7_make_integer(sc, GTK_STATE_FLAG_FOCUS_VISIBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_APPLICATION_INHIBIT_LOGOUT"), s7_make_integer(sc, GTK_APPLICATION_INHIBIT_LOGOUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_APPLICATION_INHIBIT_SWITCH"), s7_make_integer(sc, GTK_APPLICATION_INHIBIT_SWITCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_APPLICATION_INHIBIT_SUSPEND"), s7_make_integer(sc, GTK_APPLICATION_INHIBIT_SUSPEND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_APPLICATION_INHIBIT_IDLE"), s7_make_integer(sc, GTK_APPLICATION_INHIBIT_IDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_NORTH_WEST"), s7_make_integer(sc, GDK_SURFACE_EDGE_NORTH_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_NORTH"), s7_make_integer(sc, GDK_SURFACE_EDGE_NORTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_NORTH_EAST"), s7_make_integer(sc, GDK_SURFACE_EDGE_NORTH_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_WEST"), s7_make_integer(sc, GDK_SURFACE_EDGE_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_EAST"), s7_make_integer(sc, GDK_SURFACE_EDGE_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_SOUTH_WEST"), s7_make_integer(sc, GDK_SURFACE_EDGE_SOUTH_WEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_SOUTH"), s7_make_integer(sc, GDK_SURFACE_EDGE_SOUTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_EDGE_SOUTH_EAST"), s7_make_integer(sc, GDK_SURFACE_EDGE_SOUTH_EAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_NORMAL"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_DIALOG"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_DIALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_MENU"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_SPLASHSCREEN"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_SPLASHSCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_UTILITY"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_UTILITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_DOCK"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_DOCK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_DESKTOP"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_DESKTOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_DROPDOWN_MENU"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_DROPDOWN_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_POPUP_MENU"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_POPUP_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_TOOLTIP"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_TOOLTIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_NOTIFICATION"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_NOTIFICATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_COMBO"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_COMBO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_TYPE_HINT_DND"), s7_make_integer(sc, GDK_SURFACE_TYPE_HINT_DND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_DEFAULT"), s7_make_integer(sc, GDK_MEMORY_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_B8G8R8A8_PREMULTIPLIED"), s7_make_integer(sc, GDK_MEMORY_B8G8R8A8_PREMULTIPLIED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_A8R8G8B8_PREMULTIPLIED"), s7_make_integer(sc, GDK_MEMORY_A8R8G8B8_PREMULTIPLIED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_B8G8R8A8"), s7_make_integer(sc, GDK_MEMORY_B8G8R8A8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_A8R8G8B8"), s7_make_integer(sc, GDK_MEMORY_A8R8G8B8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_R8G8B8A8"), s7_make_integer(sc, GDK_MEMORY_R8G8B8A8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_A8B8G8R8"), s7_make_integer(sc, GDK_MEMORY_A8B8G8R8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_R8G8B8"), s7_make_integer(sc, GDK_MEMORY_R8G8B8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_B8G8R8"), s7_make_integer(sc, GDK_MEMORY_B8G8R8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_MEMORY_N_FORMATS"), s7_make_integer(sc, GDK_MEMORY_N_FORMATS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAINTABLE_STATIC_SIZE"), s7_make_integer(sc, GDK_PAINTABLE_STATIC_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_PAINTABLE_STATIC_CONTENTS"), s7_make_integer(sc, GDK_PAINTABLE_STATIC_CONTENTS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_WITHDRAWN"), s7_make_integer(sc, GDK_SURFACE_STATE_WITHDRAWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_MAXIMIZED"), s7_make_integer(sc, GDK_SURFACE_STATE_MAXIMIZED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_STICKY"), s7_make_integer(sc, GDK_SURFACE_STATE_STICKY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_FULLSCREEN"), s7_make_integer(sc, GDK_SURFACE_STATE_FULLSCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_ABOVE"), s7_make_integer(sc, GDK_SURFACE_STATE_ABOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_BELOW"), s7_make_integer(sc, GDK_SURFACE_STATE_BELOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_FOCUSED"), s7_make_integer(sc, GDK_SURFACE_STATE_FOCUSED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_TILED"), s7_make_integer(sc, GDK_SURFACE_STATE_TILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_TOP_TILED"), s7_make_integer(sc, GDK_SURFACE_STATE_TOP_TILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_TOP_RESIZABLE"), s7_make_integer(sc, GDK_SURFACE_STATE_TOP_RESIZABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_RIGHT_TILED"), s7_make_integer(sc, GDK_SURFACE_STATE_RIGHT_TILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_RIGHT_RESIZABLE"), s7_make_integer(sc, GDK_SURFACE_STATE_RIGHT_RESIZABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_BOTTOM_TILED"), s7_make_integer(sc, GDK_SURFACE_STATE_BOTTOM_TILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_BOTTOM_RESIZABLE"), s7_make_integer(sc, GDK_SURFACE_STATE_BOTTOM_RESIZABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_LEFT_TILED"), s7_make_integer(sc, GDK_SURFACE_STATE_LEFT_TILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_SURFACE_STATE_LEFT_RESIZABLE"), s7_make_integer(sc, GDK_SURFACE_STATE_LEFT_RESIZABLE));
#endif

#if GTK_CHECK_VERSION(3, 96, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_TEXT"), s7_make_integer(sc, GTK_EDITABLE_PROP_TEXT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_CURSOR_POSITION"), s7_make_integer(sc, GTK_EDITABLE_PROP_CURSOR_POSITION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_SELECTION_BOUND"), s7_make_integer(sc, GTK_EDITABLE_PROP_SELECTION_BOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_EDITABLE"), s7_make_integer(sc, GTK_EDITABLE_PROP_EDITABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_WIDTH_CHARS"), s7_make_integer(sc, GTK_EDITABLE_PROP_WIDTH_CHARS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_MAX_WIDTH_CHARS"), s7_make_integer(sc, GTK_EDITABLE_PROP_MAX_WIDTH_CHARS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_XALIGN"), s7_make_integer(sc, GTK_EDITABLE_PROP_XALIGN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_NUM_PROPERTIES"), s7_make_integer(sc, GTK_EDITABLE_NUM_PROPERTIES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_OVERFLOW_VISIBLE"), s7_make_integer(sc, GTK_OVERFLOW_VISIBLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_OVERFLOW_HIDDEN"), s7_make_integer(sc, GTK_OVERFLOW_HIDDEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PICK_DEFAULT"), s7_make_integer(sc, GTK_PICK_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PICK_INSENSITIVE"), s7_make_integer(sc, GTK_PICK_INSENSITIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PICK_NON_TARGETABLE"), s7_make_integer(sc, GTK_PICK_NON_TARGETABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SWING_RIGHT"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SWING_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SWING_LEFT"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SWING_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SWING_UP"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SWING_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_REVEALER_TRANSITION_TYPE_SWING_DOWN"), s7_make_integer(sc, GTK_REVEALER_TRANSITION_TYPE_SWING_DOWN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_LEFT_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_LEFT_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_ROTATE_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_ROTATE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT_RIGHT"), s7_make_integer(sc, GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_CANCEL_NO_TARGET"), s7_make_integer(sc, GDK_DRAG_CANCEL_NO_TARGET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_CANCEL_USER_CANCELLED"), s7_make_integer(sc, GDK_DRAG_CANCEL_USER_CANCELLED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_DRAG_CANCEL_ERROR"), s7_make_integer(sc, GDK_DRAG_CANCEL_ERROR));
#endif

#if GTK_CHECK_VERSION(3, 98, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_FORCE_REGULAR"), s7_make_integer(sc, GTK_ICON_LOOKUP_FORCE_REGULAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_FORCE_SYMBOLIC"), s7_make_integer(sc, GTK_ICON_LOOKUP_FORCE_SYMBOLIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_LOOKUP_PRELOAD"), s7_make_integer(sc, GTK_ICON_LOOKUP_PRELOAD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_INPUT_PURPOSE_TERMINAL"), s7_make_integer(sc, GTK_INPUT_PURPOSE_TERMINAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_EDITABLE_PROP_ENABLE_UNDO"), s7_make_integer(sc, GTK_EDITABLE_PROP_ENABLE_UNDO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CONTEXT_PRINT_SHOW_CHANGE"), s7_make_integer(sc, GTK_STYLE_CONTEXT_PRINT_SHOW_CHANGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_POPOVER_MENU_NESTED"), s7_make_integer(sc, GTK_POPOVER_MENU_NESTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_THEME_NOT_FOUND,"), s7_make_integer(sc, GTK_ICON_THEME_NOT_FOUND,));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_ICON_THEME_FAILED"), s7_make_integer(sc, GTK_ICON_THEME_FAILED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_RELATION_LE"), s7_make_integer(sc, GTK_CONSTRAINT_RELATION_LE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_RELATION_EQ"), s7_make_integer(sc, GTK_CONSTRAINT_RELATION_EQ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_RELATION_GE"), s7_make_integer(sc, GTK_CONSTRAINT_RELATION_GE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_STRENGTH_REQUIRED"), s7_make_integer(sc, GTK_CONSTRAINT_STRENGTH_REQUIRED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_STRENGTH_STRONG"), s7_make_integer(sc, GTK_CONSTRAINT_STRENGTH_STRONG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_STRENGTH_MEDIUM"), s7_make_integer(sc, GTK_CONSTRAINT_STRENGTH_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_STRENGTH_WEAK"), s7_make_integer(sc, GTK_CONSTRAINT_STRENGTH_WEAK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_NONE"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_LEFT"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_RIGHT"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_TOP"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_BOTTOM"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_START"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_START));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_END"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_END));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_WIDTH"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_WIDTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_HEIGHT"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_HEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_CENTER_X"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_CENTER_X));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_CENTER_Y"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_CENTER_Y));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_CONSTRAINT_ATTRIBUTE_BASELINE"), s7_make_integer(sc, GTK_CONSTRAINT_ATTRIBUTE_BASELINE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_SCOPE_LOCAL"), s7_make_integer(sc, GTK_SHORTCUT_SCOPE_LOCAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_SCOPE_MANAGED"), s7_make_integer(sc, GTK_SHORTCUT_SCOPE_MANAGED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_SCOPE_GLOBAL"), s7_make_integer(sc, GTK_SHORTCUT_SCOPE_GLOBAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_SHORTCUT_ACTION_EXCLUSIVE"), s7_make_integer(sc, GTK_SHORTCUT_ACTION_EXCLUSIVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_MATCH_NONE"), s7_make_integer(sc, GDK_KEY_MATCH_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_MATCH_PARTIAL"), s7_make_integer(sc, GDK_KEY_MATCH_PARTIAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GDK_KEY_MATCH_EXACT"), s7_make_integer(sc, GDK_KEY_MATCH_EXACT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STATE_FLAG_FOCUS_WITHIN"), s7_make_integer(sc, GTK_STATE_FLAG_FOCUS_WITHIN));
#endif

  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_SUCCESS"), s7_make_integer(sc, CAIRO_STATUS_SUCCESS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NO_MEMORY"), s7_make_integer(sc, CAIRO_STATUS_NO_MEMORY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_RESTORE"), s7_make_integer(sc, CAIRO_STATUS_INVALID_RESTORE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_POP_GROUP"), s7_make_integer(sc, CAIRO_STATUS_INVALID_POP_GROUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NO_CURRENT_POINT"), s7_make_integer(sc, CAIRO_STATUS_NO_CURRENT_POINT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_MATRIX"), s7_make_integer(sc, CAIRO_STATUS_INVALID_MATRIX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_STATUS"), s7_make_integer(sc, CAIRO_STATUS_INVALID_STATUS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NULL_POINTER"), s7_make_integer(sc, CAIRO_STATUS_NULL_POINTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_STRING"), s7_make_integer(sc, CAIRO_STATUS_INVALID_STRING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_PATH_DATA"), s7_make_integer(sc, CAIRO_STATUS_INVALID_PATH_DATA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_READ_ERROR"), s7_make_integer(sc, CAIRO_STATUS_READ_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_WRITE_ERROR"), s7_make_integer(sc, CAIRO_STATUS_WRITE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_SURFACE_FINISHED"), s7_make_integer(sc, CAIRO_STATUS_SURFACE_FINISHED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_SURFACE_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_SURFACE_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_PATTERN_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_PATTERN_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_CONTENT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_CONTENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_FORMAT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_FORMAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_VISUAL"), s7_make_integer(sc, CAIRO_STATUS_INVALID_VISUAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_FILE_NOT_FOUND"), s7_make_integer(sc, CAIRO_STATUS_FILE_NOT_FOUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_DASH"), s7_make_integer(sc, CAIRO_STATUS_INVALID_DASH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_DSC_COMMENT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_DSC_COMMENT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_INDEX"), s7_make_integer(sc, CAIRO_STATUS_INVALID_INDEX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_CLIP_NOT_REPRESENTABLE"), s7_make_integer(sc, CAIRO_STATUS_CLIP_NOT_REPRESENTABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_TEMP_FILE_ERROR"), s7_make_integer(sc, CAIRO_STATUS_TEMP_FILE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_STRIDE"), s7_make_integer(sc, CAIRO_STATUS_INVALID_STRIDE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_CONTENT_COLOR"), s7_make_integer(sc, CAIRO_CONTENT_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_CONTENT_ALPHA"), s7_make_integer(sc, CAIRO_CONTENT_ALPHA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_CONTENT_COLOR_ALPHA"), s7_make_integer(sc, CAIRO_CONTENT_COLOR_ALPHA));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_CLEAR"), s7_make_integer(sc, CAIRO_OPERATOR_CLEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SOURCE"), s7_make_integer(sc, CAIRO_OPERATOR_SOURCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_OVER"), s7_make_integer(sc, CAIRO_OPERATOR_OVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_IN"), s7_make_integer(sc, CAIRO_OPERATOR_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_OUT"), s7_make_integer(sc, CAIRO_OPERATOR_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_ATOP"), s7_make_integer(sc, CAIRO_OPERATOR_ATOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST"), s7_make_integer(sc, CAIRO_OPERATOR_DEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_OVER"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_OVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_IN"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_IN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_OUT"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_OUT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DEST_ATOP"), s7_make_integer(sc, CAIRO_OPERATOR_DEST_ATOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_XOR"), s7_make_integer(sc, CAIRO_OPERATOR_XOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_ADD"), s7_make_integer(sc, CAIRO_OPERATOR_ADD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SATURATE"), s7_make_integer(sc, CAIRO_OPERATOR_SATURATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_DEFAULT"), s7_make_integer(sc, CAIRO_ANTIALIAS_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_NONE"), s7_make_integer(sc, CAIRO_ANTIALIAS_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_GRAY"), s7_make_integer(sc, CAIRO_ANTIALIAS_GRAY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_ANTIALIAS_SUBPIXEL"), s7_make_integer(sc, CAIRO_ANTIALIAS_SUBPIXEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILL_RULE_WINDING"), s7_make_integer(sc, CAIRO_FILL_RULE_WINDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILL_RULE_EVEN_ODD"), s7_make_integer(sc, CAIRO_FILL_RULE_EVEN_ODD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_CAP_BUTT"), s7_make_integer(sc, CAIRO_LINE_CAP_BUTT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_CAP_ROUND"), s7_make_integer(sc, CAIRO_LINE_CAP_ROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_CAP_SQUARE"), s7_make_integer(sc, CAIRO_LINE_CAP_SQUARE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_JOIN_MITER"), s7_make_integer(sc, CAIRO_LINE_JOIN_MITER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_JOIN_ROUND"), s7_make_integer(sc, CAIRO_LINE_JOIN_ROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_LINE_JOIN_BEVEL"), s7_make_integer(sc, CAIRO_LINE_JOIN_BEVEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_SLANT_NORMAL"), s7_make_integer(sc, CAIRO_FONT_SLANT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_SLANT_ITALIC"), s7_make_integer(sc, CAIRO_FONT_SLANT_ITALIC));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_SLANT_OBLIQUE"), s7_make_integer(sc, CAIRO_FONT_SLANT_OBLIQUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_WEIGHT_NORMAL"), s7_make_integer(sc, CAIRO_FONT_WEIGHT_NORMAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_WEIGHT_BOLD"), s7_make_integer(sc, CAIRO_FONT_WEIGHT_BOLD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_DEFAULT"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_RGB"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_RGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_BGR"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_BGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_VRGB"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_VRGB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SUBPIXEL_ORDER_VBGR"), s7_make_integer(sc, CAIRO_SUBPIXEL_ORDER_VBGR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_DEFAULT"), s7_make_integer(sc, CAIRO_HINT_STYLE_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_NONE"), s7_make_integer(sc, CAIRO_HINT_STYLE_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_SLIGHT"), s7_make_integer(sc, CAIRO_HINT_STYLE_SLIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_MEDIUM"), s7_make_integer(sc, CAIRO_HINT_STYLE_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_STYLE_FULL"), s7_make_integer(sc, CAIRO_HINT_STYLE_FULL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_METRICS_DEFAULT"), s7_make_integer(sc, CAIRO_HINT_METRICS_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_METRICS_OFF"), s7_make_integer(sc, CAIRO_HINT_METRICS_OFF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_HINT_METRICS_ON"), s7_make_integer(sc, CAIRO_HINT_METRICS_ON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_TOY"), s7_make_integer(sc, CAIRO_FONT_TYPE_TOY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_FT"), s7_make_integer(sc, CAIRO_FONT_TYPE_FT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_WIN32"), s7_make_integer(sc, CAIRO_FONT_TYPE_WIN32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FONT_TYPE_QUARTZ"), s7_make_integer(sc, CAIRO_FONT_TYPE_QUARTZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_MOVE_TO"), s7_make_integer(sc, CAIRO_PATH_MOVE_TO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_LINE_TO"), s7_make_integer(sc, CAIRO_PATH_LINE_TO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_CURVE_TO"), s7_make_integer(sc, CAIRO_PATH_CURVE_TO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATH_CLOSE_PATH"), s7_make_integer(sc, CAIRO_PATH_CLOSE_PATH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_IMAGE"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_PDF"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_PDF));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_PS"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_PS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_XLIB"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_XLIB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_XCB"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_XCB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_GLITZ"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_GLITZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_QUARTZ"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_QUARTZ));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_WIN32"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_WIN32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_BEOS"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_BEOS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_DIRECTFB"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_DIRECTFB));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_SVG"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_SVG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_OS2"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_OS2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_WIN32_PRINTING"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_WIN32_PRINTING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_QUARTZ_IMAGE"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_QUARTZ_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_ARGB32"), s7_make_integer(sc, CAIRO_FORMAT_ARGB32));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_RGB24"), s7_make_integer(sc, CAIRO_FORMAT_RGB24));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_A8"), s7_make_integer(sc, CAIRO_FORMAT_A8));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FORMAT_A1"), s7_make_integer(sc, CAIRO_FORMAT_A1));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_SOLID"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_SOLID));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_SURFACE"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_SURFACE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_LINEAR"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_LINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_PATTERN_TYPE_RADIAL"), s7_make_integer(sc, CAIRO_PATTERN_TYPE_RADIAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_NONE"), s7_make_integer(sc, CAIRO_EXTEND_NONE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_REPEAT"), s7_make_integer(sc, CAIRO_EXTEND_REPEAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_REFLECT"), s7_make_integer(sc, CAIRO_EXTEND_REFLECT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_EXTEND_PAD"), s7_make_integer(sc, CAIRO_EXTEND_PAD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_FAST"), s7_make_integer(sc, CAIRO_FILTER_FAST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_GOOD"), s7_make_integer(sc, CAIRO_FILTER_GOOD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_BEST"), s7_make_integer(sc, CAIRO_FILTER_BEST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_NEAREST"), s7_make_integer(sc, CAIRO_FILTER_NEAREST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_BILINEAR"), s7_make_integer(sc, CAIRO_FILTER_BILINEAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_FILTER_GAUSSIAN"), s7_make_integer(sc, CAIRO_FILTER_GAUSSIAN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_FONT_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_FONT_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_USER_FONT_IMMUTABLE"), s7_make_integer(sc, CAIRO_STATUS_USER_FONT_IMMUTABLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_USER_FONT_ERROR"), s7_make_integer(sc, CAIRO_STATUS_USER_FONT_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_NEGATIVE_COUNT"), s7_make_integer(sc, CAIRO_STATUS_NEGATIVE_COUNT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_CLUSTERS"), s7_make_integer(sc, CAIRO_STATUS_INVALID_CLUSTERS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_SLANT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_SLANT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_WEIGHT"), s7_make_integer(sc, CAIRO_STATUS_INVALID_WEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_INVALID_SIZE"), s7_make_integer(sc, CAIRO_STATUS_INVALID_SIZE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED"), s7_make_integer(sc, CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_DEVICE_TYPE_MISMATCH"), s7_make_integer(sc, CAIRO_STATUS_DEVICE_TYPE_MISMATCH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_STATUS_DEVICE_ERROR"), s7_make_integer(sc, CAIRO_STATUS_DEVICE_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_MULTIPLY"), s7_make_integer(sc, CAIRO_OPERATOR_MULTIPLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SCREEN"), s7_make_integer(sc, CAIRO_OPERATOR_SCREEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_OVERLAY"), s7_make_integer(sc, CAIRO_OPERATOR_OVERLAY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DARKEN"), s7_make_integer(sc, CAIRO_OPERATOR_DARKEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_LIGHTEN"), s7_make_integer(sc, CAIRO_OPERATOR_LIGHTEN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_COLOR_DODGE"), s7_make_integer(sc, CAIRO_OPERATOR_COLOR_DODGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_COLOR_BURN"), s7_make_integer(sc, CAIRO_OPERATOR_COLOR_BURN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HARD_LIGHT"), s7_make_integer(sc, CAIRO_OPERATOR_HARD_LIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_SOFT_LIGHT"), s7_make_integer(sc, CAIRO_OPERATOR_SOFT_LIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_DIFFERENCE"), s7_make_integer(sc, CAIRO_OPERATOR_DIFFERENCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_EXCLUSION"), s7_make_integer(sc, CAIRO_OPERATOR_EXCLUSION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_HUE"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_HUE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_SATURATION"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_SATURATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_COLOR"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_OPERATOR_HSL_LUMINOSITY"), s7_make_integer(sc, CAIRO_OPERATOR_HSL_LUMINOSITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_SCRIPT"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_SCRIPT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_QT"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_QT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_RECORDING"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_RECORDING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_VG"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_VG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_GL"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_GL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_DRM"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_DRM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_TEE"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_TEE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_XML"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_XML));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_SURFACE_TYPE_SKIA"), s7_make_integer(sc, CAIRO_SURFACE_TYPE_SKIA));
}

static void define_doubles(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_XX_SMALL"), s7_make_real(sc, PANGO_SCALE_XX_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_X_SMALL"), s7_make_real(sc, PANGO_SCALE_X_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_SMALL"), s7_make_real(sc, PANGO_SCALE_SMALL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_MEDIUM"), s7_make_real(sc, PANGO_SCALE_MEDIUM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_LARGE"), s7_make_real(sc, PANGO_SCALE_LARGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_X_LARGE"), s7_make_real(sc, PANGO_SCALE_X_LARGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "PANGO_SCALE_XX_LARGE"), s7_make_real(sc, PANGO_SCALE_XX_LARGE));
}


static void define_symbols(s7_scheme *sc)
{
  GtkColorButton__sym = s7_make_symbol(sc, "GtkColorButton_");
  GtkViewport__sym = s7_make_symbol(sc, "GtkViewport_");
  GtkAspectFrame__sym = s7_make_symbol(sc, "GtkAspectFrame_");
  GtkAlternativeTrigger__sym = s7_make_symbol(sc, "GtkAlternativeTrigger_");
  GtkMnemonicTrigger__sym = s7_make_symbol(sc, "GtkMnemonicTrigger_");
  GtkKeyvalTrigger__sym = s7_make_symbol(sc, "GtkKeyvalTrigger_");
  gconstpointer_sym = s7_make_symbol(sc, "gconstpointer");
  GtkShortcutController__sym = s7_make_symbol(sc, "GtkShortcutController_");
  GtkNamedAction__sym = s7_make_symbol(sc, "GtkNamedAction_");
  GtkSignalAction__sym = s7_make_symbol(sc, "GtkSignalAction_");
  GtkShortcutFunc_sym = s7_make_symbol(sc, "GtkShortcutFunc");
  GtkShortcutAction__sym = s7_make_symbol(sc, "GtkShortcutAction_");
  GtkShortcutTrigger__sym = s7_make_symbol(sc, "GtkShortcutTrigger_");
  GtkShortcut__sym = s7_make_symbol(sc, "GtkShortcut_");
  action_sym = s7_make_symbol(sc, "action");
  d_sym = s7_make_symbol(sc, "d");
  dd_sym = s7_make_symbol(sc, "dd");
  GVariantType__sym = s7_make_symbol(sc, "GVariantType_");
  GMenuItem__sym = s7_make_symbol(sc, "GMenuItem_");
  GtkNative__sym = s7_make_symbol(sc, "GtkNative_");
  GVariant__sym = s7_make_symbol(sc, "GVariant_");
  GVariantType___sym = s7_make_symbol(sc, "GVariantType__");
  GtkWidgetActionActivateFunc_sym = s7_make_symbol(sc, "GtkWidgetActionActivateFunc");
  GtkPopover__sym = s7_make_symbol(sc, "GtkPopover_");
  id_sym = s7_make_symbol(sc, "id");
  drag_source_sym = s7_make_symbol(sc, "drag_source");
  gtk_tree_drag_source_drag_data_get_sym = s7_make_symbol(sc, "gtk_tree_drag_source_drag_data_get");
  GtkTreePath___sym = s7_make_symbol(sc, "GtkTreePath__");
  tree_model_sym = s7_make_symbol(sc, "tree_model");
  gtk_tree_create_row_drag_content_sym = s7_make_symbol(sc, "gtk_tree_create_row_drag_content");
  va_list_sym = s7_make_symbol(sc, "va_list");
  GtkMenuButtonCreatePopupFunc_sym = s7_make_symbol(sc, "GtkMenuButtonCreatePopupFunc");
  const_sym = s7_make_symbol(sc, "const");
  GtkDropTargetAsync__sym = s7_make_symbol(sc, "GtkDropTargetAsync_");
  gsize__sym = s7_make_symbol(sc, "gsize_");
  GtkDropTarget__sym = s7_make_symbol(sc, "GtkDropTarget_");
  GtkDropControllerMotion__sym = s7_make_symbol(sc, "GtkDropControllerMotion_");
  GtkDragIcon__sym = s7_make_symbol(sc, "GtkDragIcon_");
  GtkEventControllerFocus__sym = s7_make_symbol(sc, "GtkEventControllerFocus_");
  GHashTable__sym = s7_make_symbol(sc, "GHashTable_");
  GtkConstraintLayout__sym = s7_make_symbol(sc, "GtkConstraintLayout_");
  GtkConstraintTarget__sym = s7_make_symbol(sc, "GtkConstraintTarget_");
  GtkConstraint__sym = s7_make_symbol(sc, "GtkConstraint_");
  GtkIconPaintable__sym = s7_make_symbol(sc, "GtkIconPaintable_");
  GtkIconTheme__sym = s7_make_symbol(sc, "GtkIconTheme_");
  GtkConstraintGuide__sym = s7_make_symbol(sc, "GtkConstraintGuide_");
  gtk_event_controller_motion_contains_pointer_sym = s7_make_symbol(sc, "gtk_event_controller_motion_contains_pointer");
  _sym = s7_make_symbol(sc, "");
  GdkVulkanContext__sym = s7_make_symbol(sc, "GdkVulkanContext_");
  GError___sym = s7_make_symbol(sc, "GError__");
  GdkFrameClock__sym = s7_make_symbol(sc, "GdkFrameClock_");
  GdkToplevelLayout__sym = s7_make_symbol(sc, "GdkToplevelLayout_");
  GdkToplevel__sym = s7_make_symbol(sc, "GdkToplevel_");
  GtkPopoverMenu__sym = s7_make_symbol(sc, "GtkPopoverMenu_");
  GtkCenterLayout__sym = s7_make_symbol(sc, "GtkCenterLayout_");
  GtkGestureClick__sym = s7_make_symbol(sc, "GtkGestureClick_");
  GtkPopoverMenuBar__sym = s7_make_symbol(sc, "GtkPopoverMenuBar_");
  GtkNoSelection__sym = s7_make_symbol(sc, "GtkNoSelection_");
  GtkDragSource__sym = s7_make_symbol(sc, "GtkDragSource_");
  GdkPopupLayout__sym = s7_make_symbol(sc, "GdkPopupLayout_");
  GdkPopup__sym = s7_make_symbol(sc, "GdkPopup_");
  GdkDragSurface__sym = s7_make_symbol(sc, "GdkDragSurface_");
  GtkPropagationLimit_sym = s7_make_symbol(sc, "GtkPropagationLimit");
  GtkGestureLongPress__sym = s7_make_symbol(sc, "GtkGestureLongPress_");
  GtkScaleFormatValueFunc_sym = s7_make_symbol(sc, "GtkScaleFormatValueFunc");
  GdkContentProvider___sym = s7_make_symbol(sc, "GdkContentProvider__");
  GtkFixedLayoutChild__sym = s7_make_symbol(sc, "GtkFixedLayoutChild_");
  GtkTreeDragDest__sym = s7_make_symbol(sc, "GtkTreeDragDest_");
  GtkTreeListRow__sym = s7_make_symbol(sc, "GtkTreeListRow_");
  GtkTreeListModel__sym = s7_make_symbol(sc, "GtkTreeListModel_");
  GtkText__sym = s7_make_symbol(sc, "GtkText_");
  GtkSortListModel__sym = s7_make_symbol(sc, "GtkSortListModel_");
  GtkSliceListModel__sym = s7_make_symbol(sc, "GtkSliceListModel_");
  GtkSingleSelection__sym = s7_make_symbol(sc, "GtkSingleSelection_");
  GtkPasswordEntry__sym = s7_make_symbol(sc, "GtkPasswordEntry_");
  GtkMapListModel__sym = s7_make_symbol(sc, "GtkMapListModel_");
  GtkLayoutChild__sym = s7_make_symbol(sc, "GtkLayoutChild_");
  GtkGridLayoutChild__sym = s7_make_symbol(sc, "GtkGridLayoutChild_");
  GtkGridLayout__sym = s7_make_symbol(sc, "GtkGridLayout_");
  GtkFlattenListModel__sym = s7_make_symbol(sc, "GtkFlattenListModel_");
  GtkFilterListModel__sym = s7_make_symbol(sc, "GtkFilterListModel_");
  GtkCustomAllocateFunc_sym = s7_make_symbol(sc, "GtkCustomAllocateFunc");
  GtkCustomMeasureFunc_sym = s7_make_symbol(sc, "GtkCustomMeasureFunc");
  GtkCustomRequestModeFunc_sym = s7_make_symbol(sc, "GtkCustomRequestModeFunc");
  GtkBoxLayout__sym = s7_make_symbol(sc, "GtkBoxLayout_");
  graphene_point_t__sym = s7_make_symbol(sc, "graphene_point_t_");
  graphene_matrix_t__sym = s7_make_symbol(sc, "graphene_matrix_t_");
  GtkRoot__sym = s7_make_symbol(sc, "GtkRoot_");
  GtkWidgetClass__sym = s7_make_symbol(sc, "GtkWidgetClass_");
  GtkLayoutManager__sym = s7_make_symbol(sc, "GtkLayoutManager_");
  GtkSelectionModel__sym = s7_make_symbol(sc, "GtkSelectionModel_");
  GtkStackPage__sym = s7_make_symbol(sc, "GtkStackPage_");
  GtkNotebookPage__sym = s7_make_symbol(sc, "GtkNotebookPage_");
  GskTransform__sym = s7_make_symbol(sc, "GskTransform_");
  GParamSpec__sym = s7_make_symbol(sc, "GParamSpec_");
  GObjectClass__sym = s7_make_symbol(sc, "GObjectClass_");
  GListModel__sym = s7_make_symbol(sc, "GListModel_");
  GtkAssistantPage__sym = s7_make_symbol(sc, "GtkAssistantPage_");
  GtkAllocation__sym = s7_make_symbol(sc, "GtkAllocation_");
  GActionGroup__sym = s7_make_symbol(sc, "GActionGroup_");
  GtkWidgetPaintable__sym = s7_make_symbol(sc, "GtkWidgetPaintable_");
  GtkVideo__sym = s7_make_symbol(sc, "GtkVideo_");
  GtkPicture__sym = s7_make_symbol(sc, "GtkPicture_");
  gint64_sym = s7_make_symbol(sc, "gint64");
  GtkMediaFile__sym = s7_make_symbol(sc, "GtkMediaFile_");
  GtkMediaControls__sym = s7_make_symbol(sc, "GtkMediaControls_");
  GtkMediaStream__sym = s7_make_symbol(sc, "GtkMediaStream_");
  GdkTimeCoord___sym = s7_make_symbol(sc, "GdkTimeCoord__");
  GtkGestureStylus__sym = s7_make_symbol(sc, "GtkGestureStylus_");
  GdkGLTexture__sym = s7_make_symbol(sc, "GdkGLTexture_");
  GdkDrag__sym = s7_make_symbol(sc, "GdkDrag_");
  GdkDrop__sym = s7_make_symbol(sc, "GdkDrop_");
  GdkCairoContext__sym = s7_make_symbol(sc, "GdkCairoContext_");
  GdkSurface__sym = s7_make_symbol(sc, "GdkSurface_");
  GMenu__sym = s7_make_symbol(sc, "GMenu_");
  GApplicationFlags_sym = s7_make_symbol(sc, "GApplicationFlags");
  GdkPaintable__sym = s7_make_symbol(sc, "GdkPaintable_");
  GdkCursor__sym = s7_make_symbol(sc, "GdkCursor_");
  GBytes__sym = s7_make_symbol(sc, "GBytes_");
  GInputStream__sym = s7_make_symbol(sc, "GInputStream_");
  GdkContentDeserializer__sym = s7_make_symbol(sc, "GdkContentDeserializer_");
  GdkContentSerializer__sym = s7_make_symbol(sc, "GdkContentSerializer_");
  GOutputStream__sym = s7_make_symbol(sc, "GOutputStream_");
  GdkContentFormatsBuilder__sym = s7_make_symbol(sc, "GdkContentFormatsBuilder_");
  GString__sym = s7_make_symbol(sc, "GString_");
  GdkTexture__sym = s7_make_symbol(sc, "GdkTexture_");
  GAsyncResult__sym = s7_make_symbol(sc, "GAsyncResult_");
  GAsyncReadyCallback_sym = s7_make_symbol(sc, "GAsyncReadyCallback");
  GCancellable__sym = s7_make_symbol(sc, "GCancellable_");
  GdkContentProvider__sym = s7_make_symbol(sc, "GdkContentProvider_");
  GdkContentFormats__sym = s7_make_symbol(sc, "GdkContentFormats_");
  GdkClipboard__sym = s7_make_symbol(sc, "GdkClipboard_");
  GdkAppLaunchContext__sym = s7_make_symbol(sc, "GdkAppLaunchContext_");
  GtkEventControllerScroll__sym = s7_make_symbol(sc, "GtkEventControllerScroll_");
  GtkEventController__sym = s7_make_symbol(sc, "GtkEventController_");
  GFile__sym = s7_make_symbol(sc, "GFile_");
  GtkCssProvider__sym = s7_make_symbol(sc, "GtkCssProvider_");
  GtkWidgetPath__sym = s7_make_symbol(sc, "GtkWidgetPath_");
  GtkCssSection__sym = s7_make_symbol(sc, "GtkCssSection_");
  GtkStyleProvider__sym = s7_make_symbol(sc, "GtkStyleProvider_");
  GtkScrollbar__sym = s7_make_symbol(sc, "GtkScrollbar_");
  GtkCenterBox__sym = s7_make_symbol(sc, "GtkCenterBox_");
  GtkCheckButton__sym = s7_make_symbol(sc, "GtkCheckButton_");
  GtkDrawingAreaDrawFunc_sym = s7_make_symbol(sc, "GtkDrawingAreaDrawFunc");
  GtkShortcutLabel__sym = s7_make_symbol(sc, "GtkShortcutLabel_");
  GtkPadActionEntry__sym = s7_make_symbol(sc, "GtkPadActionEntry_");
  GtkPadController__sym = s7_make_symbol(sc, "GtkPadController_");
  GdkDevicePad__sym = s7_make_symbol(sc, "GdkDevicePad_");
  GdkMonitor__sym = s7_make_symbol(sc, "GdkMonitor_");
  GdkDeviceTool__sym = s7_make_symbol(sc, "GdkDeviceTool_");
  GdkSeat__sym = s7_make_symbol(sc, "GdkSeat_");
  GtkShortcutsWindow__sym = s7_make_symbol(sc, "GtkShortcutsWindow_");
  GtkStackSidebar__sym = s7_make_symbol(sc, "GtkStackSidebar_");
  GtkStyleContext__sym = s7_make_symbol(sc, "GtkStyleContext_");
  GdkGLContext__sym = s7_make_symbol(sc, "GdkGLContext_");
  GtkGLArea__sym = s7_make_symbol(sc, "GtkGLArea_");
  GtkGestureZoom__sym = s7_make_symbol(sc, "GtkGestureZoom_");
  GtkGestureSwipe__sym = s7_make_symbol(sc, "GtkGestureSwipe_");
  GtkGestureSingle__sym = s7_make_symbol(sc, "GtkGestureSingle_");
  GtkGestureRotate__sym = s7_make_symbol(sc, "GtkGestureRotate_");
  GtkGesturePan__sym = s7_make_symbol(sc, "GtkGesturePan_");
  GtkGestureDrag__sym = s7_make_symbol(sc, "GtkGestureDrag_");
  GdkEventSequence__sym = s7_make_symbol(sc, "GdkEventSequence_");
  GtkGesture__sym = s7_make_symbol(sc, "GtkGesture_");
  GtkActionBar__sym = s7_make_symbol(sc, "GtkActionBar_");
  GtkFlowBox__sym = s7_make_symbol(sc, "GtkFlowBox_");
  GtkFlowBoxChild__sym = s7_make_symbol(sc, "GtkFlowBoxChild_");
  GtkSearchBar__sym = s7_make_symbol(sc, "GtkSearchBar_");
  GtkListBox__sym = s7_make_symbol(sc, "GtkListBox_");
  GtkListBoxRow__sym = s7_make_symbol(sc, "GtkListBoxRow_");
  GtkHeaderBar__sym = s7_make_symbol(sc, "GtkHeaderBar_");
  GtkRevealer__sym = s7_make_symbol(sc, "GtkRevealer_");
  GtkStack__sym = s7_make_symbol(sc, "GtkStack_");
  GtkStackSwitcher__sym = s7_make_symbol(sc, "GtkStackSwitcher_");
  GtkMenu__sym = s7_make_symbol(sc, "GtkMenu_");
  GtkLevelBar__sym = s7_make_symbol(sc, "GtkLevelBar_");
  GtkMenuButton__sym = s7_make_symbol(sc, "GtkMenuButton_");
  GtkColorChooser__sym = s7_make_symbol(sc, "GtkColorChooser_");
  GtkApplicationWindow__sym = s7_make_symbol(sc, "GtkApplicationWindow_");
  GtkApplication__sym = s7_make_symbol(sc, "GtkApplication_");
  GMenuModel__sym = s7_make_symbol(sc, "GMenuModel_");
  guint___sym = s7_make_symbol(sc, "guint__");
  GtkFontChooser__sym = s7_make_symbol(sc, "GtkFontChooser_");
  GtkOverlay__sym = s7_make_symbol(sc, "GtkOverlay_");
  GtkWindowGroup__sym = s7_make_symbol(sc, "GtkWindowGroup_");
  GIcon__sym = s7_make_symbol(sc, "GIcon_");
  GtkOrientable__sym = s7_make_symbol(sc, "GtkOrientable_");
  GtkCellArea__sym = s7_make_symbol(sc, "GtkCellArea_");
  GtkBorder__sym = s7_make_symbol(sc, "GtkBorder_");
  GtkSwitch__sym = s7_make_symbol(sc, "GtkSwitch_");
  GtkScrollable__sym = s7_make_symbol(sc, "GtkScrollable_");
  GtkGrid__sym = s7_make_symbol(sc, "GtkGrid_");
  GdkRGBA__sym = s7_make_symbol(sc, "GdkRGBA_");
  GtkComboBoxText__sym = s7_make_symbol(sc, "GtkComboBoxText_");
  cairo_region_overlap_t_sym = s7_make_symbol(sc, "cairo_region_overlap_t");
  cairo_rectangle_int_t__sym = s7_make_symbol(sc, "cairo_rectangle_int_t_");
  double__sym = s7_make_symbol(sc, "double_");
  cairo_rectangle_t__sym = s7_make_symbol(sc, "cairo_rectangle_t_");
  cairo_device_t__sym = s7_make_symbol(sc, "cairo_device_t_");
  cairo_text_cluster_flags_t__sym = s7_make_symbol(sc, "cairo_text_cluster_flags_t_");
  cairo_text_cluster_t___sym = s7_make_symbol(sc, "cairo_text_cluster_t__");
  cairo_glyph_t___sym = s7_make_symbol(sc, "cairo_glyph_t__");
  cairo_text_cluster_t__sym = s7_make_symbol(sc, "cairo_text_cluster_t_");
  cairo_region_t__sym = s7_make_symbol(sc, "cairo_region_t_");
  GtkMessageDialog__sym = s7_make_symbol(sc, "GtkMessageDialog_");
  GdkDevice__sym = s7_make_symbol(sc, "GdkDevice_");
  GtkAccessible__sym = s7_make_symbol(sc, "GtkAccessible_");
  GdkModifierType__sym = s7_make_symbol(sc, "GdkModifierType_");
  GtkSpinner__sym = s7_make_symbol(sc, "GtkSpinner_");
  GtkEntryBuffer__sym = s7_make_symbol(sc, "GtkEntryBuffer_");
  GtkInfoBar__sym = s7_make_symbol(sc, "GtkInfoBar_");
  GtkScaleButton__sym = s7_make_symbol(sc, "GtkScaleButton_");
  GtkCalendarDetailFunc_sym = s7_make_symbol(sc, "GtkCalendarDetailFunc");
  GtkTooltip__sym = s7_make_symbol(sc, "GtkTooltip_");
  cairo_rectangle_list_t__sym = s7_make_symbol(sc, "cairo_rectangle_list_t_");
  void__sym = s7_make_symbol(sc, "void_");
  cairo_path_t__sym = s7_make_symbol(sc, "cairo_path_t_");
  cairo_destroy_func_t_sym = s7_make_symbol(sc, "cairo_destroy_func_t");
  cairo_user_data_key_t__sym = s7_make_symbol(sc, "cairo_user_data_key_t_");
  cairo_text_extents_t__sym = s7_make_symbol(sc, "cairo_text_extents_t_");
  cairo_font_extents_t__sym = s7_make_symbol(sc, "cairo_font_extents_t_");
  cairo_font_face_t__sym = s7_make_symbol(sc, "cairo_font_face_t_");
  cairo_glyph_t__sym = s7_make_symbol(sc, "cairo_glyph_t_");
  cairo_scaled_font_t__sym = s7_make_symbol(sc, "cairo_scaled_font_t_");
  cairo_matrix_t__sym = s7_make_symbol(sc, "cairo_matrix_t_");
  cairo_pattern_t__sym = s7_make_symbol(sc, "cairo_pattern_t_");
  GtkPageRange__sym = s7_make_symbol(sc, "GtkPageRange_");
  GtkPaperSize__sym = s7_make_symbol(sc, "GtkPaperSize_");
  GtkPrintSettingsFunc_sym = s7_make_symbol(sc, "GtkPrintSettingsFunc");
  GtkPageSetupDoneFunc_sym = s7_make_symbol(sc, "GtkPageSetupDoneFunc");
  GtkPrintSettings__sym = s7_make_symbol(sc, "GtkPrintSettings_");
  GtkPrintOperation__sym = s7_make_symbol(sc, "GtkPrintOperation_");
  GtkPageSetup__sym = s7_make_symbol(sc, "GtkPageSetup_");
  GtkPrintContext__sym = s7_make_symbol(sc, "GtkPrintContext_");
  cairo_surface_t__sym = s7_make_symbol(sc, "cairo_surface_t_");
  GtkRecentData__sym = s7_make_symbol(sc, "GtkRecentData_");
  GtkRecentInfo__sym = s7_make_symbol(sc, "GtkRecentInfo_");
  GtkRecentManager__sym = s7_make_symbol(sc, "GtkRecentManager_");
  GtkLinkButton__sym = s7_make_symbol(sc, "GtkLinkButton_");
  GDestroyNotify_sym = s7_make_symbol(sc, "GDestroyNotify");
  GtkAssistantPageFunc_sym = s7_make_symbol(sc, "GtkAssistantPageFunc");
  GtkAssistant__sym = s7_make_symbol(sc, "GtkAssistant_");
  GValue__sym = s7_make_symbol(sc, "GValue_");
  GLogFunc_sym = s7_make_symbol(sc, "GLogFunc");
  PangoMatrix__sym = s7_make_symbol(sc, "PangoMatrix_");
  PangoRenderer__sym = s7_make_symbol(sc, "PangoRenderer_");
  GtkFileChooserButton__sym = s7_make_symbol(sc, "GtkFileChooserButton_");
  PangoScriptIter__sym = s7_make_symbol(sc, "PangoScriptIter_");
  PangoAttrFilterFunc_sym = s7_make_symbol(sc, "PangoAttrFilterFunc");
  GtkIconViewForeachFunc_sym = s7_make_symbol(sc, "GtkIconViewForeachFunc");
  gchar___sym = s7_make_symbol(sc, "gchar__");
  GtkAboutDialog__sym = s7_make_symbol(sc, "GtkAboutDialog_");
  GtkTreeViewRowSeparatorFunc_sym = s7_make_symbol(sc, "GtkTreeViewRowSeparatorFunc");
  GtkCellView__sym = s7_make_symbol(sc, "GtkCellView_");
  GtkIconInfo__sym = s7_make_symbol(sc, "GtkIconInfo_");
  GtkFileChooser__sym = s7_make_symbol(sc, "GtkFileChooser_");
  GtkCellLayoutDataFunc_sym = s7_make_symbol(sc, "GtkCellLayoutDataFunc");
  GtkCellLayout__sym = s7_make_symbol(sc, "GtkCellLayout_");
  GtkFileFilterFunc_sym = s7_make_symbol(sc, "GtkFileFilterFunc");
  GtkFileFilter__sym = s7_make_symbol(sc, "GtkFileFilter_");
  GSourceFunc_sym = s7_make_symbol(sc, "GSourceFunc");
  GtkEntryCompletionMatchFunc_sym = s7_make_symbol(sc, "GtkEntryCompletionMatchFunc");
  GtkFontButton__sym = s7_make_symbol(sc, "GtkFontButton_");
  GtkExpander__sym = s7_make_symbol(sc, "GtkExpander_");
  GtkComboBox__sym = s7_make_symbol(sc, "GtkComboBox_");
  GtkTreeModelFilter__sym = s7_make_symbol(sc, "GtkTreeModelFilter_");
  GdkDisplay__sym = s7_make_symbol(sc, "GdkDisplay_");
  PangoLayoutRun__sym = s7_make_symbol(sc, "PangoLayoutRun_");
  PangoLayoutIter__sym = s7_make_symbol(sc, "PangoLayoutIter_");
  PangoLayoutLine__sym = s7_make_symbol(sc, "PangoLayoutLine_");
  int__sym = s7_make_symbol(sc, "int_");
  PangoItem__sym = s7_make_symbol(sc, "PangoItem_");
  PangoAnalysis__sym = s7_make_symbol(sc, "PangoAnalysis_");
  PangoGlyphString__sym = s7_make_symbol(sc, "PangoGlyphString_");
  PangoFontMap__sym = s7_make_symbol(sc, "PangoFontMap_");
  PangoFontFace__sym = s7_make_symbol(sc, "PangoFontFace_");
  PangoFontFace___sym = s7_make_symbol(sc, "PangoFontFace__");
  PangoFontFamily__sym = s7_make_symbol(sc, "PangoFontFamily_");
  PangoFontDescription___sym = s7_make_symbol(sc, "PangoFontDescription__");
  PangoCoverage__sym = s7_make_symbol(sc, "PangoCoverage_");
  PangoFontMetrics__sym = s7_make_symbol(sc, "PangoFontMetrics_");
  PangoFontset__sym = s7_make_symbol(sc, "PangoFontset_");
  PangoFont__sym = s7_make_symbol(sc, "PangoFont_");
  PangoFontFamily___sym = s7_make_symbol(sc, "PangoFontFamily__");
  PangoLogAttr__sym = s7_make_symbol(sc, "PangoLogAttr_");
  PangoAttrList___sym = s7_make_symbol(sc, "PangoAttrList__");
  PangoAttrIterator__sym = s7_make_symbol(sc, "PangoAttrIterator_");
  PangoRectangle__sym = s7_make_symbol(sc, "PangoRectangle_");
  PangoAttribute__sym = s7_make_symbol(sc, "PangoAttribute_");
  PangoColor__sym = s7_make_symbol(sc, "PangoColor_");
  GtkWindow__sym = s7_make_symbol(sc, "GtkWindow_");
  PangoContext__sym = s7_make_symbol(sc, "PangoContext_");
  AtkObject__sym = s7_make_symbol(sc, "AtkObject_");
  GtkTreeViewSearchEqualFunc_sym = s7_make_symbol(sc, "GtkTreeViewSearchEqualFunc");
  GtkTreeViewMappingFunc_sym = s7_make_symbol(sc, "GtkTreeViewMappingFunc");
  GtkTreeViewColumnDropFunc_sym = s7_make_symbol(sc, "GtkTreeViewColumnDropFunc");
  GtkTreeCellDataFunc_sym = s7_make_symbol(sc, "GtkTreeCellDataFunc");
  GtkTreeStore__sym = s7_make_symbol(sc, "GtkTreeStore_");
  GtkTreeIterCompareFunc_sym = s7_make_symbol(sc, "GtkTreeIterCompareFunc");
  GtkTreeSortable__sym = s7_make_symbol(sc, "GtkTreeSortable_");
  GtkTreeSelectionForeachFunc_sym = s7_make_symbol(sc, "GtkTreeSelectionForeachFunc");
  GtkTreeModel___sym = s7_make_symbol(sc, "GtkTreeModel__");
  GtkTreeSelectionFunc_sym = s7_make_symbol(sc, "GtkTreeSelectionFunc");
  GtkTreeModelSort__sym = s7_make_symbol(sc, "GtkTreeModelSort_");
  GtkTreeModelForeachFunc_sym = s7_make_symbol(sc, "GtkTreeModelForeachFunc");
  GObject__sym = s7_make_symbol(sc, "GObject_");
  GtkTreeRowReference__sym = s7_make_symbol(sc, "GtkTreeRowReference_");
  gint__sym = s7_make_symbol(sc, "gint_");
  GtkTreeDragSource__sym = s7_make_symbol(sc, "GtkTreeDragSource_");
  GtkToggleButton__sym = s7_make_symbol(sc, "GtkToggleButton_");
  PangoTabArray__sym = s7_make_symbol(sc, "PangoTabArray_");
  GtkTextView__sym = s7_make_symbol(sc, "GtkTextView_");
  GtkTextTagTableForeach_sym = s7_make_symbol(sc, "GtkTextTagTableForeach");
  GtkTextCharPredicate_sym = s7_make_symbol(sc, "GtkTextCharPredicate");
  GtkTextMark__sym = s7_make_symbol(sc, "GtkTextMark_");
  GtkTextChildAnchor__sym = s7_make_symbol(sc, "GtkTextChildAnchor_");
  GtkTextIter__sym = s7_make_symbol(sc, "GtkTextIter_");
  GtkTextTagTable__sym = s7_make_symbol(sc, "GtkTextTagTable_");
  GtkTextBuffer__sym = s7_make_symbol(sc, "GtkTextBuffer_");
  GtkStatusbar__sym = s7_make_symbol(sc, "GtkStatusbar_");
  GtkSpinButton__sym = s7_make_symbol(sc, "GtkSpinButton_");
  GtkSizeGroup__sym = s7_make_symbol(sc, "GtkSizeGroup_");
  GtkSettings__sym = s7_make_symbol(sc, "GtkSettings_");
  GtkScrolledWindow__sym = s7_make_symbol(sc, "GtkScrolledWindow_");
  GtkScale__sym = s7_make_symbol(sc, "GtkScale_");
  GtkRange__sym = s7_make_symbol(sc, "GtkRange_");
  GtkRadioButton__sym = s7_make_symbol(sc, "GtkRadioButton_");
  GSList__sym = s7_make_symbol(sc, "GSList_");
  GtkProgressBar__sym = s7_make_symbol(sc, "GtkProgressBar_");
  GtkPaned__sym = s7_make_symbol(sc, "GtkPaned_");
  GtkNotebook__sym = s7_make_symbol(sc, "GtkNotebook_");
  PangoLanguage__sym = s7_make_symbol(sc, "PangoLanguage_");
  GtkListStore__sym = s7_make_symbol(sc, "GtkListStore_");
  PangoLayout__sym = s7_make_symbol(sc, "PangoLayout_");
  GtkLabel__sym = s7_make_symbol(sc, "GtkLabel_");
  guint16__sym = s7_make_symbol(sc, "guint16_");
  GtkIMContextSimple__sym = s7_make_symbol(sc, "GtkIMContextSimple_");
  GdkEventKey__sym = s7_make_symbol(sc, "GdkEventKey_");
  PangoAttrList__sym = s7_make_symbol(sc, "PangoAttrList_");
  GtkIMContext__sym = s7_make_symbol(sc, "GtkIMContext_");
  GtkImage__sym = s7_make_symbol(sc, "GtkImage_");
  GtkFrame__sym = s7_make_symbol(sc, "GtkFrame_");
  GtkFixed__sym = s7_make_symbol(sc, "GtkFixed_");
  GtkEntry__sym = s7_make_symbol(sc, "GtkEntry_");
  GtkEditable__sym = s7_make_symbol(sc, "GtkEditable_");
  etc_sym = s7_make_symbol(sc, "etc");
  GtkDialog__sym = s7_make_symbol(sc, "GtkDialog_");
  GList__sym = s7_make_symbol(sc, "GList_");
  GtkCallback_sym = s7_make_symbol(sc, "GtkCallback");
  GtkContainer__sym = s7_make_symbol(sc, "GtkContainer_");
  GtkCellRendererToggle__sym = s7_make_symbol(sc, "GtkCellRendererToggle_");
  GtkCellRendererText__sym = s7_make_symbol(sc, "GtkCellRendererText_");
  GtkCellEditable__sym = s7_make_symbol(sc, "GtkCellEditable_");
  GtkCalendar__sym = s7_make_symbol(sc, "GtkCalendar_");
  GtkButton__sym = s7_make_symbol(sc, "GtkButton_");
  GtkBox__sym = s7_make_symbol(sc, "GtkBox_");
  GtkBin__sym = s7_make_symbol(sc, "GtkBin_");
  GtkAdjustment__sym = s7_make_symbol(sc, "GtkAdjustment_");
  GtkAccelLabel__sym = s7_make_symbol(sc, "GtkAccelLabel_");
  char___sym = s7_make_symbol(sc, "char__");
  GdkPixbufDestroyNotify_sym = s7_make_symbol(sc, "GdkPixbufDestroyNotify");
  GError__sym = s7_make_symbol(sc, "GError_");
  guchar__sym = s7_make_symbol(sc, "guchar_");
  GdkPixbuf__sym = s7_make_symbol(sc, "GdkPixbuf_");
  GdkKeymapKey__sym = s7_make_symbol(sc, "GdkKeymapKey_");
  GdkKeymap__sym = s7_make_symbol(sc, "GdkKeymap_");
  GdkRectangle__sym = s7_make_symbol(sc, "GdkRectangle_");
  GtkDestroyNotify_sym = s7_make_symbol(sc, "GtkDestroyNotify");
  GSignalEmissionHook_sym = s7_make_symbol(sc, "GSignalEmissionHook");
  GSignalInvocationHint__sym = s7_make_symbol(sc, "GSignalInvocationHint_");
  guint__sym = s7_make_symbol(sc, "guint_");
  GSignalQuery__sym = s7_make_symbol(sc, "GSignalQuery_");
  GType__sym = s7_make_symbol(sc, "GType_");
  GSignalCMarshaller_sym = s7_make_symbol(sc, "GSignalCMarshaller");
  gpointer_sym = s7_make_symbol(sc, "gpointer");
  GSignalAccumulator_sym = s7_make_symbol(sc, "GSignalAccumulator");
  GClosureNotify_sym = s7_make_symbol(sc, "GClosureNotify");
  GCallback_sym = s7_make_symbol(sc, "GCallback");
  GClosure__sym = s7_make_symbol(sc, "GClosure_");
  gunichar__sym = s7_make_symbol(sc, "gunichar_");
  void_sym = s7_make_symbol(sc, "void");
  GtkDrawingArea__sym = s7_make_symbol(sc, "GtkDrawingArea_");
  GtkIconView__sym = s7_make_symbol(sc, "GtkIconView_");
  GtkEntryCompletion__sym = s7_make_symbol(sc, "GtkEntryCompletion_");
  GtkFileFilterInfo__sym = s7_make_symbol(sc, "GtkFileFilterInfo_");
  GtkTreeSelection__sym = s7_make_symbol(sc, "GtkTreeSelection_");
  GtkCellRenderer__sym = s7_make_symbol(sc, "GtkCellRenderer_");
  GtkTreeViewColumn__sym = s7_make_symbol(sc, "GtkTreeViewColumn_");
  GtkTreeView__sym = s7_make_symbol(sc, "GtkTreeView_");
  GtkTreeIter__sym = s7_make_symbol(sc, "GtkTreeIter_");
  GtkTreePath__sym = s7_make_symbol(sc, "GtkTreePath_");
  GtkTreeModel__sym = s7_make_symbol(sc, "GtkTreeModel_");
  GtkTextTag__sym = s7_make_symbol(sc, "GtkTextTag_");
  lambda_data_sym = s7_make_symbol(sc, "lambda_data");
  GtkWidget__sym = s7_make_symbol(sc, "GtkWidget_");
  GdkEventMotion__sym = s7_make_symbol(sc, "GdkEventMotion_");
  gdouble__sym = s7_make_symbol(sc, "gdouble_");
  GdkEventAny__sym = s7_make_symbol(sc, "GdkEventAny_");
  GdkEvent__sym = s7_make_symbol(sc, "GdkEvent_");
  cairo_t__sym = s7_make_symbol(sc, "cairo_t_");
  cairo_font_options_t__sym = s7_make_symbol(sc, "cairo_font_options_t_");
  PangoFontDescription__sym = s7_make_symbol(sc, "PangoFontDescription_");
  GtkMenuBar__sym = s7_make_symbol(sc, "GtkMenuBar_");
  GtkEventControllerLegacy__sym = s7_make_symbol(sc, "GtkEventControllerLegacy_");
}


static void define_strings(s7_scheme *sc)
{
  s7_pointer cur_env;
  cur_env = s7_curlet(sc);

  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PRINTER"), s7_make_string(sc, GTK_PRINT_SETTINGS_PRINTER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_ORIENTATION"), s7_make_string(sc, GTK_PRINT_SETTINGS_ORIENTATION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAPER_FORMAT"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAPER_FORMAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAPER_WIDTH"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAPER_WIDTH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAPER_HEIGHT"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAPER_HEIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_N_COPIES"), s7_make_string(sc, GTK_PRINT_SETTINGS_N_COPIES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_DEFAULT_SOURCE"), s7_make_string(sc, GTK_PRINT_SETTINGS_DEFAULT_SOURCE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_QUALITY"), s7_make_string(sc, GTK_PRINT_SETTINGS_QUALITY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_RESOLUTION"), s7_make_string(sc, GTK_PRINT_SETTINGS_RESOLUTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_USE_COLOR"), s7_make_string(sc, GTK_PRINT_SETTINGS_USE_COLOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_DUPLEX"), s7_make_string(sc, GTK_PRINT_SETTINGS_DUPLEX));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_COLLATE"), s7_make_string(sc, GTK_PRINT_SETTINGS_COLLATE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_REVERSE"), s7_make_string(sc, GTK_PRINT_SETTINGS_REVERSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_MEDIA_TYPE"), s7_make_string(sc, GTK_PRINT_SETTINGS_MEDIA_TYPE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_DITHER"), s7_make_string(sc, GTK_PRINT_SETTINGS_DITHER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_SCALE"), s7_make_string(sc, GTK_PRINT_SETTINGS_SCALE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PRINT_PAGES"), s7_make_string(sc, GTK_PRINT_SETTINGS_PRINT_PAGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAGE_RANGES"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAGE_RANGES));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_PAGE_SET"), s7_make_string(sc, GTK_PRINT_SETTINGS_PAGE_SET));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_FINISHINGS"), s7_make_string(sc, GTK_PRINT_SETTINGS_FINISHINGS));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_NUMBER_UP"), s7_make_string(sc, GTK_PRINT_SETTINGS_NUMBER_UP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_OUTPUT_BIN"), s7_make_string(sc, GTK_PRINT_SETTINGS_OUTPUT_BIN));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_OUTPUT_FILE_FORMAT"), s7_make_string(sc, GTK_PRINT_SETTINGS_OUTPUT_FILE_FORMAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_PRINT_SETTINGS_OUTPUT_URI"), s7_make_string(sc, GTK_PRINT_SETTINGS_OUTPUT_URI));
#if GTK_CHECK_VERSION(3, 0, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_HIGHLIGHT"), s7_make_string(sc, GTK_STYLE_CLASS_HIGHLIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_FRAME"), s7_make_string(sc, GTK_STYLE_CLASS_FRAME));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_DND"), s7_make_string(sc, GTK_STYLE_CLASS_DND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_HORIZONTAL"), s7_make_string(sc, GTK_STYLE_CLASS_HORIZONTAL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_VERTICAL"), s7_make_string(sc, GTK_STYLE_CLASS_VERTICAL));
#endif

#if GTK_CHECK_VERSION(3, 20, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_LEVEL_BAR_OFFSET_FULL"), s7_make_string(sc, GTK_LEVEL_BAR_OFFSET_FULL));
#endif

#if GTK_CHECK_VERSION(3, 92, 0)
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_CELL"), s7_make_string(sc, GTK_STYLE_CLASS_CELL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_DIM_LABEL"), s7_make_string(sc, GTK_STYLE_CLASS_DIM_LABEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_ENTRY"), s7_make_string(sc, GTK_STYLE_CLASS_ENTRY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_LABEL"), s7_make_string(sc, GTK_STYLE_CLASS_LABEL));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_COMBOBOX_ENTRY"), s7_make_string(sc, GTK_STYLE_CLASS_COMBOBOX_ENTRY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_BUTTON"), s7_make_string(sc, GTK_STYLE_CLASS_BUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_LIST"), s7_make_string(sc, GTK_STYLE_CLASS_LIST));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_LIST_ROW"), s7_make_string(sc, GTK_STYLE_CLASS_LIST_ROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_CALENDAR"), s7_make_string(sc, GTK_STYLE_CLASS_CALENDAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SLIDER"), s7_make_string(sc, GTK_STYLE_CLASS_SLIDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_BACKGROUND"), s7_make_string(sc, GTK_STYLE_CLASS_BACKGROUND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_RUBBERBAND"), s7_make_string(sc, GTK_STYLE_CLASS_RUBBERBAND));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_CSD"), s7_make_string(sc, GTK_STYLE_CLASS_CSD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_TOOLTIP"), s7_make_string(sc, GTK_STYLE_CLASS_TOOLTIP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_MENU"), s7_make_string(sc, GTK_STYLE_CLASS_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_CONTEXT_MENU"), s7_make_string(sc, GTK_STYLE_CLASS_CONTEXT_MENU));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_TOUCH_SELECTION"), s7_make_string(sc, GTK_STYLE_CLASS_TOUCH_SELECTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_MENUBAR"), s7_make_string(sc, GTK_STYLE_CLASS_MENUBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_MENUITEM"), s7_make_string(sc, GTK_STYLE_CLASS_MENUITEM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_STATUSBAR"), s7_make_string(sc, GTK_STYLE_CLASS_STATUSBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_RADIO"), s7_make_string(sc, GTK_STYLE_CLASS_RADIO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_CHECK"), s7_make_string(sc, GTK_STYLE_CLASS_CHECK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_DEFAULT"), s7_make_string(sc, GTK_STYLE_CLASS_DEFAULT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_TROUGH"), s7_make_string(sc, GTK_STYLE_CLASS_TROUGH));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SCROLLBAR"), s7_make_string(sc, GTK_STYLE_CLASS_SCROLLBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SCROLLBARS_JUNCTION"), s7_make_string(sc, GTK_STYLE_CLASS_SCROLLBARS_JUNCTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SCALE"), s7_make_string(sc, GTK_STYLE_CLASS_SCALE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SCALE_HAS_MARKS_ABOVE"), s7_make_string(sc, GTK_STYLE_CLASS_SCALE_HAS_MARKS_ABOVE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SCALE_HAS_MARKS_BELOW"), s7_make_string(sc, GTK_STYLE_CLASS_SCALE_HAS_MARKS_BELOW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_HEADER"), s7_make_string(sc, GTK_STYLE_CLASS_HEADER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_ACCELERATOR"), s7_make_string(sc, GTK_STYLE_CLASS_ACCELERATOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_RAISED"), s7_make_string(sc, GTK_STYLE_CLASS_RAISED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_LINKED"), s7_make_string(sc, GTK_STYLE_CLASS_LINKED));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_DOCK"), s7_make_string(sc, GTK_STYLE_CLASS_DOCK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_PROGRESSBAR"), s7_make_string(sc, GTK_STYLE_CLASS_PROGRESSBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SPINNER"), s7_make_string(sc, GTK_STYLE_CLASS_SPINNER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_MARK"), s7_make_string(sc, GTK_STYLE_CLASS_MARK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_EXPANDER"), s7_make_string(sc, GTK_STYLE_CLASS_EXPANDER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SPINBUTTON"), s7_make_string(sc, GTK_STYLE_CLASS_SPINBUTTON));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_NOTEBOOK"), s7_make_string(sc, GTK_STYLE_CLASS_NOTEBOOK));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_VIEW"), s7_make_string(sc, GTK_STYLE_CLASS_VIEW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SIDEBAR"), s7_make_string(sc, GTK_STYLE_CLASS_SIDEBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_IMAGE"), s7_make_string(sc, GTK_STYLE_CLASS_IMAGE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_PANE_SEPARATOR"), s7_make_string(sc, GTK_STYLE_CLASS_PANE_SEPARATOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SEPARATOR"), s7_make_string(sc, GTK_STYLE_CLASS_SEPARATOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_INFO"), s7_make_string(sc, GTK_STYLE_CLASS_INFO));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_WARNING"), s7_make_string(sc, GTK_STYLE_CLASS_WARNING));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_QUESTION"), s7_make_string(sc, GTK_STYLE_CLASS_QUESTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_ERROR"), s7_make_string(sc, GTK_STYLE_CLASS_ERROR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_TOP"), s7_make_string(sc, GTK_STYLE_CLASS_TOP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_BOTTOM"), s7_make_string(sc, GTK_STYLE_CLASS_BOTTOM));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_LEFT"), s7_make_string(sc, GTK_STYLE_CLASS_LEFT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_RIGHT"), s7_make_string(sc, GTK_STYLE_CLASS_RIGHT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_PULSE"), s7_make_string(sc, GTK_STYLE_CLASS_PULSE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_ARROW"), s7_make_string(sc, GTK_STYLE_CLASS_ARROW));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_OSD"), s7_make_string(sc, GTK_STYLE_CLASS_OSD));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_LEVEL_BAR"), s7_make_string(sc, GTK_STYLE_CLASS_LEVEL_BAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_CURSOR_HANDLE"), s7_make_string(sc, GTK_STYLE_CLASS_CURSOR_HANDLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_INSERTION_CURSOR"), s7_make_string(sc, GTK_STYLE_CLASS_INSERTION_CURSOR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_TITLEBAR"), s7_make_string(sc, GTK_STYLE_CLASS_TITLEBAR));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_TITLE"), s7_make_string(sc, GTK_STYLE_CLASS_TITLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SUBTITLE"), s7_make_string(sc, GTK_STYLE_CLASS_SUBTITLE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_NEEDS_ATTENTION"), s7_make_string(sc, GTK_STYLE_CLASS_NEEDS_ATTENTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_SUGGESTED_ACTION"), s7_make_string(sc, GTK_STYLE_CLASS_SUGGESTED_ACTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_DESTRUCTIVE_ACTION"), s7_make_string(sc, GTK_STYLE_CLASS_DESTRUCTIVE_ACTION));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_POPOVER"), s7_make_string(sc, GTK_STYLE_CLASS_POPOVER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_POPUP"), s7_make_string(sc, GTK_STYLE_CLASS_POPUP));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_MESSAGE_DIALOG"), s7_make_string(sc, GTK_STYLE_CLASS_MESSAGE_DIALOG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_FLAT"), s7_make_string(sc, GTK_STYLE_CLASS_FLAT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_READ_ONLY"), s7_make_string(sc, GTK_STYLE_CLASS_READ_ONLY));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_OVERSHOOT"), s7_make_string(sc, GTK_STYLE_CLASS_OVERSHOOT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_UNDERSHOOT"), s7_make_string(sc, GTK_STYLE_CLASS_UNDERSHOOT));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_PAPER"), s7_make_string(sc, GTK_STYLE_CLASS_PAPER));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_MONOSPACE"), s7_make_string(sc, GTK_STYLE_CLASS_MONOSPACE));
  s7_define(sc, cur_env, s7_make_symbol(sc, "GTK_STYLE_CLASS_WIDE"), s7_make_string(sc, GTK_STYLE_CLASS_WIDE));
#endif

  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_JPEG"), s7_make_string(sc, CAIRO_MIME_TYPE_JPEG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_PNG"), s7_make_string(sc, CAIRO_MIME_TYPE_PNG));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_JP2"), s7_make_string(sc, CAIRO_MIME_TYPE_JP2));
  s7_define(sc, cur_env, s7_make_symbol(sc, "CAIRO_MIME_TYPE_URI"), s7_make_string(sc, CAIRO_MIME_TYPE_URI));
}

typedef struct {const char *name, *type; int64_t value;} enummer_t;
static enummer_t enum_info[] = {
#if GTK_CHECK_VERSION(2, 0, 0)
        {"G_NORMALIZE_DEFAULT", "GNormalizeMode", G_NORMALIZE_DEFAULT},
        {"G_NORMALIZE_NFD", "GNormalizeMode", G_NORMALIZE_NFD},
        {"G_NORMALIZE_DEFAULT_COMPOSE", "GNormalizeMode", G_NORMALIZE_DEFAULT_COMPOSE},
        {"G_NORMALIZE_NFC", "GNormalizeMode", G_NORMALIZE_NFC},
        {"G_NORMALIZE_ALL", "GNormalizeMode", G_NORMALIZE_ALL},
        {"G_NORMALIZE_NFKD", "GNormalizeMode", G_NORMALIZE_NFKD},
        {"G_NORMALIZE_ALL_COMPOSE", "GNormalizeMode", G_NORMALIZE_ALL_COMPOSE},
        {"G_NORMALIZE_NFKC", "GNormalizeMode", G_NORMALIZE_NFKC},
        {"G_SIGNAL_RUN_FIRST", "GSignalFlags", G_SIGNAL_RUN_FIRST},
        {"G_SIGNAL_RUN_LAST", "GSignalFlags", G_SIGNAL_RUN_LAST},
        {"G_SIGNAL_RUN_CLEANUP", "GSignalFlags", G_SIGNAL_RUN_CLEANUP},
        {"G_SIGNAL_NO_RECURSE", "GSignalFlags", G_SIGNAL_NO_RECURSE},
        {"G_SIGNAL_DETAILED", "GSignalFlags", G_SIGNAL_DETAILED},
        {"G_SIGNAL_ACTION", "GSignalFlags", G_SIGNAL_ACTION},
        {"G_SIGNAL_NO_HOOKS", "GSignalFlags", G_SIGNAL_NO_HOOKS},
        {"G_CONNECT_AFTER", "GConnectFlags", G_CONNECT_AFTER},
        {"G_CONNECT_SWAPPED", "GConnectFlags", G_CONNECT_SWAPPED},
        {"G_SIGNAL_MATCH_ID", "GSignalMatchType", G_SIGNAL_MATCH_ID},
        {"G_SIGNAL_MATCH_DETAIL", "GSignalMatchType", G_SIGNAL_MATCH_DETAIL},
        {"G_SIGNAL_MATCH_CLOSURE", "GSignalMatchType", G_SIGNAL_MATCH_CLOSURE},
        {"G_SIGNAL_MATCH_FUNC", "GSignalMatchType", G_SIGNAL_MATCH_FUNC},
        {"G_SIGNAL_MATCH_DATA", "GSignalMatchType", G_SIGNAL_MATCH_DATA},
        {"G_SIGNAL_MATCH_UNBLOCKED", "GSignalMatchType", G_SIGNAL_MATCH_UNBLOCKED},
        {"GDK_ACTION_COPY", "GdkDragAction", GDK_ACTION_COPY},
        {"GDK_ACTION_MOVE", "GdkDragAction", GDK_ACTION_MOVE},
        {"GDK_ACTION_LINK", "GdkDragAction", GDK_ACTION_LINK},
        {"GDK_ACTION_ASK", "GdkDragAction", GDK_ACTION_ASK},
        {"GDK_DELETE", "GdkEventType", GDK_DELETE},
        {"GDK_MOTION_NOTIFY", "GdkEventType", GDK_MOTION_NOTIFY},
        {"GDK_BUTTON_PRESS", "GdkEventType", GDK_BUTTON_PRESS},
        {"GDK_BUTTON_RELEASE", "GdkEventType", GDK_BUTTON_RELEASE},
        {"GDK_KEY_PRESS", "GdkEventType", GDK_KEY_PRESS},
        {"GDK_KEY_RELEASE", "GdkEventType", GDK_KEY_RELEASE},
        {"GDK_ENTER_NOTIFY", "GdkEventType", GDK_ENTER_NOTIFY},
        {"GDK_LEAVE_NOTIFY", "GdkEventType", GDK_LEAVE_NOTIFY},
        {"GDK_FOCUS_CHANGE", "GdkEventType", GDK_FOCUS_CHANGE},
        {"GDK_CONFIGURE", "GdkEventType", GDK_CONFIGURE},
        {"GDK_PROXIMITY_IN", "GdkEventType", GDK_PROXIMITY_IN},
        {"GDK_PROXIMITY_OUT", "GdkEventType", GDK_PROXIMITY_OUT},
        {"GDK_DRAG_ENTER", "GdkEventType", GDK_DRAG_ENTER},
        {"GDK_DRAG_LEAVE", "GdkEventType", GDK_DRAG_LEAVE},
        {"GDK_DRAG_MOTION", "GdkEventType", GDK_DRAG_MOTION},
        {"GDK_DROP_START", "GdkEventType", GDK_DROP_START},
        {"GDK_SCROLL", "GdkEventType", GDK_SCROLL},
        {"GDK_GRAB_BROKEN", "GdkEventType", GDK_GRAB_BROKEN},
        {"GDK_EXPOSURE_MASK", "GdkEventMask", GDK_EXPOSURE_MASK},
        {"GDK_POINTER_MOTION_MASK", "GdkEventMask", GDK_POINTER_MOTION_MASK},
        {"GDK_BUTTON_MOTION_MASK", "GdkEventMask", GDK_BUTTON_MOTION_MASK},
        {"GDK_BUTTON1_MOTION_MASK", "GdkEventMask", GDK_BUTTON1_MOTION_MASK},
        {"GDK_BUTTON2_MOTION_MASK", "GdkEventMask", GDK_BUTTON2_MOTION_MASK},
        {"GDK_BUTTON3_MOTION_MASK", "GdkEventMask", GDK_BUTTON3_MOTION_MASK},
        {"GDK_BUTTON_PRESS_MASK", "GdkEventMask", GDK_BUTTON_PRESS_MASK},
        {"GDK_BUTTON_RELEASE_MASK", "GdkEventMask", GDK_BUTTON_RELEASE_MASK},
        {"GDK_KEY_PRESS_MASK", "GdkEventMask", GDK_KEY_PRESS_MASK},
        {"GDK_KEY_RELEASE_MASK", "GdkEventMask", GDK_KEY_RELEASE_MASK},
        {"GDK_ENTER_NOTIFY_MASK", "GdkEventMask", GDK_ENTER_NOTIFY_MASK},
        {"GDK_LEAVE_NOTIFY_MASK", "GdkEventMask", GDK_LEAVE_NOTIFY_MASK},
        {"GDK_FOCUS_CHANGE_MASK", "GdkEventMask", GDK_FOCUS_CHANGE_MASK},
        {"GDK_STRUCTURE_MASK", "GdkEventMask", GDK_STRUCTURE_MASK},
        {"GDK_PROPERTY_CHANGE_MASK", "GdkEventMask", GDK_PROPERTY_CHANGE_MASK},
        {"GDK_PROXIMITY_IN_MASK", "GdkEventMask", GDK_PROXIMITY_IN_MASK},
        {"GDK_PROXIMITY_OUT_MASK", "GdkEventMask", GDK_PROXIMITY_OUT_MASK},
        {"GDK_SUBSTRUCTURE_MASK", "GdkEventMask", GDK_SUBSTRUCTURE_MASK},
        {"GDK_SCROLL_MASK", "GdkEventMask", GDK_SCROLL_MASK},
        {"GDK_SCROLL_UP", "GdkScrollDirection", GDK_SCROLL_UP},
        {"GDK_SCROLL_DOWN", "GdkScrollDirection", GDK_SCROLL_DOWN},
        {"GDK_SCROLL_LEFT", "GdkScrollDirection", GDK_SCROLL_LEFT},
        {"GDK_SCROLL_RIGHT", "GdkScrollDirection", GDK_SCROLL_RIGHT},
        {"GDK_NOTIFY_ANCESTOR", "GdkNotifyType", GDK_NOTIFY_ANCESTOR},
        {"GDK_NOTIFY_VIRTUAL", "GdkNotifyType", GDK_NOTIFY_VIRTUAL},
        {"GDK_NOTIFY_INFERIOR", "GdkNotifyType", GDK_NOTIFY_INFERIOR},
        {"GDK_NOTIFY_NONLINEAR", "GdkNotifyType", GDK_NOTIFY_NONLINEAR},
        {"GDK_NOTIFY_NONLINEAR_VIRTUAL", "GdkNotifyType", GDK_NOTIFY_NONLINEAR_VIRTUAL},
        {"GDK_NOTIFY_UNKNOWN", "GdkNotifyType", GDK_NOTIFY_UNKNOWN},
        {"GDK_CROSSING_NORMAL", "GdkCrossingMode", GDK_CROSSING_NORMAL},
        {"GDK_CROSSING_GRAB", "GdkNotifyType", GDK_CROSSING_GRAB},
        {"GDK_CROSSING_UNGRAB", "GdkNotifyType", GDK_CROSSING_UNGRAB},
        {"GDK_LSB_FIRST", "GdkByteOrder", GDK_LSB_FIRST},
        {"GDK_MSB_FIRST", "GdkByteOrder", GDK_MSB_FIRST},
        {"GDK_SHIFT_MASK", "GdkModifierType", GDK_SHIFT_MASK},
        {"GDK_LOCK_MASK", "GdkModifierType", GDK_LOCK_MASK},
        {"GDK_CONTROL_MASK", "GdkModifierType", GDK_CONTROL_MASK},
        {"GDK_BUTTON1_MASK", "GdkModifierType", GDK_BUTTON1_MASK},
        {"GDK_BUTTON2_MASK", "GdkModifierType", GDK_BUTTON2_MASK},
        {"GDK_BUTTON3_MASK", "GdkModifierType", GDK_BUTTON3_MASK},
        {"GDK_BUTTON4_MASK", "GdkModifierType", GDK_BUTTON4_MASK},
        {"GDK_BUTTON5_MASK", "GdkModifierType", GDK_BUTTON5_MASK},
        {"GDK_MODIFIER_MASK", "GdkModifierType", GDK_MODIFIER_MASK},
        {"GDK_PIXBUF_ALPHA_BILEVEL", "GdkPixbufAlphaMode", GDK_PIXBUF_ALPHA_BILEVEL},
        {"GDK_PIXBUF_ALPHA_FULL", "GdkPixbufAlphaMode", GDK_PIXBUF_ALPHA_FULL},
        {"GDK_COLORSPACE_RGB", "GdkColorspace", GDK_COLORSPACE_RGB},
        {"GDK_PIXBUF_ERROR_CORRUPT_IMAGE", "GdkPixbufError", GDK_PIXBUF_ERROR_CORRUPT_IMAGE},
        {"GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY", "GdkPixbufError", GDK_PIXBUF_ERROR_INSUFFICIENT_MEMORY},
        {"GDK_PIXBUF_ERROR_BAD_OPTION", "GdkPixbufError", GDK_PIXBUF_ERROR_BAD_OPTION},
        {"GDK_PIXBUF_ERROR_UNKNOWN_TYPE", "GdkPixbufError", GDK_PIXBUF_ERROR_UNKNOWN_TYPE},
        {"GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION", "GdkPixbufError", GDK_PIXBUF_ERROR_UNSUPPORTED_OPERATION},
        {"GDK_PIXBUF_ERROR_FAILED", "GdkPixbufError", GDK_PIXBUF_ERROR_FAILED},
        {"GDK_INTERP_NEAREST", "GdkInterpType", GDK_INTERP_NEAREST},
        {"GDK_INTERP_TILES", "GdkInterpType", GDK_INTERP_TILES},
        {"GDK_INTERP_BILINEAR", "GdkInterpType", GDK_INTERP_BILINEAR},
        {"GDK_INTERP_HYPER", "GdkInterpType", GDK_INTERP_HYPER},
        {"GTK_CALENDAR_SHOW_HEADING", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_HEADING},
        {"GTK_CALENDAR_SHOW_DAY_NAMES", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_DAY_NAMES},
        {"GTK_CALENDAR_NO_MONTH_CHANGE", "GtkCalendarDisplayOptions", GTK_CALENDAR_NO_MONTH_CHANGE},
        {"GTK_CALENDAR_SHOW_WEEK_NUMBERS", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_WEEK_NUMBERS},
        {"GTK_CELL_RENDERER_SELECTED", "GtkCellRendererState", GTK_CELL_RENDERER_SELECTED},
        {"GTK_CELL_RENDERER_PRELIT", "GtkCellRendererState", GTK_CELL_RENDERER_PRELIT},
        {"GTK_CELL_RENDERER_INSENSITIVE", "GtkCellRendererState", GTK_CELL_RENDERER_INSENSITIVE},
        {"GTK_CELL_RENDERER_SORTED", "GtkCellRendererState", GTK_CELL_RENDERER_SORTED},
        {"GTK_CELL_RENDERER_FOCUSED", "GtkCellRendererState", GTK_CELL_RENDERER_FOCUSED},
        {"GTK_DIALOG_MODAL", "GtkDialogFlags", GTK_DIALOG_MODAL},
        {"GTK_DIALOG_DESTROY_WITH_PARENT", "GtkDialogFlags", GTK_DIALOG_DESTROY_WITH_PARENT},
        {"GTK_RESPONSE_NONE", "GtkResponseType", GTK_RESPONSE_NONE},
        {"GTK_RESPONSE_REJECT", "GtkResponseType", GTK_RESPONSE_REJECT},
        {"GTK_RESPONSE_ACCEPT", "GtkResponseType", GTK_RESPONSE_ACCEPT},
        {"GTK_RESPONSE_DELETE_EVENT", "GtkResponseType", GTK_RESPONSE_DELETE_EVENT},
        {"GTK_RESPONSE_OK", "GtkResponseType", GTK_RESPONSE_OK},
        {"GTK_RESPONSE_CANCEL", "GtkResponseType", GTK_RESPONSE_CANCEL},
        {"GTK_RESPONSE_CLOSE", "GtkResponseType", GTK_RESPONSE_CLOSE},
        {"GTK_RESPONSE_YES", "GtkResponseType", GTK_RESPONSE_YES},
        {"GTK_RESPONSE_NO", "GtkResponseType", GTK_RESPONSE_NO},
        {"GTK_RESPONSE_APPLY", "GtkResponseType", GTK_RESPONSE_APPLY},
        {"GTK_RESPONSE_HELP", "GtkResponseType", GTK_RESPONSE_HELP},
        {"GTK_DEST_DEFAULT_MOTION", "GtkDestDefaults", GTK_DEST_DEFAULT_MOTION},
        {"GTK_DEST_DEFAULT_HIGHLIGHT", "GtkDestDefaults", GTK_DEST_DEFAULT_HIGHLIGHT},
        {"GTK_DEST_DEFAULT_DROP", "GtkDestDefaults", GTK_DEST_DEFAULT_DROP},
        {"GTK_DEST_DEFAULT_ALL", "GtkDestDefaults", GTK_DEST_DEFAULT_ALL},
        {"GTK_DELETE_CHARS", "GtkDeleteType", GTK_DELETE_CHARS},
        {"GTK_DELETE_WORD_ENDS", "GtkDeleteType", GTK_DELETE_WORD_ENDS},
        {"GTK_DELETE_WORDS", "GtkDeleteType", GTK_DELETE_WORDS},
        {"GTK_DELETE_DISPLAY_LINES", "GtkDeleteType", GTK_DELETE_DISPLAY_LINES},
        {"GTK_DELETE_DISPLAY_LINE_ENDS", "GtkDeleteType", GTK_DELETE_DISPLAY_LINE_ENDS},
        {"GTK_DELETE_PARAGRAPH_ENDS", "GtkDeleteType", GTK_DELETE_PARAGRAPH_ENDS},
        {"GTK_DELETE_PARAGRAPHS", "GtkDeleteType", GTK_DELETE_PARAGRAPHS},
        {"GTK_DELETE_WHITESPACE", "GtkDeleteType", GTK_DELETE_WHITESPACE},
        {"GTK_DIR_TAB_FORWARD", "GtkDirectionType", GTK_DIR_TAB_FORWARD},
        {"GTK_DIR_TAB_BACKWARD", "GtkDirectionType", GTK_DIR_TAB_BACKWARD},
        {"GTK_DIR_UP", "GtkDirectionType", GTK_DIR_UP},
        {"GTK_DIR_DOWN", "GtkDirectionType", GTK_DIR_DOWN},
        {"GTK_DIR_LEFT", "GtkDirectionType", GTK_DIR_LEFT},
        {"GTK_DIR_RIGHT", "GtkDirectionType", GTK_DIR_RIGHT},
        {"GTK_TEXT_DIR_NONE", "GtkTextDirection", GTK_TEXT_DIR_NONE},
        {"GTK_TEXT_DIR_LTR", "GtkTextDirection", GTK_TEXT_DIR_LTR},
        {"GTK_TEXT_DIR_RTL", "GtkTextDirection", GTK_TEXT_DIR_RTL},
        {"GTK_JUSTIFY_LEFT", "GtkJustification", GTK_JUSTIFY_LEFT},
        {"GTK_JUSTIFY_RIGHT", "GtkJustification", GTK_JUSTIFY_RIGHT},
        {"GTK_JUSTIFY_CENTER", "GtkJustification", GTK_JUSTIFY_CENTER},
        {"GTK_JUSTIFY_FILL", "GtkJustification", GTK_JUSTIFY_FILL},
        {"GTK_MENU_DIR_PARENT", "GtkMenuDirectionType", GTK_MENU_DIR_PARENT},
        {"GTK_MENU_DIR_CHILD", "GtkMenuDirectionType", GTK_MENU_DIR_CHILD},
        {"GTK_MENU_DIR_NEXT", "GtkMenuDirectionType", GTK_MENU_DIR_NEXT},
        {"GTK_MENU_DIR_PREV", "GtkMenuDirectionType", GTK_MENU_DIR_PREV},
        {"GTK_MOVEMENT_LOGICAL_POSITIONS", "GtkMovementStep", GTK_MOVEMENT_LOGICAL_POSITIONS},
        {"GTK_MOVEMENT_VISUAL_POSITIONS", "GtkMovementStep", GTK_MOVEMENT_VISUAL_POSITIONS},
        {"GTK_MOVEMENT_WORDS", "GtkMovementStep", GTK_MOVEMENT_WORDS},
        {"GTK_MOVEMENT_DISPLAY_LINES", "GtkMovementStep", GTK_MOVEMENT_DISPLAY_LINES},
        {"GTK_MOVEMENT_DISPLAY_LINE_ENDS", "GtkMovementStep", GTK_MOVEMENT_DISPLAY_LINE_ENDS},
        {"GTK_MOVEMENT_PARAGRAPHS", "GtkMovementStep", GTK_MOVEMENT_PARAGRAPHS},
        {"GTK_MOVEMENT_PARAGRAPH_ENDS", "GtkMovementStep", GTK_MOVEMENT_PARAGRAPH_ENDS},
        {"GTK_MOVEMENT_PAGES", "GtkMovementStep", GTK_MOVEMENT_PAGES},
        {"GTK_MOVEMENT_BUFFER_ENDS", "GtkMovementStep", GTK_MOVEMENT_BUFFER_ENDS},
        {"GTK_ORIENTATION_HORIZONTAL", "GtkOrientation", GTK_ORIENTATION_HORIZONTAL},
        {"GTK_ORIENTATION_VERTICAL", "GtkOrientation", GTK_ORIENTATION_VERTICAL},
        {"GTK_CORNER_TOP_LEFT", "GtkCornerType", GTK_CORNER_TOP_LEFT},
        {"GTK_CORNER_BOTTOM_LEFT", "GtkCornerType", GTK_CORNER_BOTTOM_LEFT},
        {"GTK_CORNER_TOP_RIGHT", "GtkCornerType", GTK_CORNER_TOP_RIGHT},
        {"GTK_CORNER_BOTTOM_RIGHT", "GtkCornerType", GTK_CORNER_BOTTOM_RIGHT},
        {"GTK_PACK_START", "GtkPackType", GTK_PACK_START},
        {"GTK_PACK_END", "GtkPackType", GTK_PACK_END},
        {"GTK_POLICY_ALWAYS", "GtkPolicyType", GTK_POLICY_ALWAYS},
        {"GTK_POLICY_AUTOMATIC", "GtkPolicyType", GTK_POLICY_AUTOMATIC},
        {"GTK_POLICY_NEVER", "GtkPolicyType", GTK_POLICY_NEVER},
        {"GTK_POS_LEFT", "GtkPositionType", GTK_POS_LEFT},
        {"GTK_POS_RIGHT", "GtkPositionType", GTK_POS_RIGHT},
        {"GTK_POS_TOP", "GtkPositionType", GTK_POS_TOP},
        {"GTK_POS_BOTTOM", "GtkPositionType", GTK_POS_BOTTOM},
        {"GTK_SCROLL_NONE", "GtkScrollType", GTK_SCROLL_NONE},
        {"GTK_SCROLL_JUMP", "GtkScrollType", GTK_SCROLL_JUMP},
        {"GTK_SCROLL_STEP_BACKWARD", "GtkScrollType", GTK_SCROLL_STEP_BACKWARD},
        {"GTK_SCROLL_STEP_FORWARD", "GtkScrollType", GTK_SCROLL_STEP_FORWARD},
        {"GTK_SCROLL_PAGE_BACKWARD", "GtkScrollType", GTK_SCROLL_PAGE_BACKWARD},
        {"GTK_SCROLL_PAGE_FORWARD", "GtkScrollType", GTK_SCROLL_PAGE_FORWARD},
        {"GTK_SCROLL_STEP_UP", "GtkScrollType", GTK_SCROLL_STEP_UP},
        {"GTK_SCROLL_STEP_DOWN", "GtkScrollType", GTK_SCROLL_STEP_DOWN},
        {"GTK_SCROLL_PAGE_UP", "GtkScrollType", GTK_SCROLL_PAGE_UP},
        {"GTK_SCROLL_PAGE_DOWN", "GtkScrollType", GTK_SCROLL_PAGE_DOWN},
        {"GTK_SCROLL_STEP_LEFT", "GtkScrollType", GTK_SCROLL_STEP_LEFT},
        {"GTK_SCROLL_STEP_RIGHT", "GtkScrollType", GTK_SCROLL_STEP_RIGHT},
        {"GTK_SCROLL_PAGE_LEFT", "GtkScrollType", GTK_SCROLL_PAGE_LEFT},
        {"GTK_SCROLL_PAGE_RIGHT", "GtkScrollType", GTK_SCROLL_PAGE_RIGHT},
        {"GTK_SCROLL_START", "GtkScrollType", GTK_SCROLL_START},
        {"GTK_SCROLL_END", "GtkScrollType", GTK_SCROLL_END},
        {"GTK_SELECTION_NONE", "GtkSelectionMode", GTK_SELECTION_NONE},
        {"GTK_SELECTION_SINGLE", "GtkSelectionMode", GTK_SELECTION_SINGLE},
        {"GTK_SELECTION_BROWSE", "GtkSelectionMode", GTK_SELECTION_BROWSE},
        {"GTK_SELECTION_MULTIPLE", "GtkSelectionMode", GTK_SELECTION_MULTIPLE},
        {"GTK_WRAP_NONE", "GtkWrapMode", GTK_WRAP_NONE},
        {"GTK_WRAP_CHAR", "GtkWrapMode", GTK_WRAP_CHAR},
        {"GTK_WRAP_WORD", "GtkWrapMode", GTK_WRAP_WORD},
        {"GTK_SORT_ASCENDING", "GtkSortType", GTK_SORT_ASCENDING},
        {"GTK_SORT_DESCENDING", "GtkSortType", GTK_SORT_DESCENDING},
        {"GTK_IMAGE_EMPTY", "GtkImageType", GTK_IMAGE_EMPTY},
        {"GTK_MESSAGE_INFO", "GtkMessageType", GTK_MESSAGE_INFO},
        {"GTK_MESSAGE_WARNING", "GtkMessageType", GTK_MESSAGE_WARNING},
        {"GTK_MESSAGE_QUESTION", "GtkMessageType", GTK_MESSAGE_QUESTION},
        {"GTK_MESSAGE_ERROR", "GtkMessageType", GTK_MESSAGE_ERROR},
        {"GTK_BUTTONS_NONE", "GtkButtonsType", GTK_BUTTONS_NONE},
        {"GTK_BUTTONS_OK", "GtkButtonsType", GTK_BUTTONS_OK},
        {"GTK_BUTTONS_CLOSE", "GtkButtonsType", GTK_BUTTONS_CLOSE},
        {"GTK_BUTTONS_CANCEL", "GtkButtonsType", GTK_BUTTONS_CANCEL},
        {"GTK_BUTTONS_YES_NO", "GtkButtonsType", GTK_BUTTONS_YES_NO},
        {"GTK_BUTTONS_OK_CANCEL", "GtkButtonsType", GTK_BUTTONS_OK_CANCEL},
        {"GTK_NOTEBOOK_TAB_FIRST", "GtkNotebookTab", GTK_NOTEBOOK_TAB_FIRST},
        {"GTK_NOTEBOOK_TAB_LAST", "GtkNotebookTab", GTK_NOTEBOOK_TAB_LAST},
        {"GTK_SIZE_GROUP_NONE", "GtkSizeGroupMode", GTK_SIZE_GROUP_NONE},
        {"GTK_SIZE_GROUP_HORIZONTAL", "GtkSizeGroupMode", GTK_SIZE_GROUP_HORIZONTAL},
        {"GTK_SIZE_GROUP_VERTICAL", "GtkSizeGroupMode", GTK_SIZE_GROUP_VERTICAL},
        {"GTK_SIZE_GROUP_BOTH", "GtkSizeGroupMode", GTK_SIZE_GROUP_BOTH},
        {"GTK_UPDATE_ALWAYS", "GtkSpinButtonUpdatePolicy", GTK_UPDATE_ALWAYS},
        {"GTK_UPDATE_IF_VALID", "GtkSpinButtonUpdatePolicy", GTK_UPDATE_IF_VALID},
        {"GTK_SPIN_STEP_FORWARD", "GtkSpinType", GTK_SPIN_STEP_FORWARD},
        {"GTK_SPIN_STEP_BACKWARD", "GtkSpinType", GTK_SPIN_STEP_BACKWARD},
        {"GTK_SPIN_PAGE_FORWARD", "GtkSpinType", GTK_SPIN_PAGE_FORWARD},
        {"GTK_SPIN_PAGE_BACKWARD", "GtkSpinType", GTK_SPIN_PAGE_BACKWARD},
        {"GTK_SPIN_HOME", "GtkSpinType", GTK_SPIN_HOME},
        {"GTK_SPIN_END", "GtkSpinType", GTK_SPIN_END},
        {"GTK_TEXT_SEARCH_VISIBLE_ONLY", "GtkTextSearchFlags", GTK_TEXT_SEARCH_VISIBLE_ONLY},
        {"GTK_TEXT_SEARCH_TEXT_ONLY", "GtkTextSearchFlags", GTK_TEXT_SEARCH_TEXT_ONLY},
        {"GTK_TEXT_WINDOW_WIDGET", "GtkTextWindowType", GTK_TEXT_WINDOW_WIDGET},
        {"GTK_TEXT_WINDOW_TEXT", "GtkTextWindowType", GTK_TEXT_WINDOW_TEXT},
        {"GTK_TEXT_WINDOW_LEFT", "GtkTextWindowType", GTK_TEXT_WINDOW_LEFT},
        {"GTK_TEXT_WINDOW_RIGHT", "GtkTextWindowType", GTK_TEXT_WINDOW_RIGHT},
        {"GTK_TEXT_WINDOW_TOP", "GtkTextWindowType", GTK_TEXT_WINDOW_TOP},
        {"GTK_TEXT_WINDOW_BOTTOM", "GtkTextWindowType", GTK_TEXT_WINDOW_BOTTOM},
        {"GTK_TREE_MODEL_ITERS_PERSIST", "GtkTreeModelFlags", GTK_TREE_MODEL_ITERS_PERSIST},
        {"GTK_TREE_MODEL_LIST_ONLY", "GtkTreeModelFlags", GTK_TREE_MODEL_LIST_ONLY},
        {"GTK_TREE_VIEW_COLUMN_GROW_ONLY", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_GROW_ONLY},
        {"GTK_TREE_VIEW_COLUMN_AUTOSIZE", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_AUTOSIZE},
        {"GTK_TREE_VIEW_COLUMN_FIXED", "GtkTreeViewColumnSizing", GTK_TREE_VIEW_COLUMN_FIXED},
        {"GTK_TREE_VIEW_DROP_BEFORE", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_BEFORE},
        {"GTK_TREE_VIEW_DROP_AFTER", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_AFTER},
        {"GTK_TREE_VIEW_DROP_INTO_OR_BEFORE", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_INTO_OR_BEFORE},
        {"GTK_TREE_VIEW_DROP_INTO_OR_AFTER", "GtkTreeViewDropPosition", GTK_TREE_VIEW_DROP_INTO_OR_AFTER},
        {"PANGO_ATTR_INVALID", "PangoAttrType", PANGO_ATTR_INVALID},
        {"PANGO_ATTR_LANGUAGE", "PangoAttrType", PANGO_ATTR_LANGUAGE},
        {"PANGO_ATTR_FAMILY", "PangoAttrType", PANGO_ATTR_FAMILY},
        {"PANGO_ATTR_STYLE", "PangoAttrType", PANGO_ATTR_STYLE},
        {"PANGO_ATTR_WEIGHT", "PangoAttrType", PANGO_ATTR_WEIGHT},
        {"PANGO_ATTR_VARIANT", "PangoAttrType", PANGO_ATTR_VARIANT},
        {"PANGO_ATTR_STRETCH", "PangoAttrType", PANGO_ATTR_STRETCH},
        {"PANGO_ATTR_SIZE", "PangoAttrType", PANGO_ATTR_SIZE},
        {"PANGO_ATTR_FONT_DESC", "PangoAttrType", PANGO_ATTR_FONT_DESC},
        {"PANGO_ATTR_FOREGROUND", "PangoAttrType", PANGO_ATTR_FOREGROUND},
        {"PANGO_ATTR_BACKGROUND", "PangoAttrType", PANGO_ATTR_BACKGROUND},
        {"PANGO_ATTR_UNDERLINE", "PangoAttrType", PANGO_ATTR_UNDERLINE},
        {"PANGO_ATTR_STRIKETHROUGH", "PangoAttrType", PANGO_ATTR_STRIKETHROUGH},
        {"PANGO_ATTR_RISE", "PangoAttrType", PANGO_ATTR_RISE},
        {"PANGO_ATTR_SHAPE", "PangoAttrType", PANGO_ATTR_SHAPE},
        {"PANGO_ATTR_SCALE", "PangoAttrType", PANGO_ATTR_SCALE},
        {"PANGO_UNDERLINE_NONE", "PangoUnderline", PANGO_UNDERLINE_NONE},
        {"PANGO_UNDERLINE_SINGLE", "PangoUnderline", PANGO_UNDERLINE_SINGLE},
        {"PANGO_UNDERLINE_DOUBLE", "PangoUnderline", PANGO_UNDERLINE_DOUBLE},
        {"PANGO_UNDERLINE_LOW", "PangoUnderline", PANGO_UNDERLINE_LOW},
        {"PANGO_COVERAGE_NONE", "PangoCoverageLevel", PANGO_COVERAGE_NONE},
        {"PANGO_COVERAGE_FALLBACK", "PangoCoverageLevel", PANGO_COVERAGE_FALLBACK},
        {"PANGO_COVERAGE_APPROXIMATE", "PangoCoverageLevel", PANGO_COVERAGE_APPROXIMATE},
        {"PANGO_COVERAGE_EXACT", "PangoCoverageLevel", PANGO_COVERAGE_EXACT},
        {"PANGO_STYLE_NORMAL", "PangoStyle", PANGO_STYLE_NORMAL},
        {"PANGO_STYLE_OBLIQUE", "PangoStyle", PANGO_STYLE_OBLIQUE},
        {"PANGO_STYLE_ITALIC", "PangoStyle", PANGO_STYLE_ITALIC},
        {"PANGO_VARIANT_NORMAL", "PangoVariant", PANGO_VARIANT_NORMAL},
        {"PANGO_VARIANT_SMALL_CAPS", "PangoVariant", PANGO_VARIANT_SMALL_CAPS},
        {"PANGO_WEIGHT_ULTRALIGHT", "PangoWeight", PANGO_WEIGHT_ULTRALIGHT},
        {"PANGO_WEIGHT_LIGHT", "PangoWeight", PANGO_WEIGHT_LIGHT},
        {"PANGO_WEIGHT_NORMAL", "PangoWeight", PANGO_WEIGHT_NORMAL},
        {"PANGO_WEIGHT_BOLD", "PangoWeight", PANGO_WEIGHT_BOLD},
        {"PANGO_WEIGHT_ULTRABOLD", "PangoWeight", PANGO_WEIGHT_ULTRABOLD},
        {"PANGO_WEIGHT_HEAVY", "PangoWeight", PANGO_WEIGHT_HEAVY},
        {"PANGO_STRETCH_ULTRA_CONDENSED", "PangoStretch", PANGO_STRETCH_ULTRA_CONDENSED},
        {"PANGO_STRETCH_EXTRA_CONDENSED", "PangoStretch", PANGO_STRETCH_EXTRA_CONDENSED},
        {"PANGO_STRETCH_CONDENSED", "PangoStretch", PANGO_STRETCH_CONDENSED},
        {"PANGO_STRETCH_SEMI_CONDENSED", "PangoStretch", PANGO_STRETCH_SEMI_CONDENSED},
        {"PANGO_STRETCH_NORMAL", "PangoStretch", PANGO_STRETCH_NORMAL},
        {"PANGO_STRETCH_SEMI_EXPANDED", "PangoStretch", PANGO_STRETCH_SEMI_EXPANDED},
        {"PANGO_STRETCH_EXPANDED", "PangoStretch", PANGO_STRETCH_EXPANDED},
        {"PANGO_STRETCH_EXTRA_EXPANDED", "PangoStretch", PANGO_STRETCH_EXTRA_EXPANDED},
        {"PANGO_STRETCH_ULTRA_EXPANDED", "PangoStretch", PANGO_STRETCH_ULTRA_EXPANDED},
        {"PANGO_FONT_MASK_FAMILY", "PangoFontMask", PANGO_FONT_MASK_FAMILY},
        {"PANGO_FONT_MASK_STYLE", "PangoFontMask", PANGO_FONT_MASK_STYLE},
        {"PANGO_FONT_MASK_VARIANT", "PangoFontMask", PANGO_FONT_MASK_VARIANT},
        {"PANGO_FONT_MASK_WEIGHT", "PangoFontMask", PANGO_FONT_MASK_WEIGHT},
        {"PANGO_FONT_MASK_STRETCH", "PangoFontMask", PANGO_FONT_MASK_STRETCH},
        {"PANGO_FONT_MASK_SIZE", "PangoFontMask", PANGO_FONT_MASK_SIZE},
        {"PANGO_ALIGN_LEFT", "PangoAlignment", PANGO_ALIGN_LEFT},
        {"PANGO_ALIGN_CENTER", "PangoAlignment", PANGO_ALIGN_CENTER},
        {"PANGO_ALIGN_RIGHT", "PangoAlignment", PANGO_ALIGN_RIGHT},
        {"PANGO_WRAP_WORD", "PangoWrapMode", PANGO_WRAP_WORD},
        {"PANGO_WRAP_CHAR", "PangoWrapMode", PANGO_WRAP_CHAR},
        {"PANGO_DIRECTION_LTR", "PangoDirection", PANGO_DIRECTION_LTR},
        {"PANGO_DIRECTION_RTL", "PangoDirection", PANGO_DIRECTION_RTL},
        {"PANGO_DIRECTION_TTB_LTR", "PangoDirection", PANGO_DIRECTION_TTB_LTR},
        {"PANGO_DIRECTION_TTB_RTL", "PangoDirection", PANGO_DIRECTION_TTB_RTL},
        {"GTK_MOVEMENT_HORIZONTAL_PAGES", "GtkMovementStep", GTK_MOVEMENT_HORIZONTAL_PAGES},
        {"GTK_SCROLL_STEPS", "GtkScrollStep", GTK_SCROLL_STEPS},
        {"GTK_SCROLL_PAGES", "GtkScrollStep", GTK_SCROLL_PAGES},
        {"GTK_SCROLL_ENDS", "GtkScrollStep", GTK_SCROLL_ENDS},
        {"GTK_SCROLL_HORIZONTAL_STEPS", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_STEPS},
        {"GTK_SCROLL_HORIZONTAL_PAGES", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_PAGES},
        {"GTK_SCROLL_HORIZONTAL_ENDS", "GtkScrollStep", GTK_SCROLL_HORIZONTAL_ENDS},
        {"GTK_WRAP_WORD_CHAR", "GtkWrapMode", GTK_WRAP_WORD_CHAR},
        {"GTK_FILE_FILTER_FILENAME", "GtkFileFilterFlags", GTK_FILE_FILTER_FILENAME},
        {"GTK_FILE_FILTER_URI", "GtkFileFilterFlags", GTK_FILE_FILTER_URI},
        {"GTK_FILE_FILTER_DISPLAY_NAME", "GtkFileFilterFlags", GTK_FILE_FILTER_DISPLAY_NAME},
        {"GTK_FILE_FILTER_MIME_TYPE", "GtkFileFilterFlags", GTK_FILE_FILTER_MIME_TYPE},
        {"GTK_FILE_CHOOSER_ACTION_OPEN", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_OPEN},
        {"GTK_FILE_CHOOSER_ACTION_SAVE", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_SAVE},
        {"GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER", "GtkFileChooserAction", GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER},
        {"PANGO_ATTR_FALLBACK", "PangoAttrType", PANGO_ATTR_FALLBACK},
        {"PANGO_ATTR_LETTER_SPACING", "PangoAttrType", PANGO_ATTR_LETTER_SPACING},
        {"PANGO_UNDERLINE_ERROR", "PangoUnderline", PANGO_UNDERLINE_ERROR},
        {"PANGO_WRAP_WORD_CHAR", "PangoWrapMode", PANGO_WRAP_WORD_CHAR},
        {"PANGO_ELLIPSIZE_NONE", "PangoEllipsizeMode", PANGO_ELLIPSIZE_NONE},
        {"PANGO_ELLIPSIZE_START", "PangoEllipsizeMode", PANGO_ELLIPSIZE_START},
        {"PANGO_ELLIPSIZE_MIDDLE", "PangoEllipsizeMode", PANGO_ELLIPSIZE_MIDDLE},
        {"PANGO_ELLIPSIZE_END", "PangoEllipsizeMode", PANGO_ELLIPSIZE_END},
        {"PANGO_SCRIPT_INVALID_CODE", "PangoScript", PANGO_SCRIPT_INVALID_CODE},
        {"PANGO_SCRIPT_COMMON", "PangoScript", PANGO_SCRIPT_COMMON},
        {"PANGO_SCRIPT_INHERITED", "PangoScript", PANGO_SCRIPT_INHERITED},
        {"PANGO_SCRIPT_ARABIC", "PangoScript", PANGO_SCRIPT_ARABIC},
        {"PANGO_SCRIPT_ARMENIAN", "PangoScript", PANGO_SCRIPT_ARMENIAN},
        {"PANGO_SCRIPT_BENGALI", "PangoScript", PANGO_SCRIPT_BENGALI},
        {"PANGO_SCRIPT_BOPOMOFO", "PangoScript", PANGO_SCRIPT_BOPOMOFO},
        {"PANGO_SCRIPT_CHEROKEE", "PangoScript", PANGO_SCRIPT_CHEROKEE},
        {"PANGO_SCRIPT_COPTIC", "PangoScript", PANGO_SCRIPT_COPTIC},
        {"PANGO_SCRIPT_CYRILLIC", "PangoScript", PANGO_SCRIPT_CYRILLIC},
        {"PANGO_SCRIPT_DESERET", "PangoScript", PANGO_SCRIPT_DESERET},
        {"PANGO_SCRIPT_DEVANAGARI", "PangoScript", PANGO_SCRIPT_DEVANAGARI},
        {"PANGO_SCRIPT_ETHIOPIC", "PangoScript", PANGO_SCRIPT_ETHIOPIC},
        {"PANGO_SCRIPT_GEORGIAN", "PangoScript", PANGO_SCRIPT_GEORGIAN},
        {"PANGO_SCRIPT_GOTHIC", "PangoScript", PANGO_SCRIPT_GOTHIC},
        {"PANGO_SCRIPT_GREEK", "PangoScript", PANGO_SCRIPT_GREEK},
        {"PANGO_SCRIPT_GUJARATI", "PangoScript", PANGO_SCRIPT_GUJARATI},
        {"PANGO_SCRIPT_GURMUKHI", "PangoScript", PANGO_SCRIPT_GURMUKHI},
        {"PANGO_SCRIPT_HAN", "PangoScript", PANGO_SCRIPT_HAN},
        {"PANGO_SCRIPT_HANGUL", "PangoScript", PANGO_SCRIPT_HANGUL},
        {"PANGO_SCRIPT_HEBREW", "PangoScript", PANGO_SCRIPT_HEBREW},
        {"PANGO_SCRIPT_HIRAGANA", "PangoScript", PANGO_SCRIPT_HIRAGANA},
        {"PANGO_SCRIPT_KANNADA", "PangoScript", PANGO_SCRIPT_KANNADA},
        {"PANGO_SCRIPT_KATAKANA", "PangoScript", PANGO_SCRIPT_KATAKANA},
        {"PANGO_SCRIPT_KHMER", "PangoScript", PANGO_SCRIPT_KHMER},
        {"PANGO_SCRIPT_LAO", "PangoScript", PANGO_SCRIPT_LAO},
        {"PANGO_SCRIPT_LATIN", "PangoScript", PANGO_SCRIPT_LATIN},
        {"PANGO_SCRIPT_MALAYALAM", "PangoScript", PANGO_SCRIPT_MALAYALAM},
        {"PANGO_SCRIPT_MONGOLIAN", "PangoScript", PANGO_SCRIPT_MONGOLIAN},
        {"PANGO_SCRIPT_MYANMAR", "PangoScript", PANGO_SCRIPT_MYANMAR},
        {"PANGO_SCRIPT_OGHAM", "PangoScript", PANGO_SCRIPT_OGHAM},
        {"PANGO_SCRIPT_OLD_ITALIC", "PangoScript", PANGO_SCRIPT_OLD_ITALIC},
        {"PANGO_SCRIPT_ORIYA", "PangoScript", PANGO_SCRIPT_ORIYA},
        {"PANGO_SCRIPT_RUNIC", "PangoScript", PANGO_SCRIPT_RUNIC},
        {"PANGO_SCRIPT_SINHALA", "PangoScript", PANGO_SCRIPT_SINHALA},
        {"PANGO_SCRIPT_SYRIAC", "PangoScript", PANGO_SCRIPT_SYRIAC},
        {"PANGO_SCRIPT_TAMIL", "PangoScript", PANGO_SCRIPT_TAMIL},
        {"PANGO_SCRIPT_TELUGU", "PangoScript", PANGO_SCRIPT_TELUGU},
        {"PANGO_SCRIPT_THAANA", "PangoScript", PANGO_SCRIPT_THAANA},
        {"PANGO_SCRIPT_THAI", "PangoScript", PANGO_SCRIPT_THAI},
        {"PANGO_SCRIPT_TIBETAN", "PangoScript", PANGO_SCRIPT_TIBETAN},
        {"PANGO_SCRIPT_CANADIAN_ABORIGINAL", "PangoScript", PANGO_SCRIPT_CANADIAN_ABORIGINAL},
        {"PANGO_SCRIPT_YI", "PangoScript", PANGO_SCRIPT_YI},
        {"PANGO_SCRIPT_TAGALOG", "PangoScript", PANGO_SCRIPT_TAGALOG},
        {"PANGO_SCRIPT_HANUNOO", "PangoScript", PANGO_SCRIPT_HANUNOO},
        {"PANGO_SCRIPT_BUHID", "PangoScript", PANGO_SCRIPT_BUHID},
        {"PANGO_SCRIPT_TAGBANWA", "PangoScript", PANGO_SCRIPT_TAGBANWA},
        {"PANGO_SCRIPT_BRAILLE", "PangoScript", PANGO_SCRIPT_BRAILLE},
        {"PANGO_SCRIPT_CYPRIOT", "PangoScript", PANGO_SCRIPT_CYPRIOT},
        {"PANGO_SCRIPT_LIMBU", "PangoScript", PANGO_SCRIPT_LIMBU},
        {"PANGO_SCRIPT_OSMANYA", "PangoScript", PANGO_SCRIPT_OSMANYA},
        {"PANGO_SCRIPT_SHAVIAN", "PangoScript", PANGO_SCRIPT_SHAVIAN},
        {"PANGO_SCRIPT_LINEAR_B", "PangoScript", PANGO_SCRIPT_LINEAR_B},
        {"PANGO_SCRIPT_TAI_LE", "PangoScript", PANGO_SCRIPT_TAI_LE},
        {"PANGO_SCRIPT_UGARITIC", "PangoScript", PANGO_SCRIPT_UGARITIC},
        {"PANGO_TAB_LEFT", "PangoTabAlign", PANGO_TAB_LEFT},
        {"PANGO_DIRECTION_WEAK_LTR", "PangoDirection", PANGO_DIRECTION_WEAK_LTR},
        {"PANGO_DIRECTION_WEAK_RTL", "PangoDirection", PANGO_DIRECTION_WEAK_RTL},
        {"PANGO_DIRECTION_NEUTRAL", "PangoDirection", PANGO_DIRECTION_NEUTRAL},
        {"GTK_IMAGE_ICON_NAME", "GtkImageType", GTK_IMAGE_ICON_NAME},
        {"PANGO_ATTR_UNDERLINE_COLOR", "PangoAttrType", PANGO_ATTR_UNDERLINE_COLOR},
        {"PANGO_ATTR_STRIKETHROUGH_COLOR", "PangoAttrType", PANGO_ATTR_STRIKETHROUGH_COLOR},
        {"PANGO_RENDER_PART_FOREGROUND", "PangoRenderPart", PANGO_RENDER_PART_FOREGROUND},
        {"PANGO_RENDER_PART_BACKGROUND", "PangoRenderPart", PANGO_RENDER_PART_BACKGROUND},
        {"PANGO_RENDER_PART_UNDERLINE", "PangoRenderPart", PANGO_RENDER_PART_UNDERLINE},
        {"PANGO_RENDER_PART_STRIKETHROUGH", "PangoRenderPart", PANGO_RENDER_PART_STRIKETHROUGH},
        {"G_LOG_FLAG_RECURSION", "GLogLevelFlags", G_LOG_FLAG_RECURSION},
        {"G_LOG_FLAG_FATAL", "GLogLevelFlags", G_LOG_FLAG_FATAL},
        {"G_LOG_LEVEL_ERROR", "GLogLevelFlags", G_LOG_LEVEL_ERROR},
        {"G_LOG_LEVEL_CRITICAL", "GLogLevelFlags", G_LOG_LEVEL_CRITICAL},
        {"G_LOG_LEVEL_WARNING", "GLogLevelFlags", G_LOG_LEVEL_WARNING},
        {"G_LOG_LEVEL_MESSAGE", "GLogLevelFlags", G_LOG_LEVEL_MESSAGE},
        {"G_LOG_LEVEL_INFO", "GLogLevelFlags", G_LOG_LEVEL_INFO},
        {"G_LOG_LEVEL_DEBUG", "GLogLevelFlags", G_LOG_LEVEL_DEBUG},
        {"G_LOG_LEVEL_MASK", "GLogLevelFlags", G_LOG_LEVEL_MASK},
        {"G_LOG_FATAL_MASK", "GLogLevelFlags", G_LOG_FATAL_MASK},
        {"GTK_ICON_VIEW_NO_DROP", "GtkIconViewDropPosition", GTK_ICON_VIEW_NO_DROP},
        {"GTK_ICON_VIEW_DROP_INTO", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_INTO},
        {"GTK_ICON_VIEW_DROP_LEFT", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_LEFT},
        {"GTK_ICON_VIEW_DROP_RIGHT", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_RIGHT},
        {"GTK_ICON_VIEW_DROP_ABOVE", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_ABOVE},
        {"GTK_ICON_VIEW_DROP_BELOW", "GtkIconViewDropPosition", GTK_ICON_VIEW_DROP_BELOW},
        {"PANGO_SCRIPT_NEW_TAI_LUE", "PangoScript", PANGO_SCRIPT_NEW_TAI_LUE},
        {"PANGO_SCRIPT_BUGINESE", "PangoScript", PANGO_SCRIPT_BUGINESE},
        {"PANGO_SCRIPT_GLAGOLITIC", "PangoScript", PANGO_SCRIPT_GLAGOLITIC},
        {"PANGO_SCRIPT_TIFINAGH", "PangoScript", PANGO_SCRIPT_TIFINAGH},
        {"PANGO_SCRIPT_SYLOTI_NAGRI", "PangoScript", PANGO_SCRIPT_SYLOTI_NAGRI},
        {"PANGO_SCRIPT_OLD_PERSIAN", "PangoScript", PANGO_SCRIPT_OLD_PERSIAN},
        {"PANGO_SCRIPT_KHAROSHTHI", "PangoScript", PANGO_SCRIPT_KHAROSHTHI},
        {"GDK_SUPER_MASK", "GdkModifierType", GDK_SUPER_MASK},
        {"GDK_HYPER_MASK", "GdkModifierType", GDK_HYPER_MASK},
        {"GDK_META_MASK", "GdkModifierType", GDK_META_MASK},
        {"GTK_SENSITIVITY_AUTO", "GtkSensitivityType", GTK_SENSITIVITY_AUTO},
        {"GTK_SENSITIVITY_ON", "GtkSensitivityType", GTK_SENSITIVITY_ON},
        {"GTK_SENSITIVITY_OFF", "GtkSensitivityType", GTK_SENSITIVITY_OFF},
        {"GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_BUFFER_CONTENTS},
        {"GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_RICH_TEXT},
        {"GTK_TEXT_BUFFER_TARGET_INFO_TEXT", "GtkTextBufferTargetInfo", GTK_TEXT_BUFFER_TARGET_INFO_TEXT},
        {"GTK_ASSISTANT_PAGE_CONTENT", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CONTENT},
        {"GTK_ASSISTANT_PAGE_INTRO", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_INTRO},
        {"GTK_ASSISTANT_PAGE_CONFIRM", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CONFIRM},
        {"GTK_ASSISTANT_PAGE_SUMMARY", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_SUMMARY},
        {"GTK_ASSISTANT_PAGE_PROGRESS", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_PROGRESS},
        {"GTK_CELL_RENDERER_ACCEL_MODE_GTK", "GtkCellRendererAccelMode", GTK_CELL_RENDERER_ACCEL_MODE_GTK},
        {"GTK_CELL_RENDERER_ACCEL_MODE_OTHER", "GtkCellRendererAccelMode", GTK_CELL_RENDERER_ACCEL_MODE_OTHER},
        {"GTK_RECENT_MANAGER_ERROR_NOT_FOUND", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_NOT_FOUND},
        {"GTK_RECENT_MANAGER_ERROR_INVALID_URI", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_INVALID_URI},
        {"GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_INVALID_ENCODING},
        {"GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_NOT_REGISTERED},
        {"GTK_RECENT_MANAGER_ERROR_READ", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_READ},
        {"GTK_RECENT_MANAGER_ERROR_WRITE", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_WRITE},
        {"GTK_RECENT_MANAGER_ERROR_UNKNOWN", "GtkRecentManagerError", GTK_RECENT_MANAGER_ERROR_UNKNOWN},
        {"GTK_MESSAGE_OTHER", "GtkMessageType", GTK_MESSAGE_OTHER},
        {"GTK_TREE_VIEW_GRID_LINES_NONE", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_NONE},
        {"GTK_TREE_VIEW_GRID_LINES_HORIZONTAL", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_HORIZONTAL},
        {"GTK_TREE_VIEW_GRID_LINES_VERTICAL", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_VERTICAL},
        {"GTK_TREE_VIEW_GRID_LINES_BOTH", "GtkTreeViewGridLines", GTK_TREE_VIEW_GRID_LINES_BOTH},
        {"GTK_PRINT_STATUS_INITIAL", "GtkPrintStatus", GTK_PRINT_STATUS_INITIAL},
        {"GTK_PRINT_STATUS_PREPARING", "GtkPrintStatus", GTK_PRINT_STATUS_PREPARING},
        {"GTK_PRINT_STATUS_GENERATING_DATA", "GtkPrintStatus", GTK_PRINT_STATUS_GENERATING_DATA},
        {"GTK_PRINT_STATUS_SENDING_DATA", "GtkPrintStatus", GTK_PRINT_STATUS_SENDING_DATA},
        {"GTK_PRINT_STATUS_PENDING", "GtkPrintStatus", GTK_PRINT_STATUS_PENDING},
        {"GTK_PRINT_STATUS_PENDING_ISSUE", "GtkPrintStatus", GTK_PRINT_STATUS_PENDING_ISSUE},
        {"GTK_PRINT_STATUS_PRINTING", "GtkPrintStatus", GTK_PRINT_STATUS_PRINTING},
        {"GTK_PRINT_STATUS_FINISHED", "GtkPrintStatus", GTK_PRINT_STATUS_FINISHED},
        {"GTK_PRINT_STATUS_FINISHED_ABORTED", "GtkPrintStatus", GTK_PRINT_STATUS_FINISHED_ABORTED},
        {"GTK_PRINT_OPERATION_RESULT_ERROR", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_ERROR},
        {"GTK_PRINT_OPERATION_RESULT_APPLY", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_APPLY},
        {"GTK_PRINT_OPERATION_RESULT_CANCEL", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_CANCEL},
        {"GTK_PRINT_OPERATION_RESULT_IN_PROGRESS", "GtkPrintOperationResult", GTK_PRINT_OPERATION_RESULT_IN_PROGRESS},
        {"GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PRINT_DIALOG},
        {"GTK_PRINT_OPERATION_ACTION_PRINT", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PRINT},
        {"GTK_PRINT_OPERATION_ACTION_PREVIEW", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_PREVIEW},
        {"GTK_PRINT_OPERATION_ACTION_EXPORT", "GtkPrintOperationAction", GTK_PRINT_OPERATION_ACTION_EXPORT},
        {"GTK_PRINT_ERROR_GENERAL", "GtkPrintError", GTK_PRINT_ERROR_GENERAL},
        {"GTK_PRINT_ERROR_INTERNAL_ERROR", "GtkPrintError", GTK_PRINT_ERROR_INTERNAL_ERROR},
        {"GTK_PRINT_ERROR_NOMEM", "GtkPrintError", GTK_PRINT_ERROR_NOMEM},
        {"GTK_PRINT_ERROR_INVALID_FILE", "GtkPrintError", GTK_PRINT_ERROR_INVALID_FILE},
        {"CAIRO_STATUS_SUCCESS", "cairo_status_t", CAIRO_STATUS_SUCCESS},
        {"CAIRO_STATUS_NO_MEMORY", "cairo_status_t", CAIRO_STATUS_NO_MEMORY},
        {"CAIRO_STATUS_INVALID_RESTORE", "cairo_status_t", CAIRO_STATUS_INVALID_RESTORE},
        {"CAIRO_STATUS_INVALID_POP_GROUP", "cairo_status_t", CAIRO_STATUS_INVALID_POP_GROUP},
        {"CAIRO_STATUS_NO_CURRENT_POINT", "cairo_status_t", CAIRO_STATUS_NO_CURRENT_POINT},
        {"CAIRO_STATUS_INVALID_MATRIX", "cairo_status_t", CAIRO_STATUS_INVALID_MATRIX},
        {"CAIRO_STATUS_INVALID_STATUS", "cairo_status_t", CAIRO_STATUS_INVALID_STATUS},
        {"CAIRO_STATUS_NULL_POINTER", "cairo_status_t", CAIRO_STATUS_NULL_POINTER},
        {"CAIRO_STATUS_INVALID_STRING", "cairo_status_t", CAIRO_STATUS_INVALID_STRING},
        {"CAIRO_STATUS_INVALID_PATH_DATA", "cairo_status_t", CAIRO_STATUS_INVALID_PATH_DATA},
        {"CAIRO_STATUS_READ_ERROR", "cairo_status_t", CAIRO_STATUS_READ_ERROR},
        {"CAIRO_STATUS_WRITE_ERROR", "cairo_status_t", CAIRO_STATUS_WRITE_ERROR},
        {"CAIRO_STATUS_SURFACE_FINISHED", "cairo_status_t", CAIRO_STATUS_SURFACE_FINISHED},
        {"CAIRO_STATUS_SURFACE_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_SURFACE_TYPE_MISMATCH},
        {"CAIRO_STATUS_PATTERN_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_PATTERN_TYPE_MISMATCH},
        {"CAIRO_STATUS_INVALID_CONTENT", "cairo_status_t", CAIRO_STATUS_INVALID_CONTENT},
        {"CAIRO_STATUS_INVALID_FORMAT", "cairo_status_t", CAIRO_STATUS_INVALID_FORMAT},
        {"CAIRO_STATUS_INVALID_VISUAL", "cairo_status_t", CAIRO_STATUS_INVALID_VISUAL},
        {"CAIRO_STATUS_FILE_NOT_FOUND", "cairo_status_t", CAIRO_STATUS_FILE_NOT_FOUND},
        {"CAIRO_STATUS_INVALID_DASH", "cairo_status_t", CAIRO_STATUS_INVALID_DASH},
        {"CAIRO_STATUS_INVALID_DSC_COMMENT", "cairo_status_t", CAIRO_STATUS_INVALID_DSC_COMMENT},
        {"CAIRO_STATUS_INVALID_INDEX", "cairo_status_t", CAIRO_STATUS_INVALID_INDEX},
        {"CAIRO_STATUS_CLIP_NOT_REPRESENTABLE", "cairo_status_t", CAIRO_STATUS_CLIP_NOT_REPRESENTABLE},
        {"CAIRO_STATUS_TEMP_FILE_ERROR", "cairo_status_t", CAIRO_STATUS_TEMP_FILE_ERROR},
        {"CAIRO_STATUS_INVALID_STRIDE", "cairo_status_t", CAIRO_STATUS_INVALID_STRIDE},
        {"CAIRO_CONTENT_COLOR", "cairo_content_t", CAIRO_CONTENT_COLOR},
        {"CAIRO_CONTENT_ALPHA", "cairo_content_t", CAIRO_CONTENT_ALPHA},
        {"CAIRO_CONTENT_COLOR_ALPHA", "cairo_content_t", CAIRO_CONTENT_COLOR_ALPHA},
        {"CAIRO_OPERATOR_CLEAR", "cairo_operator_t", CAIRO_OPERATOR_CLEAR},
        {"CAIRO_OPERATOR_SOURCE", "cairo_operator_t", CAIRO_OPERATOR_SOURCE},
        {"CAIRO_OPERATOR_OVER", "cairo_operator_t", CAIRO_OPERATOR_OVER},
        {"CAIRO_OPERATOR_IN", "cairo_operator_t", CAIRO_OPERATOR_IN},
        {"CAIRO_OPERATOR_OUT", "cairo_operator_t", CAIRO_OPERATOR_OUT},
        {"CAIRO_OPERATOR_ATOP", "cairo_operator_t", CAIRO_OPERATOR_ATOP},
        {"CAIRO_OPERATOR_DEST", "cairo_operator_t", CAIRO_OPERATOR_DEST},
        {"CAIRO_OPERATOR_DEST_OVER", "cairo_operator_t", CAIRO_OPERATOR_DEST_OVER},
        {"CAIRO_OPERATOR_DEST_IN", "cairo_operator_t", CAIRO_OPERATOR_DEST_IN},
        {"CAIRO_OPERATOR_DEST_OUT", "cairo_operator_t", CAIRO_OPERATOR_DEST_OUT},
        {"CAIRO_OPERATOR_DEST_ATOP", "cairo_operator_t", CAIRO_OPERATOR_DEST_ATOP},
        {"CAIRO_OPERATOR_XOR", "cairo_operator_t", CAIRO_OPERATOR_XOR},
        {"CAIRO_OPERATOR_ADD", "cairo_operator_t", CAIRO_OPERATOR_ADD},
        {"CAIRO_OPERATOR_SATURATE", "cairo_operator_t", CAIRO_OPERATOR_SATURATE},
        {"CAIRO_ANTIALIAS_DEFAULT", "cairo_antialias_t", CAIRO_ANTIALIAS_DEFAULT},
        {"CAIRO_ANTIALIAS_NONE", "cairo_antialias_t", CAIRO_ANTIALIAS_NONE},
        {"CAIRO_ANTIALIAS_GRAY", "cairo_antialias_t", CAIRO_ANTIALIAS_GRAY},
        {"CAIRO_ANTIALIAS_SUBPIXEL", "cairo_antialias_t", CAIRO_ANTIALIAS_SUBPIXEL},
        {"CAIRO_FILL_RULE_WINDING", "cairo_fill_rule_t", CAIRO_FILL_RULE_WINDING},
        {"CAIRO_FILL_RULE_EVEN_ODD", "cairo_fill_rule_t", CAIRO_FILL_RULE_EVEN_ODD},
        {"CAIRO_LINE_CAP_BUTT", "cairo_line_cap_t", CAIRO_LINE_CAP_BUTT},
        {"CAIRO_LINE_CAP_ROUND", "cairo_line_cap_t", CAIRO_LINE_CAP_ROUND},
        {"CAIRO_LINE_CAP_SQUARE", "cairo_line_cap_t", CAIRO_LINE_CAP_SQUARE},
        {"CAIRO_LINE_JOIN_MITER", "cairo_line_join_t", CAIRO_LINE_JOIN_MITER},
        {"CAIRO_LINE_JOIN_ROUND", "cairo_line_join_t", CAIRO_LINE_JOIN_ROUND},
        {"CAIRO_LINE_JOIN_BEVEL", "cairo_line_join_t", CAIRO_LINE_JOIN_BEVEL},
        {"CAIRO_FONT_SLANT_NORMAL", "cairo_font_slant_t", CAIRO_FONT_SLANT_NORMAL},
        {"CAIRO_FONT_SLANT_ITALIC", "cairo_font_slant_t", CAIRO_FONT_SLANT_ITALIC},
        {"CAIRO_FONT_SLANT_OBLIQUE", "cairo_font_slant_t", CAIRO_FONT_SLANT_OBLIQUE},
        {"CAIRO_FONT_WEIGHT_NORMAL", "cairo_font_weight_t", CAIRO_FONT_WEIGHT_NORMAL},
        {"CAIRO_FONT_WEIGHT_BOLD", "cairo_font_weight_t", CAIRO_FONT_WEIGHT_BOLD},
        {"CAIRO_SUBPIXEL_ORDER_DEFAULT", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_DEFAULT},
        {"CAIRO_SUBPIXEL_ORDER_RGB", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_RGB},
        {"CAIRO_SUBPIXEL_ORDER_BGR", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_BGR},
        {"CAIRO_SUBPIXEL_ORDER_VRGB", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_VRGB},
        {"CAIRO_SUBPIXEL_ORDER_VBGR", "cairo_subpixel_order_t", CAIRO_SUBPIXEL_ORDER_VBGR},
        {"CAIRO_HINT_STYLE_DEFAULT", "cairo_hint_style_t", CAIRO_HINT_STYLE_DEFAULT},
        {"CAIRO_HINT_STYLE_NONE", "cairo_hint_style_t", CAIRO_HINT_STYLE_NONE},
        {"CAIRO_HINT_STYLE_SLIGHT", "cairo_hint_style_t", CAIRO_HINT_STYLE_SLIGHT},
        {"CAIRO_HINT_STYLE_MEDIUM", "cairo_hint_style_t", CAIRO_HINT_STYLE_MEDIUM},
        {"CAIRO_HINT_STYLE_FULL", "cairo_hint_style_t", CAIRO_HINT_STYLE_FULL},
        {"CAIRO_HINT_METRICS_DEFAULT", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_DEFAULT},
        {"CAIRO_HINT_METRICS_OFF", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_OFF},
        {"CAIRO_HINT_METRICS_ON", "cairo_hint_metrics_t", CAIRO_HINT_METRICS_ON},
        {"CAIRO_FONT_TYPE_TOY", "cairo_font_type_t", CAIRO_FONT_TYPE_TOY},
        {"CAIRO_FONT_TYPE_FT", "cairo_font_type_t", CAIRO_FONT_TYPE_FT},
        {"CAIRO_FONT_TYPE_WIN32", "cairo_font_type_t", CAIRO_FONT_TYPE_WIN32},
        {"CAIRO_FONT_TYPE_QUARTZ", "cairo_font_type_t", CAIRO_FONT_TYPE_QUARTZ},
        {"CAIRO_PATH_MOVE_TO", "cairo_path_data_type_t", CAIRO_PATH_MOVE_TO},
        {"CAIRO_PATH_LINE_TO", "cairo_path_data_type_t", CAIRO_PATH_LINE_TO},
        {"CAIRO_PATH_CURVE_TO", "cairo_path_data_type_t", CAIRO_PATH_CURVE_TO},
        {"CAIRO_PATH_CLOSE_PATH", "cairo_path_data_type_t", CAIRO_PATH_CLOSE_PATH},
        {"CAIRO_SURFACE_TYPE_IMAGE", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_IMAGE},
        {"CAIRO_SURFACE_TYPE_PDF", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_PDF},
        {"CAIRO_SURFACE_TYPE_PS", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_PS},
        {"CAIRO_SURFACE_TYPE_XLIB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_XLIB},
        {"CAIRO_SURFACE_TYPE_XCB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_XCB},
        {"CAIRO_SURFACE_TYPE_GLITZ", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_GLITZ},
        {"CAIRO_SURFACE_TYPE_QUARTZ", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_QUARTZ},
        {"CAIRO_SURFACE_TYPE_WIN32", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_WIN32},
        {"CAIRO_SURFACE_TYPE_BEOS", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_BEOS},
        {"CAIRO_SURFACE_TYPE_DIRECTFB", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_DIRECTFB},
        {"CAIRO_SURFACE_TYPE_SVG", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_SVG},
        {"CAIRO_SURFACE_TYPE_OS2", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_OS2},
        {"CAIRO_SURFACE_TYPE_WIN32_PRINTING", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_WIN32_PRINTING},
        {"CAIRO_SURFACE_TYPE_QUARTZ_IMAGE", "cairo_surface_type_t", CAIRO_SURFACE_TYPE_QUARTZ_IMAGE},
        {"CAIRO_FORMAT_ARGB32", "cairo_format_t", CAIRO_FORMAT_ARGB32},
        {"CAIRO_FORMAT_RGB24", "cairo_format_t", CAIRO_FORMAT_RGB24},
        {"CAIRO_FORMAT_A8", "cairo_format_t", CAIRO_FORMAT_A8},
        {"CAIRO_FORMAT_A1", "cairo_format_t", CAIRO_FORMAT_A1},
        {"CAIRO_PATTERN_TYPE_SOLID", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_SOLID},
        {"CAIRO_PATTERN_TYPE_SURFACE", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_SURFACE},
        {"CAIRO_PATTERN_TYPE_LINEAR", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_LINEAR},
        {"CAIRO_PATTERN_TYPE_RADIAL", "cairo_pattern_type_t", CAIRO_PATTERN_TYPE_RADIAL},
        {"CAIRO_EXTEND_NONE", "cairo_extend_t", CAIRO_EXTEND_NONE},
        {"CAIRO_EXTEND_REPEAT", "cairo_extend_t", CAIRO_EXTEND_REPEAT},
        {"CAIRO_EXTEND_REFLECT", "cairo_extend_t", CAIRO_EXTEND_REFLECT},
        {"CAIRO_EXTEND_PAD", "cairo_extend_t", CAIRO_EXTEND_PAD},
        {"CAIRO_FILTER_FAST", "cairo_filter_t", CAIRO_FILTER_FAST},
        {"CAIRO_FILTER_GOOD", "cairo_filter_t", CAIRO_FILTER_GOOD},
        {"CAIRO_FILTER_BEST", "cairo_filter_t", CAIRO_FILTER_BEST},
        {"CAIRO_FILTER_NEAREST", "cairo_filter_t", CAIRO_FILTER_NEAREST},
        {"CAIRO_FILTER_BILINEAR", "cairo_filter_t", CAIRO_FILTER_BILINEAR},
        {"CAIRO_FILTER_GAUSSIAN", "cairo_filter_t", CAIRO_FILTER_GAUSSIAN},
        {"GTK_CALENDAR_SHOW_DETAILS", "GtkCalendarDisplayOptions", GTK_CALENDAR_SHOW_DETAILS},
        {"GDK_CROSSING_GTK_GRAB", "GdkCrossingMode", GDK_CROSSING_GTK_GRAB},
        {"GDK_CROSSING_GTK_UNGRAB", "GdkCrossingMode", GDK_CROSSING_GTK_UNGRAB},
        {"GDK_CROSSING_STATE_CHANGED", "GdkCrossingMode", GDK_CROSSING_STATE_CHANGED},
        {"GTK_ENTRY_ICON_PRIMARY", "GtkEntryIconPosition", GTK_ENTRY_ICON_PRIMARY},
        {"GTK_ENTRY_ICON_SECONDARY", "GtkEntryIconPosition", GTK_ENTRY_ICON_SECONDARY},
        {"PANGO_WEIGHT_THIN", "PangoWeight", PANGO_WEIGHT_THIN},
        {"PANGO_WEIGHT_BOOK", "PangoWeight", PANGO_WEIGHT_BOOK},
        {"PANGO_WEIGHT_MEDIUM", "PangoWeight", PANGO_WEIGHT_MEDIUM},
        {"CAIRO_STATUS_FONT_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_FONT_TYPE_MISMATCH},
        {"CAIRO_STATUS_USER_FONT_IMMUTABLE", "cairo_status_t", CAIRO_STATUS_USER_FONT_IMMUTABLE},
        {"CAIRO_STATUS_USER_FONT_ERROR", "cairo_status_t", CAIRO_STATUS_USER_FONT_ERROR},
        {"CAIRO_STATUS_NEGATIVE_COUNT", "cairo_status_t", CAIRO_STATUS_NEGATIVE_COUNT},
        {"CAIRO_STATUS_INVALID_CLUSTERS", "cairo_status_t", CAIRO_STATUS_INVALID_CLUSTERS},
        {"CAIRO_STATUS_INVALID_SLANT", "cairo_status_t", CAIRO_STATUS_INVALID_SLANT},
        {"CAIRO_STATUS_INVALID_WEIGHT", "cairo_status_t", CAIRO_STATUS_INVALID_WEIGHT},
        {"CAIRO_STATUS_INVALID_SIZE", "cairo_status_t", CAIRO_STATUS_INVALID_SIZE},
        {"CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED", "cairo_status_t", CAIRO_STATUS_USER_FONT_NOT_IMPLEMENTED},
        {"CAIRO_STATUS_DEVICE_TYPE_MISMATCH", "cairo_status_t", CAIRO_STATUS_DEVICE_TYPE_MISMATCH},
        {"CAIRO_STATUS_DEVICE_ERROR", "cairo_status_t", CAIRO_STATUS_DEVICE_ERROR},
        {"CAIRO_OPERATOR_MULTIPLY", "cairo_operator_t", CAIRO_OPERATOR_MULTIPLY},
        {"CAIRO_OPERATOR_SCREEN", "cairo_operator_t", CAIRO_OPERATOR_SCREEN},
        {"CAIRO_OPERATOR_OVERLAY", "cairo_operator_t", CAIRO_OPERATOR_OVERLAY},
        {"CAIRO_OPERATOR_DARKEN", "cairo_operator_t", CAIRO_OPERATOR_DARKEN},
        {"CAIRO_OPERATOR_LIGHTEN", "cairo_operator_t", CAIRO_OPERATOR_LIGHTEN},
        {"CAIRO_OPERATOR_COLOR_DODGE", "cairo_operator_t", CAIRO_OPERATOR_COLOR_DODGE},
        {"CAIRO_OPERATOR_COLOR_BURN", "cairo_operator_t", CAIRO_OPERATOR_COLOR_BURN},
        {"CAIRO_OPERATOR_HARD_LIGHT", "cairo_operator_t", CAIRO_OPERATOR_HARD_LIGHT},
        {"CAIRO_OPERATOR_SOFT_LIGHT", "cairo_operator_t", CAIRO_OPERATOR_SOFT_LIGHT},
        {"CAIRO_OPERATOR_DIFFERENCE", "cairo_operator_t", CAIRO_OPERATOR_DIFFERENCE},
        {"CAIRO_OPERATOR_EXCLUSION", "cairo_operator_t", CAIRO_OPERATOR_EXCLUSION},
        {"CAIRO_OPERATOR_HSL_HUE", "cairo_operator_t", CAIRO_OPERATOR_HSL_HUE},
        {"CAIRO_OPERATOR_HSL_SATURATION", "cairo_operator_t", CAIRO_OPERATOR_HSL_SATURATION},
        {"CAIRO_OPERATOR_HSL_COLOR", "cairo_operator_t", CAIRO_OPERATOR_HSL_COLOR},
        {"CAIRO_OPERATOR_HSL_LUMINOSITY", "cairo_operator_t", CAIRO_OPERATOR_HSL_LUMINOSITY},
        {"CAIRO_SURFACE_TYPE_SCRIPT", "cairo_surface_t", CAIRO_SURFACE_TYPE_SCRIPT},
        {"CAIRO_SURFACE_TYPE_QT", "cairo_surface_t", CAIRO_SURFACE_TYPE_QT},
        {"CAIRO_SURFACE_TYPE_RECORDING", "cairo_surface_t", CAIRO_SURFACE_TYPE_RECORDING},
        {"CAIRO_SURFACE_TYPE_VG", "cairo_surface_t", CAIRO_SURFACE_TYPE_VG},
        {"CAIRO_SURFACE_TYPE_GL", "cairo_surface_t", CAIRO_SURFACE_TYPE_GL},
        {"CAIRO_SURFACE_TYPE_DRM", "cairo_surface_t", CAIRO_SURFACE_TYPE_DRM},
        {"CAIRO_SURFACE_TYPE_TEE", "cairo_surface_t", CAIRO_SURFACE_TYPE_TEE},
        {"CAIRO_SURFACE_TYPE_XML", "cairo_surface_t", CAIRO_SURFACE_TYPE_XML},
        {"CAIRO_SURFACE_TYPE_SKIA", "cairo_surface_t", CAIRO_SURFACE_TYPE_SKIA},
#endif
#if GTK_CHECK_VERSION(3, 0, 0)
        {"GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH", "GtkSizeRequestMode", GTK_SIZE_REQUEST_HEIGHT_FOR_WIDTH},
        {"GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT", "GtkSizeRequestMode", GTK_SIZE_REQUEST_WIDTH_FOR_HEIGHT},
        {"GTK_ASSISTANT_PAGE_CUSTOM", "GtkAssistantPageType", GTK_ASSISTANT_PAGE_CUSTOM},
        {"GTK_TEXT_SEARCH_CASE_INSENSITIVE", "GtkTextSearchFlags", GTK_TEXT_SEARCH_CASE_INSENSITIVE},
        {"GTK_SCROLL_MINIMUM", "GtkScrollablePolicy", GTK_SCROLL_MINIMUM},
        {"GTK_SCROLL_NATURAL", "GtkScrollablePolicy", GTK_SCROLL_NATURAL},
        {"GTK_ALIGN_FILL", "GtkAlign", GTK_ALIGN_FILL},
        {"GTK_ALIGN_START", "GtkAlign", GTK_ALIGN_START},
        {"GTK_ALIGN_END", "GtkAlign", GTK_ALIGN_END},
        {"GTK_ALIGN_CENTER", "GtkAlign", GTK_ALIGN_CENTER},
        {"GTK_IMAGE_GICON", "GtkImageType", GTK_IMAGE_GICON},
        {"GTK_FILE_CHOOSER_ERROR_NONEXISTENT", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_NONEXISTENT},
        {"GTK_FILE_CHOOSER_ERROR_BAD_FILENAME", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_BAD_FILENAME},
        {"GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_ALREADY_EXISTS},
        {"GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME", "GtkFileChooserError", GTK_FILE_CHOOSER_ERROR_INCOMPLETE_HOSTNAME},
        {"GTK_STATE_FLAG_NORMAL", "GtkStateFlags", GTK_STATE_FLAG_NORMAL},
        {"GTK_STATE_FLAG_ACTIVE", "GtkStateFlags", GTK_STATE_FLAG_ACTIVE},
        {"GTK_STATE_FLAG_PRELIGHT", "GtkStateFlags", GTK_STATE_FLAG_PRELIGHT},
        {"GTK_STATE_FLAG_SELECTED", "GtkStateFlags", GTK_STATE_FLAG_SELECTED},
        {"GTK_STATE_FLAG_INSENSITIVE", "GtkStateFlags", GTK_STATE_FLAG_INSENSITIVE},
        {"GTK_STATE_FLAG_INCONSISTENT", "GtkStateFlags", GTK_STATE_FLAG_INCONSISTENT},
        {"GTK_STATE_FLAG_FOCUSED", "GtkStateFlags", GTK_STATE_FLAG_FOCUSED},
#endif
#if GTK_CHECK_VERSION(3, 10, 0)
        {"GTK_ALIGN_BASELINE", "GtkAlign", GTK_ALIGN_BASELINE},
        {"GTK_BASELINE_POSITION_TOP", "GtkBaselinePosition", GTK_BASELINE_POSITION_TOP},
        {"GTK_BASELINE_POSITION_CENTER", "GtkBaselinePosition", GTK_BASELINE_POSITION_CENTER},
        {"GTK_BASELINE_POSITION_BOTTOM", "GtkBaselinePosition", GTK_BASELINE_POSITION_BOTTOM},
        {"GTK_PLACES_OPEN_NORMAL", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NORMAL},
        {"GTK_PLACES_OPEN_NEW_TAB", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NEW_TAB},
        {"GTK_PLACES_OPEN_NEW_WINDOW", "GtkPlacesOpenFlags", GTK_PLACES_OPEN_NEW_WINDOW},
        {"GTK_STACK_TRANSITION_TYPE_NONE", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_NONE},
        {"GTK_STACK_TRANSITION_TYPE_CROSSFADE", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_CROSSFADE},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_UP},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_DOWN},
        {"GTK_REVEALER_TRANSITION_TYPE_NONE", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_NONE},
        {"GTK_REVEALER_TRANSITION_TYPE_CROSSFADE", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_CROSSFADE},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_UP},
        {"GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN},
#endif
#if GTK_CHECK_VERSION(3, 12, 0)
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_LEFT_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_SLIDE_UP_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_UP},
        {"GTK_STACK_TRANSITION_TYPE_OVER_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_UP},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_UNDER_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_UP_DOWN},
#endif
#if GTK_CHECK_VERSION(3, 14, 0)
        {"GTK_PHASE_NONE", "GtkPropagationPhase", GTK_PHASE_NONE},
        {"GTK_PHASE_CAPTURE", "GtkPropagationPhase", GTK_PHASE_CAPTURE},
        {"GTK_PHASE_BUBBLE", "GtkPropagationPhase", GTK_PHASE_BUBBLE},
        {"GTK_PHASE_TARGET", "GtkPropagationPhase", GTK_PHASE_TARGET},
#endif
#if GTK_CHECK_VERSION(3, 16, 0)
        {"GTK_POLICY_EXTERNAL", "GtkPolicyType", GTK_POLICY_EXTERNAL},
        {"PANGO_WEIGHT_SEMILIGHT", "PangoWeight", PANGO_WEIGHT_SEMILIGHT},
        {"GTK_TEXT_EXTEND_SELECTION_WORD", "GtkTextExtendSelection", GTK_TEXT_EXTEND_SELECTION_WORD},
        {"GTK_TEXT_EXTEND_SELECTION_LINE", "GtkTextExtendSelection", GTK_TEXT_EXTEND_SELECTION_LINE},
#endif
#if GTK_CHECK_VERSION(3, 18, 0)
        {"GDK_TOUCHPAD_SWIPE", "GdkEventType", GDK_TOUCHPAD_SWIPE},
        {"GDK_TOUCHPAD_PINCH", "GdkEventType", GDK_TOUCHPAD_PINCH},
        {"GDK_TOUCHPAD_GESTURE_PHASE_BEGIN", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_BEGIN},
        {"GDK_TOUCHPAD_GESTURE_PHASE_UPDATE", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_UPDATE},
        {"GDK_TOUCHPAD_GESTURE_PHASE_END", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_END},
        {"GDK_TOUCHPAD_GESTURE_PHASE_CANCEL", "GdkTouchpadGesturePhase", GDK_TOUCHPAD_GESTURE_PHASE_CANCEL},
        {"GDK_TOUCHPAD_GESTURE_MASK", "GdkEventMask", GDK_TOUCHPAD_GESTURE_MASK},
#endif
#if GTK_CHECK_VERSION(3, 2, 0)
        {"GTK_SIZE_REQUEST_CONSTANT_SIZE", "GtkSizeRequestMode", GTK_SIZE_REQUEST_CONSTANT_SIZE},
#endif
#if GTK_CHECK_VERSION(3, 20, 0)
        {"GTK_SHORTCUT_ACCELERATOR", "GtkShortcutType", GTK_SHORTCUT_ACCELERATOR},
        {"GTK_SHORTCUT_GESTURE_PINCH", "GtkShortcutType", GTK_SHORTCUT_GESTURE_PINCH},
        {"GTK_SHORTCUT_GESTURE_STRETCH", "GtkShortcutType", GTK_SHORTCUT_GESTURE_STRETCH},
        {"GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE", "GtkShortcutType", GTK_SHORTCUT_GESTURE_ROTATE_CLOCKWISE},
        {"GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE", "GtkShortcutType", GTK_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE},
        {"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT},
        {"GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT},
        {"GTK_SHORTCUT_GESTURE", "GtkShortcutType", GTK_SHORTCUT_GESTURE},
        {"GTK_POPOVER_CONSTRAINT_NONE", "GtkPopoverConstraint", GTK_POPOVER_CONSTRAINT_NONE},
        {"GTK_POPOVER_CONSTRAINT_WINDOW", "GtkPopoverConstraint", GTK_POPOVER_CONSTRAINT_WINDOW},
        {"GDK_SEAT_CAPABILITY_NONE", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_NONE},
        {"GDK_SEAT_CAPABILITY_POINTER", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_POINTER},
        {"GDK_SEAT_CAPABILITY_TOUCH", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TOUCH},
        {"GDK_SEAT_CAPABILITY_TABLET_STYLUS", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TABLET_STYLUS},
        {"GDK_SEAT_CAPABILITY_KEYBOARD", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_KEYBOARD},
        {"GDK_SEAT_CAPABILITY_ALL_POINTING", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_ALL_POINTING},
        {"GDK_SEAT_CAPABILITY_ALL", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_ALL},
        {"GTK_STATE_FLAG_DROP_ACTIVE", "GtkStateFlags", GTK_STATE_FLAG_DROP_ACTIVE},
#endif
#if GTK_CHECK_VERSION(3, 22, 0)
        {"GDK_AXIS_IGNORE", "GdkAxisUse", GDK_AXIS_IGNORE},
        {"GDK_AXIS_X", "GdkAxisUse", GDK_AXIS_X},
        {"GDK_AXIS_Y", "GdkAxisUse", GDK_AXIS_Y},
        {"GDK_AXIS_PRESSURE", "GdkAxisUse", GDK_AXIS_PRESSURE},
        {"GDK_AXIS_XTILT", "GdkAxisUse", GDK_AXIS_XTILT},
        {"GDK_AXIS_YTILT", "GdkAxisUse", GDK_AXIS_YTILT},
        {"GDK_AXIS_WHEEL", "GdkAxisUse", GDK_AXIS_WHEEL},
        {"GDK_AXIS_LAST", "GdkAxisUse", GDK_AXIS_LAST},
        {"GDK_AXIS_FLAG_X", "GdkAxisFlags", GDK_AXIS_FLAG_X},
        {"GDK_AXIS_FLAG_Y", "GdkAxisFlags", GDK_AXIS_FLAG_Y},
        {"GDK_AXIS_FLAG_PRESSURE", "GdkAxisFlags", GDK_AXIS_FLAG_PRESSURE},
        {"GDK_AXIS_FLAG_XTILT", "GdkAxisFlags", GDK_AXIS_FLAG_XTILT},
        {"GDK_AXIS_FLAG_YTILT", "GdkAxisFlags", GDK_AXIS_FLAG_YTILT},
        {"GDK_AXIS_FLAG_WHEEL", "GdkAxisFlags", GDK_AXIS_FLAG_WHEEL},
        {"GDK_AXIS_FLAG_DISTANCE", "GdkAxisFlags", GDK_AXIS_FLAG_DISTANCE},
        {"GDK_AXIS_FLAG_ROTATION", "GdkAxisFlags", GDK_AXIS_FLAG_ROTATION},
        {"GDK_AXIS_FLAG_SLIDER", "GdkAxisFlags", GDK_AXIS_FLAG_SLIDER},
        {"GDK_DEVICE_TOOL_TYPE_UNKNOWN", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_UNKNOWN},
        {"GDK_DEVICE_TOOL_TYPE_PEN", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_PEN},
        {"GDK_DEVICE_TOOL_TYPE_ERASER", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_ERASER},
        {"GDK_DEVICE_TOOL_TYPE_BRUSH", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_BRUSH},
        {"GDK_DEVICE_TOOL_TYPE_PENCIL", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_PENCIL},
        {"GDK_DEVICE_TOOL_TYPE_AIRBRUSH", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_AIRBRUSH},
        {"GDK_DEVICE_TOOL_TYPE_MOUSE", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_MOUSE},
        {"GDK_DEVICE_TOOL_TYPE_LENS", "GdkDeviceToolType", GDK_DEVICE_TOOL_TYPE_LENS},
        {"GDK_SUBPIXEL_LAYOUT_UNKNOWN", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_UNKNOWN},
        {"GDK_SUBPIXEL_LAYOUT_NONE", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_NONE},
        {"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_HORIZONTAL_RGB},
        {"GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_HORIZONTAL_BGR},
        {"GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_VERTICAL_RGB},
        {"GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR", "GdkSubpixelLayout", GDK_SUBPIXEL_LAYOUT_VERTICAL_BGR},
        {"GDK_DEVICE_PAD_FEATURE_BUTTON", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_BUTTON},
        {"GDK_DEVICE_PAD_FEATURE_RING", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_RING},
        {"GDK_DEVICE_PAD_FEATURE_STRIP", "GdkDevicePadFeature", GDK_DEVICE_PAD_FEATURE_STRIP},
        {"GDK_PAD_BUTTON_PRESS", "GdkEventType", GDK_PAD_BUTTON_PRESS},
        {"GDK_PAD_BUTTON_RELEASE", "GdkEventType", GDK_PAD_BUTTON_RELEASE},
        {"GDK_PAD_RING", "GdkEventType", GDK_PAD_RING},
        {"GDK_PAD_STRIP", "GdkEventType", GDK_PAD_STRIP},
        {"GDK_PAD_GROUP_MODE", "GdkEventType", GDK_PAD_GROUP_MODE},
        {"GDK_TABLET_PAD_MASK", "GdkEventMask", GDK_TABLET_PAD_MASK},
        {"GDK_ANCHOR_FLIP_X", "GdkAnchorHints", GDK_ANCHOR_FLIP_X},
        {"GDK_ANCHOR_FLIP_Y", "GdkAnchorHints", GDK_ANCHOR_FLIP_Y},
        {"GDK_ANCHOR_SLIDE_X", "GdkAnchorHints", GDK_ANCHOR_SLIDE_X},
        {"GDK_ANCHOR_SLIDE_Y", "GdkAnchorHints", GDK_ANCHOR_SLIDE_Y},
        {"GDK_ANCHOR_RESIZE_X", "GdkAnchorHints", GDK_ANCHOR_RESIZE_X},
        {"GDK_ANCHOR_RESIZE_Y", "GdkAnchorHints", GDK_ANCHOR_RESIZE_Y},
        {"GDK_ANCHOR_FLIP", "GdkAnchorHints", GDK_ANCHOR_FLIP},
        {"GDK_ANCHOR_SLIDE", "GdkAnchorHints", GDK_ANCHOR_SLIDE},
        {"GDK_ANCHOR_RESIZE", "GdkAnchorHints", GDK_ANCHOR_RESIZE},
        {"GTK_PAD_ACTION_BUTTON", "GtkPadActionType", GTK_PAD_ACTION_BUTTON},
        {"GTK_PAD_ACTION_RING", "GtkPadActionType", GTK_PAD_ACTION_RING},
        {"GTK_PAD_ACTION_STRIP", "GtkPadActionType", GTK_PAD_ACTION_STRIP},
#endif
#if GTK_CHECK_VERSION(3, 4, 0)
        {"GTK_CELL_RENDERER_EXPANDABLE", "GtkCellRendererState", GTK_CELL_RENDERER_EXPANDABLE},
        {"GTK_CELL_RENDERER_EXPANDED", "GtkCellRendererState", GTK_CELL_RENDERER_EXPANDED},
        {"GTK_STATE_FLAG_BACKDROP", "GtkStateFlags", GTK_STATE_FLAG_BACKDROP},
#endif
#if GTK_CHECK_VERSION(3, 6, 0)
        {"GDK_TOUCH_BEGIN", "GdkEventType", GDK_TOUCH_BEGIN},
        {"GDK_TOUCH_UPDATE", "GdkEventType", GDK_TOUCH_UPDATE},
        {"GDK_TOUCH_END", "GdkEventType", GDK_TOUCH_END},
        {"GDK_TOUCH_CANCEL", "GdkEventType", GDK_TOUCH_CANCEL},
        {"GDK_SCROLL_SMOOTH", "GdkScrollDirection", GDK_SCROLL_SMOOTH},
        {"GDK_CROSSING_TOUCH_BEGIN", "GdkCrossingMode", GDK_CROSSING_TOUCH_BEGIN},
        {"GDK_CROSSING_TOUCH_END", "GdkCrossingMode", GDK_CROSSING_TOUCH_END},
        {"GDK_CROSSING_DEVICE_SWITCH", "GdkCrossingMode", GDK_CROSSING_DEVICE_SWITCH},
        {"GDK_TOUCH_MASK", "GdkEventMask", GDK_TOUCH_MASK},
        {"GDK_SMOOTH_SCROLL_MASK", "GdkEventMask", GDK_SMOOTH_SCROLL_MASK},
        {"GTK_LEVEL_BAR_MODE_CONTINUOUS", "GtkLevelBarMode", GTK_LEVEL_BAR_MODE_CONTINUOUS},
        {"GTK_LEVEL_BAR_MODE_DISCRETE", "GtkLevelBarMode", GTK_LEVEL_BAR_MODE_DISCRETE},
        {"GTK_INPUT_PURPOSE_FREE_FORM", "GtkInputPurpose", GTK_INPUT_PURPOSE_FREE_FORM},
        {"GTK_INPUT_PURPOSE_ALPHA", "GtkInputPurpose", GTK_INPUT_PURPOSE_ALPHA},
        {"GTK_INPUT_PURPOSE_DIGITS", "GtkInputPurpose", GTK_INPUT_PURPOSE_DIGITS},
        {"GTK_INPUT_PURPOSE_NUMBER", "GtkInputPurpose", GTK_INPUT_PURPOSE_NUMBER},
        {"GTK_INPUT_PURPOSE_PHONE", "GtkInputPurpose", GTK_INPUT_PURPOSE_PHONE},
        {"GTK_INPUT_PURPOSE_URL", "GtkInputPurpose", GTK_INPUT_PURPOSE_URL},
        {"GTK_INPUT_PURPOSE_EMAIL", "GtkInputPurpose", GTK_INPUT_PURPOSE_EMAIL},
        {"GTK_INPUT_PURPOSE_NAME", "GtkInputPurpose", GTK_INPUT_PURPOSE_NAME},
        {"GTK_INPUT_PURPOSE_PASSWORD", "GtkInputPurpose", GTK_INPUT_PURPOSE_PASSWORD},
        {"GTK_INPUT_PURPOSE_PIN", "GtkInputPurpose", GTK_INPUT_PURPOSE_PIN},
        {"GTK_INPUT_HINT_NONE", "GtkInputHints", GTK_INPUT_HINT_NONE},
        {"GTK_INPUT_HINT_SPELLCHECK", "GtkInputHints", GTK_INPUT_HINT_SPELLCHECK},
        {"GTK_INPUT_HINT_NO_SPELLCHECK", "GtkInputHints", GTK_INPUT_HINT_NO_SPELLCHECK},
        {"GTK_INPUT_HINT_WORD_COMPLETION", "GtkInputHints", GTK_INPUT_HINT_WORD_COMPLETION},
        {"GTK_INPUT_HINT_LOWERCASE", "GtkInputHints", GTK_INPUT_HINT_LOWERCASE},
        {"GTK_INPUT_HINT_UPPERCASE_CHARS", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_CHARS},
        {"GTK_INPUT_HINT_UPPERCASE_WORDS", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_WORDS},
        {"GTK_INPUT_HINT_UPPERCASE_SENTENCES", "GtkInputHints", GTK_INPUT_HINT_UPPERCASE_SENTENCES},
        {"GTK_INPUT_HINT_INHIBIT_OSK", "GtkInputHints", GTK_INPUT_HINT_INHIBIT_OSK},
#endif
#if GTK_CHECK_VERSION(3, 8, 0)
        {"GTK_STATE_FLAG_DIR_LTR", "GtkStateFlags", GTK_STATE_FLAG_DIR_LTR},
        {"GTK_STATE_FLAG_DIR_RTL", "GtkStateFlags", GTK_STATE_FLAG_DIR_RTL},
        {"GDK_FULLSCREEN_ON_CURRENT_MONITOR", "GdkFullscreenMode", GDK_FULLSCREEN_ON_CURRENT_MONITOR},
        {"GDK_FULLSCREEN_ON_ALL_MONITORS", "GdkFullscreenMode", GDK_FULLSCREEN_ON_ALL_MONITORS},
#endif
#if GTK_CHECK_VERSION(3, 92, 0)
        {"GTK_SHORTCUT_GESTURE_SWIPE_LEFT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_SWIPE_LEFT},
        {"GTK_SHORTCUT_GESTURE_SWIPE_RIGHT", "GtkShortcutType", GTK_SHORTCUT_GESTURE_SWIPE_RIGHT},
        {"GTK_STYLE_CONTEXT_PRINT_NONE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_NONE},
        {"GTK_STYLE_CONTEXT_PRINT_RECURSE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_RECURSE},
        {"GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_SHOW_STYLE},
#endif
#if GTK_CHECK_VERSION(3, 94, 0)
        {"GTK_INPUT_HINT_VERTICAL_WRITING", "GtkInputHints", GTK_INPUT_HINT_VERTICAL_WRITING},
        {"GTK_INPUT_HINT_EMOJI", "GtkInputHints", GTK_INPUT_HINT_EMOJI},
        {"GTK_INPUT_HINT_NO_EMOJI", "GtkInputHints", GTK_INPUT_HINT_NO_EMOJI},
        {"GTK_EVENT_CONTROLLER_SCROLL_NONE", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_NONE},
        {"GTK_EVENT_CONTROLLER_SCROLL_VERTICAL", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_VERTICAL},
        {"GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_HORIZONTAL},
        {"GTK_EVENT_CONTROLLER_SCROLL_DISCRETE", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_DISCRETE},
        {"GTK_EVENT_CONTROLLER_SCROLL_KINETIC", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_KINETIC},
        {"GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES", "GtkEventControllerScrollFlags", GTK_EVENT_CONTROLLER_SCROLL_BOTH_AXES},
        {"GDK_DEVICE_TYPE_MASTER", "GdkDeviceType", GDK_DEVICE_TYPE_MASTER},
        {"GDK_DEVICE_TYPE_SLAVE", "GdkDeviceType", GDK_DEVICE_TYPE_SLAVE},
        {"GDK_DEVICE_TYPE_FLOATING", "GdkDeviceType", GDK_DEVICE_TYPE_FLOATING},
        {"GDK_SEAT_CAPABILITY_TABLET_PAD", "GdkSeatCapabilities", GDK_SEAT_CAPABILITY_TABLET_PAD},
        {"GTK_ICON_SIZE_INHERIT", "GtkIconSize", GTK_ICON_SIZE_INHERIT},
        {"GTK_ICON_SIZE_NORMAL", "GtkIconSize", GTK_ICON_SIZE_NORMAL},
        {"GTK_ICON_SIZE_LARGE", "GtkIconSize", GTK_ICON_SIZE_LARGE},
        {"GTK_STATE_FLAG_FOCUS_VISIBLE", "GtkStateFlags", GTK_STATE_FLAG_FOCUS_VISIBLE},
        {"GTK_APPLICATION_INHIBIT_LOGOUT", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_LOGOUT},
        {"GTK_APPLICATION_INHIBIT_SWITCH", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_SWITCH},
        {"GTK_APPLICATION_INHIBIT_SUSPEND", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_SUSPEND},
        {"GTK_APPLICATION_INHIBIT_IDLE", "GtkApplicationInhibitFlags", GTK_APPLICATION_INHIBIT_IDLE},
        {"GDK_SURFACE_EDGE_NORTH_WEST", "GdkSurfaceEdge", GDK_SURFACE_EDGE_NORTH_WEST},
        {"GDK_SURFACE_EDGE_NORTH", "GdkSurfaceEdge", GDK_SURFACE_EDGE_NORTH},
        {"GDK_SURFACE_EDGE_NORTH_EAST", "GdkSurfaceEdge", GDK_SURFACE_EDGE_NORTH_EAST},
        {"GDK_SURFACE_EDGE_WEST", "GdkSurfaceEdge", GDK_SURFACE_EDGE_WEST},
        {"GDK_SURFACE_EDGE_EAST", "GdkSurfaceEdge", GDK_SURFACE_EDGE_EAST},
        {"GDK_SURFACE_EDGE_SOUTH_WEST", "GdkSurfaceEdge", GDK_SURFACE_EDGE_SOUTH_WEST},
        {"GDK_SURFACE_EDGE_SOUTH", "GdkSurfaceEdge", GDK_SURFACE_EDGE_SOUTH},
        {"GDK_SURFACE_EDGE_SOUTH_EAST", "GdkSurfaceEdge", GDK_SURFACE_EDGE_SOUTH_EAST},
        {"GDK_SURFACE_TYPE_HINT_NORMAL", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_NORMAL},
        {"GDK_SURFACE_TYPE_HINT_DIALOG", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_DIALOG},
        {"GDK_SURFACE_TYPE_HINT_MENU", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_MENU},
        {"GDK_SURFACE_TYPE_HINT_SPLASHSCREEN", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_SPLASHSCREEN},
        {"GDK_SURFACE_TYPE_HINT_UTILITY", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_UTILITY},
        {"GDK_SURFACE_TYPE_HINT_DOCK", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_DOCK},
        {"GDK_SURFACE_TYPE_HINT_DESKTOP", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_DESKTOP},
        {"GDK_SURFACE_TYPE_HINT_DROPDOWN_MENU", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_DROPDOWN_MENU},
        {"GDK_SURFACE_TYPE_HINT_POPUP_MENU", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_POPUP_MENU},
        {"GDK_SURFACE_TYPE_HINT_TOOLTIP", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_TOOLTIP},
        {"GDK_SURFACE_TYPE_HINT_NOTIFICATION", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_NOTIFICATION},
        {"GDK_SURFACE_TYPE_HINT_COMBO", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_COMBO},
        {"GDK_SURFACE_TYPE_HINT_DND", "GdkSurfaceTypeHint", GDK_SURFACE_TYPE_HINT_DND},
        {"GDK_MEMORY_DEFAULT", "GdkMemoryFormat", GDK_MEMORY_DEFAULT},
        {"GDK_MEMORY_B8G8R8A8_PREMULTIPLIED", "GdkMemoryFormat", GDK_MEMORY_B8G8R8A8_PREMULTIPLIED},
        {"GDK_MEMORY_A8R8G8B8_PREMULTIPLIED", "GdkMemoryFormat", GDK_MEMORY_A8R8G8B8_PREMULTIPLIED},
        {"GDK_MEMORY_B8G8R8A8", "GdkMemoryFormat", GDK_MEMORY_B8G8R8A8},
        {"GDK_MEMORY_A8R8G8B8", "GdkMemoryFormat", GDK_MEMORY_A8R8G8B8},
        {"GDK_MEMORY_R8G8B8A8", "GdkMemoryFormat", GDK_MEMORY_R8G8B8A8},
        {"GDK_MEMORY_A8B8G8R8", "GdkMemoryFormat", GDK_MEMORY_A8B8G8R8},
        {"GDK_MEMORY_R8G8B8", "GdkMemoryFormat", GDK_MEMORY_R8G8B8},
        {"GDK_MEMORY_B8G8R8", "GdkMemoryFormat", GDK_MEMORY_B8G8R8},
        {"GDK_MEMORY_N_FORMATS", "GdkMemoryFormat", GDK_MEMORY_N_FORMATS},
        {"GDK_PAINTABLE_STATIC_SIZE", "GdkPaintableFlags", GDK_PAINTABLE_STATIC_SIZE},
        {"GDK_PAINTABLE_STATIC_CONTENTS", "GdkPaintableFlags", GDK_PAINTABLE_STATIC_CONTENTS},
        {"GDK_SURFACE_STATE_WITHDRAWN", "GdkSurfaceState", GDK_SURFACE_STATE_WITHDRAWN},
        {"GDK_SURFACE_STATE_MAXIMIZED", "GdkSurfaceState", GDK_SURFACE_STATE_MAXIMIZED},
        {"GDK_SURFACE_STATE_STICKY", "GdkSurfaceState", GDK_SURFACE_STATE_STICKY},
        {"GDK_SURFACE_STATE_FULLSCREEN", "GdkSurfaceState", GDK_SURFACE_STATE_FULLSCREEN},
        {"GDK_SURFACE_STATE_ABOVE", "GdkSurfaceState", GDK_SURFACE_STATE_ABOVE},
        {"GDK_SURFACE_STATE_BELOW", "GdkSurfaceState", GDK_SURFACE_STATE_BELOW},
        {"GDK_SURFACE_STATE_FOCUSED", "GdkSurfaceState", GDK_SURFACE_STATE_FOCUSED},
        {"GDK_SURFACE_STATE_TILED", "GdkSurfaceState", GDK_SURFACE_STATE_TILED},
        {"GDK_SURFACE_STATE_TOP_TILED", "GdkSurfaceState", GDK_SURFACE_STATE_TOP_TILED},
        {"GDK_SURFACE_STATE_TOP_RESIZABLE", "GdkSurfaceState", GDK_SURFACE_STATE_TOP_RESIZABLE},
        {"GDK_SURFACE_STATE_RIGHT_TILED", "GdkSurfaceState", GDK_SURFACE_STATE_RIGHT_TILED},
        {"GDK_SURFACE_STATE_RIGHT_RESIZABLE", "GdkSurfaceState", GDK_SURFACE_STATE_RIGHT_RESIZABLE},
        {"GDK_SURFACE_STATE_BOTTOM_TILED", "GdkSurfaceState", GDK_SURFACE_STATE_BOTTOM_TILED},
        {"GDK_SURFACE_STATE_BOTTOM_RESIZABLE", "GdkSurfaceState", GDK_SURFACE_STATE_BOTTOM_RESIZABLE},
        {"GDK_SURFACE_STATE_LEFT_TILED", "GdkSurfaceState", GDK_SURFACE_STATE_LEFT_TILED},
        {"GDK_SURFACE_STATE_LEFT_RESIZABLE", "GdkSurfaceState", GDK_SURFACE_STATE_LEFT_RESIZABLE},
#endif
#if GTK_CHECK_VERSION(3, 96, 0)
        {"GTK_EDITABLE_PROP_TEXT", "GtkEditableProperties", GTK_EDITABLE_PROP_TEXT},
        {"GTK_EDITABLE_PROP_CURSOR_POSITION", "GtkEditableProperties", GTK_EDITABLE_PROP_CURSOR_POSITION},
        {"GTK_EDITABLE_PROP_SELECTION_BOUND", "GtkEditableProperties", GTK_EDITABLE_PROP_SELECTION_BOUND},
        {"GTK_EDITABLE_PROP_EDITABLE", "GtkEditableProperties", GTK_EDITABLE_PROP_EDITABLE},
        {"GTK_EDITABLE_PROP_WIDTH_CHARS", "GtkEditableProperties", GTK_EDITABLE_PROP_WIDTH_CHARS},
        {"GTK_EDITABLE_PROP_MAX_WIDTH_CHARS", "GtkEditableProperties", GTK_EDITABLE_PROP_MAX_WIDTH_CHARS},
        {"GTK_EDITABLE_PROP_XALIGN", "GtkEditableProperties", GTK_EDITABLE_PROP_XALIGN},
        {"GTK_EDITABLE_NUM_PROPERTIES", "GtkEditableProperties", GTK_EDITABLE_NUM_PROPERTIES},
        {"GTK_OVERFLOW_VISIBLE", "GtkOverflow", GTK_OVERFLOW_VISIBLE},
        {"GTK_OVERFLOW_HIDDEN", "GtkOverflow", GTK_OVERFLOW_HIDDEN},
        {"GTK_PICK_DEFAULT", "GtkPickFlags", GTK_PICK_DEFAULT},
        {"GTK_PICK_INSENSITIVE", "GtkPickFlags", GTK_PICK_INSENSITIVE},
        {"GTK_PICK_NON_TARGETABLE", "GtkPickFlags", GTK_PICK_NON_TARGETABLE},
        {"GTK_REVEALER_TRANSITION_TYPE_SWING_RIGHT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SWING_RIGHT},
        {"GTK_REVEALER_TRANSITION_TYPE_SWING_LEFT", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SWING_LEFT},
        {"GTK_REVEALER_TRANSITION_TYPE_SWING_UP", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SWING_UP},
        {"GTK_REVEALER_TRANSITION_TYPE_SWING_DOWN", "GtkRevealerTransitionType", GTK_REVEALER_TRANSITION_TYPE_SWING_DOWN},
        {"GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_DOWN_UP},
        {"GTK_STACK_TRANSITION_TYPE_OVER_LEFT_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_LEFT_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_OVER_RIGHT_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT},
        {"GTK_STACK_TRANSITION_TYPE_ROTATE_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_ROTATE_RIGHT},
        {"GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT_RIGHT", "GtkStackTransitionType", GTK_STACK_TRANSITION_TYPE_ROTATE_LEFT_RIGHT},
        {"GDK_DRAG_CANCEL_NO_TARGET", "GdkDragCancelReason", GDK_DRAG_CANCEL_NO_TARGET},
        {"GDK_DRAG_CANCEL_USER_CANCELLED", "GdkDragCancelReason", GDK_DRAG_CANCEL_USER_CANCELLED},
        {"GDK_DRAG_CANCEL_ERROR", "GdkDragCancelReason", GDK_DRAG_CANCEL_ERROR},
#endif
#if GTK_CHECK_VERSION(3, 98, 0)
        {"GTK_ICON_LOOKUP_FORCE_REGULAR", "GtkIconLookupFlags", GTK_ICON_LOOKUP_FORCE_REGULAR},
        {"GTK_ICON_LOOKUP_FORCE_SYMBOLIC", "GtkIconLookupFlags", GTK_ICON_LOOKUP_FORCE_SYMBOLIC},
        {"GTK_ICON_LOOKUP_PRELOAD", "GtkIconLookupFlags", GTK_ICON_LOOKUP_PRELOAD},
        {"GTK_INPUT_PURPOSE_TERMINAL", "GtkInputPurpose", GTK_INPUT_PURPOSE_TERMINAL},
        {"GTK_EDITABLE_PROP_ENABLE_UNDO", "GtkEditableProperties", GTK_EDITABLE_PROP_ENABLE_UNDO},
        {"GTK_STYLE_CONTEXT_PRINT_SHOW_CHANGE", "GtkStyleContextPrintFlags", GTK_STYLE_CONTEXT_PRINT_SHOW_CHANGE},
        {"GTK_POPOVER_MENU_NESTED", "GtkPopoverMenuFlags", GTK_POPOVER_MENU_NESTED},
        {"GTK_ICON_THEME_NOT_FOUND,", "GtkIconThemeError", GTK_ICON_THEME_NOT_FOUND,},
        {"GTK_ICON_THEME_FAILED", "GtkIconThemeError", GTK_ICON_THEME_FAILED},
        {"GTK_CONSTRAINT_RELATION_LE", "GtkConstraintRelation", GTK_CONSTRAINT_RELATION_LE},
        {"GTK_CONSTRAINT_RELATION_EQ", "GtkConstraintRelation", GTK_CONSTRAINT_RELATION_EQ},
        {"GTK_CONSTRAINT_RELATION_GE", "GtkConstraintRelation", GTK_CONSTRAINT_RELATION_GE},
        {"GTK_CONSTRAINT_STRENGTH_REQUIRED", "GtkConstraintStrength", GTK_CONSTRAINT_STRENGTH_REQUIRED},
        {"GTK_CONSTRAINT_STRENGTH_STRONG", "GtkConstraintStrength", GTK_CONSTRAINT_STRENGTH_STRONG},
        {"GTK_CONSTRAINT_STRENGTH_MEDIUM", "GtkConstraintStrength", GTK_CONSTRAINT_STRENGTH_MEDIUM},
        {"GTK_CONSTRAINT_STRENGTH_WEAK", "GtkConstraintStrength", GTK_CONSTRAINT_STRENGTH_WEAK},
        {"GTK_CONSTRAINT_ATTRIBUTE_NONE", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_NONE},
        {"GTK_CONSTRAINT_ATTRIBUTE_LEFT", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_LEFT},
        {"GTK_CONSTRAINT_ATTRIBUTE_RIGHT", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_RIGHT},
        {"GTK_CONSTRAINT_ATTRIBUTE_TOP", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_TOP},
        {"GTK_CONSTRAINT_ATTRIBUTE_BOTTOM", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_BOTTOM},
        {"GTK_CONSTRAINT_ATTRIBUTE_START", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_START},
        {"GTK_CONSTRAINT_ATTRIBUTE_END", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_END},
        {"GTK_CONSTRAINT_ATTRIBUTE_WIDTH", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_WIDTH},
        {"GTK_CONSTRAINT_ATTRIBUTE_HEIGHT", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_HEIGHT},
        {"GTK_CONSTRAINT_ATTRIBUTE_CENTER_X", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_CENTER_X},
        {"GTK_CONSTRAINT_ATTRIBUTE_CENTER_Y", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_CENTER_Y},
        {"GTK_CONSTRAINT_ATTRIBUTE_BASELINE", "GtkConstraintAttribute", GTK_CONSTRAINT_ATTRIBUTE_BASELINE},
        {"GTK_SHORTCUT_SCOPE_LOCAL", "GtkShortcutScope", GTK_SHORTCUT_SCOPE_LOCAL},
        {"GTK_SHORTCUT_SCOPE_MANAGED", "GtkShortcutScope", GTK_SHORTCUT_SCOPE_MANAGED},
        {"GTK_SHORTCUT_SCOPE_GLOBAL", "GtkShortcutScope", GTK_SHORTCUT_SCOPE_GLOBAL},
        {"GTK_SHORTCUT_ACTION_EXCLUSIVE", "GtkShortcutActionFlags", GTK_SHORTCUT_ACTION_EXCLUSIVE},
        {"GDK_KEY_MATCH_NONE", "GdkKeyMatch", GDK_KEY_MATCH_NONE},
        {"GDK_KEY_MATCH_PARTIAL", "GdkKeyMatch", GDK_KEY_MATCH_PARTIAL},
        {"GDK_KEY_MATCH_EXACT", "GdkKeyMatch", GDK_KEY_MATCH_EXACT},
        {"GTK_STATE_FLAG_FOCUS_WITHIN", "GtkStateFlags", GTK_STATE_FLAG_FOCUS_WITHIN},
#endif
        {NULL, NULL, 0}};

static s7_pointer enum_value_to_name(s7_scheme *sc, int64_t val, const char *type) 
{ 
  int k; 
  int64_t range_min = 0, range_max = 0; 
  bool range_set = false; 
  for (k = 0; ; k++) 
    { 
      enummer_t nt; 
      nt = enum_info[k]; 
      if (!nt.name) 
	break; 
      if (strcmp(nt.type, type) == 0) 
	{ 
	  if (nt.value == val)        /* ... value should be <nt.name> */ 
	    return(s7_make_string(sc, nt.name)); 
	  if (!range_set) 
	    { 
	      range_min = nt.value; 
	      range_max = nt.value; 
	      range_set = true; 
	    } 
	  else 
	    { 
	      if (range_min > nt.value) range_min = nt.value; 
	      if (range_max < nt.value) range_max = nt.value; 
	    } 
	} 
    } 
  if (range_set)       /* here we found a matching name, its type is wrong, and it's out of range */ 
    { 
      char *range_string; 
      s7_pointer str; 
      range_string = (char *)malloc(256 * sizeof(char)); 
      snprintf(range_string, 256, "between %" PRId64 " and %" PRId64, range_min, range_max); 
      str = s7_make_string(sc, range_string); 
      free(range_string); 
      return(str);                            /* ... value should be between <min> and <max> */ 
    } 
  return(s7_make_symbol(sc, "integer?")); 
}

static s7_pointer g_gtk_enum_t(s7_scheme *sc, s7_pointer args) 
{ 
  s7_pointer form, argn, func, arg; 
  const char *doc_string, *p; 
  int arg_number; 
  form = s7_car(args);  
  argn = s7_cadr(args); 
  arg_number = s7_integer(argn); 
  arg = s7_list_ref(sc, form, arg_number); 
  if ((!s7_is_integer(arg)) && 
      (!s7_is_symbol(arg))) 
    return(s7_make_symbol(sc, "integer?")); 
  func = s7_car(form); 
  doc_string = s7_documentation(sc, func); 
  p = strchr(doc_string, (int)'('); 
  if (p) 
    { 
      int i; 
      for (i = 1; i < arg_number; i++) 
	p = strchr((char *)(p + 1), (int)','); 
      if (p) 
	{ 
	  const char *e; 
	  p += 2; /* past comma and space */ 
	  e = strchr(p, (int)' '); 
	  if (e) 
	    { 
	      int len; 
	      char *type; 
	      len = e - p + 1; 
	      type = (char *)malloc(len * sizeof(char)); 
	      for (i = 0; i < len; i++) type[i] = p[i]; 
	      type[len - 1] = '\0'; 
	      if (s7_is_symbol(arg)) 
		{ 
		  const char *arg_name; 
		  arg_name = s7_symbol_name(arg); /* no free */ 
		  for (i = 0; ; i++) 
		    { 
		      enummer_t et; 
		      et = enum_info[i]; 
		      if (!et.name) 
			break; 
		      if (strcmp(et.name, arg_name) == 0) 
			{ 
			  if (strcmp(et.type, type) == 0)                 /* success -- name and type match */ 
			    { 
			      free(type); 
			      return(s7_t(sc)); 
			    } 
			  return(enum_value_to_name(sc, et.value, type)); /* here the type is wrong, so try to find the correct name */ 
			} 
		    } 
		  return(s7_make_symbol(sc, "integer?"));               /* here we got no matches, so return 'integer? */ 
		} 
	      return(enum_value_to_name(sc, s7_integer(arg), type));      /* here arg is an integer */ 
	    } 
	} 
    } 
  return(s7_make_symbol(sc, "integer?")); 
}

static void define_lint(s7_scheme *sc)
{
  s7_define_safe_function(sc, "gtk_enum_t?", g_gtk_enum_t, 2, 0, 0, "lint helper");
}

void libgtk_s7_init(s7_scheme *sc);
void libgtk_s7_init(s7_scheme *sc)
{
  s7_pointer cur_env, old_shadow;
  cur_env = s7_curlet(sc);

  old_shadow = s7_set_shadow_rootlet(sc, cur_env);
  cbsc = sc;
  s7_define(sc, cur_env, s7_make_symbol(sc, "version"),
             s7_append(sc, s7_object_to_string(sc, s7_make_integer(sc, GTK_MAJOR_VERSION), false),
               s7_append(sc, s7_make_string(sc, "."),
                 s7_append(sc, s7_object_to_string(sc, s7_make_integer(sc, GTK_MINOR_VERSION), false),
                   s7_append(sc, s7_make_string(sc, "."),  s7_object_to_string(sc, s7_make_integer(sc, GTK_MICRO_VERSION), false))))));
  lg_true = s7_t(sc);
  lg_false = s7_f(sc);
  define_xm_obj(sc);
  define_integers(sc);
  define_doubles(sc);
  define_strings(sc);
  define_symbols(sc);
  define_lint(sc);
  define_structs(sc);
  define_functions(sc);
  s7_define_function(sc, "g_signal_connect", lg_g_signal_connect, 3, 1, 0, H_g_signal_connect);
  s7_set_shadow_rootlet(sc, old_shadow);
  s7_define(sc, cur_env, s7_make_symbol(sc, "libgtk-version"), s7_make_string(sc, "15-May-20"));
}
/* gcc -c libgtk_s7.c -o libgtk_s7.o -I. -fPIC `pkg-config --libs gtk+-3.0 --cflags` -lm -ldl */
/* gcc libgtk_s7.o -shared -o libgtk_s7.so */
/* (load "libgtk_s7.so" (define *gtk* (inlet 'init_func 'libgtk_s7_init))) */
